public interface Valuable {
    double getValue();
}
public class Company implements Valuable {
    private final Set<Store> stores = new HashSet<Store>();
    public void addStore ( Store store ) {
        this.stores.add ( store );
    }
    public void removeStore ( Store store ) {
        this.stores.remove ( store );
    }
    public double getValue() {
        double ret = 0.0;
        for ( Store store : stores ) {
            ret += store.getValue();
        }
        return ret;
    }
}
public class Store implements Valuable {
    private final List<Product> products = new LinkedList<Product>();
    public void addProduct ( Product product ) {
        this.products.add ( product );
    }
    public void removeProduct ( Product product ) {
        this.products.remove ( product );
    }
    public double getValue() {
        double ret = 0.0;
        for ( Product product : products ) {
            ret += product.getValue();
        }
        return ret;
    }
}
public class Product implements Valuable {
    private final double value;
    public Product ( double value ) {
        this.value = value;
    }
    public double getValue() {
        return value;
    }
}
