final JXList list = new JXList ( Locale.getAvailableLocales(), true );
list.setSortOrder ( SortOrder.ASCENDING );
final JPopupMenu popup = new JPopupMenu();
popup.add ( new JScrollPane ( list ) );
popup.setFocusable ( false );
final JTextField field = new JTextField ( 20 );
final PatternModel model = new PatternModel();
model.setMatchRule ( PatternModel.MATCH_RULE_STARTSWITH );
PropertyChangeListener modelListener = new PropertyChangeListener() {
    @Override
    public void propertyChange ( PropertyChangeEvent evt ) {
        if ( "pattern".equals ( evt.getPropertyName() ) ) {
            updateFilter ( ( Pattern ) evt.getNewValue() );
        }
    }
    private void updateFilter ( Pattern newValue ) {
        RowFilter<Object, Integer> filter = null;
        if ( newValue != null ) {
            filter = RowFilters.regexFilter ( newValue );
        }
        list.setRowFilter ( filter );
    }
};
model.addPropertyChangeListener ( modelListener );
DocumentListener documentListener = new DocumentListener() {
    @Override
    public void removeUpdate ( DocumentEvent e ) {
        updateAfterDocumentChange();
    }
    @Override
    public void insertUpdate ( DocumentEvent e ) {
        updateAfterDocumentChange();
    }
    private void updateAfterDocumentChange() {
        if ( !popup.isVisible() ) {
            popup.show ( field, 0, field.getHeight() );
        }
        model.setRawText ( field.getText() );
    }
    @Override
    public void changedUpdate ( DocumentEvent e ) {
    }
};
field.getDocument().addDocumentListener ( documentListener );
