public static void addSelectOnFocusToText ( Text text ) {
    Listener listener = new Listener() {
        private boolean hasFocus = false;
        private boolean hadFocusOnMousedown = false;
        @Override
        public void handleEvent ( Event e ) {
            switch ( e.type ) {
            case SWT.FocusIn: {
                Text t = ( Text ) e.widget;
                t.selectAll();
                t.getDisplay().asyncExec ( new Runnable() {
                    @Override
                    public void run() {
                        hasFocus = true;
                    }
                } );
                break;
            }
            case SWT.FocusOut: {
                hasFocus = false;
                ( ( Text ) e.widget ).clearSelection();
                break;
            }
            case SWT.MouseDown: {
                hadFocusOnMousedown = hasFocus;
                break;
            }
            case SWT.MouseUp: {
                Text t = ( Text ) e.widget;
                if ( t.getSelectionCount() == 0 && !hadFocusOnMousedown ) {
                    ( ( Text ) e.widget ).selectAll();
                }
                break;
            }
            }
        }
    };
    text.addListener ( SWT.FocusIn, listener );
    text.addListener ( SWT.FocusOut, listener );
    text.addListener ( SWT.MouseDown, listener );
    text.addListener ( SWT.MouseUp, listener );
}
