import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.net.URL;
import javax.imageio.ImageIO;
public class FrameTest2 {
    public static void main ( String[] args ) throws Exception {
        final String s = "Catch Torchic";
        URL url = new URL ( "http://pscode.org/media/stromlo2.jpg" );
        final Image image = ImageIO.read ( url );
        SwingUtilities.invokeLater ( new Runnable() {
            @Override
            public void run() {
                new MainMenu ( s, image );
            }
        } );
    }
}
class MainMenu extends JFrame {
    JButton autoa, manualb, createc, exitd;
    public MainMenu ( String s, Image image ) {
        super ( s );
        setLocationByPlatform ( true );
        setDefaultCloseOperation ( EXIT_ON_CLOSE );
        Container contentPane = getContentPane();
        contentPane.setLayout ( new BorderLayout() );
        CustomPanel panel = new CustomPanel ( image );
        panel.setAlignmentX ( Component.CENTER_ALIGNMENT );
        contentPane.add ( panel );
        JPanel btnPanel = new JPanel();
        btnPanel.setBorder ( new EmptyBorder ( 5, 5, 100, 5 ) );
        btnPanel.setLayout ( new BoxLayout ( btnPanel, BoxLayout.Y_AXIS ) );
        autoa = new JButton ( "AutoPlay" );
        autoa.setAlignmentX ( Component.CENTER_ALIGNMENT );
        btnPanel.add ( autoa );
        manualb = new JButton ( "Manual Play" );
        manualb.setAlignmentX ( Component.CENTER_ALIGNMENT );
        btnPanel.add ( manualb );
        createc = new JButton ( "Create Maze" );
        createc.setAlignmentX ( Component.CENTER_ALIGNMENT );
        btnPanel.add ( createc );
        exitd = new JButton ( "Exit" );
        exitd.setAlignmentX ( Component.CENTER_ALIGNMENT );
        btnPanel.add ( exitd );
        contentPane.add ( btnPanel, BorderLayout.SOUTH );
        setContentPane ( contentPane );
        ButtonHandler handler = new ButtonHandler ( this );
        autoa.addActionListener ( handler );
        manualb.addActionListener ( handler );
        createc.addActionListener ( handler );
        exitd.addActionListener ( handler );
        pack();
        setSize ( 640, 600 );
        setVisible ( true );
    }
}
class ButtonHandler implements ActionListener {
    MainMenu mm;
    public ButtonHandler ( MainMenu mm ) {
        this.mm = mm;
    }
    public void actionPerformed ( ActionEvent e ) {
        if ( e.getSource() == mm.autoa ) {
            System.out.println ( "Clicked on Auto" );
        } else if ( e.getSource() == mm.manualb ) {
            System.out.println ( "Clicked on Manual" );
        } else if ( e.getSource() == mm.createc ) {
            System.out.println ( "Clicked on Create" );
        } else {
            System.exit ( 0 );
        }
    }
}
class CustomPanel extends JPanel {
    Image pic;
    CustomPanel ( Image pic ) {
        this.pic = pic;
    }
    public void paintComponent ( Graphics painter ) {
        if ( pic != null ) {
            painter.drawImage ( pic, 105, 30, this );
        }
    }
}
