public Change createChange ( IProgressMonitor pm )
throws CoreException,
    OperationCanceledException {
    ICompilationUnit unit = element.getCompilationUnit();
    TextChange change = getTextChange ( unit );
    if ( change == null ) {
        return null;
    }
    CompilationUnit astCompUnit = parse ( unit, pm );
    ASTNode astElement = NodeFinder.perform ( astCompUnit, element.getNameRange() );
    MethodDeclaration astMethod = ( MethodDeclaration ) getParent ( astElement, MethodDeclaration.class );
    String newName = getArguments().getNewName();
    List<TraceFnFixOperation> ops = new ArrayList<TraceFnFixOperation> ( 1 );
    TraceFnCtorFinder finder = new TraceFnCtorFinder ( newName, ops );
    astMethod.accept ( finder );
    for ( TraceFnFixOperation op : ops ) {
        change.addEdit ( new ReplaceEdit ( op.startPosition,
                                           op.length,
                                           "\"" + op.methodName + "\"" ) );
    }
    return null;
}
