package com.example.mimetype;
import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.FileNameMap;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import net.sf.jmimemagic.Magic;
import net.sf.jmimemagic.MagicException;
import net.sf.jmimemagic.MagicMatchNotFoundException;
import net.sf.jmimemagic.MagicParseException;
public class MimeUtils {
    public static Map<String, List<String>> sortLinksByMimeType ( List<String> links ) {
        Map<String, List<String>> mapMimeTypesToLinks = new HashMap<String, List<String>>();
        for ( String url : links ) {
            try {
                String  mimetype = getMimeType ( url );
                System.out.println ( url + " has mimetype " + mimetype );
                if ( ! mapMimeTypesToLinks.containsKey ( mimetype ) ) {
                    mapMimeTypesToLinks.put ( mimetype, new ArrayList<String>() );
                }
                List<String> lst = mapMimeTypesToLinks.get ( mimetype );
                lst.add ( url );
            } catch ( Exception e ) {
                e.printStackTrace();
            }
        }
        return mapMimeTypesToLinks;
    }
    public static String getMimeType ( String url ) throws MalformedURLException, IOException, MagicParseException, MagicMatchNotFoundException, MagicException {
        URLConnection c = new URL ( url ).openConnection();
        BufferedInputStream in = new BufferedInputStream ( c.getInputStream() );
        byte[] content = new byte[100];
        in.read ( content );
        in.close();
        return Magic.getMagicMatch ( content, false ).getMimeType();
    }
    public static void main ( String[] args ) {
        List<String> links = new ArrayList<String>();
        links.add ( "http://stackoverflow.com/questions/10082568/how-to-differentiate-xml-from-html-links-in-java" );
        links.add ( "http://stackoverflow.com" );
        links.add ( "http://stackoverflow.com/feeds" );
        links.add ( "http://amazon.com" );
        links.add ( "http://google.com" );
        sortLinksByMimeType ( links );
    }
}
