public void aggregate() throws Exception {
    BufferedReader bigFile = new BufferedReader ( new FileReader ( "path/to/file.csv" ) );
    Map<String, HashSet<String>> map = new HashMap<String, HashSet<String>> ( 500000 );
    while ( bigFile.ready() ) {
        String line = bigFile.readLine();
        int lastTab = line.lastIndexOf ( '\t' );
        String firstFourColumns = line.substring ( 0, lastTab );
        HashSet<String> set = map.get ( firstFourColumns );
        if ( set == null ) {
            set = new HashSet<String>();
            map.put ( firstFourColumns, set );
        }
        String lastColumn = line.substring ( lastTab + 1 );
        set.add ( lastColumn );
    }
    bigFile.close();
    for ( Map.Entry<String, HashSet<String>> entry : map.entrySet() ) {
        String firstFourColumns = entry.getKey();
        System.out.print ( firstFourColumns + "=" );
        HashSet<String> aggregatedLastColumns = entry.getValue();
        for ( String column : aggregatedLastColumns ) {
            System.out.print ( column + "," );
        }
        System.out.println ( "" );
    }
}
