@MarshalMixin
interface Uuided {
    @MarshalAsString
    @MarshalId
    UUID getId();
}
@MarshalMixin
interface Named {
    @MarshalId
    String getName();
}
@MarshalObject
interface Component extends Uuided, Named {
    @MarshalAsKeyedObjectMap ( key = "name" )
    Map<String, ComponentAttribute> getAttributes();
}
@MarshalObject
interface Attribute extends Named {
    Type getType();
    @MarshalDynamic
    Object getValue();
}
interface ComponentAttribute extends Attribute {
    @MarshalUsingIds
    Component getDeclaringComponent();
}
