public interface KernelExtra extends StdCallLibrary {
    WinDef.DWORD TH32CS_SNAPHEAPLIST = new WinDef.DWORD ( 0x00000001 );
    WinDef.DWORD TH32CS_SNAPPROCESS  = new WinDef.DWORD ( 0x00000002 );
    WinDef.DWORD TH32CS_SNAPTHREAD   = new WinDef.DWORD ( 0x00000004 );
    WinDef.DWORD TH32CS_SNAPMODULE   = new WinDef.DWORD ( 0x00000008 );
    WinDef.DWORD TH32CS_SNAPMODULE32 = new WinDef.DWORD ( 0x00000010 );
    WinDef.DWORD TH32CS_SNAPALL      = new WinDef.DWORD ( ( TH32CS_SNAPHEAPLIST.intValue() |
            TH32CS_SNAPPROCESS.intValue() | TH32CS_SNAPTHREAD.intValue() | TH32CS_SNAPMODULE.intValue() ) );
    WinDef.DWORD TH32CS_INHERIT      = new WinDef.DWORD ( 0x80000000 );
    public static class PROCESSENTRY32 extends Structure {
        public static class ByReference extends PROCESSENTRY32 implements Structure.ByReference {
            public ByReference() {
            }
            public ByReference ( Pointer memory ) {
                super ( memory );
            }
        }
        public PROCESSENTRY32() {
            dwSize = new WinDef.DWORD ( size() );
        }
        public PROCESSENTRY32 ( Pointer memory ) {
            useMemory ( memory );
            read();
        }
        public WinDef.DWORD dwSize;
        public WinDef.DWORD cntUsage;
        public WinDef.DWORD th32ProcessID;
        public BaseTSD.ULONG_PTR th32DefaultHeapID;
        public WinDef.DWORD th32ModuleID;
        public WinDef.DWORD cntThreads;
        public WinDef.DWORD th32ParentProcessID;
        public WinDef.LONG pcPriClassBase;
        public WinDef.DWORD dwFlags;
        public char[] szExeFile = new char[WinDef.MAX_PATH];
    }
    public WinNT.HANDLE CreateToolhelp32Snapshot ( WinDef.DWORD dwFlags, WinDef.DWORD th32ProcessID );
    public boolean Process32First ( WinNT.HANDLE hSnapshot, KernelExtra.PROCESSENTRY32.ByReference lppe );
    public boolean Process32Next ( WinNT.HANDLE hSnapshot, KernelExtra.PROCESSENTRY32.ByReference lppe );
}
