import java.sql.Types;
public class ParamDescriptor {
    private ParamDescriptor ( int dataType, Object value ) {
        _dataType = dataType;
        _value = value;
    }
    public static ParamDescriptor forInt ( int paramVal ) {
        return new ParamDescriptor ( Types.INTEGER, paramVal );
    }
    public static ParamDescriptor forString ( String paramVal ) {
        return new ParamDescriptor ( Types.VARCHAR, paramVal );
    }
    public static ParamDescriptor forDate ( Date paramVal ) {
        return new ParamDescriptor ( Types.DATE, paramVal );
    }
    public int getDataType() {
        return _dataType;
    }
    public Object getValue() {
        return _value;
    }
    private int     _dataType;
    private Object  _value;
}
