public static long stream ( InputStream input, OutputStream output ) throws IOException {
    ReadableByteChannel inputChannel = null;
    WritableByteChannel outputChannel = null;
    try {
        inputChannel = Channels.newChannel ( input );
        outputChannel = Channels.newChannel ( output );
        ByteBuffer buffer = ByteBuffer.allocate ( 10240 );
        long size = 0;
        while ( inputChannel.read ( buffer ) != -1 ) {
            buffer.flip();
            size += outputChannel.write ( buffer );
            buffer.clear();
        }
        return size;
    } finally {
        if ( outputChannel != null ) try {
                outputChannel.close();
            } catch ( IOException ignore ) {
            }
        if ( inputChannel != null ) try {
                inputChannel.close();
            } catch ( IOException ignore ) {
            }
    }
}
