public synchronized void write ( K key, V value ) throws IOException {
    boolean nullKey = key == null || key instanceof NullWritable;
    boolean nullValue = value == null || value instanceof NullWritable;
    if ( nullKey && nullValue ) {
        return;
    }
    if ( !nullKey ) {
        if ( dataWritten ) {
            out.write ( newline );
        }
        writeObject ( key );
        out.write ( keyValueSeparator );
    } else if ( !nullValue ) {
        out.write ( valueDelimiter );
    }
    writeObject ( value );
    dataWritten = true;
}
public synchronized void close ( Reporter reporter ) throws IOException {
    if ( dataWritten ) {
        out.write ( newline );
    }
    out.close();
}
