ScanDir::ScanDir ( String thisDirPath, DirSearch * mySearch ) : FmySearch ( mySearch ),
        FmyDirPath ( thisDirPath ), fileCount ( 0 ), folderCount ( 0 ),
PoolTask ( 0, mySearch->scanCompleted ) {};
void ScanDir::run() {
    filesAndFolderNames = listAllFoldersAndFiles ( FmyDirPath );
    for ( int index = 0; index < filesAndFolderNames->Count; index++ ) {
        if ( ( int ) filesAndFolderNames->Objects[index] & faDirectory ) {
            folderCount++;
            String newFolderPath = FmyDirPath + "\\" + filesAndFolderNames->Strings[index];
            ScanDir * newScanDir = FmySearch->getScanDir ( newFolderPath );
            myPool->submit ( newScanDir );
        } else {
            fileCount++;
        }
    }
    delete ( filesAndFolderNames );
};
DirSearch::DirSearch ( String dirPath, TNotifyEvent onComplete ) : FdirPath ( dirPath ),
          FonComplete ( onComplete ), totalFileCount ( 0 ), totalFolderCount ( 0 ), dirCount ( 0 ),
PoolTask ( 0, onComplete ) {
    InitializeCriticalSection ( & countLock );
    searchCompleteEvent = new TEvent ( NULL, false, false, "", false );
};
ScanDir * DirSearch::getScanDir ( String path ) {
    EnterCriticalSection ( & countLock );
    dirCount++;
    LeaveCriticalSection ( & countLock );
    return new ScanDir ( path, this );
};
void DirSearch::run() {
    ScanDir * firstScanDir = getScanDir ( FdirPath );
    myPool->submit ( firstScanDir );
    searchCompleteEvent->WaitFor ( INFINITE );
}
void __fastcall DirSearch::scanCompleted ( TObject * Sender ) {
    ScanDir * thiscan = ( ScanDir * ) Sender;
    EnterCriticalSection ( & countLock );
    totalFileCount += thiscan->fileCount;
    totalFolderCount += thiscan->folderCount;
    dirCount--;
    LeaveCriticalSection ( & countLock );
    if ( !dirCount ) {
        searchCompleteEvent->SetEvent();
    }
    delete ( thiscan );
};
