import java.util.*;
public class ListExample {
    public static final void main ( String[] args ) {
        List<short[]> list;
        list = new LinkedList<short[]>();
        list.add ( new short[] { 0, 0, 0 } );
        System.out.println ( "list.size() before direct use: " + list.size() );
        System.out.println ( "list.get(0)[0] before direct use: " + list.get ( 0 ) [0] );
        new DirectUser ( list ).doSomething();
        System.out.println ( "list.size() after direct use: " + list.size() );
        System.out.println ( "list.get(0)[0] after direct use: " + list.get ( 0 ) [0] );
        list = new LinkedList<short[]>();
        list.add ( new short[] { 0, 0, 0 } );
        System.out.println ( "list.size() before copy-list use: " + list.size() );
        System.out.println ( "list.get(0)[0] before copy-list use: " + list.get ( 0 ) [0] );
        new CopyListUser ( list ).doSomething();
        System.out.println ( "list.size() after copy-list use: " + list.size() );
        System.out.println ( "list.get(0)[0] after copy-list use: " + list.get ( 0 ) [0] );
        list = new LinkedList<short[]>();
        list.add ( new short[] { 0, 0, 0 } );
        System.out.println ( "list.size() before deep-copy use: " + list.size() );
        System.out.println ( "list.get(0)[0] before deep-copy use: " + list.get ( 0 ) [0] );
        new DeepCopyUser ( list ).doSomething();
        System.out.println ( "list.size() after deep-copy use: " + list.size() );
        System.out.println ( "list.get(0)[0] after deep-copy use: " + list.get ( 0 ) [0] );
        System.exit ( 0 );
    }
    static class DirectUser {
        List<short[]> items;
        DirectUser ( List<short[]> items ) {
            this.items = items;
        }
        void doSomething() {
            this.items.get ( 0 ) [0] = 1;
            this.items.add ( new short[] { 2, 2, 2 } );
        }
    }
    static class CopyListUser {
        List<short[]> items;
        CopyListUser ( List<short[]> items ) {
            this.items = new LinkedList<short[]> ( items );
        }
        void doSomething() {
            this.items.get ( 0 ) [0] = 1;
            this.items.add ( new short[] { 2, 2, 2 } );
        }
    }
    static class DeepCopyUser {
        List<short[]> items;
        DeepCopyUser ( List<short[]> items ) {
            this.items = new LinkedList<short[]>();
            for ( short[] entry : items ) {
                this.items.add ( Arrays.copyOf ( entry, entry.length ) );
            }
        }
        void doSomething() {
            this.items.get ( 0 ) [0] = 1;
            this.items.add ( new short[] { 2, 2, 2 } );
        }
    }
}
