public static void setEnabledRecursive ( final Composite composite, final boolean enabled ) {
    Check.notNull ( composite, "composite" );
    Control[] children = composite.getChildren();
    for ( int i = 0; i < children.length; i++ ) {
        if ( children[i] instanceof Composite ) {
            setEnabledRecursive ( ( Composite ) children[i], enabled );
        } else {
            children[i].setEnabled ( enabled );
        }
    }
    composite.setEnabled ( enabled );
}
