public abstract class LazilyLoadedObject implements InvocationHandler {
    private Object target;
    @Override
    public Object invoke ( Object proxy, Method method, Object[] args ) throws Throwable {
        if ( target == null ) {
            target = loadObject();
        }
        return method.invoke ( target, args );
    }
    protected abstract Object loadObject();
}
