public class MavenExecutor {
    private final File       configuration;
    private final ClassWorld classWorld;
    public MavenExecutor ( final File aConfiguration ) {
        this.configuration = aConfiguration;
        this.classWorld = new ClassWorld ( "plexus.core", this.getClass().getClassLoader() );
    }
    public int unpack ( final String cmd, final File pom, final File output, final String folder, final String marker ) {
        final List<String> commands = new ArrayList<String> (
            Arrays.asList ( cmd.split ( ConfigurationConstants.MAVEN_DELIMITER ) ) );
        commands.add ( "-DoutputDirectory=" + output.getAbsolutePath() + folder );
        commands.add ( "-DmarkersDirectory=" + output.getAbsolutePath() + marker );
        commands.add ( "-gs=\"" + this.configuration.getAbsolutePath() + "\"" );
        commands.add ( "-f=\"" + pom.getAbsolutePath() + "\"" );
        return MavenCli.doMain ( commands.toArray ( new String[commands.size()] ), this.classWorld );
    }
