import com.google.api.client.auth.oauth2.Credential;
import com.google.api.client.googleapis.auth.oauth2.GoogleAuthorizationCodeRequestUrl;
import com.google.api.client.googleapis.auth.oauth2.GoogleAuthorizationCodeTokenRequest;
import com.google.api.client.googleapis.auth.oauth2.GoogleCredential;
import com.google.api.client.googleapis.auth.oauth2.GoogleTokenResponse;
import com.google.api.client.http.HttpTransport;
import com.google.api.client.http.javanet.NetHttpTransport;
import com.google.api.client.json.jackson.JacksonFactory;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.List;
public class MyClass {
    static String CLIENT_ID = "<YOUR_CLIENT_ID>";
    static String CLIENT_SECRET = "<YOUR_CLIENT_SECRET>";
    static String REDIRECT_URI = "urn:ietf:wg:oauth:2.0:oob";
    static List<String> SCOPES = Arrays.asList ( "https://docs.google.com/feeds" );
    static Credential getCredentials() throws IOException {
        HttpTransport transport = new NetHttpTransport();
        JacksonFactory jsonFactory = new JacksonFactory();
        String authorizationUrl =
            new GoogleAuthorizationCodeRequestUrl ( CLIENT_ID, REDIRECT_URI, SCOPES ).build();
        System.out.println ( "Go to the following link in your browser:" );
        System.out.println ( authorizationUrl );
        BufferedReader in = new BufferedReader ( new InputStreamReader ( System.in ) );
        System.out.println ( "What is the authorization code?" );
        String code = in.readLine();
        GoogleTokenResponse response =
            new GoogleAuthorizationCodeTokenRequest ( transport, jsonFactory, CLIENT_ID, CLIENT_SECRET,
                    code, REDIRECT_URI ).execute();
        return new GoogleCredential.Builder().setClientSecrets ( CLIENT_ID, CLIENT_SECRET )
               .setJsonFactory ( jsonFactory ).setTransport ( transport ).build()
               .setAccessToken ( response.getAccessToken() ).setRefreshToken ( response.getRefreshToken() );
    }
}
