static final int MT = -1;
static int kRooksPermutations ( int[] Q, int col, int rooksInHand ) {
    if ( col >= Q.length ) {
        return rooksInHand == 0 ? 1 : 0;
    }
    int count = 0;
    if ( rooksInHand > 0 ) {
        for ( int row = 0; row < Q.length; row++ ) {
            if ( safeToAdd ( Q, row, col ) ) {
                Q[col] = row;
                count += kRooksPermutations ( Q, col + 1, rooksInHand - 1 );
                Q[col] = MT;
            }
        }
    }
    count += kRooksPermutations ( Q, col + 1, rooksInHand );
    return count;
}
static boolean safeToAdd ( int[] Q, int row, int col ) {
    if ( Q[col] != MT ) {
        return false;
    }
    for ( int c = 0; c < Q.length; c++ ) {
        if ( Q[c] == row ) {
            return false;
        }
    }
    return true;
}
private static void kRooksPermutations ( int N, int K ) {
    final int[] Q = new int[N];
    Arrays.fill ( Q, MT );
    int perms = kRooksPermutations ( Q, 0, K );
    System.out.println ( "Perms for N = " + N + " K = " + K + " = " + perms );
}
public static void main ( String[] args ) {
    kRooksPermutations ( 8, 1 );
    kRooksPermutations ( 8, 2 );
    kRooksPermutations ( 8, 3 );
    kRooksPermutations ( 8, 4 );
    kRooksPermutations ( 8, 5 );
    kRooksPermutations ( 8, 6 );
    kRooksPermutations ( 8, 7 );
    kRooksPermutations ( 8, 8 );
}
