public static Image resizeImage ( Image image, int width, int height, boolean max ) {
    if ( width < 0 && height > 0 ) {
        return resizeImageBy ( image, height, false );
    } else if ( width > 0 && height < 0 ) {
        return resizeImageBy ( image, width, true );
    } else if ( width < 0 && height < 0 ) {
        PrinterHelper.printErr ( "Setting the image size to (width, height) of: ("
                                 + width + ", " + height + ") effectively means \"do nothing\"... Returning original image" );
        return image;
    }
    int currentHeight = image.getHeight ( null );
    int currentWidth = image.getWidth ( null );
    int expectedWidth = ( height * currentWidth ) / currentHeight;
    int size = height;
    if ( max && expectedWidth > width ) {
        size = width;
    } else if ( !max && expectedWidth < width ) {
        size = width;
    }
    return resizeImageBy ( image, size, ( size == width ) );
}
public static Image resizeImageBy ( Image image, int size, boolean setWidth ) {
    if ( setWidth ) {
        return image.getScaledInstance ( size, -1, Image.SCALE_SMOOTH );
    } else {
        return image.getScaledInstance ( -1, size, Image.SCALE_SMOOTH );
    }
}
