public class Ranges {
    public static class Range {
        private int low;
        private int high;
        public Range ( int low, int high ) {
            this.low = low;
            this.high = high;
        }
        public int getHigh() {
            return high;
        }
        public void setHigh ( int high ) {
            this.high = high;
        }
        @Override
        public String toString() {
            return ( low == high ) ? String.valueOf ( low ) : String.format ( "%d-%d", low, high );
        }
    }
    public static void main ( String[] args ) {
        String input = "2,3,6,7,8,10,12,14,15,16";
        List<Integer> inputNumbers = new ArrayList<Integer>();
        for ( String num : input.split ( "," ) ) {
            inputNumbers.add ( Integer.parseInt ( num ) );
        }
        Collections.sort ( inputNumbers );
        Range thisRange = null;
        List<Range> ranges = new ArrayList<Range>();
        for ( Integer number : inputNumbers ) {
            if ( thisRange != null && number <= thisRange.getHigh() + 1 ) {
                thisRange.setHigh ( number );
            } else {
                thisRange = new Range ( number, number );
                ranges.add ( thisRange );
            }
        }
        String result = StringUtils.collectionToCommaDelimitedString ( ranges );
        System.out.println ( "result = " + result );
    }
}
