public class SkaExecutionPanel {
    public interface Listener {
        void panelReset ( SkaExecutionPanel panel );
    }
    private List<Listener> listeners = new ArrayList<Listener>();
    public void addListener ( Listener listener ) {
        listeners.add ( listener );
    }
    public void removeListener ( Listener listener ) {
        listeners.remove ( listener );
    }
    public void reset() {
        for ( Listener listener : listeners ) {
            listener.panelReset ( this );
        }
    }
}
public class SkaTest {
    public static void main ( String args[] ) {
        for ( i = 0; i < alg.length; i++ ) {
            execPanel[i].addListener ( new SkaExecutionPanel.Listener() {
                final int index = i;
                public void panelReset ( SkaExecutionPanel panel ) {
                    alg[index].terminate();
                    createProgram ( index );
                    alg[index].start();
                    execPanel[index].unreset();
                }
            } );
        }
    }
}
