import java.util.Arrays;
public class Gene implements Cloneable {
    private static final int GENE_LENGTH = 4;
    private char m_sequence[];
    public Gene ( char sequence[] ) {
        m_sequence = Arrays.copyOf ( sequence, GENE_LENGTH );
    }
    public char getUnit ( int index ) {
        return m_sequence[index];
    }
    public void setUnit ( int index, char unit ) {
        m_sequence[index] = unit;
    }
    protected Object clone() throws CloneNotSupportedException {
        Gene clone = ( Gene ) ( super.clone() );
        clone.m_sequence = Arrays.copyOf ( m_sequence, GENE_LENGTH );
        return clone;
    }
    @Override
    public String toString() {
        return Arrays.toString ( m_sequence );
    }
}
