abstract class SVGElement {
    public void draw ( void ) {
        return;
    }
    public boolean hasWidth ( void ) {
        return false;
    }
    public boolean hasHeight ( void ) {
        return false;
    }
}
abstract class SVGElementDecorator extends SVGElement {
    protected SVGElement decoratedElement;
    public SVGElementDecorator ( SVGElement decoratedElement ) {
        this.decoratedElement = decoratedElement;
    }
    public void draw ( void ) {
        decoratedElement.draw ();
    }
}
class WidthDecorator extends SVGElementDecorator {
    private double width;
    public WidthAndHeightDecorator ( SVGElement decoratedElement ) {
        super ( decoratedElement );
    }
    public boolean hasWidth ( void ) {
        return true;
    }
    public double getWidth ( void ) {
        return width;
    }
    public void draw ( void ) {
        decoratedElement.draw ();
    }
}
