std::string error_msg;
_append_exception_trace_messages ( * pEnv,
                                   error_msg,
                                   exception,
                                   mid_throwable_getCause,
                                   mid_throwable_getStackTrace,
                                   mid_throwable_toString,
                                   mid_frame_toString );
void _append_exception_trace_messages (
    JNIEnv &      a_jni_env,
    std::string & a_error_msg,
    jthrowable   a_exception,
    jmethodID    a_mid_throwable_getCause,
    jmethodID    a_mid_throwable_getStackTrace,
    jmethodID    a_mid_throwable_toString,
    jmethodID    a_mid_frame_toString ) {
    jobjectArray frames =
        ( jobjectArray ) a_jni_env.CallObjectMethod (
            a_exception,
            a_mid_throwable_getStackTrace );
    jsize frames_length = a_jni_env.GetArrayLength ( frames );
    if ( 0 != frames ) {
        jstring msg_obj =
            ( jstring ) a_jni_env.CallObjectMethod ( a_exception,
                    a_mid_throwable_toString );
        const char * msg_str = a_jni_env.GetStringUTFChars ( msg_obj, 0 );
        if ( !a_error_msg.empty() ) {
            a_error_msg += "\nCaused by: ";
            a_error_msg += msg_str;
        } else {
            a_error_msg = msg_str;
        }
        a_jni_env.ReleaseStringUTFChars ( msg_obj, msg_str );
        a_jni_env.DeleteLocalRef ( msg_obj );
    }
    if ( frames_length > 0 ) {
        jsize i = 0;
        for ( i = 0; i < frames_length; i++ ) {
            jobject frame = a_jni_env.GetObjectArrayElement ( frames, i );
            jstring msg_obj =
                ( jstring ) a_jni_env.CallObjectMethod ( frame,
                        a_mid_frame_toString );
            const char * msg_str = a_jni_env.GetStringUTFChars ( msg_obj, 0 );
            a_error_msg += "\n    ";
            a_error_msg += msg_str;
            a_jni_env.ReleaseStringUTFChars ( msg_obj, msg_str );
            a_jni_env.DeleteLocalRef ( msg_obj );
            a_jni_env.DeleteLocalRef ( frame );
        }
    }
    if ( 0 != frames ) {
        jthrowable cause =
            ( jthrowable ) a_jni_env.CallObjectMethod (
                a_exception,
                a_mid_throwable_getCause );
        if ( 0 != cause ) {
            _append_exception_trace_messages ( a_jni_env,
                                               a_error_msg,
                                               cause,
                                               a_mid_throwable_getCause,
                                               a_mid_throwable_getStackTrace,
                                               a_mid_throwable_toString,
                                               a_mid_frame_toString );
        }
    }
}
