package at.corba.test.builder;
import java.util.LinkedHashMap;
import java.util.Map;
public class GraphBuilder {
    Map<Integer, StateBuilder> stateBuilderMap = new LinkedHashMap<Integer, StateBuilder>();
    public StateBuilder createNode ( final int nodeNumber ) {
        StateBuilder builder = new StateBuilder ( this );
        stateBuilderMap.put ( nodeNumber, builder );
        return  builder;
    }
    public SetBasedDirectedGraph build() {
        SetBasedDirectedGraph graph = new SetBasedDirectedGraph();
        for ( int key : stateBuilderMap.keySet() ) {
            StateBuilder builder = stateBuilderMap.get ( key );
            State state = graph.createNode ( key );
            state = builder.build ( state );
            graph.addNode ( state );
        }
        return graph;
    }
}
