package at.corba.test.builder;
import java.util.HashMap;
import java.util.Map;
public class StateBuilder {
    private final GraphBuilder graphBuilder;
    Map<GraphProperties, String> propertyMap = new HashMap<GraphProperties, String>();
    public StateBuilder ( final GraphBuilder graphBuilder )  {
        this.graphBuilder = graphBuilder;
    }
    public StateBuilder setLabel ( final String label ) {
        propertyMap.put ( GraphProperties.LABEL, label );
        return this;
    }
    public StateBuilder setDescription ( final String description ) {
        propertyMap.put ( GraphProperties.DESCRIPTION, description );
        return this;
    }
    public GraphBuilder add() {
        return graphBuilder;
    }
    public State build ( final State state ) {
        for ( GraphProperties key : propertyMap.keySet() ) {
            String value = propertyMap.get ( key );
            state.setProperty ( key, value );
        }
        return state;
    }
}
