private void sched ( TimerTask task, long time, long period ) {
    if ( time < 0 ) {
        throw new IllegalArgumentException ( "Illegal execution time." );
    }
    synchronized ( queue ) {
        if ( !thread.newTasksMayBeScheduled ) {
            throw new IllegalStateException ( "Timer already cancelled." );
        }
        synchronized ( task.lock ) {
            if ( task.state != TimerTask.VIRGIN )
                throw new IllegalStateException (
                    "Task already scheduled or cancelled" );
            task.nextExecutionTime = time;
            task.period = period;
            task.state = TimerTask.SCHEDULED;
        }
        queue.add ( task );
        if ( queue.getMin() == task ) {
            queue.notify();
        }
    }
}
