private static final String NULL_TREE_NODE = "";
public static void save ( TreeNode node, BufferedWriter out ) {
    if ( node == null ) {
        out.write ( NULL_TREE_NODE );
        out.newLine();
        return;
    }
    assert !node.value().equals ( NULL_TREE_NODE );
    assert !node.value().matches ( ".*[\r\n].*" );
    out.write ( node.value() );
    out.newLine();
    save ( node.left(), out );
    save ( node.right(), out );
}
public static TreeNode load ( BufferedReader in ) throws IOException {
    String value = in.readLine();
    if ( value == null ) {
        throw new EOFException();
    }
    if ( value.equals ( NULL_TREE_NODE ) ) {
        return null;
    }
    TreeNode node = new TreeNode();
    node.value ( value );
    node.left ( load ( in ) );
    node.right ( load ( in ) );
    return node;
}
