import SimpleOpenNI.*;
SimpleOpenNI  context;
SceneMapper sceneMap;
void setup() {
    context = new SimpleOpenNI ( this );
    context.enableScene();
    background ( 200, 0, 0 );
    size ( context.sceneWidth() , context.sceneHeight() );
    sceneMap = new SceneMapper ( context );
}
void draw() {
    context.update();
    sceneMap.update();
    image ( sceneMap.scene, 0, 0 );
}
class SceneMapper {
    PImage scene;
    int[] sceneMap;
    int numPixels;
    color bg;
    color[] users = {color ( 255 ), color ( 192 ), color ( 127 ), color ( 64 ), color ( 32 ) };
    SceneMapper ( SimpleOpenNI context ) {
        numPixels = context.sceneWidth() * context.sceneHeight();
        sceneMap = new int[numPixels];
        scene = createImage ( context.sceneWidth(), context.sceneHeight(), RGB );
        scene.loadPixels();
        bg = color ( 0 );
    }
    void update() {
        context.sceneMap ( sceneMap );
        Arrays.fill ( scene.pixels, bg );
        for ( int i = 0 ; i < numPixels ; i++ ) {
            for ( int u = 0 ; u < users.length; u++ ) {
                if ( sceneMap[i] > 0 ) {
                    scene.pixels[i] = users[u];
                }
            }
        }
        scene.updatePixels();
    }
}
