private void purchaseStateChanged ( int startId, String signedData, String signature ) {
    ArrayList<Security.VerifiedPurchase> purchases;
    purchases = Security.verifyPurchase ( signedData, signature );
    if ( purchases == null ) {
        return;
    }
    ArrayList<String> notifyList = new ArrayList<String>();
    for ( VerifiedPurchase vp : purchases ) {
        if ( vp.notificationId != null ) {
            notifyList.add ( vp.notificationId );
        }
        ResponseHandler.purchaseResponse ( this, vp.purchaseState, vp.productId,
                                           vp.orderId, vp.purchaseTime, vp.developerPayload );
    }
    if ( !notifyList.isEmpty() ) {
        String[] notifyIds = notifyList.toArray ( new String[notifyList.size()] );
        confirmNotifications ( startId, notifyIds );
    }
}
