import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.List;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;
import android.app.ListActivity;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;
public class AndroidRssReader extends ListActivity {
    private RSSFeed myRssFeed = null;
    public class MyCustomAdapter extends ArrayAdapter<RSSItem> {
        public MyCustomAdapter ( Context context, int textViewResourceId,
                                 List<RSSItem> list ) {
            super ( context, textViewResourceId, list );
        }
        @Override
        public View getView ( int position, View convertView, ViewGroup parent ) {
            View row = convertView;
            if ( row == null ) {
                LayoutInflater inflater = getLayoutInflater();
                row = inflater.inflate ( R.layout.row, parent, false );
            }
            TextView listTitle = ( TextView ) row.findViewById ( R.id.listtitle );
            listTitle.setText ( myRssFeed.getList().get ( position ).getTitle() );
            TextView listPubdate = ( TextView ) row.findViewById ( R.id.listpubdate );
            listPubdate.setText ( myRssFeed.getList().get ( position ).getPubdate() );
            if ( position % 2 == 0 ) {
                listTitle.setBackgroundColor ( 0xff101010 );
                listPubdate.setBackgroundColor ( 0xff101010 );
            } else {
                listTitle.setBackgroundColor ( 0xff080808 );
                listPubdate.setBackgroundColor ( 0xff080808 );
            }
            return row;
        }
    }
    @Override
    public void onCreate ( Bundle savedInstanceState ) {
        super.onCreate ( savedInstanceState );
        setContentView ( R.layout.main );
        try {
            URL rssUrl = new URL ( "http://www.gov.hk/en/about/rss/govhkrss.data.xml" );
            SAXParserFactory mySAXParserFactory = SAXParserFactory.newInstance();
            SAXParser mySAXParser = mySAXParserFactory.newSAXParser();
            XMLReader myXMLReader = mySAXParser.getXMLReader();
            RSSHandler myRSSHandler = new RSSHandler();
            myXMLReader.setContentHandler ( myRSSHandler );
            InputSource myInputSource = new InputSource ( rssUrl.openStream() );
            myXMLReader.parse ( myInputSource );
            myRssFeed = myRSSHandler.getFeed();
        } catch ( MalformedURLException e ) {
            e.printStackTrace();
        } catch ( ParserConfigurationException e ) {
            e.printStackTrace();
        } catch ( SAXException e ) {
            e.printStackTrace();
        } catch ( IOException e ) {
            e.printStackTrace();
        }
        if ( myRssFeed != null ) {
            TextView feedTitle = ( TextView ) findViewById ( R.id.feedtitle );
            TextView feedDescribtion = ( TextView ) findViewById ( R.id.feeddescribtion );
            TextView feedPubdate = ( TextView ) findViewById ( R.id.feedpubdate );
            TextView feedLink = ( TextView ) findViewById ( R.id.feedlink );
            feedTitle.setText ( myRssFeed.getTitle() );
            feedDescribtion.setText ( myRssFeed.getDescription() );
            feedPubdate.setText ( myRssFeed.getPubdate() );
            feedLink.setText ( myRssFeed.getLink() );
            MyCustomAdapter adapter =
                new MyCustomAdapter ( this, R.layout.row, myRssFeed.getList() );
            setListAdapter ( adapter );
        }
    }
    @Override
    protected void onListItemClick ( ListView l, View v, int position, long id ) {
        Intent intent = new Intent ( this, ShowDetails.class );
        Bundle bundle = new Bundle();
        bundle.putString ( "keyTitle", myRssFeed.getItem ( position ).getTitle() );
        bundle.putString ( "keyDescription", myRssFeed.getItem ( position ).getDescription() );
        bundle.putString ( "keyLink", myRssFeed.getItem ( position ).getLink() );
        bundle.putString ( "keyPubdate", myRssFeed.getItem ( position ).getPubdate() );
        intent.putExtras ( bundle );
        startActivity ( intent );
    }
}
