import org.jivesoftware.smack.packet.PacketExtension;
public class DeliveryReceipt implements PacketExtension {
    public static final String NAMESPACE = "urn:xmpp:receipts";
    private String id;
    public DeliveryReceipt ( String id ) {
        this.id = id;
    }
    public String getId() {
        return id;
    }
    public String getElementName() {
        return "received";
    }
    public String getNamespace() {
        return NAMESPACE;
    }
    public String toXML() {
        return "<received xmlns='" + NAMESPACE + "' id='" + id + "'/>";
    }
}
* /
import org.jivesoftware.smack.packet.PacketExtension;
import org.jivesoftware.smackx.provider.EmbeddedExtensionProvider;
import org.xmlpull.v1.XmlPullParser;
import java.util.List;
import java.util.Map;
public class DeliveryReceiptProvider extends EmbeddedExtensionProvider {
    @Override
    protected PacketExtension createReturnExtension ( String currentElement, String currentNamespace,
            Map<String, String> attributeMap, List<? extends PacketExtension> content ) {
        return new DeliveryReceipt ( attributeMap.get ( "id" ) );
    }
}
ProviderManager.getInstance().addExtensionProvider ( "received", DeliveryReceipt.NAMESPACE, new DeliveryReceiptProvider() );
