import org.aspectj.lang.*;
import org.apache.log4j.*;
public aspect TraceMethodCalls {
    Logger logger = Logger.getLogger ( "trace" );
    TraceMethodCalls() {
        logger.setLevel ( Level.ALL );
    }
    pointcut traceMethods()
    : ( execution ( * * .* ( .. ) )
    || execution ( * .new ( .. ) ) )
    && !within ( TraceMethodCalls );
    before() : traceMethods() {
        if ( logger.isEnabledFor ( Level.INFO ) ) {
            Signature sig = thisJoinPointStaticPart.getSignature();
            logger.log ( Level.INFO,
            "Entering ["
            + sig.getDeclaringType().getName() + "."
            + sig.getName() + "]" );
        }
    }
}
