public static final String localize ( final Locale locale, final String key, final Object... param ) {
    final String name = "message";
    final ResourceBundle rb;
    try {
        rb = ResourceBundle.getBundle ( name, locale, Thread.currentThread()
                                        .getContextClassLoader() );
    } catch ( MissingResourceException e ) {
        throw new RuntimeException ( "Bundle not found:" + name );
    }
    String keyValue = null;
    try {
        keyValue = rb.getString ( key );
    } catch ( MissingResourceException e ) {
        keyValue = "???" + key + "???";
    }
    if ( param != null && param.length > 0 ) {
        return MessageFormat.format ( keyValue, param );
    } else {
        return keyValue;
    }
}
