import java.awt.image.BufferedImage;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.imageio.ImageIO;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.SwingUtilities;
public class SplashScreen extends JFrame {
    public SplashScreen() {
        super ( "Splash screen" );
    }
    public void createSplashScreen ( final URL imageURL ) {
        JLabel splashLabel = new JLabel ( new ImageIcon ( imageURL ) );
        add ( splashLabel );
        setSize ( splashLabel.getPreferredSize() );
        setUndecorated ( true );
        setLocationRelativeTo ( null );
        setVisible ( true );
        repaint();
    }
    public void close() {
        setVisible ( false );
        dispose();
    }
    public static void main ( String[] args ) {
        SwingUtilities.invokeLater ( new Runnable() {
            @Override
            public void run() {
                try {
                    new SplashScreen().createSplashScreen ( new URL (
                            "http://art.gnome.org/download/themes/splash_screens/1334/Splash-GnomeDarkSplashScreen.png" ) );
                } catch ( MalformedURLException e ) {
                    e.printStackTrace();
                }
            }
        } );
    }
}
