import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.util.Arrays;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.text.BadLocationException;
import javax.swing.text.Document;
public class DocumentEventDemo extends JFrame {
    JPanel txtPanel, centerPanel;
    GridLayout grid;
    JTextField txtField;
    JTextArea txtArea;
    JFrame frame;
    JComponent newContentPane;
    FlowLayout flow;
    public DocumentEventDemo() {
        txtArea = new JTextArea();
        txtArea.getDocument().addDocumentListener ( new MyDocumentListener() );
        txtArea.getDocument().putProperty ( "txtArea", "MyDocumentListener" );
        centerPanel = new JPanel();
        grid = new GridLayout ( 2, 1, 1, 1 );
        txtPanel = new JPanel();
        flow = new FlowLayout ( FlowLayout.CENTER );
        txtPanel.setLayout ( flow );
        centerPanel.setLayout ( grid );
        centerPanel.add ( txtArea );
        getContentPane().add ( centerPanel, "Center" );
        this.setSize ( 500, 200 );
        this.validate();
        this.setVisible ( true );
        setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
    }
    class MyDocumentListener implements DocumentListener {
        String[] word = new String[50];
        String text;
        int i = 0;
        int y;
        int l;
        int len;
        public void changedUpdate ( DocumentEvent documentEvent ) {
            System.out.println ( "The text has been changed." );
        }
        public void insertUpdate ( DocumentEvent documentEvent ) {
            try {
                GetWord ( documentEvent );
            } catch ( BadLocationException ex ) {
                Logger.getLogger ( DocumentListener.class.getName() ).log ( Level.SEVERE, null, ex );
            }
        }
        public void removeUpdate ( DocumentEvent documentEvent ) {
            System.out.println ( "A character has been removed!" );
        }
        private void GetWord ( DocumentEvent documentEvent ) throws BadLocationException {
            DocumentEvent.EventType type = documentEvent.getType();
            if ( type.equals ( DocumentEvent.EventType.INSERT ) ) {
                Document source = documentEvent.getDocument();
                y = documentEvent.getOffset();
                l = documentEvent.getLength();
                len = source.getLength();
                text = source.getText ( y, l );
                if ( text.equals ( " " ) ) {
                    for ( int z = 0; z < len; z++ ) {
                        System.out.print ( word[z] );
                    }
                    System.out.println ( "\n" );
                    Arrays.fill ( word, null );
                    i = 0;
                }
                word[i] = text;
                i++;
            } else  {
                System.out.println ( "A character has been removed!" );
            }
        }
    };
    public static void main ( String args[] ) {
        new DocumentEventDemo();
    }
}
