public static Bitmap decodeSampledBitmapFromResource ( Resources res, int resId, int reqWidth, int reqHeight ) {
    final BitmapFactory.Options options = new BitmapFactory.Options();
    options.inJustDecodeBounds = true;
    BitmapFactory.decodeResource ( res, resId, options );
    options.inSampleSize = calculateInSampleSize ( options, reqWidth, reqHeight );
    options.inJustDecodeBounds = false;
    return BitmapFactory.decodeResource ( res, resId, options );
}
public static int calculateInSampleSize ( BitmapFactory.Options options, int reqWidth, int reqHeight ) {
    final int height = options.outHeight;
    final int width = options.outWidth;
    int inSampleSize = 1;
    if ( height > reqHeight || width > reqWidth ) {
        if ( width > height ) {
            inSampleSize = Math.round ( ( float ) height / ( float ) reqHeight );
        } else {
            inSampleSize = Math.round ( ( float ) width / ( float ) reqWidth );
        }
        final float totalPixels = width * height;
        final float totalReqPixelsCap = reqWidth * reqHeight * 2;
        while ( totalPixels / ( inSampleSize * inSampleSize ) > totalReqPixelsCap ) {
            inSampleSize++;
        }
    }
    return inSampleSize;
}
