import java.awt.*;
import java.awt.font.TextAttribute;
import java.util.Map;
import javax.swing.*;
import javax.swing.border.Border;
import javax.swing.border.CompoundBorder;
import javax.swing.border.EmptyBorder;
import javax.swing.border.MatteBorder;
import javax.swing.table.*;
public class TablePrepareRenderer extends JFrame {
    private static final long serialVersionUID = 1L;
    private JTable table;
    public TablePrepareRenderer() {
        Object[] columnNames = {"Type", "Company", "Shares", "Price", "Boolean"};
        Object[][] data = {
            {"Buy", "IBM", new Integer ( 1000 ), new Double ( 80.50 ), false},
            {"Sell", "MicroSoft", new Integer ( 2000 ), new Double ( 6.25 ), true},
            {"Sell", "Apple", new Integer ( 3000 ), new Double ( 7.35 ), true},
            {"Buy", "Nortel", new Integer ( 4000 ), new Double ( 20.00 ), false}
        };
        DefaultTableModel model = new DefaultTableModel ( data, columnNames ) {
            private static final long serialVersionUID = 1L;
            @Override
            public Class getColumnClass ( int column ) {
                return getValueAt ( 0, column ).getClass();
            }
        };
        table = new JTable ( model ) {
            private static final long serialVersionUID = 1L;
            private Border outside = new MatteBorder ( 1, 0, 1, 0, Color.red );
            private Border inside = new EmptyBorder ( 0, 1, 0, 1 );
            private Border highlight = new CompoundBorder ( outside, inside );
            @Override
            public Component prepareRenderer ( TableCellRenderer renderer, int row, int column ) {
                int modelRow = convertRowIndexToModel ( row );
                int modelColumn = convertColumnIndexToModel ( column );
                if ( !isRowSelected ( modelRow ) ) {
                    if ( modelColumn != 0 || modelRow != 0 ) {
                        comp.setBackground ( Color.GREEN );
                    } else {
                        comp.setBackground ( table.getBackground() );
                    }
                }
                return comp;
            }
        };
        table.setPreferredScrollableViewportSize ( table.getPreferredSize() );
        JScrollPane scrollPane = new JScrollPane ( table );
        getContentPane().add ( scrollPane );
    }
    public static void main ( String[] args ) {
        SwingUtilities.invokeLater ( new Runnable() {
            @Override
            public void run() {
                TablePrepareRenderer frame = new TablePrepareRenderer();
                frame.setDefaultCloseOperation ( EXIT_ON_CLOSE );
                frame.pack();
                frame.setLocationRelativeTo ( null );
                frame.setVisible ( true );
            }
        } );
    }
}
