import java.util.*;
class Command {
    private String id;
    public Command ( String pId ) {
        this.id = pId;
    }
    public void execute () {
        System.out.println ( "Command: " + id );
    }
}
public class CommandDist {
    class Cmd {
        Command command;
        double assignedProportion;
        double cumulativeProportion;
        public Cmd ( Command c, double proportion ) {
            this.command = c;
            this.assignedProportion = proportion;
            this.cumulativeProportion = 0.0;
        }
    }
    private List<Cmd> commandDistribution = new ArrayList<Cmd>();
    private java.util.Random myRandom = new java.util.Random();
    void addCommand ( Command command, double proportion ) {
        commandDistribution.add ( new Cmd ( command, proportion ) );
    }
    void normaliseProportion() {
        double total = 0;
        double cumulativeProp = 0;
        for ( Cmd cmd : commandDistribution ) {
            total += cmd.assignedProportion;
        }
        for ( Cmd cmd : commandDistribution ) {
            cumulativeProp += cmd.assignedProportion / total;
            cmd.cumulativeProportion = cumulativeProp;
        }
    }
    private Command getNextCommandToExecute () {
        double d = myRandom.nextDouble();
        for ( Cmd cmd : commandDistribution ) {
            if ( d < cmd.cumulativeProportion ) {
                return cmd.command;
            }
        }
        return commandDistribution.get ( 0 ).command;
    }
    public static void main ( String [] args ) {
        CommandDist cd = new CommandDist();
        Command c;
        cd.addCommand ( new Command ( "A" ), 50.0 );
        cd.addCommand ( new Command ( "B" ), 20.0 );
        cd.addCommand ( new Command ( "C" ), 15.0 );
        cd.addCommand ( new Command ( "D" ), 10.0 );
        cd.normaliseProportion();
        for ( int i = 0; i < 10000; i++ ) {
            c = cd.getNextCommandToExecute();
            c.execute();
        }
    }
}
