public class FileSystemListener implements FileSystemJournalListener, Runnable {
    private long _lastUSN;
    private String _imageFilename;
    public void run() {
    }
    public FileSystemListener() {
        _lastUSN = FileSystemJournal.getNextUSN();
    }
    public void fileJournalChanged() {
        long nextUSN = FileSystemJournal.getNextUSN();
        boolean imgFound = false;
        for ( long lookUSN = nextUSN - 1; ( lookUSN >= _lastUSN ) && !imgFound; --lookUSN ) {
            FileSystemJournalEntry entry = FileSystemJournal.getEntry ( lookUSN );
            if ( entry == null ) {
                break;
            } else {
                String path = entry.getPath();
                if ( path != null ) {
                    if ( path.endsWith ( "png" ) || path.endsWith ( "jpg" ) || path.endsWith ( "bmp" ) || path.endsWith ( "gif" ) ) {
                        switch ( entry.getEvent() ) {
                        case FileSystemJournalEntry.FILE_ADDED:
                            _lastUSN = lookUSN;
                            _imageFilename = path;
                            imgFound = true;
                            UiApplication.getUiApplication().removeFileSystemJournalListener ( this );
                            UiApplication.getUiApplication().invokeLater ( this );
                            break;
                        case FileSystemJournalEntry.FILE_DELETED:
                            break;
                        }
                    }
                }
            }
        }
    }
}
