public class BlockUntilAvailableSlot implements RejectedExecutionHandler {
    public void rejectedExecution ( Runnable r, ThreadPoolExecutor e ) {
        if ( e.isTerminated() || e.isShutdown() ) {
            return;
        }
        boolean submitted = false;
        while ( ! submitted ) {
            if ( Thread.currentThread().isInterrupted() ) {
            }
            try {
                e.execute ( r );
                submitted = true;
            } catch ( RejectedExceptionException e ) {
                try {
                    Thread.sleep ( 100L );
                } catch ( InterruptedException e ) {
                    ;
                }
            }
        }
    }
}
