package test.t100.t001;
import java.awt.BorderLayout;
import java.awt.GridLayout;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.SwingUtilities;
import javax.swing.event.AncestorEvent;
import javax.swing.event.AncestorListener;
public class LoginRequired {
    LoginRequired() {
        JFrame f = new JFrame ( "Login Required" );
        f.setDefaultCloseOperation ( JFrame.DISPOSE_ON_CLOSE );
        f.setSize ( 400, 300 );
        f.setResizable ( false );
        f.setLocationByPlatform ( true );
        f.setVisible ( true );
        showLogin ( f );
    }
    private void showLogin ( JFrame frame ) {
        JPanel p = new JPanel ( new BorderLayout ( 5, 5 ) );
        JPanel labels = new JPanel ( new GridLayout ( 0, 1, 2, 2 ) );
        labels.add ( new JLabel ( "User Name", SwingConstants.RIGHT ) );
        labels.add ( new JLabel ( "Password", SwingConstants.RIGHT ) );
        p.add ( labels, BorderLayout.WEST );
        JPanel controls = new JPanel ( new GridLayout ( 0, 1, 2, 2 ) );
        JTextField username = new JTextField ( "Joe Blogs" );
        controls.add ( username );
        JPasswordField password = new JPasswordField();
        password.addAncestorListener ( new RequestFocusListener ( false ) );
        controls.add ( password );
        p.add ( controls, BorderLayout.CENTER );
        JOptionPane.showMessageDialog (
            frame, p, "Log In", JOptionPane.QUESTION_MESSAGE );
    }
    public static void main ( String[] args ) {
        SwingUtilities.invokeLater ( new Runnable() {
            @Override
            public void run() {
                new LoginRequired();
            }
        } );
    }
}
class RequestFocusListener implements AncestorListener {
    private boolean removeListener;
    public RequestFocusListener() {
        this ( true );
    }
    public RequestFocusListener ( boolean removeListener ) {
        this.removeListener = removeListener;
    }
    @Override
    public void ancestorAdded ( AncestorEvent e ) {
        JComponent component = e.getComponent();
        component.requestFocusInWindow();
        if ( removeListener ) {
            component.removeAncestorListener ( this );
        }
    }
    @Override
    public void ancestorMoved ( AncestorEvent e ) {}
    @Override
    public void ancestorRemoved ( AncestorEvent e ) {}
}
