public class DuplexBase64MarshallAdapter extends XmlAdapter<String, byte[]> {
    public static final boolean HALF_DUPLEX = false;
    public static final boolean FULL_DUPLEX = true;
    private boolean isFullDuplexMode;
    public DuplexBase64MarshallAdapter() {
        this.isFullDuplexMode = HALF_DUPLEX;
    }
    public DuplexBase64MarshallAdapter ( boolean fullDuplex ) {
        this.isFullDuplexMode = fullDuplex;
    }
    @Override
    public byte[] unmarshal ( String v ) throws Exception {
        return Base64.decode ( v );
    }
    @Override
    public String marshal ( byte[] v ) throws Exception {
        if ( isFullDuplexMode ) {
            return Base64.encodeBytes ( v );
        }
        return "";
    }
}
