public static class HackRoundedDoubleConverter implements Converter {
    private HackRoundedDoubleConverter() {
    }
    @Override
    public boolean canConvert ( Class clazz ) {
        return RoundedDouble.class.isAssignableFrom ( clazz );
    }
    @Override
    public void marshal ( Object value, HierarchicalStreamWriter writer, MarshallingContext context ) {
        if ( value == null ) {
            return;
        }
        RoundedDouble number = ( RoundedDouble ) value;
        if ( Double.isNaN ( number.getValue() ) || Double.isInfinite ( number.getValue() ) ) {
            return;
        }
        if ( writer.underlyingWriter() instanceof HackJsonWriter ) {
            HackJsonWriter hackWriter = ( HackJsonWriter ) writer.underlyingWriter();
            hackWriter.dropQuotes();
            writer.setValue ( number.getRoundedValue() );
            hackWriter.allowQuotes();
        } else {
            writer.setValue ( number.getRoundedValue() );
        }
    }
    @Override
    public Object unmarshal ( HierarchicalStreamReader reader, UnmarshallingContext context ) {
        return null;
    }
}
