ZipInputStream zis = null;
try {
    zis = new ZipInputStream ( new FileInputStream ( zipFilePath ) );
    ZipEntry entry;
    while ( ( entry = zis.getNextEntry() ) != null ) {
        File entryFile = new File ( destinationPath, entry.getName() );
        if ( entry.isDirectory() ) {
            if ( entryFile.exists() ) {
                logger.log ( Level.WARNING, "Directory {0} already exists!", entryFile );
            } else {
                entryFile.mkdirs();
            }
        } else {
            if ( entryFile.getParentFile() != null && !entryFile.getParentFile().exists() ) {
                entryFile.getParentFile().mkdirs();
            }
            if ( !entryFile.exists() ) {
                entryFile.createNewFile();
            }
            OutputStream os = null;
            try {
                os = new FileOutputStream ( entryFile );
                IOUtils.copy ( zis, os );
            } finally {
                IOUtils.closeQuietly ( os );
            }
        }
    }
} finally {
    IOUtils.closeQuietly ( zis );
}
