class Canvas extends JSVGCanvas implements SVGLoadEventDispatcherListener {
    public Canvas() {
        super();
        setDocumentState ( ALWAYS_DYNAMIC );
        addSVGLoadEventDispatcherListener ( this );
    }
    private boolean isReadyForModification = false;
    public void renewDocument ( final SVGDocument doc ) {
        if ( isReadyForModification ) {
            getUpdateManager().getUpdateRunnableQueue().invokeLater (
            new Runnable() {
                @Override
                public void run() {
                    Node oldRoot = getSVGDocument().getFirstChild();
                    Node newRoot = doc.getFirstChild();
                    newRoot = getSVGDocument().importNode ( newRoot,
                                                            true );
                    getSVGDocument().replaceChild ( newRoot, oldRoot );
                }
            } );
        } else {
            setSVGDocument ( doc );
        }
    }
    @Override
    public void svgLoadEventDispatchCompleted ( SVGLoadEventDispatcherEvent e ) {
        isReadyForModification = true;
    }
}
