import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
public class FileSplit {
    public static void main ( String[] args ) throws IOException {
        new FileSplit().splitFile ( new File ( args[0] ) );
    }
    private void splitFile ( File file ) throws IOException {
        FileInputStream fis = new FileInputStream ( file );
        try {
            byte[] buffer = new byte[1024];
            int remaining = buffer.length;
            int blockNumber = 1;
            while ( true ) {
                int read = fis.read ( buffer, buffer.length - remaining, remaining );
                if ( read >= 0 ) {
                    remaining -= read;
                    if ( remaining == 0 ) {
                        writeBlock ( blockNumber, buffer, buffer.length - remaining );
                        blockNumber++;
                        remaining = buffer.length;
                    }
                } else {
                    if ( remaining < buffer.length ) {
                        writeBlock ( blockNumber, buffer, buffer.length - remaining );
                    }
                    break;
                }
            }
        } finally {
            fis.close();
        }
    }
    private void writeBlock ( int blockNumber, byte[] buffer, int length ) throws IOException {
        FileOutputStream fos = new FileOutputStream ( "output_" + blockNumber + ".dat" );
        try {
            fos.write ( buffer, 0, length );
        } finally {
            fos.close();
        }
    }
}
