import java.util.concurrent.TimeUnit;
public class StartPauseDemo extends Thread {
    volatile int i = 1;
    public void pause() {
        i = 0;
    }
    public synchronized void unPause() {
        i = 1;
        notify();
    }
    @Override
    public void run() {
        while ( i == 1 ) {
            System.out.println ( System.currentTimeMillis() );
            try {
                TimeUnit.MILLISECONDS.sleep ( 200 );
            } catch ( InterruptedException e ) {
                e.printStackTrace();
            }
            if ( i == 0 ) {
                synchronized ( this ) {
                    try {
                        wait();
                    } catch ( InterruptedException e ) {
                        e.printStackTrace();
                    }
                }
            }
        }
    }
    public static void main ( String[] args ) throws InterruptedException {
        StartPauseDemo sp = new StartPauseDemo();
        sp.start();
        while ( true ) {
            System.out.println ( "pausing" );
            sp.pause();
            TimeUnit.SECONDS.sleep ( 1 );
            System.out.println ( "unpausing" );
            sp.unPause();
            TimeUnit.SECONDS.sleep ( 1 );
        }
    }
}
