public class TestThread {
    public static void main ( String[] args ) {
        new ConnectionDispatcher ( 8080 ).start();
        new CommandProcessor().start();
    }
}
class ConnectionDispatcher extends Thread {
    private int port;
    private OutputStream outputStreams;
    ConnectionDispatcher ( int port ) {
        this.port = port;
    }
    @Override
    public void run() {
        try {
            listen ( port );
        } catch ( IOException e ) {
            e.printStackTrace();
        }
    }
    public void listen ( int port ) throws IOException {
        ss = new ServerSocket ( port );
        System.out.println ( "Listening on " + InetAddress.getLocalHost() + ":" + ss.getLocalPort() );
        boolean running = true;
        while ( running ) {
            Socket s = ss.accept();
            System.out.println ( "Connection from: " + getFullIP ( s ) );
            DataOutputStream dataOut = new DataOutputStream ( s.getOutputStream() );
            outputStreams.put ( s, dataOut );
            new ServerThread ( this, s );
        }
    }
}
class CommandProcessor extends Thread {
    @Override
    public void run() {
        Scanner cmdScanner = new Scanner ( System.in );
        String command = cmdScanner.next();
        processCommand ( command );
    }
}
