public final class MyUserDetailsService implements UserDetailsService {
    private final UsersDao usersDao;
    @Autowired
    public UserDetailsServiceImpl ( final UsersDao usersDao ) {
        this.usersDao = usersDao;
    }
    @Override
    public UserDetails loadUserByUsername ( final String username ) {
        UserEntity user = usersDao.getUserByOpenIdIdentifier ( username );
        if ( user == null ) {
            return new User ( username, "", new ArrayList<GrantedAuthority>() );
        }
        final Collection<GrantedAuthority> authorities = new ArrayList<GrantedAuthority>();
        authorities.add ( new SimpleGrantedAuthority ( user.getUserType().toString() ) );
        final UserDetails result = new User ( username, "", authorities );
        return result;
    }
}
