import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.List;
import nl.siegmann.epublib.domain.Book;
import nl.siegmann.epublib.domain.TOCReference;
import nl.siegmann.epublib.epub.EpubReader;
import android.app.Activity;
import android.content.res.AssetManager;
import android.os.Bundle;
import android.text.Html;
import android.util.Log;
import android.webkit.WebView;
public class EPubDemo extends Activity {
    WebView webview;
    String line, line1 = "", finalstr = "";
    int i = 0;
    @Override
    public void onCreate ( Bundle savedInstanceState ) {
        super.onCreate ( savedInstanceState );
        setContentView ( R.layout.main );
        webview = ( WebView ) findViewById ( R.id.webview );
        AssetManager assetManager = getAssets();
        try {
            InputStream epubInputStream = assetManager
                                          .open ( "sampleepubfile.epub" );
            Book book = ( new EpubReader() ).readEpub ( epubInputStream );
            Log.i ( "author", " : " + book.getMetadata().getAuthors() );
            Log.i ( "title", " : " + book.getTitle() );
            logTableOfContents ( book.getTableOfContents().getTocReferences(), 0 );
        } catch ( IOException e ) {
            Log.e ( "epublib exception", e.getMessage() );
        }
        String javascrips = "";
        try {
            InputStream input = this.getAssets().open (
                                    "poe-fall-of-the-house-of-usher.epub" );
            int size;
            size = input.available();
            byte[] buffer = new byte[size];
            input.read ( buffer );
            input.close();
            javascrips = new String ( buffer );
        } catch ( IOException e ) {
            e.printStackTrace();
        }
        webview.loadDataWithBaseURL ( "file:///android_asset/", javascrips,
                                      "application/epub+zip", "UTF-8", null );
    }
    @SuppressWarnings ( "unused" )
    private void logTableOfContents ( List<TOCReference> tocReferences, int depth ) {
        if ( tocReferences == null ) {
            return;
        }
        for ( TOCReference tocReference : tocReferences ) {
            StringBuilder tocString = new StringBuilder();
            for ( int i = 0; i < depth; i++ ) {
                tocString.append ( "\t" );
            }
            tocString.append ( tocReference.getTitle() );
            Log.i ( "TOC", tocString.toString() );
            try {
                InputStream is = tocReference.getResource().getInputStream();
                BufferedReader r = new BufferedReader ( new InputStreamReader ( is ) );
                while ( ( line = r.readLine() ) != null ) {
                    Log.v ( "line" + i, Html.fromHtml ( line ).toString() );
                    line1 = line1.concat ( Html.fromHtml ( line ).toString() );
                }
                finalstr = finalstr.concat ( "\n" ).concat ( line1 );
                i++;
            } catch ( IOException e ) {
            }
            logTableOfContents ( tocReference.getChildren(), depth + 1 );
        }
        webview.loadDataWithBaseURL ( "", finalstr, "text/html", "UTF-8", "" );
    }
}
