import java.util.*
import static java.text.DateFormat.*;
public class StringToDateTimeConverter extends StrutsTypeConverter {
    private static final DateFormat DATETIME_FORMAT = getDateInstance ( SHORT, Locale.getDefault() );
    public Object convertFromString ( Map context, String[] strings, Class toClass ) {
        if ( strings == null || strings.length == 0 || strings[0].trim().length() == 0 ) {
            return null;
        }
        try {
            DATETIME_FORMAT.setLenient ( false );
            return DATETIME_FORMAT.parseObject ( strings[0] );
        } catch ( ParseException e ) {
            return null;
        }
    }
    public String convertToString ( Map context, Object date ) {
        if ( date != null && date instanceof Date ) {
            return DATETIME_FORMAT.format ( date );
        } else {
            return null;
        }
    }
}
