public static void main ( String[] args ) throws Exception {
    Loader loader = new Loader();
    loader.addTranslator ( ClassPool.getDefault(), new Profiler() );
    try {
        if ( args.length < 1 ) {
            System.out.println ( TOOL_USAGE );
        } else {
            initializeProfiler();
            final String[] commandArgs = new String[args.length - 1];
            System.arraycopy ( args, 1, commandArgs, 0, commandArgs.length );
            File file = new File ( args[0] );
            JarFile jarFile = new JarFile ( args[0] );
            Manifest manifest = jarFile.getManifest();
            String mainClassName = null;
            if ( manifest != null ) {
                mainClassName = manifest.getMainAttributes().getValue ( "Main-Class" );
            }
            jarFile.close();
            mainClassName = mainClassName.replaceAll ( "/", "." );
            final File workDir = File.createTempFile ( args[0].substring ( 0, args[0].indexOf ( '.' ) ), "" );
            workDir.delete();
            workDir.mkdirs();
            unJar ( file, workDir );
            createClassPath ( workDir, file );
            ClassPool pool = ClassPool.getDefault();
            pool.insertClassPath ( workDir + "/" );
            loader.run ( mainClassName, null );
        }
    } catch ( Throwable e ) {
        e.printStackTrace();
    }
    System.out.println ( "Instrumentation of " + args[0] + " finished." );
}
