public static class Model extends SwingWorker<Integer, Progress> {
    private HashMap<String, Number> GUIparams;
    private int session;
    private int ticks;
    private JTextArea textArea;
    Model ( HashMap<String, Number> KSMParams, JTextArea textArea ) {
        GUIparams = KSMParams;
        session = ( Integer ) GUIparams.get ( "experimentsInSession" );
        ticks = ( Integer ) GUIparams.get ( "howManyTicks" );
        this.textArea = textArea;
    }
    @Override
    protected void process ( List<Progress> progressList ) {
        for ( Progress p : progressList ) {
            textArea.append ( p.getTask() + " : " + p.getElement() + "\n" );
            System.out.println ( p.getTask() + " : " + p.getElement() );
        }
    }
    @Override
    protected Integer doInBackground() throws Exception {
        int i = 0;
        while ( !isCancelled() && i < session ) {
            i++;
            int ii = 0;
            while ( !isCancelled() && ii < ticks ) {
                ii++;
            }
            publish ( new Progress ( i, ii ) );
            setProgress ( 100 * i / session );
            Thread.sleep ( 1000 );
        }
        return i;
    }
    @Override
    protected void done() {
        if ( isCancelled() ) {
            Logger.getLogger ( Model.class.getName() ).log ( Level.WARNING, "Experiment session cancelled by user. Closing Session..." );
        } else {
            Logger.getLogger ( Model.class.getName() ).log ( Level.WARNING, "Experiment session ended." );
        }
    }
}
