package com.ibm.NotesJava.agents;
import lotus.domino.*;
import java.io.File;
import java.io.FileInputStream;
import java.lang.*;
import java.util.*;
import java.awt.*;
import java.awt.List;
import java.awt.event.*;
import java.text.SimpleDateFormat;
public class MyJavaAgent extends AgentBase {
    public void NotesMain() {
        try {
            Session session = getSession();
            AgentContext agentContext = session.getAgentContext();
            Name n = session.createName ( agentContext.getEffectiveUserName() );
            String st = n.getCommon();
            Log log = session.createLog ( "JAVA_AGENT" );
            log.openFileLog ( "JAVA_AGENT.log" );
            MessageBox mb = new MessageBox();
            try {
                log.logAction ( "" );
                log.logAction ( "******************************Starting JAVA AGENT ************************" );
                log.logAction ( "Hello " + st + "!" );
                log.logAction ( "Executing JavaAgentTest with Agent: " + agentContext.getCurrentAgent().getName() );
                Database db = agentContext.getCurrentDatabase();
                log.logAction ( "Loading emaildetails.properties file from following location:C:\\Program Files\\Lotus\\Notes\\framework\\emaildetails.properties" );
                Properties pro = new Properties();
                File fil = new File ( "C:\\Program Files\\Lotus\\Notes\\framework\\emaildetails.properties" );
                DocumentCollection coll = agentContext.getUnprocessedDocuments();
                Document doc = coll.getFirstDocument();
            }
        }
        class MessageBox {
            public final int NO_ACTION = -1;
            public final int CANCEL_ACTION = 0;
            public final int OK_ACTION = 1;
            int actionCode = NO_ACTION;
            Frame parent;
            Dialog msgbox;
            MultiLineLabel msglabel;
            Panel buttons;
            Button ok, cancel;
            TextField textbox;
            Choice dropdown;
            List multilist;
            public MessageBox ()  {
                parent = new Frame();
            }
            public void dispose ()  {
                try {
                    msgbox.dispose();
                }  catch ( Exception e )  {}
                try {
                    parent.dispose();
                }  catch ( Exception e )  {}
            }
            public int doOkCancelDialog ( String title, String message )  {
                actionCode = NO_ACTION;
                try  {
                    msgbox = new Dialog ( parent, title, true );
                    msgbox.setLayout ( new BorderLayout() );
                    initMsglabel ( message );
                    msgbox.add ( "North", msglabel );
                    buttons = new Panel();
                    buttons.setLayout ( new FlowLayout() );
                    initOkButton();
                    buttons.add ( ok );
                    initCancelButton();
                    buttons.add ( cancel );
                    msgbox.add ( "South", buttons );
                    displayMsgbox();
                    msgbox.dispose();
                }  catch ( Exception e )  {
                }
                return actionCode;
            }
            public String doInputBox ( String title, String message, String defaultText )  {
                actionCode = NO_ACTION;
                try  {
                    msgbox = new Dialog ( parent, title, true );
                    msgbox.setLayout ( new BorderLayout() );
                    initMsglabel ( message );
                    msgbox.add ( "North", msglabel );
                    initTextbox ( defaultText );
                    msgbox.add ( "Center", textbox );
                    buttons = new Panel();
                    buttons.setLayout ( new FlowLayout() );
                    initOkButton();
                    buttons.add ( ok );
                    initCancelButton();
                    buttons.add ( cancel );
                    msgbox.add ( "South", buttons );
                    displayMsgbox();
                    msgbox.dispose();
                }  catch ( Exception e )  {
                }
                if ( actionCode == OK_ACTION ) {
                    return textbox.getText();
                } else {
                    return null;
                }
            }
            public String doDropdownBox ( String title, String message, String[] selections )  {
                actionCode = NO_ACTION;
                try  {
                    msgbox = new Dialog ( parent, title, true );
                    msgbox.setLayout ( new BorderLayout() );
                    initMsglabel ( message );
                    msgbox.add ( "North", msglabel );
                    initDropdown ( selections );
                    msgbox.add ( "Center", dropdown );
                    buttons = new Panel();
                    buttons.setLayout ( new FlowLayout() );
                    initOkButton();
                    buttons.add ( ok );
                    initCancelButton();
                    buttons.add ( cancel );
                    msgbox.add ( "South", buttons );
                    displayMsgbox();
                    msgbox.dispose();
                }  catch ( Exception e )  {
                }
                if ( actionCode == OK_ACTION ) {
                    return dropdown.getSelectedItem();
                } else {
                    return null;
                }
            }
            public String[] doMultilistBox ( String title, String message, String[] selections, boolean allowMultiSelect )  {
                actionCode = NO_ACTION;
                try  {
                    msgbox = new Dialog ( parent, title, true );
                    msgbox.setLayout ( new BorderLayout() );
                    initMsglabel ( message );
                    msgbox.add ( "North", msglabel );
                    initMultilist ( 4, allowMultiSelect, selections );
                    msgbox.add ( "Center", multilist );
                    buttons = new Panel();
                    buttons.setLayout ( new FlowLayout() );
                    initOkButton();
                    buttons.add ( ok );
                    initCancelButton();
                    buttons.add ( cancel );
                    msgbox.add ( "South", buttons );
                    displayMsgbox();
                    msgbox.dispose();
                }  catch ( Exception e )  {
                }
                if ( ( actionCode == OK_ACTION ) &&
                        ( java.lang.reflect.Array.getLength ( multilist.getSelectedItems() ) > 0 ) ) {
                    return multilist.getSelectedItems();
                } else {
                    return null;
                }
            }
            private void initMsglabel ( String message )  {
                msglabel = new MultiLineLabel ( message );
            }
            private void initOkButton ()  {
                ok = new Button ( "OK" );
                ok.addActionListener ( new ActionListener()  {
                    public void actionPerformed ( ActionEvent e )  {
                        actionCode = OK_ACTION;
                        msgbox.dispose();
                    }
                } );
            }
            private void initCancelButton ()  {
                cancel = new Button ( "Cancel" );
                cancel.addActionListener ( new ActionListener()  {
                    public void actionPerformed ( ActionEvent e )  {
                        actionCode = CANCEL_ACTION;
                        msgbox.dispose();
                    }
                } );
            }
            private void initTextbox ( String defaultText )  {
                textbox = new TextField ( defaultText, 40 );
                textbox.addActionListener ( new ActionListener()  {
                    public void actionPerformed ( ActionEvent e )  {
                        actionCode = OK_ACTION;
                        msgbox.dispose();
                    }
                } );
            }
            private void initDropdown ( String[] selections )  {
                dropdown = new Choice();
                for ( int i = 0; i < java.lang.reflect.Array.getLength ( selections ); i++ ) {
                    dropdown.add ( selections[i] );
                }
            }
            private void initMultilist ( int numOfLines, boolean allowMultiSelect, String[] selections )  {
                multilist = new List ( numOfLines, allowMultiSelect );
                for ( int i = 0; i < java.lang.reflect.Array.getLength ( selections ); i++ ) {
                    multilist.add ( selections[i] );
                }
            }
            private void displayMsgbox ()  {
                Dimension d = msgbox.getToolkit().getScreenSize();
                msgbox.setLocation ( d.width / 3, d.height / 3 );
                msgbox.pack();
                msgbox.setResizable ( false );
                msgbox.toFront();
                msgbox.setVisible ( true );
            }
            class MultiLineLabel extends Canvas  {
                String label;
                String[] lines;
                int rows = 1;
                int cols = 40;
                int margin = 6;
                int rowHeight;
                int lineAscent;
                int maxWidth;
                public MultiLineLabel ( String text )  {
                    label = text;
                }
                public MultiLineLabel ( String text, int columns )  {
                    if ( columns > 0 ) {
                        cols = columns;
                    }
                    label = text;
                }
                protected void measure ()  {
                    FontMetrics fm = this.getFontMetrics ( this.getFont() );
                    if ( fm == null ) {
                        return;
                    }
                    rowHeight = fm.getHeight();
                    lineAscent = fm.getAscent();
                    maxWidth = fm.stringWidth ( "X" ) * cols;
                }
                private int stringWidth ( String text )  {
                    FontMetrics fm = this.getFontMetrics ( this.getFont() );
                    if ( fm == null ) {
                        return 0;
                    }
                    return fm.stringWidth ( text );
                }
                public Font getFont ()  {
                    return super.getFont();
                }
                public void setFont ( Font f )  {
                    super.setFont ( f );
                    repaint();
                }
                public void addNotify ()  {
                    super.addNotify();
                    measure();
                }
                public Dimension getPreferredSize ()  {
                    if ( lines == null ) {
                        setText ( label );
                    }
                    return new Dimension ( maxWidth + ( 2 * margin ), ( rows * rowHeight ) + ( 2 * margin ) );
                }
                public Dimension getMinimumSize ()  {
                    if ( lines == null ) {
                        setText ( label );
                    }
                    return new Dimension ( maxWidth, ( rows * rowHeight ) );
                }
                public void setText ( String text )  {
                    label = text;
                    parseLabel();
                }
                private void parseLabel ()  {
                    String token, word;
                    StringBuffer msg = new StringBuffer ( "" );
                    StringBuffer line = new StringBuffer ( "" );
                    measure();
                    rows = 0;
                    java.util.StringTokenizer st1 = new java.util.StringTokenizer ( label, "\n", false );
                    while ( st1.hasMoreTokens() )  {
                        token = st1.nextToken();
                        if ( stringWidth ( token ) <= maxWidth )  {
                            rows++;
                            msg.append ( token + "\n" );
                        }  else  {
                            java.util.StringTokenizer st2 = new java.util.StringTokenizer ( token, " ", false );
                            while ( st2.hasMoreTokens() )  {
                                word = st2.nextToken();
                                if ( ( stringWidth ( line.toString() ) + stringWidth ( word ) ) > maxWidth )  {
                                    rows++;
                                    msg.append ( line.toString() + "\n" );
                                    line.setLength ( 0 );
                                    line.append ( word + " " );
                                }  else  {
                                    line.append ( word + " " );
                                }
                            }
                            if ( line.length() > 0 )  {
                                rows++;
                                msg.append ( line.toString() + "\n" );
                            }
                        }
                    }
                    java.util.StringTokenizer st = new java.util.StringTokenizer ( msg.toString(), "\n" );
                    lines = new String[rows];
                    for ( int i = 0; i < rows; i++ ) {
                        lines[i] = st.nextToken();
                    }
                }
                public void paint ( Graphics g )  {
                    int y;
                    setText ( label );
                    Dimension d = this.getSize();
                    y = lineAscent + ( d.height - ( rows * rowHeight ) ) / 2;
                    for ( int i = 0; i < rows; i++, y += rowHeight ) {
                        g.drawString ( lines[i], margin, y );
                    }
                }
            }
        }
