public static void extract ( String tgzFile, String outputDirectory )
throws Exception {
    FileInputStream fin = new FileInputStream ( tgzFile );
    GZIPInputStream gin = new GZIPInputStream ( fin );
    TarInputStream tin = new TarInputStream ( gin );
    File outputDir = new File ( outputDirectory );
    outputDir.mkdir();
    TarEntry tarEntry = tin.getNextEntry();
    while ( tarEntry != null ) {
        File destPath = new File ( outputDirectory + File.separator + tarEntry.getName() );
        if ( tarEntry.isDirectory() ) {
            destPath.mkdirs();
        } else {
            if ( !destPath.getParentFile().exists() ) {
                destPath.getParentFile().mkdirs();
            }
            FileOutputStream fout = new FileOutputStream ( destPath );
            tin.copyEntryContents ( fout );
            fout.close();
            destPath.setLastModified ( tarEntry.getModTime().getTime() );
        }
        tarEntry = tin.getNextEntry();
    }
    tin.close();
}
