public static class ColorTracker extends AbstractBean {
    private List<Color> colors = new ArrayList<>();
    public void addColor ( Color color ) {
        List<Color> old = getColors();
        colors.add ( 0, color );
        firePropertyChange ( "colors", old, getColors() );
    }
    public void setColors ( List<Color> colors ) {
        List<Color> old = getColors();
        this.colors = new ArrayList<> ( colors );
        firePropertyChange ( "colors", old, getColors() );
    }
    public List<Color> getColors() {
        return new ArrayList<> ( colors );
    }
}
public class MySwatchChooserPanel ... {
    ColorTracker tracker;
    public void setColorTracker ( .... ) {
        ....
        this.tracker = tracker;
        if ( tracker != null ) {
            tracker.addPropertyChangeListener ( .... );
        }
        updateRecentSwatchPanel()
    }
    protected void updateRecentSwatchPanel() {
        if ( recentSwatchPanel == null ) {
            return;
        }
        recentSwatchPanel.setMostRecentColors ( tracker != null ? tracker.getColors() : null );
    }
    class MainSwatchListener extends MouseAdapter implements Serializable {
        @Override
        public void mousePressed ( MouseEvent e ) {
            if ( !isEnabled() ) {
                return;
            }
            if ( e.getClickCount() == 2 ) {
                handleDoubleClick ( e );
                return;
            }
            Color color = swatchPanel.getColorForLocation ( e.getX(), e.getY() );
            setSelectedColor ( color );
            if ( tracker != null ) {
                tracker.addColor ( color );
            } else {
                recentSwatchPanel.setMostRecentColor ( color );
            }
        }
        private void handleDoubleClick ( MouseEvent e ) {
            if ( action != null ) {
                action.actionPerformed ( null );
            }
        }
    }
}
private JColorChooser createChooser ( ColorTracker tracker ) {
    JColorChooser chooser = new JColorChooser();
    List<AbstractColorChooserPanel> choosers =
        new ArrayList<> ( Arrays.asList ( chooser.getChooserPanels() ) );
    choosers.remove ( 0 );
    MySwatchChooserPanel swatch = new MySwatchChooserPanel();
    swatch.setColorTracker ( tracker );
    swatch.setAction ( doubleClickAction );
    choosers.add ( 0, swatch );
    chooser.setChooserPanels ( choosers.toArray ( new AbstractColorChooserPanel[0] ) );
    return chooser;
}
