public class GenericDatabaseCaller {
    private DataSource dataSource;
    public Map executeSimpleProcedure ( String functionName, boolean isFunction, Map<String, Object> inParams,
                                        Map<String, Object> outParams ) {
        InnerStoredProcedure innerStoredProcedure = new InnerStoredProcedure ( dataSource, functionName, isFunction,
                inParams, outParams );
        return innerStoredProcedure.executeProcedure ( inParams );
    }
    private class InnerStoredProcedure extends StoredProcedure {
        public InnerStoredProcedure ( DataSource ds, String SQL, boolean isFunction,  Map<String, Object> inParams, Map<String, Object> outParams ) {
            setDataSource ( ds );
            setFunction ( isFunction );
            setSql ( SQL );
            configerParameters ( inParams, outParams );
            compile();
        }
        public void configerParameters ( Map<String, Object> inParams, Map<String, Object> outputParamers ) {
            if ( inParams != null && inParams.size() > 0 ) {
                Iterator<String> keySetIterator = inParams.keySet().iterator();
                while ( keySetIterator.hasNext() ) {
                    String key = keySetIterator.next();
                    if ( inParams.get ( key ) instanceof String ) {
                        declareParameter ( new SqlParameter ( key, Types.VARCHAR ) );
                    } else if ( inParams.get ( key ) instanceof Integer ) {
                        declareParameter ( new SqlParameter ( key, Types.INTEGER ) );
                    } else if ( inParams.get ( key ) instanceof Date || inParams.get ( key ) instanceof java.sql.Date ) {
                        declareParameter ( new SqlParameter ( key, Types.DATE ) );
                    }
                }
            }
            if ( outputParamers != null && outputParamers.size() > 0 ) {
                Iterator<String> keySetIterator = outputParamers.keySet().iterator();
                while ( keySetIterator.hasNext() ) {
                    String key = keySetIterator.next();
                    if ( outputParamers.get ( key ) instanceof String ) {
                        declareParameter ( new SqlOutParameter ( key, Types.VARCHAR ) );
                    } else if ( outputParamers.get ( key ) instanceof Integer ) {
                        declareParameter ( new SqlOutParameter ( key, Types.INTEGER ) );
                    }
                }
            }
        }
        public Map executeProcedure ( Map inputs ) {
            return execute ( inputs );
        }
    }
}
