try {
    InputStream is = event.getFile().getInputstream();
    contentBytes = IOUtils.toByteArray ( is );
} catch ( IOException e ) {
    System.err.printf ( "Failed while reading bytes from %s", e.getMessage() );
}
Long contentLength = Long.valueOf ( contentBytes.length );
ObjectMetadata metadata = new ObjectMetadata();
metadata.setContentLength ( contentLength );
InputStream inputStream = event.getFile().getInputstream();
try {
    s3client.putObject ( new PutObjectRequest ( bucketName, keyName, inputStream, metadata ) );
} catch ( AmazonServiceException ase ) {
    System.out.println ( "Error Message:    " + ase.getMessage() );
    System.out.println ( "HTTP Status Code: " + ase.getStatusCode() );
    System.out.println ( "AWS Error Code:   " + ase.getErrorCode() );
    System.out.println ( "Error Type:       " + ase.getErrorType() );
    System.out.println ( "Request ID:       " + ase.getRequestId() );
} catch ( AmazonClientException ace ) {
    System.out.println ( "Error Message: " + ace.getMessage() );
} finally {
    if ( inputStream != null ) {
        inputStream.close();
    }
}
