import java.util.zip.*;
import java.io.*;
public class ChunkedZipTwo {
    static final long MAX_LIMIT = 10 * 1000 * 1024;
    public static void main ( String[] args )  throws Exception {
        String[] files = {"file1", "file2", "file3"};
        int i = 0;
        boolean needNewFile = false;
        long overallSize = 0;
        ZipOutputStream out = getOutputStream ( i );
        byte[] buffer = new byte[1024];
        for ( String thisFileName : files ) {
            if ( overallSize > MAX_LIMIT ) {
                out.close();
                i++;
                out = getOutputStream ( i );
                overallSize = 0;
            }
            FileInputStream in = new FileInputStream ( thisFileName );
            ZipEntry ze = new ZipEntry ( thisFileName );
            out.putNextEntry ( ze );
            int len;
            while ( ( len = in.read ( buffer ) ) > 0 ) {
                out.write ( buffer, 0, len );
            }
            out.closeEntry();
            in.close();
            overallSize += ze.getCompressedSize();
        }
        out.close();
    }
    public static ZipOutputStream getOutputStream ( int i ) throws IOException {
        ZipOutputStream out = new ZipOutputStream ( new FileOutputStream ( "bigfile" + i + ".zip" ) );
        out.setLevel ( Deflater.DEFAULT_COMPRESSION );
        return out;
    }
}
