import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.font.TextAttribute;
import java.util.Map;
import javax.swing.*;
import javax.swing.border.Border;
import javax.swing.border.CompoundBorder;
import javax.swing.border.EmptyBorder;
import javax.swing.border.MatteBorder;
import javax.swing.table.*;
public class TablePrepareRenderer extends JFrame {
    private static final long serialVersionUID = 1L;
    private JTable table;
    public TablePrepareRenderer() {
        Object[] columnNames = {"Type", "Company", "Shares", "Price", "Boolean"};
        Object[][] data = {
            {"Buy", "IBM", new Integer ( 1000 ), new Double ( 80.50 ), false},
            {"Sell", "MicroSoft", new Integer ( 2000 ), new Double ( 6.25 ), true},
            {"Sell", "Apple", new Integer ( 3000 ), new Double ( 7.35 ), true},
            {"Buy", "Nortel", new Integer ( 4000 ), new Double ( 20.00 ), false}
        };
        DefaultTableModel model = new DefaultTableModel ( data, columnNames ) {
            private static final long serialVersionUID = 1L;
            @Override
            public Class getColumnClass ( int column ) {
                return getValueAt ( 0, column ).getClass();
            }
        };
        table = new JTable ( model )  ;
        table.setPreferredScrollableViewportSize ( table.getPreferredSize() );
        JScrollPane scrollPane = new JScrollPane ( table );
        add ( scrollPane );
        JButton increase = new JButton ( "+" );
        increase.addActionListener ( new ActionListener() {
            public void actionPerformed ( ActionEvent e ) {
                Font font = table.getFont();
                font = font.deriveFont ( ( float ) ( font.getSize2D() * 1.10 ) );
                table.setFont ( font );
            }
        } );
        add ( increase, BorderLayout.EAST );
        JButton decrease = new JButton ( "-" );
        decrease.addActionListener ( new ActionListener() {
            public void actionPerformed ( ActionEvent e ) {
                Font font = table.getFont();
                font = font.deriveFont ( ( float ) ( font.getSize2D() * .90 ) );
                table.setFont ( font );
            }
        } );
        add ( decrease, BorderLayout.WEST );
    }
    public static void main ( String[] args ) {
        SwingUtilities.invokeLater ( new Runnable() {
            @Override
            public void run() {
                TablePrepareRenderer frame = new TablePrepareRenderer();
                frame.setDefaultCloseOperation ( EXIT_ON_CLOSE );
                frame.pack();
                frame.setLocationRelativeTo ( null );
                frame.setVisible ( true );
            }
        } );
    }
}
