@FacesValidator ( "dateRangeValidator" )
public class DateRangeValidator implements Validator {
    @Override
    public void validate ( FacesContext context, UIComponent component, Object value ) throws ValidatorException {
        if ( value == null ) {
            return;
        }
        UIInput startDateComponent = ( UIInput ) component.getAttributes().get ( "startDateComponent" );
        if ( !startDateComponent.isValid() ) {
            return;
        }
        Date startDate = ( Date ) startDateComponent.getValue();
        if ( startDate == null ) {
            return;
        }
        Date endDate = ( Date ) value;
        if ( startDate.after ( endDate ) ) {
            startDateComponent.setValid ( false );
            throw new ValidatorException ( new FacesMessage (
                                               FacesMessage.SEVERITY_ERROR, "Start date may not be after end date.", null ) );
        }
    }
}
