public class CSVFun {
    static final double Start = 0.0;
    static final double End = 10000.0;
    static final double BigStep = 0.1;
    static final double SmallStep = 0.000000001;
    private static void csv ( F f ) {
        System.out.println ( "Function: " + f );
        double t = Start;
        double ft = f.f ( t );
        System.out.println ( t + "," + ft );
        while ( t < End ) {
            double step = BigStep;
            while ( t < End && f.f ( t ) == ft ) {
                t += step;
            }
            if ( t < End ) {
                t -= step;
                while ( step > SmallStep ) {
                    step /= 10;
                    while ( t < End && f.f ( t ) == ft ) {
                        t += step;
                    }
                    t -= step;
                }
                System.out.println ( t + "," + ft );
                t += step;
            }
            if ( f.f ( t ) != ft ) {
                ft = f.f ( t );
                System.out.println ( t + "," + ft );
            }
        }
    }
    public static void main ( String[] args ) {
        try {
            for ( F f : F.values() ) {
                csv ( f );
            }
        } catch ( Exception ex ) {
            ex.printStackTrace();
        }
    }
    enum F {
        A {
            @Override
            double f ( double t ) {
                if ( t < 60 ) {
                    return ( 0.1 );
                }
                if ( t > 66.0115 ) {
                    return ( 0.1 );
                }
                return 1;
            }
        },
        B {
            @Override
            double f ( double t ) {
                if ( t > 0.5 ) {
                    return 2;
                }
                return 3;
            }
        },
        C {
            @Override
            double f ( double t ) {
                if ( t >= 0.5 ) {
                    return 2;
                }
                return 3;
            }
        },
        D {
            @Override
            double f ( double t ) {
                if ( t < 0.5 ) {
                    return 2;
                }
                return 3;
            }
        },
        E {
            @Override
            double f ( double t ) {
                if ( t <= 0.5 ) {
                    return 2;
                }
                return 3;
            }
        },
        F {
            @Override
            double f ( double t ) {
                if ( ( t >= 3600 ) & ( t <= 3660 ) ) {
                    return 25;
                }
                return 0;
            }
        },;
        abstract double f ( double t );
    }
}
