public interface RowToByteArrayConverter {
    byte[] rowToByteArray ( ResultSet resultSet );
}
public class ResultSetAsInputStream extends InputStream {
    private final RowToByteArrayConverter converter;
    private final PreparedStatement statement;
    private final ResultSet resultSet;
    private byte[] buffer;
    private int position;
    public ResultSetAsInputStream ( final RowToByteArrayConverter converter, final Connection connection, final String sql, final Object... parameters ) throws SQLException {
        this.converter = converter;
        statement = createStatement ( connection, sql, parameters );
        resultSet = statement.executeQuery();
    }
    private static PreparedStatement createStatement ( final Connection connection, final String sql, final Object[] parameters ) {
        return null;
    }
    @Override
    public int read() throws IOException {
        try {
            if ( buffer == null ) {
                if ( !resultSet.next() ) {
                    return -1;
                } else {
                    buffer = converter.rowToByteArray ( resultSet );
                    position = 0;
                    return buffer[position++] & ( 0xff );
                }
            } else {
                if ( position < buffer.length ) {
                    return buffer[position++] & ( 0xff );
                } else {
                    if ( !resultSet.next() ) {
                        return -1;
                    } else {
                        buffer = converter.rowToByteArray ( resultSet );
                        position = 0;
                        return buffer[position++] & ( 0xff );
                    }
                }
            }
        } catch ( final SQLException ex ) {
            throw new IOException ( ex );
        }
    }
    @Override
    public void close() throws IOException {
        try {
            statement.close();
        } catch ( final SQLException ex ) {
            throw new IOException ( ex );
        }
    }
}
