public class AlphanumComparator implements Comparator {
    private final boolean isDigit ( char ch ) {
        return ch >= 48 && ch <= 57;
    }
    private final String getChunk ( String s, int slength, int marker ) {
        StringBuilder chunk = new StringBuilder();
        char c = s.charAt ( marker );
        chunk.append ( c );
        marker++;
        if ( isDigit ( c ) ) {
            while ( marker < slength ) {
                c = s.charAt ( marker );
                if ( !isDigit ( c ) ) {
                    break;
                }
                chunk.append ( c );
                marker++;
            }
        } else {
            while ( marker < slength ) {
                c = s.charAt ( marker );
                if ( isDigit ( c ) ) {
                    break;
                }
                chunk.append ( c );
                marker++;
            }
        }
        return chunk.toString();
    }
    public int compare ( Object o1, Object o2 ) {
        if ( ! ( o1 instanceof String ) || ! ( o2 instanceof String ) ) {
            return 0;
        }
        String s1 = ( String ) o1;
        String s2 = ( String ) o2;
        int thisMarker = 0;
        int thatMarker = 0;
        int s1Length = s1.length();
        int s2Length = s2.length();
        while ( thisMarker < s1Length && thatMarker < s2Length ) {
            String thisChunk = getChunk ( s1, s1Length, thisMarker );
            thisMarker += thisChunk.length();
            String thatChunk = getChunk ( s2, s2Length, thatMarker );
            thatMarker += thatChunk.length();
            int result = 0;
            if ( isDigit ( thisChunk.charAt ( 0 ) ) && isDigit ( thatChunk.charAt ( 0 ) ) ) {
                int thisChunkLength = thisChunk.length();
                result = thisChunkLength - thatChunk.length();
                if ( result == 0 ) {
                    for ( int i = 0; i < thisChunkLength; i++ ) {
                        result = thisChunk.charAt ( i ) - thatChunk.charAt ( i );
                        if ( result != 0 ) {
                            return result;
                        }
                    }
                }
            } else {
                result = thisChunk.compareTo ( thatChunk );
            }
            if ( result != 0 ) {
                return result;
            }
        }
        return s1Length - s2Length;
    }
}
