try {
    try {
        server.ping();
    } catch ( Exception e ) {
        if ( failIfNotRunning ) {
            throw new MojoExecutionException ( "Failed to stop the Derby server, no server running!", e );
        }
        getLog().error ( "Derby server was already stopped." );
        return;
    }
    try {
        DriverManager.getConnection ( getConnectionURL() );
        DriverManager.getConnection ( "jdbc:derby:;shutdown=true" );
    } catch ( SQLException e ) {
    }
    server.shutdown();
    while ( true ) {
        Thread.sleep ( 1000 );
        try {
            server.ping();
        } catch ( Exception e ) {
            getLog().info ( "Derby has stopped!" );
            break;
        }
    }
    System.getProperties().remove ( "derby.system.home" );
} catch ( Exception e ) {
    throw new MojoExecutionException ( e.getMessage(), e );
}
