public class FilteringPropertiesFactoryBean extends PropertiesFactoryBean {
    private String namePrefix;
    @Override
    protected Properties mergeProperties() throws IOException {
        Properties unfilteredProperties = super.mergeProperties();
        Properties filteredProperties = new Properties();
        for ( Object key : unfilteredProperties.keySet() ) {
            String name = key.toString();
            String trimmedName = trimName ( name );
            if ( trimmedName != null ) {
                String value = unfilteredProperties.getProperty ( name );
                filteredProperties.setProperty ( trimmedName, value );
            }
        }
        return filteredProperties;
    }
    public void setNamePrefix ( String value ) {
        this.namePrefix = value;
    }
    private String trimName ( String name ) {
        if ( name.startsWith ( namePrefix ) && name.length() > namePrefix.length() ) {
            return name.substring ( namePrefix.length() );
        }
        return null;
    }
}
