public class AsyncTaskExampleActivity extends Activity {
    protected TextView _percentField;
    protected Button _cancelButton;
    protected InitTask _initTask;
    ProgressDialog pd;
    @Override
    public void onCreate ( Bundle savedInstanceState ) {
        super.onCreate ( savedInstanceState );
        setContentView ( R.layout.main );
        _percentField = ( TextView ) findViewById ( R.id.percent_field );
        _cancelButton = ( Button ) findViewById ( R.id.cancel_button );
        _cancelButton.setOnClickListener ( new CancelButtonListener() );
        _initTask = new InitTask();
        pd = ProgressDialog.show ( AsyncTaskExampleActivity.this, "Loading", "Please Wait" );
        _initTask.execute ( this );
    }
    protected class CancelButtonListener implements View.OnClickListener {
        public void onClick ( View v ) {
            _initTask.cancel ( true );
        }
    }
    protected class InitTask extends AsyncTask<Context, Integer, String> {
        @Override
        protected String doInBackground ( Context... params ) {
            int i = 0;
            while ( i <= 50 ) {
                try {
                    Thread.sleep ( 50 );
                    publishProgress ( i );
                    i++;
                } catch ( Exception e ) {
                    Log.i ( "makemachine", e.getMessage() );
                }
            }
            pd.dismiss();
            return "COMPLETE!";
        }
        @Override
        protected void onPreExecute() {
            Log.i ( "makemachine", "onPreExecute()" );
            super.onPreExecute();
        }
        @Override
        protected void onProgressUpdate ( Integer... values ) {
            super.onProgressUpdate ( values );
            Log.i ( "makemachine", "onProgressUpdate(): " +  String.valueOf ( values[0] ) );
            _percentField.setText ( ( values[0] * 2 ) + "%" );
            _percentField.setTextSize ( values[0] );
        }
        @Override
        protected void onCancelled() {
            super.onCancelled();
            Log.i ( "makemachine", "onCancelled()" );
            _percentField.setText ( "Cancelled!" );
            _percentField.setTextColor ( 0xFFFF0000 );
        }
        @Override
        protected void onPostExecute ( String result ) {
            super.onPostExecute ( result );
            Log.i ( "makemachine", "onPostExecute(): " + result );
            _percentField.setText ( result );
            _percentField.setTextColor ( 0xFF69adea );
            _cancelButton.setVisibility ( View.INVISIBLE );
        }
    }
}
