import java.util.ArrayList;
import java.util.Arrays;
import java.util.Formatter;
import java.util.List;
import java.util.Locale;
import javax.tools.Diagnostic;
import javax.tools.DiagnosticCollector;
import javax.tools.JavaCompiler;
import javax.tools.JavaFileObject;
import javax.tools.StandardJavaFileManager;
import javax.tools.ToolProvider;
public class JavaSyntaxChecker {
    public static void main ( String[] args ) {
        System.out.println ( JavaSyntaxChecker.check ( "/path/to/HelloBuggyWorld.java" ) );
    }
    public static List<String> check ( String file ) {
        JavaCompiler compiler = ToolProvider.getSystemJavaCompiler();
        StandardJavaFileManager fileManager = compiler.getStandardFileManager ( null, null, null );
        Iterable<? extends JavaFileObject> compilationUnits =
            fileManager.getJavaFileObjectsFromStrings ( Arrays.asList ( file ) );
        DiagnosticCollector<JavaFileObject> diagnostics = new DiagnosticCollector<JavaFileObject>();
        compiler.getTask ( null, fileManager, diagnostics, null, null, compilationUnits ).call();
        List<String> messages = new ArrayList<String>();
        Formatter formatter = new Formatter();
        for ( Diagnostic diagnostic : diagnostics.getDiagnostics() ) {
            messages.add ( diagnostic.getKind() + ":\t Line [" + diagnostic.getLineNumber() + "] \t Position [" + diagnostic.getPosition() + "]\t" + diagnostic.getMessage ( Locale.ROOT ) + "\n" );
        }
        return messages;
    }
}
