import java.math.BigInteger;
import java.security.KeyPair;
import java.security.KeyPairGenerator;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.SecureRandom;
import java.security.Signature;
public class ECDSAExample {
    public static void main ( String[] args ) throws Exception {
        KeyPairGenerator keyGen = KeyPairGenerator.getInstance ( "EC" );
        SecureRandom random = SecureRandom.getInstance ( "SHA1PRNG" );
        keyGen.initialize ( 256, random );
        KeyPair pair = keyGen.generateKeyPair();
        PrivateKey priv = pair.getPrivate();
        PublicKey pub = pair.getPublic();
        Signature dsa = Signature.getInstance ( "SHA1withECDSA" );
        dsa.initSign ( priv );
        String str = "This is string to sign";
        byte[] strByte = str.getBytes ( "UTF-8" );
        dsa.update ( strByte );
        byte[] realSig = dsa.sign();
        System.out.println ( "Signature: " + new BigInteger ( 1, realSig ).toString ( 16 ) );
    }
}
