private void broadcastUpdate ( Presence update ) {
    if ( update.getFrom() == null ) {
        return;
    }
    if ( localServer.isLocal ( update.getFrom() ) ) {
        if ( !RosterManager.isRosterServiceEnabled() ) {
            return;
        }
        String name = update.getFrom().getNode();
        try {
            if ( name != null && !"".equals ( name ) ) {
                Roster roster = rosterManager.getRoster ( name );
                roster.broadcastPresence ( update );
            }
        } catch ( UserNotFoundException e ) {
            log.warn ( "Presence being sent from unknown user " + name, e );
        } catch ( PacketException e ) {
            log.error ( LocaleUtils.getLocalizedString ( "admin.error" ), e );
        }
    } else {
        log.warn ( "Presence requested from server "
                   + localServer.getServerInfo().getXMPPDomain()
                   + " by unknown user: " + update.getFrom() );
    }
}
