public class ActiveField {
    private final String key;
    protected ActiveField() {
        this.key = null;
    }
    public ActiveField ( String key ) {
        System.out.println ( key );
        if ( key == null ) {
            this.key = "key:unknown";
        } else {
            this.key = key;
        }
    }
    public String toString() {
        return this.key;
    }
    @SuppressWarnings ( "unchecked" )
    public List<String> getKeys() {
        ArrayList<String> keys = new ArrayList<String>();
        ArrayList<String> names = new ArrayList<String>();
        Class cls;
        try {
            cls = Class.forName ( this.getClass().getName() );
        } catch ( ClassNotFoundException e ) {
            return keys;
        }
        Field fieldList[] = cls.getFields();
        for ( Field fld : fieldList ) {
            int mod = fld.getModifiers();
            if ( !Modifier.isPublic ( mod ) || !Modifier.isStatic ( mod ) || !Modifier.isFinal ( mod ) ) {
                continue;
            }
            if ( !String.class.equals ( fld.getType() ) ) {
                continue;
            }
            if ( !fld.getName().toUpperCase().equals ( fld.getName() ) ) {
                continue;
            }
            String value = null;
            try {
                value = StringUtils.stripToNull ( ( String ) fld.get ( this ) );
            } catch ( IllegalArgumentException e ) {
                continue;
            } catch ( IllegalAccessException e ) {
                continue;
            }
            if ( value == null || names.contains ( fld.getName() ) || keys.contains ( value ) ) {
                continue;
            }
            keys.add ( value );
            names.add ( fld.getName() );
        }
        return keys;
    }
    public int size() {
        return getKeys().size();
    }
}
