public class Main {
    private JTable table;
    private JList list;
    private JFrame frame;
    private final String[] data;
    private final AdjustmentListener singleItemScroll = new AdjustmentListener() {
        @Override
        public void adjustmentValueChanged ( AdjustmentEvent e ) {
            if ( e.getAdjustmentType() == AdjustmentEvent.TRACK ) {
                e.getAdjustable().setBlockIncrement ( 1 );
            }
        }
    };
    public Main() {
        Random rnd = new Random();
        data = new String[120];
        for ( int i = 0; i < data.length; i++ ) {
            data[i] = "Set " + i + " for: " + rnd.nextInt();
        }
        for ( int i = 0; i < data.length; i += 10 ) {
            data[i] = "<html>" + data[i] + "<br>Spacer!</html>";
        }
        setupGui();
        frame.pack();
        frame.setVisible ( true );
    }
    private void setupGui() {
        frame = new JFrame ( "Single Scroll in Swing" );
        frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
        JSplitPane split = new JSplitPane ( JSplitPane.HORIZONTAL_SPLIT );
        frame.add ( split );
        table = new JTable ( new AbstractTableModel() {
            @Override
            public int getRowCount() {
                return data.length;
            }
            @Override
            public int getColumnCount() {
                return 1;
            }
            @Override
            public Object getValueAt ( int rowIndex, int columnIndex ) {
                return data[rowIndex];
            }
        } );
        for ( int i = 0; i < data.length; i += 10 ) {
            table.setRowHeight ( i, 30 );
        }
        JScrollPane scroll = new JScrollPane ( table );
        scroll.getVerticalScrollBar().addAdjustmentListener ( singleItemScroll );
        split.add ( scroll );
        list = new JList<String> ( data );
        scroll = new JScrollPane ( list );
        scroll.getVerticalScrollBar().addAdjustmentListener ( singleItemScroll );
        split.add ( scroll );
    }
    public static void main ( String[] agrs ) {
        new Main();
    }
}
