public class SmsReceiver extends BroadcastReceiver {
    private static final String SMS_RECEIVED = "android.provider.Telephony.SMS_RECEIVED";
    @Override
    public void onReceive ( Context context, Intent intent ) {
        if ( intent.getAction().equals ( SMS_RECEIVED ) ) {
            Bundle bundle = intent.getExtras();
            if ( bundle != null ) {
                Object[] pdus = ( Object[] ) bundle.get ( "pdus" );
                if ( pdus.length == 0 ) {
                    return;
                }
                SmsMessage[] messages = new SmsMessage[pdus.length];
                StringBuilder sb = new StringBuilder();
                for ( int i = 0; i < pdus.length; i++ ) {
                    messages[i] = SmsMessage.createFromPdu ( ( byte[] ) pdus[i] );
                    sb.append ( messages[i].getMessageBody() );
                }
                String sender = messages[0].getOriginatingAddress();
                String message = sb.toString();
                Toast.makeText ( context, message, Toast.LENGTH_SHORT ).show();
            }
        }
    }
}
