public class DropHandler implements DropTargetListener {
    @Override
    public void dragEnter ( DropTargetDragEvent dtde ) {
        if ( dtde.isDataFlavorSupported ( PanelDataFlavor.SHARED_INSTANCE ) ) {
            dtde.acceptDrag ( DnDConstants.ACTION_MOVE );
        } else {
            dtde.rejectDrag();
        }
    }
    @Override
    public void dragOver ( DropTargetDragEvent dtde ) {
    }
    @Override
    public void dropActionChanged ( DropTargetDragEvent dtde ) {
    }
    @Override
    public void dragExit ( DropTargetEvent dte ) {
    }
    @Override
    public void drop ( DropTargetDropEvent dtde ) {
        boolean success = false;
        if ( dtde.isDataFlavorSupported ( PanelDataFlavor.SHARED_INSTANCE ) ) {
            Transferable transferable = dtde.getTransferable();
            try {
                Object data = transferable.getTransferData ( PanelDataFlavor.SHARED_INSTANCE );
                if ( data instanceof JPanel ) {
                    JPanel panel = ( JPanel ) data;
                    DropTargetContext dtc = dtde.getDropTargetContext();
                    Component component = dtc.getComponent();
                    if ( component instanceof JComponent ) {
                        Container parent = panel.getParent();
                        if ( parent != null ) {
                            parent.remove ( panel );
                        }
                        ( ( JComponent ) component ).add ( panel );
                        success = true;
                        dtde.acceptDrop ( DnDConstants.ACTION_MOVE );
                        invalidate();
                        repaint();
                    } else {
                        success = false;
                        dtde.rejectDrop();
                    }
                } else {
                    success = false;
                    dtde.rejectDrop();
                }
            } catch ( Exception exp ) {
                success = false;
                dtde.rejectDrop();
                exp.printStackTrace();
            }
        } else {
            success = false;
            dtde.rejectDrop();
        }
        dtde.dropComplete ( success );
    }
}
