import java.util.Random;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;
import org.mcavallo.opencloud.Cloud;
import org.mcavallo.opencloud.Tag;
public class TestOpenCloud {
    private static final String[] WORDS = { "art", "australia", "baby", "beach", "birthday", "blue", "bw", "california", "canada", "canon",
                                            "cat", "chicago", "china", "christmas", "city", "dog", "england", "europe", "family", "festival", "flower", "flowers", "food",
                                            "france", "friends", "fun", "germany", "holiday", "india", "italy", "japan", "london", "me", "mexico", "music", "nature",
                                            "new", "newyork", "night", "nikon", "nyc", "paris", "park", "party", "people", "portrait", "sanfrancisco", "sky", "snow",
                                            "spain", "summer", "sunset", "taiwan", "tokyo", "travel", "trip", "uk", "usa", "vacation", "water", "wedding"
                                          };
    protected void initUI() {
        JFrame frame = new JFrame ( TestOpenCloud.class.getSimpleName() );
        frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
        JPanel panel = new JPanel();
        Cloud cloud = new Cloud();
        Random random = new Random();
        for ( String s : WORDS ) {
            for ( int i = random.nextInt ( 50 ); i > 0; i-- ) {
                cloud.addTag ( s );
            }
        }
        for ( Tag tag : cloud.tags() ) {
            final JLabel label = new JLabel ( tag.getName() );
            label.setOpaque ( false );
            label.setFont ( label.getFont().deriveFont ( ( float ) tag.getWeight() * 10 ) );
            panel.add ( label );
        }
        frame.add ( panel );
        frame.setSize ( 800, 600 );
        frame.setVisible ( true );
    }
    public static void main ( String[] args ) {
        SwingUtilities.invokeLater ( new Runnable() {
            @Override
            public void run() {
                new TestOpenCloud().initUI();
            }
        } );
    }
}
