ColumnFactory factory = new ColumnFactory() {
    @Override
    protected int calcPrototypeWidth ( JXTable table,
                                       TableColumnExt columnExt ) {
        if ( isHierarchicalPrototype ( table, columnExt ) )  {
            return calcHierarchicalPrototypeWidth ( ( JXTreeTable ) table, columnExt );
        }
        return super.calcPrototypeWidth ( table, columnExt );
    }
    protected boolean isHierarchicalPrototype ( JXTable table,
            TableColumnExt columnExt ) {
        return ( table instanceof JXTreeTable )
               && ( ( JXTreeTable ) table ).getTreeTableModel().getHierarchicalColumn() ==
               columnExt.getModelIndex()
               && columnExt.getPrototypeValue() != null;
    }
    TreeCellRenderer dummy = new DefaultTreeCellRenderer();
    protected int calcHierarchicalPrototypeWidth ( JXTreeTable table,
            TableColumnExt columnExt ) {
        JXTree renderer = ( JXTree ) getCellRenderer ( table, columnExt );
        columnExt.getPrototypeValue(), false, false, false, -1, false );
        Component comp = dummy.getTreeCellRendererComponent ( renderer,
                         columnExt.getPrototypeValue(), false, false, false, -1, false );
        return Math.max ( renderer.getPreferredSize().width, comp.getPreferredSize().width );
    }
};
JXTreeTable table = new JXTreeTable();
table.setColumnFactory ( factory );
table.setTreeTableModel ( new FileSystemModel() );
table.getColumnExt ( 0 ).setPrototypeValue ( "long longer longest still not enough to really see" +
        " some effect of the prototype if available" );
table.getColumnFactory().configureColumnWidths ( table, table.getColumnExt ( 0 ) );
