import java.util.HashMap;
import java.util.Map;
import javax.swing.table.DefaultTableModel;
public class TableTest extends javax.swing.JFrame {
    public TableTest() {
        initComponents();
    }
    private void updateInformationTable ( HashMap<String, String> parameterMap ) {
        infoTable.setModel ( new MyTableModel ( parameterMap ) );
    }
    private class MyTableModel extends DefaultTableModel {
        private Map<String, String> data;
        public MyTableModel ( Map<String, String> data ) {
            this.data = data;
        }
        public int getRowCount() {
            return 1;
        }
        public int getColumnCount() {
            return data != null ? data.size() : 0;
        }
        public Object getValueAt ( int rowIndex, int columnIndex ) {
            return rowIndex + "," + columnIndex;
        }
    }
    @SuppressWarnings ( "unchecked" )
    private void initComponents() {
        jPanel1 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        infoTable = new javax.swing.JTable();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        setDefaultCloseOperation ( javax.swing.WindowConstants.EXIT_ON_CLOSE );
        infoTable.setModel ( new javax.swing.table.DefaultTableModel (
        new Object [][] {
            {null, null, null, null},
            {null, null, null, null},
        },
        new String [] {
            "Title 1", "", "", ""
        }
                             ) );
        infoTable.setAutoscrolls ( false );
        infoTable.setShowHorizontalLines ( false );
        infoTable.setShowVerticalLines ( false );
        infoTable.setAutoCreateColumnsFromModel ( true );
        jScrollPane1.setViewportView ( infoTable );
        jButton1.setText ( "3 Columns" );
        jButton1.addActionListener ( new java.awt.event.ActionListener() {
            public void actionPerformed ( java.awt.event.ActionEvent evt ) {
                jButton1ActionPerformed ( evt );
            }
        } );
        jButton2.setText ( "5 Columns" );
        jButton2.addActionListener ( new java.awt.event.ActionListener() {
            public void actionPerformed ( java.awt.event.ActionEvent evt ) {
                jButton2ActionPerformed ( evt );
            }
        } );
        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout ( jPanel1 );
        jPanel1.setLayout ( jPanel1Layout );
        jPanel1Layout.setHorizontalGroup (
            jPanel1Layout.createParallelGroup ( javax.swing.GroupLayout.Alignment.LEADING )
            .addGroup ( jPanel1Layout.createSequentialGroup()
                        .addComponent ( jButton1 )
                        .addPreferredGap ( javax.swing.LayoutStyle.ComponentPlacement.RELATED, 577, Short.MAX_VALUE )
                        .addComponent ( jButton2 ) )
            .addGroup ( jPanel1Layout.createParallelGroup ( javax.swing.GroupLayout.Alignment.LEADING )
                        .addComponent ( jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 739, Short.MAX_VALUE ) )
        );
        jPanel1Layout.setVerticalGroup (
            jPanel1Layout.createParallelGroup ( javax.swing.GroupLayout.Alignment.LEADING )
            .addGroup ( javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                        .addContainerGap ( 243, Short.MAX_VALUE )
                        .addGroup ( jPanel1Layout.createParallelGroup ( javax.swing.GroupLayout.Alignment.BASELINE )
                                    .addComponent ( jButton1 )
                                    .addComponent ( jButton2 ) )
                        .addContainerGap() )
            .addGroup ( jPanel1Layout.createParallelGroup ( javax.swing.GroupLayout.Alignment.LEADING )
                        .addGroup ( jPanel1Layout.createSequentialGroup()
                                    .addComponent ( jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 234, javax.swing.GroupLayout.PREFERRED_SIZE )
                                    .addGap ( 0, 25, Short.MAX_VALUE ) ) )
        );
        javax.swing.GroupLayout layout = new javax.swing.GroupLayout ( getContentPane() );
        getContentPane().setLayout ( layout );
        layout.setHorizontalGroup (
            layout.createParallelGroup ( javax.swing.GroupLayout.Alignment.LEADING )
            .addComponent ( jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE )
        );
        layout.setVerticalGroup (
            layout.createParallelGroup ( javax.swing.GroupLayout.Alignment.LEADING )
            .addComponent ( jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE )
        );
        pack();
    }
    private void jButton1ActionPerformed ( java.awt.event.ActionEvent evt ) {
        HashMap<String, String> map = new HashMap<String, String>();
        map.put ( "param1", "value1" );
        map.put ( "param2", "value2" );
        map.put ( "param3", "value3" );
        updateInformationTable ( map );
    }
    private void jButton2ActionPerformed ( java.awt.event.ActionEvent evt ) {
        HashMap<String, String> map = new HashMap<String, String>();
        map.put ( "param1", "value1" );
        map.put ( "param2", "value2" );
        map.put ( "param3", "value3" );
        map.put ( "param4", "value4" );
        map.put ( "param5", "value5" );
        updateInformationTable ( map );
    }
    public static void main ( String args[] ) {
        try {
            javax.swing.UIManager.setLookAndFeel ( "com.sun.java.swing.plaf.windows.WindowsLookAndFeel" );
        } catch ( ClassNotFoundException ex ) {
            java.util.logging.Logger.getLogger ( TableTest.class.getName() ).log ( java.util.logging.Level.SEVERE, null, ex );
        } catch ( InstantiationException ex ) {
            java.util.logging.Logger.getLogger ( TableTest.class.getName() ).log ( java.util.logging.Level.SEVERE, null, ex );
        } catch ( IllegalAccessException ex ) {
            java.util.logging.Logger.getLogger ( TableTest.class.getName() ).log ( java.util.logging.Level.SEVERE, null, ex );
        } catch ( javax.swing.UnsupportedLookAndFeelException ex ) {
            java.util.logging.Logger.getLogger ( TableTest.class.getName() ).log ( java.util.logging.Level.SEVERE, null, ex );
        }
        java.awt.EventQueue.invokeLater ( new Runnable() {
            public void run() {
                new TableTest().setVisible ( true );
            }
        } );
    }
    private javax.swing.JTable infoTable;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
}
