public InputStream oracleWorkaroundStream ( String fileName ) throws IOException {
    String ls = System.getProperty ( "line.separator" );
    Pattern pattern = Pattern.compile ( "(\\s*<)(\\w+)(.*/>)" );
    FileInputStream fis = new FileInputStream ( fileName );
    StringBuilder sb = new StringBuilder ( fis.available() * 2 );
    InputStreamReader isr = new InputStreamReader ( fis, "UTF-8" );
    BufferedReader buff = new BufferedReader ( isr );
    while ( buff.ready() ) {
        String line = buff.readLine();
        Matcher matcher = pattern.matcher ( line );
        if ( matcher.matches() ) {
            String tableName = matcher.group ( 2 );
            if ( tableName.length() > 30 ) {
                tableName = tableName.substring ( 0, 30 );
            }
            sb.append ( matcher.group ( 1 ) );
            sb.append ( tableName );
            sb.append ( matcher.group ( 3 ) );
        } else {
            sb.append ( line );
        }
        sb.append ( ls );
    }
    return new ByteArrayInputStream ( sb.toString().getBytes ( "UTF-8" ) );
}
