import org.w3c.dom.Node;
import org.w3c.dom.bootstrap.DOMImplementationRegistry;
import org.w3c.dom.ls.DOMImplementationLS;
import org.w3c.dom.ls.LSSerializer;
import org.xml.sax.InputSource;
import javax.xml.parsers.DocumentBuilderFactory;
import java.io.StringReader;
public class XmlFormatter {
    public String format ( String xml ) {
        try {
            final InputSource src = new InputSource ( new StringReader ( xml ) );
            final Node document = DocumentBuilderFactory.newInstance().newDocumentBuilder().parse ( src ).getDocumentElement();
            final Boolean keepDeclaration = Boolean.valueOf ( xml.startsWith ( "<?xml" ) );
            final DOMImplementationRegistry registry = DOMImplementationRegistry.newInstance();
            final DOMImplementationLS impl = ( DOMImplementationLS ) registry.getDOMImplementation ( "LS" );
            final LSSerializer writer = impl.createLSSerializer();
            writer.getDomConfig().setParameter ( "format-pretty-print", Boolean.TRUE );
            writer.getDomConfig().setParameter ( "xml-declaration", keepDeclaration );
            return writer.writeToString ( document );
        } catch ( Exception e ) {
            throw new RuntimeException ( e );
        }
    }
    public static void main ( String[] args ) {
        String unformattedXml =
            "<?xml version=\"1.0\" encoding=\"UTF-8\"?><QueryMessage\n" +
            "        xmlns=\"http://www.SDMX.org/resources/SDMXML/schemas/v2_0/message\"\n" +
            "        xmlns:query=\"http://www.SDMX.org/resources/SDMXML/schemas/v2_0/query\">\n" +
            "    <Query>\n" +
            "        <query:CategorySchemeWhere>\n" +
            "   \t\t\t\t\t         <query:AgencyID>ECB\n\n\n\n</query:AgencyID>\n" +
            "        </query:CategorySchemeWhere>\n" +
            "    </Query>\n\n\n\n\n" +
            "</QueryMessage>";
        System.out.println ( new XmlFormatter().format ( unformattedXml ) );
    }
}
