public TreeNode constructActualModel ( TreeAutocompleteMatcherIface matcher ) {
    if ( prunedModel == null ) {
        eraseHierarchyStructure();
        prunedModel = copyHierarchy ( ( TreeNode ) completeModel, getVisibleNodes ( matcher ) );
    }
    return prunedModel;
}
private TreeNode copyHierarchy ( TreeNode originalNode, Set<TreeNode> visibleNodes ) {
    if ( !visibleNodes.contains ( originalNode ) ) {
        return null;
    }
    TreeNode newNode = this.getCompleteModelNodes().get ( ( ( NodeWrapper ) originalNode.getData() ).getIri() );
    List<TreeNode> children = new ArrayList<TreeNode>();
    for ( int i = 0; i < originalNode.getChildCount(); i++ ) {
        TreeNode child = copyHierarchy ( ( TreeNode ) originalNode.getChildren().get ( i ), visibleNodes );
        if ( child != null ) {
            children.add ( child );
        }
    }
    ( ( DefaultTreeNode ) newNode ).setChildren ( children );
    return newNode;
}
private void eraseHierarchyStructure() {
    for ( TreeNode node : duplicateCompleteModelNodes.values() ) {
        node.setParent ( null );
    }
}
