import java.lang.reflect.Method;
import java.lang.reflect.ParameterizedType;
import java.lang.reflect.WildcardType;
import java.util.List;
public class ReflectionTest {
    public static void main ( String[] args ) throws NoSuchMethodException, SecurityException {
        Method method = ReflectionTest.class.getMethod ( "method", List.class );
        ParameterizedType listType = ( ParameterizedType ) method.getGenericParameterTypes() [0];
        ParameterizedType classType = ( ParameterizedType ) listType.getActualTypeArguments() [0];
        WildcardType genericType = ( WildcardType ) classType.getActualTypeArguments() [0];
        Class<?> genericClass = ( Class<?> ) genericType.getUpperBounds() [0];
        boolean isException = Exception.class.isAssignableFrom ( genericClass );
        System.out.println ( "Is Class<? extends Exception>: " + isException );
        boolean isRuntimeException = RuntimeException.class.isAssignableFrom ( genericClass );
        System.out.println ( "Is Class<? extends RuntimeException>: " + isRuntimeException );
    }
    public void method ( List<Class<? extends Exception>> exceptionClasses ) {
    }
}
