ScheduledThreadPoolExecutor scheduledExecutor;
...
scheduledExecutor = new ScheduledThreadPoolExecutor ( THREAD_POOL_SIZE );
...
public void schedule ( Set<Task> taskSet, long timePeriod, TimeUnit timeUnit ) {
    if ( taskSet.isEmpty() ) {
        return;
    }
    long period = TimeUnit.MILLISECOND.convert ( timePeriod, timeUnit );
    long delay = period / taskSet.size();
    long accumulativeDelay = 0;
    for ( Task task : taskSet ) {
        scheduledExecutor.schedule ( task, accumulativeDelay, TimeUnit.MILLISECOND );
        accumulativeDelay += delay;
    }
}
