private IntPtr LowLevelKeyboardHook ( int nCode, WindowsMessages wParam, [In] KBDLLHOOKSTRUCT lParam ) {
    bool callNext = true;
    bool isKeyDown = ( wParam == WindowsMessages.KEYDOWN || wParam == WindowsMessages.SYSKEYDOWN );
    bool isKeyUp = ( wParam == WindowsMessages.KEYUP || wParam == WindowsMessages.SYSKEYUP );
    if ( ( nCode >= 0 ) && ( isKeyDown || isKeyUp ) ) {
        Keys key = ( Keys ) lParam.vkCode;
    }
    return ( callNext ) ? User32.CallNextHookEx ( _mainHook, nCode, wParam, lParam ) : _nullNext;
}
private IntPtr RegisterLowLevelHook ( LowLevelKeyboardProc hook ) {
    IntPtr handle = IntPtr.Zero;
    using ( Process currentProcess = Process.GetCurrentProcess() )
    using ( ProcessModule currentModule = currentProcess.MainModule ) {
        IntPtr module = Kernel32.GetModuleHandle ( currentModule.ModuleName );
        handle = User32.SetWindowsHookEx ( HookType.KEYBOARD_LL, hook, module, 0 );
    }
    return handle;
}
private bool UnregisterLowLevelHook ( IntPtr hook ) {
    return User32.UnhookWindowsHookEx ( hook );
}
