public interface BatchSynchronisedPool<R extends Runnable> {
    void execute ( R runnable, Object batchIdentifier );
    public <T> Future<T> submit ( Callable<T> callable, Object batchIdentifier );
}
public class MyBSP<R, C> implements BatchSynchronisedPool<R, C> {
    void execute ( R runnable, Object batchIdentifier ) {
        ...
    }
    public <T> Future<T> submit ( Callable<T> callable, Object batchIdentifier ) {
        if ( ! ( callable instanceof MyDesiredCallableClass ) ) {
            throw new IllegalArgumentException ( "Types don't match." );
        }
        T result = callable.call();
        ...
    }
}
public class MyUsageClass {
    public static void main ( String[] args ) {
        MyBSP<Runnable> bsp = new MyBSP<Runnable>();
        bsp.submit ( new StringCallable(), someObject1 );
        bsp.submit ( new IntegerCallable(), someObject2 );
    }
}
