public interface BatchSynchronisedPool<R extends Runnable, C extends Callable> {
    void execute ( R runnable, Object batchIdentifier );
    public <T> Future<T> submit ( Class<T> cls, C callable, Object batchIdentifier );
}
public class MyBSP<R, C> implements BatchSynchronisedPool<R, C> {
    void execute ( R runnable, Object batchIdentifier ) {
        ...
    }
    public <T> Future<T> submit ( Class<T> cls, C callable, Object batchIdentifier ) {
        T result = cls.cast ( callable.call() );
        ...
    }
}
public class MyUsageClass {
    public static void main ( String[] args ) {
        MyBSP<Runnable, Callable> bsp = new MyBSP<Runnable, Callable>();
        bsp.submit ( new StringCallable(), someObject1 );
        bsp.submit ( new IntegerCallable(), someObject2 );
    }
}
