public static Set<Class<?>> getInheritance ( Class<?> in ) {
    LinkedHashSet<Class<?>> result = new LinkedHashSet<Class<?>>();
    result.add ( in );
    getInheritance ( in, result );
    return result;
}
private static void getInheritance ( Class<?> in, Set<Class<?>> result ) {
    Class<?> superclass = getSuperclass ( in );
    if ( superclass != null ) {
        result.add ( superclass );
        getInheritance ( superclass, result );
    }
    getInterfaceInheritance ( in, result );
}
private static void getInterfaceInheritance ( Class<?> in, Set<Class<?>> result ) {
    for ( Class<?> c : in.getInterfaces() ) {
        result.add ( c );
        getInterfaceInheritance ( c, result );
    }
}
private static Class<?> getSuperclass ( Class<?> in ) {
    if ( in == null ) {
        return null;
    }
    if ( in.isArray() && in != Object[].class ) {
        Class<?> type = in.getComponentType();
        while ( type.isArray() ) {
            type = type.getComponentType();
        }
        return type;
    }
    return in.getSuperclass();
}
