public class TestClass {
    private static int counter = 0;
    public static void main ( String[] args ) {
        Display display = Display.getDefault();
        Shell shell = new Shell ( display );
        shell.setLayout ( new FillLayout() );
        final Text textOne = new Text ( shell, SWT.BORDER );
        final Text textTwo = new Text ( shell, SWT.BORDER );
        final Text textThree = new Text ( shell, SWT.BORDER );
        final ArrayList<Text> textFields = new ArrayList<Text>();
        textFields.add ( textOne );
        textFields.add ( textTwo );
        textFields.add ( textThree );
        final HashMap<Text, Integer> textFieldsMapping = new HashMap<Text, Integer>();
        textFieldsMapping.put ( textOne, 0 );
        textFieldsMapping.put ( textTwo, 1 );
        textFieldsMapping.put ( textThree, 2 );
        KeyListener keyListener = new KeyListener() {
            @Override
            public void keyReleased ( KeyEvent arg0 ) {
            }
            @Override
            public void keyPressed ( KeyEvent arg0 ) {
                if ( arg0.character == '.' ) {
                    arg0.doit = false;
                    Text next = textFields.get ( counter );
                    next.setFocus();
                    next.forceFocus();
                }
            }
        };
        FocusListener focusListener = new FocusListener() {
            @Override
            public void focusLost ( FocusEvent arg0 ) {
            }
            @Override
            public void focusGained ( FocusEvent arg0 ) {
                Text current = ( Text ) arg0.getSource();
                int currentPosition = textFieldsMapping.get ( current );
                counter = ( currentPosition + 1 ) % textFields.size();
            }
        };
        textOne.addKeyListener ( keyListener );
        textTwo.addKeyListener ( keyListener );
        textThree.addKeyListener ( keyListener );
        textOne.addFocusListener ( focusListener );
        textTwo.addFocusListener ( focusListener );
        textThree.addFocusListener ( focusListener );
        shell.pack();
        shell.open();
        while ( !shell.isDisposed() ) {
            if ( !display.readAndDispatch() ) {
                display.sleep();
            }
        }
    }
}
