public final class MyEvaluator implements Evaluator {
    private int peopleCount;
    private int maxPeople;
    public MyEvaluator ( int max ) {
        maxPeople = max;
        peopleCount = 0;
    }
    public Evaluation evaluate ( Path p ) {
        if ( peopleCount >= maxPeople ) {
            return Evaluation.EXCLUDE_AND_PRUNE;
        }
        Node n = p.endNode();
        if ( n.hasProperty ( "type" ) && ( n.getProperty ( "type" ).equals ( NodeTypes.PERSON.name() ) ) ) {
            peopleCount++;
            return Evaluation.INCLUDE_AND_CONTINUE;
        }
        return Evaluation.EXCLUDE_AND_CONTINUE;
    }
}
