import java.io.UnsupportedEncodingException;
import java.security.InvalidAlgorithmParameterException;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.security.SecureRandom;
import javax.crypto.*;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;
public class AES {
    public static void main ( String[] args ) {
        try {
            String message = "This string contains a secret message.";
            System.out.println ( "Plaintext: " + message + "\n" );
            KeyGenerator keygen = KeyGenerator.getInstance ( "AES" );
            keygen.init ( 128 );
            byte[] key = keygen.generateKey().getEncoded();
            SecretKeySpec skeySpec = new SecretKeySpec ( key, "AES" );
            SecureRandom random = new SecureRandom();
            byte iv[] = new byte[16];
            random.nextBytes ( iv );
            IvParameterSpec ivspec = new IvParameterSpec ( iv );
            Cipher cipher = Cipher.getInstance ( "AES/CBC/PKCS5Padding" );
            cipher.init ( Cipher.ENCRYPT_MODE, skeySpec, ivspec );
            System.out.println ( "Key: " + new String ( key, "utf-8" ) + " This is important when decrypting" );
            System.out.println ( "IV: " + new String ( iv, "utf-8" ) + " This is important when decrypting" );
            System.out.println();
            byte[] encrypted = cipher.doFinal ( message.getBytes() );
            System.out.println ( "Ciphertext: " + asHex ( encrypted ) + "\n" );
            cipher.init ( Cipher.DECRYPT_MODE, skeySpec, ivspec );
            byte[] decrypted = cipher.doFinal ( encrypted );
            System.out.println ( "Plaintext: " + new String ( decrypted ) + "\n" );
        } catch ( IllegalBlockSizeException | BadPaddingException | UnsupportedEncodingException | InvalidKeyException | InvalidAlgorithmParameterException | NoSuchPaddingException | NoSuchAlgorithmException ex ) {
            ex.printStackTrace();
        }
    }
    public static String asHex ( byte buf[] ) {
        StringBuilder strbuf = new StringBuilder ( buf.length * 2 );
        int i;
        for ( i = 0; i < buf.length; i++ ) {
            if ( ( ( int ) buf[i] & 0xff ) < 0x10 ) {
                strbuf.append ( "0" );
            }
            strbuf.append ( Long.toString ( ( int ) buf[i] & 0xff, 16 ) );
        }
        return strbuf.toString();
    }
}
