public class MinimalPolicy extends Policy {
    private static PermissionCollection perms;
    public MinimalPolicy() {
        super();
        if ( perms == null ) {
            perms = new MyPermissionCollection();
            addPermissions();
        }
    }
    @Override
    public PermissionCollection getPermissions ( CodeSource codesource ) {
        return perms;
    }
    private void addPermissions() {
        SocketPermission socketPermission = new SocketPermission ( "*:1024-", "connect, resolve" );
        PropertyPermission propertyPermission = new PropertyPermission ( "*", "read, write" );
        FilePermission filePermission = new FilePermission ( "<<ALL FILES>>", "read" );
        perms.add ( socketPermission );
        perms.add ( propertyPermission );
        perms.add ( filePermission );
    }
}
