class CustomExpandable extends BaseExpandableListAdapter {
    private ArrayList<Category> mItems;
    public CustomExpandable ( Context context, ArrayList<Category> items ) {
        mItems = items;
    }
    @Override
    public Object getChild ( int groupPosition, int childPosition ) {
        return mItems.get ( groupPosition ).getEntries().get ( childPosition );
    }
    @Override
    public long getChildId ( int groupPosition, int childPosition ) {
        return 0;
    }
    @Override
    public View getChildView ( int groupPosition, int childPosition,
                               boolean isLastChild, View convertView, ViewGroup parent ) {
        return null;
    }
    @Override
    public int getChildrenCount ( int groupPosition ) {
        return mItems.get ( groupPosition ).getEntries().size();
    }
    @Override
    public Object getGroup ( int groupPosition ) {
        return mItems.get ( groupPosition ).getCategoryName();
    }
    @Override
    public int getGroupCount() {
        return mItems.size();
    }
    @Override
    public long getGroupId ( int groupPosition ) {
        return 0;
    }
    @Override
    public View getGroupView ( int groupPosition, boolean isExpanded,
                               View convertView, ViewGroup parent ) {
        return null;
    }
    @Override
    public boolean hasStableIds() {
        return false;
    }
    @Override
    public boolean isChildSelectable ( int groupPosition, int childPosition ) {
        return true;
    }
}
