public class ColorFactory {
    private static class ColorFactoryHolder {
        static final ColorFactory instance = new ColorMap();
    }
    public static ColorFactory getInstance() {
        return ColorFactoryHolder.instance;
    }
    Map<String, Color> colormap = new ConcurrentHashMap<String, Color>();
    private final Object lock = new Object();
    private ColorFactory() {
        colormap.add ( "blue", new Color ( 0, 0, 255 ) );
    }
    public Color getColor ( String spec ) {
        if ( colormap.containsKey ( spec ) ) {
            return colormap.get ( spec );
        }
        synchronized ( lock ) {
            if ( colormap.containsKey ( spec ) ) {
                return colormap.get ( spec );
            }
            Color color = parse ( spec );
            colormap.put ( spec, color );
            return color;
        }
    }
    private static Color parse ( String spec ) {
    }
}
