interface Counter {
    int count ( String hand );
}
class FirstCounter implements Counter {
    public int count ( String hand ) {
        String[] cards = hand.split ( hand );
        if ( hand.contains ( "/" ) ) {
            cards = hand.split ( "/" );
        } else if ( hand.contains ( "-" ) ) {
            cards = hand.split ( "-" );
        } else if ( hand.contains ( " " ) ) {
            cards = hand.split ( " " );
        } else {
            throw new RuntimeException ( "Incorrect format!" );
        }
        if ( hand.endsWith ( "-" ) || hand.endsWith ( "/" ) || hand.endsWith ( " " ) ) {
            return cards.length;
        }
        return cards.length - 1;
    }
}
class SecondCounter implements Counter {
    public int count ( String hand ) {
        char[] delims = {'/', ' ', '-'};
        int result = 0;
        for ( char delim : delims ) {
            for ( int i = 0; i < hand.length(); i++ ) {
                if ( hand.charAt ( i ) == delim ) {
                    ++result;
                }
            }
        }
        if ( result == 0 ) {
            throw new RuntimeException ( "Incorrect format!" );
        }
        return result;
    }
}
class Main {
    private static int testCount = 0;
    static void realAssert ( boolean condition ) {
        if ( !condition ) {
            throw new AssertionError ( "Java has no real assert" );
        }
    }
    static void test ( Counter counter ) {
        ++testCount;
        try {
            realAssert ( counter.count ( "6s/3d/2H/13c/Ad" ) == 4 );
            realAssert ( counter.count ( "6s-3d-2H-13c-Ad" ) == 4 );
            realAssert ( counter.count ( "6s 3d 2H 13c Ad" ) == 4 );
            realAssert ( counter.count ( "6s-3d-2H-13c-" ) == 4 );
            realAssert ( counter.count ( "6s/3d/2H/13c/" ) == 4 );
            realAssert ( counter.count ( "6s 3d 2H 13c " ) == 4 );
            realAssert ( counter.count ( "-6s-3d-2H-13c-" ) == 5 );
            realAssert ( counter.count ( "/6s/3d/2H/13c/" ) == 5 );
            realAssert ( counter.count ( " 6s 3d 2H 13c " ) == 5 );
            realAssert ( counter.count ( "--" ) == 2 );
            try {
                counter.count ( "foobar" );
                realAssert ( false );
            } catch ( RuntimeException e ) {
            }
            try {
                counter.count ( "foo/bar-baz" );
            } catch ( RuntimeException e ) {
            }
            System.out.println ( "Test " + testCount + " succeeded" );
        } catch ( Error e ) {
            System.out.println ( "Test " + testCount + " failed" );
            e.printStackTrace();
        }
    }
    public static void main ( String[] args ) {
        test ( new FirstCounter() );
        test ( new SecondCounter() );
    }
}
