public void execute ( Runnable command ) {
    if ( command == null ) {
        throw new NullPointerException();
    }
    int c = ctl.get();
    if ( workerCountOf ( c ) < corePoolSize ) {
        if ( addWorker ( command, true ) ) {
            return;
        }
        c = ctl.get();
    }
    if ( isRunning ( c ) && workQueue.offer ( command ) ) {
        int recheck = ctl.get();
        if ( ! isRunning ( recheck ) && remove ( command ) ) {
            reject ( command );
        } else if ( workerCountOf ( recheck ) == 0 ) {
            addWorker ( null, false );
        }
    } else if ( !addWorker ( command, false ) ) {
        reject ( command );
    }
}
