import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.security.AlgorithmParameters;
import java.security.InvalidAlgorithmParameterException;
import java.security.InvalidKeyException;
import java.security.Key;
import java.security.KeyFactory;
import java.security.NoSuchAlgorithmException;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.Security;
import java.security.interfaces.RSAKey;
import java.security.interfaces.RSAPrivateCrtKey;
import java.security.interfaces.RSAPublicKey;
import java.security.spec.InvalidKeySpecException;
import java.security.spec.KeySpec;
import java.security.spec.RSAPublicKeySpec;
import javax.crypto.Cipher;
import javax.crypto.EncryptedPrivateKeyInfo;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.PBEKeySpec;
public class DecodePKCS8 {
    public static void main ( String[] args ) throws
        IOException, NoSuchAlgorithmException, NoSuchPaddingException,
        InvalidKeySpecException, InvalidKeyException, InvalidAlgorithmParameterException {
        Security.addProvider ( new org.bouncycastle.jce.provider.BouncyCastleProvider() );
        String password = "Very long and complex password";
        byte[] encodedprivkey = getFileBytes ( "privkey.p8" );
        EncryptedPrivateKeyInfo ePKInfo = new EncryptedPrivateKeyInfo ( encodedprivkey );
        Cipher cipher = Cipher.getInstance ( ePKInfo.getAlgName() );
        PBEKeySpec pbeKeySpec = new PBEKeySpec ( password.toCharArray() );
        SecretKeyFactory skFac = SecretKeyFactory.getInstance ( ePKInfo
                                 .getAlgName() );
        Key pbeKey = skFac.generateSecret ( pbeKeySpec );
        AlgorithmParameters algParams = ePKInfo.getAlgParameters();
        cipher.init ( Cipher.DECRYPT_MODE, pbeKey, algParams );
        KeySpec pkcs8KeySpec = ePKInfo.getKeySpec ( cipher );
        KeyFactory rsaKeyFac = KeyFactory.getInstance ( "RSA" );
        PrivateKey rsaPriv = rsaKeyFac.generatePrivate ( pkcs8KeySpec );
        RSAPublicKeySpec rsaPubKeySpec = new RSAPublicKeySpec ( ( ( RSAKey ) rsaPriv ).getModulus(),
                ( ( RSAPrivateCrtKey ) rsaPriv ).getPublicExponent() );
        PublicKey rsaPubKey = ( RSAPublicKey ) rsaKeyFac.generatePublic ( rsaPubKeySpec );
        System.out.println ( "Key extracted, public part: " + rsaPubKey );
    }
    private static byte[] getFileBytes ( String path ) {
        File f = new File ( path );
        int sizecontent = ( ( int ) f.length() );
        byte[] data = new byte[sizecontent];
        try {
            FileInputStream freader = new FileInputStream ( f );
            freader.read ( data, 0, sizecontent ) ;
            freader.close();
            return data;
        } catch ( IOException ioe ) {
            System.out.println ( ioe.toString() );
            return null;
        }
    }
}
