public static void addFilesToExistingZip ( File zipFile, File[] files ) throws IOException {
    File tempFile = File.createTempFile ( zipFile.getName(), null );
    tempFile.delete();
    boolean renameOk = zipFile.renameTo ( tempFile );
    if ( !renameOk ) {
        throw new RuntimeException ( "could not rename the file " + zipFile.getAbsolutePath() + " to " + tempFile.getAbsolutePath() );
    }
    byte[] buf = new byte[1024];
    ZipInputStream zin = new ZipInputStream ( new FileInputStream ( tempFile ) );
    ZipOutputStream out = new ZipOutputStream ( new FileOutputStream ( zipFile ) );
    ZipEntry entry = zin.getNextEntry();
    while ( entry
            != null ) {
        String name = entry.getName();
        boolean notInFiles = true;
        for ( File f : files ) {
            if ( f.getName().equals ( name ) ) {
                notInFiles = false;
                break;
            }
        }
        if ( notInFiles ) {
            tempFile.delete();
        }
    }
