public static void generateAvgLengthPathFile ( String luceneIndexPath, String outputFilePath ) {
    try {
        Directory dir = FSDirectory.open ( new File ( luceneIndexPath ) );
        IndexReader reader = IndexReader.open ( dir );
        int totalLength = 0;
        for ( int i = 0; i < reader.maxDoc(); i++ ) {
            if ( reader.isDeleted ( i ) ) {
                continue;
            }
            Document doc = reader.document ( i );
            totalLength += Integer.parseInt ( doc.get ( "docLength" ) );
        }
        float avarageLength = totalLength * 1.0f / reader.maxDoc() * 1.0f;
        String avgLengthPathFile = "contents" + "\n" + avarageLength;
        Writer output = null;
        String text = "contents" + "\n" + avarageLength;
        File file = new File ( outputFilePath );
        output = new BufferedWriter ( new FileWriter ( file ) );
        output.write ( text );
        output.close();
    } catch ( Exception e ) {
        System.err.println ( e );
    }
}
