try {
    Pattern p = Pattern.compile ( "\'([^\']*)\'" );
    Document doc = Jsoup.connect ( "http://blich.co.il/timetable-shahaf" ).get();
    Elements iframe = doc.select ( "iframe" );
    if ( !iframe.isEmpty() ) {
        String src = iframe.get ( 0 ).absUrl ( "src" );
        if ( !TextUtils.isEmpty ( src ) ) {
            doc = Jsoup.connect ( src ).get();
            Elements selects = doc.select ( "select.HeaderClasses" );
            Elements options = selects.select ( "option" );
            if ( !options.isEmpty() ) {
                Collections.shuffle ( options );
                Element option = options.get ( 0 );
                String name = selects.get ( 0 ).attr ( "name" );
                if ( !TextUtils.isEmpty ( name ) ) {
                    doc = Jsoup.connect ( src )
                          .data ( "__EVENTTARGET", name )
                          .data ( "__EVENTARGUMENT", "" )
                          .data ( name, option.attr ( "value" ) )
                          .data ( "__VIEWSTATE",
                                  doc.select ( "input#__VIEWSTATE" ).attr ( "value" ) )
                          .data ( "__LASTFOCUS", "" )
                          .post();
                }
            }
            Elements links = doc.select ( "td.HeaderCell a" );
            for ( Element link : links ) {
                Matcher m = p.matcher ( link.attr ( "href" ) );
                if ( m.find() ) {
                    String eventTarget = m.group ( 1 );
                    if ( eventTarget != null && eventTarget.endsWith ( "ChangesTable" ) ) {
                        doc = Jsoup.connect ( src )
                              .data ( "__EVENTTARGET", eventTarget )
                              .data ( "__EVENTARGUMENT", "" )
                              .data ( "__VIEWSTATE",
                                      doc.select ( "input#__VIEWSTATE" ).attr ( "value" ) )
                              .data ( "__LASTFOCUS", "" )
                              .post();
                        Elements lessons = doc.select ( "div.TTLesson" );
                        if ( lessons.isEmpty() ) {
                            Log.w ( TAG, "Unable to list any lessons" );
                        } else {
                            for ( Element lesson : lessons ) {
                                System.out.println ( lesson );
                            }
                        }
                    }
                }
            }
        } else {
            Log.w ( TAG, "Unable to find iframe src" );
        }
    } else {
        Log.w ( TAG, "Unable to find iframe" );
    }
} catch ( IOException e ) {
    Log.w ( TAG, "Error reading timetable", e );
}
