package org.geotools.tutorial;
import java.awt.geom.Point2D;
import java.io.File;
import org.geotools.data.FileDataStore;
import org.geotools.data.FileDataStoreFinder;
import org.geotools.data.simple.SimpleFeatureSource;
import org.geotools.factory.Hints;
import org.geotools.map.FeatureLayer;
import org.geotools.map.Layer;
import org.geotools.map.MapContent;
import org.geotools.referencing.CRS;
import org.geotools.referencing.ReferencingFactoryFinder;
import org.geotools.styling.SLD;
import org.geotools.styling.Style;
import org.geotools.swing.JMapFrame;
import org.geotools.swing.data.JFileDataStoreChooser;
import org.opengis.referencing.crs.CRSAuthorityFactory;
import org.opengis.referencing.crs.CoordinateReferenceSystem;
import org.opengis.referencing.operation.MathTransform;
import org.geotools.referencing.*;
public class quickstart {
    public static void main ( String[] args ) throws Exception {
        CRSAuthorityFactory   factory = CRS.getAuthorityFactory ( true );
        CoordinateReferenceSystem srcCRS = factory.createCoordinateReferenceSystem ( "EPSG:2326" );
        CoordinateReferenceSystem dstCRS = factory.createCoordinateReferenceSystem ( "EPSG:4326" );
        boolean lenient = true;
        MathTransform transform = CRS.findMathTransform ( srcCRS, dstCRS, lenient );
        double[] srcProjec = {818039, 836361};
        double[] dstProjec = {0, 0};
        transform.transform ( srcProjec, 0, dstProjec, 0, 1 );
        System.out.println ( "longitude: " + dstProjec[0] + ", latitude: " + dstProjec[1] );
    }
}
