import java.io.*;
import java.util.*;
public class Sender {
    public static void main ( String[] args ) {
        new Sender().execute();
    }
    public void execute() {
        try {
            Process process = Runtime.getRuntime().exec ( "MessageReceiver.exe" );
            StreamGobbler sgInput = new StreamGobbler (
                process.getInputStream(), "input" );
            StreamGobbler sgError = new StreamGobbler (
                process.getErrorStream(), "error" );
            new Thread ( sgInput ).start();
            new Thread ( sgError ).start();
            PrintWriter writer = new PrintWriter ( process.getOutputStream() );
            Scanner scan = new Scanner ( System.in );
            while ( true ) {
                System.out.println ( "Send a command: " );
                String command = scan.nextLine();
                writer.write ( command );
                writer.write ( "\n" );
                writer.flush();
                if ( command.equals ( "end" ) ) {
                    break;
                }
            }
        } catch ( IOException ioe ) {
            ioe.printStackTrace();
        }
    }
    private class StreamGobbler implements Runnable {
        private InputStream is;
        private String type;
        private FileWriter fw;
        public StreamGobbler ( InputStream is, String type ) {
            this.is = is;
            this.type = type;
        }
        public StreamGobbler ( InputStream is, String type, File file )
        throws IOException {
            this.is = is;
            this.type = type;
            this.fw = new FileWriter ( file );
        }
        @Override
        public void run() {
            try {
                InputStreamReader isr = new InputStreamReader ( is );
                BufferedReader br = new BufferedReader ( isr );
                String line = null;
                while ( ( line = br.readLine() ) != null ) {
                    if ( fw != null ) {
                        fw.write ( line + "\n" );
                    } else {
                        System.out.println ( type + ">" + line );
                    }
                }
                if ( fw != null ) {
                    fw.close();
                }
            } catch ( IOException ioe ) {
                ioe.printStackTrace();
            }
        }
    }
}
