import java.io.File;
import java.io.IOException;
import org.codehaus.jackson.JsonFactory;
import org.codehaus.jackson.JsonGenerationException;
import org.codehaus.jackson.JsonParser;
import org.codehaus.jackson.JsonToken;
import org.codehaus.jackson.map.JsonMappingException;
public class JacksonStreamExample {
    public static void main ( String[] args ) {
        try {
            JsonFactory jfactory = new JsonFactory();
            JsonParser jParser = jfactory.createJsonParser ( new File ( "c:\\user.json" ) );
            while ( jParser.nextToken() != JsonToken.END_OBJECT ) {
                String fieldname = jParser.getCurrentName();
                if ( "name".equals ( fieldname ) ) {
                    jParser.nextToken();
                    System.out.println ( jParser.getText() );
                }
                if ( "age".equals ( fieldname ) ) {
                    jParser.nextToken();
                    System.out.println ( jParser.getIntValue() );
                }
                if ( "messages".equals ( fieldname ) ) {
                    jParser.nextToken();
                    while ( jParser.nextToken() != JsonToken.END_ARRAY ) {
                        System.out.println ( jParser.getText() );
                    }
                }
            }
            jParser.close();
        } catch ( JsonGenerationException e ) {
            e.printStackTrace();
        } catch ( JsonMappingException e ) {
            e.printStackTrace();
        } catch ( IOException e ) {
            e.printStackTrace();
        }
    }
}
