public class PercantageFormatCell extends TableCell<Object, Double> {
    public PercantageFormatCell() {
    }
    @Override
    protected void updateItem ( Double item, boolean empty ) {
        super.updateItem ( item, empty );
        if ( !empty && null == item ) {
            item = new Double ( 0.0d );
        }
        setText ( item == null ? "" : NumberFormat.getPercentInstance().format ( item ) );
        if ( item != null ) {
            double value = item.doubleValue();
            if ( isFocused() || isSelected() || isPressed() ) {
                setTextFill ( Color.WHITE );
            } else if ( value < 1 ) {
                setTextFill ( Color.BLACK );
            } else {
                setTextFill ( Color.GREEN );
            }
        }
    }
}
