package concur;
import java.util.Random;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Semaphore;
import java.util.concurrent.TimeUnit;
public class MemoryLimited {
    private static Semaphore semaphore = new Semaphore ( 1024 * 1024, true );
    public static byte[] createArray ( int size ) throws InterruptedException {
        semaphore.acquire ( size );
        return new byte[size];
    }
    public static void releaseArray ( byte[] array ) {
        semaphore.release ( array.length );
    }
    static final int N = 600000;
    public static void main ( String[] args ) {
        ExecutorService exec = Executors.newFixedThreadPool ( 2 );
        Runnable run = new Runnable() {
            @Override
            public void run() {
                Random rnd = new Random();
                for ( int i = 0; i < 10; i++ ) {
                    try {
                        TimeUnit.MILLISECONDS.sleep ( rnd.nextInt ( 100 ) * 10 );
                        byte[] array = createArray ( N );
                        System.out.printf ( "%s %d: %s (%d)%n",
                                            Thread.currentThread().getName(),
                                            System.currentTimeMillis(), array,
                                            semaphore.availablePermits() );
                        TimeUnit.MILLISECONDS.sleep ( rnd.nextInt ( 100 ) * 10 );
                        releaseArray ( array );
                    } catch ( InterruptedException e ) {
                        e.printStackTrace();
                    }
                }
            }
        };
        exec.submit ( run );
        exec.submit ( run );
        exec.shutdown();
    }
}
