import java.awt.*;
import javax.swing.*;
import static java.awt.GraphicsDevice.WindowTranslucency.*;
public class TranslucentWindowDemo extends JFrame {
    public TranslucentWindowDemo() {
        super ( "TranslucentWindow" );
        setLayout ( new GridBagLayout() );
        setSize ( 300, 200 );
        setLocationRelativeTo ( null );
        setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
        add ( new JButton ( "I am a Button" ) );
    }
    public static void main ( String[] args ) {
        GraphicsEnvironment ge =
            GraphicsEnvironment.getLocalGraphicsEnvironment();
        GraphicsDevice gd = ge.getDefaultScreenDevice();
        if ( !gd.isWindowTranslucencySupported ( TRANSLUCENT ) ) {
            System.err.println (
                "Translucency is not supported" );
            System.exit ( 0 );
        }
        JFrame.setDefaultLookAndFeelDecorated ( true );
        SwingUtilities.invokeLater ( new Runnable() {
            @Override
            public void run() {
                TranslucentWindowDemo tw = new TranslucentWindowDemo();
                tw.setOpacity ( 0.55f );
                tw.setVisible ( true );
            }
        } );
    }
}
