public class CopyDirectoryExample {
    public static void main ( String[] args ) {
        File srcFolder = new File ( "c:\\mkyong" );
        File destFolder = new File ( "c:\\mkyong-new" );
        if ( !srcFolder.exists() ) {
            System.out.println ( "Directory does not exist." );
            System.exit ( 0 );
        } else {
            try {
                copyFolder ( srcFolder, destFolder );
            } catch ( IOException e ) {
                e.printStackTrace();
                System.exit ( 0 );
            }
        }
        System.out.println ( "Done" );
    }
    public static void copyFolder ( File src, File dest )
    throws IOException {
        if ( src.isDirectory() ) {
            if ( !dest.exists() ) {
                dest.mkdir();
                System.out.println ( "Directory copied from "
                                     + src + "  to " + dest );
            }
            String files[] = src.list();
            for ( String file : files ) {
                File srcFile = new File ( src, file );
                File destFile = new File ( dest, file );
                copyFolder ( srcFile, destFile );
            }
        } else {
            InputStream in = new FileInputStream ( src );
            OutputStream out = new FileOutputStream ( dest );
            byte[] buffer = new byte[1024];
            int length;
            while ( ( length = in.read ( buffer ) ) > 0 ) {
                out.write ( buffer, 0, length );
            }
            in.close();
            out.close();
            System.out.println ( "File copied from " + src + " to " + dest );
        }
    }
}
