public class CheckboxDialog extends Dialog {
    private String message = "";
    private String checkboxMessage = "";
    private boolean checkValue;
    private Button checkButton;
    public CheckboxDialog ( Shell parentShell ) {
        super ( parentShell );
        setShellStyle ( SWT.CLOSE | SWT.TITLE | SWT.BORDER | SWT.OK | SWT.APPLICATION_MODAL );
        setBlockOnOpen ( true );
    }
    protected Control createDialogArea ( Composite parent ) {
        Composite composite = ( Composite ) super.createDialogArea ( parent );
        GridLayout layout = new GridLayout ( 1, false );
        layout.marginHeight = 15;
        layout.marginWidth = 30;
        composite.setLayout ( layout );
        final Label content = new Label ( composite, SWT.NONE );
        content.setLayoutData ( new GridData ( SWT.FILL, SWT.TOP, true, false ) );
        content.setText ( message );
        checkButton = new Button ( composite, SWT.CHECK );
        checkButton.setText ( checkboxMessage );
        checkButton.setSelection ( true );
        checkButton.setLayoutData ( new GridData ( SWT.FILL, SWT.TOP, true, false ) );
        return composite;
    }
    protected void createButtonsForButtonBar ( Composite parent ) {
        createButton ( parent, IDialogConstants.OK_ID, "OK", true );
    }
    protected void configureShell ( Shell newShell ) {
        super.configureShell ( newShell );
        newShell.setText ( "Error" );
    }
    public void okPressed() {
        checkValue = checkButton.getSelection();
        close();
    }
    public void setMessage ( String message ) {
        this.message = message;
    }
    public void setCheckboxMessage ( String checkboxMessage ) {
        this.checkboxMessage = checkboxMessage;
    }
    public boolean getCheckBoxValue() {
        return checkValue;
    }
}
