public class XMLCreators {
    protected DocumentBuilderFactory domFactory = null;
    protected DocumentBuilder domBuilder = null;
    public XMLCreators() {
        try {
            domFactory = DocumentBuilderFactory.newInstance();
            domBuilder = domFactory.newDocumentBuilder();
        } catch ( FactoryConfigurationError exp ) {
            System.err.println ( exp.toString() );
        } catch ( ParserConfigurationException exp ) {
            System.err.println ( exp.toString() );
        } catch ( Exception exp ) {
            System.err.println ( exp.toString() );
        }
    }
    public int convertFile ( String csvFileName, String xmlFileName,
                             String delimiter ) {
        int rowsCount = -1;
        BufferedReader csvReader;
        try {
            Document newDoc = domBuilder.newDocument();
            Element rootElement = newDoc.createElement ( "XMLCreators" );
            newDoc.appendChild ( rootElement );
            csvReader = new BufferedReader ( new FileReader ( csvFileName ) );
            CSVReader reader = new CSVReader ( new FileReader ( "names.csv" ), delimiter.charAt ( 0 ) );
            String[] nextLine;
            int line = 0;
            List<String> headers = new ArrayList<String> ( 5 );
            while ( ( nextLine = reader.readNext() ) != null ) {
                if ( line == 0 ) {
                    for ( String col : nextLine ) {
                        headers.add ( col );
                    }
                } else {
                    Element rowElement = newDoc.createElement ( "row" );
                    rootElement.appendChild ( rowElement );
                    int col = 0;
                    for ( String value : nextLine ) {
                        String header = headers.get ( col );
                        Element curElement = newDoc.createElement ( header );
                        curElement.appendChild ( newDoc.createTextNode ( value.trim() ) );
                        rowElement.appendChild ( curElement );
                        col++;
                    }
                }
                line++;
            }
            FileWriter writer = null;
            try {
                writer = new FileWriter ( new File ( xmlFileName ) );
                TransformerFactory tranFactory = TransformerFactory.newInstance();
                Transformer aTransformer = tranFactory.newTransformer();
                aTransformer.setOutputProperty ( OutputKeys.INDENT, "yes" );
                aTransformer.setOutputProperty ( OutputKeys.METHOD, "xml" );
                aTransformer.setOutputProperty ( "{http://xml.apache.org/xslt}indent-amount", "4" );
                Source src = new DOMSource ( newDoc );
                Result result = new StreamResult ( writer );
                aTransformer.transform ( src, result );
                writer.flush();
            } catch ( Exception exp ) {
                exp.printStackTrace();
            } finally {
                try {
                    writer.close();
                } catch ( Exception e ) {
                }
            }
        } catch ( IOException exp ) {
            System.err.println ( exp.toString() );
        } catch ( Exception exp ) {
            System.err.println ( exp.toString() );
        }
        return rowsCount;
    }
}
