public class ScreenshotTestRule implements MethodRule {
    public Statement apply ( final Statement statement, final FrameworkMethod frameworkMethod, final Object o ) {
        return new Statement() {
            @Override
            public void evaluate() throws Throwable {
                try {
                    statement.evaluate();
                } catch ( Throwable t ) {
                    captureScreenshot ( frameworkMethod.getName() );
                    throw t;
                } finally {
                    tearDown();
                }
            }
            public void tearDown() {
            }
            public void captureScreenshot ( String fileName ) {
                try {
                    new File ( "target/surefire-reports/screenshot" ).mkdirs();
                    FileOutputStream out = new FileOutputStream ( "target/surefire-reports/screenshot/screenshot-" + fileName + ".png" );
                    out.write ( ( ( TakesScreenshot ) driver ).getScreenshotAs ( OutputType.BYTES ) );
                    out.close();
                } catch ( Exception e ) {
                }
            }
        };
    }
}
