public class TableModelRowStorage
    implements TableModelListener {
    private int rowCount;
    public TableModelRowStorage ( TableModel model ) {
        model.addTableModelListener ( this );
        this.rowCount = model.getRowCount();
    }
    @Override
    public void tableChanged ( TableModelEvent e ) {
        if ( ( ( TableModel ) e.getSource() ).getRowCount() != rowCount ) {
            int old = rowCount;
            rowCount = ( ( TableModel ) e.getSource() ).getRowCount();
            doStuff ( old, rowCount );
        }
    }
    protected void doStuff ( int oldRowCount, int newRowCount ) {
        label.setText ( "RowCount: " + newRowCount );
        label.setForeground ( newRowCount - oldRowCount > 0 ? Color.GREEN : Color.RED );
        timer.start();
        firePropertyChange ( "rowCount", oldRowCount, newRowCount );
    }
}
