public static Boolean validateLogin ( String userName, String userPassword ) {
    Hashtable<String, String> env = new Hashtable<String, String>();
    env.put ( Context.INITIAL_CONTEXT_FACTORY, "com.sun.jndi.ldap.LdapCtxFactory" );
    env.put ( Context.PROVIDER_URL, "ldap://" + LDAP_SERVER + ":" + LDAP_SERVER_PORT + "/" + LDAP_BASE_DN );
    env.put ( Context.REFERRAL, "follow" );
    env.put ( Context.SECURITY_AUTHENTICATION, "simple" );
    env.put ( Context.SECURITY_PRINCIPAL, LDAP_BIND_DN );
    env.put ( Context.SECURITY_CREDENTIALS, LDAP_BIND_PASSWORD );
    DirContext ctx;
    try {
        ctx = new InitialDirContext ( env );
    } catch ( NamingException e ) {
        throw new RuntimeException ( e );
    }
    NamingEnumeration<SearchResult> results = null;
    try {
        SearchControls controls = new SearchControls();
        controls.setSearchScope ( SearchControls.SUBTREE_SCOPE );
        controls.setCountLimit ( 1 );
        controls.setTimeLimit ( 5000 );
        String searchString = "(&(objectCategory=user)(sAMAccountName=" + userName + "))";
        results = ctx.search ( "", searchString, controls );
        if ( results.hasMore() ) {
            SearchResult result = ( SearchResult ) results.next();
            Attributes attrs = result.getAttributes();
            Attribute dnAttr = attrs.get ( "distinguishedName" );
            String dn = ( String ) dnAttr.get();
            env.put ( Context.SECURITY_PRINCIPAL, dn );
            env.put ( Context.SECURITY_CREDENTIALS, userPassword );
            new InitialDirContext ( env );
            return true;
        } else {
            return false;
        }
    } catch ( AuthenticationException e ) {
        return false;
    } catch ( NameNotFoundException e ) {
        return false;
    } catch ( SizeLimitExceededException e ) {
        throw new RuntimeException ( "LDAP Query Limit Exceeded, adjust the query to bring back less records", e );
    } catch ( NamingException e ) {
        throw new RuntimeException ( e );
    } finally {
        if ( results != null ) {
            try {
                results.close();
            } catch ( Exception e ) {
            }
        }
        if ( ctx != null ) {
            try {
                ctx.close();
            } catch ( Exception e ) {
            }
        }
    }
}
