import javax.net.ssl.SSLSocketFactory;
import org.osmdroid.tileprovider.IMapTileProviderCallback;
import org.osmdroid.tileprovider.IRegisterReceiver;
import org.osmdroid.tileprovider.MapTileProviderArray;
import org.osmdroid.tileprovider.MapTileProviderBasic;
import org.osmdroid.tileprovider.modules.INetworkAvailablityCheck;
import org.osmdroid.tileprovider.modules.MapTileFileArchiveProvider;
import org.osmdroid.tileprovider.modules.MapTileFilesystemProvider;
import org.osmdroid.tileprovider.modules.NetworkAvailabliltyCheck;
import org.osmdroid.tileprovider.modules.TileWriter;
import org.osmdroid.tileprovider.tilesource.ITileSource;
import org.osmdroid.tileprovider.util.SimpleRegisterReceiver;
import android.content.Context;
public class MyTileProvider extends MapTileProviderArray implements
    IMapTileProviderCallback {
    public MyTileProvider ( final Context pContext, final ITileSource pTileSource ) {
        this ( new SimpleRegisterReceiver ( pContext ),
               new NetworkAvailabliltyCheck ( pContext ), pTileSource, app
               .getSSLSocketFactory() );
    }
    protected MyTileProvider ( final IRegisterReceiver pRegisterReceiver,
                               final INetworkAvailablityCheck aNetworkAvailablityCheck,
                               final ITileSource pTileSource,
                               final SSLSocketFactory pSSLSocketFactory ) {
        super ( pTileSource, pRegisterReceiver );
        final MapTileFilesystemProvider fileSystemProvider = new MapTileFilesystemProvider (
            pRegisterReceiver, pTileSource );
        mTileProviderList.add ( fileSystemProvider );
        final MapTileFileArchiveProvider archiveProvider = new MapTileFileArchiveProvider (
            pRegisterReceiver, pTileSource );
        mTileProviderList.add ( archiveProvider );
        final TileWriter tileWriter = new TileWriter();
        final MyTileDownloader downloaderProvider = new MyTileDownloader (
            pTileSource, tileWriter, aNetworkAvailablityCheck,
            pSSLSocketFactory );
        mTileProviderList.add ( downloaderProvider );
    }
}
