public class ShareButtonActivity extends Activity {
    SocialAuthAdapter adapter;
    @Override
    public void onCreate ( Bundle savedInstanceState ) {
        super.onCreate ( savedInstanceState );
        setContentView ( R.layout.main );
        TextView textview = ( TextView ) findViewById ( R.id.text );
        textview.setText ( "Title" );
        Button share = ( Button ) findViewById ( R.id.sharebutton );
        share.setText ( "Share" );
        share.setTextColor ( Color.WHITE );
        share.setBackgroundResource ( R.drawable.button_gradient );
        adapter = new SocialAuthAdapter ( new ResponseListener() );
        adapter.addProvider ( Provider.TWITTER, R.drawable.twitter );
        adapter.enable ( share );
    }
    private final class ResponseListener implements DialogListener {
        public void onComplete ( Bundle values ) {
            Log.d ( "ShareButton" , "Authentication Successful" );
            String providerName = values.getString ( SocialAuthAdapter.PROVIDER );
            Log.d ( "ShareButton", "Provider Name = " + providerName );
            adapter.updateStatus ( "your message|link" + System.currentTimeMillis() );
            Toast.makeText ( ShareButtonActivity.this, "Message posted on " + providerName, Toast.LENGTH_SHORT ).show();
        }
        public void onError ( SocialAuthError error ) {
            Log.d ( "ShareButton" , "Authentication Error" );
        }
        public void onCancel() {
            Log.d ( "ShareButton" , "Authentication Cancelled" );
        }
    }
}
