@Override
protected Dialog onCreateDialog ( int id ) {
    switch ( id ) {
    case 0:
        LayoutInflater factory = LayoutInflater.from ( this );
        final View bindListDialog = factory.inflate ( R.layout.multi_list_layout, null );
        multiListView = ( ListView ) bindListDialog.findViewById ( R.id.multiList );
        return new AlertDialog.Builder ( MultiSelectDemoActivity.this ).setTitle ( R.string.multiSelectTitle )
               .setCancelable ( false ).setView ( bindListDialog )
        .setPositiveButton ( R.string.btnClose, new DialogInterface.OnClickListener() {
            public void onClick ( DialogInterface dialog, int whichButton ) {
                updateItemList();
            }
        } ).create();
    default:
        return null;
    }
}
private static final boolean ONCREATE = true;
private static final boolean ONUPDATE = false;
private void setupMultiList ( Boolean newList ) {
    demoDBM.open();
    multiCur = demoDBM.getList ( userId );
    startManagingCursor ( multiCur );
    demoDBM.close();
    if ( newList ) {
        multiAdapter = new SimpleCursorAdapter ( this, R.layout.check_list_item, multiCur, new String[] { DemoDBM.ID,
                DemoDBM.NAME, DemoDBM.SEL
                                                                                                        }, new int[] { R.id.itemId, R.id.itemName, R.id.itemCheck } );
        multiAdapter.setViewBinder ( new MyViewBinder() );
        multiListView.setAdapter ( multiAdapter );
    } else {
        multiAdapter.changeCursor ( multiCur );
    }
}
@Override
protected void onPrepareDialog ( final int id, final Dialog dialog, Bundle args ) {
    setupMultiList ( ONCREATE );
}
public class MyViewBinder implements ViewBinder {
    @Override
    public boolean setViewValue ( View view, Cursor cursor, int columnIndex ) {
        int checkId = cursor.getColumnIndex ( DemoDBM.SEL );
        if ( columnIndex == checkId ) {
            CheckBox cb = ( CheckBox ) view;
            boolean bChecked = ( cursor.getInt ( checkId ) != 0 );
            cb.setChecked ( bChecked );
            cb.setOnCheckedChangeListener ( new MyOnCheckedChangeListener() );
            return true;
        }
        return false;
    }
}
public class MyOnCheckedChangeListener implements OnCheckedChangeListener {
    @Override
    public void onCheckedChanged ( CompoundButton checkBox, boolean newVal ) {
        View item = ( View ) checkBox.getParent();
        int itemId = Integer.valueOf ( ( ( TextView ) item.findViewById ( R.id.itemId ) ).getText().toString() );
        demoDBM.open();
        demoDBM.setChecked ( itemId, userId, newVal );
        demoDBM.close();
        setupMultiList ( ONUPDATE );
    }
}
