public class MyActivity extends MapActivity implements LocationListener, OnClickListener {
    private MapView mapView;
    private MyItemizedOverlay itemizedOverlay;
    Button route;
    boolean shadow;
    private LocationManager locManager;
    ArrayList<GeoPoint> points = new ArrayList<GeoPoint>();
    @Override
    public void onCreate ( Bundle savedInstanceState ) {
        super.onCreate ( savedInstanceState );
        setContentView ( R.layout.activity_main );
        route = ( Button ) findViewById ( R.id.cmd_submit );
        route.setOnClickListener ( this );
        mapView = ( MapView ) findViewById ( R.id.myMapView );
        mapView.setBuiltInZoomControls ( true );
        double lat = 41.889882;
        double lon = 12.479267;
        GeoPoint point = new GeoPoint ( ( int ) ( lat * 1E6 ), ( int ) ( lon * 1E6 ) );
        MapController controller = mapView.getController();
        controller.animateTo ( point );
        controller.setZoom ( 13 );
        mapView.invalidate();
        locManager = ( LocationManager ) getSystemService ( Context.LOCATION_SERVICE );
        locManager.requestLocationUpdates ( LocationManager.GPS_PROVIDER, 0,
                                            0, this );
        Location location = locManager
                            .getLastKnownLocation ( LocationManager.GPS_PROVIDER );
        if ( location != null ) {
            Toast.makeText (
                this,
                "Current location:\nLatitude: " + location.getLatitude()
                + "\n" + "Longitude: " + location.getLongitude(),
                Toast.LENGTH_LONG ).show();
            point = new GeoPoint ( ( int ) ( location.getLatitude() * 1E6 ), ( int ) ( location.getLongitude()
                                   * 1E6 ) );
            controller.animateTo ( point );
        } else {
            Toast.makeText ( this, "Cannot fetch current location!",
                             Toast.LENGTH_LONG ).show();
        }
        locManager.removeUpdates ( this );
        Drawable drawable = this.getResources().getDrawable ( R.drawable.marker );
        OverlayItem overlayItem = new OverlayItem ( point, "", "" );
        itemizedOverlay = new MyItemizedOverlay ( drawable, this );
        itemizedOverlay.setGestureDetector ( new GestureDetector ( new MyGestureDetector() ) );
        itemizedOverlay.addOverlay ( overlayItem );
        mapView.getOverlays().add ( itemizedOverlay );
        mapView.invalidate();
        locManager.removeUpdates ( this );
    }
    @Override
    protected boolean isRouteDisplayed() {
        return false;
    }
    @Override
    protected void onResume() {
        super.onResume();
        locManager.requestLocationUpdates ( LocationManager.GPS_PROVIDER, 0,
                                            0, this );
    }
    @Override
    protected void onPause() {
        super.onPause();
        locManager.removeUpdates ( this );
    }
}
