import java.awt.*;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import javax.swing.*;
public class World {
    private Rectangle[] blocks;
    private Image[] blockImg;
    private final int arrayNum = 500;
    private Image BLOCK_GRASS, BLOCK_DIRT, BLOCK_STONE, BLOCK_SKY;
    private int x, y;
    public World() {
        BLOCK_GRASS = new ImageIcon ( Frame1.class.getResource ( "images/openFile.gif" ) ).getImage();
        BLOCK_DIRT = new ImageIcon ( Frame1.class.getResource ( "images/openFile.gif" ) ).getImage();
        BLOCK_STONE = new ImageIcon ( Frame1.class.getResource ( "images/openFile.gif" ) ).getImage();
        BLOCK_SKY = new ImageIcon ( Frame1.class.getResource ( "images/openFile.gif" ) ).getImage();
        blocks = new Rectangle[500];
        blockImg = new Image[500];
        loadArrays();
    }
    private void loadArrays() {
        for ( int i = 0; i < arrayNum; i++ ) {
            if ( x >= 500 ) {
                x = 0;
                y += 20;
            }
            if ( i >= 0 && i < 100 ) {
                blockImg[i] = BLOCK_SKY;
                blocks[i] = new Rectangle ( x, y, 20, 20 );
            }
            if ( i >= 100 && i < 125 ) {
                blockImg[i] = BLOCK_GRASS;
                blocks[i] = new Rectangle ( x, y, 20, 20 );
            }
            if ( i >= 125 && i < 225 ) {
                blockImg[i] = BLOCK_DIRT;
                blocks[i] = new Rectangle ( x, y, 20, 20 );
            }
            if ( i >= 225 && i < 500 ) {
                blockImg[i] = BLOCK_STONE;
                blocks[i] = new Rectangle ( x, y, 20, 20 );
            }
            x += 20;
        }
    }
    public void draw ( Graphics g ) {
        for ( int i = 0; i < arrayNum; i++ ) {
            g.drawImage ( blockImg[i], blocks[i].x, blocks[i].y, null );
        }
    }
}
class GamePanel extends JPanel implements Runnable {
    private Image dbImage;
    private Graphics dbg;
    static final int GWIDTH = 500, GHEIGHT = 400;
    static final Dimension gameDim = new Dimension ( GWIDTH, GHEIGHT );
    private Thread game;
    private volatile boolean running = false;
    World world;
    public GamePanel() {
        world = new World();
        setPreferredSize ( gameDim );
        setBackground ( Color.WHITE );
        setFocusable ( true );
        requestFocus();
        addKeyListener ( new KeyAdapter() {
            @Override
            public void keyPressed ( KeyEvent e ) {
            }
            @Override
            public void keyReleased ( KeyEvent e ) {
            }
            @Override
            public void keyTyped ( KeyEvent e ) {
            }
        } );
    }
    public void run() {
        while ( running ) {
            gameUpdate();
            repaint();
        }
    }
    private void gameUpdate() {
        if ( running && game != null ) {
        }
    }
    private void gameRender() {
        if ( dbImage == null ) {
            dbImage = createImage ( GWIDTH, GHEIGHT );
            if ( dbImage == null ) {
                System.err.println ( "dbImage is still null!" );
                return;
            } else {
                dbg = dbImage.getGraphics();
            }
        }
        dbg.setColor ( Color.WHITE );
        dbg.fillRect ( 0, 0, GWIDTH, GHEIGHT );
        draw ( dbg );
    }
    public void draw ( Graphics g ) {
        world.draw ( g );
    }
    public void paintComponent ( Graphics g ) {
        super.paintComponent ( g );
        gameRender();
        paintScreen ( g );
    }
    private void paintScreen ( Graphics g ) {
        try {
            if ( dbImage != null && g != null ) {
                g.drawImage ( dbImage, 0, 0, null );
            }
            Toolkit.getDefaultToolkit().sync();
        } catch ( Exception e ) {
            System.err.println ( e );
        }
    }
    public void addNotify() {
        super.addNotify();
        startGame();
    }
    private void startGame() {
        if ( game == null || !running ) {
            game = new Thread ( this );
            game.start();
            running = true;
        }
    }
    public void stopGame() {
        if ( running ) {
            running = false;
        }
    }
}
class Main extends JFrame {
    GamePanel gp;
    public Main() {
        gp = new GamePanel();
        setSize ( 500, 400 );
        setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
        add ( gp );
        setResizable ( false );
        setVisible ( true );
    }
    public static void main ( String[] args ) {
        Main m = new Main();
    }
}
