private void cropBorderFromBitmap ( Bitmap bmp ) {
    int[] pixels;
    bmp.getPixels ( pixels, 0, width, 0, 0, width, height );
    int width = bmp.getWidth();
    int height = bmp.getHeight();
    int length = pixels.length;
    int borderColor = pixels[0];
    int borderStart;
    for ( int i = 0; i < length; i ++ ) {
        if ( pixels[i] != borderColor ) {
            borderStart = i;
            break;
        }
    }
    int borderEnd;
    for ( int i = length - 1; i >= 0; i -- ) {
        if ( pixels[i] != borderColor ) {
            borderEnd = length - i;
            break;
        }
    }
    int leftMargin = borderStart % width;
    int rightMargin = borderEnd % width;
    int topMargin = borderStart / width;
    int bottomMargin = borderEnd / width;
    bmp = createBitmap ( bmp, leftMargin, topMargin, width - leftMargin - rightMargin, height - topMargin - bottomMargin );
}
