IContainer container = IContainer.make();
if ( container.open ( "/path/to/video.avi", IContainer.Type.READ, null ) < 0 ) {
    throw new IllegalArgumentException ( "could not open file: " + filename );
}
int numStreams = container.getNumStreams();
int videoStreamId = -1;
IStreamCoder videoCoder = null;
for ( int i = 0; i < numStreams; i++ ) {
    IStream stream = container.getStream ( i );
    IStreamCoder coder = stream.getStreamCoder();
    if ( coder.getCodecType() == ICodec.Type.CODEC_TYPE_VIDEO ) {
        videoStreamId = i;
        videoCoder = coder;
        break;
    }
}
if ( videoStreamId == -1 )
    throw new RuntimeException ( "could not find video stream in container: "
                                 + filename );
if ( videoCoder.open() < 0 )
    throw new RuntimeException ( "could not open video decoder for container: "
                                 + filename );
int height = videoCoder.getHeight();
int width = videoCoder.getWidth();
