package searchselection;
import javax.faces.FactoryFinder;
import javax.faces.component.UIViewRoot;
import javax.faces.context.FacesContext;
import javax.faces.context.FacesContextFactory;
import javax.faces.lifecycle.Lifecycle;
import javax.faces.lifecycle.LifecycleFactory;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
public class FacesUtil {
    public static FacesContext getFacesContext (
        ServletRequest request, ServletResponse response ) {
        FacesContext facesContext = FacesContext.getCurrentInstance();
        if ( facesContext == null ) {
            LifecycleFactory lifecycleFactory = ( LifecycleFactory )
                                                FactoryFinder.getFactory ( FactoryFinder.LIFECYCLE_FACTORY );
            Lifecycle lifecycle = lifecycleFactory.getLifecycle ( LifecycleFactory.DEFAULT_LIFECYCLE );
            FacesContextFactory contextFactory  = ( FacesContextFactory )
                                                  FactoryFinder.getFactory ( FactoryFinder.FACES_CONTEXT_FACTORY );
            facesContext = contextFactory.getFacesContext (
                               request.getServletContext(), request, response, lifecycle );
            UIViewRoot view = facesContext.getApplication().getViewHandler().createView (
                                  facesContext, "" );
            facesContext.setViewRoot ( view );
            FacesContextWrapper.setCurrentInstance ( facesContext );
        }
        return facesContext;
    }
    private static abstract class FacesContextWrapper extends FacesContext {
        protected static void setCurrentInstance ( FacesContext facesContext ) {
            FacesContext.setCurrentInstance ( facesContext );
        }
    }
}
