public String intercept ( ActionInvocation invocation ) throws Exception {
    final ActionContext context = invocation.getInvocationContext ();
    HttpServletRequest request = ( HttpServletRequest ) context.get ( HTTP_REQUEST );
    HttpSession session =  request.getSession ( true );
    Object user = session.getAttribute ( USER_HANDLE );
    if ( user == null ) {
        String loginAttempt = request.getParameter ( LOGIN_ATTEMPT );
        if ( ! StringUtils.isBlank ( loginAttempt ) ) {
            if ( processLoginAttempt ( request, session ) ) {
                return "login-success";
            } else {
                Object action = invocation.getAction ();
                if ( action instanceof ValidationAware ) {
                    ( ( ValidationAware ) action ).addActionError ( "Username or password incorrect." );
                }
            }
        }
        return "login";
    } else {
        return invocation.invoke ();
    }
}
