public class ArcHitDetector {
    public enum Quadrant {
        TOP_LEFT, TOP_RIGHT, BOTTOM_LEFT, BOTTOM_RIGHT
    }
    private int xCenter, yCenter, innerR2, outerR2;
    public ArcHitDetector ( int xCenter, int yCenter, int outerR, int innerR ) {
        this.xCenter = xCenter;
        this.yCenter = yCenter;
        this.outerR2 = outerR * outerR;
        this.innerR2 = innerR * innerR;
    }
    public Quadrant classifyHit ( int x, int y ) {
        int dx = x - xCenter;
        int dy = y - yCenter;
        int d2 = dx * dx + dy * dy;
        if ( d2 <= outerR2 && d2 >= innerR2 ) {
            if ( x >= xCenter ) {
                return y <= yCenter ? TOP_RIGHT : BOTTOM_RIGHT;
            } else {
                return y <= yCenter ? TOP_LEFT : BOTTOM_LEFT;
            }
        } else {
            return null;
        }
    }
}
