package lab.heapdump;
import javax.management.MBeanServer;
import java.lang.management.ManagementFactory;
import java.lang.reflect.Method;
@SuppressWarnings ( "restriction" )
public class HeapDump {
    private static final String HOTSPOT_BEAN_NAME =
        "com.sun.management:type=HotSpotDiagnostic";
    private static volatile Object hotspotMBean;
    static void dumpHeap ( String fileName, boolean live ) {
        initHotspotMBean();
        try {
            Class clazz = Class.forName ( "com.sun.management.HotSpotDiagnosticMXBean" );
            Method m = clazz.getMethod ( "dumpHeap", String.class, boolean.class );
            m.invoke ( hotspotMBean , fileName, live );
        } catch ( RuntimeException re ) {
            throw re;
        } catch ( Exception exp ) {
            throw new RuntimeException ( exp );
        }
    }
    private static void initHotspotMBean() {
        if ( hotspotMBean == null ) {
            synchronized ( HeapDump.class ) {
                if ( hotspotMBean == null ) {
                    hotspotMBean = getHotspotMBean();
                }
            }
        }
    }
    private static Object getHotspotMBean() {
        try {
            Class clazz = Class.forName ( "com.sun.management.HotSpotDiagnosticMXBean" );
            MBeanServer server = ManagementFactory.getPlatformMBeanServer();
            Object bean =
                ManagementFactory.newPlatformMXBeanProxy ( server,
                        HOTSPOT_BEAN_NAME, clazz );
            return bean;
        } catch ( RuntimeException re ) {
            throw re;
        } catch ( Exception exp ) {
            throw new RuntimeException ( exp );
        }
    }
    public static void main ( String[] args ) {
        String fileName = "D:\\heap.bin";
        boolean live = true;
        switch ( args.length ) {
        case 2:
            live = args[1].equals ( "true" );
        case 1:
            fileName = args[0];
        }
        dumpHeap ( fileName, live );
    }
}
