public interface FinancialChart extends IsWidget {
    void setTickerSymbol ( String tickerSymbol );
}
class FinancialChartPresenter extends Composite implements FinancialChart {
    private final FinancialChartView view;
    private final DataServiceAsync service;
    @Inject ( FinancialChartView view, DataServiceAsync service ) {
        this.view = view;
        this.service = service;
    }
    @Override public Widget asWidget() {
        return view.asWidget();
    }
    @Override public void setTickerSymbol ( String tickerSymbol ) {
        service.getData ( tickerSymbol, new AsyncCallback<FinancialData>() {
            @Override public void onFailure ( Throwable t ) {
            }
            @Override public void onSuccess ( FinancialData data ) {
                SimpleData simpleData =
                    view.drawGraph ( simpleData );
            }
        }
    }
    interface FinancialChartView extends IsWidget {
        void drawGraph ( SimpleData simpleData );
    }
    class FinancialChartWidget extends Composite implements FinancialChartView {
        @Override public void drawGraph ( SimpleData simpleData ) {
        }
    }
    class SomethingWithFinancialChartWidget extends Composite
        implements SomethingWithFinancialChart {
        interface Binder extends UiBinder<Widget, SomethingWithFinancialChartWidget> {}
        @UiField ( provided = true ) final FinancialChart chart;
        @Inject SomethingWithFinancialChartWidget ( Binder binder, FinancialChart chart ) {
            this.chart = chart;
            initWidget ( binder.createAndBindUi ( this ) );
        }
    }
    <ui: HTMLPanel>
    < !-- lots of stuff -- >
    < mynamespace: FinancialChart ui: field = "chart" / >
            < !-- lots more stuff -- >
            < / ui: HTMLPanel >
    class MyPackagesGinModule extends AbstractGinModule {
        @Override protected void configure() {
            bind ( FinancialChart.class ).to ( FinancialChartPresenter.class );
            bind ( FinancialChartView.class ).to ( FinancialChartWidget.class );
        }
    }
