private static String convertStreamToString ( InputStream is ) {
    BufferedReader reader = new BufferedReader ( new InputStreamReader ( is ) );
    StringBuilder sb = new StringBuilder();
    String line = null;
    try {
        while ( ( line = reader.readLine() ) != null ) {
            sb.append ( line + "\n" );
        }
    } catch ( IOException e ) {
        e.printStackTrace();
    } finally {
        try {
            is.close();
        } catch ( IOException e ) {
            e.printStackTrace();
        }
    }
    return sb.toString();
}
public static String[] connect ( String url ) {
    HttpClient httpclient = new DefaultHttpClient();
    String[] str = new String[5];
    HttpGet httpget = new HttpGet ( url );
    HttpResponse response;
    try {
        response = httpclient.execute ( httpget );
        Log.d ( TAG, response.getStatusLine().toString() );
        HttpEntity entity = response.getEntity();
        if ( entity != null ) {
            InputStream instream = entity.getContent();
            String result = convertStreamToString ( instream );
            result = result.replace ( "parseExchangeRate(", "" ).replace ( ");", "" );
            Log.d ( TAG, result );
            JSONObject json = new JSONObject ( result );
            Log.d ( TAG, "<jsonobject>\n" + json.toString()
                    + "\n</jsonobject>" );
            JSONObject query = json.getJSONObject ( "query" );
            Log.d ( TAG, query.toString() );
            JSONObject results = query.getJSONObject ( "results" );
            Log.d ( TAG, results.toString() );
            JSONObject quote = results.getJSONObject ( "row" );
            Log.d ( TAG, quote.toString() );
            for ( int i = 0; i < quote.length(); i++ ) {
                String symbol = quote.getString ( "rate" );
                str[0] = symbol;
                String dayslow = quote.getString ( "DaysLow" );
                str[1] = dayslow;
                str[2] = quote.getString ( "DaysHigh" );
                str[3] = quote.getString ( "Open" );
                str[4] = quote.getString ( "Change" );
            }
            Log.d ( TAG, "<jsonobject>\n" + json.toString()
                    + "\n</jsonobject>" );
            instream.close();
        }
    } catch ( ClientProtocolException e ) {
        Log.d ( TAG, "ClientProtocolException" );
        e.printStackTrace();
    } catch ( IOException e ) {
        Log.d ( TAG, "IOException " + e.getMessage() );
        e.printStackTrace();
    } catch ( JSONException e ) {
        Log.d ( TAG, "JSONException " + e.getMessage() );
        e.getMessage();
    }
    return str;
}
