public class JRubyServlet extends HttpServlet {
    private static final long serialVersionUID = -6913887886084787803L;
    private Ruby ruby;
    private Servlet rubyServlet;
    @Override public void init ( ServletConfig config ) throws ServletException {
        super.init ( config );
        ruby = JavaEmbedUtils.initialize ( asList ( "src/main/ruby" ) );
        rubyServlet = ( Servlet ) JavaEmbedUtils.rubyToJava ( ruby.evalScriptlet ( "require 'ruby_servlet'; RubyServlet.new" ) );
        rubyServlet.init ( config );
    }
    @Override public void destroy() {
        JavaEmbedUtils.terminate ( ruby );
        super.destroy();
    }
    @Override protected void doGet ( HttpServletRequest req, HttpServletResponse res ) throws ServletException, IOException {
        rubyServlet.service ( req, res );
    }
    @Override protected void doPost ( HttpServletRequest req, HttpServletResponse res ) throws ServletException, IOException {
        doGet ( req, res );
    }
