public class FaceDetect {
    CvMemStorage storage = null;
    CvHaarClassifierCascade classifier = null;
    String[] classifierName = {
        "./classifiers/haarcascade_frontalface_alt.xml",
        "./classifiers/haarcascade_frontalface_alt2.xml",
        "./classifiers/haarcascade_profileface.xml"
    };
    public FaceDetect() {
        storage = CvMemStorage.create();
        classifier = new CvHaarClassifierCascade ( cvLoad ( classifierName[0] ) );
        if ( classifier.isNull() ) {
            System.err.println ( "Error loading classifier file" );
        }
    }
    public boolean find ( Image value ) {
        cvClearMemStorage ( storage );
        if ( !classifier.isNull() ) {
            CvSeq faces = cvHaarDetectObjects ( value.getImage(), classifier,
                                                storage, 1.1, 3, CV_HAAR_DO_CANNY_PRUNING );
            int total = faces.total();
            if ( total > 0 ) {
                return true;
            }
        }
        return false;
    }
}
