public void loadIntoClassLoader ( ClassLoader loader, String...binaryNames ) {
    final String[] classNamesToLoad =
        dependencies.getClassesToLoad ( binaryNames );
    Method defineClass = null;
    Method findLoadedClass = null;
    try {
        defineClass = ClassLoader.class.getDeclaredMethod (
                          "defineClass", String.class, byte[].class,
                          int.class, int.class );
        defineClass.setAccessible ( true );
        findLoadedClass = ClassLoader.class.getDeclaredMethod (
                              "findLoadedClass", String.class );
        findLoadedClass.setAccessible ( true );
        for ( String binaryName : classNamesToLoad ) {
            if ( !binaryName.startsWith ( "java." ) ) {
                if ( findLoadedClass.invoke ( loader, binaryName ) == null ) {
                    byte[] bytecode = getBytecode ( binaryName );
                    defineClass.invoke ( loader, binaryName, bytecode,
                                         0, bytecode.length );
                } else if ( declaredClasses.containsKey ( binaryName ) ) {
                    throw new RuntimeException (
                        "Class " + binaryName + " was already loaded, " +
                        "it must not be redeclared" );
                }
            }
        }
    } catch ( Exception e ) {
        e.printStackTrace();
        throw new RuntimeException (
            "could not load classes into ClassLoader", e );
    } finally {
        rehideMethod ( findLoadedClass );
        rehideMethod ( defineClass );
    }
}
private void rehideMethod ( Method m ) {
    if ( m != null ) {
        try {
            m.setAccessible ( false );
        } catch ( Exception e ) {
        }
    }
}
