public Integer add ( int cacheKey, String mapListKey, int value ) {
    ConcurrentMap<String, List<Integer>> cachedMap = cache.getIfPresent ( cacheKey );
    if ( cachedMap == null ) {
        return null;
    }
    List<Integer> mappedList = cachedMap.get ( mapListKey );
    if ( mappedList == null ) {
        List<Integer> newMappedList = Lists.newArrayList();
        mappedList = cachedMap.putIfAbsent ( mapListKey, newMappedList );
        if ( mappedList == null ) {
            mappedList = newMappedList;
        }
    }
    synchronized ( mappedList ) {
        mappedList.add ( value );
    }
    return value;
}
