public enum MyCache {
    INSTANCE;
    private static Cache<Integer, LoadingCache<String, List<Integer>>> cache =
    CacheBuilder.newBuilder()
    .maximumSize ( 1000 )
    .build();
    private static AtomicInteger uniqueCount = new AtomicInteger ( 0 );
    public int newMapItem() {
        int key = uniqueCount.incrementAndGet();
        cache.put ( key, CacheBuilder.newBuilder().build ( ListCacheLoader.INSTANCE ) );
        return key;
    }
    public void expireMapItem ( int key ) {
        cache.invalidate ( key );
    }
    public boolean add ( int cacheKey, String mapListKey, int value ) {
        LoadingCache<String, List<Integer>> cachedMap = cache.getIfPresent ( cacheKey );
        if ( cachedMap == null ) {
            return false;
        }
        List<Integer> mappedList = cachedMap.getUnchecked ( mapListKey );
        synchronized ( mappedList ) {
            mappedList.add ( value );
        }
        return true;
    }
    private static class ListCacheLoader extends CacheLoader<String, List<Integer>> {
        public static final ListCacheLoader INSTANCE = new ListCacheLoader();
        @Override
        public List<Integer> load ( String key ) {
            return Lists.newArrayList();
        }
    }
}
