public class ForexPostProcessor extends ADynamicAggregationPostProcessor<Double> {
    public final static String REFERENCE_CURRENCY = "EUR";
    private ForexService forexService;
    @Override
    protected Double doLeafEvaluation ( ILocation leafLocation, Object[] underlyingMeasures ) throws QuartetException {
        String currency = ( String ) leafLocation.getCoordinate ( currencyDimension, currencyLevel );
        double nativeAmount = ( Double ) underlyingMeasures[0];
        if ( ( currency.equals ( REFERENCE_CURRENCY ) ) || ( nativeAmount == 0.0 ) ) {
            return nativeAmount;
        }
        IQueryCache queryCache = pivot.getContext().get ( IQueryCache.class );
        Double rate = ( Double ) queryCache.get ( currency );
        if ( rate == null ) {
            Double rateRetrieved = forexService.retrieveQuotation ( currency, REFERENCE_CURRENCY );
            Double rateCached = ( Double ) queryCache.putIfAbsent ( currency, rateRetrieved );
            rate = rateCached == null ? rateRetrieved : rateCached;
        }
        return  nativeAmount * rate;
    }
}
