import java.io.*;
import javax.xml.bind.ValidationEventHandler;
import javax.xml.bind.annotation.DomHandler;
import javax.xml.transform.Source;
import javax.xml.transform.stream.*;
public class BodyDomHandler implements DomHandler<String, StreamResult> {
    private static final String BODY_START_TAG = "<body>";
    private static final String BODY_END_TAG = "</body>";
    private StringWriter xmlWriter = new StringWriter();
    public StreamResult createUnmarshaller ( ValidationEventHandler errorHandler ) {
        return new StreamResult ( xmlWriter );
    }
    public String getElement ( StreamResult rt ) {
        String xml = rt.getWriter().toString();
        int beginIndex = xml.indexOf ( BODY_START_TAG ) + BODY_START_TAG.length();
        int endIndex = xml.indexOf ( BODY_END_TAG );
        return xml.substring ( beginIndex, endIndex );
    }
    public Source marshal ( String n, ValidationEventHandler errorHandler ) {
        try {
            String xml = BODY_START_TAG + n.trim() + BODY_END_TAG;
            StringReader xmlReader = new StringReader ( xml );
            return new StreamSource ( xmlReader );
        } catch ( Exception e ) {
            throw new RuntimeException ( e );
        }
    }
}
