public Location getLocation() {
    try {
        locationManager = ( LocationManager ) mContext
                          .getSystemService ( LOCATION_SERVICE );
        isGPSEnabled = locationManager
                       .isProviderEnabled ( LocationManager.GPS_PROVIDER );
        isNetworkEnabled = locationManager
                           .isProviderEnabled ( LocationManager.NETWORK_PROVIDER );
        if ( isNetworkEnabled ) {
            this.canGetLocation = true;
            locationManager.requestLocationUpdates (
                LocationManager.NETWORK_PROVIDER, MIN_TIME_BW_UPDATES, MIN_DISTANCE_CHANGE_FOR_UPDATES, this );
            Log.d ( "Network", "Network" );
            if ( locationManager != null ) {
                location = locationManager
                           .getLastKnownLocation ( LocationManager.NETWORK_PROVIDER );
                if ( location != null ) {
                    latitude = location.getLatitude();
                    longitude = location.getLongitude();
                }
            }
        } else if ( isGPSEnabled ) {
            this.canGetLocation = true;
            locationManager.requestLocationUpdates (
                LocationManager.GPS_PROVIDER, MIN_TIME_BW_UPDATES, MIN_DISTANCE_CHANGE_FOR_UPDATES, this );
            Log.d ( "GPS Enabled", "GPS Enabled" );
            if ( locationManager != null ) {
                location = locationManager
                           .getLastKnownLocation ( LocationManager.GPS_PROVIDER );
                if ( location != null ) {
                    latitude = location.getLatitude();
                    longitude = location.getLongitude();
                }
            }
        } else {
            this.canGetLocation = false;
        }
    } catch ( Exception e ) {
        e.printStackTrace();
    }
    return location;
}
