public class MapOverlay {
    private GeoPoint pointToDraw;
    int[] imageNames = new int[6];
    private Point mScreenPoints;
    private Bitmap mBitmap;
    private Paint mCirclePaint;
    public MapOverlay ( GPSLocationListener gpsLocationListener, int currentUser ) {
        imageNames[0] = currentUser;
        mCirclePaint = new Paint ( Paint.ANTI_ALIAS_FLAG );
        mCirclePaint.setColor ( 0x30000000 );
        mCirclePaint.setStyle ( Style.FILL_AND_STROKE );
        mBitmap = BitmapFactory.decodeResource ( context.getResources(), imageNames[0] );
        mScreenPoints = new Point();
    }
    public void setPointToDraw ( GeoPoint point ) {
        pointToDraw = point;
    }
    public GeoPoint getPointToDraw() {
        return pointToDraw;
    }
    public boolean draw ( Canvas canvas, MapView mapView, boolean shadow, long when ) {
        super.draw ( canvas, mapView, shadow );
        if ( pointToDraw == null ) {
            return true;
        }
        mScreenPoints = mapView.getProjection().toPixels ( pointToDraw, mScreenPoints );
        int totalCircle = 4;
        int radius = 40;
        int centerimagesize = 35;
        for ( int i = 1; i <= totalCircle; i ++ ) {
            canvas.drawCircle ( screenPts.x, screenPts.y, i * radius, mCirclePaint );
        }
        canvas.drawBitmap ( mBitmap, ( screenPts.x - ( centerimagesize / 2 ) ), ( screenPts.y - ( centerimagesize / 2 ) ), null );
        super.draw ( canvas, mapView, shadow );
        return true;
    }
