public static String parseXMLForTag ( String xml, String tag ) {
    try {
        XmlPullParserFactory factory = XmlPullParserFactory.newInstance();
        XmlPullParser parser = factory.newPullParser();
        parser.setInput ( new StringReader ( xml ) );
        boolean foundTag = false;
        StringBuilder tagContents = new StringBuilder();
        int eventType = parser.getEventType();
        while ( eventType != XmlPullParser.END_DOCUMENT ) {
            switch ( eventType ) {
            case XmlPullParser.START_TAG:
                if ( parser.getName().equals ( tag ) ) {
                    foundTag = true;
                } else if ( foundTag ) {
                    tagContents.append ( "<" + parser.getName() + ">" );
                }
                break;
            case XmlPullParser.END_TAG:
                if ( parser.getName().equals ( tag ) ) {
                    return tagContents.toString();
                } else if ( foundTag ) {
                    tagContents.append ( "</" + parser.getName() + ">" );
                }
                break;
            case XmlPullParser.TEXT:
                if ( foundTag ) {
                    tagContents.append ( parser.getText() );
                }
                break;
            }
            eventType = parser.next();
        }
        return null;
    } catch ( Exception e ) {
        return null;
    }
}
}
