import java.awt.FlowLayout;
import java.math.BigDecimal;
import javax.swing.JFrame;
import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.plot.PiePlot3D;
import org.jfree.data.general.DefaultPieDataset;
import org.jfree.data.general.PieDataset;
import org.jfree.util.Rotation;
public class Report extends JFrame {
    public int total_stations = 0, total_jobs = 0, total_parts = 0;
    BigDecimal[] j1_systimebig, j1_worktimebig, j1_idletimebig, j1_queuetimebig,
               j2_systimebig, j2_worktimebig, j2_idletimebig, j2_queuetimebig,
               j3_systimebig, j3_worktimebig, j3_idletimebig, j3_queuetimebig;
    public String sim_time;
    BigDecimal systime = new BigDecimal ( 0 );
    BigDecimal worktime = new BigDecimal ( 0 );
    BigDecimal idletime = new BigDecimal ( 0 );
    BigDecimal queuetime = new BigDecimal ( 0 );
    private static final String title = "Which operating system are you using?";
    public Report() {
        initComponents();
        jPanel2.removeAll();
        jPanel2.setLayout ( new FlowLayout ( FlowLayout.LEFT ) );
        jPanel2.add ( createPieChart ( title ) );
        this.setLocationRelativeTo ( null );
    }
    private ChartPanel createPieChart ( String chartTitle ) {
        System.out.println ( "PieChart" );
        PieDataset dataset = createDataset();
        JFreeChart chart = createChart ( dataset, chartTitle );
        ChartPanel chartPanel = new ChartPanel ( chart );
        return chartPanel;
    }
    private PieDataset createDataset() {
        System.out.println ( "PieDataset" );
        DefaultPieDataset result = new DefaultPieDataset();
        result.setValue ( "Linux", 29 );
        result.setValue ( "Mac", 20 );
        result.setValue ( "Windows", 51 );
        return result;
    }
    private JFreeChart createChart ( PieDataset dataset, String title ) {
        System.out.println ( "Create Chart" );
        JFreeChart chart = ChartFactory.createPieChart3D (
                               title, dataset, true, true, false );
        PiePlot3D plot = ( PiePlot3D ) chart.getPlot();
        plot.setStartAngle ( 290 );
        plot.setDirection ( Rotation.CLOCKWISE );
        plot.setForegroundAlpha ( 0.5f );
        plot.setCircular ( true );
        return chart;
    }
    @SuppressWarnings ( "unchecked" )
    private void initComponents() {
    }
    private void jButton1ActionPerformed ( java.awt.event.ActionEvent evt ) {
        this.dispose();
    }
    public static void main ( String args[] ) {
        java.awt.EventQueue.invokeLater ( new Runnable() {
            @Override
            public void run() {
                new Report().setVisible ( true );
            }
        } );
    }
    public javax.swing.JPanel chartPanel1;
    public javax.swing.JButton jButton1;
    public javax.swing.JButton jButton2;
    public javax.swing.JLabel jLabel1;
    public javax.swing.JLabel jLabel10;
    public javax.swing.JLabel jLabel11;
    public javax.swing.JLabel jLabel12;
    public javax.swing.JLabel jLabel13;
    public javax.swing.JLabel jLabel14;
    public javax.swing.JLabel jLabel15;
    public javax.swing.JLabel jLabel16;
    public javax.swing.JLabel jLabel17;
    public javax.swing.JLabel jLabel18;
    public javax.swing.JLabel jLabel19;
    public javax.swing.JLabel jLabel2;
    public javax.swing.JLabel jLabel20;
    public javax.swing.JLabel jLabel21;
    public javax.swing.JLabel jLabel22;
    public javax.swing.JLabel jLabel23;
    public javax.swing.JLabel jLabel24;
    public javax.swing.JLabel jLabel25;
    public javax.swing.JLabel jLabel26;
    public javax.swing.JLabel jLabel27;
    public javax.swing.JLabel jLabel28;
    public javax.swing.JLabel jLabel29;
    public javax.swing.JLabel jLabel30;
    public javax.swing.JLabel jLabel4;
    public javax.swing.JLabel jLabel7;
    public javax.swing.JLabel jLabel8;
    public javax.swing.JLabel jLabel9;
    public javax.swing.JPanel jPanel1;
    public javax.swing.JPanel jPanel2;
    public javax.swing.JPanel jPanel3;
    public javax.swing.JPanel jPanel4;
    public javax.swing.JPanel jPanel6;
    public javax.swing.JPanel jPanel7;
    public javax.swing.JPanel jPanel8;
    public javax.swing.JScrollPane jScrollPane1;
    public javax.swing.JScrollPane jScrollPane3;
    public javax.swing.JScrollPane jScrollPane5;
    public javax.swing.JScrollPane jScrollPane6;
    public javax.swing.JSeparator jSeparator1;
    public javax.swing.JSeparator jSeparator3;
    public javax.swing.JSeparator jSeparator4;
    public javax.swing.JSeparator jSeparator5;
    public javax.swing.JSeparator jSeparator6;
    public javax.swing.JTabbedPane jTabbedPane1;
    public javax.swing.JTable jTable1;
    public javax.swing.JTable jTable2;
    public javax.swing.JTable jTable3;
    public javax.swing.JTable jTable4;
}
