long totalSpaceWindows ( String path ) throws IOException {
    path = FilenameUtils.normalize ( path );
    if ( path.length() > 2 && path.charAt ( 1 ) == ':' ) {
        path = path.substring ( 0, 2 );
    }
    String[] cmdAttribs = new String[] {
        "cmd.exe",
        "/C",
        "fsutil volume diskfree " + path
        + " | Find \"Total # of bytes\""
    };
    List lines = performCommand ( cmdAttribs, Integer.MAX_VALUE );
    if ( lines.size() > 0 ) {
        String line = ( String ) lines.get ( 0 );
        String bytes = line.split ( ":" ) [1].trim();
        return Long.parseLong ( bytes );
    }
    throw new IOException (
        "Command line 'fsutil volume diskfree' did not return
        + "any info  for path '" + path + "'");
    }
