public class Listener implements Runnable {
    final ILongPollingService service;
    final String listenerId;
    Listener ( ILongPollingService service, String listenerId ) {
        this.service = service;
        this.listenerId = listenerId;
    }
    @Override
    public void run() {
        for ( int iteration = 0; iteration < 100; iteration++ ) {
            IBulkedStreamEvents events = service.listen ( listenerId );
            if ( events != null ) {
                logger.log ( Level.INFO, "Received events:" );
                for ( final IDomainStreamEvent domainEvent : events.getDomainEvents() ) {
                    for ( final IStreamEvent event : domainEvent.getEvents() ) {
                        logger.log ( Level.INFO, event.toString() );
                    }
                }
            } else {
                logger.log ( Level.INFO, "No events received." );
            }
        }
    }
}
