protected static byte[] parseDERFromPEM ( byte[] pem, String beginDelimiter, String endDelimiter ) {
    String data = new String ( pem );
    String[] tokens = data.split ( beginDelimiter );
    tokens = tokens[1].split ( endDelimiter );
    return DatatypeConverter.parseBase64Binary ( tokens[0] );
}
protected static RSAPrivateKey generatePrivateKeyFromDER ( byte[] keyBytes ) throws InvalidKeySpecException, NoSuchAlgorithmException {
    PKCS8EncodedKeySpec spec = new PKCS8EncodedKeySpec ( keyBytes );
    KeyFactory factory = KeyFactory.getInstance ( "RSA" );
    return ( RSAPrivateKey ) factory.generatePrivate ( spec );
}
protected static X509Certificate generateCertificateFromDER ( byte[] certBytes ) throws CertificateException {
    CertificateFactory factory = CertificateFactory.getInstance ( "X.509" );
    return ( X509Certificate ) factory.generateCertificate ( new ByteArrayInputStream ( certBytes ) );
}
