public class StockCodeGenerator implements IdentifierGenerator {
    private static Logger log = Logger.getLogger ( StockCodeGenerator.class );
    public Serializable generate ( SessionImplementor session, Object object )
    throws HibernateException {
        String prefix = "M";
        Connection connection = session.connection();
        try {
            PreparedStatement ps = connection
                                   .prepareStatement ( "SELECT nextval ('seq_stock_code') as nextval" );
            ResultSet rs = ps.executeQuery();
            if ( rs.next() ) {
                int id = rs.getInt ( "nextval" );
                String code = prefix + StringUtils.leftPad ( "" + id, 3, '0' );
                log.debug ( "Generated Stock Code: " + code );
                return code;
            }
        } catch ( SQLException e ) {
            log.error ( e );
            throw new HibernateException (
                "Unable to generate Stock Code Sequence" );
        }
        return null;
    }
}
