package test;
import java.util.concurrent.TimeUnit;
import java.util.logging.Logger;
import javax.ejb.PostActivate;
import javax.ejb.PrePassivate;
import javax.ejb.Stateful;
import javax.ejb.StatefulTimeout;
@Stateful
@StatefulTimeout ( unit = TimeUnit.MINUTES, value = 30 )
public class StatefulTestBean {
    private static final Logger logger = Logger.getLogger ( "test" );
    private String clientInfo;
    @SuppressWarnings ( "unused" )
    @PrePassivate
    private void prePassivate() {
        logger.info ( "In PrePassivate method" );
    }
    @SuppressWarnings ( "unused" )
    @PostActivate
    private void postActivate() {
        logger.info ( "In PostActivate method" );
    }
    public String getBeanInfo() {
        return this.toString();
    }
    public String getClientInfo() {
        return clientInfo;
    }
    public void setClientInfo ( String clientInfo ) {
        this.clientInfo = clientInfo;
    }
}
