import java.util.Random;
import org.apache.http.HttpEntity;
import org.apache.http.HttpHost;
import org.apache.http.HttpResponse;
import org.apache.http.auth.AuthScope;
import org.apache.http.auth.UsernamePasswordCredentials;
import org.apache.http.client.AuthCache;
import org.apache.http.client.ResponseHandler;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.auth.DigestScheme;
import org.apache.http.impl.client.BasicResponseHandler;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.client.protocol.ClientContext;
import org.apache.http.impl.client.BasicAuthCache;
import org.apache.http.protocol.BasicHttpContext;
import org.apache.http.util.EntityUtils;
public class RestClient {
    public static void main ( String args[] ) throws Exception {
        HttpHost targetHost = new HttpHost ( "localhost", 8001, "http" );
        DefaultHttpClient httpclient = new DefaultHttpClient();
        final String userName = "admin";
        final String password = "password";
        httpclient.getCredentialsProvider().setCredentials (
            new AuthScope ( "localhost", 8001 ),
            new UsernamePasswordCredentials ( userName, password ) );
        AuthCache authCache = new BasicAuthCache();
        DigestScheme digestAuth = new DigestScheme();
        digestAuth.overrideParamter ( "realm", "some realm" );
        digestAuth.overrideParamter ( "nonce", "whatever" );
        authCache.put ( targetHost, digestAuth );
        BasicHttpContext localcontext = new BasicHttpContext();
        localcontext.setAttribute ( ClientContext.AUTH_CACHE, authCache );
        HttpGet httpget = new HttpGet ( "http://localhost:8001/rest/test" );
        try {
            HttpResponse response = httpclient.execute ( targetHost, httpget, localcontext );
            HttpEntity entity = response.getEntity();
            System.out.println ( "----------------------------------------" );
            System.out.println ( response.getStatusLine() );
            if ( entity != null ) {
                System.out.println ( "Response content length: " + entity.getContentLength() );
            }
            EntityUtils.consume ( entity );
        } finally {
            httpclient.getConnectionManager().shutdown();
        }
    }
}
