import java.awt.event.ActionEvent;
import javax.swing.*;
public class GuiTest2 {
    private static void createAndShowGui() {
        Gui2 mainPanel = new Gui2();
        JFrame frame = new JFrame ( "Gui2" );
        frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
        frame.getContentPane().add ( mainPanel );
        frame.pack();
        frame.setLocationByPlatform ( true );
        frame.setVisible ( true );
    }
    public static void main ( String[] args ) {
        SwingUtilities.invokeLater ( new Runnable() {
            public void run() {
                createAndShowGui();
            }
        } );
    }
}
class Gui2 extends JPanel {
    private JTextField field = new JTextField ( 10 );
    private JButton nextBtn = new JButton ( new NextController ( this, "Next" ) );
    public Gui2() {
        field.setEditable ( false );
        field.setFocusable ( false );
        add ( field );
        add ( nextBtn );
    }
    public void setTextFieldText ( String text ) {
        field.setText ( text );
    }
}
class NextController extends AbstractAction {
    private static final String[] TEXTS = {"Monday", "Tuesday", "Wednesday", "Thursday", "Friday"};
    private Gui2 gui;
    private int index = 0;
    public NextController ( Gui2 gui, String name ) {
        super ( name );
        this.gui = gui;
    }
    @Override
    public void actionPerformed ( ActionEvent arg0 ) {
        gui.setTextFieldText ( TEXTS[index] );
        index++;
        index %= TEXTS.length;
    }
}
