public String decrypt ( String ciphertext ) throws Exception {
    byte[] crypt = Base64.decodeBase64 ( ciphertext );
    byte[] salt = Arrays.copyOfRange ( crypt, 0, saltLength );
    byte[] iv = Arrays.copyOfRange ( crypt, saltLength, saltLength + ivLength );
    byte[] encryptedData = Arrays.copyOfRange ( crypt, saltLength + ivLength, crypt.length );
    SecretKeyFactory f = SecretKeyFactory.getInstance ( secretKeyName );
    KeySpec ks = new PBEKeySpec ( password.toCharArray(), salt, pbkdfNumIters, keyLength );
    SecretKey s = f.generateSecret ( ks );
    Key keySpec = new SecretKeySpec ( s.getEncoded(), "AES" );
    Cipher cipher = Cipher.getInstance ( cipherAlgo );
    IvParameterSpec ivSpec = new IvParameterSpec ( iv );
    cipher.init ( Cipher.DECRYPT_MODE, keySpec, ivSpec );
    byte[] decBytes = cipher.doFinal ( encryptedData );
    return new String ( decBytes );
}
