@FacesValidator ( "confirmPasswordValidator" )
public class ConfirmPasswordValidator implements Validator {
    @Override
    public void validate ( FacesContext context, UIComponent component, Object value ) throws ValidatorException {
        UIInput passwordComponent = ( UIInput ) component.getAttributes().get ( "passwordComponent" );
        String password = ( String ) passwordComponent.getValue();
        String confirmPassword = ( String ) value;
        if ( confirmPassword != null && !confirmPassword.equals ( password ) ) {
            throw new ValidatorException ( new FacesMessage (
                                               FacesMessage.SEVERITY_ERROR, "Confirm password is not the same as password", null ) );
        }
    }
}
