public static void main ( String[] args ) throws IOException, TransformationException {
    Map<String, Map<String, Integer>> actions = new HashMap<String, Map<String, Integer>>();
    Genson genson = new Genson();
    ObjectReader reader = genson.createReader ( new FileReader ( "path/to/the/file" ) );
    while ( reader.hasNext() ) {
        reader.next();
        reader.beginObject();
        String action = readUntil ( "action", reader );
        reader.next();
        String responseCode = reader.valueAsString();
        Map<String, Integer> countMap = actions.get ( action );
        if ( countMap == null ) {
            countMap = new HashMap<String, Integer>();
            actions.put ( action, countMap );
        }
        Integer count = countMap.get ( responseCode );
        if ( count == null ) {
            count = 0;
        }
        count++;
        countMap.put ( responseCode, count );
        reader.endObject();
    }
    String json = genson.serialize ( actions );
}
static String readUntil ( String name, ObjectReader reader ) throws IOException {
    while ( reader.hasNext() ) {
        reader.next();
        if ( name.equals ( reader.name() ) ) {
            return reader.valueAsString();
        }
    }
    throw new IllegalStateException();
}
