import java.awt.event.*;
import java.io.*;
import javax.swing.*;
public class InputRedirection extends Box {
    public InputRedirection() {
        super ( BoxLayout.X_AXIS );
        final PipedInputStream pisIN = new PipedInputStream();
        PipedOutputStream posIN = new PipedOutputStream();
        final BufferedWriter standardIn = new BufferedWriter ( new OutputStreamWriter ( posIN ) );
        System.setIn ( pisIN );
        try {
            pisIN.connect ( posIN );
        } catch ( IOException e2 ) {
            e2.printStackTrace();
        }
        final JTextField field = new JTextField ( 20 );
        ActionListener sendText = new ActionListener() {
            @Override
            public void actionPerformed ( ActionEvent arg0 ) {
                try {
                    standardIn.append ( field.getText() );
                    standardIn.flush();
                    field.setText ( "" );
                    field.requestFocus();
                } catch ( IOException e ) {
                    e.printStackTrace();
                }
            }
        };
        field.addActionListener ( sendText );
        add ( field );
        JButton button = new JButton ( "Send" );
        button.addActionListener ( sendText );
        add ( button );
        Thread standardInReader = new Thread ( new Runnable() {
            @Override
            public void run() {
                boolean update = false;
                final StringBuffer s = new StringBuffer();
                while ( true ) {
                    try {
                        BufferedInputStream stream = new BufferedInputStream ( System.in );
                        while ( stream.available() > 0 ) {
                            int charCode = stream.read();
                            s.append ( Character.toChars ( charCode ) );
                            update = true;
                        }
                        if ( update ) {
                            System.out.println ( s.toString() );
                            s.delete ( 0, s.length() );
                            update = false;
                        }
                    } catch ( IOException e ) {
                        e.printStackTrace();
                    }
                }
            }
        } );
        standardInReader.start();
    }
    public static void main ( String[] args ) {
        JFrame frame = new JFrame();
        frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
        frame.add ( new InputRedirection() );
        frame.pack();
        frame.setLocationRelativeTo ( null );
        frame.setVisible ( true );
    }
}
