public static boolean testTriangleAABB ( Triangle triangle,
        Vector3d origin, double size ) {
    setTriangleNormal ( triangle.getNormal ( true ) );
    Vector3d[] aabbVertices = calculateAABBVertices ( origin, size );
    if ( !testTriangleNormal ( triangle, aabbVertices ) ) {
        return false;
    }
    if ( !testTriangleEdgeNormals ( triangle, aabbVertices ) ) {
        return false;
    }
    if ( !testAABBAxis ( triangle, aabbVertices ) ) {
        return false;
    }
    return true;
}
...
private static boolean testTriangleEdgeNormals ( Triangle triangle, Vector3d[] aabbVertices ) {
    Vector3d edge = new Vector3d();
    Vector3d edgeNormal = new Vector3d();
    Vector3d[] points = triangle.getPoints();
    for ( int i = 0; i < points.length; i++ ) {
        int iOverflow = i + 1 == points.length ? 0 : i + 1;
        edge.sub ( points[ i ], points[ iOverflow ] );
        edge.normalize();
        edgeNormal.cross ( getTriangleNormal(), edge );
        projectionAABB = project2D1D ( aabbVertices, edgeNormal );
        projectionTriangle = project2D1D ( triangle.getPoints(), edgeNormal );
        if ( !projectionAABB.hasOverlap ( projectionTriangle ) ) {
            return false;
        }
    }
    return true;
}
