class CustomListView extends ListView {
    private Paint mPaint = new Paint();
    private Paint mPaintBackground = new Paint();
    public CustomListView ( Context context, AttributeSet attrs ) {
        super ( context, attrs );
        mPaint.setColor ( Color.RED );
        mPaintBackground.setColor ( Color.CYAN );
    }
    @Override
    protected void dispatchDraw ( Canvas canvas ) {
        super.dispatchDraw ( canvas );
        final int currentHeight = getMeasuredHeight();
        final int scrolledHeight = computeVerticalScrollRange();
        if ( scrolledHeight >= currentHeight || scrolledHeight == 0 ) {
            return;
        } else {
            final View lastChild = getChildAt ( getChildCount() - 1 );
            final int lastChildBottom = lastChild.getBottom();
            final int lastChildHeight = lastChild.getMeasuredHeight();
            final int nrOfLines = ( currentHeight - lastChildBottom )
                                  / lastChildHeight;
            Rect r = new Rect ( 0, lastChildBottom, getMeasuredWidth(),
                                getMeasuredHeight() );
            canvas.drawRect ( r, mPaintBackground );
            for ( int i = 0; i < nrOfLines; i++ ) {
                canvas.drawLine ( 0, lastChildBottom + ( i + 1 ) * lastChildHeight,
                                  getMeasuredWidth(), lastChildBottom + ( i + 1 )
                                  * lastChildHeight, mPaint );
            }
        }
    }
}
