public static Class[] getClasses ( String pckgname )
throws ClassNotFoundException {
    ArrayList<Class> classes = new ArrayList<Class>();
    File directory = null;
    try {
        ClassLoader cld = Thread.currentThread().getContextClassLoader();
        if ( cld == null ) {
            throw new ClassNotFoundException ( "Can't get class loader." );
        }
        String path = '/' + pckgname.replace ( '.', '/' );
        URL resource = cld.getResource ( path );
        if ( resource == null ) {
            throw new ClassNotFoundException ( "No resource for " + path );
        }
        directory = new File ( resource.getFile() );
    } catch ( NullPointerException x ) {
        throw new ClassNotFoundException ( pckgname + " (" + directory
                                           + ") does not appear to be a valid package" );
    }
    if ( directory.exists() ) {
        String[] files = directory.list();
        for ( int i = 0; i < files.length; i++ ) {
            if ( files[i].endsWith ( ".class" ) ) {
                classes.add ( Class.forName ( pckgname + '.'
                                              + files[i].substring ( 0, files[i].length() - 6 ) ) );
            }
        }
    } else {
        throw new ClassNotFoundException ( pckgname
                                           + " does not appear to be a valid package" );
    }
    Class[] classesA = new Class[classes.size()];
    classes.toArray ( classesA );
    return classesA;
}
