public class CustomSerializer extends JsonSerializer<Object> {
    private Class<?>[] _activeViews;
    public CustomSerializer ( Class<?>[] view ) {
        _activeViews = view;
    }
    @Override
    public void serialize ( Object value, JsonGenerator jgen,
                            SerializerProvider provider ) throws IOException,
        JsonProcessingException {
        BeanPropertyFilter filter = provider.getConfig().getFilterProvider().findFilter ( "CustomFilter" );
        if ( filter instanceof CustomFilter ) {
            CustomFilter customFilter = ( CustomFilter ) filter;
            customFilter.setNextViews ( _activeViews );
            provider.defaultSerializeValue ( value, jgen );
            customFilter.setNextViews ( null );
        } else {
            provider.defaultSerializeValue ( value, jgen );
        }
    }
}
