public static class Printer implements Printable {
    final Component comp;
    public Printer ( Component comp ) {
        this.comp = comp;
    }
    @Override
    public int print ( Graphics g, PageFormat format, int page_index )
    throws PrinterException {
        if ( page_index > 0 ) {
            return Printable.NO_SUCH_PAGE;
        }
        Dimension dim = comp.getSize();
        double cHeight = dim.getHeight();
        double cWidth = dim.getWidth();
        double pHeight = format.getImageableHeight();
        double pWidth = format.getImageableWidth();
        double pXStart = format.getImageableX();
        double pYStart = format.getImageableY();
        double xRatio = pWidth / cWidth;
        double yRatio = pHeight / cHeight;
        Graphics2D g2 = ( Graphics2D ) g;
        g2.translate ( pXStart, pYStart );
        g2.scale ( xRatio, yRatio );
        comp.paint ( g2 );
        return Printable.PAGE_EXISTS;
    }
}
