public abstract class Queue implements Runnable {
    private final LinkedBlockingQueue<Message> queue;
    public Queue() {
        this.queue = new LinkedBlockingQueue<Message>();
    }
    public void add ( final Message message ) {
        try {
            queue.put ( message );
        } catch ( final InterruptedException e ) {
            e.printStackTrace();
        }
    }
    @Override
    public void run() {
        while ( true ) {
            try {
                final Message message = queue.take();
                processMessage ( message );
            } catch ( final InterruptedException e ) {
                e.printStackTrace();
            }
        }
    }
    protected abstract void processMessage ( Message message );
