public class MyDouble {
    private static final double SMALL_EPSILON = 1e-8;
    private static final double SMALL_EPSILON_MULTIPLIER = 1e8;
    private static final int    SMALL_EPSILON_POWER = 8;
    private double myBase;
    private int    myPower;
    public MyDouble ( double base, int power ) {
        myBase  = base;
        myPower = power;
    }
    public MyDouble ( double base ) {
        myBase  = base;
        myPower = 0;
        adjustPower();
    }
    private void adjustPower() {
        if ( myBase < SMALL_EPSILON ) {
            myBase = myBase * SMALL_EPSILON_MULTIPLIER;
            myPower -= SMALL_EPSILON_POWER;
        }
    }
    public void multiply ( MyDouble d ) {
        myBase  *= d.myBase;
        myPower += d.myPower;
        adjustPower();
    }
    public void multiply ( double d ) {
        multiply ( new MyDouble ( d ) );
    }
    @Override
    public String toString() {
        return "Base:" + myBase + ", Power=" + myPower;
    }
    public static MyDouble multiply ( double...values ) {
        MyDouble result = new MyDouble ( 1 );
        for ( int i = 0; i < values.length; i++ ) {
            result.multiply ( values[i] );
        }
        return result;
    }
    public static void main ( String[] args ) {
        MyDouble r = MyDouble.multiply ( 1e-80, 1e100 );
        System.out.println ( r );
    }
