import java.util.regex.*;
public abstract class Rewriter {
    private Pattern pattern;
    private Matcher matcher;
    public Rewriter ( String regex ) {
        this.pattern = Pattern.compile ( regex );
    }
    public String group ( int i ) {
        return matcher.group ( i );
    }
    public abstract String replacement();
    public String rewrite ( CharSequence original ) {
        this.matcher = pattern.matcher ( original );
        StringBuffer result = new StringBuffer ( original.length() );
        while ( matcher.find() ) {
            matcher.appendReplacement ( result, "" );
            result.append ( replacement() );
        }
        matcher.appendTail ( result );
        return result.toString();
    }
    public static void main ( String... args ) throws Exception {
        String str = "12 54 1 65";
        Rewriter tripler = new Rewriter ( "(\\d{1,2})" ) {
            public String replacement() {
                int intValue = Integer.valueOf ( group ( 1 ) );
                return String.valueOf ( intValue * 3 );
            }
        };
        System.out.println ( tripler.rewrite ( str ) );
        System.out.println ( new Rewriter ( "(\\d{1,2})" ) {
            public String replacement() {
                int intValue = Integer.valueOf ( group ( 1 ) );
                return String.valueOf ( intValue * 3 );
            }
        } .rewrite ( str ) );
    }
}
