@RequestMapping ( params = "form", method = RequestMethod.GET )
public ModelAndView createForm() {
    ModelMap uiModel = new ModelMap();
    uiModel.addAttribute ( "carCreateFormBackingObject", new CarCreateFormBackingObject() );
    uiModel.addAttribute ( "manufactureres", this.manufactureresDao.readAll() );
    return new ModelAndView ( "car/create", uiModel );
}
@RequestMapping ( method = RequestMethod.POST )
public ModelAndView create ( final @Valid CarCreateFormBackingObject carCreateFormBackingObject,
                             final BindingResult bindingResult ) {
    if ( bindingResult.hasErrors() ) {
        ModelMap uiModel = new ModelMap();
        uiModel.addAttribute ( "carCreateFormBackingObject", carCreateFormBackingObject );
        uiModel.addAttribute ( "manufactureres", this.manufactureresDao.readAll() );
        return new ModelAndView ( "car/create", uiModel );
    }
    Car car = this.carService.create ( carCreateFormBackingObject.name, ... );
    return new ModelAndView ( new RedirectView ( "/cars/" + car.getId(), true ) );
}
