public class Main {
    public static void main ( String[] args ) {
        new Main();
    }
    public Main() {
        EventQueue.invokeLater ( new Runnable() {
            @Override
            public void run() {
                try {
                    UIManager.setLookAndFeel ( UIManager.getSystemLookAndFeelClassName() );
                } catch ( ClassNotFoundException ex ) {
                } catch ( InstantiationException ex ) {
                } catch ( IllegalAccessException ex ) {
                } catch ( UnsupportedLookAndFeelException ex ) {
                }
                JFrame frame = new JFrame();
                frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
                frame.setLayout ( new GridLayout ( 3, 1 ) );
                frame.add ( new Label ( "One", Color.BLACK ) );
                frame.add ( new Label ( "Two", Color.BLACK ) );
                frame.add ( new Label ( "Three", Color.BLACK ) );
                frame.pack();
                frame.setVisible ( true );
            }
        } );
    }
    public class Label extends JPanel {
        JButton btnDeleteObject;
        ImageIcon delIcon = new ImageIcon ( "Delete.png" );
        Image img = delIcon.getImage();
        Image newimg = img.getScaledInstance ( 28, 28, java.awt.Image.SCALE_SMOOTH );
        ImageIcon scaledDelIcon = new ImageIcon ( newimg );
        Color labelColour;
        public Label ( String labelName, Color labelColour ) {
            this.labelColour = labelColour;
            setLayout ( new BorderLayout() );
            addComponents ( labelName );
        }
        private void addComponents ( String labelName ) {
            JPanel innerContainer = new JPanel ( new GridBagLayout() );
            JLabel name = new JLabel ( labelName );
            LabelColourBox cBox = new LabelColourBox();
            name.setBorder ( BorderFactory.createLineBorder ( Color.blue ) );
            setBorder ( BorderFactory.createLineBorder ( Color.black ) );
            Action action = new AbstractAction ( "Button Label", scaledDelIcon ) {
                public void actionPerformed ( ActionEvent evt ) {
                    System.out.println ( "delete" );
                }
            };
            btnDeleteObject = new JButton ( action );
            btnDeleteObject.setText ( "" );
            btnDeleteObject.setContentAreaFilled ( false );
            setAlignmentX ( LEFT_ALIGNMENT );
            GridBagConstraints gbc = new GridBagConstraints();
            gbc.gridx = 0;
            gbc.gridy = 0;
            gbc.fill = GridBagConstraints.BOTH;
            innerContainer.add ( cBox, gbc );
            gbc.gridx++;
            gbc.weightx = 1;
            gbc.anchor = GridBagConstraints.WEST;
            innerContainer.add ( name, gbc );
            gbc.gridx++;
            gbc.weightx = 0;
            innerContainer.add ( btnDeleteObject, gbc );
            add ( innerContainer );
        }
        public class LabelColourBox extends JPanel {
            public LabelColourBox() {
                setLayout ( new BoxLayout ( this, BoxLayout.X_AXIS ) );
            }
            @Override
            public Dimension getPreferredSize() {
                return new Dimension ( 40, 40 );
            }
            @Override
            public Dimension getMinimumSize() {
                return getPreferredSize();
            }
            @Override
            public Dimension getMaximumSize() {
                return getPreferredSize();
            }
            @Override
            protected void paintComponent ( Graphics g ) {
                super.paintComponent ( g );
                g.setColor ( Color.RED );
                g.fillRect ( 0, 0, getWidth() - 1, getHeight() - 1 );
                g.setColor ( Color.GREEN );
                g.drawRect ( 0, 0, getWidth() - 1, getHeight() - 1 );
            }
        }
    }
}
