public class OrthogonalEdgeRenderer
    extends EdgeRenderer {
    public OrthogonalEdgeRenderer ( int edgeType, int arrowType ) {
        super ( edgeType, arrowType );
    }
    public OrthogonalEdgeRenderer() {
        this ( Constants.EDGE_TYPE_LINE, Constants.EDGE_ARROW_NONE );
    }
    protected Shape getRawShape ( VisualItem vi ) {
        Path2D.Double result = new Path2D.Double();
        if ( vi instanceof EdgeItem ) {
            EdgeItem ei = ( EdgeItem ) vi;
            double sx = ei.getSourceItem().getX();
            double sy = ei.getSourceItem().getY();
            double tx = ei.getTargetItem().getX();
            double ty = ei.getTargetItem().getY();
            double midy = ( sy + ty ) / 2;
            if ( midy != sy && midy != ty ) {
                result.moveTo ( sx, sy );
                result.lineTo ( sx, midy );
                result.lineTo ( tx, midy );
                result.lineTo ( tx, ty );
            }
        }
        return result;
    }
}
