import java.util.Arrays;
public class Queue {
    private int enqueueIndex;
    private int dequeueIndex;
    private int[] items;
    private int count;
    public Queue ( int size ) {
        enqueueIndex = 0;
        dequeueIndex = 0;
        items = new int[size];
    }
    public void enqueue ( int newNumber ) {
        if ( count == items.length ) {
            throw new IllegalStateException();
        }
        items[enqueueIndex] = newNumber;
        enqueueIndex = ++enqueueIndex == items.length ? 0 : enqueueIndex;
        ++count;
    }
    public int dequeue() {
        if ( count == 0 ) {
            throw new IllegalStateException();
        }
        int item = items[dequeueIndex];
        items[dequeueIndex] = 0;
        dequeueIndex = ++dequeueIndex == items.length ? 0 : dequeueIndex;
        --count;
        return item;
    }
    @Override
    public String toString() {
        return Arrays.toString ( items );
    }
}
