public class Main {
    public class Base {
        @Expose
        @SerializedName ( "class" )
        protected String clazz = getClass().getSimpleName();
        protected String control = "ctrl";
    }
    public class Child extends Base {
        protected String text = "This is text";
        protected Boolean boolTest = false;
    }
    public static void main ( String[] args ) {
        Main m = new Main();
        GsonBuilder b = new GsonBuilder();
        b.registerTypeAdapter ( Boolean.class, new BooleanSerializer() );
        Gson gson = b.create();
        Child c = m.new Child();
        System.out.println ( gson.toJson ( c ) );
        String testStr = "{\"text\":\"This is text\",\"boolTest\":1,\"class\":\"Child\",\"control\":\"ctrl\"}";
        Child cc = gson.fromJson ( testStr, Main.Child.class );
        System.out.println ( gson.toJson ( cc ) );
    }
}
