public static String joinStackTrace ( Throwable e ) {
    StringWriter writer = null;
    try {
        writer = new StringWriter();
        joinStackTrace ( e, writer );
        return writer.toString();
    } finally {
        if ( writer != null )
            try {
                writer.close();
            } catch ( IOException e1 ) {
            }
    }
}
public static void joinStackTrace ( Throwable e, StringWriter writer ) {
    PrintWriter printer = null;
    try {
        printer = new PrintWriter ( writer );
        while ( e != null ) {
            printer.println ( e );
            StackTraceElement[] trace = e.getStackTrace();
            for ( int i = 0; i < trace.length; i++ ) {
                printer.println ( "\tat " + trace[i] );
            }
            e = e.getCause();
            if ( e != null ) {
                printer.println ( "Caused by:\r\n" );
            }
        }
    } finally {
        if ( printer != null ) {
            printer.close();
        }
    }
}
