import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
public class DrawTest extends JPanel {
    private Rectangle shape = new Rectangle ( 100, 100 );
    private int xOffset = 0;
    private int yOffset = 0;
    boolean isDragging = false;
    public DrawTest() {
        MouseAdapter listener = new MouseAdapter() {
            @Override
            public void mousePressed ( MouseEvent e ) {
                if ( shape.contains ( e.getPoint() ) ) {
                    isDragging = true;
                    xOffset = e.getPoint().x - shape.x;
                    yOffset = e.getPoint().y - shape.y;
                }
            }
            @Override
            public void mouseReleased ( MouseEvent e ) {
                isDragging = false;
            }
            @Override
            public void mouseDragged ( MouseEvent e ) {
                if ( isDragging ) {
                    moveShape ( e );
                }
            }
            private void moveShape ( MouseEvent e ) {
                Point newLocation = e.getPoint();
                newLocation.x -= xOffset;
                newLocation.y -= yOffset;
                shape.setLocation ( newLocation );
                repaint();
            }
        };
        addMouseListener ( listener );
        addMouseMotionListener ( listener );
    }
    public Dimension getPreferredSize() {
        return new Dimension ( 400, 300 );
    }
    public void paintComponent ( Graphics g ) {
        super.paintComponent ( g );
        g.clearRect ( 0, 0, getWidth(), getHeight() );
        g.fillRect ( shape.x, shape.y, shape.width, shape.height );
    }
    public static void main ( String[] args ) {
        final JFrame frame = new JFrame();
        frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
        frame.add ( new DrawTest() );
        frame.pack();
        frame.setLocationRelativeTo ( null );
        frame.setVisible ( true );
    }
}
