package dk.dalsgaarddata;
import lotus.domino.AgentBase;
import lotus.domino.AgentContext;
import lotus.domino.Database;
import lotus.domino.DocumentCollection;
import lotus.domino.NotesException;
import lotus.domino.NotesFactory;
import lotus.domino.NotesThread;
import lotus.domino.Session;
import dk.dalsgaarddata.debug.DebugAgentContext;
public class AgentTemplate extends AgentBase {
    private Session mySession = null;
    private AgentContext myContext = null;
    private DD_BackendLog myLog = null;
    private void cleanUp() {
        try {
            if ( null != myLog ) {
                myLog.end();
            }
            if ( null != mySession ) {
                mySession.recycle();
            }
        } catch ( NotesException ne ) {
            System.err.println ( "Error cleaning up log and Session." );
        }
    }
    public void NotesMain() {
        try {
            if ( mySession == null ) {
                mySession = getSession();
                myContext = mySession.getAgentContext();
            }
            SessionContext.getInstance ( mySession, myContext );
            myLog = SessionContext.getLog();
            System.out.println ( "NotesMain Started...." );
            myLog.information ( ".... completed!" );
        } catch ( NotesException ne ) {
            myLog.error ( "Agent ERROR: NotesException = " + ne.text );
            myLog.writeStackTrace ( ne );
        } catch ( Exception e ) {
            myLog.error ( "Agent ERROR: Exception = " + e.getMessage() );
            myLog.writeStackTrace ( e );
        } finally {
            cleanUp();
        }
    }
    public AgentTemplate() {
    }
    public AgentTemplate ( Session s, AgentContext c ) {
        this.mySession = s;
        this.myContext = c;
    }
    public static void main ( String[] args ) {
        System.out.println ( "main Starting...." );
        Session s = null;
        Database d = null;
        DocumentCollection dc = null;
        AgentContext ctx = null;
        System.out.println ( "NotesThread.sinitThread()...." );
        NotesThread.sinitThread();
        try {
            System.out.println ( "createSession...." );
            s = NotesFactory.createSession();
            System.out.println ( "set database...." );
            d = s.getDatabase ( DebugAgentContext.ECLIPSE_SERVER, DebugAgentContext.ECLIPSE_DATABASE );
            System.out.println ( "Database: " + d.getFileName() + " on " + d.getServer() );
            System.out.println ( "set debug context...." );
            ctx = new DebugAgentContext ( s, d, dc );
            System.out.println ( "create agent object...." );
            AgentTemplate agent = new AgentTemplate ( s, ctx );
            System.out.println ( "call agent...." );
            agent.NotesMain();
        } catch ( Exception e ) {
            e.printStackTrace();
        } finally {
            try {
                if ( s != null ) {
                    s.recycle();
                }
            } catch ( Exception x ) {
            }
            NotesThread.stermThread();
        }
    }
}
