public void testMemoryLeaks() {
    Log.e ( TAG, "------------ testMemoryLeaks()" );
    getInstrumentation().waitForIdleSync();
    System.gc();
    Main mActivity = getActivity();
    Log.d ( TAG, "-- Extractor.stop() " + mActivity.getExtractor() );
    mActivity.getExtractor().stop();
    getInstrumentation().waitForIdleSync();
    System.gc();
    long mem = Runtime.getRuntime().freeMemory();
    Log.d ( TAG, "-- freeMemory: " + mem );
    Log.d ( TAG, "-- mActivity.finish()" );
    mActivity.finish();
    getInstrumentation().waitForIdleSync();
    Log.d ( TAG, "-- setActivity()" );
    setActivity ( null );
    getInstrumentation().waitForIdleSync();
    System.gc();
    Log.d ( TAG, "-- getActivity()" );
    mActivity = getActivity();
    assertTrue ( mActivity != null );
    Log.d ( TAG, "-- Extractor.stop() " + mActivity.getExtractor() );
    mActivity.getExtractor().stop();
    getInstrumentation().waitForIdleSync();
    System.gc();
    long memAfter = Runtime.getRuntime().freeMemory();
    Log.d ( TAG, "-- freeMemory: " + memAfter );
    assertTrue ( "Memory leak", mem > memAfter * .70 && mem < memAfter * 1.30 );
    mActivity.finish();
    getInstrumentation().waitForIdleSync();
    Log.d ( TAG, "-- end testMemoryLeaks()" );
}
