package sonic;
import javax.jms.JMSException;
import javax.jms.Session;
import javax.jms.TextMessage;
import javax.jms.TopicConnection;
import javax.jms.TopicPublisher;
import javax.jms.TopicSession;
import javax.jms.TopicConnectionFactory;
import config.ConnectionInfo;
public class AccessManager {
    private TopicConnection connection = null;
    private TopicSession session = null;
    private TopicPublisher topicPublisher = null;
    private TopicConnectionFactory connectionFactory = null;
    private ConnectionInfo info = null;
    public AccessManager ( ConnectionInfo connectionInfo ) throws JMSException {
        info = connectionInfo;
    }
    public final void connect() throws JMSException {
        connectionFactory = new progress.message.jclient.TopicConnectionFactory ( info.getSonicAddress() );
        connection = connectionFactory.createTopicConnection ( info.getUserName(), info.getPassword() );
        connection.start();
        session = connection.createTopicSession ( false, Session.AUTO_ACKNOWLEDGE );
        topicPublisher = session.createPublisher ( info.getTopic() );
        assert ( isConnected() );
    }
    public void send ( String text ) throws JMSException {
        TextMessage message = session.createTextMessage ( text );
        topicPublisher.publish ( message );
    }
    public final void disconnect() throws JMSException {
        if ( topicPublisher != null ) {
            topicPublisher.close();
            session.close();
            connection.close();
        }
        connection = null;
        session = null;
    }
    public final boolean isConnected() {
        if ( session != null ) {
            return true;
        }
        return false;
    }
}
