public class Progress {
    public static void main ( String[] args ) {
        try {
            IRunnableWithProgress op = new YourThread ( 10 );
            new ProgressMonitorDialog ( new Shell() ).run ( true, true, op );
        } catch ( InvocationTargetException ex ) {
            ex.printStackTrace();
        } catch ( InterruptedException ex ) {
            ex.printStackTrace();
        }
    }
    private static class YourThread implements IRunnableWithProgress {
        private int workload;
        public YourThread ( int workload ) {
            this.workload = workload;
        }
        @Override
        public void run ( IProgressMonitor monitor ) throws InvocationTargetException, InterruptedException {
            monitor.beginTask ( "Copying files", workload );
            for ( int i = 0; i < workload; i++ ) {
                monitor.subTask ( "Copying file " + ( i + 1 ) + " of " + workload + "..." );
                Thread.sleep ( 2000 );
                monitor.worked ( 1 );
                if ( monitor.isCanceled() ) {
                    monitor.done();
                    return;
                }
            }
            monitor.done();
        }
    }
}
