public static PointF calculateDerivedPosition ( PointF point,
        double range, double bearing ) {
    double EarthRadius = 6371000;
    double latA = Math.toRadians ( point.x );
    double lonA = Math.toRadians ( point.y );
    double angularDistance = range / EarthRadius;
    double trueCourse = Math.toRadians ( bearing );
    double lat = Math.asin (
                     Math.sin ( latA ) * Math.cos ( angularDistance ) +
                     Math.cos ( latA ) * Math.sin ( angularDistance )
                     * Math.cos ( trueCourse ) );
    double dlon = Math.atan2 (
                      Math.sin ( trueCourse ) * Math.sin ( angularDistance )
                      * Math.cos ( latA ),
                      Math.cos ( angularDistance ) - Math.sin ( latA ) * Math.sin ( lat ) );
    double lon = ( ( lonA + dlon + Math.PI ) % ( Math.PI * 2 ) ) - Math.PI;
    lat = Math.toDegrees ( lat );
    lon = Math.toDegrees ( lon );
    PointF newPoint = new PointF ( ( float ) lat, ( float ) lon );
    return newPoint;
}
