public static boolean pointIsInCircle ( PointF pointForCheck, PointF center,
                                        double radius ) {
    if ( getDistanceBetweenTwoPoints ( pointForCheck, center ) <= radius ) {
        return true;
    } else {
        return false;
    }
}
public static double getDistanceBetweenTwoPoints ( PointF p1, PointF p2 ) {
    double R = 6371000;
    double dLat = Math.toRadians ( p2.x - p1.x );
    double dLon = Math.toRadians ( p2.y - p1.y );
    double lat1 = Math.toRadians ( p1.x );
    double lat2 = Math.toRadians ( p2.x );
    double a = Math.sin ( dLat / 2 ) * Math.sin ( dLat / 2 ) + Math.sin ( dLon / 2 )
               * Math.sin ( dLon / 2 ) * Math.cos ( lat1 ) * Math.cos ( lat2 );
    double c = 2 * Math.atan2 ( Math.sqrt ( a ), Math.sqrt ( 1 - a ) );
    double d = R * c;
    return d;
}
