package com.bitplan.resthelper;
import java.lang.reflect.Field;
public class FieldHelper {
    public Field getField ( Class<?> c, String fieldName ) {
        Field result = null;
        try {
            result = c.getDeclaredField ( fieldName );
        } catch ( NoSuchFieldException nsfe ) {
            Class<?> sc = c.getSuperclass();
            result = getField ( sc, fieldName );
        }
        return result;
    }
    public void setFieldValue ( Object target, String fieldName, Object value ) throws Exception {
        Class<? extends Object> c = target.getClass();
        Field field = getField ( c, fieldName );
        field.setAccessible ( true );
        field.set ( this, value );
    }
    public Object getFieldValue ( Object target, String fieldName ) throws Exception {
        Class<? extends Object> c = target.getClass();
        Field field = getField ( c, fieldName );
        field.setAccessible ( true );
        Object result = field.get ( target );
        return result;
    }
}
