public static void HelloWorld() {
    BroadphaseInterface broadphase = new DbvtBroadphase();
    DefaultCollisionConfiguration collisionConfiguration = new DefaultCollisionConfiguration();
    CollisionDispatcher dispatcher = new CollisionDispatcher ( collisionConfiguration );
    SequentialImpulseConstraintSolver solver = new SequentialImpulseConstraintSolver();
    DiscreteDynamicsWorld dynamicsWorld = new DiscreteDynamicsWorld ( dispatcher, broadphase, solver, collisionConfiguration );
    dynamicsWorld.setGravity ( new Vector3f ( 0, -10, 0 ) );
    CollisionShape groundShape = new StaticPlaneShape ( new Vector3f ( 0, 1, 0 ), 1 );
    CollisionShape fallShape = new SphereShape ( 1 );
    DefaultMotionState groundMotionState = new DefaultMotionState ( new Transform ( new Matrix4f ( new Quat4f ( 0, 0, 0, 1 ), new Vector3f ( 0, -1, 0 ), 1.0f ) ) );
    RigidBodyConstructionInfo groundRigidBodyCI = new RigidBodyConstructionInfo ( 0, groundMotionState, groundShape, new Vector3f ( 0, 0, 0 ) );
    RigidBody groundRigidBody = new RigidBody ( groundRigidBodyCI );
    dynamicsWorld.addRigidBody ( groundRigidBody );
    DefaultMotionState fallMotionState = new DefaultMotionState ( new Transform ( new Matrix4f ( new Quat4f ( 0, 0, 0, 1 ), new Vector3f ( 0, 50, 0 ), 1.0f ) ) );
    int mass = 1;
    Vector3f fallInertia = new Vector3f ( 0, 0, 0 );
    fallShape.calculateLocalInertia ( mass, fallInertia );
    RigidBodyConstructionInfo fallRigidBodyCI = new RigidBodyConstructionInfo ( mass, fallMotionState, fallShape, fallInertia );
    RigidBody fallRigidBody = new RigidBody ( fallRigidBodyCI );
    dynamicsWorld.addRigidBody ( fallRigidBody );
    for ( int i = 0 ; i < 300 ; i++ ) {
        dynamicsWorld.stepSimulation ( 1 / 60.f, 10 );
        Transform trans = new Transform();
        fallRigidBody.getMotionState().getWorldTransform ( trans );
        System.out.println ( "sphere height: " + trans.origin.y );
    }
