public class ThreadScope implements Scope {
    private final ThreadLocal<Map<String, Object>> threadLocalObjectMap = new ThreadLocal<Map<String, Object>>() {
        @Override
        protected Map<String, Object> initialValue() {
            return new HashMap<String, Object>();
        };
    };
    public Object get ( final String beanName,
                        final ObjectFactory<?> theObjectFactory ) {
        Object object = threadLocalObjectMap.get().get ( beanName );
        if ( null == object ) {
            object = theObjectFactory.getObject();
            threadLocalObjectMap.get().put ( beanName, object );
        }
        return object;
    }
    public String getConversationId() {
        return Thread.currentThread().getName();
    }
    public void registerDestructionCallback ( final String beanName,
            final Runnable theCallback ) {
    }
    public Object remove ( final String beanName ) {
        return threadLocalObjectMap.get().remove ( beanName );
    }
    @Override
    public Object resolveContextualObject ( String key ) {
        return null;
    }
    public void cleanUpThreadScopedBeans() {
        threadLocalObjectMap.remove();
    }
}
