import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.SwingUtilities;
class CustomDialog extends JDialog
    implements ActionListener,
    PropertyChangeListener {
    private String typedText = null;
    private JTextField textField;
    private String magicWord;
    private JOptionPane optionPane;
    private String btnString1 = "Enter";
    private String btnString2 = "Cancel";
    public String getValidatedText() {
        return typedText;
    }
    public CustomDialog ( Frame aFrame, String aWord ) {
        super ( aFrame, true );
        magicWord = aWord.toUpperCase();
        setTitle ( "Quiz" );
        textField = new JTextField ( 10 );
        String msgString1 = "What was Dr. SEUSS's real last name?";
        String msgString2 = "(The answer is \"" + magicWord
                            + "\".)";
        Object[] array = {msgString1, msgString2, textField};
        Object[] options = {btnString1, btnString2};
        optionPane = new JOptionPane ( array,
                                       JOptionPane.QUESTION_MESSAGE,
                                       JOptionPane.YES_NO_OPTION,
                                       null,
                                       options,
                                       options[0] );
        setContentPane ( optionPane );
        setDefaultCloseOperation ( DISPOSE_ON_CLOSE );
        addComponentListener ( new ComponentAdapter() {
            @Override
            public void componentShown ( ComponentEvent ce ) {
                textField.requestFocusInWindow();
            }
        } );
        textField.addActionListener ( this );
        optionPane.addPropertyChangeListener ( this );
        pack();
    }
    @Override
    public void actionPerformed ( ActionEvent e ) {
        optionPane.setValue ( btnString1 );
    }
    @Override
    public void propertyChange ( PropertyChangeEvent e ) {
        String prop = e.getPropertyName();
        if ( isVisible()
                && ( e.getSource() == optionPane )
                && ( JOptionPane.VALUE_PROPERTY.equals ( prop )
                     || JOptionPane.INPUT_VALUE_PROPERTY.equals ( prop ) ) ) {
            Object value = optionPane.getValue();
            if ( value == JOptionPane.UNINITIALIZED_VALUE ) {
                return;
            }
            optionPane.setValue (
                JOptionPane.UNINITIALIZED_VALUE );
            if ( btnString1.equals ( value ) ) {
                typedText = textField.getText();
                String ucText = typedText.toUpperCase();
                if ( magicWord.equals ( ucText ) ) {
                    JOptionPane.showMessageDialog ( this, "Correct answer given" );
                    exit();
                } else {
                    textField.selectAll();
                    JOptionPane.showMessageDialog ( this,
                                                    "Sorry, \"" + typedText + "\" "
                                                    + "isn't a valid response.\n"
                                                    + "Please enter "
                                                    + magicWord + ".",
                                                    "Try again",
                                                    JOptionPane.ERROR_MESSAGE );
                    typedText = null;
                    textField.requestFocusInWindow();
                }
            } else {
                JOptionPane.showMessageDialog ( this, "It's OK.  "
                                                + "We won't force you to type "
                                                + magicWord + "." );
                typedText = null;
                exit();
            }
        }
    }
    public void exit() {
        dispose();
    }
    public static void main ( String... args ) {
        SwingUtilities.invokeLater ( new Runnable() {
            @Override
            public void run() {
                new CustomDialog ( null, "David" ).setVisible ( true );
            }
        } );
    }
}
