import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import javax.swing.JFrame;
import javax.swing.JPanel;
public class JFrameSizeAfterDrag extends JFrame {
    private int w = 0, h = 0, direction, startX = 0, startY = 0;
    public JFrameSizeAfterDrag() {
        setResizable ( false );
        setDefaultCloseOperation ( EXIT_ON_CLOSE );
        addMouseListener ( new MouseAdapter() {
            @Override
            public void mousePressed ( MouseEvent me ) {
                super.mouseClicked ( me );
                startX = me.getX();
                startY = me.getY();
                System.out.println ( "Clicked: " + startX + "," + startY );
            }
            @Override
            public void mouseReleased ( MouseEvent me ) {
                super.mouseReleased ( me );
                System.out.println ( "Mouse released" );
                if ( direction == 1 || direction == 2 || direction == 5 || direction == 6 ) {
                    setSize ( w, h );
                } else {
                    setBounds ( getX() - ( startX - me.getX() ), getY() - ( startY - me.getY() ), w, h );
                }
                validate();
            }
        } );
        addMouseMotionListener ( new MouseAdapter() {
            private boolean canResize;
            @Override
            public void mouseDragged ( MouseEvent me ) {
                super.mouseDragged ( me );
                System.out.println ( "Dragging:" + me.getX() + "," + me.getY() );
                if ( canResize && direction == 1 ) {
                    if ( startY > me.getY() ) {
                        h -= 4;
                    } else {
                        h += 4;
                    }
                } else if ( canResize && direction == 2 ) {
                    if ( startX > me.getX() ) {
                        w -= 4;
                    } else {
                        w += 4;
                    }
                } else if ( canResize && direction == 3 ) {
                    if ( startX > me.getX() ) {
                        w += 4;
                    } else {
                        w -= 4;
                    }
                } else if ( canResize && direction == 4 ) {
                    if ( startY > me.getY() ) {
                        h += 4;
                    } else {
                        h -= 4;
                    }
                } else if ( canResize && direction == 5 ) {
                    if ( startY > me.getY() && startX > me.getX() ) {
                        h -= 4;
                        w -= 4;
                    } else {
                        h += 4;
                        w += 4;
                    }
                }   else if ( canResize && direction == 7 ) {
                    if ( startY > me.getY() && startX > me.getX() ) {
                        h -= 4;
                        w -= 4;
                    } else {
                        h += 4;
                        w += 4;
                    }
                }
            }
            @Override
            public void mouseMoved ( MouseEvent me ) {
                super.mouseMoved ( me );
                if ( me.getY() >= getHeight() - 10 && me.getX() >= getWidth() - 10 ) {
                    canResize = true;
                    setCursor ( Cursor.getPredefinedCursor ( Cursor.SE_RESIZE_CURSOR ) );
                    direction = 5;
                }   else if ( me.getY() >= getHeight() - 10 && me.getX() <= 10 ) {
                    canResize = true;
                    setCursor ( Cursor.getPredefinedCursor ( Cursor.SW_RESIZE_CURSOR ) );
                    direction = 7;
                } else if ( me.getY() >= getHeight() - 10 ) {
                    canResize = true;
                    setCursor ( Cursor.getPredefinedCursor ( Cursor.S_RESIZE_CURSOR ) );
                    direction = 1;
                } else if ( me.getX() >= getWidth() - 10 ) {
                    canResize = true;
                    setCursor ( Cursor.getPredefinedCursor ( Cursor.E_RESIZE_CURSOR ) );
                    direction = 2;
                } else if ( me.getX() <= 10 ) {
                    canResize = true;
                    setCursor ( Cursor.getPredefinedCursor ( Cursor.W_RESIZE_CURSOR ) );
                    direction = 3;
                } else if ( me.getY() <= 28 ) {
                    canResize = true;
                    setCursor ( Cursor.getPredefinedCursor ( Cursor.N_RESIZE_CURSOR ) );
                    direction = 4;
                } else {
                    canResize = false;
                    setCursor ( Cursor.getPredefinedCursor ( Cursor.DEFAULT_CURSOR ) );
                }
            }
        } );
        add ( new JPanel() {
            @Override
            public Dimension getPreferredSize() {
                return new Dimension ( 200, 200 );
            }
        } );
        pack();
        setVisible ( true );
    }
    @Override
    public void setVisible ( boolean bln ) {
        super.setVisible ( bln );
        w = getWidth();
        h = getHeight();
    }
    public static void main ( String[] args ) {
        javax.swing.SwingUtilities.invokeLater ( new Runnable() {
            @Override
            public void run() {
                new JFrameSizeAfterDrag();
            }
        } );
    }
}
