public enum EventType {
    START,
    END;
}
public class EventPoint implements Comparable<EventPoint> {
    public EventType type;
    public double x;
    public Circle circle;
    public Interval interval;
    public EventPoint ( EventType type, double x,
                        Circle circle, Interval interval ) {
        this.type = type;
        this.x = x;
        this.circle = circle;
        this.interval = interval;
    }
    public int compareTo ( EventPoint other ) {
        return Double.compare ( x, other.x );
    }
    public static EventPoint start ( double x, Circle circle ) {
        return new EventPoint ( START, x, circle, null );
    }
    public static EventPoint end ( double x, Interval interval ) {
        return new EventPoint ( END, x, null, interval );
    }
}
