PriorityQueue<EventPoint> events = new PriorityQueue<EventPoint>();
BinarySearchTree<Interval> intervalTree = new BinarySearchTree<Interval>();
for ( Circle c : circles ) {
    events.add ( EventPoint.start ( c.x, c ) );
}
while ( !events.isEmpty() ) {
    EventPoint ep = events.poll();
    switch ( ep.type ) {
    case START:
        Circle current = ep.circle;
        Interval interval = new Interval ( current.y, current.y +
                                           current.height );
        intervalTree.add ( interval );
        events.add ( EventPoint.end ( current.x + current.width, interval ) );
        break;
    case END:
        intervalTree.remove ( ep.interval );
        break;
    }
}
