public class TestArraySort {
    public static void main ( String[] args ) {
        new TestArraySort();
    }
    public TestArraySort() {
        try {
            File file1 = new File ( "studentNames.txt" );
            File file2 = new File ( "studentScores.txt" );
            if ( file1.exists() && file2.exists() ) {
                Map<Integer, String> mapStudents = new TreeMap<Integer, String>();
                Map<Integer, List<Double>> mapScores = new TreeMap<Integer, List<Double>>();
                Scanner input = null;
                try {
                    input = new Scanner ( file1 );
                    while ( input.hasNext() ) {
                        int id = input.nextInt();
                        String name = input.nextLine().trim();
                        mapStudents.put ( id, name );
                    }
                } finally {
                    input.close();
                }
                try {
                    input = new Scanner ( file2 );
                    while ( input.hasNext() ) {
                        int id = input.nextInt();
                        double score = input.nextDouble();
                        List<Double> scores = mapScores.get ( id );
                        if ( scores == null ) {
                            scores = new ArrayList<Double> ( 25 );
                            mapScores.put ( id, scores );
                        }
                        scores.add ( score );
                    }
                } finally {
                    input.close();
                }
                System.out.println ( "+------------+----------------------+------+" );
                for ( Integer id : mapStudents.keySet() ) {
                    String name = mapStudents.get ( id );
                    System.out.printf ( "| %10d | %-20s | ", id, name );
                    List<Double> scores = mapScores.get ( id );
                    if ( scores.size() > 0 ) {
                        Collections.sort ( scores );
                        Collections.reverse ( scores );
                        System.out.printf ( "%4.1f |\n", scores.get ( 0 ) );
                        for ( int index = 1; index < scores.size(); index++ ) {
                            System.out.printf ( "| %10s | %-20s | %4.1f |\n", "", "", scores.get ( index ) );
                        }
                    } else {
                        System.out.println ( "00.0 |" );
                    }
                    System.out.println ( "+------------+----------------------+------+" );
                }
            }
        } catch ( IOException exp ) {
            exp.printStackTrace();
        }
    }
}
