public static void readWithBuffers() throws Exception {
    FileInputStream fis = new FileInputStream ( FILE );
    FileChannel channel = fis.getChannel();
    CharsetDecoder decoder = Charset.defaultCharset().newDecoder();
    ByteBuffer bbuf = ByteBuffer.allocate ( 4096 );
    CharBuffer cbuf = CharBuffer.allocate ( 4096 );
    for ( ;; ) {
        if ( -1 == channel.read ( bbuf ) ) {
            decoder.decode ( bbuf, cbuf, true );
            decoder.flush ( cbuf );
            break;
        }
        bbuf.flip();
        CoderResult res = decoder.decode ( bbuf, cbuf, false );
        if ( CoderResult.OVERFLOW == res ) {
            cbuf.clear();
        } else if ( CoderResult.UNDERFLOW == res ) {
            bbuf.compact();
        }
    }
    fis.close();
}
