private List<Field> getFields() {
    List<Field> list = new ArrayList<Field>();
    getFields ( list, getClass() );
    return list;
}
private List<Field> getFields ( List<Field> list, Class<?> startClass ) {
    for ( Field field : startClass.getDeclaredFields() ) {
        list.add ( field );
    }
    Class<?> superClass = startClass.getSuperclass();
    if ( !superClass.equals ( Object.class ) ) {
        getFields ( list, superClass );
    }
}
public void setParameters ( Map<String, String> props ) throws IllegalArgumentException, IllegalAccessException {
    for ( Field field : getFields() ) {
        if ( props.containsKey ( field.getName() ) ) {
            boolean prevAccessible = field.isAccessible();
            if ( !prevAccessible ) {
                field.setAccessible ( true );
            }
            field.set ( this, props.get ( field.getName() ) );
            field.setAccessible ( prevAccessible );
        }
    }
}
