public class TestTimerUpdate {
    public static void main ( String[] args ) {
        new TestTimerUpdate();
    }
    public TestTimerUpdate() {
        EventQueue.invokeLater ( new Runnable() {
            @Override
            public void run() {
                try {
                    UIManager.setLookAndFeel ( UIManager.getSystemLookAndFeelClassName() );
                } catch ( ClassNotFoundException ex ) {
                } catch ( InstantiationException ex ) {
                } catch ( IllegalAccessException ex ) {
                } catch ( UnsupportedLookAndFeelException ex ) {
                }
                JFrame frame = new JFrame();
                frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
                frame.setLayout ( new BorderLayout() );
                frame.add ( new TimerPane() );
                frame.pack();
                frame.setLocationRelativeTo ( null );
                frame.setVisible ( true );
            }
        } );
    }
    protected class TimerPane extends JPanel {
        private int updates = 0;
        public TimerPane() {
            Timer timer = new Timer ( 250, new ActionListener() {
                @Override
                public void actionPerformed ( ActionEvent e ) {
                    updates++;
                    repaint();
                }
            } );
            timer.setRepeats ( true );
            timer.setCoalesce ( true );
            timer.start();
        }
        @Override
        public Dimension getPreferredSize() {
            return new Dimension ( 200, 200 );
        }
        @Override
        protected void paintComponent ( Graphics g ) {
            super.paintComponent ( g );
            Graphics2D g2d = ( Graphics2D ) g.create();
            String text = "I've being updated " + Integer.toString ( updates ) + " times";
            FontMetrics fm = g2d.getFontMetrics();
            int x = ( getWidth() - fm.stringWidth ( text ) ) / 2;
            int y = ( ( getHeight() - fm.getHeight() ) / 2 ) + fm.getAscent();
            g2d.drawString ( text, x, y );
            g2d.dispose();
        }
    }
}
