import java.lang.*;
import java.util.*;
import java.util.regex.*;
class Main {
    public static boolean recursivePalindrome ( String str ) {
        Pattern degeneratePalindrome = Pattern.compile ( "^[^a-z]*[a-z]?[^a-z]*$", Pattern.CASE_INSENSITIVE | Pattern.DOTALL );
        Pattern potentialPalindrome  = Pattern.compile ( "^[^a-z]*([a-z])(.*)\\1[^a-z]*$", Pattern.CASE_INSENSITIVE | Pattern.DOTALL );
        return recursivePalindrome ( str, degeneratePalindrome, potentialPalindrome );
    }
    public static boolean recursivePalindrome ( String str, Pattern d, Pattern p ) {
        if ( d.matcher ( str ).find() ) {
            return true;
        }
        Matcher m = p.matcher ( str );
        if ( !m.find() ) {
            return false;
        }
        return recursivePalindrome ( m.group ( 2 ), d, p );
    }
    public static void main ( String[] args ) throws java.lang.Exception {
        String str1 = "A man, a plan, a canal... Panama!";
        String str2 = "A man, a pan, a canal... Panama!";
        System.out.println ( str1 + " : " + Boolean.toString ( recursivePalindrome ( str1 ) ) );
        System.out.println ( str2 + " : " + Boolean.toString ( recursivePalindrome ( str2 ) ) );
    }
}
