BlockingQueue<Runnable> queue = new ArrayBlockingQueue<Runnable> ( 100 );
ThreadPoolExecutor threadPool =
    new ThreadPoolExecutor ( nThreads, nThreads, 0L, TimeUnit.MILLISECONDS, queue );
threadPool.setRejectedExecutionHandler ( new RejectedExecutionHandler() {
    @Override
    public void rejectedExecution ( Runnable r, ThreadPoolExecutor executor ) {
        try {
            executor.getQueue().put ( r );
        } catch ( InterruptedException e ) {
            throw new RejectedExecutionException (
                "Unexpected InterruptedException", e );
        }
    }
} );
while ( ( String url = urlReader.readLine() ) != null ) {
    threadPool.submit ( new DownloadUrlRunnable ( url ) );
}
threadPool.shutdown();
threadPool.awaitTermination ( Long.MAX_VALUE, TimeUnit.MILLISECONDS );
...
private class DownloadUrlRunnable implements Runnable {
    private final String url;
    public DownloadUrlRunnable ( String url ) {
        this.url = url;
    }
    public void run() {
    }
}
