import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.IOException;
import java.net.URL;
import javax.imageio.ImageIO;
import javax.swing.*;
public class PaintingExample {
    private CustomPanel contentPane;
    private JTextField userField;
    private JPasswordField passField;
    private JButton loginButton;
    private void displayGUI() {
        JFrame frame = new JFrame ( "Painting Example" );
        frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
        contentPane = new CustomPanel();
        frame.setContentPane ( contentPane );
        frame.pack();
        frame.setLocationByPlatform ( true );
        frame.setVisible ( true );
    }
    public static void main ( String... args ) {
        SwingUtilities.invokeLater ( new Runnable() {
            public void run() {
                new PaintingExample().displayGUI();
            }
        } );
    }
}
class CustomPanel extends JPanel {
    private BufferedImage image;
    public CustomPanel() {
        setOpaque ( true );
        setBorder ( BorderFactory.createLineBorder ( Color.BLACK, 5 ) );
        try {
            image = ImageIO.read ( new URL (
                                       "http://gagandeepbali.uk.to/" +
                                       "gaganisonline/images/404error.jpg" ) );
        } catch ( IOException ioe ) {
            System.out.println ( "Unable to fetch image." );
            ioe.printStackTrace();
        }
    }
    @Override
    public Dimension getPreferredSize() {
        return ( new Dimension ( image.getWidth(), image.getHeight() ) );
    }
    @Override
    protected void paintComponent ( Graphics g ) {
        super.paintComponent ( g );
        g.drawImage ( image, 0, 0, this );
    }
}
