Map<String, CountingLock> locksMap = new HashMap<String, CountingLock>();
...
HttpResponse myFunction ( String key ) {
    CountingLock lock;
    synchronized ( locksMap ) {
        lock = locksMap.get ( key );
        if ( lock == null ) {
            lock = new CountingLock();
            locksMap.put ( key, lock );
        }
        lock.prepare();
    }
    lock.lock();
    try {
    } finally {
        synchronized ( locksMap ) {
            if ( lock.unlock() == 0 ) {
                locksMap.remove ( key );
            }
        }
    }
    return SOMETHING;
}
private static class CountingLock {
    private AtomicInteger interestedThreads = new AtomicInteger ( 0 );
    private Lock lock = new ReentrantLock();
    public void prepare() {
        interestedThreads.incrementAndGet();
    }
    public void lock() {
        lock.lock();
    }
    public int unlock() {
        lock.unlock();
        return interestedThreads.decrementAndGet();
    }
}
