public class HeaderListViewFromXML extends ListView {
    private int headerId;
    public HeaderListViewFromXML ( Context context ) {
        super ( context );
    }
    public HeaderListViewFromXML ( Context context, AttributeSet attrs, int defStyle ) {
        super ( context, attrs, defStyle );
    }
    public HeaderListViewFromXML ( Context context, AttributeSet attrs ) {
        super ( context, attrs );
        TypedArray a = context.getTheme().obtainStyledAttributes ( attrs, R.styleable.MyCustomWidget, 0, 0 );
        try {
            headerId = a.getResourceId ( R.styleable.MyCustomWidget_headerView, 0 );
            if ( headerId != 0 ) {
                LayoutInflater inflater = ( LayoutInflater ) context.getSystemService ( Context.LAYOUT_INFLATER_SERVICE );
                View header = inflater.inflate ( headerId, null );
                addHeaderView ( header );
            }
        } finally {
            a.recycle();
        }
    }
}
}
