package chrriis.dj.nativeswing.swtimpl.demo.examples.webbrowser;
import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import javax.swing.BorderFactory;
import javax.swing.JCheckBox;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;
import chrriis.common.UIUtils;
import chrriis.dj.nativeswing.swtimpl.NativeInterface;
import chrriis.dj.nativeswing.swtimpl.components.JWebBrowser;
public class SimpleWebBrowserExample {
    public static JComponent createContent() {
        JPanel contentPane = new JPanel ( new BorderLayout() );
        JPanel webBrowserPanel = new JPanel ( new BorderLayout() );
        webBrowserPanel.setBorder ( BorderFactory.createTitledBorder ( "Native Web Browser component" ) );
        final JWebBrowser webBrowser = new JWebBrowser();
        webBrowser.navigate ( "http://www.browserproperties.com" );
        webBrowserPanel.add ( webBrowser, BorderLayout.CENTER );
        contentPane.add ( webBrowserPanel, BorderLayout.CENTER );
        JPanel buttonPanel = new JPanel ( new FlowLayout ( FlowLayout.CENTER, 4, 4 ) );
        JCheckBox menuBarCheckBox = new JCheckBox ( "Menu Bar", webBrowser.isMenuBarVisible() );
        menuBarCheckBox.addItemListener ( new ItemListener() {
            public void itemStateChanged ( ItemEvent e ) {
                webBrowser.setMenuBarVisible ( e.getStateChange() == ItemEvent.SELECTED );
            }
        } );
        buttonPanel.add ( menuBarCheckBox );
        contentPane.add ( buttonPanel, BorderLayout.SOUTH );
        return contentPane;
    }
    public static void main ( String[] args ) {
        NativeInterface.open();
        UIUtils.setPreferredLookAndFeel();
        SwingUtilities.invokeLater ( new Runnable() {
            public void run() {
                JFrame frame = new JFrame ( "DJ Native Swing Test" );
                frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
                frame.getContentPane().add ( createContent(), BorderLayout.CENTER );
                frame.setSize ( 800, 600 );
                frame.setLocationByPlatform ( true );
                frame.setVisible ( true );
            }
        } );
        NativeInterface.runEventPump();
    }
}
