public abstract class MyClass extends JPanel implements Printable {
    [...]
    public static enum Alignment {RIGHT, LEFT, CENTER};
    [...]
    protected float drawParagraph ( Graphics2D g2, String text, float width, float x, float y, Alignment alignment ) {
        AttributedString attstring = new AttributedString ( text );
        attstring.addAttribute ( TextAttribute.FONT, font );
        AttributedCharacterIterator paragraph = attstring.getIterator();
        int paragraphStart = paragraph.getBeginIndex();
        int paragraphEnd = paragraph.getEndIndex();
        FontRenderContext frc = g2.getFontRenderContext();
        LineBreakMeasurer lineMeasurer = new LineBreakMeasurer ( paragraph, frc );
        float breakWidth = width;
        float drawPosY = y;
        lineMeasurer.setPosition ( paragraphStart );
        while ( lineMeasurer.getPosition() < paragraphEnd ) {
            TextLayout layout = lineMeasurer.nextLayout ( breakWidth );
            float drawPosX;
            switch ( alignment ) {
            case RIGHT:
                drawPosX = ( float ) x + breakWidth - layout.getAdvance();
                break;
            case CENTER:
                drawPosX = ( float ) x + ( breakWidth - layout.getAdvance() ) / 2;
                break;
            default:
                drawPosX = ( float ) x;
            }
            drawPosY += layout.getAscent();
            layout.draw ( g2, drawPosX, drawPosY );
            drawPosY += layout.getDescent() + layout.getLeading();
        }
        return drawPosY;
    }
}
