public class MyStreamSocket {
    private Socket socket;
    private DataInputStream input;
    private DataOutputStream output;
    MyStreamSocket ( InetAddress acceptorHost, int acceptorPort )
    throws SocketException, IOException {
        socket = new Socket ( acceptorHost, acceptorPort );
        setStreams();
    }
    MyStreamSocket ( Socket socket ) throws IOException {
        this.socket = socket;
        setStreams();
    }
    private void setStreams() throws IOException {
        input = new DataInputStream ( socket.getInputStream() );
        output = new DataOutputStream ( socket.getOutputStream() );
    }
    public void sendMessage ( String message ) throws IOException {
        output.writeUTF ( message );
        output.flush();
    }
    public String receiveMessage() throws IOException {
        String message = input.readUTF();
        return message;
    }
    public void close() throws IOException {
        socket.close();
    }
    public void sendFile ( File file ) throws IOException {
        FileInputStream fileIn = new FileInputStream ( file );
        byte[] buf = new byte[Short.MAX_VALUE];
        int bytesRead;
        while ( ( bytesRead = fileIn.read ( buf ) ) != -1 ) {
            output.writeShort ( bytesRead );
            output.write ( buf, 0, bytesRead );
        }
        output.writeShort ( -1 );
        fileIn.close();
    }
    public void receiveFile ( File file ) throws IOException {
        FileOutputStream fileOut = new FileOutputStream ( file );
        byte[] buf = new byte[Short.MAX_VALUE];
        int bytesSent;
        while ( ( bytesSent = input.readShort() ) != -1 ) {
            input.readFully ( buf, 0, bytesSent );
            fileOut.write ( buf, 0, bytesSent );
        }
        fileOut.close();
    }
}
