public static class Range implements Comparable<Range> {
    int start;
    int end;
    public int compareTo ( Range other ) {
        if ( start < other.start ) {
            return -1;
        }
        if ( start > other.start ) {
            return 1;
        }
        if ( end < other.end ) {
            return -1;
        }
        if ( end > other.end ) {
            return 1;
        }
        return 0;
    }
}
public int[] remove ( int[] original, List<Range> toRemove, boolean compact ) {
    int[] a;
    if ( compact ) {
        a = original;
    } else {
        int len = 0;
        for ( Range range : toRemove ) {
            len += range.end - range.start;
        }
        a = new int[original.length - len];
    }
    int nextSource = 0;
    int nextDest = 0;
    for ( Range range : toRemove ) {
        if ( nextSource < range.start ) {
            System.arraycopy ( original, nextSource, a, nextDest,
                               range.start - nextSource );
            nextDest += range.start - nextSource;
            nextSource = range.start;
        }
        nextSource = range.end;
    }
    if ( nextSource < original.length ) {
        System.arraycopy ( original, nextSource, a, nextDest,
                           original.length - nextSource );
    }
    return a;
}
