private void configureImageViews() {
    String path = externalDirectory() + File.separatorChar
                  + "sushi_plate_tokyo_20091119.png";
    ImageView fullImageView = ( ImageView ) findViewById ( R.id.fullImageView );
    ImageView bitmapRegionImageView = ( ImageView ) findViewById ( R.id.bitmapRegionImageView );
    Bitmap fullBitmap = null;
    Bitmap regionBitmap = null;
    try {
        BitmapRegionDecoder bitmapRegionDecoder = BitmapRegionDecoder
                .newInstance ( path, false );
        int fullWidth = bitmapRegionDecoder.getWidth();
        int fullHeight = bitmapRegionDecoder.getHeight();
        Rect fullRect = new Rect ( 0, 0, fullWidth, fullHeight );
        fullBitmap = bitmapRegionDecoder.decodeRegion ( fullRect, null );
        Rect regionRect = new Rect ( 275, 545, 965, 1025 );
        regionBitmap = bitmapRegionDecoder.decodeRegion ( regionRect, null );
    } catch ( IOException e ) {
        e.printStackTrace();
    }
    fullImageView.setImageBitmap ( fullBitmap );
    bitmapRegionImageView.setImageBitmap ( regionBitmap );
}
public static String externalDirectory() {
    File file = Environment.getExternalStorageDirectory();
    return file.getAbsolutePath();
}
