private TreeModelSupport support;
public ItemTreeModel ( MyNode root ) {
    this.root = root;
    support = new TreeModelSupport ( this );
}
public void addTreeModelListener ( TreeModelListener l ) {
    support.addTreeModelListener ( l );
}
public void insertNodeInto ( final MyNode newNode, final MyNode selNode,
                             final int childCount ) {
    selNode.add ( childCount, newNode );
    newNode.setLocation ( selNode );
    support.fireChildAdded ( new TreePath ( getPathToRoot ( selNode ) ),
                             childCount, newNode );
}
public MyNode[] getPathToRoot ( MyNode node ) {
    ArrayList<MyNode> itemArrayList = new ArrayList<MyNode>();
    while ( ( node != null ) ) {
        itemArrayList.add ( 0, node );
        node = node.getLocation();
    }
    return itemArrayList
           .toArray ( new MyNode[itemArrayList.size()] );
}
