public class Player extends VideoView implements OnPreparedListener, OnCompletionListener, OnErrorListener {
    private MediaPlayer mediaPlayer;
    public Player ( Context context, AttributeSet attributes ) {
        super ( context, attributes );
        this.setOnPreparedListener ( this );
        this.setOnCompletionListener ( this );
        this.setOnErrorListener ( this );
    }
    @Override
    public void onPrepared ( MediaPlayer mediaPlayer ) {
        this.mediaPlayer = mediaPlayer;
    }
    @Override
    public boolean onError ( MediaPlayer mediaPlayer, int what, int extra ) {
        ...
    }
    @Override
    public void onCompletion ( MediaPlayer mediaPlayer ) {
        ...
    }
    public void mute() {
        this.setVolume ( 0 );
    }
    public void unmute() {
        this.setVolume ( 100 );
    }
    private void setVolume ( int amount ) {
        final int max = 100;
        final double numerator = max - amount > 0 ? Math.log ( max - amount ) : 0;
        final float volume = ( float ) ( 1 - ( numerator / Math.log ( max ) ) );
        this.mediaPlayer.setVolume ( volume, volume );
    }
}
