package ravi.tutorial.java.threads;
public class TestThreads {
    public static void main ( String[] args ) {
        CommonLock commonLock = new CommonLock();
        Thread1 thread1 = new Thread1 ( commonLock );
        Thread2 thread2 = new Thread2 ( commonLock );
        thread1.start();
        thread2.start();
    }
}
class CommonLock {
}
class Thread1 extends Thread {
    private CommonLock commonLock;
    public Thread1 ( CommonLock commonLock ) {
        this.commonLock = commonLock;
    }
    public void run() {
        System.out.println ( "Started thread 1" );
        System.out.println ( "waiting thread 1" );
        try {
            synchronized ( commonLock ) {
                commonLock.wait();
            }
        } catch ( InterruptedException e ) {
            e.printStackTrace();
        }
        System.out.println ( "DONE waiting thread 1 as I got notification from THread 2" );
    }
}
class Thread2 extends Thread {
    private CommonLock commonLock;
    public Thread2 ( CommonLock commonLock ) {
        this.commonLock = commonLock;
    }
    public void run() {
        System.out.println ( "Running thread 2" );
        try {
            System.out.println ( "Sleeping thread 2" );
            Thread.sleep ( 2000 );
            synchronized ( commonLock ) {
                System.out.println ( "Notifying thread 2" );
                commonLock.notifyAll();
            }
        } catch ( InterruptedException e ) {
            e.printStackTrace();
        }
    }
}
