public class MoveToText {
    public static void main ( String[] args ) {
        new MoveToText();
    }
    public MoveToText() {
        EventQueue.invokeLater ( new Runnable() {
            @Override
            public void run() {
                try {
                    UIManager.setLookAndFeel ( UIManager.getSystemLookAndFeelClassName() );
                } catch ( ClassNotFoundException | InstantiationException | IllegalAccessException | UnsupportedLookAndFeelException ex ) {
                }
                JFrame frame = new JFrame ( "Testing" );
                frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
                frame.setLayout ( new BorderLayout() );
                frame.add ( new FindTextPane() );
                frame.setSize ( 400, 400 );
                frame.setLocationRelativeTo ( null );
                frame.setVisible ( true );
            }
        } );
    }
    public class FindTextPane extends JPanel {
        private JTextField findField;
        private JButton findButton;
        private JTextArea textArea;
        private int pos = 0;
        public FindTextPane() {
            setLayout ( new BorderLayout() );
            findButton = new JButton ( "Next" );
            findField = new JTextField ( "Java", 10 );
            textArea = new JTextArea();
            textArea.setWrapStyleWord ( true );
            textArea.setLineWrap ( true );
            Reader reader = null;
            try {
                reader = new FileReader ( new File ( "Java.txt" ) );
                textArea.read ( reader, null );
            } catch ( Exception e ) {
                e.printStackTrace();
            } finally {
                try {
                    reader.close();
                } catch ( Exception e ) {
                }
            }
            JPanel header = new JPanel ( new GridBagLayout() );
            GridBagConstraints gbc = new GridBagConstraints();
            gbc.gridx = 0;
            gbc.gridy = 0;
            gbc.anchor = GridBagConstraints.WEST;
            header.add ( findField, gbc );
            gbc.gridx++;
            header.add ( findButton, gbc );
            add ( header, BorderLayout.NORTH );
            add ( new JScrollPane ( textArea ) );
            findButton.addActionListener ( new ActionListener() {
                @Override
                public void actionPerformed ( ActionEvent e ) {
                    String find = findField.getText().toLowerCase();
                    textArea.requestFocusInWindow();
                    if ( find != null && find.length() > 0 ) {
                        Document document = textArea.getDocument();
                        int findLength = find.length();
                        try {
                            boolean found = false;
                            if ( pos + findLength > document.getLength() ) {
                                pos = 0;
                            }
                            while ( pos + findLength <= document.getLength() ) {
                                String match = document.getText ( pos, findLength ).toLowerCase();
                                if ( match.equals ( find ) ) {
                                    found = true;
                                    break;
                                }
                                pos++;
                            }
                            if ( found ) {
                                Rectangle viewRect = textArea.modelToView ( pos );
                                textArea.scrollRectToVisible ( viewRect );
                                textArea.setCaretPosition ( pos + findLength );
                                textArea.moveCaretPosition ( pos );
                                pos += findLength;
                            }
                        } catch ( Exception exp ) {
                            exp.printStackTrace();
                        }
                    }
                }
            } );
        }
    }
}
