package com.example.aop.attributes;
import java.util.Calendar;
import javax.persistence.Column;
import javax.persistence.PrePersist;
import javax.persistence.PreUpdate;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.validation.constraints.NotNull;
public interface Timestamped {
    public Calendar getCreationTimestamp();
    public void setCreationTimestamp ( Calendar creationTimestamp );
    public Calendar getModificationTimestamp();
    public void setModificationTimestamp ( Calendar modificationTimestamp );
    static aspect Impl {
        @NotNull
        @Temporal ( TemporalType.TIMESTAMP )
        @Column ( name = "created", nullable = false )
        private Calendar Timestamped.creationTimestamp = Calendar.getInstance();
        @NotNull
        @Temporal ( TemporalType.TIMESTAMP )
        @Column ( name = "last_modified", nullable = false )
        private Calendar Timestamped.modificationTimestamp = Calendar.getInstance();
        public Calendar Timestamped.getCreationTimestamp() {
            return this.creationTimestamp;
        }
        public void Timestamped.setCreationTimestamp ( Calendar creationTimestamp ) {
            this.creationTimestamp = creationTimestamp;
        }
        public Calendar Timestamped.getModificationTimestamp() {
            return this.modificationTimestamp;
        }
        public void Timestamped.setModificationTimestamp ( Calendar modificationTimestamp ) {
            this.modificationTimestamp = modificationTimestamp;
        }
        @PrePersist
        @PreUpdate
        private void Timestamped.updateModificationTimestampDuringPrePersistAndPreUpdate() {
            this.modificationTimestamp = Calendar.getInstance();
        }
    }
}
