public class Demo {
    private final Map<String, Double> suffixFrequencies =
        new TreeMap<String, Double>();
    private String getRandomSuffix() {
        final double value = Math.random();
        double accum = 0.0;
        for ( final Map.Entry<String, Double> e : suffixFrequencies.entrySet() ) {
            accum += e.getValue();
            if ( accum > value ) {
                return e.getKey();
            }
        }
        throw new AssertionError();
    }
    public static void main ( final String... args ) {
        final Demo demo = new Demo();
        demo.suffixFrequencies.put ( "abc", 0.3 );
        demo.suffixFrequencies.put ( "def", 0.2 );
        demo.suffixFrequencies.put ( "ghi", 0.5 );
        for ( int i = 0; i < 10; ++i ) {
            System.out.println ( demo.getRandomSuffix() );
        }
    }
}
