public class MySpecialTemplate extends SqlMapDaoTemplate {
    ...
    public void queryWithRowHandler ( String id,
                                      final MySpecialRowHandler myRowHandler
                                    ) throws DataException, FileException, WhateverException {
        final Set<Exception> holder = new HashSet<Exception>();
        this.queryWithRowHandler ( id, new RowHandler() {
            public void handleRow ( Object row ) {
                try {
                    myRowHandler.handleRow ( row );
                } catch ( Exception e ) {
                    holder.add ( e );
                }
            }
        } );
        if ( !holder.isEmpty() ) {
            Exception e = holder.iterator().next();
            if ( e instanceof DataException ) {
                throw ( DataException ) e;
            }
            if ( e instanceof FileException ) {
                throw ( FileException ) e;
            }
            if ( e instanceof WhateverException ) {
                throw ( WhateverException ) e;
            }
            throw ( RuntimeException ) e;
        }
    }
}
