CreateTarGZ() throws FileNotFoundException, IOException {
    try {
        System.out.println ( new File ( "." ).getAbsolutePath() );
        dirPath = "parent/childDirToCompress/";
        tarGzPath = "archive.tar";
        fOut = new FileOutputStream ( new File ( tarGzPath ) );
        bOut = new BufferedOutputStream ( fOut );
        gzOut = new GzipCompressorOutputStream ( bOut );
        tOut = new TarArchiveOutputStream ( gzOut );
        addFileToTarGz ( tOut, dirPath, "" );
    } finally {
        tOut.finish();
        tOut.close();
        gzOut.close();
        bOut.close();
        fOut.close();
    }
}
private void addFileToTarGz ( TarArchiveOutputStream tOut, String path, String base ) throws IOException {
    File f = new File ( path );
    System.out.println ( f.exists() );
    String entryName = base + f.getName();
    TarArchiveEntry tarEntry = new TarArchiveEntry ( f, entryName );
    tOut.putArchiveEntry ( tarEntry );
    if ( f.isFile() ) {
        IOUtils.copy ( new FileInputStream ( f ), tOut );
        tOut.closeArchiveEntry();
    } else {
        tOut.closeArchiveEntry();
        File[] children = f.listFiles();
        if ( children != null ) {
            for ( File child : children ) {
                System.out.println ( child.getName() );
                addFileToTarGz ( tOut, child.getAbsolutePath(), entryName + "/" );
            }
        }
    }
}
