public class TestPaintSpinner {
    public static void main ( String[] args ) {
        new TestPaintSpinner();
    }
    public TestPaintSpinner() {
        EventQueue.invokeLater ( new Runnable() {
            @Override
            public void run() {
                try {
                    UIManager.setLookAndFeel ( UIManager.getSystemLookAndFeelClassName() );
                } catch ( ClassNotFoundException | InstantiationException | IllegalAccessException | UnsupportedLookAndFeelException ex ) {
                }
                JFrame frame = new JFrame();
                frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
                frame.setLayout ( new BorderLayout() );
                frame.add ( new TestPane() );
                frame.pack();
                frame.setLocationRelativeTo ( null );
                frame.setVisible ( true );
            }
        } );
    }
    public class TestPane extends JPanel {
        public TestPane() {
            setDoubleBuffered ( true );
            setLayout ( new GridBagLayout() );
            add ( new JSpinner ( new SpinnerNumberModel ( 0, 0, Integer.MAX_VALUE, 1 ) ) );
            JPanel panel = new JPanel();
            panel.add ( new JLabel ( "Subpanel" ) );
            add ( panel );
        }
        @Override
        protected void paintComponent ( Graphics g ) {
            super.paintComponent ( g );
            Graphics2D g2d = ( Graphics2D ) g;
            Point2D sPoint = new Point2D.Float ( 0, 0 );
            Point2D ePoint = new Point2D.Float ( this.getWidth(), this.getHeight() );
            g2d.setRenderingHint (
                RenderingHints.KEY_TEXT_ANTIALIASING,
                RenderingHints.VALUE_TEXT_ANTIALIAS_ON );
        }
    }
}
