protected void onPostExecute ( String file_url ) {
    pDialog.dismiss();
    runOnUiThread ( new Runnable() {
        public void run() {
            String status = nearPlaces.status;
            if ( status.equals ( "OK" ) ) {
                if ( nearPlaces.results != null ) {
                    for ( Place p : nearPlaces.results ) {
                        HashMap<String, String> map = new HashMap<String, String>();
                        map.put ( KEY_REFERENCE, p.reference );
                        map.put ( KEY_NAME, p.name );
                        placesListItems.add ( map );
                    }
                    ListAdapter adapter = new SimpleAdapter ( MainActivity.this, placesListItems,
                            R.layout.list_item,
                            new String[] { KEY_REFERENCE, KEY_NAME}, new int[] {
                                R.id.reference, R.id.name
                            } );
                    lv.setAdapter ( adapter );
                }
            } else if ( status.equals ( "ZERO_RESULTS" ) ) {
                alert.showAlertDialog ( MainActivity.this, "Near Places",
                                        "Sorry no places found. Try to change the types of places",
                                        false );
            } else if ( status.equals ( "UNKNOWN_ERROR" ) ) {
                alert.showAlertDialog ( MainActivity.this, "Places Error",
                                        "Sorry unknown error occured.",
                                        false );
            } else if ( status.equals ( "OVER_QUERY_LIMIT" ) ) {
                alert.showAlertDialog ( MainActivity.this, "Places Error",
                                        "Sorry query limit to google places is reached",
                                        false );
            } else if ( status.equals ( "REQUEST_DENIED" ) ) {
                alert.showAlertDialog ( MainActivity.this, "Places Error",
                                        "Sorry error occured. Request is denied",
                                        false );
            } else if ( status.equals ( "INVALID_REQUEST" ) ) {
                alert.showAlertDialog ( MainActivity.this, "Places Error",
                                        "Sorry error occured. Invalid Request",
                                        false );
            } else {
                alert.showAlertDialog ( MainActivity.this, "Places Error",
                                        "Sorry error occured.",
                                        false );
            }
        }
    } );
}
