private static SimpleDateFormat fmt = new SimpleDateFormat ( "E" );
public static void main ( String[] args ) throws Exception {
    TreeSet<Integer> daySet = new TreeSet<Integer>();
    for ( String day : "Sun,Mon,Tue,Fri,Sat".split ( "," ) ) {
        daySet.add ( dayOfWeek ( day ) );
    }
    Calendar cal = Calendar.getInstance();
    int today = cal.get ( Calendar.DAY_OF_WEEK );
    cal.set ( Calendar.DAY_OF_WEEK, findNext ( daySet, today ) );
    System.out.println ( fmt.format ( cal.getTime() ) );
}
private static int dayOfWeek ( String day ) {
    Calendar cal = Calendar.getInstance();
    cal.setTime ( fmt.parse ( day, new ParsePosition ( 0 ) ) );
    return cal.get ( Calendar.DAY_OF_WEEK );
}
private static int findNext ( SortedSet<Integer> set, int from ) {
    SortedSet<Integer> tail = set.tailSet ( Integer.valueOf ( from ) );
    return tail.isEmpty() ? set.first() : tail.first();
}
