import java.util.*;
import java.io.*;
public class ToStringSample {
    public static void main ( String [] args )  throws IOException,
        ClassNotFoundException {
        String string = toString ( new SomeClass() );
        System.out.println ( " Encoded serialized version " );
        System.out.println ( string );
        SomeClass some = ( SomeClass ) fromString ( string );
        System.out.println ( "\n\nReconstituted object" );
        System.out.println ( some );
    }
    private static Object fromString ( String s ) throws IOException ,
        ClassNotFoundException {
        byte [] data = Base64Coder.decode ( s );
        ObjectInputStream ois = new ObjectInputStream (
            new ByteArrayInputStream ( data ) );
        Object o  = ois.readObject();
        ois.close();
        return o;
    }
    private static String toString ( Serializable o ) throws IOException {
        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        ObjectOutputStream oos = new ObjectOutputStream ( baos );
        oos.writeObject ( o );
        oos.close();
        return new String ( Base64Coder.encode ( baos.toByteArray() ) );
    }
}
class SomeClass implements Serializable {
    private final static long serialVersionUID = 1;
    int i    = Integer.MAX_VALUE;
    String s = "ABCDEFGHIJKLMNOP";
    Double d = new Double ( -1.0 );
    public String toString() {
        return  "SomeClass instance says: Don't worry, "
                + "I'm healthy. Look, my data is i = " + i
                + ", s = " + s + ", d = " + d;
    }
}
