public class TestResizableFrame {
    public static void main ( String[] args ) {
        new TestResizableFrame();
    }
    public TestResizableFrame() {
        EventQueue.invokeLater ( new Runnable() {
            @Override
            public void run() {
                try {
                    UIManager.setLookAndFeel ( UIManager.getSystemLookAndFeelClassName() );
                } catch ( ClassNotFoundException | InstantiationException | IllegalAccessException | UnsupportedLookAndFeelException ex ) {
                }
                JFrame frame = new JFrame();
                frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
                frame.setLayout ( new BorderLayout() );
                frame.add ( new FixedPane() );
                frame.setResizable ( false );
                frame.pack();
                frame.setLocationRelativeTo ( null );
                frame.setVisible ( true );
            }
        } );
    }
    public class FixedPane extends JPanel {
        @Override
        public Dimension getPreferredSize() {
            return new Dimension ( 200, 200 );
        }
        @Override
        protected void paintComponent ( Graphics g ) {
            super.paintComponent ( g );
            Dimension size = getSize();
            String text = size.width + "x" + size.height;
            FontMetrics fm = g.getFontMetrics();
            int x = ( getWidth() - fm.stringWidth ( text ) ) / 2;
            int y = ( ( getHeight() - fm.getHeight() ) / 2 ) + fm.getAscent();
            g.drawString ( text, x, y );
            g.setColor ( Color.RED );
            g.drawRect ( 0, 0, getWidth() - 1, getHeight() - 1 );
        }
    }
}
