public class HibernateProxyTypeAdapter extends TypeAdapter<HibernateProxy> {
    public static final TypeAdapterFactory FACTORY = new TypeAdapterFactory() {
        @Override
        @SuppressWarnings ( "unchecked" )
        public <T> TypeAdapter<T> create ( Gson gson, TypeToken<T> type ) {
            return ( HibernateProxy.class.isAssignableFrom ( type.getRawType() ) ? ( TypeAdapter<T> ) new HibernateProxyTypeAdapter ( gson ) : null );
        }
    };
    private final Gson context;
    private HibernateProxyTypeAdapter ( Gson context ) {
        this.context = context;
    }
    @Override
    public HibernateProxy read ( JsonReader in ) throws IOException {
        throw new UnsupportedOperationException ( "Not supported" );
    }
    @SuppressWarnings ( {"rawtypes", "unchecked"} )
    @Override
    public void write ( JsonWriter out, HibernateProxy value ) throws IOException {
        if ( value == null ) {
            out.nullValue();
            return;
        }
        Class<?> baseType = Hibernate.getClass ( value );
        TypeAdapter delegate = context.getAdapter ( TypeToken.get ( baseType ) );
        Object unproxiedValue = ( ( HibernateProxy ) value ).getHibernateLazyInitializer()
                                .getImplementation();
        delegate.write ( out, unproxiedValue );
    }
}
