protected void doGet ( HttpServletRequest request, HttpServletResponse response ) throws ServletException, IOException {
    try {
        response.setContentType ( "application/pdf" );
        File xmlfile = new File ( getServletContext().getRealPath ( "/AvtoSolaZ.xml" ) );
        File xsltfile = new File ( getServletContext().getRealPath ( "/AvtoSolaZaposleniXSL.xsl" ) );
        File outDir = new File ( "WebContent" );
        outDir.mkdirs();
        FopFactory fopFactory = FopFactory.newInstance();
        FOUserAgent foUserAgent = fopFactory.newFOUserAgent();
        OutputStream out = response.getOutputStream();
        try {
            Fop fop = fopFactory.newFop ( MimeConstants.MIME_PDF, foUserAgent, out );
            TransformerFactory factory = TransformerFactory.newInstance();
            Transformer transformer = factory
                                      .newTransformer ( new StreamSource ( xsltfile ) );
            transformer.setParameter ( "versionParam", "2.0" );
            Source src = new StreamSource ( xmlfile );
            Result res = new SAXResult ( fop.getDefaultHandler() );
            transformer.transform ( src, res );
        } finally {
            out.close();
        }
    } catch ( Exception e ) {
        e.printStackTrace ( System.err );
        System.exit ( -1 );
    }
}
