package com.test.mian;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import org.apache.commons.cli.AlreadySelectedException;
import org.apache.commons.cli.CommandLine;
import org.apache.commons.cli.CommandLineParser;
import org.apache.commons.cli.GnuParser;
import org.apache.commons.cli.MissingArgumentException;
import org.apache.commons.cli.MissingOptionException;
import org.apache.commons.cli.Option;
import org.apache.commons.cli.Options;
import org.apache.commons.cli.ParseException;
import org.apache.commons.cli.UnrecognizedOptionException;
import org.apache.commons.lang.WordUtils;
public class MianCLIOptions {
    private static MianCLIOptions singletonObj = null;
    private HashMap<String, Object> options = new HashMap<String, Object>();
    private ArrayList<String> arguments = new ArrayList<String>();
    public static MianCLIOptions getopts() {
        if ( singletonObj == null ) {
            throw new IllegalStateException ( "[MianCLIOptions] Command line not yet initialized." );
        }
        return singletonObj;
    }
    public static synchronized void initialize ( Options optsdef, String[] args )
    throws MianCLIOptionsException, UnrecognizedOptionException, MissingArgumentException,
        MissingOptionException, AlreadySelectedException, ParseException {
        if ( singletonObj == null ) {
            singletonObj = new MianCLIOptions ( optsdef, args );
        } else {
            throw new IllegalStateException ( "[MianCLIOptions] Command line already initialized." );
        }
    }
    public Object clone() throws CloneNotSupportedException {
        throw new CloneNotSupportedException();
    }
    public boolean isset ( String opt ) {
        return options.containsKey ( opt );
    }
    public Object getopt ( String opt ) {
        Object rc = null;
        if ( options.containsKey ( opt ) ) {
            rc = options.get ( opt );
        }
        return rc;
    }
    private MianCLIOptions ( Options optsdef, String[] args )
    throws UnrecognizedOptionException, MissingArgumentException,
        MissingOptionException, AlreadySelectedException, ParseException {
        CommandLineParser parser = new GnuParser();
        CommandLine cmdline = parser.parse ( optsdef, args );
        for ( Option opt : cmdline.getOptions() ) {
            String key = opt.getOpt();
            if ( opt.hasArgs() ) {
                options.put ( key, opt.getValuesList() );
            } else {
                options.put ( key, opt.getValue() );
            }
        }
        for ( String str : cmdline.getArgs() ) {
            if ( str.length() > 0 ) {
                arguments.add ( str );
            }
        }
    }
}
