public class PrintNumbers {
    public static void main ( String[] args ) {
        new PrintNumbers();
    }
    public PrintNumbers() {
        EventQueue.invokeLater ( new Runnable() {
            @Override
            public void run() {
                try {
                    UIManager.setLookAndFeel ( UIManager.getSystemLookAndFeelClassName() );
                } catch ( ClassNotFoundException | InstantiationException | IllegalAccessException | UnsupportedLookAndFeelException ex ) {
                }
                JFrame frame = new JFrame();
                frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
                frame.setLayout ( new BorderLayout() );
                frame.add ( new PrintPane() );
                frame.pack();
                frame.setLocationRelativeTo ( null );
                frame.setVisible ( true );
            }
        } );
    }
    public class PrintPane extends JPanel {
        private int printX;
        private int printY;
        public PrintPane() {
            Timer timer = new Timer ( 500, new ActionListener() {
                @Override
                public void actionPerformed ( ActionEvent e ) {
                    printX = ( int ) Math.round ( Math.random() * 1000 );
                    printY = ( int ) Math.round ( Math.random() * 1000 );
                    repaint();
                }
            } );
            timer.setRepeats ( true );
            timer.setCoalesce ( true );
            timer.start();
        }
        @Override
        public Dimension getPreferredSize() {
            return new Dimension ( 100, 100 );
        }
        @Override
        protected void paintComponent ( Graphics g ) {
            super.paintComponent ( g );
            int width = getWidth() - 1;
            int height = getHeight() - 1;
            FontMetrics fm = g.getFontMetrics();
            String text = printX + "x" + printY;
            int x = ( width - fm.stringWidth ( text ) ) / 2;
            int y = ( ( height - fm.getHeight() ) / 2 ) + fm.getAscent();
            g.drawString ( text, x, y );
        }
    }
}
