public static ADBBean castADBBean ( ADBBean inputADBBean, String parentLocationOfSourceClass ) throws Exception {
    Class clazz = CallbackResponsePoolClient.getClassForParentLocation ( inputADBBean, parentLocationOfSourceClass );
    ADBBean outputADBBean = CallbackResponsePoolClient.getInstanceForADBBean ( clazz );
    for ( Method method : outputADBBean.getClass().getMethods() ) {
        String methodName = method.getName();
        if ( methodName.startsWith ( "set" ) ) {
            CallbackResponsePoolClient.logger.debug ( "Found a setter: " + methodName );
            String getterName = methodName.replaceFirst ( "set", "get" );
            Object arg = inputADBBean.getClass().getMethod ( getterName ).invoke ( inputADBBean );
            if ( arg instanceof ADBBean ) {
                arg = CallbackResponsePoolClient.castADBBean ( ( ADBBean ) arg, parentLocationOfSourceClass );
            }
            if ( arg instanceof ADBBean[] ) {
                Class innputClass = ( ( ADBBean[] ) arg ).getClass().getComponentType();
                ADBBean inputArrObj = CallbackResponsePoolClient.getInstanceForADBBean ( innputClass );
                Class outputArrClass = CallbackResponsePoolClient.getClassForParentLocation ( inputArrObj, parentLocationOfSourceClass );
                Object outputArray = Array.newInstance ( outputArrClass, ( ( ADBBean[] ) arg ).length );
                for ( int i = 0; i < Array.getLength ( arg ); i++ ) {
                    Array.set ( outputArray, i, CallbackResponsePoolClient.castADBBean ( ( ADBBean ) Array.get ( arg, i ), parentLocationOfSourceClass ) );
                }
                arg = outputArray;
            }
            method.invoke ( outputADBBean, arg );
        }
    }
    return outputADBBean;
}
private static Class getClassForParentLocation ( ADBBean inputADBBean, String parentLocationOfSourceClass ) throws ClassNotFoundException {
    return Class.forName ( parentLocationOfSourceClass + "$" + inputADBBean.getClass().getSimpleName() );
}
private static ADBBean getInstanceForADBBean ( Class clazz ) throws NoSuchMethodException, SecurityException, InstantiationException, IllegalAccessException, IllegalArgumentException, InvocationTargetException {
    Constructor constructor = clazz.getConstructor();
    return ( ADBBean ) constructor.newInstance();
}
