package com.mycompany.types;
import java.io.StringReader;
import java.io.StringWriter;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.Unmarshaller;
import javax.xml.bind.annotation.XmlTransient;
@XmlTransient
public final class Utility {
    static {
        try {
            JAXB_CONTEXT = JAXBContext.newInstance ( TestClass.class );
        } catch ( Exception e ) {
            throw new ExceptionInInitializerError ( e );
        }
    }
    private Utility() {
    }
    public static TestClass parseTestClass ( String xml ) throws JAXBException {
        Unmarshaller unmarshaller = JAXB_CONTEXT.createUnmarshaller();
        return ( TestClass ) unmarshaller.unmarshal ( new StringReader ( xml ) );
    }
    public static String printTestClass ( TestClass testClass ) throws JAXBException {
        Marshaller marshaller = JAXB_CONTEXT.createMarshaller();
        marshaller.setProperty ( Marshaller.JAXB_FORMATTED_OUTPUT, true );
        StringWriter writer = new StringWriter();
        marshaller.marshal ( testClass, writer );
        return writer.toString();
    }
    private static final JAXBContext JAXB_CONTEXT;
}
