public class MyEventQueue extends EventQueue {
    protected void dispatchEvent ( AWTEvent event ) {
        super.dispatchEvent ( event );
        if ( ! ( event instanceof MouseEvent ) ) {
            return;
        }
        MouseEvent me = ( MouseEvent ) event;
        if ( !me.isPopupTrigger() ) {
            return;
        }
        Component comp = SwingUtilities.getDeepestComponentAt ( me.getComponent(), me.getX(), me.getY() );
        if ( ! ( comp instanceof JTextComponent ) ) {
            return;
        }
        if ( MenuSelectionManager.defaultManager().getSelectedPath().length > 0 ) {
            return;
        }
        JTextComponent tc = ( JTextComponent ) comp;
        JPopupMenu menu = new JPopupMenu();
        menu.add ( new CutAction ( tc ) );
        menu.add ( new CopyAction ( tc ) );
        menu.add ( new PasteAction ( tc ) );
        menu.add ( new DeleteAction ( tc ) );
        menu.addSeparator();
        menu.add ( new SelectAllAction ( tc ) );
        Point pt = SwingUtilities.convertPoint ( me.getComponent(), me.getPoint(), tc );
        menu.show ( tc, pt.x, pt.y );
    }
}
