public class HandlingExceptions {
    private static final String INPUT =
        "name\tage\nTom\t25\nAlice\nJim\t44\nMary\t33\tInvalid";
    public static void main ( String[] args ) throws IOException {
        ICsvListReader listReader = new CsvListReader ( new StringReader ( INPUT ),
                new CsvPreference.Builder ( '"', '\t', "\r\n" ).build() );
        final String[] headers = listReader.getHeader ( true );
        List<String> row = null;
        while ( ( row = listReader.read() ) != null ) {
            if ( listReader.length() != headers.length ) {
                System.out.println ( "skipping invalid row: " + row );
                continue;
            }
            Map<String, String> rowMap = new HashMap<String, String>();
            Util.filterListToMap ( rowMap, headers, row );
            System.out.println ( rowMap );
        }
        listReader.close();
    }
}
