public class Test {
    public static void main ( String args[] ) {
        new Test().test();
    }
    public static class EnumIterator implements Iterator<Enum[]> {
        private final Enum[][] enums;
        private final int[] is;
        private int i = 0;
        public EnumIterator ( Enum[]... enums ) {
            this.enums = enums;
            is = new int[enums.length];
            i = enums.length - 1;
        }
        public EnumIterator ( Class<? extends Enum>... classes ) {
            this ( enumsFromClasses ( classes ) );
        }
        private static Enum[][] enumsFromClasses ( Class<? extends Enum>[] classes ) {
            Enum[][] theEnums = new Enum[classes.length][];
            for ( int j = 0; j < classes.length; j++ ) {
                theEnums[j] = classes[j].getEnumConstants();
            }
            return theEnums;
        }
        @Override
        public boolean hasNext() {
            return ( i > 0 || is[0] < enums[0].length );
        }
        @Override
        public Enum[] next() {
            if ( hasNext() ) {
                Enum[] next = new Enum[enums.length];
                for ( int j = 0; j < next.length; j++ ) {
                    next[j] = enums[j][is[j]];
                }
                for ( i = is.length - 1; i > 0 && is[i] == enums[i].length - 1; i-- ) {
                    is[i] = 0;
                }
                is[i] += 1;
                return next;
            } else {
                throw new NoSuchElementException();
            }
        }
        @Override
        public void remove() {
            throw new UnsupportedOperationException ( "Not supported." );
        }
    }
    enum ABC {
        A, B, C;
    }
    enum XY {
        X, Y;
    }
    enum IJ {
        I, J;
    }
    private void test() {
        Iterator<Enum[]> i = new EnumIterator ( ABC.class, XY.class, IJ.class );
        for ( Enum[] e : Iterables.in ( i ) ) {
            System.out.println ( Arrays.toString ( e ) );
        }
    }
}
