public class Iterables {
    public static <T> java.lang.Iterable<T> in ( final Iterator<T> iterator ) {
        assert iterator != null;
        class SingleUseIterable implements java.lang.Iterable<T> {
            private boolean used = false;
            @Override
            public Iterator<T> iterator() {
                if ( used ) {
                    throw new IllegalStateException ( "SingleUseIterable already invoked" );
                }
                used = true;
                return iterator;
            }
        }
        return new SingleUseIterable();
    }
}
