public interface Login extends Remote {
    Session login ( String username, char[] password )
    throws LoginException, RemoteException;
}
public interface Session extends Remote {
    void logout() throws RemoteException;
    void deposit ( ... ) throws RemoteException;
    void withdraw ( ... ) throws RemoteException;
}
public class LoginImpl extends UnicastRemoteObject implements Login {
    public Session login ( String username, char[] password )
    throws LoginException, RemoteException {
        return new SessionImpl ( username );
    }
}
public class SessionImpl extends UnicastRemoteObject implements Session, Unreferenced {
    public void logout() throws RemoteException {
        unexportObject ( this, true );
    }
    public void unreferenced() {
        unexportObject ( this, true );
    }
}
