package org.dchan.orm;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.JTextField;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
public class SoundLevels extends JFrame {
    private JLabel label1, label2, label3, label4;
    private JTextField maxSound;
    private JTextField totalSound;
    private JPanel mpanel;
    private JPanel tpanel;
    private JPanel sliderPanel1;
    private JPanel sliderPanel2;
    private JPanel resetpanel;
    private JSlider slider1;
    private JSlider slider2;
    private JButton resetButton;
    public SoundLevels() {
        setTitle ( "Sound Levels" );
        setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
        resetButton = new JButton ( "Reset" );
        label1 = new JLabel ( "Left:  " );
        label2 = new JLabel ( "Right: " );
        label3 = new JLabel ( "Max:   " );
        label4 = new JLabel ( "Total: " );
        maxSound = new JTextField ( "0", 10 );
        maxSound.setEditable ( false );
        totalSound = new JTextField ( "0", 10 );
        totalSound.setEditable ( false );
        slider1 = new JSlider ( JSlider.HORIZONTAL, 0, 100, 0 );
        slider2 = new JSlider ( JSlider.HORIZONTAL, 0, 100, 0 );
        slider1.addChangeListener ( new SliderListener() );
        slider2.addChangeListener ( new SliderListener() );
        mpanel = new JPanel();
        resetpanel = new JPanel();
        tpanel = new JPanel();
        sliderPanel1 = new JPanel();
        sliderPanel2 = new JPanel();
        mpanel.add ( label1 );
        mpanel.add ( maxSound );
        tpanel.add ( label2 );
        tpanel.add ( totalSound );
        sliderPanel1.add ( label1 );
        sliderPanel1.add ( slider1 );
        sliderPanel2.add ( label2 );
        sliderPanel2.add ( slider2 );
        resetpanel.add ( resetButton );
        setLayout ( new GridLayout ( 1, 5 ) );
        add ( sliderPanel1 );
        add ( sliderPanel2 );
        add ( resetpanel );
        add ( mpanel );
        add ( tpanel );
        pack();
        setVisible ( true );
    }
    private class ResetButtonListener implements ActionListener {
        public void actionPerformed ( ActionEvent e ) {
            slider1.setValue ( 0 );
            slider2.setValue ( 0 );
        }
    }
    private class SliderListener implements ChangeListener {
        public void stateChanged ( ChangeEvent e ) {
            int max = 0;
            int total = 0;
            int slider1Val = slider1.getValue();
            int slider2Val = slider2.getValue();
            if ( slider1Val > slider2Val ) {
                max = slider1Val;
            } else {
                max = slider2Val;
            }
            total = slider2Val + slider1Val;
            totalSound.setText ( Integer.toString ( total ) );
            maxSound.setText ( Integer.toString ( max ) );
        }
    }
    public static void main ( String[] args ) {
        new SoundLevels();
    }
}
