public class IsIntegerPerformanceTest {
    public static boolean isIntegerParseInt ( String str ) {
        try {
            Integer.parseInt ( str );
            return true;
        } catch ( NumberFormatException nfe ) {}
        return false;
    }
    public static boolean isIntegerRegex ( String str ) {
        return str.matches ( "^[0-9]+$" );
    }
    public static void main ( String[] args ) {
        long starttime, endtime;
        int iterations = 1000000;
        starttime = System.currentTimeMillis();
        for ( int i = 0; i < iterations; i++ ) {
            isIntegerParseInt ( "123" );
            isIntegerParseInt ( "not an int" );
            isIntegerParseInt ( "-321" );
        }
        endtime = System.currentTimeMillis();
        System.out.println ( "This operation took " + ( endtime - starttime ) + " ms." );
        starttime = System.currentTimeMillis();
        for ( int i = 0; i < iterations; i++ ) {
            isIntegerRegex ( "123" );
            isIntegerRegex ( "not an int" );
            isIntegerRegex ( "-321" );
        }
        endtime = System.currentTimeMillis();
        System.out.println ( "This operation took " + ( endtime - starttime ) + " ms." );
    }
}
