public static final int SIZE = "IFERROR(".length();
private void replaceIfErrorFormulas ( Sheet pSheet ) {
    for ( Row row : pSheet ) {
        for ( Cell cell : row ) {
            if ( ( cell != null ) &&
                    ( cell.getCellType() == Cell.CELL_TYPE_FORMULA ) &&
                    ( cell.getCellFormula().indexOf ( "IFERROR" ) != -1 ) ) {
                cell.setCellFormula ( buildFormulaString ( cell.getCellFormula() ) );
            }
        }
    }
}
private String buildFormulaString ( String pFormula ) {
    if ( pFormula.indexOf ( "IFERROR" ) == -1 ) {
        return pFormula;
    }
    String[] values = new String[2];
    char[] tokens = pFormula.toCharArray();
    int length = computeLength ( pFormula );
    int iBegin = pFormula.indexOf ( "IFERROR" );
    int iEnd = iBegin + length - 1;
    assert ( iEnd < pFormula.length() );
    int iParam = 0;
    int numPar = 0;
    for ( int i = iBegin; i < ( length + iBegin ) ; i++ ) {
        if ( tokens[i] == '(' ) {
            values[iParam] += tokens[i];
            numPar++;
        } else if ( tokens[i] == ')' ) {
            if ( iParam < 1 ) {
                values[iParam] += tokens[i];
            }
            numPar--;
        } else if ( Character.getType ( tokens[i] ) == Character.MATH_SYMBOL ) {
            values[iParam] += tokens[i];
        } else if ( tokens[i] == ',' ) {
            if ( numPar > 1 ) {
                values[iParam] += tokens[i];
            } else {
                values[iParam++] += ')';
                numPar--;
            }
        } else {
            values[iParam] += tokens[i];
        }
        if ( numPar < 0 && iParam == 1 ) {
            break;
        }
    }
    String value        = values[0];
    String valueIfError = values[1];
    value        = value.substring ( 4 + SIZE - 1 );
    valueIfError = valueIfError.substring ( 4 );
    String newFormula = "IF(ISERROR(" + value + "),"
                        + valueIfError + ","
                        + value + ")";
    String left = pFormula.substring ( 0, iBegin );
    String right = pFormula.substring ( iEnd + 1, pFormula.length() );
    newFormula = left + newFormula + right;
    return buildFormulaString ( newFormula );
}
private int computeLength ( String pFormula ) {
    int length = SIZE;
    int numPar = 1;
    int iStart = pFormula.indexOf ( "IFERROR" );
    char [] tokens = pFormula.toCharArray();
    for ( int i = length + iStart; i < pFormula.length(); i++ ) {
        if ( numPar == 0 ) {
            break;
        }
        if ( tokens[i] == '(' ) {
            numPar++;
        } else if ( tokens[i] == ')' ) {
            numPar--;
        }
        length++;
    }
    return length;
}
