public static Set<String> calculateCallingClasses ( IJavaElement element,
        IJavaSearchScope scope )
throws CoreException {
    SearchEngine engine = new SearchEngine();
    SearchParticipant[] participants =
        new SearchParticipant[] { SearchEngine.getDefaultSearchParticipant() };
    SearchPattern pattern =
        SearchPattern.createPattern ( element, REFERENCES );
    IType enclosingType =
        ( IType ) element.getAncestor ( IJavaElement.TYPE );
    ClientClassCollector collector = new ClientClassCollector ( enclosingType );
    try {
        engine.search ( pattern, participants, scope, collector, null );
    } catch ( Exception e ) {
        System.err.println ( e.toString() + " for " + element.getElementName() );
    }
    Set<String> clients = collector.getResult();
    return clients;
}
