public static String sprintfDouble ( double v, String formatFloat, String formatSci, double thresholdLow,
                                     double thresholdHigh ) {
    if ( v == 0.0 ) {
        return "0.0";
    }
    if ( Double.isInfinite ( v ) || Double.isNaN ( v ) ) {
        return String.format ( formatFloat, v );
    }
    boolean neg = false;
    if ( v < 0 ) {
        v = -v;
        neg = true;
    }
    String e = "";
    String res;
    if ( v > thresholdLow && v < thresholdHigh ) {
        res = String.format ( formatFloat, v );
    } else {
        res = String.format ( formatSci, v );
        int sp = res.indexOf ( 'e' );
        e = res.substring ( sp );
        res = res.substring ( 0, sp );
    }
    if ( res.indexOf ( '.' ) < 0 ) {
        res += ".";
    }
    res = res.replaceAll ( "0+$", "" );
    if ( res.endsWith ( "." ) ) {
        res += "0";
    }
    res += e;
    if ( neg ) {
        res = "-" + res;
    }
    return res;
}
public static String sprintfDouble5 ( double v ) {
    return sprintfDouble ( v, "%.5f", "%.5e", 0.01, 1000000.0 );
}
