import java.util.Collection;
import java.util.Collections;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantReadWriteLock;
public class DepartmentRepository {
    private static final ReentrantReadWriteLock lock =
        new ReentrantReadWriteLock ( true );
    private static Collection<Department> departments = null;
    public Collection<Department> getAllDepartments() {
        Lock read = lock.readLock();
        read.lock();
        try {
            if ( departments == null ) {
                read.unlock();
                Lock write = lock.writeLock();
                write.lock();
                try {
                    if ( departments == null ) {
                        Collection<Department> tmp = ...;
                        departments = Collections.unmodifiableCollection ( tmp );
                    }
                    read.lock();
                } finally {
                    write.unlock();
                }
            }
            return departments;
        } finally {
            read.unlock();
        }
    }
    public void clearCache() {
        Lock write = lock.writeLock();
        write.lock();
        try {
            departments = null;
        } finally {
            write.unlock();
        }
    }
}
