package banking;
public class BankAccount {
    private int balance;
    private final int acctNum;
    private final String name;
    public BankAccount ( String name, int accNo, int bal ) {
        this.name = name;
        this.acctNum = accNo;
        this.balance = bal;
    }
    public void deposit ( int amount ) {
        if ( amount <= 0 ) {
            throw new IllegalArgumentException ( "You cannot deposit zero or less" );
        } else {
            this.balance += amount;
        }
    }
    public void withdraw ( int amount ) {
        if ( amount > balance ) {
            throw new IllegalArgumentException ( "Insufficient Funds" );
        } else if ( amount <= 0 ) {
            throw new IllegalArgumentException ( "You cannot withdraw zero or less" );
        } else {
            balance -= amount;
        }
    }
    public String getName() {
        return name;
    }
    public int getBalance() {
        return balance;
    }
    public int getAcctNum() {
        return acctNum;
    }
    public void display() {
        System.out.println ( "Name:" + name );
        System.out.println ( "Account No:" + acctNum );
        System.out.println ( "Balance:" + balance );
    }
}
