public class EmailTextView extends TextView {
    public EmailTextView ( Context context, AttributeSet attrs ) {
        super ( context, attrs );
    }
    @Override
    protected void onSizeChanged ( int w, int h, int oldw, int oldh ) {
        super.onSizeChanged ( w, h, oldw, oldh );
        int availableWidth = w - getPaddingLeft() - getPaddingRight();
        String text = getText().toString();
        if ( text.contains ( "\n@" ) ) {
            return;
        }
        int position = -1;
        for ( int i = 0; i < text.length(); i++ ) {
            if ( text.charAt ( i ) == '@' ) {
                position = i;
                break;
            }
        }
        if ( position > 0 ) {
            final Paint pnt = getPaint();
            String beforeAt = text.subSequence ( 0, position ).toString();
            String afterAt = text.subSequence ( position + 1, text.length() )
                             .toString();
            final float beforeAtSize = pnt.measureText ( beforeAt );
            final float afterAtSize = pnt.measureText ( afterAt );
            final float atSize = pnt.measureText ( "@" );
            if ( beforeAtSize > availableWidth ) {
                return;
            } else {
                if ( ( beforeAtSize + afterAtSize + atSize ) <= availableWidth ) {
                    return;
                } else {
                    setText ( beforeAt + "\n@" + afterAt );
                }
            }
        }
    }
}
