import java.awt.*;
import javax.swing.*;
import javax.swing.border.EmptyBorder;
public class SizedGUI {
    public static void main ( String[] args ) {
        Runnable r = new Runnable() {
            @Override
            public void run() {
                JPanel gui = new JPanel ( new BorderLayout() );
                gui.setBorder ( new EmptyBorder ( 2, 3, 2, 3 ) );
                gui.add ( new FixedSizeComponent() );
                gui.setBackground ( Color.RED );
                JFrame f = new JFrame ( "Demo" );
                f.add ( gui );
                f.setDefaultCloseOperation ( JFrame.DISPOSE_ON_CLOSE );
                f.setLocationByPlatform ( true );
                f.pack();
                f.setMinimumSize ( f.getSize() );
                f.setVisible ( true );
            }
        };
        SwingUtilities.invokeLater ( r );
    }
}
class FixedSizeComponent extends JPanel {
    @Override
    public Dimension getPreferredSize() {
        return new Dimension ( 400, 100 );
    }
    @Override
    public void paintComponent ( Graphics g ) {
        super.paintComponent ( g );
        int w = getWidth();
        int h = getHeight();
        g.setColor ( Color.BLACK );
        g.drawString ( w + "x" + h, w / 2, h / 2 );
    }
}
