import java.io.Serializable;
import java.util.Arrays;
import java.util.List;
import com.tricode.mrc.ui.web.messages.Messages;
public abstract class AbstractCrudForm<T extends Serializable> {
    private List<T> data;
    public AbstractCrudForm ( List<T> data ) {
        this.data = data;
    }
    protected abstract String getId ( T record );
    public abstract String getUserFriendlyTypeName();
    public abstract int getNumberOfFields();
    public abstract String[] getArrayOfColumnNames();
    protected abstract String getDataAtColumn ( T record, int column );
    public String getDataAt ( int row, int column ) {
        return getDataAtColumn ( data.get ( row ), column );
    }
    protected List<T> getData() {
        return this.data;
    }
    public String getUserFriendlyEditTypeName() {
        return Messages.getString ( "AbstractCrudForm.Edit" ) + getUserFriendlyTypeName();
    }
    public String getUserFriendlySaveTypeName() {
        return Messages.getString ( "AbstractCrudForm.New" ) + getUserFriendlyTypeName();
    }
    public List<String> getColumns() {
        return Arrays.asList ( getArrayOfColumnNames() );
    }
    public String getColumnNameAt ( int position ) {
        return getArrayOfColumnNames() [position];
    }
    public int resultsSize() {
        return data.size();
    }
    public String getId ( int row ) {
        return getId ( data.get ( row ) );
    }
}
