import javax.swing.SwingUtilities;
public aspect ThreadChecking {
    pointcut selection() : execution ( * * ( .. ) );
    pointcut edt() : selection() &&
    ( within ( @EventDispatchThreadOnly * ) ||
    @annotation ( EventDispatchThreadOnly ) );
    pointcut worker() : selection() &&
    ( within ( @WorkerThreadOnly * ) ||
    @annotation ( WorkerThreadOnly ) );
    before() : edt() {
        assert ( SwingUtilities.isEventDispatchThread() );
    }
    before() : worker() {
        assert ( !SwingUtilities.isEventDispatchThread() );
    }
}
