public class ChatPerson {
    private final List<MoveListener> listeners = new ArrayList<MoveListener>();
    private void notifyListeners ( MoveEvent e ) {
        for ( MoveListener l : listeners ) {
            l.onMoveEvent ( e );
        }
    }
    public void addMoveListener ( MoveListener l ) {
        this.listeners.add ( l );
    }
    public void removeMoveListener ( MoveListener l ) {
        this.listeners.remove ( l );
    }
    public void move ( int x, int y ) {
        this.x = x;
        this.y = y;
        this.notifyListeners ( new MoveEvent ( this, x, y ) );
    }
}
