public class Wrapper<V> {
    private Field<V> field;
    private LabelProvider<V> labelProvider;
    public Wrapper ( Field<V> field, LabelProvider<V> labelProvider ) {
        this.field = field;
        this.labelProvider = labelProvider;
    }
    public Wrapper ( LabelField<V> labelField ) {
        this ( labelField, labelField.getLabelProvider() );
    }
    private String getLabel() {
        return this.labelProvider.getLabel ( this.field.getValue() );
    }
    public Field<V> getField() {
        return this.field;
    }
    public V getValue() {
        return this.field.getValue();
    }
}
