@Resource
private TimerService timerService;
@Timeout
public void run() {
    DayPlanning planning = getPlanning();
    Order order = planning.getNextInLine();
    if ( order instanceof Order ) {
        em.merge ( planning );
        List<String> tests = new ArrayList();
        for ( Test test : order.getTests() ) {
            tests.add ( test.getName() );
        }
        TestmachineSender.orderTests ( order.getId(), order.getDomain(), tests );
        timer.schedule ( checker, safetycheckAt() );
    } else {
        timerService.createTimer ( postponeTo(), "postponed timer information" );
    }
}
@PostConstruct
public void init() {
    if ( getPlanning().hasActiveTest() ) {
        timerService.createTimer ( computeDelay(), "timer information" );
    }
}
