using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
namespace FCFS_Console {
    class Program
    {
        static void Main ( string[] args ) {
            string s = Environment.CurrentDirectory.ToString();
            if ( File.Exists ( s + @"\input.txt" ) ) {
                Console.WriteLine ( "File Exists" );
            } else {
                Console.WriteLine ( "File Not Found" );
                Console.WriteLine ( "_________________________________________________________________" );
                return;
            }
            Console.WriteLine ( "_________________________________________________________________" );
            string FileText = File.ReadAllText ( s + @"\input.txt" );
            string[] lines = FileText.Split ( '\n' );
            List<Process> processes = new List<Process>();
            for ( int i = 1; i < lines.Length; i++ ) {
                string[] tabs = lines[i].Split ( '\t' );
                Process x = new Process ( tabs[0], int.Parse ( tabs[1] ), int.Parse ( tabs[2] ), int.Parse ( tabs[3] ) );
                processes.Add ( x );
            }
            Process temp;
            for ( int k = 0; k < processes.Count; k++ ) {
                for ( int i = k + 1; i < processes.Count; i++ ) {
                    if ( processes[k].arrivalTime > processes[i].arrivalTime || ( processes[k].arrivalTime == processes[i].arrivalTime && processes[k].brust > processes[i].brust ) ) {
                        temp = processes[i];
                        processes[i] = processes[k];
                        processes[k] = temp;
                    }
                }
            }
            Console.WriteLine ( "Processes After Sorting" );
            Console.WriteLine ( "_________________________________________________________________" );
            Console.WriteLine ( "Name\tArrival\tBrust\tPriority" );
            for ( int i = 0; i < processes.Count; i++ ) {
                Console.Write ( processes[i].name + "\t" + processes[i].arrivalTime + "\t" + processes[i].brust + "\t" + processes[i].priority );
                Console.WriteLine();
            }
            Console.WriteLine ( "_________________________________________________________________" );
            Console.WriteLine ( "Gantt Chart" );
            Console.WriteLine ( "_________________________________________________________________" );
            int counter = 0;
            for ( int i = 0; i < processes.Count; i++ ) {
                Console.Write ( processes[i].name + "\t" );
                if ( processes[i].arrivalTime < counter ) {
                    printSpaces ( counter );
                } else {
                    printSpaces ( processes[i].arrivalTime );
                    counter = processes[i].arrivalTime;
                }
                printHashes ( processes[i].brust );
                counter += processes[i].brust;
                Console.WriteLine();
            }
            Console.WriteLine ( "_________________________________________________________________" );
            int clock = 0, totalwait = 0, totalturnAround = 0;
            for ( int i = 0; i < processes.Count; i++ ) {
                if ( processes[i].arrivalTime > clock ) {
                    processes[i].start = processes[i].arrivalTime;
                    clock += processes[i].start - processes[i].arrivalTime;
                    clock += processes[i].brust;
                } else {
                    if ( i > 0 ) {
                        processes[i].start = processes[i - 1].end;
                    }
                    clock += processes[i].brust;
                }
                if ( processes[i].start > processes[i].arrivalTime ) {
                    processes[i].wait = processes[i].start - processes[i].arrivalTime;
                } else {
                    processes[i].wait = 0;
                }
                processes[i].end = processes[i].start + processes[i].brust;
                processes[i].turnAround = processes[i].wait + processes[i].brust;
                totalwait += processes[i].wait;
                totalturnAround += processes[i].turnAround;
            }
            Console.WriteLine ( "Name\tArrival\tBrust\tStart\tEnd\tWait\tturnaround" );
            for ( int i = 0; i < processes.Count; i++ ) {
                Console.Write ( processes[i].name + "\t" + processes[i].arrivalTime + "\t" + processes[i].brust + "\t" + processes[i].start + "\t" + processes[i].end + "\t" + processes[i].wait + "\t" + processes[i].turnAround );
                Console.WriteLine();
            }
            double att = 0, awt = 0;
            awt = ( double ) totalwait / ( double ) processes.Count;
            att = ( double ) totalturnAround / ( double ) processes.Count;
            Console.WriteLine ( "A.W.T= " + awt + "\t A.T.T= " + att );
            Console.ReadKey();
        }
        public static void printSpaces ( int counter ) {
            for ( int i = 0; i < counter; i++ ) {
                Console.Write ( " " );
            }
        }
        public static void printHashes ( int brust ) {
            for ( int i = 0; i < brust; i++ ) {
                Console.Write ( "#" );
            }
        }
    }
}
class Process {
    public Process ( string name, int arrivalTime, int brust, int priority ) {
        this.name = name;
        this.arrivalTime = arrivalTime;
        this.brust = brust;
        this.priority = priority;
    }
    public Process() {
    }
    public string name;
    public int arrivalTime;
    public int brust;
    public int priority;
    public int wait;
    public int end;
    public int start;
    public int turnAround;
}
