import java.util.Enumeration;
import javax.swing.JFrame;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
public class PathTest {
    public PathTest() {
        DefaultMutableTreeNode root = new DefaultMutableTreeNode ( "ROOT" );
        DefaultTreeModel model = new DefaultTreeModel ( root );
        JTree tree = new JTree ( model );
        buildTreeFromString ( model, "Node 1/Node 2/Node 3/Node 4" );
        buildTreeFromString ( model, "Node 1/Node 2/Node 3/Node 5" );
        buildTreeFromString ( model, "Node 1/Node 2/Node 3/Node 6" );
        buildTreeFromString ( model, "Node 1/Node 2/Node 4/Node 5" );
        buildTreeFromString ( model, "Node 1/Node 1/Node 3/Node 5" );
        JFrame f = new JFrame();
        f.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
        f.add ( tree );
        f.setSize ( 300, 300 );
        f.setLocation ( 200, 200 );
        f.setVisible ( true );
    }
    private void buildTreeFromString ( final DefaultTreeModel model, final String str ) {
        DefaultMutableTreeNode root = ( DefaultMutableTreeNode ) model.getRoot();
        String [] strings = str.split ( "/" );
        DefaultMutableTreeNode node = root;
        for ( String s : strings ) {
            int index = childIndex ( node, s );
            if ( index < 0 ) {
                DefaultMutableTreeNode newChild = new DefaultMutableTreeNode ( s );
                node.insert ( newChild, node.getChildCount() );
                node = newChild;
            } else {
                node = ( DefaultMutableTreeNode ) node.getChildAt ( index );
            }
        }
    }
    private int childIndex ( final DefaultMutableTreeNode node, final String childValue ) {
        Enumeration<DefaultMutableTreeNode> children = node.children();
        DefaultMutableTreeNode child = null;
        int index = -1;
        while ( children.hasMoreElements() && index < 0 ) {
            child = children.nextElement();
            if ( child.getUserObject() != null && childValue.equals ( child.getUserObject() ) ) {
                index = node.getIndex ( child );
            }
        }
        return index;
    }
    public static void main ( String[] args ) {
        new PathTest();
    }
}
