private XSSFWorkbook createWorkbookFromTable ( TableViewer table ) {
    XSSFWorkbook wb = new XSSFWorkbook();
    XSSFSheet sheet = wb.createSheet ( "My Table Data" );
    XSSFCellStyle headerStyle = wb.createCellStyle();
    headerStyle.setFillForegroundColor ( IndexedColors.LEMON_CHIFFON.getIndex() );
    headerStyle.setFillPattern ( CellStyle.SOLID_FOREGROUND );
    headerStyle.setBorderTop ( CellStyle.BORDER_THIN );
    headerStyle.setBorderBottom ( CellStyle.BORDER_THIN );
    headerStyle.setBorderLeft ( CellStyle.BORDER_THIN );
    headerStyle.setBorderRight ( CellStyle.BORDER_THIN );
    headerStyle.setAlignment ( HorizontalAlignment.CENTER );
    Table table = table.getTable();
    TableColumn[] columns = table.getColumns();
    int rowIndex = 0;
    int cellIndex = 0;
    XSSFRow header = sheet.createRow ( ( short ) rowIndex++ );
    for ( TableColumn column : columns ) {
        String columnName = column.getText();
        XSSFCell cell = header.createCell ( cellIndex++ );
        cell.setCellValue ( column.getText() );
        cell.setCellStyle ( headerStyle );
    }
    TableItem[] items = table.getTable().getItems();
    for ( TableItem item : items ) {
        XSSFRow row = sheet.createRow ( ( short ) rowIndex++ );
        cellIndex = 0;
        for ( int i = 0; i < columns.length; i++ ) {
            String columnName = tableColumnNames[i];
            XSSFCell cell = row.createCell ( cellIndex++ );
            XSSFCellStyle cellStyle = wb.createCellStyle();
            ha = HorizontalAlignment.RIGHT;
            cellStyle.setAlignment ( ha );
            cell.setCellStyle ( cellStyle );
            String text = item.getText ( i );
            cell.setCellValue ( text );
        }
    }
    for ( int i = 0; i < columns.length; i++ ) {
        sheet.autoSizeColumn ( ( short ) i );
    }
    return wb;
}
