public static void unzip ( File zipfile, File directory ) throws IOException {
    ZipFile zfile = new ZipFile ( zipfile );
    Enumeration<? extends ZipEntry> entries = zfile.entries();
    while ( entries.hasMoreElements() ) {
        ZipEntry entry = entries.nextElement();
        File file = new File ( directory, entry.getName() );
        if ( entry.isDirectory() ) {
            file.mkdirs();
        } else {
            file.getParentFile().mkdirs();
            InputStream in = zfile.getInputStream ( entry );
            try {
                copy ( in, file );
            } finally {
                in.close();
            }
        }
    }
}
