private static void copy ( InputStream in, OutputStream out ) throws IOException {
    byte[] buffer = new byte[1024];
    while ( true ) {
        int readCount = in.read ( buffer );
        if ( readCount < 0 ) {
            break;
        }
        out.write ( buffer, 0, readCount );
    }
}
private static void copy ( File file, OutputStream out ) throws IOException {
    InputStream in = new FileInputStream ( file );
    try {
        copy ( in, out );
    } finally {
        in.close();
    }
}
private static void copy ( InputStream in, File file ) throws IOException {
    OutputStream out = new FileOutputStream ( file );
    try {
        copy ( in, out );
    } finally {
        out.close();
    }
}
