public class View {
    public void render ( AModel model ) {
    }
    public void render ( BModel model ) {
    }
}
public interface ModelProvider {
    public void renderWith ( View view );
}
public class AModelProvider implements ModelProvider {
    private final AModel _model;
    public void renderWith ( View  view ) {
        view.render ( _model );
    }
}
public class BModelProvider implements ModelProvider {
    private final BModel _model;
    public void renderWith ( View  view ) {
        view.render ( _model );
    }
}
public class AView extends View {
    public void render ( AModel model ) {
        model.doA();
    }
}
public class BView extends View {
    public void render ( BModel model ) {
        model.doB();
    }
}
public class Controller {
    public void renderModels ( List<ModelProvider> providers, View view ) {
        for ( ModelProvider provider : providers ) {
            provider.renderWith ( view );
        }
    }
}
