public final class AtomicBigInteger {
    private final AtomicReference<BigInteger> valueHolder = new AtomicReference<>();
    public AtomicBigInteger ( BigInteger bigInteger ) {
        valueHolder.set ( bigInteger );
    }
    public BigInteger incrementAndGet() {
        for ( ; ; ) {
            BigInteger current = valueHolder.get();
            BigInteger next = current.add ( BigInteger.ONE );
            if ( valueHolder.compareAndSet ( current, next ) ) {
                return next;
            }
        }
    }
}
