public class PrintText implements Printable {
    private static String mText;
    public static void main ( String[] args ) throws IOException {
        new PrintText();
    }
    public PrintText() {
        EventQueue.invokeLater ( new Runnable() {
            @Override
            public void run() {
                try {
                    UIManager.setLookAndFeel ( UIManager.getSystemLookAndFeelClassName() );
                } catch ( ClassNotFoundException | InstantiationException | IllegalAccessException | UnsupportedLookAndFeelException ex ) {
                }
                JFileChooser chooser = new JFileChooser();
                chooser.showOpenDialog ( null );
                File file = chooser.getSelectedFile();
                String filename = file.getName();
                String path = file.getAbsolutePath();
                BufferedReader br = null;
                try {
                    br = new BufferedReader ( new FileReader ( path ) );
                    List<String> list = new ArrayList<String>();
                    while ( ( mText = br.readLine() ) != null ) {
                        System.out.println ( mText );
                        list.add ( mText );
                    }
                    printer();
                } catch ( IOException exp ) {
                    exp.printStackTrace();
                } finally {
                    try {
                        br.close();
                    } catch ( Exception e ) {
                    }
                }
            }
        } );
    }
    AttributedString mStyledText = new AttributedString ( mText );
    public void printer() {
        PrinterJob printerJob = PrinterJob.getPrinterJob();
        Book book = new Book();
        book.append ( this, new PageFormat() );
        printerJob.setPageable ( book );
        boolean doPrint = printerJob.printDialog();
        if ( doPrint ) {
            try {
                printerJob.print();
            } catch ( PrinterException exception ) {
                System.err.println ( "Printing error: " + exception );
            }
        }
    }
    public int print ( Graphics g, PageFormat format, int pageIndex ) {
        Graphics2D g2d = ( Graphics2D ) g;
        g2d.translate ( format.getImageableX(), format.getImageableY() );
        g2d.setPaint ( Color.black );
        Point2D.Float pen = new Point2D.Float();
        AttributedCharacterIterator charIterator = mStyledText.getIterator();
        LineBreakMeasurer measurer = new LineBreakMeasurer ( charIterator, g2d.getFontRenderContext() );
        float wrappingWidth = ( float ) format.getImageableWidth();
        while ( measurer.getPosition() < charIterator.getEndIndex() ) {
            TextLayout layout = measurer.nextLayout ( wrappingWidth );
            pen.y += layout.getAscent();
            float dx = layout.isLeftToRight() ? 0 : ( wrappingWidth - layout.getAdvance() );
            layout.draw ( g2d, pen.x + dx, pen.y );
            pen.y += layout.getDescent() + layout.getLeading();
        }
        return Printable.PAGE_EXISTS;
    }
}
