private void mergeFiles() {
    try {
        DataSource videoDataSource = javax.media.Manager.createDataSource ( oml.getURL() );
        DataSource audioDataSource = javax.media.Manager.createDataSource ( realAudioFile.toURI().toURL() );
        DataSource mixedDataSource = null;
        DataSource arrayDataSource[] = new DataSource[2];
        DataSource outputDataSource = null;
        DataSink outputDataSink = null;
        MediaLocator videoLocator = new MediaLocator ( oml.getURL() );
        MediaLocator audioLocator = new MediaLocator ( realAudioFile.toURI().toURL() );
        FileTypeDescriptor outputType = new FileTypeDescriptor ( FileTypeDescriptor.QUICKTIME );
        Format outputFormat[] = new Format[2];
        VideoFormat videoFormat = new VideoFormat ( VideoFormat.JPEG );
        javax.media.format.AudioFormat audioMediaFormat = new javax.media.format.AudioFormat (
            javax.media.format.AudioFormat.LINEAR, 44100, 16, 1 );
        outputFormat[0] = videoFormat;
        outputFormat[1] = audioMediaFormat;
        Processor videoProcessor = Manager.createProcessor ( videoDataSource );
        Processor audioProcessor = Manager.createProcessor ( audioDataSource );
        Processor processor = null;
        videoProcessor.realize();
        audioProcessor.realize();
        while ( videoProcessor.getState() != 300 && audioProcessor.getState() != 300 ) {
            Thread.sleep ( 100 );
        }
        arrayDataSource[0] = videoProcessor.getDataOutput();
        arrayDataSource[1] = audioProcessor.getDataOutput();
        videoProcessor.start();
        audioProcessor.start();
        mixedDataSource = javax.media.Manager.createMergingDataSource ( arrayDataSource );
        mixedDataSource.connect();
        mixedDataSource.start();
        ProcessorModel processorModel = new ProcessorModel ( mixedDataSource, outputFormat, outputType );
        processor = Manager.createRealizedProcessor ( processorModel );
        processor.addControllerListener ( this );
        processor.configure();
        while ( processor.getState() < 180 ) {
            Thread.sleep ( 20 );
        }
        processor.setContentDescriptor ( new ContentDescriptor ( FileTypeDescriptor.QUICKTIME ) );
        TrackControl tcs[] = processor.getTrackControls();
        Format f[] = tcs[0].getSupportedFormats();
        tcs[0].setFormat ( f[0] );
        processor.realize();
        while ( processor.getState() < 300 ) {
            Thread.sleep ( 20 );
        }
        outputDataSource = processor.getDataOutput();
        MediaLocator outputLocator = new MediaLocator ( "file:/" + directory.getAbsolutePath() + "/yourmovfile.mov" );
        outputDataSink = Manager.createDataSink ( outputDataSource, outputLocator );
        outputDataSink.open();
        outputDataSink.addDataSinkListener ( this );
        outputDataSink.start();
        processor.start();
        while ( processor.getState() < 500 ) {
            Thread.sleep ( 100 );
        }
        waitForFileDone();
        outputDataSink.stop();
        processor.stop();
        outputDataSink.close();
        processor.close();
    } catch ( NoDataSourceException | IOException e ) {
        e.printStackTrace();
    } catch ( IncompatibleSourceException e ) {
        e.printStackTrace();
    } catch ( NoDataSinkException e ) {
        e.printStackTrace();
    } catch ( NoProcessorException e ) {
        e.printStackTrace();
    } catch ( InterruptedException e ) {
        e.printStackTrace();
    } catch ( CannotRealizeException e ) {
        e.printStackTrace();
    }
}
Object waitFileSync = new Object();
boolean fileDone = false;
boolean fileSuccess = true;
Object waitSync = new Object();
boolean stateTransitionOK = true;
boolean waitForFileDone() {
    synchronized ( waitFileSync ) {
        try {
            while ( !fileDone ) {
                waitFileSync.wait();
            }
        } catch ( Exception e ) {
        }
    }
    return fileSuccess;
}
public void dataSinkUpdate ( DataSinkEvent evt ) {
    if ( evt instanceof EndOfStreamEvent ) {
        synchronized ( waitFileSync ) {
            fileDone = true;
            waitFileSync.notifyAll();
        }
    } else if ( evt instanceof DataSinkErrorEvent ) {
        synchronized ( waitFileSync ) {
            fileDone = true;
            fileSuccess = false;
            waitFileSync.notifyAll();
        }
    }
}
@Override
public void controllerUpdate ( ControllerEvent evt ) {
    if ( evt instanceof ConfigureCompleteEvent
            || evt instanceof RealizeCompleteEvent
            || evt instanceof PrefetchCompleteEvent ) {
        synchronized ( waitSync ) {
            stateTransitionOK = true;
            waitSync.notifyAll();
        }
    } else if ( evt instanceof ResourceUnavailableEvent ) {
        synchronized ( waitSync ) {
            stateTransitionOK = false;
            waitSync.notifyAll();
        }
    } else if ( evt instanceof EndOfMediaEvent ) {
        evt.getSourceController().stop();
        evt.getSourceController().close();
    }
}
