public class ScheduledTask implements Runnable {
    private static final int CORE_THREAD_POOL_SIZE = 1;
    private static final int INITIAL_DELAY_MS = 0;
    private static final int INTERVAL_MS = 1000;
    private final ScheduledExecutorService scheduledExecutorService =
        Executors.newScheduledThreadPool ( ScheduledTask.CORE_THREAD_POOL_SIZE );
    private ScheduledFuture<?> scheduledFuture;
    public void run() {
        try {
            try {
            } catch RecoverableCheckedException rce {
            }
        } catch UnrecoverableCheckedException uce {
            throw new RuntimeException ( uce );
        }
    }
    public boolean isScheduling() {
        return ( this.scheduledFuture != null )
               && ( !this.scheduledFuture.isDone() );
    }
    public boolean isShutdown() {
        return scheduledExecutorService.isShutdown();
    }
    public void start() {
        this.scheduledFuture =
            this.scheduledExecutorService.scheduleWithFixedDelay (
                this,
                ScheduledTask.INITIAL_DELAY_MS,
                ScheduledTask.INTERVAL_MS,
                TimeUnit.MILLISECONDS );
    }
    public void shutdown() {
        this.scheduledExecutorService.shutdown();
    }
}
