private void closeAll ( Injector injector ) {
    for ( Map.Entry<Key<?>, Binding<?>> entry : injector.getAllBindings() ) {
        final Binding<?> binding = entry.getValue();
        if ( Closeable.class.isAssignablefrom (
                    entry.getKey().getTypeLiteral().getRawType() ) ) {
            binding.accept ( new DefaultBindingScopingVisitor<Void>() {
                @Override public Void visitEagerSingleton() {
                    Closeable instance = ( Closeable ) ( binding.getProvider().get() );
                    try {
                        instance.close();
                    } catch ( IOException e ) {
                    }
                    return null;
                }
            } );
        }
    }
}
