public Document loadXMLDocument ( String xmlFile, String xsdFile )
throws InvalidXMLFileFormatException {
    boolean isValid = validateXMLDoc ( xmlFile, xsdFile );
    if ( !isValid ) {
        throw new InvalidXMLFileFormatException ( xmlFile, xsdFile );
    }
    DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
    try {
        DocumentBuilder db = dbf.newDocumentBuilder();
        Document xmlDoc = db.parse ( xmlFile );
        xmlDoc.getDocumentElement().normalize();
        return xmlDoc;
    } catch ( ParserConfigurationException | SAXException | IOException pce ) {
        throw new InvalidXMLFileFormatException ( xmlFile );
    }
}
