import ca.uhn.hl7v2.parser.*;
import ca.uhn.hl7v2.model.Message;
import ca.uhn.hl7v2.model.v24.message.ACK;
public class ParserDemo {
    public static void main ( String args[] ) {
        String ackMessageString
            = "MSH|^~\\&|foo|foo||foo|200108151718||ACK^A01^ACK|1|D|2.4|\rMSA|AA\r";
        PipeParser pipeParser = new PipeParser();
        try {
            Message message = pipeParser.parse ( ackMessageString );
            if ( message instanceof ACK ) {
                ACK ack = ( ACK ) message;
                ack.getMSH().getProcessingID().getProcessingMode().setValue ( "P" );
            }
            XMLParser xmlParser = new DefaultXMLParser();
            String ackMessageInXML = xmlParser.encode ( message );
            System.out.println ( ackMessageInXML );
        } catch ( Exception e ) {
            e.printStackTrace();
        }
    }
}
