public class ThreadNameFilter implements javax.servlet.Filter {
    public void doFilter ( ServletRequest req, ServletResponse resp,
                           FilterChain fc ) throws IOException, ServletException {
        HttpServletRequest httpReq = ( HttpServletRequest ) req;
        final Thread curThr = Thread.currentThread();
        final String oldName = curThr.getName();
        try {
            curThr.setName ( httpReq.getRequestURI() );
            fc.doFilter ( req, resp );
        } finally {
            curThr.setName ( oldName );
        }
    }
}
