private Map<String, Long> availableItems;
private List<Long> selectedItems;
private Long selectedItem;
private boolean selectedItemRemoved;
@PostConstruct
public void init() {
    availableItems = new LinkedHashMap<String, Long>();
    for ( long i = 0; i < 10; i++ ) {
        availableItems.put ( "CHKID " + i, i );
    }
}
public void selectedItemsChanged ( ValueChangeEvent event ) {
    List<Long> oldValue = ( List<Long> ) event.getOldValue();
    List<Long> newValue = ( List<Long> ) event.getNewValue();
    if ( oldValue == null ) {
        oldValue = Collections.emptyList();
    }
    if ( oldValue.size() > newValue.size() ) {
        oldValue = new ArrayList<Long> ( oldValue );
        oldValue.removeAll ( newValue );
        selectedItem = oldValue.iterator().next();
        selectedItemRemoved = true;
    } else {
        newValue = new ArrayList<Long> ( newValue );
        newValue.removeAll ( oldValue );
        selectedItem = newValue.iterator().next();
        selectedItemRemoved = false;
    }
}
public void itemSelected ( AjaxBehaviorEvent event ) {
    System.out.println ( "Selected item: " + selectedItem );
    System.out.println ( "Selected item removed? " + selectedItemRemoved );
}
