public class MarqueeTextView extends TextView implements OnGestureListener {
    private GestureDetector gestureDetector;
    private Marquee marquee;
    private Scroller scroller;
    public MarqueeTextView ( Context context, AttributeSet attrs ) {
        this.marquee = new Marquee ( this );
        this.scroller = new Scroller ( context );
        this.setScroller ( scroller );
        gestureDetector = new GestureDetector ( getContext(), this );
        gestureDetector.setIsLongpressEnabled ( false );
    }
    public boolean onScroll ( MotionEvent e1, MotionEvent e2,
                              float distanceX, float distanceY ) {
        marquee.addToScroll ( distanceX );
        return false;
    }
    protected void onDraw ( Canvas canvas ) {
        scroller.setFinalX ( ( int ) marquee.mScroll );
        super.onDraw ( canvas );
    }
    private static final class Marquee extends Handler {
        float mScroll;
        public void addToScroll ( float amount ) {
            mScroll += amount;
        }
    }
}
