public class ToStringTransformer extends ClassTransformer {
    @Override
    protected boolean filter ( CtClass candidateClass ) throws Exception {
        CtClass myInterface = ClassPool.getDefault().get ( MyInterface.class.getName() );
        return !candidateClass.equals ( myInterface ) && candidateClass.subtypeOf ( myInterface );
    }
    @Override
    protected void applyTransformations ( CtClass classToTransform ) throws Exception {
        CtMethod toStringMethod = classToTransform.getDeclaredMethod ( "toString" );
        classToTransform.removeMethod ( toStringMethod );
        CtMethod hackedToStringMethod = CtNewMethod.make (
                                            "public String toString() { return \"toString() hacked by Javassist\"; }",
                                            classToTransform );
        classToTransform.addMethod ( hackedToStringMethod );
    }
}
