public final class Memento<T> {
    private final Queue<T> queue = new ArrayDeque<T>();
    private T currentValue;
    public void set ( final T value ) {
        currentValue = value;
    }
    public void persist() {
        queue.add ( currentValue );
    }
    public T lastSaved() {
        return queue.element();
    }
    public T lastEntered() {
        return currentValue;
    }
}
