package transport;
public abstract class ModeOfTransport {
    public abstract void updateView ( String name );
}
package transport;
public class Bus extends ModeOfTransport {
    @Override
    public void updateView ( String name ) {
        System.out.println ( "BUS" );
    }
}
package transport;
public class Train extends ModeOfTransport {
    @Override
    public void updateView ( String name ) {
        System.out.println ( "TRAIN" );
    }
}
package transport;
public class TransportVisitor {
    public static void main ( String[] args ) {
        TransportVisitor visitor = new TransportVisitor();
        String [] types = { "TRAIN", "BUS" };
        for ( String type : types ) {
            visitor.updateView ( type );
        }
    }
    public void updateView ( String transportTypeName ) {
        switch ( transportTypeName ) {
        case "BUS":
            handleInfo ( new Bus() );
            break;
        case "TRAIN":
            handleInfo ( new Train() );
            break;
        default:
            break;
        }
    }
    private void handleInfo ( ModeOfTransport transportType ) {
        transportType.updateView ( ( String ) null );
    }
}
