private static boolean fullyCovered ( final String input,
                                      final Pattern pattern ) {
    if ( input.isEmpty() ) {
        return pattern.matcher ( input ).find();
    }
    final int len = input.length();
    final boolean[] covered = new boolean[len];
    final Matcher matcher = pattern.matcher ( input );
    for ( int index = 0; index < len; index++ ) {
        if ( !matcher.find ( index ) ) {
            if ( !covered[index] ) {
                return false;
            }
            continue;
        }
        if ( matcher.start() == index ) {
            setCovered ( covered, index, matcher.end() );
        }
    }
    return true;
}
private static void setCovered ( final boolean[] covered,
                                 final int beginIndex, final int endIndex ) {
    for ( int i = beginIndex; i < endIndex; i++ ) {
        covered[i] = true;
    }
}
