public static void main ( final String[] args ) {
    final JFrame f = new JFrame();
    f.setDefaultCloseOperation ( WindowConstants.DISPOSE_ON_CLOSE );
    f.setTitle ( "JEditorPane Test" );
    final String text = "<html><body>xyz<br /><br /><br />lol <a name='link1'>test</a>some text<br /><br /><br /><br /><br /><br /><br /><br /><br /><br />some more text<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />some more text<a href='#link1'>jump to top</a></body></html>";
    final JEditorPane ep = new JEditorPane();
    ep.setContentType ( "text/html" );
    ep.setText ( text );
    ep.setEditable ( false );
    ep.addHyperlinkListener ( new HyperlinkListener() {
        @Override public void hyperlinkUpdate ( final HyperlinkEvent pE ) {
            if ( HyperlinkEvent.EventType.ACTIVATED == pE.getEventType() ) {
                String desc = pE.getDescription();
                if ( desc == null || !desc.startsWith ( "#" ) ) {
                    return;
                }
                desc = desc.substring ( 1 );
                ep.scrollToReference ( desc );
            }
        }
    } );
    final JScrollPane sp = new JScrollPane ( ep );
    f.add ( sp );
    f.setBounds ( 200, 200, 400, 400 );
    f.setVisible ( true );
}
