public static byte [] getAudioDataBytes ( byte [] sourceBytes, AudioFormat audioFormat ) throws UnsupportedAudioFileException, IllegalArgumentException, Exception {
    if ( sourceBytes == null || sourceBytes.length == 0 || audioFormat == null ) {
        throw new IllegalArgumentException ( "Illegal Argument passed to this method" );
    }
    ByteArrayInputStream bais = null;
    ByteArrayOutputStream baos = null;
    AudioInputStream sourceAIS = null;
    AudioInputStream convert1AIS = null;
    AudioInputStream convert2AIS = null;
    try {
        bais = new ByteArrayInputStream ( sourceBytes );
        sourceAIS = AudioSystem.getAudioInputStream ( bais );
        AudioFormat sourceFormat = sourceAIS.getFormat();
        AudioFormat convertFormat = new AudioFormat ( AudioFormat.Encoding.PCM_SIGNED, sourceFormat.getSampleRate(), 16, sourceFormat.getChannels(), sourceFormat.getChannels() * 2, sourceFormat.getSampleRate(), false );
        convert1AIS = AudioSystem.getAudioInputStream ( convertFormat, sourceAIS );
        convert2AIS = AudioSystem.getAudioInputStream ( audioFormat, convert1AIS );
        baos = new ByteArrayOutputStream();
        byte [] buffer = new byte[8192];
        while ( true ) {
            int readCount = convert2AIS.read ( buffer, 0, buffer.length );
            if ( readCount == -1 ) {
                break;
            }
            baos.write ( buffer, 0, readCount );
        }
        return baos.toByteArray();
    } catch ( UnsupportedAudioFileException uafe ) {
        throw uafe;
    } catch ( IOException ioe ) {
        throw ioe;
    } catch ( IllegalArgumentException iae ) {
        throw iae;
    } catch ( Exception e ) {
        throw e;
    } finally {
        if ( baos != null ) {
            try {
                baos.close();
            } catch ( Exception e ) {
            }
        }
        if ( convert2AIS != null ) {
            try {
                convert2AIS.close();
            } catch ( Exception e ) {
            }
        }
        if ( convert1AIS != null ) {
            try {
                convert1AIS.close();
            } catch ( Exception e ) {
            }
        }
        if ( sourceAIS != null ) {
            try {
                sourceAIS.close();
            } catch ( Exception e ) {
            }
        }
        if ( bais != null ) {
            try {
                bais.close();
            } catch ( Exception e ) {
            }
        }
    }
}
