public void start ( Stage stage ) {
    Scene scene = new Scene ( new Group() );
    stage.setTitle ( "Imported Fruits" );
    stage.setWidth ( 500 );
    stage.setHeight ( 500 );
    ObservableList<PieChart.Data> pieChartData =
        FXCollections.observableArrayList (
            new PieChart.Data ( "Grapefruit", 13 ),
            new PieChart.Data ( "Oranges", 25 ),
            new PieChart.Data ( "Plums", 10 ),
            new PieChart.Data ( "Pears", 22 ),
            new PieChart.Data ( "Apples", 30 ) );
    final PieChart chart = new PieChart ( pieChartData );
    chart.setTitle ( "Imported Fruits" );
    final ObservableList<Node> children = ( ( Group ) scene.getRoot() ).getChildren();
    children.add ( chart );
    final Label caption = new Label ( "" );
    caption.setTextFill ( Color.DARKORANGE );
    caption.setStyle ( "-fx-font: 24 arial;" );
    children.add ( caption );
    for ( final PieChart.Data data : chart.getData() ) {
        data.getNode().addEventHandler ( MouseEvent.MOUSE_PRESSED,
        new EventHandler<MouseEvent>() {
            @Override public void handle ( MouseEvent e ) {
                caption.setTranslateX ( e.getSceneX() );
                caption.setTranslateY ( e.getSceneY() );
                caption.setText ( String.valueOf ( data.getPieValue() ) + "%" );
                caption.setVisible ( true );
            }
        } );
    }
    stage.setScene ( scene );
    stage.show();
}
