private int encode ( byte[] array, int offset, int value ) {
    if ( value < 0 ) {
        throw new InvalidParameterException ( "Value " + value + " is negative and cannot safely be decoded." );
    }
    byte temp;
    int shift = 28;
    while ( shift > 0 && ( value >> shift ) == 0 ) {
        shift -= 7;
    }
    while ( shift > 0 ) {
        array[offset++] = ( byte ) ( ( ( value >> shift ) & 0x7F ) | 0x80 );
        shift -= 7;
    }
    array[offset++] = ( byte ) ( value & 0x7F );
    return offset;
}
