DefaultHttpClient httpclient = new DefaultHttpClient();
HttpRequestRetryHandler myRetryHandler = new HttpRequestRetryHandler() {
    public boolean retryRequest (
        IOException exception,
        int executionCount,
        HttpContext context ) {
        if ( executionCount >= 5 ) {
            return false;
        }
        if ( exception instanceof InterruptedIOException ) {
            return false;
        }
        if ( exception instanceof UnknownHostException ) {
            return false;
        }
        if ( exception instanceof SocketTimeoutException ) {
            return true;
        }
        if ( exception instanceof ConnectException ) {
            return false;
        }
        if ( exception instanceof SSLException ) {
            return false;
        }
        HttpRequest request = ( HttpRequest ) context.getAttribute (
                                  ExecutionContext.HTTP_REQUEST );
        boolean idempotent = ! ( request instanceof HttpEntityEnclosingRequest );
        if ( idempotent ) {
            return true;
        }
        return false;
    }
};
httpclient.setHttpRequestRetryHandler ( myRetryHandler );
