char * pad_pkcs5 ( const char * data, size_t data_len, size_t * padded_len ) {
    char * padded_data;
    unsigned padding_len = 8 - ( data_len % 8 );
    const char padding = padding_len;
    char * pad_ptr;
    if ( data_len + padding_len < data_len ) {
        return NULL;
    }
    padded_data = malloc ( data_len + padding_len );
    if ( !padded_data ) {
        return NULL;
    }
    memcpy ( padded_data, data, data_len );
    if ( * padded_len ) {
        * padded_len = data_len + padding_len;
    }
    pad_ptr = padded_data + data_len;
    while ( padding_len-- ) {
        * pad_ptr++ = padding;
    }
    return padded_data;
}
char * ecb_pkcs5_encrypt ( const char * key, const char * data, size_t data_len, size_t * out_len ) {
    char des_key[8];
    char * padded_data;
    size_t padded_len;
    int status;
    strncpy ( des_key, key, sizeof des_key );
    des_setparity ( des_key );
    padded_data = pad_pkcs5 ( data, data_len, & padded_len );
    if ( !padded_data ) {
        return NULL;
    }
    status = ecb_crypt ( des_key, padded_data, padded_len, DES_ENCRYPT );
    if ( DES_FAILED ( status ) ) {
        return NULL;
    }
    if ( out_len ) {
        * out_len = padded_len;
    }
    return padded_data;
}
