public void saveWorkbook ( OleAutomation controlSiteAuto, String filepath, Integer formatCode, boolean replaceExistingWithoutPrompt ) {
    Variant[] args = null;
    Variant result = null;
    try {
        if ( replaceExistingWithoutPrompt ) {
            setPropertyOnObject ( controlSiteAuto, "Application", "DisplayAlerts", "False" );
        }
        if ( formatCode == null ) {
            formatCode = 51;
        }
        int[] id = controlSiteAuto.getIDsOfNames ( new String[] {"SaveAs", "FileName", "FileFormat"} );
        args = new Variant[2];
        args[0] = new Variant ( filepath );
        args[1] = new Variant ( formatCode );
        result = controlSiteAuto.invoke ( id[0], args );
        if ( result == null || !result.getBoolean() ) {
            throw new RuntimeException ( "Unable to save active workbook" );
        }
        if ( replaceExistingWithoutPrompt ) {
            setPropertyOnObject ( controlSiteAuto, "Application", "DisplayAlerts", "True" );
        }
    } finally {
        cleanup ( args );
        cleanup ( result );
    }
}
protected void cleanup ( Variant[] variants ) {
    if ( variants != null ) {
        for ( int i = 0; i < variants.length; i++ ) {
            if ( variants[i] != null ) {
                variants[i].dispose();
            }
        }
    }
}
