public static class PageScrollable extends JPanel implements Scrollable {
    @Override
    public Dimension getPreferredScrollableViewportSize() {
        if ( getComponentCount() > 0 ) {
            return getComponent ( 0 ).getPreferredSize();
        }
        return super.getPreferredSize();
    }
    @Override
    public int getScrollableUnitIncrement ( Rectangle visibleRect,
                                            int orientation, int direction ) {
        return getPreferredScrollableViewportSize().height;
    }
    @Override
    public int getScrollableBlockIncrement ( Rectangle visibleRect,
            int orientation, int direction ) {
        return getPreferredScrollableViewportSize().height;
    }
    @Override
    public boolean getScrollableTracksViewportWidth() {
        return false;
    }
    @Override
    public boolean getScrollableTracksViewportHeight() {
        return false;
    }
}
