public class MarkImage {
    public static void main ( String[] args ) {
        new MarkImage();
    }
    public MarkImage() {
        EventQueue.invokeLater ( new Runnable() {
            @Override
            public void run() {
                try {
                    UIManager.setLookAndFeel ( UIManager.getSystemLookAndFeelClassName() );
                } catch ( ClassNotFoundException | InstantiationException | IllegalAccessException | UnsupportedLookAndFeelException ex ) {
                }
                JFrame frame = new JFrame ( "Test" );
                frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
                frame.setLayout ( new BorderLayout() );
                frame.add ( new TestPane() );
                frame.pack();
                frame.setLocationRelativeTo ( null );
                frame.setVisible ( true );
            }
        } );
    }
    public class TestPane extends JPanel {
        private BufferedImage background;
        private List<Point> clickPoints;
        public TestPane() {
            clickPoints = new ArrayList<> ( 25 );
            try {
                background = ImageIO.read ( getClass().getResource ( "/Miho_Small.png" ) );
            } catch ( IOException ex ) {
                ex.printStackTrace();
            }
            addMouseListener ( new MouseAdapter() {
                @Override
                public void mouseClicked ( MouseEvent e ) {
                    clickPoints.add ( e.getPoint() );
                    repaint();
                }
            } );
        }
        @Override
        public Dimension getPreferredSize() {
            return background == null ? super.getPreferredSize() : new Dimension ( background.getWidth(), background.getHeight() );
        }
        @Override
        protected void paintComponent ( Graphics g ) {
            super.paintComponent ( g );
            if ( background != null ) {
                int x = ( getWidth() - background.getWidth() ) / 2;
                int y = ( getHeight() - background.getHeight() ) / 2;
                g.drawImage ( background, x, y, this );
            }
            g.setColor ( Color.RED );
            for ( Point p : clickPoints ) {
                g.fillOval ( p.x - 4, p.y - 4, 8, 8 );
            }
        }
    }
}
