import org.apache.commons.codec.binary.Base64;
import javax.crypto.Mac;
import javax.crypto.spec.SecretKeySpec;
private JSONObject parseFBSignedRequest ( String signedRequest, String secret ) throws UnsupportedEncodingException, Exception {
    String[] signedRequests = signedRequest.split ( "\\.", 2 );
    String sig = signedRequests[0];
    String data = signedRequests[1];
    JSONObject jsonData = new JSONObject ( new String ( Base64.decodeBase64 ( data ), "UTF-8" ) );
    if ( !jsonData.getString ( "algorithm" ).equals ( "HMAC-SHA256" ) ) {
        return null;
    }
    if ( !hmacSHA256 ( signedRequests[1], secret ).equals ( sig ) ) {
        return null;
    }
    return jsonData;
}
private String hmacSHA256 ( String data, String key ) throws Exception {
    SecretKeySpec secretKey = new SecretKeySpec ( key.getBytes ( "UTF-8" ), "HmacSHA256" );
    Mac mac = Mac.getInstance ( "HmacSHA256" );
    mac.init ( secretKey );
    byte[] hmacData = mac.doFinal ( data.getBytes ( "UTF-8" ) );
    return new String ( Base64.encodeBase64URLSafe ( hmacData ), "UTF-8" );
}
