package com.example.filter;
import java.io.IOException;
import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
public class RoleCheckFilter implements Filter {
    public void init ( FilterConfig filterConfig ) throws ServletException {}
    public void doFilter ( ServletRequest req, ServletResponse res, FilterChain chain )
    throws IOException, ServletException {
        HttpServletRequest request = ( HttpServletRequest ) req;
        HttpServletResponse response = ( HttpServletResponse ) res;
        if ( request.isUserInRole ( "admin" ) ) {
            chain.doFilter ( request, response );
        } else {
            request.setAttribute ( "error", "You don't have enough rights to access this resource" );
            response.sendRedirect ( request.getContextPath() + "/login.jsp" );
        }
    }
    public void destroy() {}
}
