public static URI withQuery ( URI uri, Map<String, String> params ) {
    StringBuilder query = new StringBuilder();
    char separator = '?';
    for ( Entry<String, String> param : params.entrySet() ) {
        query.append ( separator );
        separator = '&';
        try {
            query.append ( URLEncoder.encode ( param.getKey(), "UTF-8" ) );
            if ( !StringUtils.isEmpty ( param.getValue() ) ) {
                query.append ( '=' );
                query.append ( URLEncoder.encode ( param.getValue(), "UTF-8" ) );
            }
        } catch ( UnsupportedEncodingException e ) {
            throw new RuntimeException ( e );
        }
    }
    return URI.create ( uri.toString() + query.toString() );
}
public static URI withQuery ( URI uri, String... params ) {
    Map<String, String> map = new LinkedHashMap<String, String>();
    for ( int i = 0; i < params.length; i += 2 ) {
        String key = params[i];
        String val = i + 1 < params.length ? params[i + 1] : "";
        map.put ( key, val );
    }
    return withQuery ( uri, map );
}
