public static BufferedImage rotateImage ( Image image, int angle ) {
    double sin = Math.abs ( Math.sin ( angle ) );
    double cos = Math.abs ( Math.cos ( angle ) );
    int originalWidth = image.getWidth ( null );
    int originalHeight = image.getHeight ( null );
    int newWidth = ( int ) Math.floor ( originalWidth * cos + originalHeight * sin );
    int newHeight = ( int ) Math.floor ( originalHeight * cos + originalWidth * sin );
    BufferedImage rotatedBI = new BufferedImage ( newWidth, newHeight, BufferedImage.TRANSLUCENT );
    Graphics2D g2d = rotatedBI.createGraphics();
    g2d.setRenderingHint ( RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON );
    g2d.translate ( ( newWidth - originalWidth ) / 2, ( newHeight - originalHeight ) / 2 );
    g2d.rotate ( angle, originalWidth / 2, originalHeight / 2 );
    g2d.drawImage ( image, 0, 0, null );
    g2d.dispose();
    return rotatedBI;
}
