private static final long ZIP_MAGIC_NUMBERS = 0x504B0304;
private static final String KMZ_CONTENT_TYPE = "application/vnd.google-earth.kmz";
private Document getDocument ( String urlString ) throws IOException, DocumentException, URISyntaxException {
    InputStream inputStream = null;
    URL url = new URL ( urlString );
    String protocol = url.getProtocol();
    if ( protocol.equalsIgnoreCase ( "file" ) ) {
        File file = new File ( url.toURI() );
        RandomAccessFile raf = new RandomAccessFile ( file, "r" );
        long n = raf.readInt();
        raf.close();
        if ( n == KmlMetadataExtractorAdaptor.ZIP_MAGIC_NUMBERS ) {
            inputStream = new ZipInputStream ( new FileInputStream ( file ) );
            ( ( ZipInputStream ) inputStream ).getNextEntry();
        } else {
            inputStream = new FileInputStream ( file );
        }
    } else if ( protocol.equalsIgnoreCase ( "http" ) || protocol.equalsIgnoreCase ( "https" ) ) {
        HttpURLConnection connection = ( HttpURLConnection ) url.openConnection();
        connection.connect();
        String contentType = connection.getContentType();
        if ( contentType.contains ( KmlMetadataExtractorAdaptor.KMZ_CONTENT_TYPE ) ) {
            inputStream = new ZipInputStream ( connection.getInputStream() );
            ( ( ZipInputStream ) inputStream ).getNextEntry();
        } else {
            inputStream = connection.getInputStream();
        }
    }
    Document document = new SAXReader().read ( inputStream );
    inputStream.close();
    return document;
}
