class EnumEnumerator<T extends Enum<T>> implements Iterable<T> {
    private final Class<T> enumClass;
    public EnumEnumerator ( Class<T> enumClass ) {
        this.enumClass = enumClass;
    }
    @SuppressWarnings ( "unchecked" )
    public Iterator<T> iterator() {
        try {
            T[] values = ( T[] ) enumClass.getDeclaredMethod ( "values" ).invoke ( null );
            return Arrays.asList ( values ).iterator();
        } catch ( Exception e ) {
            throw new IllegalStateException ( e );
        }
    }
}
