public static void moveAndOverwrite ( File source, File dest ) throws IOException {
    File backup = CSVUtils.getNonExistingTempFile ( dest );
    FileUtils.copyFile ( dest, backup );
    FileUtils.copyFile ( source, dest );
    if ( !source.delete() ) {
        throw new IOException ( "Failed to delete " + source.getName() );
    }
    if ( !backup.delete() ) {
        throw new IOException ( "Failed to delete " + backup.getName() );
    }
}
public static File getNonExistingTempFile ( File inputFile ) {
    File tempFile = new File ( inputFile.getParentFile(), inputFile.getName() + "_temp" );
    if ( tempFile.exists() ) {
        return CSVUtils.getNonExistingTempFile ( tempFile );
    } else {
        return tempFile;
    }
}
