package name.seller.rich.maven.plugins.bootstrap;
import java.util.List;
import org.apache.maven.artifact.Artifact;
import org.apache.maven.artifact.factory.ArtifactFactory;
import org.apache.maven.artifact.repository.ArtifactRepository;
import org.apache.maven.artifact.resolver.ArtifactNotFoundException;
import org.apache.maven.artifact.resolver.ArtifactResolutionException;
import org.apache.maven.artifact.resolver.ArtifactResolver;
import org.apache.maven.plugin.AbstractMojo;
import org.apache.maven.plugin.MojoExecutionException;
import org.apache.maven.plugin.MojoFailureException;
public class BootstrapAppMojo extends AbstractMojo {
    protected ArtifactFactory factory;
    protected ArtifactResolver artifactResolver;
    protected List remoteRepositories;
    protected ArtifactRepository localRepository;
    private String bootstrapArtifactId;
    private String bootstrapGroupId;
    private String bootstrapType;
    private String bootstrapVersion;
    public void execute() throws MojoExecutionException, MojoFailureException {
        try {
            Artifact pomArtifact = this.factory.createArtifact (
                                       bootstrapGroupId, bootstrapArtifactId, bootstrapVersion,
                                       "", bootstrapType );
            artifactResolver.resolve ( pomArtifact, this.remoteRepositories,
                                       this.localRepository );
        } catch ( ArtifactResolutionException e ) {
            getLog().error ( "can't resolve parent pom", e );
        } catch ( ArtifactNotFoundException e ) {
            getLog().error ( "can't resolve parent pom", e );
        }
    }
}
