private boolean isPointInPolygon ( Geopoint tap, ArrayList<Geopoint> vertices ) {
    int intersectCount = 0;
    for ( int j = 0; j < vertices.size() - 1; j++ ) {
        if ( rayCastIntersect ( tap, vertices.get ( j ), vertices.get ( j + 1 ) ) ) {
            intersectCount++;
        }
    }
    return ( intersectCount % 2 ) == 1 );
}
private boolean rayCastIntersect ( Geopoint tap, Geopoint vertA, Geopoint vertB ) {
    double aY = vertA.getLatitude();
    double bY = vertB.getLatitude();
    double aX = vertA.getLongitude();
    double bX = vertB.getLongitude();
    double pY = tap.getLatitude();
    double pX = tap.getLongitude();
    if ( ( aY > pY && bY > pY ) || ( aY < pY && bY < pY ) || ( aX < pX && bX < pX ) ) {
        return false;
    }
    double m = ( aY - bY ) / ( aX - bX );
    double bee = ( -aX ) * m + aY;
    double x = ( pY - bee ) / m;
    return x > pX;
}
