void downloadFromUrl ( URL url, String localFilename ) throws IOException {
    InputStream is = null;
    FileOutputStream fos = null;
    try {
        URLConnection urlConn = url.openConnection();
        is = urlConn.getInputStream();
        fos = new FileOutputStream ( localFilename );
        byte[] buffer = new byte[4096];
        int len;
        while ( ( len = is.read ( buffer ) ) > 0 ) {
            fos.write ( buffer, 0, len );
        }
    } finally {
        try {
            if ( is != null ) {
                is.close();
            }
        } finally {
            if ( fos != null ) {
                fos.close();
            }
        }
    }
}
