public class ChefUnit extends Unit {
    private Task actualTask;
    private int chefExperienceLevel;
    public ChefUnit ( int starterXCor, int starterYCor, double moveSpeed, int chefExperienceLevel ) {
        super ( unitType, starterXCor, starterYCor, moveSpeed );
        this.chefExperienceLevel = chefExperienceLevel;
    }
    @Override
    public void decideWhatToDo() {
        if ( chefExperienceLevel > 3 ) {
            actualTask = new CookTask ( this );
            isBussy = true;
        } else {
            actualTask = new WashDishesTask ( this );
            isBussy = true;
        }
    }
    @Override
    public void doTask() {
        isTaskDone = false;
        isDoingTask = true;
        taskStartTime = System.currentTimeMillis();
    }
    @Override
    public boolean isTaskFinished() {
        if ( ( System.currentTimeMillis() - taskStartTime ) / 1000 >= actualTask.getTaskTime() ) {
            actualTask.doTask ( this );
            isDoingTask = false;
            isTaskDone = true;
            return true;
        }
        return false;
    }
}
