public static int[][] importFile ( String fileName ) throws IOException {
    BufferedReader reader = new BufferedReader ( new FileReader ( fileName ) );
    int[][] numArray;
    String line = reader.readLine();
    if ( line == null ) {
        throw new IllegalArgumentException ( "There was no 1st line." );
    }
    String[] dimensions = line.split ( "\\s+" );
    try {
        int rows = Integer.parseInt ( dimensions[0] );
        int cols = Integer.parseInt ( dimensions[1] );
        numArray = new int[rows][cols];
    } catch ( NumberFormatException e ) {
        throw new IllegalArgumentException ( "First line of file has to be 'rows cols'" );
    }
    int row = 0;
    while ( ( line = reader.readLine() ) != null && row < numArray.length ) {
        String[] tokens = line.split ( "\\s+" );
        if ( tokens.length > numArray[row].length ) {
            throw new IllegalArgumentException ( "Too many values provided in matrix row " + row );
        }
        for ( int column = 0; column < tokens.length; column++ ) {
            try {
                int value = Integer.parseInt ( tokens[column] );
                numArray[row][column] = value;
            } catch ( NumberFormatException e ) {
                throw new IllegalArgumentException ( "Non numeric value found in matrix row " + row + ", column " + column );
            }
        }
        row++;
    }
    if ( line != null ) {
    }
    if ( row < numArray.length ) {
        throw new IllegalArgumentException ( "Expected " + numArray.length + " rows, there only were " + row );
    }
    try {
        reader.close();
    } catch ( IOException e ) { }
    return numArray;
}
