public static boolean isReadyForRead ( SocketChannel socket ) throws IOException {
    return isReady ( socket, SelectionKey.OP_READ );
}
public static boolean isReadyForWrite ( SocketChannel socket ) throws IOException {
    return isReady ( socket, SelectionKey.OP_WRITE );
}
public static boolean isReady ( SocketChannel socket, int op ) throws IOException {
    if ( socket.isBlocking() ) {
        throw new IllegalArgumentException ( "Socket must be in non-blocking mode" );
    }
    Selector selector = SelectorProvider.provider().openSelector();
    socket.register ( selector, op );
    if ( selector.selectNow() == 0 ) {
        return false;
    }
    return selector.selectedKeys().contains ( socket.keyFor ( selector ) );
}
