public static UIComponent findComponent ( String compId ) {
    return findComponent ( FacesContext.getCurrentInstance().getViewRoot(), compId );
}
public static UIComponent findComponent ( UIComponent topComponent, String compId ) {
    if ( compId == null ) {
        throw new NullPointerException ( "Component identifier cannot be null" );
    }
    if ( compId.equals ( topComponent.getId() ) ) {
        return topComponent;
    }
    if ( topComponent.getChildCount() > 0 ) {
        List childComponents = topComponent.getChildren();
        for ( UIComponent currChildComponent : childComponents ) {
            UIComponent foundComponent = findComponent ( currChildComponent, compId );
            if ( foundComponent != null ) {
                return foundComponent;
            }
        }
    }
    return null;
}
