public class BroadCastSampleActivity extends Activity {
    @Override
    protected void onCreate ( Bundle savedInstanceState ) {
        super.onCreate ( savedInstanceState );
        this.registerReceiver ( this.mConnReceiver,
                                new IntentFilter ( ConnectivityManager.CONNECTIVITY_ACTION ) );
    }
    private BroadcastReceiver mConnReceiver = new BroadcastReceiver() {
        public void onReceive ( Context context, Intent intent ) {
            boolean noConnectivity = intent.getBooleanExtra ( ConnectivityManager.EXTRA_NO_CONNECTIVITY, false );
            String reason = intent.getStringExtra ( ConnectivityManager.EXTRA_REASON );
            boolean isFailover = intent.getBooleanExtra ( ConnectivityManager.EXTRA_IS_FAILOVER, false );
            NetworkInfo currentNetworkInfo = ( NetworkInfo ) intent.getParcelableExtra ( ConnectivityManager.EXTRA_NETWORK_INFO );
            NetworkInfo otherNetworkInfo = ( NetworkInfo ) intent.getParcelableExtra ( ConnectivityManager.EXTRA_OTHER_NETWORK_INFO );
            if ( currentNetworkInfo.isConnected() ) {
                Toast.makeText ( getApplicationContext(), "Connected", Toast.LENGTH_LONG ).show();
            } else {
                Toast.makeText ( getApplicationContext(), "Not Connected", Toast.LENGTH_LONG ).show();
            }
        }
    };
}
