public static void main ( String[] args ) {
    new TestSlider();
}
public TestSlider() {
    EventQueue.invokeLater ( new Runnable() {
        @Override
        public void run() {
            try {
                UIManager.setLookAndFeel ( UIManager.getSystemLookAndFeelClassName() );
            } catch ( ClassNotFoundException | InstantiationException | IllegalAccessException | UnsupportedLookAndFeelException ex ) {
            }
            JFrame frame = new JFrame ( "Test" );
            frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
            frame.setLayout ( new BorderLayout() );
            frame.add ( new TestPane() );
            frame.pack();
            frame.setLocationRelativeTo ( null );
            frame.setVisible ( true );
        }
    } );
}
public class TestPane extends JPanel {
    public TestPane() {
        setBackground ( Color.RED );
        setLayout ( new GridBagLayout() );
        GridBagConstraints gbc = new GridBagConstraints();
        gbc.gridwidth = GridBagConstraints.REMAINDER;
        gbc.fill = GridBagConstraints.HORIZONTAL;
        add ( new TransparentBackgroundSlider(), gbc );
        add ( new TransparentSlider(), gbc );
        add ( new JSlider(), gbc );
    }
}
public class TransparentBackgroundSlider extends JSlider {
    public TransparentBackgroundSlider() {
        setOpaque ( false );
        setBackground ( Color.BLUE );
    }
    @Override
    protected void paintComponent ( Graphics g ) {
        Graphics2D g2d = ( Graphics2D ) g.create();
        g2d.setColor ( getBackground() );
        g2d.setComposite ( AlphaComposite.SrcOver.derive ( 0.5f ) );
        g2d.fillRect ( 0, 0, getWidth(), getHeight() );
        g2d.dispose();
        super.paintComponent ( g );
    }
}
public class TransparentSlider extends JSlider {
    public TransparentSlider() {
        setOpaque ( false );
        setBackground ( Color.GREEN );
    }
    @Override
    public void paint ( Graphics g ) {
        Graphics2D g2d = ( Graphics2D ) g.create();
        g2d.setComposite ( AlphaComposite.SrcOver.derive ( 0.5f ) );
        super.paint ( g2d );
        g2d.dispose();
    }
    @Override
    protected void paintComponent ( Graphics g ) {
        Graphics2D g2d = ( Graphics2D ) g.create();
        g2d.setColor ( getBackground() );
        g2d.fillRect ( 0, 0, getWidth(), getHeight() );
        g2d.dispose();
        super.paintComponent ( g );
    }
}
