DateAxis domainAxis = new DateAxis ( "Date" );
domainAxis.setTickMarkPosition ( DateTickMarkPosition.MIDDLE );
NumberAxis rangeAxis = new NumberAxis ( "Y" );
rangeAxis.setUpperMargin ( 0.15 );
StackedXYBarRenderer renderer = new StackedXYBarRenderer ( 0.10 );
renderer.setDrawBarOutline ( false );
XYPlot plot = new XYPlot ( dataset, domainAxis, rangeAxis, renderer );
XYItemLabelGenerator generator = new XYItemLabelGenerator() {
    @Override
    public String generateLabel ( XYDataset dataset, int series, int item ) {
        double sum = dataset.getYValue ( 0, item ) + dataset.getYValue ( 1, item );
        return "" + sum;
    }
};
renderer.setSeriesItemLabelGenerator ( 1, generator );
renderer.setSeriesItemLabelsVisible ( 1, true );
renderer.setSeriesPositiveItemLabelPosition ( 1, new ItemLabelPosition ( ItemLabelAnchor.OUTSIDE12,
        TextAnchor.BASELINE_CENTER ) );
renderer.setItemLabelAnchorOffset ( 10 );
JFreeChart chart = new JFreeChart ( "Stacked XY Bar Chart Demo 2", plot );
return chart;
