package servlets;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.*;
public class StreamServlet extends HttpServlet {
    private static final String WINDOWS_UPLOAD_DIR = "C:\\Projects\\Data\\img";
    @Override
    protected void doGet ( HttpServletRequest req, HttpServletResponse resp )
    throws ServletException, IOException {
        String fileName = req.getPathInfo().substring ( 1 );
        File imageFile = new File ( WINDOWS_UPLOAD_DIR, fileName );
        OutputStream os = resp.getOutputStream();
        InputStream is = new FileInputStream ( imageFile );
        IOBridge ( is, os );
        os.flush();
        Close ( is, os );
    }
    private static void IOBridge ( InputStream in, OutputStream out )
    throws IOException {
        byte data[] = new byte[1024];
        int readCount = 0;
        while ( ( readCount = in.read ( data, 0, readCount ) ) != -1 ) {
            out.write ( data );
        }
    }
    private static void Close ( Closeable... closeables ) {
        for ( Closeable c : closeables )
            if ( c != null )
                try {
                    c.close();
                } catch ( IOException ioe ) {
                    try {
                        c.close();
                    } catch ( Exception e ) {
                        e.printStackTrace();
                    }
                } finally {
                    try {
                        c.close();
                    } catch ( Exception e ) {
                        e.printStackTrace();
                    }
                }
    }
}
