KeyPairGenerator generator = KeyPairGenerator.getInstance ( "RSA" );
KeyPair keyPair = generator.generateKeyPair();
final PrivateKey privKey = keyPair.getPrivate();
Provider bcProvider = new BouncyCastleProvider();
PKCS8Generator pkcs8Generator = new PKCS8Generator ( privKey,
        PKCS8Generator.PBE_SHA1_3DES, bcProvider );
pkcs8Generator.setIterationCount ( 10000 );
pkcs8Generator.setPassword ( "Hello, World!".toCharArray() );
PemObject result = pkcs8Generator.generate();
try ( PemWriter writer = new PemWriter ( new PrintWriter ( System.out ) ) ) {
    writer.writeObject ( result );
}
