@Configuration
@EnableScheduling
public class MyAppConfig implements SchedulingConfigurer {
    @Autowired
    Environment env;
    @Bean
    public MyBean myBean() {
        return new MyBean();
    }
    @Bean ( destroyMethod = "shutdown" )
    public Executor taskExecutor() {
        return Executors.newScheduledThreadPool ( 100 );
    }
    @Override
    public void configureTasks ( ScheduledTaskRegistrar taskRegistrar ) {
        taskRegistrar.setScheduler ( taskExecutor() );
        taskRegistrar.addTriggerTask (
        new Runnable() {
            @Override public void run() {
                myBean().getSchedule();
            }
        },
        new Trigger() {
            @Override public Date nextExecutionTime ( TriggerContext triggerContext ) {
                Calendar nextExecutionTime =  new GregorianCalendar();
                Date lastActualExecutionTime = triggerContext.lastActualExecutionTime();
                nextExecutionTime.setTime ( lastActualExecutionTime != null ? lastActualExecutionTime : new Date() );
                nextExecutionTime.add ( Calendar.MILLISECOND, env.getProperty ( "myRate", Integer.class ) );
                return nextExecutionTime.getTime();
            }
        }
        );
    }
}
