import java.io.*;
import java.util.*;
public class League {
    private String name;
    private Team[] teams;
    private League ( String aName, Team[] teams ) {
        super();
        this.name = aName;
        this.teams = teams;
    }
    public static League loadLeague() {
        League theLeague = null;
        String pathname = OUFileChooser.getFilename();
        File aFile = new File ( pathname );
        Scanner bufferedScanner = null;
        try {
            String leagueName;
            int numberOfTeams;
            String teamName;
            int won;
            int drawn;
            int lost;
            int goalsFor;
            int goalsAgainst;
            Scanner lineScanner;
            String currentLine;
            bufferedScanner = new Scanner ( new BufferedReader ( new FileReader ( aFile ) ) );
            boolean firstLine = true;
            List<Team> teamsList = new ArrayList<Team>();
            Team[] teams = null;
            while ( bufferedScanner.hasNextLine() ) {
                currentLine = bufferedScanner.nextLine();
                lineScanner = new Scanner ( currentLine );
                lineScanner.useDelimiter ( "," );
                if ( firstLine ) {
                    leagueName = lineScanner.next();
                    numberOfTeams = lineScanner.nextInt();
                    firstLine = false;
                    continue;
                }
                Team aTeam = new Team ( lineScanner.next() );
                aTeam.setWon ( lineScanner.nextInt() );
                aTeam.setDrawn ( lineScanner.nextInt() );
                aTeam.setLost ( lineScanner.nextInt() );
                aTeam.setGoalsFor ( lineScanner.nextInt() );
                aTeam.setGoalsAgainst ( lineScanner.nextInt() );
                teamsList.add ( aTeam );
            }
            teams = teamsList.toArray ( new Team[] {} );
            theLeague = new League ( leagueName, teams );
        } catch ( Exception anException ) {
            System.out.println ( "Error: " + anException );
        } finally {
            try {
                bufferedScanner.close();
            } catch ( Exception anException ) {
                System.out.println ( "Error: " + anException );
            }
        }
        return theLeague;
    }
    public void display() {
        System.out.println ( this.name );
        System.out.format ( "%20s %2s %2s %2s %2s %2s %2s %    2s\n", "", "P", "W", "L", "D", "F", "A", "Pt" );
        for ( Team eachTeam : this.teams ) {
            System.out.format ( "%20s %2d %2d %2d %2d %2d %2d %2d\n",
                                eachTeam.getName(), eachTeam.getPlayed(),
                                eachTeam.getWon(), eachTeam.getDrawn(),
                                eachTeam.getLost(), eachTeam.getGoalsFor(),
                                eachTeam.getGoalsAgainst(), eachTeam.getPoints() );
        }
    }
    public void sort() {
    }
}
