import java.util.Random;
private static final Random random = new Random();
public static int nextRandom ( int maxValueExclusive ) {
    return random.nextInt ( maxValueExclusive );
}
public static long nextRandom ( long maxValueExclusive ) {
    if ( maxValueExclusive <= 0 ) {
        throw new IllegalArgumentException ( "argument must be positive: " + maxValueExclusive );
    }
    long offset = 0;
    while ( maxValueExclusive >= Integer.MAX_VALUE ) {
        long half = maxValueExclusive >>> 1;
        long nextn = random.nextBoolean() ? half : maxValueExclusive - half;
        if ( random.nextBoolean() ) {
            offset += maxValueExclusive - nextn;
        }
        maxValueExclusive = nextn;
    }
    return offset + random.nextInt ( ( int ) maxValueExclusive );
}
public static double nextRandom ( double maxValueExclusive ) {
    if ( maxValueExclusive <= 0 ) {
        throw new IllegalArgumentException ( "argument must be positive: " + maxValueExclusive );
    }
    return random.nextDouble() * maxValueExclusive;
}
public static float nextRandom ( float maxValueExclusive ) {
    if ( maxValueExclusive <= 0 ) {
        throw new IllegalArgumentException ( "argument must be positive: " + maxValueExclusive );
    }
    return random.nextFloat() * maxValueExclusive;
}
public static boolean nextRandom ( boolean unusedValue ) {
    return random.nextBoolean();
}
