import java.util.ArrayList;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.sun.xml.internal.ws.util.StringUtils;
public class TestClass {
    public static void main ( String args[] ) throws Exception {
        String text = "EXCLUDES(ABC) EXCLUDES(ABC) INCLUDES(BMG) INCLUDES(EFG) INCLUDES(IJK)";
        List<String> matchedList = findMatchPhrase ( "INCLUDES", text );
        String query = combinePhrase ( text, "INCLUDES", matchedList );
        System.out.println ( query );
    }
    private static String combinePhrase ( String expression, String keyword, List<String> matchedItemList ) {
        if ( matchedItemList.isEmpty() || matchedItemList.size() == 1 ) {
            return expression;
        }
        String matchedItem = null;
        for ( int index = 1; index < matchedItemList.size(); index++ ) {
            matchedItem = matchedItemList.get ( index );
            expression = expression.replace ( matchedItem, "" );
        }
        StringBuffer textBuffer = new StringBuffer ( expression );
        StringBuffer combineStrBuf = new StringBuffer();
        if ( matchedItemList.size() > 1 ) {
            for ( int index = 1; index < matchedItemList.size(); index++ ) {
                String str = matchedItemList.get ( index );
                combineStrBuf.append ( ( parseValue ( keyword, str ) ) );
                combineStrBuf.append ( " & " );
            }
            combineStrBuf.delete ( combineStrBuf.lastIndexOf ( " & " ), combineStrBuf.length() );
        }
        return injectInPhrase ( keyword, textBuffer, combineStrBuf.toString() );
    }
    private static String injectInPhrase ( String keyword, StringBuffer textBuffer, String injectStr ) {
        Matcher matcher = getMatcher ( textBuffer.toString() );
        while ( matcher.find() ) {
            String subStr = matcher.group();
            if ( subStr.startsWith ( keyword ) ) {
                textBuffer.insert ( matcher.end() - 1, " & ".concat ( injectStr ) );
                break;
            }
        }
        return textBuffer.toString();
    }
    private static String parseValue ( String keyword, String expression ) {
        String parsStr = "";
        if ( expression.indexOf ( keyword ) > -1 ) {
            parsStr = expression.replace ( keyword, "" ).replace ( "(", "" ).replace ( ")", "" );
        }
        return parsStr;
    }
    private static Matcher getMatcher ( String expression ) {
        String patternString = "(\\w+)\\((.*?)\\)";
        Pattern pattern = Pattern.compile ( patternString );
        return pattern.matcher ( expression );
    }
    private static List<String> findMatchPhrase ( String keyword, String expression ) {
        List<String> matchList = new ArrayList<String> ( 3 );
        keyword = StringUtils.capitalize ( keyword );
        Matcher matcher = getMatcher ( expression );
        while ( matcher.find() ) {
            String subStr = matcher.group();
            if ( subStr.startsWith ( keyword ) ) {
                matchList.add ( subStr );
            }
        }
        return matchList;
    }
}
