void polarToLatLong ( double lat, double lon, double dist, double radial,
                      double * outlat, double * outlon ) {
    if ( !dist ) {
        * outlat = lat;
        * outlon = lon;
    } else if ( lat > 89.9999 ) {
        * outlat = 90 - dist / 60;
        * outlon = fmod ( radial + 180 ) - 180;
    } else {
        double sinlat, coslon;
        dist /= 3442;
        sinlat = Sin ( lat ) * cos ( dist ) + Cos ( lat ) * sin ( dist ) * Cos ( radial );
        * outlat = Arcsin ( sinlat );
        coslon = ( cos ( dist ) - Sin ( lat ) * sinlat ) / ( Cos ( lat ) * Cos ( * outlat ) );
        * outlon = lon + ( Sin ( radial ) >= 0 : -1 : 1 ) * Arccos ( coslon );
    }
}
