import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.LineNumberReader;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreeSelectionModel;
public class TreeFromTextFile {
    private BufferedReader in;
    private LineNumberReader ln;
    private String line;
    private String root;
    private String filename = "TheTextFile.txt";
    private String encoding = "UTF-8";
    private DefaultMutableTreeNode top;
    private JTree tree;
    public TreeFromTextFile() {
        getRootNode();
        top = new DefaultMutableTreeNode ( root );
        createNodes ( top );
        tree = new JTree ( top );
        tree.getSelectionModel().setSelectionMode ( TreeSelectionModel.SINGLE_TREE_SELECTION );
    }
    public void readFile() {
        try {
            in = new BufferedReader ( new InputStreamReader ( getClass().getResourceAsStream ( filename ), encoding ) );
            while ( ( line = in.readLine() ) != null ) {
                System.out.println ( line );
            }
            in.close();
        } catch ( Exception e ) {
            e.printStackTrace();
        }
    }
    private void getRootNode() {
        try {
            in = new BufferedReader ( new InputStreamReader ( getClass().getResourceAsStream ( filename ), encoding ) );
            ln = new LineNumberReader ( in );
            if ( ln.getLineNumber() == 0 ) {
                root = ln.readLine();
            }
            in.close();
        } catch ( Exception e ) {
            e.printStackTrace();
        }
    }
    private int countOccurrences ( String haystack, char needle ) {
        int count = 0;
        for ( int i = 0; i < haystack.length(); i++ ) {
            if ( haystack.charAt ( i ) == needle ) {
                count++;
            }
        }
        return count;
    }
    private void createNodes ( DefaultMutableTreeNode top ) {
        DefaultMutableTreeNode category = null;
        DefaultMutableTreeNode subCategory = null;
        DefaultMutableTreeNode leaf = null;
        try {
            in = new BufferedReader ( new InputStreamReader ( getClass().getResourceAsStream ( filename ), encoding ) );
            while ( ( line = in.readLine() ) != null ) {
                if ( countOccurrences ( line, '\t' ) == 1 ) {
                    category = new DefaultMutableTreeNode ( line );
                    top.add ( category );
                } else if ( countOccurrences ( line, '\t' ) == 2 ) {
                    subCategory = new DefaultMutableTreeNode ( line );
                    category.add ( subCategory );
                } else if ( countOccurrences ( line, '\t' ) == 3 ) {
                    leaf = new DefaultMutableTreeNode ( line );
                    subCategory.add ( leaf );
                }
            }
            in.close();
        } catch ( Exception e ) {
            e.printStackTrace();
        }
    }
    public JTree getTree() {
        return tree;
    }
}
