public static void createZip ( Path zipLocation, Path toBeAdded, String internalPath ) throws Throwable {
    Map<String, String> env = new HashMap<String, String>();
    env.put ( "create", String.valueOf ( !zipLocation.toFile().exists() ) );
    URI fileUri = zipLocation.toUri();
    URI zipUri = new URI ( "jar:" + fileUri.getScheme(), fileUri.getPath(), null );
    System.out.println ( zipUri );
    try ( FileSystem zipfs = FileSystems.newFileSystem ( zipUri, env ) ) {
        Path internalTargetPath = zipfs.getPath ( internalPath );
        if ( !Files.exists ( internalTargetPath.getParent() ) ) {
            Files.createDirectory ( internalTargetPath.getParent() );
        }
        Files.copy ( toBeAdded, internalTargetPath, StandardCopyOption.REPLACE_EXISTING );
    }
}
public static void main ( String[] args ) throws Throwable {
    Path zipLocation = FileSystems.getDefault().getPath ( "a.zip" ).toAbsolutePath();
    Path toBeAdded = FileSystems.getDefault().getPath ( "a.txt" ).toAbsolutePath();
    createZip ( zipLocation, toBeAdded, "aa/aa.txt" );
}
