public final class GeometryUtil {
    public static final double EARTH_RADIUS_IN_METERS = 6.37814e+6;
    private GeometryUtil() {}
    public static Coordinate toCoordinate ( GeoPoint geoPoint, GeoPoint geoPointRelative ) {
        return new Coordinate ( toX ( geoPoint, geoPointRelative.getLongitude() ),
                                toY ( geoPoint, geoPointRelative.getLatitude() ) );
    }
    public static double toX ( GeoPoint geoPoint, double relativeLongitude ) {
        return  EARTH_RADIUS_IN_METERS *
                cos ( toRadians ( geoPoint.getLatitude() ) )  *
                toRadians ( geoPoint.getLongitude() - relativeLongitude );
    }
    public static double toY ( GeoPoint geoPoint, double relativeLatitude ) {
        return  EARTH_RADIUS_IN_METERS * toRadians ( geoPoint.getLatitude() - relativeLatitude );
    }
}
