protected void createWakeLocks() {
    PowerManager powerManager = ( PowerManager ) getSystemService ( Context.POWER_SERVICE );
    fullWakeLock = powerManager.newWakeLock ( ( PowerManager.SCREEN_BRIGHT_WAKE_LOCK | PowerManager.FULL_WAKE_LOCK | PowerManager.ACQUIRE_CAUSES_WAKEUP ), "Loneworker - FULL WAKE LOCK" );
    partialWakeLock = powerManager.newWakeLock ( PowerManager.PARTIAL_WAKE_LOCK, "Loneworker - PARTIAL WAKE LOCK" );
}
protected void onPause() {
    super.onPause();
    partialWakeLock.acquire();
}
protected void onResume() {
    super.onResume();
    if ( fullWakeLock.isHeld() ) {
        fullWakeLock.release();
    }
    if ( partialWakeLock.isHeld() ) {
        partialWakeLock.release();
    }
}
public void wakeDevice() {
    fullWakeLock.acquire();
    KeyguardManager keyguardManager = ( KeyguardManager ) getSystemService ( Context.KEYGUARD_SERVICE );
    KeyguardLock keyguardLock = keyguardManager.newKeyguardLock ( "TAG" );
    keyguardLock.disableKeyguard();
}
