Public class BluetoothManager extends Thread {
    boolean running = true;
    GUIController controller;
    public BluetoothManager ( GUIController controller ) {
        this.controller = controller;
    }
    public void stop() {
        this.running = false;
    }
    public void run() {
        this.localDevice = LocalDevice.getLocalDevice();
        this.localDevice.setDiscoverable ( DiscoveryAgent.GIAC );
        this.server = ( StreamConnectionNotifier ) Connector.open ( URL );
        while ( running ) {
            StreamConnection connection = this.server.acceptAndOpen();
            System.out.println ( "INFO: Bluetooth client connected" );
            BufferedInputStream bis = new BufferedInputStream ( this.connection.openInputStream() );
            ObjectInputStream ois = new ObjectInputStream ( bis );
            ArrayList contacts = ( ArrayList ) ois.readObject();
            System.out.println ( "INFO: Received from Bluetooth: " + contacts );
            this.connection.close();
            System.out.println ( "INFO: Client disconnected" );
            this.controller.refreshContacts ( contacts );
        }
    }
}
public class GUIController extends Thread implements Runnable {
    ArrayList contacts;
    BluetoothManager manager;
    public void run() {
        this.contacts = new ArrayList();
        FileReader fr = new FileReader ( "C:\WhereverYourFileIs\Contacts.file" );
        BufferedReader br = new BufferedReader ( fr );
    }
    public void startBluetoothManager() {
        this.manager = new BluetoothManager ( this );
        this.manager.start();
    }
    public void abortBluetoothManager() {
        this.manager.stop();
        this.manager = null;
    }
    public void refreshContacts ( ArrayList contacts ) {
        Iterator i = this.contacts.iterator();
        while ( i.hasNext() ) {
            this.contacts.add ( i.next() );
        }
    }
}
