@Controller
@RequestMapping ( "/errors" )
public class ErrorController {
    @RequestMapping ( value = "/redirect", method = RequestMethod.GET )
    public void errorRedirect ( HttpServletRequest request, HttpServletResponse response ) {
        String uri = ( String ) request.getAttribute ( WebUtils.ERROR_REQUEST_URI_ATTRIBUTE );
        String filename = WebUtils.extractFullFilenameFromUrlPath ( uri );
        String extension = StringUtils.getFilenameExtension ( filename );
        extension = StringUtils.hasText ( extension ) ? "." + extension : "";
        String forwardUri = "/errors/404" + extension );
        request.getRequestDispatcher ( forwardUri ).forward ( request, response );
    }
    @RequestMapping ( value = "/404", method = RequestMethod.GET )
    @ResponseBody
    public ResponseEntity<ErrorResponse> error404() {
        ErrorResponse errorBody = new ErrorResponse ( 404, "Resource Not Found!" );
        return new ResponseEntity<ErrorResponse> ( errorBody, HttpStatus.NOT_FOUND );
    }
}
