import java.util.Random;
public class Maze {
    private final int[][] grid;
    private final int width, height;
    public static void main ( String args[] ) {
        Maze mz = new Maze ( 20, 20 );
        mz.moveMouse();
    }
    private void generateDefaultMaze() {
        System.out.println ( this );
        for ( int curr = 0; curr < height; curr++ ) {
            grid[0][curr] = 2;
            grid[curr][0] = 2;
            grid[height - 1][curr] = 2;
            grid[curr][width - 1] = 2;
        }
        for ( int row = 1; row < height - 1; row++ ) {
            for ( int col = 1; col < width - 1; col++ ) {
                grid[row][col] = 1;
            }
        }
        System.out.println ( this );
    }
    public Maze ( int width, int height ) {
        this.width = width;
        this.height = height;
        grid = new int[width][height];
        this.generateDefaultMaze();
    }
    @Override
    public String toString() {
        StringBuffer sb = new StringBuffer ( 1024 );
        for ( int i = 0; i < this.width; i++ ) {
            for ( int j = 0; j < this.height; j++ ) {
                sb.append ( this.grid[i][j] ).append ( "," );
            }
            sb.append ( "\n" );
        }
        sb.append ( "\n" );
        sb.append ( "**************" );
        sb.append ( "\n" );
        return sb.toString();
    }
    private boolean isValidTurn ( int row, int col ) {
        if ( row >= 0 && row < width && ! ( this.grid[col][row] == 0 ) ) {
            return true;
        }
        return false;
    }
    public void moveMouse() {
        Random r = new Random();
        int row = r.nextInt ( width );
        int col = 0;
        grid[col][row] = 0;
        while ( col < ( this.height - 1 ) ) {
            int nextDir = r.nextInt ( 3 );
            switch ( nextDir ) {
            case 0:
                if ( this.isValidTurn ( ( row - 1 ), col ) ) {
                    --row;
                    this.grid[col][row] = 0;
                }
                break;
            case 1:
                if ( this.isValidTurn ( ( row + 1 ), col ) ) {
                    ++row;
                    this.grid[col][row] = 0;
                }
                break;
            case 2:
                ++col;
                this.grid[col][row] = 0;
                break;
            }
            System.out.println ( "turn : " + nextDir );
        }
        System.out.println ( this );
    }
}
