public String createList ( Element root, int depth ) {
    final String indentation = createIndentation ( depth );
    StringBuilder sb = new StringBuilder();
    final String typeAttr = root.attr ( "type" );
    char type = typeAttr.isEmpty() ? '1' : typeAttr.charAt ( 0 );
    for ( Element sub : root.children() ) {
        switch ( sub.tagName() ) {
        case "li":
            sb.append ( indentation ).append ( type++ ).append ( ". " ).append ( sub.ownText() ).append ( "\n" );
            break;
        case "ol":
        case "ul":
            if ( !sub.children().isEmpty() ) {
                sb.append ( createList ( sub, depth + 1 ) );
            }
            break;
        default:
            System.err.println ( "Not implemented tag: " + sub.tagName() );
        }
    }
    return sb.toString();
}
private String createIndentation ( int length ) {
    StringBuilder sb = new StringBuilder ( length );
    for ( int i = 0; i < length; i++ ) {
        sb.append ( ' ' );
    }
    return sb.toString();
}
