public class ConnectTheDots {
    public static void main ( String[] args ) {
        new ConnectTheDots();
    }
    public ConnectTheDots() {
        EventQueue.invokeLater ( new Runnable() {
            @Override
            public void run() {
                try {
                    UIManager.setLookAndFeel ( UIManager.getSystemLookAndFeelClassName() );
                } catch ( Exception ex ) {
                }
                PaintPane pp = new PaintPane();
                JFrame frame = new JFrame ( "Test" );
                frame.setGlassPane ( pp );
                pp.setVisible ( true );
                frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
                frame.add ( new DotsPane ( pp ) );
                frame.pack();
                frame.setLocationRelativeTo ( null );
                frame.setVisible ( true );
            }
        } );
    }
    public class PaintPane extends JPanel {
        private List<JButton[]> connections;
        private JButton lastSelected;
        public PaintPane() {
            setOpaque ( false );
            connections = new ArrayList<> ( 25 );
        }
        @Override
        protected void paintComponent ( Graphics g ) {
            super.paintComponent ( g );
            Graphics2D g2d = ( Graphics2D ) g.create();
            if ( lastSelected != null ) {
                g2d.setColor ( Color.RED );
                int x = lastSelected.getX() + ( ( lastSelected.getWidth() - 8 ) / 2 );
                int y = lastSelected.getY() + ( ( lastSelected.getHeight() - 8 ) / 2 );
                g2d.fillOval ( x, y, 8, 8 );
            }
            for ( JButton[] group : connections ) {
                g2d.setColor ( Color.BLUE );
                Point startPoint = group[0].getLocation();
                Point endPoint = group[1].getLocation();
                startPoint.x += ( group[0].getWidth() / 2 );
                startPoint.y += ( group[1].getHeight() / 2 );
                endPoint.x += ( group[0].getWidth() / 2 );
                endPoint.y += ( group[1].getHeight() / 2 );
                g2d.draw ( new Line2D.Float ( startPoint, endPoint ) );
            }
            g2d.dispose();
        }
        protected void buttonClicked ( JButton btn ) {
            if ( lastSelected == null ) {
                lastSelected = btn;
            } else {
                connections.add ( new JButton[] {lastSelected, btn} );
                lastSelected = null;
            }
            revalidate();
            repaint();
        }
    }
    public class DotsPane extends JPanel {
        private PaintPane paintPane;
        public DotsPane ( final PaintPane pp ) {
            paintPane = pp;
            ActionListener al = new ActionListener() {
                @Override
                public void actionPerformed ( ActionEvent e ) {
                    JButton btn = ( JButton ) e.getSource();
                    paintPane.buttonClicked ( btn );
                }
            };
            setLayout ( new GridLayout ( 6, 6 ) );
            for ( int index = 0; index < 6 * 6; index++ ) {
                JButton btn = new JButton ( "." );
                add ( btn );
                btn.addActionListener ( al );
            }
        }
        @Override
        public Dimension getPreferredSize() {
            return new Dimension ( 200, 200 );
        }
    }
}
