public class BikeBuilder {
    private String model;
    private String wheelSize;
    private String shocks;
    private String racingHandleBarType;
    public BikeBuilder setModel ( String model ) {
        this.model = model;
        return this;
    }
    public Bike build() {
        Bike bike;
        if ( shocks != null ) {
            bike = new MountainBike();
            handleMountainBike ( ( MountainBike ) bike );
        } else if ( racingHandleBarType != null ) {
            bike = new RacingBike();
            handleRacingBike ( ( RacingBike ) bike );
        } else {
            bike = new Bike();
        }
        handleCommonAttributes ( bike );
        return bike;
    }
    private void handleCommonAttributes ( Bike bike ) {
        bike.setModel ( model );
        bike.setWheelSize ( wheelSize );
    }
    private void handleMountainBike ( MountainBike bike ) {
        bike.setShocks ( shocks );
    }
    private void handleRacingBike ( RacingBike bike ) {
        bike.setRacingHandleBarType ( racingHandleBarType );
    }
}
