@Test
public void testProxy() throws InstantiationException, IllegalAccessException {
    Employee aBean = new Employee();
    aBean.setName ( "Obi-Wan" );
    aBean.setSurname ( "Kenobi" );
    Employee protectedBean = Utils.createInmutableBean ( Employee.class, aBean );
    System.out.println ( "Name: " + protectedBean.getName() );
    System.out.println ( "Name: " + protectedBean.getSurname() );
    try {
        protectedBean.setName ( "Luke" );
        protectedBean.setSurname ( "Skywalker" );
        throw new RuntimeException ( "The test should not have reached this line!" );
    } catch ( Exception e ) {
        System.out.println ( "The exception was expected! The bean should not be modified (exception message: " + e.getMessage() + ")" );
        assertEquals ( "Obi-Wan", protectedBean.getName() );
        assertEquals ( "Kenobi", protectedBean.getSurname() );
    }
}
