public class WorldObjectConverter implements Converter<WorldObject> {
    @Override
    public WorldObject read ( InputNode node ) throws Exception {
        throw new UnsupportedOperationException ( "Not supported yet." );
    }
    @Override
    public void write ( OutputNode node, WorldObject value ) throws Exception {
        final Field f = value.getClass().getDeclaredField ( "vectorNames" );
        final Element elementAnnotation = f.getAnnotation ( Element.class );
        final String name = elementAnnotation.name();
        node.setName ( name );
        for ( List<String> list : value.getVectorNames() ) {
            OutputNode subList = node.getChild ( "list-string" );
            for ( String str : list ) {
                OutputNode stringNode = subList.getChild ( "string" );
                stringNode.setValue ( str );
            }
            subList.commit();
        }
        node.commit();
    }
}
