import java.util.List;
import org.hibernate.criterion.Restrictions;
public class SplitHibernateIn {
    private static int PARAMETER_LIMIT = 999;
    public static org.hibernate.criterion.Criterion buildInCriterion ( String propertyName, List values ) {
        org.hibernate.criterion.Criterion criterion = null;
        int listSize = values.size();
        for ( int i = 0; i < listSize; i += PARAMETER_LIMIT ) {
            List subList;
            if ( listSize > i + PARAMETER_LIMIT ) {
                subList = values.subList ( i, ( i + PARAMETER_LIMIT ) );
            } else {
                subList = values.subList ( i, listSize );
            }
            if ( criterion != null ) {
                criterion = Restrictions.or ( criterion, Restrictions.in ( propertyName, subList ) );
            } else {
                criterion = Restrictions.in ( propertyName, subList );
            }
        }
        return criterion;
    }
}
