private static Connection getConnection (
    String url, java.util.Properties info, ClassLoader callerCL ) throws SQLException {
    if ( url == null ) {
        throw new SQLException ( "The url cannot be null", "08001" );
    }
    SQLException reason = null;
    for ( DriverInfo aDriver : registeredDrivers ) {
        if ( isDriverAllowed ( aDriver.driver, callerCL ) ) {
            try {
                println ( "    trying " + aDriver.driver.getClass().getName() );
                Connection con = aDriver.driver.connect ( url, info );
                if ( con != null ) {
                    println ( "getConnection returning " + aDriver.driver.getClass().getName() );
                    return ( con );
                }
            } catch ( SQLException ex ) {
                if ( reason == null ) {
                    reason = ex;
                }
            }
        } else {
            println ( "    skipping: " + aDriver.getClass().getName() );
        }
    }
    if ( reason != null )    {
        println ( "getConnection failed: " + reason );
        throw reason;
    }
    println ( "getConnection: no suitable driver found for " + url );
    throw new SQLException ( "No suitable driver found for " + url, "08001" );
}
