@SuppressLint ( "SimpleDateFormat" )
public class JacksonSimpleDateFormat extends SimpleDateFormat {
    public JacksonSimpleDateFormat() {
        if ( mParser == null ) {
            mParser = new SimpleDateFormat ( "yyyy-MM-dd'T'HH:mm:ss" );
            mParser.setTimeZone ( TimeZone.getTimeZone ( "UTC" ) );
        }
    }
    @Override
    public StringBuffer format ( Date date, StringBuffer buffer, FieldPosition field ) {
        return mParser.format ( date, buffer, field );
    }
    private static SimpleDateFormat mParser;
    @Override
    public Date parse ( String string, ParsePosition position ) {
        String str = string.split ( "\\." ) [0];
        Date date = null;
        try {
            date = mParser.parse ( str );
        } catch ( ParseException e ) {
            e.printStackTrace();
        }
        position.setIndex ( string.length() - 1 );
        return date;
    }
    @Override
    public Object clone() {
        return new JacksonSimpleDateFormat();
    }
}
