import java.io.*;
import java.net.*;
import java.util.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.text.html.*;
class GetHTML {
    public static void main ( String[] args ) {
        EditorKit kit = new HTMLEditorKit();
        Document doc = kit.createDefaultDocument();
        doc.putProperty ( "IgnoreCharsetDirective", Boolean.TRUE );
        try {
            Reader rd = getReader ( args[0] );
            kit.read ( rd, doc, 0 );
            System.out.println ( doc.getText ( 0, doc.getLength() ) );
            System.out.println ( "----" );
            ElementIterator it = new ElementIterator ( doc );
            Element elem = null;
            while ( ( elem = it.next() ) != null ) {
                AttributeSet as = elem.getAttributes();
                System.out.println ( "\n" + elem.getName() + " : " + as.getAttributeCount() );
                Enumeration enum1 = as.getAttributeNames();
                while ( enum1.hasMoreElements() ) {
                    Object name = enum1.nextElement();
                    Object value = as.getAttribute ( name );
                    System.out.println ( "\t" + name + " : " + value );
                    if ( value instanceof DefaultComboBoxModel ) {
                        DefaultComboBoxModel model = ( DefaultComboBoxModel ) value;
                        for ( int j = 0; j < model.getSize(); j++ ) {
                            Object o = model.getElementAt ( j );
                            Object selected = model.getSelectedItem();
                            if ( o.equals ( selected ) ) {
                                System.out.println ( o + " : selected" );
                            } else {
                                System.out.println ( o );
                            }
                        }
                    }
                }
                if ( elem.getName().equals ( HTML.Tag.SELECT.toString() ) ) {
                    Object o = as.getAttribute ( HTML.Attribute.ID );
                    System.out.println ( o );
                }
                if ( elem.getElementCount() == 0 ) {
                    int start = elem.getStartOffset();
                    int end = elem.getEndOffset();
                    System.out.println ( "\t" + doc.getText ( start, end - start ) );
                }
            }
        } catch ( Exception e ) {
            e.printStackTrace();
        }
        System.exit ( 1 );
    }
    static Reader getReader ( String uri )
    throws IOException {
        if ( uri.startsWith ( "http:" ) ) {
            URLConnection conn = new URL ( uri ).openConnection();
            return new InputStreamReader ( conn.getInputStream() );
        } else {
            return new FileReader ( uri );
        }
    }
}
