package com.example.dndlist;
import java.util.ArrayList;
import java.util.Arrays;
import android.app.Activity;
import android.os.Bundle;
import android.view.Menu;
import android.widget.ArrayAdapter;
import com.mobeta.android.dslv.DragSortController;
import com.mobeta.android.dslv.DragSortListView;
public class MainActivity extends Activity {
    DragSortListView listView;
    ArrayAdapter<String> adapter;
    private DragSortListView.DropListener onDrop = new DragSortListView.DropListener() {
        @Override
        public void drop ( int from, int to ) {
            if ( from != to ) {
                String item = adapter.getItem ( from );
                adapter.remove ( item );
                adapter.insert ( item, to );
            }
        }
    };
    private DragSortListView.RemoveListener onRemove = new DragSortListView.RemoveListener() {
        @Override
        public void remove ( int which ) {
            adapter.remove ( adapter.getItem ( which ) );
        }
    };
    @Override
    protected void onCreate ( Bundle savedInstanceState ) {
        super.onCreate ( savedInstanceState );
        setContentView ( R.layout.activity_main );
        listView = ( DragSortListView ) findViewById ( R.id.listview );
        String[] names = getResources().getStringArray ( R.array.random_names );
        ArrayList<String> list = new ArrayList<String> ( Arrays.asList ( names ) );
        adapter = new ArrayAdapter<String> ( this,
                                             R.layout.item_layout, R.id.textView1, list );
        listView.setAdapter ( adapter );
        listView.setDropListener ( onDrop );
        listView.setRemoveListener ( onRemove );
        DragSortController controller = new DragSortController ( listView );
        controller.setDragHandleId ( R.id.imageView1 );
        controller.setRemoveEnabled ( false );
        controller.setSortEnabled ( true );
        controller.setDragInitMode ( 1 );
        listView.setFloatViewManager ( controller );
        listView.setOnTouchListener ( controller );
        listView.setDragEnabled ( true );
    }
    @Override
    public boolean onCreateOptionsMenu ( Menu menu ) {
        getMenuInflater().inflate ( R.menu.main, menu );
        return true;
    }
}
