@Asynchronous
public Future<String> sayHelloAsync() {
    return new AsyncResult<String> ( "Hello world" );
}
Then in a second Bean exposing its method as Web Services I have done the following:
@WebService
@Stateless
public class Test {
    @EJB
    FirstBean myFirstBean;
    private Future<String> myAsyncResult;
    @WebMethod
    @WebResult ( name = "hello" )
    public String sayHello ( @WebParam ( name = "timeout_in_seconds" ) long timeout ) {
        myAsyncResult = myFirstBean.sayHelloAsync();
        String myResult = "Service is still running";
        if ( timeout > 0 ) {
            try {
                myResult = myAsyncResult.get ( timeout, TimeUnit.SECONDS );
            } catch ( InterruptedException e ) {
                myResult = "InterruptedException occured";
            } catch ( ExecutionException e ) {
                myResult = "ExecutionException occured";
            } catch ( TimeoutException e ) {
                myResult = "The timeout value " + timeout + " was reached." +
                           " The Service is still running.";
            }
        }
        return myResult;
    }
}
If the timeout is set, then the client will wait this amount of time until it is reached.
The process still has to run in my case.
I hope it will help others.
Emmanuel
