import java.io.File;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import net.sf.vfsjfilechooser.VFSJFileChooser;
import net.sf.vfsjfilechooser.filechooser.AbstractVFSFileSystemView;
import org.apache.commons.vfs.FileObject;
import org.apache.commons.vfs.FileSystemException;
public class TestFileChooser {
    public static void main ( String[] args ) {
        VFSJFileChooser fc = new VFSJFileChooser ( new Test() );
        fc.showOpenDialog ( null );
    }
    public static class Test extends AbstractVFSFileSystemView {
        @Override
        public FileObject[] getFiles ( FileObject dir, boolean useFileHiding ) {
            FileObject[] files = super.getFiles ( dir, false );
            List<FileObject> fileList = new ArrayList<FileObject> ( Arrays.asList ( files ) );
            if ( !isFileSystemRoot ( dir ) ) {
                FileObject newPath = AbstractVFSFileSystemView.getFileSystemView().createFileObject ( dir, "/.." );
                fileList.add ( 0, newPath );
            }
            files = fileList.toArray ( files );
            return files;
        }
        @Override
        public FileObject createNewFolder ( FileObject containingDir ) {
            FileObject newFolder = createFileObject ( containingDir + File.separator + "New Folder" );
            try {
                if ( newFolder.isWriteable() ) {
                    newFolder.createFolder();
                } else {
                    newFolder = null;
                }
            } catch ( FileSystemException ex ) {
            }
            return newFolder;
        }
    }
}
