public class Test {
    static final int S = 9;
    int[][] sudo;
    public Test() {
        sudo = new int[S][S];
    }
    public Test ( int[][] sudo ) {
        this.sudo = sudo;
    }
    public boolean checkHorizontal ( int row, int num ) {
        for ( int i = 0; i < S; i++ ) {
            if ( sudo[row][i] == num ) {
                return false;
            }
        }
        return true;
    }
    public boolean checkVertical ( int col, int num ) {
        for ( int i = 0; i < S; i++ ) {
            if ( sudo[i][col] == num ) {
                return false;
            }
        }
        return true;
    }
    private boolean checkBox ( int row, int col, int num ) {
        int r = ( row / 3 ) * 3;
        int c = ( col / 3 ) * 3;
        for ( int i = r; i < r + 3; i++ ) {
            for ( int j = c; j < c + 3; j++ ) {
                if ( sudo[i][j] == num ) {
                    return false;
                }
            }
        }
        return true;
    }
    boolean check ( int row, int col, int num ) {
        return checkHorizontal ( row, num )
               && checkVertical ( col, num )
               && checkBox ( row, col, num );
    }
    public boolean solve ( int row, int col ) {
        if ( row >= S ) {
            return true;
        }
        if ( sudo[row][col] == 0 ) {
            for ( int num = 1; num < 10; num++ ) {
                if ( check ( row, col, num ) ) {
                    sudo[row][col] = num;
                    if ( next ( row, col ) ) {
                        return true;
                    }
                }
            }
            sudo[row][col] = 0;
        } else {
            if ( next ( row, col ) ) {
                return true;
            }
        }
        return false;
    }
    public boolean next ( int row, int col ) {
        if ( col < S - 1 ) {
            return solve ( row, col + 1 );
        } else {
            return solve ( row + 1, 0 );
        }
    }
    public boolean boardOk() {
        boolean ok = sudo.length == S;
        for ( int row = 0; ok && row < S; row++ ) {
            ok &= sudo[row].length == S;
            for ( int col = 0; ok && col < S; col++ ) {
                if ( sudo[row][col] != 0 ) {
                    int num = sudo[row][col];
                    sudo[row][col] = 0;
                    ok &= check ( row, col, num );
                    sudo[row][col] = num;
                }
            }
        }
        return ok;
    }
    void solve() {
        if ( boardOk() ) {
            boolean solved = solve ( 0, 0 );
            if ( solved ) {
                System.out.println ( "Solved!" );
                print();
            }
        } else {
            System.out.println ( "Insoluble!" );
            print();
        }
    }
    public void print() {
        for ( int i = 0; i < sudo.length; i++ ) {
            System.out.println ( Arrays.toString ( sudo[i] ) );
        }
    }
    public static void main ( String[] args ) {
        new Test().solve();
        int[][] test = {
            {0, 0, 6, 5, 8, 3, 3, 2, 7},
            {0, 0, 0, 0, 9, 0, 0, 5, 0},
            {5, 8, 0, 0, 0, 0, 0, 0, 3},
            {0, 3, 1, 0, 4, 0, 5, 0, 0},
            {0, 0, 0, 9, 2, 0, 3, 0, 6},
            {0, 0, 0, 0, 0, 0, 0, 0, 1},
            {3, 4, 2, 0, 0, 6, 9, 1, 5},
            {5, 0, 5, 4, 0, 9, 0, 3, 2},
            {0, 1, 0, 0, 0, 0, 0, 0, 4},
        };
        new Test ( test ).solve();
    }
}
