class ImageCanvas implements Serializable {
    transient List<BufferedImage> images;
    private void writeObject ( ObjectOutputStream out ) throws IOException {
        out.defaultWriteObject();
        out.writeInt ( images.size() );
        for ( BufferedImage eachImage : images ) {
            ImageIO.write ( eachImage, "png", out );
        }
    }
    private void readObject ( ObjectInputStream in ) throws IOException, ClassNotFoundException {
        in.defaultReadObject();
        final int imageCount = in.readInt();
        images = new ArrayList<BufferedImage> ( imageCount );
        for ( int i = 0; i < imageCount; i++ ) {
            images.add ( ImageIO.read ( in ) );
        }
    }
}
