public class TestSelectionMonitor {
    public static void main ( String[] args ) {
        new TestSelectionMonitor();
    }
    public TestSelectionMonitor() {
        EventQueue.invokeLater ( new Runnable() {
            @Override
            public void run() {
                try {
                    UIManager.setLookAndFeel ( UIManager.getSystemLookAndFeelClassName() );
                } catch ( ClassNotFoundException | InstantiationException | IllegalAccessException | UnsupportedLookAndFeelException ex ) {
                }
                final JTextArea ta = new JTextArea();
                ta.addCaretListener ( new CaretListener() {
                    @Override
                    public void caretUpdate ( CaretEvent e ) {
                        int length = ta.getSelectionEnd() - ta.getSelectionStart();
                        System.out.println ( length );
                    }
                } );
                JFrame frame = new JFrame ( "Testing" );
                frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
                frame.setLayout ( new BorderLayout() );
                frame.add ( new JScrollPane ( ta ) );
                frame.pack();
                frame.setLocationRelativeTo ( null );
                frame.setVisible ( true );
            }
        } );
    }
}
