public class YourModule extend AbstractModule {
    @Override public void configure() {
        Provider<Settings> settingsProvider = binder().getProvider ( Settings.class );
        for ( Config config : Config.values() ) {
            String propertyName = config.getPropertyName();
            bind ( String.class ).annotatedWith ( config.annotation() ).toProvider (
                new GetValueFromSettingsProvider ( settingsProvider, propertyName ) );
        }
    }
}
