import java.util.ArrayList;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
public class TestPatternMatch {
    public static void main ( String[] args ) {
        List<User> result = new ArrayList<>();
        String input =
            "Wilson#$20#$Male=@=Raymond#$25#$Male=@=Sophie#$30#$Female";
        Pattern recPatt =
            Pattern.compile ( "^(=@=|.{0})(.+?)#\\$(\\d+)#\\$(.+?)(?==@=)(.*$)" );
        Matcher recMatcher;
        String workStr = input;
        while ( workStr != null && workStr.length() > 0 ) {
            recMatcher = recPatt.matcher ( workStr );
            if ( recMatcher.matches() && recMatcher.groupCount() >= 5 ) {
                result.add (
                    new User (
                        recMatcher.group ( 2 ),
                        Integer.parseInt ( recMatcher.group ( 3 ) ),
                        recMatcher.group ( 4 )
                    )
                );
                workStr = recMatcher.group ( 5 );
            } else {
                workStr = null;
            }
        }
        System.out.println ( result );
    }
}
class User {
    String  name;
    int     age;
    String  gender;
    public User ( String name, int age, String gender ) {
        this.name = name;
        this.age = age;
        this.gender = gender;
    }
    public String toString() {
        return "User [" + name + ", " + age + ", " + gender + "]";
    }
}
