package com.quartetfs.biz.pivot.aggfun.impl;
import com.quartetfs.fwk.QuartetPluginValue;
@QuartetPluginValue ( interfaceName = "com.quartetfs.biz.pivot.aggfun.IAggregationFunction" )
public class DoubleVectorSum extends GenericAggregationFunction<DoubleVector, DoubleVector> {
    private static final long serialVersionUID = 11699698472584733L;
    public DoubleVectorSum() {
        super ( "VectorSum" );
    }
    @Override
    public String description() {
        return "Function to sum compressed double vectors";
    }
    @Override
    protected DoubleVector aggregate ( boolean removal, DoubleVector aggregate, DoubleVector input ) {
        return aggregate.add ( input, removal );
    }
    @Override
    protected DoubleVector merge ( boolean removal, DoubleVector main, DoubleVector contribution ) {
        return main.add ( contribution, removal );
    }
    @Override
    protected DoubleVector cloneAggregate ( DoubleVector aggregate ) {
        return aggregate.clone();
    }
}
