public class AToBMapperImpl implements AToBMapper {
    public static final long EXPIRE_TIME_IN_SECONDS =
        TimeUnit.SECONDS.convert ( 1, TimeUnit.HOURS );
    private final SomeDAO dao;
    private final ConcurrentMap<String, String> cache;
    private final Stopwatch stopwatch;
    public AToBMapperImpl ( SomeDAO dao ) {
        this.dao = dao;
        stopwatch = new Stopwatch();
        cache = new MapMaker().concurrencyLevel ( 2 ).makeMap();
    }
    @Override
    public synchronized String getBForA ( final String a ) {
        if ( !stopwatch.isRunning() ) {
            cache.putAll ( getNewCacheContents() );
            stopwatch.start();
        }
        if ( stopwatch.elapsedTime ( TimeUnit.SECONDS ) >= EXPIRE_TIME_IN_SECONDS ) {
            cache.clear();
            cache.putAll ( getNewCacheContents() );
            stopwatch.reset();
        }
        return cache.containsKey ( a ) ? cache.get ( a ) : new String ( DEFAULT_B_NAME );
    }
    private Map<String, String> getNewCacheContents() {
        return getTheData ( Arrays.asList ( "keys", "you", "want", "to", "load" ) );
    }
    private Map<String, String> getTheData ( List<String> listOfB ) {
        return dao.getAToBMapping ( listOfB );
    }
}
