private class ListIterator implements Iterator<V> {
    private Node next;
    private boolean alreadyDeleted = false;
    ListIterator ( Node node ) {
        this.next = node;
    }
    @Override
    public boolean hasNext() {
        return next != null;
    }
    @Override
    public V next() {
        if ( next == null ) {
            throw new NoSuchElementException();
        }
        Node current = next;
        this.next = current.getNext();
        this.alreadyDeleted = false;
        return current;
    }
    @Override
    public void remove() {
        if ( alreadyDeleted || next == null ) {
            throw new IllegalStateException();
        }
        removeElement ( next.getReprKey() );
        this.alreadyRemoved = true;
    }
}
