import java.io.*;
public class CharacterStretcher {
    public static void main ( String[] args ) {
        File inputFile = new File ( "c:\\data.txt" );
        File outputFile = new File ( "c:\\temp.txt" );
        try {
            final FileInputStream fstream = new FileInputStream ( inputFile );
            final BufferedReader reader = new BufferedReader ( new InputStreamReader ( fstream ) );
            final BufferedWriter writer = new BufferedWriter ( new FileWriter ( outputFile, false ) );
            String line;
            while ( ( line = reader.readLine() ) != null ) {
                StringBuilder newLine = new StringBuilder();
                String[] parts = line.split ( " " );
                for ( String part : parts ) {
                    try {
                        int number = Integer.parseInt ( part );
                        newLine.append ( String.valueOf ( number * 4 ) );
                    } catch ( NumberFormatException nfEx ) {
                        newLine.append ( part );
                    }
                    newLine.append ( " " );
                }
                writer.append ( newLine.toString().substring ( 0, newLine.toString().length() - 1 ) + "\r\n" );
                writer.flush();
            }
            reader.close();
            writer.close();
        } catch ( FileNotFoundException e ) {
            e.printStackTrace();
        } catch ( IOException e ) {
            e.printStackTrace();
        }
    }
}
