static enum CrimeCategory {
    ASBO ( "Anti Social Behaviour" ),
    BURG ( "Burglary" ),
    CRIMDAM ( "Criminal Damage And Arson" ),
    DRUGS ( "Drugs" ),
    OTHTHEFT ( "Other Theft" ),
    PUPDISOR ( "Public Disorder And Weapons" ),
    ROBBERY ( "Robbery" ),
    SHOPLIF ( "Shoplifting" ),
    VEHICLE ( "Vehicle Crime" ),
    VIOLENT ( "Violent Crime" ),
    OTHER ( "Other Crime" );
    private final static Map<String, CrimeCategory> map =
    new HashMap<String, CrimeCategory> ( CrimeCategory.values().length, 1.0f );
    static {
        for ( CrimeCategory c : CrimeCategory.values() ) {
            map.put ( c.category, c );
        }
    }
    private String category;
    private CrimeCategory ( String category ) {
        this.category = category;
    }
    public static CrimeCategory of ( String name ) {
        CrimeCategory result = map.get ( name );
        if ( result == null ) {
            throw new IllegalArgumentException ( "No Category Exists" );
        }
        return result;
    }
}
