public class EntityCustomSerializationFactory extends CustomSerializerFactory {
    private static final Set<String> IGNORED_FIELDS = new HashSet<String> (
        Arrays.asList (
            "class",
            "value",
            "some"
        )
    );
    public EntityCustomSerializationFactory() {
        super();
    }
    public EntityCustomSerializationFactory ( Config config ) {
        super ( config );
    }
    @Override
    protected void processViews ( SerializationConfig config, BeanSerializerBuilder builder ) {
        super.processViews ( config, builder );
        if ( builder.getBeanDescription().getBeanClass().equals ( Entity.class ) ) {
            List<BeanPropertyWriter> originalWriters = builder.getProperties();
            List<BeanPropertyWriter> writers = new ArrayList<BeanPropertyWriter>();
            for ( BeanPropertyWriter writer : originalWriters ) {
                String propName = writer.getName();
                if ( !IGNORED_FIELDS.contains ( propName ) ) {
                    writers.add ( writer );
                }
            }
            builder.setProperties ( writers );
        }
    }
}
