public class StudyManagerDataSource {
    SQLiteOpenHelper dbHelper;
    SQLiteDatabase database;
    public StudyManagerDataSource ( Context context ) {
        dbHelper = new DatabaseAdapter ( context );
    }
    public void addAlarm ( Alarm alarm ) {
        open();
        ContentValues values = new ContentValues();
        values.put ( KEY_DESC, alarm.getDesc() );
        values.put ( KEY_REPEAT_DAY, alarm.getRepeatDay() );
        values.put ( KEY_REPEAT_TYPE, alarm.getRepeatType() );
        values.put ( KEY_CALENDAR, Long.toString ( alarm.getCalendarInMillis() ) );
        values.put ( KEY_APP, alarm.getApp() );
        values.put ( KEY_ACTIVE, alarm.getActive() );
        database.insert ( TABLE_NAME, null, values );
        close();
    }
    public void open() {
        database = dbHelper.getWritableDatabase();
        Log.i ( LOG_TAG, "Database Opened" );
    }
    public void close() {
        Log.i ( LOG_TAG, "Database Closed" );
        dbHelper.close();
    }
}
