public class SpeedTestExamNameActivity extends Activity {
    Spinner exam_list_spinner;
    Button  detailsBtn;
    TextView showUser;
    String full_name;
    ArrayList<String> menuItems = new ArrayList<String>();
    ArrayList<String> menuKeys = new ArrayList<String>();
    String responseBody;
    String xmlContent = null;
    static final String KEY_EXAMSET = "ExamSet";
    static final String KEY_SETID = "SetId";
    static final String KEY_SETNAME = "SetName";
    @Override
    protected void onCreate ( Bundle savedInstanceState ) {
        super.onCreate ( savedInstanceState );
        setContentView ( R.layout.activity_speed_test_exam_name );
        isOnline_downloadList();
        full_name = getFromPreference ( "user_name" );
        showUser = ( TextView ) findViewById ( R.id.speed_username_textView );
        showUser.setText ( "Welcome, " + full_name );
        exam_list_spinner = ( Spinner ) findViewById ( R.id.speed_examlist_spinner );
        addItemsOnExamListSpinner();
        detailsBtn = ( Button ) findViewById ( R.id.speed_exam_details_button );
        detailsBtn.setOnClickListener ( new View.OnClickListener() {
            @Override
            public void onClick ( View v ) {
                Toast.makeText ( SpeedTestExamNameActivity.this,
                                 "Exam List Spinner: " +
                                 String.valueOf ( exam_list_spinner.getSelectedItem() ),
                                 Toast.LENGTH_SHORT ).show();
                Toast.makeText ( SpeedTestExamNameActivity.this,
                                 "Exam List Spinner Key: " + menuKeys.get ( exam_list_spinner.getSelectedItemPosition() ),
                                 Toast.LENGTH_SHORT ).show();
                Intent intent = new Intent ( SpeedTestExamNameActivity.this, SpeedTestActivity.class );
                SpeedTestExamNameActivity.this.startActivity ( intent );
            }
        } );
    }
    public String getFromPreference ( String variable_name ) {
        String preference_return;
        SharedPreferences preferences = PreferenceManager.getDefaultSharedPreferences ( this );
        preference_return = preferences.getString ( variable_name, "" );
        return preference_return;
    }
    public boolean isOnline_downloadList() {
        ConnectivityManager cm = ( ConnectivityManager ) getSystemService ( Context.CONNECTIVITY_SERVICE );
        NetworkInfo netInfo = cm.getActiveNetworkInfo();
        if ( netInfo != null && netInfo.isConnectedOrConnecting() ) {
            new MyAsyncTask().execute ( getFromPreference ( "student_code" ) );
            return true;
        }
        AlertDialog.Builder Internet_Alert = new AlertDialog.Builder ( SpeedTestExamNameActivity.this );
        Internet_Alert.setCancelable ( false );
        Internet_Alert.setTitle ( "Attention!" );
        Internet_Alert.setMessage ( "This application requires internet connectivity, no internet connection detected" );
        Internet_Alert.setPositiveButton ( "Quit", new DialogInterface.OnClickListener() {
            public void onClick ( DialogInterface arg0, int arg1 ) {
                Intent intent = new Intent ( Intent.ACTION_MAIN );
                intent.addCategory ( Intent.CATEGORY_HOME );
                intent.setFlags ( Intent.FLAG_ACTIVITY_NEW_TASK );
                startActivity ( intent );
                onQuitPressed();
            }
        } );
        Internet_Alert.create().show();
        return false;
    }
    public void onQuitPressed() {
        int pid = android.os.Process.myPid();
        android.os.Process.killProcess ( pid );
    }
    private class MyAsyncTask extends AsyncTask<String, Integer, Double> {
        @Override
        protected Double doInBackground ( String... params ) {
            postData ( params[0] );
            return null;
        }
        protected void onPostExecute ( Double result ) {
            xmlContent = responseBody;
            parse_ExamList();
        }
        protected void onProgressUpdate ( Integer... progress ) {
        }
        public void postData ( String student_code ) {
            HttpClient httpclient = new DefaultHttpClient();
            SharedPreferences preferences = PreferenceManager.getDefaultSharedPreferences ( SpeedTestExamNameActivity.this );
            final String url_first = preferences.getString ( "URLFirstPart", "" );
            HttpPost httppost = new HttpPost ( url_first + "ExamList" );
            try {
                List<NameValuePair> nameValuePairs = new ArrayList<NameValuePair>();
                nameValuePairs.add ( new BasicNameValuePair ( "StudentCode", student_code ) );
                httppost.setEntity ( new UrlEncodedFormEntity ( nameValuePairs ) );
                httppost.setEntity ( new UrlEncodedFormEntity ( nameValuePairs ) );
                HttpResponse response = httpclient.execute ( httppost );
                responseBody = EntityUtils.toString ( response.getEntity() );
                Log.d ( "result", responseBody );
            } catch ( Throwable t ) {
                Log.d ( "Error Time of Login", t + "" );
            }
        }
    }
    void parse_ExamList() {
        XMLParser parser = new XMLParser();
        Document doc = parser.getDomElement ( xmlContent );
        NodeList nl = doc.getElementsByTagName ( KEY_EXAMSET );
        for ( int i = 0; i < nl.getLength(); i++ ) {
            Element e = ( Element ) nl.item ( i );
            menuKeys.add ( parser.getValue ( e, KEY_SETID ) );
            menuItems.add ( parser.getValue ( e, KEY_SETNAME ) );
        }
    }
    public void addItemsOnExamListSpinner() {
        List<String> list = new ArrayList<String>();
        list.add ( "Speed Test 150(min) PO Set-01" );
        ArrayAdapter<String> dataAdapter = new ArrayAdapter<String> ( this,
                android.R.layout.simple_spinner_item, menuItems );
        dataAdapter.setDropDownViewResource ( android.R.layout.simple_spinner_dropdown_item );
        exam_list_spinner.setAdapter ( dataAdapter );
    }
}
