class ModelBase {
    private static Map<String, ModelBase> daoMap = new HashMap<String, ModelBase>();
    static {
        selectMap.put ( "Album", new AlbumModel() );
        selectMap.put ( "Artist", new ArtistModel() );
        selectMap.put ( "Track", new TrackModel() );
    }
    public static List findAll ( Class classToFind ) {
        String sql = getSelectSQL ( classToFind );
        results = execute ( sql );
        return ....
    }
    private static String getSelectSQL ( Class classToFind ) {
        ModelBase dao = tableMap.get ( classToFind.getSimpleName() );
        if ( statement == null ) {
            throw new IllegalArgumentException ( "Class " +
                                                 classToFind.getSimpleName + " is not mapped" );
        }
        return dao.selectSql();
    }
    protected abstract String selectSql();
}
class AlbumModel  extends ModelBase {
    public String selectSql() {
        return "select ... from album";
    }
}
class ArtistModel  extends ModelBase {
    public String selectSql() {
        return "select ... from artist";
    }
}
class TrackModel  extends ModelBase {
    public String selectSql() {
        return "select ... from track";
    }
}
