public class FullScreenExample extends JFrame {
    public class FullScreen {
        private GraphicsDevice device;
        private JFrame frame;
        private boolean isFullScreen;
        public FullScreen() {
            frame = new JFrame();
            JPanel content = new JPanel();
            content.setLayout ( new BorderLayout() );
            frame.setContentPane ( content );
            frame.setUndecorated ( true );
            frame.addKeyListener ( new KeyListener() {
                @Override
                public void keyPressed ( KeyEvent e ) {
                    if ( e.getKeyCode() == KeyEvent.VK_ESCAPE ) {
                        exitFullScreen();
                    }
                }
                @Override
                public void keyReleased ( KeyEvent e ) {}
                @Override
                public void keyTyped ( KeyEvent e ) {}
            } );
        }
        public void enterFullScreen() {
            if ( !isFullScreen ) {
                GraphicsConfiguration config = FullScreenExample.this.getGraphicsConfiguration();
                device = config.getDevice();
                myWrapper.remove ( myPanel );
                frame.getContentPane().add ( myPanel );
                device.setFullScreenWindow ( frame );
                isFullScreen = true;
            }
        }
        public void exitFullScreen() {
            if ( isFullScreen ) {
                frame.getContentPane().remove ( myPanel );
                myWrapper.add ( myPanel );
                device.setFullScreenWindow ( null );
                frame.dispose();
                FullScreenExample.this.validate();
                isFullScreen = false;
            }
        }
    }
    private JPanel myPanel, myWrapper;
    public static void main ( String[] args ) {
        SwingUtilities.invokeLater ( new Runnable() {
            @Override
            public void run() {
                FullScreenExample frame = new FullScreenExample();
                frame.init();
                frame.setVisible ( true );
            }
        } );
    }
    public void init() {
        JPanel content = new JPanel();
        content.setBorder ( new EmptyBorder ( 5, 5, 5, 5 ) );
        content.setLayout ( new BorderLayout() );
        this.setContentPane ( content );
        this.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
        myPanel = new JPanel();
        myPanel.setBackground ( Color.BLUE );
        JButton fullscreen = new JButton ( "Full Screen" );
        final FullScreen fs = new FullScreen();
        fullscreen.addActionListener ( new ActionListener() {
            public void actionPerformed ( ActionEvent arg0 ) {
                fs.enterFullScreen();
            }
        } );
        myWrapper = new JPanel();
        myWrapper.setLayout ( new BorderLayout() );
        myWrapper.add ( myPanel );
        content.add ( myWrapper, BorderLayout.CENTER );
        content.add ( fullscreen, BorderLayout.SOUTH );
        this.setBounds ( 100, 100, 350, 350 );
    }
}
