public class SkipColumnAction extends WrappedAction {
    private JTable table;
    private Set columnsToSkip;
    public SkipColumnAction ( JTable table, KeyStroke keyStroke, Set columnsToSkip ) {
        super ( table, keyStroke );
        this.table = table;
        this.columnsToSkip = columnsToSkip;
    }
    public void actionPerformed ( ActionEvent e ) {
        TableColumnModel tcm = table.getColumnModel();
        String header;
        do {
            invokeOriginalAction ( e );
            int column = table.getSelectedColumn();
            header = tcm.getColumn ( column ).getHeaderValue().toString();
        } while ( columnsToSkip.contains ( header ) );
    }
}
