JTable myTable = new JTable ( 10, 4 ) {
    private boolean inLayout;
    @Override
    public boolean getScrollableTracksViewportWidth() {
        return hasExcessWidth();
    }
    @Override
    public void doLayout() {
        if ( hasExcessWidth() ) {
            autoResizeMode = AUTO_RESIZE_SUBSEQUENT_COLUMNS;
        }
        inLayout = true;
        super.doLayout();
        inLayout = false;
        autoResizeMode = AUTO_RESIZE_OFF;
    }
    protected boolean hasExcessWidth() {
        return getPreferredSize().width < getParent().getWidth();
    }
    @Override
    public void columnMarginChanged ( ChangeEvent e ) {
        if ( isEditing() ) {
            removeEditor();
        }
        TableColumn resizingColumn = getTableHeader().getResizingColumn();
        if ( resizingColumn != null && autoResizeMode == AUTO_RESIZE_OFF
                && !inLayout ) {
            resizingColumn.setPreferredWidth ( resizingColumn.getWidth() );
        }
        resizeAndRepaint();
    }
};
