import java.awt.Dimension;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JProgressBar;
import javax.swing.SwingWorker;
public class SwingWorkerEg {
    public static void main ( String args[] ) {
        java.awt.EventQueue.invokeLater ( new Runnable() {
            @Override
            public void run() {
                final MainFrame mainFrame = new MainFrame();
                final SomeDialog someDialog = new SomeDialog ( mainFrame );
                mainFrame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
                mainFrame.pack();
                mainFrame.setLocationRelativeTo ( null );
                someDialog.pack();
                someDialog.setLocationRelativeTo ( null );
                ImageLoadingWorker ilw = new ImageLoadingWorker();
                ilw.addPropertyChangeListener ( new PropertyChangeListener() {
                    @Override
                    public void propertyChange ( PropertyChangeEvent pcEvt ) {
                        if ( SwingWorker.StateValue.DONE == pcEvt.getNewValue() ) {
                            someDialog.setVisible ( false );
                            mainFrame.setVisible ( true );
                        }
                    }
                } );
                ilw.execute();
                someDialog.setVisible ( true );
            }
        } );
    }
}
class ImageLoadingWorker extends SwingWorker<Void, Void> {
    private static final long SLEEP_TIME = 5 * 1000;
    @Override
    protected Void doInBackground() throws Exception {
        Thread.sleep ( SLEEP_TIME );
        return null;
    }
}
class SomeDialog extends JDialog {
    private static final int PREF_W = 300;
    private static final int PREF_H = 60;
    public SomeDialog ( JFrame frame ) {
        super ( frame, "Some Dialog", ModalityType.APPLICATION_MODAL );
        JProgressBar progressBar = new JProgressBar();
        progressBar.setIndeterminate ( true );
        add ( progressBar );
    }
    @Override
    public Dimension getPreferredSize() {
        return new Dimension ( PREF_W, PREF_H );
    }
}
class MainFrame extends JFrame {
    private static final int PREF_W = 400;
    private static final int PREF_H = PREF_W;
    public MainFrame() {
        super ( "Main Frame" );
    }
    @Override
    public Dimension getPreferredSize() {
        return new Dimension ( PREF_W, PREF_H );
    }
}
