public class Server {
    public static void main ( String[] args ) {
        new Server().startServer();
    }
    public void startServer() {
        final ExecutorService clientProcessingPool = Executors.newFixedThreadPool ( 10 );
        Runnable serverTask = new Runnable() {
            @Override
            public void run() {
                try {
                    ServerSocket serverSocket = new ServerSocket ( 8000 );
                    System.out.println ( "Waiting for clients to connect..." );
                    while ( true ) {
                        Socket clientSocket = serverSocket.accept();
                        clientProcessingPool.submit ( new ClientTask ( clientSocket ) );
                    }
                } catch ( IOException e ) {
                    System.err.println ( "Unable to process client request" );
                    e.printStackTrace();
                }
            }
        };
        Thread serverThread = new Thread ( serverTask );
        serverThread.start();
    }
    private class ClientTask implements Runnable {
        private final Socket clientSocket;
        private ClientTask ( Socket clientSocket ) {
            this.clientSocket = clientSocket;
        }
        @Override
        public void run() {
            System.out.println ( "Got a client !" );
            try {
                clientSocket.close();
            } catch ( IOException e ) {
                e.printStackTrace();
            }
        }
    }
}
