public class Html5RenderKitFactory extends RenderKitFactory {
    private RenderKitFactory wrapped;
    public Html5RenderKitFactory ( RenderKitFactory wrapped ) {
        this.wrapped = wrapped;
    }
    @Override
    public void addRenderKit ( String renderKitId, RenderKit renderKit ) {
        wrapped.addRenderKit ( renderKitId, renderKit );
    }
    @Override
    public RenderKit getRenderKit ( FacesContext context, String renderKitId ) {
        RenderKit renderKit = wrapped.getRenderKit ( context, renderKitId );
        return ( HTML_BASIC_RENDER_KIT.equals ( renderKitId ) ) ? new Html5RenderKit ( renderKit ) : renderKit;
    }
    @Override
    public Iterator<String> getRenderKitIds() {
        return wrapped.getRenderKitIds();
    }
}
