public abstract class AbstractMediaPickerActivity extends Activity {
    protected static int RESULT_LOAD_IMAGE = 1;
    @Override
    public void onCreate ( Bundle savedInstanceState ) {
        super.onCreate ( savedInstanceState );
    }
    protected void startMediaPicker() {
        Intent i = new Intent ( Intent.ACTION_PICK, android.provider.MediaStore.Images.Media.EXTERNAL_CONTENT_URI );
        startActivityForResult ( i, RESULT_LOAD_IMAGE );
    }
    protected abstract void onImagePicked ( String picturePath );
    @Override
    protected void onActivityResult ( int requestCode, int resultCode, Intent data ) {
        super.onActivityResult ( requestCode, resultCode, data );
        if ( requestCode == RESULT_LOAD_IMAGE && resultCode == RESULT_OK && null != data ) {
            Uri selectedImage = data.getData();
            String[] filePathColumn = { MediaStore.Images.Media.DATA };
            Cursor cursor = getContentResolver().query ( selectedImage, filePathColumn, null, null, null );
            cursor.moveToFirst();
            int columnIndex = cursor.getColumnIndex ( filePathColumn[0] );
            String picturePath = cursor.getString ( columnIndex );
            cursor.close();
            onImagePicked ( picturePath );
        }
    }
}
