@ManagedBean ( name = "testBean" )
@SessionScoped
public class TestBackingBean {
    private String filter = StringUtils.EMPTY;
    private final List<Car> carModels = new ArrayList<Car>() {
        {
            add ( new Car ( "toyota" ) );
            add ( new Car ( "honda" ) );
            add ( new Car ( "suzuki" ) );
            add ( new Car ( "ford" ) );
            add ( new Car ( "renault" ) );
            add ( new Car ( "subaru" ) );
        }
    };
    public void onValueChange ( AjaxBehaviorEvent event ) {
        AutoComplete ac = ( AutoComplete ) event.getSource();
        Car input = ( Car ) ac.getValue();
        filter = ( input == null ) ? StringUtils.EMPTY : input.getCarmodel();
    }
    public List<Car> complete ( String input ) {
        filter = input;
        return getMatchingCarModels();
    }
    public List<Car> getMatchingCarModels() {
        if ( StringUtils.isEmpty ( filter ) ) {
            return carModels;
        }
        List<Car> matches = new ArrayList<Car>();
        for ( Car car : carModels ) {
            if ( car.getCarmodel().startsWith ( filter ) ) {
                matches.add ( car );
            }
        }
        return matches;
    }
    private Car selectedCar;
}
