private void executeProgramFromClasspath() throws IOException {
    InputStream input = getClass().getResourceAsStream ( "/program.exe" );
    if ( input == null ) {
        throw new IllegalStateException ( "Missing classpath resource." );
    }
    OutputStream output = null;
    try {
        File temporaryFile = File.createTempFile ( getClass().getName(), "" );
        output = new FileOutputStream ( temporaryFile );
        output = new BufferedOutputStream ( output );
        IOUtils.copy ( input, output );
    } finally {
        IOUtils.closeQuietly ( input );
        IOUtils.closeQuietly ( output );
    }
    try {
        String path = temporaryFile.getAbsolutePath();
        ProcessBuilder processBuilder = new ProcessBuilder ( path );
        Process process = processBuilder.start();
        process.waitFor();
    } catch ( InterruptedException e ) {
        throw new IOException ( e );
    } finally {
        if ( !temporaryFile.delete() ) {
        }
    }
}
