public class URLImageParser implements ImageGetter {
    Context c;
    View container;
    public URLImageParser ( View t, Context c ) {
        this.c = c;
        this.container = t;
    }
    public Drawable getDrawable ( String source ) {
        URLDrawable urlDrawable = new URLDrawable();
        ImageGetterAsyncTask asyncTask =
            new ImageGetterAsyncTask ( urlDrawable );
        asyncTask.execute ( source );
        return urlDrawable;
    }
    public class ImageGetterAsyncTask extends AsyncTask<String, Void, Drawable>  {
        URLDrawable urlDrawable;
        public ImageGetterAsyncTask ( URLDrawable d ) {
            this.urlDrawable = d;
        }
        @Override
        protected Drawable doInBackground ( String... params ) {
            String source = params[0];
            return fetchDrawable ( source );
        }
        @Override
        protected void onPostExecute ( Drawable result ) {
            urlDrawable.setBounds ( 0, 0, 0 + result.getIntrinsicWidth(), 0
                                    + result.getIntrinsicHeight() );
            urlDrawable.drawable = result;
            URLImageParser.this.container.invalidate();
        }
        public Drawable fetchDrawable ( String urlString ) {
            try {
                InputStream is = fetch ( urlString );
                Drawable drawable = Drawable.createFromStream ( is, "src" );
                drawable.setBounds ( 0, 0, 0 + drawable.getIntrinsicWidth(), 0
                                     + drawable.getIntrinsicHeight() );
                return drawable;
            } catch ( Exception e ) {
                return null;
            }
        }
        private InputStream fetch ( String urlString ) throws MalformedURLException, IOException {
            DefaultHttpClient httpClient = new DefaultHttpClient();
            HttpGet request = new HttpGet ( urlString );
            HttpResponse response = httpClient.execute ( request );
            return response.getEntity().getContent();
        }
    }
}
