public class PersonlistProcessor {
    public static void main ( String[] args ) throws Exception {
        new PersonlistProcessor().processPersonlist ( PersonlistProcessor.class
                .getResourceAsStream ( "personlist.xml" ) );
    }
    public void processPersonlist ( InputStream inputStream ) throws Exception {
        JAXBContext jaxbContext = JAXBContext.newInstance ( Person.class );
        XMLStreamReader xss = XMLInputFactory.newFactory().createXMLStreamReader ( inputStream );
        Unmarshaller unmarshaller = jaxbContext.createUnmarshaller();
        xss.nextTag();
        xss.require ( XMLStreamReader.START_ELEMENT, "http://example.org", "Personlist" );
        while ( xss.nextTag() == XMLStreamReader.START_ELEMENT ) {
            xss.require ( XMLStreamReader.START_ELEMENT, "http://example.org", "Person" );
            Person person = ( Person ) unmarshaller.unmarshal ( xss );
            processPerson ( person );
        }
        xss.require ( XMLStreamReader.END_ELEMENT, "http://example.org", "Personlist" );
    }
    private void processPerson ( Person person ) {
        System.out.println ( person.getName() );
        System.out.println ( person.getAddress().getCountryName() );
    }
}
