public class LineChartValueMarker extends Application {
    private Line valueMarker = new Line();
    private XYChart.Series<Number, Number> series = new XYChart.Series<>();
    private NumberAxis yAxis;
    private double yShift;
    private void updateMarker() {
        double max = 0;
        for ( Data<Number, Number> value : series.getData() ) {
            double y = value.getYValue().doubleValue();
            if ( y > max ) {
                max = y;
            }
        }
        double displayPosition = yAxis.getDisplayPosition ( max );
        valueMarker.setStartY ( yShift + displayPosition );
        valueMarker.setEndY ( yShift + displayPosition );
    }
    @Override
    public void start ( Stage stage ) {
        LineChart<Number, Number> chart = new LineChart<> ( new NumberAxis ( 0, 100, 10 ), yAxis = new NumberAxis ( 0, 100, 10 ) );
        series.getData().add ( new XYChart.Data ( 0, 0 ) );
        series.getData().add ( new XYChart.Data ( 10, 20 ) );
        chart.getData().addAll ( series );
        Pane pane = new Pane();
        pane.getChildren().addAll ( chart, valueMarker );
        Scene scene = new Scene ( pane );
        chart.setOnMouseClicked ( new EventHandler<MouseEvent>() {
            @Override
            public void handle ( MouseEvent t ) {
                series.getData().add ( new XYChart.Data ( series.getData().size() * 10, 30 + 50 * new Random().nextDouble() ) );
                updateMarker();
            }
        } );
        stage.setScene ( scene );
        stage.show();
        Node chartArea = chart.lookup ( ".chart-plot-background" );
        Bounds chartAreaBounds = chartArea.localToScene ( chartArea.getBoundsInLocal() );
        yShift = chartAreaBounds.getMinY();
        valueMarker.setStartX ( chartAreaBounds.getMinX() );
        valueMarker.setEndX ( chartAreaBounds.getMaxX() );
        updateMarker();
    }
    public static void main ( String[] args ) {
        launch();
    }
}
