public class Test {
    public void test() {
        int[] limits = {3, -5, 7};
        int[] order = {0, 2, 1};
        int[] starts = {0, 0, 0};
        int[] steps = {1, -1, 2};
        NDimensionalStepper nds = new NDimensionalStepper ( limits, order, starts, steps );
        do {
            System.out.println ( nds );
        } while ( nds.step() );
    }
    public static void main ( String args[] ) {
        new Test().test();
    }
    public static class NDimensionalStepper {
        final int[] i;
        final int[] starts;
        final int[] steps;
        final int[] limits;
        final int[] order;
        int d = 0;
        public NDimensionalStepper ( int[] limits, int[] order, int[] starts, int[] steps ) {
            this.i = Arrays.copyOf ( starts, starts.length );
            this.starts = Arrays.copyOf ( starts, starts.length );
            this.steps = Arrays.copyOf ( steps, steps.length );
            this.limits = Arrays.copyOf ( limits, limits.length );
            this.order = Arrays.copyOf ( order, order.length );
        }
        public NDimensionalStepper ( int[] limits, int[] order, int[] starts ) {
            this ( limits, order, starts, defaultSteps ( limits, starts ) );
        }
        private static int[] defaultSteps ( int[] limits, int[] starts ) {
            int[] steps = new int[limits.length];
            for ( int i = 0; i < limits.length; i++ ) {
                steps[i] = ( int ) Math.signum ( limits[i] - starts[i] );
            }
            return steps;
        }
        public NDimensionalStepper ( int[] limits, int[] order ) {
            this ( limits, order, defaultStarts ( limits.length ) );
        }
        private static int[] defaultStarts ( int d ) {
            int[] starts = new int[d];
            Arrays.fill ( starts, 0 );
            return starts;
        }
        public NDimensionalStepper ( int[] limits ) {
            this ( limits, defaultOrder ( limits.length ) );
        }
        private static int[] defaultOrder ( int d ) {
            int[] order = new int[d];
            for ( int i = 0; i < d; i++ ) {
                order[i] = d - i - 1;
            }
            return order;
        }
        public int get ( int d ) {
            return i[d];
        }
        public boolean step() {
            boolean stepped = false;
            boolean finished = false;
            while ( !stepped && !finished ) {
                int o = order[d];
                while ( finished ( o ) && d < order.length - 1 ) {
                    o = order[++d];
                }
                if ( d < order.length && !finished ( o ) ) {
                    i[o] += steps[o];
                    stepped = true;
                    while ( d > 0 ) {
                        d -= 1;
                        i[order[d]] = starts[order[d]];
                    }
                } else {
                    finished = true;
                }
            }
            return !finished;
        }
        private boolean finished ( int o ) {
            int sign = ( int ) Math.signum ( steps[o] );
            return sign * ( i[o] + steps[o] ) >= sign * limits[o];
        }
        @Override
        public String toString() {
            StringBuilder s = new StringBuilder();
            s.append ( "{" );
            for ( int d = 0; d < order.length; d++ ) {
                s.append ( get ( d ) );
                if ( d < order.length - 1 ) {
                    s.append ( "," );
                }
            }
            s.append ( "}" );
            return s.toString();
        }
    }
}
