@ServiceProvider ( service = ContextGlobalProvider.class,
                   supersedes = "org.netbeans.modules.openide.windows.GlobalActionContextImpl" )
public class CentralLookup implements ContextGlobalProvider {
    private final InstanceContent content = new InstanceContent();
    private final Lookup lookup = new AbstractLookup ( content );
    public CentralLookup() {}
    public void add ( Object instance ) {
        content.add ( instance );
    }
    public void remove ( Object instance ) {
        content.remove ( instance );
    }
    public static CentralLookup getInstance() {
        return CentralLookupHolder.INSTANCE;
    }
    @Override
    public Lookup createGlobalContext() {
        return lookup;
    }
    private static class CentralLookupHolder {
        private static final CentralLookup INSTANCE = Lookup.getDefault().lookup ( CentralLookup.class );
    }
}
