import com.gargoylesoftware.htmlunit.BrowserVersion;
import com.gargoylesoftware.htmlunit.BrowserVersionFeatures;
import com.gargoylesoftware.htmlunit.FailingHttpStatusCodeException;
import com.gargoylesoftware.htmlunit.PluginConfiguration;
import com.gargoylesoftware.htmlunit.WebClient;
import com.gargoylesoftware.htmlunit.html.DomElement;
import com.gargoylesoftware.htmlunit.html.DomNodeList;
import com.gargoylesoftware.htmlunit.html.HtmlPage;
import java.io.IOException;
public class GetFlashObjectElement {
    private final static BrowserVersion FIREFOX_10_WITH_FLASH_11 = new BrowserVersion (
        BrowserVersion.FIREFOX_10.getApplicationName(),
        BrowserVersion.FIREFOX_10.getApplicationVersion(),
        BrowserVersion.FIREFOX_10.getUserAgent(),
        BrowserVersion.FIREFOX_10.getBrowserVersionNumeric(),
        new BrowserVersionFeatures[] {
            BrowserVersionFeatures.JS_FRAME_RESOLVE_URL_WITH_PARENT_WINDOW,
            BrowserVersionFeatures.STYLESHEET_HREF_EXPANDURL,
            BrowserVersionFeatures.STYLESHEET_HREF_STYLE_NULL
        } );
    static {
        PluginConfiguration plugin = new PluginConfiguration (
            "Shockwave Flash",
            "Shockwave Flash 11.4 r402",
            "NPSWF32_11_4_402_287.dll" );
        plugin.getMimeTypes().add ( new PluginConfiguration.MimeType (
                                        "application/x-shockwave-flash",
                                        "Adobe Flash movie",
                                        "swf" ) );
        FIREFOX_10_WITH_FLASH_11.getPlugins().add ( plugin );
    }
    public static void main ( String[] args ) {
        try {
            WebClient webClient = new WebClient ( FIREFOX_10_WITH_FLASH_11 );
            HtmlPage page = webClient.getPage ( "http://www.br.de/fernsehen/bayerisches-fernsehen/sendungen/abendschau/bayerwald-tierpark-livereportage-100.html" );
            webClient.waitForBackgroundJavaScript ( 2000 );
            DomNodeList<DomElement> objectList = page.getElementsByTagName ( "object" );
            for ( int i = 0; i < objectList.getLength(); i++ ) {
                String objectString = objectList.get ( i ).asXml();
                System.out.println ( objectString );
            }
            webClient.closeAllWindows();
        } catch ( IOException | FailingHttpStatusCodeException e ) {
            System.err.println ( e.getMessage() );
        }
    }
}
