import java.awt.EventQueue;
import java.util.List;
import javax.swing.SwingWorker;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
public class WaitForSwingWorker {
    public static void main ( String[] args ) {
        new WaitForSwingWorker();
    }
    public WaitForSwingWorker() {
        EventQueue.invokeLater ( new Runnable() {
            @Override
            public void run() {
                try {
                    UIManager.setLookAndFeel ( UIManager.getSystemLookAndFeelClassName() );
                } catch ( ClassNotFoundException | InstantiationException | IllegalAccessException | UnsupportedLookAndFeelException ex ) {
                }
                ConnectionListener callback = new ConnectionListener() {
                    @Override
                    public void connectionEstablished() {
                    }
                    @Override
                    public void connectionFailed() {
                    }
                };
                new ConnectionWorker ( callback ).execute();
            }
        } );
    }
    public interface ConnectionListener {
        public void connectionEstablished();
        public void connectionFailed();
    }
    public class ConnectionWorker extends SwingWorker<Void, String> {
        private ConnectionListener callBack;
        public ConnectionWorker ( ConnectionListener listener ) {
            callBack = listener;
        }
        @Override
        protected void process ( List<String> chunks ) {
            String msg = chunks.get ( chunks.size() - 1 );
            if ( msg.equals ( "WAITING" ) ) {
            }
        }
        @Override
        protected Void doInBackground() throws Exception {
            if ( !isConnected ) {
                publish ( "WAITING" );
            }
            return null;
        }
        @Override
        protected void done() {
            if ( isConnected ) {
                callBack.connectionEstablished();
            } else {
                callBack.connectionFailed();
            }
        }
    }
}
