public class ContactList {
    static class Contact {
        String lastName;
        Contact ( final String lastName ) {
            this.lastName = lastName;
        }
        @Override
        public String toString() {
            return String.format ( "Contact[%s]", this.lastName );
        }
    }
    static final int MAX_CONTACTS = 10;
    Contact[] contactList = new Contact[MAX_CONTACTS];
    void add ( final Contact newContact ) {
        if ( newContact == null || newContact.lastName == null ) {
            return;
        }
        Contact contactToAdd = newContact;
        for ( int pos = 0; pos < MAX_CONTACTS; pos++ ) {
            final Contact current = this.contactList[pos];
            if ( current == null ) {
                this.contactList[pos] = contactToAdd;
                break;
            } else if ( current.lastName.compareTo ( contactToAdd.lastName ) > 0 ) {
                this.contactList[pos] = contactToAdd;
                contactToAdd = current;
            }
        }
    }
    static final String[] lastNames = { "A", "C", "E", "B", "D", null };
    public static void main ( final String[] args ) {
        final ContactList contactList = new ContactList();
        for ( final String lastName : lastNames ) {
            final Contact contact = new Contact ( lastName );
            contactList.add ( contact );
            System.out.println ( Arrays.toString ( contactList.contactList ) );
        }
    }
