public static int[] countOccurrences ( String x, char[] validDNAChars ) {
    int[] count = new int[validDNAChars.length];
    for ( int i = 0; i < x.length(); i++ ) {
        int index = -1;
        for ( int j = 0; j < validDNAChars.length && index < 0; j++ ) {
            if ( x.charAt ( i ) == validDNAChars[j] ) {
                index = j;
            }
        }
        if ( index >= 0 ) {
            count[index]++;
        }
    }
    return count;
}
public static int simpleScore ( Gene g0, Gene g1 ) {
    if ( g0.equals ( g1 ) ) {
        return 0;
    }
    String frag0 = g0.getDNA();
    String frag1 = g1.getDNA();
    int[] charOccurencesFrag0 = countOccurrences ( frag0, Constants.DNA_CHARS );
    int[] charOccurencesFrag1 = countOccurrences ( frag1, Constants.DNA_CHARS );
    int multSCOST = 0;
    int multDCOST = 0;
    int multDDCOST = 0;
    for ( int i = 0; i < Constants.DNA_CHARS.length; i++ ) {
        if ( ( charOccurencesFrag0[i] > 0 && charOccurencesFrag1[i] == 0 ) || ( charOccurencesFrag0[i] == 0 && charOccurencesFrag1[i] > 0 ) ) {
            multDDCOST += charOccurencesFrag0[i] + charOccurencesFrag1[i];
        }
        if ( charOccurencesFrag0[i] != 0 && charOccurencesFrag1[i] != 0 ) {
            int diff = Math.abs ( charOccurencesFrag0[i] - charOccurencesFrag1[i] );
            multDCOST += diff;
            multSCOST += Math.min ( charOccurencesFrag0[i], charOccurencesFrag1[i] );
        }
    }
    return Constants.SCOST * multSCOST + Constants.DDCOST * multDDCOST + Constants.DCOST * multDCOST;
}
