public static void main ( String[] args ) {
    if ( System.getProperty ( "os.name" ).contains ( "win" ) || System.getProperty ( "os.name" ).contains ( "Win" ) ) {
        String path = getCommandOutput ( "where javac" );
        if ( path == null || path.isEmpty() ) {
            System.err.println ( "There may have been an error processing the command or " );
            System.out.println ( "JAVAC may not set up to be used from the command line" );
            System.out.println ( "Unable to determine the location of the JDK using the command line" );
        } else {
            File javacFile = new File ( path );
            File jdkInstallationDir = javacFile.getParentFile().getParentFile();
            System.out.println ( "jdk in use at command line is: " + jdkInstallationDir.getPath() );
        }
    } else {
        String response = getCommandOutput ( "whereis javac" );
        if ( response == null ) {
            System.err.println ( "There may have been an error processing the command or " );
            System.out.println ( "JAVAC may not set up to be used from the command line" );
            System.out.println ( "Unable to determine the location of the JDK using the command line" );
        } else {
            int pathStartIndex = response.indexOf ( '/' );
            if ( pathStartIndex == -1 ) {
                System.err.println ( "There may have been an error processing the command or " );
                System.out.println ( "JAVAC may not set up to be used from the command line" );
                System.out.println ( "Unable to determine the location of the JDK using the command line" );
            } else {
                String path = response.substring ( pathStartIndex, response.length() );
                File javacFile = new File ( path );
                File jdkInstallationDir = javacFile.getParentFile().getParentFile();
                System.out.println ( "jdk in use at command line is: " + jdkInstallationDir.getPath() );
            }
        }
    }
}
