@SuppressWarnings ( "unchecked" )
public static <T> T create ( final T... instances ) {
    final Set<Class<?>> commonInterfaces = new HashSet<Class<?>>();
    commonInterfaces.addAll ( Arrays.asList ( instances[0].getClass()
                              .getInterfaces() ) );
    for ( final T instance : instances ) {
        commonInterfaces.retainAll ( Arrays.asList ( instance.getClass()
                                     .getInterfaces() ) );
    }
    final ClassLoader classLoader = instances[0].getClass().getClassLoader();
    final InvocationHandler handler = new InvocationHandler() {
        @Override
        public Object invoke ( final Object proxy, final Method m, final Object[] args )
        throws Throwable {
            for ( final T instance : instances ) {
                m.invoke ( instance, args );
            }
            return null;
        }
    };
    final Class<?>[] targetInterfaces = commonInterfaces
                                        .toArray ( new Class<?>[commonInterfaces.size()] );
    return ( T ) Proxy.newProxyInstance ( classLoader, targetInterfaces,
                                          handler );
}
