Document document = new Document ( PageSize.LETTER );
PdfWriter writer = PdfWriter.getInstance ( document, "C:\sample.pdf" );
writer.setPageEvent ( new HeaderAndFooter ( name ) );
....
public class HeaderAndFooter extends PdfPageEventHelper {
    private String name = "";
    protected Phrase footer;
    protected Phrase header;
    private static Font headerFont = new Font ( Font.COURIER, 9,
            Font.NORMAL, Color.blue );
    private static Font footerFont = new Font ( Font.TIMES_ROMAN, 9,
            Font.BOLD, Color.blue );
    public HeaderAndFooter ( String name ) {
        super();
        this.name = name;
        header = new Phrase ( "***** Header *****" );
        footer = new Phrase ( "**** Footer ****" );
    }
    @Override
    public void onEndPage ( PdfWriter writer, Document document ) {
        PdfContentByte cb = writer.getDirectContent();
        String headerContent = "Name: " + name;
        String footerContent = headerContent;
        ColumnText.showTextAligned ( cb, Element.ALIGN_LEFT, new Phrase ( headerContent, headerFont ),
                                     document.leftMargin() - 1, document.top() + 30, 0 );
        ColumnText.showTextAligned ( cb, Element.ALIGN_RIGHT, new Phrase ( String.format ( " %d ",
                                     writer.getPageNumber() ), footerFont ),
                                     document.right() - 2 , document.bottom() - 20, 0 );
    }
}
