import java.util.Enumeration;
import javax.media.j3d.Behavior;
import javax.media.j3d.Bounds;
import javax.media.j3d.Node;
import javax.media.j3d.Shape3D;
import javax.media.j3d.WakeupCriterion;
import javax.media.j3d.WakeupOnCollisionEntry;
import javax.media.j3d.WakeupOnCollisionExit;
import javax.media.j3d.WakeupOnCollisionMovement;
import javax.media.j3d.WakeupOr;
public class Coll extends Behavior {
    protected WakeupCriterion[] theCriteria;
    protected WakeupOr oredCriteria;
    protected Shape3D collidingShape;
    public Coll ( Shape3D theShape, Bounds theBounds ) {
        collidingShape = theShape;
        setSchedulingBounds ( theBounds );
    }
    public void initialize() {
        theCriteria = new WakeupCriterion[3];
        theCriteria[0] = new WakeupOnCollisionEntry ( collidingShape );
        theCriteria[1] = new WakeupOnCollisionExit ( collidingShape );
        theCriteria[2] = new WakeupOnCollisionMovement ( collidingShape );
        oredCriteria = new WakeupOr ( theCriteria );
        wakeupOn ( oredCriteria );
    }
    public void processStimulus ( Enumeration criteria ) {
        WakeupCriterion theCriterion = ( WakeupCriterion ) criteria.nextElement();
        if ( theCriterion instanceof WakeupOnCollisionEntry ) {
            Node theLeaf = ( ( WakeupOnCollisionEntry ) theCriterion )
                           .getTriggeringPath().getObject();
            System.out.println ( "Collided with " + theLeaf.getUserData() );
        } else if ( theCriterion instanceof WakeupOnCollisionExit ) {
            Node theLeaf = ( ( WakeupOnCollisionExit ) theCriterion )
                           .getTriggeringPath().getObject();
            System.out.println ( "Stopped colliding with  "
                                 + theLeaf.getUserData() );
        } else {
            Node theLeaf = ( ( WakeupOnCollisionMovement ) theCriterion )
                           .getTriggeringPath().getObject();
            System.out.println ( "Moved whilst colliding with "
                                 + theLeaf.getUserData() );
        }
        wakeupOn ( oredCriteria );
    }
}
