public class Knapsack {
    private class State {
        State previousState = null;
        int value = 0;
    }
    public List<Integer> solve ( List<Integer> list, int limit ) {
        if ( limit < 0 ) {
            throw new IllegalArgumentException();
        }
        if ( list == null ) {
            throw new IllegalArgumentException();
        }
        for ( Integer i : list ) {
            if ( i == null || i.intValue() <= 0 ) {
                throw new IllegalArgumentException();
            }
        }
        State[] states = new State[limit + 1];
        states[0] = new State();
        for ( Integer i : list ) {
            for ( int j = limit - i.intValue(); j >= 0; --j ) {
                if ( states[j] != null ) {
                    State newState = new State();
                    newState.previousState = states[j];
                    newState.value = i.intValue();
                    states[i.intValue() + j] = newState;
                }
            }
        }
        State s = null;
        for ( int i = limit; i >= 0; --i ) {
            if ( states[i] != null ) {
                s = states[i];
                break;
            }
        }
        List<Integer> ret = new ArrayList<Integer>();
        while ( s.previousState != null ) {
            ret.add ( Integer.valueOf ( s.value ) );
            s = s.previousState;
        }
        return ret;
    }
    public static void main ( String[] arg ) {
        List<Integer> list = new ArrayList<Integer>();
        for ( int i : new int[] { 5, 7, 9 } ) {
            list.add ( Integer.valueOf ( i ) );
        }
        int limit = 13;
        Knapsack k = new Knapsack();
        System.out.println ( k.solve ( list, limit ) );
    }
}
