import javax.xml.soap.*;
import javax.xml.transform.*;
import javax.xml.transform.stream.*;
public class SOAPClientSAAJ {
    public static void main ( String args[] ) {
        try {
            SOAPConnectionFactory soapConnectionFactory = SOAPConnectionFactory.newInstance();
            SOAPConnection soapConnection = soapConnectionFactory.createConnection();
            String url = "http://ws.cdyne.com/emailverify/Emailvernotestemail.asmx";
            SOAPMessage soapResponse = soapConnection.call ( createSOAPRequest(), url );
            printSOAPResponse ( soapResponse );
            soapConnection.close();
        } catch ( Exception e ) {
            System.err.println ( "Error occurred while sending SOAP Request to Server" );
            e.printStackTrace();
        }
    }
    private static SOAPMessage createSOAPRequest() throws Exception {
        MessageFactory messageFactory = MessageFactory.newInstance();
        SOAPMessage soapMessage = messageFactory.createMessage();
        SOAPPart soapPart = soapMessage.getSOAPPart();
        String serverURI = "http://ws.cdyne.com/";
        SOAPEnvelope envelope = soapPart.getEnvelope();
        envelope.addNamespaceDeclaration ( "example", serverURI );
        SOAPBody soapBody = envelope.getBody();
        SOAPElement soapBodyElem = soapBody.addChildElement ( "VerifyEmail", "example" );
        SOAPElement soapBodyElem1 = soapBodyElem.addChildElement ( "email", "example" );
        soapBodyElem1.addTextNode ( "mutantninja@gmail.com" );
        SOAPElement soapBodyElem2 = soapBodyElem.addChildElement ( "LicenseKey", "example" );
        soapBodyElem2.addTextNode ( "123" );
        MimeHeaders headers = soapMessage.getMimeHeaders();
        headers.addHeader ( "SOAPAction", serverURI  + "VerifyEmail" );
        soapMessage.saveChanges();
        System.out.print ( "Request SOAP Message = " );
        soapMessage.writeTo ( System.out );
        System.out.println();
        return soapMessage;
    }
    private static void printSOAPResponse ( SOAPMessage soapResponse ) throws Exception {
        TransformerFactory transformerFactory = TransformerFactory.newInstance();
        Transformer transformer = transformerFactory.newTransformer();
        Source sourceContent = soapResponse.getSOAPPart().getContent();
        System.out.print ( "\nResponse SOAP Message = " );
        StreamResult result = new StreamResult ( System.out );
        transformer.transform ( sourceContent, result );
    }
}
