import java.util.Date;
public class ThreadTimeTest {
    public static void taskMethod ( String taskName ) {
        System.out.println ( "Starting Task: " + taskName );
        try {
            int random = ( int ) ( Math.random() * 10 );
            System.out.println ( "Task Completion Time: " + random + " secs" );
            Thread.sleep ( random * 1000 );
            System.out.println ( "Task Complete" );
        } catch ( InterruptedException ex ) {
            System.out.println ( "Thread Interrupted due to Time out" );
        }
    }
    public static void main ( String[] arr ) {
        for ( int i = 1; i <= 10; i++ ) {
            String task = "Task " + i;
            final Thread mainThread = Thread.currentThread();
            Thread interruptThread = new Thread() {
                public void run() {
                    long startTime = new Date().getTime();
                    try {
                        while ( !isInterrupted() ) {
                            long now = new Date().getTime();
                            if ( now - startTime > 5000 )  {
                                mainThread.interrupt();
                                break;
                            } else {
                                Thread.sleep ( 1000 );
                            }
                        }
                    } catch ( InterruptedException ex ) {}
                }
            };
            interruptThread.start();
            taskMethod ( task );
            interruptThread.interrupt();
        }
    }
}
