import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.EventQueue;
import java.awt.FlowLayout;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import javax.imageio.ImageIO;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
public class BackgroundLabel {
    public static void main ( String[] args ) {
        new BackgroundLabel();
    }
    public BackgroundLabel() {
        EventQueue.invokeLater ( new Runnable() {
            @Override
            public void run() {
                try {
                    UIManager.setLookAndFeel ( UIManager.getSystemLookAndFeelClassName() );
                } catch ( ClassNotFoundException | InstantiationException | IllegalAccessException | UnsupportedLookAndFeelException ex ) {
                }
                JFrame frame = new JFrame ( "Testing" );
                frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
                frame.setLayout ( new BorderLayout() );
                frame.add ( new TestPane() );
                frame.pack();
                frame.setLocationRelativeTo ( null );
                frame.setVisible ( true );
            }
        } );
    }
    public class TestPane extends JPanel {
        public TestPane() {
            setLayout ( new FlowLayout ( FlowLayout.CENTER ) );
            try {
                BufferedImage icon = ImageIO.read ( new File ( "Pony.png" ) );
                JLabel label = new JLabel ( "Flying Ponies" );
                label.setIcon ( new ImageIcon ( icon ) );
                label.setHorizontalAlignment ( JLabel.CENTER );
                label.setVerticalAlignment ( JLabel.CENTER );
                label.setHorizontalTextPosition ( JLabel.CENTER );
                label.setVerticalTextPosition ( JLabel.CENTER );
                add ( label );
            } catch ( IOException ex ) {
                ex.printStackTrace();
            }
        }
    }
}
