public static BufferedImage getScaledImage ( BufferedImage image, int width, int height ) throws IOException {
    int imageWidth  = image.getWidth();
    int imageHeight = image.getHeight();
    double scaleX = ( double ) width / imageWidth;
    double scaleY = ( double ) height / imageHeight;
    AffineTransform scaleTransform = AffineTransform.getScaleInstance ( scaleX, scaleY );
    AffineTransformOp bilinearScaleOp = new AffineTransformOp ( scaleTransform, AffineTransformOp.TYPE_BILINEAR );
    return bilinearScaleOp.filter (
               image,
               new BufferedImage ( width, height, image.getType() ) );
}
