import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.text.BadLocationException;
import javax.swing.text.Document;
public class FileContentSubject implements Subject, DocumentListener {
    private String state;
    public String getState() {
        return this.state;
    }
    private SubjectImpl reference;
    @Override
    public void attach ( Observer o ) {
        reference.attach ( o );
    }
    @Override
    public void detach ( Observer o ) {
        reference.detach ( o );
    }
    @Override
    public void notifyAllObservers() {
        reference.notifyAllObservers();
    }
    public FileContentSubject() {
        reference = new SubjectImpl();
    }
    @Override
    public void changedUpdate ( DocumentEvent arg0 ) {
    }
    @Override
    public void insertUpdate ( DocumentEvent arg0 ) {
        Document doc = ( Document ) arg0.getDocument();
        try {
            this.state = doc.getText ( 0, doc.getLength() );
        } catch ( BadLocationException e ) {
            e.printStackTrace();
        }
        Editor e = ( Editor ) doc.getProperty ( "ownerEditor" );
        reference.detach ( e );
        notifyAllObservers();
        reference.attach ( e );
    }
    @Override
    public void removeUpdate ( DocumentEvent arg0 ) {
        Document doc = ( Document ) arg0.getDocument();
        try {
            this.state = doc.getText ( 0, doc.getLength() );
        } catch ( BadLocationException e ) {
            e.printStackTrace();
        }
        Editor e = ( Editor ) doc.getProperty ( "ownerEditor" );
        reference.detach ( e );
        notifyAllObservers();
        reference.attach ( e );
    }
}
