import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.EventQueue;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.GridBagLayout;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.image.BufferedImage;
import java.io.IOException;
import javax.imageio.ImageIO;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
public class TransparentWindow01 {
    public static void main ( String[] args ) {
        new TransparentWindow01();
    }
    public TransparentWindow01() {
        EventQueue.invokeLater ( new Runnable() {
            @Override
            public void run() {
                try {
                    UIManager.setLookAndFeel ( UIManager.getSystemLookAndFeelClassName() );
                } catch ( ClassNotFoundException | InstantiationException | IllegalAccessException | UnsupportedLookAndFeelException ex ) {
                }
                JFrame frame = new JFrame ( "Testing" );
                frame.setUndecorated ( true );
                frame.setBackground ( new Color ( 0, 0, 0, 0 ) );
                frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
                frame.setLayout ( new BorderLayout() );
                frame.add ( new TestPane() );
                frame.pack();
                frame.setLocationRelativeTo ( null );
                frame.setVisible ( true );
            }
        } );
    }
    public class TestPane extends JPanel {
        private BufferedImage image;
        public TestPane() {
            try {
                image = ImageIO.read ( getClass().getResource ( "/5UNGbsr.png" ) );
            } catch ( IOException ex ) {
            }
            setOpaque ( false );
            addMouseListener ( new MouseAdapter() {
                @Override
                public void mouseClicked ( MouseEvent e ) {
                    if ( e.getClickCount() == 2 ) {
                        System.exit ( 0 );
                    }
                }
            } );
            setLayout ( new GridBagLayout() );
            add ( new JLabel ( "Look Ma, no hands!" ) );
        }
        @Override
        public Dimension getPreferredSize() {
            Dimension size = image == null ? super.getPreferredSize() : new Dimension ( image.getWidth(), image.getHeight() );
            System.out.println ( size );
            return size;
        }
        @Override
        protected void paintComponent ( Graphics g ) {
            super.paintComponent ( g );
            if ( image != null ) {
                Graphics2D g2d = ( Graphics2D ) g.create();
                int x = ( getWidth() - image.getWidth() ) / 2;
                int y = ( getHeight() - image.getHeight() ) / 2;
                g2d.drawImage ( image, x, y, this );
                g2d.dispose();
            }
        }
    }
}
