class AnimationDrawable extends BaseDrawable {
    public final Animation anim;
    private float stateTime = 0;
    public AnimationDrawable ( Animation anim ) {
        this.anim = anim;
        setMinWidth ( anim.getKeyFrameAt ( 0 ).getRegionWidth() );
        setMinHeight ( anim.getKeyFrameAt ( 0 ).getRegionHeight() );
    }
    public void act ( float delta ) {
        stateTime += delta;
    }
    public void reset() {
        stateTime = 0;
    }
    @Override
    public void draw ( SpriteBatch batch, float x, float y, float width, float height ) {
        batch.draw ( anim.getKeyFrame ( stateTime ), x, y, width, height );
    }
}
