public int Multiply ( int x, int y ) {
    if ( x < 0 ) {
        throw new ArgumentException ( "must be positive integer", "x" );
    }
    if ( y < 0 ) {
        throw new ArgumentException ( "must be positive integer", "y" );
    }
    if ( x == 0 || y == 0 ) {
        return 0;
    }
    int xDivBy10 = x / 10;
    int yDivBy10 = y / 10;
    bool xIsSingleDigit = xDivBy10 == 0;
    bool yIsSingleDigit = yDivBy10 == 0;
    if ( xIsSingleDigit && yIsSingleDigit ) {
        return MultiplySingleDigits ( x, y );
    }
    if ( xIsSingleDigit ) {
        return ( Multiply ( x, yDivBy10 ) * 10 ) + Multiply ( x, y % 10 );
    }
    if ( yIsSingleDigit ) {
        return ( Multiply ( xDivBy10, y ) * 10 ) + Multiply ( x % 10, y );
    }
    return ( Multiply ( x, yDivBy10 ) * 10 ) + Multiply ( x, y % 10 );
}
private int MultiplySingleDigits ( int x, int y ) {
    if ( x < 0 || x > 9 ) {
        throw new ArgumentException ( "must be in range 0 - 9 (inclusive)", "x" );
    }
    if ( y < 0 || y > 9 ) {
        throw new ArgumentException ( "must be in range 0 - 9 (inclusive)", "y" );
    }
    if ( x == 0 || y == 0 ) {
        return 0;
    }
    return x + MultiplySingleDigits ( x, y - 1 );
}
