import org.hibernate.validator.constraints.Length;
import javax.persistence.*;
import java.util.HashSet;
import java.util.Set;
import java.util.UUID;
@Entity
public class User {
    @Id
    private String id = UUID.randomUUID().toString();
    @Column
    @Length ( min = 3, max = 25 )
    private String name;
    @OneToMany ( cascade = { CascadeType.ALL }, fetch = FetchType.EAGER, orphanRemoval = true )
    @JoinColumn ( name = "userId", nullable = false )
    private Set<Contact> contacts = new HashSet<Contact>();
    public UUID getId() {
        return UUID.fromString ( id );
    }
    public void setId ( UUID id ) {
        this.id = id.toString();
    }
    public String getName() {
        return name;
    }
    public void setName ( String name ) {
        this.name = name;
    }
    public Set<Contact> getContacts() {
        return contacts;
    }
    public void setContacts ( Set<Contact> contacts ) {
        this.contacts = contacts;
    }
    public void addContact ( Contact contact ) {
        this.contacts.add ( contact );
    }
    public void removeContact ( Contact contact ) {
        this.contacts.remove ( contact );
    }
}
