JNIEXPORT jint JNICALL Java_MyClass_callNativeCode ( ::JNIEnv * env, jobject thisobject ) {
    jclass thisclass = env->GetObjectClass ( thisobject );
    jclass matclass = env->FindClass ( "org/opencv/core/Mat" );
    jmethodID getPtrMethod = env->GetMethodID ( matclass, "getNativeObjAddr", "()J" );
    jfieldID mrgbafieldid = env->GetFieldID ( thisclass, "mRgba", "Lorg/opencv/core/Mat;" );
    jfieldID bufimgsfieldid = env->GetFieldID ( thisclass, "bufImgs", "[Lorg/opencv/core/Mat;" );
    jobject mrgba = env->GetObjectField ( thisobject, mrgbafieldid );
    jobjectArray bufimgsArray = ( jobjectArray ) env->GetObjectField ( thisobject, bufimgsfieldid );
    cv::Mat nativeBufImgs[7];
    for ( int i = 0; i < 7; i++ ) {
        nativeBufImgs[i] = * ( cv::Mat * ) env->CallLongMethod ( env->GetObjectArrayElement ( bufimgsArray, i ), getPtrMethod );
    }
    cv::Mat * mrgbaptr = ( cv::Mat * ) env->CallLongMethod ( mrgba, getPtrMethod );
    return nativeCode ( mrgbaptr, nativeBufImgs );
}
