package controllers;
import models.PingResponse;
import play.data.Form;
import play.libs.F;
import play.mvc.Controller;
import play.mvc.Result;
import play.libs.WS;
public class Ping extends Controller {
    final static String playProxyURL = "http://localhost:9000/";
    final static String couchAppURL = "http://localhost:80/couchappTest/";
    final static String pingURL = "http://localhost:80/pingTest/";
    public static Result init() {
        return Ping.useProxy ( "" );
    }
    public static Result useProxy ( String assetPath ) {
        if ( assetPath.equals ( "favicon.ico" ) ) {
            return ok();
        }
        if ( session ( "authorized" ) == null || !session ( "authorized" ).equals ( "true" ) ) {
            System.out.println ( "not auth" );
            return redirect ( pingURL );
        } else {
            return async (
                       WS.url ( couchAppURL + assetPath ).get().map (
            new F.Function<WS.Response, Result>() {
                public Result apply ( WS.Response response ) {
                    return ok ( response.getBody() ).as ( response.getHeader ( "Content-type" ) );
                }
            }
                       )
                   );
        }
    }
    public static Result pingCallbackGET ( String token, String httpRef ) {
        if ( token == null || token.equals ( "" ) ) {
            return unauthorized();
        } else {
            System.out.println ( "auth" );
            session ( "authorized", "true" );
            session ( "token", token );
        }
        return redirect ( playProxyURL + httpRef );
    }
}
