public class MySlideListener extends View.OnTouchListener {
    private View v;
    private GestureDetector gestureDetector;
    public MySlideListener ( View v ) {
        this.v = v;
        gestureDetector = new GestureDetector ( v.getContext(), myGestureListener );
    }
    public boolean onTouch ( View v, MotionEvent event ) {
        return gestureDetector.onTouchEvent ( event );
    }
    private SimpleOnGestureListener myGestureListener = new SimpleOnGestureListener() {
        @Override
        public boolean onScroll ( MotionEvent e1, MotionEvent e2, float distanceX, float distanceY ) {
            MarginLayoutParams lp = ( MarginLayoutParams ) view.getLayoutParams();
            lp.leftMargin = distanceX;
            lp.rightMargin = -distanceX;
            return true;
        }
    }
}
