import static org.mockito.Mockito.*;
import org.junit.Test;
import org.mockito.InOrder;
import org.mockito.exceptions.verification.VerificationInOrderFailure;
public class MyTest {
    public interface ToBeTested {
        public void crucialMethod();
        public void methodX();
        public void methodY();
    }
    @Test
    public void testXThenY() {
        ToBeTested toBeTested = mock ( ToBeTested.class );
        toBeTested.crucialMethod();
        toBeTested.methodX();
        toBeTested.methodY();
        InOrder inOrderX = inOrder ( toBeTested );
        inOrderX.verify ( toBeTested ).crucialMethod();
        inOrderX.verify ( toBeTested ).methodX();
        InOrder inOrderY = inOrder ( toBeTested );
        inOrderY.verify ( toBeTested ).crucialMethod();
        inOrderY.verify ( toBeTested ).methodY();
    }
    @Test ( expected = VerificationInOrderFailure.class )
    public void crucialTooLateForX() {
        ToBeTested toBeTested = mock ( ToBeTested.class );
        toBeTested.methodX();
        toBeTested.crucialMethod();
        toBeTested.methodY();
        InOrder inOrderX = inOrder ( toBeTested );
        inOrderX.verify ( toBeTested ).crucialMethod();
        inOrderX.verify ( toBeTested ).methodX();
        InOrder inOrderY = inOrder ( toBeTested );
        inOrderY.verify ( toBeTested ).crucialMethod();
        inOrderY.verify ( toBeTested ).methodY();
    }
    @Test ( expected = VerificationInOrderFailure.class )
    public void crucialTooLateForY() {
        ToBeTested toBeTested = mock ( ToBeTested.class );
        toBeTested.methodY();
        toBeTested.crucialMethod();
        toBeTested.methodX();
        InOrder inOrderX = inOrder ( toBeTested );
        inOrderX.verify ( toBeTested ).crucialMethod();
        inOrderX.verify ( toBeTested ).methodX();
        InOrder inOrderY = inOrder ( toBeTested );
        inOrderY.verify ( toBeTested ).crucialMethod();
        inOrderY.verify ( toBeTested ).methodY();
    }
}
