protected void onCreate ( Bundle savedInstanceState ) {
    if ( DEBUG_LIFECYCLE ) {
        Slog.v ( TAG, "onCreate " + this + ": " + savedInstanceState );
    }
    if ( mLastNonConfigurationInstances != null ) {
        mAllLoaderManagers = mLastNonConfigurationInstances.loaders;
    }
    if ( mActivityInfo.parentActivityName != null ) {
        if ( mActionBar == null ) {
            mEnableDefaultActionBarUp = true;
        } else {
            mActionBar.setDefaultDisplayHomeAsUpEnabled ( true );
        }
    }
    if ( savedInstanceState != null ) {
        Parcelable p = savedInstanceState.getParcelable ( FRAGMENTS_TAG );
        mFragments.restoreAllState ( p, mLastNonConfigurationInstances != null
                                     ? mLastNonConfigurationInstances.fragments : null );
    }
    mFragments.dispatchCreate();
    getApplication().dispatchActivityCreated ( this, savedInstanceState );
    mCalled = true;
}
