protected static int[] correction2 ( int[] pixels, int width, int height ) {
    int[] pixelsCopy = pixels.clone();
    double paramA = -0.007715;
    double paramB = 0.026731;
    double paramC = 0.0;
    double paramD = 1.0 - paramA - paramB - paramC;
    for ( int x = 0; x < width; x++ ) {
        for ( int y = 0; y < height; y++ ) {
            int d = Math.min ( width, height ) / 2;
            double centerX = ( width - 1 ) / 2.0;
            double centerY = ( height - 1 ) / 2.0;
            double deltaX = ( x - centerX ) / d;
            double deltaY = ( y - centerY ) / d;
            double dstR = Math.sqrt ( deltaX * deltaX + deltaY * deltaY );
            double srcR = ( paramA * dstR * dstR * dstR + paramB * dstR * dstR + paramC * dstR + paramD ) * dstR;
            double factor = Math.abs ( dstR / srcR );
            double srcXd = centerX + ( deltaX * factor * d );
            double srcYd = centerY + ( deltaY * factor * d );
            int srcX = ( int ) srcXd;
            int srcY = ( int ) srcYd;
            if ( srcX >= 0 && srcY >= 0 && srcX < width && srcY < height ) {
                int dstPos = y * width + x;
                pixels[dstPos] = pixelsCopy[srcY * width + srcX];
            }
        }
    }
    return pixels;
}
