@Singleton
public class CorsFilter implements Filter {
    @Override
    public void doFilter ( ServletRequest request, ServletResponse response,
                           FilterChain filterChain ) throws IOException, ServletException {
        if ( response instanceof HttpServletResponse ) {
            HttpServletResponse alteredResponse = ( ( HttpServletResponse ) response );
            addCorsHeader ( alteredResponse );
        }
        filterChain.doFilter ( request, response );
    }
    private void addCorsHeader ( HttpServletResponse response ) {
        response.addHeader ( "Access-Control-Allow-Origin", "*" );
        response.addHeader ( "Access-Control-Allow-Methods", "POST, GET, OPTIONS, PUT, DELETE, HEAD" );
        response.addHeader ( "Access-Control-Allow-Headers", "X-PINGOTHER, Origin, X-Requested-With, Content-Type, Accept" );
        response.addHeader ( "Access-Control-Max-Age", "1728000" );
    }
    @Override
    public void destroy() {}
    @Override
    public void init ( FilterConfig filterConfig ) throws ServletException {}
}
