interface Resource {
    ResourceState read();
    void write ( ResourceState );
    void dispose();
}
abstract class AbstractResource<T> implements Resource {
    protected AbstractResource ( ResourceStrategy<T> strat ) {
    }
}
class ExclusiveResource<T> extends AbstractResource<T> {
    ...
}
class ShareableResource<T> extends AbstractResource<T> {
    ...
}
public abstract class ResourceStrategy<T> {
    public abstract ResourceState read ( T obj );
    public abstract void write ( ResourceState state );
    public abstract void dispose ( T obj );
}
