package blog.immutable;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
@XmlRootElement ( name = "customer" )
@XmlAccessorType ( XmlAccessType.NONE )
public final class Customer {
    @XmlAttribute
    private final String name;
    @XmlElement
    private final Address address;
    @SuppressWarnings ( "unused" )
    private Customer() {
        this ( null, null );
    }
    public Customer ( String name, Address address ) {
        this.name = name;
        this.address = address;
    }
    public String getName() {
        return name;
    }
    public Address getAddress() {
        return address;
    }
}
