import java.awt.BorderLayout;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import javax.swing.JPanel;
import javax.swing.JTextField;
import acm.graphics.GLabel;
import acm.program.GraphicsProgram;
public class FontSampler extends GraphicsProgram implements KeyListener {
    private static final String TEST_STRING = "This is a test";
    private static final double LEFT_MARGIN = 3;
    private static final int MAX_FONT_NAME = 10;
    public void init() {
        initPanel();
        addJFontTextField();
        addGLabel();
        lastY = 0;
        add ( panel );
    }
    private void initPanel() {
        panel = new JPanel();
        panel.setLayout ( new BorderLayout() );
    }
    private void addJFontTextField() {
        fontField = new JTextField ( MAX_FONT_NAME );
        panel.add ( fontField, BorderLayout.SOUTH );
        fontField.addKeyListener ( this );
    }
    private void addGLabel() {
        lastLabel = new GLabel ( TEST_STRING );
        add ( lastLabel, 20, 20 );
    }
    public void keyPressed ( KeyEvent e ) {
        if ( e.getKeyCode() == KeyEvent.VK_ENTER ) {
            GLabel label = new GLabel ( TEST_STRING );
            label.setFont ( lastLabel.getFont() );
            label.setFont ( fontField.getText() );
            addGlabel ( label );
            lastLabel = label;
        }
    }
    private void addGlabel ( GLabel label ) {
        lastY += label.getHeight();
        lastY += lastLabel.getDescent() - label.getDescent();
        add ( label, LEFT_MARGIN, lastY );
    }
    private JTextField fontField;
    private GLabel lastLabel;
    private double lastY;
    private JPanel panel;
}
