package org.springframework;
import java.util.ArrayList;
import java.util.List;
import org.aspectj.lang.JoinPoint;
import org.aspectj.lang.annotation.After;
import org.aspectj.lang.annotation.Aspect;
import org.aspectj.lang.annotation.Before;
@Aspect
public class AspectJAnnotation {
    protected long starttime;
    protected long endtime;
    protected  ExecutionVaribale methodlevleinformation = new ExecutionVaribale();
    protected   List<ExecutionVaribale> liststore = new ArrayList<ExecutionVaribale>();
    @Before ( "execution(* *.*())" )
    public void beforeAnymethodcall ( final JoinPoint thisJoinPoint ) {
        starttime = System.currentTimeMillis();
        methodlevleinformation.setMethodname ( thisJoinPoint.getStaticPart().getSignature().getName() );
    }
    @After ( "execution(* *.*())" )
    public void afterAnymethodcall ( final JoinPoint thisJoinPoint ) {
        endtime = System.currentTimeMillis();
        methodlevleinformation.setDifferenetime ( ( starttime - endtime ) / 1000 );
        liststore.add ( methodlevleinformation );
    }
    class ExecutionVaribale {
        public long getDifferenetime() {
            return differenetime;
        }
        public void setDifferenetime ( long differenetime ) {
            this.differenetime = differenetime;
        }
        public String getMethodname() {
            return methodname;
        }
        public void setMethodname ( String methodname ) {
            this.methodname = methodname;
        }
        protected long differenetime;
        protected String  methodname;
    }
}
