import java.util.*;
import com.ibm.as400.access.*;
import com.ibm.as400.util.commtrace.*;
public class TestCommTrace {
    public static void main ( String[] args ) {
        try {
            Format f = new Format ( "/buck/linetrace" );
            FormatProperties fmtprop = new FormatProperties();
            f.setFilterProperties ( fmtprop );
            f.formatProlog();
            Prolog pro = f.getProlog();
            System.out.println ( pro.toString() );
            if ( !pro.invalidData() ) {
                Frame rec;
                while ( ( rec = f.getNextRecord() ) != null ) {
                    System.out.print ( "Frame " + rec.getRecNum().toString() );
                    System.out.println ( " time " + rec.getTime().toString() );
                    IPPacket p = rec.getPacket();
                    Header h = p.getHeader();
                    if ( p.getType() == IPPacket.IP4 ) {
                        if ( h.getType() == Header.IP4 ) {
                            IP4Header ip4 = ( IP4Header ) h;
                            System.out.println ( h.getName() );
                            System.out.println ( "IP4 src:" + ip4.getSrcAddr() + " dst:" + ip4.getDstAddr() );
                            System.out.println ( ip4.printHexHeader() );
                            System.out.println ( ip4.toString() );
                            while ( ( h = h.getNextHeader() ) != null ) {
                                if ( h.getType() == Header.TCP ) {
                                    TCPHeader tcp = ( TCPHeader ) h;
                                    System.out.println ( "TCP src:" + tcp.getSrcPort() + " dst:" + tcp.getDstPort() + " checksum:" + tcp.getCheckSum() );
                                    System.out.println ( tcp.toString() );
                                } else if ( h.getType() == Header.UDP ) {
                                    UDPHeader udp = ( UDPHeader ) h;
                                    System.out.println ( "UDP src:" + udp.getSrcPort() + " dst:" + udp.getDstPort() );
                                    System.out.println ( udp.toString() );
                                }
                            }
                        }
                    }
                }
                f.close();
            }
        } catch ( Exception e ) {
            e.printStackTrace();
        }
    }
}
