import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.GridBagLayout;
import java.awt.Image;
import java.awt.Toolkit;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
public class ImageTest {
    public static void main ( String[] args ) {
        ImagePanel panel = new ImagePanel ( "program/assets/main_bg.jpg" );
        TopTabButton buttonHome = new TopTabButton ( "home" );
        TopTabButton buttonSettings = new TopTabButton ( "settings" );
        TopTabButton buttonHelp = new TopTabButton ( "help" );
        panel.add ( buttonHome );
        panel.add ( buttonSettings );
        panel.add ( buttonHelp );
        JFrame frame = new JFrame();
        frame.setBackground ( new Color ( 53, 56, 64 ) );
        frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
        frame.add ( panel, BorderLayout.NORTH );
        frame.pack();
        frame.setLocationRelativeTo ( null );
        frame.setVisible ( true );
    }
    class TopTabButton extends JButton {
        public TopTabButton ( String buttonCode ) {
            setText ( buttonCode );
        }
    }
    class ImagePanel extends JPanel {
        private Image img;
        public ImagePanel ( String img ) {
            this ( Toolkit.getDefaultToolkit().createImage ( img ) );
        }
        public ImagePanel ( Image img ) {
            this.img = img;
            Dimension size = new Dimension ( img.getWidth ( null ), img.getHeight ( null ) );
            setLayout ( new GridBagLayout() );
        }
        public void paintComponent ( Graphics g ) {
            super.paintComponent ( g );
            g.drawImage ( img, 0, 0, getWidth(), getHeight(), this );
        }
    }
}
