public class Widget implements Comparable<Widget> {
    private final String name;
    private final int id;
    Widget ( String n, int i ) {
        name = n;
        id = i;
    }
    public String getName() {
        return name;
    }
    public int getId() {
        return id;
    }
    @Override
    public boolean equals ( Object o ) {
        if ( o != null && ( o instanceof Widget ) ) {
            return ( ( Widget ) o ).getName().equals ( name ) &&
                   ( ( Widget ) o ).getId() == id;
        }
        return false;
    }
    @Override
    public int hashCode() {
        return ( ( Integer ) id ).hashCode() + name.hashCode();
    }
    @Override
    public int compareTo ( Widget w ) {
        if ( id < w.getId() ) {
            return -1;
        } else if ( id > w.getId() ) {
            return 1;
        }
        return name.compareTo ( w.getName() );
    }
    @Override
    public String toString() {
        return "Widget: " + name + ", id: " + id;
    }
}
