public static String replacePatched ( final String string, final CharSequence target, final CharSequence replacement ) {
    if ( target == null ) {
        throw new NullPointerException ( "target == null" );
    }
    if ( replacement == null ) {
        throw new NullPointerException ( "replacement == null" );
    }
    final String targetString = target.toString();
    int matchStart = string.indexOf ( targetString, 0 );
    if ( matchStart == -1 ) {
        return new String ( string );
    }
    final char[] value = string.toCharArray();
    final int count = value.length;
    final String replacementString = replacement.toString();
    if ( targetString.length() == 0 ) {
        final StringBuilder result = new StringBuilder ( count + ( count + 1 ) * replacementString.length() );
        result.append ( replacementString );
        for ( int i = 0; i < count; ++i ) {
            result.append ( value[i] );
            result.append ( replacementString );
        }
        return new String ( result );
    }
    final StringBuilder result = new StringBuilder ( count );
    int searchStart = 0;
    do {
        result.append ( value, searchStart, matchStart - searchStart );
        result.append ( replacementString );
        searchStart = matchStart + targetString.length();
    } while ( ( matchStart = string.indexOf ( targetString, searchStart ) ) != -1 );
    result.append ( value, searchStart, count - searchStart );
    return new String ( result );
}
