package test;
import org.mozilla.javascript.*;
import java.lang.reflect.Member;
import java.lang.reflect.Method;
public class MyScriptable extends ScriptableObject {
    public static void main ( String args[] ) throws Exception {
        Context.enter();
        try {
            Scriptable scriptExecutionScope = new ImporterTopLevel ( Context.getCurrentContext() );
            Scriptable myScriptable = new MyScriptable();
            myScriptable.setParentScope ( scriptExecutionScope );
            Method scriptableInstanceMethod = MyScriptable.class.getMethod ( "myJavaInstanceMethod", new Class[] {Double.class} );
            String javascriptFunctionName = "myJavascriptGlobalFunction";
            FunctionObject scriptableInstanceMethodBoundJavascriptFunction = new MyFunctionObject ( javascriptFunctionName,
                    scriptableInstanceMethod, myScriptable );
            scriptExecutionScope.put ( javascriptFunctionName, scriptExecutionScope,
                                       scriptableInstanceMethodBoundJavascriptFunction );
            String testScript = "function simpleJavascriptFunction() {" +
                                "  try {" +
                                "    result = myJavascriptGlobalFunction(12.34);" +
                                "    java.lang.System.out.println(result);" +
                                "  }" +
                                "  catch(e) {" +
                                "    throw e;" +
                                "  }" +
                                "}" +
                                "simpleJavascriptFunction();";
            Script compiledScript = Context.getCurrentContext().compileString ( testScript, "My Test Script", 1, null );
            compiledScript.exec ( Context.getCurrentContext(), scriptExecutionScope );
        } catch ( Exception e ) {
            throw e;
        } finally {
            Context.exit();
        }
    }
    public Double myJavaInstanceMethod ( Double number ) {
        return number * 2.0d;
    }
    @Override
    public String getClassName() {
        return getClass().getName();
    }
    private static class MyFunctionObject extends FunctionObject {
        private MyFunctionObject ( String name, Member methodOrConstructor, Scriptable parentScope ) {
            super ( name, methodOrConstructor, parentScope );
        }
        @Override
        public Object call ( Context cx, Scriptable scope, Scriptable thisObj, Object[] args ) {
            return super.call ( cx, scope, getParentScope(), args );
        }
    }
}
