public class AnimalDecorator {
    static interface Animal {
        public String makeNoise();
        public void wagTail();
    }
    static class Dog implements Animal {
        public final String makeNoise() {
            return "woof";
        }
        public final void wagTail() {
        }
        static class DogDecorator implements Animal {
            private Animal animal;
            public DogDecorator ( Animal animal ) {
                this.animal = animal;
            }
            public String makeNoise() {
                animal.makeNoise();
            }
            public void wagTail() {
                animal.wagTail();
            }
        }
        static class LoudDog extends DogDecorator {
            @Override public String makeNoise() {
                return "WOOF WOOF WOOF!!!";
            }
        }
    }
