public class MainActivity extends Activity {
    RelativeLayout rl;
    final int PIC_CROP = 1;
    ImageView iv;
    File file;
    @Override
    protected void onCreate ( Bundle savedInstanceState ) {
        super.onCreate ( savedInstanceState );
        setContentView ( R.layout.activity_main );
        rl = ( RelativeLayout ) findViewById ( R.id.rl );
        Button b = ( Button ) findViewById ( R.id.button1 );
        iv = ( ImageView ) findViewById ( R.id.imageView1 );
        b.setOnClickListener ( new OnClickListener() {
            @Override
            public void onClick ( View v ) {
                save();
            }
        } );
    }
    public void save() {
        AlertDialog.Builder editalert = new AlertDialog.Builder ( MainActivity.this );
        editalert.setTitle ( "Please Enter the name with which you want to Save" );
        final EditText input = new EditText ( MainActivity.this );
        LinearLayout.LayoutParams lp = new LinearLayout.LayoutParams (
            LinearLayout.LayoutParams.FILL_PARENT,
            LinearLayout.LayoutParams.FILL_PARENT );
        input.setLayoutParams ( lp );
        editalert.setView ( input );
        editalert.setPositiveButton ( "OK", new DialogInterface.OnClickListener() {
            public void onClick ( DialogInterface dialog, int whichButton ) {
                rl.setDrawingCacheEnabled ( true );
                String name = input.getText().toString();
                Bitmap bitmap = rl.getDrawingCache();
                String root = Environment.getExternalStorageDirectory().toString();
                File myDir = new File ( root + "/MyDraw" );
                myDir.mkdirs();
                file = new File ( myDir, name + ".png" );
                if ( file.exists () ) {
                    file.delete ();
                }
                try {
                    if ( !file.exists() ) {
                        file.createNewFile();
                    }
                    FileOutputStream ostream = new FileOutputStream ( file );
                    bitmap.compress ( CompressFormat.PNG, 10, ostream );
                    ostream.close();
                    Uri uri = Uri.fromFile ( new File ( file.getAbsolutePath() ) );
                    performCrop ( uri );
                } catch ( Exception e ) {
                    e.printStackTrace();
                }
            }
        } );
        editalert.show();
    }
    private void performCrop ( Uri picUri ) {
        try {
            Intent cropIntent = new Intent ( "com.android.camera.action.CROP" );
            cropIntent.setDataAndType ( picUri, "image/*" );
            cropIntent.putExtra ( "crop", "true" );
            cropIntent.putExtra ( "aspectX", 1 );
            cropIntent.putExtra ( "aspectY", 1 );
            cropIntent.putExtra ( "outputX", 128 );
            cropIntent.putExtra ( "outputY", 128 );
            cropIntent.putExtra ( "return-data", true );
            startActivityForResult ( cropIntent, PIC_CROP );
        } catch ( ActivityNotFoundException anfe ) {
            String errorMessage = "Whoops - your device doesn't support the crop action!";
            Toast toast = Toast.makeText ( MainActivity.this, errorMessage, Toast.LENGTH_SHORT );
            toast.show();
        }
    }
    @Override
    protected void onActivityResult ( int requestCode, int resultCode, Intent data ) {
        super.onActivityResult ( requestCode, resultCode, data );
        if ( requestCode == PIC_CROP ) {
            if ( data != null ) {
                Bundle extras = data.getExtras();
                Bitmap selectedBitmap = extras.getParcelable ( "data" );
                FileOutputStream ostream;
                try {
                    ostream = new FileOutputStream ( file );
                    selectedBitmap.compress ( CompressFormat.PNG, 10, ostream );
                    ostream.close();
                } catch ( Exception e ) {
                    e.printStackTrace();
                }
                iv.setImageBitmap ( selectedBitmap );
            }
        }
    }
