package com.example.binarizeimage;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.RandomAccessFile;
import java.nio.MappedByteBuffer;
import java.nio.channels.FileChannel;
import java.nio.channels.FileChannel.MapMode;
import android.app.Activity;
import android.graphics.Bitmap;
import android.graphics.Bitmap.Config;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.os.Bundle;
import android.os.Environment;
import android.widget.ImageView;
import com.example.binarizeimage.R.drawable;
public class MainActivity extends Activity {
    private static final boolean TRASNPARENT_IS_BLACK = false;
    private static final double SPACE_BREAKING_POINT = 13.0 / 30.0;
    @Override
    protected void onCreate ( Bundle savedInstanceState ) {
        super.onCreate ( savedInstanceState );
        setContentView ( R.layout.activity_main );
        Bitmap theOriginalImage = BitmapFactory.decodeResource ( this.getResources(), drawable.ic_launcher );
        Bitmap binarizedImage = convertToMutable ( theOriginalImage );
        for ( int i = 0; i < binarizedImage.getWidth(); i++ ) {
            for ( int c = 0; c < binarizedImage.getHeight(); c++ ) {
                int pixel = binarizedImage.getPixel ( i, c );
                if ( shouldBeBlack ( pixel ) ) {
                    binarizedImage.setPixel ( i, c, Color.BLACK );
                } else {
                    binarizedImage.setPixel ( i, c, Color.WHITE );
                }
            }
        }
        ImageView iv = ( ImageView ) findViewById ( R.id.imageView1 );
        ImageView ivb = ( ImageView ) findViewById ( R.id.ImageView01 );
        iv.setImageBitmap ( BitmapFactory.decodeResource ( this.getResources(), drawable.ic_launcher ) );
        ivb.setImageBitmap ( binarizedImage );
    }
    private static boolean shouldBeBlack ( int pixel ) {
        int alpha = Color.alpha ( pixel );
        int redValue = Color.red ( pixel );
        int blueValue = Color.blue ( pixel );
        int greenValue = Color.green ( pixel );
        if ( alpha == 0x00 ) {
            return TRASNPARENT_IS_BLACK;
        }
        double distanceFromWhite = Math.sqrt ( Math.pow ( 0xff - redValue, 2 ) + Math.pow ( 0xff - blueValue, 2 ) + Math.pow ( 0xff - greenValue, 2 ) );
        double distanceFromBlack = Math.sqrt ( Math.pow ( 0x00 - redValue, 2 ) + Math.pow ( 0x00 - blueValue, 2 ) + Math.pow ( 0x00 - greenValue, 2 ) );
        double distance = distanceFromBlack + distanceFromWhite;
        return ( ( distanceFromWhite / distance ) > SPACE_BREAKING_POINT );
    }
    public static Bitmap convertToMutable ( Bitmap imgIn ) {
        try {
            File file = new File ( Environment.getExternalStorageDirectory() + File.separator + "temp.tmp" );
            RandomAccessFile randomAccessFile = new RandomAccessFile ( file, "rw" );
            int width = imgIn.getWidth();
            int height = imgIn.getHeight();
            Config type = imgIn.getConfig();
            FileChannel channel = randomAccessFile.getChannel();
            MappedByteBuffer map = channel.map ( MapMode.READ_WRITE, 0, imgIn.getRowBytes() * height );
            imgIn.copyPixelsToBuffer ( map );
            imgIn.recycle();
            System.gc();
            imgIn = Bitmap.createBitmap ( width, height, type );
            map.position ( 0 );
            imgIn.copyPixelsFromBuffer ( map );
            channel.close();
            randomAccessFile.close();
            file.delete();
        } catch ( FileNotFoundException e ) {
            e.printStackTrace();
        } catch ( IOException e ) {
            e.printStackTrace();
        }
        return imgIn;
    }
}
