static jint android_util_Log_println_native ( JNIEnv * env, jobject clazz,
        jint bufID, jint priority, jstring tagObj, jstring msgObj ) {
    const char * tag = NULL;
    const char * msg = NULL;
    if ( msgObj == NULL ) {
        jniThrowNullPointerException ( env, "println needs a message" );
        return -1;
    }
    if ( bufID < 0 || bufID >= LOG_ID_MAX ) {
        jniThrowNullPointerException ( env, "bad bufID" );
        return -1;
    }
    if ( tagObj != NULL ) {
        tag = env->GetStringUTFChars ( tagObj, NULL );
    }
    msg = env->GetStringUTFChars ( msgObj, NULL );
    int res = __android_log_buf_write ( bufID, ( android_LogPriority ) priority, tag, msg );
    if ( tag != NULL ) {
        env->ReleaseStringUTFChars ( tagObj, tag );
    }
    env->ReleaseStringUTFChars ( msgObj, msg );
    return res;
}
