static void printMat ( byte[][] mat ) {
    for ( byte[] row : mat ) {
        System.out.println ( Arrays.toString ( row ) );
    }
}
private static byte[][] stretch ( byte[][] bytes, int rfactor, int cfactor ) {
    int rows = bytes.length * rfactor;
    int cols = bytes[0].length * cfactor;
    byte[][] out = new byte[rows][cols];
    for ( int r = 0; r < rows; r++ ) {
        for ( int c = 0; c < cols; c++ ) {
            out[r][c] = bytes[r / rfactor][c / cfactor];
        }
    }
    return out;
}
public static void main ( String[] args ) throws Exception {
    byte[][] byteArray = {
        {1, 0},
        {0, 1}
    };
    byte[][] newarray = stretch ( byteArray, 10, 10 );
    printMat ( newarray );
    System.out.println();
    byte[][] byteArray2 = {
        {1, 2, 3},
        {4, 5, 6}
    };
    byte[][] newarray2 = stretch ( byteArray2, 3, 2 );
    printMat ( newarray2 );
}
