@Inject
private BeanManager beanManager;
public <T extends Object> T performInjection ( final T obj ) {
    if ( this.beanManager != null ) {
        final CreationalContext creationalContext = this.beanManager.createCreationalContext ( null );
        final InjectionTarget injectionTarget = this.beanManager.createInjectionTarget ( this.beanManager.createAnnotatedType ( obj.getClass() ) );
        injectionTarget.inject ( obj, creationalContext );
        injectionTarget.postConstruct ( obj );
    }
    return obj;
}
