import java.awt.GraphicsDevice;
import java.awt.GraphicsEnvironment;
import java.awt.HeadlessException;
public class TestHeadless {
    private static boolean isReallyHeadless() {
        if ( GraphicsEnvironment.isHeadless() ) {
            return true;
        }
        try {
            GraphicsDevice[] screenDevices = GraphicsEnvironment.getLocalGraphicsEnvironment().getScreenDevices();
            return screenDevices == null || screenDevices.length == 0;
        } catch ( HeadlessException e ) {
            e.printStackTrace();
            return true;
        }
    }
}
