package my.findbugs.detectors.forbiddencalls;
import org.apache.log4j.Logger;
import my.findbugs.detectors.util.DetectorUtil;
import edu.umd.cs.findbugs.BugInstance;
import edu.umd.cs.findbugs.BugReporter;
import edu.umd.cs.findbugs.bcel.OpcodeStackDetector;
import edu.umd.cs.findbugs.classfile.ClassDescriptor;
import edu.umd.cs.findbugs.classfile.FieldDescriptor;
public class CallToSystemOutPrintlnDetector2 extends OpcodeStackDetector {
    private static final Logger LOGGER = Logger.getLogger ( CallToSystemOutPrintlnDetector2.class );
    private BugReporter bugReporter;
    public CallToSystemOutPrintlnDetector2 ( BugReporter bugReporter ) {
        super();
        this.bugReporter = bugReporter;
        LOGGER.debug ( "Instantiated." );
    }
    public void sawOpcode ( int seen ) {
        if ( seen == GETSTATIC ) {
            try {
                FieldDescriptor operand = getFieldDescriptorOperand();
                ClassDescriptor classDescriptor = operand.getClassDescriptor();
                if ( "java/lang/System".equals ( classDescriptor.getClassName() ) &&
                        ( "err".equals ( operand.getName() ) || "out".equals ( operand.getName() ) ) ) {
                    reportBug();
                }
            } catch ( Exception e ) {
            }
        }
    }
    private void reportBug() {
        this.bugReporter.reportBug ( getBugInstance() );
    }
    private BugInstance getBugInstance() {
        return new BugInstance ( this, "MY_CALL_TO_SYSTEM_OUT_BUG", DetectorUtil.MY_PRIORITY )
               .addClassAndMethod ( this )
               .addSourceLine ( this );
    }
}
