package test;
import java.awt.Color;
import java.io.File;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import org.apache.pdfbox.pdmodel.PDDocument;
import org.apache.pdfbox.pdmodel.PDPage;
import org.apache.pdfbox.pdmodel.edit.PDPageContentStream;
import org.apache.pdfbox.pdmodel.font.PDFont;
import org.apache.pdfbox.pdmodel.font.PDTrueTypeFont;
public class Main {
    private static final String FILE_OUTPUT_PATH = "yourPath/yourFile.pdf";
    private static final String FONT_PATH = "test/yourUnicodeFont.ttf";
    private static final String EXAMPLE = "\u060F";
    public static void main ( String[] args ) {
        System.out.println ( EXAMPLE );
        PDDocument document = null;
        try {
            document = new PDDocument();
            InputStream fontStream = Main.class.getClassLoader()
                                     .getResourceAsStream ( FONT_PATH );
            PDFont font = PDTrueTypeFont.loadTTF ( document, fontStream );
            fontStream.close();
            PDPage page = new PDPage();
            PDPageContentStream stream = new PDPageContentStream ( document,
                    page, true, false );
            stream.setFont ( font, 24 );
            stream.setNonStrokingColor ( Color.BLACK );
            stream.beginText();
            stream.drawString ( EXAMPLE );
            stream.endText();
            stream.close();
            document.importPage ( page );
            File file = new File ( FILE_OUTPUT_PATH );
            file.createNewFile();
            OutputStream outputStream = new FileOutputStream ( file );
            document.save ( outputStream );
            outputStream.flush();
            outputStream.close();
        } catch ( Throwable t ) {
            t.printStackTrace();
        } finally {
            if ( document != null ) {
                try {
                    document.close();
                } catch ( Throwable t ) {
                    t.printStackTrace();
                }
            }
        }
    }
}
