String prefix = "PREFIX siocNS: <http://rdfs.org/sioc/ns#>\n"
                + "PREFIX rdfPred: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>\n"
                + "PREFIX purlPred: <http://purl.org/dc/terms/>\n"
                + "PREFIX purlPredLecture: <http://purl.org/<CENSORED>/lecture/>\n";
String queryString = "select ?post ?title ?content ?time ?creator where\n"
                     + "{\n"
                     + "?post rdfPred:type siocNS:Post.\n"
                     + "?post purlPred:title ?title. \n"
                     + "?post purlPred:content ?content. \n"
                     + "?post purlPred:created ?time. \n"
                     + "?post purlPred:creator ?creator.\n"
                     + "?post purlPred:context purlPredLecture:"
                     + lectureID + ".\n" + "}";
logger.info ( "Created Query:" + prefix + queryString );
String completeQuery = prefix + queryString;
logger.info ( "Created Query:\n" + completeQuery );
RepositoryConnection con = createRepositoryConnection();
if ( con == null ) {
    logger.warn ( "Error creating repository connection. Returning epty list" );
    return new ArrayList<UserMessage>();
}
ArrayList<UserMessage> messages = new ArrayList<UserMessage>();
try {
    try {
        TupleQuery prepareTupleQuery = con
                                       .prepareTupleQuery (
                                           QueryLanguage.SPARQL,
                                           completeQuery );
        TupleQueryResult result = prepareTupleQuery
                                  .evaluate();
        while ( result.hasNext() ) {
            ...
        }
        for ( UserMessage message : messages ) {
            collectReplysOfMessage ( lectureID,
                                     message.getId() );
        }
    } catch ( MalformedQueryException e ) {
        logger.error ( "Malformed Exception caught",
                       e );
    } catch ( QueryEvaluationException e ) {
        logger.error (
            "Error on evaluating the query", e );
    } finally {
        con.close();
    }
} catch ( RepositoryException e ) {
    logger.error (
        "Error on creationg repository connection",
        e );
}
