public static void main ( String[] args ) throws Exception {
    if ( args.length > 1 ) {
        BufferedImage firstImage = ImageIO.read ( new File ( args[0] ) );
        ImageOutputStream output =
            new FileImageOutputStream ( new File ( args[args.length - 1] ) );
        GifSequenceWriter writer =
            new GifSequenceWriter ( output, firstImage.getType(), 1, false );
        writer.writeToSequence ( firstImage );
        for ( int i = 1; i < args.length - 1; i++ ) {
            BufferedImage nextImage = ImageIO.read ( new File ( args[i] ) );
            writer.writeToSequence ( nextImage );
        }
        writer.close();
        output.close();
    } else {
        System.out.println (
            "Usage: java GifSequenceWriter [list of gif files] [output file]" );
    }
}
