@Component
public class ProtocolServer extends Thread {
    volatile ServerSocket server;
    volatile Socket connection;
    public ProtocolServer() {
        super ( "Protocol Server on 4100" );
    }
    @Activate void activate() {
        setDaemon ( true );
        start();
    }
    @Deactivate void deactivate() {
        interrupt();
        try {
            server.close();
        } catch ( Exception e ) {}
        try {
            connection.close();
        } catch ( Exception e ) {}
        join ( 10000 );
    }
    public void run() {
        while ( !isInterrupted() )
            try {
                doServer();
            } catch ( Exception e ) {
                log ( e );
                if ( !isInterrupted() )
                    try {
                        Thread.sleep ( 5000 );
                    } catch ( Exception e ) {}
            }
    }
    private void doServer() throws Exception {
        server = new ServerSocket ( 4100 )
        try {
            while ( !isInterrupted() ) {
                doConnection ( server );
            }
        } finally {
            server.close();
        }
    }
    private void doConnection ( ServerSocket server ) throws Exception {
        connection = server.accept();
        try {
            doMessages ( connection );
        } catch ( Exception e ) {
            log ( e );
        } finally {
            connection.close();
            connection = null;
        }
    }
    private void doMessages ( Socket connection ) {
        MyScanner s = new MyScanner ( socket );
        String msg;
        while ( !isInterrupted() && !"bye".equals ( msg = s.getMessage() ) ) {
            process ( msg );
        }
    }
}
