import java.util.ArrayList;
import java.util.List;
import org.apache.commons.lang.StringUtils;
import org.w3c.dom.Node;
public class XPathFlattener {
    private Node root;
    public XPathFlattener ( Node root ) {
        this.root = root;
    }
    public List<Node> flatten() {
        List<Node> nodes = flattenTreeToList ( this.root, new ArrayList<Node>() );
        return nodes;
    }
    @Override
    public String toString() {
        List<String> nodesStrings = new ArrayList<>();
        for ( Node n : this.flatten() ) {
            nodesStrings.add ( stringRepresentation ( n ) );
        }
        return StringUtils.join ( nodesStrings, ", " );
    }
    private static List<Node> flattenTreeToList ( Node node, List<Node> nodes ) {
        nodes.add ( node );
        for ( int i = 0; i < node.getChildNodes().getLength(); i++ ) {
            Node childNode = node.getChildNodes().item ( i );
            flattenTreeToList ( childNode, nodes );
        }
        return nodes;
    }
    private static String stringRepresentation ( Node node ) {
        return String.format ( "[%s, (type %d)]", node.getNodeName(), node.getNodeType() );
    }
}
