public static void toFlat ( Connection conn, File file, String destcode ) {
    PreparedStatement ps = null;
    ResultSet rs = null;
    BufferedWriter out = null;
    try {
        ps = conn.prepareStatement (
                 "SELECT threatid, lastname, firstname, flightnum " +
                 "FROM travel.passengers " +
                 "JOIN threats.aliases USING (firstname, lastname) " +
                 "WHERE destination = ?"
             );
        ps.setString ( 1, destcode );
        out = new BufferedWriter ( new FileWriter ( file ) );
        ps.setFetchSize ( 1000 );
        ps.executeQuery();
        rs = ps.getResultSet();
        while ( rs.next() ) {
            Integer threatid = rs.getInt ( 1 );
            String lastname = rs.getString ( 2 );
            String firstname = rs.getString ( 3 );
            Integer flightnum = rs.getInt ( 4 );
            String row = processRow ( threatid, lastname, firstname, flightnum );
            out.write ( row );
        }
    } catch ( SQLException e ) {
    } catch ( IOException e ) {
        e.printStackTrace();
    } finally {
        try {
            ps.close();
        } catch ( Exception e ) {
        }
        try {
            rs.close();
        } catch ( Exception e ) {
        }
        try {
            out.close();
        } catch ( Exception e ) {
        }
    }
}
