public synchronized void addPropertyChangeListener ( PropertyChangeListener listener )  {
    if ( listener == null ) {
        throw new IllegalArgumentException ( "Property change listener cannot be null." );
    }
    myPropertyChangeDelegate.addPropertyChangeListener ( listener );
}
public synchronized void removePropertyChangeListener ( PropertyChangeListener listener )  {
    if ( listener != null ) {
        myPropertyChangeDelegate.removePropertyChangeListener ( listener );
    }
}
protected void firePropertyChange ( String propertyName, Object oldValue, Object newValue )  {
    if ( myPropertyChangeDelegate.hasListeners ( propertyName ) )  {
        myPropertyChangeDelegate.firePropertyChange ( propertyName, oldValue, newValue );
    }
}
private transient PropertyChangeSupport myPropertyChangeDelegate;
