package test;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
public class Main {
    private static final String SINGLE_NUMBER_PATTERN = "([\\+-]?\\d+(,\\d+)?(\\.\\d+)?)";
    private static final String RANGE_INDICATOR_PATTERN = "(\\s?(-\\s|--|to|(up\\s?to))\\s?)";
    private static final String RANGE_PATTERN = "(?<!"
            + RANGE_INDICATOR_PATTERN + ")" + SINGLE_NUMBER_PATTERN
            + RANGE_INDICATOR_PATTERN + SINGLE_NUMBER_PATTERN + "(?!"
            + RANGE_INDICATOR_PATTERN + ")";
    private static final String ISOLATED_NUMBER_PATTERN = "(?<!"
            + RANGE_INDICATOR_PATTERN + ")" + SINGLE_NUMBER_PATTERN
            + "(?!" + RANGE_INDICATOR_PATTERN + ")";
    private static final String WHOLE_PATTERN =
        "(" + ISOLATED_NUMBER_PATTERN + ")|(" + RANGE_PATTERN + ")";
    public static void main ( String[] args ) {
        String singleNumbers = "0 -1000 30,000 3,000.00";
        String ranges = "0 to 1 1000- 2,000 30,000--40,000.00 4.00 up to 5 10,000 to -5";
        String mixed = "0 0 to 1 -1000 1000- 2,000 30,000 30,000--40,000.00 3,000.00 4.00 up to 5 10,000 to -5";
        Pattern singleNumber = Pattern.compile ( SINGLE_NUMBER_PATTERN );
        Matcher singleNumberMatcher = singleNumber.matcher ( singleNumbers );
        while ( singleNumberMatcher.find() ) {
            System.out.println ( "SINGLE NUMBER: " + singleNumberMatcher.group() );
        }
        Pattern rangesPattern = Pattern.compile ( RANGE_PATTERN );
        Matcher rangesMatcher = rangesPattern.matcher ( ranges );
        while ( rangesMatcher.find() ) {
            System.out.println ( "WHOLE RANGE: " + rangesMatcher.group() );
            System.out.println ( "\tfirst number in range: "
                                 + rangesMatcher.group ( 4 ) );
            System.out.println ( "\tsecond number in range: "
                                 + rangesMatcher.group ( 10 ) );
        }
        Pattern mixedPattern = Pattern.compile ( WHOLE_PATTERN );
        Matcher mixedMatcher = mixedPattern.matcher ( mixed );
        while ( mixedMatcher.find() ) {
            System.out.println ( "WHOLE MATCH: " + mixedMatcher.group() );
            if ( mixedMatcher.group ( 1 ) != null ) {
                System.out.println ( "\tsingle number: " + mixedMatcher.group ( 1 ) );
            } else if ( mixedMatcher.group ( 11 ) != null ) {
                System.out.println ( "\trange: " + mixedMatcher.group ( 11 ) );
                System.out.println ( "\t\tfirst number in range: "
                                     + mixedMatcher.group ( 15 ) );
                System.out.println ( "\t\tsecond number in range: "
                                     + mixedMatcher.group ( 21 ) );
            }
        }
    }
}
