public class Main {
    public static void main ( String[] args ) throws CaptureDeviceLookupException {
        Capture cap = new Capture();
        cap.doCapture();
    }
}
class PingListener implements PacketListener {
    @Override
    public void packetArrived ( Packet packet ) {
        try {
            if ( packet instanceof ICMPPacket ) {
                ICMPPacket tcpPacket = ( ICMPPacket ) packet;
                int data = tcpPacket.getMessageCode();
                if ( data == ICMPMessages.ECHO ) {
                    String srcHost = tcpPacket.getSourceAddress();
                    String dstHost = tcpPacket.getDestinationAddress();
                    System.out.println ( "Ping from: " + srcHost + " to " + dstHost );
                }
            }
        } catch ( Exception e ) {
            e.printStackTrace();
        }
    }
}
class Capture {
    public void doCapture() {
        PacketCapture capture = new PacketCapture();
        PingListener pingListener = new PingListener();
        capture.addPacketListener ( pingListener );
        try {
            capture.open ( "\\Device\\NPF_{...}", true );
            while ( true ) {
                capture.capture ( 1 );
            }
        } catch ( Exception e ) {
            e.printStackTrace();
        } finally {
            capture.removePacketListener ( pingListener );
            capture.endCapture();
            capture.close();
        }
    }
}
