public Album get_album ( String title ) {
    Connection cn = null;
    PreparedStatement pst = null;
    ResultSet rs = null;
    Album a = null;
    try {
        cn = getCon().getConnection();
        String sql = "SELECT * FROM albums WHERE Title = ?";
        pst = cn.prepareStatement ( sql );
        pst.setString ( 1, title );
        rs = pst.executeQuery();
        if ( rs.next() ) {
            a = new Album();
            a.setIdAlbum ( rs.getInt ( "idAlbum" ) );
            a.setTitle ( rs.getString ( "Title" ) );
            a.setYear ( rs.getInt ( "Year" ) );
            a.setIdArtist ( rs.getInt ( "idArtist" ) );
            a.setIdUser ( rs.getInt ( "idUser" ) );
            a.setLike ( rs.getInt ( "Like" ) );
            a.setDislike ( rs.getInt ( "Dislike" ) );
            a.setNeutral ( rs.getInt ( "Neutral" ) );
            a.setViews ( rs.getInt ( "Views" ) );
        }
    } catch ( Exception e ) {
        String msg = e.getMessage();
        e.printStacktrace();
    } finally {
        closeResultSet ( rs );
        closeStatement ( pst );
        closeConnection ( cn );
    }
    return a;
}
public void closeConnection ( Connection con ) {
    if ( con != null ) {
        try {
            con.close();
        } catch ( SQLException e ) {
        }
    }
}
public void closeStatement ( Statement st ) {
    if ( st != null ) {
        try {
            st.close();
        } catch ( SQLException e ) {
        }
    }
}
public void closeResultSet ( ResultSet rs ) {
    if ( rs != null ) {
        try {
            rs.close();
        } catch ( SQLException e ) {
        }
    }
}
