import java.awt.*;
import javax.swing.*;
import javax.swing.border.EmptyBorder;
class SquarePanel extends JPanel {
    @Override
    public Dimension getPreferredSize() {
        Dimension d = super.getPreferredSize();
        System.out.println ( "Preferred Size: " + d );
        int w = ( int ) d.getWidth();
        int h = ( int ) d.getHeight();
        int s = ( w > h ? w : h );
        Container c = getParent();
        if ( c != null ) {
            Dimension sz = c.getSize();
            if ( d.getWidth() < sz.getWidth() ) {
                w = ( int ) sz.getWidth();
                System.out.println ( "WxH: " + w + "x" + h );
                s = ( w < h ? w : h );
            }
            if ( d.getHeight() < sz.getHeight() ) {
                h = ( int ) sz.getHeight();
                System.out.println ( "WxH: " + w + "x" + h );
                s = ( w < h ? w : h );
            }
        }
        System.out.println ( "Square Preferred Size: " + new Dimension ( s, s ) );
        return new Dimension ( s, s );
    }
    @Override
    public Dimension getMinimumSize() {
        return getPreferredSize();
    }
    @Override
    public Dimension getSize() {
        return getPreferredSize();
    }
    public static void main ( String[] args ) {
        Runnable r = new Runnable() {
            @Override
            public void run() {
                JPanel gui = new JPanel ( new GridBagLayout() );
                gui.setBackground ( Color.BLUE );
                SquarePanel p = new SquarePanel();
                p.setBorder ( new EmptyBorder ( 5, 15, 5, 15 ) );
                p.setLayout ( new GridLayout ( 3, 0, 2, 2 ) );
                for ( int ii = 1; ii < 13; ii++ ) {
                    p.add ( new JButton ( "" + ii ) );
                }
                p.setBackground ( Color.red );
                gui.add ( p );
                JFrame f = new JFrame ( "Demo" );
                f.add ( gui );
                f.setDefaultCloseOperation ( JFrame.DISPOSE_ON_CLOSE );
                f.setLocationByPlatform ( true );
                f.pack();
                f.setVisible ( true );
            }
        };
        SwingUtilities.invokeLater ( r );
    }
}
