public class SimpleNotification extends Activity {
    private NotificationManager mNotificationManager;
    private int SIMPLE_NOTFICATION_ID_A = 0;
    private int SIMPLE_NOTFICATION_ID_B = 1;
    @Override
    public void onCreate ( Bundle savedInstanceState ) {
        super.onCreate ( savedInstanceState );
        setContentView ( R.layout.main );
        mNotificationManager = ( NotificationManager ) getSystemService ( NOTIFICATION_SERVICE );
        Button start = ( Button ) findViewById ( R.id.start_button );
        start.setOnClickListener ( new OnClickListener() {
            public void onClick ( View v ) {
                displayNotification ( "Extra for A", "This is A", "Some text for activity A", MyActivityA.class, SIMPLE_NOTFICATION_ID_A );
                displayNotification ( "Extra for B", "This is B", "Some text for activity B", MyActivityB.class, SIMPLE_NOTFICATION_ID_B );
            }
        } );
    }
    private void displayNotification ( String extra, String contentTitle, String contentText, Class<?> cls, int id ) {
        Notification notifyDetails = new Notification ( R.drawable.icon, "New Alert!", System.currentTimeMillis() );
        Intent intent = new Intent ( this, cls );
        intent.putExtra ( "extra", extra );
        PendingIntent contentIntent = PendingIntent.getActivity ( getApplicationContext(), id, intent, PendingIntent.FLAG_ONE_SHOT );
        notifyDetails.setLatestEventInfo ( getApplicationContext(), contentTitle, contentText, contentIntent );
        mNotificationManager.notify ( id, notifyDetails );
    }
}
