import java.awt.AlphaComposite;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import javax.imageio.ImageIO;
public class ImageTest {
    private static final int IMG_WIDTH = 512;
    private static final int IMG_CLAHEIGHT = 512;
    public static void main ( String[] args ) {
        String filePath = "e:\\Image_DCM_PNG\\";
        try {
            File myFile = new File ( filePath );
            File roots[] = myFile.listFiles();
            for ( int i = 0; i < roots.length; i++ ) {
                System.out.println ( roots[i] );
                BufferedImage originalImage = ImageIO.read ( new File ( filePath + roots[i].getName() ) );
                int type = originalImage.getType() == 0 ? BufferedImage.TYPE_INT_ARGB : originalImage.getType();
                BufferedImage resizeImageBmp = resizeImage ( originalImage, type );
                ImageIO.write ( resizeImageBmp, "png", new File ( filePath + roots[i].getName() ) );
            }
        } catch ( IOException e ) {
            System.out.println ( e.getMessage() );
        }
    }
    private static BufferedImage resizeImage ( BufferedImage originalImage, int type ) {
        BufferedImage resizedImage = new BufferedImage ( IMG_WIDTH, IMG_CLAHEIGHT, type );
        Graphics2D g = resizedImage.createGraphics();
        g.drawImage ( originalImage, 0, 0, IMG_WIDTH, IMG_CLAHEIGHT, null );
        g.dispose();
        return resizedImage;
    }
    private static BufferedImage resizeImageWithHint ( BufferedImage originalImage, int type ) {
        BufferedImage resizedImage = new BufferedImage ( IMG_WIDTH, IMG_CLAHEIGHT, type );
        Graphics2D g = resizedImage.createGraphics();
        g.drawImage ( originalImage, 0, 0, IMG_WIDTH, IMG_CLAHEIGHT, null );
        g.dispose();
        g.setComposite ( AlphaComposite.Src );
        g.setRenderingHint ( RenderingHints.KEY_INTERPOLATION,
                             RenderingHints.VALUE_INTERPOLATION_BILINEAR );
        g.setRenderingHint ( RenderingHints.KEY_RENDERING,
                             RenderingHints.VALUE_RENDER_QUALITY );
        g.setRenderingHint ( RenderingHints.KEY_ANTIALIASING,
                             RenderingHints.VALUE_ANTIALIAS_ON );
        return resizedImage;
    }
}
