import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.OutputStream;
import org.apache.commons.net.ftp.FTPClient;
import org.apache.commons.net.ftp.FTPFile;
import org.apache.commons.net.ftp.FTPReply;
public class FTPExample {
    public static void main ( String[] args ) {
        try {
            FTPClient ftp = new FTPClient();
            ftp.connect ( "MyHhostName" );
            if ( !ftp.login ( "username", "password" ) ) {
                ftp.logout();
            }
            int reply = ftp.getReplyCode();
            if ( !FTPReply.isPositiveCompletion ( reply ) ) {
                ftp.disconnect();
            }
            ftp.enterLocalPassiveMode();
            System.out.println ( "Remote system is " + ftp.getSystemType() );
            ftp.changeWorkingDirectory ( "/App/PMIGENV/BACK/Finacle/FC/app/CDCI_LOGS/log/UBSADMIN" );
            System.out.println ( "Current directory is " + ftp.printWorkingDirectory() );
            FTPFile[] ftpFiles = ftp.listFiles();
            if ( ftpFiles != null && ftpFiles.length > 0 ) {
                for ( FTPFile file : ftpFiles ) {
                    if ( !file.isFile() ) {
                        continue;
                    }
                    System.out.println ( "File is " + file.getName() );
                    OutputStream output;
                    output = new FileOutputStream ( "FtpFiles" + "/" + file.getName() );
                    ftp.retrieveFile ( file.getName(), output );
                    output.close();
                }
            }
            ftp.logout();
            ftp.disconnect();
        } catch ( Exception ex ) {
            ex.printStackTrace();
        }
    }
}
