import org.apache.log4j.Logger;
public class LoggerUtils {
    private static Logger log = null;
    static {
        System.out.println ( "Inside LoggerUtils static block" );
        log = Logger.getLogger ( LoggerUtils.class );
        System.out.println ( "LoggerUtils Class Name == "
                             + LoggerUtils.log.getClass().getName() );
    }
    public LoggerUtils() {
    }
    public static void debug ( String logString ) {
        log.debug ( logString );
    }
    public static void info ( String logString ) {
        log.info ( logString );
    }
    public static void error ( String logString ) {
        log.error ( logString );
    }
    public static void warn ( String logString ) {
        log.warn ( logString );
    }
    public static void error ( String logString, Exception e ) {
        error ( logString );
        if ( e != null ) {
            StackTraceElement[] elements = null;
            elements = e.getStackTrace();
            if ( elements != null ) {
                StringBuffer strBuffer = new StringBuffer ( "" );
                for ( int i = 0; i < elements.length; i++ ) {
                    strBuffer.append ( elements[i] ).append ( "\n" );
                }
                error ( "Stack Trace :: \n" + strBuffer.toString() );
                strBuffer = null;
            }
            elements = null;
        }
    }
    public static void error ( String logString, Object[] messages ) {
        error ( logString );
        if ( messages != null ) {
            StringBuffer strBuffer = new StringBuffer ( "" );
            for ( int i = 0; i < messages.length; i++ ) {
                strBuffer.append ( messages[i] ).append ( "\n" );
            }
            error ( strBuffer.toString() );
            strBuffer = null;
        }
    }
    public static void fatal ( String logString ) {
        log.fatal ( logString );
    }
}
