public final class MapBuilder<K, V> {
    private final Map<K, V> map = new HashMap<K, V>();
    public MapBuilder<K, V> put ( final K key, final V value ) {
        map.put ( key, value );
        return this;
    }
    public Map<K, V> build() {
        return new HashMap<K, V> ( map );
    }
    public Map<K, V> immutable() {
        return Collections.unmodifiableMap ( build() );
    }
}
