import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.List;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JProgressBar;
import javax.swing.SwingUtilities;
import javax.swing.SwingWorker;
import javax.swing.SwingWorker.StateValue;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
public class TestSwingWorker {
    private JProgressBar progressBar;
    protected void initUI() {
        final JFrame frame = new JFrame();
        frame.setTitle ( TestSwingWorker.class.getSimpleName() );
        frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
        JButton button = new JButton ( "Clik me to start work" );
        button.addActionListener ( new ActionListener() {
            @Override
            public void actionPerformed ( ActionEvent e ) {
                doWork();
            }
        } );
        progressBar = new JProgressBar ( 0, 100 );
        frame.add ( progressBar, BorderLayout.NORTH );
        frame.add ( button, BorderLayout.SOUTH );
        frame.pack();
        frame.setVisible ( true );
    }
    private boolean someFlag;
    protected void doWork() {
        SwingWorker<Void, Integer> worker = new SwingWorker<Void, Integer>() {
            @Override
            protected Void doInBackground() throws Exception {
                for ( int i = 0; i < 100; i++ ) {
                    Thread.sleep ( 10 );
                    publish ( i );
                }
                return null;
            }
            @Override
            protected void process ( List<Integer> chunks ) {
                progressBar.setValue ( chunks.get ( chunks.size() - 1 ) );
            }
            @Override
            protected void done() {
                progressBar.setValue ( 100 );
                progressBar.setStringPainted ( true );
                progressBar.setString ( "Done" );
            }
        };
        worker.getPropertyChangeSupport().addPropertyChangeListener ( "state", new PropertyChangeListener() {
            @Override
            public void propertyChange ( PropertyChangeEvent evt ) {
                if ( StateValue.DONE.equals ( evt.getNewValue() ) ) {
                    someFlag = true;
                }
            }
        } );
        worker.execute();
    }
    public static void main ( String[] args ) throws ClassNotFoundException, InstantiationException, IllegalAccessException,
        UnsupportedLookAndFeelException {
        UIManager.setLookAndFeel ( UIManager.getSystemLookAndFeelClassName() );
        SwingUtilities.invokeLater ( new Runnable() {
            @Override
            public void run() {
                new TestSwingWorker().initUI();
            }
        } );
    }
}
