@Provider
@Consumes ( "application/json" )
public class CustomJsonReader<T> implements MessageBodyReader<T> {
    @Override
    public boolean isReadable ( Class<?> type, Type genericType, Annotation[] annotations, MediaType mediaType ) {
        return true;
    }
    @Override
    public T readFrom ( Class<T> type, Type genericType, Annotation[] annotations, MediaType mediaType, MultivaluedMap<String, String> httpHeaders,
                        InputStream entityStream ) throws IOException, WebApplicationException {
        StringWriter writer = new StringWriter();
        IOUtils.copy ( entityStream, writer, "UTF-8" );
        String json = writer.toString();
        if ( String.class == genericType ) {
            return type.cast ( json );
        }
        ObjectMapper objectMapper = new ObjectMapper();
        return objectMapper.readValue ( json, type );
    }
}
