final Entry<K, V> getEntry ( Object key ) {
    if ( comparator != null ) {
        return getEntryUsingComparator ( key );
    }
    if ( key == null ) {
        throw new NullPointerException();
    }
    Comparable<? super K> k = ( Comparable<? super K> ) key;
    Entry<K, V> p = root;
    while ( p != null ) {
        int cmp = k.compareTo ( p.key );
        if ( cmp < 0 ) {
            p = p.left;
        } else if ( cmp > 0 ) {
            p = p.right;
        } else {
            return p;
        }
    }
    return null;
}
