@Immutable
public final class Edge {
    private final int minCardinality;
    public static Builder newBuilder() {
        return new Builder();
    }
    private Edge ( final Builder builder ) {
        minCardinality = builder.minCardinality;
    }
    @NotThreadSafe
    public static final class Builder {
        private int minCardinality;
        private Builder() {}
        public Builder withMinCardinality ( final int minCardinality ) {
            this.minCardinality = minCardinality;
            return this;
        }
        public Edge build() {
            return new Edge ( this );
        }
    }
}
