public class AndroidCustomGalleryActivity extends Activity {
    ImageView iv;
    Bitmap image ;
    ProgressDialog pd;
    @Override
    public void onCreate ( Bundle savedInstanceState ) {
        super.onCreate ( savedInstanceState );
        setContentView ( R.layout.activity_main );
        iv = ( ImageView ) findViewById ( R.id.imageView1 );
        pd = new ProgressDialog ( this );
        pd.setMessage ( "Loading.." );
        new TheTask().execute();
    }
    class TheTask extends AsyncTask<Void, Void, Void> {
        @Override
        protected void onPreExecute() {
            super.onPreExecute();
            pd.show();
        }
        @Override
        protected Void doInBackground ( Void... params ) {
            try {
                image = downloadBitmap ( "http://a3.twimg.com/profile_images/670625317/aam-logo-v3-twitter.png" );
            } catch ( Exception e ) {
                e.printStackTrace();
            }
            return null;
        }
        @Override
        protected void onPostExecute ( Void result ) {
            super.onPostExecute ( result );
            pd.dismiss();
            if ( image != null ) {
                iv.setImageBitmap ( image );
            }
        }
    }
    private Bitmap downloadBitmap ( String url ) {
        final DefaultHttpClient client = new DefaultHttpClient();
        final HttpGet getRequest = new HttpGet ( url );
        try {
            HttpResponse response = client.execute ( getRequest );
            final int statusCode = response.getStatusLine().getStatusCode();
            if ( statusCode != HttpStatus.SC_OK ) {
                Log.w ( "ImageDownloader", "Error " + statusCode +
                        " while retrieving bitmap from " + url );
                return null;
            }
            final HttpEntity entity = response.getEntity();
            if ( entity != null ) {
                InputStream inputStream = null;
                try {
                    inputStream = entity.getContent();
                    image = BitmapFactory.decodeStream ( inputStream );
                } finally {
                    if ( inputStream != null ) {
                        inputStream.close();
                    }
                    entity.consumeContent();
                }
            }
        } catch ( Exception e ) {
            getRequest.abort();
            Log.e ( "ImageDownloader", "Something went wrong while" +
                    " retrieving bitmap from " + url + e.toString() );
        }
        return image;
    }
}
