private class ImgListCellRenderer extends DefaultListCellRenderer {
    @Override
    public Component getListCellRendererComponent ( JList list, Object value,
            int index, boolean isSelected, boolean cellHasFocus ) {
        if ( value != null ) {
            BufferedImage img = ( ( SimpleTnWrapper ) value ).getTnImage();
            value = new ImageIcon ( img );
        }
        return super.getListCellRendererComponent ( list, value, index,
                isSelected, cellHasFocus );
    }
}
private class NonImgCellRenderer extends DefaultListCellRenderer {
    @Override
    public Component getListCellRendererComponent ( JList list, Object value,
            int index, boolean isSelected, boolean cellHasFocus ) {
        if ( value != null ) {
            SimpleTnWrapper simpleTn = ( SimpleTnWrapper ) value;
            String displayString = simpleTn.getImgHref().getImgHref();
            displayString = displayString.substring ( displayString.lastIndexOf ( "/" ) + 1 );
            value = displayString;
        }
        return super.getListCellRendererComponent ( list, value, index,
                isSelected, cellHasFocus );
    }
}
