public class MethodArgumentResolver implements HandlerMethodArgumentResolver, BeanFactoryAware {
    private final Set<Class> knownTypes = Config.getDeclaredTypes();
    private BeanFactory beanFactory;
    @Override
    public void setBeanFactory ( BeanFactory beanFactory ) throws BeansException {
        this.beanFactory = beanFactory;
    }
    @Override
    public boolean supportsParameter ( MethodParameter parameter ) {
        Class<?> type = parameter.getParameterType();
        return knownTypes.contains ( type );
    }
    @Override
    public Object resolveArgument (
        MethodParameter parameter,
        ModelAndViewContainer mavContainer,
        NativeWebRequest webRequest,
        WebDataBinderFactory binderFactory ) throws Exception {
        Class<?> type = parameter.getParameterType();
        return beanFactory.getBean ( type );
    }
}
