public class ProductAdapter extends TypeAdapter<Product> {
    public Product read ( JsonReader reader ) throws IOException {
        if ( reader.peek() == JsonToken.NULL ) {
            reader.nextNull();
            return null;
        }
        String json = reader.nextString();
        return new Product ( json );
    }
    public void write ( JsonWriter writer, Product value ) throws IOException {
        if ( value == null ) {
            writer.nullValue();
            return;
        }
        String json = value.getAsString();
        writer.value ( json );
    }
}
