static DateTime resetDate ( BaseSingleFieldPeriod period,
                            DateTime date ) {
    LocalDate out = new LocalDate ( date )
    switch ( period ) {
    case Years.ONE:
        out = out.withMonthOfYear ( 1 ).withDayOfMonth ( 1 )
              break;
    case Months.ONE:
        out = out.withDayOfMonth ( 1 )
              break;
    case Weeks.ONE:
        out = out.withDayOfWeek ( 1 ).minusDays ( 1 )
              break;
    case Days.ONE:
        break;
    default:
        throw new UnsupportedOperationException ( "Unsupported period $period" )
    }
    out.toDateMidnight().toDateTime()
}
