public enum BloodTest {
    AAA ( 10 ) {
        @Override
        public boolean isRequired ( MedicalRecord medicalRecord ) {
            return medicalRecord.includes ( "someDisease" );
        }
    },
    BBB ( 15 ) {
        @Override
        public boolean isRequired ( MedicalRecord medicalRecord ) {
            return ! medicalRecord.hasTakenBloodTestsLately();
        }
    },
    CCC ( 20 ) {
        private final int threshold;
        private BloodTest ( int threshold ) {
            this.threshold = threshold;
        }
        public boolean hasPassed ( int value ) {
            return value <= threshold;
        }
        public abstract boolean isRequired ( MedicalRecord medicalRecord );
    }
