public class ReadingFile {
    public static void main ( String[] args ) {
        final int threadCount = 10;
        BlockingQueue<String> queue = new ArrayBlockingQueue<> ( 200 );
        ExecutorService service = Executors.newFixedThreadPool ( threadCount );
        for ( int i = 0; i < ( threadCount - 1 ); i++ ) {
            service.submit ( new CPUTask ( queue ) );
        }
        service.submit ( new FileTask ( queue ) ).get();
        service.shutdownNow();
        service.awaitTermination ( 365, TimeUnit.DAYS );
    }
}
class FileTask implements Runnable {
    private final BlockingQueue<String> queue;
    public FileTask ( BlockingQueue<String> queue ) {
        this.queue = queue;
    }
    @Override
    public void run() {
        BufferedReader br = null;
        try {
            br = new BufferedReader ( new FileReader ( "D:/abc.txt" ) );
            String line;
            while ( ( line = br.readLine() ) != null ) {
                queue.offer ( line, 365, TimeUnit.DAYS );
            }
        } catch ( FileNotFoundException e ) {
            e.printStackTrace();
        } catch ( IOException e ) {
            e.printStackTrace();
        } finally {
            try {
                br.close();
            } catch ( IOException e ) {
                e.printStackTrace();
            }
        }
    }
}
class CPUTask implements Runnable {
    private final BlockingQueue<String> queue;
    public CPUTask ( BlockingQueue<String> queue ) {
        this.queue = queue;
    }
    @Override
    public void run() {
        String line;
        while ( true ) {
            try {
                line = queue.take();
            } catch ( InterruptedException ex ) {
                break;
            }
        }
        while ( ( line = queue.poll() ) != null ) {
        }
    }
}
