package android.application.project.planes;
import java.util.ArrayList;
import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
public class MainActivityChampagne {
    public static final String KEY_NAME = "title";
    public static final String KEY_NOTES = "lastcall";
    private static final String DATABASE_NAME = "Champagnedb";
    private static final String DATABASE_TABLE = "champagneTable";
    private static final int DATABASE_VERSION = 1;
    private DbHelper ourHelper;
    private final Context ourContext;
    private SQLiteDatabase ourDatabase;
    private static class DbHelper extends SQLiteOpenHelper {
        public DbHelper ( Context context ) {
            super ( context, DATABASE_NAME, null, DATABASE_VERSION );
        }
        @Override
        public void onCreate ( SQLiteDatabase db ) {
            db.execSQL ( "CREATE TABLE " + DATABASE_TABLE + " (" + KEY_NAME
                         + " TEXT NOT NULL);" );
        }
        @Override
        public void onUpgrade ( SQLiteDatabase db, int oldVersion, int newVersion ) {
            db.execSQL ( "DROP TABLE IF EXIST " + DATABASE_TABLE );
            onCreate ( db );
        }
    }
    public MainActivityChampagne ( Context c ) {
        ourContext = c;
    }
    public MainActivityChampagne open() {
        ourHelper = new DbHelper ( ourContext );
        ourDatabase = ourHelper.getWritableDatabase();
        return this;
    }
    public void close() {
        ourHelper.close();
    }
    public long createEntry ( String titles, String notes ) {
        ContentValues cv = new ContentValues();
        cv.put ( KEY_NAME, titles );
        return ourDatabase.insert ( DATABASE_TABLE, null, cv );
    }
    public ArrayList<String> getData() {
        String[] columns = new String[] { KEY_NAME };
        Cursor c = ourDatabase.query ( DATABASE_TABLE, columns, null, null, null,
                                       null, null );
        String result = "";
        int iNotes = c.getColumnIndex ( KEY_NAME );
        ArrayList<String> string_array = new ArrayList<String>();
        for ( c.moveToFirst(); !c.isAfterLast(); c.moveToNext() ) {
            result = c.getString ( iNotes ) + "\n";
            string_array.add ( result );
        }
        return string_array;
    }
    public void updateEntry ( String thetitles, String thenotes ) {
        ContentValues cvUpdate = new ContentValues();
        cvUpdate.put ( KEY_NAME, thetitles );
        ourDatabase.update ( DATABASE_TABLE, cvUpdate, KEY_NAME + "='"
                             + thetitles + "'", null );
    }
}
