#include <windows.h>
#include <shobjidl.h>
#include "jni.h"
#if defined _WIN32 || defined _WIN64
extern "C" {
    const GUID CLSID_TaskbarList = {0x56FDF344, 0xFD6D, 0x11D0, {0x95, 0x8A, 0x00, 0x60, 0x97, 0xC9, 0xA0, 0x90}};
    const GUID IID_ITaskbarList = {0x56FDF342, 0xFD6D, 0x11D0, {0x95, 0x8A, 0x00, 0x60, 0x97, 0xC9, 0xA0, 0x90}};
    const GUID IID_ITaskbarList2 = {0x602D4995, 0xB13A, 0x429b, {0xA6, 0x6E, 0x19, 0x35, 0xE4, 0x4F, 0x43, 0x17}};
    const GUID IID_ITaskList3 = {0xEA1AFB91, 0x9E28, 0x4B86, {0x90, 0xE9, 0x9E, 0x9F, 0x8A, 0x5E, 0xEF, 0xAF}};
}
#endif
extern "C" JNIEXPORT void JNICALL Java_apptotray_AppToTray_addToTaskBar ( JNIEnv *, jclass, jlong WindowHandle ) {
#if defined _WIN32 || defined _WIN64
    ITaskbarList * TaskListPtr;
    CoInitialize ( nullptr );
    long Result = !CoCreateInstance ( CLSID_TaskbarList, nullptr, CLSCTX_SERVER, IID_ITaskbarList, reinterpret_cast<void * * > ( & TaskListPtr ) );
    if ( Result ) {
        TaskListPtr->AddTab ( reinterpret_cast<HWND> ( WindowHandle ) );
    }
    TaskListPtr->Release();
    CoUninitialize();
#endif
}
extern "C" JNIEXPORT void JNICALL Java_apptotray_AppToTray_removeFromTaskBar ( JNIEnv *, jclass, jlong WindowHandle ) {
#if defined _WIN32 || defined _WIN64
    ITaskbarList * TaskListPtr;
    CoInitialize ( nullptr );
    long Result = !CoCreateInstance ( CLSID_TaskbarList, nullptr, CLSCTX_SERVER, IID_ITaskbarList, reinterpret_cast<void * * > ( & TaskListPtr ) );
    if ( Result ) {
        TaskListPtr->DeleteTab ( reinterpret_cast<HWND> ( WindowHandle ) );
    }
    TaskListPtr->Release();
    CoUninitialize();
#endif
}
extern "C" bool __stdcall DllMain ( HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved ) {
    switch ( fdwReason ) {
    case DLL_PROCESS_ATTACH:
        break;
    case DLL_PROCESS_DETACH:
        break;
    case DLL_THREAD_ATTACH:
        break;
    case DLL_THREAD_DETACH:
        break;
    }
    return TRUE;
}
