public void onCreate ( Bundle savedInstanceState ) {
    super.onCreate ( savedInstanceState );
    setContentView ( R.layout.main );
    mDisplay = ( TextView ) findViewById ( R.id.display );
    context = getApplicationContext();
    regid = getRegistrationId ( context );
    if ( regid.length() == 0 ) {
        registerBackground();
    }
    gcm = GoogleCloudMessaging.getInstance ( this );
}
private String getRegistrationId ( Context context ) {
    final SharedPreferences prefs = getGCMPreferences ( context );
    String registrationId = prefs.getString ( PROPERTY_REG_ID, "" );
    if ( registrationId.length() == 0 ) {
        Log.v ( TAG, "Registration not found." );
        return "";
    }
    int registeredVersion = prefs.getInt ( PROPERTY_APP_VERSION, Integer.MIN_VALUE );
    int currentVersion = getAppVersion ( context );
    if ( registeredVersion != currentVersion || isRegistrationExpired() ) {
        Log.v ( TAG, "App version changed or registration expired." );
        return "";
    }
    return registrationId;
}
private boolean isRegistrationExpired() {
    final SharedPreferences prefs = getGCMPreferences ( context );
    long expirationTime =
        prefs.getLong ( PROPERTY_ON_SERVER_EXPIRATION_TIME, -1 );
    return System.currentTimeMillis() > expirationTime;
}
