@ManagedBean
@ApplicationScoped
@SuppressWarnings ( { "rawtypes", "unchecked" } )
public class BaseEntityConverter implements Converter {
    @EJB
    private BaseService baseService;
    @Override
    public String getAsString ( FacesContext context, UIComponent component, Object value ) {
        if ( value == null ) {
            return "";
        }
        if ( ! ( value instanceof BaseEntity ) ) {
            throw new ConverterException ( "Value is not a valid instance of BaseEntity." );
        }
        Number id = ( ( BaseEntity ) value ).getId();
        return ( id != null ) ? id.toString() : null;
    }
    @Override
    public Object getAsObject ( FacesContext context, UIComponent component, String value ) {
        if ( value == null || value.isEmpty() ) {
            return null;
        }
        if ( !value.matches ( "[0-9]+" ) ) {
            throw new ConverterException ( "Value is not a valid ID of BaseEntity." );
        }
        Class<?> type = component.getValueExpression ( "value" ).getType ( context.getELContext() );
        return baseService.find ( ( Class<BaseEntity<? extends Number>> ) type, Long.valueOf ( value ) );
    }
}
