public Action onRecurringConsecutiveCalls ( Action...actions ) {
    return new RecurringActionSequence ( actions );
}
public class RecurringActionSequence extends ActionSequence {
    List<Action> actions;
    Iterator<Action> iterator;
    public RecurringActionSequence ( Action... actions ) {
        this.actions = new ArrayList<Action> ( Arrays.asList ( actions ) );
        resetIterator();
    }
    @Override
    public Object invoke ( Invocation invocation ) throws Throwable {
        if ( iterator.hasNext() ) {
            return iterator.next().invoke ( invocation );
        } else {
            return resetIterator().next().invoke ( invocation );
        }
    }
    private Iterator<Action> resetIterator() {
        this.iterator = this.actions.iterator();
        return this.iterator;
    }
}
