package com.stackoverflow.q1747780;
import java.util.UUID;
public class UUIDFactory {
    public static class PersonUUID implements UUIDTyped<Person> {
        @Override
        public UUID value() {
            return UUID.randomUUID();
        }
    };
    public static class AddressUUID implements UUIDTyped<Address> {
        @Override
        public UUID value() {
            return UUID.randomUUID();
        }
    };
    public <T> UUIDTyped<T> newUUID() {
        return new UUIDTyped<T>() {
            @Override
            public UUID value() {
                return UUID.randomUUID();
            }
        };
    }
    public UUIDTyped<Person> newPersonUUID() {
        return new PersonUUID();
    }
    public UUIDTyped<Address> newAddressUUID() {
        return new AddressUUID();
    }
}
