class Main {
    private static final ExecutorService es = Executors.newCachedThreadPool();
    public static void main ( final String... args ) throws Throwable {
        List<Future<Integer>> results = new ArrayList<>();
        for ( int i = 0; i < 10; i++ ) {
            results.add ( asyncSum ( i, i * i ) );
        }
        for ( final Future<Integer> result : results ) {
            System.out.println ( result.get() );
        }
    }
    private static Future<Integer> asyncSum ( final int a, final int b ) {
        return es.submit ( new Callable<Integer>() {
            @Override public Integer call() throws Exception {
                return a + b;
            }
        } );
    }
}
