package com.naveed.workingfiles;
import org.apache.commons.mail.DefaultAuthenticator;
import org.apache.commons.mail.EmailAttachment;
import org.apache.commons.mail.MultiPartEmail;
public class Mail {
    String senderID;
    String senderPassword;
    String hostName;
    int portNumber;
    String attachmentPath;
    String subject;
    String body;
    String cc;
    String bcc;
    public String getBcc() {
        return bcc;
    }
    public void setBcc ( String bcc ) {
        this.bcc = bcc;
    }
    public String getCc() {
        return cc;
    }
    public void setCc ( String cc ) {
        this.cc = cc;
    }
    public String getBody() {
        return body;
    }
    public void setBody ( String body ) {
        this.body = body;
    }
    public String getSubject() {
        return subject;
    }
    public void setSubject ( String subject ) {
        this.subject = subject;
    }
    public String getSenderID() {
        return senderID;
    }
    public void setSenderID ( String senderID ) {
        this.senderID = senderID;
    }
    public String getSenderPassword() {
        return senderPassword;
    }
    public void setSenderPassword ( String senderPassword ) {
        this.senderPassword = senderPassword;
    }
    public String getHostName() {
        return hostName;
    }
    public void setHostName ( String hostName ) {
        this.hostName = hostName;
    }
    public int getPortNumber() {
        return portNumber;
    }
    public void setPortNumber ( int portNumber ) {
        this.portNumber = portNumber;
    }
    public String getAttachmentPath() {
        return attachmentPath;
    }
    public void setAttachmentPath ( String attachmentPath ) {
        this.attachmentPath = attachmentPath;
    }
    public void sendMail ( String receiverId ) {
        try {
            MultiPartEmail email = new MultiPartEmail();
            email.setSmtpPort ( getPortNumber() );
            email.setAuthenticator ( new DefaultAuthenticator ( getSenderID(),
                                     getSenderPassword() ) );
            email.setSSL ( true );
            email.setHostName ( getHostName() );
            email.addTo ( receiverId );
            if ( getCc() != null ) {
                email.addCc ( getCc() );
            }
            if ( getBcc() != null ) {
                email.addBcc ( getBcc() );
            }
            email.setFrom ( getSenderID() );
            email.setSubject ( getSubject() );
            email.setMsg ( getBody() );
            if ( getAttachmentPath() != null ) {
                EmailAttachment attachment = new EmailAttachment();
                attachment.setPath ( getAttachmentPath() );
                attachment.setDisposition ( EmailAttachment.ATTACHMENT );
                email.attach ( attachment );
            }
            email.send();
        } catch ( Exception e ) {
            e.printStackTrace();
        }
    }
}
