package com.sapien.music.importer.util;
import java.io.File;
@SuppressLint ( "NewApi" )
public class StorageOptions {
    public static String[] labels;
    public static String[] paths;
    public static int count = 0;
    private static Context sContext;
    private static ArrayList<String> sVold = new ArrayList<String>();
    public static void determineStorageOptions ( Context context ) {
        sContext = context.getApplicationContext();
        readVoldFile();
        testAndCleanList();
        setProperties();
    }
    private static void readVoldFile() {
        sVold.add ( "/mnt/sdcard" );
        try {
            Scanner scanner = new Scanner ( new File ( "/system/etc/vold.fstab" ) );
            while ( scanner.hasNext() ) {
                String line = scanner.nextLine();
                if ( line.startsWith ( "dev_mount" ) ) {
                    String[] lineElements = line.split ( " " );
                    String element = lineElements[2];
                    if ( element.contains ( ":" ) ) {
                        element = element.substring ( 0, element.indexOf ( ":" ) );
                    }
                    if ( element.contains ( "usb" ) ) {
                        continue;
                    }
                    if ( !sVold.contains ( element ) ) {
                        sVold.add ( element );
                    }
                }
            }
        } catch ( Exception e ) {
            e.printStackTrace();
        }
    }
    private static void testAndCleanList() {
        for ( int i = 0; i < sVold.size(); i++ ) {
            String voldPath = sVold.get ( i );
            File path = new File ( voldPath );
            if ( !path.exists() || !path.isDirectory() || !path.canWrite() ) {
                sVold.remove ( i-- );
            }
        }
    }
    private static void setProperties() {
        ArrayList<String> labelList = new ArrayList<String>();
        int j = 0;
        if ( sVold.size() > 0 ) {
            if ( Build.VERSION.SDK_INT < Build.VERSION_CODES.GINGERBREAD ) {
                labelList.add ( "Auto" );
            } else if ( Build.VERSION.SDK_INT < Build.VERSION_CODES.HONEYCOMB ) {
                if ( Environment.isExternalStorageRemovable() ) {
                    labelList.add ( sContext
                                    .getString ( R.string.text_external_storage ) + " 1" );
                    j = 1;
                } else
                    labelList.add ( sContext
                                    .getString ( R.string.text_internal_storage ) );
            } else {
                if ( !Environment.isExternalStorageRemovable()
                        || Environment.isExternalStorageEmulated() )
                    labelList.add ( sContext
                                    .getString ( R.string.text_internal_storage ) );
                else {
                    labelList.add ( sContext
                                    .getString ( R.string.text_external_storage ) + " 1" );
                    j = 1;
                }
            }
            if ( sVold.size() > 1 ) {
                for ( int i = 1; i < sVold.size(); i++ ) {
                    labelList.add ( sContext
                                    .getString ( R.string.text_external_storage )
                                    + " " + ( i + j ) );
                }
            }
        }
        labels = new String[labelList.size()];
        labelList.toArray ( labels );
        paths = new String[sVold.size()];
        sVold.toArray ( paths );
        count = Math.min ( labels.length, paths.length );
        sVold.clear();
    }
