import java.util.*;
class Uniques {
    static class Pair {
        int a;
        int b;
        Pair ( int a, int b ) {
            this.a = a;
            this.b = b;
        }
        public boolean equals ( Object o ) {
            if ( o instanceof Pair ) {
                Pair p = ( Pair ) o;
                if ( a == p.a && b == p.b ) {
                    return true;
                }
                if ( a == p.b && b == p.a ) {
                    return true;
                }
            }
            return false;
        }
        public int hashCode() {
            return a ^ b;
        }
        public String toString() {
            return "Pair (" + a + "," + b + ")";
        }
    }
    static Random rand = new Random();
    static Set<Pair> generatePairs ( int[] alphabet, int num ) {
        Set<Pair> set = new HashSet<Pair>();
        int size = alphabet.length * alphabet.length;
        while ( set.size() < num ) {
            int both = rand.nextInt ( size );
            int apos = both % alphabet.length;
            int bpos = both / alphabet.length;
            int a = alphabet[apos];
            int b = alphabet[bpos];
            Pair pair = new Pair ( a, b );
            set.add ( pair );
        }
        return set;
    }
    public static void main ( String...args ) {
        int[] nums = new int[10];
        int p = 2;
        for ( int i = 0; i < nums.length; i++ ) {
            while ( !isPrime ( p ) ) {
                p++;
            }
            nums[i] = p++;
        }
        Set<Pair> pairs = generatePairs ( nums, 20 );
        for ( Pair pair : pairs ) {
            System.out.println ( pair );
        }
    }
    public static boolean isPrime ( int p ) {
        if ( p == 2 ) {
            return true;
        }
        if ( p % 2 == 0 ) {
            return false;
        }
        int q = ( int ) ( Math.sqrt ( p ) + 1 );
        for ( int i = 3; i < q; i += 2 ) {
            if ( p % i == 0 ) {
                return false;
            }
        }
        return true;
    }
}
