public class Impo extends PreferenceActivity {
    Preference info;
    Intent intent;
    Preference cache;
    @Override
    protected void onCreate ( final Bundle savedInstanceState ) {
        super.onCreate ( savedInstanceState );
        this.addPreferencesFromResource ( R.xml.layout );
        info = this.findPreference ( "info" );
        info.setOnPreferenceClickListener ( new OnPreferenceClickListener() {
            @Override
            public boolean onPreferenceClick ( final Preference preference ) {
                intent = new Intent ( getBaseContext(), Info.class );
                startActivity ( intent );
                return true;
            }
        } );
        cache = this.findPreference ( "cache" );
        cache.setOnPreferenceClickListener ( new OnPreferenceClickListener() {
            @Override
            public boolean onPreferenceClick ( final Preference preference ) {
                clearCache ( Impo.this );
                return true;
            }
        } );
    }
    public static void clearCache ( final Context context ) {
        final File cache = context.getCacheDir();
        final File appDir = new File ( cache.getParent() );
        if ( appDir.exists() ) {
            final String[] children = appDir.list();
            for ( final String childFilePath : children )
                if ( !childFilePath.equals ( "lib" ) ) {
                    deleteDir ( new File ( appDir, childFilePath ) );
                    Log.i ( "TAG", "**************** File /data/data/APP_PACKAGE/" + childFilePath
                            + " DELETED *******************" );
                }
        }
    }
    public static boolean deleteDir ( final File dir ) {
        if ( dir == null ) {
            return true;
        }
        if ( dir.isDirectory() ) {
            final String[] children = dir.list();
            for ( final String childFilePath : children ) {
                final boolean success = deleteDir ( new File ( dir, childFilePath ) );
                if ( !success ) {
                    return false;
                }
            }
        }
        return dir.delete();
    }
}
