interface Artpiece {
    public String name();
    public Bundling bundling();
    public float price();
}
public class BubbleWrap implements Bundling {
    public String bundle() {
        return "BubbleWrap";
    }
}
interface Bundling {
    public String bundle();
}
public class Cushioning implements Bundling {
    public String bundle() {
        return "Cushioning";
    }
}
abstract class FGItem implements Artpiece {
    public Bundling bundling() {
        Bundling b = new BubbleWrap();
        return b;
    }
    public abstract float price();
}
public class GlassWare extends FGItem {
    public String name() {
        return "GlassWare";
    }
    public float price() {
        return 160;
    }
}
public class Pottery extends FGItem {
    public String name() {
        return "Pottery";
    }
    public float price() {
        return 25;
    }
}
import java.util.ArrayList;
public class ArtItems implements Artpiece {
    float sum = 0;
    ArrayList<Artpiece> item = new ArrayList<Artpiece>();
    public String name() {
        return name();
    }
    public Bundling bundling() {
        return bundling();
    }
    public float price() {
        return price();
    }
    public float getCost() {
        for ( int i = 0; i < item.size(); i++ ) {
            Artpiece art = item.get ( i );
            sum += art.price();
        }
        return sum;
    }
    public void addItem ( Artpiece artpiece ) {
        item.add ( artpiece );
    }
    public void showItems() {
        for ( int i = 0; i < item.size(); i++ ) {
            Artpiece art = item.get ( i );
            System.out.println ( "Item: " + art.name() + " Packaging " + art.bundling().bundle() + ", Price: " + art.price() );
        }
    }
}
public class Dispatcher {
    public ArtItems prepareFGitem() {
        ArtItems artitems = new ArtItems();
        artitems.addItem ( new Pottery() );
        artitems.addItem ( new GlassWare() );
        return artitems;
    }
}
public class Salesorder {
    public static void main ( String[] args ) {
        Dispatcher dispatcher = new Dispatcher();
        ArtItems FGartitem = dispatcher.prepareFGitem();
        System.out.println ( "Fragile Items" );
        FGartitem.showItems();
        System.out.println ( "Total Cost: " + FGartitem.getCost() );
    }
}
