import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
public class Main {
    private static final int SIEVE_LIMIT = ( int ) Math.floor ( Math.sqrt ( 1000000000 ) ) + 1;
    private static final boolean[] COMPOSITES = new boolean[SIEVE_LIMIT];
    private static final ArrayList<Integer> PRIMES = new ArrayList<Integer>();
    public static void main ( String[] args ) {
        BufferedReader inStream = null;
        BufferedWriter outStream = null;
        int outerSieveNdx, innerSieveNdx, numCases, spaceNdx, beg, end, limit;
        String line = null;
        boolean[] segmentedSieve = null;
        StringBuilder resultBuilder = new StringBuilder();
        COMPOSITES[0] = true;
        COMPOSITES[1] = true;
        for ( outerSieveNdx = 2; outerSieveNdx * outerSieveNdx < SIEVE_LIMIT; ++outerSieveNdx ) {
            for ( innerSieveNdx = outerSieveNdx * outerSieveNdx; innerSieveNdx < SIEVE_LIMIT; innerSieveNdx += outerSieveNdx ) {
                COMPOSITES[innerSieveNdx] = true;
            }
        }
        for ( outerSieveNdx = 2; outerSieveNdx < SIEVE_LIMIT; ++outerSieveNdx ) {
            if ( !COMPOSITES[outerSieveNdx] ) {
                PRIMES.add ( outerSieveNdx );
            }
        }
        inStream = new BufferedReader ( new InputStreamReader ( System.in ) );
        outStream = new BufferedWriter ( new OutputStreamWriter ( System.out ) );
        try {
            numCases = Integer.parseInt ( inStream.readLine() );
            for ( outerSieveNdx = 0; outerSieveNdx < numCases; ++outerSieveNdx ) {
                line = inStream.readLine();
                spaceNdx = line.indexOf ( ' ' );
                beg = Integer.parseInt ( line.substring ( 0, spaceNdx ) );
                end = Integer.parseInt ( line.substring ( spaceNdx + 1 ) );
                if ( end < SIEVE_LIMIT ) {
                    for ( int aPrime : PRIMES ) {
                        if ( aPrime > end ) {
                            break;
                        } else {
                            if ( aPrime >= beg ) {
                                resultBuilder.append ( Integer.toString ( aPrime ) + '\n' );
                            }
                        }
                    }
                } else if ( beg > SIEVE_LIMIT ) {
                    segmentedSieve = segmentedSieve ( beg, end );
                    for ( innerSieveNdx = 0; innerSieveNdx < segmentedSieve.length; ++innerSieveNdx ) {
                        if ( !segmentedSieve[innerSieveNdx] ) {
                            resultBuilder.append ( Integer.toString ( beg + innerSieveNdx ) + '\n' );
                        }
                    }
                } else {
                    for ( int aPrime : PRIMES ) {
                        if ( aPrime >= beg ) {
                            resultBuilder.append ( Integer.toString ( aPrime ) + '\n' );
                        }
                    }
                    segmentedSieve = segmentedSieve ( SIEVE_LIMIT, end );
                    limit = end - SIEVE_LIMIT;
                    for ( innerSieveNdx = 0; innerSieveNdx <= limit; ++innerSieveNdx ) {
                        if ( !segmentedSieve[innerSieveNdx] ) {
                            resultBuilder.append ( Integer.toString ( SIEVE_LIMIT + innerSieveNdx ) + '\n' );
                        }
                    }
                }
                resultBuilder.append ( '\n' );
            }
            inStream.close();
            outStream.write ( resultBuilder.toString().trim() );
            outStream.close();
            return;
        } catch ( Exception e ) {
            e.printStackTrace();
        }
    }
    public static boolean[] segmentedSieve ( int beg, int end ) {
        boolean[] segmentedSieve = null;
        int innerSieveNdx;
        int limit = ( int ) Math.ceil ( Math.sqrt ( end ) );
        int remainder;
        segmentedSieve = new boolean[end - beg + 1];
        for ( int aPrime : PRIMES ) {
            if ( aPrime > limit ) {
                break;
            }
            innerSieveNdx = beg;
            remainder = innerSieveNdx % aPrime;
            if ( remainder != 0 ) {
                innerSieveNdx += aPrime - remainder;
            }
            for ( ; innerSieveNdx <= end; innerSieveNdx += aPrime ) {
                segmentedSieve[innerSieveNdx - beg] = true;
            }
        }
        return segmentedSieve;
    }
}
