public class ViewPagerMapBevelScroll extends android.support.v4.view.ViewPager {
    private static final int DEFAULT_SWIPE_MARGIN_WIDTH_DIP = 20;
    private int swipeMarginWidth;
    public ViewPagerMapBevelScroll ( Context context ) {
        super ( context );
        setDefaultSwipeMargin ( context );
    }
    public ViewPagerMapBevelScroll ( Context context, AttributeSet attrs ) {
        super ( context, attrs );
        setDefaultSwipeMargin ( context );
    }
    private void setDefaultSwipeMargin ( final Context context ) {
        swipeMarginWidth = ( int ) ( DEFAULT_SWIPE_MARGIN_WIDTH_DIP * context
                                     .getResources().getDisplayMetrics().density );
    }
    @Override
    protected boolean canScroll ( View v, boolean checkV, int dx, int x, int y ) {
        if ( v instanceof ViewPagerMapBevelScroll ) {
            if ( getCurrentItem() == SectionsPagerAdapter.MAP_TAB ) {
                return !isAllowedMapSwipe ( x, dx );
            }
        }
        return super.canScroll ( v, checkV, dx, x, y );
    }
    protected boolean isAllowedMapSwipe ( final float x, final float dx ) {
        return ( ( x < swipeMarginWidth ) && ( dx > 0 ) )
               || ( ( x > ( getWidth() - swipeMarginWidth ) ) && ( dx < 0 ) );
    }
}
