package p1;
import java.util.ArrayList;
import java.util.List;
public class BlockManager {
    private Block fallingBlock;
    private List<Block> allBlocks;
    private Column[] columns;
    private BlockManager() {
        allBlocks = new ArrayList<Block>();
        columns = new Column[9];
        for ( int i = 0; i < 9; i++ ) {
            columns[i] = new Column();
        }
    }
    public static BlockManager getInstance() {
        return BlockManagerHolder.INSTANCE;
    }
    private static class BlockManagerHolder {
        private static final BlockManager INSTANCE = new BlockManager();
    }
    public void AddBlock() {
        fallingBlock = new Block ( 0, 3, 20 );
        allBlocks.add ( fallingBlock );
    }
    public void RemoveBlock ( Block block ) {
        allBlocks.remove ( block );
        List<Block> blocks = columns[block.getColumn()].getBlocks();
        if ( blocks.size() > block.getLevel() ) {
            for ( int i = block.getLevel(); i < blocks.size(); i++ ) {
                blocks.get ( i ).getBounds().y += 20;
            }
        }
        columns[block.getColumn()].getBlocks().remove ( block );
    }
    public Block getFallingBlock() {
        return fallingBlock;
    }
    public void setFallingBlock ( Block fallingBlock ) {
        this.fallingBlock = fallingBlock;
    }
    public List<Block> getAllBlocks() {
        return allBlocks;
    }
    public void setAllBlocks ( List<Block> allBlocks ) {
        this.allBlocks = allBlocks;
    }
    public Column[] getColumns() {
        return columns;
    }
    public void setColumns ( Column[] columns ) {
        this.columns = columns;
    }
}
