package p1;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.util.LinkedList;
import java.util.TimerTask;
import javax.swing.Timer;
import javax.swing.JPanel;
public class EventRect extends JPanel {
    public static Block getFallingBlock() {
        return BlockManager.getInstance().getFallingBlock();
    }
    private BlockBuster blockBuster;
    private LinkedList<TimerTask> tasklist = new LinkedList<TimerTask>();
    Timer timet;
    int i = 1;
    public EventRect() {
        BlockManager.getInstance().AddBlock();
        this.blockBuster = new BlockBuster();
        addKeyListener ( new InputKey() );
        setFocusable ( true );
        startSampling();
    }
    @Override
    public void paintComponent ( Graphics g ) {
        super.paintComponent ( g );
        Graphics2D g2d = ( Graphics2D ) g;
        for ( Block dropObject : BlockManager.getInstance().getAllBlocks() ) {
            Rectangle bounds = dropObject.getBounds();
            g2d.setColor ( dropObject.getColor() );
            g2d.fillRect ( bounds.x, bounds.y, bounds.width + 1, bounds.height + 1 );
        }
    }
    public void moveRectangle() {
        Column[] columns = BlockManager.getInstance().getColumns();
        if ( getFallingBlock().getBounds().getY() >=
                columns[getFallingBlock().getColumn()].getDepthRemaining() ) {
            columns[getFallingBlock().getColumn()].getBlocks().add ( getFallingBlock() );
            blockBuster.bustBlocks();
            BlockManager.getInstance().AddBlock();
        } else {
            BlockManager.getInstance().getFallingBlock().getBounds().y += 20;
        }
    }
    final void startSampling() {
        TimerTask task = new TimerTask() {
            @Override
            public void run() {
                moveRectangle();
                repaint();
            }
        };
        java.util.Timer timer = new java.util.Timer();
        timer.scheduleAtFixedRate ( task, 0, 150 );
        tasklist.add ( task );
    }
    void stopSampling() {
        if ( tasklist.isEmpty() ) {
            return;
        }
        tasklist.removeFirst().cancel();
    }
}
