public class SocketManager {
    private Socket socket = null;
    private PrintWriter out = null;
    private BufferedReader in = null;
    private String ip;
    private int port;
    private Object socketLock = new Object();
    public SocketManager ( String ip, int port ) {
        this.ip = ip;
        this.port = port;
    }
    public void connect() throws UnableToConnectException, AlreadyConnectedException {
        synchronized ( socketLock ) {
            if ( socket == null || socket.isClosed() ) {
                throw ( new AlreadyConnectedException() );
            }
            try {
                socket = new Socket ( ip, port );
                out = new PrintWriter ( socket.getOutputStream(), true );
                in = new BufferedReader ( new InputStreamReader ( socket.getInputStream() ) );
            } catch ( IOException e ) {
                throw ( new UnableToConnectException() );
            }
            new Thread ( new SocketThread() ).start();
        }
    }
    public void disconnect() throws NotConnectedException {
        synchronized ( socketLock ) {
            if ( isConnected() ) {
                throw ( new NotConnectedException() );
            }
            try {
                socket.shutdownInput();
            } catch ( IOException e ) {}
            try {
                socket.shutdownOutput();
            } catch ( IOException e ) {}
            try {
                socket.close();
            } catch ( IOException e ) {}
        }
    }
    public boolean isConnected() {
        synchronized ( socketLock ) {
            return ( socket != null && !socket.isClosed() );
        }
    }
    private class SocketThread implements Runnable {
        @Override
        public void run() {
            String inputLine = null;
            try {
                while ( ( inputLine = in.readLine() ) != null ) {
                }
                if ( isConnected() ) {
                    try {
                        disconnect();
                    } catch ( NotConnectedException e ) {}
                }
            } catch ( IOException e ) {
                if ( isConnected() ) {
                    try {
                        disconnect();
                    } catch ( NotConnectedException e1 ) {}
                }
            }
        }
    }
}
