public class Block extends JComponent {
    private final static String ID = "BlockUI";
    public Block ( Color color ) {
        setBackground ( color );
        updateUI();
    }
    @Override
    public void updateUI() {
        setUI ( UIManager.getUI ( this ) );
    }
    @Override
    public String getUIClassID() {
        return ID;
    }
}
public class BasicBlockUI extends ComponentUI {
    public static ComponentUI createUI ( JComponent c ) {
        return new BasicBlockUI();
    }
    @Override
    public void paint ( Graphics g, JComponent c ) {
        g.setColor ( c.getBackground() );
        g.fillRect ( 10, 10, c.getWidth() - 20, c.getHeight() - 20 );
    }
}
UIManager.put ( "BlockUI", "org.jdesktop.swingx.plaf.BasicBlockUI" );
JXFrame frame = new JXFrame ( "custom box", true );
Block block = new Block ( Color.RED );
frame.add ( block );
frame.setSize ( 200, 200 );
frame.setVisible ( true );
