import com.hp.hpl.jena.graph.Triple;
import com.hp.hpl.jena.query.Query;
import com.hp.hpl.jena.query.QueryExecutionFactory;
import com.hp.hpl.jena.query.QueryFactory;
import com.hp.hpl.jena.query.ResultSetFormatter;
import com.hp.hpl.jena.rdf.model.Model;
import com.hp.hpl.jena.rdf.model.ModelFactory;
import com.hp.hpl.jena.rdf.model.Property;
import com.hp.hpl.jena.rdf.model.Resource;
import com.hp.hpl.jena.sparql.core.Var;
import com.hp.hpl.jena.sparql.syntax.ElementGroup;
public class AddTriplePattern {
    public static void main ( String[] args ) {
        final String queryString = "" +
                                   "select * where {\n" +
                                   "  ?s ?p ?o .\n" +
                                   "}\n" +
                                   "";
        final Query query = QueryFactory.create ( queryString );
        final Query newQuery = QueryFactory.create ( query );
        System.out.println ( "== before ==\n" + newQuery );
        final ElementGroup eg = ( ElementGroup ) newQuery.getQueryPattern();
        final Triple t = new Triple ( Var.alloc ( "s2" ), Var.alloc ( "p2" ), Var.alloc ( "o2" ) );
        eg.addTriplePattern ( t );
        newQuery.setQueryResultStar ( false );
        newQuery.addResultVar ( "s2" );
        System.out.println ( "== after ==\n" + newQuery );
        final Model model = ModelFactory.createDefaultModel();
        final Resource a = model.createResource ( "urn:ex:a" );
        model.add ( a, a.as ( Property.class ), a );
        ResultSetFormatter.out ( QueryExecutionFactory.create ( query, model ).execSelect() );
        ResultSetFormatter.out ( QueryExecutionFactory.create ( newQuery, model ).execSelect() );
    }
}
