class AnnotationRegistry {
    public static void register ( String pattern, TownyChatReplacerCallable handler ) {}
    public static void register ( Class<?> clazz ) {
        Field[] fields = clazz.getDeclaredFields();
        for ( Field field : fields ) {
            PatternHandler annotation = field.getAnnotation ( PatternHandler.class );
            if ( annotation != null ) {
                if ( !Modifier.isStatic ( field.getModifiers() ) ) {
                    System.out.println ( "Field must be static:" + field.getName() );
                    continue;
                }
                try {
                    Object object = field.get ( null );
                    if ( object instanceof TownyChatReplacerCallable ) {
                        register ( annotation.value(), ( TownyChatReplacerCallable ) object );
                    } else {
                        System.out.println ( "Field must be instanceof TownyChatReplacerCallable:"  + field.getName() );
                    }
                } catch ( IllegalArgumentException e ) {
                    e.printStackTrace();
                } catch ( IllegalAccessException e ) {
                    e.printStackTrace();
                }
            }
        }
    }
}
