public class WholeFileInputFormat extends CombineFileInputFormat<NullWritable, Text> {
    @Override
    protected boolean isSplitable ( JobContext context, Path file ) {
        return false;
    }
    @Override
    public RecordReader<NullWritable, Text> createRecordReader (
        InputSplit split, TaskAttemptContext context ) throws IOException {
        if ( ! ( split instanceof CombineFileSplit ) ) {
            throw new IllegalArgumentException ( "split must be a CombineFileSplit" );
        }
        return new CombineFileRecordReader<NullWritable, Text> ( ( CombineFileSplit ) split, context, WholeFileRecordReader.class );
    }
}
