package test.urlstore;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
public class DuplicateDemo {
    public static void main ( String[] args ) throws Exception {
        List<UrlStore> urlStores = new ArrayList<UrlStore>();
        UrlStore usg = new UrlStore ( "google" );
        UrlStore usy = new UrlStore ( "yahoo" );
        UrlStore usb = new UrlStore ( "bing" );
        UrlStore usa = new UrlStore ( "ask" );
        UrlStore usd = new UrlStore ( "duckduckgo" );
        usg.setData ( "mail" );
        urlStores.add ( usg );
        usg = new UrlStore ( "google" );
        usg.setData ( "search" );
        urlStores.add ( usg );
        usg = new UrlStore ( "google" );
        usg.setData ( "doc" );
        urlStores.add ( usg );
        usg = new UrlStore ( "google" );
        usg.setData ( "search" );
        urlStores.add ( usg );
        usg = new UrlStore ( "google" );
        usy.setData ( "search" );
        urlStores.add ( usy );
        usy.setData ( "search" );
        urlStores.add ( usy );
        usb.setData ( "search" );
        urlStores.add ( usb );
        usb.setData ( "search" );
        urlStores.add ( usb );
        usa.setData ( "search" );
        urlStores.add ( usa );
        usd.setData ( "search" );
        urlStores.add ( usd );
        System.out.println ( "before removing duplicates" );
        for ( Iterator iterator = urlStores.iterator(); iterator.hasNext(); ) {
            UrlStore urlStore = ( UrlStore ) iterator.next();
            System.out.println ( urlStore.toString() );
        }
        System.out.println ( "\n\nafter removing duplicates" );
        Set<UrlStore> uniqueUrlStores = new HashSet<UrlStore> ( urlStores );
        for ( Iterator iterator = uniqueUrlStores.iterator(); iterator.hasNext(); ) {
            UrlStore urlStore = ( UrlStore ) iterator.next();
            System.out.println ( urlStore.toString() );
        }
    }
    static class UrlStore {
        public String url;
        public String data;
        public UrlStore ( String url ) {
            this.url = url;
        }
        public void setData ( String data ) {
            this.data = data;
        }
        @Override
        public String toString() {
            return "UrlStore [url=" + url + ", data=" + data + "]";
        }
        @Override
        public int hashCode() {
            final int prime = 31;
            int result = 1;
            result = prime * result + ( ( data == null ) ? 0 : data.hashCode() );
            result = prime * result + ( ( url == null ) ? 0 : url.hashCode() );
            return result;
        }
        @Override
        public boolean equals ( Object obj ) {
            if ( this == obj ) {
                return true;
            }
            if ( obj == null ) {
                return false;
            }
            if ( getClass() != obj.getClass() ) {
                return false;
            }
            UrlStore other = ( UrlStore ) obj;
            if ( data == null ) {
                if ( other.data != null ) {
                    return false;
                }
            } else if ( !data.equals ( other.data ) ) {
                return false;
            }
            if ( url == null ) {
                if ( other.url != null ) {
                    return false;
                }
            } else if ( !url.equals ( other.url ) ) {
                return false;
            }
            return true;
        }
    }
}
