public interface DoorCommand {
    public void execute ( Door door ) throws CommandException;
}
public class Door {
    private List<Command> history = new ArrayList<Command>();
    private int angle;
    private boolean locked;
    public void addCommandToHistory ( Command command ) {
        history.add ( command );
    }
}
public class OpenDoor implements DoorCommand {
    public void execute ( Door door ) throws CommandException {
        door.addCommandToHistory ( this );
        if ( door.isLocked() ) {
            throw new CommandException ( "Door is locked, cannot open" );
        }
        if ( door.getAngle() < 90 ) {
            door.setAngle ( 90 );
        }
    }
}
public class LockDoor implements DoorCommand {
    public void execute ( Door door ) throws CommandException {
        door.addCommandToHistory ( this );
        door.setLocked ( true );
    }
}
