private static void insertWatermarkText ( Document doc, String watermarkText ) throws Exception {
    Shape watermark = new Shape ( doc, ShapeType.TEXT_PLAIN_TEXT );
    watermark.getTextPath().setText ( watermarkText );
    watermark.getTextPath().setFontFamily ( "Arial" );
    watermark.setWidth ( 500 );
    watermark.setHeight ( 100 );
    watermark.setRotation ( -40 );
    watermark.getFill().setColor ( Color.GRAY );
    watermark.setStrokeColor ( Color.GRAY );
    watermark.setRelativeHorizontalPosition ( RelativeHorizontalPosition.PAGE );
    watermark.setRelativeVerticalPosition ( RelativeVerticalPosition.PAGE );
    watermark.setWrapType ( WrapType.NONE );
    watermark.setVerticalAlignment ( VerticalAlignment.CENTER );
    watermark.setHorizontalAlignment ( HorizontalAlignment.CENTER );
    Paragraph watermarkPara = new Paragraph ( doc );
    watermarkPara.appendChild ( watermark );
    for ( Section sect : doc.getSections() ) {
        insertWatermarkIntoHeader ( watermarkPara, sect, HeaderFooterType.HEADER_PRIMARY );
        insertWatermarkIntoHeader ( watermarkPara, sect, HeaderFooterType.HEADER_FIRST );
        insertWatermarkIntoHeader ( watermarkPara, sect, HeaderFooterType.HEADER_EVEN );
    }
    System.out.println ( "Watermark Set" );
}
private static void insertWatermarkIntoHeader ( Paragraph watermarkPara, Section sect, int headerType ) throws Exception {
    HeaderFooter header = sect.getHeadersFooters().getByHeaderFooterType ( headerType );
    if ( header == null ) {
        header = new HeaderFooter ( sect.getDocument(), headerType );
        sect.getHeadersFooters().add ( header );
    }
    header.appendChild ( watermarkPara.deepClone ( true ) );
}
