...
protected final void runLeaf ( Statement statement, Description description,
                               RunNotifier notifier ) {
    EachTestNotifier eachNotifier = new EachTestNotifier ( notifier, description );
    eachNotifier.fireTestStarted();
    try {
        statement.evaluate();
        < -- test method execution is called from here
    } catch ( AssumptionViolatedException e ) {
        eachNotifier.addFailedAssumption ( e );
    } catch ( Throwable e ) {
        eachNotifier.addFailure ( e );
    } finally {
        eachNotifier.fireTestFinished();
    }
}
