public class Index {
    ...
}
public static boolean isValid ( Index index ) {
    ...
}
public class Board {
    ...
}
public enum ColorType { BLANK, WHITE, BLACK; }
public enum Direction {
    UP_LEFT, UP, UP_RIGHT, RIGHT, BOTTOM_RIGHT, BOTTOM, BOTTOM_LEFT, LEFT;
    public Index next ( Index index ) {
        switch ( this ) {
        case UP_LEFT:
            return new Index ( index.row() - 1, index.column() - 1 );
        case BOTTOM:
            return new Index ( index.row() + 1, index.column() );
            ...
        }
    }
}
public class Piece {
    private Board board;
    private ColorType color = ColorType.BLANK;
    private Index index;
    ....
    private void checkCaptures() {
        Direction[] directions = Direction.values();
        for ( Direction direction : directions ) {
            Index nextIndex = direction.next ( this.index );
            if ( isValid ( nextIndex ) ) {
                Piece piece = board.getPiece ( nextIndex );
                List<Piece> candidatesToCapture = new ArrayList<Piece>();
                piece.findCaptureCandidates ( candidatesToCapture, this.color, direction );
                for ( Piece candidate : candidatesToCapture ) {
                    candidate.capture();
                }
            }
        }
    }
    private void findCaptureCandidates ( List<Piece> captured, ColorType firstColor, Direction d ) {
        Index next = d.next ( this.index );
        if ( this.color == firstColor ) {
        } else if ( this.color == ColorType.BLANK ) {
            captured.clear();
        } else {
            if ( isValid ( next ) ) {
                captured.add ( this );
                Piece piece = board.getPiece ( next );
                piece.findCaptureCandidates ( captured, firstColor, d );
            } else {
                captured.clear();
            }
        }
    }
}
