import java.io.IOException;
import java.io.RandomAccessFile;
import net.sf.sevenzipjbinding.ISevenZipInArchive;
import net.sf.sevenzipjbinding.SevenZip;
import net.sf.sevenzipjbinding.SevenZipException;
import net.sf.sevenzipjbinding.impl.RandomAccessFileInStream;
import net.sf.sevenzipjbinding.simple.ISimpleInArchive;
import net.sf.sevenzipjbinding.simple.ISimpleInArchiveItem;
public class ExtractItemsSimple {
    public static void main ( String[] args ) {
        RandomAccessFile randomAccessFile = null;
        ISevenZipInArchive inArchive = null;
        try {
            randomAccessFile = new RandomAccessFile ( args[0], "r" );
            inArchive = SevenZip.openInArchive ( null,
                                                 new RandomAccessFileInStream ( randomAccessFile ) );
            ISimpleInArchive simpleInArchive = inArchive.getSimpleInterface();
            for ( ISimpleInArchiveItem item : simpleInArchive.getArchiveItems() ) {
                final int[] hash = new int[] { 0 };
                if ( !item.isFolder() ) {
                    System.out.println ( ArchieveInputStreamHandler.slurp ( new ArchieveInputStreamHandler ( item ).getInputStream(), 1000 ) );
                }
            }
        } catch ( Exception e ) {
            System.err.println ( "Error occurs: " + e );
            System.exit ( 1 );
        } finally {
            if ( inArchive != null ) {
                try {
                    inArchive.close();
                } catch ( SevenZipException e ) {
                    System.err.println ( "Error closing archive: " + e );
                }
            }
            if ( randomAccessFile != null ) {
                try {
                    randomAccessFile.close();
                } catch ( IOException e ) {
                    System.err.println ( "Error closing file: " + e );
                }
            }
        }
    }
}
