private final AtomicReference<Node> head = new AtomicReference<>();
@SuppressWarnings ( "unchecked" )
public void offer ( final V data ) {
    final Node<V> newNode = new Node<> ( data, Thread.currentThread().getName() );
    if ( head.compareAndSet ( null, newNode ) ) {
        return;
    }
    Node<V> pointer = head.get();
    for ( ;; ) {
        if ( pointer.next.compareAndSet ( null, newNode ) ) {
            break;
        }
        pointer = pointer.next.get();
    }
}
