import java.util.ArrayList;
import java.util.List;
public class Matrix {
    private double[][] data;
    public Matrix ( double[][] data ) {
        int r = data.length;
        int c = data[0].length;
        this.data = new double[r][c];
        for ( int i = 0; i < r; i++ ) {
            for ( int j = 0; j < c; j++ ) {
                this.data[i][j] = data[i][j];
            }
        }
    }
    public String toString() {
        StringBuilder sb = new StringBuilder ( 1024 );
        for ( double[] row : this.data ) {
            for ( double val : row ) {
                sb.append ( val );
                sb.append ( " " );
            }
            sb.append ( "\n" );
        }
        return ( sb.toString() );
    }
    public void removeRowsWithValue ( final double value ) {
        List<double[]> rowsToKeep = new ArrayList<double[]> ( this.data.length );
        for ( double[] row : this.data ) {
            boolean found = false;
            for ( double testValue : row ) {
                if ( Double.compare ( value, testValue ) == 0 ) {
                    found = true;
                    break;
                }
            }
            if ( !found ) {
                rowsToKeep.add ( row );
            }
        }
        this.data = new double[rowsToKeep.size()][];
        for ( int i = 0; i < rowsToKeep.size(); i++ ) {
            this.data[i] = rowsToKeep.get ( i );
        }
    }
    public static void main ( String[] args ) {
        double[][] test = { {1, 2, 3, 4, 5, 6, 7, 8, 9},
            {6, 2, 7, 2, 9, 6, 8, 10, 5},
            {2, 6, 4, 7, 8, 4, 3, 2, 5},
            {9, 8, 7, 5, 9, 7, 4, 1, 10},
            {5, 3, 6, 8, 2, 7, 3, 7, 2}
        };
        Matrix m = new Matrix ( test );
        System.out.println ( m );
        m.removeRowsWithValue ( 10 );
        System.out.println ( m );
    }
}
