public class TestSampleTabDefault extends SherlockActivity {
    @Override
    protected void onCreate ( Bundle savedInstanceState ) {
        super.onCreate ( savedInstanceState );
    }
    @SuppressLint ( "NewApi" )
    public static class SampleTabsDefault extends FragmentActivity implements ServiceConnection {
        private static final String[] CONTENT = new String[] { "Albums", "Artists", "Songs", "Playlist", "Genre", "Recently Played", "Easy Transfer" };
        Handler mHandler;
        private ServiceToken mToken;
        private IRemoteService  mIRemoteService;
        public static ViewPager pager;
        public static int index = 0;
        public static android.app.ActionBar mActionBar;
        @Override
        protected void onCreate ( Bundle savedInstanceState ) {
            super.onCreate ( savedInstanceState );
            setContentView ( R.layout.simple_tabs );
            FragmentPagerAdapter adapter = new GoogleMusicAdapter ( getSupportFragmentManager() );
            pager = ( ViewPager ) findViewById ( R.id.pager );
            pager.setAdapter ( adapter );
            TabPageIndicator indicator = ( TabPageIndicator ) findViewById ( R.id.indicator );
            indicator.setViewPager ( pager );
            index = getIntent().getExtras().getInt ( "index" );
            if ( index > 0 ) {
                indicator.setCurrentItem ( index );
            }
        }
        class GoogleMusicAdapter extends FragmentPagerAdapter {
            private final FragmentManager mFragmentManager;
            private Fragment mFragmentAtPos0;
            public GoogleMusicAdapter ( FragmentManager fm ) {
                super ( fm );
                mFragmentManager = fm;
            }
            @Override
            public Fragment getItem ( int position ) {
                Fragment fm = null;
                if ( position == 0 ) {
                    fm = ArtistList.ArtistListFragment.newInstance();
                    return fm;
                } else if ( position == 1 ) {
                    fm = ArtistList.ArtistListFragment.newInstance();
                    return fm;
                } else if ( position == 2 ) {
                    fm = SongsList.SongsListFragment.newInstance();
                    return fm;
                } else if ( position == 3 ) {
                    fm = PlaylistList.PlayListFragment.newInstance();
                    return fm;
                } else if ( position == 4 ) {
                    fm = GenreList.GenreListFragment.newInstance();
                    return fm;
                } else if ( position == 5 ) {
                    fm = RecentAddedList.RecentListFragment.newInstance();
                    return fm;
                } else {
                    fm = TestFragment.newInstance ( CONTENT[position] );
                }
                return fm;
            }
            @Override
            public CharSequence getPageTitle ( int position ) {
                return CONTENT[position % CONTENT.length].toUpperCase();
            }
            @Override
            public int getCount() {
                return CONTENT.length;
            }
            @Override
            public int getItemPosition ( Object object ) {
                if ( object instanceof AlbumListFragment && mFragmentAtPos0 instanceof TestFragment ) {
                    return POSITION_NONE;
                }
                return POSITION_UNCHANGED;
            }
        }
    }
}
