public class MainActivity extends Activity implements
    AdapterView.OnItemClickListener {
    int count;
    private CheckBoxAdapter mCheckBoxAdapter;
    String[] GENRES = new String[] {
        "Action", "Adventure", "Animation", "Children", "Comedy",
        "Documentary", "Drama",
        "Foreign", "History", "Independent", "Romance", "Sci-Fi",
        "Television", "Thriller"
    };
    @Override
    public void onCreate ( Bundle savedInstanceState ) {
        super.onCreate ( savedInstanceState );
        setContentView ( R.layout.activity_main );
        final ListView listView = ( ListView ) findViewById ( R.id.lv );
        listView.setItemsCanFocus ( false );
        listView.setTextFilterEnabled ( true );
        listView.setOnItemClickListener ( this );
        mCheckBoxAdapter = new CheckBoxAdapter ( this, GENRES );
        listView.setAdapter ( mCheckBoxAdapter );
        Button b = ( Button ) findViewById ( R.id.button1 );
        b.setOnClickListener ( new OnClickListener() {
            @Override
            public void onClick ( View v ) {
                StringBuilder result = new StringBuilder();
                for ( int i = 0; i < GENRES.length; i++ ) {
                    if ( mCheckBoxAdapter.mCheckStates.get ( i ) == true ) {
                        result.append ( GENRES[i] );
                        result.append ( "\n" );
                    }
                }
                Toast.makeText ( MainActivity.this, result, 1000 ).show();
            }
        } );
    }
    public void onItemClick ( AdapterView parent, View view, int
                              position, long id ) {
        mCheckBoxAdapter.toggle ( position );
    }
    class CheckBoxAdapter extends ArrayAdapter implements CompoundButton.OnCheckedChangeListener {
        private SparseBooleanArray mCheckStates;
        LayoutInflater mInflater;
        TextView tv1, tv;
        CheckBox cb;
        String[] gen;
        CheckBoxAdapter ( MainActivity context, String[] genres ) {
            super ( context, 0, genres );
            mCheckStates = new SparseBooleanArray ( genres.length );
            mInflater = ( LayoutInflater ) MainActivity.this.getSystemService ( Context.LAYOUT_INFLATER_SERVICE );
            gen = genres;
        }
        @Override
        public int getCount() {
            return gen.length;
        }
        @Override
        public Object getItem ( int position ) {
            return position;
        }
        @Override
        public long getItemId ( int position ) {
            return 0;
        }
        @Override
        public View getView ( final int position, View convertView, ViewGroup parent ) {
            View vi = convertView;
            if ( convertView == null ) {
                vi = mInflater.inflate ( R.layout.checkbox, null );
            }
            tv = ( TextView ) vi.findViewById ( R.id.textView1 );
            cb = ( CheckBox ) vi.findViewById ( R.id.checkBox1 );
            tv.setText ( "Name :" + gen [position] );
            cb.setTag ( position );
            cb.setChecked ( mCheckStates.get ( position, false ) );
            cb.setOnCheckedChangeListener ( this );
            return vi;
        }
        public boolean isChecked ( int position ) {
            return mCheckStates.get ( position, false );
        }
        public void setChecked ( int position, boolean isChecked ) {
            mCheckStates.put ( position, isChecked );
        }
        public void toggle ( int position ) {
            setChecked ( position, !isChecked ( position ) );
        }
        @Override
        public void onCheckedChanged ( CompoundButton buttonView,
                                       boolean isChecked ) {
            mCheckStates.put ( ( Integer ) buttonView.getTag(), isChecked );
        }
    }
}
