@Test
public void testAction() throws IllegalArgumentException, NoSuchMethodException, IllegalAccessException, InvocationTargetException,
    CmdLineException, IOException {
    Writer w = new StringWriter();
    Layout l = new PatternLayout ( "%m%n" );
    WriterAppender wa = new WriterAppender ( l, w );
    wa.setEncoding ( "UTF-8" );
    wa.setThreshold ( Level.ALL );
    wa.activateOptions();
    Logger log = Logger.getLogger ( ExceptionHandler.class );
    log.addAppender ( wa );
    try {
        String batchLog = w.toString();
        assertTrue ( "Invalid exception text !", batchLog.contains ( "my expected text..." ) );
    } finally {
        log.removeAppender ( wa );
        wa.close();
    }
}
