import android.content.Context;
import android.database.Cursor;
import android.net.Uri;
import android.os.Bundle;
import android.provider.ContactsContract.Contacts;
import android.support.v4.app.ListFragment;
import android.support.v4.app.LoaderManager.LoaderCallbacks;
import android.support.v4.content.CursorLoader;
import android.support.v4.content.Loader;
import android.support.v4.widget.CursorAdapter;
import android.support.v4.widget.SimpleCursorAdapter;
public class ContactListFragment extends ListFragment implements LoaderCallbacks<Cursor> {
    private CursorAdapter mAdapter;
    @Override
    public void onCreate ( Bundle savedInstanceState ) {
        super.onCreate ( savedInstanceState );
        Context context = getActivity();
        int layout = android.R.layout.simple_list_item_1;
        Cursor c = null;
        int flags = 0;
        mAdapter = new SimpleCursorAdapter ( context, layout, c, FROM, TO, flags );
    }
    @Override
    public void onActivityCreated ( Bundle savedInstanceState ) {
        super.onActivityCreated ( savedInstanceState );
        setListAdapter ( mAdapter );
        getLoaderManager().initLoader ( 0, null, this );
    }
    private static final String[] PROJECTION = {
        Contacts._ID,
        Contacts.DISPLAY_NAME_PRIMARY
    };
    private static final String[] FROM = { Contacts.DISPLAY_NAME_PRIMARY };
    private static final int[] TO = { android.R.id.text1 };
    @Override
    public Loader<Cursor> onCreateLoader ( int id, Bundle args ) {
        Uri contentUri = Contacts.CONTENT_URI;
        return new CursorLoader ( getActivity(),
                                  contentUri,
                                  PROJECTION,
                                  null,
                                  null,
                                  null );
    }
    @Override
    public void onLoadFinished ( Loader<Cursor> loader, Cursor data ) {
        mAdapter.swapCursor ( data );
    }
    @Override
    public void onLoaderReset ( Loader<Cursor> loader ) {
        mAdapter.swapCursor ( null );
    }
}
