FileChooser fc = new FileChooser();
fc.setTitle ( "Open PDF file..." );
fc.getExtensionFilters().add ( new FileChooser.ExtensionFilter ( "PDF Files", "*.pdf" ) );
File f = fc.showOpenDialog ( stage.getOwner() );
String filename = file.getAbsolutePath();
PdfDecoder pdf = new PdfDecoder();
pdf.openPdfFile ( filename );
showPage ( 1 );
pdf.closePdfFile();
. . .
private void showPage ( int page ) {
    if ( page > pdf.getPageCount() ) {
        return;
    }
    if ( page < 1 ) {
        return;
    }
    pageNumber = page;
    if ( page == pdf.getPageCount() ) {
        next.setVisible ( false );
    } else {
        next.setVisible ( true );
    }
    if ( page == 1 ) {
        back.setVisible ( false );
    } else {
        back.setVisible ( true );
    }
    int pW = pdf.getPdfPageData().getCropBoxWidth ( page );
    int pH = pdf.getPdfPageData().getCropBoxHeight ( page );
    Dimension s = Toolkit.getDefaultToolkit().getScreenSize();
    s.width -= 100;
    s.height -= 100;
    double xScale = ( double ) s.width / pW;
    double yScale = ( double ) s.height / pH;
    double scale = xScale < yScale ? xScale : yScale;
    pW *= scale;
    pH *= scale;
    Image i = getPageAsImage ( page, pW, pH );
    imageView.setImage ( i );
    imageView.setFitWidth ( pW );
    imageView.setFitHeight ( pH );
    stage.setWidth ( imageView.getFitWidth() + 2 );
    stage.setHeight ( imageView.getFitHeight() + 2 );
    stage.centerOnScreen();
}
private Image getPageAsImage ( int page, int width, int height ) {
    BufferedImage img;
    try {
        img = pdf.getPageAsImage ( page );
        if ( Image.impl_isExternalFormatSupported ( BufferedImage.class ) ) {
            return javafx.scene.image.Image.impl_fromExternalImage ( img );
        }
    } catch ( Exception e ) {
        e.printStackTrace();
    }
    return null;
}
