@Override
protected void configure ( HttpSecurity http ) throws Exception {
    http
    .exceptionHandling()
    .authenticationEntryPoint ( digestEntryPoint() )
    .and()
    .authorizeUrls()
    .antMatchers ( "/firstres/*" ).permitAll()
    .antMatchers ( "/secondres/*" ).permitAll()
    .antMatchers ( "/resources/*" ).permitAll()
    .antMatchers ( "/**" ).hasAnyAuthority ( "first_role", "second_role" ).and()
    .addFilter ( digestAuthenticationFilter ( digestEntryPoint() ) );
}
@Override
@Bean
public UserDetailsService userDetailsServiceBean() {
    return super.userDetailsServiceBean();
}
public DigestAuthenticationFilter digestAuthenticationFilter (
    DigestAuthenticationEntryPoint digestAuthenticationEntryPoint ) {
    DigestAuthenticationFilter digestAuthenticationFilter = new DigestAuthenticationFilter();
    digestAuthenticationFilter.setAuthenticationEntryPoint ( digestEntryPoint() );
    digestAuthenticationFilter.setUserDetailsService ( userDetailsServiceBean() );
    return digestAuthenticationFilter;
}
