class HighlightCaret extends DefaultCaret {
    private static final Highlighter.HighlightPainter unfocusedPainter = new DefaultHighlighter.DefaultHighlightPainter ( Color.RED );
    private static final Highlighter.HighlightPainter focusedPainter = new DefaultHighlighter.DefaultHighlightPainter ( Color.YELLOW );
    private static final long serialVersionUID = 1L;
    private boolean isFocused;
    @Override
    protected Highlighter.HighlightPainter getSelectionPainter() {
        return isFocused ? focusedPainter  : unfocusedPainter;
    }
    @Override
    public void setSelectionVisible ( boolean hasFocus ) {
        if ( hasFocus != isFocused ) {
            isFocused = hasFocus;
            super.setSelectionVisible ( false );
            super.setSelectionVisible ( true );
        }
    }
}
