@WebFilter ( "/*" )
public class LoginFilter implements Filter {
    @Override
    public void init ( FilterConfig config )
    throws ServletException {
    }
    @Override
    public void doFilter ( ServletRequest req, ServletResponse res, FilterChain chain )
    throws IOException, ServletException {
        HttpServletRequest request = ( HttpServletRequest ) req;
        HttpServletResponse response = ( HttpServletResponse ) res;
        HttpSession session = request.getSession ( false );
        String requestPath = httpServletRequest.getRequestURI();
        if ( needsAuthentication ( requestPath ) ||
                session == null ||
                session.getAttribute ( "user" ) == null ) {
            response.sendRedirect ( request.getContextPath() + "/login" );
        } else {
            chain.doFilter ( req, res );
        }
    }
    @Override
    public void destroy() {
    }
    private boolean needsAuthentication ( String url ) {
        String[] validNonAuthenticationUrls =
        { "Login.jsp", "Register.jsp" };
        for ( String validUrl : validNonAuthenticationUrls ) {
            if ( url.endsWith ( validUrl ) ) {
                return false;
            }
        }
        return true;
    }
}
