import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
public class Main extends JFrame implements ActionListener {
    private int[] intArray = new int[10000];
    private int numOfInts = 0;
    private int avg = 0;
    protected JButton avgBtn;
    protected JTextField indexEntry;
    protected JLabel instructions;
    protected JPanel resultsPanel;
    public Main() {
        this.setTitle ( "Section V, question 2" );
        this.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
        this.setSize ( 350, 250 );
        this.setLayout ( new GridLayout ( 4, 1 ) );
        instructions = new JLabel ( "Follow the instructions on the exam to use this program" );
        this.add ( instructions );
        indexEntry = new JTextField();
        this.add ( indexEntry );
        avgBtn = new JButton ( "Click for Average" );
        this.add ( avgBtn );
        avgBtn.addActionListener ( this );
        resultsPanel = new JPanel();
        resultsPanel.setBackground ( Color.BLUE );
        this.add ( resultsPanel );
        readFromFile();
        computeAverage();
        System.out.println ( avg );
    }
    private void readFromFile() {
        try {
            FileInputStream fstream = new FileInputStream ( "numbers.dat" );
            DataInputStream in = new DataInputStream ( fstream );
            BufferedReader br = new BufferedReader ( new InputStreamReader ( in ) );
            String strLine;
            int i = 0;
            while ( ( strLine = br.readLine() ) != null ) {
                System.out.println ( strLine );
                intArray[i] = Integer.parseInt ( strLine );
                numOfInts++;
                i++;
            }
            in.close();
            System.out.println ( "numOfInts = " + numOfInts );
        } catch ( Exception e ) {
            System.err.println ( "Error: " + e.getMessage() );
        }
    }
    private void computeAverage() {
        int sum = 0;
        for ( int i = 0; i < numOfInts; i++ ) {
            sum += intArray[i];
        }
        avg = sum / numOfInts;
    }
    public void actionPerformed ( ActionEvent e ) {
        if ( e.getSource() == avgBtn ) {
            computeAverage();
        }
    }
    public static void main ( String[] args ) {
        Main m = new Main();
        m.setVisible ( true );
    }
}
