private static void initPayPal() {
    InputStream is = null;
    try {
        is = ApplicationConfig.class.getResourceAsStream (
                 IS_PRODUCTION ? "/my_paypal_sdk_config.properties" : "/my_paypal_sdk_config_test.properties" );
        Properties props = new Properties();
        props.load ( is );
        PayPalResource.initConfig ( props );
        ConfigManager.getInstance().load ( props );
        String clientID = ConfigManager.getInstance().getConfigurationMap().get ( "clientID" );
        String clientSecret = ConfigManager.getInstance().getConfigurationMap().get ( "clientSecret" );
        PAYPAL_ACCESS_TOKEN = new OAuthTokenCredential ( clientID, clientSecret ).getAccessToken();
    } catch ( Exception e ) {
        throw new RuntimeException ( e );
    } finally {
        IOUtils.closeQuietly ( is );
    }
}
