import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
public class ScheduledTaskExample {
    private final ScheduledExecutorService scheduler = Executors
            .newScheduledThreadPool ( 1 );
    public void startScheduleTask() {
        final ScheduledFuture<?> taskHandle = scheduler.scheduleAtFixedRate (
        new Runnable() {
            public void run() {
                try {
                    getDataFromDatabase();
                } catch ( Exception ex ) {
                    ex.printStackTrace();
                }
            }
        }, 0, 15, TimeUnit.MINUTES );
    }
    private void getDataFromDatabase() {
        System.out.println ( "getting data..." );
    }
    public static void main ( String[] args ) {
        ScheduledTaskExample ste = new ScheduledTaskExample();
        ste.startScheduleTask();
    }
}
