import org.springframework.web.context.request.RequestAttributes;
import org.springframework.web.context.request.RequestContextHolder;
public abstract class RequestAwareRunnable implements Runnable {
    private final RequestAttributes requestAttributes;
    private Thread thread;
    public RequestAwareRunnable() {
        this.requestAttributes = RequestContextHolder.getRequestAttributes();
        this.thread = Thread.currentThread();
    }
    public void run() {
        try {
            RequestContextHolder.setRequestAttributes ( requestAttributes );
            onRun();
        } finally {
            if ( Thread.currentThread() != thread ) {
                RequestContextHolder.resetRequestAttributes();
            }
            thread = null;
        }
    }
    protected abstract void onRun();
}
