private String selectedImagePath = "";
final private int PICK_IMAGE = 1;
final private int CAPTURE_IMAGE = 2;
public Uri setImageUri() {
    File file = new File ( Environment.getExternalStorageDirectory() + "/DCIM/", "image" + new Date().getTime() + ".png" );
    Uri imgUri = Uri.fromFile ( file );
    this.imgPath = file.getAbsolutePath();
    return imgUri;
}
public String getImagePath() {
    return imgPath;
}
btnGallery.setOnClickListener ( new OnClickListener() {
    @Override
    public void onClick ( View v ) {
        Intent intent = new Intent();
        intent.setType ( "image/*" );
        intent.setAction ( Intent.ACTION_GET_CONTENT );
        startActivityForResult ( Intent.createChooser ( intent, "" ), PICK_IMAGE );
    }
} );
btnCapture.setOnClickListener ( new OnClickListener() {
    @Override
    public void onClick ( View v ) {
        final Intent intent = new Intent ( MediaStore.ACTION_IMAGE_CAPTURE );
        intent.putExtra ( MediaStore.EXTRA_OUTPUT, setImageUri() );
        startActivityForResult ( intent, CAPTURE_IMAGE );
    }
} );
@Override
protected void onActivityResult ( int requestCode, int resultCode, Intent data ) {
    if ( resultCode != Activity.RESULT_CANCELED ) {
        if ( requestCode == PICK_IMAGE ) {
            selectedImagePath = getAbsolutePath ( data.getData() );
            imgUser.setImageBitmap ( decodeFile ( selectedImagePath ) );
        } else if ( requestCode == CAPTURE_IMAGE ) {
            selectedImagePath = getImagePath();
            imgUser.setImageBitmap ( decodeFile ( selectedImagePath ) );
        } else {
            super.onActivityResult ( requestCode, resultCode, data );
        }
    }
}
public Bitmap decodeFile ( String path ) {
    try {
        BitmapFactory.Options o = new BitmapFactory.Options();
        o.inJustDecodeBounds = true;
        BitmapFactory.decodeFile ( path, o );
        final int REQUIRED_SIZE = 70;
        int scale = 1;
        while ( o.outWidth / scale / 2 >= REQUIRED_SIZE && o.outHeight / scale / 2 >= REQUIRED_SIZE ) {
            scale *= 2;
        }
        BitmapFactory.Options o2 = new BitmapFactory.Options();
        o2.inSampleSize = scale;
        return BitmapFactory.decodeFile ( path, o2 );
    } catch ( Throwable e ) {
        e.printStackTrace();
    }
    return null;
}
public String getAbsolutePath ( Uri uri ) {
    String[] projection = { MediaColumns.DATA };
    @SuppressWarnings ( "deprecation" )
    Cursor cursor = managedQuery ( uri, projection, null, null, null );
    if ( cursor != null ) {
        int column_index = cursor.getColumnIndexOrThrow ( MediaColumns.DATA );
        cursor.moveToFirst();
        return cursor.getString ( column_index );
    } else {
        return null;
    }
}
