@ServerEndpoint ( "/myendpoint" )
public class MyEndpoint {
    @EJB
    ArticleBean articleBean;
    private static final Set<Session> sessions =
        Collections.synchronizedSet ( new HashSet<Session>() );
    @OnOpen
    public void onOpen ( final Session session ) {
        session.add ( session );
        ...
    }
    @OnClose
    public void onClose ( final Session session ) {
        sessions.remove ( session );
    }
    public void broadcastArticle ( @Observes @NewArticleEvent ArticleEvent articleEvent ) {
        for ( Session s : sessions ) {
            if ( s.isOpen() ) {
                try {
                    s.getBasicRemote().sendText ( "New article up:" + articleEvent.getArticle().getSummary() );
                } catch ( IOException ex ) {
                    ...
                }
            }
        }
    }
}
