public class TransformerService implements TransformerServiceMBean {
    protected final Instrumentation instrumentation;
    public TransformerService ( Instrumentation instrumentation ) {
        this.instrumentation = instrumentation;
    }
    @Override
    public void transformClass ( String className ) {
        Class<?> targetClazz = null;
        ClassLoader targetClassLoader = null;
        try {
            targetClazz = Class.forName ( className );
            targetClassLoader = targetClazz.getClassLoader();
            transform ( targetClazz, targetClassLoader );
            return;
        } catch ( Exception ex ) {
        }
        for ( Class<?> clazz : instrumentation.getAllLoadedClasses() ) {
            if ( clazz.getName().equals ( className ) ) {
                targetClazz = clazz;
                targetClassLoader = targetClazz.getClassLoader();
                transform ( targetClazz, targetClassLoader );
                return;
            }
        }
        throw new RuntimeException ( "Failed to locate class [" + className + "]" );
    }
    protected void transform ( Class<?> clazz, ClassLoader classLoader ) {
        DemoTransformer dt = new DemoTransformer ( clazz.getName(), classLoader );
        instrumentation.addTransformer ( dt, true );
        try {
            instrumentation.retransformClasses ( clazz );
        } catch ( Exception ex ) {
            throw new RuntimeException ( "Failed to transform [" + clazz.getName() + "]", ex );
        } finally {
            instrumentation.removeTransformer ( dt );
        }
    }
}
