public class AgentInstaller {
    public static void main ( String[] args )  {
        String agentPath = "D:\\work\\workspace\\myjar\\loaded.jar";
        String vid = args[0];
        VirtualMachine vm = VirtualMachine.attach ( vid );
        if ( !vm.getSystemProperties().contains ( "demo.agent.installed" ) ) {
            vm.loadAgent ( agentPath );
        }
        String connectorAddress = vm.getAgentProperties().getProperty ( "com.sun.management.jmxremote.localConnectorAddress", null );
        if ( connectorAddress == null ) {
            String javaHome = vm.getSystemProperties().getProperty ( "java.home" );
            File managementAgentJarFile = new File ( javaHome + File.separator + "lib" + File.separator + "management-agent.jar" );
            vm.loadAgent ( managementAgentJarFile.getAbsolutePath() );
            connectorAddress = vm.getAgentProperties().getProperty ( "com.sun.management.jmxremote.localConnectorAddress", null );
        }
        JMXConnector connector = null;
        try {
            ObjectName on = new ObjectName ( "transformer:service=DemoTransformer" );
            connector = JMXConnectorFactory.connect ( new JMXServiceURL ( connectorAddress ) );
            MBeanServerConnection server = connector.getMBeanServerConnection();
            for ( int i = 1; i < args.length; i++ ) {
                String className = args[i];
                server.invoke ( on, "transformClass", new Object[] {className}, new String[] {String.class.getName() } );
            }
        } catch ( Exception ex ) {
            ex.printStackTrace ( System.err );
        } finally {
            if ( connector != null ) try {
                    connector.close();
                } catch ( Exception e ) {}
        }
    }
}
