@Entity
@Inheritance ( strategy = InheritanceType.SINGLE_TABLE )
@DiscriminatorColumn ( name = "request_type", discriminatorType = DiscriminatorType.STRING )
public abstract class CashTransferCurrencyAmount {
    @Column ( length = 3 )
    private String currencyCode;
    @Basic
    private BigDecimal amount;
    @ManyToOne
    private CashTransfer cashTransfer;
}
@Entity
@DiscriminatorValue ( "REQUIRED" )
public class CashTransferCurrencyAmountRequired extends CashTransferCurrencyAmount {
}
@Entity
@DiscriminatorValue ( "ACTUAL" )
public class CashTransferCurrencyAmountActual extends CashTransferCurrencyAmount {
}
@Entity
public class CashTransfer {
    @OneToMany ( mappedBy = "cashTransfer" )
    private Set requiredCurrencyAmountSet = new HashSet();
    @OneToMany ( mappedBy = "cashTransfer" )
    private Set actualCurrencyAmountSet = new HashSet();
}
