class DrawnItem {
    int color = Color.GREEN;
    Path line = new Path();
}
Paint paint;
int mCurrentColor = Color.GREEN;
ArrayList<DrawnItem> mDrawings = new ArrayList<DrawnItem>();
protected void onDraw ( Canvas canvas ) {
    final int count = mDrawings.size();
    for ( int i = 0; i < count; i++ ) {
        final DrawnItem item = mDrawings.get ( i );
        paint.setColor ( item.color );
        canvas.drawPath ( item.line, paint );
    }
    paint.setColor ( mCurrentColor );
    canvas.drawCircle ( x, y, 10, paint );
}
private DrawnItem mCurrentItem = null;
public boolean onTouchEvent ( MotionEvent event ) {
    final int action = event.getAction();
    switch ( action ) {
    case MotionEvent.ACTION_DOWN:
        mCurrentItem = new DrawnItem();
        mCurrentitem.color = mCurrentColor;
        mDrawings.add ( mCurrentItem );
        invalidate();
        break;
    case MotionEvent.ACTION_MOVE:
        x = event.getX();
        y = event.getY();
        mCurrentItem.line.lineTo ( x, y );
        invalidate();
        break;
    case MotionEvent.ACTION_UP:
        mCurrentItem.line.lineTo ( event.getX(), event.getY() );
        mCurrentItem = null;
        invalidate();
        break;
    case MotionEvent.ACTION_CANCEL:
        mCurrentItem = null;
        break;
    default:
        break;
