public class VisibiitySaveTextView extends TextView {
    private static final String SUPER_STATE = "super_state";
    private static final String VISIBILITY = "visibility";
    @Override
    public Parcelable onSaveInstanceState () {
        Bundle state = new Bundle();
        state.putParcelable ( SUPER_STATE, super.onSaveInstanceState() );
        state.putInt ( VISIBILITY, getVisibility() );
        return state;
    }
    @Override
    public void onRestoreInstanceState ( Parcelable state ) {
        if ( state instanceof Bundle ) {
            Bundle savedState = ( Bundle ) state;
            setVisibility ( savedState.getInt ( VISIBILITY, getVisibility() ) );
            Parcelable superState = savedState.getParcelable ( SUPER_STATE );
            super.onRestoreInstanceState ( superState );
        } else {
            super.onRestoreInstanceState ( state );
        }
    }
}
