private static Map<String, String> getFullCameraParameters ( Camera cam ) {
    Map<String, String> result = new HashMap<String, String> ( 64 );
    final String TAG = "CameraParametersRetrieval";
    try {
        Class camClass = cam.getClass();
        Method getNativeParams = camClass.getDeclaredMethod ( "native_getParameters" );
        getNativeParams.setAccessible ( true );
        String rawParamsStr = ( String ) getNativeParams.invoke ( cam );
        TextUtils.StringSplitter splitter = new TextUtils.SimpleStringSplitter ( ';' );
        splitter.setString ( rawParamsStr );
        for ( String kv : splitter ) {
            int pos = kv.indexOf ( '=' );
            if ( pos == -1 ) {
                continue;
            }
            String k = kv.substring ( 0, pos );
            String v = kv.substring ( pos + 1 );
            result.put ( k, v );
        }
        return result;
    } catch ( NoSuchMethodException ex ) {
        Log.e ( TAG, ex.toString() );
    } catch ( IllegalAccessException ex ) {
        Log.e ( TAG, ex.toString() );
    } catch ( InvocationTargetException ex ) {
        Log.e ( TAG, ex.toString() );
    }
    Log.e ( TAG, "Unable to retrieve parameters from Camera." );
    return result;
}
