public static void sftpConnection() {
    JSch jsch = new JSch();
    Session session = null;
    Channel channel = null;
    String user = "foo";
    String host = "10.9.8.7";
    Integer port = 22;
    String password = "test123";
    String watchFolder = "\\localhost\textfiles";
    String outputDir = "/remote/textFolder/";
    String filemask = "*.txt";
    try {
        session = jsch.getSession ( user, host, port );
        session.setConfig ( "StrictHostKeyChecking", "no" );
        session.setPassword ( password );
        session.connect();
        channel = session.openChannel ( "sftp" );
        channel.connect();
        ChannelSftp sftpChannel = ( ChannelSftp ) channel;
        File[] files = findFile ( watchFolder, filemask );
        for ( File file : files ) {
            putFile ( file, sftpChannel, outputDir );
        }
    } finally {
        sftpChannel.exit();
        session.disconnect();
    }
}
public static void putFile ( File file, ChannelSftp sftpChannel, String outputDir ) {
    FileInputStream fis = null;
    try {
        sftpChannel.cd ( outputDir );
        fis = new FileInputStream ( file );
        sftpChannel.put ( fis, file.getName() );
        fis.close();
    } catch {}
}
public static File[] findFile ( String dirName, final String mask ) {
    File dir = new File ( dirName );
    return dir.listFiles ( new FilenameFilter() {
        public boolean accept ( File dir, String filename ) {
            return filename.endsWith ( mask );
        }
    } );
}
