public class Stack {
    int[] stack;
    int MAX_SIZE, size;
    public Stack ( int i ) {
        MAX_SIZE = i;
        stack = new int[MAX_SIZE];
    }
    public static void main ( String[] args ) throws IOException {
        new Stack ( 2 ).run();
    }
    private void run() {
        Scanner scanner = new Scanner ( System.in );
        while ( true ) {
            showMenu();
            String[] resp = scanner.nextLine().split ( " " );
            System.out.println();
            if ( "add".equals ( resp[0] ) && resp.length == 2 ) {
                if ( size >= MAX_SIZE ) {
                    System.out.print ( "Sorry, the list is full! " );
                    printList();
                    continue;
                }
                stack[size++] = Integer.parseInt ( resp[1] );
                printList();
            } else if ( "list".equals ( resp[0] ) ) {
                printList();
            } else if ( "delete".equals ( resp[0] ) ) {
                if ( size == 0 ) {
                    System.out.println ( "List is already empty!\n" );
                    continue;
                }
                size--;
                printList();
            } else if ( "exit".equals ( resp[0] ) ) {
                break;
            } else {
                System.out.println ( "Invalid command!\n" );
            }
        }
    }
    private void printList() {
        System.out.print ( "List: {" );
        if ( size > 0 ) {
            int i = 0;
            for ( ; i < size - 1; i++ ) {
                System.out.print ( stack[i] + "," );
            }
            System.out.print ( stack[i] );
        }
        System.out.println ( "}\n" );
    }
    private void showMenu() {
        System.out.println ( "Enter one of the following commands:" );
        System.out.printf ( " %-8s: %s\n", "add <n>", "to add n to the list" );
        System.out.printf ( " %-8s: %s\n", "delete", "to delete the last number" );
        System.out.printf ( " %-8s: %s\n", "list", "to list all the numbers" );
        System.out.printf ( " %-8s: %s\n", "exit", "to terminate the program" );
        System.out.print ( "$ " );
    }
}
