private static final XMLOutputProcessor CUSTOMATTRIBUTEQUOTES = new AbstractXMLOutputProcessor() {
    @Override
    protected void printAttribute ( final Writer out, final FormatStack fstack,
                                    final Attribute attribute ) throws IOException {
        if ( !attribute.isSpecified() && fstack.isSpecifiedAttributesOnly() ) {
            return;
        }
        write ( out, " " );
        write ( out, attribute.getQualifiedName() );
        write ( out, "=" );
        write ( out, "'" );
        String value = Format.escapeAttribute ( fstack.getEscapeStrategy(), value );
        value = value.replaceAll ( "&quot;", "\"" );
        value = value.replaceAll ( "'", "&apos;" );
        write ( out, value );
        write ( out, "'" );
    }
};
