import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.scene.Cursor;
import javafx.scene.Node;
import javafx.scene.input.MouseEvent;
import javafx.stage.Stage;
import javafx.util.Duration;
public class EffectUtilities {
    public static void makeDraggable ( final Stage stage, final Node byNode ) {
        final Delta dragDelta = new Delta();
        byNode.setOnMousePressed ( new EventHandler<MouseEvent>() {
            @Override public void handle ( MouseEvent mouseEvent ) {
                dragDelta.x = stage.getX() - mouseEvent.getScreenX();
                dragDelta.y = stage.getY() - mouseEvent.getScreenY();
                byNode.setCursor ( Cursor.MOVE );
            }
        } );
        byNode.setOnMouseReleased ( new EventHandler<MouseEvent>() {
            @Override public void handle ( MouseEvent mouseEvent ) {
                byNode.setCursor ( Cursor.HAND );
            }
        } );
        byNode.setOnMouseDragged ( new EventHandler<MouseEvent>() {
            @Override public void handle ( MouseEvent mouseEvent ) {
                stage.setX ( mouseEvent.getScreenX() + dragDelta.x );
                stage.setY ( mouseEvent.getScreenY() + dragDelta.y );
            }
        } );
        byNode.setOnMouseEntered ( new EventHandler<MouseEvent>() {
            @Override public void handle ( MouseEvent mouseEvent ) {
                if ( !mouseEvent.isPrimaryButtonDown() ) {
                    byNode.setCursor ( Cursor.HAND );
                }
            }
        } );
        byNode.setOnMouseExited ( new EventHandler<MouseEvent>() {
            @Override public void handle ( MouseEvent mouseEvent ) {
                if ( !mouseEvent.isPrimaryButtonDown() ) {
                    byNode.setCursor ( Cursor.DEFAULT );
                }
            }
        } );
    }
    private static class Delta {
        double x, y;
    }
}
