import java.awt.Color;
import java.awt.Component;
import java.awt.EventQueue;
import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
import javax.swing.border.LineBorder;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;
public class TableRenderer {
    public static void main ( String[] args ) {
        new TableRenderer();
    }
    public TableRenderer() {
        EventQueue.invokeLater ( new Runnable() {
            @Override
            public void run() {
                try {
                    UIManager.setLookAndFeel ( UIManager.getSystemLookAndFeelClassName() );
                } catch ( ClassNotFoundException | InstantiationException | IllegalAccessException | UnsupportedLookAndFeelException ex ) {
                    ex.printStackTrace();
                }
                DefaultTableModel model = new DefaultTableModel ( new Object[][] {{"", "One"}, {"", "Two"}}, new Object[] {"Check", "Vistor"} ) {
                    @Override
                    public Class<?> getColumnClass ( int columnIndex ) {
                        return String.class;
                    }
                };
                JTable table = new JTable ( model );
                table.setRowSelectionAllowed ( true );
                table.setShowGrid ( false );
                table.setDefaultRenderer ( String.class, new VisitorRenderer() );
                JFrame frame = new JFrame ( "Testing" );
                frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
                frame.add ( new JScrollPane ( table ) );
                frame.pack();
                frame.setLocationRelativeTo ( null );
                frame.setVisible ( true );
            }
        } );
    }
    public class VisitorRenderer extends DefaultTableCellRenderer {
        @Override
        public Component getTableCellRendererComponent ( JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column ) {
            super.getTableCellRendererComponent ( table, value, isSelected, hasFocus, row, column );
            setBorder ( noFocusBorder );
            return this;
        }
    }
}
