public class PageObject extends LoadableComponent<PageObject> {
    public PageObject() throws Exception {
        driver = getWebDriverFromSomePlace();
        PageFactory.initElements ( driver, this );
        isLoaded();
    }
    private WebDriver driver = null;
    @FindBy ( id = "yourButton" )
    private WebElement button;
    @FindBy ( id = "textBoxThatAppears" )
    private WebElement txtBox;
    @Override
    public void isLoaded() throws Error {
        new WebDriverWait ( driver, TestHelpers.TIMEOUT )
        .until ( ExpectedConditions.visibilityOf ( button ) );
    }
    public void clickButtonAndWaitForTextbox() {
        button.click();
        new WebDriverWait ( driver, 60 )
        .until ( ExpectedConditions.visibilityOf ( txtBox ) );
    }
    public void interactWithTextbox ( String text ) {
        txtBox.sendKeys ( text );
    }
}
