public class DuplicatingTimeBasedRollingPolicy<E> extends TimeBasedRollingPolicy<E> {
    String originalRoot;
    String duplicateRoot;
    @Override
    Future<?> asyncCompress ( String nameOfFile2Compress,
                              String nameOfCompressedFile, String innerEntryName )
    throws RolloverFailure {
        final Future<?> future = super.asyncCompress ( nameOfFile2Compress, nameOfCompressedFile,
                                 innerEntryName );
        String extension = compressionMode == CompressionMode.ZIP ? ".zip" : ".gz";
        final String sourceFileName = nameOfCompressedFile + extension;
        final String destFileName = duplicateRoot + File.separator + sourceFileName.substring ( originalRoot.length() );
        new Thread ( new Runnable() {
            @Override
            public void run() {
                try {
                    future.get();
                    FileUtils.copyFile ( new File ( sourceFileName ), new File ( destFileName ) );
                } catch ( Exception e ) {
                    e.printStackTrace();
                }
            }
        } ).start();
        return future;
    }
}
