public class RollMyFile {
    private long FILE_MAX_SIZE;
    private String fileName;
    public RollMyFile ( String fileNameToStartWith, long maxFileSize ) {
        this.fileName = fileNameToStartWith;
        this.FILE_MAX_SIZE = maxFileSize;
    }
    public synchronized AsynchronousFileChannel rollMeIfNeeded ( AsynchronousFileChannel fileChannel ) throws IOException {
        if ( fileChannel.size() > FILE_MAX_SIZE ) {
            this.fileName = getNewRolledFileName ( this.fileName );
            File file = new File ( this.fileName );
            file.createNewFile();
            fileChannel = getAsyncChannel ( this.fileName );
        }
        return fileChannel;
    }
    public String getNewRolledFileName ( String currentFileName ) {
        if ( currentFileName.contains ( "." ) ) {
            currentFileName = currentFileName.substring ( 0,
                              currentFileName.lastIndexOf ( '.' ) );
        }
        return currentFileName + "." + Calendar.getInstance().getTimeInMillis();
    }
    public void write ( StringBuffer stuffToWrite ) throws IOException {
        AsynchronousFileChannel fileChannel = getAsyncChannel ( this.fileName );
        fileChannel = rollMeIfNeeded ( fileChannel );
        ByteBuffer byteBuffer = ByteBuffer.wrap ( stuffToWrite.toString().getBytes() );
        fileChannel.write ( byteBuffer, fileChannel.size() );
    }
    private AsynchronousFileChannel getAsyncChannel ( String givenFileName ) throws IOException {
        return AsynchronousFileChannel.open ( Paths.get ( givenFileName ), StandardOpenOption.WRITE );
    }
}
