class Book implements Comparable<Book> {
    public String name, id, author, publisher;
    public Book ( String name, String id, String author, String publisher ) {
        this.name = name;
        this.id = id;
        this.author = author;
        this.publisher = publisher;
    }
    public String toString() {
        return ( "(" + name + ", " + id + ", " + author + ", " + publisher + ")" );
    }
    @Override
    public int compareTo ( Book o ) {
        return toString().compareTo ( o.toString() );
    }
}
@Test
public void sortBooks() {
    Book[] books = {
        new Book ( "foo", "1", "author1", "pub1" ),
        new Book ( "bar", "2", "author2", "pub2" )
    };
    Arrays.sort ( books );
    System.out.println ( Arrays.asList ( books ) );
    Arrays.sort ( books, new Comparator<Book>() {
        @Override
        public int compare ( Book o1, Book o2 ) {
            return o1.id.compareTo ( o2.id );
        }
    } );
    System.out.println ( Arrays.asList ( books ) );
}
