PropertyChangeListener propertyChangeListener = new PropertyChangeListener () {
    @Override
    public void propertyChange ( final PropertyChangeEvent evt ) {
        if ( evt.getNewValue () == Boolean.TRUE ) {
            final Window ancestor = getWindowAncestor ( popupMenu );
            if ( ancestor != null && ancestor.getClass ().getCanonicalName ().endsWith ( "HeavyWeightWindow" ) ) {
                final Component parent = ancestor.getParent ();
                if ( parent != null && parent instanceof Window && parent.getBackground ().getAlpha () == 0 ) {
                    ancestor.setBackground ( new Color ( 0, 0, 0, 0 ) );
                }
            }
        }
    }
    private Window getWindowAncestor ( Component component ) {
        if ( component == null ) {
            return null;
        }
        if ( component instanceof Window ) {
            return ( Window ) component;
        }
        for ( Container p = component.getParent (); p != null; p = p.getParent () ) {
            if ( p instanceof Window ) {
                return ( Window ) p;
            }
        }
        return null;
    }
};
popupMenu.addPropertyChangeListener ( "visible", propertyChangeListener );
