import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Vector;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.table.DefaultTableModel;
public class DisplayResult extends JPanel {
    private boolean DEBUG = false;
    static final String JDBC_DRIVER = "org.postgresql.Driver";
    static final String DB_URL = "jdbc:postgresql://127.0.0.1:8000/testdb";
    static final String USER = "username";
    static final String PASS = "password";
    Connection conn = null;
    Statement stmt = null;
    static Vector<Vector<String>> data = new Vector<Vector<String>>();
    public DisplayResult() {
        super ( new GridLayout ( 1, 0 ) );
        Vector<String> columnNames = new Vector<String>();
        columnNames.add ( "column1" );
        columnNames.add ( "column2" );
        columnNames.add ( "column3" );
        String query =
            "select column1, column2, column3 from MYTABLE";
        try {
            conn = DriverManager.getConnection ( DB_URL, USER, PASS );
            stmt = conn.createStatement();
            ResultSet rs = stmt.executeQuery ( query );
            while ( rs.next() ) {
                Vector<String> vstring = new Vector<String>();
                vstring.add ( rs.getString ( "column1" ) );
                vstring.add ( rs.getString ( "column2" ) );
                vstring.add ( rs.getString ( "column3" ) );
                vstring.add ( "\n\n\n\n\n\n\n" );
                data.add ( vstring );
            }
        } catch ( SQLException e ) {
            e.printStackTrace();
        } finally {
            if ( stmt != null ) {
                try {
                    stmt.close();
                } catch ( SQLException ex ) {
                    Logger.getLogger ( FlashBuilderGUI.class.getName() ).log ( Level.SEVERE, null, ex );
                }
            }
        }
        DefaultTableModel model = new DefaultTableModel ( data, columnNames );
        final JTable table = new JTable ( model );
        table.setPreferredScrollableViewportSize ( new Dimension ( 500, 70 ) );
        table.setFillsViewportHeight ( true );
        if ( DEBUG ) {
            table.addMouseListener ( new MouseAdapter() {
                public void mouseClicked ( MouseEvent e ) {
                    printDebugData ( table );
                }
            } );
        }
        JScrollPane scrollPane = new JScrollPane ( table );
        add ( scrollPane );
    }
    private void printDebugData ( JTable table ) {
        int numRows = table.getRowCount();
        int numCols = table.getColumnCount();
        javax.swing.table.TableModel model = table.getModel();
        System.out.println ( "Value of data: " );
        for ( int i = 0; i < numRows; i++ ) {
            System.out.print ( "    row " + i + ":" );
            for ( int j = 0; j < numCols; j++ ) {
                System.out.print ( "  " + model.getValueAt ( i, j ) );
            }
            System.out.println();
        }
        System.out.println ( "--------------------------" );
    }
    public static void createAndShowGUI() {
        JFrame frame = new JFrame ( "Database Data" );
        frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
        DisplayResult newContentPane = new DisplayResult();
        newContentPane.setOpaque ( true );
        frame.setContentPane ( newContentPane );
        frame.pack();
        frame.setVisible ( true );
    }
    public static void main ( String[] args ) {
        javax.swing.SwingUtilities.invokeLater ( new Runnable() {
            public void run() {
                createAndShowGUI();
            }
        } );
    }
}
