public class ExpListAdapter extends BaseExpandableListAdapter {
    private ArrayList<ArrayList<String>> mGroups;
    private Context mContext;
    public ExpListAdapter ( Context context, ArrayList<ArrayList<String>> groups ) {
        mContext = context;
        mGroups = groups;
    }
    @Override
    public int getGroupCount() {
        return mGroups.size();
    }
    @Override
    public int getChildrenCount ( int groupPosition ) {
        return mGroups.get ( groupPosition ).size();
    }
    @Override
    public Object getGroup ( int groupPosition ) {
        return mGroups.get ( groupPosition );
    }
    @Override
    public Object getChild ( int groupPosition, int childPosition ) {
        return mGroups.get ( groupPosition ).get ( childPosition );
    }
    @Override
    public long getGroupId ( int groupPosition ) {
        return groupPosition;
    }
    @Override
    public long getChildId ( int groupPosition, int childPosition ) {
        return childPosition;
    }
    @Override
    public boolean hasStableIds() {
        return true;
    }
    @Override
    public View getGroupView ( int groupPosition, boolean isExpanded, View convertView,
                               ViewGroup parent ) {
        if ( convertView == null ) {
            LayoutInflater inflater = ( LayoutInflater ) mContext.getSystemService ( Context.LAYOUT_INFLATER_SERVICE );
            convertView = inflater.inflate ( R.layout.group_view, null );
        }
        if ( isExpanded ) {
        } else {
        }
        TextView textGroup = ( TextView ) convertView.findViewById ( R.id.textGroup );
        textGroup.setText ( "Group " + Integer.toString ( groupPosition ) );
        return convertView;
    }
    @Override
    public View getChildView ( int groupPosition, int childPosition, boolean isLastChild,
                               View convertView, ViewGroup parent ) {
        if ( convertView == null ) {
            LayoutInflater inflater = ( LayoutInflater ) mContext.getSystemService ( Context.LAYOUT_INFLATER_SERVICE );
            convertView = inflater.inflate ( R.layout.child_view, null );
        }
        TextView textChild = ( TextView ) convertView.findViewById ( R.id.textChild );
        textChild.setText ( mGroups.get ( groupPosition ).get ( childPosition ) );
        Button button = ( Button ) convertView.findViewById ( R.id.buttonChild );
        button.setOnClickListener ( new View.OnClickListener() {
            @Override
            public void onClick ( View view ) {
                Toast.makeText ( mContext, "button is pressed", 5000 ).show();
            }
        } );
        return convertView;
    }
    @Override
    public boolean isChildSelectable ( int groupPosition, int childPosition ) {
        return true;
    }
}
