private List<HandlerMethodArgumentResolver> getDefaultArgumentResolvers() {
    List<HandlerMethodArgumentResolver> resolvers = new ArrayList<HandlerMethodArgumentResolver>();
    resolvers.add ( new RequestParamMethodArgumentResolver ( getBeanFactory(), false ) );
    resolvers.add ( new RequestParamMapMethodArgumentResolver() );
    resolvers.add ( new PathVariableMethodArgumentResolver() );
    resolvers.add ( new ServletModelAttributeMethodProcessor ( false ) );
    resolvers.add ( new RequestResponseBodyMethodProcessor ( getMessageConverters() ) );
    resolvers.add ( new RequestPartMethodArgumentResolver ( getMessageConverters() ) );
    resolvers.add ( new RequestHeaderMethodArgumentResolver ( getBeanFactory() ) );
    resolvers.add ( new RequestHeaderMapMethodArgumentResolver() );
    resolvers.add ( new ServletCookieValueMethodArgumentResolver ( getBeanFactory() ) );
    resolvers.add ( new ExpressionValueMethodArgumentResolver ( getBeanFactory() ) );
    resolvers.add ( new ServletRequestMethodArgumentResolver() );
    resolvers.add ( new ServletResponseMethodArgumentResolver() );
    resolvers.add ( new HttpEntityMethodProcessor ( getMessageConverters() ) );
    resolvers.add ( new RedirectAttributesMethodArgumentResolver() );
    resolvers.add ( new ModelMethodProcessor() );
    resolvers.add ( new MapMethodProcessor() );
    resolvers.add ( new ErrorsMethodArgumentResolver() );
    resolvers.add ( new SessionStatusMethodArgumentResolver() );
    resolvers.add ( new UriComponentsBuilderMethodArgumentResolver() );
    if ( getCustomArgumentResolvers() != null ) {
        resolvers.addAll ( getCustomArgumentResolvers() );
    }
    resolvers.add ( new RequestParamMethodArgumentResolver ( getBeanFactory(), true ) );
    resolvers.add ( new ServletModelAttributeMethodProcessor ( true ) );
    return resolvers;
}
