import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;
import javax.swing.SwingWorker;
import javax.swing.UIManager;
public class Demo {
    JButton _alreadyPressedButton = null;
    private void initGUI() {
        ImageIcon icon1 = ( ImageIcon ) UIManager.getIcon ( "OptionPane.errorIcon" );
        ImageIcon icon2 = ( ImageIcon ) UIManager.getIcon ( "OptionPane.informationIcon" );
        ImageIcon icon3 = ( ImageIcon ) UIManager.getIcon ( "OptionPane.warningIcon" );
        List<ImageIcon> iconsList = new ArrayList<>();
        iconsList.add ( icon1 );
        iconsList.add ( icon1 );
        iconsList.add ( icon2 );
        iconsList.add ( icon2 );
        iconsList.add ( icon3 );
        iconsList.add ( icon3 );
        Collections.shuffle ( iconsList );
        ActionListener actionListener = new ActionListener() {
            @Override
            public void actionPerformed ( ActionEvent e ) {
                if ( e.getSource() instanceof JButton ) {
                    final JButton pressedButton = ( JButton ) e.getSource();
                    SwingWorker sw = new SwingWorker() {
                        @Override
                        protected Object doInBackground() throws Exception {
                            if ( _alreadyPressedButton != pressedButton ) {
                                pressedButton.setIcon ( pressedButton.getPressedIcon() );
                                if ( _alreadyPressedButton != null ) {
                                    Thread.sleep ( 500 );
                                    if ( _alreadyPressedButton.getIcon() == pressedButton.getIcon() ) {
                                        _alreadyPressedButton.setEnabled ( false );
                                        pressedButton.setEnabled ( false );
                                    } else {
                                        _alreadyPressedButton.setIcon ( null );
                                        pressedButton.setIcon ( null );
                                    }
                                    _alreadyPressedButton = null;
                                } else {
                                    _alreadyPressedButton = pressedButton;
                                }
                            }
                            return null;
                        }
                    };
                    sw.execute();
                }
            }
        };
        JPanel panel = new JPanel ( new GridLayout ( 3, 2 ) );
        panel.setPreferredSize ( new Dimension ( 200, 200 ) );
        for ( ImageIcon icon : iconsList ) {
            JButton button = new JButton();
            button.setPressedIcon ( icon );
            button.addActionListener ( actionListener );
            panel.add ( button );
        }
        JFrame frame = new JFrame ( "Demo" );
        frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
        frame.getContentPane().add ( panel );
        frame.pack();
        frame.setLocationRelativeTo ( null );
        frame.setVisible ( true );
    }
    public static void main ( String[] args ) {
        SwingUtilities.invokeLater ( new Runnable() {
            @Override
            public void run() {
                new Demo().initGUI();
            }
        } );
    }
}
