import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.util.List;
import net.lingala.zip4j.core.ZipFile;
import net.lingala.zip4j.exception.ZipException;
import net.lingala.zip4j.io.ZipInputStream;
import net.lingala.zip4j.model.FileHeader;
import net.lingala.zip4j.unzip.UnzipUtil;
public class ExtractAllFilesWithInputStreams {
    private final int BUFF_SIZE = 4096;
    public ExtractAllFilesWithInputStreams() {
        ZipInputStream is = null;
        OutputStream os = null;
        try {
            ZipFile zipFile = new ZipFile (
                "C:\\ZipTest\\ExtractAllFilesWithInputStreams.zip" );
            String destinationPath = "c:\\ZipTest";
            if ( zipFile.isEncrypted() ) {
                zipFile.setPassword ( "password" );
            }
            List fileHeaderList = zipFile.getFileHeaders();
            for ( int i = 0; i < fileHeaderList.size(); i++ ) {
                FileHeader fileHeader = ( FileHeader ) fileHeaderList.get ( i );
                if ( fileHeader != null ) {
                    String outFilePath = destinationPath
                                         + System.getProperty ( "file.separator" )
                                         + fileHeader.getFileName();
                    File outFile = new File ( outFilePath );
                    if ( fileHeader.isDirectory() ) {
                        outFile.mkdirs();
                        continue;
                    }
                    File parentDir = outFile.getParentFile();
                    if ( !parentDir.exists() ) {
                        parentDir.mkdirs();
                    }
                    is = zipFile.getInputStream ( fileHeader );
                    os = new FileOutputStream ( outFile );
                    int readLen = -1;
                    byte[] buff = new byte[BUFF_SIZE];
                    while ( ( readLen = is.read ( buff ) ) != -1 ) {
                        os.write ( buff, 0, readLen );
                    }
                    closeFileHandlers ( is, os );
                    UnzipUtil.applyFileAttributes ( fileHeader, outFile );
                    System.out.println ( "Done extracting: "
                                         + fileHeader.getFileName() );
                } else {
                    System.err.println ( "fileheader is null. Shouldn't be here" );
                }
            }
        } catch ( ZipException e ) {
            e.printStackTrace();
        } catch ( FileNotFoundException e ) {
            e.printStackTrace();
        } catch ( IOException e ) {
            e.printStackTrace();
        } catch ( Exception e ) {
            e.printStackTrace();
        } finally {
            try {
                closeFileHandlers ( is, os );
            } catch ( IOException e ) {
                e.printStackTrace();
            }
        }
    }
    private void closeFileHandlers ( ZipInputStream is, OutputStream os )
    throws IOException {
        if ( os != null ) {
            os.close();
            os = null;
        }
        if ( is != null ) {
            is.close();
            is = null;
        }
    }
    public static void main ( String[] args ) {
        new ExtractAllFilesWithInputStreams();
    }
}
