package com.glass.core.doc;
import java.io.File;
import java.io.IOException;
import java.net.URL;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Enumeration;
import java.util.List;
import com.wordnik.swagger.annotations.Api;
public class AnnotatedClassFinder {
    public Collection<Class> getAnnotatedClasess ( Class annotation,
            String packageName ) throws ClassNotFoundException, IOException {
        Collection<Class> allClasses = getClasses ( packageName );
        List<Class> annotatedClass = new ArrayList<Class>();
        for ( Class aClass : allClasses ) {
            if ( aClass.isAnnotationPresent ( annotation ) ) {
                annotatedClass.add ( aClass );
                System.out.println ( "!!!!!!!!!!!!!!!!!!!!!!!----------------!"
                                     + aClass.getName() );
            }
        }
        return annotatedClass;
    }
    private Collection<Class> getClasses ( String packageName )
    throws ClassNotFoundException, IOException {
        ClassLoader classLoader = Thread.currentThread().getContextClassLoader();
        String path = packageName.replace ( '.', '/' );
        System.out.println ( "PATH:" + path );
        Enumeration<URL> resources = classLoader.getResources ( path );
        List<File> dirs = new ArrayList<File>();
        while ( resources.hasMoreElements() ) {
            URL resource = resources.nextElement();
            dirs.add ( new File ( resource.getFile() ) );
        }
        List<Class> classes = new ArrayList<Class>();
        for ( File directory : dirs ) {
            classes.addAll ( findClasses ( directory, packageName ) );
        }
        return classes;
    }
    private List<Class> findClasses ( File directory, String packageName )
    throws ClassNotFoundException {
        List<Class> classes = new ArrayList<Class>();
        if ( !directory.exists() ) {
            return classes;
        }
        File[] files = directory.listFiles();
        for ( File file : files ) {
            if ( file.isDirectory() ) {
                classes.addAll ( findClasses ( file,
                                               packageName + "." + file.getName() ) );
            } else if ( file.getName().endsWith ( ".class" ) ) {
                classes.add ( Class.forName ( packageName
                                              + '.'
                                              + file.getName().substring ( 0,
                                                      file.getName().length() - 6 ) ) );
            }
        }
        return classes;
    }
}
