public enum DateFormatter implements IDateFormatter {
    final ThreadLocal<SimpleDateFormat> formats;
    private DateFormatter ( final String s ) {
        formats = new ThreadLocal<SimpleDateFormat>() {
            @Override
            protected SimpleDateFormat initialValue() {
                return new SimpleDateFormat ( s );
            }
        };
    }
    public String format ( Date d ) {
        return formats.get().format ( d );
    }
    public Date parse ( String s ) throws ParseException {
        return formats.get().parse ( s );
    }
}
