public class  DateFormatterHider<T extends Enum<T> & IDateFormatter> {
    private final Class<T> clazz;
    public DateFormatterHider ( Class<T> clazz ) {
        this.clazz = clazz;
    }
    public String format ( Date d, String formatCode ) {
        return getEnumInstance ( formatCode ).format ( d );
    }
    public Date parse ( String s, String formatCode ) throws ParseException {
        return getEnumInstance ( formatCode ).parse ( s );
    }
    private T getEnumInstance ( String formatCode ) {
        return Enum.valueOf ( clazz, formatCode );
    }
}
