import java.io.IOException;
import java.net.URI;
import java.util.List;
import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.multipart.commons.CommonsMultipartFile;
@Controller
public class FileController {
    @ModelAttribute ( "command" )
    public FileUploadCommand setupCommand ( HttpServletRequest request ) {
        FileUploadCommand command = new FileUploadCommand();
        CommonsMultipartFile file = ( CommonsMultipartFile ) request.getAttribute ( "file" );
        command.setFile ( file );
        return command;
    }
    @RequestMapping ( value = {"/api/file/{file_name}", "/api/v1/file/{file_name"}, method = RequestMethod.PUT )
    public ResponseEntity<String> putFile ( @PathVariable ( value = "file_name" ) String fileName, @ModelAttribute ( "command" ) @Valid FileUploadCommand command, BindingResult bindingResult ) throws IOException {
        ResponseEntity<String> responseEntity = null;
        if ( bindingResult.hasErrors() ) {
            responseEntity = new ResponseEntity<String> ( HttpStatus.BAD_REQUEST );
        } else {
            HttpHeaders responseHeaders = new HttpHeaders();
            responseHeaders.set ( "Location", "https://new_file_location.com" );
            responseEntity = new ResponseEntity<String> ( responseHeaders, HttpStatus.CREATED );
        }
        return responseEntity;
    }
}
