import java.lang.reflect.Field;
import java.lang.reflect.Type;
public class SoapParser {
    public static void parseBusinessObject ( String input, Object output )
    throws NumberFormatException, IllegalArgumentException,
        IllegalAccessException, InstantiationException {
        Class theClass = output.getClass();
        Field[] fields = theClass.getDeclaredFields();
        for ( int i = 0; i < fields.length; i++ ) {
            Type type = fields[i].getType();
            fields[i].setAccessible ( true );
            if ( fields[i].getType().equals ( String.class ) ) {
                String tag = "s" + fields[i].getName() + "=";
                if ( input.contains ( tag ) ) {
                    String strValue = input.substring (
                                          input.indexOf ( tag ) + tag.length(),
                                          input.indexOf ( ";", input.indexOf ( tag ) ) );
                    if ( strValue.length() != 0 ) {
                        fields[i].set ( output, strValue );
                    }
                }
            }
            if ( type.equals ( Integer.TYPE ) || type.equals ( Integer.class ) ) {
                String tag = "i" + fields[i].getName() + "=";
                if ( input.contains ( tag ) ) {
                    String strValue = input.substring (
                                          input.indexOf ( tag ) + tag.length(),
                                          input.indexOf ( ";", input.indexOf ( tag ) ) );
                    if ( strValue.length() != 0 ) {
                        fields[i].setInt ( output, Integer.valueOf ( strValue ) );
                    }
                }
            }
            if ( type.equals ( Float.TYPE ) || type.equals ( Float.class ) ) {
                String tag = "f" + fields[i].getName() + "=";
                if ( input.contains ( tag ) ) {
                    String strValue = input.substring (
                                          input.indexOf ( tag ) + tag.length(),
                                          input.indexOf ( ";", input.indexOf ( tag ) ) );
                    if ( strValue.length() != 0 ) {
                        fields[i].setFloat ( output, Float.valueOf ( strValue ) );
                    }
                }
            }
        }
    }
}
