import java.awt.BorderLayout;
import java.awt.EventQueue;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.dnd.DnDConstants;
import java.awt.dnd.DropTarget;
import java.awt.dnd.DropTargetDragEvent;
import java.awt.dnd.DropTargetDropEvent;
import java.awt.dnd.DropTargetEvent;
import java.awt.dnd.DropTargetListener;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
public class TestDragNDrop100 {
    public static void main ( String[] args ) {
        new TestDragNDrop100();
    }
    public TestDragNDrop100() {
        EventQueue.invokeLater ( new Runnable() {
            @Override
            public void run() {
                try {
                    UIManager.setLookAndFeel ( UIManager.getSystemLookAndFeelClassName() );
                } catch ( ClassNotFoundException | InstantiationException | IllegalAccessException | UnsupportedLookAndFeelException ex ) {
                }
                JFrame frame = new JFrame ( "Testing" );
                frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
                frame.setLayout ( new BorderLayout() );
                frame.add ( new TestPane() );
                frame.pack();
                frame.setLocationRelativeTo ( null );
                frame.setVisible ( true );
            }
        } );
    }
    public class TestPane extends JPanel implements DropTargetListener {
        public TestPane() {
            DropTarget dt = new DropTarget ( this, DnDConstants.ACTION_COPY_OR_MOVE, this, true );
            setLayout ( new GridBagLayout() );
            GridBagConstraints gbc = new GridBagConstraints();
            gbc.fill = GridBagConstraints.HORIZONTAL;
            for ( int y = 0; y < 4; y++ ) {
                gbc.gridy = y;
                for ( int x = 0; x < 4; x++ ) {
                    gbc.gridx = x;
                    JTextField field = new JTextField ( 10 );
                    DropTarget child = new DropTarget ( field, DnDConstants.ACTION_COPY_OR_MOVE, this, true );
                    add ( field, gbc );
                }
            }
        }
        @Override
        public void dragEnter ( DropTargetDragEvent dtde ) {
            System.out.println ( "DragEnter - " + dtde.getDropTargetContext().getComponent() );
        }
        @Override
        public void dragOver ( DropTargetDragEvent dtde ) {
            System.out.println ( "DragOver - " + dtde.getDropTargetContext().getComponent() );
        }
        @Override
        public void dropActionChanged ( DropTargetDragEvent dtde ) {
            System.out.println ( "dropActionChanged" + dtde.getDropTargetContext().getComponent() );
        }
        @Override
        public void dragExit ( DropTargetEvent dte ) {
            System.out.println ( "dragExit" + dte.getDropTargetContext().getComponent() );
        }
        @Override
        public void drop ( DropTargetDropEvent dtde ) {
            System.out.println ( "drop" + dtde.getDropTargetContext().getComponent() );
        }
    }
}
