private static final SessionFactory sessionFactory = buildSessionFactory();
private static SessionFactory buildSessionFactory() {
    try {
        Configuration configuration = new Configuration();
        configuration.configure();
        ServiceRegistry serviceRegistry = new ServiceRegistryBuilder().applySettings ( configuration.getProperties() ).buildServiceRegistry();
        return configuration.buildSessionFactory ( serviceRegistry );
    } catch ( Throwable ex ) {
        System.err.println ( "Initial SessionFactory creation failed." + ex );
        throw new ExceptionInInitializerError ( ex );
    }
}
public static SessionFactory getSessionFactory() {
    return sessionFactory;
}
