public boolean generate ( File destinationFile ) {
    try {
        Document document = new Document();
        FileOutputStream stream = new FileOutputStream ( destinationFile );
        PdfWriter.getInstance ( document, stream );
        document.open();
        addMetaData ( document );
        addTitlePage ( document );
        document.close();
        stream.close();
    } catch ( Exception e ) {
        e.printStackTrace();
        return false;
    }
    return true;
}
private  Font catFont = new Font ( Font.FontFamily.TIMES_ROMAN, 18,
                                   Font.BOLD );
private  Font redFont = new Font ( Font.FontFamily.TIMES_ROMAN, 12,
                                   Font.NORMAL, BaseColor.RED );
private  Font subFont = new Font ( Font.FontFamily.TIMES_ROMAN, 16,
                                   Font.BOLD );
private  Font smallBold = new Font ( Font.FontFamily.TIMES_ROMAN, 12,
                                     Font.BOLD );
private  void addTitlePage ( Document document )
throws DocumentException {
    Paragraph preface = new Paragraph();
    addEmptyLine ( preface, 1 );
    preface.add ( new Paragraph ( "Title of the document", catFont ) );
    addEmptyLine ( preface, 1 );
    preface.add ( new Paragraph ( "Report generated by: " + System.getProperty ( "user.name" ) + ", " + new Date(),
                                  smallBold ) );
    addEmptyLine ( preface, 3 );
    preface.add ( new Paragraph ( "This document describes something which is very important ",
                                  smallBold ) );
    addEmptyLine ( preface, 8 );
    preface.add ( new Paragraph ( "This document is a preliminary version and not subject to your license agreement or any other agreement with vogella.com ;-).",
                                  redFont ) );
    document.add ( preface );
    document.newPage();
}
