public void getFavicon ( String host ) {
    URL httpUrl = this.getHttpUrl ( host + "/favicon.ico" );
    Bitmap favicon = this.getBitmap ( httpUrl );
    if ( favicon == null ) {
        URL httpsUrl = this.getHttpsUrl ( host + "/favicon.ico" );
        favicon = this.getBitmap ( httpsUrl );
    }
    if ( favicon == null ) {
        throw new FaviconMissingException ( "Unable to find favicon for host: " + host );
    }
    return favicon;
}
public URL getHttpUrl ( String uri ) throws MalformedURLException {
    return new URL ( "http://" + uri );
}
public URL getHttpsUrl ( String uri ) throws MalformedURLException {
    return new URL ( "https://" + uri );
}
public Bitmap getBitmap ( URL url ) {
    InputStream inputStream = getInputStream ( url );
    Bitmap bitmap = BitmapFactory.decodeStream ( inputStream );
    return bitmap
}
public InputStream getInputStream ( URL url ) {
    HttpURLConnection connection = ( HttpURLConnection ) url.openConnection();
    connection.setDoInput ( true );
    connection.connect();
    return connection.getInputStream();
}
