public void shiftTime ( long timeToShiftInMs ) {
    long targetTime = System.currentTimeMillis() + timeToShiftInMs + 10;
    JDKTimerService clock = getSession().getSessionClock();
    List<TimerJobInstance> jobs = new ArrayList<>();
    for ( TimerJobInstance job : clock.getTimerJobInstances() ) {
        Date nextFireTime = job.getTrigger().hasNextFireTime();
        if ( nextFireTime != null ) {
            long jobTime = nextFireTime.getTime();
            if ( targetTime > jobTime ) {
                jobs.add ( job );
            }
        }
    }
    for ( TimerJobInstance job : jobs ) {
        job.getJob().execute ( job.getJobContext() );
        clock.removeJob ( job.getJobHandle() );
    }
}
