import java.io.ByteArrayInputStream;
import java.util.ArrayList;
import java.util.List;
import javax.swing.JOptionPane;
import com.hp.hpl.jena.query.QueryExecutionFactory;
import com.hp.hpl.jena.query.ResultSet;
import com.hp.hpl.jena.rdf.model.Model;
import com.hp.hpl.jena.rdf.model.ModelFactory;
import com.hp.hpl.jena.rdf.model.Resource;
public class SPARQLJOptions {
    final static String modelContent = "" +
                                       "@prefix : <http://example.org/>.\n" +
                                       ":a :p :b, :c, :d .\n" +
                                       ":b :p :c, :a .\n" +
                                       "";
    final static String query = "" +
                                "prefix : <http://example.org/> \n" +
                                "select ?value where { \n" +
                                " :a :p ?value \n" +
                                "}" +
                                "";
    public static void main ( String[] args ) {
        final Model model = ModelFactory.createDefaultModel();
        model.read ( new ByteArrayInputStream ( modelContent.getBytes() ), null, "TTL" );
        final ResultSet results = QueryExecutionFactory.create ( query, model ).execSelect();
        List<Object> values = new ArrayList<Object>();
        while ( results.hasNext() ) {
            values.add ( results.next().get ( "value" ) );
        }
        Resource choice = ( Resource ) JOptionPane.showInputDialog (
                              null,
                              "Select a resource",
                              "Selecting Resource...",
                              JOptionPane.QUESTION_MESSAGE,
                              null,
                              values.toArray(),
                              values.get ( 0 ) );
        System.out.println ( choice );
    }
}
