void setTextFit ( JLabel label, String text ) {
    Font originalFont = ( Font ) label.getClientProperty ( "originalfont" );
    if ( originalFont == null ) {
        originalFont = label.getFont();
        label.putClientProperty ( "originalfont", originalFont );
    }
    int stringWidth = label.getFontMetrics ( originalFont ).stringWidth ( text );
    int componentWidth = label.getWidth();
    if ( stringWidth > componentWidth ) {
        double widthRatio = ( double ) componentWidth / ( double ) stringWidth;
        int newFontSize = ( int ) Math.floor ( originalFont.getSize() * widthRatio );
        label.setFont ( new Font ( originalFont.getName(), originalFont.getStyle(), newFontSize ) );
    } else {
        label.setFont ( originalFont );
    }
    label.setText ( text );
}
