public final class Common {
    private static final boolean DEBUGGING = false;
    public static void setLaf() {
        if ( setLaf ( null, 1, 6, 0, "com.sun.java.swing.plaf.windows.WindowsLookAndFeel" ) ) {
            return;
        }
        if ( setLaf ( "Windows Vista", 1, 3, 0, UIManager.getCrossPlatformLookAndFeelClassName() ) ) {
            return;
        }
        if ( setLaf ( "Windows XP", 1, 3, 0, UIManager.getCrossPlatformLookAndFeelClassName() ) ) {
            return;
        }
        setLaf ( null, 1, 3, 0, UIManager.getSystemLookAndFeelClassName() );
    }
    public static void setLafNim() {
        if ( setLaf ( null, 1, 6, 0, "com.sun.java.swing.plaf.nimbus.NimbusLookAndFeel" ) ) {
            return;
        }
        if ( setLaf ( "Windows Vista", 1, 3, 0, UIManager.getCrossPlatformLookAndFeelClassName() ) ) {
            return;
        }
        if ( setLaf ( "Windows XP", 1, 3, 0, UIManager.getCrossPlatformLookAndFeelClassName() ) ) {
            return;
        }
        setLaf ( null, 1, 3, 0, UIManager.getSystemLookAndFeelClassName() );
    }
    private static boolean setLaf ( String os, int wantedMajor,
                                    int wantedMinor,
                                    int wantedBugFix,
                                    String lafClassName ) {
        if ( os != null && !System.getProperty ( "os.name", "unknown" ).equals ( os ) ) {
            return false;
        }
        try {
            UIManager.setLookAndFeel ( lafClassName );
        } catch ( UnsupportedLookAndFeelException e ) {
            if ( DEBUGGING ) {
                System.err.println ( "fail: UnsupportedLookAndFeelException" + lafClassName + e.getMessage() );
            }
            return false;
        } catch ( IllegalAccessException e ) {
            if ( DEBUGGING ) {
                System.err.println ( "fail: IllegalAccessException" + lafClassName + e.getMessage() );
            }
            return false;
        } catch ( InstantiationException e ) {
            if ( DEBUGGING ) {
                System.err.println ( "fail: InstantiationException" + lafClassName + e.getMessage() );
            }
            return false;
        } catch ( ClassNotFoundException e ) {
            if ( DEBUGGING ) {
                System.err.println ( "fail: ClassNotFoundException" + lafClassName + e.getMessage() );
            }
            return false;
        } catch ( Exception e ) {
            if ( DEBUGGING ) {
                System.err.println ( "fail: Exception" + lafClassName + e.getMessage() );
            }
            return false;
        }
        if ( DEBUGGING ) {
            System.err.println ( "Choosing L&F " + lafClassName );
        }
        return true;
    }
}
