import java.util.ArrayList;
import java.util.List;
public class CompoundActionExample {
    interface Action {
        void act ( Object argument );
    }
    static class CompoundAction implements Action {
        private final List<CompoundActionExample.Action> actions;
        CompoundAction ( final List<CompoundActionExample.Action> actions ) {
            this.actions = actions;
        }
        CompoundAction() {
            this ( new ArrayList<CompoundActionExample.Action>() );
        }
        public void add ( CompoundActionExample.Action action ) {
            actions.add ( action );
        }
        public void act ( final Object argument ) {
            for ( CompoundActionExample.Action action : actions ) {
                action.act ( argument );
            }
        }
    }
    public static void main ( String[] args ) {
        final boolean conditionA = true;
        final boolean conditionB = false;
        final Object[] listOfObjects = { "object1", "object2", "object3" };
        final CompoundAction compoundAction = new CompoundAction();
        if ( conditionA ) {
            compoundAction.add ( new Action() {
                public void act ( final Object argument ) {
                    System.out.println ( "doA(" + argument + ")" );
                }
            } );
        }
        if ( conditionB )  {
            compoundAction.add ( new Action() {
                public void act ( Object argument ) {
                    System.out.println ( "doB(" + argument + ")" );
                }
            } );
        }
        for ( final Object o : listOfObjects ) {
            compoundAction.act ( o );
        }
    }
}
