import org.apache.jmeter.control.LoopController;
import org.apache.jmeter.engine.StandardJMeterEngine;
import org.apache.jmeter.protocol.http.sampler.HTTPSampler;
import org.apache.jmeter.testelement.TestElement;
import org.apache.jmeter.testelement.TestPlan;
import org.apache.jmeter.threads.SetupThreadGroup;
import org.apache.jmeter.util.JMeterUtils;
import org.apache.jorphan.collections.HashTree;
public class JMeterTestFromCode {
    public static void main ( String[] args ) {
        StandardJMeterEngine jm = new StandardJMeterEngine();
        JMeterUtils.loadJMeterProperties ( "c:/tmp/jmeter.properties" );
        HashTree hashTree = new HashTree();
        HTTPSampler httpSampler = new HTTPSampler();
        httpSampler.setDomain ( "www.google.com" );
        httpSampler.setPort ( 80 );
        httpSampler.setPath ( "/" );
        httpSampler.setMethod ( "GET" );
        TestElement loopCtrl = new LoopController();
        ( ( LoopController ) loopCtrl ).setLoops ( 1 );
        ( ( LoopController ) loopCtrl ).addTestElement ( httpSampler );
        ( ( LoopController ) loopCtrl ).setFirst ( true );
        SetupThreadGroup threadGroup = new SetupThreadGroup();
        threadGroup.setNumThreads ( 1 );
        threadGroup.setRampUp ( 1 );
        threadGroup.setSamplerController ( ( LoopController ) loopCtrl );
        TestPlan testPlan = new TestPlan ( "MY TEST PLAN" );
        hashTree.add ( "testPlan", testPlan );
        hashTree.add ( "loopCtrl", loopCtrl );
        hashTree.add ( "threadGroup", threadGroup );
        hashTree.add ( "httpSampler", httpSampler );
        jm.configure ( hashTree );
        jm.run();
    }
}
