import java.util.Arrays;
import java.util.Scanner;
public class Item {
    private int priority;
    private String name;
    private double price;
    public Item() {
        priority = -1;
        price = 0.0;
        name = "No name yet";
    }
    public Item ( int priority, String name, double price ) {
        this.priority = priority;
        this.name = name;
        this.price = price;
    }
    public int getPriority() {
        return priority;
    }
    public void setPriority ( int priority ) {
        if ( priority >= 0 && priority <= 7 ) {
            this.priority = priority;
        } else {
            this.priority = 0;
        }
    }
    public String getName() {
        return name;
    }
    public void setName ( String name ) {
        this.name = name;
    }
    public double getPrice() {
        return price;
    }
    public void setPrice ( double price ) {
        if ( price >= 0 ) {
            if ( price <= 100 ) {
                this.price = price;
            } else {
                System.err.println ( "Error: price to high" );
            }
        } else {
            System.err.println ( "Error: price to low" );
        }
    }
    @Override
    public String toString() {
        StringBuilder builder = new StringBuilder();
        builder.append ( "Item [getPrice()=" ).append ( getPrice() ).append ( ", " );
        if ( getName() != null ) {
            builder.append ( "getName()=" ).append ( getName() ).append ( ", " );
        }
        builder.append ( "getPriority()=" ).append ( getPriority() ).append ( "]" );
        return builder.toString();
    }
    public static void main ( String[] args ) {
        Item[] list = new Item[7];
        Scanner keyboard = new Scanner ( System.in );
        for ( int i = 1; i <= list.length; i++ ) {
            Item anItem = new Item();
            System.out.println ( "Enter an item you want to add to your list " + i );
            anItem.setName ( keyboard.next() );
            System.out.println ( "Enter a price " + i );
            anItem.setPrice ( keyboard.nextDouble() );
            System.out.println ( "Enter the priority of the item " + i );
            anItem.setPriority ( keyboard.nextInt() );
            list[i - 1] = anItem;
        }
        System.out.println ( Arrays.toString ( list ) );
    }
}
