private final AtomicBoolean pauseFlag = new AtomicBoolean ( false );
...
while ( !Thread.currentThread().isInterrupted() ) {
    if ( pauseFlag.get() ) {
        synchronized ( pauseFlag ) {
            while ( pauseFlag.get() ) ) {
                try {
                    pauseFlag.wait();
                } catch ( InterruptedException e ) {
                    Thread.currentThread().interrupt();
                    return;
                }
            }
        }
    }
    ...
}
...
public void pause() {
    pauseFlag.set ( true );
}
...
public void resume() {
    pauseFlag.set ( false );
    synchronized ( pauseFlag ) {
        pauseFlag.notify();
    }
}
