import java.awt.BorderLayout;
import java.awt.EventQueue;
import java.awt.Font;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.text.DateFormat;
import java.util.Date;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.Timer;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
public class SimpleClock {
    public static void main ( String[] args ) {
        new SimpleClock();
    }
    public SimpleClock() {
        EventQueue.invokeLater ( new Runnable() {
            @Override
            public void run() {
                try {
                    UIManager.setLookAndFeel ( UIManager.getSystemLookAndFeelClassName() );
                } catch ( ClassNotFoundException | InstantiationException | IllegalAccessException | UnsupportedLookAndFeelException ex ) {
                }
                JFrame frame = new JFrame ( "Testing" );
                frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
                frame.setLayout ( new BorderLayout() );
                frame.add ( new TestPane() );
                frame.pack();
                frame.setLocationRelativeTo ( null );
                frame.setVisible ( true );
            }
        } );
    }
    public class TestPane extends JPanel {
        private JLabel time;
        public TestPane() {
            setLayout ( new GridBagLayout() );
            time = new JLabel();
            time.setFont ( time.getFont().deriveFont ( Font.BOLD, 48 ) );
            add ( time );
            updateTime();
            Timer timer = new Timer ( 500, new ActionListener() {
                @Override
                public void actionPerformed ( ActionEvent e ) {
                    updateTime();
                }
            } );
            timer.start();
        }
        protected void updateTime() {
            time.setText ( DateFormat.getTimeInstance().format ( new Date() ) );
        }
    }
}
