package com.stackoverflow.AppIdTest;
import com.sun.jna.Native;
import com.sun.jna.NativeLong;
import com.sun.jna.Pointer;
import com.sun.jna.WString;
import com.sun.jna.ptr.PointerByReference;
public class AppIdTest {
    public static void main ( String[] args ) throws Exception {
        setCurrentProcessExplicitAppUserModelID ( AppIdTest.class.getName() );
        System.out.println ( getCurrentProcessExplicitAppUserModelID() );
    }
    public static String getCurrentProcessExplicitAppUserModelID() {
        final PointerByReference r = new PointerByReference();
        if ( GetCurrentProcessExplicitAppUserModelID ( r ).longValue() == 0 ) {
            final Pointer p = r.getValue();
            return p.getString ( 0, true );
        }
        return "N/A";
    }
    public static void setCurrentProcessExplicitAppUserModelID ( final String appID ) {
        if ( SetCurrentProcessExplicitAppUserModelID ( new WString ( appID ) ).longValue() != 0 ) {
            throw new RuntimeException ( "unable to set current process explicit AppUserModelID to: " + appID );
        }
    }
    private static native NativeLong GetCurrentProcessExplicitAppUserModelID ( PointerByReference appID );
    private static native NativeLong SetCurrentProcessExplicitAppUserModelID ( WString appID );
    static {
        Native.register ( "shell32" );
    }
}
