@Override
public String getLimitString ( String sql, boolean hasOffset ) {
    sql = sql.trim();
    String forUpdateClause = null;
    boolean isForUpdate = false;
    final int forUpdateIndex = sql.toLowerCase().lastIndexOf ( "for update" ) ;
    if ( forUpdateIndex > -1 ) {
        forUpdateClause = sql.substring ( forUpdateIndex );
        sql = sql.substring ( 0, forUpdateIndex - 1 );
        isForUpdate = true;
    }
    String rank = "";
    if ( sql.contains ( "partition" ) ) {
        rank = findRank ( sql );
    }
    StringBuilder pagingSelect = new StringBuilder ( sql.length() + 100 );
    if ( hasOffset ) {
        pagingSelect.append ( "select * from ( select row_.*, rownum rownum_ from ( " );
    } else {
        pagingSelect.append ( "select * from ( " );
    }
    pagingSelect.append ( sql );
    if ( hasOffset ) {
        pagingSelect.append ( " ) row_ where rownum <= ? " );
        pagingSelect.append ( rank );
        pagingSelect.append ( ") where rownum_ > ?" );
    } else {
        pagingSelect.append ( " ) where rownum <= ?" );
        pagingSelect.append ( rank );
    }
    if ( isForUpdate ) {
        pagingSelect.append ( " " );
        pagingSelect.append ( forUpdateClause );
    }
    return pagingSelect.toString();
}
private String addRank ( String sql ) {
    int partition = sql.indexOf ( "partition" );
    String rank = "";
    if ( partition != -1 ) {
        int start = partition;
        int end = sql.indexOf ( ',', start );
        String aliasName = end == -1 ? sql.substring ( start ) : sql
                           .substring ( start, end );
        int last = aliasName.indexOf ( "as" );
        if ( last != -1 ) {
            rank = " AND " + aliasName.substring ( last + 2 ) + " = 1";
        }
    }
    return rank;
}
