public static int parseInt ( String s, int radix )
throws NumberFormatException {
    if ( s == null ) {
        throw new NumberFormatException ( "null" );
    }
    if ( radix < Character.MIN_RADIX ) {
        throw new NumberFormatException ( "radix " + radix +
                                          " less than Character.MIN_RADIX" );
    }
    if ( radix > Character.MAX_RADIX ) {
        throw new NumberFormatException ( "radix " + radix +
                                          " greater than Character.MAX_RADIX" );
    }
    int result = 0;
    boolean negative = false;
    int i = 0, len = s.length();
    int limit = -Integer.MAX_VALUE;
    int multmin;
    int digit;
    if ( len > 0 ) {
        char firstChar = s.charAt ( 0 );
        if ( firstChar < '0' ) {
            if ( firstChar == '-' ) {
                negative = true;
                limit = Integer.MIN_VALUE;
            } else if ( firstChar != '+' ) {
                throw NumberFormatException.forInputString ( s );
            }
            if ( len == 1 ) {
                throw NumberFormatException.forInputString ( s );
            }
            i++;
        }
        multmin = limit / radix;
        while ( i < len ) {
            digit = Character.digit ( s.charAt ( i++ ), radix );
            if ( digit < 0 ) {
                throw NumberFormatException.forInputString ( s );
            }
            if ( result < multmin ) {
                throw NumberFormatException.forInputString ( s );
            }
            result *= radix;
            if ( result < limit + digit ) {
                throw NumberFormatException.forInputString ( s );
            }
            result -= digit;
        }
    } else {
        throw NumberFormatException.forInputString ( s );
    }
    return negative ? result : -result;
}
