public class MyModule extends AbstractModule {
    public void configure() {
        bind ( RuleChecker.class ).annotatedWith ( named ( "password" ) ).toProvider ( PasswordRuleCheckerProvider.class );
        bind ( RuleChecker.class ).annotatedWith ( named ( "login" ) ).toProvider ( LoginRuleCheckerProvider.class );
    }
}
public static class PasswordRuleCheckerProvider implements Provider<RuleChecker> {
    private static CheckType type = CheckType.ALPHANUMERIC;
    public RuleChecker get() {
        switch ( type ) {
        case LENGTH:
            return new LengthCheck();
        case ALPHANUMERIC:
            return new AlphanumericCheck();
        case ALPHALENGTH:
            return new AlphaAndLenghtCheckAdapter();
        case NONE:
        default:
            return NoCheck();
        }
    }
}
