public static Object[] newArray ( int[] sizes ) {
    Object[] result = null;
    if ( sizes != null ) {
        for ( int n = sizes.length - 1; n >= 0; n-- ) {
            if ( result == null ) {
                result = new Object[sizes[n]];
            } else {
                Object[] oa = new Object[sizes[n]];
                for ( int i = 0; i < sizes[n]; i++ ) {
                    oa[i] = java.util.Arrays.copyOf ( result, result.length );
                }
                result = oa;
            }
        }
        if ( result == null ) {
            result = new Object[1];
        }
    }
    return result;
}
public static Object getValue ( Object[] array, int[] coordinates ) {
    Object result = null;
    if ( array == null || coordinates == null || 0 > coordinates[0] || coordinates[0] > array.length ) {
        result = null;
    } else {
        int x = coordinates[0];
        if ( array[x] instanceof Object[] ) {
            int[] c = new int[coordinates.length - 1];
            for ( int i = 0; i < c.length; i++ ) {
                c[i] = coordinates[i + 1];
            }
            result = getValue ( ( Object[] ) array[x], c );
        } else {
            result = array[x];
        }
    }
    return result;
}
public static void setValue ( Object[] array, int[] coordinates, Object value ) {
    if ( array == null || coordinates == null || array.length == 0 || coordinates.length == 0 || array.length < coordinates[0] || coordinates[0] < 0 ) {
        return;
    } else {
        int x = coordinates[0];
        if ( array[x] != null && array[x].getClass().isArray() ) {
            int[] c = new int[coordinates.length - 1];
            for ( int i = 0; i < c.length; i++ ) {
                c[i] = coordinates[i + 1];
            }
            setValue ( ( Object[] ) array[x], c, value );
        } else {
            array[x] = value;
        }
    }
    return;
}
