@Configuration
@EnableWebSecurity
@EnableGlobalMethodSecurity ( prePostEnabled = true )
public class MultiSecurityConfig {
    @Autowired
    public void registerSharedAuthentication ( AuthenticationManagerBuilder auth ) throws Exception {
        auth
        .inMemoryAuthentication()
        .withUser ( "user" ).password ( "password" ).roles ( "USER" ).and()
        .withUser ( "admin" ).password ( "password" ).roles ( "USER", "ADMIN" );
    }
    @Configuration
    @Order ( 1 )
    public static class ApiWebSecurityConfigurationAdapter extends WebSecurityConfigurerAdapter {
        protected void configure ( HttpSecurity http ) throws Exception {
            http
            .antMatcher ( "/api/**" )
            .httpBasic();
        }
    }
    @Configuration
    public static class FormWebSecurityConfigurerAdapter extends WebSecurityConfigurerAdapter {
        public void configure ( WebSecurity web ) throws Exception {
            web
            .ignoring()
            .antMatchers ( "/static/**", "/status" );
        }
        protected void configure ( HttpSecurity http ) throws Exception {
            http
            .authorizeRequests()
            .anyRequest().hasRole ( "USER" )
            .and()
            .formLogin()
            .loginPage ( "/login" )
            .permitAll();
        }
    }
}
