import java.io.File;
import java.io.IOException;
import java.nio.ByteBuffer;
import java.nio.channels.FileChannel;
import java.nio.file.StandardOpenOption;
public class TestFile {
    static final int IN_BUFFER_SIZE = 1024 * 8;
    static final int OUT_BUFFER_SIZE = 1024 * 9;
    static final int MIN_READ_BYTES = 8;
    static final int MIN_WRITE_BYTES = 8;
    private File readFromFile1 ( File inFile ) {
        final File outFile = new File ( "file2.txt" );
        final ByteBuffer inBuffer = ByteBuffer.allocate ( IN_BUFFER_SIZE );
        final ByteBuffer outBuffer = ByteBuffer.allocate ( OUT_BUFFER_SIZE );
        FileChannel readChannel = null;
        FileChannel writeChannel = null;
        try {
            readChannel = FileChannel.open ( inFile.toPath(), StandardOpenOption.READ );
            writeChannel = FileChannel.open ( outFile.toPath(), StandardOpenOption.CREATE, StandardOpenOption.WRITE );
            long totalReadByteCount = 0L;
            long totalWriteByteCount = 0L;
            boolean readMore = true;
            while ( readMore ) {
                int readOp = 0;
                while ( ( readOp = readChannel.read ( inBuffer ) ) != -1 ) {
                    totalReadByteCount += readOp;
                }
                inBuffer.flip();
                if ( readOp == -1 ) {
                    readMore = false;
                }
                while ( inBuffer.remaining() >= MIN_READ_BYTES ) {
                    outBuffer.putLong ( someOperation ( inBuffer ) );
                }
                if ( readMore ) {
                    inBuffer.compact();
                }
                outBuffer.flip();
                while ( outBuffer.hasRemaining() ) {
                    totalWriteByteCount += writeChannel.write ( outBuffer );
                }
                outBuffer.flip();
            }
            if ( inBuffer.hasRemaining() ) {
                System.err.println ( "Truncated data! Not a long value! bytes remaining: " + inBuffer.remaining() );
            }
            System.out.println ( "read total: " + totalReadByteCount + " bytes." );
            System.out.println ( "write total: " + totalWriteByteCount + " bytes." );
        } catch ( IOException e ) {
            System.out.println ( "Some error occurred while reading from File: " + e );
        } finally {
            if ( readChannel != null ) {
                try {
                    readChannel.close();
                } catch ( IOException e ) {
                    System.out.println ( "Could not close read channel: " + e );
                }
            }
            if ( writeChannel != null ) {
                try {
                    writeChannel.close();
                } catch ( IOException e ) {
                    System.out.println ( "Could not close write channel: " + e );
                }
            }
        }
        return outFile;
    }
    private long someOperation ( ByteBuffer bb ) {
        return bb.getLong();
    }
    public static void main ( String[] args ) {
        TestFile testFile = new TestFile();
        File source = new File ( "input.txt" );
        testFile.readFromFile1 ( source );
    }
}
