public class List {
    private Node first;
    private Node last;
    private int size;
    List() {
        first = null;
        last = null;
        size = 0;
    }
    public int getSize() {
        return size;
    }
    public boolean isEmpty() {
        return ( size == 0 );
    }
    public Position first() {
        return first;
    }
    public Position last() {
        return last;
    }
    public Position before ( Position p ) throws Exception {
        Node n = ( Node ) p;
        try {
            return n.getPrev();
        } catch ( NullPointerException ex ) {
            throw new Exception ( "Position Doesn't Exists" );
        }
    }
    public Position after ( Position p ) throws Exception {
        Node n = ( Node ) p;
        try {
            return n.getNext();
        } catch ( NullPointerException ex ) {
            throw new Exception ( "Position Doesn't Exists" );
        }
    }
    public void insertFirst ( Object data ) {
        Node node;
        if ( isEmpty() ) {
            Node prev = null;
            Node next = null;
            node  = new Node ( prev, data, next );
            first = node;
            last = node;
        } else {
            Node prev = null;
            Node next = first;
            node  = new Node ( prev, data, next );
            first.setPrev ( node );
            first = node;
        }
        size++;
    }
    public void insertLast ( Object data ) {
        Node node;
        if ( isEmpty() ) {
            Node prev = null;
            Node next = null;
            node  = new Node ( prev, data, next );
            first = node;
            last = node;
        } else {
            Node prev = last;
            Node next = null;
            node  = new Node ( prev, data, next );
            last.setNext ( node );
            last = node;
        }
        size++;
    }
    public void insertBefore ( Position p, Object data ) throws Exception {
        Node cur = ( Node ) p;
        Node prev;
        try {
            prev = cur.getPrev();
        } catch ( NullPointerException ex ) {
            throw new Exception ( "Position Doesn't Exists" );
        }
        Node next = cur;
        Node node;
        node  = new Node ( prev, data, next );
        next.setPrev ( node );
        if ( cur != first ) {
            prev.setNext ( node );
        } else {
            first = node;
        }
        size++;
    }
    public void insertAfter ( Position p, Object data ) throws Exception {
        Node cur = ( Node ) p;
        Node prev = cur;
        Node next;
        try {
            next = cur.getNext();
        } catch ( NullPointerException ex ) {
            throw new Exception ( "Position Doesn't Exists" );
        }
        Node node;
        node  = new Node ( prev, data, next );
        prev.setNext ( node );
        if ( cur != last ) {
            next.setPrev ( node );
        } else {
            last = node;
        }
        size++;
    }
    public Object remove ( Position p ) throws Exception {
        Node n = ( Node ) p;
        Object data = n.element();
        if ( isEmpty() ) {
            throw new Exception ( "List is Empty" );
        } else {
            Node prev, next;
            if ( n == first && n == last ) {
                first = null;
                last = null;
            } else if ( n == first ) {
                prev = null;
                next = n.getNext();
                next.setPrev ( prev );
                first = next;
            } else if ( n == last ) {
                prev = n.getPrev();
                next = null;
                prev.setNext ( next );
                last = prev;
            } else {
                prev = n.getPrev();
                next = n.getNext();
                prev.setNext ( next );
                next.setPrev ( prev );
            }
            size--;
        }
        return data;
    }
}
