public class GUDPServer_A {
    private int PORT_NUMBER = 4444;
    private DatagramSocket serverSocket;
    private DatagramPacket inPacket;
    private DatagramPacket outPacket;
    private boolean running = true;
    public static final int BUFFER_SIZE = 1024 * 4;
    public static byte[] bytes_in;
    public static byte[] bytes_out;
    public GUDPServer_A() {
        bytes_in = new byte[BUFFER_SIZE];
        bytes_out = new byte[BUFFER_SIZE];
        try {
            serverSocket = new DatagramSocket ( PORT_NUMBER );
            System.out.println ( "Servidor UDP en marcha." );
        } catch ( SocketException e ) {
            System.out.println ( "Socket: " + e.getMessage() );
        } catch ( IOException e ) {
            System.out.println ( "IO: " + e.getMessage() );
        }
    }
    public void run() {
        android.os.Process.setThreadPriority ( android.os.Process.THREAD_PRIORITY_URGENT_AUDIO );
        int lap = 0;
        while ( running ) {
            read ( bytes_in );
            bytes_out = bytes_in.clone();
            G.toc = System.currentTimeMillis();
            G.ticToc();
            G.tic = G.toc;
            write ( bytes_out );
            Log.d ( "Vuelta:", "" + lap );
            lap++;
        }
    }
    public void write ( byte[] buffer ) {
        outPacket = new DatagramPacket ( buffer, inPacket.getLength(), inPacket.getAddress(), inPacket.getPort() );
        try {
            serverSocket.send ( outPacket );
        } catch ( IOException e ) {
            e.printStackTrace();
        }
    }
    public void read ( byte[] buffer ) {
        inPacket = new DatagramPacket ( buffer, buffer.length );
        try {
            serverSocket.receive ( inPacket );
        } catch ( IOException e ) {
            e.printStackTrace();
        }
    }
    public void stop() {
        if ( serverSocket != null ) {
            serverSocket.close();
        }
    }
}
