public class GUDPClient {
    private int PORT_NUMBER = 4444;
    private DatagramSocket clientSocket;
    private DatagramPacket inPacket;
    private DatagramPacket outPacket;
    private InetAddress host;
    public static final String IP_LG = "192.168.1.102";
    public static final String IP_TABLET = "192.168.1.105";
    public GUDPClient() {
        try {
            clientSocket = new DatagramSocket();
            host = InetAddress.getByName ( IP_LG );
            System.out.println ( "Cliente UDP conectado." );
        } catch ( SocketException e ) {
            System.out.println ( "Socket: " + e.getMessage() );
        } catch ( IOException e ) {
            System.out.println ( "IO: " + e.getMessage() );
        }
    }
    public void write ( byte[] buffer ) {
        outPacket = new DatagramPacket ( buffer, buffer.length, host, PORT_NUMBER );
        try {
            clientSocket.send ( outPacket );
        } catch ( IOException e ) {
            e.printStackTrace();
        }
    }
    public void read ( byte[] buffer ) {
        inPacket = new DatagramPacket ( buffer, buffer.length );
        try {
            clientSocket.receive ( inPacket );
        } catch ( IOException e ) {
            e.printStackTrace();
        }
    }
    public void stop() {
        if ( clientSocket != null ) {
            clientSocket.close();
        }
    }
}
