import java.util.*;
public class TicTacMessAroundCode {
    public static final int BLANK = 0;
    public static final int EX = 1;
    public static final int CIRCLE = 2;
    public static final int PLAYING = 0;
    public static final int DRAW = 1;
    public static final int EX_WON = 2;
    public static final int CIRCLE_WON = 3;
    public static final int SIZE = 3;
    public static int[][] board = new int[SIZE][SIZE];
    public static int currentState;
    public static int currentPlayer;
    public static int currentRow, currentCol;
    public static Scanner in = new Scanner ( System.in );
    public static void main ( String[] args ) {
        initializeBoard();
        do {
            getMove ( currentPlayer );
            updateGame ( currentPlayer, currentRow, currentCol );
            displayBoard();
            if ( currentState == EX_WON ) {
                System.out.println ( "'X' player won!" );
            } else if ( currentState == CIRCLE_WON ) {
                System.out.println ( "'O' player won!" );
            } else if ( currentState == DRAW ) {
                System.out.println ( "It's a Draw!!" );
            }
            currentPlayer = ( currentPlayer == EX ) ? CIRCLE : EX;
        } while ( currentState == PLAYING );
    }
    public static void initializeBoard() {
        for ( int row = 0; row < SIZE; ++row ) {
            for ( int col = 0; col < SIZE; ++col ) {
                board[row][col] = BLANK;
            }
        }
        currentState = PLAYING;
        System.out.println ( "Who wants to go first (X or O)? " );
        Scanner xOrO = new Scanner ( System.in );
        String entOp = xOrO.nextLine();
        char enterOp = entOp.charAt ( 0 );
        if ( enterOp == 'X' ) {
            currentPlayer = EX;
        } else {
            currentPlayer = CIRCLE;
        }
    }
    public static void getMove ( int theSeed ) {
        boolean validInput = false;
        do {
            int row = 0;
            int col = 0;
            if ( theSeed == EX ) {
                System.out.println ( "Enter a row (0,1,2) for player X: " );
                row = in.nextInt();
                System.out.println ( "Enter a column (0,1,2) for player X: " );
                col = in.nextInt();
            }  else {
                System.out.println ( "Enter a row (0,1,2) for player O: " );
                row = in.nextInt();
                System.out.println ( "Enter a column (0,1,2) for player O: " );
                col = in.nextInt();
            }
            if ( row >= 0 && row < SIZE && col >= 0 && col < SIZE && board[row][col] == BLANK ) {
                currentRow = row;
                currentCol = col;
                board[currentRow][currentCol] = theSeed;
                validInput = true;
            } else {
                System.out.println ( "This move at (" + ( row ) + "," + ( col )
                                     + ") is not valid. Try again..." );
            }
        } while ( !validInput );
    }
    public static void updateGame ( int theSeed, int currentRow, int currentCol ) {
        if ( findWinner ( theSeed, currentRow, currentCol ) ) {
            currentState = ( theSeed == EX ) ? EX_WON : CIRCLE_WON;
        } else if ( isDraw() ) {
            currentState = DRAW;
        }
    }
    public static boolean isDraw() {
        for ( int row = 0; row < SIZE; ++row ) {
            for ( int col = 0; col < SIZE; ++col ) {
                if ( board[row][col] == BLANK ) {
                    return false;
                }
            }
        }
        return true;
    }
    public static boolean findWinner ( int theSeed, int currentRow, int currentCol ) {
        return ( board[currentRow][0] == theSeed
                 && board[currentRow][1] == theSeed
                 && board[currentRow][2] == theSeed
                 || board[0][currentCol] == theSeed
                 && board[1][currentCol] == theSeed
                 && board[2][currentCol] == theSeed
                 || currentRow == currentCol
                 && board[0][0] == theSeed
                 && board[1][1] == theSeed
                 && board[2][2] == theSeed
                 || currentRow + currentCol == 2
                 && board[0][2] == theSeed
                 && board[1][1] == theSeed
                 && board[2][0] == theSeed );
    }
    public static void displayBoard() {
        System.out.println ( "-------------" );
        for ( int row = 0; row < SIZE; ++row ) {
            System.out.print ( "|" );
            for ( int col = 0; col < SIZE; ++col ) {
                printCell ( board[row][col] );
                if ( col != SIZE ) {
                    System.out.print ( "|" );
                }
            }
            System.out.println();
            if ( row != SIZE ) {
                System.out.println ( "-------------" );
            }
        }
        System.out.println();
    }
    public static void printCell ( int content ) {
        switch ( content ) {
        case BLANK:
            System.out.print ( "   " );
            break;
        case CIRCLE:
            System.out.print ( " O " );
            break;
        case EX:
            System.out.print ( " X " );
            break;
        }
    }
}
