import com.fasterxml.jackson.annotation.JsonGetter;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonSetter;
import com.fasterxml.jackson.databind.ObjectMapper;
@SuppressWarnings ( "unused" )
public class Media {
    private Asset asset;
    @JsonGetter ( "asset" )
    public Asset getAsset() {
        return asset;
    }
    @JsonSetter ( "asset" )
    public void setAsset ( Asset asset ) {
        this.asset = asset;
    }
    @JsonSetter ( "cover_asset" )
    private void setMediaAsset ( Asset asset ) {
        if ( this.asset == null ) {
            setAsset ( asset );
        }
    }
    private static class Asset {
        @JsonProperty ( "foo" )
        private String foo;
    }
    public static void main ( String[] args ) throws Exception {
        String withAsset = "{'asset': {'foo':'bar'}}";
        String withCoverAsset = "{'cover_asset': {'foo':'bar'}}";
        ObjectMapper mapper = new ObjectMapper();
        Media mediaFromAsset = mapper.readValue ( withAsset.replace ( '\'', '"' ), Media.class );
        Media mediaFromCoverAsset = mapper.readValue ( withCoverAsset.replace ( '\'', '"' ), Media.class );
        System.out.println ( mediaFromAsset.asset.foo.equals ( mediaFromCoverAsset.asset.foo ) );
    }
}
