class OpenResultsShould {
    @Test
    public void loadResults() {
        Data fake = mock ( Data.class );
        ViewInterface view = mock ( ViewInterface.class );
        when ( view.getFilename() ).thenReturn ( "file.xml" );
        ApplicationModelInterface appModel = mock ( ApplicationModelInterface.class );
        when ( appModel.getDataForView() ).thenReturn ( fake );
        OpenResultsAction openResults = new OpenResultsAction ( view, appModel );
        openResults.actionPerformed ( new ActionEvent() );
        verify ( view ).getFileName();
        verify ( appModel ).load ( "file.xml" );
        verify ( appModel ).getDataForView();
        verify ( view ).loadDataFromModel ( fake );
    }
}
