private static void generateNotification ( Context context, String message ) {
    int icon = R.drawable.ic_status;
    long when = System.currentTimeMillis();
    NotificationManager notificationManager = ( NotificationManager ) context
            .getSystemService ( Context.NOTIFICATION_SERVICE );
    Notification notification = new Notification ( icon, message, when );
    String title = context.getString ( R.string.app_name );
    Intent notificationIntent = new Intent ( context, SplashScreen.class );
    notificationIntent.setFlags ( Intent.FLAG_ACTIVITY_CLEAR_TOP
                                  | Intent.FLAG_ACTIVITY_SINGLE_TOP );
    PendingIntent intent = PendingIntent.getActivity ( context, 0,
                           notificationIntent, 0 );
    notification.setLatestEventInfo ( context, title, message, intent );
    notification.flags |= Notification.FLAG_AUTO_CANCEL;
    notificationManager.notify ( 0, notification );
}
