import java.awt.*;
import java.awt.geom.Rectangle2D;
import java.awt.image.BufferedImage;
import java.io.IOException;
import java.net.URL;
import java.util.logging.*;
import javax.imageio.ImageIO;
import javax.swing.*;
import javax.swing.border.*;
class CButton extends JButton {
    BasicStroke basicStroke = new BasicStroke ( 2.0f );
    public CButton ( String txt ) {
        super ( txt );
        setForeground ( Color.WHITE );
        setFont ( getFont().deriveFont ( Font.BOLD, 13 ) );
        setContentAreaFilled ( false );
        setBorder ( null );
        setCursor ( new Cursor ( Cursor.HAND_CURSOR ) );
    }
    @Override
    protected void paintComponent ( Graphics g ) {
        Graphics2D g2d = ( Graphics2D ) g.create();
        g2d.setColor ( new Color ( 0xFFAA00 ) );
        g2d.setRenderingHint ( RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON );
        g2d.setStroke ( basicStroke );
        int archH = ( getHeight() - 4 ) / 2;
        g2d.drawRoundRect ( 3, 3, getWidth() - 4, getHeight() - 4, archH, archH );
        if ( getModel().isRollover() ) {
            g2d.fillRoundRect ( 3, 3, getWidth() - 4, getHeight() - 4, archH, archH );
            setForeground ( Color.black );
        } else {
            setForeground ( Color.white );
        }
        g2d.dispose();
        super.paintComponent ( g );
    }
}
class MainContainer extends JPanel {
    public BufferedImage gradientImage = null;
    public static BufferedImage textureImg;
    public static boolean loadingFinished = false;
    public MainContainer() {
        setBorder ( new EmptyBorder ( 50, 50, 50, 50 ) );
        setLayout ( new GridBagLayout() );
        JLabel usrNameLabel = new JLabel ( "User Name" );
        changeCompFont ( usrNameLabel );
        JTextField usrNameFeild = new JTextField ( "user name" );
        changeCompFont ( usrNameFeild );
        Border compundBorder = BorderFactory.createCompoundBorder (
                                   new LineBorder ( Color.white, 2 ),
                                   new EmptyBorder ( 2, 5, 2, 2 ) );
        usrNameFeild.setBorder ( compundBorder );
        usrNameFeild.setOpaque ( false );
        usrNameLabel.setLabelFor ( usrNameFeild );
        JLabel passwordLabel = new JLabel ( "Password" );
        changeCompFont ( passwordLabel );
        JPasswordField passFeild = new JPasswordField ( "Password" );
        changeCompFont ( passFeild );
        passFeild.setBorder ( compundBorder );
        passFeild.setOpaque ( false );
        passwordLabel.setLabelFor ( passFeild );
        GridBagConstraints labCnst = new GridBagConstraints();
        GridBagConstraints txtCnst = new GridBagConstraints();
        labCnst.insets = new Insets ( 0, 0, 5, 10 );
        txtCnst.insets =  new Insets ( 0, 0, 5, 10 );
        labCnst.ipady = txtCnst.ipady = 10;
        txtCnst.fill = labCnst.fill = GridBagConstraints.HORIZONTAL;
        labCnst.gridx = 0;
        txtCnst.gridx = 1;
        labCnst.gridwidth = 1;
        txtCnst.gridwidth = 2;
        labCnst.weightx = 0.3;
        txtCnst.weightx = 0.7;
        txtCnst.gridy = labCnst.gridy = 0;
        add ( usrNameLabel, labCnst );
        add ( usrNameFeild, txtCnst );
        txtCnst.gridy = labCnst.gridy = 1;
        add ( passwordLabel, labCnst );
        add ( passFeild, txtCnst );
        labCnst.gridx = 2;
        labCnst.gridy = 2;
        labCnst.ipady = 13;
        labCnst.insets = new Insets ( 0, 0, 0, 150 );
        JButton submitButt = new CButton ( "Log IN" );
        add ( submitButt, labCnst );
    }
    public void changeCompFont ( JComponent comp ) {
        comp.setForeground ( Color.WHITE );
        comp.setFont ( getFont().deriveFont ( Font.BOLD, 13 ) );
    }
    @Override
    public void paint ( Graphics g ) {
        super.paint ( g );
        Graphics2D g2d = ( Graphics2D ) g.create();
        Rectangle2D txRect = new Rectangle2D.Double ( 0, 0, textureImg.getWidth(), textureImg.getHeight() );
        TexturePaint txPaint = new TexturePaint ( textureImg, txRect );
        g2d.setPaint ( txPaint );
        g2d.setComposite ( AlphaComposite.getInstance ( AlphaComposite.SRC_OVER, 0.3f ) );
        g2d.fillRect ( 0, 0, getWidth(), getHeight() );
        g2d.dispose();
    }
    @Override
    protected void paintComponent ( Graphics g ) {
        super.paintComponent ( g );
        Graphics2D g2d = ( Graphics2D ) g.create();
        if ( gradientImage == null || gradientImage.getHeight() != getHeight() ) {
            gradientImage = createGradientImg();
        }
        g2d.drawImage ( gradientImage, 0, 0, getWidth(), getHeight(), this );
        g2d.dispose();
    }
    public BufferedImage createGradientImg() {
        BufferedImage image = new BufferedImage ( getWidth(), getHeight(), BufferedImage.TYPE_INT_RGB );
        LinearGradientPaint lgrPaint =  new LinearGradientPaint ( 0.0f, 0.0f, getWidth(), getHeight(),
                new float[] { 0.0f, 0.5f, 0.6f, 1.0f },
        new Color[] { new Color ( 0x002AFF ),
                new Color ( 0x0CAAF9 ),
                new Color ( 0x0CAAF9 ),
                new Color ( 0x002AFF )
        } );
        Graphics2D g2d = ( Graphics2D ) image.getGraphics();
        g2d.setPaint ( lgrPaint );
        g2d.fillRect ( 0, 0, getWidth(), getHeight() );
        g2d.dispose();
        return image;
    }
}
public class CustomApp {
    public static void main ( String[] args ) throws IOException {
        System.out.println ( "Please wait, Loading Texture : http://www.brewsterwallcovering.com/data/default/images/catalog/original/289-5757.jpg" );
        MainContainer.textureImg = ImageIO.read ( new URL ( "http://www.brewsterwallcovering.com/data/default/images/catalog/original/289-5757.jpg" ) );
        System.out.println ( "Loading finished. Starting the Demo!" );
        MainContainer.textureImg = MainContainer.textureImg.getSubimage ( 0, 0, 200, 200 );
        SwingUtilities.invokeLater ( new Runnable() {
            @Override
            public void run() {
                JFrame frame = new JFrame ( "Demo: LogIn Dialogue" );
                frame.setSize ( new Dimension ( 500, 300 ) );
                MainContainer container = new MainContainer();
                frame.add ( new MainContainer() );
                frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
                frame.setVisible ( true );
            }
        } );
    }
}
