import java.io.*;
import java.util.Locale;
import java.util.ResourceBundle;
import org.apache.commons.net.ftp.FTPClient;
public class FtpUpDown {
    static Locale locale = new Locale ( "de" );
    static ResourceBundle r = ResourceBundle.getBundle ( "Strings", locale );
    static String host = "IP-Address";
    static String username = "username";
    static int port = 21;
    static String password = "password";
    public static boolean connect() {
        FTPClient ftpClient = new FTPClient();
        try {
            ftpClient.connect ( host, port );
            ftpClient.login ( username, password );
            ftpClient.logout();
            ftpClient.disconnect();
        } catch ( Exception e ) {
            System.err.println ( "Unable to connect" );
            return ( false );
        }
        System.out.println ( "Connection established" );
        return ( true );
    }
    static public String getStatus() {
        if ( connect() ) {
            return ( r.getString ( "successConnectFTP" ) );
        } else {
            return ( r.getString ( "unableToConnectFTP" ) );
        }
    }
    public static String[] list() throws IOException {
        FTPClient ftpClient = new FTPClient();
        String[] filenameList;
        try {
            ftpClient.connect ( host, port );
            ftpClient.login ( username, password );
            filenameList = ftpClient.listNames();
            ftpClient.logout();
        } finally {
            ftpClient.disconnect();
        }
        return filenameList;
    }
    public static boolean download ( String localResultFile,
                                     String remoteSourceFile, boolean showMessages ) throws IOException {
        FTPClient ftpClient = new FTPClient();
        FileOutputStream fos = null;
        boolean resultOk = true;
        try {
            ftpClient.connect ( host, port );
            ftpClient.setFileType ( FTPClient.BINARY_FILE_TYPE );
            if ( showMessages ) {
                System.out.println ( ftpClient.getReplyString() );
            }
            resultOk &= ftpClient.login ( username, password );
            if ( showMessages ) {
                System.out.println ( ftpClient.getReplyString() );
            }
            fos = new FileOutputStream ( localResultFile );
            resultOk &= ftpClient.retrieveFile ( remoteSourceFile, fos );
            if ( showMessages ) {
                System.out.println ( ftpClient.getReplyString() );
            }
            resultOk &= ftpClient.logout();
            if ( showMessages ) {
                System.out.println ( ftpClient.getReplyString() );
            }
        } finally {
            try {
                if ( fos != null ) {
                    fos.close();
                }
            } catch ( IOException e ) {
            }
            ftpClient.disconnect();
        }
        return resultOk;
    }
    public static boolean upload ( String localSourceFile,
                                   String remoteResultFile, boolean showMessages ) throws IOException {
        FTPClient ftpClient = new FTPClient();
        FileInputStream fis = null;
        boolean resultOk = true;
        try {
            ftpClient.connect ( host, port );
            if ( showMessages ) {
                System.out.println ( ftpClient.getReplyString() );
            }
            resultOk &= ftpClient.login ( username, password );
            if ( showMessages ) {
                System.out.println ( ftpClient.getReplyString() );
            }
            fis = new FileInputStream ( localSourceFile );
            ftpClient.setFileType ( FTPClient.BINARY_FILE_TYPE );
            resultOk &= ftpClient.storeFile ( remoteResultFile, fis );
            if ( showMessages ) {
                System.out.println ( ftpClient.getReplyString() );
            }
            resultOk &= ftpClient.logout();
            if ( showMessages ) {
                System.out.println ( ftpClient.getReplyString() );
            }
        } finally {
            try {
                if ( fis != null ) {
                    fis.close();
                }
                ftpClient.disconnect();
            } catch ( IOException e ) {
            }
        }
        return resultOk;
    }
    public static String getHost() {
        return host;
    }
    public static void setHost ( String host ) {
        FtpUpDown.host = host;
    }
    public static String getUsername() {
        return username;
    }
    public static void setUsername ( String username ) {
        FtpUpDown.username = username;
    }
    public static int getPort() {
        return port;
    }
    public static void setPort ( int port ) {
        FtpUpDown.port = port;
    }
    public static String getPassword() {
        return password;
    }
    public static void setPassword ( String password ) {
        FtpUpDown.password = password;
    }
}
