public class TabListenerImpl implements ActionBar.TabListener {
    private List<TabInfo> mTabs = new ArrayList<TabInfo>();
    private Context mContext;
    public TabListenerImpl ( Context context ) {
        mContext = context;
    }
    @Override
    public void onTabReselected ( Tab tab, FragmentTransaction ft ) {
    }
    @Override
    public void onTabSelected ( Tab tab, FragmentTransaction ft ) {
        for ( TabInfo t : mTabs ) {
            if ( tab.getTag() == t.tag ) {
                if ( t.pageFragment == null ) {
                    t.pageFragment = Fragment.instantiate ( mContext,
                                                            t.clazz.getName() );
                    ft.add ( android.R.id.content, t.pageFragment, t.tag );
                } else {
                    ft.attach ( t.pageFragment );
                }
            } else {
                if ( t.pageFragment != null && !t.pageFragment.isDetached() ) {
                    ft.detach ( t.pageFragment );
                }
            }
        }
    }
    @Override
    public void onTabUnselected ( Tab tab, FragmentTransaction ft ) {
    }
    public void addTab ( String tag, Class<? extends Fragment> clazz ) {
        TabInfo ti = new TabInfo();
        ti.clazz = clazz;
        ti.tag = tag;
        mTabs.add ( ti );
    }
    private class TabInfo {
        Class<? extends Fragment> clazz;
        Fragment pageFragment;
        String tag;
    }
}
