public static void main ( String[] args ) {
    final int BUFFERSIZE = 1024 << 8;
    File baseDir = new File ( "C:\\path\\logs\\" );
    String[] fileNames = baseDir.list ( new FilenameFilter() {
        @Override
        public boolean accept ( File dir, String name ) {
            return name.endsWith ( ".log" );
        }
    } );
    Arrays.sort ( fileNames );
    File output = new File ( baseDir.getAbsolutePath() + File.separatorChar + "MERGED.log" );
    try {
        BufferedOutputStream out = new BufferedOutputStream ( new FileOutputStream ( output ), BUFFERSIZE );
        byte[] bytes = new byte[BUFFERSIZE];
        int bytesRead;
        final byte[] newLine = "\n".getBytes();
        for ( String s : fileNames ) {
            String fullName = baseDir.getAbsolutePath() + File.separatorChar + s;
            BufferedInputStream in = new BufferedInputStream ( new FileInputStream ( fullName ), BUFFERSIZE );
            while ( ( bytesRead = in.read ( bytes, 0, bytes.length ) ) != -1 ) {
                out.write ( bytes, 0, bytesRead );
            }
            try {
                in.close();
            } catch ( IOException e ) {}
            out.write ( newLine );
        }
        out.close();
    } catch ( Exception e ) {
        throw new RuntimeException ( e );
    }
}
