import java.io.File;
import java.io.IOException;
import org.apache.commons.io.monitor.FileAlterationListener;
import org.apache.commons.io.monitor.FileAlterationListenerAdaptor;
import org.apache.commons.io.monitor.FileAlterationMonitor;
import org.apache.commons.io.monitor.FileAlterationObserver;
public class Monitor {
    public Monitor() {
    }
    public static final String FOLDER = MYPATH;
    public static void main ( String[] args ) throws Exception {
        System.out.println ( "monitoring started" );
        final long pollingInterval = 5 * 1000;
        File folder = new File ( FOLDER );
        if ( !folder.exists() ) {
            throw new RuntimeException ( "Directory not found: " + FOLDER );
        }
        FileAlterationObserver observer = new FileAlterationObserver ( folder );
        FileAlterationMonitor monitor =
            new FileAlterationMonitor ( pollingInterval );
        FileAlterationListener listener = new FileAlterationListenerAdaptor() {
            @Override
            public void onFileCreate ( File file ) {
                System.out.println ( "File created: " + file.getCanonicalPath() );
            }
            @Override
            public void onFileDelete ( File file ) {
                try {
                    System.out.println ( "File removed: " + file.getCanonicalPath() );
                    System.out.println ( "File still exists in location: " + file.exists() );
                } catch ( IOException e ) {
                    e.printStackTrace ( System.err );
                }
            }
        };
        observer.addListener ( listener );
        monitor.addObserver ( observer );
        monitor.start();
    }
}
