PDDocument doc = null;
try {
    doc = new PDDocument();
    PDPage page = new PDPage();
    doc.addPage ( page );
    PDPageContentStream contentStream = new PDPageContentStream ( doc, page );
    PDFont pdfFont = PDType1Font.HELVETICA;
    float fontSize = 25;
    float leading = 1.5f * fontSize;
    PDRectangle mediabox = page.findMediaBox();
    float margin = 72;
    float width = mediabox.getWidth() - 2 * margin;
    float startX = mediabox.getLowerLeftX() + margin;
    float startY = mediabox.getUpperRightY() - margin;
    String text = "I am trying to create a PDF file with a lot of text contents in the document. I am using PDFBox";
    List<String> lines = new ArrayList<String>();
    int lastSpace = -1;
    while ( text.length() > 0 ) {
        int spaceIndex = text.indexOf ( ' ', lastSpace + 1 );
        if ( spaceIndex < 0 ) {
            lines.add ( text );
            text = "";
        } else {
            String subString = text.substring ( 0, spaceIndex );
            float size = fontSize * pdfFont.getStringWidth ( subString ) / 1000;
            if ( size > width ) {
                if ( lastSpace < 0 ) {
                    lastSpace = spaceIndex;
                }
                subString = text.substring ( 0, lastSpace );
                lines.add ( subString );
                text = text.substring ( lastSpace ).trim();
                lastSpace = -1;
            } else {
                lastSpace = spaceIndex;
            }
        }
    }
    contentStream.beginText();
    contentStream.setFont ( pdfFont, fontSize );
    contentStream.moveTextPositionByAmount ( startX, startY );
    for ( String line : lines ) {
        contentStream.drawString ( line );
        contentStream.moveTextPositionByAmount ( 0, -leading );
    }
    contentStream.endText();
    contentStream.close();
    doc.save ( "break-long-string.pdf" );
} finally {
    if ( doc != null ) {
        doc.close();
    }
}
