private boolean importExisitingProject ( IPath projectPath ) throws CoreException {
    final IProjectDescription description = workspace.loadProjectDescription (
            projectPath.append ( IPath.SEPARATOR + IProjectDescription.DESCRIPTION_FILE_NAME ) );
    final IProject project = workspace.getRoot().getProject ( description.getName() );
    if ( project.exists() ) {
        System.err.println ( SKTBuildPlugin.getFormattedMessage (
                                 "Build.commandLine.projectExists",
                                 project.getName() ) );
        return false;
    }
    IWorkspaceRunnable runnable = new IWorkspaceRunnable() {
        public void run ( IProgressMonitor monitor ) throws CoreException {
            project.create ( description, monitor );
            project.open ( IResource.NONE, monitor );
        }
    };
    workspace.run ( runnable,
                    workspace.getRuleFactory().modifyRule ( workspace.getRoot() ),
                    IResource.NONE, null );
    return true;
}
