package me.example.app;
import java.util.Locale;
import android.app.ActionBar;
import android.app.FragmentTransaction;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentActivity;
import android.support.v4.app.FragmentManager;
import android.support.v4.app.FragmentPagerAdapter;
import android.support.v4.view.ViewPager;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;
public class HomeActivity extends FragmentActivity implements
    ActionBar.TabListener {
    SectionsPagerAdapter mSectionsPagerAdapter;
    ViewPager mViewPager;
    @Override
    protected void onCreate ( Bundle savedInstanceState ) {
        super.onCreate ( savedInstanceState );
        setContentView ( R.layout.activity_home );
        final ActionBar actionBar = getActionBar();
        actionBar.setNavigationMode ( ActionBar.NAVIGATION_MODE_TABS );
        mSectionsPagerAdapter = new SectionsPagerAdapter (
            getSupportFragmentManager() );
        mViewPager = ( ViewPager ) findViewById ( R.id.pager );
        mViewPager.setAdapter ( mSectionsPagerAdapter );
        mViewPager
        .setOnPageChangeListener ( new ViewPager.SimpleOnPageChangeListener() {
            @Override
            public void onPageSelected ( int position ) {
                actionBar.setSelectedNavigationItem ( position );
            }
        } );
        for ( int i = 0; i < mSectionsPagerAdapter.getCount(); i++ ) {
            actionBar.addTab ( actionBar.newTab()
                               .setText ( mSectionsPagerAdapter.getPageTitle ( i ) )
                               .setTabListener ( this ) );
        }
    }
    @Override
    public boolean onCreateOptionsMenu ( Menu menu ) {
        getMenuInflater().inflate ( R.menu.home, menu );
        return true;
    }
    @Override
    public void onTabSelected ( ActionBar.Tab tab,
                                FragmentTransaction fragmentTransaction ) {
        mViewPager.setCurrentItem ( tab.getPosition() );
    }
    @Override
    public void onTabUnselected ( ActionBar.Tab tab,
                                  FragmentTransaction fragmentTransaction ) {
    }
    @Override
    public void onTabReselected ( ActionBar.Tab tab,
                                  FragmentTransaction fragmentTransaction ) {
    }
    public class SectionsPagerAdapter extends FragmentPagerAdapter {
        public SectionsPagerAdapter ( FragmentManager fm ) {
            super ( fm );
        }
        @Override
        public Fragment getItem ( int arg0 ) {
            switch ( arg0 ) {
            case 0:
                Fragment fragmentContacts = new FragmentContacts();
                return fragmentContacts;
            case 1:
                Fragment fragmentMissed = new FragmentMissed();
                return fragmentMissed;
            case 2:
                Fragment fragmentRecent = new FragmentRecent();
                return fragmentRecent;
            case 3:
                Fragment fragmentGroups = new FragmentGroups();
                return fragmentGroups;
            }
            return null;
        }
        @Override
        public int getCount() {
            return 4;
        }
        @Override
        public CharSequence getPageTitle ( int position ) {
            Locale l = Locale.getDefault();
            switch ( position ) {
            case 0:
                return getString ( R.string.title_section1 ).toUpperCase ( l );
            case 1:
                return getString ( R.string.title_section2 ).toUpperCase ( l );
            case 2:
                return getString ( R.string.title_section3 ).toUpperCase ( l );
            case 3:
                return getString ( R.string.title_section4 ).toUpperCase ( l );
            }
            return null;
        }
    }
    public static class FragmentContacts extends Fragment {
        public static final String ARG_SECTION_NUMBER = "section_number";
        public FragmentContacts() {
        }
        @Override
        public View onCreateView ( LayoutInflater inflater, ViewGroup container,
                                   Bundle savedInstanceState ) {
            View rootView = inflater.inflate ( R.layout.activity_contacts,
                                               container, false );
            return rootView;
        }
    }
    public static class FragmentMissed extends Fragment {
        public static final String ARG_SECTION_NUMBER = "section_number";
        public FragmentMissed() {
        }
        @Override
        public View onCreateView ( LayoutInflater inflater, ViewGroup container,
                                   Bundle savedInstanceState ) {
            View rootView = inflater.inflate ( R.layout.activity_missed,
                                               container, false );
            return rootView;
        }
    }
    public static class FragmentRecent extends Fragment {
        public static final String ARG_SECTION_NUMBER = "section_number";
        public FragmentRecent() {
        }
        @Override
        public View onCreateView ( LayoutInflater inflater, ViewGroup container,
                                   Bundle savedInstanceState ) {
            View rootView = inflater.inflate ( R.layout.activity_recent,
                                               container, false );
            return rootView;
        }
    }
    public static class FragmentGroups extends Fragment {
        public static final String ARG_SECTION_NUMBER = "section_number";
        public FragmentGroups() {
        }
        @Override
        public View onCreateView ( LayoutInflater inflater, ViewGroup container,
                                   Bundle savedInstanceState ) {
            View rootView = inflater.inflate ( R.layout.activity_group,
                                               container, false );
            return rootView;
        }
    }
}
