package com.example.main;
import java.io.IOException;
import java.net.URL;
import java.util.List;
import org.codehaus.jackson.JsonParseException;
import org.codehaus.jackson.map.DeserializationConfig.Feature;
import org.codehaus.jackson.map.JsonMappingException;
import org.codehaus.jackson.map.ObjectMapper;
import org.codehaus.jackson.type.TypeReference;
import com.example.dto.Computer;
public class JSONParse {
    public static void main ( String args[] ) throws JsonParseException, JsonMappingException, IOException {
        URL url = new URL ( "http://api.engin.umich.edu/hostinfo/v1/computers.json?building=PIERPONT&room=B505" );
        ObjectMapper mapper = new ObjectMapper();
        mapper.configure ( Feature.ACCEPT_SINGLE_VALUE_AS_ARRAY, true );
        mapper.configure ( Feature.FAIL_ON_UNKNOWN_PROPERTIES, false );
        List<Computer> computers = mapper.readValue ( url, new TypeReference<List<Computer>>() {} );
        for ( Computer computer : computers ) {
            System.out.println ( computer.toString() );
        }
    }
}
