private BufferedImage toCompatibleImage ( BufferedImage image ) {
    GraphicsConfiguration gfx_config = GraphicsEnvironment.
                                       getLocalGraphicsEnvironment().getDefaultScreenDevice().
                                       getDefaultConfiguration();
    if ( image.getColorModel().equals ( gfx_config.getColorModel() ) ) {
        return image;
    }
    BufferedImage new_image = gfx_config.createCompatibleImage (
                                  image.getWidth(), image.getHeight(), image.getTransparency() );
    Graphics2D g2d = ( Graphics2D ) new_image.getGraphics();
    g2d.drawImage ( image, 0, 0, null );
    g2d.dispose();
    return new_image;
}
