public class EditTextListActivity extends ListActivity {
    private static final String SAVED_STATE_KEY = "saved_state_key";
    @Override
    public void onCreate ( Bundle savedInstanceState ) {
        super.onCreate ( savedInstanceState );
        EditTextAdapter editTextAdapter = new EditTextAdapter ( this, R.layout.main );
        setListAdapter ( editTextAdapter );
        if ( savedInstanceState != null ) {
            List<String> savedStrings = savedInstanceState.getStringArrayList ( SAVED_STATE_KEY );
            for ( String savedString : savedStrings ) {
                editTextAdapter.add ( new ListItem ( savedString ) );
            }
        } else {
            for ( int i = 0; i < 30; i++ ) {
                editTextAdapter.add ( new ListItem ( "" ) );
            }
        }
    }
    @Override
    protected void onSaveInstanceState ( Bundle outState ) {
        super.onSaveInstanceState ( outState );
        ArrayList<String> arrayList = new ArrayList<String>();
        EditTextAdapter editTextAdapter = ( EditTextAdapter ) getListAdapter();
        for ( int i = 0; i < editTextAdapter.getCount(); i++ ) {
            arrayList.add ( editTextAdapter.getItem ( i ).string1 );
        }
        outState.putStringArrayList ( SAVED_STATE_KEY, arrayList );
    }
    static class ListItem {
        public String string1;
        ListItem ( String string1 ) {
            this.string1 = string1;
        }
    }
    static class ViewHolder {
        public TextView textView;
        public EditText editText;
        public TextWatcher textWatcher;
    }
    class EditTextAdapter extends ArrayAdapter<ListItem> {
        EditTextAdapter ( Context context, int resource ) {
            super ( context, android.R.layout.simple_list_item_single_choice );
        }
        @Override
        public View getView ( int position, View convertView, ViewGroup parent ) {
            View rowView = convertView;
            if ( rowView == null ) {
                rowView = getLayoutInflater().inflate ( R.layout.main, null );
                ViewHolder viewHolder = new ViewHolder();
                viewHolder.textView = ( TextView ) rowView.findViewById ( R.id.textview );
                viewHolder.editText = ( EditText ) rowView.findViewById ( R.id.edittext1 );
                rowView.setTag ( viewHolder );
            }
            ViewHolder holder = ( ViewHolder ) rowView.getTag();
            if ( holder.textWatcher != null ) {
                holder.editText.removeTextChangedListener ( holder.textWatcher );
            }
            final ListItem listItem = getItem ( position );
            holder.textWatcher = new TextWatcher() {
                @Override
                public void beforeTextChanged ( CharSequence s, int start, int count, int after ) {
                }
                @Override
                public void onTextChanged ( CharSequence s, int start, int before, int count ) {
                    listItem.string1 = s.toString();
                }
                @Override
                public void afterTextChanged ( Editable s ) {
                }
            };
            holder.editText.addTextChangedListener ( holder.textWatcher );
            holder.editText.setText ( listItem.string1 );
            holder.textView.setText ( Integer.toString ( position ) );
            return rowView;
        }
    }
}
