import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Date;
import org.apache.commons.io.FileUtils;
import org.apache.commons.io.IOUtils;
import org.apache.commons.lang3.StringEscapeUtils;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;
public class Test {
    public static void main ( String[] args ) throws IOException, InterruptedException {
        InputStream stream = Test.class.getResourceAsStream ( "/test.xhtml" );
        File xhtmlfile = File.createTempFile ( "xhtmlFile", ".tmp" );
        FileOutputStream fileOutputStream = new FileOutputStream ( xhtmlfile );
        IOUtils.copy ( stream, fileOutputStream );
        xhtmlfile.deleteOnExit();
        String htmlString = FileUtils.readFileToString ( xhtmlfile );
        Document doc = Jsoup.parse ( htmlString );
        Elements allElements = doc.getAllElements();
        for ( Element el : allElements ) {
            if ( el.id().equals ( "header1" ) ) {
                String employeeName = "dummyEmployee";
                el.text ( "<span class=\"b\">Instruction Type:</span> Example<br/><span class=\"b\">Allocated To:</span> "
                          + employeeName.toString() + "<br/><span class=\"b\">Scheduled Date:</span> " + new Date() );
                break;
            }
        }
        String html = doc.html();
        String escapeHtml4 = StringEscapeUtils.unescapeHtml4 ( html );
        System.out.println ( escapeHtml4 );
    }
}
