public class LoginActivity extends FragmentActivity implements LoaderManager.LoaderCallbacks<LoginResponse> {
    private String username, password;
    @Override
    protected void onCreate ( Bundle savedInstanceState ) {
        super.onCreate ( savedInstanceState );
        setContentView ( R.layout.login );
        Loader loader = getSupportLoaderManager().getLoader ( 0 );
        if ( loader != null ) {
            getSupportLoaderManager().initLoader ( 0, null, this );
        }
    }
    public void loginSubmit ( View button ) {
        Bundle data = new Bundle();
        data.putString ( "username", getUsername() );
        data.putString ( "password", getPassword() );
        getSupportLoaderManager().restartLoader ( 0, data, this );
    }
    @Override
    public Loader<LoginResponse> onCreateLoader ( int i, Bundle bundle ) {
        ApiClient client = new ApiClient();
        LoginApi loginApi = new LoginApi ( bundle.getString ( "username" ), bundle.getString ( "password" ) );
        return new LoginAsyncTaskLoader ( this, apiClient, loginApi );
    }
    @Override
    public void onLoadFinished ( Loader<LoginResponse> loginLoader,
                                 LoginResponse loginResponse ) {
    }
    @Override
    public void onLoaderReset ( Loader<LoginResponse> responseAndJsonHolderLoader ) {
    }
}
