OCL ocl = OCL.newInstance ( new PivotEnvironmentFactory() );
OCLHelper helper = ocl.createOCLHelper ( EXTLibraryPackage.Literals.LIBRARY );
ExpressionInOCL invariant = helper.createInvariant (
                                "books->forAll(b1, b2 | b1 <> b2 implies b1.title <> b2.title)" );
ExpressionInOCL query = helper.createQuery (
                            "books->collect(b : Book | b.category)->asSet()" );
Query queryEval = ocl.createQuery ( query );
Query constraintEval = ocl.createQuery ( invariant );
List<Library> libraries = getLibraries();
for ( Library next : libraries ) {
    if ( constraintEval.check ( next ) ) {
        @SuppressWarnings ( "unchecked" )
        Set<BookCategory> categories = ( Set<BookCategory> ) queryEval.evaluate ( next );
        System.out.printf ( "%s: %s%n", next.getName(), categories );
    }
}
