import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;
public class Sorter {
    static List<Data> read() throws FileNotFoundException, IOException {
        BufferedReader reader = new BufferedReader ( new FileReader ( "data.txt" ) );
        List<Data> list = new ArrayList<>();
        String line;
        Data data = null;
        while ( ( line = reader.readLine() ) != null ) {
            if ( line.matches ( "\\s*" ) ) {
                continue;
            }
            if ( Character.isSpaceChar ( line.charAt ( 0 ) ) ) {
                if ( data == null ) {
                    System.err.println ( "Missing serial for course " + line );
                } else {
                    data.courses.add ( line );
                }
            } else {
                if ( data != null ) {
                    list.add ( data );
                }
                data = new Data ( line );
            }
        }
        if ( data != null ) {
            list.add ( data );
        }
        return list;
    }
    public static void main ( String[] args ) {
        try {
            List<Data> list = read();
            Collections.sort ( list, new Comparator<Data>() {
                @Override
                public int compare ( Data a, Data b ) {
                    return a.serial.compareTo ( b.serial );
                }
            } );
            for ( Data data : list ) {
                data.print();
            }
        } catch ( Exception ex ) {
            System.err.println ( "Read failed." );
        }
    }
}
class Data {
    String serial;
    List<String> courses;
    Data ( String serial ) {
        this.serial = serial;
        courses = new ArrayList<>();
    }
    void print() {
        System.out.println ( serial );
        for ( String course : courses ) {
            System.out.println ( course );
        }
    }
}
