import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintWriter;
import part1.chapter01.HelloWorld;
import com.itextpdf.text.Document;
import com.itextpdf.text.DocumentException;
import com.itextpdf.text.io.RandomAccessSourceFactory;
import com.itextpdf.text.pdf.BaseFont;
import com.itextpdf.text.pdf.PRTokeniser;
import com.itextpdf.text.pdf.PdfContentByte;
import com.itextpdf.text.pdf.PdfDictionary;
import com.itextpdf.text.pdf.PdfName;
import com.itextpdf.text.pdf.PdfReader;
import com.itextpdf.text.pdf.PdfTemplate;
import com.itextpdf.text.pdf.PdfWriter;
import com.itextpdf.text.pdf.RandomAccessFileOrArray;
import com.itextpdf.text.pdf.parser.ContentByteUtils;
import com.itextpdf.text.pdf.parser.PdfContentStreamProcessor;
import com.itextpdf.text.pdf.parser.RenderListener;
public class ParsingHelloWorld {
    public static final String PDF = "results/part4/chapter15/hello_reverse.pdf";
    public static final String TEXT1 = "results/part4/chapter15/result1.txt";
    public static final String TEXT2 = "results/part4/chapter15/result2.txt";
    public static final String TEXT3 = "results/part4/chapter15/result3.txt";
    public void createPdf ( String filename ) throws DocumentException, IOException {
        Document document = new Document();
        PdfWriter writer
            = PdfWriter.getInstance ( document, new FileOutputStream ( filename ) );
        document.open();
        PdfContentByte cb = writer.getDirectContent();
        BaseFont bf = BaseFont.createFont();
        cb.beginText();
        cb.setFontAndSize ( bf, 12 );
        cb.moveText ( 88.66f, 367 );
        cb.showText ( "ld" );
        cb.moveText ( -22f, 0 );
        cb.showText ( "Wor" );
        cb.moveText ( -15.33f, 0 );
        cb.showText ( "llo" );
        cb.moveText ( -15.33f, 0 );
        cb.showText ( "He" );
        cb.endText();
        PdfTemplate tmp = cb.createTemplate ( 250, 25 );
        tmp.beginText();
        tmp.setFontAndSize ( bf, 12 );
        tmp.moveText ( 0, 7 );
        tmp.showText ( "Hello People" );
        tmp.endText();
        cb.addTemplate ( tmp, 36, 343 );
        document.close();
    }
    public void parsePdf ( String src, String dest ) throws IOException {
        PdfReader reader = new PdfReader ( src );
        byte[] streamBytes = reader.getPageContent ( 1 );
        PRTokeniser tokenizer = new PRTokeniser ( new RandomAccessFileOrArray ( new RandomAccessSourceFactory().createSource ( streamBytes ) ) );
        PrintWriter out = new PrintWriter ( new FileOutputStream ( dest ) );
        while ( tokenizer.nextToken() ) {
            if ( tokenizer.getTokenType() == PRTokeniser.TokenType.STRING ) {
                out.println ( tokenizer.getStringValue() );
            }
        }
        out.flush();
        out.close();
        reader.close();
    }
    public void extractText ( String src, String dest ) throws IOException {
        PrintWriter out = new PrintWriter ( new FileOutputStream ( dest ) );
        PdfReader reader = new PdfReader ( src );
        RenderListener listener = new MyTextRenderListener ( out );
        PdfContentStreamProcessor processor = new PdfContentStreamProcessor ( listener );
        PdfDictionary pageDic = reader.getPageN ( 1 );
        PdfDictionary resourcesDic = pageDic.getAsDict ( PdfName.RESOURCES );
        processor.processContent ( ContentByteUtils.getContentBytesForPage ( reader, 1 ), resourcesDic );
        out.flush();
        out.close();
        reader.close();
    }
    public static void main ( String[] args ) throws DocumentException, IOException {
        ParsingHelloWorld example = new ParsingHelloWorld();
        HelloWorld.main ( args );
        example.createPdf ( PDF );
        example.parsePdf ( HelloWorld.RESULT, TEXT1 );
        example.parsePdf ( PDF, TEXT2 );
        example.extractText ( PDF, TEXT3 );
    }
}
