import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.Map;
public class JsonObject<V> extends LinkedHashMap<String, V> {
    public JsonObject() {
    }
    public JsonObject ( String source ) throws IllegalArgumentException {
        this ( JsonParser.getJsonObject ( source ) );
    }
    public JsonObject ( Map<? extends String, ? extends V> map ) {
        putAll ( map );
    }
    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder ( "{" );
        Iterator<Map.Entry<String, V>> iter = entrySet().iterator();
        while ( iter.hasNext() ) {
            Map.Entry<String, V> entry = iter.next();
            sb.append ( JsonParser.toJson ( entry.getKey() ) );
            sb.append ( ':' );
            V value = entry.getValue();
            sb.append ( JsonParser.toJson ( value ) );
            if ( iter.hasNext() ) {
                sb.append ( ',' );
            }
        }
        sb.append ( "}" );
        return sb.toString();
    }
}
