import java.text.ParseException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;
public abstract class DatabaseObject<T extends DatabaseObject>
    extends JsonObject<Object> implements Cloneable {
    public final static String ROW_ID = "rowId";
    public DatabaseObject() {
    }
    @Override
    public Object get ( Object key ) {
        return doGet ( String.valueOf ( key ), true );
    }
    @Override
    public Object put ( String key, Object value ) {
        return doPut ( key, value, true );
    }
    public int getRowId() {
        return getProperty ( ROW_ID, -1 );
    }
    public void setRowId ( int rowId ) {
        setProperty ( ROW_ID, rowId );
    }
    public synchronized void save ( Database database ) throws SaveException {
        StringBuilder sql = new StringBuilder();
        sql.append ( "UPDATE " ).append ( getTableName() ).append ( " SET " );
        Iterator<String, Object> iter = entrySet().iterator();
        while ( iter.hasNext() ) {
            Map.Entry<String, Object> entry = iter.next();
            String property = entry.getKey();
            Object value = entry.getValue();
            if ( value instanceof DatabaseObject ) {
                ( ( DatabaseObject ) value ).save();
            } else if ( value instanceof Collection ) {
                for ( Object v : ( Collection ) value ) {
                    ( ( DatabaseObject ) value ).save();
                }
            } else {
                sql.append ( property );
                sql.append ( "='" ).append ( value ).append ( "'" );
            }
            if ( iter.hasNext() ) {
                sql.append ( ", " );
            }
        }
        sql.append ( "WHERE " ).append ( getIdColumn() ).append ( "=" ).append ( getRowId() );
    }
    public abstract String getTableName();
}
