protected BufferedImage transformImage ( BufferedImage image ) {
    int scaledWidth = ( int ) ( scale * image.getWidth() );
    int scaledHeight = ( int ) ( scale * image.getHeight() );
    AffineTransform transform;
    if ( rotation % 180 == 0 ) {
        transform = AffineTransform.getRotateInstance ( Math.toRadians ( rotation ), scaledWidth / 2, scaledHeight / 2 );
        transform.scale ( scale, scale );
    } else {
        transform = AffineTransform.getTranslateInstance ( ( scaledHeight - scaledWidth ) / 2, ( scaledWidth - scaledHeight ) / 2 );
        transform.rotate ( Math.toRadians ( rotation ), scaledWidth / 2, scaledHeight / 2 );
        transform.scale ( scale, scale );
    }
    AffineTransformOp operation = new AffineTransformOp ( transform, AffineTransformOp.TYPE_BICUBIC );
    BufferedImage transformedImage = operation.createCompatibleDestImage ( image, image.getColorModel() );
    return operation.filter ( image, transformedImage );
}
