public static int getExifOrientation ( String filepath ) {
    int degree = 0;
    ExifInterface exif = null;
    try {
        exif = new ExifInterface ( filepath );
    } catch ( IOException ex ) {
        ex.printStackTrace();
    }
    if ( exif != null ) {
        int orientation = exif.getAttributeInt ( ExifInterface.TAG_ORIENTATION, -1 );
        if ( orientation != -1 ) {
            switch ( orientation ) {
            case ExifInterface.ORIENTATION_ROTATE_90:
                degree = 90;
                break;
            case ExifInterface.ORIENTATION_ROTATE_180:
                degree = 180;
                break;
            case ExifInterface.ORIENTATION_ROTATE_270:
                degree = 270;
                break;
            }
        }
    }
    return degree;
}
