@Entity
@Table ( name = "people" )
public class Person {
    @Id
    @GeneratedValue ( strategy = GenerationType.AUTO )
    private Long Id;
    @ManyToMany ( cascade = CascadeType.ALL )
    @JoinTable ( name = "friends", joinColumns = @JoinColumn ( name = "person_id" ), inverseJoinColumns = @JoinColumn ( name = "friend_id" ) )
    private List<Person> friends;
    @ManyToMany ( cascade = CascadeType.ALL )
    @JoinTable ( name = "enemies", joinColumns = @JoinColumn ( name = "person_id" ), inverseJoinColumns = @JoinColumn ( name = "enemy_id" ) )
    private List<Person> enemies;
    public Person() {
        friends = new ArrayList<>();
        enemies = new ArrayList<>();
    }
    public List<Person> getFriends() {
        return Collections.unmodifiableList ( friends );
    }
    public List<Person> getEnemies() {
        return Collections.unmodifiableList ( enemies );
    }
    public void addFriend ( Person person ) {
        friends.add ( person );
        person.friends.add ( this );
    }
    public void addEnemy ( Person person ) {
        enemies.add ( person );
        person.enemies.add ( this );
    }
}
