private void tryAutoFocus() {
    if ( MyDebug.LOG ) {
        Log.d ( TAG, "tryAutoFocus" );
    }
    if ( camera == null ) {
        if ( MyDebug.LOG ) {
            Log.d ( TAG, "no camera" );
        }
    } else if ( !this.has_surface ) {
        if ( MyDebug.LOG ) {
            Log.d ( TAG, "preview surface not yet available" );
        }
    } else if ( !this.is_preview_started ) {
        if ( MyDebug.LOG ) {
            Log.d ( TAG, "preview not yet started" );
        }
    } else if ( is_taking_photo ) {
        if ( MyDebug.LOG ) {
            Log.d ( TAG, "currently taking a photo" );
        }
    } else {
        Camera.Parameters parameters = camera.getParameters();
        String focus_mode = parameters.getFocusMode();
        if ( has_focus_area || focus_mode.equals ( Camera.Parameters.FOCUS_MODE_AUTO ) || focus_mode.equals ( Camera.Parameters.FOCUS_MODE_MACRO ) ) {
            if ( MyDebug.LOG ) {
                Log.d ( TAG, "try to start autofocus" );
            }
            Camera.AutoFocusCallback autoFocusCallback = new Camera.AutoFocusCallback() {
                @Override
                public void onAutoFocus ( boolean success, Camera camera ) {
                    if ( MyDebug.LOG ) {
                        Log.d ( TAG, "autofocus complete: " + success );
                    }
                    focus_success = success ? FOCUS_SUCCESS : FOCUS_FAILED;
                    focus_complete_time = System.currentTimeMillis();
                    if ( _automationStarted ) {
                        takeSnapPhoto();
                    }
                }
            };
            this.focus_success = FOCUS_WAITING;
            this.focus_complete_time = -1;
            camera.autoFocus ( autoFocusCallback );
        }
    }
}
public void surfaceCreated ( SurfaceHolder holder ) {
    if ( MyDebug.LOG ) {
        Log.d ( TAG, "surfaceCreated()" );
    }
    this.has_surface = true;
    this.openCamera ( false );
    this.setWillNotDraw ( false );
}
public void surfaceDestroyed ( SurfaceHolder holder ) {
    if ( MyDebug.LOG ) {
        Log.d ( TAG, "surfaceDestroyed()" );
    }
    this.has_surface = false;
    this.closeCamera();
}
public void takeSnapPhoto() {
    camera.setOneShotPreviewCallback ( new Camera.PreviewCallback() {
        @Override
        public void onPreviewFrame ( byte[] data, Camera camera ) {
            Camera.Parameters parameters = camera.getParameters();
            int format = parameters.getPreviewFormat();
            if ( format == ImageFormat.NV21 || format == ImageFormat.YUY2 || format == ImageFormat.NV16 ) {
                int w = parameters.getPreviewSize().width;
                int h = parameters.getPreviewSize().height;
                YuvImage yuv_image = new YuvImage ( data, format, w, h, null );
                Rect rect = new Rect ( 0, 0, w, h );
                ByteArrayOutputStream output_stream = new ByteArrayOutputStream();
                yuv_image.compressToJpeg ( rect, 100, output_stream );
                byte[] byt = output_stream.toByteArray();
                FileOutputStream outStream = null;
                try {
                    File file = createFileInSDCard ( FOLDER_PATH, "Image_" + System.currentTimeMillis() + ".jpg" );
                    outStream = new FileOutputStream ( file );
                    outStream.write ( byt );
                    outStream.close();
                } catch ( FileNotFoundException e ) {
                    e.printStackTrace();
                } catch ( IOException e ) {
                    e.printStackTrace();
                } finally {
                }
            }
        }
    } );
}
