package linearalgebra;
import Jama.LUDecomposition;
import Jama.Matrix;
public class JamaDemo {
    public static void main ( String[] args ) {
        double [][] values = {{1, 1, 2}, {2, 4, -3}, {3, 6, -5}};
        double [] rhs = { 9, 1, 0 };
        double [] answer = { 1, 2, 3 };
        Matrix a = new Matrix ( values );
        a.print ( 10, 2 );
        LUDecomposition luDecomposition = new LUDecomposition ( a );
        luDecomposition.getL().print ( 10, 2 );
        luDecomposition.getU().print ( 10, 2 );
        Matrix b = new Matrix ( rhs, rhs.length );
        Matrix x = luDecomposition.solve ( b );
        x.print ( 10, 2 );
        Matrix residual = a.times ( x ).minus ( b );
        double rnorm = residual.normInf();
        System.out.println ( "residual: " + rnorm );
    }
}
