public static final int MEDIA_TYPE_IMAGE = 1;
public static final int MEDIA_TYPE_VIDEO = 2;
private static Uri getOutputMediaFileUri ( int type ) {
    return Uri.fromFile ( getOutputMediaFile ( type ) );
}
private static File getOutputMediaFile ( int type ) {
    File mediaStorageDir = new File ( Environment.getExternalStoragePublicDirectory (
                                          Environment.DIRECTORY_PICTURES ), "MyCameraApp" );
    if ( ! mediaStorageDir.exists() ) {
        if ( ! mediaStorageDir.mkdirs() ) {
            Log.d ( "MyCameraApp", "failed to create directory" );
            return null;
        }
    }
    String timeStamp = new SimpleDateFormat ( "yyyyMMdd_HHmmss" ).format ( new Date() );
    File mediaFile;
    if ( type == MEDIA_TYPE_IMAGE ) {
        mediaFile = new File ( mediaStorageDir.getPath() + File.separator +
                               "IMG_" + timeStamp + ".jpg" );
    } else if ( type == MEDIA_TYPE_VIDEO ) {
        mediaFile = new File ( mediaStorageDir.getPath() + File.separator +
                               "VID_" + timeStamp + ".mp4" );
    } else {
        return null;
    }
    return mediaFile;
}
