public void fireEvent ( String name, Object... args ) {
    Method method = null;
    for ( Method m : EventListener.class.getMethods() ) {
        if ( m.getName().equals ( name ) ) {
            method = m;
            break;
        }
    }
    if ( method == null ) {
        throw new IllegalArgumentException ( "Unknown event method: " + name );
    }
    for ( EventListener l : listeners ) {
        try {
            method.invoke ( l, args );
        } catch ( IllegalAccessException | InvocationTargetException e ) {
            throw new IllegalArgumentException ( e );
        }
    }
}
