public List<Garaz> getAllGaraz() throws SQLException {
    List<Garaz> garazList = new ArrayList<Garaz>();
    try (
            Connection con = getDBConnection();
            Statement stmt = con.createStatement();
            ResultSet rs = stmt.executeQuery (
                               "SELECT Garaz.G_ID, /* other garaz columns */ " +
                               "Auta.A_Id /*other auta columns */\n" +
                               "FROM Garaz\n" +
                               "LEFT JOIN Auta\n" +
                               "ON Garaz.G_Id=Auta.G_Id\n" +
                               "ORDER BY Garaz.G_Id" );
        ) {
        Garaz currentGaraz = null;
        while ( rs.next() ) {
            int garazId = rs.getInt ( "G_ID" );
            if ( currentGaraz == null || currentGaraz.getId() != garazId ) {
                currentGaraz = new Garaz ( g_id );
                garazList.add ( currentGaraz );
            }
            int a_id = rs.getInt ( "A_Id" );
            if ( !rs.wasNull() ) {
                Auto auta = new Auta ( a_id );
                currentGaraz.addAuta ( auta );
            }
        }
        return garazList;
    }
}
public class Garaz {
    private final List<Auta> autaList = new ArrayList<Auta>();
    private final int id;
    public Garaz ( int g_id ) {
        id = g_id;
    }
    public int getId() {
        return id;
    }
    public void addAuta ( Auta auta ) {
        autaList.add ( auta );
    }
    public List<Auta> getAutaList() {
        return new ArrayList<Auta> ( autaList );
    }
}
