std::unique_ptr<EngravityMessage>
VCDUManager::getConfigValue (
    const CDU_ID & rCduID,
    const std::unique_ptr<EngravityMessage> & rVarNameMessage ) {
    EngravityConfigMessage * pVariableName =
        static_cast<EngravityConfigMessage * > ( rVarNameMessage.get() );
    gpLogManager->add ( FAC_PROCESS, PRI_NOTICE,
                        "CDU_%d: getConfigValue\n", rCduID );
    CDUVariable variable = pVariableName->getCDUVariable();
    std::unique_ptr<EngravityMessage> variableValue;
    switch ( variable ) {
    case CDUVariable::baud:
        variableValue = std::unique_ptr<EngravityMessage> (
                            new EngravityConfigMessage (
                                EngravityMessageType::SetV, variable, "38400" ) );
        break;
    case CDUVariable::firmware:
        variableValue = std::unique_ptr<EngravityMessage> (
                            new EngravityConfigMessage (
                                EngravityMessageType::SetV, variable, "1.04" ) );
        break;
    case CDUVariable::type:
        variableValue = std::unique_ptr<EngravityMessage> (
                            new EngravityConfigMessage (
                                EngravityMessageType::SetV, variable, "737-NG" ) );
        break;
    case CDUVariable::serial:
        variableValue = std::unique_ptr<EngravityMessage> (
                            new EngravityConfigMessage (
                                EngravityMessageType::SetV, variable, "0074" ) );
        break;
    default:
        break;
    }
    return variableValue;
}
