import java.awt.image.BufferedImage;
import java.awt.Color;
import java.util.ArrayList;
import java.lang.Math;
import java.awt.Point;
public class EdgeDetection {
    public App ap;
    public int[] horizontalCuts = {120, 220, 320, 420};
    public int[] verticalCuts = {300, 350, 375, 400};
    public void printEdgesTest ( BufferedImage image, boolean reversex, boolean reversey, int rangex, int rangey ) {
        int[] mx = horizontalCuts;
        int[] my = verticalCuts;
        int[] xEdges = getEdges ( image, mx, reversex, true );
        int edgex = getEdge ( xEdges, rangex );
        for ( int x = 0; x < xEdges.length; x++ ) {
            System.out.println ( "EDGE = " + xEdges[x] );
        }
        System.out.println ( "THE EDGE = " + edgex );
        int[] yEdges = getEdges ( image, my, reversey, false );
        int edgey = getEdge ( yEdges, rangey );
        for ( int y = 0; y < yEdges.length; y++ ) {
            System.out.println ( "EDGE = " + yEdges[y] );
        }
        System.out.println ( "THE EDGE = " + edgey );
    }
    public int getEdge ( int[] edges, int range ) {
        ArrayList<Integer> result = new ArrayList<Integer>();
        boolean[] passes = new boolean[edges.length];
        int[][] differences = new int[edges.length][edges.length - 1];
        for ( int n = 0; n < edges.length; n++ ) {
            for ( int m = 0; m < edges.length; m++ ) {
                if ( m < n ) {
                    differences[n][m] = edges[n] - edges[m];
                } else if ( m > n ) {
                    differences[n][m - 1] = edges[n] - edges[m];
                }
            }
        }
        for ( int n = 0; n < edges.length; n++ ) {
            passes[n] = false;
            for ( int m = 0; m < edges.length - 1; m++ ) {
                if ( Math.abs ( differences[n][m] ) < range ) {
                    passes[n] = true;
                    System.out.println ( "EDGECHECK = TRUE" + n );
                    break;
                }
            }
        }
        for ( int i = 0; i < edges.length; i++ ) {
            if ( passes[i] ) {
                result.add ( edges[i] );
            }
        }
        int divisor = result.size();
        int addend = 0;
        double mean = 0;
        for ( Integer i : result ) {
            addend += i;
        }
        mean = ( double ) addend / ( double ) divisor;
        if ( mean - ( int ) mean >= .5 ) {
            System.out.println ( "MEAN " + mean );
            return ( int ) mean + 1;
        } else {
            System.out.println ( "MEAN " + mean );
            return ( int ) mean;
        }
    }
    public int[] getEdges ( BufferedImage image, int[] arr, boolean reverse, boolean verticalEdge ) {
        int red = 255;
        int green = 255;
        int blue = 255;
        int[] result = new int[arr.length];
        for ( int n = 0; n < arr.length; n++ ) {
            for ( int m = reverse ? ( verticalEdge ? image.getWidth() : image.getHeight() ) - 1 : 0; reverse ? m >= 0 : m < ( verticalEdge ? image.getWidth() : image.getHeight() ); ) {
                Color c = new Color ( image.getRGB ( verticalEdge ? m : arr[n], verticalEdge ? arr[n] : m ) );
                red = c.getRed();
                green = c.getGreen();
                blue = c.getBlue();
                if ( red < 239 && green < 239 && blue < 239 ) {
                    result[n] = m;
                    break;
                }
                if ( reverse ) {
                    m--;
                } else {
                    m++;
                }
            }
        }
        return result;
    }
}
