package test;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.powermock.api.mockito.PowerMockito;
import org.powermock.core.classloader.annotations.PrepareForTest;
import org.powermock.modules.junit4.PowerMockRunner;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import static org.junit.Assert.assertEquals;
import static org.powermock.api.mockito.PowerMockito.doReturn;
import static org.powermock.api.mockito.PowerMockito.mock;
@RunWith ( PowerMockRunner.class )
@PrepareForTest ( { SUT.class } )
public class SUTTest {
    @Test
    public void doSomethingReturnsValueFromBufferedReader() throws Exception {
        SUT sut = new SUT();
        InputStreamReader inputStreamReaderMock = mock ( InputStreamReader.class );
        BufferedReader bufferedReaderMock = mock ( BufferedReader.class );
        PowerMockito.whenNew ( InputStreamReader.class ).
        withAnyArguments().thenReturn ( inputStreamReaderMock );
        PowerMockito.whenNew ( BufferedReader.class ).
        withArguments ( inputStreamReaderMock ).
        thenReturn ( bufferedReaderMock );
        final String bufferedReaderReturnValue = "myValue";
        doReturn ( bufferedReaderReturnValue ).when ( bufferedReaderMock ).readLine();
        String result = sut.doSomething();
        assertEquals ( bufferedReaderReturnValue, result );
    }
}
