public class Root {
    public interface RootCallback {
        public void onDeviceRooted();
        public void onDeviceUnrooted();
    }
    private static String LOG_TAG = Root.class.getName();
    public void isDeviceRooted ( RootCallback callback ) {
        new RootCheckerTask ( callback ).execute();
    }
    public boolean checkRootMethod1() {
        String buildTags = android.os.Build.TAGS;
        return buildTags != null && buildTags.contains ( "test-keys" );
    }
    public boolean checkRootMethod2() {
        try {
            File file = new File ( "/system/app/Superuser.apk" );
            return file.exists();
        } catch ( Exception e ) return false;
    }
    public boolean checkRootMethod3() {
        return new ExecShell().executeCommand ( SHELL_CMD.check_su_binary ) != null;
    }
    private class RootCheckerTask extends AsyncTask<Void, Void, Boolean> {
        private final RootCallback mCallback;
        public RootCheckerTask ( RootCallback callback ) {
            mCallback = callback;
        }
        public Boolean doInBackground() {
            return checkRootMethod1() || checkRootMethod2() || checkRootMethod3();
        }
        public void onPostExecute ( Boolean hasRoot ) {
            if ( hasRoot ) {
                mCallback.onDeviceRooted();
            } else {
                mCallback.onDeviceUnrooted();
            }
        }
    }
}
