public class GiffTest {
    public static void main ( String[] args ) throws IOException {
        ImageReader reader = ImageIO.getImageReadersBySuffix ( "gif" ).next();
        reader.setInput ( ImageIO.createImageInputStream ( new FileInputStream ( "H:\\toonGif.gif" ) ) );
        int i = reader.getMinIndex();
        int numImages = reader.getNumImages ( true );
        IIOMetadata imageMetaData =  reader.getImageMetadata ( 0 );
        String metaFormatName = imageMetaData.getNativeMetadataFormatName();
        IIOMetadataNode root = ( IIOMetadataNode ) imageMetaData.getAsTree ( metaFormatName );
        IIOMetadataNode graphicsControlExtensionNode = getNode ( root, "GraphicControlExtension" );
        System.out.println ( graphicsControlExtensionNode.getAttribute ( "delayTime" ) );
    }
    private static IIOMetadataNode getNode ( IIOMetadataNode rootNode, String nodeName ) {
        int nNodes = rootNode.getLength();
        for ( int i = 0; i < nNodes; i++ ) {
            if ( rootNode.item ( i ).getNodeName().compareToIgnoreCase ( nodeName ) == 0 ) {
                return ( ( IIOMetadataNode ) rootNode.item ( i ) );
            }
        }
        IIOMetadataNode node = new IIOMetadataNode ( nodeName );
        rootNode.appendChild ( node );
        return ( node );
    }
}
