private static final Random rand = new Random();
static int[] horizontal = {2, 1, -1, -2, -2, -1, 1, 2};
static int[] vertical = { -1, -2, -2, -1, 1, 2, 2, 1};
static final int SQUARES = 8;
static boolean[][] board = new boolean[SQUARES][SQUARES];
static final int[] moves = {0, 1, 2, 3, 4, 5, 6, 7};
static int currentRow = 0;
static int currentColumn = 0;
public static void main ( String[] args ) {
    int[] squares = new int[65];
    int counter;
    for ( int i = 0; i < 1000; i++ ) {
        counter = 1;
        resetBoard();
        board[0][0] = true;
        while ( moveKnight ( rand.nextInt ( 8 ) ) ) {
            counter++;
        }
        squares[counter]++;
    }
    for ( int i = 0; i < squares.length; i++ ) {
        System.out.printf ( "%d: %d\n", i, squares[i] );
    }
}
public static void resetBoard() {
    for ( boolean[] b : board )
        for ( int j = 0; j < b.length; j++ ) {
            b[j] = false;
        }
    currentRow = 0;
    currentColumn = 0;
}
public static boolean moveKnight ( int num ) {
    if ( validMove ( num ) ) {
        currentRow += vertical[num];
        currentColumn += horizontal[num];
        board[currentRow][currentColumn] = true;
        return true;
    } else {
        for ( int i : moves ) {
            if ( validMove ( i ) ) {
                currentRow += vertical[i];
                currentColumn += horizontal[i];
                board[currentRow][currentColumn] = true;
                return true;
            }
        }
    }
    return false;
}
public static boolean validMove ( int num ) {
    int row = currentRow + vertical[num];
    int column = currentColumn + horizontal[num];
    return row < SQUARES && column < SQUARES && row >= 0 && column >= 0 && !board[row][column];
}
