@Entity
@Table ( name = "Customer" )
public class Customer {
    private static final String IS_ACTIVE = "T";
    private long id;
    private String firstName;
    private String lastName;
    private String isActive = "";
    protected Customer() {}
    public Customer ( String firstName, String lastName ) {
        this.firstName = firstName;
        this.lastName = lastName;
    }
    @Id
    @GeneratedValue ( strategy = GenerationType.AUTO )
    public long getId() {
        return id;
    }
    public void setId ( long id ) {
        this.id = id;
    }
    @Column ( unique = true, nullable = false )
    public String getFirstName() {
        return firstName;
    }
    public void setFirstName ( String firstName ) {
        this.firstName = firstName;
    }
    @Column ( unique = true, nullable = false )
    public String getLastName() {
        return lastName;
    }
    public void setLastName ( String lastName ) {
        this.lastName = lastName;
    }
    @Column ( unique = true, nullable = false )
    public String getIsActive() {
        return isActive;
    }
    public void setIsActive ( String isActive ) {
        this.isActive = isActive;
    }
    @Transient
    public boolean isActive() {
        return isActive.equals ( IS_ACTIVE );
    }
    @Override
    public String toString() {
        return String.format (
                   "Customer[id=%d, firstName='%s', lastName='%s']",
                   id, firstName, lastName );
    }
}
