public class TestFX extends Application {
    @Override
    public void start ( Stage stage ) throws Exception {
        try {
            final WebView webView = new WebView();
            final WebEngine webEngine = webView.getEngine();
            Scene scene = new Scene ( webView );
            stage.setScene ( scene );
            stage.setWidth ( 1200 );
            stage.setHeight ( 600 );
            stage.show();
            webEngine.getLoadWorker().stateProperty().addListener ( new ChangeListener<Worker.State>() {
                @Override
                public void changed ( ObservableValue<? extends State> ov, State t, State t1 ) {
                    if ( t1 == Worker.State.SUCCEEDED ) {
                        try {
                            printDocument ( webEngine.getDocument(), System.out );
                        } catch ( Exception e ) {
                            e.printStackTrace();
                        }
                    }
                }
            } );
            webView.getEngine().load ( "http://www.google.com" );
        } catch ( Exception e ) {
            e.printStackTrace();
        }
    }
    public static void printDocument ( Document doc, OutputStream out ) throws IOException, TransformerException {
        TransformerFactory tf = TransformerFactory.newInstance();
        Transformer transformer = tf.newTransformer();
        transformer.setOutputProperty ( OutputKeys.OMIT_XML_DECLARATION, "no" );
        transformer.setOutputProperty ( OutputKeys.METHOD, "xml" );
        transformer.setOutputProperty ( OutputKeys.INDENT, "yes" );
        transformer.setOutputProperty ( OutputKeys.ENCODING, "UTF-8" );
        transformer.setOutputProperty ( "{http://xml.apache.org/xslt}indent-amount", "4" );
        transformer.transform ( new DOMSource ( doc ), new StreamResult ( new OutputStreamWriter ( out, "UTF-8" ) ) );
    }
    public static void main ( String[] args ) {
        launch ( args );
    }
}
