@Override
protected void onCreate ( Bundle savedInstanceState ) {
    super.onCreate ( savedInstanceState );
    setContentView ( R.layout.menu_listview );
    mTitle = "Androi Reboot";
    getActionBar().setTitle ( mTitle );
    mDrawerLayout = ( DrawerLayout ) findViewById ( R.id.drawer_layout );
    mDrawerList = ( ListView ) findViewById ( R.id.drawer_list );
    mDrawerToggle = new ActionBarDrawerToggle ( this, mDrawerLayout,
            R.drawable.ic_drawer, R.string.drawer_open,
    R.string.drawer_close ) {
        public void onDrawerClosed ( View view ) {
            getActionBar().setTitle ( mTitle );
            invalidateOptionsMenu();
        }
        public void onDrawerOpened ( View drawerView ) {
            getActionBar().setTitle ( "Androi Reboot" );
            invalidateOptionsMenu();
        }
    };
    mDrawerLayout.setDrawerListener ( mDrawerToggle );
    ArrayAdapter<String> adapter = new ArrayAdapter<String> ( getBaseContext(),
            R.layout.arraylist, getResources().getStringArray ( R.array.menus ) );
    mDrawerList.setAdapter ( adapter );
    getActionBar().setHomeButtonEnabled ( true );
    getActionBar().setDisplayHomeAsUpEnabled ( true );
    mDrawerList.setOnItemClickListener ( new OnItemClickListener() {
        @Override
        public void onItemClick ( AdapterView<?> parent, View view,
                                  int position, long id ) {
            fireFragment ( position )
            mDrawerLayout.closeDrawer ( mDrawerList );
        }
    } );
    fireFragment ( 0 );
}
private void fireFragment ( int position ) {
    String[] menuItems = getResources().getStringArray ( R.array.menus );
    mTitle = menuItems[position];
    MainActivity rFragment = new MainActivity();
    Bundle data = new Bundle();
    data.putInt ( "position", position );
    data.putString ( "url", getUrl ( position ) );
    rFragment.setArguments ( data );
    FragmentManager fragmentManager = getFragmentManager();
    FragmentTransaction ft = fragmentManager.beginTransaction();
    ft.replace ( R.id.content_frame, rFragment );
    ft.commit();
}
