public class MyClass {
    private static URLClassLoader createURLClassLoader() {
        Collection<String> resources = ResourceList.getResources ( Pattern.compile ( ".*\\.jar" ) );
        Collection<URL> urls = new ArrayList<URL>();
        for ( String resource : resources ) {
            File file = new File ( resource );
            if ( file.isFile() && "globalclasspath".equals ( file.getParentFile().getName() ) ) {
                try {
                    urls.add ( file.toURI().toURL() );
                } catch ( MalformedURLException e ) {
                    e.printStackTrace();
                }
            }
        }
        return new URLClassLoader ( urls.toArray ( new URL[urls.size()] ) );
    }
    public static void main ( String[] args ) {
        URLClassLoader classLoader = createURLClassLoader();
        System.out.println ( classLoader.getResource ( "mine.properties" ) );
    }
}
