protected Subscriber updateSubscriberAttributes ( Subscriber subscriber, Collection<SubscriberAttributeDto> subscriberAttributesCollection ) throws ErrorException {
    if ( ( subscriberAttributesCollection != null ) && !subscriberAttributesCollection.isEmpty() ) {
        Map<String, List<Object>> subscriberAttributesMap = new HashMap<String, List<Object>> ( subscriberAttributesCollection.size() );
        for ( SubscriberAttributeDto subscriberAttribute : subscriberAttributesCollection ) {
            SubscriberAttributeMetadata attrMetadata = subscriberAttribute.getAttributeMetadata();
            if ( attrMetadata != null ) {
                String columnName = attrMetadata.getColumnName();
                List<Object> list = subscriberAttributesMap.get ( columnName );
                if ( list == null ) {
                    list = new ArrayList<Object>();
                    subscriberAttributesMap.put ( columnName, list );
                }
                list.add ( attrMetadata.convertToDatabaseValue ( ( String ) subscriberAttribute.getValue() ) );
            }
        }
        return updateSubscriberAttributes ( subscriber, subscriberAttributesMap );
    } else {
        return subscriber;
    }
}
protected Subscriber updateSubscriberAttributes ( Subscriber subscriber,  Map<String, List<Object>> map ) throws ErrorException {
    return new Subscriber();
}
