public class Execution implements Runnable {
    public String name;
    protected long startedAtMs;
    protected long timeoutMs;
    private long rateMs = 2;
    private long prevExecutionMs;
    protected Runnable action;
    public Execution ( String name, double et, Runnable action ) {
        this.name = name;
        this.action = action;
        this.timeoutMs = ( long ) ( et * 1000 );
    }
    public void run() {
        startedAtMs = System.currentTimeMillis();
        prevExecutionMs = startedAtMs;
        while ( true ) {
            if ( Thread.interrupted() ) {
                return;
            }
            long now = System.currentTimeMillis();
            if ( now - startedAtMs > timeoutMs ) {
                break;
            }
            if ( now - prevExecutionMs > rateMs ) {
                action.run();
                prevExecutionMs = now;
            }
        }
    }
    public double getTimeToDisplay() {
        return ( System.currentTimeMillis() - startedAtMs ) / 1000D;
    }
    public static void main ( String[] args ) throws InterruptedException {
        Thread thread = new Thread ( new Execution ( "exec", 0.5, new Runnable() {
            @Override
            public void run() {
                System.out.println ( new Date() );
            }
        } ) );
        thread.start();
        thread.join();
        System.out.println ( "Done!" );
    }
}
