JNIEXPORT void JNICALL Java_MyLibrary_initCpp ( JNIEnv * env, jobject javaMyLibrary ) {
    MyLibrary * lib = new MyLibrary();
    env->SetLongField ( javaMyLibrary, CPP_MYLIBRARY_POINTER_FIELD, ptr_to_jlong ( lib ) );
}
JNIEXPORT void JNICALL Java_MyLibrary_setObserver ( JNIEnv * env,
        jobject javaMyLibrary, jobject javaObserver ) {
    MyLibrary * cppMyLibrary = ( MyLibrary * ) jlong_to_ptr (
                                   env->GetLongField ( javaMyLibrary, CPP_MYLIBRARY_POINTER_FIELD ) );
    if ( cppMyLibrary == NULL ) {
        return;
    }
    jthrowable exc = NULL;
    JavaVM * jvm;
    env->GetJavaVM ( & jvm );
    jobject observer = env->NewGlobalRef ( javaObserver );
    try {
        cppMyLibrary->setLogFunction ( [jvm, observer] ( std::string & p0, std::string & p1 ) {
            JNIEnv * env;
            jvm->AttachCurrentThread ( & env, NULL );
            jclass clazz = env->GetObjectClass ( observer );
            jmethodID meth = env->GetMethodID ( clazz, "log",
                                                "(Ljava/lang/String;Ljava/lang/String;)V" );
            jstring s0 = env->NewStringUTF ( p0.c_str() );
            jstring s1 = env->NewStringUTF ( p1.c_str() );
            env->CallVoidMethod ( observer, meth, s0, s1 );
            jvm->DetachCurrentThread();
        } );
    } catch ( ... ) {
        exc =
    }
    if ( exc != NULL ) {
        env->Throw ( exc );
    }
}
