@Configuration
@EnableWebMvc
@ComponentScan ( basePackages = { "com.orgname"  } )
public class WebConfig extends WebMvcConfigurerAdapter {
    @Bean
    public ViewResolver viewResolver() {
        InternalResourceViewResolver viewResolver = new InternalResourceViewResolver();
        viewResolver.setViewClass ( JstlView.class );
        viewResolver.setPrefix ( "/view/jsp/" );
        viewResolver.setSuffix ( ".jsp" );
        return viewResolver;
    }
    @Override
    public void addResourceHandlers ( ResourceHandlerRegistry registry ) {
        registry.addResourceHandler ( "/resources/**" ).addResourceLocations ( "/resources/" );
    }
    @Bean ( name = "cookieHandlerSetDefaultBean" )
    public MethodInvokingFactoryBean methodInvokingFactoryBean() {
        MethodInvokingFactoryBean methodInvokingFactoryBean = new MethodInvokingFactoryBean();
        methodInvokingFactoryBean.setTargetClass ( CookieHandler.class );
        methodInvokingFactoryBean.setTargetMethod ( "setDefault" );
        CookieManager cookieManager = new CookieManager();
        methodInvokingFactoryBean.setArguments ( new Object[] {cookieManager} );
        return methodInvokingFactoryBean;
    }
}
