public class Main extends Activity {
    private boolean showingFirstFragment;
    public void onCreate ( Bundle savedInstanceState ) {
        setContentView ( R.layout.main );
        FragmentManager manager = getFragmentManager();
        FragmentTransaction trans = manager.beginTransaction();
        showingFirstFragment = true;
        trans.add ( R.id.main_container, new Fragment1(), "fragment_1" );
        trans.commit();
    }
    public void onBackPressed() {
        switchFragments();
    }
    private void switchFragments() {
        FragmentManager manager = getFragmentManager();
        FragmentTransaction trans = manager.beginTransaction();
        int rightIn = R.animator.slide_right_in;
        int rightOut = R.animator.slide_right_out;
        int leftIn = R.animator.slide_left_in;
        int leftOut = R.animator.slide_left_out;
        trans.setCustomAnimations ( rightIn, leftOut, leftIn, rightOut );
        if ( showingFirstFragment ) {
            int container = R.id.main_container;
            trans.replace ( container, new Fragment2(), "fragment_2" );
            trans.commit();
            showingFirstFragment = false;
        } else {
            manager.popBackStack ( null );
            showingFirstFragment = true;
        }
    }
}
