private Bitmap downloadBitmap ( String url ) {
    url = url.substring ( url.indexOf ( "src=\"" ) + 5, url.length() - 1 );
    url = url.substring ( 0, url.indexOf ( "\"" ) );
    final DefaultHttpClient client = new DefaultHttpClient();
    final HttpGet getRequest = new HttpGet ( url );
    try {
        HttpResponse response = client.execute ( getRequest );
        final int statusCode = response.getStatusLine().getStatusCode();
        if ( statusCode != HttpStatus.SC_OK ) {
            Log.w ( "ImageDownloader", "Error " + statusCode +
                    " while retrieving bitmap from " + url );
            return null;
        }
        final HttpEntity entity = response.getEntity();
        if ( entity != null ) {
            InputStream inputStream = null;
            try {
                inputStream = entity.getContent();
                final Bitmap bitmap = BitmapFactory.decodeStream ( inputStream );
                return bitmap;
            } finally {
                if ( inputStream != null ) {
                    inputStream.close();
                }
                entity.consumeContent();
            }
        }
    } catch ( Exception e ) {
        getRequest.abort();
        Log.e ( "ImageDownloader", "Something went wrong while" +
                " retrieving bitmap from " + url + e.toString() );
    }
    return null;
}
