package yar;
import javax.tools.JavaCompiler;
import javax.tools.ToolProvider;
public class DynamicCompiler {
    JavaCompiler compiler;
    public DynamicCompiler() {
        this.compiler = ToolProvider.getSystemJavaCompiler();
        if ( this.compiler == null ) {
            throw new NullPointerException ( "Cannot provide system compiler." );
        }
    }
    public void compile() {
        this.compiler.run ( null, System.out, System.err,
                            "-d", "testFiles2",
                            "testFiles/Hello1.java", "testFiles/Hello2.java" );
    }
    public static void main ( String[] args ) {
        try {
            DynamicCompiler dc = new DynamicCompiler();
            dc.compile();
        } catch ( Exception e ) {
            System.err.println ( e.getMessage() );
        }
    }
}
