public class ConfigurableHttpClientInitializer : IConfigurableHttpClientInitializer {
    OAuth2Parameters parameters;
    public ConfigurableHttpClientInitializer ( OAuth2Parameters parameters ) {
        this.parameters = parameters;
    }
    public void Initialize ( ConfigurableHttpClient httpClient ) {
        if ( parameters.TokenType == "Bearer" && parameters.TokenExpiry < DateTime.Now ) {
            OAuthUtil.RefreshAccessToken ( parameters );
        }
        httpClient.DefaultRequestHeaders.Add ( "Authorization", "Bearer " + parameters.AccessToken );
    }
}
