import java.awt.Color;
import java.awt.Dimension;
import java.awt.EventQueue;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import java.io.IOException;
import javax.imageio.ImageIO;
import javax.swing.JFrame;
import javax.swing.JTextField;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
import javax.swing.border.EmptyBorder;
public class BackgroundTextField {
    public static void main ( String[] args ) {
        new BackgroundTextField();
    }
    public BackgroundTextField() {
        EventQueue.invokeLater ( new Runnable() {
            @Override
            public void run() {
                try {
                    UIManager.setLookAndFeel ( UIManager.getSystemLookAndFeelClassName() );
                } catch ( ClassNotFoundException | InstantiationException | IllegalAccessException | UnsupportedLookAndFeelException ex ) {
                    ex.printStackTrace();
                }
                JFrame frame = new JFrame ( "Testing" );
                frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
                frame.add ( new TextFieldBackground() );
                frame.pack();
                frame.setLocationRelativeTo ( null );
                frame.setVisible ( true );
            }
        } );
    }
    public class TextFieldBackground extends JTextField {
        private BufferedImage img;
        public TextFieldBackground() {
            setColumns ( 10 );
            setOpaque ( false );
            setBorder ( new EmptyBorder ( 2, 2, 2, 2 ) );
            setBackground ( new Color ( 0, 0, 0, 0 ) );
            try {
                img = ImageIO.read ( getClass().getResource ( "/y9yBe.jpg" ) );
            } catch ( IOException ex ) {
                ex.printStackTrace();
            }
        }
        @Override
        public Dimension getPreferredSize() {
            return img == null ? super.getPreferredSize() : new Dimension ( img.getWidth(), img.getHeight() );
        }
        @Override
        protected void paintComponent ( Graphics g ) {
            Graphics2D g2d = ( Graphics2D ) g.create();
            g2d.drawImage ( img, 0, 0, this );
            getUI().paint ( g2d, this );
            g2d.dispose();
        }
    }
}
