import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.awt.image.BufferedImage;
import javax.swing.*;
public class ShapeContainment {
    private BufferedImage img;
    private Area[] obstacles = new Area[2];
    private Area walls;
    int x;
    int y;
    int xDelta = 3;
    int yDelta = 2;
    public boolean doAreasEnclose ( Area area1, Area area2 ) {
        Area temp = new Area ( area1 );
        temp.subtract ( area2 );
        Rectangle r = temp.getBounds();
        boolean enclosed = r.getWidth() == 0 && r.getHeight() == 0;
        return enclosed;
    }
    public boolean doAreasCollide ( Area area1, Area area2 ) {
        boolean collide = false;
        Area collide1 = new Area ( area1 );
        collide1.subtract ( area2 );
        if ( !collide1.equals ( area1 ) ) {
            collide = true;
        }
        Area collide2 = new Area ( area2 );
        collide2.subtract ( area1 );
        if ( !collide2.equals ( area2 ) ) {
            collide = true;
        }
        return collide;
    }
    ShapeContainment() {
        int w = 400;
        int h = 200;
        img = new BufferedImage ( w, h, BufferedImage.TYPE_INT_RGB );
        final JLabel imageLabel = new JLabel ( new ImageIcon ( img ) );
        x = w / 2;
        y = h / 2;
        obstacles[0] = new Area ( new Ellipse2D.Double ( 40, 40, 60, 60 ) );
        int[] xTriangle = {330, 360, 345};
        int[] yTriangle = {60, 60, 40};
        obstacles[1] = new Area ( new Ellipse2D.Double ( 300, 100, 60, 60 ) );
        walls = new Area ( new Rectangle ( 0, 0, w, h ) );
        ActionListener animate = new ActionListener() {
            @Override
            public void actionPerformed ( ActionEvent e ) {
                animate();
                imageLabel.repaint();
            }
        };
        Timer timer = new Timer ( 50, animate );
        timer.start();
        JOptionPane.showMessageDialog ( null, imageLabel );
        timer.stop();
    }
    public void animate() {
        Graphics2D g = img.createGraphics();
        g.setRenderingHint (
            RenderingHints.KEY_ANTIALIASING,
            RenderingHints.VALUE_ANTIALIAS_ON );
        g.setColor ( Color.BLUE );
        g.fillRect ( 0, 0, img.getWidth(), img.getHeight() );
        x += xDelta;
        y += yDelta;
        int s = 15;
        Area player = new Area ( new Ellipse2D.Double ( x, y, s, s ) );
        if ( doAreasCollide ( player, walls ) ) {
            if ( x + s > img.getWidth() || x < 0 ) {
                xDelta *= -1;
            }
            if ( y + s > img.getHeight() || y < 0 ) {
                yDelta *= -1;
            }
        }
        g.setColor ( Color.ORANGE );
        for ( Area obstacle : obstacles ) {
            if ( doAreasEnclose ( player, obstacle ) ) {
                g.setColor ( Color.RED );
            } else if ( doAreasCollide ( obstacle, player ) ) {
                g.setColor ( Color.ORANGE );
            } else {
                g.setColor ( Color.GREEN );
            }
            g.fill ( obstacle );
        }
        g.setColor ( Color.YELLOW );
        g.fill ( player );
        g.dispose();
    }
    public static void main ( String[] args ) {
        Runnable r = new Runnable() {
            @Override
            public void run() {
                new ShapeContainment();
            }
        };
        SwingUtilities.invokeLater ( r );
    }
}
