InetAddress getBroadcastAddress ( Context context ) throws IOException {
    WifiManager wifi = ( WifiManager ) context.getSystemService ( Context.WIFI_SERVICE );
    DhcpInfo dhcp = wifi.getDhcpInfo();
    if ( dhcp == null ) {
        return null;
    }
    int broadcast = ( dhcp.ipAddress & dhcp.netmask ) | ~dhcp.netmask;
    byte[] quads = new byte[4];
    for ( int k = 0; k < 4; k++ ) {
        quads[k] = ( byte ) ( ( broadcast >> k * 8 ) & 0xFF );
    }
    return InetAddress.getByAddress ( quads );
}
