int s  = 40;
int w  = 8;
int h  = 8;
int np = w * h;
int b = 255;
float nb = 0;
float mb = 64;
float db = 0;
int[][] normal, dimmed;
void setup() {
    noSmooth();
    fill ( 127 );
    size ( w * s * 2, h * s );
    normal = new int[w][h];
    dimmed = new int[w][h];
}
void draw() {
    background ( 0 );
    for ( int y = 0; y  < h ; y++ ) {
        for ( int x = 0; x < w ; x++ ) {
            fill ( normal[x][y] );
            rect ( x * s, y * s, s, s );
            fill ( dimmed[x][y] );
            rect ( ( x * s ) + ( w * s ), y * s, s, s );
        }
    }
    fill ( 127 );
    text ( "original brightness: " + nb + " max: " + mb + "\ndimmed brightness: " + db, 10, 15 );
}
void mouseDragged() {
    if ( ( mouseX > 0 && mouseX < w * s ) && ( mouseY > 0 && mouseY < h * s ) ) {
        normal[mouseX / s][mouseY / s] = b;
        nb = getBrightness ( normal );
        float bd   = ( nb - mb ) / 255.0;
        println ( nb - mb + "/" + bd );
        for ( int y = 0; y  < h ; y++ )
            for ( int x = 0; x < w ; x++ ) {
                dimmed[x][y] = normal[x][y] - ( int ) ( bd > 0 ? bd * 255.0 : 0 );
            }
        db = getBrightness ( dimmed );
    }
}
void keyPressed() {
    if ( key == '-' && b > 0 ) {
        b--;
    }
    if ( key == '=' && b < 255 ) {
        b++;
    }
    if ( key == ' ' ) {
        for ( int y = 0; y  < h ; y++ )
            for ( int x = 0; x < w ; x++ ) {
                normal[x][y] = 0;
            }
    }
}
float getBrightness ( int[][] img ) {
    float ab = 0;
    for ( int y = 0; y  < h ; y++ )
        for ( int x = 0; x < w ; x++ ) {
            ab += img[x][y];
        }
    return ( ab / np );
}
