public class MainFrame2 extends JFrame {
    public interface ModuleFactory {
        public String getTitle();
        public Component createModule ( Api api );
    }
    public static enum ModuleRegistry {
        INSTANCE;
        private final List<ModuleFactory> leftModules = new ArrayList<ModuleFactory>();
        public void registerModuleForLeftPanel ( ModuleFactory factory ) {
            leftModules.add ( factory );
        }
        private void addModulesTo ( MainFrame2 mainFrame2, Api api ) {
            for ( ModuleFactory factory : leftModules ) {
                mainFrame2.addModuleToLeftPanel ( factory.getTitle(), factory.createModule ( api ) );
            }
        }
    }
    public static MainFrame2 newInstance() {
        MainFrame2 result = new MainFrame2();
        ModuleRegistry.INSTANCE.addModulesTo ( result, result.api );
        return result;
    }
}
