public final class GetYouTubeUserVideosTask extends AsyncTask<Void, Void, Void> {
    public static final String LIBRARY = "Library";
    private final Handler replyTo;
    private final String username;
    public GetYouTubeUserVideosTask ( Handler replyTo, String username ) {
        this.replyTo = replyTo;
        this.username = username;
    }
    @Override
    protected Void doInBackground ( Void... arg0 ) {
        try {
            HttpClient client = new DefaultHttpClient();
            HttpUriRequest request = new HttpGet ( "https://gdata.youtube.com/feeds/api/videos?author=" + username + "&v=2&alt=jsonc" );
            HttpResponse response = client.execute ( request );
            String jsonString = StreamUtils.convertToString ( response.getEntity().getContent() );
            JSONObject json = new JSONObject ( jsonString );
            JSONArray jsonArray = json.getJSONObject ( "data" ).getJSONArray ( "items" );
            List<Video> videos = new ArrayList<Video>();
            for ( int i = 0; i < jsonArray.length(); i++ ) {
                JSONObject jsonObject = jsonArray.getJSONObject ( i );
                String title = jsonObject.getString ( "title" );
                String url;
                try {
                    url = jsonObject.getJSONObject ( "player" ).getString ( "mobile" );
                } catch ( JSONException ignore ) {
                    url = jsonObject.getJSONObject ( "player" ).getString ( "default" );
                }
                String thumbUrl = jsonObject.getJSONObject ( "thumbnail" ).getString ( "sqDefault" );
                videos.add ( new Video ( title, url, thumbUrl ) );
            }
            Library lib = new Library ( username, videos );
            Bundle data = new Bundle();
            data.putSerializable ( LIBRARY, lib );
            Message msg = Message.obtain();
            msg.setData ( data );
            replyTo.sendMessage ( msg );
        } catch ( ClientProtocolException e ) {
            Log.e ( "Feck", e );
        } catch ( IOException e ) {
            Log.e ( "Feck", e );
        } catch ( JSONException e ) {
            Log.e ( "Feck", e );
        }
        return null;
    }
    @Override
    protected void onPostExecute ( Void result ) {
    }
}
