static final int upperLimit  = 26;
static final int maxHeadSize = ( "" + upperLimit ).length();
static int numDecodings ( String encodedText ) {
    return numDecodings ( encodedText, new Integer[1 + encodedText.length()] );
}
static int numDecodings ( String encodedText, Integer[] cache ) {
    if ( encodedText.length() == 0 ) {
        return 1;
    }
    if ( cache[encodedText.length()] != null ) {
        return cache[encodedText.length()];
    }
    int sum = 0;
    for ( int headSize = 1; headSize <= maxHeadSize && headSize <= encodedText.length(); headSize++ ) {
        String head = encodedText.substring ( 0, headSize );
        String tail = encodedText.substring ( headSize );
        if ( Integer.parseInt ( head ) > upperLimit ) {
            break;
        }
        sum += numDecodings ( tail, cache );
    }
    cache[encodedText.length()] = sum;
    return sum;
}
