public static <T> List<List<T>> createCombinations ( List<T>... elements ) {
    List<List<T>> returnLists = new ArrayList<>();
    int[] indices = new int[elements.length];
    for ( int i = 0; i < indices.length; i++ ) {
        indices[i] = 0;
    }
    returnLists.add ( generateCombination ( indices, elements ) );
    while ( returnLists.size() < countCombinations ( elements ) ) {
        gotoNextIndex ( indices, elements );
        returnLists.add ( generateCombination ( indices, elements ) );
    }
    return returnLists;
}
private static <T> void gotoNextIndex ( int[] indices, List<T>... elements ) {
    for ( int j = indices.length - 1; j >= 0; j-- ) {
        if ( indices[j] == elements[j].size() - 1 ) {
            indices[j] = 0;
            continue;
        }
        indices[j]++;
        return;
    }
}
private static <T> List<T> generateCombination ( int[] indices, List<T>... elements ) {
    List<T> returnList = new ArrayList<>();
    for ( int i = 0; i < indices.length; i++ ) {
        returnList.add ( elements[i].get ( indices[i] ) );
    }
    return returnList;
}
private static <T> int countCombinations ( List<T>... elements ) {
    int count = 1;
    for ( List<T> list : elements ) {
        count *= list.size();
    }
    return count;
}
public static <T> List<List<T>> createCombinations ( List<List<T>> elements ) {
    return createCombinations ( ( List<T>[] ) elements.toArray() );
}
