boolean willMatchAll ( Query query ) {
    if ( query instanceof MatchAllDocsQuery ) {
        return true;
    }
}
else if ( query instanceof BooleanQuery ) {
    boolean foundMatchAll = false;
    for ( BooleanClause clause : ( ( BooleanQuery ) query ).getClauses() ) {
        if ( clause.isProhibited() ) {
            return false;
        } else if ( clause.isRequired() ) {
            if ( willMatchAll ( clause.getQuery() ) ) {
                foundMatchAll = true;
            } else {
                return false;
            }
        } else {
            if ( willMatchAll ( clause.getQuery() ) ) {
                foundMatchAll = true;
            }
        }
    }
    return foundMatchAll;
} else if ( query instanceof DisjunctionMaxQuery ) {
    boolean isMatchAll = false
    for ( Query subquery : ( ( DisjunctuionMaxQuery ) query ).getDisjuncts() ) {
        isMatchAll = isMatchAll || willMatchAll ( subquery );
    }
    return isMatchAll;
} else if ( query instanceof ConstantScoreQuery ) {
    Query subquery = ( ( ConstantScoreQuery ) query ).getQuery()
    if ( subquery == null ) {
        return false;
    }
    return willMatchAll ( subquery );
} else {
    return false;
}
}
