public class ModuleContextLoaderListener extends ContextLoaderListener {
    public ModuleContextLoaderListener() {
        super();
    }
    @Override
    public void contextInitialized ( ServletContextEvent event ) {
        ModuleManager.init ( event.getServletContext().getRealPath ( "WEB-INF" ), "/dev/temp/modules" );
        super.contextInitialized ( event );
    }
    @Override
    protected WebApplicationContext createWebApplicationContext ( ServletContext sc ) {
        XmlWebApplicationContext context = ( XmlWebApplicationContext ) super.createWebApplicationContext ( sc );
        WebApplicationUtils.setCurrentClassLoader ( context );
        return context;
    }
    @Override
    public void contextDestroyed ( ServletContextEvent event ) {
        super.contextDestroyed ( event );
        ModuleManager.destroy();
    }
}
