public class OurNotification {
    public void createNotification ( Context context, String title, String msg, String other ) {
        NotificationCompat.Builder mBuilder = new NotificationCompat.Builder ( context )
        .setSmallIcon ( R.drawable.notification )
        .setContentTitle ( title )
        .setContentText ( msg );
        Intent resultIntent = new Intent ( context, Menu.class );
        mBuilder.setAutoCancel ( true );
        mBuilder.setSound ( RingtoneManager.getDefaultUri ( RingtoneManager.TYPE_NOTIFICATION ) );
        mBuilder.setDefaults ( Notification.DEFAULT_LIGHTS );
        mBuilder.setOnlyAlertOnce ( true );
        if ( other != null ) {
            NotificationCompat.BigTextStyle bigStyle =
                new NotificationCompat.BigTextStyle();
            bigStyle.setBigContentTitle ( other );
            mBuilder.setStyle ( bigStyle );
        }
        TaskStackBuilder stackBuilder = TaskStackBuilder.create ( context );
        stackBuilder.addParentStack ( Menu.class );
        stackBuilder.addNextIntent ( resultIntent );
        PendingIntent resultPendingIntent =
            stackBuilder.getPendingIntent (
                0,
                PendingIntent.FLAG_UPDATE_CURRENT
            );
        mBuilder.setContentIntent ( resultPendingIntent );
        NotificationManager mNotificationManager =
            ( NotificationManager ) context.getSystemService ( Context.NOTIFICATION_SERVICE );
        mNotificationManager.notify ( 200, mBuilder.build() );
    }
}
