public class ProcessOutput {
    private final InputStream inputStream;
    final CountDownLatch latch = new CountDownLatch ( 1 );
    public ProcessOutput ( InputStream inputStream ) {
        this.inputStream = inputStream;
    }
    public String getRequestString ( final long timeoutMilliSeconds ) throws InterruptedException {
        StreamReader reader = new StreamReader();
        new Thread ( reader ).start();
        latch.await ( timeoutMilliSeconds, TimeUnit.MILLISECONDS );
        return reader.getRequestString();
    }
    private class StreamReader implements Runnable {
        String requestString;
        @Override
        public void run() {
            BufferedReader br = null;
            StringBuilder sb = new StringBuilder();
            String line;
            try {
                br = new BufferedReader ( new InputStreamReader ( inputStream ) );
                while ( ( line = br.readLine() ) != null ) {
                    sb.append ( line );
                }
            } catch ( IOException e ) {
                e.printStackTrace();
            } finally {
                if ( br != null ) {
                    try {
                        br.close();
                    } catch ( IOException e ) {
                        e.printStackTrace();
                    }
                }
            }
            requestString = sb.toString();
            latch.countDown();
        }
        public String getRequestString() {
            return requestString;
        } ;
    }
}
