class GetInputPanel extends JPanel {
    private static final int PREF_W = 500;
    private static final int PREF_H = 40;
    private JLabel promptLabel = new JLabel();
    private JTextField inputField = new JTextField ( 10 );
    private JButton doActionButton = new JButton();
    public GetInputPanel() {
        add ( promptLabel );
        add ( inputField );
        add ( doActionButton );
    }
    public void setAction ( Action action ) {
        inputField.setAction ( action );
        doActionButton.setAction ( action );
    }
    public void setPrompt ( String prompt ) {
        promptLabel.setText ( prompt );
    }
    public String getInputText() {
        return inputField.getText();
    }
    public void clearInputText() {
        inputField.setText ( "" );
    }
    @Override
    public Dimension getPreferredSize() {
        return new Dimension ( PREF_W, PREF_H );
    }
    @Override
    public void setEnabled ( boolean enabled ) {
        super.setEnabled ( enabled );
        inputField.setEnabled ( enabled );
        doActionButton.setEnabled ( enabled );
    }
}
