protected void processFocusEvent ( FocusEvent e ) {
    super.processFocusEvent ( e );
    if ( e.isTemporary() ) {
        return;
    }
    if ( isEdited() && e.getID() == FocusEvent.FOCUS_LOST ) {
        InputContext ic = getInputContext();
        if ( focusLostHandler == null ) {
            focusLostHandler = new FocusLostHandler();
        }
        if ( ( ic != null ) && composedTextExists ) {
            ic.endComposition();
            EventQueue.invokeLater ( focusLostHandler );
        } else {
            focusLostHandler.run();
        }
    } else if ( !isEdited() ) {
        setValue ( getValue(), true, true );
    }
}
