protected void firePropertyChange ( String propertyName,
                                    Object oldValue, Object newValue ) {
    PropertyChangeSupport changeSupport;
    synchronized ( getObjectLock() ) {
        changeSupport = this.changeSupport;
    }
    if ( changeSupport == null ||
            ( oldValue != null && newValue != null && oldValue.equals ( newValue ) ) ) {
        return;
    }
    changeSupport.firePropertyChange ( propertyName, oldValue, newValue );
}
