public sealed class ATCommands {
    public static readonly ATCommands DISABLE_ECHO =
        new ATCommands ( "ATE0" );
    public static readonly ATCommands DISABLE_DIAGNOSTIC =
        new ATCommands ( "AT^CURC=0" );
    public static readonly ATCommands ATTENTION =
        new ATCommands ( "AT" );
    public static readonly ATCommands ENABLE_HANGUP =
        new ATCommands ( "AT+CVHU=0" );
    public static readonly ATCommands ENABLE_RING_INFO =
        new ATCommands ( "AT+CRC=1" );
    public static readonly ATCommands ENABLE_CALL_INFO =
        new ATCommands ( "AT+CLIP=1" );
    public static readonly ATCommands CHECK_PIN =
        new ATCommands ( "AT+CPIN?" );
    public static readonly ATCommands INSERT_PIN =
        new ATCommands ( "AT+CPIN=<par>" );
    public static readonly ATCommands END_CALL =
        new ATCommands ( "ATH" );
    public static readonly ATCommands CALL =
        new ATCommands ( "ATD<par>;" );
    private ATCommands ( String modemCommandString ) {
        ModemCommandString = modemCommandString;
    }
    public String ModemCommandString {
        get;
        private set;
    }
    public override String ToString() {
        return ModemCommandString;
    }
    public override Boolean Equals ( Object obj ) {
        ATCommands other = obj as ATCommands;
        if ( Object.ReferenceEquals ( null, other ) ) {
            return false;
        }
        return ModemCommandString.Equals ( other.ModemCommandString, StringComparison.Ordinal );
    }
    public override int GetHashCode() {
        return ModemCommandString.GetHashCode();
    }
    public static Boolean operator == ( ATCommands left, ATCommands right ) {
        if ( Object.ReferenceEquals ( left, right ) ) {
            return true;
        }
        eles if ( Object.ReferenceEquals ( left, null ) ) {
            return false;
        }
        eles if ( Object.ReferenceEquals ( null, right ) ) {
            return false;
        }
        return left.Equals ( right );
    }
    public static Boolean operator != ( ATCommands left, ATCommands right ) {
        if ( Object.ReferenceEquals ( left, right ) ) {
            return false;
        }
        eles if ( Object.ReferenceEquals ( left, null ) ) {
            return true;
        }
        eles if ( Object.ReferenceEquals ( null, right ) ) {
            return true;
        }
        return !left.Equals ( right );
    }
    public String getModemCommandString() {
        return ModemCommandString;
    }
}
