public static void main ( String[] args ) {
    ExecutorService executor = Executors.newFixedThreadPool ( 4 );
    Future<?> future = executor.submit ( new Runnable() {
        @Override
        public void run() {
            writeToDb();
        }
    } );
    executor.shutdown();
    try {
        future.get ( 8, TimeUnit.SECONDS );
    } catch ( InterruptedException e ) {
        System.out.println ( "job was interrupted" );
    } catch ( ExecutionException e ) {
        System.out.println ( "caught exception: " + e.getCause() );
    } catch ( TimeoutException e ) {
        future.cancel ( true );
        System.out.println ( "timeout" );
    }
    if ( !executor.awaitTermination ( 2, TimeUnit.SECONDS ) ) {
        executor.shutdownNow();
    }
}
