package stackoverflow.answer;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.util.List;
import java.util.logging.Logger;
import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.auth.AuthScope;
import org.apache.http.auth.UsernamePasswordCredentials;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.auth.BasicScheme;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.protocol.BasicHttpContext;
import org.apache.http.util.EntityUtils;
public class JenkinsPoster {
    final Logger log = Logger.getLogger ( getClass().getCanonicalName() );
    private JobData jd;
    public JenkinsPoster ( JobData jobData ) {
        this.jd = jobData;
    }
    @SuppressWarnings ( "deprecation" )
    public void postJenkinsJob() throws UnsupportedEncodingException {
        log.entering ( getClass().getCanonicalName(), "JenkinsPoster" );
        String jenkinsUrl = String.format ( "%s:%s/jenkins", jd.getServer(), jd.getPort() );
        log.info ( "url = " + jenkinsUrl );
        DefaultHttpClient client = new DefaultHttpClient();
        client.getCredentialsProvider().setCredentials ( new AuthScope ( AuthScope.ANY_HOST, AuthScope.ANY_PORT ),
                new UsernamePasswordCredentials ( jd.getUsername(), jd.getPassword() ) );
        BasicScheme basicAuth = new BasicScheme();
        BasicHttpContext context = new BasicHttpContext();
        context.setAttribute ( "preemptive-auth", basicAuth );
        client.addRequestInterceptor ( new PreemptiveAuth(), 0 );
        List<NameValuePair> parameters = jd.getParameters();
        UrlEncodedFormEntity uefe = null;
        String buildUrl = "";
        if ( parameters.isEmpty() ) {
            buildUrl = jenkinsUrl + "/job/" + jd.getJob() + "/build";
        } else {
            buildUrl = jenkinsUrl + "/job/" + jd.getJob() + "/buildWithParameters";
            uefe = new UrlEncodedFormEntity ( parameters );
        }
        HttpPost post = new HttpPost ( buildUrl );
        post.setHeader ( "User-Agent", "Mozilla/5.0" );
        if ( uefe != null ) {
            post.setEntity ( uefe );
        }
        try {
            HttpResponse response = client.execute ( post, context );
            HttpEntity entity = response.getEntity();
            log.info ( EntityUtils.toString ( entity ) );
            EntityUtils.consume ( entity );
        } catch ( IOException e ) {
            e.printStackTrace();
        } finally {
            client.close();
        }
        log.exiting ( getClass().getCanonicalName(), "JenkinsPoster" );
    }
}
