private void lockWindow ( final Window window ) {
    if ( window instanceof RootPaneContainer
            && ( ( RootPaneContainer ) window ).getRootPane() != null
            && !lockedWindows.containsKey ( window ) ) {
        java.util.Timer timer = null;
        try {
            LockedWindow lockedWindow = new LockedWindow();
            lockedWindows.put ( ( RootPaneContainer ) window, lockedWindow );
            lockedWindow.originalGlassPane = ( ( RootPaneContainer ) window ).getGlassPane();
            LockedGlassPane lgp = new LockedGlassPane();
            ( ( RootPaneContainer ) window ).setGlassPane ( lgp );
            timer = switchToBusyCursor ( window );
            try {
                Thread.sleep ( 3000 );
            } catch ( InterruptedException e ) {
                System.err.println ( "Am I interrupted?" );
            }
            lockedWindow.wasVisible = ( ( RootPaneContainer ) window ).getContentPane().isVisible();
            ( ( RootPaneContainer ) window ).getContentPane().repaint();
            if ( window instanceof Frame ) {
                Frame frame = ( Frame ) window;
                lockedWindow.minimized = ( frame.getExtendedState() & Frame.ICONIFIED ) != 0;
                if ( lockMinimized ) {
                    frame.setExtendedState ( Frame.ICONIFIED );
                }
            }
        } catch ( Exception e ) {
            System.err.println ( getThreadPrefix()  + " Failed to lock window." + e.getLocalizedMessage() );
        } finally {
            switchToNormalCursorEventThread ( window, timer );
        }
    }
}
