private void unlockWindow ( RootPaneContainer window ) {
    try {
        LockedWindow lockedWindow = lockedWindows.get ( window );
        if ( lockedWindow != null && ( ( Frame ) window ).isDisplayable() ) {
            System.err.println ( getThreadPrefix() + "Unlocking..." + lockedWindow );
            if ( lockedWindow.originalGlassPane != null ) {
                System.err.println ( getThreadPrefix() + "Reset original glass pane." );
                window.setGlassPane ( lockedWindow.originalGlassPane );
            }
            ( window ).getContentPane().setVisible ( lockedWindow.wasVisible );
            ( window ).getRootPane().repaint();
            if ( !lockedWindow.minimized && window instanceof Frame ) {
                ( ( Frame ) window ).setExtendedState ( ( ( Frame ) window ).getExtendedState()
                                                        & ~Frame.ICONIFIED );
            }
            if ( window instanceof Window ) {
                if ( lockedWindow.windowListeners != null ) {
                    for ( WindowListener wl : lockedWindow.windowListeners ) {
                        System.err.print ( "windowlistener is not null " + wl );
                        ( ( Window ) window ).addWindowListener ( wl );
                    }
                }
                if ( window instanceof JFrame ) {
                    ( ( JFrame ) window )
                    .setDefaultCloseOperation ( lockedWindow.originalDefaultCloseOperation );
                } else if ( window instanceof JDialog ) {
                    ( ( JDialog ) window )
                    .setDefaultCloseOperation ( lockedWindow.originalDefaultCloseOperation );
                }
            }
            stopEventTrap ( ( Frame ) window );
            System.err.println ( getThreadPrefix()  + " Window has been unlocked" );
        }
    } catch ( Exception e ) {
        System.err.println ( getThreadPrefix()  + " Failed to unlock window. " + e.getLocalizedMessage() );
    }
}
