import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.EventQueue;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.io.File;
import java.io.IOException;
import javax.imageio.ImageIO;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
public class OverlayLabel {
    public static void main ( String[] args ) {
        new OverlayLabel();
    }
    public OverlayLabel() {
        EventQueue.invokeLater ( new Runnable() {
            @Override
            public void run() {
                try {
                    try {
                        UIManager.setLookAndFeel ( UIManager.getSystemLookAndFeelClassName() );
                    } catch ( ClassNotFoundException | InstantiationException | IllegalAccessException | UnsupportedLookAndFeelException ex ) {
                        ex.printStackTrace();
                    }
                    JLabel background = new JLabel ( new ImageIcon ( ImageIO.read ( new File ( "/path/to/image" ) ) ) );
                    background.setLayout ( new BorderLayout() );
                    background.add ( new TestPane() );
                    JFrame frame = new JFrame ( "Testing" );
                    frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
                    frame.add ( background );
                    frame.pack();
                    frame.setLocationRelativeTo ( null );
                    frame.setVisible ( true );
                } catch ( IOException ex ) {
                    ex.printStackTrace();
                }
            }
        } );
    }
    public class TestPane extends JPanel {
        public TestPane() {
            setOpaque ( false );
        }
        @Override
        public Dimension getPreferredSize() {
            return new Dimension ( 200, 200 );
        }
        @Override
        protected void paintComponent ( Graphics g ) {
            super.paintComponent ( g );
            Graphics g2d = ( Graphics2D ) g.create();
            int x = ( getWidth() - 20 ) / 2;
            int y = ( getHeight() - 20 ) / 2;
            g2d.setColor ( Color.RED );
            g2d.fillRect ( x, y, 20, 20 );
            g2d.dispose();
        }
    }
}
