import ddf.minim.analysis.*;
import ddf.minim.*;
Minim       minim;
AudioPlayer in;
FFT         fft;
float smoothing = 0.60;
final boolean useDB = true;
final int minBandwidthPerOctave = 200;
final int bandsPerOctave = 10;
float[] fftSmooth;
int avgSize;
float minVal = 0.0;
float maxVal = 0.0;
boolean firstMinDone = false;
void setup() {
    minim = new Minim ( this );
    in = minim.loadFile ( "C:\\path\\to\\some\\audio\\file.ext", 2048 );
    in.loop();
    fft = new FFT ( in.bufferSize(), in.sampleRate() );
    fft.logAverages ( minBandwidthPerOctave, bandsPerOctave );
    avgSize = fft.avgSize();
    fftSmooth = new float[avgSize];
    int myWidth = 500;
    int myHeight = 250;
    size ( myWidth, myHeight );
    colorMode ( HSB, avgSize, 100, 100 );
}
float dB ( float x ) {
    if ( x == 0 ) {
        return 0;
    } else {
        return 10 * ( float ) Math.log10 ( x );
    }
}
void draw() {
    background ( 0 );
    stroke ( 255 );
    fft.forward ( in.mix );
    final int weight = width / avgSize;
    final float maxHeight = ( height / 2 ) * 0.75;
    for ( int i = 0; i < avgSize; i++ ) {
        float fftCurr;
        if ( useDB ) {
            fftCurr = dB ( fft.getAvg ( i ) );
        } else {
            fftCurr = fft.getAvg ( i );
        }
        fftSmooth[i] = ( smoothing ) * fftSmooth[i] + ( ( 1 - smoothing ) * fftCurr );
        if ( fftSmooth[i] > maxVal ) {
            maxVal = fftSmooth[i];
        }
        if ( !firstMinDone || ( fftSmooth[i] < minVal ) ) {
            minVal = fftSmooth[i];
        }
    }
    final float range = maxVal - minVal;
    final float scaleFactor = range + 0.00001;
    for ( int i = 0; i < avgSize; i++ ) {
        stroke ( i, 100, 100 );
        strokeWeight ( weight );
        float fftSmoothDisplay = maxHeight * ( ( fftSmooth[i] - minVal ) / scaleFactor );
        float x = i * weight;
        line ( x, height / 2, x, height / 2 - fftSmoothDisplay );
    }
    text ( "smoothing: " + ( int ) ( smoothing * 100 ) + "\n", 10, 10 );
}
void keyPressed() {
    float inc = 0.01;
    if ( keyCode == UP && smoothing < 1 - inc ) {
        smoothing += inc;
    }
    if ( keyCode == DOWN && smoothing > inc ) {
        smoothing -= inc;
    }
}
