public List<Class<?>> findImplementingClassesInJarFile ( File file, Class<?> iface, ClassLoader loader ) throws Exception {
    List<Class<?>> implementingClasses = new ArrayList<Class<?>>();
    for ( String classFile : scanJarFileForClasses ( file ) ) {
        Class<?> clazz;
        try {
            if ( loader == null ) {
                clazz = Class.forName ( classFile );
            } else {
                clazz = Class.forName ( classFile, true, loader );
            }
            if ( iface.isAssignableFrom ( clazz ) && !clazz.equals ( iface ) ) {
                implementingClasses.add ( clazz );
            }
        } catch ( ClassNotFoundException e ) {
            e.printStackTrace();
        }
    }
    return implementingClasses;
}
