import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
class ComboBoxRenderer extends JLabel implements ListCellRenderer {
    private boolean colorSet;
    private Color selectionBackgroundColor;
    public ComboBoxRenderer() {
        setOpaque ( true );
        setHorizontalAlignment ( LEFT );
        setVerticalAlignment ( CENTER );
        colorSet = false;
        selectionBackgroundColor = Color.red;
    }
    public Component getListCellRendererComponent ( JList list, Object value, int index, boolean isSelected, boolean cellHasFocus ) {
        if ( !colorSet ) {
            selectionBackgroundColor = list.getSelectionBackground();
            colorSet = true;
        }
        list.setSelectionBackground ( Color.white );
        if ( isSelected ) {
            setBackground ( selectionBackgroundColor );
        } else {
            setBackground ( Color.white );
        }
        setText ( ( String ) value );
        setFont ( list.getFont() );
        return this;
    }
}
