public class RezeptArrayAdapter extends ArrayAdapter<String> {
    public final Context context;
    public final String[] values;
    final DBHandler_Rezepte db_Rzpt;
    Typeface tf;
    public RezeptArrayAdapter ( Context context, String[] values ) {
        super ( context, R.layout.list_rezepte, values );
        this.context = context;
        this.values = values;
        db_Rzpt = new DBHandler_Rezepte ( context );
        tf = Typeface.createFromAsset ( context.getAssets(), "fonts/OFLGoudyStMTT.ttf" );
    }
    @Override
    public View getView ( int position, View convertView, ViewGroup parent ) {
        LayoutInflater inflater = ( LayoutInflater ) context
                                  .getSystemService ( Context.LAYOUT_INFLATER_SERVICE );
        ConDB_Rezepte data = db_Rzpt.getConDB_Rezepte ( position );
        View rowView = inflater.inflate ( R.layout.list_rezepte, parent, false );
        TextView textView = ( TextView ) rowView.findViewById ( R.id.label );
        ImageView imageView = ( ImageView ) rowView.findViewById ( R.id.logo );
        RatingBar ratingbar1 = ( RatingBar ) rowView.findViewById ( R.id.ratingBar1 );
        ratingbar1.setIsIndicator ( true );
        textView.setText ( values[position] );
        textView.setTypeface ( tf );
        String pos = values[position];
        imageView.setImageResource ( data.getIcon() );
        ratingbar1.setRating ( data.getrating() );
        return rowView;
    }
}
