@Override
protected void onCreate ( Bundle savedInstanceState ) {
    super.onCreate ( savedInstanceState );
    setContentView ( R.layout.basic_demo );
    mMap = ( ( SupportMapFragment )  getSupportFragmentManager().findFragmentById ( R.id.map2 ) ).getMap();
    mMap.setMyLocationEnabled ( true );
    setUpMap();
    findSMSLocation();
    mMap.setInfoWindowAdapter ( new InfoWindowAdapter() {
        @Override
        public View getInfoWindow ( Marker marker )   {
            return null;
        }
        @Override
        public View getInfoContents ( Marker marker ) {
            View v = getLayoutInflater().inflate ( R.layout.custom_info, null );
            TextView tvLat = ( TextView )  v.findViewById ( R.id.info );
            tvLat.setText ( "info" );
            tvLat.setTextColor ( Color.GREEN );
            return v;
        }
    } );
}
@Override
protected void onPause() {
    super.onPause();
}
@Override
protected void onResume() {
    super.onResume();
    setUpMapIfNeeded();
}
public void findSMSLocation() {
    try {
        mMap.addMarker ( new MarkerOptions().position ( SECC ).title ( "SECC" ).snippet ( "Exhibition Way, Glasgow, G3 8YW\nSports: Boxing, Gymnastics, Judo, Netball, Wrestling, Weightlifting" ) );
        mMap.animateCamera ( CameraUpdateFactory.newLatLngZoom ( SECC, 18.0f ) );
    } catch ( Exception e ) {
        e.printStackTrace();
    }
}
private void setUpMapIfNeeded() {
    if ( mMap == null ) {
        mMap = ( ( SupportMapFragment ) getSupportFragmentManager().findFragmentById ( R.id.map2 ) )
               .getMap();
        mMap.setMyLocationEnabled ( true );
        if ( mMap != null ) {
            setUpMap();
        }
    }
}
private void setUpMap() {
    mMap.getUiSettings().setCompassEnabled ( true );
    mMap.getUiSettings().setTiltGesturesEnabled ( true );
    mMap.getUiSettings().setRotateGesturesEnabled ( true );
    mMap.getUiSettings().setScrollGesturesEnabled ( true );
    mMap.getUiSettings().setZoomControlsEnabled ( true );
    mMap.getUiSettings().setZoomGesturesEnabled ( true );
}
@Override
public boolean onMarkerClick ( Marker marker ) {
    return false;
}
