@Service
public class DeactivationService {
    private static final Logger LOG = Logger.getLogger ( DeactivationService.class );
    @Autowired
    @Qualifier ( "SkuAmerDao" )
    private SkuDAO amerdao;
    @Autowired
    @Qualifier ( "SkuEMEADao" )
    private SkuDAO emeadao;
}
public abstract class BaseDao implements SkuDAO {
    private final JdbcTemplate jdbcTemplate;
    protected BaseDao() {
        this.jdbcTemplate = new JdbcTemplate ( getDataSource() );
    }
    protected abstract DataSource getDataSource();
    public List<Sku> find() {
    }
    public void deactivate ( List<Sku> ) {
    }
}
@Repository ( "SkuAmerDao" )
public class SkuAmerDAOImpl extends BaseDao {
    @Autowired
    @Qualifier ( "AmericasDataSource" )
    private DataSource datasource;
    @Override
    protected DataSource getDatasource() {
        return dataSource;
    }
}
@Repository ( "SkuEMEADao" )
public class SkuEMEADAOImpl extends BaseDao {
    @Autowired
    @Qualifier ( "EMEADataSource" )
    private DataSource datasource;
    @Override
    protected DataSource getDatasource() {
        return dataSource;
    }
}
