public class GPScom implements SerialPortEventListener {
    private String portcom;
    private CommPortIdentifier portid = null;
    private SerialPort serialport;
    private BufferedReader fluxgps;
    public static void main ( String[]args ) {
        Win32Driver driver = new Win32Driver();
        driver.initialize();
        GPScom gpscom = new GPScom();
        gpscom.listPort();
    }
    public void listPort() {
        Enumeration listport = CommPortIdentifier.getPortIdentifiers();
        int typeport;
        String GPSPortCOM;
        while ( listport.hasMoreElements() ) {
            portid = ( CommPortIdentifier ) ( CommPortIdentifier ) listport.nextElement();
            if ( portid.getPortType() == CommPortIdentifier.PORT_SERIAL ) {
                System.out.println ( "Port Name : " + portid.getName() );
                System.out.println ( "User : " + portid.getCurrentOwner() );
                System.out.println ( "Use ? : " + portid.isCurrentlyOwned() );
                System.out.println ( "Port type : " + portid.getPortType() );
                this.ModeEvenement ( portid.getName() );
            }
        }
    }
    public void ModeEvenement ( String portcom ) {
        try {
            portid = CommPortIdentifier.getPortIdentifier ( portcom );
        } catch ( NoSuchPortException e ) {
            System.out.println ( e );
        }
        try {
            serialport = ( SerialPort ) portid.open ( "ModeEvenement", 2000 );
        } catch ( PortInUseException e ) {
            System.out.println ( e );
        }
        try {
            fluxgps = new BufferedReader ( new InputStreamReader ( serialport.getInputStream() ) );
        } catch ( IOException e ) {
            System.out.println ( e );
        }
        try {
            serialport.addEventListener ( this );
        } catch ( TooManyListenersException e ) {
            System.out.println ( e );
        }
        serialport.notifyOnDataAvailable ( true );
        try {
            serialport.setSerialPortParams ( 4800, SerialPort.DATABITS_6, SerialPort.STOPBITS_1, SerialPort.PARITY_NONE );
        } catch ( UnsupportedCommOperationException e ) {
            System.out.println ( e );
        }
        System.out.println ( "Port is open, waiting for the reading" );
    }
    public void ReadSerialPort() {
        int i = 7;
        String reponse = new String();
        try {
            System.out.println ( "i=" + i );
            while ( i != 0 ) {
                System.out.println ( "Reading the COM port \n" );
                reponse = ( String ) fluxgps.readLine();
                System.out.println ( reponse );
                i--;
                System.out.println ( "i=" + i );
            }
        } catch ( IOException e ) {
            System.out.println ( e );
        }
        try {
            fluxgps.close();
        } catch ( IOException e ) {
            System.out.println ( e );
        }
        serialport.close();
    }
    public void serialEvent ( SerialPortEvent event ) {
        switch ( event.getEventType() ) {
        case SerialPortEvent.DATA_AVAILABLE:
            this.ReadSerialPort();
            break;
        default:
            break;
        }
    }
}
