public static boolean hasPathHelper ( int[][] m, int[][] v, int i, int j ) {
    if ( i < 0 || j < 0 || i >= m.length || j >= m[0].length || v[i][j] >= 0 ) {
        return false;
    }
    v[i][j] = 0;
    if ( m[i][j] == 0 ) {
        return false;
    }
    if ( j == m[0].length - 1 ||
            hasPathHelper ( m, v, i - 1, j + 1 ) ||
            hasPathHelper ( m, v, i + 1, j + 1 ) ||
            hasPathHelper ( m, v, i + 1, j - 1 ) ||
            hasPathHelper ( m, v, i + 1, j - 1 ) ||
            hasPathHelper ( m, v, i + 1, j ) ||
            hasPathHelper ( m, v, i - 1, j ) ||
            hasPathHelper ( m, v, i    , j + 1 ) ||
            hasPathHelper ( m, v, i    , j - 1 )
       ) {
        v[i][j] = 1;
    }
    return v[i][j] == 1;
}
public static boolean hasPath ( int[][] m, int[][] v ) {
    for ( int i = 0; i < m.length; i++ )
        if ( hasPathHelper ( m, v, i, 0 ) ) {
            return true;
        }
    return false;
}
public static void main ( String... args ) {
    int[][] m = { {0, 1, 1, 1, 0},
        {1, 0, 0, 1, 0},
        {0, 0, 1, 1, 0},
        {0, 1, 0, 0, 0},
        {0, 0, 1, 1, 1}
    };
    int[][] v = new int[5][5];
    for ( int i = 0; i < 5; i++ ) {
        Arrays.fill ( v[i], -1 );
    }
    System.out.println ( "Has Path?: " + hasPath ( m, v ) );
    System.out.println ( "Path Matrix: " );
    for ( int i = 0; i < v.length; i++ ) {
        System.out.println ( Arrays.toString ( v[i] ) );
    }
}
