private class Searcher implements Runnable {
    private volatile boolean cancelled = false;
    private final String searchTerm;
    Searcher ( String searchTerm ) {
        this.searchTerm = searchTerm;
    }
    public void cancel() {
        cancelled = true;
    }
    @Override
    public void run() {
        if ( !cancelled ) {
            manager.searchString ( searchTerm );
            Platform.runLater ( listViewUpdater );
        }
    }
}
private Runnable listViewUpdater = new Runnable() {
    @Override
    public void run() {
        listView.getItems().setAll ( manager.getList() );
    }
}
private ExecutorService executor = Executors.newSingleThreadExecutor();
private Searcher lastSearcher = null;
search.textProperty().addListener ( new ChangeListener<String>() {
    @Override
    public void changed ( ObservableValue<? extends String> observableValue, String s, String s2 ) {
        if ( lastSearcher != null ) {
            lastSearcher.cancel();
        }
        lastSearcher = new Searcher ( s2 );
        executor.submit ( lastSearcher );
    }
} );
