public GameVector[] getVertices ( GameObject obj ) {
    final GameVector topLeft = new GameVector ( obj.mPosition.x - 0.06f - ( obj.mWidth / 2 ), obj.mPosition.y + 0.06f + ( obj.mHeight / 2 ) );
    final GameVector topRight = new GameVector ( obj.mPosition.x + 0.06f + ( obj.mWidth / 2 ), obj.mPosition.y + 0.06f + ( obj.mHeight / 2 ) );
    final GameVector bottomLeft = new GameVector ( obj.mPosition.x - 0.06f - ( obj.mWidth / 2 ), obj.mPosition.y - 0.06f - ( obj.mHeight / 2 ) );
    final GameVector bottomRight = new GameVector ( obj.mPosition.x + 0.06f + ( obj.mWidth / 2 ), obj.mPosition.y - 0.06f - ( obj.mHeight / 2 ) );
    GameVector[] vertices = { topLeft, topRight, bottomRight, bottomLeft };
    return vertices;
}
public GameVector[] getAxis ( GameObject shape ) {
    GameVector[] vertices = getVertices ( shape );
    GameVector[] axes = new GameVector[vertices.length];
    for ( int i = 0; i < vertices.length; i++ ) {
        GameVector p1 = vertices[i];
        GameVector p2 = vertices[i + 1 == vertices.length ? 0 : i + 1];
        GameVector edge = p1.subtract ( p2.x, p2.y );
        GameVector normal;
        normal = new GameVector ( edge.y, -edge.x );
        axes[i] = normal;
    }
    return axes;
}
public float dotProduct ( GameVector a, GameVector b ) {
    float dp = a.x * b.x + a.y * b.y;
    return dp;
}
public class Projection {
    private final float min;
    private final float max;
    public Projection ( float min, float max ) {
        this.min = min;
        this.max = max;
    }
    public boolean doesOverlap ( final Projection other ) {
        return ! ( this.min > other.max || other.min > this.max );
    }
}
