package com.example.nfc;
import android.nfc.NfcAdapter;
import android.os.Bundle;
import android.app.Activity;
import android.app.PendingIntent;
import android.content.Intent;
import android.widget.Toast;
public class MainActivity extends Activity {
    public static final String MIME_TEXT_PLAIN = "text/plain";
    public static final String TAG = "NfcDemo";
    private NfcAdapter mNfcAdapter;
    @Override
    protected void onCreate ( Bundle savedInstanceState ) {
        super.onCreate ( savedInstanceState );
        setContentView ( R.layout.activity_main );
        mNfcAdapter = NfcAdapter.getDefaultAdapter ( this );
        if ( mNfcAdapter == null ) {
            Toast.makeText ( this, "Dit apparaat ondersteund geen NFC.", Toast.LENGTH_LONG ).show();
            finish();
            return;
        }
        if ( !mNfcAdapter.isEnabled() ) {
            Toast.makeText ( this, "NFC staat niet aan", Toast.LENGTH_SHORT ).show();
        }
        handleIntent ( getIntent() );
    }
    @Override
    protected void onResume() {
        super.onResume();
        setupForegroundDispatch ( this, mNfcAdapter );
    }
    @Override
    protected void onPause() {
        stopForegroundDispatch ( this, mNfcAdapter );
        super.onPause();
    }
    @Override
    protected void onNewIntent ( Intent intent ) {
        handleIntent ( intent );
    }
    private void handleIntent ( Intent intent ) {
        if ( intent != null && intent.getAction().contains ( "android.nfc" ) ) {
        }
    }
    public static void setupForegroundDispatch ( final Activity activity, NfcAdapter adapter ) {
        final Intent intent = new Intent ( activity.getApplicationContext(), activity.getClass() );
        intent.setFlags ( Intent.FLAG_ACTIVITY_SINGLE_TOP );
        final PendingIntent pendingIntent = PendingIntent.getActivity ( activity.getApplicationContext(), 0, intent, 0 );
        String[][] techList = new String[][] {};
        adapter.enableForegroundDispatch ( activity, pendingIntent, null, techList );
    }
    public static void stopForegroundDispatch ( final Activity activity, NfcAdapter adapter ) {
        adapter.disableForegroundDispatch ( activity );
    }
}
