package com.examples.youtubeapidemo;
import static android.view.ViewGroup.LayoutParams.MATCH_PARENT;
import static android.view.ViewGroup.LayoutParams.WRAP_CONTENT;
import com.google.android.youtube.player.YouTubeInitializationResult;
import com.google.android.youtube.player.YouTubePlayer;
import com.google.android.youtube.player.YouTubePlayer.OnFullscreenListener;
import com.google.android.youtube.player.YouTubePlayer.OnInitializedListener;
import com.google.android.youtube.player.YouTubePlayer.Provider;
import com.google.android.youtube.player.YouTubePlayerFragment;
import com.google.android.youtube.player.YouTubeThumbnailLoader;
import com.google.android.youtube.player.YouTubeThumbnailLoader.ErrorReason;
import com.google.android.youtube.player.YouTubeThumbnailView;
import android.annotation.SuppressLint;
import android.annotation.TargetApi;
import android.app.Activity;
import android.app.ListFragment;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.res.Configuration;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.ViewGroup.LayoutParams;
import android.widget.BaseAdapter;
import android.widget.FrameLayout;
import android.widget.ListView;
import android.widget.TextView;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ExecutionException;
import org.apache.http.HttpResponse;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpUriRequest;
import org.apache.http.impl.client.DefaultHttpClient;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
@TargetApi ( 13 )
public final class VideoListDemoActivity extends Activity implements OnFullscreenListener {
    private static final int ANIMATION_DURATION_MILLIS = 300;
    private static final int LANDSCAPE_VIDEO_PADDING_DP = 5;
    private VideoListFragment listFragment;
    private VideoFragment videoFragment;
    private View videoBox;
    private View closeButton;
    private boolean isFullscreen;
    private static String url = "http://gdata.youtube.com/feeds/api/users/DayAndNightNewsChd/uploads?v=2&alt=jsonc";
    public static List<VideoEntry> VIDEO_LIST;
    public static List<VideoEntry> list = new ArrayList<VideoEntry>();
    @Override
    protected void onCreate ( Bundle savedInstanceState ) {
        super.onCreate ( savedInstanceState );
        JSONParse myAsyncTask = new JSONParse();
        myAsyncTask.execute();
        try {
            if ( myAsyncTask.get() == true ) {
                setContentView ( R.layout.video_list_demo );
                listFragment = ( VideoListFragment ) getFragmentManager().findFragmentById ( R.id.list_fragment );
                videoFragment =
                    ( VideoFragment ) getFragmentManager().findFragmentById ( R.id.video_fragment_container );
                closeButton = findViewById ( R.id.close_button );
                videoBox = findViewById ( R.id.video_box );
                videoBox.setVisibility ( View.INVISIBLE );
                layout();
            }
        } catch ( InterruptedException e ) {
            e.printStackTrace();
        } catch ( ExecutionException e ) {
            e.printStackTrace();
        }
    }
    private class JSONParse extends AsyncTask<Void, Void, Boolean> {
        private ProgressDialog pDialog;
        @Override
        protected void onPreExecute() {
            super.onPreExecute();
            pDialog = new ProgressDialog ( VideoListDemoActivity.this );
            pDialog.setMessage ( "Getting Data ..." );
            pDialog.setIndeterminate ( false );
            pDialog.setCancelable ( false );
            pDialog.show();
        }
        @Override
        protected Boolean doInBackground ( Void... arg0 ) {
            boolean status = false;
            try {
                HttpClient client = new DefaultHttpClient();
                HttpUriRequest request = new HttpGet ( url );
                HttpResponse response = client.execute ( request );
                String jsonString = StreamUtils.convertToString ( response.getEntity().getContent() );
                JSONObject json = new JSONObject ( jsonString );
                JSONArray jsonArray = json.getJSONObject ( "data" ).getJSONArray ( "items" );
                for ( int i = 0; i < jsonArray.length(); i++ ) {
                    JSONObject jsonObject = jsonArray.getJSONObject ( i );
                    String title = jsonObject.getString ( "title" );
                    String video = jsonObject.getString ( "id" );
                    list.add ( new VideoEntry ( title, video ) );
                }
            } catch ( ClientProtocolException e ) {
            } catch ( IOException e ) {
            } catch ( JSONException e ) {
            }
            VIDEO_LIST = Collections.unmodifiableList ( list );
            status = true;
            return status;
        }
        @Override
        protected void onPostExecute ( Boolean result ) {
            pDialog.dismiss();
        }
    }
    @Override
    public void onConfigurationChanged ( Configuration newConfig ) {
        super.onConfigurationChanged ( newConfig );
        layout();
    }
    @Override
    public void onFullscreen ( boolean isFullscreen ) {
        this.isFullscreen = isFullscreen;
        layout();
    }
    private void layout() {
        boolean isPortrait =
            getResources().getConfiguration().orientation == Configuration.ORIENTATION_PORTRAIT;
        listFragment.getView().setVisibility ( isFullscreen ? View.GONE : View.VISIBLE );
        listFragment.setLabelVisibility ( isPortrait );
        closeButton.setVisibility ( isPortrait ? View.VISIBLE : View.GONE );
        if ( isFullscreen ) {
            videoBox.setTranslationY ( 0 );
            setLayoutSize ( videoFragment.getView(), MATCH_PARENT, MATCH_PARENT );
            setLayoutSizeAndGravity ( videoBox, MATCH_PARENT, MATCH_PARENT, Gravity.TOP | Gravity.LEFT );
        } else if ( isPortrait ) {
            setLayoutSize ( listFragment.getView(), MATCH_PARENT, MATCH_PARENT );
            setLayoutSize ( videoFragment.getView(), MATCH_PARENT, WRAP_CONTENT );
            setLayoutSizeAndGravity ( videoBox, MATCH_PARENT, WRAP_CONTENT, Gravity.BOTTOM );
        } else {
            videoBox.setTranslationY ( 0 );
            int screenWidth = dpToPx ( getResources().getConfiguration().screenWidthDp );
            setLayoutSize ( listFragment.getView(), screenWidth / 4, MATCH_PARENT );
            int videoWidth = screenWidth - screenWidth / 4 - dpToPx ( LANDSCAPE_VIDEO_PADDING_DP );
            setLayoutSize ( videoFragment.getView(), videoWidth, WRAP_CONTENT );
            setLayoutSizeAndGravity ( videoBox, videoWidth, WRAP_CONTENT,
                                      Gravity.RIGHT | Gravity.CENTER_VERTICAL );
        }
    }
    @SuppressLint ( "NewApi" )
    public void onClickClose ( @SuppressWarnings ( "unused" ) View view ) {
        listFragment.getListView().clearChoices();
        listFragment.getListView().requestLayout();
        videoFragment.pause();
        videoBox.animate()
        .translationYBy ( videoBox.getHeight() )
        .setDuration ( ANIMATION_DURATION_MILLIS )
        .withEndAction ( new Runnable() {
            @Override
            public void run() {
                videoBox.setVisibility ( View.INVISIBLE );
            }
        } );
    }
    public static final class VideoListFragment extends ListFragment {
        private PageAdapter adapter;
        private View videoBox;
        @Override
        public void onCreate ( Bundle savedInstanceState ) {
            super.onCreate ( savedInstanceState );
            adapter = new PageAdapter ( getActivity(), VIDEO_LIST );
        }
        @Override
        public void onActivityCreated ( Bundle savedInstanceState ) {
            super.onActivityCreated ( savedInstanceState );
            videoBox = getActivity().findViewById ( R.id.video_box );
            getListView().setChoiceMode ( ListView.CHOICE_MODE_SINGLE );
            setListAdapter ( adapter );
        }
        @Override
        public void onListItemClick ( ListView l, View v, int position, long id ) {
            String videoId = VIDEO_LIST.get ( position ).videoId;
            VideoFragment videoFragment =
                ( VideoFragment ) getFragmentManager().findFragmentById ( R.id.video_fragment_container );
            videoFragment.setVideoId ( videoId );
            if ( videoBox.getVisibility() != View.VISIBLE ) {
                if ( getResources().getConfiguration().orientation == Configuration.ORIENTATION_PORTRAIT ) {
                    videoBox.setTranslationY ( videoBox.getHeight() );
                }
                videoBox.setVisibility ( View.VISIBLE );
            }
            if ( videoBox.getTranslationY() > 0 ) {
                videoBox.animate().translationY ( 0 ).setDuration ( ANIMATION_DURATION_MILLIS );
            }
        }
        @Override
        public void onDestroyView() {
            super.onDestroyView();
            adapter.releaseLoaders();
        }
        public void setLabelVisibility ( boolean visible ) {
            adapter.setLabelVisibility ( visible );
        }
    }
    private static final class PageAdapter extends BaseAdapter {
        private final List<VideoEntry> entries;
        private final List<View> entryViews;
        private final Map<YouTubeThumbnailView, YouTubeThumbnailLoader> thumbnailViewToLoaderMap;
        private final LayoutInflater inflater;
        private final ThumbnailListener thumbnailListener;
        private boolean labelsVisible;
        public PageAdapter ( Context context, List<VideoEntry> entries ) {
            this.entries = entries;
            entryViews = new ArrayList<View>();
            thumbnailViewToLoaderMap = new HashMap<YouTubeThumbnailView, YouTubeThumbnailLoader>();
            inflater = LayoutInflater.from ( context );
            thumbnailListener = new ThumbnailListener();
            labelsVisible = true;
        }
        public void releaseLoaders() {
            for ( YouTubeThumbnailLoader loader : thumbnailViewToLoaderMap.values() ) {
                loader.release();
            }
        }
        public void setLabelVisibility ( boolean visible ) {
            labelsVisible = visible;
            for ( View view : entryViews ) {
                view.findViewById ( R.id.text ).setVisibility ( visible ? View.VISIBLE : View.GONE );
            }
        }
        @Override
        public int getCount() {
            return entries.size();
        }
        @Override
        public VideoEntry getItem ( int position ) {
            return entries.get ( position );
        }
        @Override
        public long getItemId ( int position ) {
            return 0;
        }
        @Override
        public View getView ( int position, View convertView, ViewGroup parent ) {
            View view = convertView;
            VideoEntry entry = entries.get ( position );
            if ( view == null ) {
                view = inflater.inflate ( R.layout.video_list_item, parent, false );
                YouTubeThumbnailView thumbnail = ( YouTubeThumbnailView ) view.findViewById ( R.id.thumbnail );
                thumbnail.setTag ( entry.videoId );
                thumbnail.initialize ( DeveloperKey.DEVELOPER_KEY, thumbnailListener );
            } else {
                YouTubeThumbnailView thumbnail = ( YouTubeThumbnailView ) view.findViewById ( R.id.thumbnail );
                YouTubeThumbnailLoader loader = thumbnailViewToLoaderMap.get ( thumbnail );
                if ( loader == null ) {
                    thumbnail.setTag ( entry.videoId );
                } else {
                    thumbnail.setImageResource ( R.drawable.loading_thumbnail );
                    loader.setVideo ( entry.videoId );
                }
            }
            TextView label = ( ( TextView ) view.findViewById ( R.id.text ) );
            label.setText ( entry.text );
            label.setVisibility ( labelsVisible ? View.VISIBLE : View.GONE );
            return view;
        }
        private final class ThumbnailListener implements
            YouTubeThumbnailView.OnInitializedListener,
            YouTubeThumbnailLoader.OnThumbnailLoadedListener {
            @Override
            public void onInitializationSuccess (
                YouTubeThumbnailView view, YouTubeThumbnailLoader loader ) {
                loader.setOnThumbnailLoadedListener ( this );
                thumbnailViewToLoaderMap.put ( view, loader );
                view.setImageResource ( R.drawable.loading_thumbnail );
                String videoId = ( String ) view.getTag();
                loader.setVideo ( videoId );
            }
            @Override
            public void onInitializationFailure (
                YouTubeThumbnailView view, YouTubeInitializationResult loader ) {
                view.setImageResource ( R.drawable.no_thumbnail );
            }
            @Override
            public void onThumbnailLoaded ( YouTubeThumbnailView view, String videoId ) {
            }
            @Override
            public void onThumbnailError ( YouTubeThumbnailView view, ErrorReason errorReason ) {
                view.setImageResource ( R.drawable.no_thumbnail );
            }
        }
    }
    public static final class VideoFragment extends YouTubePlayerFragment
        implements OnInitializedListener {
        private YouTubePlayer player;
        private String videoId;
        public static VideoFragment newInstance() {
            return new VideoFragment();
        }
        @Override
        public void onCreate ( Bundle savedInstanceState ) {
            super.onCreate ( savedInstanceState );
            initialize ( DeveloperKey.DEVELOPER_KEY, this );
        }
        @Override
        public void onDestroy() {
            if ( player != null ) {
                player.release();
            }
            super.onDestroy();
        }
        public void setVideoId ( String videoId ) {
            if ( videoId != null && !videoId.equals ( this.videoId ) ) {
                this.videoId = videoId;
                if ( player != null ) {
                    player.cueVideo ( videoId );
                }
            }
        }
        public void pause() {
            if ( player != null ) {
                player.pause();
            }
        }
        @Override
        public void onInitializationSuccess ( Provider provider, YouTubePlayer player, boolean restored ) {
            this.player = player;
            player.addFullscreenControlFlag ( YouTubePlayer.FULLSCREEN_FLAG_CUSTOM_LAYOUT );
            player.setOnFullscreenListener ( ( VideoListDemoActivity ) getActivity() );
            if ( !restored && videoId != null ) {
                player.cueVideo ( videoId );
            }
        }
        @Override
        public void onInitializationFailure ( Provider provider, YouTubeInitializationResult result ) {
            this.player = null;
        }
    }
    private static final class VideoEntry {
        private final String text;
        private final String videoId;
        public VideoEntry ( String text, String videoId ) {
            this.text = text;
            this.videoId = videoId;
        }
    }
    private int dpToPx ( int dp ) {
        return ( int ) ( dp * getResources().getDisplayMetrics().density + 0.5f );
    }
    private static void setLayoutSize ( View view, int width, int height ) {
        LayoutParams params = view.getLayoutParams();
        params.width = width;
        params.height = height;
        view.setLayoutParams ( params );
    }
    private static void setLayoutSizeAndGravity ( View view, int width, int height, int gravity ) {
        FrameLayout.LayoutParams params = ( FrameLayout.LayoutParams ) view.getLayoutParams();
        params.width = width;
        params.height = height;
        params.gravity = gravity;
        view.setLayoutParams ( params );
    }
}
