import java.util.Arrays;
import java.util.Scanner;
public class Hangman implements Runnable {
    private int lives = 7;
    private char[] hiddenWord;
    private char[] aOfWord;
    private String[] words = { "ADA", "COBOL", "LOGO", "BASIC", "PROLOG", "UBUNTU", "UHURU" };
    @Override
    public void run() {
        try ( Scanner scan = new Scanner ( System.in ) ) {
            System.out.println ( "Enter the word to be searched: " );
            String inputw = scan.nextLine();
            aOfWord = inputw.toCharArray();
            hiddenWord = new char[aOfWord.length];
            Arrays.fill ( hiddenWord, '_' );
            showStatus();
            while ( lives > 0 && Arrays.equals ( aOfWord, hiddenWord ) == false ) {
                System.out.println ( "Please choose a letter: " );
                String guessletter = scan.nextLine();
                if ( guessletter.isEmpty() ) {
                    System.out.println ( "You must enter a letter. Try again!" );
                } else {
                    checkForMatch ( guessletter );
                }
            }
            System.out.println ( "Game over, you " + ( lives > 0 ? "won" : "lost" ) );
        } catch ( Exception e ) {
            System.err.println ( "Error: " + e.getMessage() );
        }
    }
    private void checkForMatch ( String letter ) {
        boolean found = false;
        for ( int i = 0; i < aOfWord.length; i++ ) {
            if ( letter.charAt ( 0 ) == aOfWord[i] ) {
                found = true;
                hiddenWord[i] = letter.charAt ( 0 );
            }
        }
        if ( !found ) {
            reduceLives();
        }
        showStatus();
    }
    private void reduceLives() {
        lives = lives - 1;
        switch ( lives ) {
        case 6:
            System.out.println ( "_____" );
            System.out.println ( "|   |" );
            System.out.println ( "|   " );
            System.out.println ( "|   " );
            System.out.println ( "|   " );
            break;
        case 5:
            System.out.println ( "_____" );
            System.out.println ( "|   |" );
            System.out.println ( "|   o" );
            System.out.println ( "|    " );
            System.out.println ( "|    " );
            break;
        case 4:
            System.out.println ( "_____" );
            System.out.println ( "|   |" );
            System.out.println ( "|   o" );
            System.out.println ( "|   | " );
            System.out.println ( "|    " );
            break;
        case 3:
            System.out.println ( "_____" );
            System.out.println ( "|   |" );
            System.out.println ( "|   o" );
            System.out.println ( "|  /| " );
            System.out.println ( "|    " );
            break;
        case 2:
            System.out.println ( "_____" );
            System.out.println ( "|   |" );
            System.out.println ( "|   o" );
            System.out.println ( "|  /|\\ " );
            System.out.println ( "|    " );
            break;
        case 1:
            System.out.println ( "_____" );
            System.out.println ( "|   |" );
            System.out.println ( "|   o" );
            System.out.println ( "|  /|\\ " );
            System.out.println ( "|    \\" );
            break;
        case 0:
            System.out.println ( "_____" );
            System.out.println ( "|   |" );
            System.out.println ( "|   o" );
            System.out.println ( "|  /|\\" );
            System.out.println ( "|  / \\" );
            break;
        }
    }
    private void showStatus() {
        System.out.println ( "Lives remaining: " + lives );
        System.out.println ( "Word found so far " + new String ( hiddenWord ) );
    }
}
