public class PlacesAutoCompleteAdapter extends ArrayAdapter<String> implements Filterable {
    private ArrayList<String> resultList;
    private static final String LOG_TAG = "Places_api";
    private static final String PLACES_API_BASE = "https://maps.googleapis.com/maps/api/place";
    private static final String TYPE_AUTOCOMPLETE = "/autocomplete";
    private static final String OUT_JSON = "/json";
    private static final String API_KEY = "-----";
    private ArrayList<String> autocomplete ( String input ) {
        ArrayList<String> resultList = null;
        HttpURLConnection conn = null;
        StringBuilder jsonResults = new StringBuilder();
        try {
            StringBuilder sb = new StringBuilder ( PLACES_API_BASE + TYPE_AUTOCOMPLETE + OUT_JSON );
            sb.append ( "?sensor=false&key=" + API_KEY );
            sb.append ( "&components=country:IN" );
            sb.append ( "&input=" + URLEncoder.encode ( input, "utf8" ) );
            URL url = new URL ( sb.toString() );
            conn = ( HttpURLConnection ) url.openConnection();
            InputStreamReader in = new InputStreamReader ( conn.getInputStream() );
            Log.d ( "====", "Requesst send" );
            int read;
            char[] buff = new char[1024];
            while ( ( read = in.read ( buff ) ) != -1 ) {
                jsonResults.append ( buff, 0, read );
            }
        } catch ( MalformedURLException e ) {
            Log.e ( LOG_TAG, "Error processing Places API URL", e );
            return resultList;
        } catch ( IOException e ) {
            Log.e ( LOG_TAG, "Error connecting to Places API", e );
            return resultList;
        } finally {
            if ( conn != null ) {
                conn.disconnect();
            }
        }
        try {
            Log.d ( "JSON", "Parsing resultant JSON :)" );
            JSONObject jsonObj = new JSONObject ( jsonResults.toString() );
            JSONArray predsJsonArray = jsonObj.getJSONArray ( "predictions" );
            resultList = new ArrayList<String> ( predsJsonArray.length() );
            Log.d ( "JSON", "predsJsonArray has length " + predsJsonArray.length() );
            for ( int i = 0; i < predsJsonArray.length(); i++ ) {
                resultList.add ( predsJsonArray.getJSONObject ( i ).getString ( "description" ) );
                Log.d ( "JSON", resultList.get ( i ) );
            }
        } catch ( JSONException e ) {
            Log.e ( LOG_TAG, "Cannot process JSON results", e );
        }
        return resultList;
    }
    public PlacesAutoCompleteAdapter ( Context context, int textViewResourceId ) {
        super ( context, textViewResourceId );
    }
    @Override
    public int getCount() {
        return resultList.size();
    }
    @Override
    public String getItem ( int index ) {
        return resultList.get ( index );
    }
    @Override
    public Filter getFilter() {
        Filter filter = new Filter() {
            protected FilterResults performFiltering ( CharSequence constraint ) {
                FilterResults filterResults = new FilterResults();
                if ( constraint != null ) {
                    resultList = autocomplete ( constraint.toString() );
                    filterResults.values = resultList;
                    filterResults.count = resultList.size();
                }
                return filterResults;
            }
            @Override
            protected void publishResults ( CharSequence constraint, FilterResults results ) {
                if ( results != null && results.count > 0 ) {
                    notifyDataSetChanged();
                } else {
                    notifyDataSetInvalidated();
                }
            }
            public boolean onLoadClass ( Class arg0 ) {
                return false;
            }
        };
        return filter;
    }
}
