try {
    DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
    DocumentBuilder db = dbf.newDocumentBuilder();
    File xml = new File ( "file.xml" );
    Document document = db.parse ( xml );
    JAXBContext jc = JAXBContext.newInstance ( Students.class );
    Binder<Node> binder = jc.createBinder();
    Students students = ( Students ) binder.unmarshal ( document );
    Student student = students.get ( 0 );
    student.setAge ( 100 );
    students.add ( new Student ( 200, "Harry", 65 ) );
    binder.updateXML ( students );
    FileOutputStream fos = null;
    try {
        TransformerFactory tf = TransformerFactory.newInstance();
        Transformer t = tf.newTransformer();
        fos = new FileOutputStream ( xml );
        t.transform ( new DOMSource ( document ), new StreamResult ( fos ) );
    } catch ( TransformerFactoryConfigurationError | TransformerException exp ) {
        exp.printStackTrace();
    } finally {
        try {
            fos.close();
        } catch ( Exception e ) {
        }
    }
} catch ( ParserConfigurationException | SAXException | IOException | JAXBException exp ) {
    exp.printStackTrace();
}
