public class MainFrame extends JFrame {
    private JProgressBar progressBar;
    private PropertyChangeListener listener = new MyPropertyChangeListener();
    readLogButton.addActionListener ( new ActionListener() {
        @Override
        public void actionPerformed ( ActionEvent evt ) {
            if ( jb.getText().equals ( "Read Log" ) )  {
                File selectedFile = FileSelector.getInstance().selectFile();
                Reader myWorker = new Reader();
                myWorker.addPropertyChangeListener ( listener );
                myWorker.readLog ( selectedFile );
            }
        }
    } );
    private class MyPropertyChangeListener implements PropertyChangeListener {
        @Override
        public void propertyChange ( final PropertyChangeEvent event ) {
            switch ( event.getPropertyName() ) {
            case "progress":
                progressBar.setIndeterminate ( false );
                progressBar.setValue ( ( Integer ) event.getNewValue() );
                break;
            case "message":
                progressBar.setString ( ( String ) event.getNewValue() );
                break;
            }
        }
    }
}
