import java.io.*;
import java.util.*;
public class Reminder implements Serializable {
    public static void main ( String[] args ) {
        Reminder re = new Reminder();
        re.put ( new Date ( System.currentTimeMillis() ), "Hope it work!" );
        re.put ( new Date ( System.currentTimeMillis() + 100 ), "it work!" );
        re.put ( new Date ( System.currentTimeMillis() + 200 ), "Wake up!" );
        String filpath = "/tmp/reminder.ser";
        re.save ( filpath, true );
        Reminder reLoad = Reminder.Load ( filpath );
        if ( reLoad != null ) {
            Iterator<Map.Entry<Date, String>> it = reLoad.entrySet().iterator();
            while ( it.hasNext() ) {
                Map.Entry<Date, String> entry = it.next();
                System.out.format ( "reminder: %tc---%s%n", entry.getKey(), entry.getValue() );
            }
        }
    }
    public Set<Map.Entry<Date, String>> entrySet() {
        return reminderMap.entrySet();
    }
    public void put ( Date chosenDate, String string ) {
        reminderMap.put ( chosenDate, string );
    }
    public String get ( Date chosenDate ) {
        return reminderMap.get ( chosenDate );
    }
    public void save ( String filePath, boolean append ) {
        System.out.println ( "Trying to save" );
        try {
            ObjectOutputStream out = new ObjectOutputStream
            ( new FileOutputStream ( filePath, append ) );
            out.writeObject ( this );
            out.close();
            System.out.printf ( "Serialized data is saved in " + filePath );
        } catch ( IOException e ) {
            e.printStackTrace();
        }
    }
    public static Reminder Load ( String filePath ) {
        System.out.println ( "Trying to load" );
        Reminder reminder = null;
        try {
            ObjectInputStream in = new ObjectInputStream
            ( new FileInputStream ( filePath ) );
            reminder = ( Reminder ) in.readObject();
            in.close();
        } catch ( IOException | ClassNotFoundException e ) {
            e.printStackTrace();
        }
        return reminder;
    }
    private static final long serialVersionUID = 1L;
    private Map<Date, String> reminderMap = new HashMap<>();
}
