@RunWith ( SpringJUnit4ClassRunner.class )
@WebAppConfiguration
@ContextConfiguration ( "classpath:spring/mvc-dispatcher-servlet.xml" )
public class MobileGatewayControllerTest {
    private MockMvc mockMvc;
    @Autowired
    private WebApplicationContext wac;
    @Autowired
    private Principal principal;
    @Autowired
    private MockServletContext servletContext;
    @Before
    public void init()  {
        mockMvc = MockMvcBuilders.webAppContextSetup ( this.wac ).build();
    }
    @Test
    public void testExampleRequest() throws Exception {
        servletContext.declareRoles ( "ROLE_1" );
        mockMvc.perform ( get ( "/testjunit" )
                          .accept ( MediaType.APPLICATION_JSON )
                          .principal ( principal ) )
        .andDo ( print() )
        .andExpect ( status().isOk() )
        .andExpect ( content().contentType ( "application/json" ) )
        .andExpect ( jsonPath ( "$.[1]" ).value ( "test" ) );
    }
}
