import java.util.HashMap;
import java.util.Map;
public class Main {
    public static void main ( String[] args ) {
        Operations operations = Operations.INSTANCE;
        operations.registerOperation ( new And() );
        operations.registerOperation ( new Equals() );
        operations.registerOperation ( new Not() );
        Expression ex3 = ExpressionParser.fromString ( "PATIENT_TYPE = 'A' AND NOT ADMISSION_TYPE = 'O'" );
        Expression ex1 = ExpressionParser.fromString ( "PATIENT_TYPE = 'A' AND ADMISSION_TYPE = 'O'" );
        Expression ex2 = ExpressionParser.fromString ( "PATIENT_TYPE = 'B'" );
        ActionDispatcher inPatient = new InPatientDispatcher();
        ActionDispatcher outPatient = new OutPatientDispatcher();
        Rule rule1 = new Rule.Builder()
        .withExpression ( ex1 )
        .withDispatcher ( outPatient )
        .build();
        Rule rule2 = new Rule.Builder()
        .withExpression ( ex2 )
        .withExpression ( ex3 )
        .withDispatcher ( inPatient )
        .build();
        Rules rules = new Rules();
        rules.addRule ( rule1 );
        rules.addRule ( rule2 );
        Map<String, String> bindings = new HashMap<>();
        bindings.put ( "PATIENT_TYPE", "'A'" );
        bindings.put ( "ADMISSION_TYPE", "'O'" );
        boolean triggered = rules.eval ( bindings );
        System.out.println ( "Action triggered: " + triggered );
    }
}
