@Override
public boolean onTouchEvent ( MotionEvent event ) {
    int index = event.getActionIndex();
    int action = event.getActionMasked();
    int pointerId = event.getPointerId ( index );
    switch ( action ) {
    case MotionEvent.ACTION_DOWN:
        if ( mVelocityTracker == null ) {
            mVelocityTracker = VelocityTracker.obtain();
        } else {
            mVelocityTracker.clear();
        }
        mVelocityTracker.addMovement ( event );
        break;
    case MotionEvent.ACTION_MOVE:
        mVelocityTracker.addMovement ( event );
        mVelocityTracker.computeCurrentVelocity ( 1000 );
        Log.d ( "", "X velocity: " +
                VelocityTrackerCompat.getXVelocity ( mVelocityTracker,
                        pointerId ) );
        Log.d ( "", "Y velocity: " +
                VelocityTrackerCompat.getYVelocity ( mVelocityTracker,
                        pointerId ) );
        break;
    case MotionEvent.ACTION_UP:
    case MotionEvent.ACTION_CANCEL:
        mVelocityTracker.recycle();
        break;
    }
    return true;
}
