final PictureCallback mPicture = new PictureCallback() {
    public void onPictureTaken ( byte[] data, Camera camera ) {
        String title = "IMG_" + new SimpleDateFormat ( "yyyyMMdd_HHmmss" ).format ( new Date() );
        String DCIM = Environment.getExternalStoragePublicDirectory ( Environment.DIRECTORY_DCIM ).toString();
        String DIRECTORY = DCIM + "/Camera";
        String path = DIRECTORY + '/' + title + ".jpg";
        FileOutputStream out = null;
        try {
            out = new FileOutputStream ( path );
            out.write ( data );
        } catch ( Exception e ) {
            Log.e ( "pictureTaken", "Failed to write data", e );
        } finally {
            try {
                out.close();
            } catch ( Exception e ) {
                Log.e ( "pictureTaken", "Failed to close file after write", e );
            }
        }
        ContentValues values = new ContentValues ( 5 );
        values.put ( ImageColumns.TITLE, title );
        values.put ( ImageColumns.DISPLAY_NAME, title + ".jpg" );
        values.put ( ImageColumns.DATE_TAKEN, System.currentTimeMillis() );
        values.put ( ImageColumns.DATA, path );
        values.put ( ImageColumns.ORIENTATION, activity.getWindowManager().getDefaultDisplay()
                     .getRotation() + 90 );
        Uri uri = null;
        try {
            uri = activity.getContentResolver().insert ( Images.Media.EXTERNAL_CONTENT_URI, values );
        } catch ( Throwable th )  {
            Log.e ( "pictureTaken", "Failed to write MediaStore" + th );
        }
    }
};
