public static class OrEnabledEmptyAction extends AbstractAction {
    private List<Action> actions;
    public OrEnabledEmptyAction ( Collection<Action> actions, String name ) {
        super ( name );
        this.actions = new ArrayList<> ( actions );
        installEnabledListener();
        updateEnabled();
    }
    private void updateEnabled() {
        boolean enabled = false;
        for ( Action action : actions ) {
            enabled |= action.isEnabled();
        }
        setEnabled ( enabled );
    }
    private void installEnabledListener() {
        PropertyChangeListener l = new PropertyChangeListener() {
            @Override
            public void propertyChange ( PropertyChangeEvent evt ) {
                if ( "enabled".equals ( evt.getPropertyName() ) ) {
                    updateEnabled();
                }
            }
        };
        for ( Action action : actions ) {
            action.addPropertyChangeListener ( l );
        }
    }
    @Override
    public void actionPerformed ( ActionEvent e ) {
    }
}
