public aspect SetterMonitoringAspect {
    declare parents : ( @com.samsoft.bean.monitor.annotation.Monitored * ) implements com.samsoft.bean.monitor.MonitoredBean;
    private Map<String, Object> MonitoredBean.cache = null;
    public boolean MonitoredBean.isMonitorinActive() {
        return cache != null;
    }
    public void MonitoredBean.stopMonitoring() {
        cache = null;
    }
    public void MonitoredBean.startMonitor() {
        cache = new HashMap<String, Object>();
    }
    public Boolean MonitoredBean.hasChanged() {
        if ( cache == null ) {
            return null;
        } else {
            return cache.size() > 0;
        }
    }
    public Object MonitoredBean.hasChanged ( String propertyName ) {
        return cache.get ( propertyName );
    }
    pointcut monitoredBeanInterfaceSetters (
        com.samsoft.bean.monitor.MonitoredBean monitoredBean ) : target ( monitoredBean ) && within ( @com.samsoft.bean.monitor.annotation.Monitored * ) && execution ( public void set * ( .. ) );
    @Before ( argNames = "monitoredBean", value = "monitoredBeanInterfaceSetters(monitoredBean)" )
    public void beforeSetterAdvice ( MonitoredBean monitoredBean,
                                     JoinPoint joinPoint ) {
        if ( monitoredBean.isMonitorinActive() ) {
            try {
                String fieldName = joinPoint.getStaticPart().getSignature()
                                   .getName().substring ( 3 ).toLowerCase();
                Object newValue = joinPoint.getArgs() [0];
                Field declaredField = monitoredBean.getClass()
                                      .getDeclaredField ( fieldName );
                declaredField.setAccessible ( true );
                Object oldValue = declaredField.get ( monitoredBean );
                if ( oldValue == null && newValue == null ) {
                    return;
                } else if ( ( oldValue == null && newValue != null )
                            || ( oldValue != null && newValue == null ) )  {
                    monitoredBean.cache.put ( fieldName, oldValue );
                } else if ( oldValue != null && newValue != null ) {
                    if ( !oldValue.equals ( newValue ) ) {
                        monitoredBean.cache.put ( fieldName, oldValue );
                    } else {
                        monitoredBean.cache.remove ( fieldName );
                    }
                }
            } catch ( Exception e ) {
                monitoredBean.cache = null;
                e.printStackTrace();
            }
        }
    }
}
