public class SampleLoader extends AsyncTaskLoader<List<SampleItem>> {
    private List<SampleItem> mData;
    public SampleLoader ( Context ctx ) {
        super ( ctx );
    }
    @Override
    public List<SampleItem> loadInBackground() {
        List<SampleItem> data = new ArrayList<SampleItem>();
        return data;
    }
    @Override
    public void deliverResult ( List<SampleItem> data ) {
        if ( isReset() ) {
            releaseResources ( data );
            return;
        }
        List<SampleItem> oldData = mData;
        mData = data;
        if ( isStarted() ) {
            super.deliverResult ( data );
        }
        if ( oldData != null && oldData != data ) {
            releaseResources ( oldData );
        }
    }
    @Override
    protected void onStartLoading() {
        if ( mData != null ) {
            deliverResult ( mData );
        }
        if ( takeContentChanged() || mData == null ) {
            forceLoad();
        }
    }
    @Override
    protected void onStopLoading() {
        cancelLoad();
    }
    @Override
    protected void onReset() {
        onStopLoading();
        if ( mData != null ) {
            releaseResources ( mData );
            mData = null;
        }
    }
    @Override
    public void onCanceled ( List<SampleItem> data ) {
        super.onCanceled ( data );
        releaseResources ( data );
    }
    private void releaseResources ( List<SampleItem> data ) {
    }
}
