public class DelegatingServletInputStream extends ServletInputStream {
    private final InputStream sourceStream;
    public DelegatingServletInputStream ( InputStream sourceStream ) {
        Assert.notNull ( sourceStream, "Source InputStream must not be null" );
        this.sourceStream = sourceStream;
    }
    public final InputStream getSourceStream() {
        return this.sourceStream;
    }
    public int read() throws IOException {
        return this.sourceStream.read();
    }
    public void close() throws IOException {
        super.close();
        this.sourceStream.close();
    }
}
