public class DataQueueListenerExample {
    public final ScheduledThreadPoolExecutor interruptExecuter = new ScheduledThreadPoolExecutor ( 1 );
    protected DataQueue dataqueue;
    public DataQueueEntry read ( int wait ) {
        ScheduledFuture<?> future = null;
        try {
            future = createInterrupter ( wait * 2, TimeUnit.SECONDS );
            return this.dataqueue.read ( wait );
        } catch ( AS400SecurityException e ) {
        } catch ( ErrorCompletingRequestException e ) {
        } catch ( IOException e ) {
        } catch ( IllegalObjectTypeException e ) {
        } catch ( InterruptedException e ) {
            return null;
        } catch ( ObjectDoesNotExistException e ) {
        } finally {
            if ( future != null && !future.isDone() ) {
                future.cancel ( true );
            }
            Thread.interrupted();
            interruptExecuter.shutdown();
        }
        return null;
    }
    public ScheduledFuture<?> createInterrupter ( long timeout, TimeUnit timeunit ) {
        return interruptExecuter.schedule ( new Interrupter(), timeout, timeunit );
    }
    class Interrupter implements Runnable {
        final Thread parent;
        Interrupter() {
            this.parent = Thread.currentThread();
        }
        @Override
        public void run() {
            parent.interrupt();
        }
    }
}
