@Provider
public class AuthFilter implements ContainerRequestFilter {
    private final AuthInfo authInfo;
    @Inject
    AuthFilter ( AuthInfo authInfo ) {
        this.authInfo = authInfo;
    }
    @Override
    public void filter ( ContainerRequestContext requestContext ) throws IOException {
        Principal principal = ...;
        authInfo.setPrincipal ( principal );
    }
}
@Path ( "hello" )
public class HelloResource {
    private final AuthInfo authInfo;
    @Inject
    HelloResource ( AuthInfo authInfo ) {
        this.authInfo = authInfo;
    }
    @GET
    @Produces ( "application/json" )
    public String hello() {
        return authInfo.getPrincipal().getUsername();
    }
}
public class MainModule extends AbstractModule {
    @Override
    protected void configure() {
        bind ( AuthFilter.class );
        bind ( HelloResource.class );
        bind ( AuthInfo.class ).in ( RequestScoped.class );
    }
}
