ImageInputStream input = ImageIO.createImageInputStream ( new File ( filePath ) );
try {
    Iterator<ImageReader> readers = ImageIO.getImageReaders ( input );
    if ( readers.hasNext() ) {
        ImageReader reader = readers.next();
        try {
            reader.setInput ( input );
            BufferedImage image = reader.read ( 0 );
            String format = reader.getFormatName();
            if ( !ImageIO.write ( image, format, outputFileOrStream ) ) {
            }
            ImageWriter writer = ImageIO.getImageWriter ( reader );
            try {
                ImageOutputStream output = ImageIO.createImageOutputStream ( outputFileOrStream );
                try {
                    writer.setOutput ( output );
                    writer.write ( image );
                } finally {
                    output.close();
                }
            } finally {
                writer.dispose();
            }
        } finally {
            reader.dispose();
        }
    }
} finally {
    input.close();
}
