public class HtmlPanelBase extends Composite {
    private String _dynPostfix = "";
    protected final String id ( final String staticId ) {
        return staticId + _dynPostfix;
    }
    private final String wrapId ( final String id ) {
        return "id=\"" + id + "\"";
    }
    private final String wrapDynId ( final String refId ) {
        return wrapId ( id ( refId ) );
    }
    private String _htmlContentAsText = null;
    protected String getHtmlContentAsText() {
        return _htmlContentAsText;
    }
    private ArrayList<String> _idList = null;
    protected HTMLPanel _holder = null;
    private HTMLPanel createHtmlPanel ( final boolean defineGloballyUniqueIds ) {
        if ( defineGloballyUniqueIds ) {
            for ( String refId : _idList ) {
                _htmlContentAsText = _htmlContentAsText.replace ( wrapId ( refId ), wrapDynId ( refId ) );
            }
        }
        return new HTMLPanel ( _htmlContentAsText );
    }
    public HtmlPanelBase ( final String htmlContentAsText, final ArrayList<String> idList, final boolean defineGloballyUniqueIds ) {
        _htmlContentAsText = htmlContentAsText;
        _idList = idList;
        this.setup ( defineGloballyUniqueIds );
        super.initWidget ( _holder );
    }
    public HtmlPanelBase ( final String htmlContentAsText ) {
        this ( htmlContentAsText, null, false );
    }
    private void setup ( final boolean defineGloballyUniqueIds ) {
        if ( defineGloballyUniqueIds ) {
            _dynPostfix = "_" + UUID.uuid().replace ( "-", "_" );
        }
        _holder = createHtmlPanel ( defineGloballyUniqueIds );
    }
}
