abstract class GenericMammalBuilder
    <B extends GenericMammalBuilder<B>> {
    String sex;
    String name;
    B ofSex ( String sex ) {
        this.sex = sex;
        return ( B ) this;
    }
    B ofName ( String name ) {
        this.name = name;
        return ( B ) this;
    }
}
final class MammalBuilder
    extends GenericMammalBuilder<MammalBuilder> {
    Mammal build() {
        return new Mammal ( this );
    }
}
abstract class GenericRabbitBuilder
    <B extends GenericRabbitBuilder<B>>
    extends GenericMammalBuilder<B> {
    Color color;
    B ofColor ( Color color ) {
        this.color = color;
        return ( B ) this;
    }
}
final class RabbitBuilder
    extends GenericRabbitBuilder<RabbitBuilder> {
    Rabbit build() {
        return new Rabbit ( this );
    }
}
