@FacesComponent ( "MyComponent" )
public class MyComponent
    extends UIComponentBase
    implements NamingContainer {
    @Override public String getFamily() {
        return UINamingContainer.COMPONENT_FAMILY;
    }
    @Override public boolean getRendersChildren() {
        return true;
    }
    @Override public void encodeChildren ( FacesContext fc ) throws IOException {
        StringWriter writer = new StringWriter();
        ResponseWriter rw = fc.getResponseWriter();
        ResponseWriter replacement = rw.cloneWithWriter ( writer );
        replacement.startDocument();
        replacement.startElement ( "div", this );
        fc.setResponseWriter ( replacement );
        super.encodeChildren ( fc );
        fc.setResponseWriter ( rw );
        replacement.endElement ( "div" );
        replacement.endDocument();
        final String renderedText = writer.toString()
                                    .substring ( 5, writer.toString().length() - 6 );
        rw.append ( Formatter.format ( renderedText ) );
    }
}
