public class Demographic extends CustomComponent implements Upload.SucceededListener, Upload.FailedListener, Upload.Receiver, Upload.ProgressListener {
    private Upload uploadPic;
    public Demographic() {
        mainLayout = new AbsoluteLayout();
        mainLayout.setImmediate ( true );
        mainLayout.setWidth ( "100%" );
        mainLayout.setHeight ( "100%" );
        mainLayout.setMargin ( false );
        uploadPic = new Upload ( "Upload image", this );
        uploadPic.setImmediate ( true );
        uploadPic.setWidth ( "-1px" );
        uploadPic.setHeight ( "-1px" );
        mainLayout.addComponent ( uploadPic, "top:135.0px;left:32.0px;" );
        uploadPic.addListener ( ( Upload.SucceededListener ) this );
        uploadPic.addListener ( ( Upload.FailedListener ) this );
        uploadPic.addListener ( ( Upload.ProgressListener ) this );
    }
    @Override
    public void uploadFailed ( FailedEvent event ) {
        app.getMainWindow().showNotification ( "Error! <br />", "Upload Failed due           to: " + event.getReason().getMessage() ,             Window.Notification.TYPE_WARNING_MESSAGE );
    }
    @Override
    public void uploadSucceeded ( SucceededEvent event ) {
        if ( event.getMIMEType().contains ( "image" ) ) {
            savePicture ( event.getFilename() );
            app.getMainWindow().showNotification ( "Success! <br />", "Image upload successful!", Window.Notification.TYPE_TRAY_NOTIFICATION );
        }
    }
}
@Override
public OutputStream receiveUpload ( String filename, String mimeType ) {
    FileOutputStream fos;
    if ( mimeType.contains ( "image" ) ) {
        String basePath = getApplication().getContext().getBaseDirectory().getAbsolutePath() + "\\Documents\\" + filename;
        File file = new File ( basePath );
        boolean checkForDir = file.exists();
        if ( !checkForDir ) {
            checkDir.mkdir();
        }
        try {
            fos = new FileOutputStream ( file );
        } catch ( final java.io.FileNotFoundException e ) {
            return null;
        }
    }
    return fos;
}
}
