import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;
public class App {
    public static void main ( String[] args ) throws IOException {
        URL url = new URL ( "http://api.bitcoincharts.com/v1/markets.json" );
        HttpURLConnection conn = ( HttpURLConnection ) url.openConnection();
        conn.setRequestMethod ( "GET" );
        conn.setRequestProperty ( "Accept", "application/json" );
        if ( conn.getResponseCode() != 200 ) {
            throw new RuntimeException ( "Failed : HTTP error code : "
                                         + conn.getResponseCode() );
        }
        InputStreamReader isr = new InputStreamReader ( conn.getInputStream() );
        TypeToken<List<MyJsonClass>> token = new TypeToken<List<MyJsonClass>>() {};
        List<MyJsonClass> list = new Gson().fromJson ( isr, token.getType() );
        for ( MyJsonClass mjc : list ) {
            System.out.println ( mjc.symbol + " : " + mjc.latest_trade );
        }
    }
}
class MyJsonClass {
    public double volume;
    public int latest_trade;
    public double bid;
    public double high;
    public String currency;
    public double currency_volume;
    public double ask;
    public double close;
    public double avg;
    public String symbol;
    public double low;
}
