template<class Key, class Compare = std::less<Key>, class Allocator = std::allocator<Key>>
            class set {
                using key_type = Key;
                using value_type = Key;
                using size_type = std::size_t;
                using difference_type = std::ptrdiff_t;
                using key_compare = Compare;
                using value_compare = Compare;
                using allocator_type = Allocator;
                using reference = value_type &;
                using const_reference = const value_type &;
                using pointer = std::allocator_traits<Allocator>::pointer;
                using const_pointer = std::allocator_traits<Allocator>::const_pointer;
                using iterator =  ;
                using const_iterator =  ;
                using reverse_iterator = std::reverse_iterator<iterator>;
                using const_reverse_iterator = std::reverse_iterator<const_iterator>
                                               iterator begin() const;
                iterator end() const;
                const_iterator cbegin() const;
                const_iterator cend() const;
                reverse_iterator rbegin() const;
                reverse_iterator rend() const;
                const_reverse_iterator crbegin() const;
                const_reverse_iterator crend() const;
                bool empty() const;
                size_type size() const;
                size_type max_size() const;
                void clear();
                std::pair<iterator, bool> insert ( const value_type & value );
                std::pair<iterator, bool> insert ( value_type && value );
                iterator insert ( const_iterator hint, const value_type & value );
                iterator insert ( const_iterator hint, value_type && value );
                template <typename InputIterator>
                void insert ( InputIterator first, InputIterator last );
                void insert ( std::initializer_list<value_type> ilist );
                template <class ...Args>
                    std::pair<iterator, bool> emplace ( Args && ... args );
                void erase ( iterator pos );
                iterator erase ( const_iterator pos );
                void erase ( iterator first, iterator last );
                iterator erase ( const_iterator first, const_iterator last );
                size_type erase ( const key_type & key );
                void swap ( set & other );
                size_type count ( const Key & key ) const;
                iterator find ( const Key & key );
                const_iterator find ( const Key & key ) const;
                std::pair<iterator, iterator> equal_range ( const Key & key );
                std::pair<const_iterator, const_iterator> equal_range ( const Key & key ) const;
                iterator lower_bound ( const Key & key );
                const_iterator lower_bound ( const Key & key ) const;
                iterator upper_bound ( const Key & key );
                const_iterator upper_bound ( const Key & key ) const;
                key_compare key_comp() const;
                value_compare value_comp() const;
            };
template<class Key, class Compare, class Alloc>
            void swap ( set<Key, Compare, Alloc> & lhs,
                        set<Key, Compare, Alloc> & rhs );
template <class Key, class Compare, class Alloc>
            bool operator== ( const set<Key, Compare, Alloc> & lhs,
                              const set<Key, Compare, Alloc> & rhs );
template <class Key, class Compare, class Alloc>
            bool operator!= ( const set<Key, Compare, Alloc> & lhs,
                              const set<Key, Compare, Alloc> & rhs );
template <class Key, class Compare, class Alloc>
            bool operator< ( const set<Key, Compare, Alloc> & lhs,
                             const set<Key, Compare, Alloc> & rhs );
template <class Key, class Compare, class Alloc>
            bool operator<= ( const set<Key, Compare, Alloc> & lhs,
                              const set<Key, Compare, Alloc> & rhs );
template <class Key, class Compare, class Alloc>
            bool operator> ( const set<Key, Compare, Alloc> & lhs,
                             const set<Key, Compare, Alloc> & rhs );
template <class Key, class Compare, class Alloc>
            bool operator>= ( const set<Key, Compare, Alloc> & lhs,
                              const set<Key, Compare, Alloc> & rhs );
