import java.io.*;
public class JavaReader {
    public static void main ( String[] args ) throws IOException {
        BufferedReader in = new BufferedReader ( new FileReader ( "message.txt" ) );
        String line = in.readLine();
        StringBuffer fileText = new StringBuffer();
        while ( line != null ) {
            fileText.append ( line + "\n" );
            line = in.readLine();
        }
        String fileContent = fileText.toString();
        System.out.println ( fileContent + "--------------------------------" );
        int vowelCount = 0, lineCount = 0;
        for ( char ch : fileContent.toCharArray() ) {
            if ( "aeiou".indexOf ( ch ) > -1 ) {
                vowelCount++;
            }
            if ( ch == '\n' ) {
                lineCount++;
            }
        }
        double wordCount = checkWordCount ( fileContent );
        double avgWordCountPerLine = wordCount / lineCount;
        System.out.println ( "Vowel count: " + vowelCount );
        System.out.println ( "Line count: " + lineCount );
        System.out.println ( "Word count: " + wordCount );
        System.out.print ( "Average word count per line: " + avgWordCountPerLine );
    }
    public static int checkWordCount ( String fileContent ) {
        String words[] = fileContent.split ( "[\\n .,;:&?]" );
        String punctutations = ".,:;";
        boolean isPunctuation = false;
        int wordCount = 0;
        for ( String word : words ) {
            if ( !word.trim().isEmpty() ) {
                for ( char punctuation : punctutations.toCharArray() ) {
                    if ( word.trim().equals ( String.valueOf ( punctuation ) ) ) {
                        isPunctuation = true;
                    }
                }
                if ( !isPunctuation ) {
                    wordCount++;
                }
            }
        }
        return wordCount;
    }
}
