import javax.swing.*;
import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
class PaintAnyTime {
    public static void main ( String[] args ) {
        EventQueue.invokeLater ( new Runnable() {
            @Override
            public void run() {
                new PaintAnyTime();
            }
        } );
    }
    final BufferedImage image = (
                                    new BufferedImage ( 500, 500, BufferedImage.TYPE_INT_ARGB )
                                );
    final JFrame frame = new JFrame();
    final JPanel panel = new JPanel() {
        @Override
        public void paintComponent ( Graphics g ) {
            super.paintComponent ( g );
            g.drawImage (
                image, 0, 0, image.getWidth(), image.getHeight(), null
            );
        }
    };
    final MouseAdapter drawer = new MouseAdapter() {
        Graphics2D g2D;
        @Override
        public void mousePressed ( MouseEvent me ) {
            g2D = image.createGraphics();
            g2D.setColor ( Color.BLACK );
        }
        @Override
        public void mouseDragged ( MouseEvent me ) {
            g2D.fillRect ( me.getX(), me.getY(), 3, 3 );
            panel.repaint();
        }
        @Override
        public void mouseReleased ( MouseEvent me ) {
            g2D.dispose();
            g2D = null;
        }
    };
    PaintAnyTime() {
        panel.setPreferredSize (
            new Dimension ( image.getWidth(), image.getHeight() )
        );
        panel.addMouseListener ( drawer );
        panel.addMouseMotionListener ( drawer );
        frame.setContentPane ( panel );
        frame.pack();
        frame.setResizable ( false );
        frame.setLocationRelativeTo ( null );
        frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
        frame.setVisible ( true );
    }
}
