public class Point implements Comparable<Point> {
    private double x;
    private double y;
    private double z;
    private String name;
    public Point ( final double x, final double y, final double z, final String name ) {
        setX ( x );
        setY ( y );
        setZ ( z );
        setName ( name );
    }
    public boolean equals ( final Point point ) {
        final boolean isEqual =
            ( this.getX() == point.getX()
              &&  this.getY() == point.getY()
              &&  this.getZ() == point.getZ() )
            || ( this.getName().equals ( point.getName() ) );
        return isEqual;
    }
    public double getX() {
        return x;
    }
    public double getY() {
        return y;
    }
    public double getZ() {
        return z;
    }
    public String getName() {
        return name;
    }
    public void setX ( final double x ) {
        this.x = x;
    }
    public void setY ( final double y ) {
        this.y = y;
    }
    public void setZ ( final double z ) {
        this.z = z;
    }
    public void setName ( final String name ) {
        this.name = name;
    }
    public String toString() {
        final StringBuffer str = new StringBuffer();
        str.append ( '(' );
        str.append ( getX() );
        str.append ( ',' );
        str.append ( getY() );
        str.append ( ',' );
        str.append ( getZ() );
        str.append ( ',' );
        str.append ( getName() );
        str.append ( ')' );
        return str.toString();
    }
    public double distanceFromOriginSquared() {
        return this.getX() * this.getX()
               + this.getY() * this.getY()
               + this.getZ() * this.getZ();
    }
    @Override
    public int compareTo ( final Point point ) {
        if ( this.getName().equals ( point.getName() ) ) {
            return 0;
        }
        final double td = this.distanceFromOriginSquared();
        final double pd = point.distanceFromOriginSquared();
        if ( td < pd ) {
            return -1;
        }
        if ( td > pd ) {
            return +1;
        }
        if ( this.getX() < point.getX() ) {
            return -1;
        }
        if ( this.getX() > point.getX() ) {
            return +1;
        }
        if ( this.getY() < point.getY() ) {
            return -1;
        }
        if ( this.getY() > point.getY() ) {
            return +1;
        }
        return 0;
    }
}
