package kieTest;
import java.util.Scanner;
import org.drools.compiler.kproject.ReleaseIdImpl;
import org.kie.api.KieServices;
import org.kie.api.builder.KieScanner;
import org.kie.api.runtime.KieContainer;
import org.kie.api.runtime.StatelessKieSession;
public class MainKieTest {
    public static void main ( String[] args ) {
        String url = "http://localhost:8080/kie-drools/maven2/de/test/Test/1.2.3/Test-1.2.3.jar";
        ReleaseIdImpl releaseId = new ReleaseIdImpl ( "de.test", "Test", "LATEST" );
        KieServices ks = KieServices.Factory.get();
        ks.getResources().newUrlResource ( url );
        KieContainer kieContainer = ks.newKieContainer ( releaseId );
        KieScanner kieScanner = ks.newKieScanner ( kieContainer );
        kieScanner.start ( 5000L );
        Scanner scanner = new Scanner ( System.in );
        while ( true ) {
            runRule ( kieContainer );
            System.out.println ( "Press enter in order to run the test again...." );
            scanner.nextLine();
        }
    }
    private static void runRule ( KieContainer kieKontainer ) {
        StatelessKieSession kSession = kieKontainer.newStatelessKieSession ( "testSession" );
        kSession.setGlobal ( "out", System.out );
        kSession.execute ( "testRuleAgain" );
    }
}
