@Configuration
@EnableWebMvc
@EnableAspectJAutoProxy ( proxyTargetClass = true )
public class WebHomeConfig extends WebMvcConfigurerAdapter implements
    ApplicationContextAware {
    private ApplicationContext _appContext;
    @Override
    public void setApplicationContext ( ApplicationContext appContext )
    throws BeansException {
        _appContext = appContext;
    }
    @Bean
    public ViewResolver getViewResolver() {
        InternalResourceViewResolver resolver = new InternalResourceViewResolver();
        resolver.setPrefix ( "/WEB-INF/views/" );
        resolver.setSuffix ( ".jsp" );
        return resolver;
    }
    @Override
    public void addViewControllers ( ViewControllerRegistry registry ) {
        registry.addViewController ( "/" ).setViewName ( "home" );
        registry.addViewController ( "/about" ).setViewName ( "aboutUs" );
        registry.addViewController ( "/privacy" ).setViewName ( "privacyPolicy" );
    }
}
