@Configuration
@EnableWebSecurity
public class MultiHttpSecurityConfig {
    @Autowired
    public void configureGlobal ( AuthenticationManagerBuilder auth ) {
        auth
        .inMemoryAuthentication()
        .withUser ( "user" ).password ( "password" ).roles ( "USER" );
    }
    @Configuration
    @Order ( 1 )
    public static class ApiWebSecurityConfigurationAdapter extends WebSecurityConfigurerAdapter {
        protected void configure ( HttpSecurity http ) throws Exception {
            http
            .antMatcher ( "/api/**" )
            .authorizeRequests()
            .anyRequest().hasRole ( "ADMIN" )
            .and()
            .httpBasic();
        }
    }
    @Configuration
    public static class FormLoginWebSecurityConfigurerAdapter extends WebSecurityConfigurerAdapter {
        @Override
        protected void configure ( HttpSecurity http ) throws Exception {
            http
            .authorizeRequests()
            .anyRequest().authenticated()
            .and()
            .formLogin();
        }
    }
}
