private void recursiveUpdate ( final float[][] heightMapping, final boolean[][] traversed,
                               final int x, final int z, final float startHeight, final boolean positive ) {
    if ( x < 0 || x >= width || z < 0 || z >= depth ) {
        return;
    }
    if ( traversed[x][z] ) {
        return;
    }
    if ( ( positive && startHeight <= 0f ) || ( !positive && startHeight >= 0f ) ) {
        heightMapping[x][z] = 0f;
        return;
    }
    traversed[x][z] = true;
    heightMapping[x][z] = startHeight;
    recursiveUpdate ( heightMapping, traversed, x - 1, z - 1,
                      calculateNewStartHeight ( startHeight, positive ), positive );
    recursiveUpdate ( heightMapping, traversed, x - 1, z + 1,
                      calculateNewStartHeight ( startHeight, positive ), positive );
    recursiveUpdate ( heightMapping, traversed, x + 1, z - 1,
                      calculateNewStartHeight ( startHeight, positive ), positive );
    recursiveUpdate ( heightMapping, traversed, x + 1, z + 1,
                      calculateNewStartHeight ( startHeight, positive ), positive );
    recursiveUpdate ( heightMapping, traversed, x, z - 1,
                      calculateNewStartHeight ( startHeight, positive ), positive );
    recursiveUpdate ( heightMapping, traversed, x, z + 1,
                      calculateNewStartHeight ( startHeight, positive ), positive );
    recursiveUpdate ( heightMapping, traversed, x + 1, z,
                      calculateNewStartHeight ( startHeight, positive ), positive );
    recursiveUpdate ( heightMapping, traversed, x - 1, z,
                      calculateNewStartHeight ( startHeight, positive ), positive );
}
