import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.EventQueue;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
import javax.swing.border.EmptyBorder;
public class TestTree {
    public static void main ( String[] args ) {
        new TestTree();
    }
    public TestTree() {
        EventQueue.invokeLater ( new Runnable() {
            @Override
            public void run() {
                try {
                    UIManager.setLookAndFeel ( UIManager.getSystemLookAndFeelClassName() );
                } catch ( ClassNotFoundException | InstantiationException | IllegalAccessException | UnsupportedLookAndFeelException ex ) {
                }
                JFrame frame = new JFrame ( "Testing" );
                frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
                frame.setLayout ( new BorderLayout() );
                frame.add ( new OutterPane() );
                frame.pack();
                frame.setLocationRelativeTo ( null );
                frame.setVisible ( true );
            }
        } );
    }
    public class InnerPane extends JPanel {
        public InnerPane() {
            setBackground ( Color.RED );
            addMouseListener ( new MouseAdapter() {
                @Override
                public void mouseClicked ( MouseEvent e ) {
                    System.out.println ( "Inner was clicked at : " + e.getPoint() );
                    MouseEvent convertMouseEvent = SwingUtilities.convertMouseEvent ( e.getComponent(), e, getParent() );
                    getParent().dispatchEvent ( convertMouseEvent );
                }
            } );
        }
    }
    public class OutterPane extends JPanel {
        public OutterPane() {
            setLayout ( new BorderLayout() );
            setBorder ( new EmptyBorder ( 10, 10, 10, 10 ) );
            add ( new InnerPane() );
            addMouseListener ( new MouseAdapter() {
                @Override
                public void mouseClicked ( MouseEvent e ) {
                    System.out.println ( "Outter was clicked at : " + e.getPoint() );
                }
            } );
        }
        @Override
        public Dimension getPreferredSize() {
            return new Dimension ( 200, 200 );
        }
    }
}
