package demo;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.EnableAutoConfiguration;
import org.springframework.context.ApplicationContext;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.ImportResource;
import java.util.Collection;
@ComponentScan
@EnableAutoConfiguration
public class Application {
    public static void main ( String[] args ) {
        ApplicationContext applicationContext = SpringApplication.run ( Application.class, args );
        Collection<Foo> shouldBeConfigured = applicationContext.getBeansOfType ( Foo.class ).values();
        System.out.println ( shouldBeConfigured.toString() );
    }
}
@Configuration
@ImportResource ( "/another.xml" )
class XmlImportingConfiguration {
}
class Foo {
    private String name;
    public void setName ( String name ) {
        this.name = name;
    }
    @Override
    public String toString() {
        return "Foo{" +
               "name='" + name + '\'' +
               '}';
    }
}
