public final void invokeAndHandle ( ServletWebRequest webRequest,
                                    ModelAndViewContainer mavContainer, Object... providedArgs ) throws Exception {
    Object returnValue = invokeForRequest ( webRequest, mavContainer, providedArgs );
    setResponseStatus ( webRequest );
    if ( returnValue == null ) {
        if ( isRequestNotModified ( webRequest ) || hasResponseStatus() || mavContainer.isRequestHandled() ) {
            mavContainer.setRequestHandled ( true );
            return;
        }
    } else if ( StringUtils.hasText ( this.responseReason ) ) {
        mavContainer.setRequestHandled ( true );
        return;
    }
    mavContainer.setRequestHandled ( false );
    try {
        this.returnValueHandlers.handleReturnValue ( returnValue, getReturnValueType ( returnValue ), mavContainer, webRequest );
    } catch ( Exception ex ) {
        if ( logger.isTraceEnabled() ) {
            logger.trace ( getReturnValueHandlingErrorMessage ( "Error handling return value", returnValue ), ex );
        }
        throw ex;
    }
}
