@Override
public void mouseClicked ( MouseEvent evt ) {
    if ( !SwingUtilities.isLeftMouseButton ( evt ) ) {
        return;
    }
    Component[] siblings = layeredPane.getComponentsInLayer ( JLayeredPane.getLayer ( this ) );
    int pos = layeredPane.getPosition ( this );
    for ( Component sibling : siblings ) {
        if ( layeredPane.getPosition ( sibling ) > pos ) {
            Point p = SwingUtilities.convertPoint ( this, evt.getX(), evt.getY(), sibling );
            if ( sibling.contains ( p ) ) {
                MouseEvent dispatch = SwingUtilities.convertMouseEvent (
                                          this, evt, sibling );
                sibling.dispatchEvent ( dispatch );
                break;
            }
        }
    }
    System.out.println ( getName() + evt );
}
