protected String getText ( Message message ) throws JMSException, IOException {
    if ( message instanceof TextMessage ) {
        return ( ( TextMessage ) message ).getText();
    } else if ( message instanceof BytesMessage ) {
        byte zipped[] = new byte[ ( int ) ( ( BytesMessage ) message )
                                  .getBodyLength()];
        ( ( BytesMessage ) message ).readBytes ( zipped );
        ByteArrayInputStream bais = new ByteArrayInputStream ( zipped );
        StringBuilder sb = null;
        GZIPInputStream in = null;
        try {
            in = new GZIPInputStream ( bais );
            BufferedReader reader = new BufferedReader (
                new InputStreamReader ( in ) );
            sb = new StringBuilder();
            String line = null;
            while ( ( line = reader.readLine() ) != null ) {
                sb.append ( line );
            }
        } finally {
            try {
                if ( in != null ) {
                    in.close();
                }
            } catch ( IOException e ) {
                log.error ( "getText: ", e );
            }
            try {
                if ( bais != null ) {
                    bais.close();
                }
            } catch ( IOException e ) {
                log.error ( "getText: ", e );
            }
        }
        return sb.toString();
    } else {
        throw new JMSException ( "Unrecognized message type "
                                 + message.getClass() );
    }
}
