@PrePersist
private void attachChildren() {
    for ( Field field : MethodHandles.lookup().lookupClass().getDeclaredFields() ) {
        Annotation annotation = field.getAnnotation ( OneToMany.class );
        if ( annotation == null ) {
            continue;
        }
        String childFieldName = ( ( OneToMany ) annotation ).mappedBy();
        try {
            ParameterizedType listType = ( ParameterizedType ) field.getGenericType();
            Class<?> childType = ( Class<?> ) listType.getActualTypeArguments() [0];
            Method setter = new PropertyDescriptor ( childFieldName, childType ).getWriteMethod();
            Iterable<Object> children = ( Iterable<Object> ) field.get ( this );
            for ( Object child : children ) {
                setter.invoke ( child, this );
            }
        } catch ( IllegalArgumentException | IllegalAccessException | InvocationTargetException | IntrospectionException e ) {
            e.printStackTrace();
        }
    }
}
