public static void setContents ( File aFile, String aContents )
throws FileNotFoundException, IOException {
    if ( aFile == null ) {
        throw new IllegalArgumentException ( "File should not be null." );
    }
    if ( !aFile.exists() ) {
        throw new FileNotFoundException ( "File does not exist: " + aFile );
    }
    if ( !aFile.isFile() ) {
        throw new IllegalArgumentException ( "Should not be a directory: " + aFile );
    }
    if ( !aFile.canWrite() ) {
        throw new IllegalArgumentException ( "File cannot be written: " + aFile );
    }
    Writer output = null;
    try {
        output = new BufferedWriter ( new FileWriter ( aFile ) );
        output.write ( aContents );
    } finally {
        if ( output != null ) {
            output.close();
        }
    }
}
