import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.net.URL;
import java.net.URLClassLoader;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import javax.tools.Diagnostic;
import javax.tools.DiagnosticCollector;
import javax.tools.JavaCompiler;
import javax.tools.JavaFileObject;
import javax.tools.StandardJavaFileManager;
import javax.tools.ToolProvider;
public class InlineCompiler {
    public static void main ( String[] args ) {
        StringBuilder sb = new StringBuilder ( 64 );
        sb.append ( "package testcompile;\n" );
        sb.append ( "public class HelloWorld implements inlinecompiler.InlineCompiler.DoStuff {\n" );
        sb.append ( "    public void doStuff() {\n" );
        sb.append ( "        System.out.println(\"Hello world\");\n" );
        sb.append ( "    }\n" );
        sb.append ( "}\n" );
        File helloWorldJava = new File ( "testcompile/HelloWorld.java" );
        if ( helloWorldJava.getParentFile().exists() || helloWorldJava.getParentFile().mkdirs() ) {
            try {
                Writer writer = null;
                try {
                    writer = new FileWriter ( helloWorldJava );
                    writer.write ( sb.toString() );
                    writer.flush();
                } finally {
                    try {
                        writer.close();
                    } catch ( Exception e ) {
                    }
                }
                DiagnosticCollector<JavaFileObject> diagnostics = new DiagnosticCollector<JavaFileObject>();
                JavaCompiler compiler = ToolProvider.getSystemJavaCompiler();
                StandardJavaFileManager fileManager = compiler.getStandardFileManager ( diagnostics, null, null );
                List<String> optionList = new ArrayList<String>();
                optionList.add ( "-classpath" );
                optionList.add ( System.getProperty ( "java.class.path" ) + ";dist/InlineCompiler.jar" );
                Iterable<? extends JavaFileObject> compilationUnit
                    = fileManager.getJavaFileObjectsFromFiles ( Arrays.asList ( helloWorldJava ) );
                JavaCompiler.CompilationTask task = compiler.getTask (
                                                        null,
                                                        fileManager,
                                                        diagnostics,
                                                        optionList,
                                                        null,
                                                        compilationUnit );
                if ( task.call() ) {
                    System.out.println ( "Yipe" );
                    URLClassLoader classLoader = new URLClassLoader ( new URL[] {new File ( "./" ).toURI().toURL() } );
                    Class<?> loadedClass = classLoader.loadClass ( "testcompile.HelloWorld" );
                    Object obj = loadedClass.newInstance();
                    if ( obj instanceof DoStuff ) {
                        DoStuff stuffToDo = ( DoStuff ) obj;
                        stuffToDo.doStuff();
                    }
                } else {
                    for ( Diagnostic<? extends JavaFileObject> diagnostic : diagnostics.getDiagnostics() ) {
                        System.out.format ( "Error on line %d in %s%n",
                                            diagnostic.getLineNumber(),
                                            diagnostic.getSource().toUri() );
                    }
                }
                fileManager.close();
            } catch ( IOException | ClassNotFoundException | InstantiationException | IllegalAccessException exp ) {
                exp.printStackTrace();
            }
        }
    }
    public static interface DoStuff {
        public void doStuff();
    }
}
