public class Fraction {
    private final int numerator;
    private final int denominator;
    public Fraction() {
        numerator = 0;
        denominator = 1;
    }
    public Fraction ( int num, int den ) {
        if ( den == 0 ) {
            throw new IllegalArgumentException ( "Denominator cannot be zero" );
        }
        int[] fractionData = this.normalize ( num, den );
        this.numerator = fractionData[0];
        this.denominator = fractionData[1];
    }
    private int[] normalize ( int numParam, int denParam ) {
        int[] fractionData = new int[2];
        fractionData[0] = numParam;
        fractionData[1] = denParam;
        BigInteger gcd;
        BigInteger num = BigInteger.valueOf ( numParam );
        BigInteger den = BigInteger.valueOf ( denParam );
        gcd = num.gcd ( den );
        if ( gcd.intValue() > 1 ) {
            fractionData[0] = numParam / gcd.intValue();
            fractionData[1] = denParam / gcd.intValue();
        }
        return fractionData;
    }
}
