@Mojo ( name = "svn-info", defaultPhase = LifecyclePhase.PROCESS_SOURCES )
@Execute ( phase = LifecyclePhase.PROCESS_SOURCES )
public class SvnInfoMojo extends AbstractMojo {
    @Component
    private MavenProject project;
    @Parameter ( property = "project.scm.url", defaultValue = "${project.scm.url}", required = true )
    private String url;
    private String svnLastRevision;
    private String svnLastChangedDate;
    public void execute() throws MojoExecutionException, MojoFailureException {
        SVNController controller = new SVNController ( url );
        info = controller.getInfo();
        this.svnLastRevision = Long.toString ( info.getCommittedRevision().getNumber() );
        project.getProperties().setProperty ( "last-rev", this.svnLastRevision );
        this.svnLastChangedDate = parseDate ( info.getCommittedDate() );
        project.getProperties().setProperty ( "last-changed", this.svnLastChangedDate );
    }
}
