public class AES {
    public static SecretKey generateAESKey ( int bits ) throws NoSuchAlgorithmException {
        KeyGenerator kgen = KeyGenerator.getInstance ( "AES" );
        kgen.init ( bits );
        return kgen.generateKey();
    }
    public static byte[] encrypt ( SecretKey key, byte[] plaintext ) throws Exception {
        SecureRandom rnd = new SecureRandom();
        byte[] IV = new byte[128 / 8];
        rnd.nextBytes ( IV );
        IvParameterSpec IVSpec = new IvParameterSpec ( IV );
        Cipher AESCipher = Cipher.getInstance ( "AES/CFB/NoPadding" );
        AESCipher.init ( Cipher.ENCRYPT_MODE, key, IVSpec );
        byte[] ciphertext = AESCipher.doFinal ( plaintext );
        byte[] output = new byte[ciphertext.length + ( 128 / 8 )];
        System.arraycopy ( IV, 0, output, 0, IV.length );
        System.arraycopy ( ciphertext, 0, output, IV.length, ciphertext.length );
        return output;
    }
    public static byte[] decrypt ( SecretKey key, byte[] IV, byte[] ciphertext ) throws Exception {
        Cipher AESCipher = Cipher.getInstance ( "AES/CFB/NoPadding" );
        IvParameterSpec IVSpec = new IvParameterSpec ( IV );
        AESCipher.init ( Cipher.DECRYPT_MODE, key, IVSpec );
        byte[] plaintext = AESCipher.doFinal ( ciphertext );
        return plaintext;
    }
    public static void main ( String[] args ) throws Exception {
        String sPlaintext = "rainbows";
        byte[] rPlaintext = sPlaintext.getBytes ( Charset.forName ( "UTF-8" ) );
        SecretKey key = generateAESKey ( 128 );
        byte[] output = encrypt ( key, rPlaintext );
        byte[] IV = new byte[128 / 8];
        byte[] ciphertext = new byte[output.length - ( 128 / 8 )];
        System.arraycopy ( output, 0, IV, 0, IV.length );
        System.arraycopy ( output, IV.length, ciphertext, 0, ciphertext.length );
        byte[] dPlaintext = decrypt ( key, IV, ciphertext );
        String decryptedMessage = new String ( dPlaintext, Charset.forName ( "UTF-8" ) );
        System.out.println ( "Original message: " + sPlaintext );
        System.out.println ( "Original message bytes: " + Arrays.toString ( rPlaintext ) );
        System.out.println ( "Encryption Output bytes: " + Arrays.toString ( output ) );
        System.out.println ( "Decrypted message bytes: " + Arrays.toString ( dPlaintext ) );
        System.out.println ( "Decrypted message: " + decryptedMessage );
    }
}
