void beginPlaying ( Track track ) {
    mState = State.Stopped;
    relaxResources ( false );
    try {
        if ( track != null ) {
            createMediaPlayerIfNeeded();
            mPlayer.setAudioStreamType ( AudioManager.STREAM_MUSIC );
            mPlayer.setDataSource ( track.audioUrl );
        } else {
            processStopRequest ( true, false );
            return;
        }
        mState = State.Preparing;
        setUpAsForeground();
        mPlayer.prepareAsync();
        if ( !mWifiLock.isHeld() ) {
            mWifiLock.acquire();
        }
    } catch ( IOException ex ) {
        Log.e ( "MusicService", "IOException playing next song: " + ex.getMessage() );
        ex.printStackTrace();
    }
}
