@Override
public void doFilter (
    ServletRequest request,
    ServletResponse response,
    FilterChain filterChain ) throws IOException, ServletException {
    WsdlResponseWrapper myResponse = new WsdlResponseWrapper ( ( HttpServletResponse ) response );
    filterChain.doFilter ( request, myResponse );
    boolean isResponseOutputStream = myResponse.getOutputStreamContent().length > 0;
    StringBuffer responseBuffer;
    if ( isResponseOutputStream ) {
        responseBuffer = new StringBuffer ( new String ( myResponse.getOutputStreamContent() ) );
    } else {
        responseBuffer = new StringBuffer ( myResponse.getWriterContent() );
    }
    if ( request instanceof HttpServletRequest ) {
        HttpServletRequest httpServletRequest = ( HttpServletRequest ) request;
        String requestedHostname = httpServletRequest.getHeader ( "x-forwarded-host" );
        if ( ( null != requestedHostname ) && !requestedHostname.isEmpty() ) {
            String myHostname = httpServletRequest.getHeader ( "host" );
            int myPort = httpServletRequest.getLocalPort();
            int index = responseBuffer.indexOf ( myHostname );
            int length = myHostname.length();
            while ( index > -1 ) {
                responseBuffer.replace ( index, index + length, requestedHostname );
                index = responseBuffer.indexOf ( myHostname );
            }
            String portString = ":" + myPort;
            length = portString.length();
            index = responseBuffer.indexOf ( portString );
            while ( index > -1 ) {
                responseBuffer.replace ( index, index + length, "" );
                index = responseBuffer.indexOf ( portString );
            }
        }
    }
    if ( isResponseOutputStream ) {
        response.getOutputStream().write ( responseBuffer.toString().getBytes() );
    } else {
        response.getWriter().print ( responseBuffer );
    }
}
