import java.io.File;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import opennlp.addons.modelbuilder.DefaultModelBuilderUtil;
import opennlp.tools.entitylinker.EntityLinkerProperties;
import opennlp.tools.namefind.NameFinderME;
import opennlp.tools.namefind.TokenNameFinderModel;
import opennlp.tools.util.Span;
public class ModelBuilderAddonUse {
    private static List<String> getSentencesFromSomewhere() throws Exception {
        List<String> sentences = new ArrayList<>();
        int counter = 0;
        DocProvider dp = new DocProvider();
        String modelPath = "c:\\apache\\entitylinker\\";
        EntityLinkerProperties properties = new EntityLinkerProperties ( new File ( modelPath + "entitylinker.properties" ) );
        Map<Long, List<String>> docs = dp.getDocs ( properties );
        for ( Long key : docs.keySet() ) {
            counter++;
            System.out.println ( "\t\tDOC: " + key + "\n\n" );
            String docu = "";
            sentences.addAll ( docs.get ( key ) );
            counter++;
            if ( counter > 1000 ) {
                break;
            }
        }
        return sentences;
    }
    public static void main ( String[] args ) throws Exception {
        File sentences = new File ( "C:\\temp\\modelbuilder\\sentences.text" );
        File knownEntities = new File ( "C:\\temp\\modelbuilder\\knownentities.txt" );
        File blacklistedentities = new File ( "C:\\temp\\modelbuilder\\blentities.txt" );
        File annotatedSentences = new File ( "C:\\temp\\modelbuilder\\annotatedSentences.txt" );
        File theModel = new File ( "C:\\temp\\modelbuilder\\theModel" );
        FileWriter sentenceWriter = new FileWriter ( sentences, true );
        FileWriter blacklistWriter = new FileWriter ( blacklistedentities, true );
        FileWriter knownEntityWriter = new FileWriter ( knownEntities, true );
        double keeperThresh = .95;
        double blacklistThresh = .7;
        TokenNameFinderModel personModel = new TokenNameFinderModel ( new File ( "c:\\temp\\opennlpmodels\\en-ner-person.zip" ) );
        NameFinderME personFinder = new NameFinderME ( personModel );
        for ( String s : getSentencesFromSomewhere() ) {
            sentenceWriter.write ( s.trim() + "\n" );
            sentenceWriter.flush();
            String[] tokens = s.split ( " " );
            Span[] find = personFinder.find ( tokens );
            double[] probs = personFinder.probs();
            String[] names = Span.spansToStrings ( find, tokens );
            for ( int i = 0; i < names.length; i++ ) {
                if ( probs[i] > keeperThresh ) {
                    knownEntityWriter.write ( names[i].trim() + "\n" );
                }
                if ( probs[i] < blacklistThresh ) {
                    blacklistWriter.write ( names[i].trim() + "\n" );
                }
            }
            personFinder.clearAdaptiveData();
            blacklistWriter.flush();
            knownEntityWriter.flush();
        }
        knownEntityWriter.flush();
        knownEntityWriter.close();
        sentenceWriter.flush();
        sentenceWriter.close();
        blacklistWriter.flush();
        blacklistWriter.close();
        DefaultModelBuilderUtil.generateModel ( sentences, knownEntities, blacklistedentities,
                                                theModel, annotatedSentences, "person", 3 );
    }
}
