public static byte[] UrlTokenDecode ( String input ) {
    if ( input == null ) {
        return new byte[0];
    }
    int len = input.length();
    if ( len < 1 ) {
        return new byte[0];
    }
    int numPadChars = ( int ) input.charAt ( len - 1 ) - ( int ) '0';
    if ( numPadChars < 0 || numPadChars > 10 ) {
        return null;
    }
    char[] base64Chars = new char[len - 1 + numPadChars];
    for ( int iter = 0; iter < len - 1; iter++ ) {
        char c = input.charAt ( iter );
        switch ( c ) {
        case '-':
            base64Chars[iter] = '+';
            break;
        case '_':
            base64Chars[iter] = '/';
            break;
        default:
            base64Chars[iter] = c;
            break;
        }
    }
    for ( int iter = len - 1; iter < base64Chars.length; iter++ ) {
        base64Chars[iter] = '=';
    }
    String assembledString = String.copyValueOf ( base64Chars );
    return Base64.decodeBase64 ( assembledString );
}
