protected WebApplicationContext createWebApplicationContext ( ServletContext sc ) {
    Class<?> contextClass = determineContextClass ( sc );
    if ( !ConfigurableWebApplicationContext.class.isAssignableFrom ( contextClass ) ) {
        throw new ApplicationContextException ( "Custom context class [" + contextClass.getName() +
                                                "] is not of type [" + ConfigurableWebApplicationContext.class.getName() + "]" );
    }
    ConfigurableWebApplicationContext wac =
        ( ConfigurableWebApplicationContext ) BeanUtils.instantiateClass ( contextClass );
    return wac;
}
