#include <Python.h>
#include "foo.h"
typedef struct {
    PyObject_HEAD;
    foo * foo;
} PyFoo;
static PyObject * PyFoo_new ( PyTypeObject * type, PyObject * args, PyObject * kwargs ) {
    const char * bar;
    if ( !PyArg_ParseTuple ( args, "s", & bar ) ) {
        return NULL;
    }
    PyFoo * self;
    self = ( PyFoo * ) type->tp_alloc ( type, 0 );
    if ( self == NULL ) {
        return NULL;
    }
    self->foo = foo_new ( bar );
    if ( self->foo == NULL ) {
        Py_DECREF ( self );
        return NULL;
    }
    return ( PyObject * ) self;
}
static void PyFoo_dealloc ( PyFoo * self ) {
    foo_delete ( self->foo );
    self->ob_type->tp_free ( ( PyObject * ) self );
}
static PyObject * PyFoo_bar ( PyFoo * self ) {
    return ( PyObject * ) PyString_FromString ( self->foo->bar )
}
static PyMethodDef PyFoo_methods[] = {
    {"foo", ( PyCFunction ) PyFoo_bar, METH_NOARGS, "Returns foo."},
    {NULL},
};
