public class Tree {
    private Node root;
    public int findDepth ( int searchNodeValue ) {
        List<Node> nodesAtCurrentLevel = Collections.singletonList ( root );
        return recursiveSearch ( 0, searchNodeValue, nodesAtCurrentLevel );
    }
    public int recursiveSearch ( int level, int searchNodeValue, List<Node> nodesAtCurrentLevel ) {
        List<Node> nodesAtNextLevel = new ArrayList<Node>();
        for ( Node node : nodesAtCurrentLevel ) {
            if ( node.getValue() == searchNodeValue ) {
                return level;
            }
            if ( node.hasChildren() ) {
                nodesAtNextLevel.addAll ( node.getChildren() );
            }
        }
        if ( !nodesAtNextLevel.isEmpty() ) {
            return recursiveSearch ( level + 1, searchNodeValue, nodesAtNextLevel );
        }
        return -1;
    }
}
class Node {
    private int value;
    private List<Node> children = new ArrayList<Node>();
    public Node ( int value ) {
        this.value = value;
    }
    public boolean hasChildren() {
        return children.isEmpty();
    }
    public int getValue() {
        return value;
    }
    public List<Node> getChildren() {
        return children;
    }
}
