public class ExampleMonitor implements Runnable {
    private boolean t1Entered = false;
    public synchronized void synchronizedTimerMethod() {
        while ( !t1Entered && !Thread.currentThread().getName().equals ( "t1" ) ) {
            try {
                wait();
            } catch ( Exception e ) {
            }
        }
        t1Entered = true;
        long enterTime = System.currentTimeMillis();
        while ( true ) {
            System.out.println ( Thread.currentThread().getName() );
            if ( System.currentTimeMillis() - enterTime > 5000 ) {
                break;
            }
        }
        this.notifyAll();
    }
    public void run() {
        synchronizedTimerMethod();
    }
    public static void main ( String[] args ) throws InterruptedException {
        ExampleMonitor ts1 = new ExampleMonitor();
        Thread t1 = new Thread ( ts1 );
        t1.setName ( "t1" );
        Thread t2 = new Thread ( ts1 );
        t2.setName ( "t2" );
        t2.start();
        Thread.sleep ( 2000 );
        t1.start();
    }
}
