public class DDVideoEncoder  {
    private static final String TAG = DDVideoEncoder.class.getSimpleName();
    private SequenceEncoder encoder;
    public DDVideoEncoder ( String filepath ) throws IOException, OutOfMemoryError {
        File out = new File ( filepath );
        encoder = new SequenceEncoder ( out );
    }
    public Boolean addFrame ( String filePath, int newSize ) throws IOException {
        Bitmap bi = getResizedBitmap ( filePath, newSize );
        try {
            encoder.encodeImage ( bi );
        } catch ( OutOfMemoryError outOfMemoryError ) {
            Log.d ( TAG, "encodeImage:" + outOfMemoryError );
            return  false;
        } catch ( NullPointerException nil ) {
            Log.d ( TAG, "encodeImage:" + nil );
            return  false;
        }
        return true;
    }
    public void finishEncoding() {
        try {
            encoder.finish();
        } catch ( IOException io ) {
            Log.d ( "DDVideoEncoder", "IOException" );
        }
    }
    private Bitmap getResizedBitmap ( String filePath, int newSize ) {
        BitmapFactory.Options o = new BitmapFactory.Options();
        o.inJustDecodeBounds = true;
        BitmapFactory.decodeFile ( filePath, o );
        final int REQUIRED_SIZE = newSize * 10;
        int scale = 1;
        while ( o.outWidth / scale / 2 >= REQUIRED_SIZE && o.outHeight / scale / 2 >= REQUIRED_SIZE ) {
            scale *= 2;
        }
        BitmapFactory.Options o2 = new BitmapFactory.Options();
        o2.inSampleSize = scale;
        return BitmapFactory.decodeFile ( filePath, o2 );
    }
}
