package sampleserver;
import java.io.*;
import java.net.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import java.lang.Object.*;
public class serverTest extends JFrame {
    private JTextField userText;
    private JTextArea chatWindow;
    private ServerSocket server;
    private Vector<String> users;
    private Vector<String> ips;
    private JTextArea conList;
    private ArrayList<SampleServer> connections = new ArrayList<SampleServer>();
    public static void main ( String[] args ) {
        new serverTest();
    }
    public serverTest() {
        super ( "Instant Messenger" );
        userText = new JTextField();
        userText.addActionListener (
        new ActionListener() {
            public void actionPerformed ( ActionEvent event ) {
                sendMessage ( event.getActionCommand() );
                userText.setText ( "" );
            }
        }
        );
        add ( userText, BorderLayout.SOUTH );
        users = new Vector();
        ips = new Vector();
        chatWindow = new JTextArea();
        conList = new JTextArea();
        conList.setEditable ( false );
        add ( new JScrollPane ( chatWindow ) );
        add ( new JScrollPane ( conList ), BorderLayout.EAST );
        conList.append ( "   ONLINE USERS    \n" );
        setSize ( 300, 150 );
        setDefaultCloseOperation ( EXIT_ON_CLOSE );
        setVisible ( true );
        try {
            server = new ServerSocket ( 6789, 100 );
            while ( true ) {
                try {
                    showMessage ( "Waiting for someone to connect...\n" );
                    Socket connection = server.accept();
                    ips.add ( connection.getInetAddress().getHostName() );
                    BufferedReader fromC = new BufferedReader ( new InputStreamReader ( connection.getInputStream() ) );
                    String s = new String ( fromC.readLine() );
                    users.add ( s );
                    String con = ( connection.getInetAddress().getHostName() );
                    showMessage ( s + " / " + con + " has connected." );
                    Iterator c = users.iterator();
                    Iterator b = ips.iterator();
                    conList.setText ( "" );
                    while ( c.hasNext() ) {
                        String d = ( c.next() ).toString();
                        String e = ( b.next().toString() );
                        conList.append ( d + "\n" );
                        conList.append ( "(" + e + ")\n\n" );
                    }
                    final SampleServer se = new SampleServer ( connection, s, con, this );
                    Thread t = new Thread ( new Runnable() {
                        public void run() {
                            se.run();
                        }
                    } );
                    connections.add ( se );
                } catch ( EOFException eofException ) {
                    showMessage ( "\n Server ended the connection!" );
                }
            }
        } catch ( IOException ioException ) {
            ioException.printStackTrace();
        }
    }
    public void closeAll() {
        while ( !connections.isEmpty() ) {
            connections.get ( 0 ).closeAll();
            connections.remove ( 0 );
        }
    }
    public void sendMessage ( String text ) {
        showMessage ( "\n SERVER - " + text );
        for ( SampleServer s : connections ) {
            s.sendMessage ( text );
        }
    }
    public void showMessage ( final String text ) {
        SwingUtilities.invokeLater (
        new Runnable() {
            public void run() {
                chatWindow.append ( text );
            }
        }
        );
    }
}
