import java.util.Objects;
public class Card {
    public enum Suit {
        CLUBS, DIAMONDS, HEARTS, SPADES;
    }
    public enum Rank {
        TWO, THREE, FOUR, FIVE, SIX, SEVEN, EIGHT, NINE, TEN,
        JACK, QUEEN, KING, ACE;
    }
    private final Suit suit;
    private final Rank rank;
    public Card ( Suit suit, Rank rank ) {
        this.suit = suit;
        this.rank = rank;
    }
    public Suit getSuit() {
        return suit;
    }
    public Rank getRank() {
        return rank;
    }
    @Override
    public String toString() {
        return rank + " of " + suit;
    }
    @Override
    public int hashCode() {
        int hash = 5;
        hash = 97 * hash + Objects.hashCode ( this.suit );
        hash = 97 * hash + Objects.hashCode ( this.rank );
        return hash;
    }
    @Override
    public boolean equals ( Object obj ) {
        if ( obj == null ) {
            return false;
        }
        if ( getClass() != obj.getClass() ) {
            return false;
        }
        final Card other = ( Card ) obj;
        if ( this.suit != other.suit ) {
            return false;
        }
        if ( this.rank != other.rank ) {
            return false;
        }
        return true;
    }
}
