public class IOData extends Observable implements SerialPortEventListener {
    public SerialPort serialPort;
    public String received = "tom";
    private static final String portName = "/dev/tty.usbmodem1421";
    public static BufferedReader input;
    public static OutputStream output;
    public static final int TIME_OUT = 2000;
    public static final int DATA_RATE = 9600;
    public void initialize() {
        CommPortIdentifier portId = null;
        Enumeration portEnum = CommPortIdentifier.getPortIdentifiers();
        while ( portEnum.hasMoreElements() ) {
            CommPortIdentifier currPortId = ( CommPortIdentifier ) portEnum.nextElement();
            if ( currPortId.getName().equals ( portName ) ) {
                portId = currPortId;
            }
        }
        if ( portId == null ) {
            System.out.println ( "Could not find COM port." );
            return;
        }
        try {
            serialPort = ( SerialPort ) portId.open ( this.getClass().getName(), TIME_OUT );
            serialPort.setSerialPortParams ( DATA_RATE, SerialPort.DATABITS_8, SerialPort.STOPBITS_1, SerialPort.PARITY_NONE );
            input = new BufferedReader ( new InputStreamReader ( serialPort.getInputStream() ) );
            output = serialPort.getOutputStream();
            char ch = 1;
            output.write ( ch );
            serialPort.addEventListener ( this );
            serialPort.notifyOnDataAvailable ( true );
        } catch ( Exception e ) {
            System.err.println ( e.toString() );
        }
    }
    public synchronized void close() {
        if ( serialPort != null ) {
            serialPort.removeEventListener();
            serialPort.close();
        }
    }
    public synchronized void serialEvent ( SerialPortEvent oEvent ) {
        if ( oEvent.getEventType() == SerialPortEvent.DATA_AVAILABLE ) {
            String temp = "empty";
            try {
                temp = input.readLine();
            } catch ( IOException e ) {
                e.printStackTrace();
            }
            System.out.println ( "Received this: " + temp );
            received = temp;
        }
    }
    public static synchronized void writeData ( String data ) {
        System.out.println ( "Sent: " + data );
        try {
            output.write ( data.getBytes() );
        } catch ( Exception e ) {
            System.out.println ( "could not write to port" );
        }
    }
