import java.text.Normalizer;
import org.xml.sax.ErrorHandler;
import org.xml.sax.SAXException;
import com.sun.tools.xjc.BadCommandLineException;
import com.sun.tools.xjc.Options;
import com.sun.tools.xjc.Plugin;
import com.sun.tools.xjc.outline.Outline;
import com.sun.xml.bind.api.impl.NameConverter;
public class NormalizeElements extends Plugin {
    @Override
    public String getOptionName() {
        return "normalize";
    }
    @Override
    public String getUsage() {
        return "  -normalize    :  normalize the classes and method names generated by removing the accented characters";
    }
    @Override
    public void onActivated ( Options opts ) throws BadCommandLineException {
        opts.setNameConverter ( new NonAsciiConverter(), this );
    }
    @Override
    public boolean run ( Outline model, Options opt, ErrorHandler errorHandler )
    throws SAXException {
        return true;
    }
}
class NonAsciiConverter extends NameConverter.Standard {
    @Override
    public String toClassName ( String s ) {
        String origStr = super.toClassName ( s );
        return normalize ( origStr );
    }
    @Override
    public String toPropertyName ( String s ) {
        String origStr = super.toPropertyName ( s );
        return normalize ( origStr );
    }
    @Override
    public String toVariableName ( String s ) {
        String origStr = super.toVariableName ( s );
        return normalize ( origStr );
    }
    @Override
    public String toInterfaceName ( String s ) {
        String origStr = super.toInterfaceName ( s );
        return normalize ( origStr );
    }
    private String normalize ( String accented ) {
        String normalized = Normalizer.normalize ( accented, Normalizer.Form.NFD );
        normalized = normalized.replaceAll ( "[^\\p{ASCII}]", "" );
        return normalized;
    }
}
