private void initLocaleResolver ( ApplicationContext context ) {
    try {
        this.localeResolver = context.getBean ( LOCALE_RESOLVER_BEAN_NAME, LocaleResolver.class );
        if ( logger.isDebugEnabled() ) {
            logger.debug ( "Using LocaleResolver [" + this.localeResolver + "]" );
        }
    } catch ( NoSuchBeanDefinitionException ex ) {
        this.localeResolver = getDefaultStrategy ( context, LocaleResolver.class );
        if ( logger.isDebugEnabled() ) {
            logger.debug ( "Unable to locate LocaleResolver with name '" + LOCALE_RESOLVER_BEAN_NAME +
                           "': using default [" + this.localeResolver + "]" );
        }
    }
}
