public static void main ( String[] args ) throws NoSuchAlgorithmException, NoSuchProviderException, InvalidKeyException, IllegalStateException, SignatureException, KeyStoreException, CertificateException, FileNotFoundException, IOException {
    Security.addProvider ( new BouncyCastleProvider() );
    Date validityBeginDate = new Date ( System.currentTimeMillis() - 24 * 60 * 60 * 1000 );
    Date validityEndDate = new Date ( System.currentTimeMillis() + 2 * 365 * 24 * 60 * 60 * 1000 );
    KeyPairGenerator keyPairGenerator = KeyPairGenerator.getInstance ( "RSA", "BC" );
    keyPairGenerator.initialize ( 1024, new SecureRandom() );
    KeyPair keyPair = keyPairGenerator.generateKeyPair();
    X509V1CertificateGenerator certGen = new X509V1CertificateGenerator();
    X500Principal dnName = new X500Principal ( "CN=" + "username" );
    certGen.setSerialNumber ( new BigInteger ( "100" ) );
    certGen.setSubjectDN ( dnName );
    certGen.setIssuerDN ( dnName );
    certGen.setNotBefore ( validityBeginDate );
    certGen.setNotAfter ( validityEndDate );
    certGen.setPublicKey ( keyPair.getPublic() );
    certGen.setSignatureAlgorithm ( "SHA256WithRSAEncryption" );
    X509Certificate cert = certGen.generate ( keyPair.getPrivate(), "BC" );
    KeyStore clientKeystore = KeyStore.getInstance ( "PKCS12", "BC" );
    clientKeystore.load ( null, null );
    clientKeystore.setKeyEntry ( "mkey", keyPair.getPrivate(), null, new X509Certificate[] { cert } );
    clientKeystore.store ( new FileOutputStream ( "admin.pkcs" ), "pass".toCharArray() );
}
