void processFiles ( List<ZippedFile> files ) {
    LinkedList<ZippedFile> remaining = new LinkedList<ZippedFile> ( files );
    for ( ZippedFile file : remaining ) {
        file.wantAccess();
    }
    while ( !remaining.isEmpty() ) {
        ZippedFile file = remaining.removeFirst();
        int status = file.beginAccess();
        if ( status == ZippedFile.BEGIN_ERROR ) {
            file.finishAccess();
        } else if ( status == ZippedFile.BEGIN_BUSY ) {
            remaining.addLast ( file );
        } else if ( status == ZippedFile.BEGIN_OK ) {
            processFileData ( file );
            file.finishAccess();
        }
    }
}
