@WebAppConfiguration
@ContextConfiguration ( classes = WebConfig.class )
@RunWith ( SpringJUnit4ClassRunner.class )
public class Example {
    @Autowired
    private WebApplicationContext webApplicationContext;
    @Test
    public void test() throws Exception {
        MockMultipartFile firstFile = new MockMultipartFile ( "data", "filename.txt", "text/plain", "some xml".getBytes() );
        MockMultipartFile secondFile = new MockMultipartFile ( "data", "other-file-name.data", "text/plain", "some other type".getBytes() );
        MockMultipartFile jsonFile = new MockMultipartFile ( "json", "", "application/json", "{\"json\": \"someValue\"}".getBytes() );
        MockMvc mockMvc = MockMvcBuilders.webAppContextSetup ( webApplicationContext ).build();
        mockMvc.perform ( MockMvcRequestBuilders.fileUpload ( "/upload" )
                          .file ( firstFile )
                          .file ( secondFile ).file ( jsonFile )
                          .param ( "some-random", "4" ) )
        .andExpect ( status().is ( 200 ) )
        .andExpect ( content().string ( "success" ) );
    }
}
