import java.io.*;
import java.util.*;
import java.util.logging.*;
public class ExerciseSerializable {
    public static void main ( String... aArguments ) {
        List<String> quarks = Arrays.asList (
                                  "up", "down", "strange", "charm", "top", "bottom"
                              );
        try {
            OutputStream file = new FileOutputStream ( "quarks.ser" );
            OutputStream buffer = new BufferedOutputStream ( file );
            ObjectOutput output = new ObjectOutputStream ( buffer );
            try {
                output.writeObject ( quarks );
            } finally {
                output.close();
            }
        } catch ( IOException ex ) {
            fLogger.log ( Level.SEVERE, "Cannot perform output.", ex );
        }
        try {
            InputStream file = new FileInputStream ( "quarks.ser" );
            InputStream buffer = new BufferedInputStream ( file );
            ObjectInput input = new ObjectInputStream ( buffer );
            try {
                List<String> recoveredQuarks = ( List<String> ) input.readObject();
                for ( String quark : recoveredQuarks ) {
                    System.out.println ( "Recovered Quark: " + quark );
                }
            } finally {
                input.close();
            }
        } catch ( ClassNotFoundException ex ) {
            fLogger.log ( Level.SEVERE, "Cannot perform input. Class not found.", ex );
        } catch ( IOException ex ) {
            fLogger.log ( Level.SEVERE, "Cannot perform input.", ex );
        }
    }
    private static final Logger fLogger =
        Logger.getLogger ( ExerciseSerializable.class.getPackage().getName() )
        ;
}
