protected void setPropertiesFromAttributes() {
    StyleSheet sheet = getStyleSheet();
    this.attr = sheet.getViewAttributes ( this );
    borderSize = ( short ) getIntAttr ( HTML.Attribute.BORDER, isLink() ?
                                        DEFAULT_BORDER : 0 );
    leftInset = rightInset = ( short ) ( getIntAttr ( HTML.Attribute.HSPACE,
                                         0 ) + borderSize );
    topInset = bottomInset = ( short ) ( getIntAttr ( HTML.Attribute.VSPACE,
                                         0 ) + borderSize );
    borderColor = ( ( StyledDocument ) getDocument() ).getForeground
                  ( getAttributes() );
    AttributeSet attr = getElement().getAttributes();
    Object alignment = attr.getAttribute ( HTML.Attribute.ALIGN );
    vAlign = 1.0f;
    if ( alignment != null ) {
        alignment = alignment.toString();
        if ( "top".equals ( alignment ) ) {
            vAlign = 0f;
        } else if ( "middle".equals ( alignment ) ) {
            vAlign = .5f;
        }
    }
    AttributeSet anchorAttr = ( AttributeSet ) attr.getAttribute ( HTML.Tag.A );
    if ( anchorAttr != null && anchorAttr.isDefined
            ( HTML.Attribute.HREF ) ) {
        synchronized ( this ) {
            state |= LINK_FLAG;
        }
    } else {
        synchronized ( this ) {
            state = ( state | LINK_FLAG ) ^ LINK_FLAG;
        }
    }
}
