import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.EmptyBorder;
import java.io.*;
public class ChooserInCurrentDir {
    JPanel gui = new JPanel ( new BorderLayout() );
    JFileChooser fileChooser;
    private JTextArea output = new JTextArea ( 10, 40 );
    ChooserInCurrentDir() {
        initComponents();
    }
    public final void initComponents() {
        gui.setBorder ( new EmptyBorder ( 2, 3, 2, 3 ) );
        String userDirLocation = System.getProperty ( "user.dir" );
        File userDir = new File ( userDirLocation );
        fileChooser = new JFileChooser ( userDir );
        Action open = new AbstractAction ( "Open" ) {
            @Override
            public void actionPerformed ( ActionEvent e ) {
                int result = fileChooser.showOpenDialog ( gui );
                if ( result == JFileChooser.APPROVE_OPTION ) {
                    try {
                        File f = fileChooser.getSelectedFile();
                        FileReader fr = new FileReader ( f );
                        output.read ( fr, f );
                        fr.close();
                    } catch ( Exception ex ) {
                        ex.printStackTrace();
                    }
                }
            }
        };
        Action save = new AbstractAction ( "Save" ) {
            @Override
            public void actionPerformed ( ActionEvent e ) {
                int result = fileChooser.showSaveDialog ( gui );
                throw new UnsupportedOperationException ( "Not supported yet." );
            }
        };
        JToolBar tb = new JToolBar();
        gui.add ( tb, BorderLayout.PAGE_START );
        tb.add ( open );
        tb.add ( save );
        output.setWrapStyleWord ( true );
        output.setLineWrap ( true );
        gui.add ( new JScrollPane (
                      output,
                      JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
                      JScrollPane.HORIZONTAL_SCROLLBAR_NEVER ) );
    }
    public final JComponent getGui() {
        return gui;
    }
    public static void main ( String[] args ) {
        Runnable r = new Runnable() {
            @Override
            public void run() {
                ChooserInCurrentDir cicd = new ChooserInCurrentDir();
                JFrame f = new JFrame ( "Chooser In Current Dir" );
                f.add ( cicd.getGui() );
                f.setDefaultCloseOperation ( JFrame.DISPOSE_ON_CLOSE );
                f.setLocationByPlatform ( true );
                f.pack();
                f.setVisible ( true );
            }
        };
        SwingUtilities.invokeLater ( r );
    }
}
