Concept stand = new Concept ( getSynset ( "stand#v#1" ), POS.v );
Concept jump = new Concept ( getSynset ( "jump#v#1" ), POS.v );
double score = compare ( comparer, co, stand );
private static double compare ( RelatednessCalculator comparer, Concept one,
                                Concept other ) throws Exception {
    Relatedness res = comparer.calcRelatednessOfSynset ( one, other );
    if ( StringUtils.isNotBlank ( res.getError() ) ) {
        throw new Exception ( "WordNET similiarity for " + one + " and " + other + " failed with this error: " + res.getError() + "\n" + res.getTrace() );
    }
    return res.getScore();
}
private static Concept getSynset ( String wordnetword ) {
    String[] parts = StringUtils.split ( wordnetword, "#" );
    String lemma = parts[0];
    POS mypos = POS.valueOf ( parts[1] );
    int index = Integer.parseInt ( parts[2] ) - 1;
    List<Synset> synsets = WordNetUtil.wordToSynsets ( lemma, mypos );
    Synset synset = synsets.get ( index );
    String synstring = synset.getSynset();
    return new Concept ( synstring, mypos, lemma, synset.getSrc() );
}
