@Configuration
@ComponentScan
@EnableAspectJAutoProxy
public class Main {
    private static int subClassCounter;
    public static void main ( String[] args ) {
        subClassCounter = 0;
        GenericApplicationContext  context = new AnnotationConfigApplicationContext ( Main.class );
        SubClassN sbc1 = context.getBean ( SubClassN.class );
        SubClassN sbc2 = context.getBean ( SubClassN.class );
        SubClassN sbc3 = context.getBean ( SubClassN.class );
        ChangeExistingCode cec = context.getBean ( ChangeExistingCode.class );
        cec.setActive ( true );
        letThemDoSomething ( "BEFORE", sbc1, sbc2, sbc3 );
        cec.setActive ( false );
        letThemDoSomething ( "AFTER", sbc1, sbc2, sbc3 );
        context.close();
    }
    private static void letThemDoSomething ( String prefix, SubClassN... existingClasses ) {
        System.out.format ( "%s ======\n", prefix );
        for ( SubClassN subClassInstance : existingClasses ) {
            subClassInstance.doSomething();
        }
        System.out.println();
    }
    @Bean
    @Scope ( BeanDefinition.SCOPE_PROTOTYPE )
    private static SubClassN buildSubClassN() {
        subClassCounter++;
        return new SubClassN ( subClassCounter );
    }
}
