import java.util.concurrent.TimeUnit;
import java.util.logging.Level;
import java.util.logging.Logger;
public class TestGameLoop {
    public static void main ( String[] args ) {
        new TestGameLoop();
    }
    public TestGameLoop() {
        gameLoop();
    }
    public static class Constants {
        public static final double OPTIMAL = 25;
    }
    private boolean game = true;
    private long lastLoop;
    private long lastFps;
    private long fps;
    private void gameLoop() {
        new Thread() {
            private long last;
            private long start;
            private int wait;
            public void run() {
                long millisPerSecond = TimeUnit.MILLISECONDS.convert ( 1, TimeUnit.SECONDS );
                long optimalDelay =  Math.round ( millisPerSecond / Constants.OPTIMAL );
                optimalDelay = TimeUnit.MILLISECONDS.toNanos ( optimalDelay );
                long loop = System.nanoTime();
                while ( game ) {
                    long now = System.nanoTime();
                    update();
                    render();
                    long timeTaken = System.nanoTime();
                    long delta = timeTaken - now;
                    long delay = optimalDelay - delta;
                    if ( delay > 0 ) {
                        try {
                            delay = TimeUnit.NANOSECONDS.toMillis ( delay );
                            Thread.sleep ( delay );
                        } catch ( InterruptedException ex ) {
                            ex.printStackTrace();
                        }
                    }
                    long loopDelay = TimeUnit.NANOSECONDS.toSeconds ( System.nanoTime() - loop );
                    if ( loopDelay >= 1 ) {
                        loop = System.nanoTime();
                        System.out.println ( "FPS = " + fps );
                        fps = 0;
                    } else {
                        fps++;
                    }
                }
            }
        } .start();
    }
    public void update() {
        try {
            Thread.sleep ( Math.round ( Math.random() * 20 ) );
        } catch ( InterruptedException ex ) {
            ex.printStackTrace();
        }
    }
    public void render() {
        try {
            Thread.sleep ( Math.round ( Math.random() * 20 ) );
        } catch ( InterruptedException ex ) {
            ex.printStackTrace();
        }
    }
}
