@Configuration
@EnableCaching
public class CachingConfig implements CachingConfigurer {
    @Bean ( destroyMethod = "shutdown" )
    public net.sf.ehcache.CacheManager ehCacheManager() {
        CacheConfiguration cacheConfiguration = new CacheConfiguration();
        cacheConfiguration.setName ( "myCacheName" );
        cacheConfiguration.setMemoryStoreEvictionPolicy ( "LRU" );
        cacheConfiguration.setMaxEntriesLocalHeap ( 1000 );
        net.sf.ehcache.config.Configuration config = new net.sf.ehcache.config.Configuration();
        config.addCache ( cacheConfiguration );
        return net.sf.ehcache.CacheManager.newInstance ( config );
    }
    @Bean
    @Override
    public CacheManager cacheManager() {
        return new EhCacheCacheManager ( ehCacheManager() );
    }
    @Bean
    @Override
    public KeyGenerator keyGenerator() {
        return new SimpleKeyGenerator();
    }
}
