import java.util.Calendar;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.SpinnerDateModel;
import javax.swing.SwingUtilities;
import javax.swing.text.DateFormatter;
public class Demo {
    private void createAndShowGUI() {
        Calendar calendar = Calendar.getInstance();
        calendar.set ( Calendar.HOUR_OF_DAY, 24 );
        calendar.set ( Calendar.MINUTE, 0 );
        calendar.set ( Calendar.SECOND, 0 );
        SpinnerDateModel model = new SpinnerDateModel();
        model.setValue ( calendar.getTime() );
        JSpinner spinner = new JSpinner ( model );
        JSpinner.DateEditor editor = new JSpinner.DateEditor ( spinner, "HH:mm:ss" );
        DateFormatter formatter = ( DateFormatter ) editor.getTextField().getFormatter();
        formatter.setAllowsInvalid ( false );
        formatter.setOverwriteMode ( true );
        spinner.setEditor ( editor );
        JPanel content = new JPanel();
        content.add ( spinner );
        JFrame frame = new JFrame ( "Demo" );
        frame.setDefaultCloseOperation ( JFrame.DISPOSE_ON_CLOSE );
        frame.getContentPane().add ( content );
        frame.pack();
        frame.setLocationRelativeTo ( null );
        frame.setVisible ( true );
    }
    public static void main ( String[] args ) {
        SwingUtilities.invokeLater ( new Runnable() {
            @Override
            public void run() {
                new Demo().createAndShowGUI();
            }
        } );
    }
}
