public static void writeJPG (
    BufferedImage bufferedImage,
    OutputStream outputStream,
    float quality ) throws IOException {
    Iterator<ImageWriter> iterator =
        ImageIO.getImageWritersByFormatName ( "jpg" );
    ImageWriter imageWriter = iterator.next();
    ImageWriteParam imageWriteParam = imageWriter.getDefaultWriteParam();
    imageWriteParam.setCompressionMode ( ImageWriteParam.MODE_EXPLICIT );
    imageWriteParam.setCompressionQuality ( quality );
    ImageOutputStream imageOutputStream =
        new MemoryCacheImageOutputStream ( outputStream );
    imageWriter.setOutput ( imageOutputStream );
    IIOImage iioimage = new IIOImage ( bufferedImage, null, null );
    imageWriter.write ( null, iioimage, imageWriteParam );
    imageOutputStream.flush();
}
