public static List<String> getJarFileListing ( String jarLocation, String filter ) {
    List<String> files = new ArrayList<String>();
    if ( jarLocation == null ) {
        return files;
    }
    JarInputStream jarInputStream = null;
    try {
        jarInputStream = new JarInputStream ( new FileInputStream ( jarLocation ) );
        JarEntry jarEntry;
        do {
            jarEntry = jarInputStream.getNextJarEntry();
            if ( jarEntry != null ) {
                String fileName = jarEntry.getName();
                if ( filter == null || fileName.matches ( filter ) ) {
                    files.add ( fileName );
                }
            }
        } while ( jarEntry != null );
        jarInputStream.close();
    } catch ( IOException ioe ) {
        throw new RuntimeException ( "Unable to get Jar input stream from '" + jarLocation + "'", ioe );
    }
    return files;
}
