public Order register ( Order value ) {
    Map<String, Order> innerMap = getInnerMap ( type );
    innerMap.put ( value.getId(), value );
    return backing.register ( value );
}
private Map<String, Order> getInnerMap ( String type ) {
    if ( !typeView.containsKey ( type ) ) {
        synchronized ( typeView )  {
            if ( !typeView.containsKey ( type ) ) {
                typeView.put ( type, new ConcurrentHashMap<>() );
            }
        }
    }
    return typeView.get ( type );
}
public Order remove ( String orderId ) {
    Order order = backing.remove ( orderId );
    if ( order == null ) {
        return null;
    }
    String type = order.getType();
    Map<String, Order> innerMap = getInnerMap ( type );
    if ( innerMap == null ) {
        throw new IllegalStateException ( "Somehow the inner map is out of sync!!" );
    } else {
        innerMap.remove ( order.getId() );
    }
    return order;
}
public Collection<Order> getOrders() {
    return backing.getOrders();
}
public Map<String, Order> getOrdersByType ( String type ) {
    return Collections.unmodifiableMap ( getInnerMap ( type ) );
}
