package your.package.structure.adapter;
import your.package.structure.device.DevicePort;
import flex.messaging.messages.AsyncMessage;
import flex.messaging.messages.Message;
import flex.messaging.services.MessageService;
import flex.messaging.services.ServiceAdapter;
import flex.messaging.util.UUIDUtils;
public class TestServiceAdapter extends ServiceAdapter {
    private volatile boolean running;
    private Message createTestMessage() {
        DevicePort objectToSend = new DevicePort ( "RouterDevice" );
        final AsyncMessage msg = new AsyncMessage();
        msg.setDestination ( getClass().getSimpleName() + "Destination" );
        msg.setClientId ( UUIDUtils.createUUID() );
        msg.setMessageId ( UUIDUtils.createUUID() );
        msg.setBody ( objectToSend );
        return msg;
    }
    private void sendMessageToClients ( Message msg ) {
        ( ( MessageService ) getDestination().getService() ).pushMessageToClients ( msg, false );
    }
    @Override
    public void start() {
        super.start();
        Thread messageSender = new Thread() {
            public void run() {
                running = true;
                while ( running ) {
                    sendMessageToClients ( createTestMessage() );
                    secondsToSleep ( 3 );
                }
            }
        };
        messageSender.start();
    }
    @Override
    public void stop() {
        super.stop();
        running = false;
    }
    @Override
    public Object invoke ( Message message ) {
        if ( message.getBody().equals ( "stop" ) ) {
            running = false;
        }
        return null;
    }
    private void secondsToSleep ( int seconds ) {
        try {
            Thread.sleep ( seconds * 1000 );
        } catch ( InterruptedException e ) {
            System.out.println ( "TestServiceAdapter Interrupted while sending messages" );
            e.printStackTrace();
        }
    }
}
