public class MainActivity extends Activity {
    ImageView img_logo;
    protected static final int CAMERA_REQUEST = 0;
    protected static final int GALLERY_PICTURE = 1;
    Uri mCapturedImageURI2;
    SharedPreferences settings;
    @Override
    protected void onCreate ( Bundle savedInstanceState ) {
        super.onCreate ( savedInstanceState );
        setContentView ( R.layout.activity_main );
        settings = getSharedPreferences ( "pref", 0 );
        Button b1 = ( Button ) findViewById ( R.id.button1 );
        Button b2 = ( Button ) findViewById ( R.id.bto2 );
        b2.setOnClickListener ( new OnClickListener() {
            @Override
            public void onClick ( View arg0 ) {
                startActivity ( new Intent ( MainActivity.this, A2.class ) );
            }
        } );
        img_logo = ( ImageView ) findViewById ( R.id.imageView1 );
        Log.d ( "SHAREDimagezzzz", "**********SHAREDzzzzzzz suckes******" );
        BitmapFactory.Options o3 = new BitmapFactory.Options();
        o3.inJustDecodeBounds = true;
        BitmapFactory.decodeFile ( settings.getString ( "photo1", "android.resource://com.tiktak.babyalbum/" + R.drawable.ic_launcher ), o3 );
        final int REQUIRED_SIZE = 2048;
        int width_tmp = o3.outWidth, height_tmp = o3.outHeight;
        int scale = 1;
        while ( true ) {
            if ( width_tmp < REQUIRED_SIZE && height_tmp < REQUIRED_SIZE ) {
                break;
            }
            width_tmp /= 2;
            height_tmp /= 2;
            scale *= 2;
        }
        BitmapFactory.Options o4 = new BitmapFactory.Options();
        o4.inSampleSize = scale;
        Bitmap bit1 = BitmapFactory.decodeFile ( settings.getString ( "photo1", "android.resource://com.tiktak.babyalbum/" + R.drawable.ic_launcher ), o4 );
        img_logo.setImageBitmap ( bit1 );
        Log.d ( "SHAREDimage", "**********SHARED suckes******" );
        b1.setOnClickListener ( new OnClickListener() {
            @Override
            public void onClick ( View arg0 ) {
                startDialog();
            }
        } );
    }
    protected void startDialog() {
        AlertDialog.Builder myAlertDialog = new AlertDialog.Builder ( this );
        myAlertDialog.setTitle ( "Upload Pictures Option" );
        myAlertDialog.setMessage ( "How do you want to set your picture?" );
        myAlertDialog.setPositiveButton ( "Gallery",
        new DialogInterface.OnClickListener() {
            public void onClick ( DialogInterface arg0, int arg1 ) {
                Intent galleryintent = new Intent ( Intent.ACTION_GET_CONTENT );
                galleryintent.setType ( "image/*" );
                galleryintent.putExtra ( "return-data", true );
                startActivityForResult ( galleryintent, GALLERY_PICTURE );
            }
        } );
        myAlertDialog.setNegativeButton ( "Camera",
        new DialogInterface.OnClickListener() {
            public void onClick ( DialogInterface arg0, int arg1 ) {
                ContentValues values = new ContentValues();
                values.put ( MediaStore.Images.Media.TITLE, "fileName" );
                mCapturedImageURI2 = getContentResolver().insert ( MediaStore.Images.Media.EXTERNAL_CONTENT_URI, values );
                Intent cameraIntent = new Intent ( "android.media.action.IMAGE_CAPTURE" );
                cameraIntent.putExtra ( MediaStore.EXTRA_OUTPUT, mCapturedImageURI2 );
                startActivityForResult ( cameraIntent, CAMERA_REQUEST );
            }
        } );
        myAlertDialog.show();
    }
    Bitmap bmp;
    public void decodeFile ( String filePath ) {
        BitmapFactory.Options o = new BitmapFactory.Options();
        o.inJustDecodeBounds = true;
        BitmapFactory.decodeFile ( filePath, o );
        final int REQUIRED_SIZE = 2048;
        int width_tmp = o.outWidth, height_tmp = o.outHeight;
        int scale = 1;
        while ( true ) {
            if ( width_tmp < REQUIRED_SIZE && height_tmp < REQUIRED_SIZE ) {
                break;
            }
            width_tmp /= 2;
            height_tmp /= 2;
            scale *= 2;
        }
        BitmapFactory.Options o2 = new BitmapFactory.Options();
        o2.inSampleSize = scale;
        bmp = BitmapFactory.decodeFile ( filePath, o2 );
    }
    @Override
    public void onActivityResult ( int requestCode, int resultCode, Intent data ) {
        super.onActivityResult ( requestCode, resultCode, data );
        if ( requestCode == GALLERY_PICTURE ) {
            if ( resultCode == RESULT_OK ) {
                Uri selectedImage = data.getData();
                String[] filePathColumn = {MediaStore.Images.Media.DATA};
                Cursor cursor = getContentResolver().query ( selectedImage, filePathColumn, null, null, null );
                if ( cursor != null ) {
                    cursor.moveToFirst();
                    int columnIndex = cursor.getColumnIndex ( filePathColumn[0] );
                    String filePath = cursor.getString ( columnIndex );
                    cursor.close();
                    decodeFile ( filePath );
                    img_logo.setImageBitmap ( bmp );
                    Log.d ( "galleryimage", "**********gallery suckes******" );
                    settings = getSharedPreferences ( "pref", 0 );
                    Editor prefsEditor = settings.edit();
                    prefsEditor.putString ( "photo1", filePath );
                    prefsEditor.commit();
                }
            } else {
                Toast.makeText ( getApplicationContext(), "Cancelled",
                                 Toast.LENGTH_SHORT ).show();
            }
        } else if ( resultCode == RESULT_CANCELED ) {
            Toast.makeText ( getApplicationContext(), "Cancelled",
                             Toast.LENGTH_SHORT ).show();
        } else if ( requestCode == CAMERA_REQUEST ) {
            if ( resultCode == RESULT_OK ) {
                String[] projection = { MediaStore.Images.Media.DATA};
                Cursor cursor = getContentResolver().query ( mCapturedImageURI2, projection, null, null, null );
                int column_index_data = cursor.getColumnIndexOrThrow ( MediaStore.Images.Media.DATA );
                cursor.moveToFirst();
                String capturedImageFilePath = cursor.getString ( column_index_data );
                Log.d ( "photos*******", " in camera take int  " + capturedImageFilePath );
                decodeFile ( capturedImageFilePath );
                if ( data != null ) {
                    img_logo.setImageBitmap ( bmp );
                    settings = getSharedPreferences ( "pref", 0 );
                    Editor prefsEditor = settings.edit();
                    prefsEditor.putString ( "photo1", capturedImageFilePath );
                    prefsEditor.commit();
                }
            }
        }
    }
}
