interface ReverseLookupSupport<E extends Enum<E>> {
    Class<E> getDeclaringClass();
default Optional<E> lookup ( String name ) {
        try {
            return Stream.of ( getDeclaringClass().getEnumConstants() )
                   .filter ( e->e.name().equals ( name ) ).findFirst();
        } catch ( IllegalArgumentException ex ) {
            return null;
        }
    }
}
