public static Object trimReflective ( Object object ) throws Exception {
    if ( object == null ) {
        return null;
    }
    Class<? extends Object> c = object.getClass();
    try {
        for ( PropertyDescriptor propertyDescriptor : Introspector
                .getBeanInfo ( c, Object.class ).getPropertyDescriptors() ) {
            Method method = propertyDescriptor.getReadMethod();
            String name = method.getName();
            if ( method.getReturnType().equals ( String.class ) ) {
                String property = ( String ) method.invoke ( object );
                if ( property != null ) {
                    Method setter = c.getMethod ( "set" + name.substring ( 3 ),
                                                  new Class<?>[] { String.class } );
                    if ( setter != null ) {
                        setter.invoke ( object, property.trim() );
                    }
                }
            }
            if ( method.getReturnType().isArray()
                    && !method.getReturnType().isPrimitive()
                    && !method.getReturnType().equals ( String[].class )
                    && !method.getReturnType().equals ( byte[].class ) ) {
                System.out.println ( method.getReturnType() );
                if ( method.invoke ( object ) instanceof Object[] ) {
                    Object[] objectArray = ( Object[] ) method.invoke ( object );
                    if ( objectArray != null ) {
                        for ( Object obj : ( Object[] ) objectArray ) {
                            trimReflective ( obj );
                        }
                    }
                }
            }
            if ( method.getReturnType().equals ( String[].class ) ) {
                String[] propertyArray = ( String[] ) method.invoke ( object );
                if ( propertyArray != null ) {
                    Method setter = c.getMethod ( "set" + name.substring ( 3 ),
                                                  new Class<?>[] { String[].class } );
                    if ( setter != null ) {
                        String[] modifiedArray = new String[propertyArray.length];
                        for ( int i = 0; i < propertyArray.length; i++ )
                            if ( propertyArray[i] != null ) {
                                modifiedArray[i] = propertyArray[i].trim();
                            }
                        setter.invoke ( object,
                                        new Object[] { modifiedArray } );
                    }
                }
            }
            if ( Collection.class.isAssignableFrom ( method.getReturnType() ) ) {
                Collection collectionProperty = ( Collection ) method
                                                .invoke ( object );
                if ( collectionProperty != null ) {
                    for ( int index = 0; index < collectionProperty.size(); index++ ) {
                        if ( collectionProperty.toArray() [index] instanceof String ) {
                            String element = ( String ) collectionProperty
                                             .toArray() [index];
                            if ( element != null ) {
                                if ( collectionProperty instanceof List ) {
                                    ( ( List ) collectionProperty ).set ( index,
                                                                          element.trim() );
                                } else {
                                    collectionProperty.remove ( element );
                                    collectionProperty.add ( element.trim() );
                                }
                            }
                        } else {
                            trimReflective ( collectionProperty.toArray() [index] );
                        }
                    }
                }
            }
            if ( method.getReturnType().equals ( Map.class ) ) {
                Map mapProperty = ( Map ) method.invoke ( object );
                if ( mapProperty != null ) {
                    for ( int index = 0; index < mapProperty.keySet().size(); index++ ) {
                        if ( mapProperty.keySet().toArray() [index] instanceof String ) {
                            String element = ( String ) mapProperty.keySet()
                                             .toArray() [index];
                            if ( element != null ) {
                                mapProperty.put ( element.trim(),
                                                  mapProperty.get ( element ) );
                                mapProperty.remove ( element );
                            }
                        } else {
                            trimReflective ( mapProperty.get ( index ) );
                        }
                    }
                    for ( Map.Entry entry : ( Set<Map.Entry> ) mapProperty
                            .entrySet() ) {
                        if ( entry.getValue() instanceof String ) {
                            String element = ( String ) entry.getValue();
                            if ( element != null ) {
                                entry.setValue ( element.trim() );
                            }
                        } else {
                            trimReflective ( entry.getValue() );
                        }
                    }
                }
            } else {
                Object property = ( Object ) method.invoke ( object );
                if ( property != null ) {
                    trimReflective ( property );
                }
            }
        }
    } catch ( Exception e ) {
        throw new Exception ( "Strings cannot be trimmed because: ", e );
    }
    return object;
}
