int numTri = 6;
tri[] triangles = new tri[numTri];
float angleIncrement = TWO_PI / numTri;
float radius = 100;
boolean[] options = {false, false, false};
void setup() {
    size ( 600, 600 );
    smooth();
    for ( int i = 0 ; i < numTri; i++ ) {
        triangles[i] = new tri();
    }
}
void draw() {
    background ( 0 );
    translate ( width * .5, height * .5 );
    for ( int i = 0 ; i < numTri; i++ ) {
        pushMatrix();
        rotate ( angleIncrement * i );
        translate ( radius, 0 );
        drawAxes ( 20 );
        triangles[i].run();
        popMatrix();
    }
}
void drawAxes ( int size ) {
    pushStyle();
    stroke ( 255, 0, 0 );
    line ( 0, 0, size, 0 );
    stroke ( 0, 255, 0 );
    line ( 0, 0, 0, size );
    popStyle();
}
void keyReleased() {
    for ( int i = 0 ; i < 3; i++ ) if ( key == ( 49 + i ) ) {
            options[i] = !options[i];
        }
    for ( int i = 0; i < numTri; i++ ) {
        triangles[i].rotateAroundCentre = options[0];
        triangles[i].translateAroundCentre = options[1];
        triangles[i].translateVertically = options[2];
    }
}
class tri {
    float ai = TWO_PI / 3;
    float r  = 50;
    float sr = r * 1.5;
    float vt = 5;
    PVector[] verts = new PVector[3];
    boolean rotateAroundCentre = false;
    boolean translateAroundCentre = false;
    boolean translateVertically = false;
    tri() {
        for ( int i = 0 ; i < 3; i++ ) {
            verts[i] = new PVector ( cos ( ai * i ) * r, sin ( ai * i ) * r );
        }
    }
    void run() {
        pushMatrix();
        float angle = millis() * 0.0005;
        if ( rotateAroundCentre ) {
            rotate ( angle );
        }
        drawAxes ( 30 );
        if ( translateVertically ) {
            translate ( sin ( angle ) * vt, 0 );
        }
        drawAxes ( 40 );
        if ( translateAroundCentre ) {
            rotate ( angle );
            drawAxes ( 40 );
            translate ( sr, 0 );
        }
        display();
        popMatrix();
    }
    void display() {
        fill ( 255 );
        strokeWeight ( 0.8 );
        triangle ( verts[0].x, verts[0].y, verts[1].x, verts[1].y, verts[2].x, verts[2].y );
        drawAxes ( 10 );
    }
}
