import java.io.IOException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import javax.servlet.AsyncContext;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
@WebServlet ( urlPatterns = { "/test" }, asyncSupported = true )
public class TestServ extends HttpServlet  implements AsyncServletTaskProcessor {
    private ExecutorService exec;
    public int CALLBACK_TIMEOUT;
    public void init() throws ServletException {
        CALLBACK_TIMEOUT = Integer.parseInt ( getInitParameter ( "timeout" ) );
        int size = Integer.parseInt ( getInitParameter ( "threadpoolsize" ) );
        exec = Executors.newFixedThreadPool ( size );
    }
    @Override
    public void doGet ( HttpServletRequest rq, HttpServletResponse rs ) {
        rs.setContentType ( "text/plain" );
        rs.setHeader ( "Access-Control-Allow-Origin", "*" );
        final AsyncContext asy = rq.startAsync();
        asy.setTimeout ( CALLBACK_TIMEOUT );
        asy.addListener ( new AsyncListenerImpl ( asy ) );
        exec.execute ( new AsyncServletTaskRunner ( asy, this ) );
    }
    @Override
    public String getServletInfo() {
        return "Short description";
    }
    @Override
    public void process ( AsyncContext ctx ) throws IOException, ServletException {
    }
}
