public static ExpectedCondition<WebElement> visibilityOfElementLocated (
    final By locator ) {
    return new ExpectedCondition<WebElement>() {
        @Override
        public WebElement apply ( WebDriver driver ) {
            try {
                return elementIfVisible ( findElement ( locator, driver ) );
            } catch ( StaleElementReferenceException e ) {
                return null;
            }
        }
        @Override
        public String toString() {
            return "visibility of element located by " + locator;
        }
    };
}
