private void overlayView ( Node dialogNode ) {
    if ( ! ( webView.getParent() instanceof BorderPane ) ) {
        return;
    }
    BorderPane viewParent = ( BorderPane ) webView.getParent();
    StackPane overlayPane = new StackPane();
    overlayPane.getChildren().addAll ( webView, new Group ( dialogNode ) );
    webView.setDisable ( true );
    viewParent.setCenter ( overlayPane );
}
private void removeViewOverlay() {
    BorderPane viewParent = ( BorderPane ) webView.getParent().getParent();
    viewParent.setCenter ( webView );
}
public EventHandler<WebEvent<String>> createAlertHandler() {
    return stringWebEvent -> {
        AlertHandler alertHandler = new AlertHandler (
            stringWebEvent.getData(),
        event -> {
            webView.setDisable ( false );
            removeViewOverlay();
        }
        );
        overlayView ( alertHandler );
    };
}
. . .
getView().disabledProperty().addListener ( new ChangeListener<Boolean>() {
    final BoxBlur soften = new BoxBlur();
    final ColorAdjust dim = new ColorAdjust();
    {
        dim.setInput ( soften );
        dim.setBrightness ( -0.5 );
    }
    @Override
    public void changed ( ObservableValue<? extends Boolean> observableValue, Boolean oldValue, Boolean newValue ) {
        if ( newValue ) {
            getView().setEffect ( dim );
        } else {
            getView().setEffect ( null );
        }
    }
} );
. . .
public class AlertHandler extends VBox {
    public AlertHandler ( String message, EventHandler<ActionEvent> confirmHandler ) {
        super ( 14 );
        final Label promptMessage = new Label ( message );
        final ImageView alertImage = new ImageView ( ResourceUtil.getImage ( "alert_48.png" ) );
        alertImage.setFitHeight ( 32 );
        alertImage.setPreserveRatio ( true );
        promptMessage.setGraphic ( alertImage );
        promptMessage.setWrapText ( true );
        promptMessage.setPrefWidth ( 350 );
        HBox buttonBar = new HBox ( 20 );
        final Button confirmButton = new Button ( getString ( "dialog.continue" ) );
        confirmButton.setDefaultButton ( true );
        buttonBar.getChildren().addAll ( confirmButton );
        setPadding ( new Insets ( 10 ) );
        getStyleClass().add ( "alert-dialog" );
        getChildren().addAll ( promptMessage, buttonBar );
        final DropShadow dropShadow = new DropShadow();
        setEffect ( dropShadow );
        confirmButton.setOnAction ( confirmHandler );
    }
}
. . .
getView().getEngine().setOnAlert ( dialogFactory.createAlertHandler() );
