import internal.sandbox.domain.Foo;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Controller;
import org.springframework.validation.FieldError;
import org.springframework.web.bind.MethodArgumentNotValidException;
import org.springframework.web.bind.annotation.*;
import javax.validation.Valid;
import java.util.HashMap;
import java.util.Map;
@Controller
public class SomeController {
    @ExceptionHandler ( MethodArgumentNotValidException.class )
    @ResponseStatus ( HttpStatus.BAD_REQUEST )
    @ResponseBody
    public Map<String, String> handleValidationFailure ( MethodArgumentNotValidException e ) {
        Map<String, String> errors = new HashMap<>();
        for ( FieldError fieldError : e.getBindingResult().getFieldErrors() ) {
            errors.put ( fieldError.getObjectName() + fieldError.getField(),
                         fieldError.getDefaultMessage() );
        }
        return errors;
    }
    @RequestMapping ( value = "/", method = RequestMethod.POST, consumes = "application/json" )
    public ResponseEntity<?> post ( @Valid @RequestBody Foo foo ) {
        return new ResponseEntity<> ( HttpStatus.OK );
    }
}
