@Service ( "userService" )
@Transactional ( readOnly = true )
public class UserServiceImpl implements UserService, UserDetailsService {
    @Autowired
    private UserDao userDao;
    @Override
    public User getByUsername ( String username ) {
        return userDao.getByUsername ( username );
    }
    @Override
    public UserDetails loadUserByUsername ( String username ) throws UsernameNotFoundException {
        User user = getByUsername ( username );
        if ( user == null ) {
            throw new UsernameNotFoundException ( "user not found" );
        } else {
            List<GrantedAuthority> listAuthorities = new ArrayList<GrantedAuthority>();
            listAuthorities.add ( new SimpleGrantedAuthority ( "ROLE_USER" ) );
            return new org.springframework.security.core.userdetails.User ( username, user.getPassword(), true, true, true, true, listAuthorities );
        }
    }
}
