static JsonFactory jsonFactory = new ObjectMapper().getFactory();
public static int handleJsonStream ( InputStream stream, ItemHandler handler ) throws IOException {
    JsonParser parser = jsonFactory.createJsonParser ( stream );
    verify ( parser.nextToken(), START_OBJECT, parser );
    verify ( parser.nextToken(), FIELD_NAME, parser );
    verify ( parser.getCurrentName(), "items", parser );
    verify ( parser.nextToken(), START_ARRAY, parser );
    int count = 0;
    while ( parser.nextToken() != END_ARRAY ) {
        verify ( parser.getCurrentToken(), START_OBJECT, parser );
        Item item = parser.readValueAs ( Item.class );
        handler.onItem ( item );
        count++;
    }
    parser.close();
    return count;
}
