package taglib;
import org.springframework.context.NoSuchMessageException;
import org.springframework.web.servlet.tags.MessageTag;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.jsp.JspException;
public class SwitchableMessageTag extends MessageTag {
    private String code;
    @Override
    protected String resolveMessage() throws JspException, NoSuchMessageException {
        if ( showMessageKeys() && hasPermission() ) {
            return this.code;
        }
        return super.resolveMessage();
    }
    protected boolean showMessageKeys() {
        HttpServletRequest req = ( HttpServletRequest ) pageContext.getRequest();
        String value = req.getParameter ( "messagekeys" );
        if ( value instanceof String && "enabled".equals ( value ) ) {
            return true;
        }
        return false;
    }
    protected boolean hasPermission() {
        return true;
    }
    @Override
    public void setCode ( String code ) {
        super.setCode ( code );
        this.code = code;
    }
}
