public class UserLoginTask extends AsyncTask<Void, Void, Boolean> {
    @Override
    protected Boolean doInBackground ( Void... params ) {
        final ResponseContainer responseContainer = new ResponseContainer();
        Network.login ( mEmail, mPassword, new AsyncHttpResponseHandler() {
            @Override
            public void onSuccess ( int statusCode, Header[] headers,
                                    byte[] responseBody ) {
                if ( statusCode == 200 ) {
                    for ( int i = 0; i < headers.length; i++ ) {
                        if ( headers[i].getName().equalsIgnoreCase ( "token" ) ) {
                            Network.SetToken ( headers[i].getValue() );
                            responseContainer.result = true;
                        }
                    }
                }
                responseContainer.result = false;
            }
            @Override
            public void onFailure ( int statusCode, Header[] headers,
                                    byte[] responseBody, Throwable error ) {
                responseContainer.result = false;
            }
        } );
        return responseContainer.result;
    }
    @Override
    protected void onPostExecute ( final Boolean success ) {
        mAuthTask = null;
        showProgress ( false );
        if ( success ) {
            finish();
        } else {
            mPasswordView
            .setError ( getString ( R.string.error_incorrect_password ) );
            mPasswordView.requestFocus();
        }
    }
    private class ResponseContainer {
        public boolean result;
    }
}
