package com.chat;
import java.io.IOException;
import java.net.InetAddress;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.HashMap;
import java.util.LinkedHashMap;
public class LiveChatServer {
    private static LinkedHashMap<String, ClientThread> clientInfo = new LinkedHashMap<String, ClientThread>();
    private ServerSocket serverSocket;
    public LiveChatServer() {
        startServer();
    }
    public void startServer() {
        String port = "1234";
        try {
            int portNo = Integer.valueOf ( port );
            serverSocket = new ServerSocket ( portNo, 0, InetAddress.getLocalHost() );
            System.out.println ( serverSocket );
            System.out.println ( serverSocket.getInetAddress().getHostName() + ":"
                                 + serverSocket.getLocalPort() );
            while ( true ) {
                Socket socket = serverSocket.accept();
                new ClientThread ( socket );
            }
        } catch ( IOException e ) {
            System.out.println ( "IO Exception:" + e );
            System.exit ( 1 );
        } catch ( NumberFormatException e ) {
            System.out.println ( "Number Format Exception:" + e );
            System.exit ( 1 );
        }
    }
    public static HashMap<String, ClientThread> getClientInfo() {
        return clientInfo;
    }
    public static void main ( String args[] ) {
        new LiveChatServer();
    }
}
