package com.chat;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.Socket;
import java.util.HashMap;
public class ClientThread implements Runnable {
    private Socket socket;
    private BufferedReader in;
    private PrintWriter out;
    private String chatName;
    private Thread thread;
    private volatile boolean isRunning = true;
    private int opcode;
    private HashMap<String, ClientThread> clientInfo = new HashMap<String, ClientThread>();
    public ClientThread ( Socket socket ) {
        try {
            this.socket = socket;
            this.clientInfo = LiveChatServer.getClientInfo();
            in = new BufferedReader ( new InputStreamReader ( socket.getInputStream() ) );
            out = new PrintWriter ( socket.getOutputStream(), true );
            thread = new Thread ( this );
            thread.start();
        } catch ( IOException e ) {
            System.out.println ( e );
        }
    }
    public void run() {
        try {
            while ( isRunning ) {
                if ( !in.ready() ) {
                    continue;
                }
                opcode = Integer.parseInt ( in.readLine() );
                switch ( opcode ) {
                case Opcode.CLIENT_CONNECTEING:
                    chatName = in.readLine();
                    boolean result = clientInfo.containsKey ( chatName );
                    out.println ( Opcode.CLIENT_CONNECTEING );
                    out.println ( result );
                    if ( result ) {
                        continue;
                    }
                    clientInfo.put ( chatName, this );
                    int i = 0;
                    for ( String key : clientInfo.keySet() ) {
                        if ( key.equals ( chatName ) ) {
                            System.out.println ( chatName + " added at " + ( i + 1 ) + " position" );
                        }
                        i++;
                    }
                    for ( ClientThread client : clientInfo.values() ) {
                        client.out.println ( Opcode.CLIENT_CONNECTED );
                        client.out.println ( clientInfo.size() );
                        for ( ClientThread client1 : clientInfo.values() ) {
                            client.out.println ( client1.chatName );
                        }
                    }
                    break;
                }
            }
            out.close();
            in.close();
            socket.close();
        } catch ( IOException e ) {
            System.out.println ( e );
        }
    }
}
