public void waitUntilTextChanges ( WebDriver driver, String... titles ) {
    new FluentWait<WebDriver> ( driver )
    .withTimeout ( 60, TimeUnit.SECONDS )
    .pollingEvery ( 10, TimeUnit.MILLISECONDS )
    .until ( new Predicate<WebDriver>() {
        public boolean apply ( WebDriver d ) {
            boolean titleMatched = false;
            String windowTitle = driver.getTitle();
            for ( String title : titles ) {
                titleMatched = windowTitle.equalsIgnoreCase ( title );
                if ( titleMatched ) {
                    break;
                }
            }
            return titleMatched;
        }
    } );
}
