@Config (
    url = "http://ddavison.github.io/tests/getting-started-with-selenium.htm",
    browser = Browser.CHROME,
    hub = ""
)
public class SampleFunctionalTest extends AutomationTest {
    @Test
    public void test() {
        click ( props.get ( "click" ) )
        .validateAttribute ( props.get ( "click" ), "class", "success" )
        .setText ( By.id ( "setTextField" ), "woot!" )
        .validateText ( By.id ( "setTextField" ), "woot!" )
        .check ( By.id ( "checkbox" ) )
        .validateChecked ( By.id ( "checkbox" ) )
        .check ( props.get ( "radio.2" ) )
        .validateUnchecked ( props.get ( "radio.1" ) )
        .selectOptionByText ( By.xpath ( "//select[@id='select']" ), "Second" )
        .validateText ( By.id ( "select" ), "2" )
        .selectOptionByValue ( By.cssSelector ( "select#select" ), "3" )
        .validateText ( props.get ( "select" ), "3" )
        .switchToFrame ( "frame" )
        .validatePresent ( By.cssSelector ( "div#frame_content" ) )
        .switchToWindow ( "Getting Started with Selenium" )
        .click ( By.linkText ( "Open a new tab / window" ) )
        .waitForWindow ( "Google" )
        .setText ( By.name ( "q" ), "google!" )
        .closeWindow();
    }
}
