@Warmup ( iterations = 5, time = 1, timeUnit = TimeUnit.SECONDS )
@Measurement ( iterations = 5, time = 1, timeUnit = TimeUnit.SECONDS )
@Fork ( 3 )
@BenchmarkMode ( Mode.AverageTime )
@OutputTimeUnit ( TimeUnit.NANOSECONDS )
@State ( Scope.Thread )
public class MHOpto {
    private int value = 42;
    private Field reflective;
    private MethodHandle unreflect;
    private MethodHandle mh;
    @Setup
    public void setup() throws NoSuchMethodException, IllegalAccessException, NoSuchFieldException {
        reflective = MHOpto.class.getDeclaredField ( "value" );
        unreflect = MethodHandles.lookup().unreflectGetter ( reflective );
        mh = MethodHandles.lookup().findGetter ( MHOpto.class, "value", int.class );
    }
    @GenerateMicroBenchmark
    public int plain() {
        return value;
    }
    @GenerateMicroBenchmark
    public int reflect() throws InvocationTargetException, IllegalAccessException {
        return ( int ) reflective.get ( this );
    }
    @GenerateMicroBenchmark
    public int unreflect_invoke() throws Throwable {
        return ( int ) unreflect.invoke ( this );
    }
    @GenerateMicroBenchmark
    public int unreflect_invokeExact() throws Throwable {
        return ( int ) unreflect.invokeExact ( this );
    }
    @GenerateMicroBenchmark
    public int mh_invoke() throws Throwable {
        return ( int ) mh.invoke ( this );
    }
    @GenerateMicroBenchmark
    public int mh_invokeExact() throws Throwable {
        return ( int ) mh.invokeExact ( this );
    }
}
