public class SMSClient implements Runnable {
    public final static int SYNCHRONOUS = 0;
    public final static int ASYNCHRONOUS = 1;
    private Thread myThread = null;
    private int mode = -1;
    private String recipient = null;
    private String message = null;
    public int status = -1;
    public long messageNo = -1;
    public SMSClient ( int mode ) {
        this.mode = mode;
    }
    public int sendMessage ( String recipient, String message ) {
        this.recipient = recipient;
        this.message = message;
        myThread = new Thread ( this );
        myThread.start();
        return status;
    }
    public void run() {
        Sender aSender = new Sender ( recipient, message );
        try {
            aSender.send ();
            if ( mode == SYNCHRONOUS ) {
                while ( aSender.status == -1 ) {
                    myThread.sleep ( 1000 );
                }
            }
            if ( aSender.status == 0 ) {
                messageNo = aSender.messageNo ;
            }
        } catch ( Exception e ) {
            e.printStackTrace();
        }
        this.status = aSender.status ;
        aSender = null;
    }
}
