import org.jivesoftware.smack.provider.PrivacyProvider;
import org.jivesoftware.smack.provider.ProviderManager;
import org.jivesoftware.smackx.GroupChatInvitation;
import org.jivesoftware.smackx.PrivateDataManager;
import org.jivesoftware.smackx.packet.ChatStateExtension;
import org.jivesoftware.smackx.packet.LastActivity;
import org.jivesoftware.smackx.packet.OfflineMessageInfo;
import org.jivesoftware.smackx.packet.OfflineMessageRequest;
import org.jivesoftware.smackx.packet.SharedGroupsInfo;
import org.jivesoftware.smackx.provider.AdHocCommandDataProvider;
import org.jivesoftware.smackx.provider.BytestreamsProvider;
import org.jivesoftware.smackx.provider.DataFormProvider;
import org.jivesoftware.smackx.provider.DelayInformationProvider;
import org.jivesoftware.smackx.provider.DiscoverInfoProvider;
import org.jivesoftware.smackx.provider.DiscoverItemsProvider;
import org.jivesoftware.smackx.provider.MUCAdminProvider;
import org.jivesoftware.smackx.provider.MUCOwnerProvider;
import org.jivesoftware.smackx.provider.MUCUserProvider;
import org.jivesoftware.smackx.provider.MessageEventProvider;
import org.jivesoftware.smackx.provider.MultipleAddressesProvider;
import org.jivesoftware.smackx.provider.RosterExchangeProvider;
import org.jivesoftware.smackx.provider.StreamInitiationProvider;
import org.jivesoftware.smackx.provider.VCardProvider;
import org.jivesoftware.smackx.provider.XHTMLExtensionProvider;
import org.jivesoftware.smackx.search.UserSearch;
import android.util.Log;
public class ServiceProviders {
    public static void Register_Providers ( ProviderManager pm ) {
        pm.addIQProvider ( "query", "jabber:iq:private",
                           new PrivateDataManager.PrivateDataIQProvider() );
        try {
            pm.addIQProvider ( "query", "jabber:iq:time",
                               Class.forName ( "org.jivesoftware.smackx.packet.Time" ) );
        } catch ( ClassNotFoundException e ) {
            Log.w ( "TestClient",
                    "Can't load class for org.jivesoftware.smackx.packet.Time" );
        }
        pm.addExtensionProvider ( "x", "jabber:x:roster",
                                  new RosterExchangeProvider() );
        pm.addExtensionProvider ( "x", "jabber:x:event",
                                  new MessageEventProvider() );
        pm.addExtensionProvider ( "active",
                                  "http://jabber.org/protocol/chatstates",
                                  new ChatStateExtension.Provider() );
        pm.addExtensionProvider ( "composing",
                                  "http://jabber.org/protocol/chatstates",
                                  new ChatStateExtension.Provider() );
        pm.addExtensionProvider ( "paused",
                                  "http://jabber.org/protocol/chatstates",
                                  new ChatStateExtension.Provider() );
        pm.addExtensionProvider ( "inactive",
                                  "http://jabber.org/protocol/chatstates",
                                  new ChatStateExtension.Provider() );
        pm.addExtensionProvider ( "gone",
                                  "http://jabber.org/protocol/chatstates",
                                  new ChatStateExtension.Provider() );
        pm.addExtensionProvider ( "html", "http://jabber.org/protocol/xhtml-im",
                                  new XHTMLExtensionProvider() );
        pm.addExtensionProvider ( "x", "jabber:x:conference",
                                  new GroupChatInvitation.Provider() );
        pm.addIQProvider ( "query", "http://jabber.org/protocol/disco#items",
                           new DiscoverItemsProvider() );
        pm.addIQProvider ( "query", "http://jabber.org/protocol/disco#info",
                           new DiscoverInfoProvider() );
        pm.addExtensionProvider ( "x", "jabber:x:data", new DataFormProvider() );
        pm.addExtensionProvider ( "x", "http://jabber.org/protocol/muc#user",
                                  new MUCUserProvider() );
        pm.addIQProvider ( "query", "http://jabber.org/protocol/muc#admin",
                           new MUCAdminProvider() );
        pm.addIQProvider ( "query", "http://jabber.org/protocol/muc#owner",
                           new MUCOwnerProvider() );
        pm.addExtensionProvider ( "x", "jabber:x:delay",
                                  new DelayInformationProvider() );
        try {
            pm.addIQProvider ( "query", "jabber:iq:version",
                               Class.forName ( "org.jivesoftware.smackx.packet.Version" ) );
        } catch ( ClassNotFoundException e ) {
        }
        pm.addIQProvider ( "vCard", "vcard-temp", new VCardProvider() );
        pm.addIQProvider ( "offline", "http://jabber.org/protocol/offline",
                           new OfflineMessageRequest.Provider() );
        pm.addExtensionProvider ( "offline",
                                  "http://jabber.org/protocol/offline",
                                  new OfflineMessageInfo.Provider() );
        pm.addIQProvider ( "query", "jabber:iq:last", new LastActivity.Provider() );
        pm.addIQProvider ( "query", "jabber:iq:search", new UserSearch.Provider() );
        pm.addIQProvider ( "sharedgroup",
                           "http://www.jivesoftware.org/protocol/sharedgroup",
                           new SharedGroupsInfo.Provider() );
        pm.addExtensionProvider ( "addresses",
                                  "http://jabber.org/protocol/address",
                                  new MultipleAddressesProvider() );
        pm.addIQProvider ( "si", "http://jabber.org/protocol/si",
                           new StreamInitiationProvider() );
        pm.addIQProvider ( "query", "http://jabber.org/protocol/bytestreams",
                           new BytestreamsProvider() );
        pm.addIQProvider ( "query", "jabber:iq:privacy", new PrivacyProvider() );
        pm.addIQProvider ( "command", "http://jabber.org/protocol/commands",
                           new AdHocCommandDataProvider() );
        pm.addExtensionProvider ( "malformed-action",
                                  "http://jabber.org/protocol/commands",
                                  new AdHocCommandDataProvider.MalformedActionError() );
        pm.addExtensionProvider ( "bad-locale",
                                  "http://jabber.org/protocol/commands",
                                  new AdHocCommandDataProvider.BadLocaleError() );
        pm.addExtensionProvider ( "bad-payload",
                                  "http://jabber.org/protocol/commands",
                                  new AdHocCommandDataProvider.BadPayloadError() );
        pm.addExtensionProvider ( "bad-sessionid",
                                  "http://jabber.org/protocol/commands",
                                  new AdHocCommandDataProvider.BadSessionIDError() );
        pm.addExtensionProvider ( "session-expired",
                                  "http://jabber.org/protocol/commands",
                                  new AdHocCommandDataProvider.SessionExpiredError() );
        pm.addIQProvider ( "query", "http://jabber.org/protocol/disco#info",
                           new DiscoverInfoProvider() );
        pm.addExtensionProvider ( "x", "jabber:x:data", new DataFormProvider() );
    }
}
