public class FolderPartitioner implements Partitioner {
    private static final Logger logger = LoggerFactory.getLogger ( FolderPartitioner.class );
    private static final String DEFAULT_KEY_NAME = "fileName";
    private static final String PARTITION_KEY = "partition";
    private String folder;
    private String keyName = DEFAULT_KEY_NAME;
    public Map<String, ExecutionContext> partition ( int gridSize ) {
        Map<String, ExecutionContext> map = new HashMap<String, ExecutionContext> (
            gridSize );
        int i = 0;
        File dir = new File ( folder );
        File[] chunkList = dir.listFiles();
        for ( File chunkStep : chunkList ) {
            if ( chunkStep.isDirectory() ) {
                ExecutionContext context = new ExecutionContext();
                context.putString ( keyName, chunkStep.getName() );
                logger.info ( "Creating partition for folder:" + context.getString ( keyName ) );
                map.put ( PARTITION_KEY + i, context );
                i++;
            }
        }
        return map;
    }
    public void setKeyName ( String keyName ) {
        this.keyName = keyName;
    }
    public String getFolder() {
        return folder;
    }
    public void setFolder ( String folder ) {
        this.folder = folder;
    }
}
