package utils;
public class ServerCounter {
    private static ServerCounter INSTANCE = new ServerCounter();
    private final AtomicLong counter;
    private ServerCounter() {
        long value = this.loadCounterFromFile();
        counter = new AtomicLong ( value );
    };
    private long loadCounterFromFile() {
        BufferedReader br = null;
        try {
            br = new BufferedReader ( new FileReader ( "C:\\Test\\counter.txt" ) );
            String line = br.readLine();
            if ( line != null && line.length() > 0 ) {
                return Long.parseLong ( line );
            }
            return 0;
        } catch ( Exception e ) {
            return 0;
        } finally {
            try {
                if ( br != null ) {
                    br.close();
                }
            } catch ( IOException ex ) {
                ex.printStackTrace();
            }
        }
    }
    public static ServerCounter getInstance() {
        return INSTANCE;
    }
    public String nextval() {
        return String.valueOf ( counter.incrementAndGet() );
    }
    public void writeToFile() {
        writeToFile ( counter.get() );
    }
    private void writeToFile ( long value ) {
        try {
            BufferedWriter bw = new BufferedWriter ( new FileWriter ( "C:\\Test\\counter.txt" ) );
            bw.write ( "" + value );
            bw.close();
        } catch ( IOException e ) {
            e.printStackTrace();
        }
    }
}
