public class Holidays {
    private final Calendar calendar = Calendar.getInstance();
    private final String holidayName;
    public Holidays ( String holidayName, Date date ) {
        this.holidayName = holidayName;
        this.calendar.setTime ( date );
    }
    @Override
    public int compareTo ( Holidays another ) {
        if ( MainActivity.sortByName == true ) {
            return holidayName.compareToIgnoreCase ( another.holidayName );
        }
        return getTimeInMillis() - another.getTimeInMillis();
    }
    public long getTimeInMillis() {
        return this.calendar.getTimeInMillis();
    }
    @Override
    public String toString() {
        DayOfWeek day = DayOfWeek.values() [calendar.get ( Calendar.DAY_OF_WEEK )];
        return String.format ( "%s falls of %s", this.holidayName, day );
    }
}
