public class Main {
    public static void main ( String[] args ) throws JAXBException {
        JAXBContext context = JAXBContext.newInstance ( Model.class, Definitions.class );
        Unmarshaller unmarshaller = context.createUnmarshaller();
        Model model = ( Model ) unmarshaller.unmarshal ( Main.class.getClassLoader().getResourceAsStream ( "input.xml" ) );
        List<Task> tasks = new ArrayList<Task>();
        for ( Node node : model.getNodes() ) {
            tasks.add ( new Task ( node.getId() ) );
        }
        Definitions definitions = new Definitions ( new Process ( model.getId(), tasks ) );
        StringWriter sw = new StringWriter();
        Marshaller marshaller = context.createMarshaller();
        marshaller.setProperty ( Marshaller.JAXB_FORMATTED_OUTPUT, true );
        marshaller.setProperty ( Marshaller.JAXB_ENCODING, "UTF-8" );
        marshaller.marshal ( definitions, sw );
        System.out.println ( sw.toString() );
    }
}
