final XYChart chart = new LineChart ( mDataset, mRenderer );
mChartView = new GraphicalView ( this, chart );
mChartView.setOnTouchListener ( new View.OnTouchListener() {
    @Override
    public boolean onTouch ( View v, MotionEvent event ) {
        XYSeries series = mDataset.getSeriesAt ( 0 );
        for ( int i = 0; i < series.getItemCount(); i++ ) {
            double[] xy = chart.toScreenPoint ( new double[] { series.getX ( i ), series.getY ( i ) }, 0 );
            double dx = ( xy[0] - event.getX() );
            double dy = ( xy[1] - event.getY() );
            double distance = Math.sqrt ( dx * dx + dy * dy );
            if ( distance <= 2 * pointSize ) {
                SeriesSelection sel =
                    chart.getSeriesAndPointForScreenCoordinate ( new Point ( ( float ) xy[0], ( float ) xy[1] ) );
                if ( sel != null ) {
                    Toast.makeText ( XYChartBuilder.this, "Touched: " + sel.getValue(), Toast.LENGTH_SHORT ).show();
                }
                break;
            }
            Log.i ( "LuS", "dist: " + distance );
        }
        return true;
    }
} );
