public class DataNamingStrategy extends PropertyNamingStrategy {
    public static final String DATA_FIELD = "variable:data";
    private String fieldName;
    public DataNamingStrategy ( String fieldName ) {
        this.fieldName = fieldName;
    }
    @Override
    public String nameForField ( MapperConfig<?> config, AnnotatedField field,
                                 String defaultName ) {
        return ( defaultName.equals ( DATA_FIELD ) ) ?
               fieldName :
               super.nameForField ( config, field, defaultName );
    }
    @Override
    public String nameForSetterMethod ( MapperConfig<?> config,
                                        AnnotatedMethod method, String defaultName ) {
        return ( defaultName.equals ( DATA_FIELD ) ) ?
               fieldName :
               super.nameForGetterMethod ( config, method, defaultName );
    }
    @Override
    public String nameForGetterMethod ( MapperConfig<?> config,
                                        AnnotatedMethod method, String defaultName ) {
        return nameForSetterMethod ( config, method, defaultName );
    }
}
