settings.addActionListener ( new ActionListener() {
    public void actionPerformed ( ActionEvent e ) {
        remove ( createWorld );
        remove ( addServer );
        repaint();
        final Preferences prefs = Preferences.userNodeForPackage ( Render.class );
        soundLevel = prefs.getInt ( "SOUND_LEVEL", 50 );
        lightLevel = prefs.getInt ( "LIGHT_LEVEL", 50 );
        JLabel soundLabel = new JLabel ( "Sound: " );
        soundLabel.setBounds ( 170, 110, 150, 35 );
        soundLabel.setForeground ( Color.white );
        add ( soundLabel );
        add ( sound );
        sound.setBounds ( 210, 110, 150, 35 );
        sound.setMinimum ( 0 );
        sound.setMaximum ( 100 );
        sound.setValueIsAdjusting ( true );
        sound.setValue ( soundLevel );
        sound.setToolTipText ( "Audio: " + soundLevel + "%" );
        sound.addChangeListener ( new ChangeListener() {
            public void stateChanged ( ChangeEvent e ) {
                soundLevel = sound.getValue();
                sound.setToolTipText ( "Audio: " + soundLevel + "%" );
                prefs.putInt ( "SOUND_LEVEL", soundLevel );
            }
        } );
        JLabel lightLabel = new JLabel ( "Light: " );
        lightLabel.setBounds ( 370, 110, 150, 35 );
        lightLabel.setForeground ( Color.white );
        add ( lightLabel );
        add ( light );
        light.setBounds ( 405, 110, 150, 35 );
        light.setMinimum ( 0 );
        light.setMaximum ( 100 );
        light.setValueIsAdjusting ( true );
        light.setValue ( lightLevel );
        light.setToolTipText ( "Brightness: " + lightLevel + "%" );
        light.addChangeListener ( new ChangeListener() {
            public void stateChanged ( ChangeEvent e ) {
                lightLevel = light.getValue();
                light.setToolTipText ( "Brightness: " + lightLevel + "%" );
                prefs.putInt ( "LIGHT_LEVEL", lightLevel );
            }
        } );
    }
} );
