@Override
public void onLocationChanged ( Location location ) {
    tvLocation = ( TextView ) findViewById ( R.id.tv_location );
    latitude = location.getLatitude();
    longitude = location.getLongitude();
    LatLng latLng = new LatLng ( latitude, longitude );
    map.moveCamera ( CameraUpdateFactory.newLatLng ( latLng ) );
    map.animateCamera ( CameraUpdateFactory.zoomTo ( 15 ) );
    map.addMarker ( new MarkerOptions().position (
                        new LatLng ( latitude, longitude ) ).title ( addressText ) );
    map.setOnMarkerClickListener ( new GoogleMap.OnMarkerClickListener() {
        @Override
        public boolean onMarkerClick ( Marker marker ) {
            Toast.makeText ( getBaseContext(), "marker clicked",
                             Toast.LENGTH_LONG ).show();
            return false;
        }
    } );
    Geocoder geoCoder = new Geocoder ( this );
    try {
        matches = geoCoder.getFromLocation ( latitude, longitude, 1 );
    } catch ( IOException e ) {
        e.printStackTrace();
    }
    Address bestMatch = ( matches.isEmpty() ? null : matches.get ( 0 ) );
    addressText = String.format ( "%s, %s, %s", bestMatch
                                  .getMaxAddressLineIndex() > 0 ? bestMatch.getAddressLine ( 0 )
                                  : "", bestMatch.getLocality(), bestMatch.getCountryName() );
}
@Override
public void onMapLongClick ( LatLng point ) {
}
@Override
public void onMapClick ( LatLng point ) {
}
@Override
public boolean onCreateOptionsMenu ( Menu menu ) {
    getMenuInflater().inflate ( R.menu.main, menu );
    return true;
}
