public class LocalBinder extends Binder {
    LocalService getService() {
        return LocalService.this;
    }
}
@Override
public IBinder onBind ( Intent intent ) {
    return mBinder;
}
public int getRandomNumber() {
    return mGenerator.nextInt ( 100 );
}
}
public class BindingActivity extends Activity {
    LocalService mService;
    boolean mBound = false;
    @Override
    protected void onCreate ( Bundle savedInstanceState ) {
        super.onCreate ( savedInstanceState );
        setContentView ( R.layout.main );
    }
    @Override
    protected void onStart() {
        super.onStart();
        Intent intent = new Intent ( this, LocalService.class );
        bindService ( intent, mConnection, Context.BIND_AUTO_CREATE );
    }
    @Override
    protected void onStop() {
        super.onStop();
        if ( mBound ) {
            unbindService ( mConnection );
            mBound = false;
        }
    }
    public void onButtonClick ( View v ) {
        if ( mBound ) {
            int num = mService.getRandomNumber();
            Toast.makeText ( this, "number: " + num, Toast.LENGTH_SHORT ).show();
        }
    }
    private ServiceConnection mConnection = new ServiceConnection() {
        @Override
        public void onServiceConnected ( ComponentName className,
                                         IBinder service ) {
            LocalBinder binder = ( LocalBinder ) service;
            mService = binder.getService();
            mBound = true;
        }
        @Override
        public void onServiceDisconnected ( ComponentName arg0 ) {
            mBound = false;
        }
    };
}
