class IncomingHandler extends Handler {
    @Override
    public void handleMessage ( Message msg ) {
        switch ( msg.what ) {
        case MSG_SAY_HELLO:
            Toast.makeText ( getApplicationContext(), "hello!", Toast.LENGTH_SHORT ).show();
            break;
        default:
            super.handleMessage ( msg );
        }
    }
}
final Messenger mMessenger = new Messenger ( new IncomingHandler() );
@Override
public IBinder onBind ( Intent intent ) {
    Toast.makeText ( getApplicationContext(), "binding", Toast.LENGTH_SHORT ).show();
    return mMessenger.getBinder();
}
}
public class ActivityMessenger extends Activity {
    Messenger mService = null;
    boolean mBound;
    private ServiceConnection mConnection = new ServiceConnection() {
        public void onServiceConnected ( ComponentName className, IBinder service ) {
            mService = new Messenger ( service );
            mBound = true;
        }
        public void onServiceDisconnected ( ComponentName className ) {
            mService = null;
            mBound = false;
        }
    };
    public void sayHello ( View v ) {
        if ( !mBound ) {
            return;
        }
        Message msg = Message.obtain ( null, MessengerService.MSG_SAY_HELLO, 0, 0 );
        try {
            mService.send ( msg );
        } catch ( RemoteException e ) {
            e.printStackTrace();
        }
    }
    @Override
    protected void onCreate ( Bundle savedInstanceState ) {
        super.onCreate ( savedInstanceState );
        setContentView ( R.layout.main );
    }
    @Override
    protected void onStart() {
        super.onStart();
        bindService ( new Intent ( this, MessengerService.class ), mConnection,
                      Context.BIND_AUTO_CREATE );
    }
    @Override
    protected void onStop() {
        super.onStop();
        if ( mBound ) {
            unbindService ( mConnection );
            mBound = false;
        }
    }
}
