public class FileGetter {
    private static String RESOURCE_DIRECTORY = "bin";
    public InputStream getResourceFileStream ( String filename ) {
        InputStream inputStream = null;
        inputStream = getExternalFile ( filename );
        if ( inputStream != null ) {
            return inputStream;
        }
        inputStream = getInternalPackagedFile ( filename );
        if ( inputStream != null ) {
            return inputStream;
        }
        inputStream = getInternalUnpackagedFile ( filename );
        if ( inputStream != null ) {
            return inputStream;
        }
        return null;
    }
    private static InputStream getExternalFile ( String filename ) {
        String appRootPath = FileGetter.class.getProtectionDomain().getCodeSource()
                             .getLocation().getPath();
        try {
            String decodedPath = URLDecoder.decode ( appRootPath, "UTF-8" );
            File jarfile = new File ( decodedPath );
            File parentDirectory = jarfile.getParentFile();
            if ( testExists ( parentDirectory ) ) {
                File shellScript = new File ( parentDirectory, filename );
                if ( testExists ( shellScript ) ) {
                    return new FileInputStream ( shellScript );
                }
            }
        } catch ( UnsupportedEncodingException e ) {
        } catch ( NullPointerException e ) {
        } catch ( FileNotFoundException e ) {
        }
        return null;
    }
    private static InputStream getInternalPackagedFile ( String filename ) {
        URL resUrl = FileGetter.class.getResource ( File.separator + RESOURCE_DIRECTORY
                     + File.separator + filename );
        String badPath = resUrl.getPath();
        String goodPath = badPath.substring ( badPath.indexOf ( "!" ) + 1 );
        InputStream input = FileGetter.class.getResourceAsStream ( goodPath );
        return input;
    }
    private static InputStream getInternalUnpackagedFile ( String filename ) {
        File shellScriptFile = new File ( RESOURCE_DIRECTORY + File.separator + filename );
        if ( testExists ( shellScriptFile ) ) {
            try {
                InputStream shellScriptStream = new FileInputStream ( shellScriptFile );
                if ( shellScriptStream != null ) {
                    return shellScriptStream;
                }
            } catch ( FileNotFoundException e ) {
            }
        }
        return null;
    }
    private static boolean testExists ( File file ) {
        return file != null && file.exists() && file.canRead();
    }
}
