public class MainActivity extends Activity {
    private CustomService mService = null;
    private boolean mIsBound;
    @Override
    protected void onCreate ( Bundle savedInstanceState ) {
        super.onCreate ( savedInstanceState );
        startService ( new Intent ( this.getBaseContext(), CustomService.class ) );
        doBindService();
    }
    private ServiceConnection mConnection = new ServiceConnection() {
        @Override
        public void onServiceConnected ( ComponentName componentName, IBinder iBinder ) {
            mService = ( ( CustomService.LocalBinder ) iBinder ).getInstance();
            mService.setHandler ( yourHandler );
        }
        @Override
        public void onServiceDisconnected ( ComponentName componentName ) {
            mService = null;
        }
    };
    private void doBindService() {
        bindService ( new Intent ( this,
                                   CustomService.class ), mConnection, Context.BIND_AUTO_CREATE );
        mIsBound = true;
    }
    private void doUnbindService() {
        if ( mIsBound ) {
            unbindService ( mConnection );
            mIsBound = false;
        }
    }
    @Override
    protected void onDestroy() {
        super.onDestroy();
        doUnbindService();
    }
