import javafx.application.Application;
import javafx.beans.binding.Bindings;
import javafx.scene.Scene;
import javafx.scene.control.*;
import javafx.scene.layout.*;
import javafx.stage.Stage;
public class ScrollableTabs extends Application {
    @Override public void start ( Stage stage ) {
        final TabPane tabPane = new TabPane();
        tabPane.setTabClosingPolicy ( TabPane.TabClosingPolicy.UNAVAILABLE );
        tabPane.getTabs().setAll (
            makeTab ( "doe", "A deer, a female deer." ),
            makeTab ( "ray", "A flash a golden light." ),
            makeTab ( "me",  "A name a call myself." )
        );
        Label selectedLabel = new Label();
        selectedLabel.textProperty().bind (
            Bindings.select (
                tabPane,
                "selectionModel",
                "selectedItem",
                "content",
                "text"
            )
        );
        tabPane.getSelectionModel().select ( 1 );
        VBox.setVgrow ( tabPane, Priority.ALWAYS );
        stage.setScene (
            new Scene (
                new VBox ( 10,
                           selectedLabel,
                           tabPane
                         )
            )
        );
        stage.show();
    }
    private Tab makeTab ( String title, String text ) {
        Tab tab = new Tab ( title );
        tab.setContent (
            new TextArea ( text )
        );
        return tab;
    }
    public static void main ( String[] args ) {
        launch ( args );
    }
}
