import org.eclipse.jdt.core.dom.AST;
import org.eclipse.jdt.core.dom.ASTNode;
import org.eclipse.jdt.core.dom.ASTParser;
import org.eclipse.jdt.core.dom.Block;
import org.eclipse.jdt.core.dom.CompilationUnit;
import org.eclipse.jdt.core.dom.MethodDeclaration;
import org.eclipse.jdt.core.dom.TypeDeclaration;
public class JdtDomExample {
    public static void main ( String[] args ) {
        AST ast = AST.newAST ( AST.JLS8 );
        CompilationUnit cu =  ast.newCompilationUnit();
        TypeDeclaration typeDecl = ast.newTypeDeclaration();
        typeDecl.setName ( ast.newSimpleName ( "MyClass" ) );
        cu.types().add ( typeDecl );
        MethodDeclaration method = cu.getAST().newMethodDeclaration();
        method.setName ( ast.newSimpleName ( "myMethod" ) );
        typeDecl.bodyDeclarations().add ( method );
        ASTParser parser = ASTParser.newParser ( AST.JLS8 );
        parser.setSource ( "System.out.println(\"Hello\" + \" world\");".toCharArray() );
        parser.setKind ( ASTParser.K_STATEMENTS );
        Block block = ( Block ) parser.createAST ( null );
        block = ( Block ) ASTNode.copySubtree ( ast, block );
        method.setBody ( block );
        System.out.println ( cu );
    }
}
