KeyPairGenerator kpg = KeyPairGenerator.getInstance ( "EC" );
ECGenParameterSpec gps = new ECGenParameterSpec ( "secp256r1" );
kpg.initialize ( gps );
KeyPair apair = kpg.generateKeyPair();
ECPublicKey apub  = ( ECPublicKey ) apair.getPublic();
ECParameterSpec aspec = apub.getParams();
ECPoint apoint = apub.getW();
BigInteger x = apoint.getAffineX(), y = apoint.getAffineY();
ECPoint bpoint = new ECPoint ( x, y );
ECPublicKeySpec bpubs = new ECPublicKeySpec ( bpoint, aspec );
KeyFactory kfa = KeyFactory.getInstance ( "EC" );
ECPublicKey bpub = ( ECPublicKey ) kfa.generatePublic ( bpubs );
Signature sig = Signature.getInstance ( "SHA256withECDSA" );
byte [] data = "test".getBytes();
sig.initSign ( apair.getPrivate() );
sig.update ( data );
byte[] dsig = sig.sign();
sig.initVerify ( bpub );
sig.update ( data );
System.out.println ( sig.verify ( dsig ) );
