private static boolean isOperandChar ( final char c ) {
    return Character.isDigit ( c ) || c == '.';
}
private static String[] splitPostfixExpression ( final String input ) {
    final List<String> postfixExpression = new ArrayList<>();
    boolean encounteredOperandStart = false;
    String currentOperand = "";
    for ( final char c : input.toCharArray() ) {
        if ( encounteredOperandStart ) {
            if ( isOperandChar ( c ) ) {
                currentOperand += c;
            } else {
                postfixExpression.add ( currentOperand );
                postfixExpression.add ( String.valueOf ( c ) );
                currentOperand = "";
                encounteredOperandStart = false;
            }
        } else {
            if ( isOperandChar ( c ) ) {
                encounteredOperandStart = true;
            }
            currentOperand += c;
        }
    }
    if ( !currentOperand.isEmpty() ) {
        postfixExpression.add ( currentOperand );
    }
    return postfixExpression.toArray ( new String[postfixExpression.size()] );
}
