private static final class TestKey implements Serializable {
    boolean equals;
    int hash;
    TestKey ( boolean equals, int hash ) {
        this.equals = equals;
        this.hash = hash;
    }
    @Override
    public boolean equals ( Object other ) {
        return equals;
    }
    @Override
    public int hashCode() {
        return hash;
    }
}
public void testIdentity() throws Exception {
    CacheEHCache<TestKey, String> cache = CacheEHCache.instance (
            new File ( "/tmp/ehcache" ), "testcache", 10 );
    cache.clear();
    TestKey k11 = new TestKey ( true, 1 );
    cache.put ( k11, "Test11" );
    assertEquals ( cache.size(), 1 );
    assertTrue ( cache.containsKey ( k11 ) );
    cache.remove ( k11 );
    assertEquals ( cache.size(), 0 );
    TestKey k21 = new TestKey ( false, 1 );
    cache.put ( k21, "Test21" );
    assertEquals ( cache.size(), 1 );
    assertFalse ( cache.containsKey ( k21 ) );
    k21.equals = true;
    cache.clear();
    assertEquals ( cache.size(), 0 );
    TestKey k31 = new TestKey ( true, 1 );
    TestKey k32 = new TestKey ( true, 2 );
    cache.put ( k31, "Test21" );
    assertEquals ( cache.size(), 1 );
    assertTrue ( cache.containsKey ( k31 ) );
    assertFalse ( cache.containsKey ( k32 ) );
    cache.clear();
}
