private Image head;
public Character ( BufferedImage head ) {
    this.head = makeColorTransparent ( head, Color.WHITE );
}
public void draw ( Graphics2D g ) {
    g.drawImage ( head, ( int ) posX, ( int ) posY, null );
}
public static Image makeColorTransparent ( BufferedImage im, final Color color ) {
    ImageFilter filter = new RGBImageFilter() {
        public int markerRGB = color.getRGB() | 0xFF000000;
        public final int filterRGB ( int x, int y, int rgb ) {
            if ( ( rgb | 0xFF000000 ) == markerRGB ) {
                return 0x00FFFFFF & rgb;
            } else {
                return rgb;
            }
        }
    };
    ImageProducer ip = new FilteredImageSource ( im.getSource(), filter );
    return Toolkit.getDefaultToolkit().createImage ( ip );
}
