import java.math.BigDecimal;
public class MathArray<N extends Number> {
    private Number[] array;
    MathArray ( N[] array ) {
        this.array = array;
    }
    void warnNaN ( Double bd ) {
        if ( ( bd.isNaN() ) ) {
            System.err.println ( "Warning: result is undefined" );
        }
    }
    void warnNaN ( Number bd ) {
        warnNaN ( new Double ( bd.doubleValue() ) ) ;
    }
    void applyNeg() {
        for ( int i = 0; i < array.length; i++ ) {
            array[i] = negate ( array[i] );
            warnNaN ( array[i] );
        }
    }
    private Number negate ( BigDecimal bd ) {
        return bd.negate() ;
    }
    private Number negate ( Double bd ) {
        return bd.isNaN() ? bd : new BigDecimal ( bd.doubleValue() ).negate() ;
    }
    private Number negate ( Number bd ) {
        return negate ( new Double ( bd.doubleValue() ) ) ;
    }
    void applySqrt() {
        for ( int i = 0; i < array.length; i++ ) {
            array[i] = new Double ( Math.sqrt ( array[i].doubleValue() ) );
            warnNaN ( array[i] );
        }
    }
    void applySin() {
        for ( int i = 0; i < array.length; i++ ) {
            array[i] = new Double ( Math.sin ( array[i].doubleValue() ) );
            warnNaN ( array[i] );
        }
    }
    void applyCos() {
        for ( int i = 0; i < array.length; i++ ) {
            array[i] = new Double ( Math.cos ( array[i].doubleValue() ) );
            warnNaN ( array[i] );
        }
    }
    void print() {
        for ( int i = 0; i < array.length; i++ ) {
            System.out.print ( array[i] + ( i < array.length - 1 ? ", " : "\n" ) );
        }
    }
    public static void main ( String[] args ) {
        MathArray<Number> te = new MathArray<Number> ( new Number[] { new BigDecimal ( 0.1 ), new BigDecimal ( 2.23 ), new BigDecimal ( 3.08 ) } );
        te.applySin();
        te.applySqrt();
        te.applyNeg();
        te.print();
    }
}
