public static long pushEventToCalender ( Activity curActivity,
        String title, String addInfo, String place, int status,
        long startDate, int reminderTime, boolean needReminder,
        boolean needMailService ) {
    String eventUriString = "content://com.android.calendar/events";
    ContentValues eventValues = new ContentValues();
    eventValues.put ( "calendar_id", 1 );
    eventValues.put ( "title", title );
    eventValues.put ( "description", addInfo );
    eventValues.put ( "eventLocation", place );
    long endDate = startDate + 1000 * 60 * 60;
    eventValues.put ( "dtstart", startDate );
    eventValues.put ( "dtend", endDate );
    eventValues.put ( "eventStatus", status );
    eventValues.put ( "hasAlarm", 1 );
    eventValues.put ( "eventTimezone", TimeZone.getDefault().getID() );
    Uri eventUri = curActivity.getApplicationContext().getContentResolver()
                   .insert ( Uri.parse ( eventUriString ), eventValues );
    long eventID = Long.parseLong ( eventUri.getLastPathSegment() );
    if ( needReminder ) {
        String reminderUriString = "content://com.android.calendar/reminders";
        ContentValues reminderValues = new ContentValues();
        reminderValues.put ( "event_id", eventID );
        reminderValues.put ( "minutes", reminderTime );
        reminderValues.put ( "method", 1 );
        Uri reminderUri = curActivity.getApplicationContext()
                          .getContentResolver()
                          .insert ( Uri.parse ( reminderUriString ), reminderValues );
        if ( _DEBUG ) {
            Log.e ( "URI", reminderUri.toString() );
        }
    }
    if ( needMailService ) {
        String attendeuesesUriString = "content://com.android.calendar/attendees";
        ContentValues attendeesValues = new ContentValues();
        attendeesValues.put ( "event_id", eventID );
        attendeesValues.put ( "attendeeName", "xxxxx" );
        attendeesValues.put ( "attendeeEmail", "yyyy@gmail.com" );
        attendeesValues.put ( "attendeeRelationship", 0 );
        attendeesValues.put ( "attendeeType", 0 );
        attendeesValues.put ( "attendeeStatus", 0 );
        Uri attendeuesesUri = curActivity.getApplicationContext()
                              .getContentResolver()
                              .insert ( Uri.parse ( attendeuesesUriString ), attendeesValues );
        if ( _DEBUG ) {
            Log.e ( "URI", attendeuesesUri.toString() );
        }
    }
    return eventID;
}
