import java.util.concurrent.Callable;
import javafx.application.Application;
import javafx.beans.binding.Bindings;
import javafx.scene.Node;
import javafx.scene.Scene;
import javafx.scene.control.TextArea;
import javafx.scene.layout.VBox;
import javafx.stage.Stage;
public class AutosizingTextArea extends Application {
    @Override
    public void start ( Stage primaryStage ) {
        TextArea textArea = new TextArea();
        textArea.setMinHeight ( 24 );
        textArea.setWrapText ( true );
        VBox root = new VBox ( textArea );
        Scene scene = new Scene ( root, 600, 400 );
        primaryStage.setScene ( scene );
        primaryStage.show();
        Node text = textArea.lookup ( ".text" );
        textArea.prefHeightProperty().bind ( Bindings.createDoubleBinding ( new Callable<Double>() {
            @Override
            public Double call() throws Exception {
                return text.getBoundsInLocal().getHeight();
            }
        }, text.boundsInLocalProperty() ).add ( 20 ) );
    }
    public static void main ( String[] args ) {
        launch ( args );
    }
}
