public class TimerView extends TextView {
    private Handler handler = new Handler();
    private long startTime;
    private long elapsedTime;
    private final int REFRESH_RATE = 100;
    private String hours, minutes, seconds, milliseconds;
    private long secs, mins, hrs;
    private boolean stopped = false;
    public TimerView ( Context context ) {
        super ( context );
    }
    public TimerView ( Context context, AttributeSet attrs ) {
        super ( context, attrs );
    }
    public TimerView ( Context context, AttributeSet attrs, int defStyle ) {
        super ( context, attrs, defStyle );
    }
    public void start() {
        if ( stopped ) {
            startTime = System.currentTimeMillis() - elapsedTime;
        } else {
            startTime = System.currentTimeMillis();
        }
        handler.removeCallbacks ( startTimer );
        handler.postDelayed ( startTimer, 0 );
    }
    public void stop() {
        handler.removeCallbacks ( startTimer );
        stopped = true;
    }
    private Runnable startTimer = new Runnable() {
        public void run() {
            elapsedTime = System.currentTimeMillis() - startTime;
            updateTimer ( elapsedTime );
            handler.postDelayed ( this, REFRESH_RATE );
        }
    };
    private void updateTimer ( float time ) {
        secs = ( long ) ( time / 1000 );
        mins = ( long ) ( ( time / 1000 ) / 60 );
        hrs = ( long ) ( ( ( time / 1000 ) / 60 ) / 60 );
        secs = secs % 60;
        seconds = String.valueOf ( secs );
        if ( secs == 0 ) {
            seconds = "00";
        }
        if ( secs < 10 && secs > 0 ) {
            seconds = "0" + seconds;
        }
        mins = mins % 60;
        minutes = String.valueOf ( mins );
        if ( mins == 0 ) {
            minutes = "00";
        }
        if ( mins < 10 && mins > 0 ) {
            minutes = "0" + minutes;
        }
        hours = String.valueOf ( hrs );
        if ( hrs == 0 ) {
            hours = "00";
        }
        if ( hrs < 10 && hrs > 0 ) {
            hours = "0" + hours;
        }
        milliseconds = String.valueOf ( ( long ) time );
        if ( milliseconds.length() == 2 ) {
            milliseconds = "0" + milliseconds;
        }
        if ( milliseconds.length() <= 1 ) {
            milliseconds = "00";
        }
        milliseconds = milliseconds.substring ( milliseconds.length() - 3, milliseconds.length() - 2 );
        this.setText ( minutes + ":" + seconds + "." + milliseconds );
    }
}
