public static Bitmap decodeSampledBitmapFromResource ( InputStream in,
        int reqWidth, int reqHeight ) throws IOException {
    final BitmapFactory.Options options = new BitmapFactory.Options();
    options.inJustDecodeBounds = true;
    in.mark ( in.available() );
    BitmapFactory.decodeStream ( in, null, options );
    options.inSampleSize = calculateInSampleSize ( options, reqWidth,
                           reqHeight );
    in.reset();
    options.inJustDecodeBounds = false;
    return BitmapFactory.decodeStream ( in, null, options );
}
public static int calculateInSampleSize ( BitmapFactory.Options options,
        int reqWidth, int reqHeight ) {
    final int height = options.outHeight;
    final int width = options.outWidth;
    int inSampleSize = 1;
    if ( height > reqHeight || width > reqWidth ) {
        final int halfHeight = height / 2;
        final int halfWidth = width / 2;
        while ( ( halfHeight / inSampleSize ) > reqHeight
                && ( halfWidth / inSampleSize ) > reqWidth ) {
            inSampleSize *= 2;
        }
    }
    return inSampleSize;
}
