public static org.apache.logging.log4j.Logger createInstanceLogger ( String appenderName,
        String logFileName ) {
    org.apache.logging.log4j.Logger logger = org.apache.logging.log4j.LogManager
            .getLogger ( String.format ( "DynamicLogger%s",
                                         String.valueOf ( DynamicLogManager.loggerCount++ ) ) );
    org.apache.logging.log4j.core.Logger coreLogger = ( org.apache.logging.log4j.core.Logger ) logger;
    org.apache.logging.log4j.core.LoggerContext context = coreLogger.getContext();
    org.apache.logging.log4j.core.config.BaseConfiguration configuration = ( org.apache.logging.log4j.core.config.BaseConfiguration ) context
            .getConfiguration();
    TriggeringPolicy compositePolicy = CompositeTriggeringPolicy.createPolicy (
                                           SizeBasedTriggeringPolicy.createPolicy ( "5mb" ),
                                           TimeBasedTriggeringPolicy.createPolicy ( "1", "true" ) );
    String fileName = String.format ( "%1$s/%2$s", appenderName, logFileName );
    String filePattern = String.format ( "%1$s/%2$s.%%d{yyyy-MM-dd}",
                                         appenderName, logFileName );
    Layout<String> layout = PatternLayout.createLayout ( DynamicLogManager._conversionPattern,
                            configuration, RegexReplacement.createRegexReplacement ( "a^", "." ),
                            "utf-8", "false" );
    Filter f = ThresholdFilter.createFilter ( "trace", "accept", "accept" );
    Appender a = RollingFileAppender.createAppender ( fileName,
                 filePattern,
                 "true",
                 appenderName,
                 "true",
                 "true",
                 compositePolicy,
                 null,
                 layout,
                 f,
                 "true",
                 "false",
                 "null",
                 configuration
                                                    );
    a.start();
    coreLogger.addAppender ( a );
    coreLogger.setLevel ( Level.ALL );
    return coreLogger;
