@Configuration
@EnableWebMvcSecurity
public class SecurityConfig extends WebSecurityConfigurerAdapter {
    @Autowired
    private UserDetailsService userDetailsService;
    @Override
    protected void configure ( HttpSecurity http ) throws Exception {
        http
        .formLogin()
        .loginPage ( "/login" )
        .defaultSuccessUrl ( "/petclinic/" )
        .usernameParameter ( "j_username" )
        .passwordParameter ( "j_password" )
        .loginProcessingUrl ( "/j_spring_security_check" )
        .failureUrl ( "/login" )
        .permitAll()
        .and()
        .logout()
        .logoutSuccessUrl ( "/index.jsp" )
        .and()
        .authorizeRequests()
        .antMatchers ( "/**" ).hasRole ( "ROLE_ADMIN" )
        .antMatchers ( "/j_spring_security_check" ).permitAll()
        .and()
        .userDetailsService ( userDetailsService );
    }
}
