public class ImmutablePagedTableModel extends AbstractTableModel {
    private final List<MyBusinessObject> allData;
    private final int pageSize;
    private int pos;
    public ImmutablePagedTableModel ( List<MyBusinessObject> allData ) {
        this.allData = new ArrayList<MyBusinessObject> ( allData );
    }
    public boolean hasNextPage() {
        return pos + pageSize < allData.size();
    }
    public void nextPage() {
        if ( hasNextPage() ) {
            pos += pageSize;
            fireTableDataChanged();
        } else {
            throw new IndexOutOfBoundsException();
        }
    }
    public int getRowcount() {
        return Math.min ( pageSize, allData.size() - pos );
    }
}
