public class GamePanel extends JPanel {
    List<BlueSpell> spells;
    Timer timer = null;
    public GamePanel() {
        spells = new ArrayList<>();
        timer = new Timer ( 40, new ActionListener() {
            public void actionPerformed ( ActionEvent e ) {
                If ( spells.size() > 0 ) {
                    Iterator spellIt = spells.iterator();
                    while ( spellIt.hasNext() ) {
                        BlueSpell spell = ( BlueSpell ) spellIt.next();
                        if ( spell.collidesWithSomthing() ) {
                            spellIt.remove();
                        } else if ( spell.isOffScreen() ) {
                            spellIt.remove();
                        } else {
                            spell.animate();
                        }
                    }
                }
                repaint();
            }
        } );
        timer.start();
    }
    protected void paintComponent ( Graphics g ) {
        super.paintComponent ( g );
        If ( spells.size() > 0 ) {
            for ( BlueSpell spell : spells ) {
                spell.drawSpell ( g );
            }
        }
    }
}
