HttpProcessor processor = HttpProcessorBuilder.create()
                          .addAll ( new RequestContent(),
                                    new RequestTargetHost(),
                                    new RequestConnControl(),
                                    new RequestUserAgent ( "HTTP/1.1" ) )
                          .build();
InetSocketAddress target = new InetSocketAddress ( "localhost", 8080 );
CustomHttpConnection conn = new CustomHttpConnection ( 10 * 1024 );
try {
    Socket socket = new Socket();
    socket.connect ( target, 5000 );
    conn.bind ( socket );
    HttpGet request = new HttpGet ( "/" );
    request.addHeader ( HTTP.CONN_DIRECTIVE, HTTP.CONN_CLOSE );
    HttpClientContext context = HttpClientContext.create();
    context.setTargetHost ( new HttpHost ( target.getHostName(), target.getPort() ) );
    context.setRequestConfig ( RequestConfig.DEFAULT );
    context.setAttribute ( HttpClientContext.HTTP_REQUEST, request );
    context.setAttribute ( HttpClientContext.HTTP_CONNECTION, conn );
    processor.process ( request, context );
    conn.sendRequestHeader ( request );
    if ( request instanceof HttpEntityEnclosingRequest ) {
        conn.sendRequestEntity ( ( ( HttpEntityEnclosingRequest ) request ) );
    }
    conn.flush();
    SessionInputBuffer connSessionInputBuffer = conn.getSessionInputBuffer();
    IdentityInputStream instream = new IdentityInputStream ( connSessionInputBuffer );
    int l;
    byte[] buff = new byte[1024];
    while ( ( l = instream.read ( buff ) ) != -1 ) {
        System.out.println ( new String ( buff, 0, l, Consts.ASCII ) );
    }
} finally {
    conn.close();
}
