import org.apache.jena.atlas.io.IndentedWriter;
import org.apache.log4j.Logger;
import com.hp.hpl.jena.query.Query;
import com.hp.hpl.jena.query.QueryExecution;
import com.hp.hpl.jena.query.QueryExecutionFactory;
import com.hp.hpl.jena.query.QueryFactory;
import com.hp.hpl.jena.query.QuerySolution;
import com.hp.hpl.jena.query.ResultSet;
import com.hp.hpl.jena.rdf.model.Model;
import com.hp.hpl.jena.rdf.model.ModelFactory;
import com.hp.hpl.jena.rdf.model.RDFNode;
import com.hp.hpl.jena.rdf.model.Resource;
import com.hp.hpl.jena.util.FileManager;
import com.hp.hpl.jena.vocabulary.RDF;
public class Jungle1 {
    public static final String jungle_file = "jungle.n3";
    public static final String NL = System.getProperty ( "line.separator" );
    private static final Logger log = Logger.getLogger ( "Jungle1" );
    public static void main ( String[] args ) {
        final Model m = ModelFactory.createDefaultModel();
        FileManager.get().readModel ( m, jungle_file );
        log.debug ( "We have loaded a model with no. statements = " + m.size() );
        final String jungle = "http://www.lirmm.fr/jungle#";
        final String prolog1 = "PREFIX jungle: <" + jungle + ">";
        final String prolog2 = "PREFIX rdf: <" + RDF.getURI() + ">";
        final String queryString = prolog1 + NL + prolog2 + NL + "SELECT ?individu WHERE {?individu rdf:type jungle:Lion }";
        final Query query = QueryFactory.create ( queryString );
        query.serialize ( new IndentedWriter ( System.out, true ) );
        System.out.println();
        final QueryExecution qexec = QueryExecutionFactory.create ( query, m );
        System.out.println ( "Les Lions : " );
        try {
            final ResultSet rs = qexec.execSelect();
            for ( ; rs.hasNext(); ) {
                final QuerySolution rb = rs.nextSolution();
                final RDFNode y = rb.get ( "individu" );
                System.out.print ( "uri : " + y + "--- " );
                final Resource z = rb.getResource ( "individu" );
                System.out.println ( "plus simplement " + z.getLocalName() );
            }
        } finally {
            qexec.close();
        }
    }
}
