package org.springframework.mail.javamail;
import javax.activation.FileTypeMap;
import javax.mail.Address;
import javax.mail.MessagingException;
import javax.mail.Session;
import javax.mail.internet.MimeMessage;
public class RoutedSmartMimeMessage extends SmartMimeMessage {
    private Address[] rcptTo = null;
    public RoutedSmartMimeMessage ( final Session session,
                                    final String defaultEncoding,
                                    final FileTypeMap defaultFileTypeMap ) {
        super ( session, defaultEncoding, defaultFileTypeMap );
    }
    public Address[] getRcptTo() {
        return rcptTo;
    }
    public void setRcptTo ( final Address... rcptTo ) {
        this.rcptTo = rcptTo;
    }
    @Override
    public Address[] getAllRecipients() throws MessagingException {
        if ( rcptTo != null ) {
            return rcptTo;
        } else {
            return super.getAllRecipients();
        }
    }
    public static MimeMessage createMesage ( final JavaMailSenderImpl javaMailSender ) {
        return new SmartMimeMessage ( javaMailSender.getSession(), javaMailSender.getDefaultEncoding(), javaMailSender.getDefaultFileTypeMap() );
    }
}
