public class TimerTest {
    public static final int TIMEOUT = 5;
    private static Timer timer;
    public static void main ( String[] args ) {
        timer = myTimer ( TIMEOUT );
        try {
            Thread.sleep ( 2500 );
        } catch ( InterruptedException e ) {
        }
        timer.cancel();
        System.out.println ( "Timer interrupted by main" );
    }
    public static Timer myTimer ( final int timeout ) {
        final Timer t = new Timer();
        TimerTask timerTask = new TimerTask() {
            private int sec = timeout;
            @Override
            public void run() {
                sec--;
                if ( sec < 0 ) {
                    t.cancel();
                    System.out.println ( "Timer stopped by TimerTask" );
                } else {
                    System.out.println ( "Current time: " + ( sec < 10 ? "0" : "" ) + sec + " seconds" );
                }
            }
        };
        t.schedule ( timerTask, 1000, 1000 );
        return t;
    }
}
