public class MoreDoubleStatistics extends DoubleSummaryStatistics {
    private double M1, M2, M3, M4;
    @Override
    public void accept ( double x ) {
        super.accept ( x );
        double delta, delta_n, delta_n2, term1;
        long n = getCount();
        long n1 = n - 1;
        delta = x - M1;
        delta_n = delta / n;
        delta_n2 = delta_n * delta_n;
        term1 = delta * delta_n * n1;
        M1 += delta_n;
        M4 += term1 * delta_n2 * ( n * n - 3 * n + 3 ) + 6 * delta_n2 * M2 - 4 * delta_n * M3;
        M3 += term1 * delta_n * ( n - 2 ) - 3 * delta_n * M2;
        M2 += term1;
    }
    public double mean() {
        return getAverage();
    }
    public double variance() {
        return M2 / ( getCount() - 1 );
    }
    public double stdDev() {
        return sqrt ( variance() );
    }
    public double skew() {
        return sqrt ( getCount() ) * M3 / pow ( M2, 1.5 );
    }
    public double kurtosis() {
        return getCount() * M4 / ( M2 * M2 ) - 3.0;
    }
}
