public enum Action {
    MOVE_FORWARD, REVERSE, TURN_LEFT, TURN_RIGHT
    Action decodeAction ( boolean b1, boolean b2 ) {
        Action ret;
        if ( b1 ) {
            ret = b2 ? Action.MOVE_FORWARD : Action.TURN_LEFT;
        } else {
            ret = b2 ? Action.TURN_RIGHT : Action.REVERSE;
        }
        return ret;
    }
}
public class Gene {
    private final boolean[] values = new boolean[32];
    public Action getActionForSensorInputs ( boolean wallInFront,
            boolean wallBehind, boolean wallToLeft, boolean wallToRight ) {
        int i = 0;
        if ( wallToRight ) {
            i |= 0x01;
        }
        if ( wallToLeft ) {
            i |= 0x02;
        }
        if ( wallBehind ) {
            i |= 0x04;
        }
        if ( wallInFront ) {
            i |= 0x08;
        }
        int index = i * 2;
        boolean b1 = this.values[index];
        boolean b2 = this.values[index + 1];
        return Action.decodeAction ( b1, b2 );
    }
}
