public class CorsFilter implements Filter {
    private static final Logger log = Logger.getAnonymousLogger();
    @Override
    public void init ( FilterConfig filterConfig ) throws ServletException {
    }
    @Override
    public void doFilter ( ServletRequest servletRequest, ServletResponse servletResponse, FilterChain filterChain ) throws IOException, ServletException {
        log.info ( "Adding Access Control Response Headers" );
        HttpServletResponse response = ( HttpServletResponse ) servletResponse;
        response.setHeader ( "Access-Control-Allow-Origin", "*" );
        response.setHeader ( "Access-Control-Allow-Credentials", "true" );
        response.setHeader ( "Access-Control-Allow-Methods", "POST, GET, HEAD, OPTIONS" );
        response.setHeader ( "Access-Control-Allow-Headers", "Origin, Accept, X-Requested-With, Content-Type, Access-Control-Request-Method, Access-Control-Request-Headers" );
        filterChain.doFilter ( servletRequest, servletResponse );
    }
    @Override
    public void destroy() {
    }
}
