template <typename TDerived>
class Singleton {
    static_assert ( is_base_of<Singleton, TDerived>::value, "Singleton: unexpected Derived template parameter" );
    public:
    static TDerived & instance() {
        static TDerived instance_;
        return instance_;
    }
    protected:
    Singleton() {
    }
};
class SomeSingleton : public Singleton<SomeSingleton> {
    ...
};
