import org.sonar.api.component.ResourcePerspectives;
public class MySensor extends Sensor {
    private final ResourcePerspectives perspectives;
    public MySensor ( ResourcePerspectives p ) {
        this.perspectives = p;
    }
    public void analyse ( Project project, SensorContext context ) {
        Resource myResource;
        Issuable issuable = perspectives.as ( Issuable.class, myResource );
        if ( issuable != null ) {
            Issue issue = issuable.newIssueBuilder()
                          .setRuleKey ( RuleKey.of ( "pmd", "AvoidArrayLoops" )
                                        .setLine ( 10 )
                                        .build();
                                        issuable.addIssue ( issue );
        }
    }
}
