package examples.yellowPages;
import jade.core.Agent;
import jade.core.AID;
import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPANames;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;
import jade.domain.FIPAAgentManagement.Property;
public class DFRegisterAgent extends Agent {
    protected void setup() {
        String serviceName = "unknown";
        Object[] args = getArguments();
        if ( args != null && args.length > 0 ) {
            serviceName = ( String ) args[0];
        }
        System.out.println ( "Agent " + getLocalName() + " registering service \"" + serviceName + "\" of type \"weather-forecast\"" );
        try {
            DFAgentDescription dfd = new DFAgentDescription();
            dfd.setName ( getAID() );
            ServiceDescription sd = new ServiceDescription();
            sd.setName ( serviceName );
            sd.setType ( "weather-forecast" );
            sd.addOntologies ( "weather-forecast-ontology" );
            sd.addLanguages ( FIPANames.ContentLanguage.FIPA_SL );
            sd.addProperties ( new Property ( "country", "Italy" ) );
            dfd.addServices ( sd );
            DFService.register ( this, dfd );
        } catch ( FIPAException fe ) {
            fe.printStackTrace();
        }
    }
}
