package examples.yellowPages;
import jade.core.Agent;
import jade.core.AID;
import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPANames;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;
import jade.domain.FIPAAgentManagement.SearchConstraints;
import jade.util.leap.Iterator;
public class DFSearchAgent extends Agent {
    protected void setup() {
        System.out.println ( "Agent " + getLocalName() + " searching for services of type \"weather-forecast\"" );
        try {
            DFAgentDescription template = new DFAgentDescription();
            ServiceDescription templateSd = new ServiceDescription();
            templateSd.setType ( "weather-forecast" );
            template.addServices ( templateSd );
            SearchConstraints sc = new SearchConstraints();
            sc.setMaxResults ( new Long ( 10 ) );
            DFAgentDescription[] results = DFService.search ( this, template, sc );
            if ( results.length > 0 ) {
                System.out.println ( "Agent " + getLocalName() + " found the following weather-forecast services:" );
                for ( int i = 0; i < results.length; ++i ) {
                    DFAgentDescription dfd = results[i];
                    AID provider = dfd.getName();
                    Iterator it = dfd.getAllServices();
                    while ( it.hasNext() ) {
                        ServiceDescription sd = ( ServiceDescription ) it.next();
                        if ( sd.getType().equals ( "weather-forecast" ) ) {
                            System.out.println ( "- Service \"" + sd.getName() + "\" provided by agent " + provider.getName() );
                        }
                    }
                }
            } else {
                System.out.println ( "Agent " + getLocalName() + " did not find any weather-forecast service" );
            }
        } catch ( FIPAException fe ) {
            fe.printStackTrace();
        }
    }
}
