import jade.core.*;
import jade.core.behaviours.*;
import jade.domain.FIPAAgentManagement.*;
import jade.domain.FIPAException;
import jade.domain.DFService;
import jade.domain.FIPANames;
import jade.util.leap.Iterator;
public class SubDF2 extends jade.domain.df {
    public void setup() {
        int len = 0;
        byte[] buffer = new byte[1024];
        try {
            AID parentName = new AID ( "df@10.251.216.135:1099/JADE" );
            parentName.addAddresses ( "http://NikhilChilwant:7778/acc" );
            super.setup();
            setDescriptionOfThisDF ( getDescription() );
            super.showGui();
            DFService.register ( this, parentName, getDescription() );
            addParent ( parentName, getDescription() );
            System.out.println ( "Agent: " + getName() + " federated with default df." );
            DFAgentDescription template = new DFAgentDescription();
            ServiceDescription templateSd = new ServiceDescription();
            templateSd.setType ( "weather-forecast" );
            templateSd.addProperties ( new Property ( "country", "Italy" ) );
            template.addServices ( templateSd );
            SearchConstraints sc = new SearchConstraints();
            sc.setMaxResults ( new Long ( 10 ) );
            DFAgentDescription[] results = DFService.search ( this, parentName, template, sc );
            System.out.println ( "SUB DF ***Agent " + getLocalName() + " found the following weather-forecast services:" );
            for ( int i = 0; i < results.length; ++i ) {
                DFAgentDescription dfd = results[i];
                AID provider = dfd.getName();
                Iterator it = dfd.getAllServices();
                while ( it.hasNext() ) {
                    ServiceDescription sd = ( ServiceDescription ) it.next();
                    if ( sd.getType().equals ( "weather-forecast" ) ) {
                        System.out.println ( "- Service \"" + sd.getName() + "\" provided by agent " + provider.getName() );
                    }
                }
            }
            String serviceName = "unknown2";
            DFAgentDescription dfd = new DFAgentDescription();
            dfd.setName ( getAID() );
            ServiceDescription sd = new ServiceDescription();
            sd.setName ( serviceName );
            sd.setType ( "weather-forecast2" );
            sd.addOntologies ( "weather-forecast-ontology2" );
            sd.addLanguages ( FIPANames.ContentLanguage.FIPA_SL );
            sd.addProperties ( new Property ( "country2", "Italy2" ) );
            dfd.addServices ( sd );
            DFService.register ( this, parentName, dfd );
        } catch ( FIPAException fe ) {
            fe.printStackTrace();
        }
    }
    private DFAgentDescription getDescription() {
        DFAgentDescription dfd = new DFAgentDescription();
        dfd.setName ( getAID() );
        ServiceDescription sd = new ServiceDescription();
        sd.setName ( getLocalName() + "-sub-df" );
        sd.setType ( "fipa-df" );
        sd.addProtocols ( FIPANames.InteractionProtocol.FIPA_REQUEST );
        sd.addOntologies ( "fipa-agent-management" );
        sd.setOwnership ( "JADE" );
        dfd.addServices ( sd );
        return dfd;
    }
}
