package org.simplecorporation.myengine.core.android;
import org.simplecorporation.myengine.core.Settings;
import org.simplecorporation.myengine.core.game.BaseGame;
import org.simplecorporation.myengine.core.input.InputManager;
import org.simplecorporation.myengine.utils.ScreenUtils;
import android.app.Activity;
import android.graphics.Paint;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
public class AndroidDisplay extends SurfaceView implements SurfaceHolder.Callback {
    public BaseGame androidGame;
    public AndroidGameThread androidGameThread;
    public boolean created;
    public AndroidDisplay ( Activity gameActivity , BaseGame androidGame ) {
        super ( gameActivity );
        this.getHolder().addCallback ( this );
        AndroidStore.gameActivity = gameActivity;
        this.androidGame = androidGame;
        this.androidGameThread = new AndroidGameThread ( this.getHolder(), this.androidGame, this );
        this.created = false;
        this.setFocusable ( true );
    }
    public void surfaceCreated ( SurfaceHolder surfaceHolder ) {
        this.created = true;
        InputManager.create();
        if ( Settings.Window.Fullscreen ) {
            Settings.Window.Size.Width = ScreenUtils.getScreenWidth();
            Settings.Window.Size.Height = ScreenUtils.getScreenHeight();
        } else {
            Settings.Window.Size.Width = this.getWidth();
            Settings.Window.Size.Height = this.getHeight();
        }
        AndroidStore.gameResources = this.getResources();
        this.androidGame.gameCreated();
        AndroidStore.gamePaint = new Paint();
        this.androidGameThread.setRunning ( true );
        if ( ! this.androidGameThread.isAlive() ) {
            this.androidGameThread.start();
        }
    }
    public void surfaceChanged ( SurfaceHolder surfaceHolder , int format , int width , int height ) {
        Settings.Window.Size.Width = ScreenUtils.getScreenWidth();
        Settings.Window.Size.Height = ScreenUtils.getScreenHeight();
        this.androidGameThread.surfaceHolder = surfaceHolder;
    }
    public void surfaceDestroyed ( SurfaceHolder surfaceHolder ) {
        this.created = false;
    }
    public void stopThread() {
        boolean retry = true;
        while ( retry ) {
            try {
                this.androidGame.gameStopped();
                this.androidGame.gameClosing();
                this.androidGameThread.join();
                retry = false;
            } catch ( InterruptedException e ) {
            }
        }
    }
}
