public class Demo extends Application {
    ListView<String> list = new ListView<String>();
    ObservableList<String> data = FXCollections.observableArrayList (
                                      "chocolate", "salmon", "gold", "coral", "darkorchid",
                                      "darkgoldenrod", "lightsalmon", "black", "rosybrown", "blue",
                                      "blueviolet", "brown" );
    @Override
    public void start ( Stage stage ) {
        VBox box = new VBox();
        Scene scene = new Scene ( box, 200, 200 );
        stage.setScene ( scene );
        box.getChildren().addAll ( list );
        VBox.setVgrow ( list, Priority.ALWAYS );
        list.setItems ( data );
        list.setCellFactory ( new Callback<ListView<String>, ListCell<String>>() {
            @Override
            public ListCell<String> call ( ListView<String> list ) {
                return new ButtonCell();
            }
        } );
        stage.show();
    }
    static class ButtonCell extends ListCell<String> {
        @Override
        public void updateItem ( String item, boolean empty ) {
            super.updateItem ( item, empty );
            if ( item != null ) {
                final Button btn = new Button ( item + " with index " + getIndex() );
                btn.setOnAction ( new EventHandler<ActionEvent>() {
                    @Override
                    public void handle ( ActionEvent event ) {
                        System.out.println ( "I am a " + getItem() + " with index " + getIndex() );
                    }
                } );
                setGraphic ( btn );
            } else {
                setGraphic ( null );
            }
        }
    }
    public static void main ( String[] args ) {
        launch ( args );
    }
}
