bool writeDelimitedTo (
    const google::protobuf::MessageLite & message,
    google::protobuf::io::ZeroCopyOutputStream * rawOutput ) {
    google::protobuf::io::CodedOutputStream output ( rawOutput );
    const int size = message.ByteSize();
    output.WriteVarint32 ( size );
    uint8_t * buffer = output.GetDirectBufferForNBytesAndAdvance ( size );
    if ( buffer != NULL ) {
        message.SerializeWithCachedSizesToArray ( buffer );
    } else {
        message.SerializeWithCachedSizes ( & output );
        if ( output.HadError() ) {
            return false;
        }
    }
    return true;
}
bool readDelimitedFrom (
    google::protobuf::io::ZeroCopyInputStream * rawInput,
    google::protobuf::MessageLite * message ) {
    google::protobuf::io::CodedInputStream input ( rawInput );
    uint32_t size;
    if ( !input.ReadVarint32 ( & size ) ) {
        return false;
    }
    google::protobuf::io::CodedInputStream::Limit limit =
        input.PushLimit ( size );
    if ( !message->MergeFromCodedStream ( & input ) ) {
        return false;
    }
    if ( !input.ConsumedEntireMessage() ) {
        return false;
    }
    input.PopLimit ( limit );
    return true;
}
