public class QuestionSaver {
    public QuestionSaver() {
    }
    public void saveQuestion ( Question question ) throws ParserConfigurationException {
        DocumentBuilderFactory docFactory = DocumentBuilderFactory.newInstance();
        DocumentBuilder docBuilder = docFactory.newDocumentBuilder();
        Document doc = docBuilder.newDocument();
        Element rootElement = doc.createElement ( "question" );
        doc.appendChild ( rootElement );
        save ( rootElement, doc, question );
    }
    private void save ( Element rootElement, Document doc, Question question ) {
        SaveIndependentProperties ( rootElement, doc, question );
        try {
            SaveToFile ( doc );
        } catch ( TransformerConfigurationException e ) {
            e.printStackTrace();
        }
    }
    private void SaveToFile ( Document doc ) throws TransformerConfigurationException {
        try {
            TransformerFactory transformerFactory = TransformerFactory.newInstance();
            Transformer transformer = transformerFactory.newTransformer();
            DOMSource source = new DOMSource ( doc );
            StreamResult result = new StreamResult ( System.out );
            transformer.transform ( source, result );
        } catch ( TransformerException e ) {
            System.out.println ( "Fout met transformen!" );
        }
        System.out.println ( "File saved!" );
    }
    private void SaveIndependentProperties ( Element rootElement, Document doc, Question question ) {
        Element actualquestion = doc.createElement ( "actualquestion" );
        actualquestion.appendChild ( doc.createTextNode ( question.getQuestion() ) );
        rootElement.appendChild ( actualquestion );
        Element score = doc.createElement ( "score" );
        score.appendChild ( doc.createTextNode ( Integer.toString ( question.getScore() ) ) );
        rootElement.appendChild ( score );
        QuestionType questionType = question.getType();
        Element type = doc.createElement ( "type" );
        type.appendChild ( doc.createTextNode ( getQuestionTypeString ( questionType ) ) );
        rootElement.appendChild ( type );
        Element source = doc.createElement ( "source" );
        source.appendChild ( doc.createTextNode ( question.getSource() ) );
        rootElement.appendChild ( source );
        Element extraInformation = doc.createElement ( "extrainformation" );
        extraInformation.appendChild ( doc.createTextNode ( question.getExtraInformation() ) );
        rootElement.appendChild ( extraInformation );
    }
    private String getQuestionTypeString ( QuestionType questionType ) {
        if ( questionType == QuestionType.MULTIPLEANSWER ) {
            return "multipleanswer";
        } else if ( questionType == QuestionType.MULTIPLECHOICE ) {
            return "multiplechoice";
        } else {
            return "speed";
        }
    }
    public static void main ( String[] args ) {
        try {
            new QuestionSaver().saveQuestion ( new Question() );
        } catch ( Exception e ) {
            e.printStackTrace();
        }
    }
}
