public Collection<Integer> getBiggerThan ( Collection<Integer> col, int value ) {
    final Class<? extends Collection> clazz = col.getClass();
    System.out.println ( "Input collection type: " + clazz );
    final Supplier<Collection<Integer>> supplier = () -> {
        try {
            return clazz.newInstance();
        } catch ( InstantiationException | IllegalAccessException e ) {
            throw new RuntimeException (
                "A checked exception caught inside lambda", e );
        }
    };
    return col.stream()
           .filter ( v -> v > value )
           .collect ( supplier, Collection::add, Collection::addAll );
}
