@ApplicationScoped
public class GuavaEventBus {
    private static final Logger LOGGER = LoggerFactory.getLogger ( GuavaEventBus.class );
    private static final EventBus eventBus = new EventBus();
    @Produces
    @ApplicationScoped
    private EventBus createGuavaEventBus() {
        return eventBus;
    }
    public void broadcastEveryEvent ( @Observes Object event ) {
        LOGGER.debug ( "Broadcast event: {}", event );
        eventBus.post ( event );
    }
    public static void register ( Object bean ) {
        LOGGER.debug ( "Register bean: {}", bean );
        eventBus.register ( bean );
    }
    public static void unregister ( Object bean ) {
        eventBus.unregister ( bean );
    }
}
