class LotsOfBytes {
    byte a0, a1, a2, a3, a4, a5, a6, a7, a8, a9, aa, ab, ac, ad, ae, af;
    byte b0, b1, b2, b3, b4, b5, b6, b7, b8, b9, ba, bb, bc, bd, be, bf;
    byte c0, c1, c2, c3, c4, c5, c6, c7, c8, c9, ca, cb, cc, cd, ce, cf;
    byte d0, d1, d2, d3, d4, d5, d6, d7, d8, d9, da, db, dc, dd, de, df;
    byte e0, e1, e2, e3, e4, e5, e6, e7, e8, e9, ea, eb, ec, ed, ee, ef;
}
class LotsOfInts {
    int a0, a1, a2, a3, a4, a5, a6, a7, a8, a9, aa, ab, ac, ad, ae, af;
    int b0, b1, b2, b3, b4, b5, b6, b7, b8, b9, ba, bb, bc, bd, be, bf;
    int c0, c1, c2, c3, c4, c5, c6, c7, c8, c9, ca, cb, cc, cd, ce, cf;
    int d0, d1, d2, d3, d4, d5, d6, d7, d8, d9, da, db, dc, dd, de, df;
    int e0, e1, e2, e3, e4, e5, e6, e7, e8, e9, ea, eb, ec, ed, ee, ef;
}
public class Test {
    private static final int SIZE = 1000000;
    public static void main ( String[] args ) throws Exception {
        LotsOfBytes[] first = new LotsOfBytes[SIZE];
        LotsOfInts[] second = new LotsOfInts[SIZE];
        System.gc();
        long startMem = getMemory();
        for ( int i = 0; i < SIZE; i++ ) {
            first[i] = new LotsOfBytes();
        }
        System.gc();
        long endMem = getMemory();
        System.out.println ( "Size for LotsOfBytes: " + ( endMem - startMem ) );
        System.out.println ( "Average size: " + ( ( endMem - startMem ) / ( ( double ) SIZE ) ) );
        System.gc();
        startMem = getMemory();
        for ( int i = 0; i < SIZE; i++ ) {
            second[i] = new LotsOfInts();
        }
        System.gc();
        endMem = getMemory();
        System.out.println ( "Size for LotsOfInts: " + ( endMem - startMem ) );
        System.out.println ( "Average size: " + ( ( endMem - startMem ) / ( ( double ) SIZE ) ) );
        long total = 0;
        for ( int i = 0; i < SIZE; i++ ) {
            total += first[i].a0 + second[i].a0;
        }
        System.out.println ( total );
    }
    private static long getMemory() {
        Runtime runtime = Runtime.getRuntime();
        return runtime.totalMemory() - runtime.freeMemory();
    }
}
