@Component
public class PathLoginAuthenticationEntryPoint extends LoginUrlAuthenticationEntryPoint {
    private final PathTokens tokens;
    @Autowired
    public PathLoginAuthenticationEntryPoint ( PathTokens tokens ) {
        super ( "/" );
        this.tokens = tokens;
    }
    @Override
    protected String determineUrlToUseForThisRequest ( HttpServletRequest request, HttpServletResponse response,
            AuthenticationException exception ) {
        return getLoginUrlFromPath ( request );
    }
    private String getLoginUrlFromPath ( HttpServletRequest request ) {
        String requestUrl = request.getRequestURI();
        if ( tokens.isTokenInPath ( requestUrl ) ) {
            return "/" + tokens.getTokenFromPath ( requestUrl ) + "_signin";
        }
        throw new PathTokenNotFoundException ( "Token not found in request URL " + requestUrl + " when retrieving LoginUrl for login form" );
    }
}
