class NetworkService implements Runnable {
    private final ServerSocket serverSocket;
    private final ExecutorService pool;
    public NetworkService ( int port, int poolSize )
    throws IOException {
        serverSocket = new ServerSocket ( port );
        pool = Executors.newFixedThreadPool ( poolSize );
    }
    public void run() {
        try {
            for ( ;; ) {
                pool.execute ( new Handler ( serverSocket.accept() ) );
            }
        } catch ( IOException ex ) {
            pool.shutdown();
        }
    }
}
class Handler implements Runnable {
    private final Socket socket;
    Handler ( Socket socket ) {
        this.socket = socket;
    }
    public void run() {
    }
}
