@Provider
public class RestExceptionMapper implements ExceptionMapper<Throwable> {
    private static final Logger log = LoggerFactory.getLogger ( RestExceptionMapper.class );
    @Override
    public Response toResponse ( Throwable exception ) {
        log.error ( "toResponse() caught exception", exception );
        return Response.status ( getStatusCode ( exception ) )
               .entity ( getEntity ( exception ) )
               .build();
    }
    private int getStatusCode ( Throwable exception ) {
        if ( exception instanceof WebApplicationException ) {
            return ( ( WebApplicationException ) exception ).getResponse().getStatus();
        }
        return Response.Status.INTERNAL_SERVER_ERROR.getStatusCode();
    }
    private Object getEntity ( Throwable exception ) {
        StringWriter errorMsg = new StringWriter();
        exception.printStackTrace ( new PrintWriter ( errorMsg ) );
        return errorMsg.toString();
    }
}
