public void waitForTest ( JavascriptExecutor executor, String testId ) {
    new FluentWait<JavascriptExecutor> ( executor ) {
        protected RuntimeException timeoutException (
            String message, Throwable lastException ) {
            Assert.fail ( testId + " did not finish async calls" );
        }
    } .withTimeout ( 10, SECONDS )
    .until ( new Predicate<JavascriptExecutor>() {
        public boolean apply ( JavascriptExecutor e ) {
            return ( Boolean ) executor.executeScript (
                       "_isTestDone_('" + testId + "');" );
        }
    } );
}
@Test public void serverPingTest() {
    driver.executeScript ( "_setJunitTestid_('MainAppTest.serverPingTest');" );
    waitForTest ( driver, "MainAppTest.serverPingTest" );
}
