dragHandle.setOnTouchListener ( new View.OnTouchListener() {
    float centerX, centerY, startR, startScale, startX, startY;
    public boolean onTouch ( View v, MotionEvent e ) {
        if ( e.getAction() == MotionEvent.ACTION_DOWN ) {
            centerX = ( imageView.getLeft() + imageView.getRight() ) / 2f;
            centerY = ( imageView.getTop() + imageView.getBottom() ) / 2f;
            startX = e.getRawX() - dragHandle.getX() + centerX;
            startY = e.getRawY() - dragHandle.getY() + centerY;
            startR = ( float ) Math.hypot ( e.getRawX() - startX, e.getRawY() - startY );
            startScale = imageView.getScaleX();
        } else if ( e.getAction() == MotionEvent.ACTION_MOVE ) {
            float newR = ( float ) Math.hypot ( e.getRawX() - startX, e.getRawY() - startY );
            float newScale = newR / startR * startScale;
            imageView.setScaleX ( newScale );
            imageView.setScaleY ( newScale );
            dragHandle.setX ( centerX + imageView.getWidth() / 2f * newScale );
            dragHandle.setY ( centerY + imageView.getHeight() / 2f * newScale );
        } else if ( e.getAction() == MotionEvent.ACTION_UP ) {
        }
        return true;
    }
} );
