private static final long serialVersionUID = 1L;
private static JLabel num;
private static JTextField in;
private static JButton enter = new JButton ( "Enter" );
private static Tree tempTree;
private int nodeNumber;
public Tree() {
    this.nodeNumber = 0;
    num = new JLabel ( "Number of Branches: " );
    add ( num );
    in = new JTextField ( 5 );
    add ( in );
    add ( enter );
    add ( enter );
}
private void draw ( Graphics2D g, int n, int x, int y ) {
    if ( n == 0 ) {
        return;
    } else {
        int angle = 45;
        int length = 50;
        g.drawLine ( x, y, x, y - length );
        g.setColor ( Color.BLACK );
        g.rotate ( Math.toRadians ( -angle ), x, y - length );
        draw ( g, n - 1, x, y - length );
        g.rotate ( Math.toRadians ( angle ), x, y - length );
        g.rotate ( Math.toRadians ( angle ), x, y - length );
        draw ( g, n - 1, x, y - length );
        g.rotate ( Math.toRadians ( -angle ), x, y - length );
    }
}
private void draw ( Graphics2D g, int x, int y ) {
    int n = this.nodeNumber;
    if ( n == 0 ) {
        return;
    } else {
        int angle = 45;
        int length = 50;
        g.drawLine ( x, y, x, y - length );
        g.setColor ( Color.BLACK );
        g.rotate ( Math.toRadians ( -angle ), x, y - length );
        draw ( g, n - 1, x, y - length );
        g.rotate ( Math.toRadians ( angle ), x, y - length );
        g.rotate ( Math.toRadians ( angle ), x, y - length );
        draw ( g, n - 1, x, y - length );
        g.rotate ( Math.toRadians ( -angle ), x, y - length );
    }
}
public void setNodeNumber ( int number ) {
    this.nodeNumber = number;
}
protected void paintComponent ( Graphics g ) {
    super.paintComponent ( g );
    Graphics2D gg = ( Graphics2D ) g;
    draw ( gg, getWidth() / 2, getHeight() / 2 );
}
public static void main ( String[] args ) {
    Tree tree = new Tree();
    tree.setPreferredSize ( new Dimension ( 500, 500 ) );
    JFrame frame = new JFrame ( "Test" );
    frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
    frame.getContentPane().add ( tree );
    frame.setSize ( 500, 500 );
    Tree.tempTree = tree;
    Listener enterListener = new Listener();
    Tree.enter.setActionCommand ( "ENTER" );
    Tree.enter.addActionListener ( enterListener );
    frame.setLocationRelativeTo ( null );
    frame.setVisible ( true );
}
public static void refreshTree() {
    int inputNumber;
    try {
        inputNumber =  Integer.parseInt ( Tree.in.getText() );
        Tree.tempTree.setNodeNumber ( inputNumber );
        Tree.tempTree.updateUI();
    } catch ( NumberFormatException e ) {
        System.out.println ( " Invalid node Number " + e );
    }
}
