public static List<Runnable> shutdown ( ExecutorService es, int timeoutSeconds ) {
    es.shutdown();
    if ( timeoutSeconds > 0 ) {
        try {
            es.awaitTermination ( timeoutSeconds, TimeUnit.SECONDS );
        } catch ( InterruptedException e ) {
            log.warn ( "Waiting for executor service tasks completion interrupted.", e );
        }
    }
    return ( es.isTerminated() ? null : es.shutdownNow() );
}
