public class MySequenceCodeStringGenerator {
    private static final int generatorMonth;
    private static final int generatorSequenceNumber;
    private static final MySequenceCodeStringGenerator INSTANCE = new MySequenceCodeStringGenerator();
    private MySequenceCodeStringGenerator() {
        generatorMonth = getCurrentMonth();
        generatorSequenceNumber = 0;
    }
    public static MySequenceCodeStringGenerator getInstance() {
        return INSTANCE;
    }
    public static int getSequenceCodeString {
        int sequenceNumber = getSequenceNumber();
        Calendar now = Calendar.getInstance();
        int year = now.get ( Calendar.YEAR );
        int month = now.get ( Calendar.MONTH );
        String yearString = String.valueOf ( year );
        return String.format ( "%02d-%02d%s", sequenceNumber, month + 1, yearString.substring ( 2 ) );
    }
    private int getCurrentMonth() {
        Calendar now = Calendar.getInstance();
        return now.get ( Calendar.MONTH );
    }
    private int getSequenceNumber() {
        currentMonth = getCurrentMonth();
        if ( currentMonth != generatorMonth ) {
            generatorMonth = currentMonth;
            generatorSequenceNumber = 0;
        }
        return ++generatorSequenceNumber;
    }
}
