public class MyApp extends Application {
    public enum TrackerName {
        APP_TRACKER,
        GLOBAL_TRACKER,
        E_COMMERCE_TRACKER,
    }
    HashMap<TrackerName, Tracker> mTrackers = new HashMap<TrackerName, Tracker>();
    synchronized Tracker getTracker ( TrackerName trackerId ) {
        if ( !mTrackers.containsKey ( trackerId ) ) {
            GoogleAnalytics analytics = GoogleAnalytics.getInstance ( this );
            Tracker t = ( trackerId == TrackerName.APP_TRACKER ) ? analytics.newTracker ( PROPERTY_ID )
                        : ( trackerId == TrackerName.GLOBAL_TRACKER ) ? analytics.newTracker ( R.xml.global_tracker )
                        : analytics.newTracker ( R.xml.ecommerce_tracker );
            mTrackers.put ( trackerId, t );
        }
        return mTrackers.get ( trackerId );
    }
}
