public static BufferedImage resizeImage ( Image image, int width, int height ) {
    BufferedImage bufferedImage = new BufferedImage ( width, height, BufferedImage.TYPE_INT_RGB );
    Graphics2D g = bufferedImage.createGraphics();
    g.setRenderingHint ( RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BICUBIC );
    g.setRenderingHint ( RenderingHints.KEY_RENDERING, RenderingHints.VALUE_RENDER_QUALITY );
    AffineTransform scaleTransform = AffineTransform.getScaleInstance (
                                         width / ( double ) image.getWidth ( null ), height / ( double ) image.getHeight ( null ) );
    g.drawImage ( image, scaleTransform, null );
    g.dispose();
    return bufferedImage;
}
