import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentTransaction;
import android.support.v4.view.ViewPager;
import android.support.v7.app.ActionBar;
import android.support.v7.app.ActionBarActivity;
import android.support.v7.app.ActionBar.Tab;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
public class AttractionFragment extends Fragment implements ActionBar.TabListener {
    private ViewPager viewPager;
    private TabsPagerAdapter mAdapter;
    private ActionBar actionBar;
    private String[] tabs = { "Solo", "Karanganyar", "Sukoharjo", "Sragen", "Boyolali", "Klaten", "Wonogiri"  };
    public AttractionFragment() {}
    @Override
    public View onCreateView ( LayoutInflater inflater, ViewGroup container,
                               Bundle savedInstanceState ) {
        View rootView = inflater.inflate ( R.layout.frag2, container, false );
        viewPager = ( ViewPager ) rootView.findViewById ( R.id.pager );
        actionBar = ( ( ActionBarActivity ) getActivity() ).getSupportActionBar();
        mAdapter = new TabsPagerAdapter ( getActivity().getSupportFragmentManager() );
        viewPager.setAdapter ( mAdapter );
        actionBar.setHomeButtonEnabled ( false );
        actionBar.setNavigationMode ( ActionBar.NAVIGATION_MODE_TABS );
        for ( String tab_name : tabs ) {
            actionBar.addTab ( actionBar.newTab().setText ( tab_name )
                               .setTabListener ( AttractionFragment.this ) );
        }
        viewPager.setOnPageChangeListener ( new ViewPager.OnPageChangeListener() {
            @Override
            public void onPageSelected ( int position ) {
                actionBar.setSelectedNavigationItem ( position );
            }
            @Override
            public void onPageScrolled ( int arg0, float arg1, int arg2 ) {
            }
            @Override
            public void onPageScrollStateChanged ( int arg0 ) {
            }
        } );
        return rootView;
    }
    @Override
    public void onTabReselected ( Tab tab, FragmentTransaction ft ) {
    }
    @Override
    public void onTabSelected ( Tab tab, FragmentTransaction ft ) {
        viewPager.setCurrentItem ( tab.getPosition() );
    }
    @Override
    public void onTabUnselected ( Tab tab, FragmentTransaction ft ) {
    }
}
