public class TabTextArea extends TextArea {
    private static final Logger logger = LoggerFactory.getLogger ( TabTextArea.class );
    public TabTextArea() {
        this.addEventFilter ( KeyEvent.KEY_PRESSED, new EventHandler<KeyEvent>() {
            @Override
            public void handle ( KeyEvent event ) {
                if ( event.getCode() == KeyCode.TAB ) {
                    TextAreaSkin skin = ( TextAreaSkin ) getSkin();
                    if ( skin.getBehavior() instanceof TextAreaBehavior ) {
                        TextAreaBehavior behavior = ( TextAreaBehavior ) skin.getBehavior();
                        if ( event.isControlDown() ) {
                            behavior.callAction ( "InsertTab" );
                        } else {
                            behavior.callAction ( "TraverseNext" );
                        }
                        event.consume();
                    }
                }
            }
        } );
    }
