import net.sf.ehcache.Cache;
import net.sf.ehcache.CacheManager;
import net.sf.ehcache.config.CacheConfiguration;
import net.sf.ehcache.config.Configuration;
import net.sf.ehcache.config.DiskStoreConfiguration;
import net.sf.ehcache.config.PersistenceConfiguration;
import net.sf.ehcache.config.PersistenceConfiguration.Strategy;
import net.sf.ehcache.store.MemoryStoreEvictionPolicy;
import org.apache.http.impl.client.cache.CacheConfig;
import org.apache.http.impl.client.cache.CachingHttpClients;
import org.apache.http.impl.client.cache.ehcache.EhcacheHttpCacheStorage;
CacheConfig cacheConfig = CacheConfig
                          .custom()
                          .setMaxCacheEntries ( 1000 )
                          .setMaxObjectSize ( 8192 )
                          .build();
mgr = CacheManager.create();
Cache testCache = new Cache ( new CacheConfiguration ( "http", 100000 )
                              .memoryStoreEvictionPolicy ( MemoryStoreEvictionPolicy.LFU )
                              .eternal ( false )
                              .timeToLiveSeconds ( 60 )
                              .timeToIdleSeconds ( 30 )
                              .diskExpiryThreadIntervalSeconds ( 0 )
                              .persistence ( new PersistenceConfiguration().strategy ( Strategy.LOCALRESTARTABLE ) ) );
mgr.addCache ( testCache );
Cache cache = mgr.getCache ( "http" );
EhcacheHttpCacheStorage ehcacheHttpCacheStorage = new EhcacheHttpCacheStorage ( cache );
CloseableHttpClient httpclient = CachingHttpClients.custom()
                                 .setCacheConfig ( cacheConfig )
                                 .setHttpCacheStorage ( ehcacheHttpCacheStorage )
                                 .build();
