import java.io.*;
import java.net.URL;
import javax.sound.sampled.*;
public enum SoundEffect  {
    BUSY ( "resources/phone-busy.wav" ),
    CALLING ( "resources/phone-calling.wav" ),
    DISCONNECT ( "resources/phone-disconnect.wav" ),
    RING ( "resources/telephone-ring.wav" );
    private Clip clip;
    private URL url;
    private AudioInputStream audioInputStream;
    SoundEffect ( String soundFileName ) {
        try {
            this.url = this.getClass().getClassLoader().getResource ( soundFileName );
            this.audioInputStream = AudioSystem.getAudioInputStream ( url );
            clip = AudioSystem.getClip();
            clip.open ( audioInputStream );
        } catch ( UnsupportedAudioFileException e ) {
            e.printStackTrace();
        } catch ( IOException e ) {
            e.printStackTrace();
        } catch ( LineUnavailableException e ) {
            e.printStackTrace();
        }
    }
    public void play() {
        clip.loop ( Clip.LOOP_CONTINUOUSLY );
    }
    public void stop() {
        clip.stop();
        clip.flush();
        clip.setFramePosition ( 0 );
    }
    static void init() {
        values();
    }
    public boolean isActive() {
        return clip.isActive();
    }
    public boolean isOpen() {
        return clip.isOpen();
    }
    public void setFramePosition() {
        clip.setFramePosition ( 0 );
    }
}
