public interface OrderedXml {
    ImmutableMap<String, Object> toOrderedMap();
}
public class Parent implements OrderedXml {
    @Key ( "First" ) String first;
    @Key ( "Second" ) String second;
    @Key ( "Child" ) Child third;
    @Override
    public ImmutableMap<String, Object> toOrderedMap() {
        return ImmutableMap.of (
                   "First", first,
                   "Second", second,
                   "Child", third.toOrderedMap()
               );
    }
}
public class Child implements OrderedXml {
    @Key ( "@param1" ) String param1;
    @Key ( "@param2" ) String param2;
    @Key ( "text()" ) String value;
    @Override
    public ImmutableMap<String, Object> toOrderedMap() {
        return ImmutableMap.of (
                   "@param1", param1,
                   "@param2", param2,
                   "text()", value
               );
    }
}
public class Main {
    public static void main ( String[] args ) {
        Parent parent = new Parent();
        parent.first = "Hello";
        parent.second = "World";
        parent.child = new Child();
        parent.child.param1 = "p1";
        parent.child.param2 = "p2";
        parent.child.value = "This is a child";
        String xml = new XmlNamespaceDictionary()
        .toStringOf ( "Parent", parent.toOrderedXml() );
        System.out.println ( xml );
    }
}
