package org.camunda.bpm;
import org.camunda.bpm.engine.ProcessEngine;
import org.camunda.bpm.engine.RepositoryService;
import org.camunda.bpm.engine.RuntimeService;
import org.camunda.bpm.engine.repository.ProcessDefinition;
import org.camunda.bpm.engine.runtime.ProcessInstance;
import java.util.List;
public class AllRunningProcessInstances {
    public List<ProcessInstance> getAllRunningProcessInstances ( String processDefinitionName ) {
        ProcessEngine processEngine = BpmPlatform.getDefaultProcessEngine();
        RuntimeService runtimeService = processEngine.getRuntimeService();
        RepositoryService repositoryService = processEngine.getRepositoryService();
        ProcessDefinition myProcessDefinition =
            repositoryService.createProcessDefinitionQuery()
            .processDefinitionName ( processDefinitionName )
            .latestVersion()
            .singleResult();
        List<ProcessInstance> processInstances =
            runtimeService.createProcessInstanceQuery()
            .processDefinitionId ( myProcessDefinition.getId() )
            .active()
            .list();
        return processInstances;
    }
}
