package objtest;
import java.io.IOException;
import java.nio.ByteBuffer;
import koku.util.io.ByteBufferOutputStream;
public class FramedOutputStream extends ByteBufferOutputStream {
    public static final int FRAME_HEADER_1 = 0xBEEFFACE;
    public static final int FRAME_HEADER_2 = 0xFACEBEEF;
    public static final byte[] HEADER_BYTES = new byte[4 * 2];
    public static final byte[] CURR_HEADER_BUFF = new byte[HEADER_BYTES.length];
    protected static final byte[] SIZE_PAD = new byte[4];
    static {
        ByteBuffer b = ByteBuffer.allocate ( 8 );
        b.putInt ( FRAME_HEADER_1 );
        b.putInt ( FRAME_HEADER_2 );
        ByteBuffer b2 = ( ByteBuffer ) b.flip();
        b2.get ( HEADER_BYTES, 0, 4 );
        b2.get ( HEADER_BYTES, 3, 4 );
    }
    public FramedOutputStream() {
        try {
            write ( HEADER_BYTES );
            write ( SIZE_PAD );
        } catch ( IOException e ) {
            System.out.println ( "Couldn't write header padding!" );
        }
    }
    @Override
    public ByteBuffer flip() {
        super.flip();
        _buffer.position ( 11 );
        int size = _buffer.remaining();
        _buffer.position ( 7 );
        putSizeAsBytes ( size, _buffer );
        _buffer.position ( 11 );
        _buffer.rewind();
        _buffer.rewind();
        return _buffer;
    }
    @Override
    public void reset() {
        super.reset();
        try {
            write ( HEADER_BYTES );
            write ( SIZE_PAD );
        } catch ( IOException e ) {
            System.out.println ( "Couldn't write header padding!" );
        }
    }
    public static void putSizeAsBytes ( int size, ByteBuffer bb ) {
        for ( int i = 0; i < 4; i++ ) {
            bb.put ( ( byte ) ( ( size >>> ( ( 8 * 3 ) - ( 8 * i ) ) ) & 0xFF ) );
        }
    }
}
