public class Secured extends Security.Authenticator {
    public static final String UNAUTHENTICATED = "unauthenticated";
    public static User getLoggedInUser() {
        if ( session ( "userId" ) == null ) {
            return null;
        }
        return User.findById ( Long.parseLong ( session ( "userId" ) ) );
    }
    public static String getLoggedInUsername() {
        if ( session ( "userId" ) == null ) {
            return null;
        }
        return User.findById ( Long.parseLong ( session ( "userId" ) ) ).getUsername();
    }
    @Override
    public String getUsername ( Http.Context ctx ) {
        if ( session ( "userId" ) == null ) {
            return null;
        }
        String previousTick = session ( "userTime" );
        if ( previousTick != null && !previousTick.equals ( "" ) ) {
            long previousT = Long.valueOf ( previousTick );
            long currentT = new Date().getTime();
            long timeout = Long.valueOf ( Play.application().configuration().getString ( "sessionTimeout" ) ) * 1000 * 60;
            if ( ( currentT - previousT ) > timeout ) {
                session().clear();
                return null;
            }
        }
        String tickString = Long.toString ( new Date().getTime() );
        session ( "userTime", tickString );
        return User.findById ( Long.parseLong ( session ( "userId" ) ) ).getUsername();
    }
}
