package test;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
public class Multithreader {
    volatile static boolean shouldFilePrinterPrint = false;
    public static void main ( String[] args ) throws IOException {
        final BufferedReader br = new BufferedReader ( new FileReader ( new File ( "file.txt" ) ) );
        Runnable filePrinter = new Runnable() {
            @Override
            public void run() {
                while ( true ) {
                    if ( shouldFilePrinterPrint ) {
                        shouldFilePrinterPrint = false;
                        String line;
                        int counter = 0;
                        try {
                            while ( counter < 5 && ( line = br.readLine() ) != null ) {
                                counter++;
                                System.out.println ( line );
                            }
                        } catch ( IOException e ) {
                            e.printStackTrace();
                        }
                    }
                }
            }
        };
        Runnable inputAwaiter = new Runnable() {
            @Override
            public void run() {
                while ( true ) {
                    try {
                        System.in.read();
                        shouldFilePrinterPrint = true;
                    } catch ( IOException e ) {
                        e.printStackTrace();
                    }
                }
            }
        };
        ExecutorService executorService = Executors.newFixedThreadPool ( 2 );
        executorService.execute ( filePrinter );
        executorService.execute ( inputAwaiter );
    }
}
