public class MapItemizedOverlay extends ItemizedOverlay<OverlayItem> {
    private ArrayList<OverlayItem> mOverlays = new ArrayList<OverlayItem>();
    private Context mContext;
    public MapItemizedOverlay ( Drawable defaultMarker, Context context ) {
        super ( defaultMarker, new DefaultResourceProxyImpl ( context ) );
        mContext = context;
    }
    public void addOverlay ( OverlayItem overlay ) {
        mOverlays.add ( overlay );
        populate();
    }
    @Override
    protected OverlayItem createItem ( int i ) {
        return mOverlays.get ( i );
    }
    @Override
    public int size() {
        return mOverlays.size();
    }
    protected boolean onTap ( int index ) {
        OverlayItem item = mOverlays.get ( index );
        Log.d ( "Title", item.getTitle() );
        Log.d ( "Snippet", item.getSnippet() );
        Log.d ( "Id", item.getUid() );
        Dialog dialog = new Dialog ( mContext );
        dialog.getWindow().requestFeature ( Window.FEATURE_NO_TITLE );
        dialog.getWindow().setBackgroundDrawable ( new ColorDrawable ( android.graphics.Color.TRANSPARENT ) );
        dialog.setContentView ( R.layout.custom_dialog );
        dialog.setCancelable ( true );
        TextView map_popup_header = ( TextView ) dialog.findViewById ( R.id.map_popup_header );
        map_popup_header.setText ( item.getTitle() );
        TextView map_popup_body = ( TextView ) dialog.findViewById ( R.id.map_popup_body );
        map_popup_body.setText ( item.getSnippet() );
        ImageView imgMoreInfo = ( ImageView ) dialog.findViewById ( R.id.map_more_info_imageView );
        imgMoreInfo.setOnClickListener ( new View.OnClickListener() {
            @Override
            public void onClick ( View v ) {
                Log.d ( "Clicked", "more info" );
            }
        } );
        dialog.show();
        return true;
    }
    @Override
    public boolean onSnapToItem ( int arg0, int arg1, Point arg2, IMapView arg3 ) {
        return false;
    }
}
