import java.awt.Color;
import java.awt.Dimension;
import java.awt.EventQueue;
import java.awt.GradientPaint;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.GridBagLayout;
import java.awt.RenderingHints;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
public class GradientButtons {
    public static void main ( String[] args ) {
        new GradientButtons();
    }
    public GradientButtons() {
        EventQueue.invokeLater ( new Runnable() {
            @Override
            public void run() {
                try {
                    UIManager.setLookAndFeel ( UIManager.getSystemLookAndFeelClassName() );
                } catch ( ClassNotFoundException | InstantiationException | IllegalAccessException | UnsupportedLookAndFeelException ex ) {
                }
                JFrame frame = new JFrame ( "Testing" );
                frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
                frame.setLayout ( new GridBagLayout() );
                frame.add ( new RoundButton ( "Click me" ) );
                frame.pack();
                frame.setLocationRelativeTo ( null );
                frame.setVisible ( true );
            }
        } );
    }
    public class RoundButton extends JButton {
        public RoundButton ( String text ) {
            super ( text );
            setBorderPainted ( false );
            setContentAreaFilled ( false );
            setFocusPainted ( false );
            setOpaque ( false );
        }
        @Override
        public Dimension getPreferredSize() {
            Dimension size = super.getPreferredSize();
            int radius = Math.max ( size.width, size.height );
            size.width = radius;
            size.height = radius;
            return size;
        }
        @Override
        protected void paintComponent ( Graphics g ) {
            Graphics2D g2d = ( Graphics2D ) g;
            g2d.setRenderingHint ( RenderingHints.KEY_ANTIALIASING,
                                   RenderingHints.VALUE_ANTIALIAS_ON );
            GradientPaint gp = new GradientPaint ( 0, 0,
                                                   Color.RED, 0, getHeight(),
                                                   Color.YELLOW );
            g2d.setPaint ( gp );
            g2d.fillOval ( 0, 0, getWidth(), getHeight() );
            super.paintComponent ( g );
        }
    }
}
