package org.camunda.bpm;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.camunda.bpm.engine.ProcessEngine;
import org.camunda.bpm.engine.RepositoryService;
import org.camunda.bpm.engine.RuntimeService;
import org.camunda.bpm.engine.runtime.ProcessInstance;
import org.camunda.bpm.model.bpmn.BpmnModelInstance;
import org.camunda.bpm.model.xml.instance.ModelElementInstance;
public class AllActiveActivities {
    public Map<String, String> getAllActiveActivities ( String processInstanceId ) {
        ProcessEngine processEngine = BpmPlatform.getDefaultProcessEngine()
                                      RuntimeService runtimeService = processEngine.getRuntimeService();
        RepositoryService repositoryService = processEngine.getRepositoryService();
        ProcessInstance processInstance =
            runtimeService.createProcessInstanceQuery()
            .processInstanceId ( processInstanceId )
            .singleResult();
        HashMap<String, String> activityNameByActivityId = new HashMap<String, String>();
        List<String> activeActivityIds =
            runtimeService.getActiveActivityIds ( processInstance.getId() );
        BpmnModelInstance bpmnModelInstance =
            repositoryService.getBpmnModelInstance ( processInstance.getProcessDefinitionId() );
        for ( String activeActivityId : activeActivityIds ) {
            ModelElementInstance modelElementById =
                bpmnModelInstance.getModelElementById ( activeActivityId );
            String activityName = modelElementById.getAttributeValue ( "name" );
            activityNameByActivityId.put ( activeActivityId, activityName );
        }
        return activityNameByActivityId;
    }
}
