public class IntegerDomainPermutation implements Iterator<int[]> {
    private int[] permutation;
    private int[] domainBorders;
    private List<List<Integer>> domain;
    private boolean hasNext = true;
    public IntegerDomainPermutation ( List<List<Integer>> domain ) {
        this.domain = domain;
        permutation = new int[domain.size()];
        domainBorders = new int[domain.size()];
        for ( int i = 0; i < domain.size(); i++ ) {
            domainBorders[i] = domain.get ( i ).get ( domain.get ( i ).size() - 1 );
        }
        for ( int i = 0; i < domain.size(); i++ ) {
            permutation[i] = domain.get ( i ).get ( 0 );
        }
    }
    @Override
    public boolean hasNext() {
        return hasNext;
    }
    @Override
    public int[] next() {
        int[] perm = Arrays.copyOf ( permutation, permutation.length );
        if ( checkNext() ) {
            hasNext = true;
            increment();
        } else {
            hasNext = false;
        }
        return perm;
    }
    @Override
    public void remove() {
        throw new UnsupportedOperationException ( "Not supported yet." );
    }
    public boolean checkNext() {
        for ( int i = permutation.length - 1; i >= 0; i-- ) {
            if ( ! ( permutation[i] == domainBorders[i] ) ) {
                return true;
            }
        }
        return false;
    }
    private void increment() {
        for ( int i = permutation.length - 1; i >= 0; i-- ) {
            if ( ! ( permutation[i] == domainBorders[i] ) ) {
                permutation[i] = domain.get ( i ).get ( domain.get ( i ).indexOf ( permutation[i] ) + 1 );
                return;
            } else {
                permutation[i] = domain.get ( i ).get ( 0 );
            }
        }
    }
