public class Game extends JPanel {
    private static final long serialVersionUID = 1L;
    static int HEIGHT = 650;
    static int WIDTH = 1200;
    static int score = 0;
    static String deathMessage = "Click to start";
    static boolean dead = false;
    static boolean startGame = false;
    static Player spaceShip = new Player ( 1, 3, 100, HEIGHT / 2 - 110, WIDTH / 3 );
    static HighScoreManager hm = new HighScoreManager ( 0 );
    static int highscore = hm.getScores();
    static int max = highscore;
    Meteor asteroid = new Meteor ( WIDTH + 600,
                                   ( int ) ( ( Math.random() * 440 ) + 110 ), -18, 60 );
    Meteor asteroid2 = new Meteor ( WIDTH + ( WIDTH / 5 ) + 600,
                                    ( int ) ( ( Math.random() * 440 ) + 110 ), -18, 60 );
    Meteor asteroid3 = new Meteor ( WIDTH + ( WIDTH / 5 ) * 2 + 600,
                                    ( int ) ( ( Math.random() * 440 ) + 110 ), -18, 60 );
    Meteor asteroid4 = new Meteor ( WIDTH + ( WIDTH / 5 ) * 3 + 600,
                                    ( int ) ( ( Math.random() * 440 ) + 110 ), -18, 60 );
    Meteor asteroid5 = new Meteor ( WIDTH + ( WIDTH / 5 ) * 4 + 600,
                                    ( int ) ( ( Math.random() * 440 ) + 110 ), -18, 60 );
    int scrollX = 0;
    BufferedImage img;
    {
        try {
            img = ImageIO.read ( new File ( "4.png" ) );
        } catch ( IOException e ) {
            throw new RuntimeException ( "FailedToLoadImage" );
        }
    }
    public Game() {
        this.addKeyListener ( new KeyAdapter() {
            public void keyPressed ( KeyEvent event ) {
            }
            public void keyReleased ( KeyEvent event ) {
                if ( event.getKeyCode() == KeyEvent.VK_UP ) {
                    spaceShip.jumpUp();
                }
                if ( event.getKeyCode() == KeyEvent.VK_DOWN ) {
                    spaceShip.jumpDown();
                }
            }
            public void keyTyped ( KeyEvent event ) {
                if ( event.getKeyCode() == KeyEvent.VK_UP ) {
                    spaceShip.jumpUp();
                }
                if ( event.getKeyCode() == KeyEvent.VK_DOWN ) {
                    spaceShip.jumpDown();
                }
            }
        } );
    }
    public void move() {
        this.addMouseListener ( new MouseAdapter() {
            public void mousePressed ( MouseEvent arg0 ) {
                setFocusable ( true );
                requestFocusInWindow();
                deathMessage = "";
                startGame = true;
            }
        } );
        if ( !startGame ) {
            asteroid.setMeteor ( WIDTH + 600 );
            asteroid2.setMeteor ( WIDTH + ( WIDTH / 5 ) + 600 );
            asteroid3.setMeteor ( WIDTH + ( WIDTH / 5 ) * 2 + 600 );
            asteroid4.setMeteor ( WIDTH + ( WIDTH / 5 ) * 3 + 600 );
            asteroid5.setMeteor ( WIDTH + ( WIDTH / 5 ) * 4 + 600 );
        } else {
            spaceShip.move();
            asteroid.move();
            asteroid2.move();
            asteroid3.move();
            asteroid4.move();
            asteroid5.move();
            scrollX += asteroid.getSpeed();
            if ( scrollX == -1800 ) {
                scrollX = 0;
            }
            if ( dead ) {
                asteroid.setMeteor ( WIDTH + 600 );
                asteroid2.setMeteor ( WIDTH + ( WIDTH / 2 ) + 600 );
                dead = false;
            }
        }
    }
    public static void score() {
        score += 1;
    }
    public void paint ( Graphics g ) {
        super.paint ( g );
        g.drawImage ( img, 0, 0, null );
        g.setFont ( new Font ( "comicsans", Font.BOLD, 40 ) );
        g.setColor ( Color.WHITE );
        g.drawString ( "Score: " + score / 9, WIDTH / 2 - 80, 580 );
        g.drawString ( "Highscore: " + highscore / 9, WIDTH / 2 - 120, 40 );
        g.setColor ( Color.RED );
        g.drawString ( deathMessage, 200, 200 );
        spaceShip.paint ( g );
        asteroid.paint ( g );
        asteroid2.paint ( g );
        asteroid3.paint ( g );
        asteroid4.paint ( g );
        asteroid5.paint ( g );
    }
    public static void reset() {
        spaceShip.setY ( Game.HEIGHT / 2 - spaceShip.getSize() + 10 );
        spaceShip.setSpeed ( 2 );
        if ( score > highscore && score != 0 ) {
            highscore = score;
            hm.setScore ( score );
        }
        score = 0;
        deathMessage = "you died, click to try again";
        startGame = false;
    }
}
public class HighScoreManager {
    private Score scores;
    private static final File saveFile = new File ( new File ( System.getProperty ( "user.home" ) ), "spaceData.ser" );
    OutputStream outputStream = null;
    InputStream inputStream = null;
    public HighScoreManager ( int score ) {
        scores = new Score ( score );
    }
    public int getScores() {
        loadScoreFile();
        return scores.getScore();
    }
    public void setScore ( int score ) {
        loadScoreFile();
        scores.setScore ( score );
        updateScoreFile();
    }
    public void loadScoreFile() {
        if ( saveFile.exists() ) {
            try {
                FileInputStream fileIn = new FileInputStream ( saveFile );
                ObjectInputStream in = new ObjectInputStream ( fileIn );
                scores = ( Score ) in.readObject();
                in.close();
                fileIn.close();
            } catch ( IOException i ) {
                throw new RuntimeException ( "Load of scores failed", i );
            } catch ( ClassNotFoundException c ) {
                throw new RuntimeException ( "Load of scores failed", c );
            }
        } else {
            System.out.println ( "First run? No save file found" );
        }
    }
    public void updateScoreFile() {
        try {
            FileOutputStream fileOut = new FileOutputStream ( saveFile );
            ObjectOutputStream out = new ObjectOutputStream ( fileOut );
            out.writeObject ( scores );
            out.close();
            fileOut.close();
        } catch ( IOException i ) {
            throw new RuntimeException ( "updateScoreFile failed", i );
        }
    }
    public int getHighscore() {
        return scores.getScore();
    }
}
public class Main {
    static JFrame frame = new JFrame();
    static boolean startGame = false;
    static String str;
    public static void main ( String [] args ) throws InterruptedException {
        frame.setSize ( Game.WIDTH, Game.HEIGHT );
        frame.setVisible ( true );
        frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
        frame.setLocationRelativeTo ( null );
        frame.setResizable ( false );
        runnit();
    }
    public static void runnit() throws InterruptedException {
        final Game game = new Game();
        Timer animationTimer = new Timer ( 40, new ActionListener() {
            public void actionPerformed ( ActionEvent event ) {
                game.repaint();
                game.move();
            };
        } );
        frame.add ( game );
        game.setVisible ( true );
        frame.revalidate();
        animationTimer.start();
    }
}
public class Meteor {
    private int x;
    private int y;
    private int speed;
    private int size;
    BufferedImage img;
    {
        try {
            img = ImageIO.read ( new File ( "6.png" ) );
        } catch ( IOException e ) {
            throw new RuntimeException ( "FailedToLoadImage" );
        }
    }
    public Meteor ( int x, int y, int speed, int size ) {
        this.x = x;
        this.y = y;
        this.speed = speed;
        this.size = size;
    }
    public void setMeteor ( int i ) {
        this.x = i;
    }
    public  void setSpeed ( int speed ) {
        this.speed = speed;
    }
    public  int getSpeed() {
        return speed;
    }
    public  void setSize ( int size ) {
        this.size = size;
    }
    public  int getSize() {
        return size;
    }
    public  void setX ( int x ) {
        this.x = x;
    }
    public  void setY ( int y ) {
        this.y = y;
    }
    public void paint ( Graphics g ) {
        g.drawImage ( img, x, y, null );
        g.setColor ( Color.RED );
    }
    public void move() {
        x += speed;
        Rectangle wallBounds = new Rectangle ( x, 0, size, Game.HEIGHT );
        Rectangle wallBoundsCritical = new Rectangle ( x, y, size, size );
        if ( ( wallBoundsCritical.intersects ( Game.spaceShip.getBounds() ) ) ) {
            Game.reset();
            setMeteor ( x );
            died();
        }
        if ( ( wallBounds.intersects ( Game.spaceShip.getBounds() ) ) ) {
            Game.score();
        }
        if ( x <= 0 - size ) {
            x = Game.WIDTH;
            y = ( int ) ( ( Math.random() * 440 ) + 80 );
        }
    }
    public Rectangle getScoreBounds() {
        return new Rectangle ( x, 0, size, Game.HEIGHT );
    }
    public Rectangle getCriticalBounds() {
        return new Rectangle ( x, y, size, size );
    }
    public void died() {
        y = ( int ) ( ( Math.random() * 440 ) + 110 );
    }
}
public class Player {
    private int speed;
    private int gravity;
    private int size;
    private int y;
    private int x;
    BufferedImage img;
    {
        try {
            img = ImageIO.read ( new File ( "2.png" ) );
        } catch ( IOException e ) {
            throw new RuntimeException ( "FailedToLoadImage" );
        }
    }
    public Player ( int speed, int gravity, int size, int y, int x ) {
        this.speed = speed;
        this.gravity = gravity;
        this.size = size;
        this.y = y;
        this.x = x;
    }
    public void jumpUp() {
        speed = 17;
    }
    public void jumpDown() {
        speed = -17;
    }
    public  void move() {
        if ( y > 0 && y <= 255 ) {
            speed = speed - gravity;
            y = y - speed;
        }
        if ( y >= 255 && y <= Game.HEIGHT ) {
            speed = speed + gravity;
            y = y - speed;
        }
        if ( y < 0 || y >= 510 ) {
            Game.reset();
            Game.dead = true;
        }
    }
    public  void setSpeed ( int speed ) {
        this.speed = speed;
    }
    public  void setGravity ( int gravity ) {
        this.gravity = gravity;
    }
    public  void setSize ( int size ) {
        this.size = size;
    }
    public  int getSize() {
        return size;
    }
    public  void setX ( int x ) {
        this.x = x;
    }
    public  void setY ( int y ) {
        this.y = y;
    }
    public void paint ( Graphics g ) {
        g.drawImage ( img, x, y, null );
    }
    public Rectangle getBounds() {
        return new Rectangle ( x, y, size, size );
    }
}
public class Score  implements Serializable {
    private static final long serialVersionUID = 1L;
    private int score;
    public int getScore() {
        return score;
    }
    public void setScore ( int score ) {
        this.score = score;
    }
    public Score ( int score ) {
        this.score = score;
    }
}
