public class GeneralDialogFragment extends BaseDialogFragment<GeneralDialogFragment.OnDialogFragmentClickListener> {
    public interface OnDialogFragmentClickListener {
        public void onOkClicked ( GeneralDialogFragment dialog );
        public void onCancelClicked ( GeneralDialogFragment dialog );
    }
    public static GeneralDialogFragment newInstance ( String title, String message ) {
        GeneralDialogFragment frag = new GeneralDialogFragment();
        Bundle args = new Bundle();
        args.putString ( "title", title );
        args.putString ( "msg", message );
        frag.setArguments ( args );
        return frag;
    }
    @Override
    public Dialog onCreateDialog ( Bundle savedInstanceState ) {
        return new AlertDialog.Builder ( getActivity() )
               .setTitle ( getArguments().getString ( "title" ) )
               .setMessage ( getArguments().getString ( "message" ) )
               .setCancelable ( false )
               .setPositiveButton ( "OK",
        new DialogInterface.OnClickListener() {
            public void onClick ( DialogInterface dialog, int whichButton ) {
                getActivityInstance().onOkClicked ( GeneralDialogFragment.this );
            }
        }
                                  )
        .setNegativeButton ( "Cancel",
        new DialogInterface.OnClickListener() {
            public void onClick ( DialogInterface dialog, int whichButton ) {
                getActivityInstance().onCancelClicked ( GeneralDialogFragment.this );
            }
        }
                           )
        .create();
    }
}
