* @return the <code>ViewIntroAdapterPart < / code > for this workbench, <code>null < / code > if it
              * cannot be found.
              * /
    ViewIntroAdapterPart getViewIntroAdapterPart() {
        IWorkbenchWindow[] windows = this.workbench.getWorkbenchWindows();
        for ( int i = 0; i < windows.length; i++ ) {
            IWorkbenchWindow window = windows[i];
            WorkbenchPage page = ( WorkbenchPage ) window.getActivePage();
            if ( page == null ) {
                continue;
            }
            IPerspectiveDescriptor[] perspDescs = page.getOpenPerspectives();
            for ( int j = 0; j < perspDescs.length; j++ ) {
                IPerspectiveDescriptor descriptor = perspDescs[j];
                IViewReference reference = page.findPerspective ( descriptor )
                                           .findView ( IIntroConstants.INTRO_VIEW_ID );
                if ( reference != null ) {
                    IViewPart part = reference.getView ( false );
                    if ( part != null && part instanceof ViewIntroAdapterPart ) {
                        return ( ViewIntroAdapterPart ) part;
                    }
                }
            }
        }
        return null;
    }
