void validate ( String xml, String schemaName ) throws Exception {
    DocumentBuilderFactory builderFactory = DocumentBuilderFactory.newInstance();
    builderFactory.setNamespaceAware ( true );
    DocumentBuilder parser = builderFactory
                             .newDocumentBuilder();
    Document document = parser.parse ( new StringInputStream ( xml ) );
    SchemaFactory factory = SchemaFactory
                            .newInstance ( XMLConstants.W3C_XML_SCHEMA_NS_URI );
    factory.setResourceResolver ( new ResourceResolver() );
    Source schemaFile = new StreamSource ( getClass().getClassLoader()
                                           .getResourceAsStream ( schemaName ) );
    Schema schema = factory.newSchema ( schemaFile );
    Validator validator = schema.newValidator();
    validator.validate ( new DOMSource ( document ) );
}
