#include "stdafx.h"
#include <opencv2/core/core.hpp>
#include <opencv2/highgui/highgui.hpp>
#include <opencv2/imgproc/imgproc.hpp>
#include <iostream>
using namespace cv;
using namespace std;
int _tmain ( int argc, _TCHAR * argv[] ) {
    Mat im = imread ( INPUT_FILE, CV_LOAD_IMAGE_GRAYSCALE );
    Mat morph;
    Mat morphKernelV = getStructuringElement ( MORPH_RECT, Size ( 1, 7 ) );
    morphologyEx ( im, morph, MORPH_CLOSE, morphKernelV );
    Mat bwV;
    threshold ( morph, bwV, 0, 255.0, CV_THRESH_BINARY | CV_THRESH_OTSU );
    Mat morphKernelH = getStructuringElement ( MORPH_RECT, Size ( 7, 1 ) );
    morphologyEx ( im, morph, MORPH_CLOSE, morphKernelH );
    Mat bwH;
    threshold ( morph, bwH, 0, 255.0, CV_THRESH_BINARY | CV_THRESH_OTSU );
    Mat bw = bwV & bwH;
    threshold ( bw, bw, 128.0, 255.0, CV_THRESH_BINARY_INV );
    Mat rgb;
    cvtColor ( im, rgb, CV_GRAY2BGR );
    vector<vector<Point>> contours;
    vector<Vec4i> hierarchy;
    findContours ( bw, contours, hierarchy, CV_RETR_CCOMP, CV_CHAIN_APPROX_SIMPLE, Point ( 0, 0 ) );
    double areaThL = bw.rows * .04 * bw.cols * .06;
    double areaThH = bw.rows * .7 * bw.cols * .7;
    double area = 0;
    for ( int idx = 0; idx >= 0; idx = hierarchy[idx][0] ) {
        area = contourArea ( contours[idx] );
        if ( area > areaThL && area < areaThH ) {
            drawContours ( rgb, contours, idx, Scalar ( 0, 0, 255 ), 2, 8, hierarchy );
            Rect rect = boundingRect ( contours[idx] );
            cout << "rect: (" << rect.x << ", " << rect.y << ") " << rect.width << " x " << rect.height << endl;
            Mat imRect ( im, rect );
        }
    }
    return 0;
}
