static final char ESCAPING_CHAR = '\\';
private List<String> parseString ( final String  str,
                                   final char    delimiter,
                                   final boolean removeEmpty )
throws IOException {
    final Reader        input  = new StringReader ( str );
    final StringBuilder part   = new StringBuilder();
    final List<String>  result = new ArrayList<String>();
    int c;
    do {
        c = input.read();
        if ( c != delimiter ) {
            if ( c == ESCAPING_CHAR ) {
                c = input.read();
            }
            if ( c >= 0 ) {
                part.append ( ( char ) c );
                continue;
            }
        }
        if ( part.length() > 0 || !removeEmpty ) {
            result.add ( part.toString() );
            part.setLength ( 0 );
        }
    } while ( c >= 0 );
    return result;
}
