package com.five_doors.xposedtranslate.util;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.nio.channels.FileChannel;
public class FileUtil {
    public static void copyFile ( File sourceFile, File destFile ) throws IOException {
        if ( !destFile.exists() ) {
            destFile.createNewFile();
        }
        FileChannel source = null;
        FileChannel destination = null;
        try {
            source = new FileInputStream ( sourceFile ).getChannel();
            destination = new FileOutputStream ( destFile ).getChannel();
            long count = 0;
            long size = source.size();
            while ( ( count += destination.transferFrom ( source, count, size - count ) ) < size );
        } finally {
            if ( source != null ) {
                source.close();
            }
            if ( destination != null ) {
                destination.close();
            }
        }
    }
    public static void deleteRecursive ( File fileOrDirectory ) {
        if ( fileOrDirectory.isDirectory() )
            for ( File child : fileOrDirectory.listFiles() ) {
                deleteRecursive ( child );
            }
        fileOrDirectory.delete();
    }
    public static String convertStreamToString ( InputStream is ) throws Exception {
        BufferedReader reader = new BufferedReader ( new InputStreamReader ( is ) );
        StringBuilder sb = new StringBuilder();
        String line = null;
        while ( ( line = reader.readLine() ) != null ) {
            sb.append ( line ).append ( "\n" );
        }
        reader.close();
        return sb.toString();
    }
    public static String getStringFromFile ( String filePath ) throws Exception {
        File fl = new File ( filePath );
        FileInputStream fin = new FileInputStream ( fl );
        String ret = convertStreamToString ( fin );
        fin.close();
        return ret;
    }
}
