public class Console extends JPanel implements KeyListener, CaretListener {
    private static final String PROMPT = ">>";
    private JScrollPane scrollPane;
    private JTextArea consoleTextPane;
    private int startIndex;
    public Console() {
        super();
        consoleTextPane = new JTextArea();
        consoleTextPane.setText ( PROMPT );
        consoleTextPane.setBorder ( null );
        consoleTextPane.setLineWrap ( true );
        consoleTextPane.setWrapStyleWord ( false );
        startIndex = consoleTextPane.getText().length();
        consoleTextPane.setCaretPosition ( startIndex );
        consoleTextPane.addCaretListener ( this );
        consoleTextPane.addKeyListener ( this );
        scrollPane = new JScrollPane ( consoleTextPane );
        scrollPane.setVerticalScrollBarPolicy ( ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS );
        scrollPane.setBorder ( null );
        JPanel panelCenter = new JPanel ( new BorderLayout() );
        panelCenter.setPreferredSize ( new Dimension ( 400, 200 ) );
        panelCenter.add ( scrollPane, BorderLayout.CENTER );
        add ( panelCenter, BorderLayout.CENTER );
    }
    public static void main ( String[] args ) {
        JFrame frame = new JFrame ( "Console" );
        frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
        frame.setResizable ( false );
        frame.add ( new Console() );
        frame.pack();
        frame.setVisible ( true );
    }
    @Override
    public void keyTyped ( KeyEvent e ) {
    }
    @Override
    public void keyReleased ( KeyEvent e ) {
    }
    @Override
    public void keyPressed ( KeyEvent e ) {
        switch ( e.getKeyCode() ) {
        case KeyEvent.VK_ENTER:
            String command = consoleTextPane.getText().substring ( startIndex );
            if ( !command.isEmpty() ) {
                consoleTextPane.append ( System.lineSeparator()
                                         + "Command Entered: " + command );
            }
            consoleTextPane.append ( System.lineSeparator() + PROMPT );
            startIndex = consoleTextPane.getText().length();
            e.consume();
            break;
        case KeyEvent.VK_BACK_SPACE:
            if ( consoleTextPane.getCaretPosition() <= startIndex ) {
                e.consume();
                Toolkit.getDefaultToolkit().beep();
            }
            break;
        default:
            break;
        }
    }
    @Override
    public void caretUpdate ( CaretEvent e ) {
        if ( e.getDot() < startIndex ) {
            consoleTextPane.setCaretPosition ( startIndex );
            Toolkit.getDefaultToolkit().beep();
        }
    }
}
