HttpMethodRetryHandler retryHandler = new HttpMethodRetryHandler() {
    public boolean retryMethod (
        final HttpMethod method,
        final IOException exception,
        int executionCount ) {
        if ( executionCount >= 5 ) {
            return false;
        }
        if ( exception instanceof NoHttpResponseException ) {
            return true;
        }
        if ( !method.isRequestSent() ) {
            return true;
        }
        return false;
    }
};
ApacheHttpClient client = ApacheHttpClient.create();
HttpClient hc = client.getClientHandler().getHttpClient();
hc.getParams().setParameter ( HttpMethodParams.RETRY_HANDLER, retryHandler );
client.resource ( "/stores/" + storeId ).type ( MediaType.APPLICATION_JSON_TYPE ).put ( ClientResponse.class, indexableStore );
