public class MultiServer2 implements Runnable {
    public static final int PORT_NUMBER = 2222;
    private static final int THREAD_POOL_COUNT = 20;
    private List<MultiClientHandler> clientList = new ArrayList<>();
    private ServerSocket serverSocket;
    private ExecutorService clientExecutor = Executors.newFixedThreadPool ( THREAD_POOL_COUNT );
    public MultiServer2() throws IOException {
        serverSocket = new ServerSocket ( PORT_NUMBER );
    }
    @Override
    public void run() {
        while ( true ) {
            try {
                Socket clientSocket = serverSocket.accept();
                MultiClientHandler client = new MultiClientHandler ( clientSocket );
                clientList.add ( client );
                clientExecutor.execute ( client );
            } catch ( IOException e ) {
                e.printStackTrace();
            }
        }
    }
