public class PersistentSetMapper implements CustomFieldMapper {
    private PersistentCollectionUtils mapperUtils = new PersistentCollectionUtils();
    @Override
    public boolean mapField ( Object source, Object destination, Object sourceFieldValue, ClassMap classMap, FieldMap fieldMapping ) {
        if ( !mapperUtils.isAbstractPersistentCollection ( sourceFieldValue ) ) {
            return false;
        }
        if ( mapperUtils.wasAbstractPersistentCollectionInitialized ( sourceFieldValue ) ) {
            return false;
        } else {
            boolean wasInitialized = mapperUtils.tryToInitializeCollection ( ( Collection<?> ) sourceFieldValue );
            if ( wasInitialized ) {
                return false;
            } else {
                destination = null;
                return true;
            }
        }
    }
}
