public class WktLiteral extends BaseDatatype {
    public static final String TypeURI = "http://www.opengis.net/ont/sf#wktLiteral";
    public static final String CRS84 = "<http://www.opengis.net/def/crs/OGC/1.3/CRS84>";
    public static final RDFDatatype wktLiteralType = new WktLiteral();
    private WktLiteral() {
        super ( WktLiteral.TypeURI );
    }
    public String unparse ( Object value ) {
        return value.toString();
    }
    public Object parse ( String lexicalForm ) {
        return new TypedValue ( String.format ( "%s %s", WktLiteral.CRS84, lexicalForm ), this.getURI() );
    }
    public boolean isEqual ( LiteralLabel value1, LiteralLabel value2 ) {
        return value1.getDatatype() == value2.getDatatype()
               && value1.getValue().equals ( value2.getValue() );
    }
