private void startRecordinga() {
    AudioRecord  recorder = new AudioRecord ( MediaRecorder.AudioSource.MIC,
            RECORDER_SAMPLERATE, RECORDER_CHANNELS,
            RECORDER_AUDIO_ENCODING, BufferElements2Rec * BytesPerElement );
    recorder.startRecording();
    isRecording = true;
    recordingThread = new Thread ( new Runnable() {
        public void run() {
            writeAudioDataToFile();
        }
    }, "AudioRecorder Thread" );
    recordingThread.start();
}
private byte[] short2byte ( short[] sData ) {
    int shortArrsize = sData.length;
    byte[] bytes = new byte[shortArrsize * 2];
    for ( int i = 0; i < shortArrsize; i++ ) {
        bytes[i * 2] = ( byte ) ( sData[i] & 0x00FF );
        bytes[ ( i * 2 ) + 1] = ( byte ) ( sData[i] >> 8 );
        sData[i] = 0;
    }
    return bytes;
}
private void writeAudioDataToFile() {
    String filePath = Environment.getExternalStorageDirectory()
                      .getAbsolutePath() + "/Myfolder/" + YOUR_FILE_NAME + ".pcm";
    short sData[] = new short[BufferElements2Rec];
    FileOutputStream os = null;
    try {
        os = new FileOutputStream ( filePath );
    } catch ( FileNotFoundException e ) {
        e.printStackTrace();
    }
    while ( isRecording ) {
        recorder.read ( sData, 0, BufferElements2Rec );
        System.out.println ( "Short wirting to file" + sData.toString() );
        try {
            byte bData[] = short2byte ( sData );
            os.write ( bData, 0, BufferElements2Rec * BytesPerElement );
        } catch ( IOException e ) {
            e.printStackTrace();
        }
    }
    try {
        os.close();
    } catch ( IOException e ) {
        e.printStackTrace();
    }
}
private void stopRecording() {
    if ( null != recorder ) {
        isRecording = false;
        recorder.stop();
        recorder.release();
        recorder = null;
        recordingThread = null;
    }
}
