@Entity ( name = "auth_user" )
public class User implements UserDetails {
    @Id
    @Column
    private String id;
    @Column ( nullable = false, unique = true )
    private String name;
    @ManyToMany ( fetch = FetchType.EAGER, cascade = CascadeType.ALL )
    private Set<Role> roles = new HashSet<Role>();
    public Collection<? extends GrantedAuthority> getAuthorities() {
        Set<GrantedAuthority> authList = new HashSet<GrantedAuthority>();
        for ( Role role : user.getRoles() ) {
            authList.add ( new SimpleGrantedAuthority ( role.getName() ) );
        }
        return authList;
    }
}
