@Configuration
@EnableWebMvc
@ComponentScan ( "com.kreuzman" )
public class WebConfig {
    @Bean
    public ITemplateResolver templateResolver() {
        TemplateResolver resolver = new ServletContextTemplateResolver();
        resolver.setPrefix ( "/templates/" );
        resolver.setSuffix ( ".html" );
        resolver.setTemplateMode ( "HTML5" );
        resolver.setCacheTTLMs ( 0l );
        return resolver;
    }
    @Bean
    public SpringTemplateEngine templateEngine() {
        SpringTemplateEngine engine = new SpringTemplateEngine();
        engine.setTemplateResolver ( templateResolver() );
        return engine;
    }
    @Bean
    public ViewResolver thymeleafViewResolver() {
        ThymeleafViewResolver viewResolver = new ThymeleafViewResolver();
        viewResolver.setTemplateEngine ( templateEngine() );
        viewResolver.setCharacterEncoding ( "UTF-8" );
        return viewResolver;
    }
}
