public class JsonViewMessageConverter extends MappingJackson2HttpMessageConverter {
    @Override
    protected void writeInternal ( Object object, HttpOutputMessage outputMessage )
    throws IOException, HttpMessageNotWritableException {
        if ( object instanceof ContainerViewEntity && ( ( ContainerViewEntity ) object ).hasView() ) {
            writeView ( ( ContainerViewEntity ) object, outputMessage );
        } else {
            super.writeInternal ( object, outputMessage );
        }
    }
    protected void writeView ( ContainerViewEntity view, HttpOutputMessage outputMessage )
    throws IOException, HttpMessageNotWritableException {
        JsonEncoding encoding = this.getJsonEncoding ( outputMessage.getHeaders().getContentType() );
        ObjectWriter writer = this.getWriterForView ( view.getView() );
        JsonGenerator jsonGenerator = writer.getFactory().createGenerator ( outputMessage.getBody(), encoding );
        try {
            writer.writeValue ( jsonGenerator, view.getObject() );
        } catch ( IOException ex ) {
            throw new HttpMessageNotWritableException ( "Could not write JSON: " + ex.getMessage(), ex );
        }
    }
    private ObjectWriter getWriterForView ( Class<?> view ) {
        ObjectMapper mapper = new ObjectMapper();
        mapper.configure ( MapperFeature.DEFAULT_VIEW_INCLUSION, false );
        return mapper.writer().withView ( view );
    }
}
