public static <N> List<Map<N, N>> enumerateEdges ( List<N> nodes, Map<N, N> edges ) {
    if ( nodes.isEmpty() ) {
        return Collections.singletonList ( new HashMap<> ( edges ) );
    }
    N start = nodes.get ( 0 );
    List<Map<N, N>> acc = new LinkedList<>();
    for ( int i = 1; i < nodes.size(); ++i ) {
        N end = nodes.get ( i );
        edges.put ( start, end );
        List<N> unused = new ArrayList<> ( nodes );
        unused.remove ( i );
        unused.remove ( 0 );
        acc.addAll ( enumerateEdges ( unused, edges ) );
        edges.remove ( start );
    }
    return acc;
}
