class VivzAdapter extends ArrayAdapter<String> implements OnCheckedChangeListener {
    Context context;
    int[] images;
    String[] titlesArray, descrptionArray;
    List<Integer> positions = new ArrayList<Integer>();
    ArrayList<Boolean> arrChecked;
    VivzAdapter ( Context context, String[] titles, int[] images, String[] description ) {
        super ( context, R.layout.single_row, R.id.textView1, titles );
        this.context = context;
        this.images = images;
        this.titlesArray = titles;
        this.descrptionArray = description;
        arrChecked = new ArrayList<Boolean>();
        for ( int i = 0; i < titles.size(); i++ ) {
            arrChecked.add ( false );
        }
    }
    class MyViewHolder {
        ImageView myImage;
        TextView myTitle;
        TextView myDescription;
        CheckBox box;
        MyViewHolder ( View v ) {
            myImage = ( ImageView ) v.findViewById ( R.id.imageView1 );
            myTitle = ( TextView ) v.findViewById ( R.id.textView1 );
            myDescription = ( TextView ) v.findViewById ( R.id.textView2 );
            box = ( CheckBox ) v.findViewById ( R.id.checkBox1 );
        }
    }
    @Override
    public View getView ( int position, View convertView, ViewGroup parent ) {
        View row = convertView;
        MyViewHolder holder = null;
        if ( row == null ) {
            LayoutInflater inflater = ( LayoutInflater ) context.getSystemService ( Context.LAYOUT_INFLATER_SERVICE );
            row = inflater.inflate ( R.layout.single_row, parent, false );
            holder = new MyViewHolder ( row );
            row.setTag ( holder );
        } else {
            holder = ( MyViewHolder ) row.getTag();
        }
        holder.myImage.setImageResource ( images[position] );
        holder.myTitle.setText ( titlesArray[position] );
        holder.myDescription.setText ( descrptionArray[position] );
        holder.box.setId ( position );
        holder.box.setOnClickListener ( new OnClickListener() {
            @Override
            public void onClick ( View v ) {
                int id = v.getId();
                if ( arrChecked.get ( id ) ) {
                    arrChecked.set ( id, false );
                } else {
                    arrChecked.set ( id, true );
                }
            }
        } );
        holder.box.setChecked ( arrChecked.get ( position ) );
        return row;
    }
}
