public class User implements HttpSessionBindingListener {
    private static Map<User, HttpSession> logins = new HashMap<User, HttpSession>();
    private Long id;
    private String username;
    @Override
    public boolean equals ( Object other ) {
        return ( other instanceof User ) && ( id != null ) ? id.equals ( ( ( User ) other ).id ) : ( other == this );
    }
    @Override
    public int hashCode() {
        return ( id != null ) ? ( this.getClass().hashCode() + id.hashCode() ) : super.hashCode();
    }
    @Override
    public void valueBound ( HttpSessionBindingEvent event ) {
        HttpSession session = logins.remove ( this );
        if ( session != null ) {
            session.invalidate();
        }
        logins.put ( this, event.getSession() );
    }
    @Override
    public void valueUnbound ( HttpSessionBindingEvent event ) {
        logins.remove ( this );
    }
}
