public class Main extends SimpleApplication {
    public static void main ( String[] args ) {
        Main app = new Main();
        app.setShowSettings ( false );
        app.start();
    }
    final float speed = 0.01f;
    BitmapText hudText;
    Quaternion orientation;
    DirectionalLight sun;
    @Override
    public void simpleInitApp() {
        flyCam.setEnabled ( false );
        setDisplayStatView ( false );
        setDisplayFps ( false );
        hudText = new BitmapText ( guiFont, false );
        hudText.setSize ( guiFont.getCharSet().getRenderedSize() );
        hudText.setColor ( ColorRGBA.Blue );
        hudText.setText ( "" );
        hudText.setLocalTranslation ( 300, hudText.getLineHeight() * 2, 0 );
        guiNode.attachChild ( hudText );
        cam.setLocation ( new Vector3f ( 10, 0, 0 ) );
        cam.lookAt ( Vector3f.ZERO, Vector3f.UNIT_Z );
        addOriginalSphere();
        addRotatedSphere();
    }
    public void addOriginalSphere() {
        Sphere sphere1Mesh = new Sphere ( 50, 50, 2 );
        sphere1Mesh.setTextureMode ( Sphere.TextureMode.Projected );
        Material sphere1Mat = new Material ( assetManager, "Common/MatDefs/Misc/Unshaded.j3md" );
        sphere1Mat.setTexture ( "ColorMap", assetManager.loadTexture ( "Textures/world.png" ) );
        Geometry sphere1Geo = new Geometry ( "Original Sphere", sphere1Mesh );
        sphere1Geo.setMaterial ( sphere1Mat );
        sphere1Geo.setLocalTranslation ( 0, -2, 0 );
        rootNode.attachChild ( sphere1Geo );
    }
    public void addRotatedSphere() {
        Sphere sphere1Mesh = new Sphere ( 50, 50, 2 );
        sphere1Mesh.setTextureMode ( Sphere.TextureMode.Projected );
        Material sphere1Mat = new Material ( assetManager, "Common/MatDefs/Misc/Unshaded.j3md" );
        sphere1Mat.setTexture ( "ColorMap", assetManager.loadTexture ( "Textures/world.png" ) );
        Geometry sphere1Geo = new Geometry ( "Rotated Sphere", sphere1Mesh );
        sphere1Geo.setMaterial ( sphere1Mat );
        sphere1Geo.setLocalTranslation ( 0, 2, 0 );
        Quaternion quat = new Quaternion();
        quat.fromAngles ( 0 , 0 , FastMath.PI );
        sphere1Geo.setLocalRotation ( quat );
        rootNode.attachChild ( sphere1Geo );
    }
    @Override
    public void simpleUpdate ( float tpf ) {
    }
}
