static Type resolveReturnType ( Type classType, Method method, Type... argTypes ) {
    Type returnType = TypeToken.of ( classType )
                      .resolveType ( method.getGenericReturnType() ).getType();
    Type[] parameterTypes = method.getGenericParameterTypes();
    TypeResolver resolver = new TypeResolver();
    for ( int i = 0; i < parameterTypes.length; i++ ) {
        @SuppressWarnings ( "unchecked" )
        TypeToken<Object> paramType =
            ( TypeToken<Object> ) TypeToken.of ( parameterTypes[i] );
        @SuppressWarnings ( "unchecked" )
        TypeToken<Object> argType =
            ( TypeToken<Object> ) TypeToken.of ( argTypes[i] );
        if ( method.isVarArgs() && i == parameterTypes.length - 1 ) {
        } else {
            TypeToken<?> argTypeAsParamType =
                argType.getSupertype ( paramType.getRawType() );
            resolver = resolver.where (
                           paramType.getType(), argTypeAsParamType.getType() );
        }
    }
    return resolver.resolveType ( returnType );
}
