private String convertTcToHtml ( Tc tc ) {
    StringBuilder sb = new StringBuilder();
    sb.append ( "<html><body>" );
    List<Object> paragraphs = getAllElementFromObject ( tc, P.class );
    if ( paragraphs == null || paragraphs.size() == 0 ) {
        return null;
    }
    List<Object> runs = getAllElementFromObject ( paragraphs.get ( 0 ), R.class );
    addRunsToHtmlStringBuffer ( sb, runs );
    if ( paragraphs.size() > 1 ) {
        sb.append ( "<br />" );
        for ( int i = 1; i < paragraphs.size(); i++ ) {
            List<Object> moreRuns = getAllElementFromObject ( paragraphs.get ( i ), R.class );
            addRunsToHtmlStringBuffer ( sb, moreRuns );
            sb.append ( "<br />" );
        }
    }
    sb.append ( "</body></html>" );
    return sb.toString();
}
private void addRunsToHtmlStringBuffer ( StringBuilder sb, List<Object> runs ) {
    if ( runs != null && runs.size() > 0 ) {
        for ( Object r : runs ) {
            R run = ( R ) r;
            List<Object> brs = getAllElementFromObject ( run, Br.class );
            if ( brs != null && brs.size() > 0 ) {
                LOGGER.info ( "BR:" );
                sb.append ( "<br/>" );
            }
            List<Object> texts = getAllElementFromObject ( run, Text.class );
            if ( texts != null && texts.size() > 0 ) {
                StringBuilder text_sb = new StringBuilder();
                for ( Object t : texts ) {
                    Text text = ( Text ) t;
                    text_sb.append ( text.getValue() );
                }
                String htmlText = replaceWithHtmlCharacters ( text_sb.toString() );
                if ( run.getRPr() != null && run.getRPr().getB() != null && ( run.getRPr().getB().isVal() ) ) {
                    LOGGER.info ( "Bold Text:" );
                    sb.append ( "<b>" );
                    sb.append ( htmlText );
                    sb.append ( "</b>" );
                } else {
                    LOGGER.info ( "Normal Text:" );
                    sb.append ( htmlText );
                }
            }
        }
    }
}
private String replaceWithHtmlCharacters ( String text ) {
    text = text.replace ( "\"", "&quot;" );
    text = text.replace ( "<", "&lt;" );
    text = text.replace ( ">", "&gt;" );
    return text;
}
