import java.awt.Desktop;
import java.awt.Dimension;
import java.awt.EventQueue;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.File;
import java.io.IOException;
import javax.swing.DefaultListModel;
import javax.swing.JFrame;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
public class FileListExample {
    public static void main ( String[] args ) {
        new FileListExample();
    }
    public FileListExample() {
        EventQueue.invokeLater ( new Runnable() {
            @Override
            public void run() {
                try {
                    UIManager.setLookAndFeel ( UIManager.getSystemLookAndFeelClassName() );
                } catch ( ClassNotFoundException | InstantiationException | IllegalAccessException | UnsupportedLookAndFeelException ex ) {
                    ex.printStackTrace();
                }
                File[] files = new File ( "..." ).listFiles();
                DefaultListModel<File> model = new DefaultListModel<>();
                for ( File file : files ) {
                    model.addElement ( file );
                }
                JList<File> list = new JList<> ( model );
                list.addMouseListener ( new MouseAdapter() {
                    @Override
                    public void mouseClicked ( MouseEvent e ) {
                        if ( SwingUtilities.isLeftMouseButton ( e ) && e.getClickCount() == 2 ) {
                            JList list = ( JList ) e.getComponent();
                            File file = ( File ) list.getSelectedValue();
                            try {
                                Desktop desktop = Desktop.getDesktop();
                                desktop.open ( file );
                            } catch ( IOException exp ) {
                                exp.printStackTrace();
                            }
                        }
                    }
                } );
                JFrame frame = new JFrame ( "Testing" );
                frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
                frame.add ( new JScrollPane ( list ) );
                frame.pack();
                frame.setLocationRelativeTo ( null );
                frame.setVisible ( true );
            }
        } );
    }
}
