import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.*;
import java.text.*;
import java.util.concurrent.TimeUnit;
public class cancelOrder extends HttpServlet {
    String confirmNumber = "0";
    String shippingDate = "01/01/2000";
    Date date;
    public static long getDateDiffInDays ( Date date1, Date date2 ) {
        long diffInMillis = date2.getTime() - date1.getTime();
        return TimeUnit.MILLISECONDS.toDays ( diffInMillis );
    }
    protected void processRequest ( HttpServletRequest request, HttpServletResponse response )
    throws ServletException, java.io.IOException {
        String enteredConfirmNumber = request.getParameter ( "ConfirmationNumber" );
        Cookie[] cookies = request.getCookies();
        Cookie cookie;
        for ( int i = 0; i < cookies.length; i++ ) {
            cookie = cookies[i];
            String foundCookie = cookie.getName();
            if ( foundCookie.equals ( enteredConfirmNumber ) ) {
                confirmNumber = foundCookie;
                shippingDate = cookie.getValue();
            }
        }
        SimpleDateFormat formatter = new SimpleDateFormat ( "dd/MM/yyyy" );
        try {
            date = formatter.parse ( shippingDate );
        } catch ( ParseException e ) {
            e.printStackTrace();
        }
        Calendar shipDate = Calendar.getInstance();
        shipDate.setTime ( date );
        Calendar today = Calendar.getInstance();
        long daysTillShip = getDateDiffInDays ( today.getTime(), shipDate.getTime() );
        if ( confirmNumber.equals ( enteredConfirmNumber ) &&
                daysTillShip > 5 ) {
            showPage ( response, "Your order was successfully canceled." );
        }  else {
            showPage ( response, "Either it is less than 5 days before delivery " +
                       "or your confirmation number does not exist" );
        }
    }
    protected void showPage ( HttpServletResponse response, String message )
    throws ServletException, java.io.IOException {
        response.setContentType ( "text/html" );
        java.io.PrintWriter out = response.getWriter();
        out.println ( "<html>" );
        out.println ( "<head>" );
        out.println ( "<title>Status of Your Order</title>" );
        out.println ( "</head>" );
        out.println ( "<body>" );
        out.println ( "<h2>" + message + "</h2>" );
        out.println ( "</body>" );
        out.println ( "</html>" );
        out.close();
    }
    protected void doGet ( HttpServletRequest request, HttpServletResponse response )
    throws ServletException, java.io.IOException {
        processRequest ( request, response );
    }
    protected void doPost ( HttpServletRequest request, HttpServletResponse response )
    throws ServletException, java.io.IOException {
        processRequest ( request, response );
    }
}
