import java.io.IOException;
import java.net.HttpURLConnection;
import java.net.InetAddress;
import java.net.URL;
import java.net.UnknownHostException;
import java.io.*;
public class Internet {
    private final static String DEFAULT_LOCAL_HOST = "127.0.0.1";
    private URL url;
    private HttpURLConnection http;
    private int responseCode;
    private String responseMessage;
    public Internet ( URL url ) {
        this.url = url;
    }
    public boolean isValid() {
        try {
            http = ( HttpURLConnection ) url.openConnection();
            http.setRequestMethod ( "HEAD" );
            http.connect();
            if ( http.getResponseCode() != HttpURLConnection.HTTP_OK ) {
                System.out.print ( http.getResponseCode() + " : " );
                System.err.print ( http.getResponseCode() + " : " );
                http = ( HttpURLConnection ) url.openConnection();
                http.setRequestMethod ( "GET" );
                http.connect();
            }
            responseCode = http.getResponseCode();
            responseMessage = http.getResponseMessage();
            return http.getResponseCode() == HttpURLConnection.HTTP_OK;
        } catch ( IOException e ) {
            responseCode = -1;
            responseMessage = e.getMessage();
            return false;
        }
    }
    public int getResponseCode() {
        return responseCode;
    }
    public String getResponseMessage() {
        return responseMessage;
    }
    public static boolean isConnected() {
        String hostAddress = DEFAULT_LOCAL_HOST;
        try {
            InetAddress localHost = InetAddress.getLocalHost();
            hostAddress = localHost.getHostAddress();
            System.out.println ( hostAddress );
        } catch ( UnknownHostException e ) {
            System.out.println ( e );
        }
        return ! hostAddress.equals ( DEFAULT_LOCAL_HOST );
    }
    public static void main ( String[] args )
    throws Exception {
        System.out.println ( "Connected: " + Internet.isConnected() );
        for ( int i = 0; i < args.length; i++ ) {
            URL url = new URL ( args[i] );
            Internet internet = new Internet ( url );
            System.out.println ( url + " is valid: " + internet.isValid() );
        }
    }
}
