public class StreamSplitter {
    private InputStream st;
    private Charset charset;
    public StreamSplitter ( InputStream st, Charset charset ) {
        this.st = st;
        this.charset = charset;
    }
    public String readUntil ( String marker ) throws IOException {
        StringBuilder res = new StringBuilder();
        if ( !readUntil ( marker, res ) ) {
            return null;
        }
        return res.toString();
    }
    public boolean readUntil ( String marker, StringBuilder res ) throws IOException {
        byte[] markerBytes = marker.getBytes ( charset );
        int b;
        int n = 0;
        while ( ( b = st.read() ) != -1 ) {
            byte bb = ( byte ) b;
            if ( markerBytes[n] == bb ) {
                n++;
                if ( n == markerBytes.length ) {
                    return true;
                }
            } else {
                if ( n != 0 && res != null ) {
                    for ( int nn = 0; nn < n; nn++ ) {
                        res.append ( ( char ) markerBytes[nn] );
                    }
                }
                if ( res != null ) {
                    res.append ( ( char ) bb );
                }
                n = 0;
            }
        }
        return false;
    }
}
