import javafx.application.Platform;
import javafx.embed.swing.JFXPanel;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.scene.Group;
import javafx.scene.Scene;
import javafx.scene.text.Font;
import javafx.scene.text.Text;
import javax.swing.*;
public class PrintFx {
    private static void initAndShowGUI() {
        JFrame frame = new JFrame ( "Swing and JavaFX" );
        final JFXPanel fxPanel = new JFXPanel();
        frame.add ( fxPanel );
        frame.setSize ( 300, 200 );
        frame.setVisible ( true );
        frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
        Platform.runLater ( new Runnable() {
            @Override
            public void run() {
                initFX ( fxPanel );
            }
        } );
    }
    private static void initFX ( JFXPanel fxPanel ) {
        Scene scene = createScene();
        fxPanel.setScene ( scene );
    }
    private static Scene createScene() {
        Group root = new Group();
        Scene scene = new Scene ( root, javafx.scene.paint.Color.ALICEBLUE );
        Text text = new Text();
        text.setX ( 40 );
        text.setY ( 100 );
        text.setFont ( new Font ( 25 ) );
        text.setText ( "Welcome JavaFX!" );
        javafx.scene.control.Button button2 = new javafx.scene.control.Button ( "Open AWT print dialog" );
        button2.setOnAction ( new EventHandler() {
            @Override public void handle ( ActionEvent e ) {
                SwingUtilities.invokeLater ( new Runnable() {
                    @Override
                    public void run() {
                        System.out.println ( "now open dialog!" );
                        java.awt.print.PrinterJob.getPrinterJob().printDialog();
                    }
                } );
            }
        } );
        root.getChildren().add ( text );
        root.getChildren().add ( button2 );
        return ( scene );
    }
    public static void main ( String[] args ) {
        SwingUtilities.invokeLater ( new Runnable() {
            @Override
            public void run() {
                initAndShowGUI();
            }
        } );
    }
}
