public static class EntryManager {
    private int inFoo = 0;
    private int inBar = 0;
    private Queue<Thread> queue = new LinkedList<>();
    public synchronized void enterBar ( Thread t ) throws InterruptedException {
        queue.add ( t );
        while ( queue.peek() != t ) {
            this.wait();
        }
        while ( inFoo > 0 ) {
            this.wait();
        }
        queue.remove();
        inBar++;
        this.notifyAll();
    }
    public synchronized void enterFoo ( Thread t ) throws InterruptedException {
        queue.add ( t );
        while ( queue.peek() != t ) {
            this.wait();
        }
        while ( inBar > 0 ) {
            this.wait();
        }
        queue.remove();
        inFoo++;
        this.notifyAll();
    }
    public synchronized void exitBar() {
        inBar--;
        this.notifyAll();
    }
    public synchronized void exitFoo() {
        inFoo--;
        this.notifyAll();
    }
}
