package com.lethal.config;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.servlet.config.annotation.EnableWebMvc;
import org.springframework.web.servlet.config.annotation.ResourceHandlerRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurerAdapter;
import org.springframework.web.servlet.view.JstlView;
import org.springframework.web.servlet.view.UrlBasedViewResolver;
import org.springframework.core.Ordered;
import org.springframework.format.FormatterRegistry;
import org.springframework.web.servlet.config.annotation.ViewControllerRegistry;
import com.lethal.converter.StringToServiceTypeConverter;
@Configuration
@EnableWebMvc
@ComponentScan ( "com.lethal" )
public class WebAppConfig extends WebMvcConfigurerAdapter {
    @Override
    public void addViewControllers ( ViewControllerRegistry registry ) {
        registry.addViewController ( "/login" ).setViewName ( "login" );
        registry.setOrder ( Ordered.HIGHEST_PRECEDENCE );
    }
    @Bean
    public UrlBasedViewResolver setupViewResolver() {
        UrlBasedViewResolver resolver = new UrlBasedViewResolver();
        resolver.setPrefix ( "/WEB-INF/views/" );
        resolver.setSuffix ( ".jsp" );
        resolver.setViewClass ( JstlView.class );
        return resolver;
    }
    public void addResourceHandlers ( ResourceHandlerRegistry registry ) {
        registry.addResourceHandler ( "/resources/**" ).addResourceLocations ( "/resources/" );
    }
    @Bean
    public StringToServiceTypeConverter getStringToServiceTypeConverter() {
        return new StringToServiceTypeConverter();
    }
    @Override
    public void addFormatters ( FormatterRegistry formatterRegistry ) {
        formatterRegistry.addConverter ( getStringToServiceTypeConverter() );
    }
}
