import com.fasterxml.jackson.databind.ObjectMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.security.access.AccessDeniedException;
import org.springframework.stereotype.Component;
import org.springframework.web.servlet.HandlerExceptionResolver;
import org.springframework.web.servlet.ModelAndView;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.HashMap;
import java.util.Map;
@Component ( "handlerExceptionResolver" )
public class RestExceptionResolver implements HandlerExceptionResolver {
    private final ObjectMapper objectMapper;
    @Autowired
    public RestExceptionResolver ( ObjectMapper objectMapper ) {
        this.objectMapper = objectMapper;
    }
    @Override
    public ModelAndView resolveException ( HttpServletRequest request, HttpServletResponse response, Object object, Exception exception ) {
        if ( exception instanceof AccessDeniedException ) {
            try {
                Map<String, Object> data = new HashMap<String, Object>();
                data.put ( "status", HttpServletResponse.SC_FORBIDDEN );
                data.put ( "message", "my custom message" );
                response.setStatus ( HttpServletResponse.SC_FORBIDDEN );
                response.setContentType ( MediaType.APPLICATION_JSON_VALUE );
                objectMapper.writeValue ( response.getOutputStream(), data );
                return new ModelAndView();
            } catch ( Exception e ) {
                throw new RuntimeException ( e.getMessage(), e );
            }
        }
        return null;
    }
}
