@Configuration
@EnableWebMvcSecurity
public class WebSecurityConfig extends WebSecurityConfigurerAdapter {
    @Autowired
    private UserDetailsService customUserDetailsService
    @Autowired
    public void configureGlobal ( AuthenticationManagerBuilder auth )
    throws Exception {
        auth.userDetailsService ( customUserDetailsService );
    }
    @Override
    protected void configure ( HttpSecurity http ) throws Exception {
        http.csrf().disable();
        http.authorizeRequests().antMatchers ( "/home/logout.do" ).permitAll()
        .anyRequest().authenticated().and().formLogin()
        .loginPage ( "/home/login.do" ).permitAll()
        .failureUrl ( "/home/accessdenied.do" ).permitAll();
    }
}
