import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.EventQueue;
import java.awt.FlowLayout;
import javax.swing.JFrame;
import static javax.swing.JFrame.EXIT_ON_CLOSE;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumn;
public class Gui extends JFrame {
    public static void main ( String[] args ) {
        EventQueue.invokeLater ( new Runnable() {
            @Override
            public void run() {
                try {
                    UIManager.setLookAndFeel ( UIManager.getSystemLookAndFeelClassName() );
                } catch ( ClassNotFoundException | InstantiationException | IllegalAccessException | UnsupportedLookAndFeelException ex ) {
                }
                Gui frame = new Gui();
                frame.start ( new DefaultTableModel ( new Object[] {"A", "B", "C"}, 10 ) );
            }
        } );
    }
    AbstractTableModel model;
    JTable table;
    public void start ( AbstractTableModel model ) {
        this.model = model;
        table = new JTable ( model ) {
            @Override
            public boolean isCellEditable ( int arg0, int arg1 ) {
                return false;
            }
        };
        table.setAutoResizeMode ( JTable.AUTO_RESIZE_OFF );
        TableColumn column = null;
        for ( int i = 0; i < model.getColumnCount(); i++ ) {
            column = table.getColumnModel().getColumn ( i );
            column.setPreferredWidth ( 120 );
            column.setMaxWidth ( 300 );
            column.setMinWidth ( 50 );
        }
        JScrollPane pane = new JScrollPane ( table );
        pane.setPreferredSize ( new Dimension ( 900, 900 ) );
        add ( pane );
        setLayout ( new FlowLayout() );
        setVisible ( true );
        setDefaultCloseOperation ( EXIT_ON_CLOSE );
        pack();
    }
}
