ScheduledExecutorService scheduler = Executors.newSingleThreadScheduledExecutor();
RetryExecutor executor = new AsyncRetryExecutor ( scheduler ).
retryOn ( SocketException.class ).
withExponentialBackoff ( 500, 2 ).
withMaxDelay ( 10_000 ).
withUniformJitter().
withMaxRetries ( 20 );
final CompletableFuture<Socket> future = executor.getWithRetry ( () ->
        new Socket ( "localhost", 8080 )
                                                               );
future.thenAccept ( socket ->
                    System.out.println ( "Connected! " + socket )
                  );
