public class Main {
    public static void main ( String[] args ) throws Exception {
        Scanner main = new Scanner ( new File ( "main.csv" ) );
        Scanner look = new Scanner ( new File ( "look.csv" ) );
        FileWriter replaced = new FileWriter ( createReplacedCsv() );
        Map<String, String> lookCsvWords = storeLookCsvInSet ( look );
        StringBuilder builder = new StringBuilder();
        int line = 0;
        while ( main.hasNext() ) {
            String[] wordsInLine = main.nextLine().split ( "," );
            for ( String word : wordsInLine ) {
                if ( lookCsvWords.containsKey ( word ) && line == 0 ) {
                    word = lookCsvWords.get ( word );
                }
                builder.append ( word ).append ( "," );
            }
            line ++;
            builder.deleteCharAt ( builder.lastIndexOf ( "," ) );
            builder.append ( "\n" );
        }
        replaced.write ( builder.toString() );
        replaced.close();
    }
    private static File createReplacedCsv() throws Exception {
        File replacedCsv = new File ( "replaced.csv" );
        replacedCsv.createNewFile();
        return replacedCsv;
    }
    private static Map<String, String> storeLookCsvInSet ( Scanner lookScanner ) throws Exception {
        Map<String, String> lookCsvWordMappings = new HashMap<String, String>();
        String[] line1Values = lookScanner.nextLine().split ( "," );
        String[] line2Values = lookScanner.nextLine().split ( "," );
        for ( int i = 0; i < line1Values.length; i++ ) {
            lookCsvWordMappings.put ( line1Values[i], line2Values[i] );
        }
        return lookCsvWordMappings;
    }
