public Pollen ( int zipcode, final Context context ) {
    this.context = context;
    this.zipcode = zipcode;
    Document doc;
    try {
        doc = Jsoup.connect ( "http://www.wunderground.com/DisplayPollen.asp?Zipcode=" + this.zipcode ).get();
        if ( doc.select ( "div.columns" ).first().text() == null ) {
            throw new IllegalStateException ( "div.columns is NULL" );
        }
        Element location = doc.select ( "div.columns" ).first();
        this.location = location.text();
        Element pollenType = doc.select ( "div.panel h3" ).first();
        this.pollenType = pollenType.text();
        SimpleDateFormat format = new SimpleDateFormat ( "EEE MMMM dd, yyyy" );
        for ( int i = 0; i < 4; i++ ) {
            Element dates = doc.select ( "td.text-center.even-four" ).get ( i );
            Element levels = doc.select ( "td.levels" ).get ( i );
            pollenMap.put ( format.parse ( dates.text() ), levels.text() );
        }
    } catch ( IOException e ) {
        displayToast ( context );
    } catch ( ParseException e ) {
        displayToast ( context );
    } catch ( IllegalStateException e ) {
        displayToast ( context );
    }
}
private void displayToast ( Context context ) {
    ( ( Activity ) context ).runOnUiThread ( new Runnable() {
        public void run() {
            Toast toast = Toast.makeText ( context, R.string.toast_parse_fail, Toast.LENGTH_LONG );
            toast.show();
        }
    } );
}
