public class LEB128InputStreamReader extends InputStreamReader {
    public LEB128InputStreamReader ( InputStream stream ) {
        super ( stream, StandardCharsets.UTF_8 );
    }
    public String readString() throws IOException {
        int nextCharValue = this.read();
        if ( nextCharValue != -1 ) {
            StringBuilder s = new StringBuilder();
            boolean lengthKeepGoing = ( nextCharValue & ( 1 << 7 ) ) == ( 1 << 7 );
            ArrayList<Integer> lengths = new ArrayList<>();
            lengths.add ( nextCharValue & 0x7F );
            while ( lengthKeepGoing ) {
                nextCharValue = this.read();
                lengthKeepGoing = ( nextCharValue & ( 1 << 7 ) ) == ( 1 << 7 );
                lengths.add ( nextCharValue & ( 0x7F ) );
            }
            int totalLength = 0;
            for ( int i = 0; i < lengths.size(); i++ ) {
                totalLength += lengths.get ( i ) << ( 7 * i );
            }
            for ( int i = 0; i < totalLength; i++ ) {
                s.append ( ( char ) this.read() );
            }
            return s.toString();
        }
        return null;
    }
}
