public static Map jsonToMap ( JSONObject json ) throws JSONException {
    Map<String, Object> retMap = new HashMap<String, Object>();
    if ( json != JSONObject.NULL ) {
        retMap = toMap ( json );
    }
    return retMap;
}
public static Map toMap ( JSONObject object ) throws JSONException {
    Map<String, Object> map = new HashMap<String, Object>();
    Iterator<String> keysItr = object.keys();
    while ( keysItr.hasNext() ) {
        String key = keysItr.next();
        Object value = object.get ( key );
        if ( value instanceof JSONArray ) {
            value = toList ( ( JSONArray ) value );
        } else if ( value instanceof JSONObject ) {
            value = toMap ( ( JSONObject ) value );
        }
        map.put ( key, value );
    }
    return map;
}
public static List toList ( JSONArray array ) throws JSONException {
    List<Object> list = new ArrayList<Object>();
    for ( int i = 0; i < array.length(); i++ ) {
        list.add ( array.get ( i ) );
    }
    return list;
}
