private static boolean running = false;
private static Object execLock = new Object();
private boolean start() {
    synchronized ( execLock ) {
        boolean ret = running;
        running = true;
        return ret;
    }
}
private void end() {
    synchronized ( execLock ) {
        running = false;
    }
}
public void launchExpensiveTask() {
    if ( running ) {
        return;
    }
    if ( start() ) {
        return;
    }
    try {
        runExpensiveTask();
    } finally {
        end();
    }
}
