public class Point implements Comparable<Point> {
    private long x;
    private double y;
    @Override
    public int compareTo ( Point o ) {
        int cmp1 = Long.compare ( this.x, o.x );
        return  cmp1 != 0 ? cmp1 : Double.compare ( this.y, o.y ) ;
    }
    @Override
    public String toString() {
        return "(" + x + "," + y + ")";
    }
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ( int ) ( x ^ ( x >>> 32 ) );
        long temp;
        temp = Double.doubleToLongBits ( y );
        result = prime * result + ( int ) ( temp ^ ( temp >>> 32 ) );
        return result;
    }
    @Override
    public boolean equals ( Object obj ) {
        if ( this == obj ) {
            return true;
        }
        if ( obj == null ) {
            return false;
        }
        if ( getClass() != obj.getClass() ) {
            return false;
        }
        Point other = ( Point ) obj;
        if ( x != other.x ) {
            return false;
        }
        if ( Double.doubleToLongBits ( y ) != Double.doubleToLongBits ( other.y ) ) {
            return false;
        }
        return true;
    }
}
