import java.net.InetAddress;
import java.net.UnknownHostException;
import java.util.StringTokenizer;
import java.util.Vector;
import android.app.Activity;
public class iprange extends Activity {
    public static boolean ValidateIP ( String IPAddress, String NetMask ) throws UnknownHostException, Exception {
        int ip, network, netmask, cidr, tokens = 0;
        if ( !validateInetAddress ( IPAddress ) ) {
            return false;
        }
        ip = toInt ( InetAddress.getByName ( IPAddress ) );
        Vector<Object> nm = new Vector<Object>();
        StringTokenizer nmt = new StringTokenizer ( NetMask, "/" );
        while ( nmt.hasMoreTokens() ) {
            nm.add ( nmt.nextToken() );
            tokens++;
        }
        if ( tokens == 1 ) {
            nm.add ( "32" );
        }
        if ( !validateInetAddress ( nm.get ( 0 ).toString() ) ) {
            return false;
        }
        network = toInt ( InetAddress.getByName ( nm.get ( 0 ).toString() ) );
        if ( nm.get ( 1 ).toString().length() < 3 ) {
            cidr = Integer.parseInt ( nm.get ( 1 ).toString() );
            if ( !validateCIDR ( cidr, NetMask ) ) {
                return false;
            }
            netmask = 0x80000000 >> ( cidr - 1 );
        } else {
            if ( !validateInetAddress ( nm.get ( 1 ).toString() ) ) {
                return false;
            }
            cidr = Integer.bitCount ( toInt ( InetAddress.getByName ( nm.get ( 1 ).toString() ) ) );
        }
        if ( cidr == 32 ) {
            return ip == network;
        }
        netmask = 0x80000000 >> ( cidr - 1 );
        return ( ( ip & netmask ) == network );
    }
    private static boolean validateCIDR ( int cidr, String NetMask ) throws Exception {
        if ( cidr < 0 || cidr > 32 ) {
            throw new Exception ( "CIDR value out of bounds [0..32]: " + NetMask );
        }
        return true;
    }
    private static boolean validateInetAddress ( String IPAddress ) throws Exception {
        int i = 0;
        StringTokenizer tokens = new StringTokenizer ( IPAddress, "." );
        while ( tokens.hasMoreTokens() ) {
            String token = tokens.nextToken().toString();
            if ( !Integer.toString ( ( Integer.parseInt ( token ) & 0xff ) ).equals ( token ) ) {
                throw new Exception ( "Can't validate IP Address: " + IPAddress );
            }
            i++;
        }
        if ( i > 4 ) {
            throw new Exception ( "IP Address has more than 4 parts: " + IPAddress );
        }
        return true;
    }
    private static int toInt ( InetAddress inetAddress ) {
        byte[] address = inetAddress.getAddress();
        int net = 0;
        for ( int i = 0; i < address.length; i++ ) {
            net = ( net << 8 ) | ( address[i] & 0xff );
        }
        return net;
    }
}
