@Component
public class ApiMultiplexingProcessor extends TMultiplexedProcessor {
    UserServiceHandler userServiceHandler;
    ReportServiceHandler reportServiceHandler;
    @Autowired
    public ApiMultiplexingProcessor ( UserServiceProcessor userServiceProcessor, ReportServiceProcessor reportServiceProcessor ) {
        this.registerProcessor ( "UserService", userServiceProcessor );
        this.registerProcessor ( "ReportService", reportServiceProcessor );
        userServiceHandler = userServiceProcessor.getHandler();
        reportServiceHandler = reportServiceProcessor.getHandler();
    }
    public UserServiceHandler getUserServiceHandler() {
        return userServiceHandler;
    }
    public void setUserServiceHandler ( UserServiceHandler userServiceHandler ) {
        this.userServiceHandler = userServiceHandler;
    }
    public ReportServiceHandler getReportServiceHandler() {
        return reportServiceHandler;
    }
    public void setReportServiceHandler ( ReportServiceHandler reportServiceHandler ) {
        this.reportServiceHandler = reportServiceHandler;
    }
}
