public class TiledMapStage extends Stage {
    private TiledMap tiledMap;
    public TiledMapStage ( TiledMap tiledMap ) {
        this.tiledMap = tiledMap;
        for ( MapLayer layer : tiledMap.getLayers() ) {
            TiledMapTileLayer tiledLayer = ( TiledMapTileLayer ) layer;
            createActorsForLayer ( tiledLayer );
        }
    }
    private void createActorsForLayer ( TiledMapTileLayer tiledLayer ) {
        for ( int x = 0; x < tiledLayer.getWidth(); x++ ) {
            for ( int y = 0; y < tiledLayer.getHeight(); y++ ) {
                TiledMapTileLayer.Cell cell = tiledLayer.getCell ( x, y );
                TiledMapActor actor = new TiledMapActor ( tiledMap, tiledLayer, cell );
                actor.setBounds ( x * tiledLayer.getTileWidth(), y * tiledLayer.getTileHeight(), tiledLayer.getTileWidth(),
                                  tiledLayer.getTileHeight() );
                addActor ( actor );
                EventListener eventListener = new TiledMapClickListener ( actor );
                actor.addListener ( eventListener );
            }
        }
    }
}
