private void sendMessage ( BluetoothGattCharacteristic characteristic, String CHARACTERS ) {
    byte[] initial_packet = new byte[3];
    initial_packet[0] = BLE.INITIAL_MESSAGE_PACKET;
    if ( Long.valueOf (
                String.valueOf ( CHARACTERS.length() + initial_packet.length ) )
            > BLE.DEFAULT_BYTES_VIA_BLE ) {
        sendingContinuePacket ( characteristic, initial_packet, CHARACTERS );
    } else {
        sendingLastPacket ( characteristic, initial_packet, CHARACTERS );
    }
}
private void sendingContinuePacket ( BluetoothGattCharacteristic characteristic,
                                     byte[] initial_packet, String CHARACTERS ) {
    int times = Byte.valueOf ( String.valueOf (
                                   CHARACTERS.length() / BLE.DEFAULT_BYTES_IN_CONTINUE_PACKET ) );
    Log.i ( TAG, "CHARACTERS.length() " + CHARACTERS.length() );
    Log.i ( TAG, "times " + times );
    byte[] sending_continue_hex = new byte[BLE.DEFAULT_BYTES_IN_CONTINUE_PACKET];
    for ( int time = 0; time <= times; time++ ) {
        try {
            Thread.sleep ( 200 );
        } catch ( InterruptedException e ) {
            e.printStackTrace();
        }
        if ( time == times ) {
            Log.i ( TAG, "LAST PACKET " );
            int character_length = CHARACTERS.length()
                                   - BLE.DEFAULT_BYTES_IN_CONTINUE_PACKET * times;
            initial_packet[1] = Byte.valueOf ( String.valueOf ( character_length
                                               + BLE.INITIAL_MESSAGE_PACKET_LENGTH ) );
            initial_packet[2] = BLE.SENDING_LAST_PACKET;
            Log.i ( TAG, "character_length " + character_length );
            byte[] sending_last_hex = new byte[character_length];
            for ( int i = 0; i < sending_last_hex.length; i++ ) {
                sending_last_hex[i] =
                    CHARACTERS.getBytes() [sending_continue_hex.length * time + i];
            }
            byte[] last_packet =
                new byte[character_length + BLE.INITIAL_MESSAGE_PACKET_LENGTH];
            System.arraycopy ( initial_packet, 0, last_packet,
                               0, initial_packet.length );
            System.arraycopy ( sending_last_hex, 0, last_packet,
                               initial_packet.length, sending_last_hex.length );
            characteristic.setValue ( last_packet );
        } else {
            Log.i ( TAG, "CONTINUE PACKET " );
            int character_length = sending_continue_hex.length;
            initial_packet[1] = Byte.valueOf ( String.valueOf (
                                                   character_length + BLE.INITIAL_MESSAGE_PACKET_LENGTH ) );
            initial_packet[2] = BLE.SENDING_CONTINUE_PACKET;
            for ( int i = 0; i < sending_continue_hex.length; i++ ) {
                Log.i ( TAG, "Send stt : "
                        + ( sending_continue_hex.length * time + i ) );
                sending_continue_hex[i] =
                    CHARACTERS.getBytes() [sending_continue_hex.length * time + i];
            }
            byte[] sending_continue_packet =
                new byte[character_length + BLE.INITIAL_MESSAGE_PACKET_LENGTH];
            System.arraycopy ( initial_packet, 0, sending_continue_packet,
                               0, initial_packet.length );
            System.arraycopy ( sending_continue_hex, 0, sending_continue_packet,
                               initial_packet.length, sending_continue_hex.length );
            characteristic.setValue ( sending_continue_packet );
        }
        mBluetoothGatt.writeCharacteristic ( characteristic );
    }
}
public boolean writeCharacteristic ( BluetoothGattCharacteristic characteristic,
                                     String data ) {
    if ( mBluetoothAdapter == null || mBluetoothGatt == null ) {
        Log.w ( TAG, "BluetoothAdapter not initialized" );
        return false;
    }
    if ( ActivityBLEController.IS_FIRST_TIME ) {
        byte[] merge_title = sendTitle ( data );
        characteristic.setValue ( merge_title );
        mBluetoothGatt.writeCharacteristic ( characteristic );
        ActivityBLEController.IS_FIRST_TIME = false;
        return true;
    } else {
        if ( data.length() <= BLE.LIMIT_CHARACTERS ) {
            sendMessage ( characteristic, data );
            ActivityBLEController.IS_FIRST_TIME = true;
            return true;
        } else {
            typed_character = data.length();
            return false;
        }
    }
}
