package org.sba.robotsend;
import java.awt.AWTException;
import java.awt.Robot;
import java.awt.event.KeyEvent;
import java.nio.ByteBuffer;
import java.nio.charset.Charset;
public class RobotSend {
    private Robot robot;
    private Charset cp850;
    private static final int[] keys = { KeyEvent.VK_NUMPAD0, KeyEvent.VK_NUMPAD1,
                                        KeyEvent.VK_NUMPAD2, KeyEvent.VK_NUMPAD3, KeyEvent.VK_NUMPAD4,
                                        KeyEvent.VK_NUMPAD5, KeyEvent.VK_NUMPAD6, KeyEvent.VK_NUMPAD7,
                                        KeyEvent.VK_NUMPAD8, KeyEvent.VK_NUMPAD9
                                      };
    public static void main ( String[] args ) {
        RobotSend robot = new RobotSend();
        try {
            robot.run ( args );
        } catch ( Exception e ) {
            e.printStackTrace();
        }
    }
    public void run ( String[] args ) throws AWTException {
        robot = new Robot();
        cp850 = Charset.forName ( "IBM850" );
        for ( String str : args ) {
            sendString ( str );
        }
    }
    public void sendByte ( byte c ) {
        int i = ( int ) c;
        if ( i < 0 ) {
            i = 256 + i;
        }
        if ( i < 0  || i > 255 ) {
            i = 'X';
        }
        int i1 = i / 100;
        int i2 = ( i % 100 ) / 10;
        int i3 = i % 10;
        robot.keyPress ( KeyEvent.VK_ALT );
        robot.keyPress ( keys[i1] );
        robot.keyRelease ( keys[i1] );
        robot.keyPress ( keys[i2] );
        robot.keyRelease ( keys[i2] );
        robot.keyPress ( keys[i3] );
        robot.keyRelease ( keys[i3] );
        robot.keyRelease ( KeyEvent.VK_ALT );
    }
    public void sendEnter() {
        robot.keyPress ( KeyEvent.VK_ENTER );
        robot.keyRelease ( KeyEvent.VK_ENTER );
    }
    public void sendString ( String str ) {
        ByteBuffer buf = cp850.encode ( str );
        for ( byte b : buf.array() ) {
            sendByte ( b );
        }
        sendEnter();
    }
}
