@Configuration
@EnableWebMvcSecurity
public class WebSecurityConfig extends WebSecurityConfigurerAdapter {
    @Autowired
    private YourSpecificProvider provider;
    @Override
    protected void configure ( HttpSecurity http ) throws Exception {
        http
        .authorizeRequests()
        .antMatchers ( "/css/**", "/js/**", "/fonts/**", "/images/**" ).permitAll()
        .anyRequest().authenticated();
        http
        .formLogin()
        .loginPage ( "/login" )
        .permitAll()
        .and()
        .logout()
        .logoutUrl ( "/logout" )
        .logoutSuccessUrl ( "/login" );
    }
    @Override
    protected void configure ( AuthenticationManagerBuilder auth ) throws Exception {
        auth.authenticationProvider ( provider );
    }
}
