public class AdvancePreferenceExample extends PreferenceActivity implements OnSharedPreferenceChangeListener {
    private static final String KEY_EDIT_TEXT_PREFERENCE = "name";
    @Override
    protected void onCreate ( Bundle savedInstanceState ) {
        super.onCreate ( savedInstanceState );
        addPreferencesFromResource ( R.xml.settings );
    }
    @Override
    protected void onResume() {
        super.onResume();
        getPreferenceScreen().getSharedPreferences()
        .registerOnSharedPreferenceChangeListener ( this );
        updatePreference ( KEY_EDIT_TEXT_PREFERENCE );
    }
    @Override
    protected void onPause() {
        super.onPause();
        getPreferenceScreen().getSharedPreferences()
        .unregisterOnSharedPreferenceChangeListener ( this );
    }
    @Override
    public void onSharedPreferenceChanged ( SharedPreferences sharedPreferences,
                                            String key ) {
        updatePreference ( key );
    }
    private void updatePreference ( String key ) {
        if ( key.equals ( KEY_EDIT_TEXT_PREFERENCE ) ) {
            Preference preference = findPreference ( key );
            if ( preference instanceof EditTextPreference ) {
                EditTextPreference editTextPreference = ( EditTextPreference ) preference;
                if ( editTextPreference.getText().trim().length() > 0 ) {
                    editTextPreference.setSummary ( "Entered Name is  " + editTextPreference.getText() );
                } else {
                    editTextPreference.setSummary ( "Enter Your Name" );
                }
            }
        }
    }
}
