import java.util.concurrent.locks.ReentrantLock;
public class MyClass {
    private volatile MyObject completedResults;
    private final ReentrantLock resultsLock;
    private final ReentrantLock refreshLock;
    public MyClass() {
        resultsLock = new ReentrantLock();
        refreshLock = new ReentrantLock();
    }
    public MyObject myMethodToRequestResults ( boolean refresh ) {
        MyObject resultsToReturn;
        resultsLock.lock();
        try {
            if ( completedResults == null ) {
                completedResults = generateResults();
                refresh = false;
            }
            resultsToReturn = completedResults;
        } finally {
            resultsLock.unlock();
        }
        if ( refresh ) {
            if ( !refreshLock.tryLock() ) {
                resultsToReturn = new MyObject ( resultsToReturn );
                resultsToReturn.setSomeoneElseIsRegeneratingTheStuffRightNow ( true );
            } else {
                try {
                    completedResults = generateResults();
                    resultsToReturn = completedResults;
                } finally {
                    refreshLock.unlock();
                }
            }
        }
        return resultsToReturn;
    }
}
