private class CustomListAdapter extends ArrayAdapter {
    private Context mContext;
    private int id;
    private List <String>items ;
    public CustomListAdapter ( Context context, int textViewResourceId , List<String> list ) {
        super ( context, textViewResourceId, list );
        mContext = context;
        id = textViewResourceId;
        items = list ;
    }
    @Override
    public View getView ( int position, View v, ViewGroup parent ) {
        View mView = v ;
        if ( mView == null ) {
            LayoutInflater vi = ( LayoutInflater ) mContext.getSystemService ( Context.LAYOUT_INFLATER_SERVICE );
            mView = vi.inflate ( id, null );
        }
        TextView text = ( TextView ) mView.findViewById ( R.id.textView );
        if ( items.get ( position ) != null ) {
            text.setTextColor ( Color.WHITE );
            text.setText ( items.get ( position ) );
            text.setBackgroundColor ( Color.RED );
            int color = Color.argb ( 200, 255, 64, 64 );
            text.setBackgroundColor ( color );
        }
        return mView;
    }
}
