@Root ( name = "Envelope" )
@Namespace ( prefix = "soap" )
@Convert ( value = SOAPEnvelope.SOAPEnvelopeConverter.class )
public class SOAPEnvelope {
    private Vehicles vehicles;
    public Vehicles getVehicles() {
        return vehicles;
    }
    protected void setVehicles ( Vehicles vehicles ) {
        this.vehicles = vehicles;
    }
    public static class SOAPEnvelopeConverter implements Converter<SOAPEnvelope> {
        @Override
        public SOAPEnvelope read ( InputNode node ) throws Exception {
            SOAPEnvelope envelope = new SOAPEnvelope();
            InputNode vehiclesNode = findVehiclesNode ( node );
            if ( vehiclesNode == null ) {
                throw new Exception ( "No vehicles node!" );
            }
            Serializer ser = new Persister();
            envelope.setVehicles ( ser.read ( Vehicles.class, vehiclesNode ) );
            return envelope;
        }
        @Override
        public void write ( OutputNode node, SOAPEnvelope value ) throws Exception {
            throw new UnsupportedOperationException ( "Not supported yet." );
        }
        private InputNode findVehiclesNode ( InputNode rootNode ) throws Exception {
            InputNode body = rootNode.getNext ( "Body" );
            InputNode buslocationResponse = body.getNext ( "BuslocationResponse" );
            InputNode next;
            while ( ( next = buslocationResponse.getNext() ) != null ) {
                if ( next.getName().equals ( "Vehicles" ) == true ) {
                    return next;
                }
            }
            return null;
        }
    }
}
