import javax.swing.JApplet;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.RowFilter;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.table.TableModel;
import javax.swing.table.TableRowSorter;
public class TestTableSorterFilter extends JApplet {
    private String[] columnNames
        = {"Country", "Capital", "Population in Millions", "Democracy"};
    private Object[][] data = {
        {"USA", "Washington DC", 280, true},
        {"Canada", "Ottawa", 32, true},
        {"United Kingdom", "London", 60, true},
        {"Germany", "Berlin", 83, true},
        {"France", "Paris", 60, true},
        {"Norway", "Oslo", 4.5, true},
        {"India", "New Delhi", 1046, true}
    };
    private JTable jTable = new JTable ( data, columnNames );
    private TableRowSorter<TableModel> rowSorter
        = new TableRowSorter<> ( jTable.getModel() );
    private JTextField jtfFilter = new JTextField();
    private JButton jbtFilter = new JButton ( "Filter" );
    public TestTableSorterFilter() {
        jTable.setRowSorter ( rowSorter );
        JPanel panel = new JPanel ( new BorderLayout() );
        panel.add ( new JLabel ( "Specify a word to match:" ),
                    BorderLayout.WEST );
        panel.add ( jtfFilter, BorderLayout.CENTER );
        add ( panel, BorderLayout.SOUTH );
        add ( new JScrollPane ( jTable ), BorderLayout.CENTER );
        jtfFilter.getDocument().addDocumentListener ( new DocumentListener() {
            @Override
            public void changedUpdate ( DocumentEvent arg0 ) {}
            @Override
            public void insertUpdate ( DocumentEvent arg0 ) {
                String text = jtfFilter.getText();
                if ( text.trim().length() == 0 ) {
                    rowSorter.setRowFilter ( null );
                } else {
                    rowSorter.setRowFilter ( RowFilter.regexFilter ( text ) );
                }
            }
            @Override
            public void removeUpdate ( DocumentEvent arg0 ) {
                String text = jtfFilter.getText();
                if ( text.trim().length() == 0 ) {
                    rowSorter.setRowFilter ( null );
                } else {
                    rowSorter.setRowFilter ( RowFilter.regexFilter ( text ) );
                }
            }
        } );
    }
}
