package com.example.freejeetoproject;
import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.Arrays;
import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import com.facebook.Request;
import com.facebook.Response;
import com.facebook.Session;
import com.facebook.SessionState;
import com.facebook.UiLifecycleHelper;
import com.facebook.model.GraphUser;
import com.facebook.widget.LoginButton;
import android.annotation.SuppressLint;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.net.ParseException;
import android.os.Bundle;
import android.os.StrictMode;
import android.support.v4.app.Fragment;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
public class MainFragment extends Fragment {
    private static final String TAG = "MainFragment";
    private UiLifecycleHelper uiHelper;
    private static final int REAUTH_ACTIVITY_CODE = 100;
    Context context;
    @Override
    public View onCreateView ( LayoutInflater inflater,
                               ViewGroup container,
                               Bundle savedInstanceState ) {
        View view = inflater.inflate ( R.layout.activity_mainlogin, container, false );
        Button authButton = ( Button ) view.findViewById ( R.id.authButton );
        ( ( LoginButton ) authButton ).setFragment ( this );
        ( ( LoginButton ) authButton ).setReadPermissions ( Arrays.asList ( "email" ) );
        return view;
    }
    private Session.StatusCallback callback = new Session.StatusCallback() {
        @Override
        public void call ( Session session, SessionState state, Exception exception ) {
            onSessionStateChange ( session, state, exception );
        }
    };
    @SuppressLint ( "NewApi" )
    @Override
    public void onCreate ( Bundle savedInstanceState ) {
        super.onCreate ( savedInstanceState );
        uiHelper = new UiLifecycleHelper ( getActivity(), callback );
        uiHelper.onCreate ( savedInstanceState );
    }
    private void onSessionStateChange ( Session session, SessionState state, Exception exception ) {
    }
    private void makeMeRequest ( final Session session ) {
        Request request = Request.newMeRequest ( session,
        new Request.GraphUserCallback() {
            @Override
            public void onCompleted ( GraphUser user, Response response ) {
                if ( session == Session.getActiveSession() ) {
                    if ( user != null ) {
                        Log.e ( "name", user.getName() );
                        String email = ( String ) response.getGraphObject().getProperty ( "email" );
                        Log.e ( "email", email );
                        if ( response.getError() != null ) {
                        }
                    }
                } );
                request.executeAsync();
            }
            @Override
            public void onResume() {
                super.onResume();
                uiHelper.onResume();
            }
            @Override
            public void onActivityResult ( int requestCode, int resultCode, Intent data ) {
                super.onActivityResult ( requestCode, resultCode, data );
                uiHelper.onActivityResult ( requestCode, resultCode, data );
                Log.e ( "on", "activityResult" );
            }
            @Override
            public void onPause() {
                super.onPause();
                uiHelper.onPause();
                Log.e ( "on", "pause" );
            }
            @Override
            public void onDestroy() {
                super.onDestroy();
                uiHelper.onDestroy();
                Log.e ( "on", "destroy" );
            }
            @Override
            public void onSaveInstanceState ( Bundle outState ) {
                super.onSaveInstanceState ( outState );
                uiHelper.onSaveInstanceState ( outState );
                Log.e ( "on", "SaveInstaneState" );
            }
        }
