public class Main {
    private static final long FINISH_BY = 10000;
    private static final int START_WITH = 1;
    private static final long DELAY_BETWEEN_PASSES = 50;
    private static volatile int currentResult = 0;
    public static void main ( String[] args ) {
        Thread eversquareThread = new Thread ( new Runnable() {
            @Override public void run() {
                eversquare ( START_WITH, DELAY_BETWEEN_PASSES );
            }
        } );
        eversquareThread.setDaemon ( true );
        eversquareThread.start();
        long currentTime = System.currentTimeMillis();
        final long stopTime = currentTime + FINISH_BY;
        while ( currentTime < stopTime ) {
            final long sleepTime = stopTime - currentTime;
            try {
                Thread.sleep ( sleepTime );
            } catch ( InterruptedException ex ) {
            }
            currentTime = System.currentTimeMillis();
        }
        System.out.println ( currentResult );
    }
    private static void eversquare ( final int startValue, final long delay ) {
        int currentValue = startValue;
        while ( true ) {
            currentResult = square ( currentValue );
            currentValue++;
            if ( delay > 0 ) {
                try {
                    Thread.sleep ( delay );
                } catch ( InterruptedException ex ) {
                    ex.printStackTrace();
                }
            }
        }
    }
    private static int square ( int x ) {
        return x * x;
    }
}
