@Test
public void nominalClose() {
    Closeable closeable = new MyCloseable();
    Assert.assertFalse ( closeable.isClosed() );
    MyClass.close ( closeable );
    Assert.assertTrue ( closeable.isClosed() );
}
@Test ( expected = RuntimeException.class )
public void ioExceptionClose() {
    Closeable closeable = new Closeable() {
        @Override
        public void close() {
            throw new IOException ( "test IO" );
        }
    };
    MyClass.close ( closeable );
}
private static class MyCloseable implements Closeable {
    private closed = false;
    @Overrive
    public void close() {
        closed = true;
    }
    public boolean isClosed() {
        return close;
    }
}
