package hello;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.EnableAutoConfiguration;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.Import;
import org.springframework.data.jpa.repository.config.EnableJpaRepositories;
import org.springframework.data.rest.core.event.ValidatingRepositoryEventListener;
import org.springframework.data.rest.webmvc.config.RepositoryRestMvcConfiguration;
@Configuration
@EnableJpaRepositories
@Import ( RepositoryRestMvcConfiguration.class )
@EnableAutoConfiguration
public class Application extends RepositoryRestMvcConfiguration {
    public static void main ( String[] args ) {
        SpringApplication.run ( Application.class, args );
    }
    @Override
    protected void configureValidatingRepositoryEventListener ( ValidatingRepositoryEventListener validatingListener ) {
        validatingListener.addValidator ( "beforeCreate", new PeopleValidator() );
    }
}
