import javafx.animation.PauseTransition;
import javafx.application.*;
import javafx.geometry.Insets;
import javafx.scene.Scene;
import javafx.scene.control.Label;
import javafx.stage.Stage;
import javafx.util.Duration;
import java.util.*;
public class Wumpus extends Application {
    private static final Insets SAFETY_ZONE = new Insets ( 10 );
    private Label cowerInFear = new Label();
    private Stage mainStage;
    @Override
    public void start ( final Stage stage ) {
        mainStage = stage;
        mainStage.setAlwaysOnTop ( true );
        Platform.setImplicitExit ( false );
        Timer timer = new Timer();
        timer.schedule ( new WumpusAttack(), 0, 5_000 );
        cowerInFear.setPadding ( SAFETY_ZONE );
        cowerInFear.textProperty().addListener ( ( observable, oldValue, newValue ) -> {
            PauseTransition pause = new PauseTransition (
                Duration.seconds ( 2 )
            );
            pause.setOnFinished ( event -> stage.hide() );
            pause.play();
        } );
        cowerInFear.setOnMouseClicked ( event -> {
            timer.cancel();
            Platform.exit();
        } );
        stage.setScene ( new Scene ( cowerInFear ) );
    }
    public class WumpusAttack extends TimerTask {
        private String[] attacks = {
            "hugs you",
            "reads you a bedtime story",
            "sings you a lullaby",
            "puts you to sleep"
        };
        private Random random = new Random ( 42 );
        @Override
        public void run() {
            Platform.runLater ( () -> {
                cowerInFear.setText ( "The Wumpus " + nextAttack() + "!" );
                mainStage.sizeToScene();
                mainStage.show();
            } );
        }
        private String nextAttack() {
            return attacks[random.nextInt ( attacks.length )];
        }
    }
    public static void main ( String[] args ) {
        launch ( args );
    }
}
