public class MainActivity extends FragmentActivity implements LocationListener {
    GoogleMap googleMap;
    @Override
    protected void onCreate ( Bundle savedInstanceState ) {
        super.onCreate ( savedInstanceState );
        setContentView ( R.layout.activity_main );
        int status = GooglePlayServicesUtil.isGooglePlayServicesAvailable ( getBaseContext() );
        if ( status != ConnectionResult.SUCCESS ) {
            int requestCode = 10;
            Dialog dialog = GooglePlayServicesUtil.getErrorDialog ( status, this, requestCode );
            dialog.show();
        } else {
            SupportMapFragment fm = ( SupportMapFragment ) getSupportFragmentManager().findFragmentById ( R.id.map );
            googleMap = fm.getMap();
            googleMap.setMyLocationEnabled ( true );
            LocationManager locationManager = ( LocationManager ) getSystemService ( LOCATION_SERVICE );
            Criteria criteria = new Criteria();
            String provider = locationManager.getBestProvider ( criteria, true );
            Location location = locationManager.getLastKnownLocation ( provider );
            if ( location != null ) {
                onLocationChanged ( location );
            }
            locationManager.requestLocationUpdates ( provider, 20000, 0, this );
        }
    }
    @Override
    public void onLocationChanged ( Location location ) {
        TextView tvLocation = ( TextView ) findViewById ( R.id.tv_location );
        double latitude = location.getLatitude();
        double longitude = location.getLongitude();
        LatLng latLng = new LatLng ( latitude, longitude );
        googleMap.moveCamera ( CameraUpdateFactory.newLatLng ( latLng ) );
        googleMap.animateCamera ( CameraUpdateFactory.zoomTo ( 15 ) );
        tvLocation.setText ( "Latitude:" +  latitude  + ", Longitude:" + longitude );
    }
    @Override
    public void onProviderDisabled ( String provider ) {
    }
    @Override
    public void onProviderEnabled ( String provider ) {
    }
    @Override
    public void onStatusChanged ( String provider, int status, Bundle extras ) {
    }
    @Override
    public boolean onCreateOptionsMenu ( Menu menu ) {
        getMenuInflater().inflate ( R.menu.activity_main, menu );
        return true;
    }
}
