private static boolean shouldBroadcastSafe (
    Location loc, Location lastLoc, UpdateRecord record, long now ) {
    if ( lastLoc == null ) {
        return true;
    }
    long minTime = record.mRequest.getFastestInterval();
    long delta = ( loc.getElapsedRealtimeNanos() - lastLoc.getElapsedRealtimeNanos() )
                 / NANOS_PER_MILLI;
    if ( delta < minTime - MAX_PROVIDER_SCHEDULING_JITTER_MS ) {
        return false;
    }
    double minDistance = record.mRequest.getSmallestDisplacement();
    if ( minDistance > 0.0 ) {
        if ( loc.distanceTo ( lastLoc ) <= minDistance ) {
            return false;
        }
    }
    ...
