package com.ds.listviewtest;
import android.app.ListActivity;
import android.content.Context;
import android.database.DataSetObserver;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.ListAdapter;
import android.widget.TextView;
public class MainActivity extends ListActivity {
    static final String[] FRUITS = new String[] {
        "Apple", "Avocado", "Banana",
        "Blueberry", "Coconut", "Durian", "Guava", "Kiwifruit",
        "Jackfruit", "Mango", "Olive", "Pear", "Sugar-apple"
    };
    @Override
    protected void onCreate ( Bundle savedInstanceState ) {
        super.onCreate ( savedInstanceState );
        setListAdapter ( new SimpleAdapter ( FRUITS ) );
        setContentView ( R.layout.activity_main );
    }
    private class SimpleAdapter implements ListAdapter {
        String[] items;
        public SimpleAdapter ( String[] items ) {
            this.items = items;
        }
        @Override
        public void registerDataSetObserver ( DataSetObserver observer ) {
        }
        @Override
        public void unregisterDataSetObserver ( DataSetObserver observer ) {
        }
        @Override
        public int getCount() {
            return items.length;
        }
        @Override
        public Object getItem ( int position ) {
            return items[position];
        }
        @Override
        public long getItemId ( int position ) {
            return position;
        }
        @Override
        public boolean hasStableIds() {
            return false;
        }
        @Override
        public View getView ( int position, View convertView, ViewGroup parent ) {
            LayoutInflater inflater = ( LayoutInflater ) getApplicationContext().getSystemService (
                                          Context.LAYOUT_INFLATER_SERVICE );
            View rowView = inflater.inflate ( R.layout.list_item, parent, false );
            TextView textView = ( TextView ) rowView.findViewById ( R.id.comment );
            textView.setText ( items[position] );
            return rowView;
        }
        @Override
        public int getItemViewType ( int position ) {
            return 0;
        }
        @Override
        public int getViewTypeCount() {
            return 1;
        }
        @Override
        public boolean isEmpty() {
            return false;
        }
        @Override
        public boolean areAllItemsEnabled() {
            return true;
        }
        @Override
        public boolean isEnabled ( int position ) {
            return true;
        }
    }
}
