private class MyListAdapter implements ListAdapter {
    @Override
    public View getView ( int position, View convertView, ViewGroup parent ) {
        if ( convertView != null ) {
            CheckedTextView textView = ( CheckedTextView ) convertView;
            textView.setText ( "the text for item " + position );
            textView.setTextColor ( makeColorStateListForItem ( position ) );
            return textView;
        } else {
            CheckedTextView textView = new CheckedTextView ( parent.getContext() );
            textView.setText ( "the text for item " + position );
            textView.setTextColor ( makeColorStateListForItem ( position ) );
            return textView;
        }
    }
    private ColorStateList makeColorStateListForItem ( int position ) {
        int pressedColor = pressedColorForItem ( position );
        int checkedColor = checkedColorForItem ( position );
        int defaultColor = defaultColorForItem ( position );
        ColorStateList colorStateList = new ColorStateList (
            new int[][] {
                new int[]{android.R.attr.state_pressed},
                new int[]{android.R.attr.state_checked},
                new int[]{0},
            },
            new int[] {
                pressedColor,
                checkedColor,
                defaultColor
            } );
    }
    private int pressedColorForItem ( int position ) {
        return ...;
    }
    private int checkedColorForItem ( int position ) {
        return ...;
    }
    private int defaultColorForItem ( int position ) {
        return Color.WHITE;
    }
