public class TransferHelper extends TransferHandler {
    private static final long serialVersionUID = 1L;
    public TransferHelper() {
    }
    @Override
    public int getSourceActions ( JComponent c ) {
        return MOVE;
    }
    @Override
    protected Transferable createTransferable ( JComponent source ) {
        JTable table = ( JTable ) source;
        return new CellDataTransferable ( new CellData ( table ) );
    }
    @Override
    protected void exportDone ( JComponent source, Transferable data, int action ) {
    }
    @Override
    public boolean canImport ( TransferSupport support ) {
        boolean canImport = false;
        Component comp = support.getComponent();
        if ( comp instanceof JTable ) {
            JTable table = ( JTable ) comp;
            DropLocation dl = support.getDropLocation();
            Point dp = dl.getDropPoint();
            int dragColumn = table.columnAtPoint ( dp );
            try {
                Transferable t = support.getTransferable();
                CellData cd = ( CellData ) t.getTransferData ( CellDataTransferable.CELL_DATA_FLAVOR );
                if ( cd.getTable() != table ) {
                    if ( dragColumn == cd.getColumn() ) {
                        canImport = true;
                    }
                }
            } catch ( UnsupportedFlavorException | IOException ex ) {
                ex.printStackTrace();
            }
        }
        return canImport;
    }
    @Override
    public boolean importData ( TransferSupport support ) {
        boolean imported = false;
        Component comp = support.getComponent();
        if ( comp instanceof JTable ) {
            JTable target = ( JTable ) comp;
            DropLocation dl = support.getDropLocation();
            Point dp = dl.getDropPoint();
            int dropCol = target.columnAtPoint ( dp );
            int dropRow = target.rowAtPoint ( dp );
            try {
                Transferable t = support.getTransferable();
                CellData cd = ( CellData ) t.getTransferData ( CellDataTransferable.CELL_DATA_FLAVOR );
                if ( cd.getTable() != target ) {
                    if ( dropCol == cd.getColumn() ) {
                        String exportValue = ( String ) target.getValueAt ( dropRow, dropCol );
                        String importValue = cd.getValue();
                        target.setValueAt ( importValue, dropRow, dropCol );
                        JTable source = cd.getTable();
                        int row = source.getSelectedRow();
                        int col = source.getSelectedColumn();
                        source.setValueAt ( exportValue, row, col );
                        imported = true;
                    }
                }
            } catch ( UnsupportedFlavorException | IOException ex ) {
                ex.printStackTrace();
            }
        }
        return imported;
    }
}
