public static Bitmap drawableToBitmap ( Drawable drawable ) {
    if ( drawable instanceof BitmapDrawable ) {
        return ( ( BitmapDrawable ) drawable ).getBitmap();
    }
    Bitmap bitmap = Bitmap.createBitmap ( drawable.getIntrinsicWidth(), drawable.getIntrinsicHeight(), Config.ARGB_8888 );
    Canvas canvas = new Canvas ( bitmap );
    drawable.setBounds ( 0, 0, canvas.getWidth(), canvas.getHeight() );
    drawable.draw ( canvas );
    return bitmap;
}
