protected void parseSessionCookiesId ( org.apache.coyote.Request req, Request request ) {
    Context context = ( Context ) request.getMappingData().context;
    if ( context != null && !context.getServletContext()
            .getEffectiveSessionTrackingModes().contains (
                SessionTrackingMode.COOKIE ) ) {
        return;
    }
    Cookies serverCookies = req.getCookies();
    int count = serverCookies.getCookieCount();
    if ( count <= 0 ) {
        return;
    }
    String sessionCookieName = SessionConfig.getSessionCookieName ( context );
    for ( int i = 0; i < count; i++ ) {
        ServerCookie scookie = serverCookies.getCookie ( i );
        if ( scookie.getName().equals ( sessionCookieName ) ) {
            if ( !request.isRequestedSessionIdFromCookie() ) {
                convertMB ( scookie.getValue() );
                request.setRequestedSessionId
                ( scookie.getValue().toString() );
                request.setRequestedSessionCookie ( true );
                request.setRequestedSessionURL ( false );
                if ( log.isDebugEnabled() ) {
                    log.debug ( " Requested cookie session id is " +
                                request.getRequestedSessionId() );
                }
            } else {
                if ( !request.isRequestedSessionIdValid() ) {
                    convertMB ( scookie.getValue() );
                    request.setRequestedSessionId
                    ( scookie.getValue().toString() );
                }
            }
        }
    }
}
