@Configuration
@EnableWebSecurity
public class SecurityConfig extends WebSecurityConfigurerAdapter {
    @Autowired
    private DataSource dataSource;
    @Override
    protected void configure ( HttpSecurity http ) throws Exception {
        http
        .authorizeRequests()
        .antMatchers ( "/", "/home" ).permitAll()
        .anyRequest().authenticated();
        http
        .formLogin()
        .loginPage ( "/login" )
        .permitAll()
        .and()
        .logout()
        .permitAll();
    }
    @Override
    protected void registerAuthentication ( AuthenticationManagerBuilder auth ) throws Exception {
        auth
        .jdbcAuthentication()
        .dataSource ( dataSource )
        .withUser ( "user" ).password ( "password" ).roles ( "USER" ).and()
        .withUser ( "admin" ).password ( "password" ).roles ( "USER", "ADMIN" ).and()
        .withDefaultSchema();
    }
