BufferedImage createResizedCopy ( Image originalImage,
                                  int scaledWidth, int scaledHeight,
                                  boolean preserveAlpha ) {
    System.out.println ( "resizing..." );
    int imageType = preserveAlpha ? BufferedImage.TYPE_INT_RGB : BufferedImage.TYPE_INT_ARGB;
    BufferedImage scaledBI = new BufferedImage ( scaledWidth, scaledHeight, imageType );
    Graphics2D g = scaledBI.createGraphics();
    if ( preserveAlpha ) {
        g.setComposite ( AlphaComposite.Src );
    }
    g.drawImage ( originalImage, 0, 0, scaledWidth, scaledHeight, null );
    g.dispose();
    return scaledBI;
}
