public class Mapper  {
    public static void main ( String[] args ) throws ParseException {
        SimpleDateFormat dateFormat = new SimpleDateFormat ( "dd-M-yyyy hh:mm:ss" );
        String dateOfDeparture = "31-08-1982 10:20:56";
        String dateOfArrival = "31-08-1983 10:20:56";
        Date date1 = dateFormat.parse ( dateOfDeparture );
        Date date2 = dateFormat.parse ( dateOfArrival );
        OrikaMapFrom objectMapFrom  = new OrikaMapFrom();
        OrikaMapTo objectMapTo = new OrikaMapTo();
        objectMapFrom.setSource ( "Delhi" );
        objectMapFrom.setDestination ( "Amsterdam" );
        objectMapFrom.setDateOfDeparture ( date1 );
        objectMapFrom.setDateOfArrival ( date2 );
        MapperFactory mapperFactory = new DefaultMapperFactory.Builder().build();
        mapperFactory.classMap ( OrikaMapFrom.class, OrikaMapTo.class )
        .field ( "source", "sourcePlace" )
        .field ( "destination", "destinationPlace" )
        .customize ( new CustomMapper<OrikaMapFrom, OrikaMapTo>() {
            public void mapAtoB ( OrikaMapFrom a, OrikaMapTo b ) {
                long diff = a.getDateOfArrival().getTime() - a.getDateOfDeparture().getTime();
                b.setTravelDuration ( ( int ) TimeUnit.DAYS.convert ( diff, TimeUnit.MILLISECONDS ) );
            }
        } )
        .register();
        MapperFacade mapper = mapperFactory.getMapperFacade();
        objectMapTo = mapper.map ( objectMapFrom, OrikaMapTo.class );
        objectMapTo.setTravelDuration ( noOfDays );
        System.out.println ( objectMapTo.getSourcePlace() );
        System.out.println ( objectMapTo.getDestinationPlace() );
        System.exit ( 0 );
    }
}
