public static void writePointsToFile ( List<Vector> points,
                                       String fileName,
                                       FileSystem fs,
                                       Configuration conf ) throws IOException {
    Path path = new Path ( fileName );
    SequenceFile.Writer writer = new SequenceFile.Writer ( fs, conf,
            path, LongWritable.class, VectorWritable.class );
    long recNum = 0;
    VectorWritable vec = new VectorWritable();
    for ( Vector point : points ) {
        vec.set ( point );
        writer.append ( new LongWritable ( recNum++ ), vec );
    }
    writer.close();
}
