public class CommonElements {
    private int comparisons = 0;
    public <T extends Comparable> List<T> findCommonElements ( T[][] arrays ) {
        final List<T> commonElements = new ArrayList<>();
        T[] shortestArray = null;
        for ( T[] array : arrays ) {
            if ( shortestArray == null || array.length < shortestArray.length ) {
                shortestArray = array;
            }
        }
        if ( shortestArray == null ) {
            return Collections.emptyList();
        }
        for ( T element : shortestArray ) {
            boolean common = true;
            for ( T[] array : arrays ) {
                if ( array == shortestArray ) {
                    continue;
                }
                boolean found = false;
                for ( int j = 0; j < array.length; ++j ) {
                    final T compareElement = array[j];
                    if ( compareElement != null ) {
                        comparisons++;
                        if ( compareElement.equals ( element ) ) {
                            array[j] = null;
                            found = true;
                            break;
                        }
                    }
                }
                common = found;
                if ( !found ) {
                    break;
                }
            }
            if ( common ) {
                commonElements.add ( element );
            }
        }
        return commonElements;
    }
    public int getComparisons() {
        return comparisons;
    }
    public void setComparisons ( int comparisons ) {
        this.comparisons = comparisons;
    }
    public void test1() {
        Comparable[] items1 = {'a', 'b', 'c', 'd', 'e', 'f'};
        Comparable[] items2 = {'d', 'e', 'f', 'g', 'h', 'i'};
        Comparable[] items3 = {'a', 'c', 'e', 'g', 'i', 'k'};
        Comparable[][] collection = {items1, items2, items3};
        List<Comparable> result = findCommonElements ( collection );
        System.out.println ( "Test 1" );
        System.out.println ( getComparisons() );
        System.out.println ( result );
        System.out.println();
    }
    public void test2() {
        Comparable[] items1 = {'a', 'b', 'c', 'd', 'e', 'f'};
        Comparable[] items2 = {'d', 'e', 'f', 'g', 'h'};
        Comparable[] items3 = {'a', 'c', 'e', 'g'};
        Comparable[][] collection = {items1, items2, items3};
        List<Comparable> result = findCommonElements ( collection );
        System.out.println ( "Test 2" );
        System.out.println ( getComparisons() );
        System.out.println ( result );
        System.out.println();
    }
    public void test3() {
        Comparable[] items1 = {'a', 'b', 'c', 'd'};
        Comparable[] items2 = {'d', 'e', 'f', 'g', 'h'};
        Comparable[] items3 = {'a', 'c', 'e', 'g', 'i', 'k'};
        Comparable[][] collection = {items1, items2, items3};
        List<Comparable> result = findCommonElements ( collection );
        System.out.println ( "Test 3" );
        System.out.println ( getComparisons() );
        System.out.println ( result );
        System.out.println();
    }
    public static void main ( String[] args ) {
        new CommonElements().test1();
        new CommonElements().test2();
        new CommonElements().test3();
    }
}
