import java.util.regex.*;
public abstract class Rewriter {
    private Pattern pattern;
    private Matcher matcher;
    public Rewriter ( String regex ) {
        this.pattern = Pattern.compile ( regex );
    }
    public String group ( int i ) {
        return matcher.group ( i );
    }
    public abstract String replacement();
    public String rewrite ( CharSequence original ) {
        this.matcher = pattern.matcher ( original );
        StringBuffer result = new StringBuffer ( original.length() );
        while ( matcher.find() ) {
            matcher.appendReplacement ( result, "" );
            result.append ( replacement() );
        }
        matcher.appendTail ( result );
        return result.toString();
    }
    public static void main ( String... args ) throws Exception {
        String str = ">Foo baR<";
        Rewriter caseSwapper = new Rewriter ( "[A-Za-z]" ) {
            public String replacement() {
                char ch0 = group ( 0 ).charAt ( 0 );
                char ch1 = Character.isUpperCase ( ch0 ) ?
                           Character.toLowerCase ( ch0 ) :
                           Character.toUpperCase ( ch0 );
                return String.valueOf ( ch1 );
            }
        };
        System.out.println ( caseSwapper.rewrite ( str ) );
        System.out.println ( new Rewriter ( ">(\\w+)|(\\w+)<" ) {
            public String replacement() {
                return group ( 1 ) != null ? group ( 1 ) + "<"
                       : ">" + group ( 2 );
            }
        } .rewrite ( str ) );
    }
}
