public class PositionHolder {
    private int oldPosition;
    private Position position;
    private PropertyChangeSupport propertySupport = new PropertyChangeSupport ( this );
    public PositionHolder ( Position aPos ) {
        position = aPos;
        oldPosition = aPos.getOffset();
    }
    public void addPropertyChangeListener ( PropertyChangeListener aListener ) {
        propertySupport.addPropertyChangeListener ( aListener );
    }
    public void verifyPosition() {
        propertySupport.firePropertyChangeEvent ( "position", oldPosition, position.getOffset() );
        oldPosition = position.getOffset();
    }
    public Position getPosition() {
        return position;
    }
}
public class PositionUpdater implements DocumentListener {
    private List<PositionHolder> holders;
    public PositionUpdater ( List<PositionHolder> someHolders ) {
        holders = someHolders;
    }
    public void insertUpdate ( DocumentEvent e ) {
        for ( PositionHolder h : holders ) {
            h.verifyPosition();
        }
    }
    public void removeUpdate ( DocumentEvent e ) {
        insertUpdate ( e );
    }
    public void changeUpdate ( DocumentEvent e ) {
        insertUpdate ( e );
    }
}
JTextComponent textComp =
    List<PositionHolder> holderList = new ArrayList<>();
textComp.getDocument().addDocumentListener ( new PositionUpdater ( holderList ) );
