public static <T extends Comparable<?>> Set<Range<T>>
getIntersectingRanges ( Range<T> intersects, Iterable<Range<T>> ranges ) {
    ImmutableSet.Builder<Range<T>> builder = ImmutableSet.builder();
    for ( Range<T> r : ranges ) {
        if ( r.isConnected ( intersects ) && !r.intersection ( intersects ).isEmpty() ) {
            builder.add ( r );
        }
    }
    return builder.build();
}
public static Set<Range<Integer>> getIntersectingContinuousRanges ( int[] intersects,
        int[] instances ) {
    Preconditions.checkArgument ( intersects.length == 2 );
    Preconditions.checkArgument ( instances.length >= 2 );
    ImmutableList.Builder<Range<Integer>> builder = ImmutableList.builder();
    for ( int i = 0; i < instances.length - 1; i++ ) {
        builder.add ( Range.closed ( instances[i], instances[i + 1] ) );
    }
    return getIntersectingRanges ( Range.closed ( intersects[0], intersects[1] ),
                                   builder.build() );
}
