@Entity
public class Reporting {
    @Id
    @Column ( name = "file_name", nullable = false )
    private String fileName;
    @Embedded
    private ReportingFile reportingFile;
    @CollectionOfElements ( fetch = FetchType.EAGER )
    @JoinTable (
        name = "t_reports",
        joinColumns = @JoinColumn ( name = "file_name", referencedColumnName = "file_name", insertable = false, updatable = false ) )
    private List<ReportingFile> reports;
    @Embeddable
    public static class ReportingFile implements Serializable {
        @Column ( name = "file_name", insertable = false, updatable = false )
        private String fileName;
        @Column ( name = "xml_content" )
        private Clob xmlContent;
    }
}
