@Entity
public class Reporting {
    @Id
    @Column ( name = "file_name", nullable = false )
    private String fileName;
    @Embedded
    private ReportingFile reportingFile;
    @CollectionOfElements ( fetch = FetchType.EAGER )
    @JoinTable (
        name = "t_reports",
        joinColumns = @JoinColumn ( name = "file_name", referencedColumnName = "file_name" ) )
    private List<Clob> xmlContents;
    @Transient
    public List<ReportingFile> getReports() {
        List<ReportingFile> reports = new ArrayList<ReportingFile>();
        for ( Clob xmlContent : getXmlContents() ) {
            reports.add ( new ReportingFile ( getFileName(), xmlContent ) );
        }
        return reports;
    }
    @Embeddable
    public static class ReportingFile implements Serializable {
        public ReportingFile() {}
        public ReportingFile ( String fileName, Clob xmlContent ) {
            this.fileName = fileName;
            this.xmlContent = xmlContent;
        }
        @Column ( name = "file_name", insertable = false, updatable = false )
        private String fileName;
        @Column ( name = "xml_content" )
        private Clob xmlContent;
    }
}
