import com.artofsolving.jodconverter.DocumentConverter;
import com.artofsolving.jodconverter.openoffice.connection.OpenOfficeConnection;
import com.artofsolving.jodconverter.openoffice.connection.SocketOpenOfficeConnection;
import com.artofsolving.jodconverter.openoffice.converter.OpenOfficeDocumentConverter;
import java.io.File;
import java.net.ConnectException;
public class JODConv {
    public static void main ( String[] args ) throws ConnectException {
        if ( args.length != 2 ) {
            System.out.println ( "Usage:\nJODConv <file-to-convert> <pdf-file>" );
            System.exit ( 0 );
        }
        String sourceFilePath = args[0];
        String destFilePath = args[1];
        File inputFile = new File ( sourceFilePath );
        File outputFile = new File ( destFilePath );
        OpenOfficeConnection connection = new SocketOpenOfficeConnection ( 8100 );
        connection.connect();
        DocumentConverter converter = new OpenOfficeDocumentConverter ( connection );
        converter.convert ( inputFile, outputFile );
        connection.disconnect();
    }
}
