public class DrawerActivity extends Activity {
    protected ActionBarDrawerToggle mDrawerToggle;
    private String[] navOptions = new String[] {"Collect Offers", "Exclusive", "Glove Box",
            "Servicing", "Dealer", "Settings"
                                               };
    @Override
    protected void onCreate ( Bundle savedInstanceState ) {
        super.onCreate ( savedInstanceState );
    }
    @Override
    protected void onPostCreate ( Bundle savedInstanceState ) {
        super.onPostCreate ( savedInstanceState );
        mDrawerToggle.syncState();
    }
    @Override
    public void onConfigurationChanged ( Configuration newConfig ) {
        super.onConfigurationChanged ( newConfig );
        mDrawerToggle.onConfigurationChanged ( newConfig );
    }
    @Override
    public boolean onOptionsItemSelected ( MenuItem item ) {
        if ( mDrawerToggle.onOptionsItemSelected ( item ) ) {
            return true;
        }
        return super.onOptionsItemSelected ( item );
    }
    @Override
    public void setContentView ( final int layoutResID ) {
        DrawerLayout fullLayout = ( DrawerLayout ) getLayoutInflater()
                                  .inflate ( R.layout.activity_drawer, null );
        LinearLayout actContent = ( LinearLayout ) fullLayout.findViewById ( R.id.content );
        DrawerLayout mDrawerLayout = ( DrawerLayout ) fullLayout.findViewById ( R.id.drawer_layout );
        ListView mDrawerList = ( ListView ) fullLayout.findViewById ( R.id.nav_drawer );
        mDrawerList.setAdapter ( new ArrayAdapter<String> ( this, R.layout.drawer_list_item, navOptions ) );
        mDrawerToggle = new ActionBarDrawerToggle (
            this,
            mDrawerLayout,
            R.drawable.ic_drawer,
            R.string.drawer_open,
            R.string.drawer_close
        ) {
            public void onDrawerClosed ( View view ) {
                super.onDrawerClosed ( view );
                getActionBar().setTitle ( R.string.app_name );
            }
            public void onDrawerOpened ( View drawerView ) {
                super.onDrawerOpened ( drawerView );
                getActionBar().setTitle ( R.string.app_name );
            }
        };
        mDrawerLayout.setDrawerListener ( mDrawerToggle );
        getActionBar().setDisplayHomeAsUpEnabled ( true );
        getActionBar().setHomeButtonEnabled ( true );
        getLayoutInflater().inflate ( layoutResID, actContent, true );
        super.setContentView ( fullLayout );
    }
}
