TrustManagerFactory tmf = TrustManagerFactory
                          .getInstance ( TrustManagerFactory.getDefaultAlgorithm() );
tmf.init ( ( KeyStore ) null );
X509TrustManager defaultTm = null;
for ( TrustManager tm : tmf.getTrustManagers() ) {
    if ( tm instanceof X509TrustManager ) {
        defaultTm = ( X509TrustManager ) tm;
        break;
    }
}
FileInputStream myKeys = new FileInputStream ( "truststore.jks" );
KeyStore myTrustStore = KeyStore.getInstance ( KeyStore.getDefaultType() );
myTrustStore.load ( myKeys, "password".toCharArray() );
myKeys.close();
tmf = TrustManagerFactory
      .getInstance ( TrustManagerFactory.getDefaultAlgorithm() );
tmf.init ( myTrustStore );
X509TrustManager myTm = null;
for ( TrustManager tm : tmf.getTrustManagers() ) {
    if ( tm instanceof X509TrustManager ) {
        myTm = ( X509TrustManager ) tm;
        break;
    }
}
final X509TrustManager finalDefaultTm = defaultTm;
final X509TrustManager finalMyTm = myTm;
X509TrustManager customTm = new X509TrustManager() {
    @Override
    public X509Certificate[] getAcceptedIssuers() {
        return finalDefaultTm.getAcceptedIssuers();
    }
    @Override
    public void checkServerTrusted ( X509Certificate[] chain,
                                     String authType ) throws CertificateException {
        try {
            finalMyTm.checkServerTrusted ( chain, authType );
        } catch ( CertificateException e ) {
            finalDefaultTm.checkServerTrusted ( chain, authType );
        }
    }
    @Override
    public void checkClientTrusted ( X509Certificate[] chain,
                                     String authType ) throws CertificateException {
        finalDefaultTm.checkClientTrusted ( chain, authType );
    }
};
SSLContext sslContext = SSLContext.getInstance ( "TLS" );
sslContext.init ( null, new TrustManager[] { customTm }, null );
SSLContext.setDefault ( sslContext );
