public static String setExternalLinkTargets ( String html ) {
    final NodeVisitor linkVisitor = new NodeVisitor() {
        @Override
        public void visitTag ( Tag tag ) {
            String name = tag.getTagName();
            if ( "a".equalsIgnoreCase ( name ) ) {
                if ( isExternalLink ( url.getHost() ) {
                tag.setAttribute ( "target", "_blank" );
                }
            }
        }
    };
    Parser parser = Parser.createParser ( html, null );
    NodeList list;
    try {
        list = parser.parse ( null );
        list.visitAllNodesWith ( linkVisitor );
        return list.toHtml();
    } catch ( ParserException e ) {
        return html;
    }
}
