import java.net.URL;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Image;
import javax.swing.JPanel;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import javax.imageio.*;
import javax.swing.JFrame;
import javax.swing.JButton;
import javax.swing.JApplet;
import javax.swing.JComponent;
public class JAppletGallery extends JApplet implements ActionListener {
    private JButton first;
    private JButton previous;
    private JButton next;
    private JButton last;
    private int cacheSize = 2;
    static int total = 400;
    int imageIndex = 0;
    String msg = "";
    String folderName = "/Users/Martynas/pictures/leicester/";
    File folder = new File ( folderName );
    Image pictures[] = new Image[total];
    static String[] imageName = new String[total];
    public static void main ( String[] args ) {
        final JAppletGallery ap = new JAppletGallery();
        if ( args.length > 0 ) {
            ap.folderName = args[0];
        }
        ap.folder = new File ( ap.folderName );
        final JFrame f = new JFrame ( "Gal " );
        javax.swing.SwingUtilities.invokeLater ( new Runnable() {
            public void run() {
                f.getContentPane().setLayout ( null );
                f.getContentPane().add ( ap );
                f.setBounds ( 0, 0, 700, 700 );
                ap.setBounds ( 15, 15, 675, 675 );
                f.setVisible ( true );
                ap.init();
                ap.start();
                f.invalidate();
                f.repaint();
            }
        } );
    }
    public JAppletGallery() {
    }
    public void init() {
        makeGui();
        prepareImages();
    }
    private void makeGui() {
        setBackground ( Color.DARK_GRAY );
        setForeground ( Color.WHITE );
        setLayout ( new BorderLayout() );
        setSize ( 800, 600 );
        first = new JButton ( "First" );
        first.setForeground ( Color.BLACK );
        previous = new JButton ( "Previous" );
        previous.setForeground ( Color.BLACK );
        next = new JButton ( "Next" );
        next.setForeground ( Color.BLACK );
        last = new JButton ( "Last" );
        last.setForeground ( Color.BLACK );
        JPanel btnPanel = new JPanel();
        btnPanel.setLayout ( new java.awt.FlowLayout() );
        btnPanel.add ( first );
        btnPanel.add ( previous );
        btnPanel.add ( next );
        btnPanel.add ( last );
        add ( BorderLayout.NORTH, btnPanel );
        ImgShow imgs = new ImgShow();
        imgs.parent = this;
        add ( BorderLayout.CENTER, imgs );
        first.addActionListener ( this );
        previous.addActionListener ( this );
        next.addActionListener ( this );
        last.addActionListener ( this );
    }
    public void drawNext() {
        imageIndex = imageIndex + 1;
        if ( imageIndex == total ) {
            imageIndex = 0;
        }
        picsLoadAndTrim();
        repaint();
    }
    public void drawPrevious() {
        imageIndex = imageIndex - 1;
        if ( imageIndex < 0 ) {
            imageIndex = total - 1;
        }
        picsLoadAndTrim();
        repaint();
    }
    private void picsLoadAndTrim() {
        int before = imageIndex - cacheSize;
        int before2 = total;
        if ( before < 0 ) {
            before2 = total + before;
        }
        int after = imageIndex + cacheSize;
        int after2 = -1;
        if ( after >= total ) {
            after2 = after - total;
        }
        System.out.println ( "total " + total + " imageIndex " + imageIndex  + ", before " + before + ", after " + after + ", before2 " + before2 + ", after2 " + after2 );
        for ( int i = 0; i < total ; i++ ) {
            if ( ( i >= before && i <= after ) || ( i <= after2 ) || ( i >= before2 ) ) {
                System.out.println ( "CHECK " + i );
                if ( pictures[i] == null ) {
                    try {
                        pictures[i] = ImageIO.read ( new File ( folder, imageName[i] ) );
                    } catch ( Exception e ) {
                        msg = msg + " " + imageName[i];
                    }
                } else {
                }
            } else {
                System.out.println ( "rel " + i );
                pictures[i] = null;
            }
        }
    }
    public URL getDocumentBase() {
        URL u = null;
        try {
            if ( u == null ) {
                u = new URL ( "file://" + folderName );
            }
        } catch ( Exception e ) {
            System.out.println ( e );
        }
        return u;
    }
    public void drawFirst() {
        imageIndex = 0;
        picsLoadAndTrim();
        repaint();
    }
    public void drawLast() {
        imageIndex = total - 1;
        picsLoadAndTrim();
        repaint();
    }
    public void actionPerformed ( ActionEvent e ) {
        if ( e.getSource() == previous ) {
            drawPrevious();
        } else if ( e.getSource() == next ) {
            drawNext();
        } else if ( e.getSource() == first ) {
            drawFirst();
        } else if ( e.getSource() == last ) {
            drawLast();
        }
    }
    public  void filesFolder ( File folder ) {
        File[] listOfFiles = folder.listFiles();
        int index = 0;
        for ( File file : listOfFiles ) {
            String s = file.getName().toLowerCase();
            if ( file.isFile() && ( s.endsWith ( ".png" ) || s.endsWith ( "jpg" ) ) ) {
                imageName[index] = file.getName();
                index++;
            }
        }
        total = index;
        if ( cacheSize > total ) {
            cacheSize = total;
        }
    }
    private void prepareImages() {
        filesFolder ( folder );
        picsLoadAndTrim();
    }
}
class ImgShow extends JComponent {
    JAppletGallery parent;
    public void paint ( Graphics g ) {
        if ( parent.pictures[parent.imageIndex] != null ) {
            g.drawImage ( parent.pictures[parent.imageIndex], 0, 35, this );
        } else {
            g.drawString ( parent.msg, 10, 35 );
        }
    }
}
