package de.tavendo.test1;
import android.app.Activity;
import android.os.Bundle;
import android.util.Log;
import de.tavendo.autobahn.WebSocketConnection;
import de.tavendo.autobahn.WebSocketException;
import de.tavendo.autobahn.WebSocketHandler;
public class Test1Activity extends Activity {
    private static final String TAG = "de.tavendo.test1";
    private final WebSocketConnection mConnection = new WebSocketConnection();
    private void start() {
        final String wsuri = "ws://192.168.1.132:9000";
        try {
            mConnection.connect ( wsuri, new WebSocketHandler() {
                @Override
                public void onOpen() {
                    Log.d ( TAG, "Status: Connected to " + wsuri );
                    mConnection.sendTextMessage ( "Hello, world!" );
                }
                @Override
                public void onTextMessage ( String payload ) {
                    Log.d ( TAG, "Got echo: " + payload );
                }
                @Override
                public void onClose ( int code, String reason ) {
                    Log.d ( TAG, "Connection lost." );
                }
            } );
        } catch ( WebSocketException e ) {
            Log.d ( TAG, e.toString() );
        }
    }
    @Override
    public void onCreate ( Bundle savedInstanceState ) {
        super.onCreate ( savedInstanceState );
        setContentView ( R.layout.main );
        start();
    }
}
