@Override
public List<AroundBust> load ( int first, int pageSize, List<SortMeta> multiSortMeta, final Map<String, Object> filters ) {
    Map<String, String> map = new LinkedHashMap<String, String>();
    if ( map != null && !map.isEmpty() ) {
        List<Ordering<AroundBust>>list = new ArrayList<Ordering<AroundBust>>();
        for ( Map.Entry<String, String>entry : map.entrySet() ) {
            if ( entry.getKey().equalsIgnoreCase ( "id" ) ) {
                Ordering<AroundBust> ordering = Ordering.natural().onResultOf ( IntegerSorting.ID_SORT );
                list.add ( entry.getValue().equalsIgnoreCase ( "asc" ) ? ordering : ordering.reverse() );
            } else if ( entry.getKey().equalsIgnoreCase ( "size" ) ) {
                Ordering<AroundBust> ordering = Ordering.natural().onResultOf ( BigDecimalSorting.VALUE_SORT );
                list.add ( entry.getValue().equalsIgnoreCase ( "asc" ) ? ordering : ordering.reverse() );
            }
        }
        Ordering<AroundBust> compoundOrdering = list.remove ( 0 );
        for ( Ordering<AroundBust>ordering : list ) {
            compoundOrdering = compoundOrdering.compound ( ordering );
        }
        entireList = compoundOrdering.sortedCopy ( entireList );
    } else {
        entireList = Ordering.natural().onResultOf ( IntegerSorting.ID_SORT ).reverse().sortedCopy ( entireList );
    }
    return Lists.newArrayList ( entireList.subList ( first, Math.min ( pageSize + first, listSize ) ) );
}
