protected void onCreate ( Bundle savedInstanceState ) {
    super.onCreate ( savedInstanceState );
    setContentView ( R.layout.activity_main );
    lv = ( ListView ) findViewById ( R.id.listView1 );
    mydb = new DBHelper ( this );
    lv.setAdapter ( new ViewAdapter ( mydb.getList() ) );
    lv.setOnItemClickListener ( new OnItemClickListener() {
        @Override
        public void onItemClick ( AdapterView<?> arg0, View arg1, int arg2,
                                  long arg3 ) {
            int id_To_Search = arg2 + 1;
            Bundle dataBundle = new Bundle();
            dataBundle.putInt ( "id", id_To_Search );
            Intent intent = new Intent ( getApplicationContext(),
                                         com.example.addressbook.Display.class );
            intent.putExtras ( dataBundle );
            startActivity ( intent );
        }
    } );
}
public class ViewAdapter extends BaseAdapter {
    LayoutInflater mInflater;
    List<Listcollection> collectionlist;
    public ViewAdapter ( List<Listcollection> c ) {
        collectionlist = c;
        mInflater = LayoutInflater.from ( context );
    }
    @Override
    public int getCount() {
        return collectionlist.size();
    }
    @Override
    public Object getItem ( int position ) {
        return null;
    }
    @Override
    public long getItemId ( int position ) {
        return position;
    }
    @Override
    public View getView ( int position, View convertView, ViewGroup parent ) {
        if ( convertView == null ) {
            convertView = mInflater.inflate ( R.layout.list_item, null );
        }
        final TextView nameText = ( TextView ) convertView
                                  .findViewById ( R.id.lvname );
        nameText.setText ( "Name : " + collectionlist.get ( position ).getName() );
        final TextView ageText = ( TextView ) convertView
                                 .findViewById ( R.id.lvdate );
        ageText.setText ( "Age : " + collectionlist.get ( position ).getDate() );
        return convertView;
    }
}
