public class SummaryForwardFilter implements Filter {
    @Override
    public void init ( FilterConfig filterConfig ) throws ServletException {
    }
    @Override
    public void doFilter ( ServletRequest servletRequest, ServletResponse servletResponse, FilterChain filterChain ) throws IOException, ServletException {
        HttpServletRequest request = ( HttpServletRequest ) servletRequest;
        HttpServletResponse response = ( HttpServletResponse ) servletResponse;
        String url = request.getRequestURL().toString();
        String[] urlSegments = url.split ( "/" );
        String guid = urlSegments[urlSegments.length - 1];
        if ( guid.matches ( "^[a-fA-F0-9]{8}(-[a-fA-F0-9]{4}){3}-[a-fA-F0-9]{12}$" ) ) {
            request.getRequestDispatcher ( "/WEB-INF/pages/summary.jsp" ).forward ( servletRequest, servletResponse );
            return;
        }
        response.sendError ( HttpServletResponse.SC_NOT_FOUND );
    }
    @Override
    public void destroy() {
    }
}
