public void doAuthenticationRedirect ( HttpServletResponse response, final HttpSession currentSessiond ) throws Exception {
    AuthnRequest authnRequest = generateAuthnRequest();
    HttpServletResponseAdapter responseAdapter = new HttpServletResponseAdapter ( response, true );
    responseAdapter.setStatusCode ( HttpServletResponse.SC_MOVED_TEMPORARILY );
    SAMLMessageContext<?, AuthnRequest, ?> context =  SAMLUtility.makeSamlMessageContext();
    context.setPeerEntityEndpoint ( endpointObject );
    context.setOutboundSAMLMessage ( authnRequest );
    context.setOutboundSAMLMessageSigningCredential ( getSigningCredential() );
    context.setOutboundMessageTransport ( responseAdapter );
    try {
        runEncoder ( new HTTPRedirectDeflateEncoder(), context );
    } catch ( Throwable t ) {
        Log.error ( "Error endcoding AuthnRequest: ", t );
    }
}
private void runEncoder ( MessageEncoder encoder, MessageContext context )      throws IOException, MessageEncodingException {
    encoder.encode ( context );
}
