public class MatchesPropertyFunctionFactory implements PropertyFunctionFactory {
    @Override
    public PropertyFunction create ( final String uri ) {
        return new PFuncSimpleAndList() {
            @Override
            public QueryIterator execEvaluated ( final Binding parent, final Node subject, final Node predicate, final PropFuncArg object, final ExecutionContext execCxt ) {
                final boolean nonzeroPercentMatch = true;
                final Double percent = 0.75;
                if ( nonzeroPercentMatch ) {
                    final Binding binding =
                        BindingFactory.binding ( parent,
                                                 Var.alloc ( object.getArg ( 1 ) ),
                                                 NodeFactory.createLiteral ( percent.toString(), XSDDatatype.XSDdecimal ) );
                    return QueryIterSingleton.create ( binding, execCtx );
                } else {
                    return QueryIterNullIterator.create ( execCtx );
                }
            }
        };
    }
}
