import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;
public class fantasyFootball {
    private List<String> teamNames = new ArrayList<String>();
    private int numberOfTeams;
    private int numberOfWeeks;
    private int[][] score;
    private int[] teamAverage;
    private int[] scoreAverage;
    public static void main ( String[] args ) {
        fantasyFootball book = new fantasyFootball();
        book.display();
    }
    public fantasyFootball ( int[][] a ) {
        if ( a.length == 0 || a[0].length == 0 ) {
            System.out.println ( "Empty score records. Aborting." );
            System.exit ( 0 );
        }
        numberOfTeams = a.length;
        numberOfWeeks = a[0].length;
        fillScore ( a );
        fillTeamAverage();
        fillScoreAverage();
    }
    public fantasyFootball ( fantasyFootball book ) {
        numberOfTeams = book.numberOfTeams;
        numberOfWeeks = book.numberOfWeeks;
        fillScore ( book.score );
        fillTeamAverage();
        fillScoreAverage();
    }
    public fantasyFootball() {
        Scanner keyboard = new Scanner ( System.in );
        System.out.println ( "Enter number of teams:" );
        numberOfTeams = keyboard.nextInt();
        System.out.println ( "Enter number of weeks:" );
        numberOfWeeks = keyboard.nextInt();
        score = new int[numberOfTeams][numberOfWeeks];
        for ( int teamName = 1; teamName <= numberOfTeams; teamName++ ) {
            System.out.println ( "Enter team " + teamName + " name " );
            String name = keyboard.next();
            teamNames.add ( name );
            for ( int weekNumber = 1; weekNumber <= numberOfWeeks; weekNumber++ ) {
                System.out.println ( "Enter score for team " + teamName + " on week number " + weekNumber );
                score[teamName - 1][weekNumber - 1] = keyboard.nextInt();
            }
        }
        fillTeamAverage();
        fillScoreAverage();
    }
    private void fillScore ( int[][] a ) {
        score = new int[numberOfTeams][numberOfWeeks];
        for ( int teamName = 1; teamName <= numberOfTeams; teamName++ ) {
            for ( int weekNumber = 1; weekNumber <= numberOfWeeks; weekNumber++ ) {
                score[teamName][weekNumber] = a[teamName][weekNumber];
            }
        }
    }
    private void fillTeamAverage() {
        teamAverage = new int[numberOfTeams];
        for ( int teamName = 1; teamName <= numberOfTeams; teamName++ ) {
            int sum = 0;
            for ( int weekNumber = 1; weekNumber <= numberOfWeeks; weekNumber++ ) {
                sum = sum + score[teamName - 1][weekNumber - 1];
            }
            teamAverage[teamName - 1] = sum / numberOfWeeks;
        }
    }
    private void fillScoreAverage() {
        scoreAverage = new int[numberOfWeeks];
        for ( int weekNumber = 1; weekNumber <= numberOfWeeks; weekNumber++ ) {
            int sum = 0;
            for ( int teamName = 1; teamName <= numberOfTeams; teamName++ ) {
                sum = sum + score[teamName - 1][weekNumber - 1];
            }
            scoreAverage[weekNumber - 1] = sum / numberOfTeams;
        }
    }
    public void display() {
        for ( int teamName = 1; teamName <= numberOfTeams; teamName++ ) {
            System.out.print ( "Team " + teamNames.get ( teamName - 1 ) + " Weeks: " );
            for ( int weekNumber = 1; weekNumber <= numberOfWeeks; weekNumber++ ) {
                System.out.print ( score[teamName - 1][weekNumber - 1] + " " );
            }
            System.out.println ( " Ave = " + teamAverage[teamName - 1] );
        }
        System.out.println ( "Week averages: " );
        for ( int weekNumber = 1; weekNumber <= numberOfWeeks; weekNumber++ )
            System.out.print ( "Week " + weekNumber + " Ave = "
                               + scoreAverage[weekNumber - 1] + " " );
        System.out.println();
    }
    private void teamName() {
        Scanner keyboard = new Scanner ( System.in );
        String[] teamName = new String[3];
    }
}
