public MultipartRequest ( HttpServletRequest request,
                          String saveDirectory,
                          int maxPostSize,
                          String encoding,
                          FileRenamePolicy policy ) throws IOException {
    if ( request == null ) {
        throw new IllegalArgumentException ( "request cannot be null" );
    }
    if ( saveDirectory == null ) {
        throw new IllegalArgumentException ( "saveDirectory cannot be null" );
    }
    if ( maxPostSize <= 0 ) {
        throw new IllegalArgumentException ( "maxPostSize must be positive" );
    }
    File dir = new File ( saveDirectory );
    if ( !dir.isDirectory() ) {
        throw new IllegalArgumentException ( "Not a directory: " + saveDirectory );
    }
