package m.example.postrwq;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.DefaultHttpClient;
import org.json.JSONObject;
import android.support.v7.app.ActionBarActivity;
import android.app.Activity;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;
public class MainActivity extends ActionBarActivity {
    Button btnPost;
    TextView tvIsConnected;
    @Override
    protected void onCreate ( Bundle savedInstanceState ) {
        super.onCreate ( savedInstanceState );
        setContentView ( R.layout.activity_main );
        btnPost = ( Button ) findViewById ( R.id.button1 );
        tvIsConnected = ( TextView ) findViewById ( R.id.textView1 );
        if ( isConnected() ) {
            tvIsConnected.setBackgroundColor ( 0xFF00CC00 );
            tvIsConnected.setText ( "You are conncted" );
        } else {
            tvIsConnected.setText ( "You are NOT conncted" );
        }
        btnPost.setOnClickListener ( new OnClickListener() {
            @Override
            public void onClick ( View v ) {
                new HttpAsyncTask().execute ( "http://hmkcode.appspot.com/jsonservlet" );
            }
        } );
    }
    private class HttpAsyncTask extends AsyncTask<String, Void, String> {
        @Override
        protected String doInBackground ( String... urls ) {
            return POST ( urls[0] );
        }
        @Override
        protected void onPostExecute ( String result ) {
            Toast.makeText ( getBaseContext(), "Data Sent!", Toast.LENGTH_LONG ).show();
        }
    }
    public static String POST ( String url ) {
        InputStream inputStream = null;
        String result = "";
        try {
            HttpClient httpclient = new DefaultHttpClient();
            HttpPost httpPost = new HttpPost ( url );
            String json = "my string";
            StringEntity se = new StringEntity ( json );
            httpPost.setEntity ( se );
            httpPost.setHeader ( "Accept", "application/json" );
            httpPost.setHeader ( "Content-type", "application/json" );
            HttpResponse httpResponse = httpclient.execute ( httpPost );
            inputStream = httpResponse.getEntity().getContent();
            if ( inputStream != null ) {
                result = convertInputStreamToString ( inputStream );
            } else {
                result = "Did not work!";
            }
        } catch ( Exception e ) {
            Log.d ( "InputStream", e.getLocalizedMessage() );
        }
        return result;
    }
    private static String convertInputStreamToString ( InputStream inputStream ) throws IOException {
        BufferedReader bufferedReader = new BufferedReader ( new InputStreamReader ( inputStream ) );
        String line = "";
        String result = "";
        while ( ( line = bufferedReader.readLine() ) != null ) {
            result += line;
        }
        inputStream.close();
        return result;
    }
    public boolean isConnected() {
        ConnectivityManager connMgr = ( ConnectivityManager ) getSystemService ( Activity.CONNECTIVITY_SERVICE );
        NetworkInfo networkInfo = connMgr.getActiveNetworkInfo();
        if ( networkInfo != null && networkInfo.isConnected() ) {
            return true;
        } else {
            return false;
        }
    }
    @Override
    public boolean onCreateOptionsMenu ( Menu menu ) {
        getMenuInflater().inflate ( R.menu.main, menu );
        return true;
    }
    @Override
    public boolean onOptionsItemSelected ( MenuItem item ) {
        int id = item.getItemId();
        if ( id == R.id.action_settings ) {
            return true;
        }
        return super.onOptionsItemSelected ( item );
    }
