class TileSet {
    private Map<Integer, BufferedImage> tileImages;
    TileSet() {
        ....
        prepareTileImages();
    }
    private void prepareTileImages() {
        tileImages = new HashMap<Integer, BufferedImage>();
        for ( int tile : allPossibleTileValuesThatMayBeInTheMap ) {
            BufferedImage image =
                getTileImage().getSubimage (
                    getTileX ( tile ),
                    getTileY ( tile ),
                    getTileWidth(),
                    getTileHeight() );
            BufferedImage managedImage = convertToARGB ( image );
            tileImages.put ( tile, managedImage );
        }
    }
    private static BufferedImage convertToARGB ( BufferedImage image ) {
        BufferedImage newImage = new BufferedImage (
            image.getWidth(), image.getHeight(),
            BufferedImage.TYPE_INT_ARGB );
        Graphics2D g = newImage.createGraphics();
        g.drawImage ( image, 0, 0, null );
        g.dispose();
        return newImage;
    }
    public BufferedImage getTileImage ( int tile ) {
        return tileImages.get ( tile );
    }
}
