@Module()
public class ApplicationModule {
    @Provides @Named ( "ValueA" ) String provideValueA() {
        return "This is ValueA";
    }
}
@Module (
    addsTo = ApplicationModule.class
)
public class ActivityModule {
    @Provides @Named ( "ValueB" ) String provideValueB ( @Named ( "ValueA" ) String valueA ) {
        return valueA + " and ValueB";
    }
}
public class DemoApplication extends Application {
    private ObjectGraph graph;
    @Override public void onCreate() {
        super.onCreate();
        graph = ObjectGraph.create ( getModules().toArray() );
    }
    protected List<Object> getModules() {
        return Arrays.asList (
                   new ApplicationModule()
               );
    }
    public void inject ( Object object ) {
        graph.inject ( object );
    }
    public ObjectGraph getObjectGraph() {
        return graph;
    }
}
public class DemoActivity extends Activity {
    private ObjectGraph activityGraph;
    @Override protected void onCreate ( Bundle savedInstanceState ) {
        super.onCreate ( savedInstanceState );
        DemoApplication application = ( DemoApplication ) getApplication();
        activityGraph = application.getApplicationGraph().plus ( new ActivityModule() );
        activityGraph.inject ( this );
    }
    @Override protected void onDestroy() {
        activityGraph = null;
        super.onDestroy();
    }
}
