@Component
public class ContestFlow {
    static Logger logger = LoggerFactory.getLogger ( ContestFlow.class );
    @Autowired
    private ServiceService ServiceService;
    @Autowired
    private AgencyService AgencyService;
    public Set<ContestService> converterCheckboxToSetContestService ( Contest contest, String ids_string ) {
        Set<ContestService> contestServices = new HashSet<ContestService> ( 0 );
        if ( ids_string != null ) {
            String[] arr_ids = ids_string.split ( "," );
            for ( int i = 0; i < arr_ids.length; i++ ) {
                try {
                    Service service = ServiceService.getService ( Integer.parseInt ( arr_ids[i] ) );
                    logger.info ( "Aggiungo il service id [" + arr_ids[i] + "]" );
                    ContestServiceId contestServiceId = new ContestServiceId();
                    contestServiceId.setService ( service );
                    contestServiceId.setContest ( contest );
                    ContestService contestService = new ContestService();
                    contestService.setService ( service );
                    contestService.setContest ( contest );
                    contestService.setPk ( contestServiceId );
                    contestServices.add ( contestService );
                } catch ( Exception ex ) {
                    ex.printStackTrace();
                    logger.info ( "Service id [" + arr_ids[i] + "] not found!" );
                }
            }
        }
        return contestServices;
    }
    public List<String> converterSetContestServiceToCheckbox ( Set<ContestService> contestServices ) {
        List<String> result = new ArrayList<String>();
        if ( contestServices != null ) {
            Iterator<ContestService> iterator = contestServices.iterator();
            while ( iterator.hasNext() ) {
                ContestService contestService = iterator.next();
                Integer id = contestService.getService().getId();
                result.add ( id.toString() );
            }
        }
        return result;
    }
    public Set<ContestAgency> converterCheckboxToSetContestAgency ( Contest contest, String ids_string ) {
        Set<ContestAgency> contestAgencies = new HashSet<ContestAgency> ( 0 );
        if ( ids_string != null ) {
            String[] arr_ids = ids_string.split ( "," );
            for ( int i = 0; i < arr_ids.length; i++ ) {
                try {
                    Agency agency = AgencyService.getAgency ( Integer.parseInt ( arr_ids[i] ) );
                    logger.info ( "Adding agency id [" + arr_ids[i] + "]" );
                    ContestAgencyId contestAgencyId = new ContestAgencyId();
                    contestAgencyId.setAgency ( agency );
                    contestAgencyId.setContest ( contest );
                    ContestAgency contestAgency = new ContestAgency();
                    contestAgency.setAgency ( agency );
                    contestAgency.setContest ( contest );
                    contestAgency.setPk ( contestAgencyId );
                    contestAgency.setContractCount ( 0 );
                    contestAgencies.add ( contestAgency );
                } catch ( RecordNotFoundException ex ) {
                    ex.printStackTrace();
                    logger.info ( "Agency id [" + arr_ids[i] + "] not found!" );
                }
            }
        }
        return contestAgencies;
    }
    public List<String> converterSetContestAgencyToCheckbox ( Set<ContestAgency> contestAgencies ) {
        List<String> result = new ArrayList<String>();
        if ( contestAgencies != null ) {
            Iterator<ContestAgency> iterator = contestAgencies.iterator();
            while ( iterator.hasNext() ) {
                ContestAgency contestAgency = iterator.next();
                Integer id = contestAgency.getAgency().getId();
                result.add ( id.toString() );
            }
        }
        return result;
    }
}
