package uk.me.jstott.jcoord;
public class Test {
    public static void main ( String[] args ) {
        System.out
        .println ( "Calculate Surface Distance between two Latitudes/Longitudes" );
        LatLng lld1 = new LatLng ( 40.718119, -73.995667 );
        System.out.println ( "New York Lat/Long: " + lld1.toString() );
        LatLng lld2 = new LatLng ( 51.499981, -0.125313 );
        System.out.println ( "London Lat/Long: " + lld2.toString() );
        double d = lld1.distance ( lld2 );
        System.out.println ( "Surface Distance between New York and London: " + d
                             + "km" );
        System.out.println();
        System.out.println ( "Convert OS Grid Reference to Latitude/Longitude" );
        System.out.println ( "Using OSGB36" );
        OSRef os1 = new OSRef ( 651409.903, 313177.270 );
        System.out.println ( "OS Grid Reference: " + os1.toString() + " - "
                             + os1.toSixFigureString() );
        LatLng ll1 = os1.toLatLng();
        System.out.println ( "Converted to Lat/Long: " + ll1.toString() );
        System.out.println();
        System.out.println ( "Using WGS84" );
        OSRef os1w = new OSRef ( 651409.903, 313177.270 );
        System.out.println ( "OS Grid Reference: " + os1w.toString() + " - "
                             + os1w.toSixFigureString() );
        LatLng ll1w = os1w.toLatLng();
        ll1w.toWGS84();
        System.out.println ( "Converted to Lat/Long: " + ll1w.toString() );
        System.out.println();
        System.out.println ( "Convert Latitude/Longitude to OS Grid Reference" );
        System.out.println ( "Using OSGB36" );
        LatLng ll2 = new LatLng ( 52.657570301933, 1.7179215806451 );
        System.out.println ( "Latitude/Longitude: " + ll2.toString() );
        OSRef os2 = ll2.toOSRef();
        System.out.println ( "Converted to OS Grid Ref: " + os2.toString() + " - "
                             + os2.toSixFigureString() );
        System.out.println();
        System.out.println ( "Using WGS84" );
        LatLng ll2w = new LatLng ( 52.657570301933, 1.7179215806451 );
        System.out.println ( "Latitude/Longitude: " + ll2.toString() );
        ll2w.toOSGB36();
        OSRef os2w = ll2w.toOSRef();
        System.out.println ( "Converted to OS Grid Ref: " + os2w.toString() + " - "
                             + os2w.toSixFigureString() );
        System.out.println();
        System.out
        .println ( "Convert Six-Figure OS Grid Reference String to an OSRef Object" );
        String os6 = "TG514131";
        System.out.println ( "Six figure string: " + os6 );
        OSRef os6x = new OSRef ( os6 );
        System.out.println ( "Converted to OS Grid Ref: " + os6x.toString() + " - "
                             + os6x.toSixFigureString() );
        System.out.println();
        System.out.println ( "Convert UTM Reference to Latitude/Longitude" );
        UTMRef utm1 = new UTMRef ( 456463.99, 3335334.05, 'E', 12 );
        System.out.println ( "UTM Reference: " + utm1.toString() );
        LatLng ll3 = utm1.toLatLng();
        System.out.println ( "Converted to Lat/Long: " + ll3.toString() );
        System.out.println();
        System.out.println ( "Convert Latitude/Longitude to UTM Reference" );
        LatLng ll4 = new LatLng ( -60.1167, -111.7833 );
        System.out.println ( "Latitude/Longitude: " + ll4.toString() );
        UTMRef utm2 = ll4.toUTMRef();
        System.out.println ( "Converted to UTM Ref: " + utm2.toString() );
        System.out.println();
    }
}
