@Component
public class OAuthConsumerDetailsService implements ConsumerDetailsService {
    final static Logger log = LoggerFactory.getLogger ( OAuthConsumerDetailsService.class );
    @Override
    public ConsumerDetails loadConsumerByConsumerKey ( String consumerKey ) throws OAuthException {
        BaseConsumerDetails cd;
        if ( "key".equals ( consumerKey ) ) {
            cd = new BaseConsumerDetails();
            cd.setConsumerKey ( consumerKey );
            cd.setSignatureSecret ( new SharedConsumerSecretImpl ( "secret" ) );
            cd.setConsumerName ( "Sample" );
            cd.setRequiredToObtainAuthenticatedToken ( false );
            cd.getAuthorities().add ( new SimpleGrantedAuthority ( "ROLE_OAUTH" ) );
            log.info ( "OAuth check SUCCESS, consumer key: " + consumerKey );
        } else {
            throw new OAuthException ( "For this example, key must be 'key'" );
        }
        return cd;
    }
}
