public class ExampleAdapter extends BaseAdapter {
    private final LayoutInflater inflater;
    private final List<ParseObject> objects;
    private final boolean[] activated;
    public ExampleAdapter ( Context context, List<ParseObject> objects ) {
        this.inflater = LayoutInflater.from ( context );
        this.objects = objects;
        this.activated = new boolean[objects.size()];
    }
    public void showProgressBar ( int position, boolean visible ) {
        this.activated[position] = visible;
        notifyDataSetChanged();
    }
    @Override
    public int getCount() {
        return this.objects.size();
    }
    @Override
    public ParseObject getItem ( int position ) {
        return this.objects.get ( position );
    }
    @Override
    public long getItemId ( int position ) {
        return 0;
    }
    @Override
    public View getView ( int position, View convertView, ViewGroup parent ) {
        if ( convertView == null ) {
            convertView = inflater.inflate ( R.layout.myrow, parent, false );
            ViewHolder holder = new ViewHolder();
            holder.text = ( TextView ) convertView.findViewById ( R.id.text );
            holder.my_prog = ( ProgressBar ) convertView.findViewById ( R.id.my_prog );
            convertView.setTag ( holder );
        }
        ParseObject parseObject = getItem ( position );
        ViewHolder holder = ( ViewHolder ) convertView.getTag();
        String name = parseObject.get ( "name" );
        int progressBarVisibility = this.activated[position] ? View.VISIBLE : View.GONE;
        int textViewVisibility = this.activated[position] ? View.GONE : View.VISIBLE;
        holder.text.setText ( name );
        holder.text.setVisibility ( textViewVisibility );
        holder.my_prog.setVisibility ( progressBarVisibility );
        return convertView;
    }
    private class ViewHolder {
        public TextView text;
        public ProgressBar my_prog;
    }
}
