@ManagedBean ( eager = true )
@ApplicationScoped
public class JobRunner {
    private ScheduledExecutorService scheduler;
    private static final int POOL_SIZE = 1;
    ScheduledFuture<?> runHandle;
    @PostConstruct
    public void init() {
        scheduler = Executors.newScheduledThreadPool ( POOL_SIZE );
        runHandle = scheduler.scheduleAtFixedRate ( new MyJob(), 5, 5, TimeUnit.MINUTES );
    }
    @PreDestroy
    public void destroy() {
        scheduler.shutdownNow();
    }
    public void reschedule ( int newDelay ) {
        runHandle.cancel ( false );
        runHandle = scheduler.scheduleAtFixedRate ( new MyJob(), newDelay, newDelay, TimeUnit.MINUTES );
    }
}
public class MyJob implements Runnable {
    public void run() {
    }
}
