import javafx.scene.layout.Pane;
import javafx.scene.paint.Color;
import javafx.scene.paint.Paint;
import javafx.scene.text.Font;
import javafx.scene.text.Text;
import javafx.scene.text.TextAlignment;
public class CircularText extends Pane {
    private double circleWidth;
    private double circleHeight;
    private double textSize;
    private double textStartDegree;
    private double textRotate;
    private double gapSpacing;
    private double offSetX;
    private double offSetY;
    private Font font;
    private Paint textFill;
    private String fontName;
    final String text;
    public CircularText ( String text ) {
        this.circleWidth = 250;
        this.circleHeight = 250;
        this.text = text;
        textSize = ( this.circleWidth / this.text.length() ) * 2;
        this.font = new Font ( "Times Roman", textSize );
        this.textFill = Color.BLACK;
        this.textStartDegree = 240;
        this.textRotate = 90;
        this.gapSpacing = 0.975;
        this.offSetX = 4;
        this.offSetY = 3;
        paintText ( this.text, this.font );
    }
    public CircularText ( String text, double w, double h ) {
        this.circleWidth = w;
        this.circleHeight = h;
        this.text = text;
        textSize = ( this.circleWidth / ( this.text.length() ) * 2 );
        this.font = new Font ( "Times Roman", textSize );
        this.textFill = Color.BLACK;
        this.textStartDegree = 240;
        this.textRotate = 90;
        this.gapSpacing = 0.975;
        this.offSetX = 4;
        this.offSetY = 3;
        paintText ( this.text, this.font );
    }
    public Paint getTextFill() {
        return textFill;
    }
    public void setTextFill ( Paint textFill ) {
        this.textFill = textFill;
        this.font = new Font ( fontName, textSize );
        paintText ( this.text, this.font );
    }
    public double getTextStartDegree() {
        return textStartDegree;
    }
    public void setTextStartDegree ( double textStartDegree ) {
        this.textStartDegree = textStartDegree;
        this.font = new Font ( fontName, textSize );
        paintText ( this.text, this.font );
    }
    public double getTextRotate() {
        return textRotate;
    }
    public void setTextRotate ( double textRotate ) {
        this.textRotate = textRotate;
        this.font = new Font ( fontName, textSize );
        paintText ( this.text, this.font );
    }
    public double getGapSpacing() {
        return gapSpacing;
    }
    public void setGapSpacing ( double gapSpacing ) {
        this.gapSpacing = gapSpacing;
        this.font = new Font ( fontName, textSize );
        paintText ( this.text, this.font );
    }
    public Font getFont() {
        return this.font;
    }
    public void setFont ( String name ) {
        this.font = new Font ( name, textSize );
        this.fontName = name;
        paintText ( this.text, this.font );
    }
    public double getTextSize() {
        return this.textSize;
    }
    public void setTextSize ( double textSize, double offSetX, double offSetY ) {
        this.textSize = textSize;
        this.offSetX = offSetX;
        this.offSetY = offSetY;
        this.font = new Font ( fontName, textSize );
        paintText ( this.text, this.font );
    }
    public double getCircleWidth() {
        return circleWidth;
    }
    public void setCircleWidth ( double w ) {
        this.circleWidth = w;
        textSize = ( this.circleWidth / this.text.length() ) * 2;
        paintText ( this.text, this.font );
    }
    public double getCircleHeight() {
        return circleHeight;
    }
    public void setCircleHeight ( double h ) {
        this.circleHeight = h;
        textSize = ( this.circleWidth / this.text.length() ) * 2;
        paintText ( this.text, this.font );
    }
    protected void paintText ( String text, Font font ) {
        getChildren().clear();
        double radius = Math.min ( circleWidth, circleHeight ) * 0.8 * 0.5;
        double centerX = circleWidth / 2;
        double centerY = circleHeight / 2;
        int i = 0;
        double degree = 360.0 / ( text.length() / this.gapSpacing );
        for ( double degrees = this.textStartDegree;
                i < text.length(); i++, degrees += degree ) {
            double pointX = centerX + radius *
                            Math.cos ( Math.toRadians ( degrees ) ) - ( this.textSize ) *
                            this.offSetX;
            double pointY = centerY + radius *
                            Math.sin ( Math.toRadians ( degrees ) ) - ( this.textSize ) *
                            this.offSetY;
            Text letter = new Text ( pointX, pointY,
                                     String.valueOf ( text.charAt ( i ) ) );
            letter.setFont ( font );
            letter.setFill ( this.textFill );
            letter.setRotate ( degrees + this.textRotate );
            letter.setTextAlignment ( TextAlignment.CENTER );
            getChildren().add ( letter );
        }
    }
}
