import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import javax.swing.JFrame;
import javax.swing.SwingUtilities;
public class ComponentResizeDemo {
    public ComponentResizeDemo() {
        final JFrame frame = new JFrame();
        frame.setSize ( 300, 300 );
        frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
        frame.setLocationByPlatform ( true );
        frame.setVisible ( true );
        SwingUtilities.invokeLater ( new Runnable() {
            public void run() {
                addComponentListener ( frame );
            }
        } );
    }
    public static void addComponentListener ( JFrame frame ) {
        frame.addComponentListener ( new ComponentAdapter() {
            @Override
            public void componentResized ( ComponentEvent e ) {
                System.out.println ( "Frame resized" );
            }
        } );
    }
    public static void main ( String[] args ) {
        SwingUtilities.invokeLater ( new Runnable() {
            public void run() {
                new ComponentResizeDemo();
            }
        } );
    }
}
