import java.io.Serializable;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
@Entity
@Table ( name = "person" )
public class Person implements Serializable {
    private long id;
    private String firstName;
    private String lastName;
    private String eMail;
    public Person() {
    }
    public Person ( String firstName, String lastName, String eMail ) {
        this.firstName = firstName;
        this.lastName = lastName;
        this.eMail = eMail;
    }
    @Id
    @GeneratedValue ( strategy = GenerationType.AUTO )
    public long getId() {
        return id;
    }
    public void setId ( long id ) {
        this.id = id;
    }
    @Size ( min = 2, max = 255, message = "Enter between 2 and 255 characters!" )
    @Column ( name = "firstname" )
    @NotNull
    public String getFirstName() {
        return firstName;
    }
    public void setFirstName ( String firstName ) {
        this.firstName = firstName;
    }
    @Column ( name = "lastname" )
    @NotNull
    public String getLastName() {
        return lastName;
    }
    public void setLastName ( String lastName ) {
        this.lastName = lastName;
    }
    @NotNull
    public String geteMail() {
        return eMail;
    }
    public void seteMail ( String eMail ) {
        this.eMail = eMail;
    }
}
