public Annotation[] getAnnotations() {
    return AnnotationParser.toArray ( annotationData().annotations );
}
private volatile transient AnnotationData annotationData;
private AnnotationData annotationData() {
    while ( true ) {
        AnnotationData annotationData = this.annotationData;
        int classRedefinedCount = this.classRedefinedCount;
        if ( annotationData != null &&
                annotationData.redefinedCount == classRedefinedCount ) {
            return annotationData;
        }
        AnnotationData newAnnotationData = createAnnotationData ( classRedefinedCount );
        if ( Atomic.casAnnotationData ( this, annotationData, newAnnotationData ) ) {
            return newAnnotationData;
        }
    }
}
private static class AnnotationData {
    final Map<Class<? extends Annotation>, Annotation> annotations;
    final Map<Class<? extends Annotation>, Annotation> declaredAnnotations;
    final int redefinedCount;
    AnnotationData ( Map<Class<? extends Annotation>, Annotation> annotations,
                     Map<Class<? extends Annotation>, Annotation> declaredAnnotations,
                     int redefinedCount ) {
        this.annotations = annotations;
        this.declaredAnnotations = declaredAnnotations;
        this.redefinedCount = redefinedCount;
    }
}
