@SuppressLint ( "NewApi" )
@Override
public boolean onCreateOptionsMenu ( Menu menu ) {
    MenuInflater inflater = getMenuInflater();
    inflater.inflate ( R.menu.country_list_activity_actions, menu );
    mSearchMenu = menu.findItem ( R.id.action_search );
    if ( Build.VERSION.SDK_INT >= Build.VERSION_CODES.HONEYCOMB ) {
        SearchManager searchManager = ( SearchManager ) getSystemService ( Context.SEARCH_SERVICE );
        mSearchView = ( SearchView ) menu.findItem ( R.id.action_search ).getActionView();
        mSearchView.setSearchableInfo ( searchManager.getSearchableInfo ( getComponentName() ) );
        mSearchView.setIconifiedByDefault ( false );
        ImageView closeButton = ( ImageView ) mSearchView.findViewById ( R.id.search_close_btn );
        closeButton.setOnClickListener ( new View.OnClickListener() {
            @Override
            public void onClick ( View v ) {
                LoggerUtils.d ( LOG, "Search close button clicked" );
                EditText et = ( EditText ) findViewById ( R.id.search_src_text );
                et.setText ( "" );
                mSearchView.setQuery ( "", false );
                mSearchView.onActionViewCollapsed();
                mSearchMenu.collapseActionView();
            }
        } );
    }
    mSearchMenu.setOnActionExpandListener ( new OnActionExpandListener() {
        @Override
        public boolean onMenuItemActionExpand ( MenuItem item ) {
            LoggerUtils.d ( LOG, "Search widget expand " );
            return true;
        }
        @Override
        public boolean onMenuItemActionCollapse ( MenuItem item ) {
            LoggerUtils.d ( LOG, "Search widget colapsed " );
            return true;
        }
    } );
    return super.onCreateOptionsMenu ( menu );
}
