@Service ( "MyThreadManagerService" )
public class MyThreadManagerServiceImpl implements MyThreadManagerService {
    private Thread[] workers;
    private int workerPoolSize = 5;
    @PostConstruct
    private void init() {
        workers = new Thread[workerPoolSize];
        for ( int i = 0; i < workerPoolSize; i++ ) {
            workers[i] = new Thread ( new MyWorkerThread() );
            workers[i].start();
        }
    }
    @PreDestroy
    public void dismantle() {
        for ( Thread worker : workers ) {
            worker.setRunning ( false );
        }
        for ( Thread worker : workers ) {
            worker.join();
        }
    }
    public void setWorkerPoolSize ( int newSize ) {
        workerPoolSize = newSize;
    }
}
