public class HttpURLConnectionExample {
    private final String USER_AGENT = "Mozilla/5.0";
    public static void main ( String[] args ) throws Exception {
        HttpURLConnectionExample http = new HttpURLConnectionExample();
        System.out.println ( "Testing 1 - Send Http GET request" );
        http.sendGet();
        System.out.println ( "\nTesting 2 - Send Http POST request" );
        http.sendPost();
    }
    private void sendGet() throws Exception {
        String url = "http://www.google.com/search?q=mkyong";
        URL obj = new URL ( url );
        HttpURLConnection con = ( HttpURLConnection ) obj.openConnection();
        con.setRequestMethod ( "GET" );
        con.setRequestProperty ( "User-Agent", USER_AGENT );
        int responseCode = con.getResponseCode();
        System.out.println ( "\nSending 'GET' request to URL : " + url );
        System.out.println ( "Response Code : " + responseCode );
    }
    private void sendPost() throws Exception {
        String url = "https://selfsolve.apple.com/wcResults.do";
        URL obj = new URL ( url );
        HttpsURLConnection con = ( HttpsURLConnection ) obj.openConnection();
        con.setRequestMethod ( "POST" );
        con.setRequestProperty ( "User-Agent", USER_AGENT );
        con.setRequestProperty ( "Accept-Language", "en-US,en;q=0.5" );
        String urlParameters = "sn=C02G8416DRJM&cn=&locale=&caller=&num=12345";
        con.setDoOutput ( true );
        DataOutputStream wr = new DataOutputStream ( con.getOutputStream() );
        wr.writeBytes ( urlParameters );
        wr.flush();
        wr.close();
        int responseCode = con.getResponseCode();
        System.out.println ( "\nSending 'POST' request to URL : " + url );
        System.out.println ( "Post parameters : " + urlParameters );
        System.out.println ( "Response Code : " + responseCode );
    }
}
