static double computeMI ( int[] a, int avals, int[] t, int tvals ) {
    double numinst = a.length;
    double oneovernuminst = 1 / numinst;
    double sum = 0;
    long[][] crosscounts = new long[avals][tvals];
    long[] tcounts = new long[tvals];
    long[] acounts = new long[avals];
    for ( int i = 0; i < a.length; i++ ) {
        int av = a[i];
        int tv = t[i];
        acounts[av]++;
        tcounts[tv]++;
        crosscounts[av][tv]++;
    }
    for ( int tv = 0; tv < tvals; tv++ ) {
        for ( int av = 0; av < avals; av++ ) {
            if ( crosscounts[av][tv] != 0 ) {
                double sumtmp = ( numinst * crosscounts[av][tv] ) / ( acounts[av] * tcounts[tv] );
                sum += oneovernuminst * crosscounts[av][tv] * Math.log ( sumtmp ) * log2;
            }
        }
    }
    return sum;
}
