package io.netty.example.objectecho;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.ChannelInboundHandlerAdapter;
import java.util.logging.Logger;
public class ObjectEchoServerHandler extends ChannelInboundHandlerAdapter {
    private static final Logger log = Logger.getLogger ( ObjectEchoServerHandler.class.getName() );
    @Override
    public void channelRead ( ChannelHandlerContext ctx, Object msg ) {
        log.warning ( msg.toString() );
        ctx.write ( msg );
    }
    @Override
    public void channelReadComplete ( ChannelHandlerContext ctx ) {
        log.info ( "finished reading..?" );
        ctx.flush();
    }
    @Override
    public void exceptionCaught ( ChannelHandlerContext ctx, Throwable cause ) {
        cause.printStackTrace();
        ctx.close();
    }
}
