CountDownLatch startSignal = new CountDownLatch ( 1 );
CountDownLatch doneSignal = new CountDownLatch ( 5 );
class Worker implements Runnable {
    private final CountDownLatch startSignal;
    private final CountDownLatch doneSignal;
    private final int threadNumber;
    Worker ( CountDownLatch startSignal, CountDownLatch doneSignal,
             int threadNumber ) {
        this.startSignal = startSignal;
        this.doneSignal = doneSignal;
        this.threadNumber = threadNumber;
    }
    public void run() {
        try {
            startSignal.await();
            doWork();
            doneSignal.countDown();
        } catch ( InterruptedException ex ) {
            LOGGER.error ( ex );
        }
    }
}
for ( int i = 1; i <= 5; i++ ) {
    new Thread ( new Worker ( startSignal, doneSignal, i ) ).start();
}
startSignal.countDown();
try {
    doneSignal.await();
} catch ( InterruptedException interruptedException ) {
    LOGGER.error ( interruptedException );
}
