package data;
import java.beans.PropertyEditor;
import java.beans.PropertyEditorManager;
import java.lang.reflect.Field;
import java.util.HashMap;
import java.util.Map;
public class Reflection {
    public static <T> Map<String, String> Serialize ( final T obj ) throws IllegalArgumentException, IllegalAccessException {
        boolean flag;
        Field current;
        Map<String, String> map = new HashMap<String, String>();
        Class<? extends Object> objClass = obj.getClass();
        Field[] fields = objClass.getDeclaredFields();
        for ( int i = 0; i < fields.length; i++ ) {
            current = fields[i];
            flag = current.isAccessible();
            if ( !flag ) {
                current.setAccessible ( true );
            }
            map.put ( fields[i].getName(), fields[i].get ( ( Object ) obj ).toString() );
            if ( !flag ) {
                current.setAccessible ( false );
            }
        }
        return map;
    }
    public static <T> void Deserialize ( final T obj, final Map<String, String> map ) throws IllegalArgumentException, IllegalAccessException {
        boolean flag;
        Field current;
        Class objClass = obj.getClass();
        Field[] fields = objClass.getDeclaredFields();
        for ( int i = 0; i < fields.length; i++ ) {
            current = fields[i];
            flag = current.isAccessible();
            if ( !flag ) {
                current.setAccessible ( true );
            }
            current.set ( obj, convert ( current.getType(), map.get ( current.getName() ) ) );
            if ( !flag ) {
                current.setAccessible ( false );
            }
        }
    }
    private static Object convert ( Class<?> targetType, String text ) {
        PropertyEditor editor = PropertyEditorManager.findEditor ( targetType );
        editor.setAsText ( text );
        return editor.getValue();
    }
}
