import java.io.FileOutputStream;
import java.io.IOException;
import org.apache.poi.xwpf.usermodel.XWPFDocument;
import org.apache.poi.xwpf.usermodel.XWPFTable;
import org.apache.poi.xwpf.usermodel.XWPFTableCell;
import org.apache.poi.xwpf.usermodel.XWPFTableRow;
import org.openxmlformats.schemas.wordprocessingml.x2006.main.STMerge;
public class VerticalMerge {
    public static void main ( String[] args ) {
        int rows = 5;
        int cols = 5;
        XWPFDocument document = new XWPFDocument();
        XWPFTable table = document.createTable ( rows, cols );
        fillTable ( table );
        mergeCellsVertically ( table, 3, 1, 3 );
        try {
            FileOutputStream out = new FileOutputStream ( "vertical merge.docx" );
            document.write ( out );
            out.close();
        } catch ( IOException e ) {
            e.printStackTrace();
        }
    }
    private static void fillTable ( XWPFTable table ) {
        for ( int rowIndex = 0; rowIndex < table.getNumberOfRows(); rowIndex++ ) {
            XWPFTableRow row = table.getRow ( rowIndex );
            for ( int colIndex = 0; colIndex < row.getTableCells().size(); colIndex++ ) {
                XWPFTableCell cell = row.getCell ( colIndex );
                cell.addParagraph().createRun().setText ( " cell " + rowIndex + colIndex + " " );
            }
        }
    }
    private static void mergeCellsVertically ( XWPFTable table, int col, int fromRow, int toRow ) {
        for ( int rowIndex = fromRow; rowIndex <= toRow; rowIndex++ ) {
            XWPFTableCell cell = table.getRow ( rowIndex ).getCell ( col );
            if ( rowIndex == fromRow ) {
                cell.getCTTc().addNewTcPr().addNewVMerge().setVal ( STMerge.RESTART );
            } else {
                cell.getCTTc().addNewTcPr().addNewVMerge().setVal ( STMerge.CONTINUE );
            }
        }
    }
}
