public class ExampleSQLiteOpenHelper extends SQLiteOpenHelper {
    public ExampleSQLiteOpenHelper ( Context context, String name, SQLiteDatabase.CursorFactory factory, int version ) {
        super ( context, name, factory, version );
    }
    @Override
    public void onCreate ( SQLiteDatabase db ) {
        db.execSQL ( "CREATE TABLE MailingList (Email VARCHAR, Name VARCHAR, PhoneNumber VARCHAR);" );
        db.execSQL ( "CREATE TABLE SomeTable (_id PRIMARY KEY AUTOINCREMENT, SomeColumn VARCHAR)" );
        ...
    }
    @Override
    public void onUpgrade ( SQLiteDatabase db, int oldVersion, int newVersion ) {
        for ( int i = oldVersion + 1; i <= newVersion; i++ ) {
            upgradeTo ( db, i );
        }
    }
    private void upgradeTo ( SQLiteDatabase db, int version ) {
        switch ( version ) {
        case 2:
            db.execSQL ( "ALTER TABLE MailingList ADD COLUMN PhoneNumber VARCHAR" );
            break;
        case 3:
            db.execSQL ( "CREATE TABLE SomeTable (_id PRIMARY KEY AUTOINCREMENT, SomeColumn VARCHAR)" );
            break;
        case 4:
            ...
            break;
        case 5:
            ...
            break;
        }
    }
}
