import java.util.Random;
import java.util.concurrent.Callable;
import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.TimeUnit;
import rx.subjects.ReplaySubject;
public class Callables {
    public static void main ( String[] args ) {
        Random random = new Random();
        Callable<Boolean> callable = () -> random.nextBoolean();
        ReplaySubject<Boolean> results = ReplaySubject.create();
        Runnable runnable = () -> {
            try {
                boolean result = callable.call();
                results.onNext ( result );
            } catch ( Exception e ) {
            }
        };
        ScheduledExecutorService executor = Executors.newScheduledThreadPool ( 5 );
        executor.scheduleAtFixedRate ( runnable, 1, 1, TimeUnit.SECONDS );
        results.forEach ( result -> System.out.println ( "Result: " + result ) );
        System.out.println ( "Waiting for results..." );
    }
}
