public static BufferedImage getDifferenceImage ( BufferedImage img1, BufferedImage img2 ) {
    int width1 = img1.getWidth();
    int width2 = img2.getWidth();
    int height1 = img1.getHeight();
    int height2 = img2.getHeight();
    if ( ( width1 != width2 ) || ( height1 != height2 ) ) {
        System.err.println ( "Error: Images dimensions mismatch" );
        System.exit ( 1 );
    }
    BufferedImage outImg = new BufferedImage ( width, height, BufferedImage.TYPE_INT_RGB );
    int diff;
    int result;
    for ( int i = 0; i < height1; i++ ) {
        for ( int j = 0; j < width1; j++ ) {
            int rgb1 = img1.getRGB ( j, i );
            int rgb2 = img2.getRGB ( j, i );
            int r1 = ( rgb1 >> 16 ) & 0xff;
            int g1 = ( rgb1 >> 8 ) & 0xff;
            int b1 = ( rgb1 ) & 0xff;
            int r2 = ( rgb2 >> 16 ) & 0xff;
            int g2 = ( rgb2 >> 8 ) & 0xff;
            int b2 = ( rgb2 ) & 0xff;
            diff = Math.abs ( r1 - r2 );
            diff += Math.abs ( g1 - g2 );
            diff += Math.abs ( b1 - b2 );
            diff /= 3;
            result = ( diff << 16 ) | ( diff << 8 ) | diff;
            outImg.setRGB ( j, i, result );
        }
    }
    return outImg;
}
