public class ProfileCreation extends Activity {
    private static final int RESULT_LOAD_IMAGE = 1;
    FrameLayout layout;
    Button save;
    @Override
    public void onCreate ( Bundle savedInstanceState ) {
        super.onCreate ( savedInstanceState );
        setContentView ( R.layout.activity_profile_creation );
        save = ( Button ) findViewById ( R.id.btnConfirm );
        String picturePath = PreferenceManager.getDefaultSharedPreferences ( this ).getString ( "picturePath", "" );
        if ( !picturePath.equals ( "" ) ) {
            ImageView imageView = ( ImageView ) findViewById ( R.id.profilePicturePreview );
            imageView.setImageBitmap ( BitmapFactory.decodeFile ( picturePath ) );
        }
        Button buttonLoadImage = ( Button ) findViewById ( R.id.btnPictureSelect );
        buttonLoadImage.setOnClickListener ( new View.OnClickListener() {
            @Override
            public void onClick ( View arg0 ) {
                Intent i = new Intent (
                    Intent.ACTION_PICK,
                    android.provider.MediaStore.Images.Media.EXTERNAL_CONTENT_URI );
                startActivityForResult ( i, RESULT_LOAD_IMAGE );
            }
        } );
        save.setOnClickListener ( new View.OnClickListener() {
            @Override
            public void onClick ( View arg0 ) {
                Bitmap bitmap = BitmapFactory.decodeFile ( "picturePath" );
                ByteArrayOutputStream stream = new ByteArrayOutputStream();
                bitmap.compress ( Bitmap.CompressFormat.PNG, 100, stream );
                Object image = null;
                try {
                    String path = null;
                    image = readInFile ( path );
                } catch ( Exception e ) {
                    e.printStackTrace();
                }
                ParseFile file = new ParseFile ( "picturePath", ( byte[] ) image );
                file.saveInBackground();
                ParseObject imgupload = new ParseObject ( "Image" );
                imgupload.put ( "Image", "picturePath" );
                imgupload.put ( "ImageFile", file );
                imgupload.saveInBackground();
                SeekBar seekBar = ( SeekBar ) findViewById ( R.id.seekBar1 );
                final TextView seekBarValue = ( TextView ) findViewById ( R.id.seekbarvalue );
                seekBar.setOnSeekBarChangeListener ( new SeekBar.OnSeekBarChangeListener() {
                    @Override
                    public void onProgressChanged ( SeekBar seekBar, int progress,
                                                    boolean fromUser ) {
                        seekBarValue.setText ( String.valueOf ( progress ) );
                    }
                    @Override
                    public void onStartTrackingTouch ( SeekBar seekBar ) {
                    }
                    @Override
                    public void onStopTrackingTouch ( SeekBar seekBar ) {
                    }
                } );
            }
        } );
    }
    @Override
    protected void onActivityResult ( int requestCode, int resultCode, Intent data ) {
        super.onActivityResult ( requestCode, resultCode, data );
        if ( requestCode == RESULT_LOAD_IMAGE && resultCode == RESULT_OK
                && null != data ) {
            Uri selectedImage = data.getData();
            String[] filePathColumn = { MediaStore.Images.Media.DATA };
            Cursor cursor = getContentResolver().query ( selectedImage,
                            filePathColumn, null, null, null );
            cursor.moveToFirst();
            int columnIndex = cursor.getColumnIndex ( filePathColumn[0] );
            String picturePath = cursor.getString ( columnIndex );
            cursor.close();
            ImageView imageView = ( ImageView ) findViewById ( R.id.profilePicturePreview );
            imageView.setImageBitmap ( BitmapFactory.decodeFile ( picturePath ) );
        }
    }
    private byte[] readInFile ( String path ) throws IOException {
        byte[] data = null;
        File file = new File ( path );
        InputStream input_stream = new BufferedInputStream ( new FileInputStream (
                    file ) );
        ByteArrayOutputStream buffer = new ByteArrayOutputStream();
        data = new byte[16384];
        int bytes_read;
        while ( ( bytes_read = input_stream.read ( data, 0, data.length ) ) != -1 ) {
            buffer.write ( data, 0, bytes_read );
        }
        input_stream.close();
        return buffer.toByteArray();
    }
}
