public final class AdapterUtil {
    public static <AdapterType> AdapterType adapt ( Object adaptableObject, Class<AdapterType> adapterType ) {
        if ( adapterType.isInstance ( adaptableObject ) ) {
            return adapterType.cast ( adaptableObject );
        }
        if ( adaptableObject instanceof IAdaptable ) {
            AdapterType result = adapterType.cast ( ( ( IAdaptable ) adaptableObject ).getAdapter ( adapterType ) );
            if ( result != null ) {
                return result;
            }
        }
        return adapterType.cast ( Platform.getAdapterManager().getAdapter ( adaptableObject, adapterType ) );
    }
}
