package org.jfree.fx.demo;
import static javafx.application.Application.launch;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import javafx.application.Application;
import javafx.scene.Scene;
import javafx.scene.canvas.Canvas;
import javafx.scene.layout.StackPane;
import javafx.stage.Stage;
import javax.swing.JLabel;
import org.jfree.fx.FXGraphics2D;
import org.scilab.forge.jlatexmath.TeXConstants;
import org.scilab.forge.jlatexmath.TeXFormula;
import org.scilab.forge.jlatexmath.TeXIcon;
public class FXGraphics2DDemo3 extends Application {
    static class MyCanvas extends Canvas {
        private FXGraphics2D g2;
        private TeXIcon icon;
        public MyCanvas() {
            this.g2 = new FXGraphics2D ( getGraphicsContext2D() );
            TeXFormula formula = new TeXFormula ( "x=\\frac{-b \\pm \\sqrt {b^2-4ac}}{2a}" );
            this.icon = formula.createTeXIcon ( TeXConstants.STYLE_DISPLAY, 20 );
            widthProperty().addListener ( evt -> draw() );
            heightProperty().addListener ( evt -> draw() );
        }
        private void draw() {
            double width = getWidth();
            double height = getHeight();
            getGraphicsContext2D().clearRect ( 0, 0, width, height );
            BufferedImage image = new BufferedImage ( icon.getIconWidth(),
                    icon.getIconHeight(), BufferedImage.TYPE_INT_ARGB );
            Graphics2D gg = image.createGraphics();
            gg.setColor ( Color.WHITE );
            gg.fillRect ( 0, 0, icon.getIconWidth(), icon.getIconHeight() );
            JLabel jl = new JLabel();
            jl.setForeground ( new Color ( 0, 0, 0 ) );
            icon.paintIcon ( jl, gg, 0, 0 );
            this.g2.drawImage ( image, 0, 0, null );
        }
        @Override
        public boolean isResizable() {
            return true;
        }
        @Override
        public double prefWidth ( double height ) {
            return getWidth();
        }
        @Override
        public double prefHeight ( double width ) {
            return getHeight();
        }
    }
    @Override
    public void start ( Stage stage ) throws Exception {
        MyCanvas canvas = new MyCanvas();
        StackPane stackPane = new StackPane();
        stackPane.getChildren().add ( canvas );
        canvas.widthProperty().bind ( stackPane.widthProperty() );
        canvas.heightProperty().bind ( stackPane.heightProperty() );
        stage.setScene ( new Scene ( stackPane ) );
        stage.setTitle ( "FXGraphics2DDemo3.java" );
        stage.setWidth ( 700 );
        stage.setHeight ( 390 );
        stage.show();
    }
    public static void main ( String[] args ) {
        launch ( args );
    }
}
