package org.jfree.fx.demo;
import static javafx.application.Application.launch;
import javafx.application.Application;
import javafx.scene.Scene;
import javafx.scene.canvas.Canvas;
import javafx.scene.layout.StackPane;
import javafx.stage.Stage;
import org.jfree.fx.FXGraphics2D;
import org.scilab.forge.jlatexmath.Box;
import org.scilab.forge.jlatexmath.TeXConstants;
import org.scilab.forge.jlatexmath.TeXFormula;
import org.scilab.forge.jlatexmath.TeXIcon;
public class FXGraphics2DDemo3 extends Application {
    static class MyCanvas extends Canvas {
        private FXGraphics2D g2;
        private Box box;
        public MyCanvas() {
            this.g2 = new FXGraphics2D ( getGraphicsContext2D() );
            this.g2.scale ( 20, 20 );
            TeXFormula formula = new TeXFormula ( "x=\\frac{-b \\pm \\sqrt {b^2-4ac}}{2a}" );
            TeXIcon icon = formula.createTeXIcon ( TeXConstants.STYLE_DISPLAY, 20 );
            this.box = icon.getBox();
            widthProperty().addListener ( evt -> draw() );
            heightProperty().addListener ( evt -> draw() );
        }
        private void draw() {
            double width = getWidth();
            double height = getHeight();
            getGraphicsContext2D().clearRect ( 0, 0, width, height );
            this.box.draw ( g2, 1, 5 );
        }
        @Override
        public boolean isResizable() {
            return true;
        }
        @Override
        public double prefWidth ( double height ) {
            return getWidth();
        }
        @Override
        public double prefHeight ( double width ) {
            return getHeight();
        }
    }
    @Override
    public void start ( Stage stage ) throws Exception {
        javafx.scene.text.Font.loadFont ( FXGraphics2DDemo3.class.getResourceAsStream ( "/org/scilab/forge/jlatexmath/fonts/base/jlm_cmmi10.ttf" ), 1 );
        javafx.scene.text.Font.loadFont ( FXGraphics2DDemo3.class.getResourceAsStream ( "/org/scilab/forge/jlatexmath/fonts/maths/jlm_cmsy10.ttf" ), 1 );
        javafx.scene.text.Font.loadFont ( FXGraphics2DDemo3.class.getResourceAsStream ( "/org/scilab/forge/jlatexmath/fonts/latin/jlm_cmr10.ttf" ), 1 );
        MyCanvas canvas = new MyCanvas();
        StackPane stackPane = new StackPane();
        stackPane.getChildren().add ( canvas );
        canvas.widthProperty().bind ( stackPane.widthProperty() );
        canvas.heightProperty().bind ( stackPane.heightProperty() );
        stage.setScene ( new Scene ( stackPane ) );
        stage.setTitle ( "FXGraphics2DDemo3.java" );
        stage.setWidth ( 700 );
        stage.setHeight ( 390 );
        stage.show();
    }
    public static void main ( String[] args ) {
        launch ( args );
    }
}
