public class FileReaderWorker extends SwingWorker<List<String>, String> {
    private File file;
    private JTextArea ta;
    public FileReaderWorker ( File file, JTextArea ta ) {
        this.file = file;
        this.ta = ta;
    }
    public File getFile() {
        return file;
    }
    public JTextArea getTextArea() {
        return ta;
    }
    @Override
    protected List<String> doInBackground() throws Exception {
        List<String> contents = new ArrayList<> ( 256 );
        try ( BufferedReader br = new BufferedReader ( new FileReader ( getFile() ) ) ) {
            String text = null;
            while ( ( text = br.readLine() ) != null ) {
                contents.add ( text );
                publish ( text );
            }
        }
        return contents;
    }
    @Override
    protected void done() {
        try {
            get();
        } catch ( InterruptedException | ExecutionException ex ) {
            ex.printStackTrace();
        }
    }
    @Override
    protected void process ( List<String> chunks ) {
        JTextArea ta = getTextArea();
        for ( String text : chunks ) {
            ta.append ( text );
        }
    }
}
