class myThread extends Thread {
    Context context;
    public myThread ( Context context ) {
        this.context = context;
    }
    public void setRunning ( Boolean running ) {
        this.running = running;
    }
    @Override
    public void run() {
        Canvas canvas;
        Log.d ( TAG, "Starting game loop" );
        long beginTime;
        long timeDiff;
        int sleepTime;
        int framesSkipped;
        sleepTime = 0;
        while ( running ) {
            canvas = null;
            try {
                canvas = this.surfaceHolder.lockCanvas();
                if ( canvas != null ) {
                    synchronized ( surfaceHolder ) {
                        beginTime = System.currentTimeMillis();
                        framesSkipped = 0;
                        this.gameView.update();
                        this.gameView.render ( canvas );
                        timeDiff = System.currentTimeMillis() - beginTime;
                        sleepTime = ( int ) ( FRAME_PERIOD - timeDiff );
                        if ( sleepTime > 0 ) {
                            try {
                                Thread.sleep ( sleepTime );
                            } catch ( InterruptedException e ) {
                            }
                        }
                        while ( sleepTime < 0 && framesSkipped < MAX_FRAME_SKIPS ) {
                            this.gameView.update();
                            sleepTime += FRAME_PERIOD;
                            framesSkipped++;
                        }
                    }
                }
            } finally {
                if ( canvas != null ) {
                    surfaceHolder.unlockCanvasAndPost ( canvas );
                }
            }
        }
    }
}
