@Override
public void evaluate() throws Throwable {
    Throwable caughtThrowable = null;
    for ( int i = 0; i < retryCount; i++ ) {
        try {
            base.evaluate();
        } catch ( Throwable t ) {
            caughtThrowable = t;
            System.err.println ( description.getDisplayName() + ": run " + ( i + 1 ) + " failed" );
        }
    }
    if ( caughtThrowable != null ) {
        System.err.println ( description.getDisplayName() + ": giving up after " + retryCount + " failures" );
        throw caughtThrowable;
    }
}
