public class TestActivity extends Activity {
    Button btnDisplay;
    ImageButton btnAdd;
    LinearLayout container;
    @Override
    protected void onCreate ( Bundle savedInstanceState ) {
        super.onCreate ( savedInstanceState );
        setContentView ( R.layout.activity_main );
        container = findViewById ( R.id.linearLayoutForm );
        btnAdd = ( ImageButton ) findViewById ( R.id.btnAdd );
        btnDisplay = ( Button ) findViewById ( R.id.btnDisplay );
        btnAdd.setOnClickListener ( addListener );
    }
    View.OnClickListener addListener = new View.OnClickListener() {
        @Override
        public void onClick ( View v ) {
            final LinearLayout newView = ( LinearLayout ) getLayoutInflater().inflate ( R.layout.rowdetail, null );
            newView.setLayoutParams ( new LayoutParams ( ViewGroup.LayoutParams.WRAP_CONTENT, ViewGroup.LayoutParams.WRAP_CONTENT ) );
            ImageButton btnRemove = ( ImageButton ) newView.findViewById ( R.id.btnRemove );
            btnRemove.setOnClickListener ( new View.OnClickListener() {
                @Override
                public void onClick ( View v ) {
                    container.removeView ( newView );
                }
            } );
            container.addView ( newView );
            Spinner s = newView.findViewById ( R.id.spinner1 );
            try {
                loadSpinnerData ( s );
            } catch ( IOException e ) {
                e.printStackTrace();
            }
        }
    };
    private void loadSpinnerData ( Spinner s ) throws IOException {
        DBHelper db = new DBHelper ( getApplicationContext() );
        List<String> products = db.getAllProducts();
        ArrayAdapter<String> dataAdapter = new ArrayAdapter<String> ( this,
                android.R.layout.simple_spinner_item, products );
        dataAdapter
        .setDropDownViewResource ( android.R.layout.simple_spinner_dropdown_item );
        s.setAdapter ( dataAdapter );
    }
}
