public int uploadFile ( final String sourceFileUri, final String upLoadServerUri, final String renameFile ) {
    HttpURLConnection conn = null;
    DataOutputStream dos = null;
    String lineEnd = "\r\n";
    String twoHyphens = "--";
    String boundary = "*****";
    int bytesRead, bytesAvailable, bufferSize;
    byte[] buffer;
    int maxBufferSize = 1 * 1024 * 1024;
    File sourceFile = new File ( sourceFileUri );
    if ( !sourceFile.isFile() ) {
        dialog.dismiss();
        Log.e ( "uploadFile", "Source File not exist : " + sourceFileUri );
        activity.runOnUiThread ( new Runnable() {
            public void run() {
                new DialogHandler().customDialog ( activity, "ERROR", "Source File not exist : " + sourceFileUri );
            }
        } );
        return 0;
    } else {
        try {
            FileInputStream fileInputStream = new FileInputStream ( sourceFile );
            URL url = new URL ( upLoadServerUri );
            conn = ( HttpURLConnection ) url.openConnection();
            conn.setDoInput ( true );
            conn.setDoOutput ( true );
            conn.setUseCaches ( false );
            conn.setRequestMethod ( "POST" );
            conn.setRequestProperty ( "Connection", "Keep-Alive" );
            conn.setRequestProperty ( "ENCTYPE", "multipart/form-data" );
            conn.setRequestProperty ( "Content-Type", "multipart/form-data;boundary=" + boundary );
            conn.setRequestProperty ( "uploaded_file", renameFile );
            dos = new DataOutputStream ( conn.getOutputStream() );
            dos.writeBytes ( twoHyphens + boundary + lineEnd );
            dos.writeBytes ( "Content-Disposition: form-data; name=\"type\""
                             + lineEnd );
            dos.writeBytes ( lineEnd );
            dos.writeBytes ( "Your value" );
            dos.writeBytes ( lineEnd );
            dos.writeBytes ( twoHyphens + boundary + lineEnd );
            dos.writeBytes ( twoHyphens + boundary + lineEnd );
            dos.writeBytes ( "Content-Disposition: form-data; name='uploaded_file';filename='"
                             + renameFile + "'" + lineEnd );
            dos.writeBytes ( lineEnd );
            bytesAvailable = fileInputStream.available();
            bufferSize = Math.min ( bytesAvailable, maxBufferSize );
            buffer = new byte[bufferSize];
            bytesRead = fileInputStream.read ( buffer, 0, bufferSize );
            while ( bytesRead > 0 ) {
                dos.write ( buffer, 0, bufferSize );
                bytesAvailable = fileInputStream.available();
                bufferSize = Math.min ( bytesAvailable, maxBufferSize );
                bytesRead = fileInputStream.read ( buffer, 0, bufferSize );
            }
            dos.writeBytes ( lineEnd );
            dos.writeBytes ( twoHyphens + boundary + twoHyphens + lineEnd );
            serverResponseCode = conn.getResponseCode();
            String serverResponseMessage = conn.getResponseMessage();
            Log.i ( "uploadFile", "HTTP Response is : " + serverResponseMessage + ": " + serverResponseCode );
            if ( serverResponseCode == 200 ) {
                activity.runOnUiThread ( new Runnable() {
                    public void run() {
                        String message = "File Upload Completed.";
                        Toast.makeText ( activity, message, Toast.LENGTH_SHORT ).show();
                    }
                } );
            }
            fileInputStream.close();
            dos.flush();
            dos.close();
        } catch ( MalformedURLException ex ) {
            dialog.dismiss();
            ex.printStackTrace();
            activity.runOnUiThread ( new Runnable() {
                public void run() {
                    Toast.makeText ( activity, "MalformedURLException : : check script url.", Toast.LENGTH_SHORT ).show();
                }
            } );
            Log.e ( "Upload file to server", "error: " + ex.getMessage(), ex );
        } catch ( Exception e ) {
            dialog.dismiss();
            e.printStackTrace();
            activity.runOnUiThread ( new Runnable() {
                public void run() {
                    Toast.makeText ( activity, "Got Exception : see logcat ", Toast.LENGTH_SHORT ).show();
                }
            } );
            Log.e ( "Upload file to server Exception", "Exception : " + e.getMessage(), e );
        }
        dialog.dismiss();
        return serverResponseCode;
    }
}
