public interface Processable {
    public void process();
}
public class BarMock implements Processable {
    private MyClass clazz;
    private boolean called;
    public BarMock ( MyClass clazz ) {
        this.clazz = clazz;
        called = false;
    }
    @Override
    public void process() {
        called = true;
        clazz.stop();
    }
    public boolean isCalled() {
        return called;
    }
}
public class MyClass implements Runnable {
    boolean running;
    public void run() {
        foo.start();
        work();
        foo.end();
    }
    public void work() {
        running = true;
        while ( running ) {
            bar.process();
        }
    }
    public void stop() {
        running = false;
    }
    public boolean isRunning() {
        return running;
    }
}
