public class DbHelper extends SQLiteOpenHelper {
    private static final int DATABASE_VERSION = 1;
    private static final String DATABASE_NAME = "triviaQuiz";
    private static final String TABLE_QUEST = "quest";
    private static final String KEY_ID = "id";
    private static final String KEY_QUES = "question";
    private static final String KEY_ANSWER = "answer";
    private static final String KEY_OPTA = "opta";
    private static final String KEY_OPTB = "optb";
    private static final String KEY_OPTC = "optc";
    private SQLiteDatabase dbase;
    public DbHelper ( Context context ) {
        super ( context, DATABASE_NAME, null, DATABASE_VERSION );
    }
    @Override
    public void onCreate ( SQLiteDatabase db ) {
        String sql = "CREATE TABLE IF NOT EXISTS " + TABLE_QUEST + " ( "
                     + KEY_ID + " INTEGER PRIMARY KEY AUTOINCREMENT, " + KEY_QUES
                     + " TEXT, " + KEY_ANSWER + " TEXT, " + KEY_OPTA + " TEXT, "
                     + KEY_OPTB + " TEXT, " + KEY_OPTC + " TEXT)";
        db.execSQL ( sql );
        addQuestions ( db );
    }
    private void addQuestions ( SQLiteDatabase db ) {
        Question q1 = new Question ( "Which company is the largest manufacturer" +
                                     " of network equipment?", "HP", "IBM", "CISCO", "C" );
        this.addQuestion ( q1, db );
        Question q2 = new Question ( "Which of the following is NOT " +
                                     "an operating system?", "SuSe", "BIOS", "DOS", "B" );
        this.addQuestion ( q2, db );
        Question q3 = new Question ( "Which of the following is the fastest" +
                                     " writable memory?", "RAM", "FLASH", "Register", "C" );
        this.addQuestion ( q3, db );
        Question q4 = new Question ( "Which of the following device" +
                                     " regulates internet traffic?",    "Router", "Bridge", "Hub", "A" );
        this.addQuestion ( q4, db );
        Question q5 = new Question ( "Which of the following is NOT an" +
                                     " interpreted language?", "Ruby", "Python", "BASIC", "C" );
        this.addQuestion ( q5, db );
    }
    @Override
    public void onUpgrade ( SQLiteDatabase db, int oldV, int newV ) {
        db.execSQL ( "DROP TABLE IF EXISTS " + TABLE_QUEST );
        onCreate ( db );
    }
    public void addQuestion ( Question quest, SQLiteDatabase db ) {
        ContentValues values = new ContentValues();
        values.put ( KEY_QUES, quest.getQUESTION() );
        values.put ( KEY_ANSWER, quest.getANSWER() );
        values.put ( KEY_OPTA, quest.getOPTA() );
        values.put ( KEY_OPTB, quest.getOPTB() );
        values.put ( KEY_OPTC, quest.getOPTC() );
        db.insert ( TABLE_QUEST, null, values );
    }
    public List<Question> getAllQuestions() {
        List<Question> quesList = new ArrayList<Question>();
        String selectQuery = "SELECT  * FROM " + TABLE_QUEST;
        dbase = this.getReadableDatabase();
        Cursor cursor = dbase.rawQuery ( selectQuery, null );
        if ( cursor.moveToFirst() ) {
            do {
                Question quest = new Question();
                quest.setID ( cursor.getInt ( 0 ) );
                quest.setQUESTION ( cursor.getString ( 1 ) );
                quest.setANSWER ( cursor.getString ( 2 ) );
                quest.setOPTA ( cursor.getString ( 3 ) );
                quest.setOPTB ( cursor.getString ( 4 ) );
                quest.setOPTC ( cursor.getString ( 5 ) );
                quesList.add ( quest );
            } while ( cursor.moveToNext() );
        }
        dbase.close();
        return quesList;
    }
    public int rowcount() {
        int row = 0;
        String selectQuery = "SELECT  * FROM " + TABLE_QUEST;
        SQLiteDatabase db = this.getWritableDatabase();
        Cursor cursor = db.rawQuery ( selectQuery, null );
        row = cursor.getCount();
        return row;
    }
}
