mQMatrix = ...;
ImageInputStream imageInputStream = ImageIO.createImageInputStream ( ... );
ImageReader reader = ImageIO.getImageReaders ( imageInputStream ).next();
reader.setInput ( imageInputStream );
mSourceImage = reader.read ( 0 );
IIOMetadata metadata = null;
ImageWriter imageWriter = ImageIO.getImageWritersByFormatName ( "JPEG" ).next();
if ( mQMatrix != null ) {
    dumpMatrices ( mQMatrix );
    metadata = imageWriter.getDefaultImageMetadata ( ImageTypeSpecifier.createFromRenderedImage ( m‌​SourceImage ), null );
    IIOMetadataNode nativeMeta = ( IIOMetadataNode ) metadata.getAsTree ( "javax_imageio_jpeg_image_1.0" );
    NodeList dqtables = nativeMeta.getElementsByTagName ( "dqtable" );
    for ( int i = 0; i < dqtables.getLength(); i++ ) {
        IIOMetadataNode dqt = ( IIOMetadataNode ) dqtables.item ( i );
        int dqtId = Integer.parseInt ( dqt.getAttribute ( "qtableId" ) );
        dqt.setUserObject ( mQMatrix[dqtId] );
    }
    NodeList dhtables = nativeMeta.getElementsByTagName ( "dhtable" );
    JPEGHuffmanTable[] huffmanDcTables = {JPEGHuffmanTable.StdDCLuminance, JPEGHuffmanTable.StdDCChrominance};
    JPEGHuffmanTable[] huffmanAcTables = {JPEGHuffmanTable.StdACLuminance, JPEGHuffmanTable.StdACChrominance};
    for ( int i = 0; i < dhtables.getLength(); i++ ) {
        IIOMetadataNode dht = ( IIOMetadataNode ) dhtables.item ( i );
        int dhtClass = Integer.parseInt ( dht.getAttribute ( "class" ) );
        int dhtId = Integer.parseInt ( dht.getAttribute ( "htableId" ) );
        dht.setUserObject ( dhtClass == 0 ? huffmanDcTables[dhtId] : huffmanAcTables[dhtId] );
    }
    metadata.mergeTree ( "javax_imageio_jpeg_image_1.0", nativeMeta );
}
ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
ImageOutputStream imageOutputStream = ImageIO.createImageOutputStream ( outputStream );
imageWriter.setOutput ( imageOutputStream );
JPEGImageWriteParam params = new JPEGImageWriteParam ( null );
params.setCompressionMode ( metadata == null ? MODE_DEFAULT : MODE_COPY_FROM_METADATA );
imageWriter.write ( null, new IIOImage ( mSourceImage, null, metadata ), params );
imageOutputStream.close();
mCompressedImageSize = outputStream.size();
try ( FileOutputStream fileOutputStream = new FileOutputStream ( mOutFileName ) ) {
    fileOutputStream.write ( outputStream.toByteArray() );
}
mCompressedImage = ImageIO.read ( new ByteArrayInputStream ( outputStream.toByteArray() ) );
