GoogleMap mMap;
@Override
protected void onStart() {
    super.onStart();
    mMap = ( ( MapFragment ) getFragmentManager().findFragmentById ( R.id.map ) ).getMap();
    mMap.setMyLocationEnabled ( true );
    mMap.setOnMyLocationChangeListener ( new GoogleMap.OnMyLocationChangeListener() {
        @Override
        public void onMyLocationChange ( Location location ) {
            LatLng loc = new LatLng ( location.getLatitude(), location.getLongitude() );
            float accuracy = location.getAccuracy() * 2;
            DisplayMetrics metrics = new DisplayMetrics();
            getWindowManager().getDefaultDisplay().getMetrics ( metrics );
            int screenSize = Math.min ( metrics.widthPixels, metrics.heightPixels );
            long equator = 40075004;
            double requiredMpp = accuracy / screenSize;
            double zoomLevel = ( ( Math.log ( equator / ( 256 * requiredMpp ) ) ) / Math.log ( 2 ) ) + 1;
            Log.e ( TAG, String.format ( "Accuracy: %f. Screen Width: %d, Height: %d",
                                         accuracy, metrics.widthPixels, metrics.heightPixels ) );
            Log.e ( TAG, String.format ( "Required M/Px: %f Zoom Level: %f Approx Zoom Level: %d",
                                         requiredMpp, zoomLevel, calculateZoomLevel ( screenSize, accuracy ) ) );
            mMap.animateCamera ( CameraUpdateFactory.newLatLngZoom ( loc, ( float ) zoomLevel ) );
            mMap.setOnMyLocationChangeListener ( null );
        }
    } );
}
private int calculateZoomLevel ( int screenWidth, float accuracy ) {
    double equatorLength = 40075004;
    double metersPerPixel = equatorLength / 256;
    int zoomLevel = 1;
    while ( ( metersPerPixel * ( double ) screenWidth ) > accuracy ) {
        metersPerPixel /= 2;
        zoomLevel++;
    }
    return zoomLevel;
}
