public List<Map<String, Object>> valueList ( String dataSource, Object[] params, String sql ) throws DataAccessException {
    Connection con = null;
    PreparedStatement ps = null;
    ResultSet rs = null;
    Clob clob = null;
    try {
        con = dataSource.getConnection();
        ps = con.prepareStatement ( "SELECT samplefield FROM sampletable WHERE SDE.ST_INTERSECTS(SHAPE, SDE.ST_GEOMETRY(?, ?)) = 1 AND SHAPE IS NOT NULL" );
        Clob clob = OracleUtils.createTemporaryCLOB ( conn, true, 10 );
        clob.setString ( 1, ( String ) params[0] );
        ps.setClob ( 1, clob );
        ps.setObject ( 2, params[1], java.sql.Types.INTEGER );
        rs = ps.executeQuery();
        List<Map<String, Object>> out = new LinkedList()
        while ( rs.next() ) {
            Map<String, Object> oneBindingMap = new HashMap ( 1 );
            oneBindingMap.put ( "samplefield", rs.getObject ( 1 ) );
            out.add ( oneBindingMap );
        }
        return out;
    } catch ( SQLException e ) {
        throw new DataAccessException ( e.getMessage(), e );
    } finally {
        try {
            if ( clob != null ) {
                clob.free();
            }
        } catch ( Exception e ) {
            e.printStackTrace();
        }
        try {
            if ( rs != null ) {
                rs.close();
            }
        } catch ( Exception e ) {
            e.printStackTrace();
        }
        try {
            if ( ps != null ) {
                ps.close();
            }
        } catch ( Exception e ) {
            e.printStackTrace();
        }
        try {
            if ( con != null ) {
                con.close();
            }
        } catch ( Exception e ) {
            e.printStackTrace();
        }
    }
}
