@Bean
public ServletContextTemplateResolver templateResolver() {
    ServletContextTemplateResolver templateResolver = new ServletContextTemplateResolver();
    templateResolver.setCacheable ( false );
    templateResolver.setPrefix ( "/WEB-INF/jsp/" );
    templateResolver.setSuffix ( ".jsp" );
    templateResolver.setTemplateMode ( "HTML5" );
    return templateResolver;
}
@Bean
public SpringTemplateEngine templateEngine() {
    SpringTemplateEngine templateEngine = new SpringTemplateEngine();
    templateEngine.setTemplateResolver ( templateResolver() );
    return templateEngine;
}
@Bean
public ViewResolver viewResolver() {
    ThymeleafViewResolver viewResolver = new ThymeleafViewResolver();
    viewResolver.setTemplateEngine ( templateEngine() );
    viewResolver.setCharacterEncoding ( "UTF-8" );
    viewResolver.setOrder ( 1 );
    return viewResolver;
}
