public DefaultMutableTreeNode addNodes ( File dir, String filter )
throws Exception {
    DefaultMutableTreeNode node = new DefaultMutableTreeNode ( dir );
    boolean matchFound = false;
    for ( File file : dir.listFiles() ) {
        if ( file.isDirectory() ) {
            if ( file.getName().contains ( filter ) ) {
                matchFound = true;
            }
            DefaultMutableTreeNode maybeNode = addNodes ( file, filter );
            if ( maybeNode != null ) {
                matchFound = true;
                node.add ( maybeNode );
            }
        } else {
            String tmpContent = FileUtils.readFileToString ( file );
            if ( file.getName().contains ( filter )
                    || tmpContent.contains ( filter ) ) {
                matchFound = true;
                log ( "adding file: " + file.toString() );
                node.add ( new DefaultMutableTreeNode ( file ) );
            }
        }
    }
    if ( matchFound || dir.getName().contains ( filter ) ) {
        return node;
    }
    return null;
}
