public class EventHandlerRepository {
    private Object lock = new Object();
    private Map<EventType, EventHandler> handlers;
    public EventHandlerRepository() {
        handlers = new HashMap<EventType, EventHandler>();
    }
    void registerHandler ( EventType type, EventHandler handler ) {
        synchronized ( lock ) {
            handlers.put ( type, handler );
        }
    }
    public EventHandler getHandler ( EventType type ) {
        synchronized ( lock ) {
            return handlers.get ( type );
        }
    }
}
