public class Node {
    public final Graph graph;
    private int id;
    private boolean visited;
    public Node ( Graph g, int i, boolean v ) {
        graph = g;
        id = i;
        visited = v;
        graph.addNode ( this );
    }
    public int getId() {
        return id;
    }
    public void setVisited ( boolean v ) {
        visited = v;
    }
    public boolean isVisited() {
        return visited;
    }
    public Set<Node> getNeighbors() {
        return graph.neighborsOf ( this );
    }
}
public class Graph {
    private HashMap<Node, HashSet<Node>> graph;
    public Graph() {
        graph = new HashMap<Node, HashSet<Node>>();
    }
    public void addNode ( Node n ) throws IllegalArgumentException {
        if ( n.graph != this ) {
            throw new IllegalArgumentException ( n + " belongs to " + n.graph ", not " + this );
        }
        if ( ! graph.contains ( n ) ) {
            graph.put ( n, new HashSet<Node>() );
        }
    }
    public Set<Node> neighborsOf ( Node n ) {
        if ( ! graph.contains ( n ) ) {
            return null;
        }
        return graph.get ( n );
    }
    public void makeConnection ( Node source, Node sink ) {
        addNode ( source );
        addNode ( sink );
        graph.get ( source ).add ( sink );
    }
}
