package com.example.pickmymovie;
import java.io.IOException;
import java.util.ArrayList;
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.database.Cursor;
import android.database.SQLException;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.widget.ProgressBar;
public class LoadingActivity extends Activity {
    private ProgressBar bar;
    @Override
    protected void onCreate ( Bundle savedInstanceState ) {
        super.onCreate ( savedInstanceState );
        setContentView ( R.layout.loading );
        bar = ( ProgressBar ) findViewById ( R.id.progress1 );
        bar.setMax ( 10000 );
        LoadingTask task = new LoadingTask ( this );
        task.execute();
    }
    private class LoadingTask extends AsyncTask<Cursor, Integer, Boolean> {
        private Cursor cursor;
        private ArrayList<Movie> movieList;
        private DataBaseHelper DbHelper;
        private Context context;
        public LoadingTask ( Context context ) {
            this.context = context;
        }
        @Override
        protected void onPreExecute() {
            DbHelper = new DataBaseHelper ( context );
            try {
                DbHelper.createDataBase();
            } catch ( IOException e ) {
                e.printStackTrace();
            }
            try {
                DbHelper.openDataBase();
            } catch ( SQLException sqle ) {
                throw sqle;
            }
            cursor = DbHelper.getCursor();
        }
        @Override
        protected Boolean doInBackground ( Cursor... param ) {
            int total = cursor.getCount();
            int margin = 10000 / total;
            movieList = new ArrayList<Movie>();
            for ( int i = 0; i < cursor.getCount(); i++ ) {
                if ( cursor.moveToFirst() ) {
                    do {
                        Movie movie = new Movie();
                        movie.setId ( Integer.parseInt ( cursor.getString ( 0 ) ) );
                        movie.setName ( cursor.getString ( 1 ) );
                        movie.setGenre ( cursor.getString ( 2 ) );
                        movie.setImage ( cursor.getString ( 3 ) );
                        movie.setRating ( Integer.parseInt ( cursor.getString ( 4 ) ) );
                        movieList.add ( movie );
                        publishProgress ( i * margin );
                    } while ( cursor.moveToNext() );
                }
            }
            return true;
        }
        @Override
        protected void onCancelled() {
        }
        protected void publishProgress ( Integer progress ) {
            bar.setProgress ( progress );
        }
        @Override
        protected void onPostExecute ( Boolean result ) {
            if ( result ) {
                Intent intent = new Intent ( LoadingActivity.this, MainActivity.class );
                intent.putParcelableArrayListExtra ( "movies", movieList );
                Log.w ( "movies", movieList.get ( 0 ).title() );
                startActivity ( intent );
            }
        }
    }
}
