public class ServerCommunicationHandler extends ChannelInboundHandlerAdapter {
    private final ChannelGroup channels = new DefaultChannelGroup ( GlobalEventExecutor.INSTANCE );
    @Override
    public void channelActive ( ChannelHandlerContext ctx ) throws Exception {
        channels.add ( ctx.channel() );
        ctx.fireChannelActive();
    }
    @Override
    public void channelRead ( ChannelHandlerContext ctx, Object msg ) throws Exception {
        broadcastMessage ( msg );
        ctx.fireChannelRead ( msg );
    }
    @Override
    public void channelInactive ( ChannelHandlerContext ctx ) throws Exception {
        channels.remove ( ctx.channel() );
        ctx.fireChannelInactive();
    }
    public void broadcastMessage ( Object object ) {
        channels.writeAndFlush ( object );
    }
}
