import java.lang.reflect.Array;
public class ArrayTransfer {
    private static int getArrayDimension ( Object array ) {
        Class<?> clazz = array.getClass();
        int dimension = 0;
        while ( clazz.isArray() ) {
            clazz = clazz.getComponentType();
            dimension += 1;
        }
        if ( clazz != boolean.class ) {
            throw new IllegalArgumentException ( "Base array type not boolean" );
        }
        return dimension;
    }
    private static Object transferToIntArray ( Object booleanArray, int dimension ) {
        if ( booleanArray == null ) {
            return null;
        }
        Class<?> componentType;
        if ( dimension == 1 ) {
            componentType = int.class;
        } else {
            int[] allZeroDimensions = new int[dimension - 1];
            componentType = Array.newInstance ( int.class, allZeroDimensions ).getClass();
        }
        int length = Array.getLength ( booleanArray );
        Object newArray = Array.newInstance ( componentType, length );
        for ( int i = 0; i < length; ++i ) {
            if ( dimension == 1 ) {
                Boolean value = ( Boolean ) Array.get ( booleanArray, i );
                Array.set ( newArray, i, ( value.booleanValue() ) ? 1 : 0 );
            } else {
                Object oldChildArray = Array.get ( booleanArray, i );
                Object newChildArray = transferToIntArray ( oldChildArray, dimension - 1 );
                Array.set ( newArray, i, newChildArray );
            }
        }
        return newArray;
    }
    public static Object transferToIntArray ( Object booleanArray ) {
        if ( booleanArray == null ) {
            return null;
        }
        int dimension = getArrayDimension ( booleanArray );
        return transferToIntArray ( booleanArray, dimension );
    }
}
