import java.util.function.Consumer;
public interface WindowBridge {
    public abstract class WindowOpened extends WindowAdapter {
        public abstract void windowOpened ( Event e );
    }
    public static WindowOpened windowOpened ( Consumer<Event> c ) {
        return new WindowOpened() {
            public void windowOpened ( Event e ) {
                c.accept ( e );
            }
        };
    }
    public abstract class WindowClosing extends WindowAdapter {
        public abstract void windowClosing ( Event e );
    }
    public static WindowClosing windowClosing ( Consumer<Event> c ) {
        return new WindowClosing() {
            public void windowClosing ( Event e ) {
                c.accept ( e );
            }
        };
    }
}
