class Link {
    public int data1;
    public double data2;
    public Link nextLink;
    public Link ( int d1, double d2 ) {
        data1 = d1;
        data2 = d2;
    }
    public void printLink() {
        System.out.print ( "{" + data1 + ", " + data2 + "} " );
    }
}
class LinkList {
    private Link first;
    public LinkList() {
        first = null;
    }
    public boolean isEmpty() {
        return first == null;
    }
    public void insert ( int d1, double d2 ) {
        Link link = new Link ( d1, d2 );
        link.nextLink = first;
        first = link;
    }
    public Link delete() {
        Link temp = first;
        first = first.nextLink;
        return temp;
    }
    public void printList() {
        Link currentLink = first;
        System.out.print ( "List: " );
        while ( currentLink != null ) {
            currentLink.printLink();
            currentLink = currentLink.nextLink;
        }
        System.out.println ( "" );
    }
}
class LinkListTest {
    public static void main ( String[] args ) {
        LinkList list = new LinkList();
        list.insert ( 1, 1.01 );
        list.insert ( 2, 2.02 );
        list.insert ( 3, 3.03 );
        list.insert ( 4, 4.04 );
        list.insert ( 5, 5.05 );
        list.printList();
        while ( !list.isEmpty() ) {
            Link deletedLink = list.delete();
            System.out.print ( "deleted: " );
            deletedLink.printLink();
            System.out.println ( "" );
        }
        list.printList();
    }
}
