public class SkillsSet<T extends SkillType> {
    private Map<T, Integer> skills = new HashMap<>();
    private T[] enumConstants;
    private Class<T> enumClass;
    public SkillsSet ( String[] skills, Class<T> enumClass ) {
        enumConstants = enumClass.getEnumConstants();
        if ( enumConstants == null ) {
            throw new IllegalArgumentException ( "enumClass is not an enum" );
        }
        for ( String string : skills ) {
            T t = getEnumValue ( string )
            if ( t == null ) {
                throw new IllegalArgumentException();
            }
            this.skills.put ( t, t.getPenalty() );
        }
    }
    @SuppressWarnings ( "unchecked" )
    public T getEnumValue ( String string ) {
        try {
            return ( T ) enumConstants[0].fromValue ( string );
        } catch ( IllegalArgumentException e ) {
            return null;
        }
    }
    @SuppressWarnings ( "unchecked" )
    public T getEnumValueAlternate ( String string ) {
        try {
            return ( T ) enumClass.getMethod ( "valueOf", String.class ).invoke ( null, string )
        } catch ( Exception e ) {
            return null;
        }
    }
    ...
}
