protected void start() {
    ServerSocket s;
    System.out.println ( "Webserver starting up on port 8181" );
    System.out.println ( "(press ctrl-c to exit)" );
    try {
        s = new ServerSocket ( 8181 );
    } catch ( Exception e ) {
        System.out.println ( "Error: " + e );
        return;
    }
    for ( ;; ) {
        System.out.println ( "Waiting for connection" );
        try {
            Socket remote = s.accept();
            System.out.println ( "Connection established." );
            BufferedReader in = new BufferedReader ( new InputStreamReader ( remote.getInputStream() ) );
            PrintWriter out = new PrintWriter ( remote.getOutputStream() );
            String tokens[] = in.readLine().split ( "\\s+" ) ;
            if ( tokens.length != 3 ) {
                out.println ( "HTTP/1.0 400 Bad Request" );
                out.println ( "Connection: close" );
                out.println ( "" );
                out.flush();
                remote.close();
                continue;
            }
            if ( ( tokens[2].compareToIgnoreCase ( "HTTP/1.0" ) != 0 ) &&
                    ( tokens[2].compareToIgnoreCase ( "HTTP/1.1" ) != 0 ) ) {
                out.println ( "HTTP/1.0 505 HTTP Version Not Supported" );
                out.println ( "Connection: close" );
                out.println ( "" );
                out.flush();
                remote.close();
                continue;
            }
            if ( tokens[0].compareToIgnoreCase ( "GET" ) != 0 ) {
                out.println ( "HTTP/1.0 405 Method Not Allowed" );
                out.println ( "Connection: close" );
                out.println ( "" );
                out.flush();
                remote.close();
                continue;
            }
            String path = tokens[1];
            String query = null;
            int idx = path.indexOf ( '?' );
            if ( idx != -1 ) {
                query = path.substring ( idx + 1 );
                file = path.substring ( 0, idx );
            }
            if ( path != "/pic" ) {
                out.println ( "HTTP/1.0 404 Not Found" );
                out.println ( "Connection: close" );
                out.println ( "" );
                out.flush();
                remote.close();
                continue;
            }
            out.println ( "HTTP/1.0 200 OK" );
            out.println ( "Connection: close" );
            out.println ( "Content-Type: ..." );
            out.println ( "Content-Length: ..." );
            out.println();
            out.flush();
            remote.close();
        } catch ( Exception e ) {
            System.out.println ( "Error: " + e );
        }
    }
}
