public static void main ( String[] args ) {
    float[][] f = { { 2, 2, 3, 3 }, { 2, 2, 3, 3 }, { 0, 0, 1, 1 }, { 0, 0, 1, 1 } };
    float[][] f2 = splitHeightMap ( f, TerrainQuadrant.BotttomRight );
    for ( float[] floats : f2 ) {
        System.out.println ( Arrays.toString ( floats ) );
    }
}
protected static float[][] splitHeightMap ( float[][] heightMap, TerrainQuadrant quadrant ) {
    int newSize = heightMap.length >> 1;
    float[][] newHeightMap = new float[ newSize ][ newSize ];
    int xOffset = 0;
    int yOffset = newSize;
    int xRestriction = newSize;
    int yRestriction = heightMap.length;
    switch ( quadrant ) {
    case BottomRight:
        xOffset = newSize;
        yOffset = newSize;
        xRestriction = heightMap.length;
        break;
    case TopLeft:
        yOffset = 0;
        yRestriction = newSize;
        break;
    case TopRight:
        yOffset = 0;
        xOffset = newSize;
        xRestriction = heightMap.length;
        yRestriction = newSize;
        break;
    default:
        break;
    }
    int xCount = 0, yCount = 0;
    for ( int y = yOffset; y < yRestriction; y++ ) {
        float[] row = heightMap[ y ];
        for ( int x = xOffset; x < xRestriction; x++ ) {
            float value = row[ x ];
            newHeightMap[ yCount ][ xCount ] = value;
            xCount++;
        }
        xCount = 0;
        yCount++;
    }
    return newHeightMap;
}
