import javafx.beans.property.SimpleStringProperty;
import javafx.beans.property.StringProperty;
import javafx.collections.FXCollections;
import javafx.fxml.FXML;
import javafx.scene.control.TableView;
public class TableController {
    @FXML
    private TableView<Person> table ;
    @FXML
    public void populateTable() {
        table.setItems ( FXCollections.observableArrayList (
                             new Person ( "Jacob", "Smith" ),
                             new Person ( "Isabella", "Johnson" ),
                             new Person ( "Ethan", "Williams" ),
                             new Person ( "Emma", "Jones" ),
                             new Person ( "Michael", "Brown" )
                         ) );
    }
    @FXML
    public void clearTable() {
        table.getItems().clear();
    }
    public static class Person {
        private final StringProperty firstName = new SimpleStringProperty ( this, "firstName" );
        public StringProperty firstNameProperty() {
            return firstName ;
        }
        public final String getFirstName() {
            return firstName.get();
        }
        public final void setFirstName ( String firstName ) {
            this.firstName.set ( firstName );
        }
        private final StringProperty lastName = new SimpleStringProperty ( this, "lastName" );
        public StringProperty lastNameProperty() {
            return lastName ;
        }
        public final String getLastName() {
            return lastName.get();
        }
        public final void setLastName ( String lastName ) {
            this.lastName.set ( lastName );
        }
        public Person ( String firstName, String lastName ) {
            setFirstName ( firstName );
            setLastName ( lastName );
        }
    }
}
