import java.awt.EventQueue;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JProgressBar;
import javax.swing.Timer;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
@SuppressWarnings ( "serial" )
public class ProgressBar extends JFrame {
    private int c = 0;
    private Timer t;
    private JButton btn;
    private JProgressBar pBar;
    private final int waitingTime = 15 * 60 * 1000;
    private final int delay = waitingTime / 100;
    public ProgressBar() {
        setLayout ( new FlowLayout() );
        t = new Timer ( delay, new ActionListener() {
            @Override
            public void actionPerformed ( ActionEvent e ) {
                if ( c <= 100 ) {
                    pBar.setValue ( ++c );
                }
            }
        } );
        btn = new JButton ( "WAIT" );
        btn.addActionListener ( new ActionListener() {
            @Override
            public void actionPerformed ( ActionEvent e ) {
                t.start();
            }
        } );
        add ( btn );
        pBar = new JProgressBar ( 0, 100 );
        pBar.setValue ( c );
        pBar.setStringPainted ( true );
        pBar.addChangeListener ( new ChangeListener() {
            @Override
            public void stateChanged ( ChangeEvent e ) {
                if ( pBar.getValue() == 100 ) {
                    t.stop();
                    JOptionPane.showMessageDialog ( null, "Your order is ready!" );
                    c = 0;
                    pBar.setValue ( c );
                }
            }
        } );
        add ( pBar );
        pack();
        setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
        setVisible ( true );
        setLocationRelativeTo ( null );
    }
    public static void main ( String[] args ) {
        EventQueue.invokeLater ( new Runnable() {
            public void run() {
                try {
                    new ProgressBar();
                } catch ( Exception ex ) {
                    JOptionPane.showMessageDialog ( null, "Fatal Error." );
                }
            }
        } );
    }
}
