class MySQLCategoryDAO extends SwingWorker<Void, Category> {
    private List<Category> list;
    MySQLCategoryDAO ( Job job, List<Category> list ) {
        this.list = list;
    }
    @Override
    protected Void doInBackground() {
        while ( results.next() ) {
            int id = results.getInt ( "id" );
            String name = results.getString ( "name" );
            publish ( new Category ( id, name ) );
        }
        return null;
    }
    @Override
    protected void process ( List<Category> chunks ) {
        list.addAll ( chunks );
    }
}
public void load() throws Exception {
    people.clear();
    DAOFactory factory = DAOFactory.getFactory ( DAOFactory.MYSQL );
    CategoryDAO personDAO = factory.getCategoryDAO();
    new MySQLCategoryDAO ( Job.SELECT, people ).execute();
}
