final String wkt = "http://www.opengis.net/ont/geosparql#wktLiteral";
final StreamRDF outputHandler = StreamRDFLib.writer ( System.out );
StreamRDF inputHandler = new StreamRDFBase() {
    @Override
    public void triple ( Triple triple ) {
        Node object = triple.getObject();
        Node transformed;
        if ( object.isLiteral() &&
                wkt.equals ( object.getLiteralDatatypeURI() ) ) {
            transformed = NodeFactory.createLiteral (
                              "<http://www.opengis.net/def/crs/EPSG/0/4326> "
                              + object.getLiteralLexicalForm(),
                              object.getLiteralDatatype() );
        } else {
            transformed = object;
        }
        outputHandler.triple (
            Triple.create ( triple.getSubject(), triple.getPredicate(),
                            transformed
                          ) );
    }
};
RDFDataMgr.parse ( inputHandler, RDFDataMgr.open ( "file" ) );
