public abstract class JAXBGenerateTest extends AbstractMojoTestCase {
    static {
        System.setProperty ( "basedir", getBaseDir().getAbsolutePath() );
    }
    protected MavenProjectBuilder mavenProjectBuilder;
    protected void setUp() throws Exception {
        super.setUp();
        mavenProjectBuilder = ( MavenProjectBuilder ) getContainer().lookup (
                                  MavenProjectBuilder.ROLE );
    }
    protected static File getBaseDir() {
        ...
    }
    public void testExecute() throws Exception {
        final File pom = new File ( getBaseDir(),
                                    "src/test/resources/test-pom.xml" );
        final ArtifactRepository localRepository = new DefaultArtifactRepository ( "local",
                new File ( getBaseDir(), "target/test-repository" ).toURI().toURL().toString()             , new DefaultRepositoryLayout() );
        final MavenProject mavenProject = mavenProjectBuilder.build ( pom, localRepository, null );
        final XJC2Mojo generator = ( XJC2Mojo ) lookupMojo ( "generate", pom );
        generator.setProject ( mavenProject );
        generator.setLocalRepository ( localRepository );
        generator.setSchemaDirectory ( new File ( getBaseDir(), "src/test/resources/" ) );
        generator.setSchemaIncludes ( new String[] { "*.xsd" } );
        generator.setBindingIncludes ( new String[] { "*.xjb" } );
        generator.setGenerateDirectory ( new File ( getBaseDir(), "target/test/generated-sources" ) );
        generator.setVerbose ( true );
        generator.setGeneratePackage ( "unittest" );
        generator.setRemoveOldOutput ( false );
        generator.execute();
    }
}
