public class ExampleAdapter extends BaseAdapter {
    private final LayoutInflater inflater;
    private final List<Item> items;
    private ExampleAdapter ( Context context, List<Item> items ) {
        this.inflater = LayoutInflater.from ( context );
        this.items = items;
    }
    @Override
    public int getCount() {
        return this.items.size();
    }
    @Override
    public Item getItem ( int position ) {
        return this.items.get ( position );
    }
    @Override
    public long getItemId ( int position ) {
        return this.items.get ( position ).hashCode();
    }
    @Override
    public View getView ( int position, View convertView, ViewGroup parent ) {
        final Item item = getItem ( position );
        if ( convertView == null ) {
            convertView = this.inflater.inflate ( R.layout.example_list_item, parent, false );
            final ViewHolder viewHolder = new ViewHolder();
            viewHolder.tvDisplayText = ( TextView ) convertView.findViewById ( R.id.tvDisplayText );
            viewHolder.tvMeta = ( TextView ) convertView.findViewById ( R.id.tvMeta );
            convertView.setTag ( viewHolder );
        }
        final ViewHolder viewHolder = ( ViewHolder ) convertView.getTag();
        viewHolder.tvDisplayText.setText ( item.getDisplayText() );
        viewHolder.tvMeta.setText ( item.getMeta() );
        return convertView;
    }
}
