public static void main ( String[] args ) {
    Path myFile = Paths.get ( System.getProperty ( "user.home" ), "Desktop", "tester.xlsx" );
    try {
        XSSFWorkbook wb = new XSSFWorkbook ( new FileInputStream ( myFile.toFile() ) );
        XSSFSheet sheet = wb.getSheetAt ( 0 );
        makeRowBold ( wb, sheet.getRow ( 0 ) );
        wb.write ( new FileOutputStream ( myFile.toFile() ) );
    } catch ( IOException e ) {
        e.printStackTrace();
    }
}
public static void makeRowBold ( Workbook wb, Row row ) {
    CellStyle style = wb.createCellStyle();
    Font font = wb.createFont();
    font.setBoldweight ( Font.BOLDWEIGHT_BOLD );
    style.setFont ( font );
    for ( int i = 0; i < row.getLastCellNum(); i++ ) {
        row.getCell ( i ).setCellStyle ( style );
    }
}
