public final class ScrollUtil {
    public static final int NONE = 0, TOP = 1, VCENTER = 2, BOTTOM = 4, LEFT = 8, HCENTER = 16, RIGHT = 32;
    private static final int OFFSET = 100;
    private ScrollUtil() {
    }
    public static void scroll ( JComponent c, int part ) {
        scroll ( c, part & ( LEFT | HCENTER | RIGHT ), part & ( TOP | VCENTER | BOTTOM ) );
    }
    public static void scroll ( JComponent c, int horizontal, int vertical ) {
        Rectangle visible = c.getVisibleRect();
        Rectangle bounds = c.getBounds();
        switch ( vertical ) {
        case TOP:
            visible.y = 0;
            break;
        case VCENTER:
            visible.y = ( bounds.height - visible.height ) / 2;
            break;
        case BOTTOM:
            visible.y = bounds.height - visible.height + OFFSET;
            break;
        }
        switch ( horizontal ) {
        case LEFT:
            visible.x = 0;
            break;
        case HCENTER:
            visible.x = ( bounds.width - visible.width ) / 2;
            break;
        case RIGHT:
            visible.x = bounds.width - visible.width + OFFSET;
            break;
        }
        c.scrollRectToVisible ( visible );
    }
}
