public class MainActivity extends Activity {
    private GoogleMap googleMap;
    @Override
    protected void onCreate ( Bundle savedInstanceState ) {
        super.onCreate ( savedInstanceState );
        setContentView ( R.layout.layout );
        try {
            initilizeMap();
            googleMap.setMapType ( GoogleMap.MAP_TYPE_NORMAL );
            googleMap.setMyLocationEnabled ( true );
            googleMap.getUiSettings().setZoomControlsEnabled ( false );
            googleMap.getUiSettings().setMyLocationButtonEnabled ( true );
            googleMap.getUiSettings().setCompassEnabled ( true );
            googleMap.getUiSettings().setRotateGesturesEnabled ( true );
            googleMap.getUiSettings().setZoomGesturesEnabled ( true );
            double latitude = 21.3235752;
            double longitude = 74.1881265;
            double[] randomLocation = createRandLocation ( latitude,
                                      longitude );
            MarkerOptions marker = new MarkerOptions().position (
                new LatLng ( randomLocation[0], randomLocation[1] ) )
            .title ( " Mapview Test " );
            marker.icon ( BitmapDescriptorFactory.fromResource ( R.drawable.marker ) );
            googleMap.addMarker ( marker );
            CameraPosition cameraPosition = new CameraPosition.Builder()
            .target ( new LatLng ( randomLocation[0],
                                   randomLocation[1] ) ).zoom ( 15 ).build();
            googleMap.animateCamera ( CameraUpdateFactory
                                      .newCameraPosition ( cameraPosition ) );
        } catch ( Exception e ) {
            e.printStackTrace();
        }
    }
    @Override
    protected void onResume() {
        super.onResume();
        initilizeMap();
    }
    @SuppressLint ( "NewApi" )
    private void initilizeMap() {
        if ( googleMap == null ) {
            googleMap = ( ( MapFragment ) getFragmentManager().findFragmentById (
                              R.id.map ) ).getMap();
            if ( googleMap == null ) {
                Toast.makeText ( getApplicationContext(),
                                 "Sorry! unable to create maps", Toast.LENGTH_SHORT )
                .show();
            }
        }
    }
    private double[] createRandLocation ( double latitude, double longitude ) {
        return new double[] { latitude + ( ( Math.random() - 0.5 ) / 500 ),
                              longitude + ( ( Math.random() - 0.5 ) / 500 ),
                              150 + ( ( Math.random() - 0.5 ) * 10 )
                            };
    }
}
