public class Main {
    private BufferedReader userInput;
    private String testString;
    public static void main ( final String args[] ) {
        BufferedReader userInput = new BufferedReader ( new InputStreamReader ( System.in ) );
        Main test = new Main ( userInput );
        test.getTestString();
        test.removeOsWithRegex();
        test.removeOsByReplacingWithX();
        test.removeOsByInLoopDeletion();
    }
    public Main ( final BufferedReader userInput ) {
        this.userInput = userInput;
    }
    private void getTestString() {
        System.out.print ( "Enter Test String: " );
        try {
            testString = userInput.readLine();
            testString = "." + testString + ".";
        } catch ( IOException e ) {
            throw new IllegalStateException ( "Something wrong happened: " + e.getMessage() + ". Shutting down." );
        }
    }
    private void removeOsWithRegex() {
        System.out.println ( "Removing 'O' with regexp from: " + testString );
        String resultString = testString.replaceAll ( "[O]+X", "X" ).replaceAll ( "X[O]+", "X" );
        int count = resultString.length() - resultString.replace ( "O", "" ).length();
        System.out.println ( "Result string:  " + resultString );
        System.out.println ( "Total 'O' left:  " + count );
    }
    public void removeOsByReplacingWithX() {
        System.out.println ( "Removing 'O' by replacing them with X: " + testString );
        byte[] byteArray = testString.getBytes();
        boolean changesMade;
        do {
            changesMade = false;
            for ( int i = 1; i < byteArray.length - 1; i++ ) {
                if ( byteArray[i] == 'X' ) {
                    if ( byteArray[i - 1] == 'O' ) {
                        byteArray[i - 1] = 'X';
                        changesMade = true;
                    }
                    if ( byteArray[i + 1] == 'O' ) {
                        byteArray[i + 1] = 'X';
                        changesMade = true;
                    }
                }
            }
        } while ( changesMade );
        String resultString = new String ( byteArray );
        int count = resultString.length() - resultString.replace ( "O", "" ).length();
        System.out.println ( "Result string:  " + resultString );
        System.out.println ( "Total 'O' left:  " + count );
    }
    public void removeOsByInLoopDeletion() {
        System.out.println ( "Removing 'O' by deleting them in loop: " + testString );
        byte[] byteArray = testString.getBytes();
        boolean changesMade;
        do {
            changesMade = false;
            for ( int i = 1; i < byteArray.length - 1; i++ ) {
                if ( byteArray[i] == 'X' ) {
                    if ( byteArray[i + 1] == 'O' ) {
                        byteArray = shortenByteArray ( byteArray, i + 1 );
                        changesMade = true;
                        break;
                    }
                }
                if ( byteArray[i] == 'O' ) {
                    if ( byteArray[i + 1] == 'X' ) {
                        byteArray = shortenByteArray ( byteArray, i );
                        changesMade = true;
                        break;
                    }
                }
            }
        } while ( changesMade );
        String resultString = new String ( byteArray );
        int count = resultString.length() - resultString.replace ( "O", "" ).length();
        System.out.println ( "Result string:  " + resultString );
        System.out.println ( "Total 'O' left:  " + count );
    }
    private byte[] shortenByteArray ( final byte[] byteArray, final Integer startIndex ) {
        byte[] newByteArray = new byte[byteArray.length - 1];
        for ( int i = 0; i < newByteArray.length; i++ ) {
            if ( i < startIndex ) {
                newByteArray[i] = byteArray[i];
            } else {
                newByteArray[i] = byteArray[i + 1];
            }
        }
        return newByteArray;
    }
}
