public class AppConfigDeserializer implements JsonDeserializer<List<Config>> {
    @Override
    public List<Config> deserialize ( JsonElement json, Type typeOfT,
                                      JsonDeserializationContext context ) throws JsonParseException {
        json = Objects.requireNonNull ( json );
        List<Config> configs = new ArrayList<>();
        if ( JsonArray.class.isAssignableFrom ( json.getClass() ) ) {
            JsonArray jsonArray = ( JsonArray ) json;
            for ( JsonElement jsonElement : jsonArray ) {
                JsonObject jsonObject = ( JsonObject ) jsonElement.getAsJsonObject();
                configs.add (
                    new Config (
                        jsonObject.get ( "appName" ) != null ?
                        jsonObject.get ( "appName" ).getAsString() : null,
                        jsonObject.get ( "propertyName" ) != null ?
                        jsonObject.get ( "propertyName" ).getAsString() : null,
                        jsonObject.get ( "propertyValue" ) != null ?
                        jsonObject.get ( "propertyValue" ).getAsString() : null,
                        jsonObject.get ( "propertyDescription" ) != null ?
                        jsonObject.get ( "propertyDescription" ).getAsString() : null,
                        jsonObject.get ( "editable" ) != null ?
                        jsonObject.get ( "editable" ).getAsBoolean() : false,
                        jsonObject.get ( "updated" ) != null ?
                        jsonObject.get ( "updated" ).getAsBoolean() : false ) );
            }
        } else if ( JsonObject.class.isAssignableFrom ( json.getClass() ) ) {
            JsonObject jsonObject = ( JsonObject ) json.getAsJsonObject();
            configs.add ( new Config (
                              jsonObject.get ( "appName" ) != null ?
                              jsonObject.get ( "appName" ).getAsString() : null,
                              jsonObject.get ( "propertyName" ) != null ?
                              jsonObject.get ( "propertyName" ).getAsString() : null,
                              jsonObject.get ( "propertyValue" ) != null ?
                              jsonObject.get ( "propertyValue" ).getAsString() : null,
                              jsonObject.get ( "propertyDescription" ) != null ?
                              jsonObject.get ( "propertyDescription" ).getAsString() : null,
                              jsonObject.get ( "editable" ) != null ?
                              jsonObject.get ( "editable" ).getAsBoolean() : false,
                              jsonObject.get ( "updated" ) != null ?
                              jsonObject.get ( "updated" ).getAsBoolean() : false ) );
        }
        return configs;
    }
}
