public class AppConfigPropertiesConverter
    extends AbstractHttpMessageConverter<List<Config>> {
    public static final Charset DEFAULT_CHARSET = Charset.forName ( "UTF-8" );
    private Gson gson = null;
    private final GsonBuilder gsonBuilder = new GsonBuilder();
    private final TypeToken<List<Config>> token = new TypeToken<List<Config>>() {};
    public AppConfigPropertiesConverter() {
        super ( new MediaType ( "application", "json", DEFAULT_CHARSET ), new MediaType (
                    "application", "*+json", DEFAULT_CHARSET ) );
    }
    public void initializeAdapters() {
        this.gsonBuilder.registerTypeAdapter ( token.getType(), new AppConfigDeserializer() );
        this.gson = this.gsonBuilder.create();
    }
    @Override
    protected boolean supports ( Class<?> clazz ) {
        return List.class.isAssignableFrom ( clazz );
    }
    @Override
    protected List<Config> readInternal (
        Class<? extends List<Config>> clazz, HttpInputMessage inputMessage )
    throws IOException, HttpMessageNotReadableException {
        Reader jsonReader =
            new InputStreamReader ( inputMessage.getBody(), DEFAULT_CHARSET.displayName() );
        return this.gson.fromJson ( jsonReader, this.token.getType() );
    }
    @Override
    protected void writeInternal (
        List<Config> configs, HttpOutputMessage outputMessage )
    throws IOException, HttpMessageNotWritableException {
        outputMessage.getBody().write (
            this.gson.toJson (
                configs, this.token.getType() ).getBytes ( DEFAULT_CHARSET.displayName() ) );
    }
}
