@Provider
public class ResponseInterceptor implements WriterInterceptor {
    @Override
    public void aroundWriteTo ( WriterInterceptorContext context ) throws IOException, WebApplicationException {
        OutputStream originalStream = context.getOutputStream();
        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        context.setOutputStream ( baos );
        try {
            context.proceed();
        } finally {
            JsonNode response = new ObjectMapper().readTree ( baos.toByteArray() );
            baos.writeTo ( originalStream );
            baos.close();
            context.setOutputStream ( originalStream );
        }
    }
}
