public class Main {
    private static final String BASE_URL = "http://x.x.x.x/";
    private static final String USERNAME = "jeff@p.com";
    private static final String PASSWORD = "pat";
    private static final String ENCODING = "utf-8";
    private static String getContentRestUrl ( final Long contentId, final String[] expansions ) throws UnsupportedEncodingException {
        final String expand = URLEncoder.encode ( StringUtils.join ( expansions, "," ), ENCODING );
        return String.format ( "%s/rest/api/content/%s?expand=%s&os_authType=basic&os_username=%s&os_password=%s", BASE_URL, contentId, expand, URLEncoder.encode ( USERNAME, ENCODING ), URLEncoder.encode ( PASSWORD, ENCODING ) );
    }
    public static void main ( final String[] args ) throws Exception {
        final long pageId = 8226411;
        HttpClient client = new DefaultHttpClient();
        String pageObj = null;
        HttpEntity pageEntity = null;
        try {
            HttpGet getPageRequest = new HttpGet ( getContentRestUrl ( pageId, new String[] {"body.storage", "version"} ) );
            HttpResponse getPageResponse = client.execute ( getPageRequest );
            pageEntity = getPageResponse.getEntity();
            pageObj = IOUtils.toString ( pageEntity.getContent() );
            System.out.println ( "Get Page Request returned " + getPageResponse.getStatusLine().toString() );
            System.out.println ( "" );
            System.out.println ( pageObj );
        } finally {
            if ( pageEntity != null ) {
                EntityUtils.consume ( pageEntity );
            }
        }
        JSONObject page = new JSONObject ( pageObj );
        page.getJSONObject ( "body" ).getJSONObject ( "storage" ).put ( "value", "hello, world" );
        int currentVersion = page.getJSONObject ( "version" ).getInt ( "number" );
        page.getJSONObject ( "version" ).put ( "number", currentVersion + 1 );
        HttpEntity putPageEntity = null;
        try {
            HttpPut putPageRequest = new HttpPut ( getContentRestUrl ( pageId, new String[] {} ) );
            StringEntity entity = new StringEntity ( page.toString(), ContentType.APPLICATION_JSON );
            putPageRequest.setEntity ( entity );
            HttpResponse putPageResponse = client.execute ( putPageRequest );
            putPageEntity = putPageResponse.getEntity();
            System.out.println ( "Put Page Request returned " + putPageResponse.getStatusLine().toString() );
            System.out.println ( "" );
            System.out.println ( IOUtils.toString ( putPageEntity.getContent() ) );
        } finally {
            EntityUtils.consume ( putPageEntity );
        }
    }
}
