@Configuration
public class FeatureConfig implements ApplicationContextAware {
    static boolean needInit = true;
    @Override
    public void setApplicationContext ( ApplicationContext ac ) throws BeansException {
        AnnotationConfigWebApplicationContext parent =
            ( AnnotationConfigWebApplicationContext ) ( ( AnnotationConfigWebApplicationContext ) ac ).getParent();
        if ( needInit ) {
            needInit = false;
            parent.register ( RootConfig.class );
            parent.refresh();
            ( ( AnnotationConfigWebApplicationContext ) ac ).refresh();
        }
    }
    @Configuration
    @Conditional ( NoParentContext.class )
    public static class RootConfig {
    }
    public static class NoParentContext implements Condition {
        @Override
        public boolean matches ( ConditionContext cc, AnnotatedTypeMetadata atm ) {
            logger.debug ( " {} parent {}", cc.getBeanFactory(), cc.getBeanFactory().getParentBeanFactory() );
            return ( cc.getBeanFactory().getParentBeanFactory() == null );
        }
    }
}
