public static final Gson customGson = new GsonBuilder().registerTypeHierarchyAdapter ( byte[].class,
        new ByteArrayToBase64TypeAdapter() ).create();
private static class ByteArrayToBase64TypeAdapter implements JsonSerializer<byte[]>, JsonDeserializer<byte[]> {
    public byte[] deserialize ( JsonElement json, Type typeOfT, JsonDeserializationContext context ) throws JsonParseException {
        return Base64.decode ( json.getAsString(), Base64.NO_WRAP );
    }
    public JsonElement serialize ( byte[] src, Type typeOfSrc, JsonSerializationContext context ) {
        return new JsonPrimitive ( Base64.encodeToString ( src, Base64.NO_WRAP ) );
    }
}
