package com.ipot.image_upload;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.database.Cursor;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.provider.MediaStore;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.Toast;
public class MainActivity extends Activity {
    ImageView viewImage;
    Button b, upp;
    String ppath;
    private ProgressDialog dialog = null;
    private int serverResponseCode = 0;
    private String upLoadServerUri = null;
    @Override
    public void onCreate ( Bundle savedInstanceState ) {
        super.onCreate ( savedInstanceState );
        setContentView ( R.layout.activity_main );
        b = ( Button ) findViewById ( R.id.btnSelectPhoto );
        upp = ( Button ) findViewById ( R.id.up );
        upLoadServerUri = "http://server.com/android/upload_image.php";
        viewImage = ( ImageView ) findViewById ( R.id.viewImage );
        b.setOnClickListener ( new View.OnClickListener() {
            @Override
            public void onClick ( View v ) {
                selectImage();
            }
        } );
        upp.setOnClickListener ( new OnClickListener() {
            @Override
            public void onClick ( View v ) {
                System.out.println ( "path value..." + ppath );
                dialog = ProgressDialog.show ( MainActivity.this, "", "Uploading file...", true );
                new Thread ( new Runnable() {
                    public void run() {
                        int y = uploadFile ( ppath );
                    }
                } ).start();
            }
        } );
    }
    private void selectImage() {
        final CharSequence[] options = { "Take Photo", "Choose from Gallery", "Cancel" };
        AlertDialog.Builder builder = new AlertDialog.Builder ( MainActivity.this );
        builder.setTitle ( "Add Photo!" );
        builder.setItems ( options, new DialogInterface.OnClickListener() {
            @Override
            public void onClick ( DialogInterface dialog, int item ) {
                if ( options[item].equals ( "Take Photo" ) ) {
                    Intent intent = new Intent ( MediaStore.ACTION_IMAGE_CAPTURE );
                    File f = new File ( android.os.Environment.getExternalStorageDirectory(), "temp.jpg" );
                    intent.putExtra ( MediaStore.EXTRA_OUTPUT, Uri.fromFile ( f ) );
                    startActivityForResult ( intent, 1 );
                } else if ( options[item].equals ( "Choose from Gallery" ) ) {
                    System.out.println ( "before call ..." );
                    Intent intent = new   Intent ( Intent.ACTION_PICK, android.provider.MediaStore.Images.Media.EXTERNAL_CONTENT_URI );
                    startActivityForResult ( intent, 2 );
                } else if ( options[item].equals ( "Cancel" ) ) {
                    dialog.dismiss();
                }
            }
        } );
        builder.show();
    }
    @Override
    protected void onActivityResult ( int requestCode, int resultCode, Intent data ) {
        super.onActivityResult ( requestCode, resultCode, data );
        if ( resultCode == RESULT_OK ) {
            if ( requestCode == 1 ) {
                File f = new File ( Environment.getExternalStorageDirectory().toString() );
                for ( File temp : f.listFiles() ) {
                    if ( temp.getName().equals ( "temp.jpg" ) ) {
                        f = temp;
                        break;
                    }
                }
                try {
                    Bitmap bitmap;
                    BitmapFactory.Options bitmapOptions = new BitmapFactory.Options();
                    bitmap = BitmapFactory.decodeFile ( f.getAbsolutePath(),
                                                        bitmapOptions );
                    viewImage.setImageBitmap ( bitmap );
                    String path = android.os.Environment
                                  .getExternalStorageDirectory()
                                  + File.separator + "temp.jpg";
                    System.out.println ( "image path..." + path );
                    ppath = path;
                    OutputStream outFile = null;
                    File file = new File ( path, String.valueOf ( System.currentTimeMillis() ) + ".jpg" );
                    try {
                        outFile = new FileOutputStream ( file );
                        bitmap.compress ( Bitmap.CompressFormat.JPEG, 85, outFile );
                        outFile.flush();
                        outFile.close();
                    } catch ( FileNotFoundException e ) {
                        e.printStackTrace();
                    } catch ( IOException e ) {
                        e.printStackTrace();
                    } catch ( Exception e ) {
                        e.printStackTrace();
                    }
                } catch ( Exception e ) {
                    e.printStackTrace();
                }
            } else if ( requestCode == 2 ) {
                Uri selectedImage = data.getData();
                String[] filePath = { MediaStore.Images.Media.DATA };
                Cursor c = getContentResolver().query ( selectedImage, filePath, null, null, null );
                c.moveToFirst();
                int columnIndex = c.getColumnIndex ( filePath[0] );
                String picturePath = c.getString ( columnIndex );
                c.close();
                Bitmap thumbnail = ( BitmapFactory.decodeFile ( picturePath ) );
                Log.w ( "path of image from gallery......******************.........", picturePath + "" );
                String selectedImagePath;
                selectedImagePath = getPath ( selectedImage );
                System.out.println ( "before set image..." );
                viewImage.setImageBitmap ( thumbnail );
                System.out.println ( "image path from gallery..." + selectedImagePath );
                ppath = selectedImagePath;
            }
        }
    }
    public int uploadFile ( String ppath2 ) {
        String fileName = ppath2;
        HttpURLConnection conn = null;
        DataOutputStream dos = null;
        String lineEnd = "\r\n";
        String twoHyphens = "--";
        String boundary = "*****";
        int bytesRead, bytesAvailable, bufferSize;
        byte[] buffer;
        int maxBufferSize = 1 * 1024 * 1024;
        File sourceFile = new File ( ppath2 );
        if ( !sourceFile.isFile() ) {
            dialog.dismiss();
            Log.e ( "uploadFile", "Source File not exist :" + ppath );
            runOnUiThread ( new Runnable() {
                public void run() {
                }
            } );
            return 0;
        } else {
            try {
                FileInputStream fileInputStream = new FileInputStream ( sourceFile );
                URL url = new URL ( upLoadServerUri );
                conn = ( HttpURLConnection ) url.openConnection();
                conn.setDoInput ( true );
                conn.setDoOutput ( true );
                conn.setUseCaches ( false );
                conn.setRequestMethod ( "POST" );
                conn.setRequestProperty ( "Connection", "Keep-Alive" );
                conn.setRequestProperty ( "ENCTYPE", "multipart/form-data" );
                conn.setRequestProperty ( "Content-Type", "multipart/form-data;boundary=" + boundary );
                conn.setRequestProperty ( "uploaded_file", fileName );
                dos = new DataOutputStream ( conn.getOutputStream() );
                dos.writeBytes ( twoHyphens + boundary + lineEnd );
                dos.writeBytes ( "Content-Disposition: form-data; name=\"uploaded_file\";filename=\""
                                 + fileName + "\"" + lineEnd );
                dos.writeBytes ( lineEnd );
                bytesAvailable = fileInputStream.available();
                bufferSize = Math.min ( bytesAvailable, maxBufferSize );
                buffer = new byte[bufferSize];
                bytesRead = fileInputStream.read ( buffer, 0, bufferSize );
                while ( bytesRead > 0 ) {
                    dos.write ( buffer, 0, bufferSize );
                    bytesAvailable = fileInputStream.available();
                    bufferSize = Math.min ( bytesAvailable, maxBufferSize );
                    bytesRead = fileInputStream.read ( buffer, 0, bufferSize );
                }
                dos.writeBytes ( lineEnd );
                dos.writeBytes ( twoHyphens + boundary + twoHyphens + lineEnd );
                serverResponseCode = conn.getResponseCode();
                String serverResponseMessage = conn.getResponseMessage();
                Log.i ( "uploadFile", "HTTP Response is : "
                        + serverResponseMessage + ": " + serverResponseCode );
                if ( serverResponseCode == 200 ) {
                    runOnUiThread ( new Runnable() {
                        public void run() {
                            String msg = "File Upload Completed.\n\n See uploaded file here : \n\n"
                                         + " F:/wamp/wamp/www/uploads";
                            Toast.makeText ( MainActivity.this, "File Upload Complete.", Toast.LENGTH_SHORT ).show();
                        }
                    } );
                }
                fileInputStream.close();
                dos.flush();
                dos.close();
            } catch ( MalformedURLException ex ) {
                dialog.dismiss();
                ex.printStackTrace();
                runOnUiThread ( new Runnable() {
                    public void run() {
                        Toast.makeText ( MainActivity.this, "MalformedURLException", Toast.LENGTH_SHORT ).show();
                    }
                } );
                Log.e ( "Upload file to server", "error: " + ex.getMessage(), ex );
            } catch ( Exception e ) {
                dialog.dismiss();
                e.printStackTrace();
                runOnUiThread ( new Runnable() {
                    public void run() {
                        Toast.makeText ( MainActivity.this, "Got Exception : see logcat ", Toast.LENGTH_SHORT ).show();
                    }
                } );
                Log.e ( "Upload file to server Exception", "Exception : "  + e.getMessage(), e );
            }
            dialog.dismiss();
            return serverResponseCode;
        }
    }
    private String getPath ( Uri uri ) {
        if ( uri == null ) {
            return null;
        }
        String[] projection = { MediaStore.Images.Media.DATA };
        Cursor cursor = managedQuery ( uri, projection, null, null, null );
        if ( cursor != null ) {
            int column_index = cursor
                               .getColumnIndexOrThrow ( MediaStore.Images.Media.DATA );
            cursor.moveToFirst();
            return cursor.getString ( column_index );
        }
        return uri.getPath();
    }
}
