import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;
public class Main {
    public static Comparator<String> getComparator() {
        return new Comparator<String>() {
            @Override
            public int compare ( String o1, String o2 ) {
                String[] columns1 = o1.split ( "\\s+" );
                String[] columns2 = o2.split ( "\\s+" );
                if ( columns1[0].compareTo ( columns2[0] ) != 0 ) {
                    return columns1[0].compareTo ( columns2[0] );
                }
                if ( columns1[2].compareTo ( columns2[2] ) != 0 ) {
                    return columns1[2].compareTo ( columns2[2] );
                }
                return 0;
            }
        };
    }
    public static void main ( String[] args ) throws IOException {
        final Path path = Paths.get ( "input.csv" );
        List<String> lines = Files.readAllLines ( path, DEFAULT_CHARSET );
        Collections.sort ( lines, getComparator() );
        for ( String line : lines ) {
            System.out.println ( line );
        }
    }
    private static final Charset DEFAULT_CHARSET = Charset.defaultCharset();
}
