public class BallPit extends JPanel {
    private List<Ball> balls;
    public BallPit() {
        balls = new ArrayList<> ( 25 );
        balls.add ( new Ball ( Color.RED, getPreferredSize() ) );
        Timer timer = new Timer ( 40, new ActionListener() {
            @Override
            public void actionPerformed ( ActionEvent e ) {
                for ( Ball ball : balls ) {
                    ball.update ( getSize() );
                }
                repaint();
            }
        } );
        timer.start();
    }
    @Override
    public Dimension getPreferredSize() {
        return new Dimension ( 200, 200 );
    }
    @Override
    protected void paintComponent ( Graphics g ) {
        super.paintComponent ( g );
        Graphics2D g2d = ( Graphics2D ) g.create();
        g2d.setRenderingHint ( RenderingHints.KEY_ALPHA_INTERPOLATION, RenderingHints.VALUE_ALPHA_INTERPOLATION_QUALITY );
        g2d.setRenderingHint ( RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON );
        g2d.setRenderingHint ( RenderingHints.KEY_COLOR_RENDERING, RenderingHints.VALUE_COLOR_RENDER_QUALITY );
        g2d.setRenderingHint ( RenderingHints.KEY_DITHERING, RenderingHints.VALUE_DITHER_ENABLE );
        g2d.setRenderingHint ( RenderingHints.KEY_FRACTIONALMETRICS, RenderingHints.VALUE_FRACTIONALMETRICS_ON );
        g2d.setRenderingHint ( RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BILINEAR );
        g2d.setRenderingHint ( RenderingHints.KEY_RENDERING, RenderingHints.VALUE_RENDER_QUALITY );
        g2d.setRenderingHint ( RenderingHints.KEY_STROKE_CONTROL, RenderingHints.VALUE_STROKE_PURE );
        for ( Ball ball : balls ) {
            ball.paint ( g2d );
        }
        g2d.dispose();
    }
}
