public class AuthenticationRequestWrapper extends HttpServletRequestWrapper {
    private final String payload;
    public AuthenticationRequestWrapper ( HttpServletRequest request ) throws AuthenticationException {
        super ( request );
        StringBuilder stringBuilder = new StringBuilder();
        BufferedReader bufferedReader = null;
        try {
            InputStream inputStream = request.getInputStream();
            if ( inputStream != null ) {
                bufferedReader = new BufferedReader ( new InputStreamReader ( inputStream ) );
                char[] charBuffer = new char[128];
                int bytesRead = -1;
                while ( ( bytesRead = bufferedReader.read ( charBuffer ) ) > 0 ) {
                    stringBuilder.append ( charBuffer, 0, bytesRead );
                }
            } else {
                stringBuilder.append ( "" );
            }
        } catch ( IOException ex ) {
            log.error ( "Error reading the request payload", ex );
            throw new AuthenticationException ( "Error reading the request payload", ex );
        } finally {
            if ( bufferedReader != null ) {
                try {
                    bufferedReader.close();
                } catch ( IOException iox ) {
                }
            }
        }
        payload = stringBuilder.toString();
    }
    @Override
    public ServletInputStream getInputStream () throws IOException {
        final ByteArrayInputStream byteArrayInputStream = new ByteArrayInputStream ( payload.getBytes() );
        ServletInputStream inputStream = new ServletInputStream() {
            public int read ()
            throws IOException {
                return byteArrayInputStream.read();
            }
        };
        return inputStream;
    }
}
