@RunWith ( PowerMockRunner.class )
@PrepareForTest ( DocumentBuilderFactory.class )
public class XmlFileWriterTest {
    @Test ( expected = ParserConfigurationException.class )
    public void createCompleteExportXmlWithParseConfigurationException() throws Exception {
        String xmlFilename = "junitExportTestWithParseConfigurationException.xml";
        String content = "any content";
        XmlFileWriter writer = new XmlFileWriter();
        DocumentBuilderFactory mockDocumentBuilderFactory = PowerMockito.mock ( DocumentBuilderFactory.class );
        PowerMockito.when ( mockDocumentBuilderFactory.newDocumentBuilder() ).thenThrow ( new ParserConfigurationException ( "Simulated ex" ) );
        PowerMockito.mockStatic ( DocumentBuilderFactory.class );
        PowerMockito.when ( DocumentBuilderFactory.newInstance() ).thenReturn ( mockDocumentBuilderFactory );
        writer.createCompleteExportXml ( xmlFilename, content );
    }
