public class MyApplication extends Application {
    public void onCreate() {
        super.onCreate();
        try {
            File httpCacheDir = new File ( this.getCacheDir(), "http" );
            long httpCacheSize = 10 * 1024 * 1024;
            HttpResponseCache.install ( httpCacheDir, httpCacheSize );
            catch ( IOException e ) {
                Log.i ( TAG, "HTTP response cache installation failed:" + e );
            }
            registerActivityLifecycleCallbacks (
                new MyApplicationActivityLifeCycleCallbacks() );
        }
        public void flushCache() {
            HttpResponseCache cache = HttpResponseCache.getInstalled();
            if ( cache != null ) {
                cache.flush();
            }
        }
        private class MyApplicationActivityLifeCycleCallbacks extends ActivityLifecycleCallbacks {
            public void onActivityStopped ( Activity activity ) {
                flushCache();
            }
        }
    }
