@Test
public void verifyConnectionTest_multipart() {
    try {
        PostMethod filePost = new PostMethod ( url );
        Part[] parts = { new StringPart ( "param", "value" ) };
        MultipartRequestEntity request = new MultipartRequestEntity ( parts, filePost.getParams() );
        filePost.setRequestEntity ( request );
        this.server.handle ( Method.POST, "/", request.getContentType() ).with (
        new HttpRequestHandler() {
            @Override
            public void handle ( final HttpRequest request,
                                 final HttpResponse response ) {
                response.setStatusCode ( 200 );
                response.setContentType ( "text/xml" );
            }
        } );
        HttpClient client = new HttpClient();
        int status = client.executeMethod ( filePost );
        Assert.assertEquals ( 200, status );
    } catch ( Exception e ) {
        Assert.fail ( e.getMessage() );
    }
}
