import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import javax.swing.*;
public class ProgressBarTest2 {
    private JFrame frame;
    private JButton btnRun;
    private JProgressBar progressBar = new JProgressBar ( 0, 100 );
    public static void main ( String[] args ) {
        EventQueue.invokeLater ( new Runnable() {
            public void run() {
                try {
                    UIManager
                    .setLookAndFeel ( "com.sun.java.swing.plaf.windows.WindowsLookAndFeel" );
                    ProgressBarTest2 window = new ProgressBarTest2();
                    window.frame.setVisible ( true );
                } catch ( Exception e ) {
                    e.printStackTrace();
                }
            }
        } );
    }
    public ProgressBarTest2() {
        initialize();
    }
    private void initialize() {
        frame = new JFrame();
        frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
        frame.setResizable ( false );
        progressBar.setAlignmentX ( Component.RIGHT_ALIGNMENT );
        progressBar.setStringPainted ( true );
        frame.getContentPane().add ( progressBar, BorderLayout.SOUTH );
        btnRun = new JButton ( "Start Long Run" );
        JPanel panel = new JPanel();
        panel.setPreferredSize ( new Dimension ( 450, 300 ) );
        panel.setLayout ( new GridBagLayout() );
        panel.add ( btnRun );
        frame.getContentPane().add ( panel, BorderLayout.CENTER );
        btnRun.addActionListener ( new ActionListener() {
            @Override
            public void actionPerformed ( ActionEvent e ) {
                longRun();
            }
        } );
        frame.pack();
        frame.setLocationRelativeTo ( null );
        frame.setVisible ( true );
    }
    private void longRun() {
        LongRunner2 longRunner = new LongRunner2 ( 10000 );
        longRunner.addPropertyChangeListener ( new PropertyChangeListener() {
            @Override
            public void propertyChange ( PropertyChangeEvent evt ) {
                if ( "progress".equals ( evt.getPropertyName() ) ) {
                    int progress = ( int ) evt.getNewValue();
                    System.out.println ( "Value in propertyChangeListener: "
                                         + progress );
                    progressBar.setValue ( progress );
                }
            }
        } );
        longRunner.execute();
    }
}
class LongRunner2 extends SwingWorker<Integer, Double> {
    private static final long SLEEP_TIME = 15;
    int numOfPoints;
    double progress;
    public LongRunner2 ( int numOfPoints ) {
        this.numOfPoints = numOfPoints;
        this.progress = 0;
    }
    private void runLong ( int bigNum ) {
        for ( int i = 0; i < bigNum; i++ ) {
            try {
                Thread.sleep ( SLEEP_TIME );
            } catch ( InterruptedException e ) {
                e.printStackTrace();
            }
            progress = ( ( ( double ) i * 100 ) / ( double ) bigNum );
            setProgress ( ( int ) progress );
        }
    }
    @Override
    protected Integer doInBackground() throws Exception {
        runLong ( numOfPoints );
        return null;
    }
}
