package Window_On_ActiveScreen;
import java.awt.HeadlessException;
import java.awt.MouseInfo;
import java.awt.Point;
import java.util.List;
import javafx.geometry.Rectangle2D;
import javafx.stage.Screen;
public class StartUpLocation {
    private double xPos = 0;
    private double yPos = 0;
    public StartUpLocation ( double windowWidth, double windowHeight ) {
        try {
            Point p = MouseInfo.getPointerInfo().getLocation();
            List<Screen> screens = Screen.getScreens();
            if ( p != null && screens != null && screens.size() > 1 ) {
                Rectangle2D screenBounds;
                for ( Screen screen : screens ) {
                    screenBounds = screen.getVisualBounds();
                    if ( screenBounds.contains ( p.x, p.y ) ) {
                        xPos = screenBounds.getMinX() + ( ( screenBounds.getMaxX() - screenBounds.getMinX() - windowWidth ) / 2 );
                        yPos = screenBounds.getMinY() + ( ( screenBounds.getMaxY() - screenBounds.getMinY() - windowHeight ) / 2 );
                        return;
                    }
                }
            }
        } catch ( HeadlessException headlessException ) {
            headlessException.printStackTrace();
        }
    }
    public double getXPos() {
        return xPos;
    }
    public double getYPos() {
        return yPos;
    }
}
