import java.util.HashMap;
public class AssociationHolder<LeftClass, RightClass, AssociationClass> {
    private HashMap<LeftClass, HashMap<RightClass, AssociationClass>> associationsLeft =
        new HashMap<LeftClass, HashMap<RightClass, AssociationClass>>();
    private HashMap<RightClass, HashMap<LeftClass, AssociationClass>> associationsRight =
        new HashMap<RightClass, HashMap<LeftClass, AssociationClass>>();
    public void setAssociation ( LeftClass left, RightClass right, AssociationClass association ) {
        HashMap<RightClass, AssociationClass> leftMap = this.associationsLeft.get ( left );
        if ( leftMap == null ) {
            leftMap = new HashMap<RightClass, AssociationClass>();
            this.associationsLeft.put ( left, leftMap );
        }
        HashMap<LeftClass, AssociationClass> rightMap = this.associationsRight.get ( right );
        if ( rightMap == null ) {
            rightMap = new HashMap<LeftClass, AssociationClass>();
            this.associationsRight.put ( right, rightMap );
        }
        leftMap.put ( right, association );
        rightMap.put ( left, association );
    }
    public AssociationClass getAssociation ( LeftClass left, RightClass right ) {
        HashMap<RightClass, AssociationClass> leftMap = this.associationsLeft.get ( left );
        if ( leftMap == null ) {
            return null;
        }
        return leftMap.get ( right );
    }
    public HashMap<RightClass, AssociationClass> getAssociationsLeft ( LeftClass left ) {
        HashMap<RightClass, AssociationClass> leftMap = this.associationsLeft.get ( left );
        if ( leftMap == null ) {
            return new HashMap<RightClass, AssociationClass>();
        } else {
            return leftMap;
        }
    }
    public HashMap<LeftClass, AssociationClass> getAssociationsRight ( RightClass right ) {
        HashMap<LeftClass, AssociationClass> rightMap = this.associationsRight.get ( right );
        if ( rightMap == null ) {
            return new HashMap<LeftClass, AssociationClass>();
        } else {
            return rightMap;
        }
    }
    public void removeAssociation ( LeftClass left, RightClass right ) {
        HashMap<RightClass, AssociationClass> leftMap = this.getAssociationsLeft ( left );
        HashMap<LeftClass, AssociationClass> rightMap = this.getAssociationsRight ( right );
        leftMap.remove ( right );
        rightMap.remove ( left );
    }
}
