package javaapplication2;
import java.util.ArrayList;
import java.util.List;
import org.bytedeco.javacpp.Pointer;
import static org.bytedeco.javacpp.opencv_calib3d.*;
import static org.bytedeco.javacpp.opencv_core.*;
import static org.bytedeco.javacpp.opencv_highgui.*;
import static org.bytedeco.javacpp.opencv_imgproc.*;
public class JavaApplication2 {
    public static void main ( String[] args ) throws Exception  {
        System.loadLibrary ( "opencv_core249" );
        System.loadLibrary ( "jniopencv_core" );
        Mat im = new Mat ( 480, 640, CV_8UC3 );
        Mat dst = null;
        final List<Point> pSrc = new ArrayList<Point>();
        final List<Point> pDst = new ArrayList<Point>();
        pDst.add ( new Point ( 94, 72 ) );
        pDst.add ( new Point ( 343, 72 ) );
        pDst.add ( new Point ( 343, 501 ) );
        pDst.add ( new Point ( 94, 501 ) );
        namedWindow ( "src", 0 );
        namedWindow ( "dst", 0 );
        MouseCallback mouseSrc = new MouseCallback() {
            @Override
            public void call ( int event, int x, int y, int flags, Pointer param ) {
                if ( event == CV_EVENT_LBUTTONDOWN ) {
                    if ( pSrc.size() >= 4 ) {
                        pSrc.clear();
                    }
                    pSrc.add ( new Point ( x, y ) );
                }
            }
        };
        setMouseCallback ( "src", mouseSrc, null );
        im = imread ( "c:/data/notre.jpg" );
        while ( true ) {
            if ( dst == null ) {
                dst = im.clone();
            }
            Mat imD = im.clone();
            Mat dstD = dst.clone();
            for ( int i = 0; i < pSrc.size(); ++i ) {
                circle ( imD, pSrc.get ( i ), 4, new Scalar ( 255, 0, 0, 255 ), -1, 1, 1 );
            }
            if ( pSrc.size() == 4 && pDst.size() == 4 ) {
                Mat msrc = new Mat ( 4, 2, CV_64FC1 );
                Mat mdst = new Mat ( 4, 2, CV_64FC1 );
                for ( int i = 0; i < pSrc.size(); ++i ) {
                    msrc.asCvMat().put ( i, 0, ( double ) pSrc.get ( i ).x() );
                    msrc.asCvMat().put ( i, 1, ( double ) pSrc.get ( i ).y() );
                }
                for ( int i = 0; i < pDst.size(); ++i ) {
                    mdst.asCvMat().put ( i, 0, ( double ) pDst.get ( i ).x() );
                    mdst.asCvMat().put ( i, 1, ( double ) pDst.get ( i ).y() );
                }
                Mat H = findHomography ( msrc, mdst );
                warpPerspective ( imD, dstD, H, new Size ( dstD.cols(), dstD.rows() ) );
            }
            for ( int i = 0; i < pDst.size(); ++i ) {
                circle ( dstD, pDst.get ( i ), 4, new Scalar ( 255, 255, 0, 255 ), -1, 1, 1 );
            }
            imshow ( "src", imD );
            imshow ( "dst", dstD );
            if ( cvWaitKey ( 1 ) == 27 ) {
                break;
            }
        }
    }
}
