abstract static class InfiniteIterator<T> implements Iterator<T> {
    @Override
    public boolean hasNext() {
        return true;
    }
}
static class InfiniteDigits extends InfiniteIterator<Character> {
    int n = 1;
    String s = Integer.toString ( n );
    int i = 0;
    @Override
    public Character next() {
        if ( i >= s.length() ) {
            s = Integer.toString ( ++n );
            i = 0;
        }
        return s.charAt ( i++ );
    }
}
static class StringFinder {
    final Iterator<Character> source;
    final StringBuilder traversed = new StringBuilder();
    public StringFinder ( Iterator<Character> source ) {
        this.source = source;
    }
    public int find ( final String find ) {
        int matched = 0;
        int passed = 0;
        while ( matched < find.length() ) {
            Character next = source.next();
            traversed.append ( next );
            if ( next == find.charAt ( matched ) ) {
                matched += 1;
            } else {
                passed += matched + 1;
                matched = 0;
            }
        }
        return passed + 1;
    }
}
private void test ( String string ) {
    StringFinder finder = new StringFinder ( new InfiniteDigits() );
    System.out.println ( "'" + string + "' found at " + finder.find ( string ) + " traversed " + finder.traversed );
}
public void test() {
    test ( "567" );
    test ( "1112" );
    test ( "765" );
}
