Set<SoftReference<Bitmap>> mReusableBitmaps;
private LruCache<String, BitmapDrawable> mMemoryCache;
if ( Utils.hasHoneycomb() ) {
    mReusableBitmaps =
        Collections.synchronizedSet ( new HashSet<SoftReference<Bitmap>>() );
}
mMemoryCache = new LruCache<String, BitmapDrawable> ( mCacheParams.memCacheSize ) {
    @Override
    protected void entryRemoved ( boolean evicted, String key,
                                  BitmapDrawable oldValue, BitmapDrawable newValue ) {
        if ( RecyclingBitmapDrawable.class.isInstance ( oldValue ) ) {
            ( ( RecyclingBitmapDrawable ) oldValue ).setIsCached ( false );
        } else {
            if ( Utils.hasHoneycomb() ) {
                mReusableBitmaps.add
                ( new SoftReference<Bitmap> ( oldValue.getBitmap() ) );
            }
        }
    }
    ....
}
