public class CriteriaContainer implements Serializable {
    private static final long serialVersionUID = 1L;
    private Criteria criteria = null;
    private DetachedCriteria detachedCriteria = null;
    public CriteriaContainer ( Criteria criteria ) {
        this.criteria = criteria;
        this.detachedCriteria = null;
    }
    public CriteriaContainer ( DetachedCriteria detachedCriteria ) {
        this.detachedCriteria = detachedCriteria;
        this.criteria = null;
    }
    public CriteriaContainer add ( final Criterion eq ) {
        if ( criteria != null ) {
            criteria.add ( eq );
        } else if ( detachedCriteria != null ) {
            detachedCriteria.add ( eq );
        }
        return this;
    }
    public Criteria getCriteria() {
        return criteria;
    }
    public DetachedCriteria getDetachedCriteria() {
        return detachedCriteria;
    }
    public CriteriaContainer createAlias ( final String associationPath, final String alias ) {
        if ( criteria != null ) {
            criteria.createAlias ( associationPath, alias );
        } else if ( detachedCriteria != null ) {
            detachedCriteria.createAlias ( associationPath, alias );
        }
        return this;
    }
    public CriteriaContainer setResultTransformer ( final ResultTransformer transformer ) {
        if ( criteria != null ) {
            criteria.setResultTransformer ( transformer );
        } else if ( detachedCriteria != null ) {
            detachedCriteria.setResultTransformer ( transformer );
        }
        return this;
    }
}
criteria = addBasicCriteria ( new CriteriaContainer ( criteria ), ... ).getCriteria()
           detachedCriteria = addBasicCriteria ( new CriteriaContainer ( detachedCriteria ), ... ).getDetachedCriteria()
