public class WormRef<T>
    extends Object {
    private volatile T                      reference;
    public WormRef() {
        super();
        reference = null;
    }
    public WormRef<T> init ( T val ) {
        synchronized ( this ) {
            if ( reference != null ) {
                throw new IllegalStateException ( "The WormRef container is already initialized" );
            }
            reference = val;
        }
        return this;
    }
    public T get() {
        if ( reference == null ) {
            throw new IllegalStateException ( "The WormRef container is not initialized" );
        }
        return reference;
    }
}
