public class UserController extends BaseCommandController {
    private OccupationRepository occupationRepository;
    private CountryRepository countryRepository;
    public UserController() {
        setCommandClass ( User.class );
        setValidator ( new UserValidator() );
    }
    public void initBind ( HttpServletRequest request, ServletRequestDataBinder binder ) {
        binder.registerCustomPropertyEditor ( Occupation.class, new PropertyEditorSupport() {
            public void setAsText ( String occupationId ) {
                if ( StringUtils.isBlank ( occupationId ) ) {
                    setValue ( null );
                    return;
                }
                setValue ( occupationRepository.getById ( Integer.valueOf ( occupationId ) ) );
            }
            public String getAsText() {
                if ( getValue() == null ) {
                    return;
                }
                return String.valueOf ( ( ( Occupation ) getValue() ).getId() );
            }
        } );
    }
}
