public class UserBindingInitializer implements WebBindingInitializer {
    private OccupationRepository occupationRepository;
    private CountryRepository countryRepository;
    public void initBinder ( WebDataBinder binder, WebRequest request ) {
        binder.registerCustomPropertyEditor ( Occupation.class, new PropertyEditorSupport() {
            public void setAsText ( String occupationId ) {
                if ( StringUtils.isBlank ( occupationId ) ) {
                    setValue ( null );
                    return;
                }
                setValue ( occupationRepository.getById ( Integer.valueOf ( occupationId ) ) );
            }
            public String getAsText() {
                if ( getValue() == null ) {
                    return;
                }
                return String.valueOf ( ( ( Occupation ) getValue() ).getId() );
            }
        } );
    }
}
