public interface DocumentNodeVisitor {
    void visitWord ( Word word );
    void visitImage ( Image img );
}
public interface DocumentNode {
    void applyVisitor ( DocumentVisitor v );
}
public class Word implements DocumentNode {
    private final String s;
    public Word ( String s ) {
        this.s = s;
    }
    public String getValue() {
        return this.s;
    }
    public void applyVisitor ( DocumentVisitor v ) {
        v.visitWord ( this );
    }
}
public class Image implements DocumentNode {
    public void applyVisitor ( DocumentVisitor v ) {
        v.visitImage ( this );
    }
}
public class Paragraph implements DocumentNode {
    private final List<DocumentNode> children;
    public Paragraph() {
        this.children = new LinkedList<DocumentNode>();
    }
    public void addChild ( DocumentNode child ) {
        this.children.add ( child );
    }
    public void applyVisitor ( DocumentVisitor v ) {
        for ( DocumentNode child : children ) {
            child.applyVisitor ( v );
        }
    }
}
public class SpellChecker implements DocumentVisitor
    public void visitImage ( Image i ) {
}
public void visitWord ( Word word ) {
    if ( !dictionary.contains ( word.getValue() ) {
}
}
}
