final int DATA_SIZE = 9;
final double SEED = 1000.0;
double[][] data = new double[DATA_SIZE][DATA_SIZE];
data[0][0] = data[0][DATA_SIZE - 1] = data[DATA_SIZE - 1][0] =
        data[DATA_SIZE - 1][DATA_SIZE - 1] = SEED;
double h = 500.0;
Random r = new Random();
for ( int sideLength = DATA_SIZE - 1;
        sideLength >= 2;
        sideLength /= 2, h /= 2.0 ) {
    int halfSide = sideLength / 2;
    for ( int x = 0; x < DATA_SIZE - 1; x += sideLength ) {
        for ( int y = 0; y < DATA_SIZE - 1; y += sideLength ) {
            double avg = data[x][y] +
                         data[x + sideLength][y] +
                         data[x][y + sideLength] +
                         data[x + sideLength][y + sideLength];
            avg /= 4.0;
            data[x + halfSide][y + halfSide] =
                avg + ( r.nextDouble() * 2 * h ) - h;
        }
    }
    for ( int x = 0; x < DATA_SIZE - 1; x += halfSide ) {
        for ( int y = ( x + halfSide ) % sideLength; y < DATA_SIZE - 1; y += sideLength ) {
            double avg =
                data[ ( x - halfSide + DATA_SIZE ) % DATA_SIZE][y] +
                data[ ( x + halfSide ) % DATA_SIZE][y] +
                data[x][ ( y + halfSide ) % DATA_SIZE] +
                data[x][ ( y - halfSide + DATA_SIZE ) % DATA_SIZE];
            avg /= 4.0;
            avg = avg + ( r.nextDouble() * 2 * h ) - h;
            data[x][y] = avg;
            if ( x == 0 ) {
                data[DATA_SIZE - 1][y] = avg;
            }
            if ( y == 0 ) {
                data[x][DATA_SIZE - 1] = avg;
            }
        }
    }
}
for ( double[] row : data ) {
    for ( double d : row ) {
        System.out.printf ( "%8.3f ", d );
    }
    System.out.println();
}
