@Address
public class Address {
    @NotNull @Max ( 50 ) private String street1;
    @Max ( 50 ) private String street2;
    @Max ( 10 ) @NotNull private String zipCode;
    @Max ( 20 ) @NotNull String city;
    @NotNull private Country country;
    ...
}
@ConstraintValidator ( MultiCountryAddressValidator.class )
@Target ( TYPE )
@Retention ( RUNTIME )
public @interface Address {
String message() default "{error.address}";
String[] groups() default {};
}
public class MultiCountryAddressValidator implements Constraint<Address> {
    public void initialize ( Address constraintAnnotation ) {
    }
    public boolean isValid ( Object object ) {
        if ( ! ( object instanceof Address ) ) {
            throw new IllegalArgumentException ( "@Address only applies to Address" );
        }
        Address address = ( Address ) object;
        Country country = address.getCountry();
        if ( country.getISO2() == "FR" ) {
            return isValid;
        } else if ( country.getISO2() == "GR" ) {
            return isValid;
        }
    }
}
