import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.plaf.basic.*;
public class ComboBoxItem extends JFrame implements ActionListener {
    public ComboBoxItem() {
        Vector model = new Vector();
        model.addElement ( new Item ( 1, "car" ) );
        model.addElement ( new Item ( 2, "plane" ) );
        model.addElement ( new Item ( 3, "train" ) );
        model.addElement ( new Item ( 4, "boat" ) );
        JComboBox comboBox;
        comboBox = new JComboBox ( model );
        comboBox.setDragEnabled ( true );
        comboBox.addActionListener ( this );
        getContentPane().add ( comboBox, BorderLayout.NORTH );
        comboBox = new JComboBox ( model );
        comboBox.setDragEnabled ( true );
        comboBox.setRenderer ( new ItemRenderer() );
        comboBox.addActionListener ( this );
        getContentPane().add ( comboBox, BorderLayout.SOUTH );
    }
    public void actionPerformed ( ActionEvent e ) {
        JComboBox comboBox = ( JComboBox ) e.getSource();
        Item item = ( Item ) comboBox.getSelectedItem();
        System.out.println ( item.getId() + " : " + item.getDescription() );
    }
    class ItemRenderer extends BasicComboBoxRenderer {
        public Component getListCellRendererComponent (
            JList list, Object value, int index,
            boolean isSelected, boolean cellHasFocus ) {
            super.getListCellRendererComponent ( list, value, index,
                                                 isSelected, cellHasFocus );
            if ( value != null ) {
                Item item = ( Item ) value;
                setText ( item.getDescription().toUpperCase() );
            }
            if ( index == -1 ) {
                Item item = ( Item ) value;
                setText ( "" + item.getId() );
            }
            return this;
        }
    }
    class Item {
        private int id;
        private String description;
        public Item ( int id, String description ) {
            this.id = id;
            this.description = description;
        }
        public int getId() {
            return id;
        }
        public String getDescription() {
            return description;
        }
        public String toString() {
            return description;
        }
    }
    public static void main ( String[] args ) {
        JFrame frame = new ComboBoxItem();
        frame.setDefaultCloseOperation ( EXIT_ON_CLOSE );
        frame.pack();
        frame.setVisible ( true );
    }
}
