public interface Message {
    void writeTo ( DataOutputStream daos ) throws IOException;
}
public class MessageHandler {
    private final DataOutputStream daos;
    private final DataInputStream dais;
    private final Thread sender;
    private final Thread receiver;
    private final BlockingQueue<Message> outboundMessages = new LinkedBlockingQueue<Message>();
    public MessageHandler ( Socket skt ) throws IOException {
        this.daos = new DataOutputStream ( skt.getOutputStream() );
        this.dais = new DataInputStream ( skt.getInputStream() );
        this.sender = new Thread ( new Runnable() {
            public void run() {
                while ( !Thread.interrupted() ) {
                    Message msg = outboundMessages.take();
                    try {
                        msg.writeTo ( daos );
                    } catch ( IOException ex ) {
                    }
                }
            }
        }, String.format ( "SenderThread-%s", skt.getRemoteSocketAddress() ) );
        this.receiver = new Thread ( new Runnable() {
            public void run() {
            }
        }, String.format ( "ReceiverThread-%s", skt.getRemoteSocketAddress() ) );
        sender.start();
        receiver.start();
    }
    public void sendOutboundMessage ( Message msg ) {
        outboundMessages.add ( msg );
    }
    public void destroy() {
    }
}
