import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Date;
public class LayoutDemo extends JFrame {
    LayoutDemo() {
        super ( "LayoutDemo" );
        super.setSize ( 400, 200 );
        super.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
        createGUI();
        super.setVisible ( true );
    }
    private void createGUI() {
        super.setLayout ( new BorderLayout() );
        final JPanel bottomPanel = new JPanel ( new FlowLayout ( FlowLayout.LEFT ) );
        final JTextArea textArea = new JTextArea();
        final JButton searchButton = new JButton ( "search" );
        searchButton.addActionListener ( new ActionListener() {
            @Override
            public void actionPerformed ( ActionEvent e ) {
                textArea.setText ( textArea.getText() + "pressed search on " + ( new Date() ) + "\n" );
            }
        } );
        bottomPanel.add ( searchButton );
        super.add ( new JScrollPane ( textArea ), BorderLayout.CENTER );
        super.add ( bottomPanel, BorderLayout.SOUTH );
    }
    public static void main ( String[] args ) {
        SwingUtilities.invokeLater ( new Runnable() {
            public void run() {
                new LayoutDemo();
            }
        } );
    }
}
