public class NativeRMISecurityManager extends RMISecurityManager {
    private static final boolean UNIX;
    static {
        String OS = System.getProperty ( "os.name" ).toLowerCase();
        UNIX = ( OS.compareTo ( "windows" ) != 0 );
    }
    protected static InheritableThreadLocal<String> user =
        new InheritableThreadLocal<String>();
    public static setThreadUser ( String username ) {
        user.set ( username );
    }
    public NativeRMISecurityManager ( String initialUser ) {
        super();
        setThreadUser ( initialUser );
    }
    public void checkRead ( String file ) {
        super.checkRead ( file );
        if ( UNIX ) {
            if ( file == null ) {
                throw new SecurityException ( "file = NULL !!!" );
            }
            String str_user = NativeRMISecurityManager.user.get();
            if ( str_user != null ) {
                int ret = c_checkRead ( file, str_user );
                if ( ret != 0 ) {
                    throw new SecurityException ( "Access error: " + file );
                }
            }
        }
    }
    public native int c_checkRead ( String file, String user );
}
