protected void doGet ( HttpServletRequest request, HttpServletResponse response ) throws ServletException, IOException {
    String imageFilename = request.getPathInfo().substring ( 1 );
    int thumbWidth = Integer.parseInt ( request.getParameter ( "w" ) );
    int thumbHeight = Integer.parseInt ( request.getParameter ( "h" ) );
    InputStream imageInput = new FileInputStream ( new File ( "/images", imageFilename ) );
    Image image = ImageIO.read ( imageInput );
    BufferedImage thumb = new BufferedImage ( thumbWidth, thumbHeight, BufferedImage.TYPE_INT_RGB );
    Graphics2D graphics2D = thumb.createGraphics();
    graphics2D.setBackground ( Color.WHITE );
    graphics2D.setPaint ( Color.WHITE );
    graphics2D.fillRect ( 0, 0, thumbWidth, thumbHeight );
    graphics2D.setRenderingHint ( RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BILINEAR );
    graphics2D.drawImage ( image, 0, 0, thumbWidth, thumbHeight, null );
    response.setContentType ( "image/jpeg" );
    ImageIO.write ( thumb, "JPG", response.getOutputStream() );
}
