import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
public class ReaderClass {
    public static void main ( String[] args ) {
        InputStreamReader isReader = new InputStreamReader ( System.in );
        BufferedReader reader = new BufferedReader ( isReader );
        try {
            System.out.println ( "Please enter a number:" );
            int firstInt = readInt ( reader );
            System.out.println ( "Please enter a second number:" );
            int secondInt = readInt ( reader );
            System.out.printf ( "%d + %d = %d",
                                firstInt, secondInt, firstInt + secondInt );
        } catch ( IOException ioe ) {
            System.err.println ( "An error occurred reading from the reader, "
                                 + ioe );
            System.exit ( -1 );
        } finally {
            try {
                reader.close();
            } catch ( IOException ioe ) {
                System.err.println ( "An error occurred closing the reader, "
                                     + ioe );
                System.exit ( -1 );
            }
        }
    }
    private static int readInt ( BufferedReader reader ) throws IOException {
        while ( true ) {
            try {
                return Integer.parseInt ( reader.readLine() );
            } catch ( NumberFormatException nfe ) {
                System.out.println ( "That's not a number! Try again." );
            }
        }
    }
}
