public class PatchedTextField extends JFormattedTextField {
    public PatchedTextField() {
        super();
        final Action originalDeleteAction =
            getActionMap().get ( DefaultEditorKit.deletePrevCharAction );
        getActionMap().put ( DefaultEditorKit.deletePrevCharAction,
        new AbstractAction() {
            ActionEvent previousEvent;
            public void actionPerformed ( ActionEvent e ) {
                if ( previousEvent == null || e.getWhen() - previousEvent.getWhen() > 1 ) {
                    originalDeleteAction.actionPerformed ( e );
                }
                previousEvent = e;
            }
        } );
    }
}
