public class DelegatingThreadPool implements ThreadPool {
    private int size = 5;
    private final ThreadPoolExecutor executor = new ThreadPoolExecutor ( size, size,
            0L, TimeUnit.MILLISECONDS, new LinkedBlockingQueue<Runnable>() );
    public boolean runInThread ( Runnable runnable ) {
        synchronized ( executor ) {
            if ( executor.getActiveCount() == size ) {
                return false;
            }
            executor.submit ( runnable );
            return true;
        }
    }
    public int blockForAvailableThreads() {
        synchronized ( executor ) {
            return executor.getActiveCount();
        }
    }
    public void initialize() throws SchedulerConfigException {
    }
    public void shutdown ( boolean waitForJobsToComplete ) {
        executor.shutdownNow();
    }
    public int getPoolSize() {
        return size;
    }
    public void setInstanceId ( String schedInstId ) {
    }
    public void setInstanceName ( String schedName ) {
    }
