public class GenerateHibernatePojoMojo extends AbstractMojo {
    private File hbmDirectory;
    private File outputDirectory;
    private String jdk5;
    public void execute() throws MojoExecutionException, MojoFailureException {
        POJOExporter exporter = new POJOExporter();
        exporter.setOutputDirectory ( outputDirectory );
        Configuration config = new Configuration();
        config.setProperty ( "jdk5", jdk5 );
        String args = System.getProperty ( "exec.args" );
        if ( args != null && !"".equals ( args ) ) {
            String[] entityNames = args.split ( "," );
            for ( String entityName : entityNames ) {
                File hbmFile = new File ( hbmDirectory + "/" + entityName.replace ( '.', '/' ) + ".hbm.xml" );
                config.addFile ( hbmFile );
            }
        } else {
            config.addDirectory ( hbmDirectory );
        }
        exporter.setConfiguration ( config );
        exporter.start();
    }
}
