public class LimitInputStream extends FilterInputStream {
    private int bytesRead;
    private int limit;
    public LimitInputStream ( InputStream in, int limit ) {
        super ( in );
        this.limit = limit;
    }
    public int read ( byte[] data, int offs, int len ) throws IOException {
        if ( len == 0 ) {
            return 0;
        }
        if ( bytesRead == limit ) {
            return -1;
        }
        int toRead = Math.min ( limit - bytesRead, len );
        int actuallyRead = super.read ( data, offs, toRead );
        if ( actuallyRead == -1 ) {
            throw new UnexpectedEOFException();
        }
        bytesRead += actuallyRead;
        return actuallyRead;
    }
    public void close() { }
}
