import java.awt.*;
import java.awt.datatransfer.*;
public class LoadToClipboard {
    public static void main ( String [] args ) {
        Toolkit tolkit = Toolkit.getDefaultToolkit();
        Clipboard clip = tolkit.getSystemClipboard();
        clip.setContents ( new ImageSelection ( tolkit.getImage ( "StackOverflowLogo.png" ) ) , null );
    }
}
class ImageSelection implements Transferable {
    private Image image;
    public ImageSelection ( Image image ) {
        this.image = image;
    }
    public DataFlavor[] getTransferDataFlavors() {
        return new DataFlavor[] {DataFlavor.imageFlavor};
    }
    public boolean isDataFlavorSupported ( DataFlavor flavor ) {
        return DataFlavor.imageFlavor.equals ( flavor );
    }
    public Object getTransferData ( DataFlavor flavor ) throws UnsupportedFlavorException {
        if ( !DataFlavor.imageFlavor.equals ( flavor ) ) {
            throw new UnsupportedFlavorException ( flavor );
        }
        return image;
    }
}
