private class DownloadTask extends AsyncTask<String, Integer, String> {
    private Context context;
    private PowerManager.WakeLock mWakeLock;
    public DownloadTask ( Context context ) {
        this.context = context;
    }
    @Override
    protected String doInBackground ( String... sUrl ) {
        InputStream input = null;
        OutputStream output = null;
        HttpURLConnection connection = null;
        try {
            URL url = new URL ( sUrl[0] );
            connection = ( HttpURLConnection ) url.openConnection();
            connection.connect();
            if ( connection.getResponseCode() != HttpURLConnection.HTTP_OK ) {
                return "Server returned HTTP " + connection.getResponseCode()
                       + " " + connection.getResponseMessage();
            }
            int fileLength = connection.getContentLength();
            input = connection.getInputStream();
            output = new FileOutputStream ( "/sdcard/file_name.extension" );
            byte data[] = new byte[4096];
            long total = 0;
            int count;
            while ( ( count = input.read ( data ) ) != -1 ) {
                if ( isCancelled() ) {
                    input.close();
                    return null;
                }
                total += count;
                if ( fileLength > 0 ) {
                    publishProgress ( ( int ) ( total * 100 / fileLength ) );
                }
                output.write ( data, 0, count );
            }
        } catch ( Exception e ) {
            return e.toString();
        } finally {
            try {
                if ( output != null ) {
                    output.close();
                }
                if ( input != null ) {
                    input.close();
                }
            } catch ( IOException ignored ) {
            }
            if ( connection != null ) {
                connection.disconnect();
            }
        }
        return null;
    }
