@Override
protected void onPreExecute() {
    super.onPreExecute();
    PowerManager pm = ( PowerManager ) context.getSystemService ( Context.POWER_SERVICE );
    mWakeLock = pm.newWakeLock ( PowerManager.PARTIAL_WAKE_LOCK,
                                 getClass().getName() );
    mWakeLock.acquire();
    mProgressDialog.show();
}
@Override
protected void onProgressUpdate ( Integer... progress ) {
    super.onProgressUpdate ( progress );
    mProgressDialog.setIndeterminate ( false );
    mProgressDialog.setMax ( 100 );
    mProgressDialog.setProgress ( progress[0] );
}
@Override
protected void onPostExecute ( String result ) {
    mWakeLock.release();
    mProgressDialog.dismiss();
    if ( result != null ) {
        Toast.makeText ( context, "Download error: " + result, Toast.LENGTH_LONG ).show();
    } else {
        Toast.makeText ( context, "File downloaded", Toast.LENGTH_SHORT ).show();
    }
}
