public class DownloadService extends IntentService {
    public static final int UPDATE_PROGRESS = 8344;
    public DownloadService() {
        super ( "DownloadService" );
    }
    @Override
    protected void onHandleIntent ( Intent intent ) {
        String urlToDownload = intent.getStringExtra ( "url" );
        ResultReceiver receiver = ( ResultReceiver ) intent.getParcelableExtra ( "receiver" );
        try {
            URL url = new URL ( urlToDownload );
            URLConnection connection = url.openConnection();
            connection.connect();
            int fileLength = connection.getContentLength();
            InputStream input = new BufferedInputStream ( connection.getInputStream() );
            OutputStream output = new FileOutputStream ( "/sdcard/BarcodeScanner-debug.apk" );
            byte data[] = new byte[1024];
            long total = 0;
            int count;
            while ( ( count = input.read ( data ) ) != -1 ) {
                total += count;
                Bundle resultData = new Bundle();
                resultData.putInt ( "progress" , ( int ) ( total * 100 / fileLength ) );
                receiver.send ( UPDATE_PROGRESS, resultData );
                output.write ( data, 0, count );
            }
            output.flush();
            output.close();
            input.close();
        } catch ( IOException e ) {
            e.printStackTrace();
        }
        Bundle resultData = new Bundle();
        resultData.putInt ( "progress" , 100 );
        receiver.send ( UPDATE_PROGRESS, resultData );
    }
}
