public final class SecurityHandler implements SOAPHandler<SOAPMessageContext> {
    ...
    @Override
    public boolean handleMessage ( final SOAPMessageContext msgCtx ) {
        final Boolean outInd = ( Boolean ) msgCtx.get ( MessageContext.MESSAGE_OUTBOUND_PROPERTY );
        if ( outInd.booleanValue() ) {
            try {
                final SOAPEnvelope envelope = msgCtx.getMessage().getSOAPPart().getEnvelope();
                SOAPHeader header = envelope.getHeader();
                if ( header == null ) {
                    header = envelope.addHeader();
                }
                final SOAPElement security = header.addChildElement ( "Security", "wsse",
                                             "http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd" );
                final SOAPElement userToken = security.addChildElement ( "UsernameToken", "wsse" );
                userToken.addChildElement ( "Username", "wsse" ).addTextNode ( "MyWSSUsername" );
                userToken.addChildElement ( "Password", "wsse" ).addTextNode ( "MyWSSPassword" );
            } catch ( final Exception e ) {
                LOG.error ( e );
                return false;
            }
        }
        return true;
    }
    ...
}
