class ScrollableDialog extends TitleAreaDialog {
    private String title;
    private String text;
    private String scrollableText;
    public ScrollableDialog ( Shell parentShell, String title, String text, String scrollableText ) {
        super ( parentShell );
        this.title = title;
        this.text = text;
        this.scrollableText = scrollableText;
    }
    @Override
    protected Control createDialogArea ( Composite parent ) {
        Composite composite = ( Composite ) super.createDialogArea ( parent );
        GridData gridData = new GridData();
        gridData.grabExcessHorizontalSpace = true;
        gridData.horizontalAlignment = GridData.FILL;
        gridData.grabExcessVerticalSpace = true;
        gridData.verticalAlignment = GridData.FILL;
        Text scrollable = new Text ( composite, SWT.BORDER | SWT.V_SCROLL );
        scrollable.setLayoutData ( gridData );
        scrollable.setText ( scrollableText );
        return composite;
    }
    @Override
    public void create() {
        super.create();
        setTitle ( title );
        setMessage ( text, IMessageProvider.ERROR );
    }
    @Override
    protected void createButtonsForButtonBar ( Composite parent ) {
        Button okButton = createButton ( parent, OK, "OK", true );
        okButton.addSelectionListener ( new SelectionAdapter() {
            @Override
            public void widgetSelected ( SelectionEvent e ) {
                close();
            }
        } );
    }
    @Override
    protected boolean isResizable() {
        return true;
    }
}
