CertificateFactory cf = CertificateFactory.getInstance ( "X.509" );
InputStream signatureIn = new ByteArrayInputStream ( signature );
DERObject obj = new ASN1InputStream ( signatureIn ).readObject();
ContentInfo contentInfo = ContentInfo.getInstance ( obj );
SignedData signedData = SignedData.getInstance ( contentInfo.getContent() );
Enumeration certificates = signedData.getCertificates().getObjects();
List certList = new ArrayList();
while ( certificates.hasMoreElements() ) {
    DERObject certObj = ( DERObject ) certificates.nextElement();
    InputStream in = new ByteArrayInputStream ( certObj.getDEREncoded() );
    certList.add ( cf.generateCertificate ( in ) );
}
CertPath certPath = cf.generateCertPath ( certList );
KeyStore keyStore = KeyStore.getInstance ( "JKS" );
keyStore.load ( new FileInputStream ( keyStorePath ), null );
PKIXParameters params = new PKIXParameters ( keyStore );
params.setRevocationEnabled ( false );
CertPathValidator validator = CertPathValidator.getInstance ( "PKIX" );
CertPathValidatorResult result = validator.validate ( certPath, params );
