public static void flushAllLogs() {
    try {
        Set<FileAppender> flushedFileAppenders = new HashSet<FileAppender>();
        Enumeration currentLoggers = LogManager.getLoggerRepository().getCurrentLoggers();
        while ( currentLoggers.hasMoreElements() ) {
            Object nextLogger = currentLoggers.nextElement();
            if ( nextLogger instanceof Logger ) {
                Logger currentLogger = ( Logger ) nextLogger;
                Enumeration allAppenders = currentLogger.getAllAppenders();
                while ( allAppenders.hasMoreElements() ) {
                    Object nextElement = allAppenders.nextElement();
                    if ( nextElement instanceof FileAppender ) {
                        FileAppender fileAppender = ( FileAppender ) nextElement;
                        if ( !flushedFileAppenders.contains ( fileAppender ) && !fileAppender.getImmediateFlush() ) {
                            flushedFileAppenders.add ( fileAppender );
                            fileAppender.setImmediateFlush ( true );
                            currentLogger.info ( "FLUSH" );
                            fileAppender.setImmediateFlush ( false );
                        } else {
                        }
                    }
                }
            }
        }
    } catch ( RuntimeException e ) {
        log.error ( "Failed flushing logs", e );
    }
}
