package com.mycompany.myapp;
import java.io.File;
import java.net.URL;
import java.security.ProtectionDomain;
import org.mortbay.jetty.Server;
import org.mortbay.jetty.webapp.WebAppContext;
public final class EmbeddedJettyServer {
    public static void main ( String[] args ) throws Exception {
        int port = Integer.parseInt ( System.getProperty ( "port", "8080" ) );
        Server server = new Server ( port );
        ProtectionDomain domain = EmbeddedJettyServer.class.getProtectionDomain();
        URL location = domain.getCodeSource().getLocation();
        WebAppContext webapp = new WebAppContext();
        webapp.setContextPath ( "/" );
        webapp.setDescriptor ( location.toExternalForm() + "/WEB-INF/web.xml" );
        webapp.setServer ( server );
        webapp.setWar ( location.toExternalForm() );
        webapp.setTempDirectory ( new File ( "/path/to/webapp-directory" ) );
        server.setHandler ( webapp );
        server.start();
        server.join();
    }
}
