public static Image rescaleImage ( Image original, double XRatio, double YRatio ) {
    int originalWidth = original.getWidth();
    int originalHeight = original.getHeight();
    int newWidth = ( int ) ( XRatio * originalWidth );
    int newHeight = ( int ) ( YRatio * originalHeight );
    int[] rawInput = new int[originalHeight * originalWidth];
    original.getRGB ( rawInput, 0, originalWidth, 0, 0, originalWidth, originalHeight );
    int[] rawOutput = new int[newWidth * newHeight];
    int YD = ( originalHeight / newHeight ) * originalWidth - originalWidth;
    int YR = originalHeight % newHeight;
    int XD = originalWidth / newWidth;
    int XR = originalWidth % newWidth;
    int outOffset = 0;
    int inOffset =  0;
    for ( int y = newHeight, YE = 0; y > 0; y-- ) {
        for ( int x = newWidth, XE = 0; x > 0; x-- ) {
            rawOutput[outOffset++] = rawInput[inOffset];
            inOffset += XD;
            XE += XR;
            if ( XE >= newWidth ) {
                XE -= newWidth;
                inOffset++;
            }
        }
        inOffset += YD;
        YE += YR;
        if ( YE >= newHeight ) {
            YE -= newHeight;
            inOffset += originalWidth;
        }
    }
    return Image.createRGBImage ( rawOutput, newWidth, newHeight, true );
}
