@Scope ( APPLICATION )
@Name ( "org.jboss.seam.web.authenticationFilter" )
@Install ( value = false, precedence = BUILT_IN )
@BypassInterceptors
@Filter ( within = "org.jboss.seam.web.exceptionFilter" )
public class CustomAuthenticationFilter extends org.jboss.seam.web.AbstractFilter {
    private void authenticate ( HttpServletRequest request, final String username ) throws ServletException, IOException {
        new ContextualHttpServletRequest ( request ) {
            @Override
            public void process() throws ServletException, IOException, LoginException {
                Identity identity = Identity.instance();
                identity.getCredentials().setUsername ( username );
                try {
                    identity.preAuthenticate();
                    identity.postAuthenticate();
                } finally {
                    identity.getCredentials.setPassword ( null );
                }
            }
        } .run();
    }
}
