package your.pack.name;
import java.io.File;
public class Desktop {
    Desktop() {}
    public static Desktop getDesktop() {
        String os = System.getProperty ( "os.name" ).toLowerCase();
        Desktop desktop = new Desktop();
        if ( os.indexOf ( "windows" ) != -1 || os.indexOf ( "nt" ) != -1 ) {
            desktop = new WindowsDesktop();
        } else if ( os.equals ( "windows 95" ) || os.equals ( "windows 98" ) ) {
            desktop = new Windows9xDesktop();
        } else if ( os.indexOf ( "mac" ) != -1 ) {
            desktop = new OSXDesktop();
        } else if ( os.indexOf ( "linux" ) != -1 && isGnome() ) {
            desktop = new GnomeDesktop();
        } else if ( os.indexOf ( "linux" ) != -1 && isKde() ) {
            desktop = new KdeDesktop();
        } else {
            throw new UnsupportedOperationException ( String.format ( "The platform %s is not supported ", os ) );
        }
        return desktop;
    }
    public void open ( File file ) {
        throw new UnsupportedOperationException();
    }
    public void imaginaryAction ( File file ) {
        throw new UnsupportedOperationException();
    }
}
class GnomeDesktop extends Desktop {
    public void open ( File file ) {
    }
    public void imaginaryAction ( File file ) {
    }
}
class KdeDesktop extends Desktop {
    public void open ( File file ) {
    }
    public void imaginaryAction ( File file ) {
    }
}
class OSXDesktop extends Desktop {
    public void open ( File file ) {
    }
    public void imaginaryAction ( File file ) {
    }
}
class WindowsDesktop extends Desktop {
    public void open ( File file ) {
    }
    public void imaginaryAction ( File file ) {
    }
}
class Windows9xDesktop extends Desktop {
    public void open ( File file ) {
    }
    public void imaginaryAction ( File file ) {
    }
}
