public class Test {
    public static void main ( String[] args ) throws Throwable  {
        for ( int i = 0; i < 3; i++ ) {
            ProcessRunner pr = new ProcessRunner ( args );
            pr.start();
            pr.join ( 100 );
            if ( !pr.isDone() )  {
                System.err.println ( "Destroying process " + pr );
                pr.abort();
            }
        }
    }
    static class ProcessRunner extends Thread  {
        ProcessBuilder b;
        Process p;
        boolean done = false;
        ProcessRunner ( String[] args )  {
            super ( "ProcessRunner " + args );
            b = new ProcessBuilder ( args );
        }
        public void run()   {
            try   {
                p = b.start();
                p.waitFor();
            } catch ( Exception e ) {
                System.err.println ( e.getMessage() );
            } finally {
                done = true;
            }
        }
        int exitValue() throws IllegalStateException  {
            if ( p != null )  {
                return p.exitValue();
            }
            throw new IllegalStateException ( "Process not started yet" );
        }
        boolean isDone()  {
            return done;
        }
        void abort()   {
            if ( ! isDone() ) {
                p.destroy();
            }
        }
    }
}
