import java.util.List;
import java.net.URL;
import java.net.URLConnection;
import java.util.Map;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
public class StringTemplate {
    private static final Pattern patternPattern = Pattern.compile ( "\\{([^\\{\\}]+)\\}" );
    private String stringPattern;
    private Pattern thisStringPattern;
    private List<String> vars = new ArrayList<String>();
    private StringTemplate ( String stringPattern )  {
        this.stringPattern = stringPattern;
        initialize();
    }
    public List<String> getVars() {
        return vars;
    }
    public boolean matches ( String actualString )  {
        return thisStringPattern.matcher ( actualString ).matches();
    }
    public Map<String, String> match ( String actualString ) {
        Matcher m = thisStringPattern.matcher ( actualString );
        Map<String, String> map = new LinkedHashMap<String, String>();
        if ( m.matches() )   {
            int gc = m.groupCount();
            for ( int i = 0; i < gc; i++ )   {
                int g = i + 1;
                map.put ( vars.get ( i ), actualString.substring ( m.start ( g ), m.end ( g ) ) );
            }
        }
        return map;
    }
    private void initialize()  {
        Matcher m = patternPattern.matcher ( stringPattern );
        StringBuffer builder = new StringBuffer();
        while ( m.find() )   {
            String var = m.group ( 1 );
            vars.add ( var );
            m.appendReplacement ( builder, "(.*)" );
        }
        m.appendTail ( builder );
        String genPattern = builder.toString();
        thisStringPattern = Pattern.compile ( genPattern );
    }
    public static void main ( String[] args ) throws Throwable  {
        StringTemplate t = new StringTemplate ( args[0] );
        System.out.println ( "Matches with actual Class Identifier: java.lang.String: " + t.matches ( args[1] ) );
        System.out.println ( "Var values: " + t.match ( args[1] ) );
    }
}
