@Stateless
public class OrderBillingServiceBean implements OrderBillingService {
    ...
    @Asynchronous
    public void billOrder ( Order order ) {
        try {
            bill ( order );
            notifyBillingSuccess ( order );
            order.setStatus ( OrderStatus.COMPLETE );
        } catch ( BillingException be ) {
            notifyBillingFailure ( be, order );
            order.setStatus ( OrderStatus.BILLING_FAILED );
        } finally {
            update ( order );
        }
    }
    ...
}
