@Stateless
public class OrderBillingServiceBean implements OrderBillingService {
    ...
    @Asynchronous
    public Future<OrderStatus> billOrder ( Order order ) {
        try {
            bill ( order );
            notifyBillingSuccess ( order );
            return new AsyncResult<OrderStatus> ( OrderStatus.COMPLETE );
        } catch ( BillingException be ) {
            notifyBillingFailure ( be, order );
            return new AsyncResult<OrderStatus>
                   ( OrderStatus.BILLING_FAILED );
        }
    }
    ...
}
