public Result execute ( Query query ) throws InterruptedException {
    int id = atomicInteger.incrementAndGet();
    ResultFuture resultFuture = new ResultFuture();
    resultFutureMap.put ( id, resultFuture );
    query.executeAsyncWithId ( id );
    try {
        return resultFuture.get();
    } finally {
        resultFutureMap.remove ( id );
    }
}
public void handleResult ( Result result ) {
    int id = result.getId();
    ResultFuture resultFuture = resultFutureMap.get ( id );
    if ( resultFuture == null ) {
        return;
    }
    resultFuture.set ( result );
}
