public interface InputStreamAction {
    void useStream ( InputStream stream ) throws IOException;
}
public void executeWithFile ( String filename, InputStreamAction action )
throws IOException {
    InputStream stream = new FileInputStream ( filename );
    try {
        action.useStream ( stream );
    } finally {
        stream.close();
    }
}
executeWithFile ( "filename.txt", new InputStreamAction() {
    public void useStream ( InputStream stream ) throws IOException {
    }
} );
executeWithFile ( "filename.txt", s -> System.out.println ( s.read() ) );
executeWithFile ( "filename.txt", ClassName::methodName );
