BasicHttpContext localContext = new BasicHttpContext();
BasicScheme basicAuth = new BasicScheme();
localContext.setAttribute ( "preemptive-auth", basicAuth );
httpClient.addRequestInterceptor ( new PreemptiveAuthInterceptor(), 0 );
( ... )
static class PreemptiveAuthInterceptor implements HttpRequestInterceptor {
    public void process ( final HttpRequest request, final HttpContext context ) throws HttpException, IOException {
        AuthState authState = ( AuthState ) context.getAttribute ( ClientContext.TARGET_AUTH_STATE );
        if ( authState.getAuthScheme() == null ) {
            AuthScheme authScheme = ( AuthScheme ) context.getAttribute ( "preemptive-auth" );
            CredentialsProvider credsProvider = ( CredentialsProvider ) context.getAttribute ( ClientContext.CREDS_PROVIDER );
            HttpHost targetHost = ( HttpHost ) context.getAttribute ( ExecutionContext.HTTP_TARGET_HOST );
            if ( authScheme != null ) {
                Credentials creds = credsProvider.getCredentials ( new AuthScope ( targetHost.getHostName(), targetHost.getPort() ) );
                if ( creds == null ) {
                    throw new HttpException ( "No credentials for preemptive authentication" );
                }
                authState.setAuthScheme ( authScheme );
                authState.setCredentials ( creds );
            }
        }
    }
}
