public class Runner {
    public static void main ( String args[] ) {
        Runner r = new Runner();
        try {
            r.dowork();
        } catch ( IOException e ) {
            e.printStackTrace();
        }
    }
    CyclicBarrier barrier;
    ExecutorService executor;
    private int totalWorkers = 2;
    public Runner() {
        this.barrier = new CyclicBarrier ( this.totalWorkers + 1 );
        this.executor = Executors.newFixedThreadPool ( this.totalWorkers );
    }
    public synchronized void dowork() throws IOException {
        final Worker worker = new Worker();
        for ( String line : new String[] {"Line 1", "Line 2", "Line 3"} ) {
            System.out.println ( "Read line: " + line );
            for ( int c = 0; c < this.totalWorkers; c++ ) {
                final String curLine = line;
                this.executor.submit ( new Runnable() {
                    public void run() {
                        worker.doWork ( curLine );
                    }
                } );
            }
            try {
                System.out.println ( "Waiting for work to be complete on line: " + line );
                this.barrier.await();
            } catch ( InterruptedException e ) {
                e.printStackTrace();
            } catch ( BrokenBarrierException e ) {
                e.printStackTrace();
            }
        }
        System.out.println ( "All work complete!" );
    }
    class Worker {
        public void doWork ( String line ) {
            System.out.println ( "Working on line: " + line );
            try {
                Runner.this.barrier.await();
            } catch ( InterruptedException e ) {
                e.printStackTrace();
            } catch ( BrokenBarrierException e ) {
                e.printStackTrace();
            }
        }
    }
}
