public class ApplicationFilter implements Filter {
    private Map<String, HttpSession> sessions = new HashMap<String, HttpSession>();
    public void init ( FilterConfig config ) throws ServletException {
    }
    public void destroy() {
    }
    public void doFilter ( ServletRequest servletRequest, ServletResponse servletResponse, FilterChain chain )
    throws IOException, ServletException {
        HttpServletRequest request = ( HttpServletRequest ) servletRequest;
        HttpServletResponse response = ( HttpServletResponse ) servletResponse;
        Principal principal = request.getUserPrincipal();
        HttpSession session = request.getSession();
        if ( principal != null && session.getAttribute ( "THE_PRINCIPAL" ) == null ) {
            session.setAttribute ( "THE_PRINCIPAL", session );
            String username = principal.getName();
            HttpSession s = sessions.get ( username );
            if ( s != null ) {
                s.invalidate();
            }
            sessions.put ( username, session );
        }
        chain.doFilter ( servletRequest, servletResponse );
    }
}
