@Entity
public class SubPart implements Serializable {
    @EmbeddedId
    private SubPartId subPartId;
    @ManyToOne ( fetch = FetchType.LAZY )
    @JoinColumn ( name = "PART_ID", insertable = false, updateable = false )
    private Part part;
    @ManyToOne ( fetch = FetchType.LAZY )
    @JoinColumn ( name = "SUP_PART_ID", insertable = false, updateable = false )
    private SubPart subPart;
    public SubPart() {}
    public SubPart ( SubPartId subPartId ) {
        this.subPartId = subPartId;
    }
    @Embeddable
    public static class SubPartId implements Serializable {
        @Column ( name = "PART_ID", updateable = false, nullable = false )
        private Integer partId;
        @Column ( name = "SUB_PART_ID", updateable = false, nullable = false )
        private Integer subPartId;
        public SubPartId() {}
        public SubPartId ( Integer partId, Integer subPartId ) {
            this.partId = partId;
            this.subPartId = subPartId;
        }
        @Override
        public boolean equals ( Object o ) {
            if ( ! ( o instanceof SubPartId ) ) {
                return null;
            }
            final SubPartId other = ( SubPartId ) o;
            return new EqualsBuilder().append ( getPartId(), other.getPartId() )
                   .append ( getSubPartId(), other.getSubPartId() )
                   .isEquals();
        }
        @Override
        public int hashCode() {
            return new HashCodeBuilder().append ( getPartId() )
                   .append ( getSubPartId() )
                   .toHashCode();
        }
    }
}
