public class StringFormatter {
    private static final String fieldStart = "\\$\\{";
    private static final String fieldEnd = "\\}";
    private static final String regex = fieldStart + "([^}]+)" + fieldEnd;
    private static final Pattern pattern = Pattern.compile ( regex );
    public static String format ( String format, Map<String, Object> objects ) {
        Matcher m = pattern.matcher ( format );
        String result = format;
        while ( m.find() ) {
            String[] found = m.group ( 1 ).split ( "\\." );
            Object o = objects.get ( found[0] );
            Field f = o.getClass().getField ( found[1] );
            String newVal = f.get ( o ).toString();
            result = result.replaceFirst ( regex, newVal );
        }
        return result;
    }
    static class Dog {
        public String name;
        public String owner;
        public String gender;
    }
    public static void main ( String[] args ) {
        Dog d = new Dog();
        d.name = "fido";
        d.owner = "Jane Doe";
        d.gender = "him";
        Map<String, Object> map = new HashMap<String, Object>();
        map.put ( "d", d );
        System.out.println (
            StringFormatter.format (
                "My dog is named ${d.name}, and ${d.owner} owns ${d.gender}.",
                map ) );
    }
}
