private final static String NON_THIN = "[^iIl1\\.,']";
private static int textWidth ( String str ) {
    return ( int ) ( str.length() - str.replaceAll ( NON_THIN, "" ).length() / 2 );
}
public static String ellipsize ( String text, int max ) {
    if ( textWidth ( text ) <= max ) {
        return text;
    }
    int end = text.lastIndexOf ( ' ', max - 3 );
    if ( end == -1 ) {
        return text.substring ( 0, max - 3 ) + "...";
    }
    int newEnd = end;
    do {
        end = newEnd;
        newEnd = text.indexOf ( ' ', end + 1 );
        if ( newEnd == -1 ) {
            newEnd = text.length();
        }
    } while ( textWidth ( text.substring ( 0, newEnd ) + "..." ) < max );
    return text.substring ( 0, end ) + "...";
}
