static class CommandLine {
    HashMap<String, Options> options = new HashMap<String, Options>();
    public void register ( String cmd, Options opts ) {
        options.put ( cmd, opts );
    }
    public void parse ( String line ) {
        String[] split = line.split ( "\\s" );
        String cmd = split[0];
        String[] args = new String[split.length - 1];
        if ( args.length > 0 ) {
            System.arraycopy ( split, 1, args, 0, args.length );
        }
        Options opts = options.get ( cmd );
        if ( opts == null )
            ;
        else {
            opts.parse ( args );
            opts.reset();
        }
    }
}
public static void main ( String[] args ) throws Exception {
    CommandLine cl = new CommandLine();
    cl.register ( "size", new Options() );
    cl.register ( "create-char", new Options() );
    BufferedReader in = new BufferedReader ( new InputStreamReader ( System.in ) );
    while ( true ) {
        cl.parse ( in.readLine() );
    }
}
