public class Triple {
    private final int a, b, c;
    public Triple ( int a, int b, int c ) {
        if ( ( a >= c ) || ( b >= c ) ) {
            throw new IllegalArgumentException ( "c is not the largest of the three" );
        }
        this.a = a;
        this.b = b;
        this.c = c;
    }
    public boolean isPythagorean() {
        return a * a + b * b == c * c;
    }
    @Override
    public String toString() {
        return "(" + a + ", " + b + ", " + c + ")";
    }
}
