private void addMissingSuperCall ( final TypeElement element ) {
    final String className = element.getQualifiedName().toString();
    final JCClassDecl classDeclaration =
        this.findClassDeclarationForName ( className );
    if ( classDeclaration == null ) {
        this.error ( element, "Can't find class declaration for " + className );
    } else {
        this.info ( element, "Creating renderHead(response) method" );
        final JCTree extending = classDeclaration.extending;
        if ( extending != null ) {
            final String p = extending.toString();
            if ( p.startsWith ( "com.myclient" ) ) {
                return;
            } else {
                final com.sun.tools.javac.util.Name paramName =
                    elementUtils.getName ( "response" );
                final JCAnnotation overrideAnnotation =
                    this.treeMaker.Annotation (
                        Processor.buildTypeExpressionForClass (
                            this.treeMaker,
                            elementUtils,
                            Override.class
                        ),
                        List.<JCExpression> nil()
                    );
                final JCModifiers mods =
                    this.treeMaker.Modifiers ( Flags.PUBLIC,
                                               List.of ( overrideAnnotation ) );
                final List<JCVariableDecl> params =
                    List.of ( this.treeMaker.VarDef ( this.treeMaker.Modifiers ( Flags.FINAL ),
                                                      paramName,
                                                      Processor.buildTypeExpressionForClass ( this.treeMaker,
                                                              elementUtils,
                                                              IHeaderResponse.class ),
                                                      null ) );
                final JCExpression returnType =
                    this.treeMaker.TypeIdent ( TypeTags.VOID );
                final List<JCStatement> statements =
                    List.<JCStatement> of (
                        this.treeMaker.Exec (
                            this.treeMaker.Apply (
                                List.<JCExpression> nil(),
                                this.treeMaker.Select (
                                    this.treeMaker.Ident (
                                        elementUtils.getName ( "super" )
                                    ),
                                    elementUtils.getName ( "renderHead" )
                                ),
                                List.<JCExpression> of ( this.treeMaker.Ident ( paramName ) ) )
                        )
                    );
                final JCBlock body = this.treeMaker.Block ( 0, statements );
                final JCMethodDecl methodDef =
                    this.treeMaker.MethodDef (
                        mods,
                        elementUtils.getName ( "renderHead" ),
                        returnType,
                        List.<JCTypeParameter> nil(),
                        params,
                        List.<JCExpression> nil(),
                        body,
                        null );
                classDeclaration.defs =
                    classDeclaration.defs.append ( methodDef );
                this.info ( element,
                            "Created renderHead(response) method successfully" );
            }
        }
    }
}
