try {
    InputStream is = new BufferedInputStream (
        new FileInputStream ( "filename.gif" ) );
    DocPrintJob job = service.createPrintJob();
    Doc doc = new SimpleDoc ( is, flavor, null );
    PrintJobWatcher pjDone = new PrintJobWatcher ( job );
    job.print ( doc, null );
    pjDone.waitForDone();
    is.close();
} catch ( PrintException e ) {
} catch ( IOException e ) {
}
class PrintJobWatcher {
    boolean done = false;
    PrintJobWatcher ( DocPrintJob job ) {
        job.addPrintJobListener ( new PrintJobAdapter() {
            public void printJobCanceled ( PrintJobEvent pje ) {
                allDone();
            }
            public void printJobCompleted ( PrintJobEvent pje ) {
                allDone();
            }
            public void printJobFailed ( PrintJobEvent pje ) {
                allDone();
            }
            public void printJobNoMoreEvents ( PrintJobEvent pje ) {
                allDone();
            }
            void allDone() {
                synchronized ( PrintJobWatcher.this ) {
                    done = true;
                    PrintJobWatcher.this.notify();
                }
            }
        } );
    }
    public synchronized void waitForDone() {
        try {
            while ( !done ) {
                wait();
            }
        } catch ( InterruptedException e ) {
        }
    }
}
