public class CreateBarChart  {
    String aFileName = "image1.jpg";
    int width = 250;
    int height = 200;
    double quality = 100;
    JFreeChart chart = null;
    public CreateBarChart ( String aFileName, int width, int height, double quality ) {
        this.aFileName = aFileName;
        this.width = width;
        this.height = height;
        this.quality = quality;
    }
    public CreateBarChart() {
    }
    private static CategoryDataset createDataset ( String barchartdata[][] ) {
        String series1 = "";
        DefaultCategoryDataset dataset = new DefaultCategoryDataset();
        for ( int i = barchartdata.length - 1; i >= 0; i-- ) {
            if ( barchartdata[i][0] == null ) {
                break;
            } else {
                String value_str = barchartdata[i][0];
                value_str = value_str.replaceAll ( "#", "" );
                float value = 0;
                value = Integer.parseInt ( value_str );
                dataset.addValue ( value, series1, barchartdata[i][1] );
            }
        }
        return dataset;
    }
    public  JFreeChart createChart ( String barchartdata[][] ) {
        CategoryDataset dataset = createDataset ( barchartdata );
        chart = ChartFactory.createBarChart3D (
                    "",
                    "",
                    "",
                    dataset,
                    PlotOrientation.VERTICAL,
                    false,
                    false,
                    false
                );
        chart.setBackgroundPaint ( Color.white );
        chart.setPadding ( RectangleInsets.ZERO_INSETS );
        CategoryPlot plot = chart.getCategoryPlot();
        plot.setBackgroundPaint ( Color.WHITE );
        plot.setDomainGridlinePaint ( Color.white );
        plot.setDomainGridlinesVisible ( true );
        plot.setRangeGridlinePaint ( Color.white );
        plot.getDomainAxis().setCategoryMargin ( 0.0f );
        final NumberAxis rangeAxis = ( NumberAxis ) plot.getRangeAxis();
        rangeAxis.setStandardTickUnits ( NumberAxis.createIntegerTickUnits() );
        BarRenderer renderer = ( BarRenderer ) plot.getRenderer();
        renderer.setDrawBarOutline ( true );
        GradientPaint gp0 = new GradientPaint (
            0.0f, 0.0f, new Color ( 0, 118, 112 ),
            100.0f, 100.0f, new Color ( 0, 118, 112 )
        );
        renderer.setSeriesPaint ( 0, gp0 );
        CategoryAxis domainAxis = plot.getDomainAxis();
        domainAxis.setCategoryLabelPositions (
            CategoryLabelPositions.createUpRotationLabelPositions ( Math.PI / 5.0 )
        );
        try {
            saveToFile ( chart, aFileName );
        } catch ( Exception ex ) {
            ex.printStackTrace();
        }
        return chart;
    }
    private  void saveToFile ( JFreeChart chart, String aFileName ) throws FileNotFoundException, IOException {
        BufferedImage img = draw ( chart, width, height );
        FileOutputStream fos = new FileOutputStream ( aFileName );
        JPEGImageEncoder encoder2 = JPEGCodec.createJPEGEncoder ( fos );
        JPEGEncodeParam param2 = encoder2.getDefaultJPEGEncodeParam ( img );
        param2.setQuality ( ( float ) quality, true );
        encoder2.encode ( img, param2 );
        fos.close();
    }
    private static BufferedImage draw ( JFreeChart chart, int width, int height ) {
        BufferedImage img =
            new BufferedImage ( width , height,
                                BufferedImage.TYPE_INT_RGB );
        Graphics2D g2 = img.createGraphics();
        try {
            chart.draw ( g2, new Rectangle2D.Double ( 0, 0, width, height ) );
            g2.dispose();
        } catch ( Exception ex ) {
            ex.printStackTrace();
        }
        return img;
    }
    public static void main ( String[] args ) throws FileNotFoundException, IOException {
        CreateBarChart demo = new CreateBarChart ( "f:/image.jpg", 250, 300, 100 );
        String data[][] = new String[2][2];
        data[0][0] = "30";
        data[0][1] = "jan";
        data[1][0] = "20";
        data[1][1] = "feb";
        demo.createChart ( data );
        demo.saveToFile ( demo.chart, "iamge.jpg" );
    }
}
