package parsers;
import javax.xml.stream.*;
import java.io.*;
import javax.xml.namespace.QName;
public class StAXTest {
    public static void main ( String[] args ) throws Exception {
        long time1 = System.currentTimeMillis();
        XMLInputFactory factory = XMLInputFactory.newInstance();
        XMLStreamReader reader = factory.createXMLStreamReader (
                                     new FileInputStream (
                                         new File ( "/Users/macpro/Desktop/myxml.xml" ) ) );
        try {
            int inElement = 0;
            for ( int event = reader.next(); event != XMLStreamConstants.END_DOCUMENT;
                    event = reader.next() ) {
                switch ( event ) {
                case XMLStreamConstants.START_ELEMENT:
                    if ( isElement ( reader.getLocalName(), "href" ) ) {
                        inElement++;
                    }
                    break;
                case XMLStreamConstants.END_ELEMENT:
                    if ( isElement ( reader.getLocalName(), "href" ) ) {
                        inElement--;
                        if ( inElement == 0 ) {
                            System.out.println();
                        }
                    }
                    break;
                case XMLStreamConstants.CHARACTERS:
                    if ( inElement > 0 ) {
                        System.out.println ( reader.getText() );
                    }
                    break;
                case XMLStreamConstants.CDATA:
                    if ( inElement > 0 ) {
                        System.out.println ( reader.getText() );
                    }
                    break;
                }
            }
            reader.close();
        } catch ( XMLStreamException ex ) {
            System.out.println ( ex.getMessage() );
            System.exit ( 1 );
        }
        long time2 = System.currentTimeMillis() - time1;
        System.out.println ( time2 );
    }
    public static boolean isElement ( String name, String element ) {
        if ( name.equals ( element ) ) {
            return true;
        }
        return false;
    }
}
