public abstract class JpaBaseRolledBackTestCase {
    protected static EntityManagerFactory emf;
    protected EntityManager em;
    @BeforeClass
    public static void createEntityManagerFactory() {
        emf = Persistence.createEntityManagerFactory ( "PetstorePu" );
    }
    @AfterClass
    public static void closeEntityManagerFactory() {
        emf.close();
    }
    @Before
    public void beginTransaction() {
        em = emf.createEntityManager();
        em.getTransaction().begin();
    }
    @After
    public void rollbackTransaction() {
        if ( em.getTransaction().isActive() ) {
            em.getTransaction().rollback();
        }
        if ( em.isOpen() ) {
            em.close();
        }
    }
}
