package StockMarket;
import java.util.Vector;
import org.omg.CORBA.*;
import org.omg.CORBA.Object;
import org.omg.CosNaming.NameComponent;
import org.omg.CosNaming.NamingContextExt;
import org.omg.CosNaming.NamingContextExtHelper;
import org.omg.CosNaming.NamingContextPackage.CannotProceed;
import org.omg.CosNaming.NamingContextPackage.NotFound;
import org.omg.PortableServer.*;
import org.omg.PortableServer.POAPackage.ServantNotActive;
import org.omg.PortableServer.POAPackage.WrongPolicy;
public class StockServerImpl
    extends StockServerPOA
    implements StockServer {
    private static final long serialVersionUID = 1L;
    public static final String SERVICENAME = "StockServer";
    private Vector<String> myStockSymbols;
    private Vector<Float> myStockValues;
    @SuppressWarnings ( "unused" )
    private ORB orb;
    public void setORB ( ORB orb_val ) {
        orb = orb_val;
    }
    private static char ourCharacters[] = {
        'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I',
        'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R',
        'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z'
    };
    private static String ourPathName = "StockServer";
    public StockServerImpl() {
        myStockSymbols = new Vector<String>();
        myStockValues = new Vector<Float>();
        for ( int i = 0; i < 10; i++ ) {
            StringBuffer stockSymbol = new StringBuffer ( "    " );
            for ( int j = 0; j < 4; j++ ) {
                stockSymbol.setCharAt ( j, ourCharacters[ ( int ) ( Math.random() * 26f )] );
            }
            myStockSymbols.addElement ( stockSymbol.toString() );
            myStockValues.addElement ( new Float ( Math.random() * 100f ) );
        }
        System.out.println ( "Generated stock symbols:" );
        for ( int i = 0; i < 10; i++ ) {
            System.out.println (
                " " + myStockSymbols.elementAt ( i )
                + " " + myStockValues.elementAt ( i )
            );
        }
        System.out.println();
    }
    @Override
    public float getStockValue ( String symbol ) throws InvalidStockSymbolException {
        System.out.println ( "Getting stock value for symbol: " + symbol );
        int stockIndex = myStockSymbols.indexOf ( symbol );
        if ( stockIndex != -1 ) {
            return ( myStockValues.elementAt ( stockIndex ).floatValue() );
        } else {
            throw new InvalidStockSymbolException();
        }
    }
    @Override
    public String[] getStockSymbols() {
        System.out.println ( "Getting stock symbols..." );
        String[] symbols = new String[myStockSymbols.size()];
        myStockSymbols.copyInto ( symbols );
        return symbols;
    }
    public static void setOurPathName ( String ourPathName ) {
        StockServerImpl.ourPathName = ourPathName;
    }
    public static String getOurPathName() {
        return ourPathName;
    }
    public static void main ( String args[] ) {
        NameComponent path[] = null;
        NamingContextExt ncRef = null;
        org.omg.CORBA.Object objRef = null;
        org.omg.CORBA.Object ref = null;
        StockServer href = null;
        StockServerImpl stockServerImpl = null;
        ORB orb = StockServerORBHelper.getORB ( args );
        POA rootpoa = StockServerPOAHelper.getRoot ( orb );
        try {
            stockServerImpl = new StockServerImpl();
        } catch ( Exception ex ) {
            System.err.println ( "Can't create StockServer: " + ex.getMessage() );
        }
        try {
            stockServerImpl.setORB ( orb );
        } catch ( Exception ex ) {
            System.err.println ( "Can't set ORB on StockServer: " + ex.getMessage() );
        }
        try {
            ref = rootpoa.servant_to_reference ( stockServerImpl );
        } catch ( ServantNotActive ex ) {
            System.err.println ( "Can't assign servant to reference, Servant Not Active: " + ex.getMessage() );
            ex.printStackTrace();
        } catch ( WrongPolicy ex ) {
            System.err.println ( "Can't assign servant to reference, Wrong Policy: " + ex.getMessage() );
            ex.printStackTrace();
        }
        try {
            href = StockServerHelper.narrow ( ref );
        } catch ( Exception ex ) {
            System.err.println ( "Can't narrow StockServer: " + ex.getMessage() );
            ex.printStackTrace();
        }
        try {
            objRef = orb.resolve_initial_references ( "NameService" );
        } catch ( Exception ex ) {
            System.err.println ( "Can't resolve NameServeice: " + ex.getMessage() );
            ex.printStackTrace();
        }
        try {
            ncRef = NamingContextExtHelper.narrow ( objRef );
        } catch ( Exception ex ) {
            System.err.println ( "Can't narrow NamingContextExt: " + ex.getMessage() );
        }
        try {
            path = ncRef.to_name ( SERVICENAME );
        } catch ( org.omg.CosNaming.NamingContextPackage.InvalidName ex ) {
            System.err.println ( "Can't name path: " + ex.getMessage() );
        }
        try {
            ncRef.rebind ( path, href );
        } catch ( NotFound ex ) {
            System.err.println ( "Can't rebind ncRef, not Found: " + ex.getMessage() );
        } catch ( CannotProceed ex ) {
            System.err.println ( "Can't rebind ncRef, cannot proceed: " + ex.getMessage() );
        } catch ( org.omg.CosNaming.NamingContextPackage.InvalidName ex ) {
            System.err.println ( "Can't rebind ncRef, invalid name: " + ex.getMessage() );
        }
        System.out.println ( "StockServer ready and waiting..." );
        orb.run();
        java.lang.Object waitOnMe = new java.lang.Object();
        synchronized ( waitOnMe ) {
            try {
                waitOnMe.wait();
            } catch ( InterruptedException ex ) {
                System.err.println ( "Can't wait: " + ex.getMessage() );
                ex.printStackTrace();
            }
        }
        System.out.println ( "StockServer Exiting..." );
    }
    @Override
    public Request _create_request ( Context arg0, String arg1, NVList arg2,
                                     NamedValue arg3 ) {
        return null;
    }
    @Override
    public Request _create_request ( Context arg0, String arg1, NVList arg2,
                                     NamedValue arg3, ExceptionList arg4, ContextList arg5 ) {
        return null;
    }
    @Override
    public Object _duplicate() {
        return null;
    }
    @Override
    public DomainManager[] _get_domain_managers() {
        return null;
    }
    @Override
    public Policy _get_policy ( int arg0 ) {
        return null;
    }
    @Override
    public int _hash ( int arg0 ) {
        return 0;
    }
    @Override
    public boolean _is_equivalent ( Object arg0 ) {
        return false;
    }
    @Override
    public void _release() {
    }
    @Override
    public Request _request ( String arg0 ) {
        return null;
    }
    @Override
    public Object _set_policy_override ( Policy[] arg0, SetOverrideType arg1 ) {
        return null;
    }
}
