package ru.donz.util.javatools;
import java.io.*;
public class ConsoleProcessExecutor {
    public static void execute ( String[] args, Runtime runtime, File workDir, OutputStream out, OutputStream err )
    throws IOException, InterruptedException {
        Process process = runtime.exec ( args, null, workDir );
        new Thread ( new StreamReader ( process.getInputStream(), out ) ).start();
        new Thread ( new StreamReader ( process.getErrorStream(), err ) ).start();
        int rc = process.waitFor();
        if ( rc != 0 ) {
            StringBuilder argSB = new StringBuilder( );
            for ( String arg : args ) {
                argSB.append ( arg ).append ( ' ' );
            }
            throw new RuntimeException ( "Process execution failed. Return code: " + rc + "\ncommand: " + argSB );
        }
    }
}
class StreamReader implements Runnable {
    private final InputStream in;
    private final OutputStream out;
    public StreamReader ( InputStream in, OutputStream out ) {
        this.in = in;
        this.out = out;
    }
    @Override
    public void run() {
        int c;
        try {
            while ( ( c = in.read() ) != -1 ) {
                out.write ( c );
            }
            out.flush();
        } catch ( IOException e ) {
            e.printStackTrace();
        }
    }
}
