private abstract class HashIterator<E> implements Iterator<E> {
    Entry<K, V> next;
    int expectedModCount;
    int index;
    Entry<K, V> current;
    HashIterator() {
        expectedModCount = modCount;
        if ( size > 0 ) {
            Entry[] t = table;
            while ( index < t.length && ( next = t[index++] ) == null )
                ;
        }
    }
    final Entry<K, V> nextEntry() {
        if ( modCount != expectedModCount ) {
            throw new ConcurrentModificationException();
        }
        Entry<K, V> e = next;
        if ( e == null ) {
            throw new NoSuchElementException();
        }
        if ( ( next = e.next ) == null ) {
            Entry[] t = table;
            while ( index < t.length && ( next = t[index++] ) == null )
                ;
        }
        current = e;
        return e;
    }
}
