#include "stdafx.h"
class QuackBehavior {
    public:
    virtual void quack() = NULL;
};
class Quack : public QuackBehavior {
    public:
    void quack() {
        printf ( "Quack" );
    }
};
class Squeak : public QuackBehavior {
    public:
    void quack() {
        printf ( "Squeak" );
    }
};
class Duck {
    public:
    QuackBehavior * pQuack;
    void performQuack() {
        if ( pQuack != NULL ) {
            pQuack->quack();
        }
    }
    void setQuackBehavior ( QuackBehavior * qb ) {
        pQuack = qb;
    }
};
class MallardDuck : public Duck {
    public:
    MallardDuck() {
        pQuack = new Quack();
    }
};
int _tmain ( int argc, _TCHAR * argv[] ) {
    Duck * mallard = new MallardDuck();
    mallard->setQuackBehavior ( new Squeak() );
    mallard->performQuack();
    return 0;
}
