public class Main {
    public static void main ( String... args ) throws IOException {
        final String filename = args[0];
        final File file = new File ( filename );
        DataInputStream dis = new DataInputStream ( new FileInputStream ( file ) );
        byte[] bytes = new byte[ ( int ) file.length()];
        dis.readFully ( bytes );
        test ( bytes, false );
        for ( int i = 0; i < 5; i++ ) {
            test ( bytes, true );
        }
    }
    private static void test ( byte[] bytes, boolean print ) throws IOException {
        OutputStream out = new ByteOutputStream ( bytes.length );
        Deflater def = new Deflater ( Deflator.BEST_SPEED );
        DeflaterOutputStream dos = new DeflaterOutputStream ( out, def, 4 * 1024 );
        long start = System.nanoTime();
        int count = 0;
        int size = 5 * 1024;
        for ( int i = 0; i < bytes.length - size; i += size, count++ ) {
            dos.write ( bytes, i, size );
            dos.flush();
        }
        dos.close();
        long time = System.nanoTime() - start;
        long latency = time / count;
        long bandwidth = ( count * size * 1000L ) / time;
        if ( print ) {
            System.out.println ( "Average latency " + latency + " ns. Bandwidth " + bandwidth + " MB/s." );
        }
    }
}
