public static void logHeap ( Class clazz ) {
    Double allocated = new Double ( Debug.getNativeHeapAllocatedSize() ) / 1048576.0 );
    Double available = new Double ( Debug.getNativeHeapSize() ) / 1048576.0 );
    Double free = new Double ( Debug.getNativeHeapFreeSize() ) / 1048576.0 );
    DecimalFormat df = new DecimalFormat();
    df.setMaximumFractionDigits ( 2 );
    df.setMinimumFractionDigits ( 2 );
    Log.d ( APP, "debug. =================================" );
    Log.d ( APP, "debug.heap native: allocated " + df.format ( allocated ) + "MB of " + df.format ( available ) + "MB (" + df.format ( free ) + "MB free) in [" + clazz.getName().replaceAll ( "com.myapp.android.", "" ) + "]" );
    Log.d ( APP, "debug.memory: allocated: " + df.format ( new Double ( Runtime.getRuntime().totalMemory() / 1048576.0 ) ) + "MB of " + df.format ( new Double ( Runtime.getRuntime().maxMemory() / 1048576.0 ) ) + "MB (" + df.format ( new Double ( Runtime.getRuntime().freeMemory() / 1048576.0 ) ) + "MB free)" );
    System.gc();
    System.gc();
    if ( allocated >= ( new Double ( Runtime.getRuntime().maxMemory() ) / 1048576.0 ) - MEMORY_BUFFER_LIMIT_FOR_RESTART ) ) {
        android.os.Process.killProcess ( android.os.Process.myPid() );
    }
}
