package so3950354;
import java.util.Iterator;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.ConcurrentMap;
public class ServerManager {
    private final ConcurrentMap<Server, Long> lastActive = new ConcurrentHashMap<Server, Long>();
    protected long now() {
        return System.currentTimeMillis();
    }
    public void markActive ( Server server ) {
        lastActive.put ( server, Long.valueOf ( now() ) );
    }
    public void removeInactive ( long timeoutMillis ) {
        final long now = now();
        Iterator<Map.Entry<Server, Long>> it = lastActive.entrySet().iterator();
        while ( it.hasNext() ) {
            final Map.Entry<Server, Long> entry = it.next();
            final long backThen = entry.getValue().longValue();
            if ( now - backThen >= timeoutMillis ) {
                it.remove();
            }
        }
    }
    static class Server {
    }
}
