void Sprite::combineTextures ( vector<Texture> const & dependant_textures,
                               Texture & combined_tex ) {
    vector< Texture >::iterator iter = dependant_textures.begin();
    combined_tex = * iter;
    if ( dependant_textures.size() > 1 )
        for ( iter++; iter != dependant_textures.end(); iter++ ) {
            Texture & current_tex = * iter;
            for ( unsigned char pixel_index = 0;
                    pixel_index < current_tex.numPixels(); pixel_index++ ) {
                int const BYTESPERPIXEL = 4;
                if ( !current_tex.getRawData() [pixel_index * BYTESPERPIXEL + 3] )
                    for ( int copied_bytes = 0; copied_bytes < 3; copied_bytes++ ) {
                        int index = pixel_index * BYTESPERPIXEL + copied_bytes;
                        combined_tex.getRawData() [index] =
                            current_tex.getRawData() [index];
                    }
            }
        }
}
