import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import javax.swing.*;
public class RoundButton extends JButton {
    public RoundButton ( String label ) {
        super ( label );
        Dimension size = getPreferredSize();
        size.width = size.height = Math.max ( size.width, size.height );
        setPreferredSize ( size );
        setContentAreaFilled ( false );
    }
    protected void paintComponent ( Graphics g ) {
        if ( getModel().isArmed() ) {
            g.setColor ( Color.lightGray );
        } else {
            g.setColor ( getBackground() );
        }
        g.fillOval ( 0, 0, getSize().width - 1, getSize().height - 1 );
        super.paintComponent ( g );
    }
    protected void paintBorder ( Graphics g ) {
        g.setColor ( getForeground() );
        g.drawOval ( 0, 0, getSize().width - 1, getSize().height - 1 );
    }
    Shape shape;
    public boolean contains ( int x, int y ) {
        if ( shape == null || !shape.getBounds().equals ( getBounds() ) ) {
            shape = new Ellipse2D.Float ( 0, 0, getWidth(), getHeight() );
        }
        return shape.contains ( x, y );
    }
    public static void main ( String[] args ) {
        JButton button = new RoundButton ( "Jackpot" );
        button.setBackground ( Color.green );
        button.setBounds ( 0, 0, 100, 100 );
        JButton button2 = new RoundButton ( "Jackpot2" );
        button2.setBackground ( Color.red );
        button2.setBounds ( 50, 50, 100, 100 );
        JFrame frame = new JFrame();
        frame.getContentPane().setBackground ( Color.yellow );
        frame.getContentPane().setLayout ( null );
        frame.getContentPane().add ( button );
        frame.getContentPane().add ( button2 );
        frame.setSize ( 200, 200 );
        frame.setVisible ( true );
        MouseListener mouseListener = new MouseAdapter() {
            public void mouseEntered ( MouseEvent e ) {
            }
            public void mouseExited ( MouseEvent e ) {
            }
            public void mouseClicked ( MouseEvent e ) {
                System.out.println ( "clicked " );
            }
            public void mousePressed ( MouseEvent e ) {
                System.out.println ( "pressed " );
            }
            public void mouseReleased ( MouseEvent e ) {
                System.out.println ( "released " );
            }
        };
        button.addMouseListener ( mouseListener );
    }
}
