DROP SEQUENCE SEQ_USER;
DROP TABLE "USER" CASCADE CONSTRAINTS;
PURGE TABLE "USER";
CREATE TABLE "USER"
(
    USER_ID          NUMBER ( 10 ) NOT NULL,
    CREATOR_USER_FK  NUMBER ( 10 ) NOT NULL,
    PRIMARY KEY ( USER_ID )
);
ALTER TABLE "USER" ADD CONSTRAINT FK_USER_CUSER FOREIGN KEY ( CREATOR_USER_FK ) REFERENCES "USER" ( USER_ID );
CREATE SEQUENCE SEQ_USER START WITH 1 INCREMENT BY 1;
CREATE TRIGGER "USER_ID_SEQ_INC" BEFORE
INSERT ON "USER" FOR EACH ROW
WHEN ( new.USER_ID IS NULL )
BEGIN
SELECT SEQ_USER.nextval
INTO : new.USER_ID
FROM DUAL;
END;
/
ALTER TRIGGER "USER_ID_SEQ_INC" ENABLE;
