public class AddableArray {
    private int[] a;
    public AddableArray ( final int... a ) {
        this.a = a;
    }
    public void plus ( final int[] b ) {
        assert b != null;
        if ( a.length < b.length ) {
            final int[] newA = new int[b.length];
            System.arraycopy ( a, 0, newA, 0, a.length );
            a = newA;
        }
        for ( int i = 0; i < b.length; i++ ) {
            a[i] = a[i] + b[i];
        }
    }
    int[] get() {
        return a;
    }
    @Override
    public String toString() {
        final StringBuilder sb = new StringBuilder ( "a[] = [ " );
        for ( int i = 0; i < a.length; i++ ) {
            if ( i > 0 ) {
                sb.append ( ", " );
            }
            sb.append ( a[i] );
        }
        sb.append ( " ]" );
        return sb.toString();
    }
    public static void main ( final String[] args ) {
        final AddableArray myAddableArray = new AddableArray ( 1, 2, 3 );
        System.out.println ( "Elements before plus(): " );
        System.out.println ( myAddableArray.toString() );
        final int b[] = {1, 2, 3, 4};
        myAddableArray.plus ( b );
        System.out.println ( "Elements after plus(): " );
        System.out.println ( myAddableArray.toString() );
    }
}
