package jfco.progs;
import java.util.concurrent.CountDownLatch;
public class ObjectLatch<R> {
    private R object = null;
    private final CountDownLatch latch = new CountDownLatch ( 1 );
    public boolean isAvailable() {
        return latch.getCount() == 0;
    }
    public synchronized void set ( R object ) {
        if ( !isAvailable() ) {
            this.object = object;
            latch.countDown();
        }
    }
    public R get() throws InterruptedException {
        latch.await();
        synchronized ( this ) {
            return object;
        }
    }
}
