public static swapNode ( Node parent, Node child ) {
    Long superId = parent.getParentId();
    child.parentId ( superId );
    parent.setParentId ( child.getId() );
    child.setId ( parentId );
}
public static List<Node> createNodeTree ( List<Node> allNodes, Long parentId ) {
    List<Node> treeList = new ArrayList<Node>();
    for ( Node node : nodes ) {
        if ( parentIdMatches ( node, parentId ) ) {
            node.setChildren ( createNodeTree ( allNodes, node.getId() ) );
            treeList.add ( node );
        }
    }
    return treeList;
}
private static boolean parentIdMatches ( Node node, Long parentId ) {
    return ( parentId != null && parentId.equals ( node.getParentId() ) )
           || ( parentId == null && node.getParentId() == null );
}
public interface Node {
    void setParentId ( Long id );
    Long getParentId();
    Long getId();
    List<Node> getChildren();
    void setChildren ( List<Node> nodes );
}
