public List<ErrorMessage> validate ( T value ) {
    if ( ruleSetModified ) {
        Collections.sort ( rule );
        ruleSetModified = false;
    }
    List <ErrorMessage> errors = new ArrayList<String>();
    PrioritizedRule prev = null;
    for ( PrioritizedRule<? super T> rule : tests ) {
        if ( prev != null && prev.compareTo ( rule ) != 0 && !errors.isEmpty() ) {
            return errors;
        }
        errors.addAll ( rule.check ( value ) );
        prev = rule;
    }
    return errors;
}
