void getFrame ( Camera cam ) {
    ByteBuffer frameData = cam.getFrame();
    byte[] imgArray = new byte[frame.data.capacity()];
    frameData.get ( imgArray );
    DataBufferByte frameDataBuf = new DataBufferByte ( imgArray, imgArray.length );
    int dataType = DataBuffer.TYPE_BYTE;
    int width = cam.getFrameWidth();
    int height = cam.getFrameHeight();
    int pixelStride = cam.getPixelStride();
    int scanlineStride = cam.getScanlineStride();
    int bandOffsets = new int[] {2, 1, 0};
    PixelInterleavedSampleModel pism = new PixelInterleavedSampleModel
    (
        dataType,
        width,
        height,
        pixelStride,
        scanlineStride,
        bandOffsets
    );
    WritableRaster raster = new ImgFeedWritableRaster ( pism, frameDataBuf, new Point ( 0, 0 ) );
    ColorSpace cs = ColorSpace.getInstance ( ColorSpace.CS_sRGB );
    ComponentColorModel cm = new ComponentColorModel ( cs, false, false, Transparency.OPAQUE, DataBuffer.TYPE_BYTE );
    BufferedImage newImg = new BufferedImage ( cm, raster, false, null );
    handleNewImage ( newImg );
}
