public void save ( List<Entity> entities ) throws SQLException {
    Connection connection = null;
    PreparedStatement statement = null;
    try {
        connection = database.getConnection();
        statement = connection.prepareStatement ( SQL_INSERT );
        for ( int i = 0; i < entities.size(); i++ ) {
            Entity entity = entities.get ( i );
            statement.setString ( 1, entity.getSomeProperty() );
            statement.addBatch();
            if ( ( i + 1 ) % 1000 == 0 ) {
                statement.executeBatch();
            }
        }
        statement.executeBatch();
    } finally {
        if ( statement != null ) try {
                statement.close();
            } catch ( SQLException logOrIgnore ) {}
        if ( connection != null ) try {
                connection.close();
            } catch ( SQLException logOrIgnore ) {}
    }
}
