import java.io.FileInputStream;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.Marshaller;
import javax.xml.bind.Unmarshaller;
import javax.xml.stream.XMLInputFactory;
import javax.xml.stream.XMLStreamReader;
import javax.xml.stream.util.StreamReaderDelegate;
public class Demo {
    public static void main ( String[] args ) throws Exception {
        JAXBContext jc = JAXBContext.newInstance ( Customer.class );
        XMLInputFactory xif = XMLInputFactory.newInstance();
        XMLStreamReader xsr = xif.createXMLStreamReader ( new FileInputStream ( "input.xml" ) );
        xsr = new MyStreamReaderDelegate ( xsr );
        Unmarshaller unmarshaller = jc.createUnmarshaller();
        Customer customer = ( Customer ) unmarshaller.unmarshal ( xsr );
        Marshaller marshaller = jc.createMarshaller();
        marshaller.setProperty ( Marshaller.JAXB_FORMATTED_OUTPUT, true );
        marshaller.marshal ( customer, System.out );
    }
    private static class MyStreamReaderDelegate extends StreamReaderDelegate {
        public MyStreamReaderDelegate ( XMLStreamReader xsr ) {
            super ( xsr );
        }
        @Override
        public String getAttributeLocalName ( int index ) {
            return super.getAttributeLocalName ( index ).toLowerCase();
        }
        @Override
        public String getLocalName() {
            return super.getLocalName().toLowerCase();
        }
    }
}
