class Example {
    class LazyInitStrategy implements Runnable {
        private final Runnable operation;
        private boolean done = false;
        LazyInitStrategy ( Runnable operation ) {
            this.operation = operation;
        }
        @Override
        public void run() {
            if ( !done ) {
                operation.run();
                done = true;
            }
        }
    }
    private final class AbstractInit implements Runnable {
        public void run() {
        }
    }
    private final class AbstractWebInit implements Runnable {
        public void run() {
        }
    }
    class AbstractTestClass {
        final LazyInitStrategy setup = new LazyInitStrategy ( new AbstractInit() );
        @Before
        public void before() {
            setup.run();
        }
    }
    class AbstractWebTestClass extends WebTestCase {
        final LazyInitStrategy setupInfo = new LazyInitStrategy ( new AbstractWebInit() );
        @Before
        public void before() {
            setupInfo.run();
        }
    }
