public void test() {
    EntityManager em = entityManagerFactory.createEntityManager();
    em.getTransaction().begin();
    Organization org = em.find ( Organization.class, 1 );
    em.getTransaction().commit();
    PersistenceUnitUtil unitUtil = em.getEntityManagerFactory().getPersistenceUnitUtil();
    Assert.assertTrue ( unitUtil.isLoaded ( org ) );
    Assert.assertFalse ( unitUtil.isLoaded ( org, "users" ) );
    initializeCollection ( org.getUsers() );
    Assert.assertTrue ( unitUtil.isLoaded ( org, "users" ) );
    for ( User user : org.getUsers() ) {
        Assert.assertTrue ( unitUtil.isLoaded ( user ) );
        Assert.assertTrue ( unitUtil.isLoaded ( user.getOrganization() ) );
    }
}
private void initializeCollection ( Collection<?> collection ) {
    if ( collection == null ) {
        return;
    }
    collection.iterator().hasNext();
}
