public class DiagramMaker {
    private final int[] data;
    private final char[] filler;
    private final int maxHeight;
    private final int columnWidth;
    private final int spacing;
    private int[] colHeights;
    public DiagramMaker ( int[] data, char[] filler, int maxHeight, int columnWidth, int spacing ) {
        this.data = data;
        this.filler = filler;
        this.maxHeight = maxHeight;
        this.columnWidth = columnWidth;
        this.spacing = spacing;
    }
    public render ( StringBuffer buffer ) {
        colHeights = DiagramMaker.getColumnHeights ( data, maxHeight );
        for ( int i = 0; i < maxHeight; i++ ) {
            printLine ( buffer, i );
        }
    }
    public void printLine ( StringBuffer buffer, int lineNum ) {
        for ( int i = 0; i < colHeights.length; i++ ) {
            if ( colHeights[lineNum] >= maxHeight - lineNum ) {
                DiagramMaker.printColumnLine ( buffer, filler[i], columnWidth );
                if ( i < colHeights.length - 1 ) {
                    DiagramMaker.printColumnLine ( buffer, ' ', spacing );
                }
            }
        }
    }
    protected static void printColumnLine ( StringBuffer buffer, char filler, int width ) {
        for ( int i = 0; i < width; i++ ) {
            buffer.append ( filler );
        }
    }
    protected static int getMaxData ( int[] data ) {
        int maxData = 0;
        for ( int val : data ) {
            if ( val > maxData ) {
                maxData = val;
            }
        }
        return maxData;
    }
    protected static int[] getColumnHeights ( int[] data, int maxHeight ) {
        int maxData = getMaxData ( data )
                      int[] heights = new int[data.length];
        for ( int i = 0; i < data.length; i++ ) {
            double scale = ( ( double ) data[i] ) / maxData;
            heights[i] = ( int ) ( scale * data[i] );
        }
    }
}
