import javax.swing.SwingUtilities;
public class Test {
    public static class ExceptionHandler
        implements Thread.UncaughtExceptionHandler {
        public void handle ( Throwable thrown ) {
            handleException ( Thread.currentThread().getName(), thrown );
        }
        public void uncaughtException ( Thread thread, Throwable thrown ) {
            handleException ( thread.getName(), thrown );
        }
        protected void handleException ( String tname, Throwable thrown ) {
            System.err.println ( "Exception on " + tname );
            thrown.printStackTrace();
        }
    }
    public static void main ( String[] args ) {
        Thread.setDefaultUncaughtExceptionHandler ( new ExceptionHandler() );
        System.setProperty ( "sun.awt.exception.handler",
                             ExceptionHandler.class.getName() );
        SwingUtilities.invokeLater ( new Runnable() {
            public void run() {
                ( ( Object ) null ).toString();
            }
        } );
        ( ( Object ) null ).toString();
    }
}
