public static void removeLines ( final File targetFile,
                                 final Charset charSet,
                                 final Collection<Integer> lineNumbers ) throws IOException {
    final List<String> lines = Files.readLines ( targetFile, charSet );
    for ( final Integer lineNumber : Ordering
            .natural()
            .reverse()
            .immutableSortedCopy ( lineNumbers ) ) {
        lines.remove ( lineNumber.intValue() );
    }
    Files.write ( Joiner.on ( '\n' ).join ( lines ), targetFile, charSet );
}
