@Controller
@RequestMapping ( "/wizard.form" )
@SessionAttributes ( "command" )
public class WizardController {
    @RequestMapping
    public String getInitialPage ( final ModelMap modelMap ) {
        modelMap.addAttribute ( "command", new YourCommandClass() );
        return "initialView";
    }
    @RequestMapping ( params = "_step=1" )
    public String processFirstStep ( final @ModelAttribute ( "command" ) YourCommandClass command,
                                     final Errors errors ) {
        return "firstStepView";
    }
    @RequestMapping ( method = RequestMethod.POST )
    public String processPage ( @RequestParam ( "_page" ) final int currentPage,
                                final @ModelAttribute ( "command" ) YourCommandClass command,
                                final HttpServletResponse response ) {
        return pageViews[currentPage];
    }
    @RequestMapping ( params = "_finish" )
    public String processFinish ( final @ModelAttribute ( "command" ) YourCommandClass command,
                                  final Errors errors,
                                  final ModelMap modelMap,
                                  final SessionStatus status ) {
        status.setComplete();
        return "successView";
    }
    @RequestMapping ( params = "_cancel" )
    public String processCancel ( final HttpServletRequest request,
                                  final HttpServletResponse response,
                                  final SessionStatus status ) {
        status.setComplete();
        return "canceledView";
    }
}
