class MyHighlighter extends DefaultHighlighter {
    private JTextComponent component;
    @Override
    public final void install ( final JTextComponent c ) {
        super.install ( c );
        this.component = c;
    }
    @Override
    public final void deinstall ( final JTextComponent c ) {
        super.deinstall ( c );
        this.component = null;
    }
    @Override
    public final void paint ( final Graphics g ) {
        final Highlighter.Highlight[] highlights = getHighlights();
        final int len = highlights.length;
        for ( int i = 0; i < len; i++ ) {
            Highlighter.Highlight info = highlights[i];
            if ( info.getClass().getName().indexOf ( "LayeredHighlightInfo" ) > -1 ) {
                final Rectangle a = this.component.getBounds();
                final Insets insets = this.component.getInsets();
                a.x = insets.left;
                a.y = insets.top;
                a.height -= insets.top + insets.bottom;
                for ( ; i < len; i++ ) {
                    info = highlights[i];
                    if ( info.getClass().getName().indexOf (
                                "LayeredHighlightInfo" ) > -1 ) {
                        final Highlighter.HighlightPainter p = info
                                                               .getPainter();
                        p.paint ( g, info.getStartOffset(), info
                                  .getEndOffset(), a, this.component );
                    }
                }
            }
        }
    }
}
