import java.io.*;
import java.util.*;
import java.awt.*;
import java.awt.image.*;
import javax.imageio.*;
import javax.media.*;
import javax.media.control.*;
import javax.media.format.*;
import javax.media.util.*;
public class FrameGrab {
    public static void main ( String[] args ) throws Exception {
        CaptureDeviceInfo deviceInfo = CaptureDeviceManager.getDevice ( "vfw:Microsoft WDM Image Capture (Win32):0" );
        Player player = Manager.createRealizedPlayer ( deviceInfo.getLocator() );
        player.start();
        Thread.sleep ( 3000 );
        FrameGrabbingControl frameGrabber = ( FrameGrabbingControl ) player.getControl ( "javax.media.control.FrameGrabbingControl" );
        Buffer buf = frameGrabber.grabFrame();
        Image img = ( new BufferToImage ( ( VideoFormat ) buf.getFormat() ).createImage ( buf ) );
        BufferedImage buffImg = new BufferedImage ( img.getWidth ( null ), img.getHeight ( null ), BufferedImage.TYPE_INT_RGB );
        Graphics2D g = buffImg.createGraphics();
        g.drawImage ( img, null, null );
        g.setColor ( Color.RED );
        g.setFont ( new Font ( "Verdana", Font.BOLD, 16 ) );
        g.drawString ( ( new Date() ).toString(), 10, 25 );
        ImageIO.write ( buffImg, "png", new File ( "c:\\webcam.png" ) );
        player.close();
        player.deallocate();
        System.exit ( 0 );
    }
}
