private void runTests3() {
    System.out.println ( "Current Locale is " + Locale.getDefault().toString() );
    String numbersInEuropeanFormatString[] = new String[] { "1.000,234567", "1,2345678", "1.222.333,234567" };
    String formatUK = "###,##0.0000";
    System.out.println ( "Output numbers using the German locale\n" );
    for ( String num : numbersInEuropeanFormatString ) {
        formatNumberAsDouble ( num, formatUK, Locale.GERMAN );
    }
    System.out.println ( "Output numbers using the UK locale\n" );
    for ( String num : numbersInEuropeanFormatString ) {
        formatNumberAsDouble ( num, formatUK, Locale.UK );
    }
    System.out.println ( "\n\nOutput numbers using new DecimalFormat( " + formatUK + " )\n" );
    for ( String num : numbersInEuropeanFormatString ) {
        formatNumberAsDouble ( num, formatUK, null );
    }
}
private void formatNumberAsDouble ( String value, String format, Locale locale ) {
    NumberFormat formatter;
    int decimalPlaces;
    if ( locale != null ) {
        formatter = NumberFormat.getNumberInstance ( locale );
        decimalPlaces = ( new DecimalFormat ( format ) ).getMaximumFractionDigits();
    } else {
        formatter = new DecimalFormat ( format );
        decimalPlaces = formatter.getMaximumFractionDigits();
    }
    Double result = null;
    try {
        result = formatter.parse ( value ).doubleValue();
    } catch ( ParseException ex ) {
    }
    BigDecimal bd = new BigDecimal ( result );
    Double roundedValue = bd.setScale ( decimalPlaces, RoundingMode.HALF_UP ).doubleValue();
    System.out.println ( "\tValue = " + value );
    System.out.println ( locale == null  ? "\tLocale not specified" : "\tLocale = " + locale.toString() );
    System.out.println ( format == null || format.length() == 0 ? "\tFormat = Not specified" : "\tFormat = " + format );
    System.out.println ( "\tResult (Double) = " + result );
    System.out.println ( "\tRounded Result (Double) (" + decimalPlaces + "dp) = " + roundedValue );
    System.out.println ( "" );
}
