public void setVolume ( double value ) {
    value = ( value <= 0.0 ) ? 0.0001 : ( ( value > 1.0 ) ? 1.0 : value );
    try {
        float dB = ( float ) ( Math.log ( value ) / Math.log ( 10.0 ) * 20.0 );
        gainControl.setValue ( dB );
    } catch ( Exception ex ) {
        ex.printStackTrace();
    }
}
float currDB = 0F;
float targetDB = 0F;
float fadePerStep = .1F;
boolean fading = false;
public void shiftVolumeTo ( double value ) {
    value = ( value <= 0.0 ) ? 0.0001 : ( ( value > 1.0 ) ? 1.0 : value );
    targetDB = ( float ) ( Math.log ( value ) / Math.log ( 10.0 ) * 20.0 );
    if ( !fading ) {
        Thread t = new Thread ( this );
        t.start();
    }
}
public void run() {
    fading = true;
    if ( currDB > targetDB ) {
        while ( currDB > targetDB ) {
            currDB -= fadePerStep;
            gainControl.setValue ( currDB );
            try {
                Thread.sleep ( 10 );
            } catch ( Exception e ) {}
        }
    } else if ( currDB < targetDB ) {
        while ( currDB < targetDB ) {
            currDB += fadePerStep;
            gainControl.setValue ( currDB );
            try {
                Thread.sleep ( 10 );
            } catch ( Exception e ) {}
        }
    }
    fading = false;
    currDB = targetDB;
}
