public class MyCache {
    private final static HashMap cacheMap = new HashMap();
    private final static Vector fetchList = new Vector();
    private Object cacheValue;
    private boolean waitingState;
    public MyCache ( Object key ) {
        if ( cacheMap.containsKey ( key ) ) {
            cacheValue = cacheMap.get ( key );
        } else {
            waitingState = true;
            if ( fetchInProgress ( key, false ) ) {
                return;
            }
            new Thread ( new MyFetch ( key ) ).start();
        }
    }
    synchronized private static boolean fetchInProgress ( Object key, boolean remove ) {
        if ( remove ) {
            fetchList.remove ( key );
        } else {
            boolean fetchingNow = fetchList.contains ( key );
            if ( fetchingNow ) {
                return true;
            }
            fetchList.addElement ( key );
        }
        return false;
    }
    public Object getValue () {
        if ( waitingState ) {
            getCacheValue ( true );
        }
        return cacheValue;
    }
    synchronized private void getCacheValue ( boolean waitOnLock ) {
        if ( waitOnLock ) {
            while ( waitingState ) {
                try {
                    wait();
                } catch ( InterruptedException intex ) {
                }
            }
        } else {
            waitingState = false;
            notifyAll();
        }
    }
    public class MyFetch implements Runnable {
        private Object fetchKey;
        public MyFetch ( Object key ) {
            fetchKey = key;
        }
        public void run () {
            Object fetchedValue = null;
            cacheMap.put ( fetchKey, fetchedValue );
            fetchInProgress ( fetchKey, true );
            getCacheValue ( false );
        }
    }
}
