package com.ron.audio.functions;
import java.io.BufferedInputStream;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import android.media.AudioFormat;
import android.media.AudioManager;
import android.media.AudioTrack;
public class AudioPlayManager implements Runnable {
    private File fileName;
    private volatile boolean playing;
    public AudioPlayManager() {
        super();
        setPlaying ( false );
    }
    public void run() {
        int musicLength = ( int ) ( fileName.length() / 2 );
        short[] music = new short[musicLength];
        try {
            InputStream is = new FileInputStream ( fileName );
            BufferedInputStream bis = new BufferedInputStream ( is );
            DataInputStream dis = new DataInputStream ( bis );
            int i = 0;
            while ( dis.available() > 0 ) {
                music[i] = dis.readShort();
                i++;
            }
            dis.close();
            AudioTrack audioTrack = new AudioTrack ( AudioManager.STREAM_MUSIC,
                    11025,
                    AudioFormat.CHANNEL_CONFIGURATION_MONO,
                    AudioFormat.ENCODING_PCM_16BIT,
                    musicLength,
                    AudioTrack.MODE_STREAM );
            audioTrack.play();
            while ( playing ) {
                audioTrack.write ( music, 0, musicLength );
            }
        } catch ( Exception e ) {
            e.printStackTrace();
        }
    }
    public void setFileName ( File fileName ) {
        this.fileName = fileName;
    }
    public File getFileName() {
        return fileName;
    }
    public void setPlaying ( boolean playing ) {
        this.playing = playing;
    }
    public boolean isPlaying() {
        return playing;
    }
