public static String getHost ( String url ) {
    if ( url == null || url.length() == 0 ) {
        return "";
    }
    int doubleslash = url.indexOf ( "//" );
    if ( doubleslash == -1 ) {
        doubleslash = 0;
    } else {
        doubleslash += 2;
    }
    int end = url.indexOf ( '/', doubleslash );
    end = end >= 0 ? end : url.length();
    int port = url.indexOf ( ':', doubleslash );
    end = ( port > 0 && port < end ) ? port : end;
    return url.substring ( doubleslash, end );
}
public static String getBaseDomain ( String url ) {
    String host = getHost ( url );
    int startIndex = 0;
    int nextIndex = host.indexOf ( '.' );
    int lastIndex = host.lastIndexOf ( '.' );
    while ( nextIndex < lastIndex ) {
        startIndex = nextIndex + 1;
        nextIndex = host.indexOf ( '.', startIndex );
    }
    if ( startIndex > 0 ) {
        return host.substring ( startIndex );
    } else {
        return host;
    }
}
