public class Converter {
    public static void main ( String[] args ) {
        File rootDir = new File ( "." );
        renamePackageToPackageInfo ( rootDir );
    }
    private static void renamePackageToPackageInfo ( File dir ) {
        File[] files = dir.listFiles ( new FilenameFilter() {
            @Override
            public boolean accept ( File dir, String name ) {
                return "package.html".equals ( name );
            }
        } );
        for ( File file : files ) {
            convertFile ( file );
        }
        File[] dirs = dir.listFiles ( new FileFilter() {
            @Override
            public boolean accept ( File pathname ) {
                return pathname.isDirectory();
            }
        } );
        for ( File subdir : dirs ) {
            renamePackageToPackageInfo ( subdir );
        }
    }
    private static void convertFile ( File html ) {
        String fqpn = getPackageName ( html );
        File packageInfo = new File ( html.getParent(), "package-info.java" );
        if ( packageInfo.exists() ) {
            System.out.println ( "package-info.java already exists for package: " + fqpn );
            return;
        }
        try {
            PrintWriter out = new PrintWriter ( packageInfo );
            BufferedReader in = new BufferedReader ( new FileReader ( html ) );
            out.println ( "/**" );
            while ( true ) {
                String line = in.readLine();
                if ( line.equalsIgnoreCase ( "<BODY>" ) ) {
                    break;
                }
            }
            while ( true ) {
                String line = in.readLine();
                if ( line.equalsIgnoreCase ( "</BODY>" ) ) {
                    break;
                }
                out.println ( " * " + line );
            }
            out.println ( "*/" );
            out.println ( "package " + fqpn + ";" );
            out.close();
            in.close();
        } catch ( FileNotFoundException e ) {
            e.printStackTrace();
        } catch ( IOException e ) {
            e.printStackTrace();
        }
    }
    private static String getPackageName ( File file ) {
        StringBuilder path = new StringBuilder ( file.getParent() );
        path.delete ( 0, 2 );
        return path.toString().replaceAll ( "\\\\", "." );
    }
}
