public List<Instance> getMatchingInstances ( Map<String, String> attrValues ) {
    Criteria crit = session.createCriteria ( Instance.class, "i" );
    for ( Map.Entry<String, String> entry : attrValues ) {
        String attrName = entry.getKey();
        String val = entry.getValue();
        DetachedCriteria valueCrit = DetachedCriteria.forClass ( Value.class, "v" );
        DetachedCriteria attrCrit =
            valueCrit.createCriteria ( "attribute", CriteriaSpecification.LEFT_JOIN );
        Criterion localAttr = Restrictions.eq ( "v.localAttributeName", attrName );
        Criterion globalAttr = Restrictions.eq ( "name", attrName );
        attrCrit.add ( Restrictions.or ( localAttr, globalAttr ) );
        valueCrit.add ( Restrictions.eq ( "value", val ) );
        valueCrit.add ( Restrictions.eqProperty ( "instance.id", "i.id" ) );
        valueCrit.setProjection ( Projections.property ( "id" ) );
        crit.add ( Subqueries.exists ( valueCrit ) );
    }
    return crit.list();
}
