public void run() {
    initializeState();
    while ( stillRunning ) {
        while ( isPaused() && stillRunning ) {
            try {
                sleep ( 100 );
            } catch ( InterruptedException e ) {
            }
        }
        if ( !stillRunning ) {
            break;
        }
        Canvas c = null;
        try {
            c = surfaceHolder.lockCanvas ( null );
            synchronized ( surfaceHolder ) {
                updateState();
                handleInput();
                updatePhysics();
                updateAnimations();
                updateSound();
                updateVideo ( c );
            }
        } finally {
            if ( c != null ) {
                surfaceHolder.unlockCanvasAndPost ( c );
            }
        }
    }
}
