public class DataRobot {
    private List _listeners = new ArrayList();
    private String data;
    public boolean analyzeData ( String temp ) {
        data = temp;
        fireDataAnalyzedEvent ( data );
        return true;
    }
    public synchronized void addDataAnalyzedListener ( DataAnalyzedListener listener ) {
        _listeners.add ( listener );
    }
    public synchronized void removeDataAnalyzedListener ( DataAnalyzedListener listener ) {
        _listeners.remove ( listener );
    }
    private synchronized void fireDataAnalyzedEvent ( String temp ) {
        DataAnalyzedEvent dRE = new DataAnalyzedEvent ( this, temp );
        Iterator listeners = _listeners.iterator();
        while ( listeners.hasNext() ) {
            ( ( DataAnalyzedListener ) listeners.next() ).dataAnalyzedReceived ( dRE );
        }
    }
    public interface DataAnalyzedListener {
        public void dataAnalyzedReceived ( DataAnalyzedEvent event );
    }
}
