public class DataBuilder {
    private List _listeners = new ArrayList();
    private String data;
    public boolean submitData ( String temp ) {
        data = temp;
        fireDataBuilderEvent ( data );
        return true;
    }
    public synchronized void addDataBuilderListener ( DataBuilderListener listener ) {
        _listeners.add ( listener );
    }
    public synchronized void removeDataBuilderListener ( DataBuilderListener listener ) {
        _listeners.remove ( listener );
    }
    private synchronized void fireDataBuilderEvent ( String temp ) {
        DataBuilderEvent dRE = new DataBuilderEvent ( this, temp );
        Iterator listeners = _listeners.iterator();
        while ( listeners.hasNext() ) {
            ( ( DataBuilderListener ) listeners.next() ).dataBuilderReceived ( dRE );
        }
    }
    public interface DataBuilderListener {
        public void dataBuilderReceived ( DataBuilderEvent event );
    }
}
