package resolver;
import java.util.EnumSet;
public class EnumPatternExample {
    public enum Style {
        BOLD, ITALIC, UNDERLINE, STRIKETHROUGH
    }
    public static void main ( String[] args ) {
        final EnumSet<Style> styles = EnumSet.noneOf ( Style.class );
        styles.addAll ( EnumSet.range ( Style.BOLD, Style.STRIKETHROUGH ) );
        styles.removeAll ( EnumSet.of ( Style.UNDERLINE, Style.STRIKETHROUGH ) );
        assert EnumSet.of ( Style.BOLD, Style.ITALIC ).equals ( styles );
        System.out.println ( styles );
    }
