package j3d_picking;
import java.awt.*;
import javax.swing.*;
import javax.media.j3d.*;
import com.sun.j3d.utils.universe.*;
import com.sun.j3d.utils.picking.behaviors.*;
import com.sun.j3d.utils.geometry.*;
import com.sun.j3d.utils.picking.PickIntersection;
import com.sun.j3d.utils.picking.PickResult;
import com.sun.j3d.utils.picking.PickTool;
import javax.vecmath.Point3d;
public class HelloJava3D
    extends JFrame {
    public HelloJava3D() {
        GraphicsConfiguration config = SimpleUniverse.getPreferredConfiguration();
        Canvas3D canvas3D = new Canvas3D ( config );
        BranchGroup scene = createSceneGraph();
        SimpleUniverse simpleU = new SimpleUniverse ( canvas3D );
        simpleU.getViewingPlatform().setNominalViewingTransform();
        BoundingSphere behaveBounds = new BoundingSphere();
        ExamplePickBehavior behavior = new ExamplePickBehavior ( canvas3D, scene, behaveBounds );
        scene.addChild ( behavior );
        scene.compile();
        simpleU.addBranchGraph ( scene );
        getContentPane().add ( canvas3D, BorderLayout.CENTER );
    }
    public BranchGroup createSceneGraph() {
        BranchGroup objRoot = new BranchGroup();
        ColorCube cube = new ColorCube ( 0.4 );
        cube.setCapability ( Node.ENABLE_PICK_REPORTING );
        PickTool.setCapabilities ( cube, PickTool.INTERSECT_FULL );
        objRoot.addChild ( cube );
        return objRoot;
    }
    public static void main ( String[] args ) {
        JFrame frame = new HelloJava3D();
        frame.setTitle ( "Hello Java3D" );
        frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
        frame.setBounds ( 0, 0, 400, 300 );
        frame.setVisible ( true );
    }
    private class ExamplePickBehavior extends PickMouseBehavior {
        public ExamplePickBehavior ( Canvas3D canvas, BranchGroup bg, Bounds bounds ) {
            super ( canvas, bg, bounds );
            setSchedulingBounds ( bounds );
            pickCanvas.setMode ( PickTool.GEOMETRY_INTERSECT_INFO );
        }
        public void updateScene ( int xpos, int ypos ) {
            pickCanvas.setShapeLocation ( xpos, ypos );
            Point3d eyePos = pickCanvas.getStartPosition();
            PickResult pickResult = null;
            pickResult = pickCanvas.pickClosest();
            if ( pickResult != null ) {
                PickIntersection pi = pickResult.getClosestIntersection ( eyePos );
                Point3d intercept = pi.getPointCoordinatesVW();
                System.out.println ( intercept );
            }
        }
    }
}
