public interface MyEnumInterface<E extends MyEnumInterface & Enum<E>> {
    public static boolean aUsefulNonStaticMethod();
    String getValue();
    MyEnumInfo<E> enumInfo();
}
public class MyEnumInfo<E extends MyEnumInterface<E>> {
    private static <E extends MyEnumInterface<E>> MyEnumInfo ( Class<E> enumClass ) {
        ...
    }
    public static <E extends MyEnumInterface<E>> MyEnumInfo<E> infoForClass ( Class<E> enumClass ) {
        ... return a cached value
    }
    public static <E extends MyEnumInterface<E>> MyEnumInfo ( E e ) {
        return infoForClass ( e.getClass() );
    }
    E enumForValue ( String value ) {
        ....
    }
}
public enum MyEnum implements MyEnumInterface<MyEnum> {
    VALUE_ONE ( "my data" );
    VALUE_TWO ( "some other data" );
    private String myValue;
    public boolean aUsefulNonStaticMethod() {
    }
    public String getValue() {
        return myValue;
    }
    public static MyEnumInfo<E> staticEnumInfo() {
        return MyEnumInfo.infoForClass ( MyEnumClass.class );
    }
    public MyEnumInfo<E> enumInfo() {
        return MyEnumInfo.infoForClass ( getClass() );
    }
}
