package org.life.java.stackoverflow.questions;
import net.contentobjects.jnotify.JNotify;
import net.contentobjects.jnotify.JNotifyListener;
public class JNotifyDemo {
    public void sample() throws Exception {
        String path = System.getProperty ( "user.home" );
        int mask = JNotify.FILE_CREATED
                   | JNotify.FILE_DELETED
                   | JNotify.FILE_MODIFIED
                   | JNotify.FILE_RENAMED;
        boolean watchSubtree = true;
        int watchID = JNotify.addWatch ( path, mask, watchSubtree, new Listener() );
        Thread.sleep ( 1000000 );
        boolean res = JNotify.removeWatch ( watchID );
        if ( !res ) {
        }
    }
    class Listener implements JNotifyListener {
        public void fileRenamed ( int wd, String rootPath, String oldName,
                                  String newName ) {
            print ( "renamed " + rootPath + " : " + oldName + " -> " + newName );
        }
        public void fileModified ( int wd, String rootPath, String name ) {
            print ( "modified " + rootPath + " : " + name );
        }
        public void fileDeleted ( int wd, String rootPath, String name ) {
            print ( "deleted " + rootPath + " : " + name );
        }
        public void fileCreated ( int wd, String rootPath, String name ) {
            print ( "created " + rootPath + " : " + name );
        }
        void print ( String msg ) {
            System.err.println ( msg );
        }
    }
    public static void main ( String[] args ) throws Exception {
        new JNotifyDemo().sample();
    }
}
