import java.util.Collections;
import java.util.Enumeration;
import java.util.Iterator;
public final class Enumerations {
    public static final <T> Iterable<T> iterable ( final Enumeration<T> enumeration ) {
        return new Iterable<T>() {
            public final Iterator<T> iterator() {
                return new Iterator<T>() {
                    public final boolean hasNext() {
                        return enumeration.hasMoreElements();
                    }
                    public final T next() {
                        return enumeration.nextElement();
                    }
                    public final void remove() {
                        throw new UnsupportedOperationException();
                    }
                };
            }
        };
    }
}
