@JsonDeserialize ( using = JacksonDeserializer.class )
public class Address {
    ...
}
@JsonCachable
static class JacksonDeserializer extends JsonDeserializer<Address> {
    @Override
    public Address deserialize ( JsonParser parser, DeserializationContext context )
    throws IOException, JsonProcessingException {
        JsonToken token = parser.getCurrentToken();
        if ( token != JsonToken.START_OBJECT ) {
            throw new JsonMappingException ( "Expected START_OBJECT: " + token, parser.getCurrentLocation() );
        }
        token = parser.nextToken();
        Builder result = new Builder();
        while ( token != JsonToken.END_OBJECT ) {
            if ( token != JsonToken.FIELD_NAME ) {
                throw new JsonMappingException ( "Expected FIELD_NAME: " + token, parser.getCurrentLocation() );
            }
            LocationType key = LocationType.valueOf ( parser.getText() );
            token = parser.nextToken();
            if ( token != JsonToken.VALUE_STRING ) {
                throw new JsonMappingException ( "Expected VALUE_STRING: " + token, parser.getCurrentLocation() );
            }
            String value = parser.getText();
            result.put ( key, value );
            token = parser.nextToken();
        }
        return result.create();
    }
}
