typedef enum t_mon_enum_type {
    MONEnum_Edno = 1,
    MONEnum_Dve = 2,
    MONEnum_Tre = 3
} t_mon_enum_type;
@interface MONObject : NSObject {
    t_mon_enum_type type;
    int msgId;
    int size;
}
@end
@implementation MONObject
- ( NSMutableData * ) dataRepresentation {
    const int typeAsInt = ( int ) type;
    const size_t capacity = sizeof ( typeAsInt ) + sizeof ( msgId ) + sizeof ( size );
    NSMutableData * data = [[NSMutableData alloc] initWithCapacity:capacity];
    [data appendBytes: & typeAsInt length:sizeof ( typeAsInt )];
    [data appendBytes: & msgId length:sizeof ( msgId )];
    [data appendBytes: & size length:sizeof ( size )];
    return [data autorelease];
}
- ( BOOL ) isDataRepresentationValid: ( NSData * ) data {
}
- ( BOOL ) restoreFromDataRepresentation: ( NSData * ) data {
    if ( ![self isDataRepresentationValid] ) {
        return NO;
    }
    NSRange range = { 0, 0 };
    int tmp = 0;
    range.length = sizeof ( tmp );
    [data getBytes: & tmp range:range];
    type = ( t_mon_enum_type ) tmp;
    range.location += range.length;
    range.length = sizeof ( msgId );
    [data getBytes: & msgId range:range];
    range.location += range.length;
    range.length = sizeof ( size );
    [data getBytes: & size range:range];
    return YES;
}
