import java.awt.*;
import java.awt.geom.*;
public class TransformedStroke
    implements Stroke {
    private static final long serialVersionUID = 1;
    private AffineTransform transform;
    private AffineTransform inverse;
    private Stroke stroke;
    public TransformedStroke ( Stroke base, AffineTransform at )
    throws NoninvertibleTransformException {
        this.transform = new AffineTransform ( at );
        this.inverse = transform.createInverse();
        this.stroke = base;
    }
    public Shape createStrokedShape ( Shape s ) {
        Shape sTrans = transform.createTransformedShape ( s );
        Shape sTransStroked = stroke.createStrokedShape ( sTrans );
        Shape sStroked = inverse.createTransformedShape ( sTransStroked );
        return sStroked;
    }
}
