public class RotatableImage {
    Image image;
    float currentDegrees;
    public RotateableImage ( Image image ) {
        this.image = image;
        this.currentDegrees = 0.0f;
        this.remainingDegrees = 0.0f;
    }
    public void paintOn ( Graphics g ) {
    }
    public void spin ( float additionalDegrees ) {
        setSpin ( currentDegrees + additionalDegrees );
    }
    public void setSpin ( float newDegrees ) {
        currentDegrees += additionalDegrees;
        while ( currentDegrees < 0f ) {
            currentDegrees += 360f;
        }
        while ( currentDegrees >= 360f ) {
            currentDegrees -= 360f;
        }
    }
}
public class ImageSpinner implements Runnable {
    RotateableImage image;
    final float totalDegrees;
    float degrees;
    float speed;
    public ImageSpinner ( RotatableImage image, float degrees, float speed ) {
        this.image = image;
        this.degrees = degrees;
        this.totalDegrees = degrees;
        this.speed = speed;
    }
    public void run() {
        int fps = 40;
        while ( Math.abs ( degrees ) > Math.abs ( speed / fps ) ) {
            float degreesToRotate = speed / fps;
            image.spin ( degreesToRotate );
            degrees -= degreesToRotate;
            try {
                Thread.sleep ( 1000 / fps );
            } catch ( InterruptedException e ) {
            }
        }
        image.setSpin ( totalDegrees );
    }
}
