@Before
@Transactional
public void setUp() {
    smsDao.deleteAllSms ( 1 );
    sessionFactory.getCurrentSession().flush();
    List<SmsBean> list = smsDao.getNewSmsList ( 1 );
    assertEquals ( 0, list.size() );
}
@Test
@Transactional ( propagation = NEVER )
public void checkLanguagePreferenceTest() throws InterruptedException, ExecutionException {
    User user = tx.execute ( new TransactionCallback<User>() {
        public User doInTransaction ( TransactionStatus status ) {
            User user = ( User ) sessionFactory.getCurrentSession().load ( User.class, new Long ( 1 ) );
            prefsDao.saveLanguagePref ( new UserPrefs ( "", user ) );
            return user;
        }
    } );
    Future<UserPrefs> prefs = messagingService.checkLanguagePreference ( user.getId() );
    System.out.println ( "wait completion of async task" );
    prefs.get();
    System.out.println ( "Async task has finished" );
}
private TransactionTemplate tx;
@Autowired
public void setPtm ( PlatformTransactionManager ptm ) {
    tx = new TransactionTemplate ( ptm );
}
