public static int levenshtein ( String s, String t, int threshold ) {
    int slen = s.length();
    int tlen = t.length();
    if ( tlen > slen ) {
        String stmp = s;
        s = t;
        t = stmp;
        int itmp = slen;
        slen = tlen;
        tlen = itmp;
    }
    int[] p = new int[tlen + 1];
    int[] d = new int[tlen + 1];
    int[] dtmp;
    int n = 0;
    for ( ; n < Math.min ( p.length, threshold + 1 ); ++n ) {
        p[n] = n;
    }
    Arrays.fill ( p, n, p.length, Integer.MAX_VALUE );
    Arrays.fill ( d, Integer.MAX_VALUE );
    for ( int row = 1; row < s.length() + 1; ++row ) {
        char schar = s.charAt ( row - 1 );
        d[0] = row;
        int min = Math.max ( 1, row - threshold );
        int max = Math.min ( d.length, row + threshold + 1 );
        if ( min > 1 ) {
            d[min - 1] = Integer.MAX_VALUE;
        }
        for ( int col = min; col < max; ++col ) {
            if ( schar == t.charAt ( col - 1 ) ) {
                d[col] = p[col - 1];
            } else {
                d[col] = Math.min ( p[col - 1], Math.min ( d[col - 1], p[col] ) ) + 1;
            }
        }
        dtmp = p;
        p = d;
        d = dtmp;
    }
    if ( p[tlen] == Integer.MAX_VALUE ) {
        return -1;
    }
    return p[tlen];
}
