bool os::is_interrupted ( Thread * thread, bool clear_interrupted ) {
    assert ( Thread::current() == thread || Threads_lock->owned_by_self(),
             "possibility of dangling Thread pointer" );
    OSThread * osthread = thread->osthread();
    bool interrupted = osthread->interrupted();
    if ( interrupted && clear_interrupted ) {
        osthread->set_interrupted ( false );
    }
    return interrupted;
}
