public class ClickPreventableTextView extends TextView implements OnClickListener {
    private boolean preventClick;
    private OnClickListener clickListener;
    private boolean ignoreSpannableClick;
    public ClickPreventableTextView ( Context context ) {
        super ( context );
    }
    public ClickPreventableTextView ( Context context, AttributeSet attrs ) {
        super ( context, attrs );
    }
    public ClickPreventableTextView ( Context context, AttributeSet attrs, int defStyle ) {
        super ( context, attrs, defStyle );
    }
    public boolean onTouchEvent ( MotionEvent event ) {
        if ( getMovementMethod() != null ) {
            getMovementMethod().onTouchEvent ( this, ( Spannable ) getText(), event );
        }
        this.ignoreSpannableClick = true;
        boolean ret = super.onTouchEvent ( event );
        this.ignoreSpannableClick = false;
        return ret;
    }
    public boolean ignoreSpannableClick() {
        return ignoreSpannableClick;
    }
    public void preventNextClick() {
        preventClick = true;
    }
    @Override
    public void setOnClickListener ( OnClickListener listener ) {
        this.clickListener = listener;
        super.setOnClickListener ( this );
    }
    @Override
    public void onClick ( View v ) {
        if ( preventClick ) {
            preventClick = false;
        } else if ( clickListener != null ) {
            clickListener.onClick ( v );
        }
    }
}
