package com.denisk.fun.swing;
import java.awt.*;
import javax.swing.*;
public class GridBagLayoutTest extends JFrame {
    private static void createAndShowGUI() {
        JFrame frame = new JFrame ( "GridBagLayoutDemo" );
        frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
        frame.setContentPane ( createContentPane() );
        frame.pack();
        frame.setVisible ( true );
    }
    public static void main ( String[] args ) {
        javax.swing.SwingUtilities.invokeLater ( new Runnable() {
            public void run() {
                createAndShowGUI();
            }
        } );
    }
    private static Container createContentPane() {
        int WINHEIGHT = 600;
        int WINWIDTH = 800;
        JPanel totalGui = new JPanel();
        totalGui.setBackground ( Color.white );
        totalGui.setMinimumSize ( new Dimension ( WINWIDTH, WINHEIGHT ) );
        totalGui.setPreferredSize ( new Dimension ( WINWIDTH, WINHEIGHT ) );
        totalGui.setMaximumSize ( new Dimension ( WINWIDTH, WINHEIGHT ) );
        totalGui.setLayout ( new GridBagLayout() );
        totalGui.setOpaque ( true );
        GridBagConstraints c = new GridBagConstraints();
        JPanel leftPanel = new JPanel();
        int LEFTPANELWIDTH = WINWIDTH * 2 / 3;
        leftPanel.setMinimumSize ( new Dimension ( LEFTPANELWIDTH, WINHEIGHT ) );
        leftPanel.setPreferredSize ( new Dimension ( LEFTPANELWIDTH, WINHEIGHT ) );
        leftPanel.setMaximumSize ( new Dimension ( LEFTPANELWIDTH, WINHEIGHT ) );
        c.gridx = 0;
        c.gridy = 0;
        c.gridheight = 4;
        c.gridwidth = 2;
        c.fill = GridBagConstraints.HORIZONTAL;
        totalGui.add ( leftPanel, c );
        c.gridx = 2;
        c.gridy = 0;
        c.gridwidth = 0;
        c.fill = GridBagConstraints.HORIZONTAL;
        c.anchor = GridBagConstraints.CENTER;
        JSeparator verticalsep = new JSeparator ( SwingConstants.VERTICAL );
        verticalsep.setBackground ( new Color ( 255, 0, 102 ) );
        verticalsep.setPreferredSize ( new Dimension ( 6, WINHEIGHT - 10 ) );
        totalGui.add ( verticalsep, c );
        JPanel rightPanel = new JPanel();
        int RIGHTPANELWIDTH = WINWIDTH * 1 / 3;
        rightPanel.setBackground ( Color.blue );
        rightPanel.setMinimumSize ( new Dimension ( RIGHTPANELWIDTH, WINHEIGHT ) );
        rightPanel.setPreferredSize ( new Dimension ( RIGHTPANELWIDTH, WINHEIGHT ) );
        rightPanel.setMaximumSize ( new Dimension ( RIGHTPANELWIDTH, WINHEIGHT ) );
        c.gridx = 2;
        c.gridy = 0;
        c.gridwidth = 1;
        c.gridheight = 4;
        c.fill = GridBagConstraints.HORIZONTAL;
        totalGui.add ( rightPanel, c );
        return totalGui;
    }
}
