package stackoverflow.fight;
public class Opponent {
    private final String name;
    private final int maxHitpoints;
    private int currentHitpoints;
    private Weapon weapon;
    private final boolean isMonster;
    private int currentMoney;
    public Opponent ( String name, int maxHitpoints, boolean isMonster ) {
        super();
        this.name = name;
        this.maxHitpoints = maxHitpoints;
        this.isMonster = isMonster;
        this.currentHitpoints = this.maxHitpoints;
        weapon = isMonster ? Weapon.CLAWS : Weapon.BAT;
        currentMoney = isMonster ? 0 : 10;
    }
    public Weapon getWeapon() {
        return weapon;
    }
    public void setWeapon ( Weapon weapon ) {
        if ( this.weapon == weapon ) {
            return;
        }
        this.weapon = weapon;
        this.currentMoney -= weapon.getCost();
        System.out.println ( "\t" + name + " bought new weapon " + weapon.getName() + ". Money left: " + currentMoney );
    }
    public String getName() {
        return name;
    }
    public int getCurrentHitpoints() {
        return currentHitpoints;
    }
    public void attack ( Opponent opponent ) {
        if ( isAlive() ) {
            int damage = weapon.rollDamage();
            opponent.wound ( damage );
            System.out.println ( "\t" + name + " attacks " + opponent.getName() + " with " + weapon.getName()
                                 + " and deals " + damage + " points of damage, leaving " + opponent.getCurrentHitpoints() );
        } else {
            System.out.println ( "\t" + name + " would strike but unfortunately died trying!" );
        }
    }
    public void wound ( int damage ) {
        currentHitpoints -= damage;
    }
    public boolean isAlive() {
        return currentHitpoints > 0;
    }
    public void recover ( int hitPoints ) {
        currentHitpoints += hitPoints;
        if ( currentHitpoints > maxHitpoints ) {
            currentHitpoints = maxHitpoints;
        }
        System.out.println ( "\t" + name + " recovers " + hitPoints + " to a current of " + currentHitpoints );
    }
    public boolean isMonster() {
        return isMonster;
    }
    public int getCurrentMoney() {
        return currentMoney;
    }
}
