import java.sql.Types;
public class SQLTypeMap {
    public static String convert ( int type ) {
        String result = "java.lang.Object";
        switch ( type ) {
        case Types.CHAR:
        case Types.VARCHAR:
        case Types.LONGVARCHAR:
            result = "java.lang.String";
            break;
        case Types.NUMERIC:
        case Types.DECIMAL:
            result = "java.math.BigDecimal";
            break;
        case Types.BIT:
            result = "java.lang.Boolean";
            break;
        case Types.TINYINT:
            result = "java.lang.Byte";
            break;
        case Types.SMALLINT:
            result = "java.lang.Short";
            break;
        case Types.INTEGER:
            result = "java.lang.Integer";
            break;
        case Types.BIGINT:
            result = "java.lang.Long";
            break;
        case Types.REAL:
            result = "java.lang.Real";
            break;
        case Types.FLOAT:
        case Types.DOUBLE:
            result = "java.lang.Double";
            break;
        case Types.BINARY:
        case Types.VARBINARY:
        case Types.LONGVARBINARY:
            result = "java.lang.Byte[]";
            break;
        case Types.DATE:
            result = "java.sql.Date";
            break;
        case Types.TIME:
            result = "java.sql.Time";
            break;
        case Types.TIMESTAMP:
            result = "java.sql.Timestamp";
            break;
        }
        return result;
    }
}
