public class Fib implements Callable<Integer> {
    int n;
    Executor exec;
    Fib ( final int n, final Executor exec ) {
        this.n = n;
        this.exec = exec;
    }
    @Override
    public Integer call() throws Exception {
        if ( n == 0 || n == 1 ) {
            return n;
        }
        final Fib n1 = new Fib ( n - 1, exec );
        final Fib n2 = new Fib ( n - 2, exec );
        final FutureTask<Integer> n2Task = new FutureTask<Integer> ( n2 );
        exec.execute ( n2Task );
        final int partialResult = n1.call();
        n2Task.run();
        return partialResult + n2Task.get();
    }
}
