@Aspect
public class ExceptionAspect {
    private static final Logger log = LoggerFactory.getLogger ( ExceptionAspect.class );
    public Object handle ( ProceedingJoinPoint pjp ) throws Throwable {
        try {
            return pjp.proceed();
        } catch ( Throwable t ) {
            log.warn ( "invocation of " + pjp.getSignature().toLongString() + " failed", t );
            throw t;
        }
    }
}
