public String toString ( int radix ) {
    if ( radix < Character.MIN_RADIX || Character.MAX_RADIX < radix ) {
        throw new IllegalArgumentException ( "radix out of range: " + radix );
    }
    if ( digits.length == 0 ) {
        return "0";
    }
    int[] rdigits = convertTo ( radix );
    StringBuilder b = new StringBuilder ( rdigits.length );
    for ( int dig : rdigits ) {
        b.append ( Character.forDigit ( dig, radix ) );
    }
    return b.toString();
}
