public final class SpringUtil {
    private static ApplicationContext context = null;
    private static Set<String> alreadyLoaded = new HashSet<String>();
    public static void setContext ( String... wiringFiles ) {
        alreadyLoaded.clear();
        alreadyLoaded.addAll ( Arrays.asList ( wiringFiles ) );
        context = new ClassPathXmlApplicationContext ( wiringFiles );
    }
    public static void addContext ( String... addFiles ) {
        if ( context == null ) {
            setContext ( addFiles );
            return;
        }
        Set<String> notAlreadyLoaded = new HashSet<String>();
        for ( String target : addFiles ) {
            if ( !alreadyLoaded.contains ( target ) ) {
                notAlreadyLoaded.add ( target );
            }
        }
        if ( notAlreadyLoaded.size() > 0 ) {
            alreadyLoaded.addAll ( notAlreadyLoaded );
            context = new ClassPathXmlApplicationContext ( notAlreadyLoaded.toArray ( new String[] {} ), context );
        }
    }
    public static ApplicationContext getContext() {
        return context;
    }
    public static Object getBean ( final String beanName ) {
        if ( context == null ) {
            throw new RuntimeException ( "Context has not been loaded." );
        }
        return getContext().getBean ( beanName );
    }
    public static void reset() {
        alreadyLoaded.clear();
        context = null;
    }
