@Override
public MethodVisitor visitMethod ( final int access, final String name, final String desc, final String signature, final String[] exceptions ) {
    if ( instrument && name.equals ( "<init>" ) ) {
        MethodVisitor mv = super.visitMethod ( access, name, desc, signature, exceptions );
        ...
    } else if ( instrument && isPublicSetter ( access, name, desc ) ) {
        String propertyName = Introspector.decapitalize ( name.substring ( 3 ) );
        String getter = "get" + name.substring ( 3 );
        Type type = Type.getArgumentTypes ( desc ) [0];
        String arg = type.getDescriptor();
        MethodVisitor orig = super.visitMethod ( access & ~ACC_PUBLIC | ACC_PRIVATE | ACC_SYNTHETIC, "_" + name, desc, signature, exceptions );
        MethodVisitor wrap = super.visitMethod ( access, name, desc, signature, exceptions );
        wrap.visitCode();
        wrap.visitVarInsn ( ALOAD, 0 );
        wrap.visitFieldInsn ( GETFIELD, classname, "_propertyChangeSupport", "Ljava/beans/PropertyChangeSupport;" );
        wrap.visitLdcInsn ( propertyName );
        wrap.visitVarInsn ( ALOAD, 0 );
        wrap.visitMethodInsn ( INVOKEVIRTUAL, classname, getter, "()" + arg );
        generateAutoBoxIfNeccessary ( wrap, arg );
        wrap.visitVarInsn ( type.getOpcode ( ILOAD ), 1 );
        generateAutoBoxIfNeccessary ( wrap, arg );
        wrap.visitVarInsn ( ALOAD, 0 );
        wrap.visitVarInsn ( type.getOpcode ( ILOAD ), 1 );
        wrap.visitMethodInsn ( INVOKEVIRTUAL, classname, "_" + name, desc );
        wrap.visitMethodInsn ( INVOKEVIRTUAL, "java/beans/PropertyChangeSupport", "firePropertyChange", "(Ljava/lang/String;Ljava/lang/Object;Ljava/lang/Object;)V" );
        wrap.visitInsn ( RETURN );
        wrap.visitMaxs ( 6, 2 );
        wrap.visitEnd();
        return orig;
    } else {
        return super.visitMethod ( access, name, desc, signature, exceptions );
    }
}
