package de.fencing_game.paul.examples;
import java.io.*;
import java.security.*;
public class SignatureOutputStream
    extends OutputStream {
    private OutputStream target;
    private Signature sig;
    public SignatureOutputStream ( OutputStream target, Signature sig ) {
        this.target = target;
        this.sig = sig;
    }
    public void write ( int b )
    throws IOException {
        write ( new byte[] { ( byte ) b} );
    }
    public void write ( byte[] b )
    throws IOException {
        write ( b, 0, b.length );
    }
    public void write ( byte[] b, int offset, int len )
    throws IOException {
        target.write ( b, offset, len );
        try {
            sig.update ( b, offset, len );
        } catch ( SignatureException ex ) {
            throw new IOException ( ex );
        }
    }
    public void flush()
    throws IOException {
        target.flush();
    }
    public void close()
    throws IOException {
        target.close();
    }
}
