import java.lang.reflect.InvocationTargetException;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import org.apache.commons.beanutils.PropertyUtils;
import org.apache.commons.lang.StringUtils;
public class ObjectUtils {
    @SuppressWarnings ( "unchecked" )
    public static boolean isObjectEmpty ( Object object ) {
        if ( object == null ) {
            return true;
        } else if ( object instanceof String ) {
            return StringUtils.isEmpty ( StringUtils.trim ( ( String ) object ) );
        } else if ( object instanceof List ) {
            boolean allEntriesStillEmpty = true;
            final Iterator<Object> iter = ( ( List ) object ).iterator();
            while ( allEntriesStillEmpty && iter.hasNext() ) {
                final Object listEntry = iter.next();
                allEntriesStillEmpty = isObjectEmpty ( listEntry );
            }
            return allEntriesStillEmpty;
        } else {
            try {
                boolean allPropertiesStillEmpty = true;
                final Map<String, Object> properties = PropertyUtils.describe ( object );
                final Iterator<Entry<String, Object>> iter = properties.entrySet().iterator();
                while ( allPropertiesStillEmpty && iter.hasNext() ) {
                    final Entry<String, Object> entry = iter.next();
                    final String key = entry.getKey();
                    final Object value = entry.getValue();
                    if ( "class".equals ( key ) ) {
                        continue;
                    }
                    allPropertiesStillEmpty = isObjectEmpty ( value );
                }
                return allPropertiesStillEmpty;
            } catch ( IllegalAccessException e ) {
                throw new RuntimeException ( e );
            } catch ( InvocationTargetException e ) {
                throw new RuntimeException ( e );
            } catch ( NoSuchMethodException e ) {
                throw new RuntimeException ( e );
            }
        }
    }
}
