public class Deck {
    private static final String[] ORDERED_CARDS = new String[] {
        "AH", "2H", "3H", "4H", "5H", "6H", "7H", "8H",
        "9H", "10H", "JH"
    };
    private String[] cards;
    public Deck() {
        cards = new String[ORDERED_CARDS.length];
        System.arraycopy ( ORDERED_CARDS, 0, cards, 0, ORDERED_CARDS.length );
    }
    public void shuffle() {
        assert ( cards != null );
        Collections.shuffle ( Arrays.asList ( cards ) );
    }
    public String toString() {
        final StringBuffer sb = new StringBuffer();
        for ( String card : cards ) {
            sb.append ( card );
            sb.append ( ", " );
        }
        return sb.toString();
    }
    public boolean equals ( Deck other ) {
        if ( other == null ) {
            return false;
        }
        assert ( other.cards != null );
        if ( other.cards.length != this.cards.length ) {
            return false;
        }
        final int cardCount = this.cards.length;
        for ( int i = 0; i < cardCount; ++i ) {
            if ( !this.cards[i].equals ( other.cards[i] ) ) {
                return false;
            }
        }
        return true;
    }
}
