class CollaboratorsFinder implements BeanFactoryPostProcessor {
    private final Object bean;
    private final Set<String> collaborators = new HashSet<String>();
    CollaboratorsFinder ( Object bean ) {
        if ( bean == null ) {
            throw new IllegalArgumentException ( "Must pass a non-null bean" );
        }
        this.bean = bean;
    }
    @Override
    public void postProcessBeanFactory ( ConfigurableListableBeanFactory beanFactory ) throws BeansException {
        for ( String beanName : BeanFactoryUtils.beanNamesIncludingAncestors ( beanFactory ) ) {
            BeanDefinition beanDefinition = beanFactory.getBeanDefinition ( beanName );
            if ( beanDefinition.isAbstract() ) {
                continue;
            }
            MutablePropertyValues values = beanDefinition.getPropertyValues();
            PropertyValue myBeanValue = values.getPropertyValue ( "myBean" );
            if ( myBeanValue == null ) {
                continue;
            }
            if ( bean == myBeanValue.getValue() ) {
                collaborators.add ( beanName );
            }
            ConstructorArgumentValues constructorArgs = beanDefinition.getConstructorArgumentValues();
        }
    }
    public Set<String> getCollaborators() {
        return collaborators;
    }
}
