public class LoginInterceptor extends AbstractInterceptor {
    @Override
    public String intercept ( final ActionInvocation invocation ) throws Exception {
        Map<String, Object> session = ActionContext.getContext().getSession();
        Integer userId = ( Integer ) session.get ( "userId" );
        if ( userId != null ) {
            return invocation.invoke();
        }
        Object action = invocation.getAction();
        if ( ! ( action instanceof LoginRequired ) ) {
            return invocation.invoke();
        }
        if ( ! ( action instanceof LoginAction ) ) {
            return "loginRedirect";
        }
        return invocation.invoke();
    }
}
