public interface Observer {
    public void update ( Event arg );
}
public class Event {
    public int ID;
}
public Button implements Observer {
    public void update ( Event arg ) {
        switch ( arg.ID ) {
        case 1:
            break;
        default:
            System.out.println ( "Buttons don't handle events of ID: " + arg.ID );
            break;
        }
    }
}
public ProgressBar implements Observer {
    public void update ( Event arg ) {
        switch ( arg.ID ) {
        case 2:
            break;
        case 3:
            break;
        default:
            System.out.println ( "Progress bars don't handle events of ID: " + arg.ID );
            break;
        }
    }
}
public class Subject {
    private ArrayList<Observer> allUIControls;
    public registerControl ( Observer control ) {
        allUIControls.add ( control );
    }
    public void updateControls ( Event arg ) {
        foreach ( Observer control in allUIControls ) {
            control.update ( arg );
        }
    }
}
