public class LimitFilter implements Filter {
    private int limit = 5;
    private int count;
    private Object lock = new Object();
    public void doFilter ( ServletRequest request, ServletResponse response,
                           FilterChain chain ) throws IOException, ServletException {
        try {
            boolean ok;
            synchronized ( lock ) {
                ok = count++ < limit;
            }
            if ( ok ) {
                chain.doFilter ( request, response );
            } else {
            }
        } finally {
            synchronized ( lock ) {
                count--;
            }
        }
    }
}
