public class BackgroundServletContextListener implements ServletContextListener {
    private ScheduledExecutorService executor;
    private BackgroundService service;
    public void contextInitialized ( ServletContextEvent sce ) {
        service = new BackgroundService();
        executor = Executors.newSingleThreadScheduledExecutor();
        executor.scheduleAtFixedRate ( service, 0, 5, TimeUnit.MINUTES );
        sce.getServletContext().setAttribute ( "service", service );
    }
    public void contextDestroyed ( ServletContextEvent sce ) {
        executor.shutdown();
    }
}
public class BackgroundService implements Runnable {
    public void run() {
    }
}
