public abstract class CompanyException extends Exception {
    private static final List<ExceptionCallback> callBacks =
        new ArrayList<ExceptionCallback>();
    public CompanyException ( String message ) {
        super ( message );
        invokeCallbacks();
    }
    public static void registerCallback ( ExceptionCallback callback ) {
        List<ExceptionCallback> newCallbacks = new ArrayList<ExceptionCallback>();
        newCallBacks.addAll ( callBacks );
        newCallbacks.add ( callback );
        callBacks = newCallBacks;
    }
    private void invokeCallbacks() {
        for ( ExceptionCallback callBack : callBacks ) {
            try {
                callBack.exceptionConstructed ( this );
            } catch ( Throwable th ) {
            }
        }
    }
}
