public String dec ( String password, String salt, String encString )
throws Exception {
    byte[] ivData = toByte ( encString.substring ( 0, 32 ) );
    byte[] encData = toByte ( encString.substring ( 32 ) );
    PBEKeySpec pbeKeySpec = new PBEKeySpec ( password.toCharArray(),
            toByte ( salt ), 50, 256 );
    SecretKeyFactory keyFactory = SecretKeyFactory
                                  .getInstance ( "PBEWithSHA256And256BitAES-CBC-BC" );
    SecretKeySpec secretKey = new SecretKeySpec ( keyFactory.generateSecret (
                pbeKeySpec ).getEncoded(), "AES" );
    byte[] key = secretKey.getEncoded();
    KeyParameter keyParam = new KeyParameter ( key );
    CipherParameters params = new ParametersWithIV ( keyParam, ivData );
    BlockCipherPadding padding = new PKCS7Padding();
    BufferedBlockCipher cipher = new PaddedBufferedBlockCipher (
        new CBCBlockCipher ( new AESEngine() ), padding );
    cipher.reset();
    cipher.init ( false, params );
    byte[] buf = new byte[cipher.getOutputSize ( encData.length )];
    int len = cipher.processBytes ( encData, 0, encData.length, buf, 0 );
    len += cipher.doFinal ( buf, len );
    byte[] out = new byte[len];
    System.arraycopy ( buf, 0, out, 0, len );
    return new String ( out, "UTF-8" );
}
