File file = new File ( "states.txt" );
SortedMap<String, List<String>> map = new TreeMap<String, List<String>>();
Scanner scanner = new Scanner ( file ).useDelimiter ( "\\n" );
while ( scanner.hasNext() ) {
    String line = scanner.next();
    if ( line.contains ( "," ) ) {
        String[] parts = line.split ( "," );
        String city = parts[0].trim();
        String state = parts[1].trim();
        List<String> cities = map.get ( state );
        if ( cities == null ) {
            cities = new ArrayList<String>();
            map.put ( state, cities );
        }
        if ( !cities.contains ( city ) ) {
            cities.add ( city );
        }
    }
}
for ( String state : map.keySet() ) {
    StringBuilder sb = new StringBuilder();
    sb.append ( state + ": " );
    List<String> cities = map.get ( state );
    for ( String city : cities ) {
        sb.append ( city + ", " );
    }
    sb.delete ( sb.length() - 2, sb.length() );
    String output = sb.toString();
    System.out.println ( output );
}
