@Component
public class OaliaBeanFactoryPostProcessor implements BeanFactoryPostProcessor {
    @SuppressWarnings ( "unchecked" )
    public void postProcessBeanFactory (
        ConfigurableListableBeanFactory beanFactory ) throws BeansException {
        for ( String beanName : beanFactory.getBeanDefinitionNames() ) {
            BeanDefinition beanDefinition = beanFactory.getBeanDefinition ( beanName );
            Class beanClass = null;
            try {
                beanClass = Class.forName ( beanDefinition.getBeanClassName() );
            } catch ( ClassNotFoundException e ) {
                e.printStackTrace();
            }
            if ( Command.class.isAssignableFrom ( beanClass ) ) {
                beanDefinition.setScope ( "prototype" );
            }
            System.out.println ( "[Post Processing] " + beanName + " [" + beanDefinition.getScope() + "]" );
        }
    }
}
