private ModelAndView getModelAndView ( Method handlerMethod, Object returnValue, ServletWebRequest webRequest )
throws Exception {
    ResponseStatus responseStatusAnn = AnnotationUtils.findAnnotation ( handlerMethod, ResponseStatus.class );
    if ( responseStatusAnn != null ) {
        HttpStatus responseStatus = responseStatusAnn.value();
        String reason = responseStatusAnn.reason();
        if ( !StringUtils.hasText ( reason ) ) {
            webRequest.getResponse().setStatus ( responseStatus.value() );
        } else {
            webRequest.getResponse().sendError ( responseStatus.value(), reason );
        }
    }
}
