public class SampleListener implements ServletContextListener {
    public static final long _startTimerDelayMin = 10;
    public static final long _startTimerPeriodMin = 60;
    Timer timer;
    ServletContext context = null;
    public void contextInitialized ( ServletContextEvent contextEvent ) {
        context = contextEvent.getServletContext();
        scheduleTimer();
    }
    public void scheduleTimer() {
        long delay = _startTimerDelayMin * 60000;
        long period = _startTimerPeriodMin * 60000;
        timer = new Timer();
        timer.scheduleAtFixedRate ( new RemindTask(), delay, period );
    }
    public void contextDestroyed ( ServletContextEvent arg0 ) {
        timer.cancel();
    }
    private static String getPropertyValue ( String key ) {
        String value = "";
        try {
            value = Util.getPropertyValueOfKey ( key ).trim();
        } catch ( IOException e ) {
        }
        return value;
    }
    class RemindTask extends TimerTask {
        public void run() {
            clearScopeVariables();
        }
        public void clearScopeVariables() {
            Date dt = new Date();
            Enumeration<String> applicationScopeVarNames = ( Enumeration<String> ) context.getAttributeNames();
        }
    }
