import java.io.*;
class TracingPrintStream extends PrintStream {
    public TracingPrintStream ( PrintStream original ) {
        super ( original );
    }
    @Override
    public void println ( String line ) {
        StackTraceElement[] stack = Thread.currentThread().getStackTrace();
        StackTraceElement caller = stack[2];
        super.println ( caller.getClassName() + ": " + line );
    }
}
public class Test {
    public static void main ( String[] args ) throws Exception {
        System.setOut ( new TracingPrintStream ( System.out ) );
        System.out.println ( "Sample line" );
    }
}
