public enum UsageCode {
    ANTIQUE ( 'A' ),
    FLOOD_DAMAGED ( 'F' ),
    NEW ( 'N' );
    UNKNOWN ( '0' )
    private static final Map<Character, UsageCode> charToEnum
    = new HashMap<Character, UsageCode>();
    static {
        for ( UsageCode code : values() ) {
            charToEnum.put ( code.getCode(), code );
        }
    }
    public static UsageCode fromLegacyCode ( char code ) {
        return charToEnum.get ( code );
    }
    private final char code;
    UsageCode ( char code ) {
        this.code = code;
    }
    public char getCode() {
        return code;
    }
}
