import java.io.*;
import javax.tools.*;
import java.lang.reflect.*;
import org.antlr.runtime.*;
import org.antlr.Tool;
public class Main {
    public static void main ( String[] args ) throws Exception {
        final String grammar =
            "grammar T;                                                  \n" +
            "                                                            \n" +
            "parse                                                       \n" +
            "  :  (ANY {System.out.println(\"ANY=\" + $ANY.text);})* EOF \n" +
            "  ;                                                         \n" +
            "                                                            \n" +
            "SPACE                                                       \n" +
            "  :  (' ' | '\\t' | '\\r' | '\\n') {skip();}                \n" +
            "  ;                                                         \n" +
            "                                                            \n" +
            "ANY                                                         \n" +
            "  :  .                                                      \n" +
            "  ;                                                           ";
        final String grammarName = "T";
        final String entryPoint = "parse";
        Writer out = new BufferedWriter ( new FileWriter ( new File ( grammarName + ".g" ) ) );
        out.write ( grammar );
        out.close();
        Tool tool = new Tool ( new String[] {grammarName + ".g"} );
        tool.process();
        JavaCompiler compiler = ToolProvider.getSystemJavaCompiler();
        compiler.run ( null, System.out, System.err, "-sourcepath", "", grammarName + "Lexer.java" );
        compiler.run ( null, System.out, System.err, "-sourcepath", "", grammarName + "Parser.java" );
        Lexer lexer = ( Lexer ) Class.forName ( grammarName + "Lexer" ).newInstance();
        lexer.setCharStream ( new ANTLRStringStream ( args[0] ) );
        CommonTokenStream tokens = new CommonTokenStream ( lexer );
        Class<?> parserClass = Class.forName ( grammarName + "Parser" );
        Constructor parserCTor = parserClass.getConstructor ( TokenStream.class );
        Parser parser = ( Parser ) parserCTor.newInstance ( tokens );
        Method entryPointMethod = parserClass.getMethod ( entryPoint );
        entryPointMethod.invoke ( parser );
    }
}
