public T findOrCreate ( final T t ) throws InvalidRecordException {
    T found = findUnique ( t );
    if ( found != null ) {
        return found;
    }
    TransactionTemplate tt = new TransactionTemplate ( ( PlatformTransactionManager )
            transactionManager );
    tt.setPropagationBehavior ( TransactionDefinition.PROPAGATION_REQUIRES_NEW );
    try {
        found = ( T ) tt.execute ( new TransactionCallback<T>() {
            try {
                return store ( t );
            } catch ( ConstraintViolationException e ) {
                status.setRollbackOnly();
                return null;
            }
        } );
        if ( found == null ) {
            found = findUnique ( t );
        }
    } catch ( ... ) {
    }
    return found;
}
