public class IdNotEmptySpecification : ISpecification<User> {
    public bool IsSatisfiedBy ( User subject ) {
        return !string.IsNullOrEmpty ( subject.Id );
    }
}
public class NameNotTakenSpecification : ISpecification<User> {
    private Service.IUserNameService UserNameService { get; set; }
    public bool IsSatisfiedBy ( User subject ) {
        return UserNameService.NameIsAvailable ( subject.Name );
    }
}
