public class WeakResourceBundle extends ResourceBundle {
    private Map cache = new WeakHashMap();
    protected Locale locale = Locale.US;
    protected Object handleGetObject ( String key ) {
        if ( cache.containsKey ( key ) ) {
            return cache.get ( key );
        }
        String value = loadFromDatabase ( key, locale );
        cache.put ( key, value );
        return value;
    }
    public Enumeration getKeys() {
        return loadKeysFromDatabase();
    }
    public Locale getLocale() {
        return locale;
    }
    private String loadFromDatabase ( String key, Locale aLocale ) {
        System.out.println ( "Loading key: " + key
                             + " from database for locale:"
                             + aLocale );
        return "dummy_" + aLocale.getDisplayLanguage ( aLocale );
    }
    private Enumeration loadKeysFromDatabase() {
        return Collections.enumeration ( new ArrayList() );
    }
}
