StatelessKnowledgeSession ksession = this.kbase.newStatelessKnowledgeSession();
KnowledgeRuntimeLogger klogger = configureKnowledgeRuntimeLogger ( ksession );
List<Command> commands = new ArrayList<Command>();
commands.add ( CommandFactory.newInsert ( inputObj, "inputObj" ) );
commands.add ( CommandFactory.newFireAllRules() );
commands.add ( CommandFactory.newQuery ( "outputObj", "GetOutputObj" ) );
ExecutionResults results = ksession.execute ( CommandFactory.newBatchExecution ( commands ) );
QueryResults queryResults = ( ( NativeQueryResults ) results.getValue ( "baseTrade" ) ).getResults();
try {
    Iterator iter = queryResults.iterator();
    while ( iter.hasNext() ) {
        QueryResult result = iter.next();
        return ( BaseTrade ) result.get ( "baseTrade" );
    }
} finally {
    if ( klogger != null ) {
        klogger.close();
    }
}
