Intent intent = new Intent ( RecognizerIntent.ACTION_RECOGNIZE_SPEECH );
intent.putExtra ( RecognizerIntent.EXTRA_LANGUAGE_MODEL,
                  RecognizerIntent.LANGUAGE_MODEL_FREE_FORM );
intent.putExtra ( RecognizerIntent.EXTRA_CALLING_PACKAGE,
                  "com.domain.app" );
SpeechRecognizer recognizer = SpeechRecognizer
                              .createSpeechRecognizer ( this.getApplicationContext() );
RecognitionListener listener = new RecognitionListener() {
    @Override
    public void onResults ( Bundle results ) {
        ArrayList<String> voiceResults = results
                                         .getStringArrayList ( SpeechRecognizer.RESULTS_RECOGNITION );
        if ( voiceResults == null ) {
            Log.e ( TAG, "No voice results" );
        } else {
            Log.d ( TAG, "Printing matches: " );
            for ( String match : voiceResults ) {
                Log.d ( TAG, match );
            }
        }
    }
    @Override
    public void onReadyForSpeech ( Bundle params ) {
        Log.d ( TAG, "Ready for speech" );
    }
    @Override
    public void onError ( int error ) {
        Log.d ( TAG,
                "Error listening for speech: " + error );
    }
    @Override
    public void onBeginningOfSpeech() {
        Log.d ( TAG, "Speech starting" );
    }
    @Override
    public void onBufferReceived ( byte[] buffer ) {
    }
    @Override
    public void onEndOfSpeech() {
    }
    @Override
    public void onEvent ( int eventType, Bundle params ) {
    }
    @Override
    public void onPartialResults ( Bundle partialResults ) {
    }
    @Override
    public void onRmsChanged ( float rmsdB ) {
    }
};
recognizer.setRecognitionListener ( listener );
recognizer.startListening ( intent );
