public class DataBaseHelper extends SQLiteOpenHelper {
    private Context mycontext;
    private String DB_PATH = "/data/data/gr.peos/databases/";
    private static String DB_NAME = "BLib.sqlite";
    public SQLiteDatabase myDataBase;
    public DataBaseHelper ( Context context ) throws IOException  {
        super ( context, DB_NAME, null, 1 );
        this.mycontext = context;
        boolean dbexist = checkdatabase();
        if ( dbexist ) {
            opendatabase();
        } else {
            System.out.println ( "Database doesn't exist" );
            createdatabase();
        }
    }
    public void createdatabase() throws IOException {
        boolean dbexist = checkdatabase();
        if ( dbexist ) {
        } else {
            this.getReadableDatabase();
            try {
                copydatabase();
            } catch ( IOException e ) {
                throw new Error ( "Error copying database" );
            }
        }
    }
    private boolean checkdatabase() {
        boolean checkdb = false;
        try {
            String myPath = DB_PATH + DB_NAME;
            File dbfile = new File ( myPath );
            checkdb = dbfile.exists();
        } catch ( SQLiteException e ) {
            System.out.println ( "Database doesn't exist" );
        }
        return checkdb;
    }
    private void copydatabase() throws IOException {
        InputStream myinput = mycontext.getAssets().open ( DB_NAME );
        String outfilename = DB_PATH + DB_NAME;
        OutputStream myoutput = new FileOutputStream ( "/data/data/gr.peos/databases/BLib.sqlite" );
        byte[] buffer = new byte[1024];
        int length;
        while ( ( length = myinput.read ( buffer ) ) > 0 ) {
            myoutput.write ( buffer, 0, length );
        }
        myoutput.flush();
        myoutput.close();
        myinput.close();
    }
    public void opendatabase() throws SQLException {
        String mypath = DB_PATH + DB_NAME;
        myDataBase = SQLiteDatabase.openDatabase ( mypath, null, SQLiteDatabase.OPEN_READWRITE );
    }
    public synchronized void close() {
        if ( myDataBase != null ) {
            myDataBase.close();
        }
        super.close();
    }
