private Thread readingThread = new ListeningThread();
private class ListeningThread extends Thread {
    public void run() {
        running = true;
        try {
            while ( !close ) {
                listen();
            }
            messenger.close();
        } catch ( ConnectException ce ) {
            doNotifyConnectionFailed ( ce );
        } catch ( Exception e ) {
            messenger.close();
        }
        running = false;
    }
}
public void connect ( String host, int port ) {
    try {
        SocketChannel socket = SocketChannel.open();
        socket.configureBlocking ( false );
        socket.register ( this.selector, SelectionKey.OP_CONNECT );
        socket.connect ( new InetSocketAddress ( host, port ) );
    } catch ( IOException e ) {
        this.doNotifyConnectionFailed ( e );
    }
}
protected void listen() throws IOException {
    this.selector.select();
    Iterator<SelectionKey> iter = selector.selectedKeys().iterator();
    while ( iter.hasNext() ) {
        SelectionKey key = iter.next();
        iter.remove();
        if ( key.isValid() ) {
            if ( key.isConnectable() ) {
                SocketChannel client = ( SocketChannel ) key.channel();
                if ( client != null && client.finishConnect() ) {
                    client.register ( this.selector, SelectionKey.OP_READ );
                }
            } else if ( key.isReadable() && ( SocketChannel ) key.channel() == this.messenger.getSocket() ) {
            }
        }
    }
}
public void start() {
    if ( !this.running ) {
        this.readingThread = new ListeningThread();
        this.readingThread.start();
    }
}
public void close() {
    this.close = true;
}
