@Override
public int bulkInsert ( Uri uri, ContentValues[] values ) {
    int numValues = values.length;
    mDb = mOpenHelper.getWritableDatabase();
    mDb.beginTransactionWithListener ( this );
    try {
        for ( int i = 0; i < numValues; i++ ) {
            Uri result = insertInTransaction ( uri, values[i] );
            if ( result != null ) {
                mNotifyChange = true;
            }
            mDb.yieldIfContendedSafely();
        }
        mDb.setTransactionSuccessful();
    } finally {
        mDb.endTransaction();
    }
    onEndTransaction();
    return numValues;
}
