public class SearchResults extends ListActivity {
    @Override
    public void onCreate ( Bundle savedInstanceState ) {
        super.onCreate ( savedInstanceState );
        DbManager myDbHelper = new DbManager ( null );
        myDbHelper = new DbManager ( this );
        myDbHelper.createNewDatabase();
        try {
            myDbHelper.open();
            Log.d ( "Search Results", "database opened" );
        } catch ( SQLException sqle ) {
            throw sqle;
        }
        Intent intent = getIntent();
        String query = intent.getStringExtra ( SearchManager.QUERY );
        String select = "SELECT DISTINCT b._ISBN as _id, b.BookTitle, b.Edition, b.Year, b.Pages, b.Rating, c.Category, p.Publisher, w.LastName"
                        + "   FROM"
                        + "   Books b"
                        + "   JOIN Categories_Books cb ON cb._Books_ISBN = _id"
                        + "   JOIN Categories c ON c._CategoryID = cb._Categories_CategoryID"
                        + "   JOIN Publishers p ON p._PublisherID = b.PublisherID"
                        + "   JOIN Writers_Books wb ON wb._Books_ISBN = _id"
                        + "   JOIN Writers w ON w._WriterID = wb._Writers_WriterID"
                        + "   WHERE b.BookTitle LIKE '%"
                        + query
                        + "%'"
                        + "   OR c.Category LIKE '%"
                        + query
                        + "%'"
                        + "   OR p.Publisher LIKE '%"
                        + query
                        + "%'"
                        + "   OR w.LastName LIKE '%"
                        + query
                        + "%'"
                        + "   OR _id LIKE '%"
                        + query
                        + "%'"
                        + "   GROUP BY b.BookTitle";
        Cursor c = myDbHelper.rawQ ( select );
        startManagingCursor ( c );
        String[] columns = new String[] { "Books.BookTitle",
                                          "Publishers.Publisher"
                                        };
        int[] to = new int[] { R.id.ISBN_entry, R.id.Title_entry };
        try {
            SimpleCursorAdapter mAdapter = new SimpleCursorAdapter ( this,
                    R.layout.listlayout, c, columns, to );
            this.setListAdapter ( mAdapter );
        } catch ( Exception e ) {
        }
    }
}
