public static void main ( String[] args ) throws IOException {
    Set<String> dictionary = new HashSet<String>();
    Scanner filescan = new Scanner ( new File ( "dictionary.txt" ) );
    while ( filescan.hasNext() ) {
        dictionary.add ( filescan.nextLine().toLowerCase() );
    }
    Scanner scan = new Scanner ( System.in );
    System.out.print ( "Enter a string: " );
    String input = scan.next().toLowerCase();
    System.out.println();
    List<List<String>> results = new ArrayList<List<String>>();
    long time = System.currentTimeMillis();
    search ( input, dictionary, new Stack<String>(), results );
    time = System.currentTimeMillis() - time;
    for ( List<String> result : results ) {
        for ( String word : result ) {
            System.out.print ( word + " " );
        }
        System.out.println ( "(" + result.size() + " words)" );
    }
    System.out.println();
    System.out.println ( "Took " + time + "ms" );
}
public static void search ( String input, Set<String> dictionary,
                            Stack<String> words, List<List<String>> results ) {
    for ( int i = 0; i < input.length(); i++ ) {
        String substring = input.substring ( 0, i + 1 );
        if ( dictionary.contains ( substring ) ) {
            words.push ( substring );
            if ( i == input.length() - 1 ) {
                results.add ( new ArrayList<String> ( words ) );
            } else {
                search ( input.substring ( i + 1 ), dictionary, words, results );
            }
            words.pop();
        }
    }
}
