public static List<String> splitSSV ( String in ) throws IOException {
    ArrayList<String> out = new ArrayList<String>();
    StringReader r = new StringReader ( in );
    StringBuilder b = new StringBuilder();
    int inQuote = -1;
    boolean escape = false;
    int c;
    while ( ( c = r.read() ) != -1 ) {
        if ( escape ) {
            b.append ( ( char ) c );
            escape = false;
            continue;
        }
        switch ( c ) {
        case '\\':
            escape = true;
            break;
        case '\"':
        case '\'':
            if ( c == '\"' || c == '\'' ) {
                if ( inQuote == -1 ) {
                    inQuote = c;
                } else {
                    inQuote = -1;
                }
            }
            break;
        case ' ':
            if ( inQuote == -1 ) {
                out.add ( b.toString() );
                b.setLength ( 0 );
            } else {
                b.append ( ( char ) c );
            }
            break;
        default:
            b.append ( ( char ) c );
        }
    }
    if ( b.length() > 0 ) {
        out.add ( b.toString() );
    }
    return out;
}
