public class Worker implements Runnable {
    private static final Metrics metrics = new Metrics();
    public void run() {
        while ( true ) {
            ...get record
            long start = System.currentTimeMillis();
            ...do work
            long end = System.currentTimeMillis();
            metrics.addMetric ( end - start );
        }
    }
    private static final class Metrics {
        private final ExecutorService metricThread =
            Executors.newSingleThreadExecutor();
        private int count = 0;
        private long processingTime = 0;
        public void addMetric ( final long time ) {
            metricThread.execute ( new Runnable() {
                public void run() {
                    count++;
                    processingTime += time;
                    if ( count % 1000 == 0 ) {
                        ... log some metrics
                        processingTime = 0;
                        count = 0;
                    }
                }
            } );
        }
    }
}
