public static void sendMailAndThrowException ( SMTPParams sparams, String  subject, DataSource msgTextSource, DataSource[] fids, boolean debug ) throws MessagingException {
    Session session = getMailSession ( sparams );
    PrintStream f = null;
    if ( debug ) {
        f = getPrintStream();
    }
    session.setDebug ( debug );
    session.setDebugOut ( f );
    try {
        MimeMessage msg = new MimeMessage ( session );
        msg.setFrom ( new InternetAddress ( sparams.getFrom() ) );
        String to_list[] = sparams.getRecipients().split ( "," );
        InternetAddress[] address = new InternetAddress[to_list.length];
        for ( int i = 0; i < to_list.length; i++ ) {
            String temp = to_list[i].trim();
            if ( temp.length() > 0 ) {
                address[i] = new InternetAddress ( to_list[i].trim() );
            }
        }
        msg.setRecipients ( Message.RecipientType.TO, address );
        if ( ( msg.getAllRecipients() == null ) || ( msg.getAllRecipients().length == 0 ) ) {
            throw new MessagingException ( "No valid recipients" );
        }
        msg.setSubject ( subject, "UTF-8" );
        Multipart mp = new MimeMultipart();
        if ( msgTextSource != null ) {
            MimeBodyPart mbp1 = new MimeBodyPart();
            mbp1.setDataHandler ( new DataHandler ( msgTextSource ) );
            mp.addBodyPart ( mbp1 );
        }
        if ( fids != null ) {
            for ( int i = 0; i < fids.length; i++ ) {
                if ( fids[i] == null ) {
                    continue;
                }
                MimeBodyPart mbp2 = new MimeBodyPart();
                mbp2.setDataHandler ( new DataHandler ( fids[i] ) );
                mbp2.setFileName ( fids[i].getName() );
                mp.addBodyPart ( mbp2 );
            }
        }
        msg.setContent ( mp );
        msg.setSentDate ( new java.util.Date() );
        smtpSend ( session, msg, sparams );
    } catch ( MessagingException mex ) {
        throw mex;
    } finally {
        closeDebug ( f );
    }
}
