import java.beans.*;
public class MvcModel {
    public static final String STATE_PROP_NAME = "State";
    private PropertyChangeSupport pcSupport = new PropertyChangeSupport ( this );
    private State state = State.NO_STATE;
    public void setState ( State state ) {
        State oldState = this.state;
        this.state = state;
        pcSupport.firePropertyChange ( STATE_PROP_NAME, oldState, state );
    }
    public State getState() {
        return state;
    }
    public String getStateText() {
        return state.getText();
    }
    public void addPropertyChangeListener ( PropertyChangeListener listener ) {
        pcSupport.addPropertyChangeListener ( listener );
    }
}
