package at.percom.temp.zztests;
import java.lang.reflect.InvocationTargetException;
import org.apache.commons.beanutils.BeanMap;
import org.apache.commons.beanutils.PropertyUtilsBean;
public class Main {
    public static void main ( String[] args ) throws IllegalAccessException, InvocationTargetException, NoSuchMethodException {
        Main main = new Main();
        main.start();
    }
    public void start() throws IllegalAccessException, InvocationTargetException, NoSuchMethodException {
        SampleBean sample1 = new SampleBean ( "John", "Doe", 1971 );
        SampleBean sample2 = new SampleBean ( "John X.", "Doe", 1971 );
        compareObjects ( sample1, sample2 );
    }
    public void compareObjects ( Object oldObject, Object newObject ) throws IllegalAccessException, InvocationTargetException, NoSuchMethodException {
        BeanMap map = new BeanMap ( oldObject );
        PropertyUtilsBean propUtils = new PropertyUtilsBean();
        for ( Object propNameObject : map.keySet() ) {
            String propertyName = ( String ) propNameObject;
            Object property1 = propUtils.getProperty ( oldObject, propertyName );
            Object property2 = propUtils.getProperty ( newObject, propertyName );
            if ( property1.equals ( property2 ) ) {
                System.out.println ( "  " + propertyName + " is equal" );
            } else {
                System.out.println ( "> " + propertyName + " is different (oldValue=\"" + property1 + "\", newValue=\"" + property2 + "\")" );
            }
        }
    }
    public class SampleBean {
        public String firstName;
        public String lastName;
        public int yearOfBirth;
        public SampleBean ( String firstName, String lastName, int yearOfBirth ) {
            this.firstName = firstName;
            this.lastName = lastName;
            this.yearOfBirth = yearOfBirth;
        }
        public String getFirstName() {
            return firstName;
        }
        public String getLastName() {
            return lastName;
        }
        public int getYearOfBirth() {
            return yearOfBirth;
        }
    }
}
