package com.opencmsserver.taglib;
import org.opencms.flex.CmsFlexController;
import org.opencms.jsp.Messages;
import org.opencms.main.CmsLog;
import javax.servlet.ServletRequest;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.BodyTagSupport;
import org.apache.commons.logging.Log;
public class StripPTag extends BodyTagSupport {
    private static final long serialVersionUID = -2361021288258405388L;
    private static final Log LOG = CmsLog.getLog ( StripPTag.class );
    public int doEndTag() throws JspException {
        ServletRequest req = pageContext.getRequest();
        if ( CmsFlexController.isCmsRequest ( req ) ) {
            try {
                String content = getBodyContent().getString();
                content = content.replaceAll ( "<p>", "" );
                content = content.replaceAll ( "</p>", "" );
                getBodyContent().clear();
                getBodyContent().print ( content );
                getBodyContent().writeOut ( pageContext.getOut() );
            } catch ( Exception ex ) {
                if ( LOG.isErrorEnabled() ) {
                    LOG.error ( "Failed using StripPTag. ", ex );
                }
                throw new JspException ( ex );
            }
        }
        return EVAL_PAGE;
    }
}
