package krc.utilz;
import java.io.Serializable;
import java.nio.charset.Charset;
public class Random extends java.util.Random  implements Serializable {
    private static final long serialVersionUID = 34324;
    public static final int DEFAULT_MIN_STRING_LENGTH = 5;
    public static final int DEFAULT_MAX_STRING_LENGTH = 25;
    public Random() {
        super();
    }
    public Random ( long seed ) {
        super ( seed );
    }
    public double nextDouble ( double lo, double hi ) {
        double n = hi - lo;
        double i = super.nextDouble() % n;
        if ( i < 0 ) {
            i *= -1.0;
        }
        return lo + i;
    }
    public int nextInt ( int lo, int hi )
    throws IllegalArgumentException {
        if ( lo >= hi ) {
            throw new IllegalArgumentException ( "lo must be < hi" );
        }
        int n = hi - lo + 1;
        int i = super.nextInt() % n;
        if ( i < 0 ) {
            i = -i;
        }
        return lo + i;
    }
    public int nextInt ( int lo, int hi, int xlo, int xhi )
    throws IllegalArgumentException {
        if ( xlo < lo ) {
            throw new IllegalArgumentException ( "xlo must be >= lo" );
        }
        if ( xhi > hi ) {
            throw new IllegalArgumentException ( "xhi must be =< hi" );
        }
        if ( xlo > xhi ) {
            throw new IllegalArgumentException ( "xlo must be >= xhi" );
        }
        int i;
        do {
            i = nextInt ( lo, hi );
        } while ( i >= xlo && i <= xhi );
        return ( i );
    }
    public String nextString()
    throws IllegalArgumentException {
        return ( nextString ( DEFAULT_MIN_STRING_LENGTH, DEFAULT_MAX_STRING_LENGTH ) );
    }
    public String nextString ( int minLen, int maxLen )
    throws IllegalArgumentException {
        if ( minLen < 0 ) {
            throw new IllegalArgumentException ( "minLen must be >= 0" );
        }
        if ( minLen > maxLen ) {
            throw new IllegalArgumentException ( "minLen must be <= maxLen" );
        }
        return ( nextString ( minLen, maxLen, 'A', 'z', '[', '`' ) );
    }
    public String nextString ( int minLen, int maxLen, char lo, char hi )
    throws IllegalArgumentException {
        if ( lo < 0 ) {
            throw new IllegalArgumentException ( "lo must be >= 0" );
        }
        String retval = null;
        try {
            int n = minLen == maxLen ? maxLen : nextInt ( minLen, maxLen );
            byte b[] = new byte[n];
            for ( int i = 0; i < n; i++ ) {
                b[i] = ( byte ) nextInt ( ( int ) lo, ( int ) hi );
            }
            retval = new String ( b, Charset.defaultCharset().name() );
        } catch ( Exception e ) {
            e.printStackTrace();
        }
        return retval;
    }
    public String nextString ( int minLen, int maxLen, char lo, char hi, char xlo, char xhi )
    throws IllegalArgumentException {
        if ( lo < 0 ) {
            throw new IllegalArgumentException ( "lo must be >= 0" );
        }
        String retval = null;
        try {
            int n = minLen == maxLen ? maxLen : nextInt ( minLen, maxLen );
            byte b[] = new byte[n];
            for ( int i = 0; i < n; i++ ) {
                b[i] = ( byte ) nextInt ( ( int ) lo, ( int ) hi, ( int ) xlo, ( int ) xhi );
            }
            retval = new String ( b, Charset.defaultCharset().name() );
        } catch ( Exception e ) {
            e.printStackTrace();
        }
        return retval;
    }
}
