public static float toFloat ( int hbits ) {
    int mant = hbits & 0x03ff;
    int exp =  hbits & 0x7c00;
    if ( exp == 0x7c00 ) {
        exp = 0x3fc00;
    } else if ( exp != 0 ) {
        exp += 0x1c000;
        if ( mant == 0 && exp > 0x1c400 )
            return Float.intBitsToFloat ( ( hbits & 0x8000 ) << 16
                                          | exp << 13 | 0x3ff );
    } else if ( mant != 0 ) {
        exp = 0x1c400;
        do {
            mant <<= 1;
            exp -= 0x400;
        } while ( ( mant & 0x400 ) == 0 );
        mant &= 0x3ff;
    }
    return Float.intBitsToFloat (
               ( hbits & 0x8000 ) << 16
               | ( exp | mant ) << 13 );
}
