String[] getResourceListing ( Class clazz, String path ) throws URISyntaxException, IOException {
    URL dirURL = clazz.getClassLoader().getResource ( path );
    if ( dirURL != null && dirURL.getProtocol().equals ( "file" ) ) {
        return new File ( dirURL.toURI() ).list();
    }
    if ( dirURL == null ) {
        String me = clazz.getName().replace ( ".", "/" ) + ".class";
        dirURL = clazz.getClassLoader().getResource ( me );
    }
    if ( dirURL.getProtocol().equals ( "jar" ) ) {
        String jarPath = dirURL.getPath().substring ( 5, dirURL.getPath().indexOf ( "!" ) );
        JarFile jar = new JarFile ( URLDecoder.decode ( jarPath, "UTF-8" ) );
        Enumeration<JarEntry> entries = jar.entries();
        Set<String> result = new HashSet<String>();
        while ( entries.hasMoreElements() ) {
            String name = entries.nextElement().getName();
            if ( name.startsWith ( path ) ) {
                String entry = name.substring ( path.length() );
                int checkSubdir = entry.indexOf ( "/" );
                if ( checkSubdir >= 0 ) {
                    entry = entry.substring ( 0, checkSubdir );
                }
                result.add ( entry );
            }
        }
        return result.toArray ( new String[result.size()] );
    }
    throw new UnsupportedOperationException ( "Cannot list files for URL " + dirURL );
}
