private static KnowledgeBase readKnowledgeBase ( ClassLoader loader ) throws Exception {
    KnowledgeBuilderConfiguration kBuilderConfiguration = KnowledgeBuilderFactory.newKnowledgeBuilderConfiguration ( null, loader );
    KnowledgeBuilder kbuilder = KnowledgeBuilderFactory.newKnowledgeBuilder ( kBuilderConfiguration );
    KnowledgeBaseConfiguration kbaseConfig = KnowledgeBaseFactory.newKnowledgeBaseConfiguration ( null, loader );
    kbuilder.add ( ResourceFactory.newFileResource ( "./rulefiles/testing.drl" ), ResourceType.DRL );
    KnowledgeBuilderErrors errors = kbuilder.getErrors();
    if ( errors.size() > 0 ) {
        for ( KnowledgeBuilderError error : errors ) {
            System.err.println ( error );
        }
        throw new IllegalArgumentException ( "Could not parse knowledge." );
    }
    KnowledgeBase kbase = KnowledgeBaseFactory.newKnowledgeBase ( kbaseConfig );
    kbase.addKnowledgePackages ( kbuilder.getKnowledgePackages() );
    return kbase;
}
