import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.Writer;
import java.util.ArrayList;
import java.util.List;
class DependencyDataCollection {
    private final int sNo;
    private final String sessionID;
    private final int noOfDependency;
    private final int noOfRejection;
    private final int totalValue;
    public DependencyDataCollection ( final int    sNo,
                                      final String sessionID,
                                      final int    noOfDependency,
                                      final int    noOfRejection,
                                      final int    totalValue ) {
        this.sNo            = sNo;
        this.sessionID      = sessionID;
        this.noOfDependency = noOfDependency;
        this.noOfRejection  = noOfRejection;
        this.totalValue     = totalValue;
    }
    public int getSNo() {
        return sNo;
    }
    public String getSessionID() {
        return sessionID;
    }
    public int getNoOfDependency() {
        return noOfDependency;
    }
    public int getNoOfRejection() {
        return noOfRejection;
    }
    public int getTotalValue() {
        return totalValue;
    }
}
class DependencyStack {
    private final List<DependencyDataCollection> dependencies;
    {
        dependencies = new ArrayList<DependencyDataCollection>();
    }
    public void add ( final DependencyDataCollection ddc ) {
        dependencies.add ( ddc );
    }
    public int size() {
        return dependencies.size();
    }
    public void show() {
        show ( System.out );
    }
    public void show ( final OutputStream out ) {
        show ( new OutputStreamWriter ( out ) );
    }
    public void show ( final Writer writer ) {
        show ( new PrintWriter ( writer ) );
    }
    public void show ( final PrintWriter writer ) {
        for ( final DependencyDataCollection ddc : dependencies ) {
            writer.println ( ddc.getSNo()            + "   " +
                             ddc.getSessionID()      + "   " +
                             ddc.getNoOfDependency() + "   " +
                             ddc.getNoOfRejection()  + "   " +
                             ddc.getTotalValue() );
        }
    }
    public int returnIndexOfSession ( final String sessionID ) {
        DependencyDataCollection foundDDC;
        final int                retVal;
        foundDDC = null;
        for ( final DependencyDataCollection ddc : dependencies ) {
            if ( ddc.getSessionID().equals ( sessionID ) ) {
                foundDDC = ddc;
                break;
            }
        }
        if ( foundDDC == null ) {
            retVal = -1;
        } else {
            retVal = foundDDC.getSNo();
        }
        return ( retVal );
    }
    public static void main ( final String[] args ) {
        DependencyStack ds = new DependencyStack();
        ds.add ( new DependencyDataCollection ( 1, "a", 0, 0, 0 ) );
        ds.add ( new DependencyDataCollection ( 1, "a", 0, 0, 0 ) );
        ds.show();
    }
}
