public class ChainComparator<T> implements Comparator<T> {
    private final List<Comparator<T>> comparators;
    public ChainComparator ( List<Comparator<T>> comparators ) {
        this.comparators = comparators;
    }
    public int compare ( T t1, T t2 ) {
        for ( Comparator<T> comp : comparators ) {
            int comparisonResult = t1.compareTo ( t2 );
            if ( comparisonResult != 0 ) {
                return comparisonResult;
            }
        }
        return 0;
    }
}
