package com.neurologic.example;
import javax.servlet.http.HttpServletRequest;
import net.oauth.signature.OAuthSignature;
import net.oauth.signature.impl.OAuthHmacSha1Signature;
import net.oauth.token.v1.AccessToken;
import net.oauth.token.v1.RequestToken;
import com.neurologic.oauth.service.impl.OAuth1Service;
public class TwitterOAuthService extends OAuth1Service {
    public static final String TWITTER_REQUEST_TOKEN_SESSION = "TWITTER_REQUEST_TOKEN_SESSION";
    public static final String TWITTER_ACCESS_TOKEN_SESSION = "TWITTER_ACCESS_TOKEN_SESSION";
    @Override
    protected OAuthSignature getOAuthSignature() {
        return new OAuthHmacSha1Signature();
    }
    @Override
    protected String getRealm() {
        return null;
    }
    @Override
    protected RequestToken getRequestToken ( HttpServletRequest request ) {
        return ( RequestToken ) request.getSession().getAttribute ( TWITTER_REQUEST_TOKEN_SESSION );
    }
    @Override
    public void saveAccessToken ( HttpServletRequest request, AccessToken accessToken ) {
        request.getSession().setAttribute ( TWITTER_ACCESS_TOKEN_SESSION, accessToken );
    }
}
