public T cas ( final String key, final T initial, int initialExp,
               final CASMutation<T> m ) throws Exception {
    T rv = initial;
    boolean done = false;
    for ( int i = 0; !done && i < max; i++ ) {
        CASValue<T> casval = client.gets ( key, transcoder );
        T current = null;
        if ( casval != null ) {
            T tmp = casval.getValue();
            current = tmp;
        }
        if ( current != null ) {
            assert casval != null : "casval was null with a current value";
            rv = m.getNewValue ( current );
            if ( client.cas ( key, casval.getCas(), rv, transcoder )
                    == CASResponse.OK ) {
                done = true;
            }
        } else {
            if ( initial == null ) {
                done = true;
                rv = null;
            } else if ( client.add ( key, initialExp, initial, transcoder ).get() ) {
                done = true;
                rv = initial;
            }
        }
    }
    if ( !done ) {
        throw new RuntimeException ( "Couldn't get a CAS in " + max
                                     + " attempts" );
    }
    return rv;
}
