import java.util.regex.Pattern;
import java.util.regex.Matcher;
public static String getFriendlyName ( String registryKey ) {
    if ( registryKey == null || registryKey.isEmpty() ) {
        throw new IllegalArgumentException ( "'registryKey' null or empty" );
    }
    try {
        int hkey = WinRegistry.HKEY_LOCAL_MACHINE;
        return WinRegistry.readString ( hkey, registryKey, "FriendlyName" );
    } catch ( Exception ex ) {
        System.err.println ( ex.getMessage() );
        return null;
    }
}
public static int getComNumber ( String registryKey ) {
    String friendlyName = getFriendlyName ( registryKey );
    if ( friendlyName != null && friendlyName.indexOf ( "COM" ) >= 0 ) {
        String substr = friendlyName.substring ( friendlyName.indexOf ( "COM" ) );
        Matcher matchInt = Pattern.compile ( "\\d+" ).matcher ( substr );
        if ( matchInt.find() ) {
            return Integer.parseInt ( matchInt.group() );
        }
    }
    return -1;
}
