public class FacebookSuggestOracle extends SuggestOracle {
    private FacebookServiceAsync service = GWT.create ( FacebookService.class );
    private Request currentRequest;
    private Callback currentCallback;
    @Override
    public void requestSuggestions ( Request request, Callback callback ) {
        this.currentRequest = request;
        this.currentCallback = callback;
        service.getFacebookGroupIds ( request.getQuery(), new AsyncCallback<List<String>>() {
            public void onSuccess ( List<String> result ) {
                createSuggestionsForGroupIds ( result );
            }
        } );
    }
    private void createSuggestionsForGroupIds ( List<String> groupIds ) {
        List<FacebookGroupSuggestion> suggestions = new ArrayList<FacebookGroupSuggestion>();
        for ( String groupId : groupIds ) {
            suggestions.add ( new FacebookGroupSuggestion ( groupId ) );
        }
        Response response = new Response ( suggestions );
        currentCallback.onSuggestionsReady ( currentRequest, response );
        for ( String groupId : groupIds ) {
            service.getIconForGroup ( groupId, new AsyncCallback<Icon>() {
                public void onSuccess ( Icon result ) {
                }
            } );
        }
    }
}
