public static BigDecimal getHypergeometricDistribution (
    int a[][], int scale, int roundingMode
) throws OutOfMemoryError, NullPointerException {
    ArrayList<Integer> R = new ArrayList<Integer>();
    ArrayList<Integer> C = new ArrayList<Integer>();
    ArrayList<Integer> E = new ArrayList<Integer>();
    int n = 0;
    for ( int i = 0; i < a.length; i++ ) {
        for ( int j = 0; j < a[i].length; j++ ) {
            if ( a[i][j] < 0 ) {
                return null;
            }
            n += a[i][j];
            add ( C, j, a[i][j] );
            add ( R, i, a[i][j] );
            E.add ( a[i][j] );
        }
    }
    BigDecimal term1 =
        new BigDecimal ( multiplyFactorials ( C ).multiply ( multiplyFactorials ( R ) ) );
    BigDecimal term2 =
        new BigDecimal ( getFactorial ( n ).multiply ( multiplyFactorials ( E ) ) );
    return term1.divide ( term2, scale, roundingMode );
}
