import java.net.URL;
import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.Clip;
class ClipPlayer {
    public static void main ( String[] args ) {
        ClipPlayer cp = new ClipPlayer();
        cp.demoSam();
    }
    private void demoSam() {
        Sam sam;
        try {
            sam = new Sam ( "Chook.wav" );
        } catch ( Exception e ) {
            say ( "Exception thrown by Sam: " + e.getMessage() );
            System.exit ( 1 );
            return;
        }
        int countDown = 20;
        do {
            say ( "Doing something requiring accompanying sound effect..." );
            try {
                sam.playIt();
            } catch ( Exception e ) {
                say ( "Caught exception from playIt: " + e.getMessage() );
                System.exit ( 1 );
            }
            synchronized ( this ) {
                try {
                    wait ( 125 );
                } catch ( Exception e2 ) {
                    say ( "huh?" );
                }
            }
        } while ( --countDown > 0 );
    }
    final class Sam {
        AudioInputStream ais;
        Clip             clip;
        Sam ( String clipName ) throws Exception {
            ClassLoader classLoader = Thread.currentThread().getContextClassLoader();
            URL url = classLoader.getResource ( clipName );
            ais = AudioSystem.getAudioInputStream ( url );
            clip = AudioSystem.getClip();
            clip.open ( ais );
        }
        public void playIt() throws Exception {
            clip.setFramePosition ( 0 );
            clip.loop ( 0 );
            clip.start();
        }
    }
    private static void say ( String s ) {
        System.out.println ( s );
    }
}
