public class AndroidSaxFeedParser extends BaseFeedParser {
    ArrayList<ItemPojo> itemList = new ArrayList<ItemPojo>();
    Map<String, ArrayList<ItemPojo>> itemStore = new HashMap<String, ArrayList<ItemPojo>> ( 1 );
    ItemPojo currentItem = null;
    String sectionName = null;
    public AndroidSaxFeedParser() {
        super();
    }
    public Map<String, ArrayList<ItemPojo>> parse() {
        RootElement root = new RootElement ( SECTIONS );
        Element section = root.getChild ( SECTION );
        Element itemHeader = section.getChild ( ITEM_HEADER );
        itemHeader.setEndTextElementListener ( new EndTextElementListener() {
            public void end ( String body ) {
                sectionName = body.trim();
                Log.i ( "New Section", "New section found : " + sectionName );
            }
        } );
        section.setStartElementListener ( new StartElementListener() {
            public void start ( Attributes attributes ) {
                itemList = new ArrayList<ItemPojo> ( 0 );
                Log.i ( "Size of list", "Size : " + itemList.size() );
            }
        } );
        section.setEndElementListener ( new EndElementListener() {
            public void end() {
                itemStore.put ( sectionName, itemList );
            }
        } );
        Element items = section.getChild ( ITEMS );
        Element item = items.getChild ( ITEM );
        items.setEndElementListener ( new EndElementListener() {
            public void end() {
                Collections.sort ( itemList, ItemPojo.COMPARE_BY_POSITION );
            }
        } );
        item.setStartElementListener ( new StartElementListener() {
            public void start ( Attributes attributes ) {
                currentItem = new ItemPojo();
                currentItem.setItemPosition ( Integer.parseInt ( attributes.getValue ( "pos" ) ) );
            }
        } );
        item.setEndElementListener ( new EndElementListener() {
            public void end() {
                itemList.add ( currentItem );
                Log.i ( "Test xml", "New items found " + currentItem.toString() );
            }
        } );
        item.getChild ( ITEM_NAME ).setEndTextElementListener ( new EndTextElementListener() {
            public void end ( String body ) {
                currentItem.setItemName ( body.trim() );
            }
        } );
        item.getChild ( DESCRIPTION ).setEndTextElementListener ( new EndTextElementListener() {
            public void end ( String body ) {
                currentItem.setItemDescription ( body.trim() );
            }
        } );
        try {
            Xml.parse ( this.getInputStream(), Xml.Encoding.UTF_8, root.getContentHandler() );
        } catch ( Exception e ) {
            throw new RuntimeException ( e );
        }
        return itemStore;
    }
}
