abstract class Nexus<T extends Nexus<T>> {
    private T next;
    protected Nexus() {
        this.add ( ( T ) this );
    }
    public T add ( T obj ) {
        return getHeadAndTail().add ( obj );
    }
    protected abstract HeadAndTail<T> getHeadAndTail();
}
class HeadAndTail<T extends Nexus<T>> {
    T head = null;
    T tail = null;
    int num = 0;
    public T add ( T obj ) {
        obj.next = null;
        if ( num++ == 0 ) {
            head = tail = obj;
        } else {
            tail = tail.next = obj;
        }
        return obj;
    }
}
class ConcreteNexus extends Nexus<ConcreteNexus> {
    private static HeadAndTail<ConcreteNexus> headAndTail = new HeadAndTail<ConcreteNexus>();
    protected HeadAndTail<ConcreteNexus> getHeadAndTail() {
        return headAndTail;
    }
}
