public static List<Method> getMethodsAnnotatedWith ( final Class<?> type, final Class<? extends Annotation> annotation ) {
    final List<Method> methods = new ArrayList<Method>();
    Class<?> klass = type;
    while ( klass != Object.class ) {
        final List<Method> allMethods = new ArrayList<Method> ( Arrays.asList ( klass.getDeclaredMethods() ) );
        for ( final Method method : allMethods ) {
            if ( annotation == null || method.isAnnotationPresent ( annotation ) ) {
                Annotation annotInstance = method.getAnnotation ( annotation );
                methods.add ( method );
            }
        }
        klass = klass.getSuperclass();
    }
    return methods;
}
