public static List<Method> getMethodsAnnotatedWithMethodXY ( final Class<?> type ) {
    final List<Method> methods = new ArrayList<Method>();
    Class<?> klass = type;
    while ( klass != Object.class ) {
        final List<Method> allMethods = new ArrayList<Method> ( Arrays.asList ( klass.getDeclaredMethods() ) );
        for ( final Method method : allMethods ) {
            if ( method.isAnnotationPresent ( MethodXY.class ) ) {
                MethodXY annotInstance = method.getAnnotation ( MethodXY.class );
                if ( annotInstance.x() == 3 && annotInstance.y() == 2 ) {
                    methods.add ( method );
                }
            }
        }
        klass = klass.getSuperclass();
    }
    return methods;
}
