public class Foo extends View implements AnimationListener, OnCompletionListener {
    private MyAnimation mAnim;
    private MyMediaPlayer mMediaPlayer;
    private boolean mIsOneActivityFinished = false;
    synchronized private void onActivityFinished() {
        if ( !mIsOneActivityFinished ) {
            mIsOneActivityFinished = true;
            return;
        }
    }
    public void start() {
        mAnim = new MyAnimation();
        mAnim.setAnimationListener ( this );
        startAnimation ( mAnim );
        mMediaPlayer = MyMediaPlayer();
        mMediaPlayer.setOnCompletionListener ( this );
        mMediaPlayer.start();
    }
    @Override
    public void onAnimationEnd ( Animation animation ) {
        onActivityFinished();
    }
    @Override
    public void onCompletion ( MediaPlayer mp ) {
        onActivityFinished();
    }
}
