private void printStackTraceAsCause ( PrintStream s,
                                      StackTraceElement[] causedTrace ) {
    StackTraceElement[] trace = getOurStackTrace();
    int m = trace.length - 1, n = causedTrace.length - 1;
    while ( m >= 0 && n >= 0 && trace[m].equals ( causedTrace[n] ) ) {
        m--;
        n--;
    }
    int framesInCommon = trace.length - 1 - m;
    s.println ( "Caused by: " + this );
    for ( int i = 0; i <= m; i++ ) {
        s.println ( "\tat " + trace[i] );
    }
    if ( framesInCommon != 0 ) {
        s.println ( "\t... " + framesInCommon + " more" );
    }
    Throwable ourCause = getCause();
    if ( ourCause != null ) {
        ourCause.printStackTraceAsCause ( s, trace );
    }
}
