public class Demo extends Application {
    private static JFXPanel javafxPanel;
    public static void main ( String[] args ) {
        SwingUtilities.invokeLater ( new Runnable() {
            @Override
            public void run() {
                initAndShowGUI();
            }
        } );
    }
    public static void initAndShowGUI() {
        JFrame frame = new JFrame ( "Swing application" );
        frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
        javafxPanel = new JFXPanel();
        frame.getContentPane().add ( javafxPanel, BorderLayout.CENTER );
        Application.launch ( Demo.class, null );
        frame.pack();
        frame.setVisible ( true );
    }
    @Override
    public void start ( Stage mainStage ) {
        javafxPanel.setScene ( createScene() );
    }
    private static Scene createScene() {
        Text text = new Text ( "Hello World" );
        text.setFont ( new Font ( 24 ) );
        text.setEffect ( new Reflection() );
        BorderPane pane = new BorderPane();
        pane.setCenter ( text );
        Scene scene = new Scene ( pane );
        return scene;
    }
}
