import java.io.*;
import java.net.*;
import java.util.*;
import java.util.concurrent.*;
public class SerializeOverSocket {
    private static ExecutorService executorService =
        Executors.newSingleThreadExecutor();
    public static void main ( String[] args ) throws Exception {
        executorService.submit ( new Server() );
        Thread.sleep ( 100 );
        ArrayList<Integer> integers =
            new ArrayList<Integer> ( Arrays.asList ( 1, 2, 3, 4, 5 ) );
        Socket s = new Socket();
        s.connect ( new InetSocketAddress ( "localhost", 1234 ) );
        ObjectOutputStream out = new ObjectOutputStream ( s.getOutputStream() );
        out.writeObject ( integers );
        s.close();
    }
    static class Server implements Runnable {
        public void run() {
            try {
                ServerSocket server = new ServerSocket ( 1234 );
                Socket clientSocket = server.accept();
                ObjectInputStream in =
                    new ObjectInputStream ( clientSocket.getInputStream() );
                Object o = in.readObject();
                System.out.println ( "Received this object on the server: " + o );
                clientSocket.close();
                server.close();
                executorService.shutdown();
            } catch ( IOException e ) {
                throw new UnsupportedOperationException ( "Not written" );
            } catch ( ClassNotFoundException e ) {
                throw new UnsupportedOperationException ( "Not written" );
            }
        }
    }
}
