static public Type getType ( final Class<?> klass, final int pos ) {
    final Type superclass = klass.getGenericSuperclass();
    if ( ! ( superclass instanceof Class ) ) {
        throw new RuntimeException ( "This instance should belong to an anonymous class" );
    }
    final Type[] types = ( ( ParameterizedType ) superclass ).getActualTypeArguments();
    if ( pos < types.length ) {
        throw RuntimeException ( String.format ( "Could not find generic parameter #%d because only %d parameters were passed", pos, types.length ) );
    }
    return types[pos];
}
