public class MyJFileChooser extends JFileChooser {
    private static final int COLUMN_FILENAME = 0;
    private static final int COLUMN_FILESIZE = 1;
    private static final int COLUMN_FILETYPE = 2;
    private static final int COLUMN_FILEDATE = 3;
    private static final int COLUMN_FILEATTR = 4;
    private static final int COLUMN_COLCOUNT = 5;
    private static String[] COLUMNS = null;
    Vector detailsBtn = new Vector();
    UI ui;
    static JTable tbl;
    public void customizeFileChooser ( Component[] comp ) {
        int cnt = 1;
        for ( int x = 0; x < comp.length; x++ ) {
            if ( comp[x] instanceof JPanel ) {
                customizeFileChooser ( ( ( JPanel ) comp[x] ).getComponents() );
                Component[] c = ( ( JPanel ) comp[x] ).getComponents();
                for ( int i = 0; i < c.length; i++ ) {
                    if ( c[i] instanceof JTextField ) {
                        ( ( JTextField ) c[i] ).setVisible ( false );
                    }
                    if ( c[i] instanceof JToggleButton ) {
                        detailsBtn.add ( ( JToggleButton ) c[i] );
                        ( ( JToggleButton ) c[i] ).doClick();
                    }
                    if ( c[i] instanceof JLabel ) {
                        JLabel lbl = ( JLabel ) c[i];
                        if ( x == 0 && i == 0 ) {
                            lbl.setVisible ( false );
                        } else if ( x == 2 && i == 0 ) {
                            lbl.setVisible ( false );
                        } else if ( x == 0 && i == 1 ) {
                            lbl.setVisible ( false );
                        }
                    }
                    if ( c[i] instanceof JComboBox ) {
                        JComboBox b = ( JComboBox ) c[i];
                        if ( x == 0 && i == 1 ) {
                            b.setVisible ( false );
                        }
                        if ( x == 2 && i == 1 ) {
                            b.setVisible ( false );
                        }
                        if ( x == 2 && i == 3 ) {
                            b.setVisible ( false );
                        }
                    }
                }
            }
        }
    }
    public MyJFileChooser() {
        if ( COLUMNS == null ) {
            Locale l = getLocale();
            COLUMNS = new String[] {
                UIManager.getString ( "FileChooser.fileNameHeaderText", l ),
                UIManager.getString ( "FileChooser.fileSizeHeaderText", l ),
                UIManager.getString ( "FileChooser.fileTypeHeaderText", l ),
                UIManager.getString ( "FileChooser.fileDateHeaderText", l ),
                UIManager.getString ( "FileChooser.fileAttrHeaderText", l )
            };
        }
    }
    public void show() {
        MyJFileChooser fc = new MyJFileChooser();
        fc.showOpenDialog ( MyJFileChooser.this );
    }
    public final void setUI ( ComponentUI comp ) {
        super.setUI ( ui = new UI ( this ) );
    }
    private final static class UI extends MetalFileChooserUI {
        private DirectoryModel model;
        public UI ( JFileChooser e ) {
            super ( e );
        }
        protected final void createModel() {
            model = new DirectoryModel ( getFileChooser() );
        }
        public final BasicDirectoryModel getModel() {
            return model;
        }
        protected final JPanel createDetailsView ( JFileChooser chooser ) {
            final JPanel panel = super.createDetailsView ( chooser );
            tbl = findJTable ( panel.getComponents() );
            if ( tbl != null ) {
                tbl.getTableHeader().setReorderingAllowed ( false );
                tbl.getTableHeader().addMouseListener ( new MouseAdapter() {
                    public void mouseClicked ( MouseEvent e ) {
                        if ( e.getClickCount() > 1 ) {
                            return;
                        }
                        e.consume();
                        final int col = tbl.getTableHeader().columnAtPoint ( e.getPoint() );
                        if ( col == COLUMN_FILENAME || col == COLUMN_FILESIZE
                                || col == COLUMN_FILEDATE ) {
                            model.sort ( col, tbl );
                        }
                    }
                } );
            }
            return panel;
        }
        private final static JTable findJTable ( Component[] comp ) {
            for ( int i = 0; i < comp.length; i++ ) {
                if ( comp[i] instanceof JTable ) {
                    return ( JTable ) comp[i];
                }
                if ( comp[i] instanceof Container ) {
                    JTable tbl = findJTable ( ( ( Container ) comp[i] ).getComponents() );
                    if ( tbl != null ) {
                        return tbl;
                    }
                }
            }
            return null;
        }
    }
    private final static class DirectoryModel extends BasicDirectoryModel {
        int col = 0;
        boolean ascending;
        DirectoryModel ( JFileChooser chooser ) {
            super ( chooser );
        }
        protected final boolean lt ( File a, File b ) {
            System.out.println ( "LT called?" );
            boolean less = false;
            switch ( col ) {
            case COLUMN_FILEDATE:
                less = a.lastModified() > b.lastModified();
                break;
            case COLUMN_FILESIZE:
                less = a.length() > b.length();
                break;
            default:
                less = a.getName().compareToIgnoreCase ( b.getName() ) > 0;
                break;
            }
            if ( ascending ) {
                return less = !less;
            }
            return less;
        }
        protected final void sort ( int c, JTable tbl ) {
            col = c;
            ascending = !ascending;
            String indicator = " (^)";
            if ( ascending ) {
                indicator = " (v)";
            }
            final JTableHeader th = tbl.getTableHeader();
            final TableColumnModel tcm = th.getColumnModel();
            for ( int i = 0; i < MyJFileChooser.COLUMN_COLCOUNT - 1; i++ ) {
                final TableColumn tc = tcm.getColumn ( i );
                tc.setHeaderValue ( COLUMNS[i] );
            }
            final TableColumn tc = tcm.getColumn ( col );
            tc.setHeaderValue ( COLUMNS[col] + indicator );
            th.repaint();
            validateFileCache();
        }
        protected final void sort ( Vector data ) {
            switch ( col ) {
            case COLUMN_FILEDATE:
                Collections.sort ( data, new Comparator() {
                    public int compare ( Object o1, Object o2 ) {
                        int ret = 1;
                        final File a = ( File ) o1;
                        final File b = ( File ) o2;
                        if ( a.lastModified() > b.lastModified() ) {
                            ret = -1;
                        } else if ( a.lastModified() == b.lastModified() ) {
                            ret = 0;
                        }
                        if ( ascending ) {
                            ret *= -1;
                        }
                        return ret;
                    }
                } );
                break;
            case COLUMN_FILESIZE:
                Collections.sort ( data, new Comparator() {
                    public int compare ( Object o1, Object o2 ) {
                        int ret = 1;
                        final File a = ( File ) o1;
                        final File b = ( File ) o2;
                        if ( a.length() > b.length() ) {
                            ret = -1;
                        } else if ( a.length() == b.length() ) {
                            ret = 0;
                        }
                        if ( ascending ) {
                            ret *= -1;
                        }
                        return ret;
                    }
                } );
                break;
            case COLUMN_FILENAME:
                Collections.sort ( data, new Comparator() {
                    public int compare ( Object o1, Object o2 ) {
                        final File a = ( File ) o1;
                        final File b = ( File ) o2;
                        if ( ascending ) {
                            return a.getName().compareToIgnoreCase ( b.getName() );
                        } else {
                            return -1 * a.getName().compareToIgnoreCase ( b.getName() );
                        }
                    }
                } );
                break;
            }
        }
    }
}
