class TabbedPaneFocus extends JTabbedPane implements ChangeListener, PropertyChangeListener {
    private Hashtable tabFocus;
    public TabbedPaneFocus() {
        tabFocus = new Hashtable();
        addChangeListener ( this );
        KeyboardFocusManager.getCurrentKeyboardFocusManager().addPropertyChangeListener ( this );
    }
    @Override
    public void propertyChange ( PropertyChangeEvent e ) {
        if ( "permanentFocusOwner".equals ( e.getPropertyName() ) ) {
            final Object value = e.getNewValue();
            if ( value != null ) {
                tabFocus.put ( getTitleAt ( getSelectedIndex() ), value );
            }
        }
    }
    @Override
    public void stateChanged ( ChangeEvent e ) {
        Object value = tabFocus.get ( getTitleAt ( getSelectedIndex() ) );
        if ( value != null ) {
            ( ( Component ) value ).requestFocusInWindow();
        }
    }
}
