package so_6936111;
import java.util.concurrent.Exchanger;
public class WorkflowDemo {
    public static void main ( String[] args ) {
        Pipeline pipeline = new Pipeline();
        pipeline.start();
    }
    public static class Pipeline {
        Exchanger<Message> exchanger = new Exchanger<Message>();
        Message msg_1 = new Message();
        Message msg_2 = new Message();
        void start() {
            new Thread ( new WorkerR() ).start();
            new Thread ( new WorkerL() ).start();
        }
        public static class Message {
            private Object content;
            public Object getContent() {
                return content;
            }
            public void setContent ( Object c ) {
                this.content = c;
            }
        }
        class WorkerR implements Runnable {
            public void run() {
                Message message = msg_1;
                try {
                    while ( true ) {
                        Object data = doSomeWork();
                        message.setContent ( data );
                        message = exchanger.exchange ( message );
                    }
                } catch ( InterruptedException ex ) {
                    ex.printStackTrace();
                }
            }
            private Object doSomeWork() {
                return String.format ( "STEP-1@t:%d", System.nanoTime() );
            }
        }
        class WorkerL implements Runnable {
            public void run() {
                Message message = msg_2;
                try {
                    while ( true ) {
                        message = exchanger.exchange ( message );
                        Object data = doPostProcessing ( message.getContent() );
                        System.out.format ( "%s\n", data );
                    }
                } catch ( InterruptedException ex ) {
                    ex.printStackTrace();
                }
            }
            private Object doPostProcessing ( Object data ) {
                return String.format ( "%s | STEP-2@t:%d", data, System.nanoTime() );
            }
        }
    }
}
