import java.io.IOException;
import java.io.Writer;
import java.util.*;
import org.jdom.Attribute;
import org.jdom.Element;
import org.jdom.output.XMLOutputter;
public class OneAttributePerLineOutputter extends XMLOutputter {
    String namespace = null;
    private int nbInlineAttribs;
    public OneAttributePerLineOutputter (
        String namespace,
        int nbInlineAttribs ) {
        this.namespace = namespace;
        this.nbInlineAttribs = nbInlineAttribs;
    }
    static private int elementDepth ( Element element ) {
        int result = 0;
        while ( element != null ) {
            result++;
            element = element.getParentElement();
        }
        return result;
    }
    @Override protected void printAttributes (
        Writer writer,
        List attribs,
        Element parent,
        NamespaceStack ns ) throws IOException {
        for ( Object attribObj : attribs ) {
            Attribute attrib = ( Attribute ) attribObj;
            if ( ( this.namespace == null ) ||
                    ( this.namespace.equals ( attrib.getNamespaceURI() ) ) ) {
                if ( attribs.size() > this.nbInlineAttribs ) {
                    writer.append ( "\n" );
                    for ( int i = 0; i < elementDepth ( parent ); i++ ) {
                        writer.append ( this.getFormat().getIndent() );
                    }
                }
            }
            List list = new ArrayList<Object>();
            list.add ( attrib );
            super.printAttributes ( writer, list, parent, ns );
        }
    }
}
