import java.awt.Window;
import java.awt.Dialog.ModalityType;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.*;
public class WindowCommunication {
    private static void createAndShowUI() {
        JFrame frame = new JFrame ( "WindowCommunication" );
        frame.getContentPane().add ( new MyFramePanel() );
        frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
        frame.pack();
        frame.setLocationRelativeTo ( null );
        frame.setVisible ( true );
    }
    public static void main ( String[] args ) {
        java.awt.EventQueue.invokeLater ( new Runnable() {
            public void run() {
                createAndShowUI();
            }
        } );
    }
}
class MyFramePanel extends JPanel {
    private JTextField field = new JTextField ( 10 );
    private JButton openDialogeBtn = new JButton ( "Open Dialog" );
    private MyDialogPanel dialogPanel = new MyDialogPanel();
    private JDialog dialog;
    public MyFramePanel() {
        openDialogeBtn.addActionListener ( new ActionListener() {
            public void actionPerformed ( ActionEvent e ) {
                openTableAction();
            }
        } );
        field.setEditable ( false );
        field.setFocusable ( false );
        add ( field );
        add ( openDialogeBtn );
    }
    private void openTableAction() {
        if ( dialog == null ) {
            Window win = SwingUtilities.getWindowAncestor ( this );
            if ( win != null ) {
                dialog = new JDialog ( win, "My Dialog",
                                       ModalityType.APPLICATION_MODAL );
                dialog.getContentPane().add ( dialogPanel );
                dialog.pack();
                dialog.setLocationRelativeTo ( null );
            }
        }
        dialog.setVisible ( true );
        field.setText ( dialogPanel.getFieldText() );
    }
}
class MyDialogPanel extends JPanel {
    private JTextField field = new JTextField ( 10 );
    private JButton okButton = new JButton ( "OK" );
    public MyDialogPanel() {
        okButton.addActionListener ( new ActionListener() {
            public void actionPerformed ( ActionEvent e ) {
                okButtonAction();
            }
        } );
        add ( field );
        add ( okButton );
    }
    public String getFieldText() {
        return field.getText();
    }
    private void okButtonAction() {
        Window win = SwingUtilities.getWindowAncestor ( this );
        if ( win != null ) {
            win.dispose();
        }
    }
}
