package net.pms.plugin.webservice;
import javax.xml.ws.Endpoint;
import org.apache.log4j.Logger;
public abstract class ServiceBase {
    private static final Logger log = Logger.getLogger ( ServiceBase.class );
    protected boolean isInitialized;
    private Endpoint endpoint = null;
    public void bind ( String host, int port, String path ) {
        String endpointURL = "http://" + host + ":" + port + "/" + path;
        try {
            endpoint = Endpoint.publish ( endpointURL, this );
            isInitialized = true;
            log.info ( "Sucessfully bound enpoint: " + endpointURL );
        } catch ( Exception e ) {
            log.error ( "Failed to bind enpoint: " + endpointURL, e );
        }
    }
    public void shutdown() {
        log.info ( "Shut down " + getClass().getName() );
        if ( endpoint != null ) {
            endpoint.stop();
        }
        endpoint = null;
    }
}
