public class CrossSubdomainSessionValve extends ValveBase {
    public CrossSubdomainSessionValve() {
        super();
        info = "common-tomcat-CrossSubdomainSessionValve";
    }
    @Override
    public void invoke ( Request request, Response response ) throws IOException, ServletException {
        if ( request.getSession ( true ).isNew() ) {
            Cookie sessionCookie = findSessionCookie ( response.getCookies() );
            if ( sessionCookie != null ) {
                String cookieDomainToSet = getCookieDomainToSet ( request.getServerName() );
                if ( cookieDomainToSet != null ) {
                    replaceCookie ( response.getCoyoteResponse().getMimeHeaders(), sessionCookie, cookieDomainToSet );
                }
            }
        }
        getNext().invoke ( request, response );
    }
    protected Cookie findSessionCookie ( Cookie[] cookies ) {
        if ( cookies != null )
            for ( Cookie cookie : cookies )
                if ( Globals.SESSION_COOKIE_NAME.equals ( cookie.getName() ) ) {
                    return cookie;
                    return null;
                }
        protected void replaceCookie ( MimeHeaders headers, Cookie originalCookie, String domainToSet ) {
            for ( int i = 0, size = headers.size(); i < size; i++ ) {
                if ( headers.getName ( i ).equals ( "Set-Cookie" ) ) {
                    MessageBytes value = headers.getValue ( i );
                    if ( value.indexOf ( originalCookie.getName() ) >= 0 ) {
                        if ( originalCookie.getDomain() == null ) {
                            StringBuilder builder = new StringBuilder ( value.getString() ).append ( "; Domain=" ).append ( domainToSet );
                            value.setString ( builder.toString() );
                        } else {
                            String newDomain = value.getString().replaceAll ( "Domain=[A-Za-z0-9.-]*", "Domain=" + domainToSet );
                            value.setString ( newDomain );
                        }
                    }
                }
            }
        }
        protected String getCookieDomainToSet ( String cookieDomain ) {
            String[] parts = cookieDomain.split ( "\\." );
            if ( parts.length >= 3 ) {
                return "." + parts[parts.length - 2] + "." + parts[parts.length - 1];
            }
            return null;
        }
        public String toString() {
            return ( "CrossSubdomainSessionValve[container=" + container.getName() + ']' );
        }
    }
