package ch.beo.streaming.swing;
import java.awt.Component;
import java.io.IOException;
import javax.media.Time;
import javax.media.protocol.PullBufferDataSource;
import javax.media.protocol.PullBufferStream;
import ch.beo.streaming.base.ControlHelper;
public class ComponentDataSource extends PullBufferDataSource {
    private final PullBufferStream[] streams;
    public ComponentDataSource ( Component component ) {
        streams = new PullBufferStream[] { new ComponentBufferStream ( component ) };
    }
    @Override
    public void connect() throws IOException {
    }
    @Override
    public void disconnect() {
    }
    @Override
    public String getContentType() {
        return streams[0].getContentDescriptor().getContentType();
    }
    @Override
    public Object getControl ( String controlType ) {
        return ControlHelper.getControl ( this, controlType );
    }
    @Override
    public Object[] getControls() {
        return ControlHelper.getControls ( this );
    }
    @Override
    public Time getDuration() {
        return Time.TIME_UNKNOWN;
    }
    @Override
    public void start() throws IOException {
    }
    @Override
    public void stop() throws IOException {
    }
    @Override
    public PullBufferStream[] getStreams() {
        return streams;
    }
}
