public static void main ( String arg[] ) {
    Gate.init();
    gate.Corpus corpus = ( Corpus ) Factory.createResource ( "gate.corpora.CorpusImpl" );
    Gate.getCreoleRegister().registerDirectories ( new File ( Gate.getPluginsHome(), ANNIEConstants.PLUGIN_DIR ).toURI().toURL() );
    Gate.getCreoleRegister().registerDirectories ( new URL ( "file:///GATE_HOME/plugins/Tagger_Numbers" ) );
    Document doc = new DocumentImpl();
    String str = "Height is 60 in. Weight is 150 lbs pulse rate 90 Pulse rate 90";
    DocumentContentImpl impl = new DocumentContentImpl ( str );
    doc.setContent ( impl );
    ProcessingResource token = ( ProcessingResource ) Factory.createResource ( "gate.creole.tokeniser.DefaultTokeniser", Factory.newFeatureMap() );
    ProcessingResource sspliter = ( ProcessingResource ) Factory.createResource ( "gate.creole.splitter.SentenceSplitter", Factory.newFeatureMap() );
    ProcessingResource number = ( ProcessingResource ) Factory.createResource ( "gate.creole.numbers.NumbersTagger", Factory.newFeatureMap() );
    corpus.add ( doc );
    SerialAnalyserController pipeline = ( SerialAnalyserController ) Factory.createResource ( "gate.creole.SerialAnalyserController", Factory.newFeatureMap(), Factory.newFeatureMap(), "ANNIE" );
    pipeline.setCorpus ( corpus );
    pipeline.add ( token );
    pipeline.add ( sspliter );
    pipeline.add ( number );
    pipeline.execute();
    AnnotationSetImpl ann = ( AnnotationSetImpl ) doc.getAnnotations();
    Iterator<Annotation>i = ann.get ( vital ).iterator();
    Annotation annotation = i.next();
    long start = annotation.getStartNode().getOffset();
    long end =  annotation.getEndNode().getOffset();
    System.out.println ( doc.toString().substring ( ( int ) start, ( int ) end ) );
}
