public abstract ObservableAnswer implements Answer {
    private Listener[] listeners;
    public ObservableAnswer ( Listener...listeners ) {
        this.listeners = listeners;
    }
    @Override
    public Object answer ( InvocationOnMock invocation ) {
        Object answer = observedAnswer ( invocation );
        for ( Listener listener : listeners ) {
            listener.send ( answer );
        }
        return answer;
    }
    public abstract Object observedAnswer ( InvocationOnMock invocation );
}
