public List readResources ( CmsRequestContext context,
                            CmsResource parent, CmsResourceFilter filter,
                            boolean readTree ) throws CmsException, CmsSecurityException {
    List result = null;
    CmsDbContext dbc = m_dbContextFactory.getDbContext ( context );
    try {
        checkPermissions ( dbc, parent, CmsPermissionSet.ACCESS_READ,
                           true, CmsResourceFilter.ALL );
        result = m_driverManager.readResources ( dbc, parent, filter,
                 readTree );
    } catch ( Exception e ) {
        dbc.report ( null, Messages.get().container (
                         Messages.ERR_READ_RESOURCES_1,
                         context.removeSiteRoot ( parent.getRootPath() ) ), e );
    } finally {
        dbc.clear();
    }
    return result;
}
