@WebFilter ( urlPatterns = {"/app/*"} )
public class AuthenticationFilter implements Filter {
    @Override
    public void doFilter ( ServletRequest req, ServletResponse res, FilterChain chain ) throws IOException, ServletException {
        HttpServletRequest request = ( HttpServletRequest ) req;
        HttpServletResponse response = ( HttpServletResponse ) res;
        HttpSession session = request.getSession ( false );
        UserManager userManager = ( session != null ) ? ( UserManager ) session.getAttribute ( "userManager" ) : null;
        if ( userManager == null || !userManager.isLoggedIn() ) {
            response.sendRedirect ( request.getContextPath() + "/login.xhtml" );
        } else {
            chain.doFilter ( req, res );
        }
    }
}
