public void runNTimes ( Runnable task, int maxRunCount, long period, TimeUnit unit, ScheduledExecutor executor ) {
    new FixedExecutionRunnable ( task, maxRunCount ).runNTimes ( period, unit, exeutor );
}
class FixedExecutionRunnable implements Runnable {
    private final AtomicInteger runCount = new AtomicInteger();
    private final Runnable delegate;
    private volatile ScheduledFuture<?> self;
    private final int maxRunCount;
    public FixedExecutionRunnable ( Runnable delegate, int maxRunCount ) {
        this.delegate = delegate;
        this.maxRunCount = maxRunCount;
    }
    public void run() {
        delegate.run();
        if ( runCount.incrementAndGet() == maxRunCount ) {
            self.cancel ( false );
        }
    }
    public void runNTimes ( ScheduledExecutorService executor, long period, TimeUnit unit ) {
        self = executor.scheduleAtFixedRate ( this, 0, period, unit );
    }
}
