public enum MatrixFactory {
    DIAGONAL_MATRIX {
        @Override
        public MainMatrix create ( Object[] args ) {
            double[] diagonal = ( double[] ) args[0];
            return new DiagonalMatrix ( diagonal );
        }
    },
    FULL_MATRIX() {
        @Override
        public MainMatrix create ( Object[] args ) {
            int rows = ( Integer ) args[0];
            int cols = ( Integer ) args[1];
            return new FullMatrix ( rows, cols );
        }
    };
    public abstract MainMatrix create ( Object[] args );
}
