static class ImageComponent extends JComponent {
    final BufferedImage img;
    public ImageComponent ( URL url ) throws IOException {
        img = ImageIO.read ( url );
        setZoom ( 1 );
    }
    @Override
    protected void paintComponent ( Graphics g ) {
        super.paintComponent ( g );
        Dimension dim = getPreferredSize();
        g.drawImage ( img, 0, 0, dim.width, dim.height, this );
    }
    private void setZoom ( double zoom ) {
        int w = ( int ) ( zoom * img.getWidth() );
        int h = ( int ) ( zoom * img.getHeight() );
        setPreferredSize ( new Dimension ( w, h ) );
        revalidate();
        repaint();
    }
}
