class DominicFile {
    static boolean equalfiles ( File f1, File f2 ) {
        byte[] b1 = getBytesFromFile ( f1 );
        byte[] b2 = getBytesFromFile ( f2 );
        if ( b1.length != b2.length ) {
            return false;
        }
        for ( int i = 0; i < b1.length; i++ ) {
            if ( b1[i] != b2[i] ) {
                return false;
            }
        }
        return true;
    }
    static int firstDiffBetween ( File f1, File f2 ) {
        byte[] b1 = getBytesFromFile ( f1 );
        byte[] b2 = getBytesFromFile ( f2 );
        int shortest = b1.length;
        if ( b2.length < shortest ) {
            shortest = b2.length;
        }
        for ( int i = 0; i < shortest; i++ ) {
            if ( b1[i] != b2[i] ) {
                return i;
            }
        }
        return -1;
    }
    public static byte[] getBytesFromFile ( File file ) throws IOException {
        InputStream is = new FileInputStream ( file );
        long length = file.length();
        if ( length > Integer.MAX_VALUE ) {
        }
        byte[] bytes = new byte[ ( int ) length];
        int offset = 0;
        int numRead = 0;
        while ( offset < bytes.length
                && ( numRead = is.read ( bytes, offset, bytes.length - offset ) ) >= 0 ) {
            offset += numRead;
        }
        if ( offset < bytes.length ) {
            throw new IOException ( "Could not completely read file " + file.getName() );
        }
        is.close();
        return bytes;
    }
}
