package org.superbiz.corn;
import javax.annotation.PostConstruct;
import javax.annotation.Resource;
import javax.ejb.Lock;
import javax.ejb.LockType;
import javax.ejb.ScheduleExpression;
import javax.ejb.Singleton;
import javax.ejb.Startup;
import javax.ejb.Timeout;
import javax.ejb.Timer;
import javax.ejb.TimerConfig;
import javax.ejb.TimerService;
import java.util.concurrent.atomic.AtomicInteger;
@Singleton
@Lock ( LockType.READ )
@Startup
public class FarmerBrown {
    private final AtomicInteger checks = new AtomicInteger();
    @Resource
    private TimerService timerService;
    @PostConstruct
    private void construct() {
        final TimerConfig plantTheCorn = new TimerConfig ( "plantTheCorn", false );
        timerService.createCalendarTimer ( new ScheduleExpression().month ( 5 ).dayOfMonth ( "20-Last" ).minute ( 0 ).hour ( 8 ), plantTheCorn );
        timerService.createCalendarTimer ( new ScheduleExpression().month ( 6 ).dayOfMonth ( "1-10" ).minute ( 0 ).hour ( 8 ), plantTheCorn );
        final TimerConfig harvestTheCorn = new TimerConfig ( "harvestTheCorn", false );
        timerService.createCalendarTimer ( new ScheduleExpression().month ( 9 ).dayOfMonth ( "20-Last" ).minute ( 0 ).hour ( 8 ), harvestTheCorn );
        timerService.createCalendarTimer ( new ScheduleExpression().month ( 10 ).dayOfMonth ( "1-10" ).minute ( 0 ).hour ( 8 ), harvestTheCorn );
        final TimerConfig checkOnTheDaughters = new TimerConfig ( "checkOnTheDaughters", false );
        timerService.createCalendarTimer ( new ScheduleExpression().second ( "*" ).minute ( "*" ).hour ( "*" ), checkOnTheDaughters );
    }
    @Timeout
    public void timeout ( Timer timer ) {
        if ( "plantTheCorn".equals ( timer.getInfo() ) ) {
            plantTheCorn();
        } else if ( "harvestTheCorn".equals ( timer.getInfo() ) ) {
            harvestTheCorn();
        } else if ( "checkOnTheDaughters".equals ( timer.getInfo() ) ) {
            checkOnTheDaughters();
        }
    }
    private void plantTheCorn() {
    }
    private void harvestTheCorn() {
    }
    private void checkOnTheDaughters() {
        checks.incrementAndGet();
    }
    public int getChecks() {
        return checks.get();
    }
}
