import java.awt.*;
import java.awt.event.*;
import java.awt.image.BufferedImage;
import javax.swing.*;
public class MyPanel extends JPanel {
    private GraphicsEnvironment ge;
    private GraphicsDevice gs;
    private GraphicsConfiguration gc;
    private BufferedImage offScreen;
    public MyPanel ( boolean visible ) {
        super();
        this.setLayout ( new BorderLayout ( 640, 416 ) );
        this.setOpaque ( false );
        this.setVisible ( visible );
        ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
        gs = ge.getDefaultScreenDevice();
        gc = gs.getDefaultConfiguration();
        addComponentListener ( new ComponentAdapter() {
            @Override
            public void componentResized ( ComponentEvent e ) {
                setUp();
            }
        } );
    }
    @Override
    protected void paintComponent ( Graphics g ) {
        super.paintComponent ( g );
        if ( offScreen != null ) {
            g.drawImage ( offScreen, 0, 0, null );
        }
    }
    private void setUp() {
        offScreen = gc.createCompatibleImage ( getSize().width, getSize().height,
                                               Transparency.TRANSLUCENT );
    }
    public void upDateOffScreen() {
        Graphics2D osGraphics = offScreen.createGraphics();
        osGraphics.dispose();
        repaint();
    }
}
