class A {
    public int currentState = 0;
    public def listeners = [];
    public void setCurrentState ( int i ) {
        this.currentState = i;
        listeners.each { it ( i ); }
    }
    public A() {
        this.addListener ( this. & _onStateChanged );
    }
    public void addListener ( def callback ) {
        this.listeners.add ( 0, callback );
    }
    protected void _onStateChanged ( int state ) {
        println "The state in A is $state";
        if ( state == 0 || state == 1 ) {
            def event = new MyEvent ( this );
            event.execute();
        }
    }
}
class B extends A {
    public B() {
        super();
        this.addListener ( this. & _onBStateChanged );
    }
    protected void _onBStateChanged ( int state ) {
        println "The state in B is $state";
        if ( state == 0 ) {
            println "Launch a specific event!";
        }
    }
}
class MyEvent {
    private B b = null;
    public MyEvent ( B b ) {
        this.b = b;
    }
    public void execute() {
        b.currentState++;
    }
}
def b = new B();
b.currentState = 0;
