package mawi12345;
import java.lang.annotation.Annotation;
import java.lang.reflect.Method;
public class ReflectionTest {
    public static void printAnnotations ( Class<?> clazz ) {
        Method[] methods = clazz.getDeclaredMethods();
        System.out.println ( "found " + methods.length + " methods" );
        for ( int i = 0; i < methods.length; i++ ) {
            Annotation[] methodAnnotations = methods[i].getAnnotations();
            for ( Annotation methodAnnotation : methodAnnotations ) {
                System.out.println ( methodAnnotation );
            }
            Annotation[][] parameterAnnotations = methods[i].getParameterAnnotations();
            Class<?>[] parameters = methods[i].getParameterTypes();
            for ( int x = 0; x < parameterAnnotations.length; x++ ) {
                Class<?> parameter = parameters[x];
                for ( Annotation annotation : parameterAnnotations[x] ) {
                    System.out.println ( parameter.getName() + " " + annotation );
                }
            }
        }
    }
    public static void main ( String[] args ) {
        Test test = new Test();
        Class<?> clazz = test.getClass();
        System.out.println ( "Class Test" );
        printAnnotations ( clazz );
        System.out.println();
        Class<?>[] interfaces = clazz.getInterfaces();
        System.out.println ( "found " + interfaces.length + " interfaces" );
        for ( Class<?> type : interfaces ) {
            System.out.println ( type );
            printAnnotations ( type );
        }
    }
}
