package com.example;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Matrix;
import android.graphics.Point;
import android.location.Location;
import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapView;
import com.google.android.maps.MyLocationOverlay;
public class MyCustomLocationOverlay extends MyLocationOverlay {
    private Context mContext;
    private float   mOrientation;
    public MyCustomLocationOverlay ( Context context, MapView mapView ) {
        super ( context, mapView );
        mContext = context;
    }
    @Override
    protected void drawMyLocation ( Canvas canvas, MapView mapView, Location lastFix, GeoPoint myLocation, long when ) {
        Point screenPts = mapView.getProjection().toPixels ( myLocation, null );
        Bitmap arrowBitmap = BitmapFactory.decodeResource ( mContext.getResources(), R.drawable.arrow_green );
        Matrix matrix = new Matrix();
        matrix.postRotate ( mOrientation );
        Bitmap rotatedBmp = Bitmap.createBitmap (
                                arrowBitmap,
                                0, 0,
                                arrowBitmap.getWidth(),
                                arrowBitmap.getHeight(),
                                matrix,
                                true
                            );
        canvas.drawBitmap (
            rotatedBmp,
            screenPts.x - ( rotatedBmp.getWidth()  / 2 ),
            screenPts.y - ( rotatedBmp.getHeight() / 2 ),
            null
        );
    }
    public void setOrientation ( float newOrientation ) {
        mOrientation = newOrientation;
    }
}
