import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;
import java.util.zip.ZipOutputStream;
public class JarUpdater {
    public static void main ( String[] args ) {
        File[] contents = {new File ( "F:\\ResourceTest.txt" ),
                 new File ( "F:\\ResourceTest2.bmp" )
        };
        File jarFile = new File ( "F:\\RepackMe.jar" );
        try {
            updateZipFile ( jarFile, contents );
        } catch ( IOException e ) {
            e.printStackTrace();
        }
    }
    public static void updateZipFile ( File zipFile,
                                       File[] files ) throws IOException {
        File tempFile = File.createTempFile ( zipFile.getName(), null );
        tempFile.delete();
        boolean renameOk = zipFile.renameTo ( tempFile );
        if ( !renameOk ) {
            throw new RuntimeException ( "could not rename the file " + zipFile.getAbsolutePath() + " to " + tempFile.getAbsolutePath() );
        }
        byte[] buf = new byte[1024];
        ZipInputStream zin = new ZipInputStream ( new FileInputStream ( tempFile ) );
        ZipOutputStream out = new ZipOutputStream ( new FileOutputStream ( zipFile ) );
        ZipEntry entry = zin.getNextEntry();
        while ( entry != null ) {
            String name = entry.getName();
            boolean notInFiles = true;
            for ( File f : files ) {
                if ( f.getName().equals ( name ) ) {
                    notInFiles = false;
                    break;
                }
            }
            if ( notInFiles ) {
                out.putNextEntry ( new ZipEntry ( name ) );
                int len;
                while ( ( len = zin.read ( buf ) ) > 0 ) {
                    out.write ( buf, 0, len );
                }
            }
            entry = zin.getNextEntry();
        }
        zin.close();
        for ( int i = 0; i < files.length; i++ ) {
            InputStream in = new FileInputStream ( files[i] );
            out.putNextEntry ( new ZipEntry ( files[i].getName() ) );
            int len;
            while ( ( len = in.read ( buf ) ) > 0 ) {
                out.write ( buf, 0, len );
            }
            out.closeEntry();
            in.close();
        }
        out.close();
        tempFile.delete();
    }
}
