public class Testing {
    private Timer timer;
    public void myFunction() {
        long countDownTimeSEC = 60;
        long countDownTimeMS = 1000 * countDownTimeSEC;
        JLabel label = m_GameApplet.GetJpanelStartNetGame().GetJlabelSeconds();
        label.setFont ( new java.awt.Font ( "Lucida Handwriting", 1, 36 ) );
        label.setForeground ( Color.red );
        label.setText ( Long.toString ( countDownTimeSEC ) );
        JButton button = m_GameApplet.GetJpanelStartNetGame().GetJbuttonFinish();
        ArrayList<AbstractAction> actsWhenComplete = new ArrayList<AbstractAction>();
        CountDownClockAction cdca = new CountDownClockAction ( label, countDownTimeMS, actsWhenComplete );
        this.timer  = new Timer ( 1000, cdca );
        actsWhenComplete.add ( new CountDownFinishAction ( label, button, this.timer ) );
        this.timer.start();
    }
    public static class CountDownClockAction extends AbstractAction {
        private static final long serialVersionUID = 1L;
        private final JLabel labelToUpdate;
        private final long startMS;
        private long currentMS;
        private long timeMark;
        private final ArrayList<AbstractAction> actionsToExeWhenComplete;
        private boolean actionsExedFlag;
        public CountDownClockAction (
            final JLabel labelToUpdate,
            final long startMS,
            ArrayList<AbstractAction> actionsToExeWhenComplete
        ) {
            super();
            this.labelToUpdate = labelToUpdate;
            this.startMS = startMS;
            this.currentMS = startMS;
            this.timeMark = 0;
            this.actionsExedFlag = false;
            this.actionsToExeWhenComplete = actionsToExeWhenComplete;
        }
        @Override
        public void actionPerformed ( final ActionEvent e ) {
            if ( this.timeMark == 0 ) {
                this.timeMark = System.currentTimeMillis();
            }
            long timeDelta = System.currentTimeMillis() - this.timeMark;
            if ( this.labelToUpdate != null ) {
                labelToUpdate.setText ( Long.toString ( ( long ) ( currentMS / 1000 ) ) );
            }
            if ( currentMS > 0 ) {
                currentMS -= timeDelta;
            } else if ( currentMS <= 0 && this.actionsExedFlag == false ) {
                this.actionsExedFlag = true;
                if ( this.actionsToExeWhenComplete != null )
                    for ( AbstractAction aa : this.actionsToExeWhenComplete ) {
                        aa.actionPerformed ( e );
                    }
            }
            this.timeMark = System.currentTimeMillis();
        }
    }
    public static class CountDownFinishAction extends AbstractAction {
        private final JLabel labelToUpdate;
        private final JButton buttonToUpdate;
        private final Timer timerToStop;
        public CountDownFinishAction (
            JLabel labelToUpdate,
            JButton buttonToUpdate,
            Timer timerToStop
        ) {
            super();
            this.labelToUpdate = labelToUpdate;
            this.buttonToUpdate = buttonToUpdate;
            this.timerToStop = timerToStop;
        }
        @Override
        public void actionPerformed ( final ActionEvent e ) {
            if ( this.labelToUpdate != null ) {
                this.labelToUpdate.setText ( "0" );
            }
            if ( this.buttonToUpdate != null ) {
                this.buttonToUpdate.setVisible ( false );
            }
            if ( this.timerToStop != null ) {
                this.timerToStop.stop();
            }
        }
    }
}
