private AudioManager theAudioManager;
private Object myOnAudioFocusChangeListener = null;
private static final int AUDIOMANAGER_AUDIOFOCUS_GAIN = 1;
private static final int AUDIOMANAGER_AUDIOFOCUS_LOSS = -1;
theAudioManager = ( AudioManager ) context.getSystemService ( Context.AUDIO_SERVICE );
public void setOnAudioFocusChangeListener() {
    Log.i ( this, "setOnAudioFocusChangeListener()" );
    Class<?>[] innerClasses = theAudioManager.getClass().getDeclaredClasses();
    for ( Class<?> interfaze : innerClasses ) {
        if ( interfaze.getSimpleName().equalsIgnoreCase ( "OnAudioFocusChangeListener" ) ) {
            Class<?>[] classArray = new Class<?>[1];
            classArray[0] = interfaze;
            myOnAudioFocusChangeListener = Proxy.newProxyInstance ( interfaze.getClassLoader(), classArray, new ProxyOnAudioFocusChangeListener() );
        }
    }
}
public void getAudioFocus() {
    if ( myOnAudioFocusChangeListener != null ) {
        Log.i ( this, "getAudioFocus()" );
        try {
            Method[] methods = theAudioManager.getClass().getDeclaredMethods();
            for ( Method method : methods ) {
                if ( method.getName().equalsIgnoreCase ( "requestAudioFocus" ) ) {
                    method.invoke ( theAudioManager, myOnAudioFocusChangeListener, AudioManager.STREAM_MUSIC, AUDIOMANAGER_AUDIOFOCUS_GAIN );
                    Log.i ( this, "requestAudioFocus" );
                }
            }
        } catch ( Exception e ) {
            Log.e ( this, e.getMessage() );
        }
    }
}
public void releaseAudioFocus() {
    if ( myOnAudioFocusChangeListener != null ) {
        Log.i ( this, "releaseAudioFocus()" );
        try {
            Method[] methods = theAudioManager.getClass().getDeclaredMethods();
            for ( Method method : methods ) {
                if ( method.getName().equalsIgnoreCase ( "abandonAudioFocus" ) ) {
                    method.invoke ( theAudioManager, myOnAudioFocusChangeListener );
                }
            }
        } catch ( Exception e ) {
            Log.e ( this, e.getMessage() );
        }
    }
}
private class ProxyOnAudioFocusChangeListener implements InvocationHandler {
    public void onAudioFocusChange ( int focusChange ) {
        Log.e ( this, "onAudioFocusChange() focusChange = " + focusChange );
        if ( focusChange == AUDIOMANAGER_AUDIOFOCUS_LOSS ) {
            Log.i ( this, "AUDIOMANAGER_AUDIOFOCUS_LOSS" );
            Message msg = mHandler.obtainMessage ( ControllerHandler.SET_ON_PAUSE );
            mHandler.sendMessage ( msg );
        } else if ( focusChange == AUDIOMANAGER_AUDIOFOCUS_GAIN ) {
            Log.i ( this, "AUDIOMANAGER_AUDIOFOCUS_GAIN" );
        }
    }
    public Object invoke ( Object proxy, Method method, Object[] args ) throws Throwable {
        Object result = null;
        try {
            if ( args != null ) {
                if ( method.getName().equals ( "onAudioFocusChange" ) && args[0] instanceof Integer ) {
                    onAudioFocusChange ( ( Integer ) args[0] );
                }
            }
        } catch ( Exception e ) {
            throw new RuntimeException ( "unexpected invocation exception: " + e.getMessage() );
        }
        return result;
    }
}
