package com.example.map;
import java.util.List;
import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapActivity;
import com.google.android.maps.MapController;
import com.google.android.maps.MapView;
import android.app.AlertDialog;
import android.app.Dialog;
import android.location.Address;
import android.location.Geocoder;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
public class mapView extends MapActivity {
    MapView myMap;
    Button btnSearch;
    EditText adress;
    Geocoder gc;
    double lat;
    double lon;
    @Override
    public void onCreate ( Bundle savedInstanceState ) {
        super.onCreate ( savedInstanceState );
        setContentView ( R.layout.main );
        myMap = ( MapView ) findViewById ( R.id.simpleGM_map );
        btnSearch = ( Button ) findViewById ( R.id.simpleGM_btn_search );
        adress = ( EditText ) findViewById ( R.id.simpleGM_adress );
        gc = new Geocoder ( this );
        btnSearch.setOnClickListener ( new OnClickListener() {
            public void onClick ( View v ) {
                String addressInput = adress.getText().toString();
                try {
                    List<Address> foundAdresses = gc.getFromLocationName (
                                                      addressInput, 5 );
                    if ( foundAdresses.size() == 0 ) {
                        Dialog locationError = new AlertDialog.Builder (
                            mapView.this ).setIcon ( 0 ).setTitle (
                            "Error" ).setPositiveButton ( R.string.ok, null )
                        .setMessage (
                            "Sorry, your address doesn't exist." )
                        .create();
                        locationError.show();
                    } else {
                        for ( int i = 0; i < foundAdresses.size(); ++i ) {
                            Address x = foundAdresses.get ( i );
                            lat = x.getLatitude();
                            lon = x.getLongitude();
                        }
                        navigateToLocation ( ( lat * 1000000 ), ( lon * 1000000 ),
                                             myMap );
                    }
                } catch ( Exception e ) {
                }
            }
        } );
    }
    @Override
    protected boolean isRouteDisplayed() {
        return false;
    }
    /
    * Navigates a given MapView to the specified Longitude and Latitude
    * @param latitude
    * @param longitude
    * @param mv
    * /
    public static void navigateToLocation ( double latitude, double longitude,
                                            MapView mv ) {
        GeoPoint p = new GeoPoint ( ( int ) latitude, ( int ) longitude );
        mv.displayZoomControls ( true );
        MapController mc = mv.getController();
        mc.animateTo ( p );
        int zoomlevel = mv.getMaxZoomLevel();
        mc.setZoom ( zoomlevel - 1 );
        mv.setSatellite ( false );
    }
}
