static void exit ( int status ) {
    boolean runMoreFinalizers = false;
    synchronized ( lock ) {
        if ( status != 0 ) {
            runFinalizersOnExit = false;
        }
        switch ( state ) {
        case RUNNING:
            state = HOOKS;
            break;
        case HOOKS:
            break;
        case FINALIZERS:
            if ( status != 0 ) {
                halt ( status );
            } else {
                runMoreFinalizers = runFinalizersOnExit;
            }
            break;
        }
    }
    if ( runMoreFinalizers ) {
        runAllFinalizers();
        halt ( status );
    }
    synchronized ( Shutdown.class ) {
        sequence();
        halt ( status );
    }
}
