public static int[] getIntermediatePoint (
    int startLatMicroDeg,
    int startLonMicroDeg,
    int endLatMicroDeg,
    int endLonMicroDeg,
    double t
) {
    double alatRad = Math.toRadians ( ( double ) startLatMicroDeg / 1000000 );
    double alonRad = Math.toRadians ( ( double ) startLonMicroDeg / 1000000 );
    double blatRad = Math.toRadians ( ( double ) endLatMicroDeg / 1000000 );
    double blonRad = Math.toRadians ( ( double ) endLonMicroDeg / 1000000 );
    double dlon = blonRad - alonRad;
    double alatRadSin = Math.sin ( alatRad );
    double blatRadSin = Math.sin ( blatRad );
    double alatRadCos = Math.cos ( alatRad );
    double blatRadCos = Math.cos ( blatRad );
    double dlonCos = Math.cos ( dlon );
    double distance = Math.acos ( alatRadSin * blatRadSin +
                                  alatRadCos * blatRadCos *
                                  dlonCos );
    double bearing = Math.atan2 (
                         Math.sin ( dlon ) * blatRadCos,
                         alatRadCos * blatRadSin -
                         alatRadSin * blatRadCos * dlonCos );
    double angularDistance = distance * t;
    double angDistSin = Math.sin ( angularDistance );
    double angDistCos = Math.cos ( angularDistance );
    double xlatRad = Math.asin ( alatRadSin * angDistCos +
                                 alatRadCos * angDistSin * Math.cos ( bearing ) );
    double xlonRad = alonRad + Math.atan2 (
                         Math.sin ( bearing ) * angDistSin * alatRadCos,
                         angDistCos - alatRadSin * Math.sin ( xlatRad ) );
    int xlat = ( int ) Math.round ( Math.toDegrees ( xlatRad ) * 1000000 );
    int xlon = ( int ) Math.round ( Math.toDegrees ( xlonRad ) * 1000000 );
    if ( xlat > 90000000 ) {
        xlat = 90000000;
    }
    if ( xlat < -90000000 ) {
        xlat = -90000000;
    }
    while ( xlon > 180000000 ) {
        xlon -= 360000000;
    }
    while ( xlon <= -180000000 ) {
        xlon += 360000000;
    }
    return new int[] {xlat, xlon};
}
