public class ClassExistsPredicate implements Predicate<String> {
    private final HeapDump heapDump;
    public ClassExistsPredicate ( HeapDump heapDump ) {
        this.heapDump = heapDump;
    }
    @Override
    public boolean apply ( String fullyQualifiedClassName ) {
        return true;
    }
}
public enum GuavaVersion {
    R01,
    R02 {
        @Override
        Set<String> getAddedClasses() {
            return ImmutableSet.of ( "com.google.common.base.Foo" );
        }
    },
    R03 {
        @Override
        Set<String> getAddedClasses() {
            return ImmutableSet.of ( "com.google.common.collect.ForwardingFooIterator" );
        }
    },
    R04 {
        @Override
        Set<String> getAddedClasses() {
            return ImmutableSet.of ( "com.google.common.collect.FooFoo2" );
        }
    };
    Set<String> getAddedClasses() {
        return ImmutableSet.of();
    }
    public static GuavaVersion getGuavaVersionFor ( HeapDump heapDump ) {
        ClassExistsPredicate classExists = new ClassExistsPredicate ( heapDump );
        for ( GuavaVersion version : Lists.reverse ( Arrays.asList ( GuavaVersion.values() ) ) ) {
            if ( Iterables.all ( version.getAddedClasses(), classExists ) ) {
                return version;
            }
        }
        throw new RuntimeException ( "Unable to determine Guava version..." );
    }
}
