public void testAsManager() throws Exception {
    Properties p = new Properties();
    p.put ( Context.INITIAL_CONTEXT_FACTORY, "org.apache.openejb.client.LocalInitialContextFactory" );
    p.put ( Context.SECURITY_PRINCIPAL, "jane" );
    p.put ( Context.SECURITY_CREDENTIALS, "waterfall" );
    InitialContext context = new InitialContext ( p );
    try {
        movies.addMovie ( new Movie ( "Quentin Tarantino", "Reservoir Dogs", 1992 ) );
        movies.addMovie ( new Movie ( "Joel Coen", "Fargo", 1996 ) );
        movies.addMovie ( new Movie ( "Joel Coen", "The Big Lebowski", 1998 ) );
        List<Movie> list = movies.getMovies();
        assertEquals ( "List.size()", 3, list.size() );
        for ( Movie movie : list ) {
            movies.deleteMovie ( movie );
        }
        assertEquals ( "Movies.getMovies()", 0, movies.getMovies().size() );
    } finally {
        context.close();
    }
}
