public boolean add ( E e ) {
    if ( offer ( e ) ) {
        return true;
    } else {
        throw new IllegalStateException ( "Queue full" );
    }
}
public boolean offer ( E e ) {
    if ( e == null ) {
        throw new NullPointerException();
    }
    final ReentrantLock lock = this.lock;
    lock.lock();
    try {
        if ( count == items.length ) {
            return false;
        } else {
            insert ( e );
            return true;
        }
    } finally {
        lock.unlock();
    }
}
public void put ( E e ) throws InterruptedException {
    if ( e == null ) {
        throw new NullPointerException();
    }
    final E[] items = this.items;
    final ReentrantLock lock = this.lock;
    lock.lockInterruptibly();
    try {
        try {
            while ( count == items.length ) {
                notFull.await();
            }
        } catch ( InterruptedException ie ) {
            notFull.signal();
            throw ie;
        }
        insert ( e );
    } finally {
        lock.unlock();
    }
}
