private class ProcessResultReader extends Thread {
    final InputStream is;
    final String type;
    final StringBuilder sb;
    ProcessResultReader ( @Nonnull final InputStream is, @Nonnull String type ) {
        this.is = is;
        this.type = type;
        this.sb = new StringBuilder();
    }
    public void run() {
        try {
            final InputStreamReader isr = new InputStreamReader ( is );
            final BufferedReader br = new BufferedReader ( isr );
            String line = null;
            while ( ( line = br.readLine() ) != null ) {
                this.sb.append ( line ).append ( "\n" );
            }
        } catch ( final IOException ioe ) {
            System.err.println ( ioe.getMessage() );
            throw new RuntimeException ( ioe );
        }
    }
    @Override
    public String toString() {
        return this.sb.toString();
    }
}
