package deck.displayer;
import java.net.URL;
import java.util.ArrayList;
import javax.swing.ImageIcon;
public class Test extends javax.swing.JFrame {
    ArrayList<Card> cards = new ArrayList<Card>();
    public Test() {
        try {
            initComponents();
            String suits = "shdc";
            String faces = "a23456789tjqk";
            for ( int suit = 0; suit < suits.length(); suit++ ) {
                for ( int face = 0; face < faces.length(); face++ ) {
                    String imagePath = "cards/" + faces.charAt ( face )
                                       + suits.charAt ( suit ) + ".gif";
                    URL imageURL = this.getClass().getResource ( imagePath );
                    ImageIcon img = new ImageIcon ( imageURL );
                    System.out.println ( "Adding: " + String.valueOf ( faces.charAt ( face ) )
                                         + String.valueOf ( suits.charAt ( suit ) ) );
                    cards.add ( new Card ( String.valueOf ( faces.charAt ( face ) )
                                           + String.valueOf ( suits.charAt ( suit ) ), img ) );
                }
            }
            pageList.setCellRenderer ( new CardCellRenderer() );
            pageList.setModel ( new javax.swing.AbstractListModel() {
                @Override
                public int getSize() {
                    return cards.size();
                }
                @Override
                public Object getElementAt ( int i ) {
                    return cards.get ( i );
                }
            } );
        } catch ( Exception e ) {
            System.exit ( 1 );
        }
    }
    @SuppressWarnings ( "unchecked" )
    private void initComponents() {
        jScrollPane1 = new javax.swing.JScrollPane();
        pageList = new javax.swing.JList();
        setDefaultCloseOperation ( javax.swing.WindowConstants.EXIT_ON_CLOSE );
        pageList.setModel ( new javax.swing.AbstractListModel() {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
            public int getSize() {
                return strings.length;
            }
            public Object getElementAt ( int i ) {
                return strings[i];
            }
        } );
        jScrollPane1.setViewportView ( pageList );
        javax.swing.GroupLayout layout = new javax.swing.GroupLayout ( getContentPane() );
        getContentPane().setLayout ( layout );
        layout.setHorizontalGroup (
            layout.createParallelGroup ( javax.swing.GroupLayout.Alignment.LEADING )
            .addGroup ( layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent ( jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 125, Short.MAX_VALUE )
                        .addContainerGap() )
        );
        layout.setVerticalGroup (
            layout.createParallelGroup ( javax.swing.GroupLayout.Alignment.LEADING )
            .addGroup ( layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent ( jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 278, Short.MAX_VALUE )
                        .addContainerGap() )
        );
        pack();
    }
    public static void main ( String args[] ) {
        try {
            for ( javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels() ) {
                if ( "Nimbus".equals ( info.getName() ) ) {
                    javax.swing.UIManager.setLookAndFeel ( info.getClassName() );
                    break;
                }
            }
        } catch ( ClassNotFoundException ex ) {
            java.util.logging.Logger.getLogger ( Test.class.getName() ).log ( java.util.logging.Level.SEVERE, null, ex );
        } catch ( InstantiationException ex ) {
            java.util.logging.Logger.getLogger ( Test.class.getName() ).log ( java.util.logging.Level.SEVERE, null, ex );
        } catch ( IllegalAccessException ex ) {
            java.util.logging.Logger.getLogger ( Test.class.getName() ).log ( java.util.logging.Level.SEVERE, null, ex );
        } catch ( javax.swing.UnsupportedLookAndFeelException ex ) {
            java.util.logging.Logger.getLogger ( Test.class.getName() ).log ( java.util.logging.Level.SEVERE, null, ex );
        }
        java.awt.EventQueue.invokeLater ( new Runnable() {
            @Override
            public void run() {
                new Test().setVisible ( true );
            }
        } );
    }
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JList pageList;
}
