import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import javax.swing.*;
import java.awt.image.*;
import javax.imageio.ImageIO;
public class Picture {
    JFileChooser fileChooser = new JFileChooser();
    final JFrame frame = new JFrame ( "Edit Image" );
    Container content;
    static BufferedImage image;
    BufferedImage image2;
    JLabel imageLabel;
    public Picture() {
        fileChooser.setDialogTitle ( "Choose an image file to begin:" );
        fileChooser.showOpenDialog ( frame );
        File selectedFile = fileChooser.getSelectedFile();
        if ( fileChooser.getSelectedFile() != null ) {
            try {
                image = ImageIO.read ( selectedFile );
            } catch ( IOException e ) {
                System.out.println ( "Invalid image file: " + selectedFile );
                System.exit ( 0 );
            }
        } else {
            System.out.println ( "No File Selected!" );
        }
    }
    public int width() {
        int width = image.getWidth();
        return width;
    }
    public int height() {
        int height = image.getHeight();
        return height;
    }
    public void saveImage() {
        fileChooser.setDialogTitle ( "Save this image?" );
        fileChooser.showSaveDialog ( frame );
        try {
            ImageIO.write ( this.image, "JPG", fileChooser.getSelectedFile() );
        } catch ( IOException f ) {
            System.out.println ( "Saving failed! Could not save image." );
        }
    }
    public void show() {
        content = frame.getContentPane();
        frame.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
        frame.setResizable ( false );
        ImageIcon icon = new ImageIcon ( image );
        imageLabel = new JLabel ( icon );
        frame.setContentPane ( imageLabel );
        JMenuBar menuBar = new JMenuBar();
        frame.setJMenuBar ( menuBar );
        JMenu progName = new JMenu ( "Edit Image" );
        progName.setBackground ( Color.RED );
        menuBar.add ( progName );
        JMenu fileMenu = new JMenu ( "File" );
        menuBar.add ( fileMenu );
        JMenu editMenu = new JMenu ( "Edit" );
        menuBar.add ( editMenu );
        ImageIcon exitIcon = new ImageIcon ( "app-exit.png" );
        JMenuItem exitAction = new JMenuItem ( "Exit", exitIcon );
        progName.add ( exitAction );
        exitAction.addActionListener ( new ActionListener() {
            public void actionPerformed ( ActionEvent e ) {
                ImageIcon saveIcon = new ImageIcon ( "save-icon.png" );
                int askSave = JOptionPane.showConfirmDialog ( null, "Save current image?", "", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE, saveIcon );
                if ( askSave == JOptionPane.YES_OPTION ) {
                    saveImage();
                    System.exit ( 0 );
                } else {
                    System.exit ( 0 );
                }
            }
        } );
        ImageIcon newIcon = new ImageIcon ( "new-image.png" );
        JMenuItem newAction = new JMenuItem ( "Open Image", newIcon );
        fileMenu.add ( newAction );
        newAction.addActionListener ( new ActionListener() {
            public void actionPerformed ( ActionEvent e ) {
                ImageIcon saveIcon = new ImageIcon ( "save-icon.png" );
                int askSave = JOptionPane.showConfirmDialog ( null, "Save current image?", "", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE, saveIcon );
                if ( askSave == JOptionPane.YES_OPTION ) {
                    saveImage();
                    Picture p = new Picture();
                    imageLabel.setIcon ( new ImageIcon ( image ) );
                    frame.setSize ( width(), height() );
                } else {
                    Picture p = new Picture();
                    imageLabel.setIcon ( new ImageIcon ( image ) );
                    frame.setSize ( width(), height() );
                }
            }
        } );
        ImageIcon saveIcon = new ImageIcon ( "save-image.png" );
        JMenuItem saveAction = new JMenuItem ( "Save Image As...", saveIcon );
        fileMenu.add ( saveAction );
        saveAction.addActionListener ( new ActionListener() {
            public void actionPerformed ( ActionEvent e ) {
                saveImage();
            }
        } );
        ImageIcon gsIcon = new ImageIcon ( "grayscale-image.png" );
        JMenuItem grayScale = new JMenuItem ( "Grayscale", gsIcon );
        editMenu.add ( grayScale );
        grayScale.addActionListener ( new ActionListener() {
            public void actionPerformed ( ActionEvent e ) {
                grayscale ( width(), height() );
            }
        } );
        ImageIcon scaleIcon = new ImageIcon ( "scale-image.png" );
        JMenuItem scaleImg = new JMenuItem ( "Scale Image", scaleIcon );
        editMenu.add ( scaleImg );
        scaleImg.addActionListener ( new ActionListener() {
            public void actionPerformed ( ActionEvent e ) {
                ImageIcon widthIcon = new ImageIcon ( "LR-arrows.png" );
                String scaleWidth = ( String ) JOptionPane.showInputDialog ( null, "What should the new width be?", "", JOptionPane.QUESTION_MESSAGE, widthIcon, null, null );
                ImageIcon heightIcon = new ImageIcon ( "UD-arrows.png" );
                String scaleHeight = ( String ) JOptionPane.showInputDialog ( null, "What should the new height be?", "", JOptionPane.QUESTION_MESSAGE, widthIcon, null, null );
                double x = Double.parseDouble ( scaleWidth );
                double y = Double.parseDouble ( scaleHeight );
                int newWidth = ( int ) x;
                int newHeight = ( int ) y;
                frame.setSize ( newWidth, newHeight );
                scale ( newWidth, newHeight );
            }
        } );
        ImageIcon rotateIcon = new ImageIcon ( "rotate-image.png" );
        JMenuItem rotateImg = new JMenuItem ( "Rotate Image", rotateIcon );
        editMenu.add ( rotateImg );
        rotateImg.addActionListener ( new ActionListener() {
            public void actionPerformed ( ActionEvent e ) {
            }
        } );
        frame.pack();
        frame.repaint();
        frame.setVisible ( true );
    }
    public void grayscale ( int width, int height ) {
        image2 = new BufferedImage ( width, height, BufferedImage.TYPE_BYTE_GRAY );
        ColorConvertOp grayScale = new ColorConvertOp ( image.getColorModel().getColorSpace(), image2.getColorModel().getColorSpace(), null );
        grayScale.filter ( image, image2 );
        imageLabel.setIcon ( new ImageIcon ( image2 ) );
        image = image2;
    }
    public void scale ( int width, int height ) {
        image2 = new BufferedImage ( width, height, BufferedImage.TYPE_INT_RGB );
        Graphics g = image2.createGraphics();
        g.drawImage ( image, 0, 0, image2.getWidth(), image2.getHeight(), 0, 0, width(), height(), null );
        imageLabel.setIcon ( new ImageIcon ( image2 ) );
        image = image2;
    }
    public void rotate ( int width, int height, int theta ) {
    }
    public static void main ( String[] args ) {
        Picture p = new Picture();
        p.show();
    }
}
