public void generateTone()
throws LineUnavailableException {
    if ( clip != null ) {
        clip.stop();
        clip.close();
    } else {
        clip = AudioSystem.getClip();
    }
    boolean addHarmonic = harmonic.isSelected();
    int intSR = ( ( Integer ) sampleRate.getSelectedItem() ).intValue();
    int intFPW = framesPerWavelength.getValue();
    float sampleRate = ( float ) intSR;
    int wavelengths = 20;
    byte[] buf = new byte[2 * intFPW * wavelengths];
    AudioFormat af = new AudioFormat (
        sampleRate,
        8,
        2,
        true,
        false
    );
    int maxVol = 127;
    for ( int i = 0; i < intFPW * wavelengths; i++ ) {
        double angle = ( ( float ) ( i * 2 ) / ( ( float ) intFPW ) ) * ( Math.PI );
        buf[i * 2] = getByteValue ( angle );
        if ( addHarmonic ) {
            buf[ ( i * 2 ) + 1] = getByteValue ( 2 * angle );
        } else {
            buf[ ( i * 2 ) + 1] = buf[i * 2];
        }
    }
    try {
        byte[] b = buf;
        AudioInputStream ais = new AudioInputStream (
            new ByteArrayInputStream ( b ),
            af,
            buf.length / 2 );
        clip.open ( ais );
    } catch ( Exception e ) {
        e.printStackTrace();
    }
}
