if ( isValid() && ( !isEmpty ( newValue ) || validateEmptyFields ( context ) ) ) {
    if ( validators != null ) {
        Validator[] validators = this.validators.asArray ( Validator.class );
        for ( Validator validator : validators ) {
            try {
                validator.validate ( context, this, newValue );
            } catch ( ValidatorException ve ) {
                setValid ( false );
                FacesMessage message;
                String validatorMessageString = getValidatorMessage();
                if ( null != validatorMessageString ) {
                    message =
                        new FacesMessage ( FacesMessage.SEVERITY_ERROR,
                                           validatorMessageString,
                                           validatorMessageString );
                    message.setSeverity ( FacesMessage.SEVERITY_ERROR );
                } else {
                    Collection<FacesMessage> messages = ve.getFacesMessages();
                    if ( null != messages ) {
                        message = null;
                        String cid = getClientId ( context );
                        for ( FacesMessage m : messages ) {
                            context.addMessage ( cid, m );
                        }
                    } else {
                        message = ve.getFacesMessage();
                    }
                }
                if ( message != null ) {
                    context.addMessage ( getClientId ( context ), message );
                }
            }
        }
    }
}
