import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Random;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Future;
import java.util.concurrent.ScheduledThreadPoolExecutor;
class Worker implements Callable<Integer> {
    @Override
    public Integer call() throws Exception {
        Random random = new Random();
        Thread.sleep ( random.nextInt ( 5000 ) + 5000 );
        int x = random.nextInt ( 500 );
        System.out.println ( "Computed " + x );
        return x;
    }
}
public class Program {
    public static void main ( String[] args ) {
        final int POOL_SIZE = 10;
        final int N = 39;
        System.out.println ( "Starting " + N + " workers" );
        Collection<Callable<Integer>> workers = new ArrayList<Callable<Integer>> ( N );
        for ( int i = 0; i < N; i++ ) {
            workers.add ( new Worker() );
        }
        ExecutorService executor = new ScheduledThreadPoolExecutor ( POOL_SIZE );
        List<Future<Integer>> results = null;
        try {
            results = executor.invokeAll ( workers );
        } catch ( InterruptedException e ) {
            e.printStackTrace();
            return;
        }
        int sum = 0;
        for ( Future<Integer> future : results ) {
            try {
                sum += future.get();
            } catch ( InterruptedException e ) {
                e.printStackTrace();
                return;
            } catch ( ExecutionException e ) {
                e.printStackTrace();
                return;
            }
        }
        double average = ( double ) sum / ( double ) N;
        System.out.println ( "         Sum: " + sum );
        System.out.println ( "     Workers: " + N );
        System.out.println ( "     Average: " + average );
    }
}
