class CustomButton extends JButton {
    CustomButton() {
        setLayout ( null );
        updateStyles();
        getModel().addChangeListener ( new ChangeListener() {
            @Override
            public void stateChanged ( ChangeEvent e ) {
                updateStyles();
            }
        } );
    }
    private void updateStyles() {
    }
    private int getSynthComponentState() {
        int state = SynthConstants.ENABLED;
        if ( !isEnabled() ) {
            state = SynthConstants.DISABLED;
        }
        if ( model.isPressed() ) {
            if ( model.isArmed() ) {
                state = SynthConstants.PRESSED;
            } else {
                state = SynthConstants.MOUSE_OVER;
            }
        }
        if ( model.isRollover() ) {
            state |= SynthConstants.MOUSE_OVER;
        }
        if ( model.isSelected() ) {
            state |= SynthConstants.SELECTED;
        }
        if ( isFocusOwner() && isFocusPainted() ) {
            state |= SynthConstants.FOCUSED;
        }
        if ( isDefaultButton() ) {
            state |= SynthConstants.DEFAULT;
        }
        return state;
    }
}
