public abstract class Filter {
    private int currentPageNo;
    private int currentStartPageNo;
    private int currentEndPageNo;
    private int elementsPerPage;
    private int pageNumberInNavigation;
    public abstract Query createCountQuery();
    public abstract Query createQuery();
    public void setCurrentPageNo() {
    }
    public Long getAllElementsCount() {
        Query query = createCountQuery();
        List list = query.list();
        return !list.isEmpty() && list.get ( 0 ) != null ? query.list().get ( 0 ) : 0;
    }
    public List getElements() {
        Query query = createQuery();
        int from = ( ( currentPageNo - 1 ) * elementsPerPage );
        query.setFirstResult ( from );
        query.setMaxResults ( elementsPerPage );
        return query.list();
    }
    public List getAllElements() {
        Query query = createQuery();
        return query.list();
    }
    public void refresh() {
    }
    public List next() {
        setCurrentPageNo ( getCurrentPageNo() + 1 );
        getElements();
    }
    public List previoius() {
        setCurrentPageNo ( getCurrentPageNo() - 1 );
        getElements();
    }
}
