public class JdkVersionService {
    @Inject
    private JdkVersionWebService jdkVersionWebService;
    private final Supplier<JdkVersion> latestJdkVersionCache
        = Suppliers.memoizeWithExpiration ( jdkVersionSupplier(), 365, TimeUnit.DAYS );
    public JdkVersion getLatestJdkVersion() {
        return latestJdkVersionCache.get();
    }
    private Supplier<JdkVersion> jdkVersionSupplier() {
        return new Supplier<JdkVersion>() {
            public JdkVersion get() {
                return jdkVersionWebService.checkLatestJdkVersion();
            }
        };
    }
}
