public class World implements StateChangeListener {
    private Animal dog_;
    private Animals cats_;
    private final List<StateChangeListener> listeners = new ArrayList<StateChangeListener>();
    public World() {
        listeners.add ( this );
    }
    public <RequestType extends Request> void sendRequest (
        Animal<RequestType, ?> animal, Request<RequestType> request ) {
        animal.sendRequest ( request );
        for ( StateChangeListener listener : listeners ) {
            listener.stateChanged ( animal, request );
        }
    }
    public void stateChanged ( Animal<?, ?> animal, State<?> state ) {
    }
    ...
