private String byteToString ( byte[] data ) {
    String text = new String();
    for ( int i = 0; i < data.length; i++ ) {
        text += ( char ) ( data[i] & 0x00FF );
    }
    return text;
}
private static String bytesToHexString ( byte[] bytes ) {
    StringBuilder sb = new StringBuilder ( bytes.length * 2 );
    Formatter formatter = new Formatter ( sb );
    for ( byte b : bytes ) {
        formatter.format ( "%02x", b );
    }
    return sb.toString();
}
public void writeImageToServer ( URL scriptURL, BufferedImage img ) {
    try {
        ByteArrayOutputStream jpegOutput = new ByteArrayOutputStream();
        JPEGImageEncoder encoder = JPEGCodec.createJPEGEncoder ( jpegOutput );
        encoder.encode ( img );
        HttpURLConnection urlConnection = ( HttpURLConnection )
                                          scriptURL.openConnection();
        urlConnection.setDoOutput ( true );
        urlConnection.setDoInput ( true );
        urlConnection.setUseCaches ( false );
        urlConnection.setRequestMethod ( "POST" );
        urlConnection.setRequestProperty ( "Content-type", "application/x-www-form-urlencoded" );
        byte[] imageData = jpegOutput.toByteArray();
        String imageString = bytesToHexString ( imageData );
        String content = "img=" + URLEncoder.encode ( imageString, "UTF-8" );
        urlConnection.setRequestProperty ( "Content-length", String.valueOf ( content.length() ) );
        OutputStream urlout = urlConnection.getOutputStream();
        DataOutputStream printOut = new DataOutputStream ( urlout );
        printOut.writeBytes ( content );
        urlout.flush();
        urlout.close();
        printOut.flush();
        printOut.close();
        jpegOutput.flush();
        jpegOutput.close();
        urlConnection.disconnect();
    } catch ( IOException e ) {
        e.printStackTrace();
    }
}
