HttpClient httpclient = new DefaultHttpClient();
HttpGet httpget = new HttpGet ( url );
HttpResponse response;
String returnString = null;
try {
    response = httpclient.execute ( httpget );
    if ( response.getStatusLine().getStatusCode() == 200 ) {
        HttpEntity entity = response.getEntity();
        if ( entity != null ) {
            InputStream instream = entity.getContent();
            JSONObject myAwway = new JSONObject ( convertStreamToString ( instream ) );
            String query = myAwway.getString ( "query" );
            * *
            JSONArray suggestions = myAwway.getJSONArray ( "suggestions" );
            returnString = "Found: " + suggestions.length() + " locations for " + query;
            for ( int i = 0; i < suggestions.length(); i++ ) {
                returnString += "\n\t" + suggestions.getString ( i );
            }
            instream.close();
        }
    } else {
        returnString = "Unable to load page - " + response.getStatusLine();
    }
} catch ( IOException  ex ) {
    returnString = "Connection failed; " + ex.getMessage();
} catch ( JSONException ex ) {
    returnString = "JSON failed; " + ex.getMessage();
}
return returnString;
}
private static String convertStreamToString ( InputStream is ) {
    BufferedReader reader = new BufferedReader ( new InputStreamReader ( is ) );
    StringBuilder sb = new StringBuilder();
    String line = null;
    try {
        while ( ( line = reader.readLine() ) != null ) {
            sb.append ( line + "\n" );
        }
    } catch ( IOException e ) {
        e.printStackTrace();
    } finally {
        try {
            is.close();
        } catch ( IOException e ) {
            e.printStackTrace();
        }
    }
    return sb.toString();
}
