package mycompany;
import com.engidea.comm.CommPort;
import com.engidea.comm.CommPortIdentifier;
import com.engidea.comm.SerialPort;
import com.engidea.comm.SerialPortEvent;
import com.engidea.comm.SerialPortEventListener;
import com.engidea.win32jcom.WinjcomIdentifier;
import java.io.*;
import java.util.Iterator;
import java.util.List;
import java.applet.*;
import java.security.*;
public class PortWriter extends Applet {
    private CommPortIdentifier portIdentifier;
    private SerialPort serport;
    public static void main ( String[] args ) {}
    public void init() {
        System.out.println ( "Booting RS232 Java Applet..." );
    }
    public void Sends ( String port, String message ) {
        final String com_port = port;
        final String send_message = message;
        AccessController.doPrivileged ( new PrivilegedAction<Object>() {
            public Object run() {
                try {
                    portIdentifier = new WinjcomIdentifier ( 0 );
                    try {
                        selectComport ( com_port );
                        new Thread ( new PortReader() ).start();
                        try {
                            System.out.println ( com_port + ": " + send_message );
                            typeSendBytes ( send_message );
                        } catch ( Exception e ) {
                            System.out.println ( "Couldn't send data to " + com_port );
                        }
                    } catch ( IOException e ) {
                        System.out.println ( "Couldn't connect to " + com_port );
                    }
                } catch ( Exception e ) {
                    System.out.println ( e );
                }
                return null;
            }
        } );
    }
    private void typeSendBytes ( String message ) {
        try {
            BufferedReader in = new BufferedReader ( new InputStreamReader ( System.in ) );
            String aStr = "";
            if ( aStr != null ) {
                aStr = message + "\r\n";
                byte []buf = aStr.getBytes();
                serport.write ( buf, 0, buf.length );
            }
        } catch ( Exception exc ) {
            exc.printStackTrace();
        }
    }
    private SerialPort openPort ( String portName ) throws IOException {
        try {
            CommPort aPort = portIdentifier.getCommPort ( portName );
            aPort.open();
            return ( SerialPort ) aPort;
        } catch ( Exception exc ) {
            throw exc;
        }
    }
    private void selectComport ( String portName ) throws IOException {
        try {
            serport = openPort ( portName );
            serport.setSerialPortParams ( 9600, 8, SerialPort.STOPBITS_2, SerialPort.PARITY_NONE );
            serport.enableReceiveTimeout ( 20000 );
            serport.setEventListener ( new EventListener() );
            serport.notifyOnDSR ( true );
            serport.notifyOnCarrierDetect ( true );
            serport.notifyOnCTS ( true );
        } catch ( IOException exc ) {
            throw exc;
        }
    }
    private final class EventListener implements SerialPortEventListener {
        public void serialEvent ( SerialPortEvent ev ) {
            System.out.println ( "Got event=" + ev );
        }
    }
    private final class PortReader implements Runnable {
        public void run() {
            try {
                byte []buff = new byte[1];
                while ( serport.read ( buff, 0, buff.length ) > 0 ) {
                    System.out.print ( new String ( buff ) );
                }
            } catch ( Exception exc ) {
                exc.printStackTrace();
            }
        }
    }
}
