public class BinaryTree {
    public static BinaryTreeNode nodeFromSortedArray ( String[]a,
            int left, int right ) {
        if ( right < left ) {
            return null;
        }
        if ( right == left ) {
            return new BinaryTreeNode ( a[left] );
        }
        int mid = ( left + right ) / 2;
        BinaryTreeNode n = new BinaryTreeNode ( a[mid] );
        n.left = nodeFromSortedArray ( a, left, mid - 1 );
        n.right = nodeFromSortedArray ( a, mid + 1, right );
        return n;
    }
    public static BinaryTree fromSortedArray ( String[]a ) {
        BinaryTree bt = new BinaryTree();
        bt.setRoot ( nodeFromSortedArray ( a, 0, a.length - 1 ) );
        return bt;
    }
}
