public class ExamplePanel extends JPanel {
    Rectangle2D.Double selectionRect;
    Point mouseDown, mouseHere;
    ...
    protected void paintComponent ( Graphics g ) {
        AlphaComposite ta = AlphaComposite.getInstance ( AlphaComposite.SRC_OVER, 0.1f );
        g2d.setComposite ( ta );
        g2d.setColor ( Color.BLUE );
        g2d.fill ( selectionRect );
        g2d.setComposite ( AlphaComposite.SrcOver );
        g2d.setColor ( Color.BLACK );
        g2d.draw ( selectionRect );
    }
}
public class ExammpleMouseListener extends MouseAdapter {
    @Override
    public void mousePressed ( MouseEvent e ) {
        super.mousePressed ( e );
        pnl.mouseDown = e.getPoint();
    }
    @Override
    public void mouseDragged ( MouseEvent e ) {
        super.mouseDragged ( e );
        if ( ( e.getModifiersEx() & InputEvent.BUTTON1_DOWN_MASK ) == 0 ) {
            return;
        }
        pnl.mouseHere = e.getPoint();
        double downX = pnl.mouseDown.getX();
        double downY = pnl.mouseDown.getY();
        double hereX = pnl.mouseHere.getX();
        double hereY = pnl.mouseHere.getY();
        double l = Math.min ( downX, hereX );
        double t = Math.min ( downY, hereY );
        double w = Math.abs ( downX - hereX );
        double h = Math.abs ( downY - hereY );
        pnl.selectionRect = new Rectangle2D.Double ( l, t, w, h );
        pnl.repaint();
    }
    @Override
    public void mouseReleased ( MouseEvent e ) {
        super.mouseReleased ( e );
        pnl.selectionRect = null;
        pnl.repaint();
    }
}
}
