public class CharacterHandler {
    public static void main ( String[] args ) throws IOException {
        Charset encoding = Charset.defaultCharset();
        for ( String filename : args ) {
            File file = new File ( filename );
            handleFile ( file, encoding );
        }
    }
    private static void handleFile ( File file, Charset encoding )
    throws IOException {
        try ( InputStream in = new FileInputStream ( file );
                    Reader reader = new InputStreamReader ( in, encoding );
                    Reader buffer = new BufferedReader ( reader ) ) {
            handleCharacters ( buffer );
        }
    }
    private static void handleCharacters ( Reader reader )
    throws IOException {
        int r;
        while ( ( r = reader.read() ) != -1 ) {
            char ch = ( char ) r;
            System.out.println ( "Do something with " + ch );
        }
    }
}
