import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.geom.Area;
import java.awt.geom.Ellipse2D;
import java.awt.geom.Line2D;
import java.awt.geom.Path2D;
import java.awt.geom.PathIterator;
import java.awt.geom.Point2D;
import java.util.ArrayList;
import java.util.Random;
import javax.swing.JFrame;
public class AreaTest extends JFrame {
    private static final long serialVersionUID = -2221432546854106311L;
    Area area = new Area();
    ArrayList<Line2D.Double> areaSegments = new ArrayList<Line2D.Double>();
    Point2D.Double insidePoint = new Point2D.Double ( 225, 225 );
    Point2D.Double closestPoint = new Point2D.Double ( -1, -1 );
    Point2D.Double bestPoint = new Point2D.Double ( -1, -1 );
    ArrayList<Point2D.Double> closestPointList = new ArrayList<Point2D.Double>();
    AreaTest() {
        Path2D.Double triangle = new Path2D.Double();
        Random random = new Random();
        for ( int i = 0; i < 3; i++ ) {
            triangle.moveTo ( random.nextInt ( 400 ) + 50, random.nextInt ( 400 ) + 50 );
            triangle.lineTo ( random.nextInt ( 400 ) + 50, random.nextInt ( 400 ) + 50 );
            triangle.lineTo ( random.nextInt ( 400 ) + 50, random.nextInt ( 400 ) + 50 );
            triangle.closePath();
            area.add ( new Area ( triangle ) );
            triangle.reset();
        }
        if ( !area.contains ( insidePoint ) );
        {
            while ( !area.contains ( insidePoint ) ) {
                insidePoint.setLocation ( random.nextInt ( 400 ) + 50, random.nextInt ( 400 ) + 50 );
            }
        }
        ArrayList<double[]> areaPoints = new ArrayList<double[]>();
        double[] coords = new double[6];
        for ( PathIterator pi = area.getPathIterator ( null ); !pi.isDone(); pi.next() ) {
            int type = pi.currentSegment ( coords );
            double[] pathIteratorCoords = {type, coords[0], coords[1]};
            areaPoints.add ( pathIteratorCoords );
        }
        double[] start = new double[3];
        for ( int i = 0; i < areaPoints.size(); i++ ) {
            double[] currentElement = areaPoints.get ( i );
            double[] nextElement = { -1, -1, -1};
            if ( i < areaPoints.size() - 1 ) {
                nextElement = areaPoints.get ( i + 1 );
            }
            if ( currentElement[0] == PathIterator.SEG_MOVETO ) {
                start = currentElement;
            }
            if ( nextElement[0] == PathIterator.SEG_LINETO ) {
                areaSegments.add (
                    new Line2D.Double (
                        currentElement[1], currentElement[2],
                        nextElement[1], nextElement[2]
                    )
                );
            } else if ( nextElement[0] == PathIterator.SEG_CLOSE ) {
                areaSegments.add (
                    new Line2D.Double (
                        currentElement[1], currentElement[2],
                        start[1], start[2]
                    )
                );
            }
        }
        for ( Line2D.Double line : areaSegments ) {
            double u =
                ( ( insidePoint.getX() - line.x1 ) * ( line.x2 - line.x1 ) + ( insidePoint.getY() - line.y1 ) * ( line.y2 - line.y1 ) )
                / ( ( line.x2 - line.x1 ) * ( line.x2 - line.x1 ) + ( line.y2 - line.y1 ) * ( line.y2 - line.y1 ) );
            double xu = line.x1 + u * ( line.x2 - line.x1 );
            double yu = line.y1 + u * ( line.y2 - line.y1 );
            if ( u < 0 ) {
                closestPoint.setLocation ( line.getP1() );
            } else if ( u > 1 ) {
                closestPoint.setLocation ( line.getP2() );
            } else {
                closestPoint.setLocation ( xu, yu );
            }
            closestPointList.add ( ( Point2D.Double ) closestPoint.clone() );
            if ( closestPoint.distance ( insidePoint ) < bestPoint.distance ( insidePoint ) ) {
                bestPoint.setLocation ( closestPoint );
            }
        }
        setSize ( new Dimension ( 500, 500 ) );
        setLocationRelativeTo ( null );
        setDefaultCloseOperation ( EXIT_ON_CLOSE );
        setResizable ( false );
        setVisible ( true );
    }
    public void paint ( Graphics g ) {
        Graphics2D g2d = ( Graphics2D ) g;
        g.setColor ( Color.lightGray );
        g2d.fill ( area );
        g.setColor ( Color.black );
        for ( Line2D.Double line : areaSegments ) {
            g2d.draw ( line );
        }
        g.setColor ( Color.red );
        g2d.fill (
            new Ellipse2D.Double (
                insidePoint.getX() - 3,
                insidePoint.getY() - 3,
                6,
                6
            )
        );
        for ( Point2D.Double point : closestPointList ) {
            g.setColor ( Color.black );
            g2d.fill (
                new Ellipse2D.Double (
                    point.getX() - 3,
                    point.getY() - 3,
                    6,
                    6
                )
            );
        }
        g.setColor ( Color.green );
        g2d.fill (
            new Ellipse2D.Double (
                bestPoint.getX() - 3,
                bestPoint.getY() - 3,
                6,
                6
            )
        );
    }
    public static void main ( String[] args ) {
        new AreaTest();
    }
}
