public boolean setCustomTag ( AudioFile audioFile, String description, String text ) {
    FrameBodyTXXX txxxBody = new FrameBodyTXXX();
    txxxBody.setDescription ( description );
    txxxBody.setText ( text );
    Tag tag = audioFile.getTagOrCreateAndSetDefault();
    if ( ! ( tag instanceof ID3v23Tag || tag instanceof ID3v24Tag ) ) {
        Tag newTagV23 = null;
        if ( tag instanceof ID3v1Tag ) {
            newTagV23 = new ID3v23Tag ( ( ID3v1Tag ) audioFile.getTag() );
        }
        if ( tag instanceof ID3v22Tag ) {
            newTagV23 = new ID3v23Tag ( ( ID3v11Tag ) audioFile.getTag() );
        }
        audioFile.setTag ( newTagV23 );
    }
    AbstractID3v2Frame frame = null;
    if ( tag instanceof ID3v23Tag ) {
        frame = new ID3v23Frame ( "TXXX" );
    } else if ( tag instanceof ID3v24Tag ) {
        frame = new ID3v24Frame ( "TXXX" );
    }
    frame.setBody ( txxxBody );
    try {
        tag.addField ( frame );
    } catch ( FieldDataInvalidException e ) {
        e.printStackTrace();
        return false;
    }
    try {
        audioFile.commit();
    } catch ( CannotWriteException e ) {
        e.printStackTrace();
        return false;
    }
    return true;
}
