fieldID = env->GetFieldID ( identifyResultClass , "identParams", "Ljava/util/List;" );
if ( fieldID != NULL ) {
    jclass listClass = env->FindClass ( "java/util/List" );
    if ( listClass == NULL ) {
        DBG_WARNING ( DBG_CTX, ( "Can't Find Class \"java/util/List\".\n" ) );
        return -1;
    }
    jobject listObject = env->GetObjectField ( methodReturnObj, fieldID );
    if ( listObject == NULL ) {
        DBG_WARNING ( DBG_CTX, ( "Can't get ObjectField for \"List\".\n" ) );
        return -1;
    }
    jmethodID getMethodID = env->GetMethodID ( listClass, "get", "(I)Ljava/lang/Object;" );
    if ( getMethodID == NULL ) {
        DBG_WARNING ( DBG_CTX, ( "Can't get MethodID for \"java.util.List.get(int location)\".\n" ) );
        return -1;
    }
    jmethodID sizeMethodID = env->GetMethodID ( listClass, "size", "()I" );
    if ( sizeMethodID == NULL ) {
        DBG_WARNING ( DBG_CTX, ( "Can't get MethodID for \"int java.util.List.size()\".\n" ) );
        return -1;
    }
    int listItemsCount = ( int ) env->CallIntMethod ( listObject, sizeMethodID );
    DBG_DISPLAY ( DBG_CTX, ( "List has %i items\n", listItemsCount ) );
    for ( int i = 0; i < listItemsCount; ++i ) {
        jobject identParamsObject = env->CallObjectMethod ( listObject, getMethodID, i - 1 );
        if ( identParamsObject == NULL ) {
            DBG_WARNING ( DBG_CTX, ( "Can't get Object from \"identParamsObject\" at index %i.\n", i - 1 ) );
        }
    }
