public Dimension getFontSize ( Graphics graphics, Font font, String text ) {
    FontMetrics metrics = graphics.getFontMetrics ( font );
    int hgt = metrics.getHeight();
    int adv = metrics.stringWidth ( text );
    Dimension size = new Dimension ( adv + 2, hgt + 2 );
    return size;
}
public Font findFont ( Dimension componentSize, Font oldFont, String text, Graphics g ) {
    Font savedFont = oldFont;
    for ( int i = 0; i < 100; i++ ) {
        Font newFont = new Font ( oldFont.getFontName(), oldFont.getStyle(), i );
        Dimension d = getFontSize ( g, newFont, text );
        if ( componentSize.height < d.height || componentSize.width < d.width ) {
            return savedFont;
        }
        savedFont = newFont;
    }
    return oldFont;
}
