import java.util.*;
public class Test {
    public static <K, V> void combinations ( Map<K, Set<V>> map, List<Map<K, V>> list ) {
        recurse ( map, new LinkedList<K> ( map.keySet() ).listIterator(), new HashMap<K, V>(), list );
    }
    private static <K, V> void recurse ( Map<K, Set<V>> map, ListIterator<K> iter, Map<K, V> cur, List<Map<K, V>> list ) {
        if ( !iter.hasNext() ) {
            Map<K, V> entry = new HashMap<K, V>();
            for ( K key : cur.keySet() ) {
                entry.put ( key, cur.get ( key ) );
            }
            list.add ( entry );
        } else {
            K key = iter.next();
            Set<V> set = map.get ( key );
            for ( V value : set ) {
                cur.put ( key, value );
                recurse ( map, iter, cur, list );
                cur.remove ( key );
            }
            iter.previous();
        }
    }
    public static void main ( String[] args ) {
        Map<Integer, Set<Integer>> map = new HashMap<Integer, Set<Integer>>() {
            {
                put ( 1, new HashSet<Integer>() {
                    {
                        add ( 11 );
                        add ( 12 );
                    }
                } );
                put ( 2, new HashSet<Integer>() {
                    {
                        add ( 21 );
                        add ( 22 );
                        add ( 23 );
                    }
                } );
                put ( 3, new HashSet<Integer>() {
                    {
                        add ( 31 );
                    }
                } );
            }
        };
        List<Map<Integer, Integer>> list = new LinkedList<Map<Integer, Integer>>();
        combinations ( map, list );
        for ( Map<Integer, Integer> combination : list ) {
            System.out.println ( combination );
        }
    }
}
