import java.io.IOException;
import javax.security.auth.callback.Callback;
import javax.security.auth.callback.CallbackHandler;
import javax.security.auth.callback.UnsupportedCallbackException;
import org.apache.log4j.Logger;
import org.apache.ws.security.WSPasswordCallback;
public final class ClientPasswordHandler implements CallbackHandler {
    protected static Logger log = Logger.getLogger ( ClientPasswordHandler.class );
    private static final PropertyManager PROPS = PropertyManager.getInstance();
    private static String PASSWORD = PROPS.getPassword();
    private static boolean IS_PASSWORD_CLEAR = PROPS.getIsClearPassword();
    public void handle ( Callback[] callbacks ) throws IOException, UnsupportedCallbackException {
        if ( log.isDebugEnabled() ) {
            log.debug ( "Setting password for UsernameToken" );
        }
        WSPasswordCallback pc = ( WSPasswordCallback ) callbacks[0];
        if ( IS_PASSWORD_CLEAR ) {
            synchronized ( this ) {
                PASSWORD = PasswordDigestUtil.doPasswordDigest ( PASSWORD );
                IS_PASSWORD_CLEAR = false;
                PROPS.setIsClearPassword ( IS_PASSWORD_CLEAR );
                PROPS.setPassword ( PASSWORD );
                PROPS.saveProperties();
            }
        }
        pc.setPassword ( PASSWORD );
    }
}
