public class Application extends org.restlet.Application {
    public static void main ( String... args ) throws Exception {
        final Component comp = new Component();
        comp.getServers().add ( Protocol.HTTP, 3000 );
        comp.getDefaultHost().attach ( "/v1", new Application() );
        comp.start();
    }
    private final ObjectContainer container;
    public Application() {
        EmbeddedConfiguration config = Db4oEmbedded.newConfiguration();
        config.common().updateDepth ( 2 );
        this.container = Db4oEmbedded.openFile ( config, System
                         .getProperty ( "user.home" )
                         + File.separator + "restbook.dbo" );
    }
    @Override
    public Restlet createInboundRoot() {
        final Router router = new Router ( getContext() );
        router.attach ( "/users/{username}", UserResource.class );
        router.attach ( "/users/{username}/bookmarks", BookmarksResource.class );
        final TemplateRoute uriRoute = router.attach (
                                           "/users/{username}/bookmarks/{URI}", BookmarkResource.class );
        uriRoute.getTemplate().getVariables().put ( "URI",
                new Variable ( Variable.TYPE_URI_ALL ) );
        return router;
    }
    public ObjectContainer getContainer() {
        return this.container;
    }
}
@Override
public Application getApplication() {
    return ( Application ) super.getApplication();
}
public ObjectContainer getContainer() {
    return getApplication().getContainer();
}
