ExecutorService threads = Executors.newFixedThreadPool ( MAX_THREADS );
...
ConcurrentLinkedQueue<Future> collectors = new ConcurrentLinkedQueue<Future>();
...
Callable<Void> c = new FileListCollector ( path, recurse, filter );
collectors.add ( threads.submit ( c ) );
...
private void checkForFinished() {
    int runningThreads = 0;
    try {
        List<Future> deadThreads = new LinkedList<Future>();
        for ( Future f : collectors ) {
            if ( f != null ) {
                if ( !f.isDone() ) {
                    runningThreads += 1;
                } else {
                    deadThreads.add ( f );
                }
            }
        }
        collectors.removeAll ( deadThreads );
    } catch ( ConcurrentModificationException cme ) {
        runningThreads += 1;
    }
    if ( runningThreads == 0 ) {
        close();
    }
}
public void close() {
    if ( !fileQueue.isClosed() ) {
        fileQueue.close();
        threads.shutdownNow();
        boolean terminated = false;
        do {
            try {
                terminated = threads.awaitTermination ( 1, TimeUnit.SECONDS );
            } catch ( InterruptedException ex ) {
            }
        } while ( !terminated );
        log ( "! All done" );
    }
}
