public SimpleViewer() {
    try {
        scriptNode = new OutArg<ScriptNode>();
        context = Context.createFromXmlFile ( SAMPLE_XML_FILE, scriptNode );
        depthGen = DepthGenerator.create ( context );
        DepthMetaData depthMD = depthGen.getMetaData();
        histogram = new float[10000];
        width = depthMD.getFullXRes();
        height = depthMD.getFullYRes();
        imgbytes = new byte[width * height];
        DataBufferByte dataBuffer = new DataBufferByte ( imgbytes, width * height );
        Raster raster = Raster.createPackedRaster ( dataBuffer, width, height, 8, null );
        bimg = new BufferedImage ( width, height, BufferedImage.TYPE_BYTE_GRAY );
        bimg.setData ( raster );
    } catch ( GeneralException e ) {
        e.printStackTrace();
        System.exit ( 1 );
    }
}
