public static int mulAndCheck ( int a, int b ) {
    int ret;
    String msg = "overflow: multiply";
    if ( a > b ) {
        ret = mulAndCheck ( b, a );
    } else {
        if ( a < 0 ) {
            if ( b < 0 ) {
                if ( a >= Integer.MAX_VALUE / b ) {
                    ret = a * b;
                } else {
                    throw new ArithmeticException ( msg );
                }
            } else if ( b > 0 ) {
                if ( Integer.MIN_VALUE / b <= a ) {
                    ret = a * b;
                } else {
                    throw new ArithmeticException ( msg );
                }
            } else {
                ret = 0;
            }
        } else if ( a > 0 ) {
            if ( a <= Integer.MAX_VALUE / b ) {
                ret = a * b;
            } else {
                throw new ArithmeticException ( msg );
            }
        } else {
            ret = 0;
        }
    }
    return ret;
}
@Test ( expected = ArithmeticException.class )
public void testOverflow() {
    mulAndCheck ( Integer.MAX_VALUE, Integer.MAX_VALUE );
}
@Test ( expected = ArithmeticException.class )
public void testOverflow1() {
    mulAndCheck ( Integer.MIN_VALUE, Integer.MAX_VALUE );
}
@Test
public void testTimesMinus1() {
    Assert.assertEquals ( Integer.MIN_VALUE + 1, mulAndCheck ( Integer.MAX_VALUE, -1 ) );
    Assert.assertEquals ( Integer.MAX_VALUE, mulAndCheck ( Integer.MIN_VALUE + 1, -1 ) );
}
