public abstract class FilterStringPanel extends Panel {
    private static final long serialVersionUID = 1L;
    private FilterForm filterForm;
    public FilterStringPanel ( String id ) {
        super ( id );
        filterForm = new FilterForm ( "filterForm" );
        add ( filterForm );
    }
    public String getFilterString() {
        return filterForm.getFilterString();
    }
    public abstract void onUpdateFilter ( AjaxRequestTarget target );
    private class FilterForm extends Form<Void> {
        private static final long serialVersionUID = 1L;
        private transient String filterString;
        public FilterForm ( String id ) {
            super ( id );
            final TextField<String> filterTextField = new TextField<String> ( "filterTextField", new PropertyModel<String> ( this, "filterString" ) );
            add ( filterTextField );
            add ( new AjaxButton ( "filterButton" ) {
                private static final long serialVersionUID = 1L;
                @Override
                protected void onSubmit ( AjaxRequestTarget target, Form<?> form ) {
                    onUpdateFilter ( target );
                }
            } );
        }
        public String getFilterString() {
            return filterString;
        }
    }
}
