public void drawBillBoardSprite ( Texture texture, Vector3f sprPos, float r, float g, float b, int sprWidth, int sprHeight ) {
    GL11.glPushMatrix();
    GL11.glTranslatef ( sprPos.x, 0, sprPos.z );
    texture.bind();
    FloatBuffer modelview = BufferUtils.createFloatBuffer ( 16 );
    GL11.glGetFloat ( GL11.GL_MODELVIEW_MATRIX, modelview );
    for ( int i = 0; i < 3; i += 2 )
        for ( int j = 0; j < 3; j++ ) {
            if ( i == j ) {
                modelview.put ( i * 4 + j, 1.0f );
            } else {
                modelview.put ( i * 4 + j, 0.0f );
            }
        }
    GL11.glLoadMatrix ( modelview );
    GL11.glBegin ( GL11.GL_QUADS );
    GL11.glTexCoord2f ( 0, 0 );
    GL11.glVertex3f ( - ( sprWidth / 2 ), ( sprHeight / 2 ), 0 );
    GL11.glTexCoord2f ( texture.getWidth(), 0 );
    GL11.glVertex3f ( + ( sprWidth / 2 ), ( sprHeight / 2 ), 0 );
    GL11.glTexCoord2f ( texture.getWidth(), texture.getHeight() );
    GL11.glVertex3f ( + ( sprWidth / 2 ), - ( sprHeight / 2 ), 0 );
    GL11.glTexCoord2f ( 0, texture.getHeight() );
    GL11.glVertex3f ( - ( sprWidth / 2 ), - ( sprHeight / 2 ), 0 );
    GL11.glEnd();
    GL11.glPopMatrix();
}
