public void loadJndiBeansFromServer (
    @Observes AfterBeanDiscovery beanDiscovery, BeanManager beanManager )
throws NamingException, ClassNotFoundException, IOException {
    Properties interfacesToNames = extractInterfacesToNames();
    Properties jndiProperties = new Properties();
    Context context = new InitialContext();
    for ( Entry<?, ?> entry : interfacesToNames.entrySet() ) {
        String interfaceName = entry.getKey().toString();
        Class<?> interfaceClass = Class.forName ( interfaceName );
        String jndiName = entry.getValue().toString();
        Bean<?> jndiBean = createJndIBeanFor ( beanManager, interfaceClass, jndiName, jndiProperties );
        beanDiscovery.addBean ( jndiBean );
    }
}
