class TestAD {
    static DirContext ldapContext;
    public static void main ( String[] args ) throws NamingException {
        try {
            System.out.println ( "Début du test Active Directory" );
            Hashtable<String, String> ldapEnv = new Hashtable<String, String> ( 11 );
            ldapEnv.put ( Context.INITIAL_CONTEXT_FACTORY, "com.sun.jndi.ldap.LdapCtxFactory" );
            ldapEnv.put ( Context.PROVIDER_URL,  "ldap://dom.fr:389" );
            ldapEnv.put ( Context.SECURITY_AUTHENTICATION, "simple" );
            ldapEnv.put ( Context.SECURITY_PRINCIPAL, "cn=jean paul blanc,ou=MonOu,dc=dom,dc=fr" );
            ldapEnv.put ( Context.SECURITY_CREDENTIALS, "pwd" );
            ldapContext = new InitialDirContext ( ldapEnv );
            SearchControls searchCtls = new SearchControls();
            String returnedAtts[] = {"sn", "givenName", "samAccountName"};
            searchCtls.setReturningAttributes ( returnedAtts );
            searchCtls.setSearchScope ( SearchControls.SUBTREE_SCOPE );
            String searchFilter = "(&(objectClass=user))";
            String searchBase = "dc=dom,dc=fr";
            int totalResults = 0;
            NamingEnumeration<SearchResult> answer = ldapContext.search ( searchBase, searchFilter, searchCtls );
            while ( answer.hasMoreElements() ) {
                SearchResult sr = ( SearchResult ) answer.next();
                totalResults++;
                System.out.println ( ">>>" + sr.getName() );
                Attributes attrs = sr.getAttributes();
                System.out.println ( ">>>>>>" + attrs.get ( "samAccountName" ) );
            }
            System.out.println ( "Total results: " + totalResults );
            ldapContext.close();
        } catch ( Exception e ) {
            System.out.println ( " Search error: " + e );
            e.printStackTrace();
            System.exit ( -1 );
        }
    }
}
