public class FruitPool extends GenericPool<Sprite> {
    private final TextureRegion mTextureRegion;
    public FruitPool ( final TextureRegion pFruitTextureRegion ) {
        this.mTextureRegion = pFruitTextureRegion;
    }
    @Override
    protected Sprite onAllocatePoolItem() {
        return new Sprite ( 0, 0, this.mTextureRegion );
    }
    @Override
    protected void onHandleObtainItem ( final Sprite pItem ) {
        pItem.reset();
    }
    @Override
    protected void onHandleRecycleItem ( final Sprite pItem ) {
        pItem.setVisible ( false );
        pItem.setIgnoreUpdate ( true );
    }
}
