public class FruitPool extends GenericPool<Sprite> {
    private final TextureRegion mTextureRegion;
    private final Scene mAttachedScene;
    public FruitPool ( final TextureRegion pFruitTextureRegion, final Scene pScene ) {
        this.mTextureRegion = pFruitTextureRegion;
        this.mAttachedScene = pScene;
    }
    @Override
    protected Sprite onAllocatePoolItem() {
        Sprite newSprite = new Sprite ( 0, 0, this.mTextureRegion );
        this.mAttachedScene.attachChild ( newSprite );
        return newSprite;
    }
    @Override
    protected void onHandleObtainItem ( final Sprite pItem ) {
        pItem.reset();
    }
    @Override
    protected void onHandleRecycleItem ( final Sprite pItem ) {
        pItem.setVisible ( true );
        pItem.setIgnoreUpdate ( true );
    }
}
