public class LdapAuthenticationProvider implements AuthenticationProvider {
    private LdapAuthenticator authenticator;
    public Authentication authenticate ( Authentication auth ) throws AuthenticationException {
        DirContextOperations authAdapter = authenticator.authenticate ( auth );
        LdapAuthenticationToken ldapAuth = new LdapAuthenticationToken ( auth, "ROLE_USER" );
        InitialLdapContext ldapContext = ( InitialLdapContext ) authAdapter
                                         .getObjectAttribute ( "ldapContext" );
        if ( ldapContext != null ) {
            ldapAuth.setContext ( ldapContext );
        }
        return ldapAuth;
    }
    public boolean supports ( Class clazz ) {
        return ( UsernamePasswordAuthenticationToken.class.isAssignableFrom ( clazz ) );
    }
    public LdapAuthenticator getAuthenticator() {
        return authenticator;
    }
    public void setAuthenticator ( LdapAuthenticator authenticator ) {
        this.authenticator = authenticator;
    }
}
