public class LdapAuthenticatorImpl implements LdapAuthenticator {
    private DefaultSpringSecurityContextSource contextFactory;
    private String principalPrefix = "";
    public DirContextOperations authenticate ( Authentication authentication ) {
        String principal = principalPrefix + authentication.getName();
        String password = "";
        if ( authentication.getCredentials() != null ) {
            password = authentication.getCredentials().toString();
        }
        if ( ! ( "".equals ( principal.trim() ) ) && ! ( "".equals ( password.trim() ) ) ) {
            InitialLdapContext ldapContext = ( InitialLdapContext ) contextFactory
                                             .getReadWriteContext ( principal, password );
            DirContextOperations authAdapter = new DirContextAdapter();
            authAdapter.addAttributeValue ( "ldapContext", ldapContext );
            return authAdapter;
        } else {
            throw new BadCredentialsException ( "Blank username and/or password!" );
        }
    }
    static public InitialLdapContext recreateLdapContext ( LdapAuthenticator authenticator,
            LdapAuthenticationToken auth ) {
        DirContextOperations authAdapter = authenticator.authenticate ( auth );
        InitialLdapContext context = ( InitialLdapContext ) authAdapter
                                     .getObjectAttribute ( "ldapContext" );
        auth.setContext ( context );
        return context;
    }
    public DefaultSpringSecurityContextSource getContextFactory() {
        return contextFactory;
    }
    public void setContextFactory ( DefaultSpringSecurityContextSource contextFactory ) {
        this.contextFactory = contextFactory;
    }
    public String getPrincipalPrefix() {
        return principalPrefix;
    }
    public void setPrincipalPrefix ( String principalPrefix ) {
        if ( principalPrefix != null ) {
            this.principalPrefix = principalPrefix;
        } else {
            this.principalPrefix = "";
        }
    }
}
