package net.sanjayts.test;
import java.lang.management.ManagementFactory;
import java.lang.management.ThreadInfo;
import java.util.concurrent.TimeUnit;
public class ThreadDumpTest {
    public static void main ( String[] args ) throws Exception {
        final Object lock = new Object();
        for ( int i = 0; i < 6; ++i ) {
            final int cnt = i;
            new DaemonThread ( new Runnable() {
                @Override
                public void run() {
                    try {
                        if ( cnt % 2 == 0 ) {
                            synchronized ( lock ) {
                                TimeUnit.MINUTES.sleep ( 1 );
                            }
                        } else {
                            TimeUnit.MINUTES.sleep ( 1 );
                        }
                    } catch ( InterruptedException e ) {
                        e.printStackTrace();
                    }
                }
            }, "mythread-" + cnt ).start();
        }
        ThreadInfo[] infos = ManagementFactory.
                             getThreadMXBean().dumpAllThreads ( true, true );
        for ( ThreadInfo info : infos ) {
            System.out.println ( info );
            System.out.println ( "===========================" );
        }
        TimeUnit.SECONDS.sleep ( 2 );
    }
}
class DaemonThread extends Thread {
    public DaemonThread ( Runnable r, String name ) {
        super ( r, name );
        setDaemon ( true );
    }
}
