public class HypotheticalApi {
    public static HypotheticalApi getInstance() {
    }
    public void getUserProfile ( String userName, final GetResponseCallback callback ) {
        String restUrl = Utils.constructRestUrlForProfile ( userName );
        new GetTask ( restUrl, new RestTaskCallback () {
            @Override
            public void onTaskComplete ( String response ) {
                Profile profile = Utils.parseResponseAsProfile ( response );
                callback.onDataReceived ( profile );
            }
        } ).execute();
    }
    public void postUserProfile ( Profile profile, final PostCallback callback ) {
        String restUrl = Utils.constructRestUrlForProfile ( profile );
        String requestBody = Utils.serializeProfileAsString ( profile );
        new PostTask ( restUrl, requestBody, new RestTaskCallback() {
            public void onTaskComplete ( String response ) {
                callback.onPostSuccess();
            }
        } ).execute();
    }
}
public abstract class GetResponseCallback {
    abstract void onDataReceived ( Profile profile );
}
public abstract class PostCallback {
    public abstract void onPostSuccess();
}
