public final class Foo {
    public static void main ( final String... args )
    throws IOException {
        final Pattern pattern
            = Pattern.compile ( "\\\\/Date\\((\\d+)(-\\d+)?\\)\\\\/" );
        final ObjectMapper mapper = new ObjectMapper();
        final JsonNode node = mapper.readTree (
                                  "{\"PostingDate\": \"\\/Date(1325134800000-0500)\\/\"}" );
        if ( !node.has ( "PostingDate" ) ) {
            System.err.println ( "Bad JSON input!" );
            System.exit ( 1 );
        }
        final String dateSpec = node.get ( "PostingDate" ).getTextValue();
        final Matcher matcher = pattern.matcher ( dateSpec );
        if ( !matcher.matches() ) {
            System.err.println ( "Bad pattern!" );
            System.exit ( 1 );
        }
        final long millis = Long.parseLong ( matcher.group ( 1 ) );
        String tz = matcher.group ( 2 );
        if ( tz.isEmpty() ) {
            tz = "+0000";
        }
        final Date date = new Date ( millis );
        System.out.printf ( "Date: %s %s\n",
                            new SimpleDateFormat ( "yyyy/MM/dd HH:MM:ss" ).format ( date ), tz );
    }
}
