public class Dawg {
    Dawg[] children = new Dawg[256];
    boolean isLeaf = false;
    public void add ( byte[] word ) {
        Dawg loc = find ( word, 0, true );
        loc.isLeaf = true;
    }
    public void add ( String word ) {
        add ( word.getBytes() );
    }
    public boolean contains ( byte [] word ) {
        Dawg d = find ( word, 0, false );
        return d != null && d.isLeaf;
    }
    public boolean contains ( String word ) {
        return contains ( word.getBytes() );
    }
    private Dawg find ( byte [] word, int i, boolean grow ) {
        Dawg child = children[word[i]];
        if ( child == null ) {
            if ( grow ) {
                child = new Dawg();
                children[word[i]] = child;
            }
        }
        if ( child != null ) {
            if ( i < word.length - 1 ) {
                child = child.find ( word, i + 1, grow );
            }
        }
        return child;
    }
    public static void main ( String[] args ) {
        Dawg d = new Dawg();
        d.add ( "H" );
        d.add ( "Hello" );
        d.add ( "World" );
        d.add ( "Hell" );
        System.out.println ( "Hello is " + ( d.contains ( "Hello" ) ? "in" : "out" ) );
        System.out.println ( "World is " + ( d.contains ( "World" ) ? "in" : "out" ) );
        System.out.println ( "Hell is " + ( d.contains ( "Hell" ) ? "in" : "out" ) );
        System.out.println ( "Hal is " + ( d.contains ( "Hal" ) ? "in" : "out" ) );
        System.out.println ( "Hel is " + ( d.contains ( "Hel" ) ? "in" : "out" ) );
        System.out.println ( "H is " + ( d.contains ( "H" ) ? "in" : "out" ) );
    }
}
