public static String snapFromHtmlWithCookies ( Context context, String xPath, String attrToSnap, String urlString,
        String cookies ) throws IOException, XPatherException {
    String snap = "";
    HtmlCleaner cleaner = new HtmlCleaner();
    CleanerProperties props = cleaner.getProperties();
    props.setAllowHtmlInsideAttributes ( true );
    props.setAllowMultiWordAttributes ( true );
    props.setRecognizeUnicodeChars ( true );
    props.setOmitComments ( true );
    URL url = new URL ( urlString );
    HttpURLConnection connection = ( HttpURLConnection ) url.openConnection();
    connection.setDoOutput ( true );
    connection.setRequestProperty ( context.getString ( R.string.cookie_prefix ), cookies );
    connection.connect();
    TagNode root = cleaner.clean ( new InputStreamReader ( connection.getInputStream() ) );
    Object[] foundNodes = root.evaluateXPath ( xPath );
    if ( foundNodes.length > 0 ) {
        TagNode foundNode = ( TagNode ) foundNodes[0];
        snap = foundNode.getAttributeByName ( attrToSnap );
    }
    return snap;
}
