private class BillingPurchaseObserver extends PurchaseObserver {
    public BillingPurchaseObserver ( Handler handler ) {
        super ( Pro.this, handler );
    }
    @Override
    public void onBillingSupported ( boolean supported ) {
        if ( supported ) {
        } else {
            Toast.makeText ( getApplicationContext(), R.string.billing_not_supported, Toast.LENGTH_LONG ).show();
        }
    }
    @Override
    public void onPurchaseStateChange ( PurchaseState purchaseState, String itemId,
                                        int quantity, long purchaseTime, String developerPayload ) {
        BillingItem item = BillingItem.getBySku ( getApplicationContext(), itemId );
        if ( purchaseState == PurchaseState.PURCHASED ) {
            if ( item != null ) {
                boolean resu = item.makePurchased ( getApplicationContext() );
                if ( resu ) {
                    Toast.makeText ( getApplicationContext(), R.string.billing_item_purchased, Toast.LENGTH_LONG ).show();
                }
            }
        }
    }
    private void trackPurchase ( BillingItem item, long purchaseTime ) {
    }
    @Override
    public void onRequestPurchaseResponse ( RequestPurchase request,
                                            ResponseCode responseCode ) {
        if ( responseCode == ResponseCode.RESULT_OK ) {
            Toast.makeText ( getApplicationContext(), R.string.billing_item_request_sent, Toast.LENGTH_SHORT ).show();
        } else if ( responseCode == ResponseCode.RESULT_USER_CANCELED ) {
        } else {
        }
    }
    @Override
    public void onRestoreTransactionsResponse ( RestoreTransactions request,
            ResponseCode responseCode ) {
        if ( responseCode == ResponseCode.RESULT_OK ) {
            SharedPreferences.Editor edit = PreferencesHelper.getInstance().getDefaultSettings ( getApplicationContext() ).edit();
            edit.putBoolean ( Consts.DB_INITIALIZED, true );
            edit.commit();
        } else {
        }
    }
}
