public class FruitPool extends GenericPool<Sprite> {
    private ITextureRegion[] mTextureRegions = new ITextureRegion[5];
    private Scene mScene;
    private int mCount;
    public FruitPool ( final ITextureRegion watermelonRegion, ITextureRegion cherryRegion, ITextureRegion mBallTextureRegion, ITextureRegion grapeTextureRegion, ITextureRegion strawberryTextureRegion, Scene attachedScene ) {
        this.mTextureRegions[0] = watermelonRegion;
        this.mTextureRegions[1] = cherryRegion;
        this.mTextureRegions[2] = mBallTextureRegion;
        this.mTextureRegions[3] = grapeTextureRegion;
        this.mTextureRegions[4] = strawberryTextureRegion;
        this.mScene = attachedScene;
    }
    @Override
    protected Sprite onAllocatePoolItem() {
        int fruitPos = MathUtils.random ( 0, 4 );
        final Sprite fruit = new Sprite ( 0, 0, this.mTextureRegions[fruitPos] );
        this.mScene.attachChild ( fruit );
        return fruit;
    }
    @Override
    protected void onHandleObtainItem ( final Sprite pItem ) {
        pItem.reset();
    }
    @Override
    protected void onHandleRecycleItem ( final Sprite pItem ) {
        pItem.setVisible ( false );
        pItem.setIgnoreUpdate ( true );
    }
}
