import java.awt.FlowLayout;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.awt.dnd.DropTarget;
import java.awt.dnd.DropTargetDragEvent;
import java.awt.dnd.DropTargetDropEvent;
import java.awt.dnd.DropTargetEvent;
import java.awt.dnd.DropTargetListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.IOException;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.TransferHandler;
public class NameSlot extends JLabel implements DropTargetListener {
    NameSlot ( final String name ) {
        super ( name );
        new DropTarget ( this, this );
        this.setTransferHandler ( new TransferHandler ( "text" ) );
        final MouseListener listener = new MouseAdapter() {
            @Override
            public void mousePressed ( final MouseEvent me ) {
                final JLabel comp = ( JLabel ) me.getSource();
                System.out.println ( comp );
                final TransferHandler handler = comp.getTransferHandler();
                handler.exportAsDrag ( comp, me, TransferHandler.COPY );
            }
        };
        this.addMouseListener ( listener );
    }
    @Override
    public void dragEnter ( final DropTargetDragEvent dtde ) {
    }
    @Override
    public void dragExit ( final DropTargetEvent dte ) {
    }
    @Override
    public void dragOver ( final DropTargetDragEvent dtde ) {
    }
    @Override
    public void drop ( final DropTargetDropEvent dtde ) {
        try {
            final String s = ( String ) dtde.getTransferable().getTransferData (
                                 new DataFlavor ( "application/x-java-jvm-local-objectref; class=java.lang.String" ) );
            System.out.println ( "drop detected from " + s + " to " + this.getText() );
        } catch ( final UnsupportedFlavorException e ) {
            e.printStackTrace();
        } catch ( final IOException e ) {
            e.printStackTrace();
        } catch ( final ClassNotFoundException e ) {
            e.printStackTrace();
        }
    }
    @Override
    public void dropActionChanged ( final DropTargetDragEvent dtde ) {
    }
    public static void main ( final String[] args ) {
        final JFrame frame = new JFrame();
        frame.setDefaultCloseOperation ( JFrame.DISPOSE_ON_CLOSE );
        frame.setLayout ( new FlowLayout() );
        final NameSlot ns = new NameSlot ( "test" );
        frame.add ( ns );
        final NameSlot ns2 = new NameSlot ( "test2" );
        frame.add ( ns2 );
        frame.pack();
        frame.setLocationRelativeTo ( null );
        frame.setVisible ( true );
    }
}
