public ParticleSystem createParticleSystem ( final TextureRegion waterDropTextureRegion ) {
    final float particlesXSpawn = 400;
    final float particlesYSpawn = 300;
    final float maxRate = 10;
    final float minRate = 5;
    final int maxParticles = 100;
    final PointParticleEmitter pointParticleEmtitter = new PointParticleEmitter ( particlesXSpawn, particlesYSpawn );
    final ParticleSystem particleSystem = new ParticleSystem ( pointParticleEmtitter, maxRate, minRate, maxParticles, waterDropTextureRegion );
    particleSystem.addParticleInitializer ( new VelocityInitializer ( -20, 20, -20, 20 ) );
    particleSystem.addParticleInitializer ( new GravityInitializer() );
    particleSystem.addParticleModifier ( new AlphaModifier ( 1, 0, 0, 3 ) );
    particleSystem.addParticleModifier ( new ExpireModifier ( 3 ) );
    return particleSystem;
}
