import com.google.common.base.Preconditions;
import com.google.inject.Inject;
import com.google.inject.Injector;
import com.google.inject.Key;
import com.google.inject.Module;
import com.google.inject.servlet.ServletScopes;
import java.util.Collections;
import java.util.Map;
import java.util.concurrent.Callable;
public final class RequestInjector {
    private final Map<Key<?>, Object> seedMap = Collections.emptyMap();
    private final Injector injector;
    @Inject
    private RequestInjector ( Injector injector ) {
        this.injector = injector;
    }
    public <V> Callable<V> scopeRequest ( final Class<? extends Callable<V>> callable,
                                          final Module... modules ) {
        Preconditions.checkNotNull ( callable, "callable may not be null" );
        return ServletScopes.scopeRequest ( new Callable<V>() {
            @Override
            public V call() throws Exception {
                return injector.createChildInjector ( modules ).getInstance ( callable ).call();
            }
        }, seedMap );
    }
}
