public final class Buffers {
    public static ByteBuffer clone ( ByteBuffer original ) {
        Preconditions.checkNotNull ( original, "original may not be null" );
        ByteBuffer result = ByteBuffer.allocate ( original.capacity() );
        ByteBuffer source = original.duplicate();
        source.rewind();
        result.put ( source );
        try {
            source.reset();
            result.position ( source.position() );
            result.mark();
        } catch ( InvalidMarkException unused ) {
        }
        result.position ( original.position() );
        result.limit ( original.limit() );
        return result;
    }
    public static byte[] toArray ( ByteBuffer buffer ) {
        if ( buffer.hasArray() && !buffer.isReadOnly() && buffer.position() == 0
                && buffer.remaining() == buffer.limit() ) {
            return buffer.array();
        }
        ByteBuffer copy = buffer.duplicate();
        byte[] result = new byte[copy.remaining()];
        copy.get ( result );
        return result;
    }
    private Buffers() {
    }
}
