@RunWith ( MockitoJUnitRunner.class )
public class RegistrationControllerTest {
    @InjectMocks
    private RegistrationController controllerUT = new RegistrationController();
    @Mock
    private RegistrationService registrationService;
    @Mock
    private ModelMap model;
    @Mock
    private BulkRegistration bulkRegistration;
    @Mock
    private FileData fileData;
    @Before
    public void setUp() {
        when ( bulkRegistration.getFileData() ).thenReturn ( fileData );
    }
    @Test
    public void testCreate() throws Exception {
        final String target = "bulkRegistration";
        BindingResult result = new BindingResult();
        String nextPage = null;
        nextPage = controllerUT.create ( bulkRegistration, result, model );
        assertEquals ( "Controller is not requesting the correct form", nextPage,
                       target );
    }
    @Test ( expected = NumberFormatException.class )
    public void testCreateWithNumberFormatException() throws Exception {
        doThrow ( new NumberFormatException() ).when ( registrationService )
        .processFile ( any ( File.class ), anyList() );
        BindingResult result = new BindingResult();
        controllerUT.create ( bulkRegistration, result, model );
    }
}
