public class ConfigurableDispatcherServlet extends DispatcherServlet {
    private String contextParent;
    protected WebApplicationContext initWebApplicationContext() {
        WebApplicationContext parent = WebApplicationContextUtils.getWebApplicationContext ( getServletContext(),
                                       "org.springframework.web.servlet.FrameworkServlet.CONTEXT." + getContextParent() );
        WebApplicationContext wac = createWebApplicationContext ( parent );
        String attrName = getServletContextAttributeName();
        getServletContext().setAttribute ( attrName, wac );
        if ( this.logger.isDebugEnabled() ) {
            this.logger.debug ( "Published WebApplicationContext of servlet '" + getServletName() +
                                "' as ServletContext attribute with name [" + attrName + "]" );
        }
        if ( this.logger.isInfoEnabled() ) {
            this.logger.info ( getServletName() + " is a child of " + parent.getDisplayName() );
        }
        return wac;
    }
    public String getContextParent() {
        return contextParent;
    }
    public void setContextParent ( String contextParent ) {
        this.contextParent = contextParent;
    }
}
