@RunWith ( SpringJUnit4ClassRunner.class )
@ContextConfiguration ( locations = { "classpath:applicationContext.xml" } )
@TestExecutionListeners ( { DependencyInjectionTestExecutionListener.class,
                            DirtiesContextTestExecutionListener.class
                          } )
public class MyDaoTest extends DBTestCase {
    @Autowired
    private MyDao myDao;
    @Autowired
    private BasicDataSource dataSource;
    private IDatabaseTester databaseTester;
    @Before
    public void setUp() throws Exception {
        databaseTester = new DataSourceDatabaseTester ( dataSource );
        databaseTester.setDataSet ( this.getDataSet() );
        databaseTester.setSetUpOperation ( this.getSetUpOperation() );
        databaseTester.onSetup();
    }
    @After
    public void tearDown() throws Exception {
        databaseTester.setTearDownOperation ( this.getTearDownOperation() );
        databaseTester.onTearDown();
    }
    @Override
    protected IDataSet getDataSet() throws Exception {
        final FlatXmlDataSetBuilder builder = new FlatXmlDataSetBuilder();
        builder.setColumnSensing ( true );
        return builder.build ( this.getClass().getClassLoader()
                               .getResourceAsStream ( "data.xml" ) );
    }
    @Override
    protected DatabaseOperation getSetUpOperation() {
        return DatabaseOperation.CLEAN_INSERT;
    }
    @Override
    protected DatabaseOperation getTearDownOperation() {
        return DatabaseOperation.TRUNCATE_TABLE;
    }
    @Override
    protected void closeConnection ( IDatabaseConnection conn ) {
    }
