public static DateTime dateTimeFloor ( DateTime dt, Period p ) {
    if ( p.getYears() != 0 ) {
        return dt.yearOfEra().roundFloorCopy().minusYears ( dt.getYearOfEra() % p.getYears() );
    } else if ( p.getMonths() != 0 ) {
        return dt.monthOfYear().roundFloorCopy().minusMonths ( ( dt.getMonthOfYear() - 1 ) % p.getMonths() );
    } else if ( p.getWeeks() != 0 ) {
        return dt.weekOfWeekyear().roundFloorCopy().minusWeeks ( ( dt.getWeekOfWeekyear() - 1 ) % p.getWeeks() );
    } else if ( p.getDays() != 0 ) {
        return dt.dayOfMonth().roundFloorCopy().minusDays ( ( dt.getDayOfMonth() - 1 ) % p.getDays() );
    } else if ( p.getHours() != 0 ) {
        return dt.hourOfDay().roundFloorCopy().minusHours ( dt.getHourOfDay() % p.getHours() );
    } else if ( p.getMinutes() != 0 ) {
        return dt.minuteOfHour().roundFloorCopy().minusMinutes ( dt.getMinuteOfHour() % p.getMinutes() );
    } else if ( p.getSeconds() != 0 ) {
        return dt.secondOfMinute().roundFloorCopy().minusSeconds ( dt.getSecondOfMinute() % p.getSeconds() );
    }
    return dt.millisOfSecond().roundCeilingCopy().minusMillis ( dt.getMillisOfSecond() % p.getMillis() );
}
