public class MainThread extends Thread {
    private SurfaceHolder surfaceHolder;
    private MainGamePanel gamePanel;
    private boolean running;
    public boolean pleaseWait = true;
    public void setRunning ( boolean running ) {
        this.running = running;
    }
    public MainThread ( SurfaceHolder surfaceHolder, MainGamePanel gamePanel ) {
        super();
        this.surfaceHolder = surfaceHolder;
        this.gamePanel = gamePanel;
    }
    @Override
    public void run() {
        Canvas canvas;
        while ( running ) {
            if ( !pleaseWait ) {
                canvas = null;
                try {
                    canvas = this.surfaceHolder.lockCanvas();
                    synchronized ( surfaceHolder ) {
                        this.gamePanel.update();
                        this.gamePanel.onDraw ( canvas );
                    }
                } finally {
                    if ( canvas != null ) {
                        surfaceHolder.unlockCanvasAndPost ( canvas );
                    }
                }
            } else {
                synchronized ( this ) {
                    try {
                        wait();
                    } catch ( Exception e ) { }
                }
            }
        }
    }
}
