FtpServerFactory serverFactory = new FtpServerFactory();
ListenerFactory factory = new ListenerFactory();
factory.setPort ( 1234 );
serverFactory.addListener ( "default", factory.createListener() );
PropertiesUserManagerFactory userManagerFactory = new PropertiesUserManagerFactory();
userManagerFactory.setFile ( new File ( "/home/blablah/myusers.properties" ) );
userManagerFactory.setPasswordEncryptor ( new PasswordEncryptor() {
    @Override
    public String encrypt ( String password ) {
        return password;
    }
    @Override
    public boolean matches ( String passwordToCheck, String storedPassword ) {
        return passwordToCheck.equals ( storedPassword );
    }
} );
BaseUser user = new BaseUser();
user.setName ( "test" );
user.setPassword ( "test" );
user.setHomeDirectory ( "/home/blablah" );
List<Authority> authorities = new ArrayList<Authority>();
authorities.add ( new WritePermission() );
user.setAuthorities ( authorities );
UserManager um = userManagerFactory.createUserManager();
try {
    um.save ( user );
} catch ( FtpException e1 ) {
}
serverFactory.setUserManager ( um );
Map<String, Ftplet> m = new HashMap<String, Ftplet>();
m.put ( "miaFtplet", new Ftplet() {
    @Override
    public void init ( FtpletContext ftpletContext ) throws FtpException {
    }
    @Override
    public void destroy() {
    }
    @Override
    public FtpletResult beforeCommand ( FtpSession session, FtpRequest request ) throws FtpException, IOException {
        return FtpletResult.DEFAULT;
    }
    @Override
    public FtpletResult afterCommand ( FtpSession session, FtpRequest request, FtpReply reply ) throws FtpException, IOException {
        return FtpletResult.DEFAULT;
    }
    @Override
    public FtpletResult onConnect ( FtpSession session ) throws FtpException, IOException {
        return FtpletResult.DEFAULT;
    }
    @Override
    public FtpletResult onDisconnect ( FtpSession session ) throws FtpException, IOException {
        return FtpletResult.DEFAULT;
    }
} );
serverFactory.setFtplets ( m );
FtpServer server = serverFactory.createServer();
try {
    server.start();
} catch ( FtpException ex ) {
}
