@WebFilter ( "/*" )
public class ResponseLogger implements Filter {
    @Override
    public void init ( FilterConfig config ) throws ServletException {
    }
    @Override
    public void doFilter ( ServletRequest request, ServletResponse response, FilterChain chain ) throws ServletException, IOException {
        if ( response.getCharacterEncoding() == null ) {
            response.setCharacterEncoding ( "UTF-8" );
        }
        HttpServletResponseCopier responseCopier = new HttpServletResponseCopier ( ( HttpServletResponse ) response );
        try {
            chain.doFilter ( request, responseCopier );
            responseCopier.flushBuffer();
        } finally {
            byte[] copy = responseCopier.getCopy();
            System.out.println ( new String ( copy, response.getCharacterEncoding() ) );
        }
    }
    @Override
    public void destroy() {
    }
}
