package com.edwinbuck;
import java.io.PrintStream;
import java.util.HashSet;
import java.util.Set;
import org.apache.tools.ant.BuildLogger;
import org.apache.tools.ant.BuildEvent;
import org.apache.tools.ant.util.StringUtils;
public class JavacFileLogger implements BuildLogger {
    protected PrintStream out;
    protected PrintStream err;
    protected static final String eol = StringUtils.LINE_SEP;
    private Set<String> errorFiles = new HashSet<String>();
    private boolean ignoringMessages = true;
    public void buildStarted ( BuildEvent event ) {
    }
    public void buildFinished ( BuildEvent event ) {
    }
    public void targetStarted ( BuildEvent event ) {
    }
    public void targetFinished ( BuildEvent event ) {
    }
    public void taskStarted ( BuildEvent event ) {
        if ( event.getTask().getTaskName().equals ( "javac" ) ) {
            ignoringMessages = false;
        }
    }
    public void taskFinished ( BuildEvent event ) {
        if ( event.getTask().getTaskName().equals ( "javac" ) ) {
            ignoringMessages = true;
            for ( String filename : errorFiles ) {
                out.print ( filename );
                out.print ( eol );
            }
        }
    }
    public void messageLogged ( BuildEvent event ) {
        if ( !ignoringMessages ) {
            if ( event.getMessage().contains ( ".java:" ) ) {
                errorFiles.add ( event.getMessage().substring ( 0, event.getMessage().indexOf ( ":" ) ) );
            }
        }
    }
    public void setErrorPrintStream ( PrintStream err ) {
        this.err = err;
    }
    public void setEmacsMode ( boolean emacsMode ) {
    }
    public void setOutputPrintStream ( PrintStream output ) {
        this.out = output;
    }
    public void setMessageOutputLevel ( int level ) {
    }
}
