public class DataChangeEvent {
    private String message;
    public DataChangeEvent ( String message ) {
        this.message = message;
    }
    public String getMessage() {
        return message;
    }
}
public interface DataChangeListenter {
    public void dataChangeEvent ( DataChangeEvent event );
}
public class DataChangedHandler {
    private static List<DataChangeListenter> listeners = new ArrayList<DataChangeListenter>();
    public static void registerDataChangeListener ( DataChangeListenter listener ) {
        listeners.add ( listener );
    }
    public static void fireDataChange ( DataChangeEvent dataChangeEvent ) {
        for ( DataChangeListenter listenter : listeners ) {
            listenter.dataChangeEvent ( dataChangeEvent );
        }
    }
}
public class ProcessMessage implements DataChangeListenter {
    public ProcessMessage() {
        DataChangedHandler.registerDataChangeListener ( this );
    }
    public void dataChangeEvent ( DataChangeEvent event ) {
        System.out.println ( event.getMessage() );
    }
}
public class TelnetClientHandler extends SimpleChannelHandler {
    private static final Logger logger = Logger.getLogger ( TelnetClientHandler.class.getName() );
    @Override
    public void messageReceived ( ChannelHandlerContext ctx, MessageEvent e ) {
        String message = ( String ) e.getMessage();
        DataChangedHandler.fireDataChange ( message );
    }
}
