public abstract class MyUtility {
    public static boolean addFavoriteItem ( Activity activity, String favoriteItem ) {
        String favoriteList = getStringFromPreferences ( activity, null, "favorites" );
        if ( favoriteList != null ) {
            favoriteList = favoriteList + "," + favoriteItem;
        } else {
            favoriteList = favoriteItem;
        }
        return putStringInPreferences ( activity, favoriteList, "favorites" );
    }
    public static String[] getFavoriteList ( Activity activity ) {
        String favoriteList = getStringFromPreferences ( activity, null, "favorites" );
        return convertStringToArray ( favoriteList );
    }
    private static boolean putStringInPreferences ( Activity activity, String nick, String key ) {
        SharedPreferences sharedPreferences = activity.getPreferences ( Activity.MODE_PRIVATE );
        SharedPreferences.Editor editor = sharedPreferences.edit();
        editor.putString ( key, nick );
        editor.commit();
        return true;
    }
    private static String getStringFromPreferences ( Activity activity, String defaultValue, String key ) {
        SharedPreferences sharedPreferences = activity.getPreferences ( Activity.MODE_PRIVATE );
        String temp = sharedPreferences.getString ( key, defaultValue );
        return temp;
    }
    private static String[] convertStringToArray ( String str ) {
        String[] arr = str.split ( "," );
        return arr;
    }
}
