private static Integer evaluate ( Node node, Map<string, Integer> vars ) {
    if ( node is an assignment ) {
        String varName = ...
                         Node expr = ...
                                     Integer value = evaluate ( expr, vars );
        vars.put ( varName, value );
        return value;
    }
    if ( node is a variable reference ) {
        String varName = ...
                         return vars.get ( varName );
    }
    if ( node is an integer constant ) {
        String constVal = ...
                          return Integer.decode ( constVal );
    }
    if ( node is a binary expression ) {
        Node lhs = ...
                   Node rhs = ...
                              Integer lhsVal = evaluate ( lhs, vars );
        Integer rhsVal = evaluate ( rhs, vars );
        if ( operator is plus ) {
            return new Integer ( ( ( int ) lhsVal ) + ( ( int ) rhsVal ) );
        }
        if ( operator is minus ) {
            return new Integer ( ( ( int ) lhsVal ) - ( ( int ) rhsVal ) );
        }
        if ( operator is multiply ) {
            return new Integer ( ( ( int ) lhsVal ) * ( ( int ) rhsVal ) );
        }
        if ( operator is divide ) {
            return new Integer ( ( ( int ) lhsVal ) / ( ( int ) rhsVal ) );
        }
    }
}
