class TexfFieldStreamer extends InputStream implements ActionListener {
    private JTextField tf;
    private String str = null;
    private int pos = 0;
    public TexfFieldStreamer ( JTextField jtf ) {
        tf = jtf;
    }
    @Override
    public void actionPerformed ( ActionEvent e ) {
        str = tf.getText() + "\n";
        pos = 0;
        tf.setText ( "" );
        synchronized ( this ) {
            this.notifyAll();
        }
    }
    @Override
    public int read() {
        if ( str != null && pos == str.length() ) {
            str = null;
            return java.io.StreamTokenizer.TT_EOF;
        }
        while ( str == null || pos >= str.length() ) {
            try {
                synchronized ( this ) {
                    this.wait();
                }
            } catch ( InterruptedException ex ) {
                ex.printStackTrace();
            }
        }
        return str.charAt ( pos++ );
    }
}
