import java.util.List;
import android.content.Context;
import android.content.pm.ApplicationInfo;
import android.content.pm.PackageManager;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;
import com.plop.R;
public class AppliAdaptateur extends BaseAdapter {
    private Context mContext;
    private List mListAppInfo;
    private PackageManager mPackManager;
    public AppliAdaptateur ( Context c, List list, PackageManager pm ) {
        mContext = c;
        mListAppInfo = list;
        mPackManager = pm;
    }
    @Override
    public int getCount() {
        return mListAppInfo.size();
    }
    @Override
    public Object getItem ( int position ) {
        return mListAppInfo.get ( position );
    }
    @Override
    public long getItemId ( int position ) {
        return position;
    }
    @Override
    public View getView ( int position, View convertView, ViewGroup parent ) {
        ApplicationInfo entry = ( ApplicationInfo ) mListAppInfo.get ( position );
        View v = convertView;
        if ( v == null ) {
            LayoutInflater inflater = LayoutInflater.from ( mContext );
            v = inflater.inflate ( R.layout.appliligne, null );
        }
        ImageView ivAppIcon = ( ImageView ) v.findViewById ( R.id.ivIcon );
        TextView tvAppName = ( TextView ) v.findViewById ( R.id.tvName );
        TextView tvPkgName = ( TextView ) v.findViewById ( R.id.tvPack );
        ivAppIcon.setImageDrawable ( entry.loadIcon ( mPackManager ) );
        tvAppName.setText ( entry.loadLabel ( mPackManager ) );
        tvPkgName.setText ( entry.packageName );
        return v;
    }
}
