public Map<String, List<Class<?>>> loadAndScanJar ( File jarFile )
throws ClassNotFoundException, ZipException, IOException {
    super.addURL ( jarFile.toURI().toURL() );
    Map<String, List<Class<?>>> classes = new HashMap<String, List<Class<?>>>();
    List<Class<?>> interfaces = new ArrayList<Class<?>>();
    List<Class<?>> clazzes = new ArrayList<Class<?>>();
    List<Class<?>> enums = new ArrayList<Class<?>>();
    List<Class<?>> annotations = new ArrayList<Class<?>>();
    classes.put ( "interfaces", interfaces );
    classes.put ( "classes", clazzes );
    classes.put ( "annotations", annotations );
    classes.put ( "enums", enums );
    int count = 0;
    JarFile jar = new JarFile ( jarFile );
    Enumeration<? extends JarEntry> enumeration = jar.entries();
    while ( enumeration.hasMoreElements() ) {
        ZipEntry zipEntry = enumeration.nextElement();
        if ( zipEntry.getName().endsWith ( ".class" ) ) {
            String className = zipEntry.getName();
            className = className.replace ( ".class", "" ).replace ( "/", "." );
            Class<?> clazz = this.loadClass ( className );
            try {
                if ( clazz.isInterface() ) {
                    interfaces.add ( clazz );
                } else if ( clazz.isAnnotation() ) {
                    annotations.add ( clazz );
                } else if ( clazz.isEnum() ) {
                    enums.add ( clazz );
                } else {
                    clazzes.add ( clazz );
                }
                count++;
            } catch ( ClassCastException e ) {
            }
        }
    }
    System.out.println ( "Total: " + count );
    return classes;
}
