public class DifferentialEvolution {
    public static final double alpha = 0.001;
    public static double evaluate ( double x ) {
        return -x * ( x + 1 );
    }
    public static double max ( int N ) {
        double[] xs  = new double[N];
        for ( int j = 0; j < N; j++ ) {
            xs[j] = Math.random() * 1000.0 - 500.0;
        }
        boolean done = false;
        while ( !done ) {
            for ( int j = 0; j < N; j++ ) {
                double yj1 = xs[ ( int ) ( Math.random() * N )];
                double yj2 = xs[ ( int ) ( Math.random() * N )];
                double cj = xs[j] + alpha * ( yj1 - yj2 );
                if ( evaluate ( cj ) > evaluate ( xs[j] ) ) {
                    xs[j] = cj;
                }
            }
            double average = average ( xs );
            done = true;
            for ( int j = 0; j < N; j++ ) {
                if ( !about ( xs[j], average ) ) {
                    done = false;
                    break;
                }
            }
        }
        return average ( xs );
    }
    public static double average ( double[] values ) {
        double sum = 0;
        for ( int i = 0; i < values.length; i++ ) {
            sum += values[i];
        }
        return sum / values.length;
    }
    public static boolean about ( double a, double b ) {
        if ( Math.abs ( a - b ) <= alpha / 10000 ) {
            return true;
        }
        return false;
    }
    public static void main ( String[] args ) {
        long t = System.currentTimeMillis();
        System.out.println ( max ( 3 ) );
        System.out.println ( "Time (Milliseconds): " + ( System.currentTimeMillis() - t ) );
    }
