static class Fingering {
    int string;
    int fret;
    public String toString() {
        return "String : " + stringNames[string] + ", fret : " + fret;
    }
}
static String[] stringNames = new String[] {"Low E", "A", "D", "G", "B", "High E"};
static int[] strings = new int[] {64, 69, 74, 79, 83, 88};
public static Fingering getIdealFingering ( int note ) {
    if ( note < strings[0] ) {
        throw new RuntimeException ( "Note " + note + " is not playable on a guitar in standard tuning." );
    }
    Fingering result = new Fingering();
    int idealString = 0;
    for ( int x = 1; x < strings.length; x++ ) {
        if ( note < strings[x] ) {
            break;
        }
        idealString = x;
    }
    result.string = idealString;
    result.fret = note - strings[idealString];
    return result;
}
public static void main ( String[] args ) {
    System.out.println ( getIdealFingering ( 64 ) );
    System.out.println ( getIdealFingering ( 66 ) );
    System.out.println ( getIdealFingering ( 72 ) );
    System.out.println ( getIdealFingering ( 76 ) );
    System.out.println ( getIdealFingering ( 88 ) );
    System.out.println ( getIdealFingering ( 100 ) );
    System.out.println ( getIdealFingering ( 103 ) );
}
