public class PrivateMemberPlugin
    extends Plugin {
    @Override
    public String getOptionName() {
        return "Xpm";
    }
    @Override
    public String getUsage() {
        return "  -Xpm    : Change members visibility to private";
    }
    @Override
    public boolean run ( Outline model, Options opt, ErrorHandler errorHandler )
    throws SAXException {
        for ( ClassOutline co : model.getClasses() ) {
            JDefinedClass jdc = co.implClass;
            List<JFieldVar> fields = new ArrayList<JFieldVar> ( jdc.fields().values() );
            for ( JFieldVar field : fields ) {
                if ( !field.name().equalsIgnoreCase ( "serialVersionuid" ) ) {
                    if ( field.mods().getValue() != JMod.PRIVATE ) {
                        jdc.removeField ( field );
                        jdc.field ( JMod.PRIVATE, field.type(), field.name() );
                    }
                }
            }
        }
        return true;
    }
}
