class LazyIterator implements Iterator<Foo> {
    private Iterator<Foo> backingIterator = null;
    private void lazyLoad() {
        if ( backingIterator != null ) {
            return;
        }
    }
    @Override
    public boolean hasNext() {
        lazyLoad();
        return backingIterator.hasNext();
    }
    @Override
    public Foo next() {
        lazyLoad();
        return backingIterator.next();
    }
    @Override
    public void remove() {
        lazyLoad();
        backingIterator.remove();
    }
}
