@Context
private HttpServletRequest httpRequest;
@Context
private UriInfo uriInfo;
public Response handleResponse ( Message message, OperationResourceInfo opResourceInfo, Response response ) {
    try {
        logContextData ( httpRequest, uriInfo );
        OutputStream os = message.getContent ( OutputStream.class );
        String relevantData = getDataFromRequest ( httpRequest );
        message.setContent ( OutputStream.class, new MyOutputStreamWrapper ( os, relevantData ) );
    } catch ( CustomException e ) {
        return Response.status ( Status.UNAUTHORIZED ).build();
    } catch ( Exception e ) {
        return Response.status ( Status.INTERNAL_SERVER_ERROR ).build();
    }
    return response;
}
public Response handleRequest ( Message message, ClassResourceInfo classResourceInfo ) {
    try {
        logContextData();
        String updatedQueryString = buildNewQueryString ( this.uriInfo, httpRequest );
        message.put ( Message.QUERY_STRING, updatedQueryString );
        return null;
    } catch ( CustomException e ) {
        return Response.status ( Status.UNAUTHORIZED ).build();
    } catch ( Exception e ) {
        return Response.status ( Status.INTERNAL_SERVER_ERROR ).build();
    }
}
