package excelfilereading;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.apache.poi.hssf.usermodel.HSSFCell;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.Iterator;
import java.util.List;
import java.util.ArrayList;
public class Main {
    @SuppressWarnings ( "unchecked" )
    public static void main ( String[] args ) throws Exception {
        String filename = "FirstExcel.xls";
        List sheetData = new ArrayList();
        FileInputStream fis = null;
        try {
            fis = new FileInputStream ( filename );
            HSSFWorkbook workbook = new HSSFWorkbook ( fis );
            HSSFSheet sheet = workbook.getSheetAt ( 0 );
            Iterator rows = sheet.rowIterator();
            while ( rows.hasNext() ) {
                HSSFRow row = ( HSSFRow ) rows.next();
                Iterator cells = row.cellIterator();
                List data = new ArrayList();
                while ( cells.hasNext() ) {
                    HSSFCell cell = ( HSSFCell ) cells.next();
                    data.add ( cell );
                }
                sheetData.add ( data );
            }
        } catch ( IOException e ) {
            e.printStackTrace();
        } finally {
            if ( fis != null ) {
                fis.close();
            }
        }
        showExelData ( sheetData );
    }
    private static void showExelData ( List sheetData ) {
        for ( int i = 0; i < sheetData.size(); i++ ) {
            List list = ( List ) sheetData.get ( i );
            for ( int j = 0; j < list.size(); j++ ) {
                HSSFCell cell = ( HSSFCell ) list.get ( j );
                System.out.print (
                    cell.getRichStringCellValue().getString() );
                if ( j < list.size() - 1 ) {
                    System.out.print ( ", " );
                }
            }
            System.out.println ( "" );
        }
    }
}
