import org.apache.maven.plugin.AbstractMojo;
import org.apache.maven.plugin.MojoExecutionException;
import org.apache.maven.project.MavenProject;
import org.sonatype.aether.RepositorySystem;
import org.sonatype.aether.RepositorySystemSession;
import org.sonatype.aether.artifact.Artifact;
import org.sonatype.aether.collection.CollectRequest;
import org.sonatype.aether.graph.Dependency;
import org.sonatype.aether.graph.DependencyNode;
import org.sonatype.aether.repository.RemoteRepository;
import org.sonatype.aether.resolution.DependencyRequest;
import org.sonatype.aether.util.artifact.DefaultArtifact;
import org.sonatype.aether.util.graph.PreorderNodeListGenerator;
import java.util.ArrayList;
import java.util.List;
@SuppressWarnings ( "unchecked" )
public class ShareableJarsInWarsExtractor extends AbstractMojo {
    private MavenProject project;
    private RepositorySystem repoSystem;
    private RepositorySystemSession repoSession;
    private List<RemoteRepository> remoteRepos;
    public void execute() throws MojoExecutionException {
        Artifact projectArtifact = getProjectArtifact();
        List<Dependency> projectDependencies = getArtifactsDependencies ( projectArtifact );
        for ( Dependency d : projectDependencies ) {
            if ( d.getArtifact() != null && "war".equals ( d.getArtifact().getExtension() ) ) {
                List<Dependency> warDependencies = getArtifactsDependencies ( d.getArtifact() );
            }
        }
    }
    private List<Dependency> getArtifactsDependencies ( Artifact a ) {
        List<Dependency> ret = new ArrayList<Dependency>();
        DefaultArtifact pomArtifact = new DefaultArtifact ( a.getGroupId(), a.getArtifactId(), "pom", a.getVersion() );
        CollectRequest collectRequest = new CollectRequest();
        collectRequest.setRoot ( new Dependency ( pomArtifact, "compile" ) );
        collectRequest.setRepositories ( remoteRepos );
        try {
            DependencyNode node = repoSystem.collectDependencies ( repoSession, collectRequest ).getRoot();
            DependencyRequest projectDependencyRequest = new DependencyRequest ( node, null );
            repoSystem.resolveDependencies ( repoSession, projectDependencyRequest );
            PreorderNodeListGenerator nlg = new PreorderNodeListGenerator();
            node.accept ( nlg );
            ret.addAll ( nlg.getDependencies ( true ) );
        } catch ( Exception e ) {
            e.printStackTrace();
        }
        return ret;
    }
    private Artifact getProjectArtifact() {
        return new DefaultArtifact ( project.getArtifact().toString() );
    }
}
