public class ServiceContextHandler implements SOAPHandler<SOAPMessageContext> {
    private static final Logger logger = LoggerFactory.getLogger ( ServiceContextHandler.class );
    @Autowired
    private SOAPHeaderData soapHeaderData;
    @PostConstruct
    public void init() {
        SpringBeanAutowiringSupport.processInjectionBasedOnCurrentContext ( this );
    }
    public void close ( MessageContext context ) {
    }
    public boolean handleFault ( SOAPMessageContext context ) {
        return true;
    }
    public boolean handleMessage ( SOAPMessageContext context ) {
        if ( ! ( ( Boolean ) context.get ( SOAPMessageContext.MESSAGE_OUTBOUND_PROPERTY ) ).booleanValue() ) {
            process ( context );
        }
        return true;
    }
    public Set<QName> getHeaders() {
        return null;
    }
    @SuppressWarnings ( "unchecked" )
    private void process ( SOAPMessageContext context ) {
        try {
            JAXBContext jc = JAXBContext.newInstance ( ObjectFactory.class );
            Object[] headers = context.getHeaders ( new ObjectFactory().createServiceContext ( null ).getName(), jc, true );
            for ( Object header : headers ) {
                if ( ( header instanceof JAXBElement<?> ) && ( ( JAXBElement<?> ) header ).getValue() instanceof ServiceContextType ) {
                    soapHeaderData.setServiceContext ( ( ( JAXBElement<ServiceContextType> ) header ).getValue() );
                    break;
                }
            }
        } catch ( JAXBException e ) {
            logger.error ( ExceptionUtils.getStackTrace ( e ) );
        } catch ( WebServiceException e ) {
            logger.error ( ExceptionUtils.getStackTrace ( e ) );
        }
    }
}
