import java.awt.*;
import javax.swing.*;
import javax.swing.text.AbstractDocument;
import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import javax.swing.text.DocumentFilter;
import javax.swing.text.DocumentFilter.FilterBypass;
public class InputInteger {
    private JTextField tField;
    private MyDocumentFilter documentFilter;
    private void displayGUI() {
        JFrame frame = new JFrame ( "Input Integer Example" );
        frame.setDefaultCloseOperation ( JFrame.DISPOSE_ON_CLOSE );
        JPanel contentPane = new JPanel();
        contentPane.setBorder (
            BorderFactory.createEmptyBorder ( 5, 5, 5, 5 ) );
        tField = new JTextField ( 10 );
        ( ( AbstractDocument ) tField.getDocument() ).setDocumentFilter (
            new MyDocumentFilter() );
        contentPane.add ( tField );
        frame.setContentPane ( contentPane );
        frame.pack();
        frame.setLocationByPlatform ( true );
        frame.setVisible ( true );
    }
    public static void main ( String[] args ) {
        Runnable runnable = new Runnable() {
            @Override
            public void run() {
                new InputInteger().displayGUI();
            }
        };
        EventQueue.invokeLater ( runnable );
    }
}
class MyDocumentFilter extends DocumentFilter {
    @Override
    public void insertString ( DocumentFilter.FilterBypass fp
                               , int offset, String string, AttributeSet aset )
    throws BadLocationException {
        int len = string.length();
        boolean isValidInteger = true;
        for ( int i = 0; i < len; i++ ) {
            if ( !Character.isDigit ( string.charAt ( i ) ) ) {
                isValidInteger = false;
                break;
            }
        }
        if ( isValidInteger ) {
            super.insertString ( fp, offset, string, aset );
        } else {
            Toolkit.getDefaultToolkit().beep();
        }
    }
    @Override
    public void replace ( DocumentFilter.FilterBypass fp, int offset
                          , int length, String string, AttributeSet aset )
    throws BadLocationException {
        int len = string.length();
        boolean isValidInteger = true;
        for ( int i = 0; i < len; i++ ) {
            if ( !Character.isDigit ( string.charAt ( i ) ) ) {
                isValidInteger = false;
                break;
            }
        }
        if ( isValidInteger ) {
            super.replace ( fp, offset, length, string, aset );
        } else {
            Toolkit.getDefaultToolkit().beep();
        }
    }
}
