import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
public class ShellTest {
    public static void main ( String[] args ) {
        final Display display = new Display();
        final Shell shell = new Shell ( display );
        shell.setLayout ( new GridLayout() );
        Button b = new Button ( shell, SWT.PUSH );
        b.setText ( "Open Shell" );
        b.addSelectionListener ( new SelectionAdapter() {
            public void widgetSelected ( SelectionEvent e ) {
                openNewShell ( shell );
            }
        } );
        shell.setSize ( 250, 150 );
        shell.open();
        while ( !shell.isDisposed() ) {
            if ( !display.readAndDispatch() ) {
                display.sleep();
            }
        }
        display.dispose();
    }
    protected static void openNewShell ( final Shell shell ) {
        Shell child = new Shell ( shell, SWT.TITLE | SWT.SYSTEM_MODAL | SWT.CLOSE | SWT.MAX );
        child.setSize ( 100, 100 );
        child.setLayout ( new GridLayout() );
        child.setLayoutData ( new GridData ( SWT.FILL, SWT.FILL, true, true ) );
        child.open();
    }
}
