package com.stackoverflow.haylem.sublists;
import java.util.ArrayList;
import java.util.List;
public class SubLists {
    public static <T> List<List<T>> partition ( List<T> l, final int nPartitions ) {
        final List<List<T>> partitions = new ArrayList<List<T>> ( nPartitions );
        final int           nElements  = l.size() / nPartitions;
        final int           nRest      = l.size() % nElements;
        for ( int i = 0; i < nPartitions; i++ ) {
            partitions.add ( l.subList (
                                 i * nElements,
                                 i * nElements + nElements
                             ) );
        }
        if ( nRest > 0 ) {
            partitions.add ( l.subList (
                                 nPartitions * nElements,
                                 ( nPartitions * nElements ) + nRest ) );
        }
        return ( partitions );
    }
    public static List<String>      generateStringList ( final int size ) {
        final List<String> data = new ArrayList<String> ( size );
        for ( int i = 0; i < 129; i++ ) {
            data.add ( "String " + i );
        }
        return ( data );
    }
    public static <T> void          printSubLists ( final List<List<T>> sLists ) {
        for ( int i = 0; i < sLists.size(); i++ ) {
            System.out.println ( "partition " + i );
            for ( final T element : sLists.get ( i ) ) {
                System.out.println ( " " + element );
            }
        }
    }
    public static void              test() {
        final List<String> data = generateStringList ( 129 );
        printSubLists ( partition ( data, 5 ) );
        printSubLists ( partition ( data, data.size() / 4 ) );
    }
}
