public static class MyDBWorker extends SwingWorker<Void, Object[]> {
    private JTable table;
    private DefaultTableModel model;
    private ResultSet resultado;
    public MyDBWorker ( JTable table, ResultSet resultado ) {
        this.table = table;
        this.resultado = resultado;
    }
    @Override
    protected Void doInBackground() throws Exception {
        ResultSetMetaData metadata = resultado.getMetaData();
        int columnas = metadata.getColumnCount();
        Object[] etiquetas = new Object[columnas];
        for ( int i = 0; i < columnas; i++ ) {
            etiquetas[i] = metadata.getColumnName ( i + 1 );
        }
        publish ( etiquetas );
        while ( resultado.next() && !this.isCancelled() ) {
            Object fila[] = new Object[columnas];
            for ( int i = 0; i < columnas; i++ ) {
                fila[i] = resultado.getObject ( i + 1 );
            }
            publish ( fila );
        }
        return null;
    }
    @Override
    protected void process ( List<Object[]> chunks ) {
        int startIndex = 0;
        if ( model == null ) {
            model = new DefaultTableModel();
            model.setColumnIdentifiers ( chunks.get ( 0 ) );
            table.setModel ( model );
            startIndex = 1;
        }
        for ( int i = startIndex; i < chunks.size(); i++ ) {
            model.addRow ( chunks.get ( i ) );
        }
    }
    @Override
    protected void done() {
        if ( isCancelled() ) {
            return;
        }
        try {
            get();
            if ( table.getModel().getRowCount() == 0 ) {
            }
        } catch ( ExecutionException e ) {
        } catch ( InterruptedException e ) {
        }
    }
}
SwingWorker worker = new MyDBWorker ( table, resultado );
PropertyChangeListener stateListener = new PropertyChangeListener() {
    @Override
    public void propertyChange ( PropertyChangeEvent e ) {
        if ( e.getNewValue() == SwingWorker.StateValue.STARTED ) {
            progressBar.setIndeterminate ( true );
        }
        if ( e.getNewValue() == SwingWorker.StateValue.DONE ) {
            progressBar.setIndeterminate ( false );
        }
    }
};
worker.addPropertyChangeListener ( doneListener );
worker.execute();
