if ( time >= 100000 ) {
    latitude = 0;
    longitude = 0;
}
} catch ( NullPointerException e ) {
    System.out.println ( "Null" );
    e.printStackTrace();
} catch ( Exception e ) {
    e.printStackTrace();
}
runAsyncTask();
}
@Override
protected void onDestroy() {
    super.onDestroy();
    locationManager.removeUpdates ( locationListener );
}
public void setCriteria() {
    Criteria criteria = new Criteria();
    criteria.setAccuracy ( Criteria.ACCURACY_FINE );
    criteria.setAltitudeRequired ( false );
    criteria.setBearingRequired ( false );
    criteria.setCostAllowed ( true );
    criteria.setPowerRequirement ( Criteria.POWER_MEDIUM );
    provider = locationManager.getBestProvider ( criteria, true );
    Toast.makeText ( getApplicationContext(), "Provider - " + provider, Toast.LENGTH_SHORT ).show();
    if ( provider == null ) {
        provider = LocationManager.GPS_PROVIDER;
    }
}
public void runAsyncTask() {
    if ( getCurrentLocation == null ) {
        getCurrentLocation = new CurrentPositionTask();
    }
    if ( getCurrentLocation != null ) {
        getCurrentLocation.execute ( "Searching for Location" );
    }
}
public boolean checkConnection() {
    ConnectivityManager conMgr = ( ConnectivityManager ) getSystemService ( AndroidLocationActivity.CONNECTIVITY_SERVICE );
    if ( conMgr.getActiveNetworkInfo() != null && conMgr.getActiveNetworkInfo().isAvailable() && conMgr.getActiveNetworkInfo().isConnected() ) {
        return true;
    } else {
        return false;
    }
}
private class CurrentPositionTask extends AsyncTask<String, Void, Void> {
    private ProgressDialog Dialog = new ProgressDialog ( AndroidLocationActivity.this );
    private boolean flag = true;
    public CurrentPositionTask() {
        locationListener = new MyLocationListener();
    }
    @Override
    protected void onPreExecute() {
        super.onPreExecute();
        try {
            if ( checkConnection() ) {
                Dialog.setTitle ( "Loading" );
                Dialog.setMessage ( "Searching for Location" );
                Dialog.show();
                locationManager.requestLocationUpdates ( provider, 0, 0, locationListener );
            } else {
                Toast.makeText ( getApplicationContext(), "Internet is Not Available", Toast.LENGTH_LONG ).show();
            }
        } catch ( Exception e ) {
            e.printStackTrace();
        }
    }
    @Override
    protected Void doInBackground ( String... params ) {
        while ( flag ) {
            if ( latitude != 0 && longitude != 0 ) {
                flag = false;
            }
        }
        return null;
    }
    @Override
    protected void onPostExecute ( Void result ) {
        Toast.makeText ( AndroidLocationActivity.this, "Location Floats:- " + latitude + "," + longitude, Toast.LENGTH_LONG ).show();
        super.onPostExecute ( result );
        if ( Dialog != null && Dialog.isShowing() ) {
            Dialog.dismiss();
            time = 0;
            Intent homeIntent = new Intent ( AndroidLocationActivity.this.getApplicationContext(), HomeMenuActivity.class );
