private static <K, V> ListMultimap<K, V> makeLinkedArrayListMultimap() {
    return Multimaps.newListMultimap ( Maps.<K, Collection<V>>newLinkedHashMap(),
    new Supplier<List<V>>() {
        @Override public List<V> get() {
            return Lists.newArrayList();
        }
    } );
}
public static void main ( final String[] args ) {
    final ListMultimap<String, String> multimap = makeLinkedArrayListMultimap();
    multimap.putAll ( "one", ImmutableList.of ( "zero", "three" ) );
    multimap.putAll ( "two", ImmutableList.of ( "three", "four", "three" ) );
    multimap.putAll ( "three", ImmutableList.<String>of() );
    multimap.put ( "four", "forty-two" );
    System.out.println ( multimap );
    final List<String> listForOnes = multimap.get ( "one" );
    System.out.println ( listForOnes.get ( 0 ) );
}
