@Override
public void contextInitialized ( ServletContextEvent sce ) {
    ApplicationFactory applicationFactory = ( ApplicationFactory ) FactoryFinder.getFactory ( FactoryFinder.APPLICATION_FACTORY );
    Application application = applicationFactory.getApplication();
    ActionListener defaultActionListener = application.getActionListener();
    ClassLoader contextClassLoader = Thread.currentThread().getContextClassLoader();
    ActionListenerInvocationHandler actionListenerInvocationHandler = new ActionListenerInvocationHandler ( defaultActionListener );
    @SuppressWarnings ( "rawtypes" )
    Class[] interfaces = new Class[] { ActionListener.class };
    ActionListener actionListenerProxy = ( ActionListener ) Proxy.newProxyInstance ( contextClassLoader, interfaces, actionListenerInvocationHandler );
    application.setActionListener ( actionListenerProxy );
}
