private Bitmap decodeToLowResImage ( byte [] b, int width, int height ) {
    try {
        BitmapFactory.Options o = new BitmapFactory.Options();
        o.inJustDecodeBounds = true;
        BitmapFactory.decodeStream ( new ByteArrayInputStream ( b ), null, o );
        final int REQUIRED_SIZE_WIDTH = ( int ) ( width * 0.7 );
        final int REQUIRED_SIZE_HEIGHT = ( int ) ( height * 0.7 );
        int width_tmp = o.outWidth, height_tmp = o.outHeight;
        int scale = 1;
        while ( true ) {
            if ( width_tmp / 2 < REQUIRED_SIZE_WIDTH || height_tmp / 2 < REQUIRED_SIZE_HEIGHT ) {
                break;
            }
            width_tmp /= 2;
            height_tmp /= 2;
            scale *= 2;
        }
        BitmapFactory.Options o2 = new BitmapFactory.Options();
        o2.inSampleSize = scale;
        return BitmapFactory.decodeStream ( new ByteArrayInputStream ( b ), null, o2 );
    } catch ( OutOfMemoryError e ) {
    }
    return null;
}
