def estimateProbability ( priorProbs, buyCount, noBuyCount ) :
# first, estimate the prob that the actual buy/nobuy counts would be observed
# given each of the priors (times a constant that's the same in each case and
# not worth the effort of computing;-)`
condProbs = [p**buyCount * (1.0-p)**noBuyCount for p in priorProbs]
# the normalization factor for the above-mentioned neglected constant
# can most easily be computed just once
            normalize = 1.0 / sum(condProbs)
# so here's the probability for each of the prior ( starting from a uniform
# metaprior)
                        priorMeta = [normalize * cp for cp in condProbs]
# so the result is the sum of prior probs weighed by prior metaprobs
                                    return sum ( pm * pp for pm, pp in zip ( priorMeta, priorProbs ) )
                                                def example ( numProspects = 4 ) :
# the a priori prob of buying was either 0.3 or 0.7, how does it change
# depending on how 4 prospects bought or didn't?
                                                for bought in range(0, numProspects+1):
                                                    result = estimateProbability([0.3, 0.7], bought, numProspects-bought)
                                                            print 'b = % d, p = % .2f' % (bought, result)
                                                            example()
