public aspect ExceptionReporterAspect {
    public final static String LOGGER_NAME = "AspectJExceptionLogger";
    private static final Log LOGGER = LogFactory.getLog ( LOGGER_NAME );
    pointcut stringRequestHandler() :
    execution ( @RequestMapping Object the.package..* ( .. ) );
    Object around() : objectRequestHandler() {
        try {
            return proceed();
        } catch ( Exception ex ) {
            Signature sig = thisJoinPointStaticPart.getSignature();
            Object[] args = thisJoinPoint.getArgs();
            String location = sig.getDeclaringTypeName() + '.' + sig.getName() + ", args=" + Arrays.toString ( args );
            LOGGER.warn ( "(AOP detected) exception within " + location, ex );
            throw ( ex )
        }
    }
}
