public enum CellType { GRAY, RED, ORANGE }
public class Cell {
    ....
    public final CellType type;
    public List<Cell> getTouchingSimilarCells() {
        List<Cell> result = new ArrayList<Cell>();
        result.add ( this );
        for ( Cell c : getAdjecentCells() ) {
            if ( c != null && c.type == this.type ) {
                result.addAll ( c.getTouchingSimilarCells() );
            }
        }
        return result;
    }
    public List<Cell> getAdjecentCells() {
        List<Cell> result = new ArrayList<Cell>();
        result.add ( cellBlock ( this.getX() + 1, this.getY() ) );
        result.add ( cellBlock ( this.getX() - 1, this.getY() ) );
        result.add ( cellBlock ( this.getX(), this.getY() + 1 ) );
        result.add ( cellBlock ( this.getX(), this.getY() - 1 ) );
        return result;
    }
}
