public class EmbeddedMongoTest {
    private static final String DATABASE_NAME = "embedded";
    private MongodExecutable mongodExe;
    private MongodProcess mongod;
    private Mongo mongo;
    @Before
    public void beforeEach() throws Exception {
        MongoDBRuntime runtime = MongoDBRuntime.getDefaultInstance();
        mongodExe = runtime.prepare ( new MongodConfig ( Version.V2_3_0, 12345, Network.localhostIsIPv6() ) );
        mongod = mongodExe.start();
        mongo = new Mongo ( "localhost", 12345 );
    }
    @After
    public void afterEach() throws Exception {
        if ( this.mongod != null ) {
            this.mongod.stop();
            this.mongodExe.stop();
        }
    }
    @Test
    public void shouldCreateNewObjectInEmbeddedMongoDb() {
        DB db = mongo.getDB ( DATABASE_NAME );
        DBCollection col = db.createCollection ( "testCollection", new BasicDBObject() );
        col.save ( new BasicDBObject ( "testDoc", new Date() ) );
        assertThat ( col.getCount(), Matchers.is ( 1L ) );
    }
}
