try {
    if ( crossProcessLockAcquire ( SomeClassInYourApp.class, 3000 ) ) {
    } else {
    }
} finally {
    crossProcessLockRelease();
}
private static boolean crossProcessLockAcquire ( final Class<?> c, final long waitMS ) {
    if ( fileLock == null && c != null && waitMS > 0 ) {
        try {
            long dropDeadTime = System.currentTimeMillis() + waitMS;
            File file = new File ( lockTempDir, c.getName() + ".lock" );
            RandomAccessFile randomAccessFile = new RandomAccessFile ( file, "rw" );
            FileChannel fileChannel = randomAccessFile.getChannel();
            while ( System.currentTimeMillis() < dropDeadTime ) {
                fileLock = fileChannel.tryLock();
                if ( fileLock != null ) {
                    break;
                }
                Thread.sleep ( 250 );
            }
        } catch ( Exception e ) {
            e.printStackTrace();
        }
    }
    return fileLock == null ? false : true;
}
private static void crossProcessLockRelease() {
    if ( fileLock != null ) {
        try {
            fileLock.release();
            fileLock = null;
        } catch ( IOException e ) {
            e.printStackTrace();
        }
    }
}
private static File lockTempDir = new File ( System.getProperty ( "java.io.tmpdir" ) + File.separator + "locks" );
private static FileLock fileLock = null;
static {
    Runtime.getRuntime().addShutdownHook ( new Thread() {
        public void run() {
            crossProcessLockRelease();
        }
    } );
}
