import java.io.*;
public class RemoveGamma {
    public static final long SIGNATURE = 0x89504E470D0A1A0AL;
    private static final int IHDR = 0x49484452;
    private static final int IDAT = 0x49444154;
    private static final int IEND = 0x49454E44;
    private static final int PLTE = 0x504C5445;
    private static final int tRNS = 0x74524E53;
    private static final int gAMA = 0x67414D41;
    private static final int cHRM = 0x6348524D;
    private static final int sRGB = 0x73524742;
    private static final int iCCP = 0x69434350;
    private static final int tEXt = 0x74455874;
    private static final int zTXt = 0x7A545874;
    private static final int iTXt = 0x69545874;
    private static final int bKGD = 0x624B4744;
    private static final int pHYs = 0x70485973;
    private static final int sBIT = 0x73424954;
    private static final int sPLT = 0x73504C54;
    private static final int hIST = 0x68495354;
    private static final int tIME = 0x74494D45;
    public void remove ( InputStream is ) throws Exception {
        int data_len = 0;
        int chunk_type = 0;
        long CRC = 0;
        byte[] buf = null;
        DataOutputStream ds = new DataOutputStream ( new FileOutputStream ( "temp.png" ) );
        long signature = readLong ( is );
        if ( signature != SIGNATURE ) {
            System.out.println ( "--- NOT A PNG IMAGE ---" );
            return;
        }
        ds.writeLong ( SIGNATURE );
        if ( ( readInt ( is ) != 13 ) || ( readInt ( is ) != IHDR ) ) {
            System.out.println ( "--- NOT A PNG IMAGE ---" );
            return;
        }
        ds.writeInt ( 13 );
        ds.writeInt ( IHDR );
        buf = new byte[13 + 4];
        is.read ( buf, 0, 17 );
        ds.write ( buf );
        while ( true ) {
            data_len = readInt ( is );
            chunk_type = readInt ( is );
            if ( chunk_type == IEND ) {
                System.out.println ( "IEND found" );
                ds.writeInt ( data_len );
                ds.writeInt ( IEND );
                int crc = readInt ( is );
                ds.writeInt ( crc );
                break;
            }
            switch ( chunk_type ) {
            case gAMA: {
                System.out.println ( "gamma found" );
                is.skip ( data_len + 4 );
                break;
            }
            default: {
                buf = new byte[data_len + 4];
                is.read ( buf, 0, data_len + 4 );
                ds.writeInt ( data_len );
                ds.writeInt ( chunk_type );
                ds.write ( buf );
                break;
            }
            }
        }
        is.close();
        ds.close();
    }
    private int readInt ( InputStream is ) throws Exception {
        byte[] buf = new byte[4];
        is.read ( buf, 0, 4 );
        return ( ( ( buf[0] & 0xff ) << 24 ) | ( ( buf[1] & 0xff ) << 16 ) |
                 ( ( buf[2] & 0xff ) << 8 ) | ( buf[3] & 0xff ) );
    }
    private long readLong ( InputStream is ) throws Exception {
        byte[] buf = new byte[8];
        is.read ( buf, 0, 8 );
        return ( ( ( buf[0] & 0xffL ) << 56 ) | ( ( buf[1] & 0xffL ) << 48 ) |
                 ( ( buf[2] & 0xffL ) << 40 ) | ( ( buf[3] & 0xffL ) << 32 ) | ( ( buf[4] & 0xffL ) << 24 ) |
                 ( ( buf[5] & 0xffL ) << 16 ) | ( ( buf[6] & 0xffL ) << 8 ) | ( buf[7] & 0xffL ) );
    }
    public static void main ( String args[] ) throws Exception {
        FileInputStream fs = new FileInputStream ( args[0] );
        RemoveGamma rg = new RemoveGamma();
        rg.remove ( fs );
    }
}
