private final URI urlToPage;
private final String saveToFileName;
public JGet ( String urlToPage, String saveToFilename ) {
    if ( urlToPage == null ) {
        throw new NullPointerException ( "The URL must not be null" );
    }
    if ( saveToFilename == null ) {
        throw new NullPointerException ( "The name of the destination file must not be null" );
    }
    this.saveToFileName = saveToFilename;
    try {
        this.urlToPage = new URI ( urlToPage );
    } catch ( URISyntaxException e ) {
        throw new IllegalArgumentException ( "Invalid URL provided: " + urlToPage );
    }
}
