public class ListChecker implements Runnable {
    static final int THREADS = 20;
    static final EndLockedList<Integer> list = new EndLockedList<Integer>();
    int id;
    public ListChecker ( int id ) {
        this.id = id;
    }
    @Override
    public void run() {
        StringBuilder result = new StringBuilder();
        for ( int i = 0; i < list.size(); i++ ) {
            result.append ( i ).append ( "," );
        }
        list.add ( id );
        list.unlock();
        System.out.println ( id + ": " + result.toString() );
    }
    public static void main ( String[] args ) {
        for ( int i = 0; i < THREADS; i++ ) {
            ListChecker checker = new ListChecker ( i + 1 );
            new Thread ( checker ).start();
        }
    }
    private static class EndLockedList<T> extends ArrayList<T> {
        private final Lock lock = new ReentrantLock();
        private volatile boolean locked = false;
        @Override
        public boolean add ( T it ) {
            lock.lock();
            try {
                return super.add ( it );
            } finally {
                lock.unlock();
            }
        }
        @Override
        public T get ( int i ) {
            T it = super.get ( i );
            if ( i == size() - 1 ) {
                lock.lock();
                if ( i < size() - 1 ) {
                    lock.unlock();
                } else {
                    locked = true;
                }
            }
            return it;
        }
        void unlock() {
            if ( locked ) {
                locked = false;
                lock.unlock();
            }
        }
    }
}
