public class DatabaseBackupReminder extends Thread
    String backupFrequency;
String backupTimeOfDay;
boolean backupIsSet = false;
Timestamp lastBackupRunTime;
Timestamp backupScheduleSetTime;
Period periodSinceLastBackup;
boolean backupEverRan;
public enum enumBackupFrequencies {DAILY, WEEKLY, MONTHLY, NEVER}
Herd herd;
public DatabaseBackupReminder ( String backupFrequency, String backupTimeOfDay, Timestamp lastBackupRunTime, Timestamp backupScheduleSetTime, Herd herd )
boolean getBackupStillValid()
public void promptForBackup ( Period duration, boolean backupEverRunx )
public void run()
public String timeSinceLastBackupString()
public String timeSinceLastBackupString ( Period duration, boolean backupEverRunx )
public DatabaseBackupReminder ( String backupFrequency, String backupTimeOfDay, Timestamp lastBackupRunTime, Timestamp backupScheduleSetTime, Herd herd ) {
    this.herd = herd;
    if ( backupFrequency == null ) {
        backupFrequency = "";
    }
    if ( backupTimeOfDay == null ) {
        backupTimeOfDay = "";
    }
    if ( backupScheduleSetTime == null ) {
        this.backupScheduleSetTime = new Timestamp ( 0 );
    } else {
        this.backupScheduleSetTime = backupScheduleSetTime;
    }
    this.backupFrequency = backupFrequency;
    this.backupTimeOfDay = backupTimeOfDay;
    if ( lastBackupRunTime == null ) {
        this.lastBackupRunTime = new Timestamp ( 0 );
    } else {
        this.lastBackupRunTime = lastBackupRunTime;
    }
    periodSinceLastBackup = new Period ( this.lastBackupRunTime.getTime(), Calendar.getInstance().getTimeInMillis() );
    if ( backupFrequency.trim().length() > 1 ) {
        backupIsSet = true;
    }
    backupEverRan = false;
    if ( this.lastBackupRunTime.getTime() != 0 ) {
        backupEverRan = true;
    }
}
boolean getBackupStillValid() {
    if ( lastBackupRunTime.getTime() > 0 ) {
        backupEverRan = true;
    } else {
        return false;
    }
    if ( backupFrequency.trim().length() > 1 ) {
        backupIsSet = true;
    }
    if ( backupIsSet ) {
        switch ( enumBackupFrequencies.valueOf ( backupFrequency.trim().toUpperCase() ) ) {
        case DAILY:
            if ( periodSinceLastBackup.getYears() > 1 || periodSinceLastBackup.getMonths() > 1 || periodSinceLastBackup.getWeeks() > 1 || periodSinceLastBackup.getDays() >= 1 ) {
                return false;
            }
            break;
        case WEEKLY:
            if ( periodSinceLastBackup.getYears() > 1 || periodSinceLastBackup.getMonths() > 1 || periodSinceLastBackup.getWeeks() >= 1 ) {
                return false;
            }
            break;
        case MONTHLY:
            if ( periodSinceLastBackup.getYears() > 1 || periodSinceLastBackup.getMonths() >= 1 ) {
                return false;
            }
            break;
        case NEVER:
        }
    }
    if ( backupEverRan ) {
        return true;
    } else {
        return false;
    }
}
public void run() {
    if ( backupIsSet ) {
        switch ( enumBackupFrequencies.valueOf ( backupFrequency.trim().toUpperCase() ) ) {
        case DAILY:
            if ( periodSinceLastBackup.getYears() > 1 || periodSinceLastBackup.getMonths() > 1 || periodSinceLastBackup.getWeeks() > 1 || periodSinceLastBackup.getDays() > 1 ) {
                promptForBackup ( periodSinceLastBackup, backupEverRan );
            }
            break;
        case WEEKLY:
            if ( periodSinceLastBackup.getYears() > 1 || periodSinceLastBackup.getMonths() > 1 || periodSinceLastBackup.getWeeks() > 1 ) {
                promptForBackup ( periodSinceLastBackup, backupEverRan );
            }
            break;
        case MONTHLY:
            if ( periodSinceLastBackup.getYears() > 1 || periodSinceLastBackup.getMonths() > 1 ) {
                promptForBackup ( periodSinceLastBackup, backupEverRan );
            }
            break;
        case NEVER:
        }
    }
}
public void promptForBackup ( Period duration, boolean backupEverRun ) {
    int response;
    long delay = 0;
    response = JOptionPane.showConfirmDialog ( null, timeSinceLastBackupString ( duration, backupEverRun ) );
    if ( response == JOptionPane.NO_OPTION ) {
        BackupSnoozePanel snoozePanel = new BackupSnoozePanel();
        JOptionPane.showMessageDialog ( null, snoozePanel );
        switch ( snoozePanel.BackupDelayInterval.getSelectedIndex() ) {
        case 0:
            delay = 5000;
            break;
        case 1:
            delay = 10000;
            break;
        case 2:
            delay = 15000;
            break;
        case 3:
            delay = 20000;
            break;
        case 4:
            delay = 0;
            break;
        }
    } else {
    }
    try {
        if ( delay > 0 ) {
        }
    } catch ( Exception ex ) {
    }
}
public String timeSinceLastBackupString ( Period duration, boolean backupEverRunx ) {
    if ( !backupEverRunx ) {
        return "The backup has never been run. Would you like to run one?";
    }
    String durationString = "It has been ";
    if ( duration.getYears() >= 1 ) {
        durationString += duration.getYears() + " years";
    }
    if ( duration.getMonths() >= 1 ) {
        durationString += duration.getMonths() + " months";
    }
    if ( duration.getWeeks() >= 1 ) {
        durationString += duration.getWeeks() + " weeks ";
    }
    if ( duration.getDays() >= 1 ) {
        durationString += duration.getDays() + " days";
    }
    durationString += " since your last backup. Would you like to run one?";
    return durationString;
}
public String timeSinceLastBackupString() {
    return timeSinceLastBackupString ( periodSinceLastBackup, backupEverRan );
}
