import java.awt.*;
import javax.swing.*;
public class TerrisView {
    public JComponent canvas;
    public TerrisView ( String title ) {
        JFrame f = new JFrame ( title );
        canvas = new JComponent() {
            @Override
            public void paintComponent ( Graphics g ) {
                super.paintComponent ( g );
                g.setColor ( getBackground() );
                g.fillRect ( 0, 0, getWidth(), getHeight() );
                g.setColor ( Color.BLACK );
                int pad = 10;
                g.fillRect ( pad, pad, getWidth() - ( 2 * pad ), getHeight() - ( 2 * pad ) );
            }
        };
        canvas.setPreferredSize ( new Dimension ( 300, 400 ) );
        canvas.setBackground ( Color.ORANGE );
        f.add ( canvas, BorderLayout.CENTER );
        f.pack();
        f.setMinimumSize ( f.getSize() );
        f.setLocationByPlatform ( true );
        f.setDefaultCloseOperation ( JFrame.EXIT_ON_CLOSE );
        f.setVisible ( true );
    }
    public static void main ( String[] args ) {
        SwingUtilities.invokeLater ( new Runnable() {
            public void run() {
                new TerrisView ( "Terris View" );
            }
        } );
    }
}
