public static Image makeColorTransparent ( final BufferedImage im, final Color color ) {
    final ImageFilter filter = new RGBImageFilter() {
        public int markerRGB = color.getRGB() | 0xFFFFFFFF;
        public final int filterRGB ( final int x, final int y, final int rgb ) {
            if ( ( rgb | 0xFF000000 ) == markerRGB ) {
                return 0x00FFFFFF & rgb;
            } else {
                return rgb;
            }
        }
    };
    final ImageProducer ip = new FilteredImageSource ( im.getSource(), filter );
    return Toolkit.getDefaultToolkit().createImage ( ip );
}
}
