class TransparentFilter extends RGBImageFilter {
    final static int aShift = 24;
    final static int rShift = 16;
    final static int gShift = 8;
    final static int bShift = 0;
    final static int aMask = 0xff << aShift;
    final static int rMask = 0xff << rShift;
    final static int gMask = 0xff << gShift;
    final static int bMask = 0xff << bShift;
    final static int rgbMask = rMask | gMask | bMask;
    float saturationFudge;
    TransparentFilter ( float saturationFudge ) {
        this.saturationFudge = saturationFudge;
        canFilterIndexColorModel = true;
    }
    public int filterRGB ( int x, int y, int argb ) {
        int r = ( argb & rMask ) >>> TransparentFilter.rShift;
        int g = ( argb & gMask ) >>> TransparentFilter.gShift;
        int b = ( argb & bMask ) >>> TransparentFilter.bShift;
        float[] hsb = Color.RGBtoHSB ( r, g, b, null );
        float fa = 255f * hsb[1] / this.saturationFudge;
        int a = Math.max ( 0, Math.min ( 255, Math.round ( fa ) ) ) << TransparentFilter.aShift;
        return a | ( argb & TransparentFilter.rgbMask );
    }
}
