import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
public class Shape extends JApplet {
    private static final long serialVersionUID = 1L;
    JRadioButton squareButton = new JRadioButton ( "Square", true );
    JRadioButton ovalButton = new JRadioButton ( "Oval", false );
    JRadioButton rectangleButton = new JRadioButton ( "Rectangle", false );
    JRadioButton triangleButton = new JRadioButton ( "Triangle", false );
    JRadioButton redButton = new JRadioButton ( "Red", true );
    JRadioButton blueButton = new JRadioButton ( "Blue", false );
    JRadioButton greenButton = new JRadioButton ( "Green", false );
    JRadioButton yellowButton = new JRadioButton ( "Yellow", false );
    JButton drawButton = new JButton ( "Draw!" );
    JButton animateButton = new JButton ( "Animate!" );
    JTextField lengthField = new JTextField ( "Enter a length", 15 );
    JTextField widthField = new JTextField ( "Enter a width", 15 );
    JPanel shapePanel = new JPanel();
    JPanel colorPanel = new JPanel();
    JPanel buttonPanel = new JPanel();
    JPanel textPanel = new JPanel();
    drawPanel dPanel;
    ButtonGroup shapeGroup = new ButtonGroup();
    ButtonGroup colorGroup = new ButtonGroup();
    int length = 200;
    int width = 200;
    Color color = Color.RED;
    String shape = "square";
    public void init() {
        setLayout ( new FlowLayout() );
        shapePanel.setLayout ( new GridLayout ( 2, 2, 5, 5 ) );
        shapePanel.setBorder ( BorderFactory.createTitledBorder ( "Choose a shape" ) );
        colorPanel.setLayout ( new GridLayout ( 2, 2, 5, 5 ) );
        colorPanel.setBorder ( BorderFactory.createTitledBorder ( "Choose a color" ) );
        buttonPanel.setLayout ( new GridLayout ( 1, 2, 5, 5 ) );
        buttonPanel.setBorder ( BorderFactory.createLineBorder ( Color.red, 2 ) );
        textPanel.setLayout ( new GridLayout ( 1, 2, 5, 5 ) );
        lengthField.setFont ( new Font ( "Arial", Font.PLAIN, 12 ) );
        lengthField.setForeground ( new Color ( 150, 150, 150 ) );
        widthField.setFont ( new Font ( "Arial", Font.PLAIN, 12 ) );
        widthField.setForeground ( new Color ( 150, 150, 150 ) );
        shapeGroup.add ( squareButton );
        shapeGroup.add ( ovalButton );
        shapeGroup.add ( rectangleButton );
        shapeGroup.add ( triangleButton );
        colorGroup.add ( redButton );
        colorGroup.add ( blueButton );
        colorGroup.add ( greenButton );
        colorGroup.add ( yellowButton );
        shapePanel.add ( squareButton );
        shapePanel.add ( ovalButton );
        shapePanel.add ( rectangleButton );
        shapePanel.add ( triangleButton );
        colorPanel.add ( redButton );
        colorPanel.add ( blueButton );
        colorPanel.add ( greenButton );
        colorPanel.add ( yellowButton );
        buttonPanel.add ( drawButton );
        buttonPanel.add ( animateButton );
        textPanel.add ( lengthField );
        textPanel.add ( widthField );
        dPanel  = new drawPanel();
        dPanel.setPreferredSize ( new Dimension ( 500, 300 ) );
        add ( shapePanel );
        add ( colorPanel );
        add ( buttonPanel );
        add ( textPanel );
        add ( dPanel );
        lengthField.addFocusListener ( new FocusListener() {
            public void focusGained ( FocusEvent e ) {
                lengthField.setText ( "" );
                lengthField.setForeground ( Color.black );
            }
            public void focusLost ( FocusEvent e ) {}
        } );
        widthField.addFocusListener ( new FocusListener() {
            public void focusGained ( FocusEvent e ) {
                widthField.setText ( "" );
                widthField.setForeground ( Color.black );
            }
            public void focusLost ( FocusEvent e ) {}
        } );
        drawButton.addActionListener ( new drawListener() );
    }
    class drawListener implements ActionListener {
        public void actionPerformed ( ActionEvent e ) {
            int mylength = 5;
            int mywidth = 5;
            try {
                mylength = Integer.parseInt ( lengthField.getText() );;
                mywidth = Integer.parseInt ( widthField.getText() );;
            } catch ( Exception ex ) {
                JOptionPane.showMessageDialog ( null, "" + ex, "", JOptionPane.ERROR_MESSAGE );
            }
            if ( ( mylength > 200 || mylength < 5 ) ) {
                JOptionPane.showMessageDialog ( null, "Please make sure the number is above 5 and less than 200",
                                                "Invalid length message", JOptionPane.ERROR_MESSAGE );
            } else if ( ( mywidth > 200 || mywidth < 5 ) ) {
                JOptionPane.showMessageDialog ( null, "Please make sure the number is above 5 and less than 200",
                                                "Invalid width message", JOptionPane.ERROR_MESSAGE );
            } else {
                length = mylength;
                width = mywidth;
                if ( redButton.isSelected() ) {
                    color = Color.RED;
                } else if ( blueButton.isSelected() ) {
                    color = Color.BLUE;
                } else if ( greenButton.isSelected() ) {
                    color = Color.GREEN;
                } else if ( yellowButton.isSelected() ) {
                    color = Color.YELLOW;
                }
                if ( rectangleButton.isSelected() ) {
                    shape = "rectangle";
                } else if ( triangleButton.isSelected() ) {
                    shape = "triangle";
                } else if ( ovalButton.isSelected() ) {
                    shape = "oval";
                } else if ( squareButton.isSelected() ) {
                    shape = "square";
                }
            }
        }
    }
    class drawPanel extends JPanel {
        private static final long serialVersionUID = 1L;
        public void paintComponent ( Graphics g ) {
            super.paintComponent ( g );
            Graphics2D g2 = ( Graphics2D ) g;
            g2.setColor ( Color.black );
            g2.drawString ( "My awesome string", 200, 200 );
        }
    }
}
