public abstract class LoaderState {
    private BigBean bean;
    public LoaderState ( BigBean b ) {
        this.bigBean = b;
    }
    public abstract LoaderState getNextLoader();
    public abstract void loadData();
    class DatabaseLoaderState extends LoaderState {
        public void loadData() {
            public LoaderState getNextLoader() {
                if ( iHadSomeData ) {
                    return new FlatFileLoaderState ( bigBean );
                }
                return new SomeOtherLoaderState ( bigBean );
            }
        }
    }
    LoaderState state = new LoaderState.DatabaseLoaderState ( new BigBean() );
    do {
        state.loadData();
        state = state.getNextLoader();
    } while ( state != null );
